-- name=int_deploy_inv
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_deploy_inv", interface.originhub );
  ObjSet( "int_deploy_inv", { pos_z = pos_z } );

  private.SHOW_ANIM_TIME = 0.5;
  private.SKIP_MOUSE_OVER_ANIM_TIME = 0.5;

  private.show = false;
  private.show_obj = nil;
  
  private.previous_loc = {};

  ObjSet("spr_int_deploy_inv_close", {
    event_mdown = function () common_impl.HideDeployInv() end,
    event_menter = function () private.CloseMouseEnterAnim(); end,
    event_mleave = function () private.CloseMouseLeaveAnim(); end
  });

  ObjSet("int_deploy_inv_exit", {
    event_mdown = function () common_impl.HideDeployInv() end,
    event_menter = function () private.ExitMouseEnterAnim();SetCursor( CURSOR_DOWN ); end,
    event_mleave = function () private.ExitMouseLeaveAnim();SetCursor( CURSOR_DEFAULT ); end
  });

  ObjSet("spr_int_deploy_inv_back", {
    event_mdown = function () common_impl.HideDeployInv() end
  });

end;
--******************************************************************************************
function public.Define ( deploy_inv )

  _G[ deploy_inv ] = {};

end;
--******************************************************************************************
function public.Destroy ()

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  common_impl.Lock(false);

  if ( event_id == "show" ) then

    private.Execute( private.inv, "Open" );
    private.show = true;

    ObjSet( "obj_int_deploy_inv_root", { input = true } );

    ObjSet( "spr_int_deploy_inv_back", { bake = 0 } );

    ObjSet( private.show_obj, { input = true, active = true } );

    if ng_global.progress[ ng_global.currentprogress ].common.buttonlock ~= 1 then

      --interface.InventoryAutoHideSet( true );

    end;

  elseif ( event_id == "hide" ) then

    private.Execute( private.inv, "Close" );
    private.show = false;

    ObjSet( "obj_int_deploy_inv_root", { active = false, visible = false, input = false } );
    ObjAttach( private.show_obj, ng_global.progress[ ng_global.currentprogress ].common.chapter.."_inv_deploy");

    ObjSet( "spr_int_deploy_inv_back", { bake = 0 } );

    ObjSet( private.show_obj, { input = false, active = false } );

    private.show_obj = nil;

  end;

end;
--******************************************************************************************
function private.ShowAnim ( event_id )

  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  private.Execute( private.inv, "PreOpen" );
  --interface.InventoryAutoHideSet( false );

  common_impl.Lock(true);

  ObjAnimate( "obj_int_deploy_inv_root", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;
  private.Execute( private.inv, "PreClose" );

  common_impl.Lock(true);
  ObjAnimate( "obj_int_deploy_inv_root", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function private.ExitMouseEnterAnim ()

  SetCursor( CURSOR_DOWN );

  local obj = "int_deploy_inv_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.ExitMouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "int_deploy_inv_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.CloseMouseEnterAnim ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_deploy_inv_close_focus";

  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.CloseMouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_deploy_inv_close_focus";

  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function public.GetCurrentName ()

  return private.show_obj;

end;
--******************************************************************************************
function public.IsOnScreen ()

  return private.show;

end;
--******************************************************************************************
function public.Show ( inv_obj )

  local event_id = "show";

  private.inv = string.sub( inv_obj, 5 );
  private.show_obj = "deploy_"..inv_obj;

  ObjSet( "spr_int_deploy_inv_back", { clear_bake = 1, bake = 1 } );

  ObjSet( "obj_int_deploy_inv_root", { active = true, visible = true, alp = 0 } );
  ObjAttach( private.show_obj, "spr_int_deploy_inv_back" );
  ObjSet( private.show_obj, { pos_x = 0, pos_y = 0 } );

  local prg = ng_global.currentprogress;
  local event = "win_"..private.inv;

  private.ShowAnim( event_id );

end;
--******************************************************************************************
function public.Hide ()

  if ( private.show ) then

    ObjSet( "spr_int_deploy_inv_back", { clear_bake = 1, bake = 1 } );

    local event_id = "hide";
    private.HideAnim( event_id );

    local prg = ng_global.currentprogress;
    local event = "win_"..private.inv;

    if ng_global.progress[ prg ][ event ] and cmn.IsEventStart( event ) and not cmn.IsEventDone( event )then

      cmn.MiniGameHide( private.inv );

    end;

  end;

end;
--******************************************************************************************
function public.PreviousLoc ( tb )

  if tb then
  
    table.insert( private.previous_loc, tb );
    
  end;

end;
--******************************************************************************************
function public.CheckPreviousLoc ( mg_name )

  for i = 1, #private.previous_loc do
    
    if private.previous_loc[ i ][ 1 ] == mg_name then
      
      return private.previous_loc[ i ][ 2 ];
      
    end;
    
  end;
  
  return nil;

end;
--******************************************************************************************
function private.Execute( inv_obj, func )

  if inv_obj and func and _G[ inv_obj ] and _G[ inv_obj ][ func ] then
    _G[ inv_obj ][ func ]();
  end;

end;