-- name=int_dialog_task
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_dialog_task", interface.originhub );
  ObjSet( "int_dialog_task", { pos_z = pos_z } );
  
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  public.DIRECTION = 1;
  
  public.show = false;
  private.SHOW_ANIM_TIME = 0.5;
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  
  private.FuncEnd = nil;
  private.task = "";

  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () public.StopTypeAnim (); end,
  } );
  
  private.WideScreenUpdate();

end;
--******************************************************************************************
function private.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    ObjSet( "int_dialog_task", { pos_x = -171 } );
  
  else

    ObjSet( "int_dialog_task", { pos_x = 0 } );

  end;

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  
end;
--******************************************************************************************
function private.AnimEnd( event_id )  

  common_impl.Lock( false );

  if ( event_id == "show" ) then
  
    public.show = true;
    --ObjSet( "obj_int_dialog_task_root", { input = true } );

  elseif ( event_id == "hide" ) then
  
    public.show = false;
    ObjSet( "obj_int_dialog_task_root", { input = false } );
    ObjSet( "obj_int_dialog_task", { event_mdown = function () public.StopTypeAnim (); end } );


    if ( private.FuncEnd ) then
  
      private.FuncEnd();
      private.FuncEnd = nil;

    end;

  end;

end;
--******************************************************************************************
function private.ShowAnim ( event_id, data )
  
  local func_end = function () private.TypeAnim( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;
  
  common_impl.Lock( true );
  private.task = data.task;

  ObjAnimate( "obj_int_dialog_task", "alp", 0, 0, func_end,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function private.TypeAnim ( event_id )  

  common_impl.Lock( false );

  ObjSet( "obj_int_dialog_task_root", { input = true } );

  --ObjSet( "txt_int_dialog_task_description", { text = "str_dialog_task_"..private.task } );
  private.AnimEnd( event_id ); 
  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () public.Hide(); end,
  } );

  --common_impl.PrintText(
  --  "txt_int_dialog_task_description", 
  --  "str_dialog_task_"..private.task, 
  --  private.SHOW_ANIM_TIME*3, 
  --  func_end
  --);

  common_impl.Lock( false );

end;
--******************************************************************************************
function public.StopTypeAnim ()

  common_impl.ShowText("txt_int_dialog_task_description");
  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () public.Hide(); end,
  } );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local func_end = function () private.AnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  common_impl.Lock( true );
  ObjAnimate( "obj_int_dialog_task", "alp", 0, 0, func_end,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--*****************************************************************************************
function public.Show ( data )

  common_impl.PlayAudio( "sfx", "aud_new_task", 0, "", 0 );

  local event_id = "show";  

  common_impl.HideDeployInv();

  private.Update( data );
  private.FuncEnd = data.func_end;
  private.ShowAnim( event_id, data );

end;
--******************************************************************************************
function public.Hide ()

  local event_id = "hide";
  private.HideAnim( event_id );

  if private.task == "show_id" then
    common_impl.TutorialShow( "tutorial_page_1" );
    private.task = "";
  end;

end;
--******************************************************************************************
function private.Update ( data )

  ObjSet( "txt_int_dialog_task_header", { text = "str_dialog_task_header_"..data.state } );
  ObjSet( "txt_int_dialog_task_description", { text = "str_dialog_task_"..data.task } );

end;