-- name=int_diary
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_diary", interface.originhub );
  ObjSet( "int_diary", { pos_z = pos_z } );

  public.show = 0;
  private.SHOW_ANIM_TIME = 1;
  private.MOUSE_OVER_ANIM_TIME = 0.3;

  -------------------init------------------------------------------------------------
  --1 ray
  --2 ben
  --3 may
  --4 christian
  --5 cassandra
  --6 james
  --7 molly
  
  --8  sam
  --9  joanna
  --10 lucas
  --11 alfred
  --12 jerome
  
  local note_tmp = {
    { { "ray_photo", "ray_1" }, { "ray_2", "ray_3", "ray_4", "ray_5" }, { "ray_6", "ray_7", "ray_8", "ray_9" }, { "ray_10", "ray_11" } }, 
    { { "ben_photo", "ben_cross", "ben_1", "ben_2" }, { "ben_3" } },
    { { "may_photo", "may_cross", "may_1" } },
    { { "christian_photo", "christian_cross", "christian_1", "christian_2" }, { "christian_3" } },
    { { "cassandra_photo", "cassandra_cross", "cassandra_1", "cassandra_2" }, { "cassandra_3", "cassandra_4", "cassandra_5" } },
    { { "james_photo", "james_1", "james_2" }, { "james_3", "james_4" } },
    { { "molly_photo", "molly_cross", "molly_1", "molly_2" }, { "molly_3" } },
    
    { { "sam_photo", "sam_1", "sam_2" } },
    { { "joanna_photo", "joanna_1" } },
    { { "lucas_photo", "lucas_1" } },
    { { "alfred_photo", "alfred_1" } },
    { { "jerome_photo", "jerome_1" } },
  }

  private.bookmark = {};
  local p = private;
  for i = 1, #note_tmp do
  
    private.bookmark[ i ] = {};
    private.bookmark[ i ].pages = {};

    ObjSet( "obj_diary_bookmark_"..i.."_page", { visible = false } );
    ObjSet( "obj_diary_bookmark_"..i.."_button", { input = false } );
    
    
    for j = 1, #note_tmp[ i ] do

      ObjSet( "obj_diary_bookmark_"..i.."_page_"..j, { alp = 0 } );
      
      private.bookmark[ i ].pages[ j ] = {};
      
      for k = 1, #note_tmp[ i ][ j ] do
      
        private.bookmark[ i ].pages[ j ][ k ] = {};
        private.bookmark[ i ].pages[ j ][ k ].name = note_tmp[ i ][ j ][ k ];
        private.bookmark[ i ].pages[ j ][ k ].state = false;
        
        ObjSet( "obj_diary_bookmark_"..i.."_page_"..j.."_"..private.bookmark[ i ].pages[ j ][ k ].name, { alp = 0 } );
      
      end;
      
    end;
  
  end;
  
  private.current_bookmark = 1;
  private.current_page = 1;
  private.not_first = false;
  
  --для уменьшения кода стрелок
  private.left = -1;
  private.right = 1;
  
  -----------------------------------------------------------------------------------

  local tb = {};
  
  table.insert( tb, { "obj_diary_arrow_right", { 
    event_mdown = function() private.ArrowClick( "right" ) end,
    event_menter = function() private.MouseEnterAnim( "arrow_right" ) end,
    event_mleave = function() private.MouseLeaveAnim( "arrow_right" ) end
  } } );
  
  table.insert( tb, { "obj_diary_arrow_left", {
    event_mdown = function() private.ArrowClick( "left" ) end,
    event_menter = function() private.MouseEnterAnim( "arrow_left" ) end,
    event_mleave = function() private.MouseLeaveAnim( "arrow_left" ) end
  } } );
  table.insert( tb, { "obj_diary_close", {
    event_mdown = interface.DiaryShow,
    event_menter = function() private.MouseEnterAnim( "close" ) end,
    event_mleave = function() private.MouseLeaveAnim( "close" ) end
  } } );
  
  for i = 1, 12 do
    
    table.insert( tb, { "obj_diary_bookmark_"..i.."_button", { event_mdown = function() private.OpenBookmark( i ) end } } );
    
  end;
  
  ObjMultiSet( tb );
  
  -----------------------------------------------------------------------------------
  
  

end;
--******************************************************************************************
function public.Destroy ()

end;
--******************************************************************************************
function private.AnimEnd ( event_id )
 
  common_impl.Lock(false);

  if ( event_id == "show" ) then
  
    public.show = 1;
    ObjSet( "int_diary", { input = true } );

  elseif ( event_id == "hide" ) then
  
    public.show = 0;
    ObjSet( "int_diary", { active = false, visible = false, input = false } );

  end;

end;
--******************************************************************************************
function private.ShowAnim ( event_id )

  local trg = function () private.AnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;
  
  private.InitState();
  common_impl.Lock(true);

  ObjAnimate( "int_diary", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local trg = function () private.AnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;
  common_impl.Lock(true);
  ObjAnimate( "int_diary", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function private.MouseEnterAnim ( but_name )

  SetCursor( CURSOR_HAND );
  
  local obj = "spr_diary_add_"..but_name;
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_diary_add_"..but_name;
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function private.InitState ()
  
  local prg = { "std", "ext" };
  local current_prg = ng_global.currentprogress;
  
  --включение закладок текущего прогресса
  for i = 1, #prg do
    
    local state = false;
    
    if prg[ i ] == current_prg then
      
      state = true;
      
    end;
    
    ObjSet( "obj_diary_bookmark_"..prg[ i ], { visible = state } );
    
  end;
  --ручная проверка
  --ng_global.progress[ current_prg ].common.diary.note = { "ray1", "ray4", "may2", "cassandra2", "cassandra3", "james4", "james5", "molly3", "molly4" }
  --ng_global.progress[ current_prg ].common.diary.new = { "ray1", "ray4", "may2", "cassandra2", "cassandra3", "james4", "james5", "molly3", "molly4" }
  --перенос данных из сейвов
  local note_tmp = {
    { { "ray_photo" } },
    { { "ben_photo" } },
    { { "may_photo" } },
    { { "christian_photo" } },
    { { "cassandra_photo" } },
    { { "james_photo" } },
    { { "molly_photo" } }
  }

  for i = 1, #private.bookmark do
    
    ObjSet( "spr_diary_bookmark_"..i.."_flag", { alp = 0 } );
    
    for j = 1, #private.bookmark[ i ].pages do
      
      for k = 1, #private.bookmark[ i ].pages[ j ] do
        
        for note = 1, #ng_global.progress[ current_prg ].common.diary.note do
        
          if private.bookmark[ i ].pages[ j ][ k ].name == ng_global.progress[ current_prg ].common.diary.note[ note ] then
            
            private.bookmark[ i ].pages[ j ][ k ].state = true;
            ObjSet( "obj_diary_bookmark_"..i.."_page_"..j.."_"..private.bookmark[ i ].pages[ j ][ k ].name, { alp = 1 } );
            
            break;
            
          end;
        
        end;
        
      end;
      
    end;
    
  end;
    
  if not private.not_first then
  
    private.not_first = true;
    
    local bookmark = 1;
    
    if current_prg == "ext" then
      
      bookmark = 8;
      
    end;
      
    private.OpenBookmark( bookmark );
    
  end;
  
  private.SetBookmark( private.current_bookmark );
  private.SetArrows();
  private.ShowPage();
  
end;
--******************************************************************************************
function private.OpenBookmark ( bookmark )

  private.current_bookmark = bookmark;
  private.current_page = 1;
  
  private.SetBookmark( bookmark );
  
  --ObjSet( "obj_diary_bookmark_"..bookmark.."_page_1", { alp = 1 } );
  
  private.SetArrows();
  private.ShowPage();
  
end;
--******************************************************************************************
function private.ArrowClick ( arrow )

  ObjSet( "obj_diary_bookmark_"..private.current_bookmark.."_page_"..private.current_page, { alp = 0 } );
  
  private.current_page = private.current_page + private[ arrow ];
  
  ObjSet( "obj_diary_bookmark_"..private.current_bookmark.."_page_"..private.current_page, { alp = 1 } );

  private.SetArrows();
  private.ShowPage();
  
end;
--******************************************************************************************
function private.SetBookmark ( bookmark )

  ObjAttach( "spr_diary_bookmark_over", "obj_diary_bookmark_"..bookmark );
  
  for i = 1, #private.bookmark do
    
    ObjSet( "obj_diary_bookmark_"..i, { pos_z = 0 } );
    
    local is_break = false;
    ObjSet( "txt_diary_bookmark_"..i.."_name", { visible = false } );
    ObjSet( "obj_diary_bookmark_"..i.."_button", { input = false } );
    ObjSet( "obj_diary_bookmark_"..i.."_page", { visible = true } );
    
    --if i ~= bookmark then
    
      for j = 1, #private.bookmark[ i ].pages do
        
        for k = 1, #private.bookmark[ i ].pages[ j ] do
          
          if private.bookmark[ i ].pages[ j ][ k ].state then
            
            ObjSet( "txt_diary_bookmark_"..i.."_name", { visible = true } );
            
            if i ~= bookmark then
            
              ObjSet( "obj_diary_bookmark_"..i.."_button", { input = true } );
              ObjSet( "obj_diary_bookmark_"..i.."_page", { visible = false } );
              
            end;
            
            is_break = true;
            break;
            
          end;
          
        end;
        
        if is_break then
          
          break;
          
        end;
        
      end;
    
    --end;
      
  end;

  ObjSet( "obj_diary_bookmark_"..bookmark, { pos_z = 1 } );
  
end;
--******************************************************************************************
function private.SetFlagNew ()

  local current_prg = ng_global.currentprogress;
  
  for i = 1, #private.bookmark do
    
    ObjSet( "spr_diary_bookmark_"..i.."_flag", { alp = 0 } );
    
    for j = 1, #private.bookmark[ i ].pages do
      
      for k = 1, #private.bookmark[ i ].pages[ j ] do
        
        for new = 1, #ng_global.progress[ current_prg ].common.diary.new do
          
          if private.bookmark[ i ].pages[ j ][ k ].name == ng_global.progress[ current_prg ].common.diary.new[ new ] then
            
            ObjSet( "spr_diary_bookmark_"..i.."_flag", { alp = 1 } );
            
            break;
            
          end;
          
        end;
        
      end;
      
    end;
    
  end;

end;
--******************************************************************************************
function private.SetArrows ()
  
  local arrow = { "left", "right" };
  local p = private;
  for i = 1, #arrow do
    
    ObjSet( "obj_diary_arrow_"..arrow[ i ], { input = false } );
    
    if private.bookmark[ private.current_bookmark ].pages[ private.current_page + private[ arrow[ i ] ] ] then
      
      for j = 1, #private.bookmark[ private.current_bookmark ].pages[ private.current_page + private[ arrow[ i ] ] ] do
      
        if private.bookmark[ private.current_bookmark ].pages[ private.current_page + private[ arrow[ i ] ] ][ j ].state then
          
          ObjSet( "obj_diary_arrow_"..arrow[ i ], { input = true } );
          break;
          
        end;
      
      end;
      
    end;
    
  end;
  
end;
--******************************************************************************************
function private.ShowPage ()
  
  local current_prg = ng_global.currentprogress;
  
  ObjSet( "txt_diary_numerator_page", { text = private.current_page } );
  
  for i = 1, #private.bookmark[ private.current_bookmark ].pages do
    
    local alp = 0;
    
    if i == private.current_page then
      
      alp = 1;
      
    end;
    
    ObjSet( "obj_diary_bookmark_"..private.current_bookmark.."_page_"..i, { alp = alp } );

  end;
  
  for i = 1, #private.bookmark[ private.current_bookmark ].pages[ private.current_page ] do
    
    for j = 1, #ng_global.progress[ current_prg ].common.diary.new do
      
      if private.bookmark[ private.current_bookmark ].pages[ private.current_page ][ i ].name == ng_global.progress[ current_prg ].common.diary.new[ j ] then
        
        table.remove( ng_global.progress[ current_prg ].common.diary.new, j );
        break;
        
      end;
      
    end;
    
  end;
  
  private.SetFlagNew();
  
end;
--******************************************************************************************
function public.Show ()

  local event_id = "show";
  ObjSet( "int_diary", { active = true, visible = true, alp = 0 } );
  common_impl.HideDeployInv();
  private.ShowAnim( event_id );

end;
--******************************************************************************************
function public.Hide ()

  local event_id = "hide";
  private.HideAnim( event_id );

end;
--******************************************************************************************