-- name=int_map_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;

  private.POPUP_WINDOW_BACK_X = 0;
  private.POPUP_WINDOW_BACK_Y = 0;

  private.HUB_POPUP_WINDOW_X = 200;
  private.HUB_POPUP_WINDOW_Y = 0;

  private.curren_location_audio_env = {};

  private.MIN_END_Y = -280;
  
  private.screen = 
  {
     [ "closedroom" ]         = { screen = 1, visit = false, lock = false, activ = false }
    ,[ "hall" ]               = { screen = 1, visit = false, lock = false, activ = false }
    ,[ "room_211" ]           = { screen = 1, visit = false, lock = false, activ = false }
    ,[ "room_313" ]           = { screen = 1, visit = false, lock = false, activ = false }
    ,[ "serviceroom" ]        = { screen = 1, visit = false, lock = false, activ = false }
    ,[ "terrace" ]            = { screen = 1, visit = false, lock = false, activ = false }
    ,[ "thirdfloorcorridor" ] = { screen = 1, visit = false, lock = false, activ = false }

    ,[ "winecellar" ]         = { screen = 2, visit = false, lock = false, activ = false }
    ,[ "toilets" ]            = { screen = 2, visit = false, lock = false, activ = false }
    ,[ "eventshall" ]         = { screen = 2, visit = false, lock = false, activ = false }
    ,[ "library" ]            = { screen = 2, visit = false, lock = false, activ = false }
    ,[ "stairflight" ]        = { screen = 2, visit = false, lock = false, activ = false }
    ,[ "cemetery" ]           = { screen = 2, visit = false, lock = false, activ = false }

    ,[ "cemetery_3" ]         = { screen = 3, visit = false, lock = false, activ = false }
    ,[ "lucien_room" ]        = { screen = 3, visit = false, lock = false, activ = false }
    ,[ "tower" ]              = { screen = 3, visit = false, lock = false, activ = false }
    ,[ "brook" ]              = { screen = 3, visit = false, lock = false, activ = false }
    ,[ "barber_room" ]        = { screen = 3, visit = false, lock = false, activ = false }
    ,[ "weapon_room" ]        = { screen = 3, visit = false, lock = false, activ = false }

    ,[ "porch"]               = { screen = 4, visit = false, lock = false, activ = false } 
    ,[ "hall_lvl4"]           = { screen = 4, visit = false, lock = false, activ = false } 
    ,[ "park_lvl4"]           = { screen = 4, visit = false, lock = false, activ = false } 
    ,[ "backyard"]            = { screen = 4, visit = false, lock = false, activ = false } 
    ,[ "room_211_lvl4"]       = { screen = 4, visit = false, lock = false, activ = false } 
    ,[ "graveyard"]           = { screen = 4, visit = false, lock = false, activ = false } 
    ,[ "lucien_room_lvl4"]    = { screen = 4, visit = false, lock = false, activ = false } 
    ,[ "weaponry"]            = { screen = 4, visit = false, lock = false, activ = false } 
  };

  private.save_rooms = 
  {
  };

  local table_multiset = {};

  table.insert( table_multiset, { "obj_map_btn_close", { 
    event_mdown = int_map.Close,
    event_menter = function () private.ButtonEnter( "spr_map_btn_close_focus" ) end, 
    event_mleave = function () private.ButtonLeave( "spr_map_btn_close_focus" ) end 
  } } );

  private.levels_numbers = { level1 = 1, level2 = 2, level3 = 3, levelext = 4 }
  
  for room, value in pairs( private.screen ) do    

    local obj_name  = "obj_map_marker";
    local postfix   = "_screen_"..private.screen[ room ].screen.."_"..room;

    ObjClone( obj_name,  postfix, 1, "obj_map_screen_"..private.screen[ room ].screen );
    ObjClone( "spr_map"..postfix,  "_on",  1, "spr_map"..postfix );
    ObjClone( "spr_map"..postfix,  "_off", 0, "spr_map"..postfix );

    local param = ObjGet( "spr_map"..postfix );

    table.insert( table_multiset, { obj_name..postfix, { 
      pos_x = param.pos_x, 
      pos_y = param.pos_y + 3, 
      pos_z = 3 
    } } );

    table.insert( table_multiset, { "spr_map"..postfix, { 
      event_mdown  = function() private.MarkerMDown( room ) end, 
      event_menter = function() private.MarkerMEnter( CURSOR_HAND, room, private.screen[ room ].screen ) end, 
      event_mleave = function() private.MarkerMLeave( room, private.screen[ room ].screen ) end,
    } } );

    table.insert( table_multiset, { "spr_map"..postfix.."_on", { 
      pos_x = 0, 
      pos_y = 0, 
      alp = 0,
      input = false,
      res = "assets/interface/resources/map/layers/screen_"..private.screen[ room ].screen.."/rm_"..room.."_on" 
    } } );
    table.insert( table_multiset, { "spr_map"..postfix.."_off", { 
      pos_x = 0, 
      pos_y = 0, 
      visible = true,
      input = false,
      res = "assets/interface/resources/map/layers/screen_"..private.screen[ room ].screen.."/rm_"..room.."_off" 
    } } );

  end;

  ObjMultiSet( table_multiset );
  
  private.current_screen = 1;

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then
    --
  else
    --
  end;

end;
--******************************************************************************************
function public.ShowAnim ( event_id )

  local func_end = function () 

    int_map.EventAnimEnd( event_id ); 
    private.curren_location_audio_env = cmn.GetAudio( "env" );
    cmn.Lock( false );
    
  end;

  local tme = private.SHOW_ANIM_TIME;

  cmn.Lock( true );
  ObjAnimate( "int_map", "alp", 0, 0, func_end,{ 
    0.0, 3, 0,
    tme, 3, 1
  } );

  if GetCurrentRoom() ~= "mg_catacomb" then

    private.current_screen = private.screen[ private.pos_player ].screen;
    private.SetCurrentScreen();

    ObjSet( "obj_map_marker_player", { visible = true, pos_x = 0, pos_y = 0 } );
    ObjAttach( "obj_map_marker_player", "obj_map_marker_player_place_screen_"..private.current_screen.."_"..private.pos_player );

    for room, value in pairs( private.screen ) do private.CheckMapRoom( room ); end;

  end;

end;
--******************************************************************************************
function public.HideAnim ( event_id )

  local func_end = function () 

    int_map.EventAnimEnd( event_id );
    common_impl.PlayDialogTimer();

    if( #private.curren_location_audio_env > 0 ) then
      common_impl.EnvPlay( private.curren_location_audio_env, "" );
    end;

  end;

  local tme = private.HIDE_ANIM_TIME;

  ObjAnimate( "int_map", "alp", 0, 0, func_end,{
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.UpdateGameMode ( msg, params )

  if ( params.mode == 3 and not ng_global.gamemode_custom[ "tasks" ] ) then
  end;

end;
--******************************************************************************************
-- function *** Buttons *** () end;
--******************************************************************************************
function private.ButtonDown ( room )

  common.GotoRoom( room, 0, true );
  interface.WidgetSetVisible( InterfaceWidget_Map, false ); 
  common_impl.Lock( true );

end;
--******************************************************************************************
function private.ButtonEnter ( obj )

  local tme = 0.3;
  SetCursor( CURSOR_HAND );
  local alp = ObjGet( obj ).alp;

  ObjAnimate( obj, "alp", 0, 0, "", { 
    0.0,              0, alp, 
    tme *( 1 - alp ), 0,    1
  } );

end;
--******************************************************************************************
function private.ButtonLeave ( obj )

  local tme = 0.3;
  SetCursor( CURSOR_DEFAULT );
  local alp = ObjGet( obj ).alp;

  ObjAnimate( obj, "alp", 0, 0, "", { 
    0.0,       0,    alp, 
    tme *alp , 0,    0
  } ); 

end;
--******************************************************************************************
-- function *** Marker *** () end;
--******************************************************************************************
function private.MarkerMDown ( room )

  local chapter = ng_global.progress[ ng_global.currentprogress ].common.chapter;

  if private.save_rooms[ room ] then

    if private.save_rooms[ room ][ chapter ] then
       room = private.save_rooms[ room ][ chapter ];
    end;

  end;

  if ( GetCurrentRoom() ~= "rm_"..room ) then
    cmn.GotoRoom( "rm_"..room );  
  end;

  int_map.Close();
  
end;
--******************************************************************************************
function private.MarkerMEnter ( cur_type, room, screen )

  local cur = cur_type or CURSOR_DEFAULT;

  common_impl.SetCursor( cur );
  common_impl.PopupShow( room );

  local name_light = "spr_map_screen_"..screen.."_"..room.."_on"
  ObjSet( name_light, { alp = 1 } );

end;
--******************************************************************************************
function private.MarkerMLeave ( room, screen )

  common_impl.SetCursor( CURSOR_DEFAULT );
  common_impl.PopupHide();

  local name_light = "spr_map_screen_"..screen.."_"..room.."_on"
  ObjSet( name_light, { alp = 0 } );

end;

--******************************************************************************************
-- function *** LOGIC *** () end;
--******************************************************************************************
function public.VisitMapRoom ( room )
      
  if ( private.screen[ room ] ) then
  
    local current_screen = private.screen[ room ].screen;

    private.screen[ room ].visit = true;      
    private.pos_player = room; 
      
    ObjSet( "spr_map_screen_"..current_screen.."_"..room,        { input = true, active = true  } );
    ObjSet( "obj_map_marker_undiscovered_screen_"..current_screen.."_"..room, { visible = false } );

  end;

end;
--******************************************************************************************
function public.LockMapRoom ( name, lock )
  
  if ( private.screen[ name ] ) then
    private.screen[ name ].lock = lock;
  end;

end;
--******************************************************************************************
function public.ActiveTaskRoom ( name, active )
    
  if ( private.screen[ name ] ) then
    private.screen[ name ].activ = active;    
  end;

end;
--******************************************************************************************
function private.CheckMapRoom ( room_name )
  
  local current_screen = private.screen[ room_name ].screen;
  local current_lock   = private.screen[ room_name ].lock;
  local current_visit  = private.screen[ room_name ].visit;
  local current_active = private.screen[ room_name ].activ;
  local table_multiset = {};

  --spr_map_screen_1_porch

  local prefix      = "obj_map_marker";
  local spr_prefix  = "spr_map";
  local postfix     = "_screen_"..current_screen.."_"..room_name;
  
  table.insert( table_multiset, { prefix..postfix,            { input = false } } ); 
  table.insert( table_multiset, { "spr_map"..postfix.."_off", { visible = not current_visit } } ); 

  if ( current_visit ) then

    table.insert( table_multiset, { spr_prefix..postfix,         { input   = not current_lock } } );        
    table.insert( table_multiset, { prefix.."_blocked"..postfix, { visible = current_lock     } } );

    if ( current_lock ) then
      table.insert( table_multiset, { prefix.."_task"..postfix,    { visible = false } } );
      table.insert( table_multiset, { prefix.."_no_task"..postfix, { visible = false } } );
    else
      table.insert( table_multiset, { prefix.."_task"..postfix,    { visible = current_active     } } );
      table.insert( table_multiset, { prefix.."_no_task"..postfix, { visible = not current_active } } );
    end;

  end;

  ObjMultiSet( table_multiset );

end;
--******************************************************************************************
function private.SetCurrentScreen ()

  local table_multiset = {};

  for s = 1, 4 do
    table.insert( table_multiset, { "obj_map_screen_"..s, { input = false, alp = 0 } } );
  end;

  local current_level_name = private.current_screen ;
  table.insert( table_multiset, { "obj_map_screen_"..current_level_name, { input = true, alp = 1 } } );

  --------------------------------------------------------------------------------------------
  if (current_level_name == 4) then

    table.insert( table_multiset, { "spr_int_map_back_lvl4", { alp = 1, visible = true  } } );
    table.insert( table_multiset, { "obj_map_paper_lvl3",    { alp = 1, visible = true  } } );

    table.insert( table_multiset, { "spr_int_map_back",      { alp = 0, visible = false } } );
    table.insert( table_multiset, { "obj_map_paper",         { alp = 0, visible = false } } );
    private.AnimationPlate ( "obj_map_paper_lvl3" ); 

  elseif (current_level_name == 3) then

    table.insert( table_multiset, { "spr_int_map_back",      { alp = 1, visible = true  } } );
    table.insert( table_multiset, { "obj_map_paper_lvl3",    { alp = 1, visible = true  } } );

    table.insert( table_multiset, { "spr_int_map_back_lvl4", { alp = 0, visible = false } } );
    table.insert( table_multiset, { "obj_map_paper",         { alp = 0, visible = false } } );
    private.AnimationPlate ( "obj_map_paper_lvl3" ); 

  else
    table.insert( table_multiset, { "spr_int_map_back",      { alp = 1, visible = true  } } );
    table.insert( table_multiset, { "obj_map_paper",         { alp = 1, visible = true  } } );

    table.insert( table_multiset, { "spr_int_map_back_lvl4", { alp = 0, visible = false } } );
    table.insert( table_multiset, { "obj_map_paper_lvl3",    { alp = 0, visible = false } } );
    private.AnimationPlate ( "obj_map_paper" ); 
  end;
  --------------------------------------------------------------------------------------------

  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

end;

--******************************************************************************************
-- function *** ANIM *** () end;
--******************************************************************************************
function private.AnimationPlate ( obj ) 

  ObjAnimate( obj , "ang", 1, 0, "", { 
     0.0, 0,  0.00, 
     3.0, 0,  0.02, 
     6.0, 0,  0.00,
     9.0, 0, -0.02,
    12.0, 0,  0.00  
  } );

end;
--******************************************************************************************