-- name=int_taskpanel_secret
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_taskpanel_secret", interface.originhub );
  ObjSet( "int_taskpanel_secret", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.MOVE_ANIM_TIME      = 0.6;
  private.MOVE_ANIM_POS_Y_TOP = 714;
  private.MOVE_ANIM_POS_Y_BOT = 888;

  local pos_offset = - 15;
  --private.TASKHEADER_MOVE_ANIM_TIME_BEG  = int_taskheader_impl.MOVE_ANIM_TIME_BEG;
  --private.TASKHEADER_MOVE_ANIM_TIME_END  = int_taskheader_impl.MOVE_ANIM_TIME_END;
  --private.TASKHEADER_MOVE_ANIM_POS_Y_TOP = int_taskheader_impl.MOVE_ANIM_POS_Y_TOP + pos_offset;
  --private.TASKHEADER_MOVE_ANIM_POS_Y_BOT = int_taskheader_impl.MOVE_ANIM_POS_Y_BOT + pos_offset;

  local tb = {};

  table.insert( tb, { "obj_int_taskpanel_secret_clk_win_secret", {
    event_mdown =  function () private.ClkAchievButton( "win_secret" ); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } } );

  table.insert( tb, { "obj_int_taskpanel_secret_clk_less_12minutes", {
    event_mdown =  function () private.ClkAchievButton( "less_12minutes" ); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } } );

  table.insert( tb, { "obj_int_taskpanel_secret_clk_less_6minutes", {
    event_mdown =  function () private.ClkAchievButton( "less_6minutes" ); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } } );

  table.insert( tb, { "obj_int_taskpanel_secret_clk_no_hint", {
    event_mdown =  function () private.ClkAchievButton( "no_hint" ); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } } );

  ObjMultiSet( tb );

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function private.WideScreenUpdate ()
end;
--******************************************************************************************
function public.UpdateProgressPanel ()

  local prg = { "get_amulets_secret", "get_chimeras_secret", "get_jacketl_secret", "get_blood_secret", "get_knives_secret", "get_ghost_secret" };

  for i = 1, #prg do

    if ( cmn.IsEventDone( prg[ i ] ) ) then

      ObjSet( "spr_int_taskpanel_secret_progress_bar_"..i, { alp = 1 } );
      
    end;

  end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local obj = "int_taskpanel_secret";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme = private.MOVE_ANIM_TIME;

  local beg_y = ObjGet( obj ).pos_y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 2, beg_y,--private.MOVE_ANIM_POS_Y_BOT,
    tme, 2, private.MOVE_ANIM_POS_Y_TOP
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local obj = "int_taskpanel_secret";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme = private.MOVE_ANIM_TIME;

  local beg_y = ObjGet( obj ).pos_y; 

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 1, beg_y,--private.MOVE_ANIM_POS_Y_TOP,
    tme, 1, private.MOVE_ANIM_POS_Y_BOT
  } );

end;
--******************************************************************************************
function private.ClkAchievButton ( id )

  common_impl.ShowBbt( "bbt_secretroom_achiev_info_"..id );

end;
--******************************************************************************************
function public.UpdateAchievpanel ()

  for key, value in pairs( ng_global.secret.achiev ) do 

    if ( value ) then

      ObjMultiSet( {
        { "spr_int_taskpanel_secret_"..key,           { alp = 1 } },
        { "spr_int_taskpanel_secret_"..key.."_done",  { alp = 1 } },
        { "spr_int_taskpanel_secret_"..key.."_off",   { alp = 0 } },
      } );

    elseif ( ng_global.secret.achiev_temp[ key ] ) then

      ObjMultiSet( {
        { "spr_int_taskpanel_secret_"..key,           { alp = 1 } },
        { "spr_int_taskpanel_secret_"..key.."_done",  { alp = 0 } },
        { "spr_int_taskpanel_secret_"..key.."_off",   { alp = 0 } },
      } );

    elseif ( not ng_global.secret.achiev_temp[ key ] ) then

      ObjMultiSet( {
        { "spr_int_taskpanel_secret_"..key,           { alp = 0 } },
        { "spr_int_taskpanel_secret_"..key.."_done",  { alp = 0 } },
        { "spr_int_taskpanel_secret_"..key.."_off",   { alp = 1 } },
      } );

    end;

  end;

end;
--******************************************************************************************






