-- name=interface_impl

function public.Init ()

    private.Init_Deploy();
    public.Init_DialogHint();
    public.Init_Lock();
    private.Init_Diary();
    private.Init_Task();
    private.Init_Achievements();
    private.Init_BtnCollectibles2();
    private.Init_BtnCollectibles();
    private.Init_BtnMorph();
    private.Init_Slider();
    private.Init_BtnMiniHO();
    private.Init_BtnDiary();

    private.Init_IntTaskpanelSecret();
    private.Init_IntMorphSecret();
    private.Init_IntTimerSecret();
    private.Init_IntDialogSecret();

end;
--******************************************************************************************
function private.Init_Deploy ()

  function interface.DeployInvAdd(pos_z)

    InterfaceWidget_Deploy_Inv = "InterfaceWidget_Deploy_Inv";
    interface.CustomWidgetAdd( InterfaceWidget_Deploy_Inv, "assets/interface/int_deploy_inv", "int_deploy_inv",pos_z );

  end;
  -------------------------------------------------------------------------------------
  function interface.GetCurrentInv ()

    if ( _G[ "int_deploy_inv" ] ) then

      if ( int_deploy_inv.IsOnScreen() ) then 
 
        return int_deploy_inv.GetCurrentName();

      end;   
  
    end;

    return "";

  end;

  -------------------------------------------------------------------------------------

  function interface.DeployInvShow ( inv_obj )
    
    if _G[ "int_deploy_inv" ] then

      int_deploy_inv.Show( inv_obj );

    end;

  end;

  -------------------------------------------------------------------------------------

  function interface.DeployInvHide ()

    --common_impl.DeleteHintFx()
  
    if _G[ "int_deploy_inv" ] then

      int_deploy_inv.Hide();

    end;
    
  end;
  
  -------------------------------------------------------------------------------------

  function interface.DeployPreviousLoc ( tb )

    if _G[ "int_deploy_inv" ] then

      int_deploy_inv.PreviousLoc( tb );

    end;
    
  end;

  -------------------------------------------------------------------------------------

  function interface.DeployCheckPreviousLoc ( mg_name )

    if _G[ "int_deploy_inv" ] then

      return int_deploy_inv.CheckPreviousLoc( mg_name );

    end;
    
  end;

end;
--******************************************************************************************
function public.Init_DialogHint ()

  -------------------------------------------------------------------------------------
  function interface.DialogHintAdd ()

    InterfaceWidget_Dialog_Hint = "InterfaceWidget_Dialog_Hint";
    interface.CustomWidgetAdd( InterfaceWidget_Dialog_Hint, "assets/interface/int_dialog_hint", "int_dialog_hint" );

  end;

  -------------------------------------------------------------------------------------

  function interface.DialogHintShow ( dlg_room )

    dlg_room = dlg_room;  
    int_dialog_hint.Show( dlg_room );

  end;

  -------------------------------------------------------------------------------------

  function interface.DialogHintHide ()

    int_dialog_hint.Hide();

  end;

end;
--******************************************************************************************
function public.Init_Lock ()

  function interface.LockAdd()

    InterfaceWidget_Lock = "InterfaceWidget_Lock";
    interface.CustomWidgetAdd( InterfaceWidget_Lock, "assets/interface/int_lock", "int_lock", 1501 );

    ------------------------------------------------------------------------------------

    function interface.LockShow ( key )

      if _G[ "int_lock" ] then

        int_lock.Show( key );

      end;

    end;

    ------------------------------------------------------------------------------------

    function interface.LockHide ( key )

      if _G[ "int_lock" ] then

        int_lock.Hide( key );

      end;

    end;

  end;

end;
--******************************************************************************************
function private.Init_Task ()

  function interface.ButtonTaskAdd ( pos_z )

    InterfaceWidget_Button_Task = "InterfaceWidget_Button_Task";
    interface.CustomWidgetAdd( InterfaceWidget_Button_Task, "assets/interface/int_button_task", "int_button_task", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.DialogTaskAdd ( pos_z )

    InterfaceWidget_Dialog_Task = "InterfaceWidget_Dialog_Task";
    interface.CustomWidgetAdd( InterfaceWidget_Dialog_Task, "assets/interface/int_dialog_task", "int_dialog_task", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.DialogTaskShow ( task, state, func_end )
    
    local data = { task = task, state = state, func_end = func_end };

    if ( not int_dialog_task.show ) then 
     
      if ( _G[ "int_dialog_task" ] ) then

         int_dialog_task.Show( data );

      end;

    else

      interface.DialogTaskHide();

    end;

  end;
  ------------------------------------------------------------------------------------
  function interface.DialogTaskHide ()

    if ( int_dialog_task.show ) then

      if ( _G[ "int_dialog_task" ] ) then

         int_dialog_task.Hide();

      end;

    end;
    
  end;
  ------------------------------------------------------------------------------------
  function interface.KeyTaskAdd ( task_name, func_end )

    ng_global.task_current = task_name;
    int_button_task.Update( true, task_name );
    --common_impl.PlayAudio( "sfx", "common/audio/aud_global_task", 0, "", 0 );
    
    interface.DialogTaskShow( task_name, "new_task", func_end );

  end;
  ------------------------------------------------------------------------------------
  function interface.KeyTaskDone ( runtime )

    if ( runtime ) then

      interface.DialogTaskShow( ng_global.task_current, "done_task" );  

    end;
    int_button_task.Update( false, "none" );
    ng_global.task_current = "none";
  
  end;
  ------------------------------------------------------------------------------------
  function interface.KeyUpdate ()

    local active = false;
    if ( ng_global.task_current ) and ( ng_global.task_current ~= "none" ) then
      active = true;
    end;

    int_button_task.Update( active, ng_global.task_current );
  
  end;
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_BtnDiary ()

  function interface.ButtonDiaryAdd ( pos_z )

    InterfaceWidget_Button_Diary = "InterfaceWidget_Button_Diary";
    interface.CustomWidgetAdd( InterfaceWidget_Button_Diary, "assets/interface/int_button_diary", "int_button_diary", pos_z );

  end;

end;
--******************************************************************************************
function private.Init_Achievements ()

  function interface.AchievementsAdd ( pos_z )

    InterfaceWidget_achievements = "InterfaceWidget_achievements";
    interface.CustomWidgetAdd( InterfaceWidget_achievements, "assets/interface/int_achievements", "int_achievements", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.ShowAchievements ( name )

    int_achievements.Show( name );

  end;
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_BtnCollectibles2 ()

  function interface.BtnCollectibles2Add ( pos_z )

    InterfaceWidget_collectibles2 = "InterfaceWidget_collectibles2";
    interface.CustomWidgetAdd( InterfaceWidget_collectibles2, "assets/interface/int_button_collectibles2", "int_button_collectibles2", pos_z );

  end;
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_BtnCollectibles ()

  function interface.BtnCollectiblesAdd ( pos_z )

    InterfaceWidget_collectibles = "InterfaceWidget_collectibles";
    interface.CustomWidgetAdd( InterfaceWidget_collectibles, "assets/interface/int_button_collectibles", "int_button_collectibles", pos_z );

  end;
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------

end;

--******************************************************************************************
function private.Init_BtnMorph ()

  function interface.BtnMorphAdd ( pos_z )

    InterfaceWidget_morph = "InterfaceWidget_morph";
    interface.CustomWidgetAdd( InterfaceWidget_morph, "assets/interface/int_button_morph", "int_button_morph", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.ShowMorph ()
   
    int_button_morph.Show();

  end;
  ------------------------------------------------------------------------------------

end;


--******************************************************************************************
function private.Init_BtnMiniHO ()

  function interface.BtnMiniHOAdd ( pos_z )

    InterfaceWidget_MiniHO = "InterfaceWidget_MiniHO";
    interface.CustomWidgetAdd( InterfaceWidget_MiniHO, "assets/interface/int_button_mini_ho", "int_button_mini_ho", pos_z );

  end;

end;


--******************************************************************************************
function private.Init_Diary()

  function interface.DiaryAdd(pos_z)

    InterfaceWidget_Diary = "InterfaceWidget_Diary";
    interface.CustomWidgetAdd( InterfaceWidget_Diary, "assets/interface/int_diary", "int_diary",pos_z );

  end;

  ------------------------------------------------------------------------------------

  function interface.DiaryShow ()
    
    if int_diary.show == 0 then 
     
      if _G[ "int_diary" ] then

         int_diary.Show();

      end;

    else

      interface.DiaryHide();

    end;

  end;

  ------------------------------------------------------------------------------------

  function interface.DiaryHide ()

    if int_diary.show == 1 then

      if _G[ "int_diary" ] then

         int_diary.Hide();

      end;

    end;
    
  end;

end;
--******************************************************************************************
function private.Init_Slider ()

  function interface.SliderAdd (pos_z)

    InterfaceWidget_Slider = "InterfaceWidget_Slider";
    interface.CustomWidgetAdd( InterfaceWidget_Slider, "assets/interface/int_slider", "int_slider", pos_z );

  end;

end;
--******************************************************************************************
-- secretroom --->
--******************************************************************************************
function private.Init_IntTaskpanelSecret ()

  function interface.IntTaskpanelSecretAdd ( pos_z )

    InterfaceWidget_TaskpanelSecret = "InterfaceWidget_TaskpanelSecret";
    interface.CustomWidgetAdd( InterfaceWidget_TaskpanelSecret, "assets/interface/int_taskpanel_secret", "int_taskpanel_secret", pos_z );

  end;
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_IntMorphSecret ()

  function interface.IntMorphSecretAdd ( pos_z )

    InterfaceWidget_MorphSecret = "InterfaceWidget_MorphSecret";
    interface.CustomWidgetAdd( InterfaceWidget_MorphSecret, "assets/interface/int_morph_secret", "int_morph_secret", pos_z );

  end;
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_IntTimerSecret ()

  function interface.IntTimerSecretAdd ( pos_z )

    InterfaceWidget_TimerSecret = "InterfaceWidget_TimerSecret";
    interface.CustomWidgetAdd( InterfaceWidget_TimerSecret, "assets/interface/int_timer_secret", "int_timer_secret", pos_z );

  end;
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_IntDialogSecret ()

  function interface.IntDialogSecretAdd ( pos_z )

    InterfaceWidget_DialogSecret = "InterfaceWidget_DialogSecret";
    interface.CustomWidgetAdd( InterfaceWidget_DialogSecret, "assets/interface/int_dialog_secret", "int_dialog_secret", pos_z );

  end;
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------

end;
-- secretroom end
