-- name=subroom_impl
--********************************************************************************************************************
function public.Init()

  public.BLACK = "spr_subroom_black_screen";
  public.FRAME = "grd_int_frame_subroom_impl";
  private.BLACK_ALP = 0.8;

  private.SHOW_TIME = 0.5;
  private.HIDE_TIME = 0.5;
  public.IsAnim = false;

end;
--********************************************************************************************************************
function public.Show( event_id, subroom_name, position, frame )
  
  local trg = function() 

    if not ( subroom_name == "zz_clockface_2" ) then
      
      cmn.Lock( false, "show_zz" )
      
    end;
    
    subroom.EventAnimEnd( event_id ); 
    public.IsAnim = false; 

  end;

  local tme = private.SHOW_TIME;

  local params_anim = 
  { 
    alp = {0,0,0, tme,1,1},
    pos_xy = {0,0,position[1].x,position[1].y, tme,1,position[2].x,position[2].y},
    scale_xy = {0,0,0,0, 4*tme/5,3,1.1,1.1, tme,3,1,1 }
  };

  local back_params = ObjGet( subroom_name );

  public.IsAnim = true;

  cmn.Lock( true, "show_zz" );

  for param, anm_table in pairs( params_anim ) do
    ObjAnimate( subroom_name, param, 0, 0, "", anm_table );
  end;

  ObjAnimate( public.BLACK, "alp", 0, 0, trg, {0,0,ObjGet( public.BLACK ).alp, tme,0,private.BLACK_ALP} );

  ObjSet( subroom_name, {  
      inputrect_init = true,
      inputrect_x = ( - 0.5 * back_params.draw_width ),
      inputrect_w = back_params.draw_width, 
      inputrect_y = ( - 0.5 * back_params.draw_height ),
      inputrect_h = back_params.draw_height, 
  } );


  --[[
    ObjSet( subroom_name, {  
        croprect_init = true, 
        croprect_x = ( - 0.5 * back_params.draw_width ),
        croprect_w = back_params.draw_width, 
        croprect_y = ( - 0.5 * back_params.draw_height ),
        croprect_h = back_params.draw_height 
    } );
 
  ]]

  interface.ShowFrameSubroom( subroom_name, frame );

end;
--********************************************************************************************************************
function public.Hide( event_id, subroom_name, position, is_subroom )

  local trg = function()  
    
    interface.HideFrameSubroom();
    cmn.Lock( false, "hide_zz" );
    subroom.EventAnimEnd( event_id ); 
    public.IsAnim = false;     

  end;

  local tme = private.HIDE_TIME;

  local params_anim = 
  { 
    alp = {0,0,1, tme,0,0},
    pos_xy = {0,0,position[2].x,position[2].y, tme,0,position[1].x,position[1].y},
    scale_xy = {0,0,1,1, tme/5,3,1.1,1.1, tme,3,0,0 }
  };

  public.IsAnim = true;

  cmn.Lock( true, "hide_zz" );

  for param, anm_table in pairs( params_anim ) do
    ObjAnimate( subroom_name, param, 0, 0, trg, anm_table );
    trg = "";
  end;

  if ( not is_subroom ) then
    ObjAnimate( public.BLACK, "alp", 0, 0, "", {0,0,private.BLACK_ALP, tme,0,0} );  
  end;

end;
--********************************************************************************************************************
