-- name=ho_minibar
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "minibar" );
  game.relations[ "ho_minibar" ].exitroom = "rm_room_211";

  --------------------------------------------------------------------------------------------------
  private.room_objname = "ho_minibar";
  private.task_name = "win_minibar";
  private.win = 6;
  
  private.anim_demon = false;
  private.anim_cocaroaches = false;

  private.coordinates_cover_object = { 
                                        spr_minibar_card_1_cover = { old = { pos_x = 585, pos_y = 497 }, new = { pos_x = 760, pos_y = 613 } }, 
                                        spr_minibar_card_2_cover = { old = { pos_x = 234, pos_y = 305 }, new = { pos_x = 330, pos_y = 283 } },
                                        spr_minibar_corkscrew_1_cover = { old = { pos_x = 687, pos_y = 194 }, new = { pos_x = 695, pos_y = 91 } },
                                        spr_minibar_dice_1_cover = { old = { pos_x = 659, pos_y = 316 }, new = { pos_x = 696, pos_y = 346 } },
                                        spr_minibar_lemon_1_cover = { old = { pos_x = 172, pos_y = 465 }, new = { pos_x = -5, pos_y = 513 } },
                                        spr_minibar_lemon_2_cover = { old = { pos_x = 662, pos_y = 427 }, new = { pos_x = 777, pos_y = 507 } },
                                        spr_minibar_pipe_1_cover = { old = { pos_x = 862, pos_y = 75 }, new = { pos_x = 717, pos_y = 43 } },
                                        spr_minibar_pipe_2_cover = { old = { pos_x = 361, pos_y = 455 }, new = { pos_x = 431, pos_y = 525 } },
                                        spr_minibar_winehorn_1_cover = { old = { pos_x = 843, pos_y = 377 }, new = { pos_x = 1076, pos_y = 462 } } 
                                     };
                                      
                         
  private.angle_move = {
                          spr_minibar_corkscrew_2_cover = 2,
                          spr_minibar_dice_2_cover = 0.27 
                       };
                        
                        
  private.scale_move = {
                          spr_minibar_dice_2_cover = 0.8  
                       };

                        
  private.alpha_move = { 
                          spr_minibar_winehorn_2_cover = { 
                                                          appear = { "spr_minibar_winehorn_2_cover_2" },
                                                          dissappear = { "spr_minibar_winehorn_2_cover" } 
                                                       }
                       };
                        
  --------------------------------------------------------------------------------------------------

  private.moving_type = { 
                            spr_minibar_card_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_minibar_card_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_minibar_corkscrew_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_minibar_corkscrew_2_cover = "MOVE_ANGLE",
                            spr_minibar_dice_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_minibar_dice_2_cover = "MIXED",
                            spr_minibar_lemon_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_minibar_lemon_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_minibar_pipe_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_minibar_pipe_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_minibar_winehorn_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_minibar_winehorn_2_cover = "MOVE_ALPHA" 
                        };

  --------------------------------------------------------------------------------------------------

  ObjMultiSet( {  
    { "spr_minibar_card_1_cover",           { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_card_1_cover", "card" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_card_2_cover",           { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_card_2_cover", "card" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_corkscrew_1_cover",      { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_corkscrew_1_cover", "corkscrew" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_corkscrew_2_cover",      { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_corkscrew_2_cover", "corkscrew" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_dice_1_cover",           { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_dice_1_cover", "dice" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_dice_2_cover",           { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_dice_2_cover", "dice" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_lemon_1_cover",          { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_lemon_1_cover", "lemon" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_lemon_2_cover",          { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_lemon_2_cover", "lemon" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_pipe_1_cover",           { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_pipe_1_cover", "pipe" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_pipe_2_cover",           { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_pipe_2_cover", "pipe" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_winehorn_1_cover",       { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_winehorn_1_cover", "winehorn" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_winehorn_2_cover",       { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_winehorn_2_cover", "winehorn" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_minibar_wooden_amulet",          { input = false, 
                                              event_mdown = function() private.TaskComplete( "spr_minibar_wooden_amulet", "wooden_amulet" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
                                              
    { "obj_minibar_demon",                  { event_mdown = private.AnimDemon } },
    { "obj_minibar_cocaroaches",            { event_mdown = private.AnimCocaroaches } }
    
  } );    
  
  
  --------------------------------------------------------------------------------------------
  -- function win_minibar () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_minibar" ] = {
    type = "win",
    room = "rm_room_211",
    zz = "ho_minibar",
    zz_gate = "gho_room_211_minibar"
  };
  local win_minibar_inv = function ()
  
    if ( cmn.IsEventDone( "win_minibar" ) ) then
    
      interface.InventoryItemAdd( "inv_woodenamulet", "spr_minibar_win" );    
    
    end;
    
  end;
  local win_minibar_loc = function ()
  
    if ( cmn.IsEventDone( "win_minibar" ) ) then
    
      ObjDelete( "gho_room_211_minibar" );    
    
    end;
    
  end;

  cmn.AddSubscriber( "win_minibar", win_minibar_inv );
  cmn.AddSubscriber( "win_minibar", win_minibar_loc, "rm_room_211" );
  
  --------------------------------------------------------------------------------------------------
  local start_minibar_func = function ()

    DbgTrace("start_minibar_func");
    
    if ( cmn.IsEventStart( "win_minibar" ) ) then

      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;
-------------------------------------
-------------------------------------
      local foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
      local nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

      if #foundCouples > 0 then 

        local lastCouple = foundCouples[ #foundCouples ];
        if #lastCouple == 1 then

          local taskPanelObject = "spr_minibar_"..lastCouple[ 1 ].."_shadow_1";
          ObjAttach( taskPanelObject, "obj_int_taskpanel_minibar" ); 
          ObjSet( taskPanelObject, { pos_x = -170, pos_y = 15 } );

          ObjSet( "txt_minibar_taskpanel", { scale_x = 0, scale_y = 0 } );

        else 

          ObjSet( "txt_minibar_taskpanel", { scale_x = 1, scale_y = 1 } );

        end; 

        if ( #foundCouples == private.win and #lastCouple == 2 ) then 

          ObjAttach( "spr_minibar_wooden_amulet_shadow", "obj_int_taskpanel_minibar" ); 
          ObjSet( "spr_minibar_wooden_amulet_shadow", { pos_x = 0, pos_y = 15 } );
          ObjSet( "spr_minibar_wooden_amulet", { input = true } );

        end;

      end;
-------------------------------------
-------------------------------------
      for i = 1, #foundCouples, 1 do 

        local curCoupleObject = foundCouples[ i ];
        local curCoupleCover = nameTaskObjects[ i ];

        for j = 1, #curCoupleObject, 1 do 

          local taskObjectCover = curCoupleCover[ j ];
          ObjSet( taskObjectCover, { input = false } );
          
          if private.moving_type[ taskObjectCover ] == "MOVE_XY_COVER_OBJECT" then 

            local taskObjectCoverX = private.coordinates_cover_object[ taskObjectCover ].new.pos_x;
            local taskObjectCoverY = private.coordinates_cover_object[ taskObjectCover ].new.pos_y; 
            ObjSet( taskObjectCover, { pos_x = taskObjectCoverX, pos_y = taskObjectCoverY } );
   
          elseif private.moving_type[ taskObjectCover ] == "MOVE_ANGLE" then 

            local taskObjectCoverAngle = private.angle_move[ taskObjectCover ];
            ObjSet( taskObjectCover, { ang = taskObjectCoverAngle } );
            
          elseif private.moving_type[ taskObjectCover ] == "MIXED" then  
            
            local taskObjectCoverAngle = private.angle_move[ taskObjectCover ];
            local taskObjectCoverScale = private.scale_move[ taskObjectCover ];
            ObjSet( taskObjectCover, { ang = taskObjectCoverAngle, scale_x = taskObjectCoverScale } );          
            
          elseif private.moving_type[ taskObjectCover ] == "MOVE_ALPHA" then 

            local animObjectsAppear = private.alpha_move[ taskObjectCover ].appear;
            
            for i = 1, #animObjectsAppear, 1 do
              
              local curObject = animObjectsAppear[ i ];
              ObjSet( curObject, { alp = 1 } );
              
            end;
            
            local animObjectsDissappear = private.alpha_move[ taskObjectCover ].dissappear;
            
            for i = 1, #animObjectsDissappear, 1 do
              
              local curObject = animObjectsDissappear[ i ];
              ObjSet( curObject, { alp = 0 } );
              
            end;

          end;

        end; 

      end;

    end;

  end;
  cmn.AddSubscriber( "win_minibar", start_minibar_func, private.room_objname );   
  
end;

--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level2/env/aud_room_313_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_minibar" ) ) then
  
    cmn.InitHo( "minibar" );
    cmn.SetEventDone( "opn_minibar" );
    
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = {};
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = {};

  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "card_1",       1, 0, { { "spr_minibar_card_1_cover", "spr_minibar_card_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "card_2",       1, 0, { { "spr_minibar_card_2_cover", "spr_minibar_card_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "corkscrew_1",  1, 0, { { "spr_minibar_corkscrew_1_cover",  "spr_minibar_corkscrew_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "corkscrew_2",  1, 0, { { "spr_minibar_corkscrew_2_cover",  "spr_minibar_corkscrew_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "dice_1",       1, 0, { { "spr_minibar_dice_1_cover",  "spr_minibar_dice_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "dice_2",       1, 0, { { "spr_minibar_dice_2_cover",  "spr_minibar_dice_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "lemon_1",      1, 0, { { "spr_minibar_lemon_1_cover",   "spr_minibar_lemon_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "lemon_2",      1, 0, { { "spr_minibar_lemon_2_cover",   "spr_minibar_lemon_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "pipe_1",       1, 0, { { "spr_minibar_pipe_1_cover",   "spr_minibar_pipe_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "pipe_2",       1, 0, { { "spr_minibar_pipe_2_cover",   "spr_minibar_pipe_1_cover"  } } );
  interface.TaskPanelTaskAdd( ho_items, "winehorn_1",   1, 0, { { "spr_minibar_winehorn_1_cover", "spr_minibar_winehorn_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "winehorn_2",   1, 0, { { "spr_minibar_winehorn_2_cover", "spr_minibar_winehorn_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "wooden_amulet", 1, 0, { { "spr_minibar_wooden_amulet" } } );

  ObjAttach( "obj_int_taskpanel_minibar", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 
  interface.TaskPanelShow( ho_items );

end;


--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  
  common_impl.TutorialShow( "tutorial_page_16" );
  
end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();
  
  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_minibar" );

end;


--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();
  
end;


--*********************************************************************************************************************
function private.TaskComplete( sender, task ) 
 
  
  DbgTrace("private.TaskComplete");
  
  local EMPTY_PROGRESS = 0;
  local ACTIVATE_WIN_OBJECT = 6;
  local NOT_COMPLETED_COUPLE = 1;
  local COMPLETED_COUPLE = 2;

  local foundCouples = {};
  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local countFoundCouples = #foundCouples;

  local nameTaskObjects = {};
  nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

  if countFoundCouples == EMPTY_PROGRESS then
 
    local foundTask = { task };
    table.insert( foundCouples, foundTask );

    local foundObjectTask = { sender };
    table.insert( nameTaskObjects, foundObjectTask );

    private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
    private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
    ObjSet( sender, { input = false } );

    cmn.Lock( true );

  else 

    local lastCouple = foundCouples[ countFoundCouples ];
    local sizeLastCouple = #lastCouple;

    if sizeLastCouple == COMPLETED_COUPLE then   

      if countFoundCouples == ACTIVATE_WIN_OBJECT then 

        local taskObjectNameWin = "spr_minibar_"..task;
        cmn.HoTaskFind( taskObjectNameWin, task );
        private.TaskPanel( "WINNING", "wooden_amulet" );

      else 

        local foundTask = { task };
        table.insert( foundCouples, foundTask );

        local foundObjectTask = { sender };
        table.insert( nameTaskObjects, foundObjectTask );

        private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
        private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );

      end;

    elseif sizeLastCouple == NOT_COMPLETED_COUPLE then  

      local firstObject = lastCouple[ 1 ];
      local lastObjectTask = nameTaskObjects[ #nameTaskObjects ];
      local prevSender = lastObjectTask[ 1 ];

      if firstObject == task then 

        table.insert( lastCouple, task );
        table.insert( lastObjectTask, sender );

        local taskObjectName_1 = "spr_minibar_"..task.."_1";
        local task_1 = task.."_1";
        cmn.HoTaskFind( taskObjectName_1, task_1 );
        
        --common_impl.StopAudio( "sfx", "aud_hide_sfx", 0 );
        common_impl.StopAudio( "sfx", "aud_clk_ho_sfx2", 0 );
        
        local taskObjectName_2 = "spr_minibar_"..task.."_2";
        local task_2 = task.."_2";
        cmn.HoTaskFind( taskObjectName_2, task_2 );
        
        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_RIGHT_COUPLE", task );
        private.TaskPanel( "RIGHT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );

        if countFoundCouples == ACTIVATE_WIN_OBJECT then 

          ObjSet( "spr_minibar_wooden_amulet", { input = true } );

          local func_end_win = function () 
            private.TaskPanel( "ACTIVATE_WIN_OBJECT", "wooden_amulet" );
          end;

          ObjAnimate( "obj_minibar_items", "alp",0,0, func_end_win, { 0, 0, 1,    0.7, 0, 1 } );

        end;

      else 

        table.remove( foundCouples );
        table.remove( nameTaskObjects );

        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_WRONG_COUPLE", task, prevSender );
        private.TaskPanel( "WRONG_COMPLETED_COUPLE", firstObject );
        ObjSet( prevSender, { input = true } );

        cmn.Lock( true );

      end;

    end;

  end;
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = foundCouples;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = nameTaskObjects;
  
  if ( #ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples > 0 ) then

    local sizeS = #ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;

    if ( #ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples[ sizeS ] == 1 ) then
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples[ sizeS ][ 1 ];
    else
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = "";
    end;

  else 

    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = "";

  end;
  
end;


--*********************************************************************************************************************
function private.MoveCoveringObjects( taskObject, moveType, direction ) 

  
  DbgTrace("private.MoveCoveringObjects");
  
  if moveType == "MOVE_XY_COVER_OBJECT" then 

    local oldX = private.coordinates_cover_object[ taskObject ].old.pos_x;
    local oldY = private.coordinates_cover_object[ taskObject ].old.pos_y;

    local newX = private.coordinates_cover_object[ taskObject ].new.pos_x;
    local newY = private.coordinates_cover_object[ taskObject ].new.pos_y;

    local beginX = 0;
    local beginY = 0;

    local endX = 0;
    local endY = 0;

    if direction == "OLD_TO_NEW" then 

      beginX = oldX;
      beginY = oldY;

      endX = newX;
      endY = newY;
      
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_ho_parts", 0, "", 0 );

    elseif direction == "NEW_TO_OLD" then 

      beginX = newX;
      beginY = newY;

      endX = oldX;
      endY = oldY;

      common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );

    end;

    ObjAnimate( taskObject, "pos_xy",0,0, "", { 0, 3, beginX, beginY,    0.4, 3, endX, endY } );
    
-------------------------------------
-------------------------------------
  elseif moveType == "MOVE_ANGLE" then 

    local beginAngle = 0;
    local endAngle = 0;

    if direction == "OLD_TO_NEW" then 

      beginAngle = 0;
      endAngle = private.angle_move[ taskObject ];
      
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_ho_parts", 0, "", 0 );
    
    elseif direction == "NEW_TO_OLD" then 

      beginAngle = private.angle_move[ taskObject ];
      endAngle = 0;

      common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );

    end;
    
    ObjAnimate( taskObject, "ang",0,0, "", { 0, 0, beginAngle,    0.4, 0, endAngle } );
    
-------------------------------------
-------------------------------------
  elseif moveType == "MOVE_ALPHA" then

    local beginState = 0;
    local endState = 0;

    if direction == "OLD_TO_NEW" then 

      beginState = 0;
      endState = 1;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_ho_parts", 0, "", 0 );
      
    elseif direction == "NEW_TO_OLD" then 

      beginState = 1;
      endState = 0;

      common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );
      
    end;
    
    local animObjectsAppear = private.alpha_move[ taskObject ].appear;
    
    for i = 1, #animObjectsAppear, 1 do
      
      local curObject = animObjectsAppear[ i ];
      ObjAnimate( curObject, "alp",0,0, "", { 0, 3, beginState,    0.4, 3, endState } );
      
    end;
    
    local animObjectsDissappear = private.alpha_move[ taskObject ].dissappear;
    
    for i = 1, #animObjectsDissappear, 1 do
      
      local curObject = animObjectsDissappear[ i ];
      ObjAnimate( curObject, "alp",0,0, "", { 0, 3, endState,    0.4, 3, beginState } );
      
    end;
      
-------------------------------------
-------------------------------------
  elseif moveType == "MIXED" then
    
    local beginAngle = 0;
    local endAngle = 0;

    local beginScale = 1;
    local endScale = 1;
    
    if direction == "OLD_TO_NEW" then 

      beginAngle = 0;
      endAngle = private.angle_move[ taskObject ];
      
      beginScale = 1;
      endScale = private.scale_move[ taskObject ];

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_ho_parts", 0, "", 0 );
    
    elseif direction == "NEW_TO_OLD" then 

      beginAngle = private.angle_move[ taskObject ];
      endAngle = 0;
      
      beginScale = private.scale_move[ taskObject ];
      endScale = 1;
      
      common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );

    end;
    
    ObjAnimate( taskObject, "ang",0,0, "", { 0, 0, beginAngle,    0.4, 0, endAngle } );   
    ObjAnimate( taskObject, "scale_x",0,0, "", { 0, 0, beginScale,    0.4, 0, endScale } );
    
  end;

end;


--*********************************************************************************************************************
function private.AnimCoveringObjects( sender, animType, task, prevSender ) 

  
  DbgTrace("private.AnimCoveringObjects");
  
  local func_end_block = function () 

    cmn.Lock( false );

  end;

  if animType == "FIRST_OBJECT_OF_COUPLE" then 

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( "obj_minibar_gates", "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_RIGHT_COUPLE" then 

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( "obj_minibar_gates", "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_WRONG_COUPLE" then 

    local func_end = function () 

      if prevSender then 
        private.MoveCoveringObjects( prevSender, private.moving_type[ prevSender ], "NEW_TO_OLD" );
        private.MoveCoveringObjects( sender, private.moving_type[ sender ], "NEW_TO_OLD" ); 
      end;

    end;

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( "obj_minibar_gates", "alp",0,0, func_end, { 0, 0, 1,    0.4, 0, 1 } );
    ObjAnimate( "obj_minibar_gates", "scale_x",0,0, func_end_block, { 0, 0, 1,    1.0, 0, 1 } );

  end; 

end;


--*********************************************************************************************************************
function private.TaskPanelUpdate() 

  
  DbgTrace("private.TaskPanelUpdate");
  
  ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );

  ObjSet( "txt_minibar_taskpanel", { pos_x = 0, pos_y = 15 } );
  ObjAttach( "txt_minibar_taskpanel", "obj_int_taskpanel_minibar" );

  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local count = 6 - #foundCouples;

  local COLOR_R = 1;
  local COLOR_G = 1;
  local COLOR_B = 1;

  ObjSet( "txt_minibar_taskpanel",
  {
     text   = "str_int_taskpanel_pattern_couples",
     param0 = COLOR_R,
     param1 = COLOR_G,
     param2 = COLOR_B,
     param3 = StringGet( "str_taskpanel_couple_ho" ),
     param4 = count
   } );

  if count == 0 then 
  
    ObjSet( "txt_minibar_taskpanel", { alp = 0 } );

  end;

end;


--*********************************************************************************************************************
function private.TaskPanel( animType, curTask ) 

  
  DbgTrace("private.TaskPanel");
  
  local OBJECT_Y = 15;
  local OBJECT_LEFT_X = -170;
  local OBJECT_MIDDLE_X = 0;
  local OBJECT_RIGHT_X = 170;

  if animType == "NOT_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_minibar_"..curTask.."_shadow_1";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_minibar" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_LEFT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( "txt_minibar_taskpanel", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 0, 0 } );

  elseif animType == "RIGHT_COMPLETED_COUPLE" then 

    local taskPanelObject_1 = "spr_minibar_"..curTask.."_shadow_1";
    local taskPanelObject_2 = "spr_minibar_"..curTask.."_shadow_2";
    ObjAttach( taskPanelObject_2, "obj_int_taskpanel_minibar" ); 

    local func_end = function () 

      ObjAnimate( taskPanelObject_1, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
      ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
------------------------------
------------------------------
      local fxTaskPanelObject = "fx_minibar_"..curTask;
      local pos = GetObjPosByObj( taskPanelObject_1, "obj_int_taskpanel_minibar" );
      ObjCreate( fxTaskPanelObject, "partsys" );
      ObjSet( fxTaskPanelObject,
      {
        res = "assets/interface/resources/ho_collect_effect",
        blendmode = 2, color_r = 0.8, color_g = 0.4, color_b = 1, 
        alp = 1, visible = true, pos_x = pos[1], pos_y = pos[2], pos_z = 1, input = false
      } );

      local func_end_fx = function () 
        ObjDelete( fxTaskPanelObject );
      end;

      ObjAttach( fxTaskPanelObject, "obj_int_taskpanel_minibar" );
      ObjAnimate( fxTaskPanelObject, "alp", 0, 0, func_end_fx, { 0, 0, 1,    0.4, 0, 1,    0.7, 0, 0 } );
------------------------------
------------------------------
      private.TaskPanelUpdate();
      ObjAnimate( "txt_minibar_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

    end;

    ObjSet( taskPanelObject_2, { pos_x = OBJECT_RIGHT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( taskPanelObject_1, "pos_x",0,0, "", { 0, 3, OBJECT_LEFT_X,    0.3, 3, OBJECT_LEFT_X,    0.7, 3, OBJECT_MIDDLE_X } );
    ObjAnimate( taskPanelObject_2, "pos_x",0,0, func_end, { 0, 3, OBJECT_RIGHT_X,    0.3, 3, OBJECT_RIGHT_X,    0.7, 3, OBJECT_MIDDLE_X } );   

  elseif animType == "WRONG_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_minibar_"..curTask.."_shadow_1";

    local func_end = function () 

      ObjDetach( taskPanelObject );

    end;

    ObjAnimate( taskPanelObject, "alp",0,0, func_end, { 0, 3, 1,    0.3, 3, 0 } );

    private.TaskPanelUpdate();
    ObjAnimate( "txt_minibar_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

  elseif animType == "ACTIVATE_WIN_OBJECT" then 

    local taskPanelObject = "spr_minibar_"..curTask.."_shadow";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_minibar" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_MIDDLE_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

  elseif animType == "WINNING" then 

    local taskPanelObject = "spr_minibar_"..curTask.."_shadow";
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );

  end;

end;

--*********************************************************************************************************************
function private.AnimDemon() 

  DbgTrace("private.AnimDemon");
  
  if not private.anim_demon then
    
    local func_end = function()
    
      cmn.Lock( false );
    
    end;
    
    cmn.Lock( true );
    
    private.anim_demon = true;
    
    AnimPlay( "anm_minibar_demon_haha", "DoAnim", func_end );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_hand_ho", 0, "", 0 );
    
  else
    
    private.TaskComplete( "spr_minibar_winehorn_2_cover", "winehorn" );
    
  end;

end;

--*********************************************************************************************************************
function private.AnimCocaroaches() 
  
  DbgTrace("private.AnimCocaroaches");

  if not private.anim_cocaroaches then
    
    private.anim_cocaroaches = true;
    
    ObjSet( "anm_minibar_cocaroaches", { alp = 1 } );
    AnimPlay( "anm_minibar_cocaroaches", "DoAnim", "" );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_sc_hit", 0, "", 0 );
    
  end;
  
  private.TaskComplete( "spr_minibar_card_1_cover", "card" );

end;

