-- name=ho_signs
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "signs" );
  game.relations[ "ho_signs" ].exitroom = "rm_room_313";
  private.room_objname = "ho_signs";
  --------------------------------------------------------------------------------------------------

  ObjMultiSet( {
      { "spr_signs_amulet",             { event_mdown = function() cmn.HoTaskFind( "spr_signs_amulet", "amulet" ); end } },
      { "spr_signs_book",               { event_mdown = function() cmn.HoTaskFind( "spr_signs_book", "book" ); end } },
      { "spr_signs_horns",              { event_mdown = function() cmn.HoTaskFind( "spr_signs_horns", "horns" ); end } },

      { "spr_signs_mace",               { event_mdown = function() cmn.HoTaskFind( "spr_signs_mace", "mace" ); end } },
      { "spr_signs_pick",               { event_mdown = function() cmn.HoTaskFind( "spr_signs_pick", "pick" ); end } },
      { "spr_signs_pitchfork",          { event_mdown = function() cmn.HoTaskFind( "spr_signs_pitchfork", "pitchfork" ); end } },

      { "spr_signs_rose",               { event_mdown = function() cmn.HoTaskFind( "spr_signs_rose", "rose" ); end } },
      { "spr_signs_5_done",             { event_mdown = function() cmn.HoTaskFind( "spr_signs_5_done", "5_done" ); end } },
      { "spr_signs_lamp",               { event_mdown = function() cmn.HoTaskFind( "spr_signs_lamp", "lamp" ); end } },
      { "spr_signs_letter",             { event_mdown = function() cmn.HoTaskFind( "spr_signs_letter", "letter" ); end } },

      { "spr_signs_cell_1",             { event_mdown = function() cmn.HoTaskFind( "spr_signs_cell_1", "cell" ); end } },
      { "spr_signs_cell_2",             { event_mdown = function() cmn.HoTaskFind( "spr_signs_cell_2", "cell" ); end } },
      { "spr_signs_cell_3",             { event_mdown = function() cmn.HoTaskFind( "spr_signs_cell_3", "cell" ); end } },

      { "spr_signs_rope_1",             { event_mdown = function() cmn.HoTaskFind( "spr_signs_rope_1", "rope" ); end } },
      { "spr_signs_rope_2",             { event_mdown = function() cmn.HoTaskFind( "spr_signs_rope_2", "rope" ); end } },
      { "spr_signs_rope_3",             { event_mdown = function() cmn.HoTaskFind( "spr_signs_rope_3", "rope" ); end } },
 
      { "spr_signs_5_before",           { event_startdrag = function() private.DragDigit_5(); end } },
      { "spr_signs_5_before",           { event_dragdrop = function() private.DropDigit_5(); end } },
        
      { "spr_signs_hammer_for_rose",    { event_startdrag = function() private.DragHammer(); end } },
      { "spr_signs_hammer_for_rose",    { event_dragdrop = function() private.DropHammer(); end } },
        
      { "spr_signs_note",               { event_mdown = function() common_impl.NoteScale( "spr_signs_note" ); end; } },
      { "spr_signs_note_big",           { event_mdown = function() common_impl.NoteScale( "spr_signs_note" ); end; } },         
        
  } );
      

  --------------------------------------------------------------------------------------------
  -- function use_5_done () end;
  --------------------------------------------------------------------------------------------
  function private.use_5_done_beg ()

    ObjDelete( "spr_signs_5_before" );
    ObjDelete( "obj_signs_use_paper" );

  end;

  function private.use_5_done_end ()
    
    ObjDelete( "anm_signs_five" );
    
    ObjMultiSet( { 
      { "anm_signs_5_after",  { alp = 1 } },
    } );
  
    local activation_object = true; 

    if ( cmn.IsEventStart( "win_signs" ) ) then

      for i = 1, #ng_global.progress[ "std" ][ "win_signs" ].found do

        if ng_global.progress[ "std" ][ "win_signs" ].found[ i ].task == "5_done" then

          activation_object = false; 

        end;

      end;

    end;

    if activation_object then 
      
      ObjMultiSet( { 
        { "spr_signs_5_done",  { alp = 1, visible = true, input = true } },
      } );

    end; 

  end;
  
  --------------------------------------------------------------------------------------------
  -- function use_rose () end;
  --------------------------------------------------------------------------------------------
  function private.use_rose_beg ()

    ObjDelete( "spr_signs_hammer_for_rose" );
    ObjDelete( "spr_signs_hammer_for_rose_shadow" );
    ObjDelete( "obj_signs_use_hammer" );

  end;

  function private.use_rose_end ()
    
    ObjDelete( "anm_signs_hammer" );
    ObjDelete( "spr_signs_rose_dome" );
  
    local activation_object = true; 

    if ( cmn.IsEventStart( "win_signs" ) ) then

      for i = 1, #ng_global.progress[ "std" ][ "win_signs" ].found do

        if ng_global.progress[ "std" ][ "win_signs" ].found[ i ].task == "rose" then

          activation_object = false; 

        end;

      end;

    end;

    if activation_object then 
      
      ObjMultiSet( { 
        { "spr_signs_rose",  { alp = 1, visible = true, input = true } },
      } );

    end; 

  end;  
  
  --------------------------------------------------------------------------------------------
  -- function win_signs () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_signs" ] = {
    type = "win",
    room = "rm_room_313",
    zz = "ho_signs",
    zz_gate = "gho_room_313_signs"
  };
  local win_signs_inv = function ()
  
    if ( cmn.IsEventDone( "win_signs" ) ) then
    
      interface.InventoryItemAdd( "inv_paperandpencil", "spr_signs_win" );    
    
    end;
    
  end;
  local win_signs_loc = function ()
  
    if ( cmn.IsEventDone( "win_signs" ) ) then
    
      ObjDelete( "gho_room_313_signs" );    
    
    end;
    
  end;

  cmn.AddSubscriber( "win_signs", win_signs_inv );
  cmn.AddSubscriber( "win_signs", win_signs_loc, "rm_room_313" );
  --------------------------------------------------------------------------------------------------
  local start_signs_func = function ()

  if ( cmn.IsEventStart( "win_signs" ) ) then

    local ho_found = ng_global.progress[ "std" ][ "win_signs" ].found;

    for i = 1, #ho_found, 1 do
    
      ObjDelete( ho_found[ i ][ "object" ] );
    
    end;

  end;

  end;
  cmn.AddSubscriber( "win_signs", start_signs_func, private.room_objname );  

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  
  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level1/env/aud_ho_env", 0, "", 0 );
  common_impl.PlayAudio( "env", "level1/env/aud_room_313_env", 1, "", 0 );

  if ( not cmn.IsEventDone( "opn_signs" ) ) then
  
    cmn.InitHo( "signs" );
    cmn.SetEventDone( "opn_signs" );

    cmn.SetMarkedTask( "signs", "5_done" );
    cmn.SetMarkedTask( "signs", "rose" );
  
  end;

  if ( cmn.IsUnmarkedTask( "signs", "5_done" ) ) then

    private.use_5_done_beg(); 
    private.use_5_done_end(); 
  
  end;
  
  if ( cmn.IsUnmarkedTask( "signs", "rose" ) ) then

    private.use_rose_beg(); 
    private.use_rose_end(); 
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "amulet",         1, 0, { { "spr_signs_amulet" } } );
  interface.TaskPanelTaskAdd( ho_items, "book",           1, 0, { { "spr_signs_book" } } );
  interface.TaskPanelTaskAdd( ho_items, "horns",          1, 0, { { "spr_signs_horns" } } );
  interface.TaskPanelTaskAdd( ho_items, "mace",           1, 0, { { "spr_signs_mace" } } );
  interface.TaskPanelTaskAdd( ho_items, "pick",           1, 0, { { "spr_signs_pick" } } );
  interface.TaskPanelTaskAdd( ho_items, "pitchfork",      1, 0, { { "spr_signs_pitchfork" } } );
  interface.TaskPanelTaskAdd( ho_items, "lamp",           1, 0, { { "spr_signs_lamp" } } );
  interface.TaskPanelTaskAdd( ho_items, "letter",         1, 0, { { "spr_signs_letter" } } );

  interface.TaskPanelTaskAdd( ho_items, "cell",           3, 0, { { "spr_signs_cell_1" }, { "spr_signs_cell_2" }, { "spr_signs_cell_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "rope",           3, 0, { { "spr_signs_rope_1" }, { "spr_signs_rope_2" }, { "spr_signs_rope_3" } } );

  interface.TaskPanelTaskAdd( ho_items, "5_done",         1, 1, { { "spr_signs_5_before", "obj_signs_use_paper" }, { "spr_signs_5_done" } } ); 
  interface.TaskPanelTaskAdd( ho_items, "rose",           1, 1, { { "spr_signs_hammer_for_rose", "obj_signs_use_hammer" }, { "spr_signs_rose" } } ); 
  
  interface.TaskPanelShow( ho_items );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  common_impl.TutorialShow( "tutorial_page_14" );

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();
  cmn.NoteScaleClose( { "spr_signs_note" } );

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin(); 
  
end;
--*********************************************************************************************************************
function private.DragDigit_5 ()

  common_impl.PlayAudio( "sfx", "aud_take_inventory" );
  
  ObjMultiSet( { 
    { "spr_signs_5_before",  { pos_z = 1000 } },
  } );
  
end;


--*********************************************************************************************************************
function private.DropDigit_5 ()

  if cmn.ApplyObj( "spr_signs_5_before", "obj_signs_use_paper" ) then

    private.UseDigit_5Anim();

  else 

    common_impl.WrongApply();
    
    ObjMultiSet( { 
      { "spr_signs_5_before",  { pos_z = 0 } },
    } );   
    
  end;
  
end;


--*********************************************************************************************************************
function private.UseDigit_5Anim()

  cmn.Lock( true );
  private.use_5_done_beg();
  cmn.UnmarkTask( "signs", "5_done" );

  local func_end = function ()

    cmn.Lock( false );
    private.use_5_done_end();
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper1", 0, "", 0 );

  end;
  
  ObjSet( "anm_signs_five", { alp = 1 } );
  AnimPlay( "anm_signs_five", "5", func_end );

end;


--*********************************************************************************************************************
function private.DragHammer ()

  common_impl.PlayAudio( "sfx", "aud_take_inventory" );
  
  ObjMultiSet( { 
    { "spr_signs_hammer_for_rose",  { pos_z = 1000 } },
    { "spr_signs_hammer_for_rose_shadow",  { alp = 0 } },
  } );
  
end;


--*********************************************************************************************************************
function private.DropHammer ()

  if cmn.ApplyObj( "spr_signs_hammer_for_rose", "obj_signs_use_hammer" ) then

    private.UseHammerAnim();

  else 

    common_impl.WrongApply();
    
    ObjMultiSet( { 
      { "spr_signs_hammer_for_rose",  { pos_z = 0 } },
      { "spr_signs_hammer_for_rose_shadow",  { alp = 1 } },
    } );   
    
  end;
  
end;


--*********************************************************************************************************************
function private.UseHammerAnim()

  cmn.Lock( true );
  private.use_rose_beg();
  cmn.UnmarkTask( "signs", "rose" );

  local func_end = function ()

    cmn.Lock( false );
    private.use_rose_end();

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hammer", 0, "", 0 );
  
  ObjDelete( "spr_signs_rose_dome" );
  
  ObjSet( "anm_signs_hammer", { alp = 1 } );
  AnimPlay( "anm_signs_hammer", "glass_dome", func_end );

end;



