-- name=mg_onworkbench
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_onworkbench";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_serviceroom" } );

  ObjMultiSet({ 
    { "spr_onworkbench_curvedstick", { event_mdown = private.get_curvedstick }},
  });
  
  private.LogicInit();
  
  cmn.AnimateAmbientLight( "spr_onworkbench_light" );

  --------------------------------------------------------------------------------------------
  -- function get_curvedstick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_curvedstick" ] = {
    type = "click",                     --special
    use_place = "spr_onworkbench_curvedstick", --special
    room = "rm_serviceroom",
    zz = private.room_objname,
    zz_gate = "gmg_serviceroom_onworkbench"
  };
  
  local get_curvedstick_inv = function ()
  
    interface.InventoryItemAdd( "inv_curvedstick", "spr_onworkbench_curvedstick" );
  
  end;
  
  local get_curvedstick_closezz = function ()
  
    ObjDelete( "gfx_onworkbench_curvedstick" );
    
    
  end;

  local get_curvedstick_loc = function ()

    ObjDelete( "gmg_serviceroom_onworkbench" );

  end;
  
  cmn.AddSubscriber( "get_curvedstick", get_curvedstick_inv );
  cmn.AddSubscriber( "get_curvedstick", get_curvedstick_closezz, private.room_objname );
  cmn.AddSubscriber( "get_curvedstick", get_curvedstick_loc, "rm_serviceroom" ); 
  --------------------------------------------------------------------------------------------
  -- function win_onworkbench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_onworkbench" ] = {
    type = "win",
    use_place = "gmg_serviceroom_onworkbench",
    room = "rm_serviceroom",
    zz_gate = "gmg_serviceroom_onworkbench"
  };     
  
  local win_onworkbench = function ()

    if ( cmn.IsEventDone( "win_onworkbench" ) ) then  

      ObjMultiSet( { 
        { "spr_onworkbench_curvedstick",  { input = true } },
        { "gfx_onworkbench_curvedstick",  { active = true } },
        { "spr_onworkbench_game_lever_1",  { input = false } },
        { "spr_onworkbench_game_lever_2",  { input = false } },
        { "spr_onworkbench_game_lever_3",  { input = false } },
        { "spr_onworkbench_game_lever_4",  { input = false } },
        { "spr_onworkbench_game_lever_5",  { input = false } },
      } );

    end;
    
  end;
  local win_onworkbench_loc = function ()

    if ( cmn.IsEventDone( "win_onworkbench" ) ) then  

    end;

  end;
  cmn.AddSubscriber( "win_onworkbench", win_onworkbench, private.room_objname );
  cmn.AddSubscriber( "win_onworkbench", win_onworkbench_loc, "rm_serviceroom" );  
  --------------------------------------------------------------------------------------------
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_curvedstick ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_curvedstick" );
  cmn.CallEventHandler( "get_curvedstick" );
  
  cmn.GotoRoom( "rm_serviceroom" );

end;


--*********************************************************************************************************************
function public.Open () 

end;


--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level1/env/aud_serviceroom_env" }, "", 0.5 );
 
  int_slider.InitSlider( private.room_objname );
    
  if not cmn.IsEventDone( "win_onworkbench" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

  private.Load();
  private.Update();

end;


--*********************************************************************************************************************
function public.Close ()

end;


--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level1/env/aud_serviceroom_env", 0.5 );
    
  if not cmn.IsEventDone( "win_onworkbench" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;


--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

private.gamedata = {};

private.WIN = { 
                { id = 1, depth = "SMALL" },
                { id = 1, depth = "BIG" },
                { id = 2, depth = "BIG" },
                { id = 3, depth = "BIG" } 
              };

private.head_position = { start_y = 113, end_y_1 = 163, end_y_2 = 177 };

private.head_position_horizontal = { 550, 591, 632, 672 };

private.drill_position = { start_y = 108, end_y = 9 };
  
private.drill_lever_angle = { -1, 0, 1 };

private.drill_lever_delta = -1;


private.LEVER_NAME = "spr_onworkbench_game_lever_"; 
private.HEAD_NAME = "spr_onworkbench_head"; 
private.HOLE_NAME = "spr_onworkbench_head_tool_hole_"; 
private.DRILL_NAME = "spr_onworkbench_head_tool_"; 

private.LEVER_COUNT = 5; 


--*******************************************************************************************************************
function private.Default ()

  ng_global.progress[ "std" ][ "win_onworkbench" ].drill = 3;
  ng_global.progress[ "std" ][ "win_onworkbench" ].position = 3;
  ng_global.progress[ "std" ][ "win_onworkbench" ].done_slots = { false, false, false, false };

end; 


--*******************************************************************************************************************
function private.Load ()

  if ( not ng_global.progress[ "std" ][ "win_onworkbench" ].drill or 
  not ng_global.progress[ "std" ][ "win_onworkbench" ].position or
  not ng_global.progress[ "std" ][ "win_onworkbench" ].done_slots ) then 

    private.Default();

  end; 

  private.gamedata = ng_global.progress[ "std" ][ "win_onworkbench" ];

end;


--*******************************************************************************************************************
function private.LogicInit ()  
  
  for i = 1, private.LEVER_COUNT, 1 do
    
    local curLever = private.LEVER_NAME..i;
    
    ObjSet( curLever, { 
                          input = true,
                          event_mdown = function () private.LeverClick( i ); end,
                          event_menter = function () private.Enter( i ); end,
                          event_mleave = function () private.Leave( i ); end
                      } );
    
  end;
                      
end;


--*******************************************************************************************************************
function private.Enter ( leverID )
 
  SetCursor( CURSOR_HAND );
  
  local current = private.LEVER_NAME..leverID.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );
  
end;


--*******************************************************************************************************************
function private.Leave ( leverID )  

  SetCursor( CURSOR_DEFAULT );
  
  local current = private.LEVER_NAME..leverID.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );
  
end;


--*******************************************************************************************************************
function private.LeverClick ( leverType ) 

  if leverType == 1 then
    
    private.ChangeDepth( "SMALL" );
    
  elseif leverType == 2 then
    
    private.ChangeDrill();
    
  elseif leverType == 3 then
    
    private.ChangePosition( "LEFT" );
    
  elseif leverType == 4 then
    
    private.ChangePosition( "RIGHT" );
    
  elseif leverType == 5 then
    
    private.ChangeDepth( "BIG" );
    
  end;
  
end;


--*******************************************************************************************************************
function private.IsWinningSlot ( distance )
  
  local result = false;
  
  local curHeadPosition = private.gamedata.position;
  
  if ( private.gamedata.drill == private.WIN[ curHeadPosition ].id and 
  distance == private.WIN[ curHeadPosition ].depth ) then
  
    result = true;
    
  end;
  
  return result;
  
end;


--*******************************************************************************************************************
function private.ChangeDepth ( distance )
  
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_lever2", 0, "", 0 );

  local func_end = function()

    cmn.Lock( false );
    private.Update();
    
    ObjMultiSet( { 
      { "spr_onworkbench_curvedstick",  { alp = 1 } },
      { "anm_onworkbench_lever_brocken",  { alp = 0 } },
    } );

  end; 
  
  local curHeadPosition = private.gamedata.position;
  
  if not private.gamedata.done_slots[ curHeadPosition ] then
  
    cmn.Lock( true );
    
    local headStartPosition = private.head_position.start_y;
    local headEndPosition = 0;
    
    if distance == "SMALL" then
      
      headEndPosition = private.head_position.end_y_1;
      ObjAnimate( "spr_onworkbench_game_lever_1", "pos_y",0,0, "", { 0, 3, 204,    0.3, 3, 299,    0.6, 3, 204 } );
      
    elseif distance == "BIG" then
      
      headEndPosition = private.head_position.end_y_2;
      ObjAnimate( "spr_onworkbench_game_lever_5", "pos_y",0,0, "", { 0, 3, 345,    0.3, 3, 502,    0.6, 3, 345 } );
    end;
    
    ObjAnimate( private.HEAD_NAME, "pos_y",0,0, "", { 0, 3, headStartPosition,    0.3, 3, headEndPosition,    0.6, 3, headStartPosition } );
    
    if private.IsWinningSlot( distance ) then
      
      private.gamedata.done_slots[ curHeadPosition ] = true;
      
      local winningSlot = private.HOLE_NAME..curHeadPosition;
      ObjAnimate( winningSlot, "alp",0,0, func_end, { 0, 0, 0,    0.2, 0, 0,    0.4, 0, 1,    0.6, 0, 1 } );
      
    else
      
      private.gamedata.done_slots = { false, false, false, false };
      
      local func_anim = function()
        
        ObjMultiSet( { 
          { "spr_onworkbench_curvedstick",  { alp = 0 } },
          { "anm_onworkbench_lever_brocken",  { alp = 1 } },
        } );
     
        AnimPlay( "anm_onworkbench_lever_brocken", "DoAnim", func_end ); 
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_breakkey", 0, "", 0 );       
        
      end; 
      
      ObjAnimate( "obj_onworkbench_gates", "alp",0,0, func_anim, { 0, 0, 1,    0.2, 0, 1 } );
      
    end;
    
  end; 
  
end;


--*******************************************************************************************************************
function private.ChangeDrill ()

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_lever", 0, "", 0 );

  local func_end = function()

    cmn.Lock( false );
    private.Update();

  end; 
  
  local oldDrill = private.DRILL_NAME..private.gamedata.drill;
  local oldLeverAngle = private.drill_lever_angle[ private.gamedata.drill ];
  
  if private.gamedata.drill == 3 then
    
    private.drill_lever_delta = -1;
    
  elseif private.gamedata.drill == 1 then
      
    private.drill_lever_delta = 1;
    
  end;
  
  cmn.Lock( true );
  
  private.gamedata.drill = private.gamedata.drill + private.drill_lever_delta;
  
  local newDrill = private.DRILL_NAME..private.gamedata.drill;
  local newLeverAngle = private.drill_lever_angle[ private.gamedata.drill ];
  
  ObjAnimate( "spr_onworkbench_game_lever_2", "ang",0,0, "", { 0, 0, oldLeverAngle,    0.3, 0, newLeverAngle } );
  
  local oldDrillY = private.drill_position.start_y;
  local newDrillY = private.drill_position.end_y;
  
  ObjAnimate( oldDrill, "pos_y",0,0, "", { 0, 3, oldDrillY,    0.3, 3, oldDrillY,    0.6, 3, newDrillY } );
  ObjAnimate( newDrill, "pos_y",0,0, func_end, { 0, 3, newDrillY,    0.6, 3, newDrillY,    0.9, 3, oldDrillY } );

end;


--*******************************************************************************************************************
function private.ChangePosition ( direction )

  local func_end = function()

    cmn.Lock( false );
    private.Update();

  end; 
  
  local curLever = "";
  local newLeverAngle = 0;
  local isNeedMoving = true;
  
  local oldHeadPosition = 0;
  local newHeadPosition = 0;
  
  if direction == "LEFT" then
    
    curLever = "spr_onworkbench_game_lever_3";
    newLeverAngle = 0.785;
    oldHeadPosition = private.head_position_horizontal[ private.gamedata.position ];
    
    if private.gamedata.position == 1 then 
      
      isNeedMoving = false;
      
    else
      
      private.gamedata.position = private.gamedata.position - 1;
      
    end;
    
    newHeadPosition = private.head_position_horizontal[ private.gamedata.position ];
    
  elseif direction == "RIGHT" then
    
    curLever = "spr_onworkbench_game_lever_4";
    newLeverAngle = -0.785;
    oldHeadPosition = private.head_position_horizontal[ private.gamedata.position ];
    
    if private.gamedata.position == 4 then 
      
      isNeedMoving = false;
      
    else
      
      private.gamedata.position = private.gamedata.position + 1;
      
    end;
    
    newHeadPosition = private.head_position_horizontal[ private.gamedata.position ];  
    
  end;
  
  if isNeedMoving then
    
    cmn.Lock( true );
    
    ObjAnimate( private.HEAD_NAME, "pos_x",0,0, func_end, { 0, 3, oldHeadPosition,    0.3, 3, newHeadPosition } );
    ObjAnimate( curLever, "ang",0,0, "", { 0, 0, 0,    0.15, 0, newLeverAngle,    0.3, 0, 0 } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_lever2", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_lever",  0, "", 0 );

  end;
  
end;


--*******************************************************************************************************************
function private.Update ()
  
  local leverAngle = private.drill_lever_angle[ private.gamedata.drill ];
  local headPosition = private.head_position_horizontal[ private.gamedata.position ];
  
  ObjMultiSet( { 
    { "spr_onworkbench_game_lever_2", { ang = leverAngle } },
    { private.HEAD_NAME, { pos_x = headPosition } },
  } );
  ------------------------------------------------
  ------------------------------------------------
  for i = 1, #private.drill_lever_angle, 1 do 
    
    local curDrill = private.DRILL_NAME..i;
    local drillPosition = private.drill_position.end_y;
    
    if i == private.gamedata.drill then
      
      drillPosition = private.drill_position.start_y;
      
    end;
    
    ObjSet( curDrill, { pos_y = drillPosition } );
    
  end;
  ------------------------------------------------
  ------------------------------------------------
  for i = 1, #private.gamedata.done_slots, 1 do
    
    local curHole = private.HOLE_NAME..i;
    
    if private.gamedata.done_slots[ i ] then 
      
      ObjSet( curHole, { alp = 1 } );
      
    else 
      
      ObjSet( curHole, { alp = 0 } );
      
    end;
    
  end;
  
  if ( private.CheckWin() and
  not cmn.IsEventDone( "win_onworkbench" ) ) then
    
    private.WinAnim();
    
  end;
  
end;


--*******************************************************************************************************************
function private.CheckWin () 

  local result = false;
  local count = 0;
  
  for i = 1, #private.gamedata.done_slots, 1 do 
    
    if private.gamedata.done_slots[ i ] then
      
      count = count + 1;
      
    end;
    
  end;
  
  if count == #private.gamedata.done_slots then
    
    result = true;
    
  end;
  
  return result;
  
end;


--*******************************************************************************************************************
function private.WinAnim () 
  
  local func_end = function()

    cmn.SetEventDone( "win_onworkbench" );
    cmn.CallEventHandler( "win_onworkbench" );

    cmn.Lock( false );
    common_impl.PassingMgWin();

  end; 
  
  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_gate", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
  cmn.MiniGameHide();
  cmn.Lock( true );
  
  local curHeadX = ObjGet( private.HEAD_NAME ).pos_x;
  ObjAnimate( private.HEAD_NAME, "pos_x",0,0, func_end, { 0, 3, curHeadX,    0.6, 3, 453 } );
  
end;


--*********************************************************************************************************************
function public.Reset ()
  
  private.Default(); 
  private.Load();
  private.Update(); 

end; 


--*********************************************************************************************************************
function public.Skip ()

  private.gamedata.done_slots = { true, true, true, true };
  
  private.Load();
  private.Update(); 
  
end;








