-- name=mg_scaryhead
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_scaryhead";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_closedroom" } );

  ObjMultiSet({ 
    { "spr_scaryhead_sharptooth", { event_mdown = private.get_sharptooth }},
  });
  
  private.LogicInit();

  --------------------------------------------------------------------------------------------
  -- function get_sharptooth () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sharptooth" ] = {
    type = "click",                     --special
    use_place = "spr_scaryhead_sharptooth", --special
    room = "rm_closedroom",
    zz = private.room_objname,
    zz_gate = "gmg_closedroom_scaryhead"
  };  
  
  local get_sharptooth_inv = function ()
  
    interface.InventoryItemAdd( "inv_sharptooth", "spr_scaryhead_sharptooth" );
  
  end;
  
  local get_sharptooth_closezz = function ()
  
    ObjDelete( "gfx_scaryhead_sharptooth" );
  
  end;
  
  local get_sharptooth_loc = function ()

    ObjDelete( "gmg_closedroom_scaryhead" );

  end;
  
  cmn.AddSubscriber( "get_sharptooth", get_sharptooth_inv );
  cmn.AddSubscriber( "get_sharptooth", get_sharptooth_closezz, private.room_objname );
  cmn.AddSubscriber( "get_sharptooth", get_sharptooth_loc, "rm_closedroom" );
  --------------------------------------------------------------------------------------------
  -- function win_scaryhead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_scaryhead" ] = {
    type = "win",
    use_place = "gmg_closedroom_scaryhead",
    room = "rm_closedroom",
    zz_gate = "gmg_closedroom_scaryhead"
  };   
  
  local win_scaryhead = function ()

    if ( cmn.IsEventDone( "win_scaryhead" ) ) then  
      
      ObjMultiSet( { 
        { "spr_scaryhead_jaw",          { pos_y = 601, input = true  } },
        { "gfx_scaryhead_sharptooth",   {             active = true  } },
        { "obj_scaryhead_boxes",        {              input = false } },
        { "obj_scaryhead_areas",        {              input = false } },
        { "spr_scaryhead_runner",       { alp = 0,   visible = false } },
        { "spr_scaryhead_eyes",         {  pos_x = 520, pos_y = 61   } },
      } );

    end;

  end;
  local win_scaryhead_loc = function ()

    if ( cmn.IsEventDone( "win_scaryhead" ) ) then  

    end;

  end;
  cmn.AddSubscriber( "win_scaryhead", win_scaryhead, private.room_objname );
  cmn.AddSubscriber( "win_scaryhead", win_scaryhead_loc, "rm_closedroom" ); 
  --------------------------------------------------------------------------------------------
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_sharptooth ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sharptooth" );
  cmn.CallEventHandler( "get_sharptooth" );
  
  cmn.GotoRoom( "rm_closedroom" );

end;


--*********************************************************************************************************************
function public.Open () 

  --private.AnimEye();
  
end;

--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level1/env/aud_closedroom_env" }, "", 0.5 );
  
  int_slider.InitSlider( private.room_objname );
    
  if not cmn.IsEventDone( "win_scaryhead" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

  private.Load();
  private.Update();

end;


--*********************************************************************************************************************
function public.Close ()

end;


--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level1/env/aud_closedroom_env", 0.5 );
    
  if not cmn.IsEventDone( "win_scaryhead" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;


--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

private.gamedata = {};

--private.win = false;

-- box ID, which contains runner 
private.cur_box = 0;

-- y-position for slots of boxes
private.slot_position = { 182, 182, 182, 323, 323, 323 };

-- connections between points and boxes, which are contain points  
private.box_points = { 
                        1, 1, 1, 1, 1, 1, 
                        2, 2, 2, 2, 2, 2, 2, 
                        3, 3, 3, 3, 3, 3,
                        4, 4, 4, 4, 4, 4, 4, 4,
                        5, 5, 5, 5, 5, 5, 5,
                        6, 6, 6, 6, 6, 6, 
                        6, 6  
                     };
                
-- moving direction in dependence box angle and pushed button       
private.direction_vector = { 
                  { runner_button_up = { 0, -1 }, runner_button_down = { 0, 1 }, runner_button_left = { -1, 0 }, runner_button_right = { 1, 0 } },
                  { runner_button_up = { 1, 0 }, runner_button_down = { -1, 0 }, runner_button_left = { 0, -1 }, runner_button_right = { 0, 1 } },
                  { runner_button_up = { 0, 1 }, runner_button_down = { 0, -1 }, runner_button_left = { 1, 0 }, runner_button_right = { -1, 0 } },
                  { runner_button_up = { -1, 0 }, runner_button_down = { 1, 0 }, runner_button_left = { 0, 1 }, runner_button_right = { 0, -1 } } 
                           };   

-- edges names, which connect corresponding points 
private.point_connection = {
                              "12", "23", "45", "46", 
                              "78", "89", "910", "1112", "1113", 
                              "1415", "1516", "1718", "1819",
                              "2021", "2122", "2324", "2425", "2526", "2627",
                              "2829", "2930", "3132", "3233", "3334",
                              "3536", "3637", "3839", "3940", "4142" 
                           };


private.BOX_NAME = "spr_scaryhead_box_";
private.RUNNER_NAME = "spr_scaryhead_runner";
private.POINT_NAME = "obj_scaryhead_point_";

private.BOX_COUNT = 6;
private.POINT_COUNT = 42;

private.NO_SELECTED_BOX = 0;
private.ANGLE_DELTA = 1.57;
private.DELTA_MOVING = 0;

private.MAXIMUM_VALUE_OF_MOVING = 200;
private.NO_MOVING = 1;
private.POINT_DELTA = 5;
private.WIN_POINT = 41;


--*******************************************************************************************************************
function private.Default ()

  ng_global.progress[ "std" ][ "win_scaryhead" ].box_states = { 2, 4, 6, 1, 3, 5 };
  ng_global.progress[ "std" ][ "win_scaryhead" ].box_angles = { 3, 2, 1, 2, 0, 1 };
  ng_global.progress[ "std" ][ "win_scaryhead" ].runner_position = { pos_x = -67, pos_y = -12 };
  ng_global.progress[ "std" ][ "win_scaryhead" ].runner_box = 1;
  ng_global.progress[ "std" ][ "win_scaryhead" ].win = 0;
  
end; 


--*******************************************************************************************************************
function private.Load ()

  if ( not ng_global.progress[ "std" ][ "win_scaryhead" ].box_states or
  not ng_global.progress[ "std" ][ "win_scaryhead" ].box_angles or
  not ng_global.progress[ "std" ][ "win_scaryhead" ].runner_position or
  not ng_global.progress[ "std" ][ "win_scaryhead" ].runner_box or
  not ng_global.progress[ "std" ][ "win_scaryhead" ].win ) then 

    private.Default();

  end; 

  private.gamedata = ng_global.progress[ "std" ][ "win_scaryhead" ];

end;


--*******************************************************************************************************************
function private.LogicInit ()  
  
  for i = 1, private.BOX_COUNT, 1 do

    local curBox = private.BOX_NAME..i;

    ObjSet( curBox, { 
                      input = true,
                      event_mdown = function () private.BoxClick( i ); end,
                      event_menter = function () SetCursor( CURSOR_HAND );    end,
                      event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
                    } );

  end;
                        
  local areaName = { 
                      "runner_button_up",
                      "runner_button_down",
                      "runner_button_left",
                      "runner_button_right",
                      "box_button_up",
                      "box_button_down",
                      "box_button_angle"
                   };
                    
  for i = 1, #areaName, 1 do
    
    local curArea = "obj_scaryhead_"..areaName[ i ];
    
    ObjSet( curArea, { 
                        input = true,
                        event_mdown = function () private.AreaClick( areaName[ i ] ); end,
                        event_menter = function () private.Enter( areaName[ i ] ); end,
                        event_mleave = function () private.Leave( areaName[ i ] ); end
                      } );
    
  end;
                        
end;


--*******************************************************************************************************************
function private.Enter ( areaName )
 
  SetCursor( CURSOR_HAND );
  
  local current = "spr_scaryhead_"..areaName.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );

  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter2", 0, "", 0 );

end;


--*******************************************************************************************************************
function private.Leave ( areaName )  

  SetCursor( CURSOR_DEFAULT );
  
  local current = "spr_scaryhead_"..areaName.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );
  
end;


--*******************************************************************************************************************
function private.BoxClick ( boxID ) 

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_part", 0, "", 0 ); 

  local func_end = function()

    cmn.Lock( false );
    private.Update();

  end; 
  
  local lastBoxFocus = private.BOX_NAME..private.cur_box.."_focus";
  local curBoxFocus = private.BOX_NAME..boxID.."_focus";
  
  if private.cur_box == private.NO_SELECTED_BOX then
    
    private.cur_box = boxID;
    
    cmn.Lock( true );    
    ObjAnimate( curBoxFocus, "alp",0,0, func_end, { 0, 2, 0,    0.3, 2, 1 } );
   
  elseif private.cur_box == boxID then

    private.cur_box = private.NO_SELECTED_BOX;
    
    cmn.Lock( true );
    ObjAnimate( curBoxFocus, "alp",0,0, func_end, { 0, 2, 1,    0.3, 2, 0 } );
    
  else 
    
    private.cur_box = boxID;
    
    cmn.Lock( true );
    
    ObjAnimate( lastBoxFocus, "alp",0,0, func_end, { 0, 2, 1,    0.3, 2, 0 } );
    ObjAnimate( curBoxFocus, "alp",0,0, "", { 0, 2, 0,    0.3, 2, 1 } );
    
  end;

end;


--*******************************************************************************************************************
function private.AreaClick ( areaName ) 
  
  if ( areaName == "box_button_up" or 
    areaName == "box_button_down" ) then
    
    if private.cur_box ~= private.NO_SELECTED_BOX then
      
      private.BoxUpDownMoving( areaName );
      
    end;
   
  elseif ( areaName == "box_button_angle" ) then  
    
    if private.cur_box ~= private.NO_SELECTED_BOX then
  
      private.BoxAngleMoving();
      
    end;
    
  elseif ( areaName == "runner_button_up" or areaName == "runner_button_down" or
  areaName == "runner_button_left" or areaName == "runner_button_right" ) then  
    
    private.RunnerMoving( areaName );
  
  end;
  
end;


--*******************************************************************************************************************
-- getting slot ID by box ID 

function private.GettingSlotID ( boxID ) 
  
  local slotID = 1;
  
  for i = 1, private.BOX_COUNT, 1 do
    
    if ( boxID == private.gamedata.box_states[ i ] ) then
      
      slotID = i;
      break;
      
    end;
    
  end;
  
  return slotID;

end;


--*******************************************************************************************************************
-- vertical box moving 

function private.BoxUpDownMoving ( movingType ) 
  
  local func_end = function()

    cmn.Lock( false );
    private.Update(); 

  end; 
  
  local curSlot_1 = private.GettingSlotID( private.cur_box );
  
  if ( movingType == "box_button_up" ) then
    
    if ( curSlot_1 > 3 ) then
      
      local curSlot_2 = curSlot_1 - 3;
      local curBox_1 = private.BOX_NAME..private.cur_box;
      local curBox_2 = private.BOX_NAME..private.gamedata.box_states[ curSlot_2 ];
      
      local curPosY_1 = private.slot_position[ curSlot_1 ];
      local curPosY_2 = private.slot_position[ curSlot_2 ];
      
      local temp = private.gamedata.box_states[ curSlot_2 ];
      private.gamedata.box_states[ curSlot_2 ] = private.gamedata.box_states[ curSlot_1 ];
      private.gamedata.box_states[ curSlot_1 ] = temp;
      
      cmn.Lock( true );
      ObjAnimate( curBox_1, "pos_y",0,0, func_end, { 0, 3, curPosY_1,    0.3, 3, curPosY_2 } );
      ObjAnimate( curBox_2, "pos_y",0,0, "", { 0, 3, curPosY_2,    0.3, 3, curPosY_1 } );
      
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_part2", 0, "", 0 );

    end;
    
  elseif ( movingType == "box_button_down" ) then
    
    if ( curSlot_1 < 4 ) then
      
      local curSlot_2 = curSlot_1 + 3;
      local curBox_1 = private.BOX_NAME..private.cur_box;
      local curBox_2 = private.BOX_NAME..private.gamedata.box_states[ curSlot_2 ];
      
      local curPosY_1 = private.slot_position[ curSlot_1 ];
      local curPosY_2 = private.slot_position[ curSlot_2 ];
      
      local temp = private.gamedata.box_states[ curSlot_2 ];
      private.gamedata.box_states[ curSlot_2 ] = private.gamedata.box_states[ curSlot_1 ];
      private.gamedata.box_states[ curSlot_1 ] = temp;
      
      cmn.Lock( true );
      ObjAnimate( curBox_1, "pos_y",0,0, func_end, { 0, 3, curPosY_1,    0.3, 3, curPosY_2 } );
      ObjAnimate( curBox_2, "pos_y",0,0, "", { 0, 3, curPosY_2,    0.3, 3, curPosY_1 } );
      
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_part2", 0, "", 0 );

    end;
    
  end;

end;


--*******************************************************************************************************************
-- angular box moving 

function private.BoxAngleMoving () 
 
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_part", 0, "", 0 ); 

  local func_end = function()

    cmn.Lock( false );
    private.Update(); 

  end; 
  
  local oldAngle = private.ANGLE_DELTA * private.gamedata.box_angles[ private.cur_box ];
  oldAngle = private.Rounding( oldAngle );
  
  private.gamedata.box_angles[ private.cur_box ] = private.gamedata.box_angles[ private.cur_box ] + 1;
  local newAngle = private.ANGLE_DELTA * private.gamedata.box_angles[ private.cur_box ];
  newAngle = private.Rounding( newAngle );
  
  if private.gamedata.box_angles[ private.cur_box ] > 3 then
    
    private.gamedata.box_angles[ private.cur_box ] = 0;
    
  end;
  
  local curBox = private.BOX_NAME..private.cur_box;
  
  cmn.Lock( true );
  ObjAnimate( curBox, "ang",0,0, func_end, { 0, 0, oldAngle,    0.3, 0, newAngle } );

end;


--*******************************************************************************************************************
-- checking on closeness of current points

function private.ArePointsConnected ( point1, point2 )
  
  --DbgTrace("private.ArePointsConnected point1:"..tostring(point1).." point2:"..tostring(point2));
  
  local result = false;
  
  local pointArea1 = private.POINT_NAME..point1;
  local pointAreaPosition_1 = GetObjPosByObj( pointArea1, "mg_scaryhead" );

  local pointArea1_X = math.ceil( pointAreaPosition_1[ 1 ] ); 
  local pointArea1_Y = math.ceil( pointAreaPosition_1[ 2 ] ); 
  
  local pointArea2 = private.POINT_NAME..point2;
  local pointAreaPosition_2 = GetObjPosByObj( pointArea2, "mg_scaryhead" );

  local pointArea2_X = math.ceil( pointAreaPosition_2[ 1 ] ); 
  local pointArea2_Y = math.ceil( pointAreaPosition_2[ 2 ] ); 
  
  if ( math.abs( pointArea1_X - pointArea2_X ) <= private.POINT_DELTA and
  math.abs( pointArea1_Y - pointArea2_Y ) <= private.POINT_DELTA ) then
  
    result = true;
  
  end;
  
  return result;
  
end;


--*******************************************************************************************************************
-- checking on points connection by current edge 

function private.ArePointsMakeEdge ( edge, reverse )
   
  --DbgTrace("private.ArePointsMakeEdge edge:"..tostring(edge).." reverse:"..tostring(reverse));
  
  local result = false;

  for i = 1, #private.point_connection, 1 do 

    if ( private.point_connection[ i ] == edge or
    private.point_connection[ i ] == reverse ) then 

      result = true;
      break;

    end;

  end;

  return result;

end;


--*******************************************************************************************************************
-- right path of runner moving creating by array 
-- of points, which are crossed with runner  

function private.PathCreating ( crossingPoints )
  
  --DbgTrace("private.PathCreating crossingPoints:"..tostring(crossingPoints));
  
  local path = {};

  table.insert( path, crossingPoints[ 1 ] );

  for i = 2, #crossingPoints, 1 do
    --DbgTrace("private.PathCreating i="..i);
    local point1 = crossingPoints[ i - 1 ];
    local point2 = crossingPoints[ i ];

    local edge = crossingPoints[ i - 1 ]..crossingPoints[ i ];
    local reverse = crossingPoints[ i ]..crossingPoints[ i - 1 ];
    
    if ( private.ArePointsConnected( point1, point2 ) or
    private.ArePointsMakeEdge( edge, reverse ) ) then 

      table.insert( path, crossingPoints[ i ] );

    else 

      break; 

    end; 

  end;
  
  return path;
  
end;


--*******************************************************************************************************************
-- getting animation frames by right path of runner moving 

function private.AnimFramesCreating ( rightPath )
  
  --DbgTrace("private.AnimFramesCreating rightPath:"..tostring(rightPath));
   
  local frames = {};
  local runnerBox = private.BOX_NAME..private.gamedata.runner_box;
  
  local startX = private.gamedata.runner_position.pos_x;
  local startY = private.gamedata.runner_position.pos_y;
  
  local time = 0.3;
  local interpolation = 0;
  
  table.insert( frames, 0 );
  table.insert( frames, interpolation );
  table.insert( frames, startX );
  table.insert( frames, startY );
  
  for i = 2, #rightPath, 1 do
    --DbgTrace("private.AnimFramesCreating i:"..i);
    local pointArea = private.POINT_NAME..rightPath[ i ];
    local pointAreaPosition = GetObjPosByObj( pointArea, runnerBox );

    local curX = math.ceil( pointAreaPosition[ 1 ] ); 
    local curY = math.ceil( pointAreaPosition[ 2 ] ); 
    
    local curTime = time * ( i - 1 );
    
    table.insert( frames, curTime );
    table.insert( frames, interpolation );
    table.insert( frames, curX );
    table.insert( frames, curY );
    
    if ( i == #rightPath ) then

      local box = private.BOX_NAME..private.box_points[ rightPath[ i ] ];
      local pointAreaPositionEnd = GetObjPosByObj( pointArea, box );

      if ( rightPath[ i ] >= private.WIN_POINT ) then

        pointAreaPositionEnd = GetObjPosByObj( pointArea, runnerBox );
        private.gamedata.win = 1;

      end;

      local endX = math.ceil( pointAreaPositionEnd[ 1 ] ); 
      local endY = math.ceil( pointAreaPositionEnd[ 2 ] );
    
      private.gamedata.runner_position.pos_x = endX;
      private.gamedata.runner_position.pos_y = endY;

      if ( rightPath[ i ] < private.WIN_POINT ) then
  
        private.gamedata.runner_box = private.box_points[ rightPath[ i ] ];

      end;
      
    end;
    
  end;
  
  return frames;
  
end;


--*******************************************************************************************************************
-- checking on element uniqueness in the array 

function private.IsArrayContainsItem ( array, item )
  
  --DbgTrace("private.IsArrayContainsItem array:"..tostring(array).." item:"..tostring(item));
  
  local result = false;
  
  for i = 1, #array, 1 do
    
    if array[ i ] == item then
      
      result = true;
      break;
      
    end;
    
  end;
  
  return result;
  
end;


--*******************************************************************************************************************
-- getting of array of points, which are crossed with runner  

function private.GettingPointsArray ( oldRunnerX, oldRunnerY, movingDirection )
  
  --DbgTrace("private.GettingPointsArray oldRunnerX:"..tostring(oldRunnerX).." oldRunnerY:"..tostring(oldRunnerY).." movingDirection:"..tostring(movingDirection));
  
  local crossingPoints = {};
  
  local curRunnerX = oldRunnerX;
  local curRunnerY = oldRunnerY;
  local old_point = -1;
  
  for i = 1, private.MAXIMUM_VALUE_OF_MOVING, 1 do 
    
    curRunnerX = curRunnerX + movingDirection[ 1 ];
    curRunnerY = curRunnerY + movingDirection[ 2 ];

    ObjSet( private.RUNNER_NAME, { pos_x = curRunnerX, pos_y = curRunnerY } );
    local check = false;
    for j = 1, private.POINT_COUNT, 1 do 
      --DbgTrace("private.GettingPointsArray i:"..i.." j:"..j);
      local curPoint = private.POINT_NAME..j;

      if ( ApplyObj( private.RUNNER_NAME, curPoint ) and old_point~=j) then --and not private.IsArrayContainsItem( crossingPoints, j ) ) then 
        old_point = j;
        table.insert( crossingPoints, j );
        --DbgTrace("private.GettingPointsArray i:"..i.." j:"..j.." true");
        break;

      end; 

    end;
    --DbgTrace("private.GettingPointsArray i:"..i);
  end; 
  
  return crossingPoints;

end;


--*******************************************************************************************************************
function private.RunnerMoving ( areaName )
  
  --DbgTrace("private.RunnerMoving areaName:"..tostring(areaName));
  
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_part3", 0, "", 0 );

  local curBox = private.BOX_NAME..private.gamedata.runner_box;

  local func_end = function()

    cmn.Lock( false );
    private.Update(); 

  end;   
  
  local oldRunnerX = private.gamedata.runner_position.pos_x;
  local oldRunnerY = private.gamedata.runner_position.pos_y;
  
  local curAngle = private.gamedata.box_angles[ private.gamedata.runner_box ];
  local movingDirection = private.direction_vector[ curAngle + 1 ][ areaName ];
  
  local crossingPoints = private.GettingPointsArray( oldRunnerX, oldRunnerY, movingDirection );
  ObjSet( private.RUNNER_NAME, { pos_x = oldRunnerX, pos_y = oldRunnerY } );
  
  if #crossingPoints > private.NO_MOVING then
    
    local rightPath = private.PathCreating( crossingPoints ); 
    local animFrames = private.AnimFramesCreating( rightPath );
    
    cmn.Lock( true );
    ObjAnimate( private.RUNNER_NAME, "pos_xy",0,0, func_end, animFrames );

  else

    common_impl.StopAudio( "sfx", "level1/sfx/aud_move_part3", 0.2 );

  end;
  
end;


--*******************************************************************************************************************
function private.Update ()
  
  for i = 1, private.BOX_COUNT, 1 do
    
    local curBoxID = private.gamedata.box_states[ i ];
    local curBox = private.BOX_NAME..curBoxID;
    
    local curBoxY = private.slot_position[ i ];
    local curBoxAngle = private.ANGLE_DELTA * private.gamedata.box_angles[ curBoxID ];
    curBoxAngle = private.Rounding( curBoxAngle );
        
    ObjMultiSet( { 
      { curBox,  { pos_y = curBoxY, pos_z = 0, ang = curBoxAngle } },
    } );
    
  end;

  local runnerBox = private.BOX_NAME..private.gamedata.runner_box;
  local selectBox = private.BOX_NAME..private.cur_box;

  local runnerX = private.gamedata.runner_position.pos_x;
  local runnerY = private.gamedata.runner_position.pos_y;
  
  ObjAttach( private.RUNNER_NAME, runnerBox );

  ObjMultiSet( { 
    { private.RUNNER_NAME,  { pos_x = runnerX, pos_y = runnerY } },
    { runnerBox,  { pos_z = 20 } },
    { selectBox,  { pos_z = 10 } },
  } );
  
  if ( private.gamedata.win == 1 and
  not cmn.IsEventDone( "win_scaryhead" ) )then
    
    private.Win();
    
  end;
  
end;


--*******************************************************************************************************************
function private.Win () 
  
  local func_end = function()

    cmn.Lock( false );
    common_impl.PassingMgWin();

    cmn.SetEventDone( "win_scaryhead" );
    cmn.CallEventHandler( "win_scaryhead" );
    
  end; 
  
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clown_win", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
  cmn.MiniGameHide();
  cmn.Lock( true );
  
  ObjAnimate( private.RUNNER_NAME, "scale_xy",0,0, "", { 0, 3, 0.7, 0.7,    0.3, 3, 0.7, 0.7,    0.6, 3, 0, 0 } );
  ObjAnimate( "spr_scaryhead_jaw", "pos_y",0,0, func_end, { 0, 3, 552,    0.6, 3, 552,    0.9, 3, 601 } );
  local obj_params = ObjGet( "spr_scaryhead_eyes" )
  ObjAnimate( "spr_scaryhead_eyes", "pos_xy",0,0, "", { 
    0,   0, obj_params.pos_x, obj_params.pos_y,
    0.4, 0, obj_params.pos_x, obj_params.pos_y,
    0.9, 2, 520, 61
  } );

end;


--*********************************************************************************************************************
function public.Reset ()
  
  local curBoxFocus = private.BOX_NAME..private.cur_box.."_focus";
  ObjSet( curBoxFocus, { alp = 0 } );

  private.cur_box = 0;
  
  private.Default(); 
  private.Load();
  private.Update(); 

end; 


--*********************************************************************************************************************
function public.Skip ()

  private.gamedata.win = 1;

  local runnerBox = private.BOX_NAME..private.gamedata.runner_box;
  local winArea = private.POINT_NAME..private.POINT_COUNT;

  local pointAreaPositionEnd = GetObjPosByObj( winArea, runnerBox );

  local endX = math.ceil( pointAreaPositionEnd[ 1 ] ); 
  local endY = math.ceil( pointAreaPositionEnd[ 2 ] );

  private.gamedata.runner_position.pos_x = endX;
  private.gamedata.runner_position.pos_y = endY;
  
  private.Load();
  private.Update(); 
  
end;

--*********************************************************************************************************************
local anim_obj = {
                  { "spr_scaryhead_eyes",             516, 0, 20, 0}
                };

local x = 0;
local y = 0;
--------------------------------------------------------------------------------------------
function private.AnimEye()
  
--  if cmn.IsEventDone( "win_scaryhead" ) then
--    
--    return;
--    
--  end;
--  
--  ObjSet( "tmr_scaryhead_eyes", { endtrig = private.AnimEye, time = 0.5, playing = true } );
--  
--  local res = cmn.AnimForCur( anim_obj, x, y );
--
--  x = res[ 1 ];
--  y = res[ 2 ];

end;
--------------------------------------------------------------------------------------------
function private.Rounding( int )

  if int > -0.1 and int < 0.1 then return 0;
  elseif int > 1.5 and int < 1.6 then return 1.57;
  elseif int > 3.1 and int < 3.2 then return 3.14;
  elseif int > 4.7 and int < 4.8 then return 4.71;
  elseif int > 6.2 and int < 6.3 then return 6.28;
  end;

end;





