-- name=level1
function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 21 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 20 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 20 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 22 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup, 27 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog, 26 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 26 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 9 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide, 28 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 27 );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.ButtonTaskAdd( 1 );
  --interface.ButtonDiaryAdd( 20 );
  interface.DialogTaskAdd( 20 );  
  interface.BtnMiniHOAdd( 18 );
  --interface.DiaryAdd( 26 );
  
  interface.SliderAdd( -1 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 18 );
    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
    interface.BtnMorphAdd( 18 );

  end;
   
  private.Init();
  ModLoad( "assets/levels/level1/mod_level1_inv" );
  level1_inv.Init();

  common.LevelLoad( "level1", "std", "rm_closedroom", param, private.menu_moduls );

  common_impl.CollectiblesMusicLoadOnLocation(); 
  common_impl.Collectibles2Load();
  common_impl.MorphLoad();
  
  private.TutorialSetParams();
  interface.KeyUpdate();

  cmn.PlayMusEnv();

end;


function private.Init ()
  
  game = {};
  game.room_names =
  {
    "rm_closedroom"
    ,"rm_thirdfloorcorridor"
    ,"rm_room_313"
    ,"rm_terrace"
    ,"rm_room_211"
    ,"rm_serviceroom"
    ,"rm_hall"
    ,"mg_onworkbench"
    ,"mg_inthreewaymirror"
    ,"ho_minibar"
    ,"mg_scaryhead"
    ,"ho_darkcorner"
    ,"ho_portraithall"
    ,"ho_signs"
    ,"rm_demo"
  };

  game.progress_names_room =
  {
     { "see_intro"                         }
    ,{ "opn_closedroom"                    }
    ,{ "see_closedroom_1",                 "rm_closedroom"  }
    ,{ "see_entrancedoor",                 "rm_closedroom"  }
    ,{ "see_closedroom_destruction",       "rm_closedroom"  }
    ,{ "see_closedroom_bats",              "rm_closedroom"  }
    ,{ "see_sink_scare",                   "rm_closedroom"  }
    ,{ "get_stone",                        "rm_closedroom",         { "opn_closedroom"                         } }
    ,{ "clk_closedroom_crate_1",           "rm_closedroom",         { "opn_closedroom"                         } }
    ,{ "clk_closedroom_crate_2",           "rm_closedroom",         { "clk_closedroom_crate_1"                 } }
    ,{ "use_stone",                        "rm_closedroom",         { "get_stone", "clk_closedroom_crate_2"    } }
    ,{ "get_torch",                        "rm_closedroom",         { "use_stone"                              } }
    ,{ "use_torch_11",                     "rm_closedroom",         { "get_torch"                              } }
    ,{ "opn_darkcorner",                   "rm_closedroom"          }
    ,{ "win_darkcorner",                   "rm_closedroom",         { "use_torch_11"                           } }
    ,{ "get_carvedamulet_1",               "rm_closedroom",         { "opn_closedroom"                         } }
    ,{ "use_rubbertoy",                    "rm_closedroom",         { "win_darkcorner"                         } }
    ,{ "get_tinywire",                     "rm_closedroom",         { "use_rubbertoy"                          } }
    ,{ "clk_floorlamp_1",                  "rm_closedroom",         { "opn_closedroom"                         } }
    ,{ "clk_floorlamp_2",                  "rm_closedroom",         { "clk_floorlamp_1"                        } }
    ,{ "use_tinywire",                     "rm_closedroom",         { "get_tinywire", "clk_floorlamp_2"        } }
    ,{ "win_floorlamp",                    "rm_closedroom",         { "use_tinywire"                           } }
    ,{ "see_closedroom_lamp",              "rm_closedroom",         { "win_floorlamp"                          } }
    ,{ "get_button",                       "rm_closedroom",         { "win_floorlamp"                          } }
    ,{ "use_button",                       "rm_closedroom",         { "get_button"                             } }
    ,{ "clk_ventilationwindow_button",     "rm_closedroom",         { "use_button"                             } }
    ,{ "get_magnet",                       "rm_closedroom",         { "clk_ventilationwindow_button"           } }
    ,{ "use_magnet_1",                     "rm_closedroom",         { "get_magnet"                             } }
    ,{ "get_wire",                         "rm_closedroom",         { "use_magnet_1"                           } }
    ,{ "clk_wire_1",                       }
    ,{ "clk_wire_2",                       }
    ,{ "get_lockpick",                     }
    ,{ "use_lockpick",                     "rm_closedroom",         { "use_lockpick"                           } }
    ,{ "opn_thirdfloorcorridor"            }
    ,{ "see_thirdfloorcorridor_bobby"      }
    ,{ "see_room_313_door",                "rm_thirdfloorcorridor"  }
    ,{ "see_room_313_door_spiders",        "rm_thirdfloorcorridor"  }
    ,{ "see_thirdfloorcorridor_ghost",     "rm_thirdfloorcorridor"  }
    ,{ "get_box",                          "rm_thirdfloorcorridor", { "opn_thirdfloorcorridor"                 } }
    ,{ "clk_mirror_door",                  "rm_thirdfloorcorridor", { "opn_thirdfloorcorridor"                 } }
    ,{ "get_corkscrew",                    "rm_thirdfloorcorridor", { "clk_mirror_door"                        } }
    ,{ "use_corkscrew",                    "rm_closedroom",         { "get_corkscrew"                          } }
    ,{ "get_cork",                         "rm_closedroom",         { "use_corkscrew"                          } }
    ,{ "use_cork",                         "rm_thirdfloorcorridor", { "get_cork"                               } }
    ,{ "use_magnet_2",                     "rm_thirdfloorcorridor", { "use_cork"                               } }
    ,{ "get_boxkey",                       "rm_thirdfloorcorridor", { "use_magnet_2"                           } }
    ,{ "use_boxkey",                       }
    ,{ "clk_boxkey",                       }
    ,{ "get_eye",                          }
    ,{ "use_eye",                          "rm_closedroom",         { "get_eye"                                } }
    ,{ "win_scaryhead",                    "rm_closedroom",         { "use_eye"                                } }
    ,{ "get_sharptooth",                   "rm_closedroom",         { "win_scaryhead"                          } }
    ,{ "use_sharptooth",                   "rm_closedroom",         { "get_sharptooth"                         } }
    ,{ "get_pallet",                       "rm_closedroom",         { "use_sharptooth"                         } }
    ,{ "use_pallet",                       "rm_thirdfloorcorridor", { "get_pallet"                             } }
    ,{ "get_screen",                       "rm_thirdfloorcorridor", { "use_pallet"                             } }
    ,{ "use_screen",                       "rm_closedroom",         { "get_screen"                             } }
    ,{ "get_lionhead_1",                   "rm_closedroom",         { "use_screen"                             } }
    ,{ "get_room_313_key",                 "rm_closedroom",         { "use_screen"                             } }
    ,{ "see_thirdfloorcorridor_gargoyle",  "rm_thirdfloorcorridor"  }
    ,{ "use_room_313_key",                 "rm_thirdfloorcorridor", { "get_room_313_key"                       } }
    ,{ "clk_room_313_key",                 "rm_thirdfloorcorridor", { "use_room_313_key"                       } }
    ,{ "opn_room_313"                      }
    ,{ "see_fb_bobby"      ,               "rm_room_313" }
    ,{ "see_room_313_piano",               "rm_room_313" }
    ,{ "see_room_313_portrait",            "rm_room_313" }
    ,{ "clk_ritualsigns_signs",            "rm_room_313",           { "opn_room_313"                           } }
    ,{ "use_torch_12",                     "rm_room_313",           { "opn_room_313"                           } }
    ,{ "get_bracedrill",                   "rm_room_313",           { "use_torch_12"                           } }
    ,{ "get_torchnobatteries",             "rm_room_313",           { "use_torch_12"                           } }
    ,{ "clk_drill",                        "rm_thirdfloorcorridor", { "get_screen"                             } }
    ,{ "use_bracedrill",                   "rm_thirdfloorcorridor", { "clk_drill", "get_bracedrill"            } }
    ,{ "get_ornamental_chandelier",        "rm_thirdfloorcorridor", { "use_bracedrill"                         } }
    ,{ "get_metalbeams",                   "rm_thirdfloorcorridor", { "use_bracedrill"                         } }
    ,{ "use_ornamental_chandelier",        "rm_closedroom",         { "get_ornamental_chandelier"              } }
    ,{ "win_sink_1",                       "rm_closedroom",         { "use_ornamental_chandelier"              } }
    ,{ "get_tongs",                        "rm_closedroom",         { "win_sink_1"                             } }
    ,{ "use_tongs",                        "rm_room_313",           { "get_tongs"                              } }
    ,{ "get_bobbyamulet",                  "rm_room_313",           { "use_tongs"                              } }
    ,{ "use_bobbyamulet",                  "rm_room_313",           { "get_bobbyamulet"                        } }
    ,{ "get_matches",                      "rm_room_313",           { "use_bobbyamulet"                        } }
    ,{ "use_matches",                      "rm_thirdfloorcorridor", { "get_matches"                            } }
    ,{ "get_oldalbum",                     "rm_thirdfloorcorridor", { "use_matches"                            } }
    ,{ "clk_oldalbum_1",                   }
    ,{ "use_oldalbum_hat_1",               }
    ,{ "use_oldalbum_hat_2",               }
    ,{ "use_oldalbum_hat_3",               }
    ,{ "clk_oldalbum_2",                   }
    ,{ "use_oldalbum_ribbon",              }
    ,{ "use_oldalbum_pince_nez",           }
    ,{ "use_oldalbum_tie",                 }
    ,{ "clk_oldalbum_3",                   }
    ,{ "use_oldalbum_bell",                }
    ,{ "use_oldalbum_candle",              }
    ,{ "use_oldalbum_parrot",              }
    ,{ "clk_oldalbum_4",                   }
    ,{ "use_oldalbum_fireiron",            }
    ,{ "use_oldalbum_vineglass",           }
    ,{ "use_oldalbum_photo",               }
    ,{ "clk_oldalbum_5",                   }
    ,{ "use_oldalbum_bottle",              }
    ,{ "use_oldalbum_cheese",              }
    ,{ "use_oldalbum_crane",               }
    ,{ "clk_oldalbum_6",                   }
    ,{ "get_hotelsign",                    }
    ,{ "use_hotelsign",                    "rm_room_313",           { "get_hotelsign"                          } }
    ,{ "get_collar",                       "rm_room_313",           { "use_hotelsign"                          } }
    ,{ "see_room_313_1",                   "rm_room_313" }
    ,{ "get_diamond",                      }
    ,{ "use_diamond",                      "rm_room_313",           { "get_diamond"                            } }
    ,{ "get_statuette",                    "rm_room_313",           { "use_diamond"                            } }
    ,{ "get_ring",                         "rm_room_313",           { "use_diamond"                            } }
    ,{ "use_statuette",                    "rm_room_313",           { "get_statuette"                          } }
    ,{ "get_carvedamulet_2",               "rm_room_313",           { "use_statuette"                          } }
    ,{ "use_carvedamulet_1",               "rm_room_313",           { "get_carvedamulet_1"                     } }
    ,{ "use_carvedamulet_2",               "rm_room_313",           { "get_carvedamulet_2"                     } }
    ,{ "opn_signs",                        "rm_room_313",           { "use_carvedamulet_1", "use_carvedamulet_2" } }
    ,{ "win_signs",                        "rm_room_313",           { "opn_signs"                              } }
    ,{ "use_paperandpencil",               "rm_room_313",           { "win_signs"                              } }
    ,{ "get_codepart_1",                   "rm_room_313",           { "use_paperandpencil"                     } }
    ,{ "use_ring",                         "rm_room_313",           { "get_ring"                               } }
    ,{ "get_codepart2",                    "rm_room_313",           { "use_ring"                               } }
    ,{ "get_paperpin",                     "rm_room_313",           { "use_ring"                               } }
    ,{ "get_nails",                        "rm_room_313",           { "use_ring"                               } }
    ,{ "use_paperpin",                     "rm_room_313",           { "get_paperpin"                           } }
    ,{ "get_codepart3",                    "rm_room_313",           { "use_paperpin"                           } }
    ,{ "use_codepart_1",                   "rm_room_313",           { "get_codepart_1"                         } }
    ,{ "use_codepart2",                    "rm_room_313",           { "get_codepart2"                          } }
    ,{ "use_codepart3",                    "rm_room_313",           { "get_codepart3"                          } }
    ,{ "win_couch",                        "rm_room_313",           { "get_codepart_1","get_codepart2","get_codepart3" } }
    ,{ "get_firstaidkit",                  "rm_room_313",           { "win_couch"                              } }
    ,{ "get_clasp",                        "rm_room_313",           { "win_couch"                              } }
    ,{ "use_clasp",                        "rm_room_313",           { "get_clasp"                              } }
    ,{ "get_knittingneedle",               "rm_room_313",           { "use_clasp"                              } }
    ,{ "use_knittingneedle",               "rm_room_313",           { "get_knittingneedle"                     } }
    ,{ "get_cross_1",                      "rm_room_313",           { "use_knittingneedle"                     } }
    ,{ "use_cross_1",                      }
    ,{ "clk_cross_1",                      }
    ,{ "get_cutters",                      }
    ,{ "use_cutters",                      "rm_room_313",           { "get_cutters"                            } }
    ,{ "opn_terrace"                       }
    ,{ "see_terrace_1",                    "rm_terrace" }
    ,{ "get_toyplane",                     "rm_terrace",            { "opn_terrace"                            } }
    ,{ "get_hammer",                       "rm_terrace",            { "opn_terrace"                            } }
    ,{ "use_toyplane",                     "rm_room_313",           { "get_toyplane"                           } }
    ,{ "win_toy",                          "rm_room_313",           { "use_toyplane"                           } }
    ,{ "use_hammer_1",                     "rm_room_313",           { "get_hammer"                             } }
    ,{ "get_wood_1",                       "rm_room_313",           { "use_hammer_1"                           } }
    ,{ "clk_toy_door",                     "rm_room_313",           { "get_wood_1"                             } }
    ,{ "get_lionhead_2",                   "rm_room_313",           { "clk_toy_door"                           } }
    ,{ "use_lionhead_1",                   "rm_terrace",            { "get_lionhead_1"                         } }
    ,{ "use_lionhead_2",                   "rm_terrace",            { "get_lionhead_2"                         } }
    ,{ "get_symbol",                       "rm_terrace",            { "use_lionhead_1", "use_lionhead_2"       } }
    ,{ "use_symbol",                       "rm_room_313",           { "get_symbol"                             } }
    ,{ "get_weathervanepart",              "rm_room_313",           { "use_symbol"                             } }
    ,{ "use_weathervanepart",              "rm_terrace",            { "get_weathervanepart"                    } }
    ,{ "get_breadcrust",                   "rm_terrace",            { "use_weathervanepart"                    } }
    ,{ "use_breadcrust",                   "rm_room_313",           { "get_breadcrust"                         } }
    ,{ "get_wheel",                        "rm_room_313",           { "use_breadcrust"                         } }
    ,{ "clk_couch_wheel",                  "rm_room_313",           { "opn_room_313"                           } }
    ,{ "use_wheel",                        "rm_room_313",           { "clk_couch_wheel", "get_wheel"           } }
    ,{ "clk_couch_chair",                  "rm_room_313",           { "use_wheel"                              } }
    ,{ "use_hammer_2",                     "rm_room_313",           { "get_hammer", "clk_couch_chair"          } }
    ,{ "get_wood_2",                       "rm_room_313",           { "use_hammer_2"                           } }
    ,{ "get_valve",                        "rm_room_313",           { "use_hammer_2"                           } }
    ,{ "get_wood_3",                       "rm_terrace",            { "opn_terrace"                            } }
    ,{ "see_terrace_suicide1",             "rm_terrace" }
    ,{ "use_hammer_3",                     "rm_terrace",            { "get_hammer", "use_lionhead_1", "use_lionhead_2" } }
    ,{ "get_wood_4",                       "rm_terrace",            { "use_hammer_3"                                   } }
    ,{ "see_terrace_suicide2",             "rm_terrace" }
    ,{ "use_wood",                         "rm_terrace",            { "get_wood_1", "get_wood_2", "get_wood_3", "get_wood_4" } }
    ,{ "use_nails",                        "rm_terrace",            { "get_nails",  "use_wood"                } }
    ,{ "use_hammer_4",                     "rm_terrace",            { "get_hammer", "use_nails"               } }
    ,{ "see_room_211",                     "rm_terrace" }
    ,{ "opn_room_211"                      }
    ,{ "see_room_211_1",                   "rm_room_211" }
    ,{ "see_room_211_scare",               "rm_room_211" }
    ,{ "see_room_211_scare_2",             "rm_room_211" }
    ,{ "see_room_211_ghost",               "rm_room_211" }
    ,{ "see_room_211_maidghost",           "rm_room_211" }
    ,{ "get_ladle",                        "rm_room_211",           { "opn_room_211"                          } }
    ,{ "get_universalkey",                 "rm_room_211",           { "opn_room_211"                          } }
    ,{ "use_universalkey",                 "rm_room_313",           { "get_universalkey"                      } }
    ,{ "clk_reverse_key",                  "rm_room_313",           { "use_universalkey"                      } }
    ,{ "use_valve",                        "rm_thirdfloorcorridor", { "clk_reverse_key"                       } }
    ,{ "use_ladle",                        "rm_thirdfloorcorridor", { "clk_reverse_key"                       } }
    ,{ "clk_valve",                        "rm_thirdfloorcorridor", { "use_valve", "use_ladle"                } }
    ,{ "get_ladleofboilingwater",          "rm_thirdfloorcorridor", { "clk_valve"                             } }
    ,{ "use_ladleofboilingwater",          "rm_room_211",           { "get_ladleofboilingwater"               } }
    ,{ "opn_minibar",                      "rm_room_211",           { "use_ladleofboilingwater"               } }
    ,{ "win_minibar",                      "rm_room_211",           { "opn_minibar"                           } }
    ,{ "use_woodenamulet",                 "rm_room_313",           { "win_minibar"                           } }
    ,{ "get_woodendoll",                   "rm_room_313",           { "use_woodenamulet"                      } }
    ,{ "clk_selfmadepen",                  }
    ,{ "get_selfmadepen",                  }
    ,{ "clk_oldselfmadepen",               "rm_terrace",            { "opn_terrace"                           } }
    ,{ "use_selfmadepen",                  "rm_terrace",            { "clk_oldselfmadepen", "get_selfmadepen" } }
    ,{ "get_pruners",                      "rm_terrace",            { "use_selfmadepen"                       } }
    ,{ "get_cleaningagen",                 "rm_terrace",            { "use_selfmadepen"                       } }
    ,{ "use_pruners_1",                    "rm_room_211",           { "get_pruners"                           } }
    ,{ "get_rope",                         "rm_room_211",           { "use_pruners_1"                         } }
    ,{ "clk_beams",                        }
    ,{ "use_rope",                         }
    ,{ "clk_rope_1",                       }
    ,{ "clk_rope_2",                       }
    ,{ "clk_rope_3",                       }
    ,{ "clk_rope_4",                       }
    ,{ "get_ropeladder",                   }
    ,{ "use_ropeladder",                   "rm_room_211",           { "get_ropeladder"                        } }
    ,{ "use_cleaningagen_1",               "rm_room_211",           { "get_cleaningagen"                      } }
    ,{ "clk_cleaningagen_1",               "rm_room_211",           { "use_cleaningagen_1"                    } }
    ,{ "get_broom",                        "rm_room_211",           { "clk_cleaningagen_1"                    } }
    ,{ "opn_serviceroom"                   }
    ,{ "see_serviceroom_ceiling",          "rm_serviceroom"         }
    ,{ "see_serviceroom_ghost",            "rm_serviceroom"         }
    ,{ "use_broom",                        "rm_serviceroom",        { "opn_serviceroom", "get_broom"          } }
    ,{ "get_stick",                        "rm_serviceroom",        { "use_broom"                             } }
    ,{ "get_cross_2",                      "rm_serviceroom",        { "use_broom"                             } }
    ,{ "use_cross_2",                      }
    ,{ "clk_cross_2",                      }
    ,{ "get_salammoniac",                  }
    ,{ "use_salammoniac",                  "rm_serviceroom",        { "get_salammoniac"                       } }
    ,{ "dlg_serviceroom_clark_1",          "rm_serviceroom",        { "use_salammoniac"                       } }
    ,{ "see_serviceroom_1",                "rm_serviceroom",        { "dlg_serviceroom_clark_1"               } }
    ,{ "dlg_serviceroom_clark_2",          "rm_serviceroom",        { "see_serviceroom_1"                     } }
    ,{ "get_hexagon",                      }
    ,{ "use_hexagon",                      "rm_room_211",           { "get_hexagon"                           } }
    ,{ "win_inthreewaymirror",             "rm_room_211",           { "use_hexagon"                           } }
    ,{ "get_hook",                         "rm_room_211",           { "win_inthreewaymirror"                  } }
    ,{ "clk_stick_1",                      }
    ,{ "clk_stick_2",                      }
    ,{ "use_hook",                         }
    ,{ "get_stickwithhook",                }
    ,{ "use_stickwithhook",                "rm_terrace",            { "get_stickwithhook"                     } }
    ,{ "get_phoenixfigurine",              "rm_terrace",            { "use_stickwithhook"                     } }
    ,{ "use_phoenixfigurine",              "rm_thirdfloorcorridor", { "get_phoenixfigurine"                   } }
    ,{ "win_wall",                         "rm_thirdfloorcorridor", { "use_phoenixfigurine"                   } }
    ,{ "get_carvedhandle",                 "rm_thirdfloorcorridor", { "win_wall"                              } }
    ,{ "clk_carvedhandle",                 "rm_terrace",            { "use_lionhead_1", "use_lionhead_2"      } }
    ,{ "use_carvedhandle",                 "rm_terrace",            { "clk_carvedhandle", "get_carvedhandle"  } }
    ,{ "get_screwdriver",                  "rm_terrace",            { "use_carvedhandle"                      } }
    ,{ "use_screwdriver_1",                "rm_serviceroom",        { "get_screwdriver"                       } }
    ,{ "get_fireaxe",                      "rm_serviceroom",        { "use_screwdriver_1"                     } }
    ,{ "use_fireaxe",                      "rm_room_211",           { "get_fireaxe"                           } }
    ,{ "clk_fireaxe",                      "rm_room_211",           { "use_fireaxe"                           } }
    ,{ "opn_hall"                          }
    ,{ "see_hall_clark",                   "rm_hall"                }
    ,{ "use_pruners_2",                    "rm_hall",               { "get_pruners", "opn_hall"               } }
    ,{ "get_lock",                         "rm_hall",               { "use_pruners_2"                         } }
    ,{ "get_battery_2",                    "rm_hall",               { "use_pruners_2"                         } }
    ,{ "use_cleaningagen_2",               "rm_hall",               { "get_cleaningagen", "opn_hall"          } }
    ,{ "use_screwdriver_2",                "rm_hall",               { "get_screwdriver", "opn_hall"           } }
    ,{ "get_battery_1",                    "rm_hall",               { "use_screwdriver_2"                     } }
    ,{ "see_hall_ghost",                   "rm_hall",               { "get_battery_1"                         } }
    ,{ "clk_torchnobatteries_1",           }
    ,{ "clk_torchnobatteries_2",           }
    ,{ "use_battery_1",                    }
    ,{ "use_battery_2",                    }
    ,{ "clk_torchnobatteries_3",           }
    ,{ "clk_torchnobatteries_4",           }
    ,{ "get_torch_2",                      }
    ,{ "use_torch_2",                      "rm_serviceroom",        { "get_torch_2"                           } }
    ,{ "get_acid",                         "rm_serviceroom",        { "use_torch_2"                           } }
    ,{ "clk_room_211_symbols",             "rm_serviceroom",        { "opn_room_211"                          } }
    ,{ "clk_room_211_paper",               "rm_serviceroom",        { "clk_room_211_symbols"                  } }
    ,{ "use_acid",                         "rm_room_211",           { "clk_room_211_paper", "get_acid"        } }
    ,{ "get_jewel",                        "rm_room_211",           { "use_acid"                              } }
    ,{ "use_jewel",                        "rm_serviceroom",        { "get_jewel"                             } }
    ,{ "clk_jewel",                        "rm_serviceroom",        { "use_jewel"                             } }
    ,{ "get_familyportrait",               "rm_serviceroom",        { "clk_jewel"                             } }
    ,{ "clk_portrait_symbol",              "rm_hall",               { "opn_hall"                              } }
    ,{ "use_familyportrait",               "rm_hall",               { "get_familyportrait", "clk_portrait_symbol" } }
    ,{ "opn_portraithall",                 "rm_hall",               { "use_familyportrait"                    } }
    ,{ "win_portraithall",                 "rm_hall",               { "opn_portraithall"                      } }
    ,{ "clk_bloodyamulet",                 "rm_serviceroom",        { "use_broom"                             } }
    ,{ "use_bloodyamulet",                 "rm_serviceroom",        { "clk_bloodyamulet", "win_portraithall"  } }
    ,{ "get_metalcarcass",                 "rm_serviceroom",        { "use_bloodyamulet"                      } }
    ,{ "use_metalcarcass",                 "rm_serviceroom",        { "get_metalcarcass"                      } }
    ,{ "win_onworkbench",                  "rm_serviceroom",        { "use_metalcarcass"                      } }
    ,{ "get_curvedstick",                  "rm_serviceroom",        { "win_onworkbench"                       } }
    ,{ "use_lock",                         "rm_hall",               { "get_lock"                              } }
    ,{ "use_curvedstick",                  "rm_hall",               { "get_curvedstick"                       } }
    ,{ "see_hall_chandelier"               }
    ,{ "see_hall_outro"                    }
    
    ,{ "get_collect_morph_item_1"          }
    ,{ "get_collect_morph_item_2"          }
    ,{ "get_collect_morph_item_3"          }
    ,{ "get_collect_morph_item_4"          }
    ,{ "get_collect_morph_item_5"          }
    ,{ "get_collect_morph_item_6"          }
    ,{ "get_collect_morph_item_7"          }

  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
    
  game.relations = {};
  
  private.menu_moduls = {
                          "rm_credits"
                        };

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
                              "rm_collectibles2",
                              "rm_collectibles",
                              "rm_achievements"
                           };

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;  
  

end;


function private.TutorialSetParams ()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;
  
    ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_page_1" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = {} } , -- Показать туториал? 

      [ "tutorial_page_2" ] = { shown = 0, noskip = false, posx = 600, posy = 200, arrows = { 
                                                                              { pos_x = 100, pos_y = -130, ang =  2.2, target = "gzz_closedroom_entrancedoor" }
                                                                            } },   -- Открыть зз
      [ "tutorial_page_3" ] = { shown = 0, noskip = false, posx = 400, posy = 200, arrows = { 
                                                                              { pos_x = -100, pos_y = -30, ang =  -2, target = "spr_entrancedoor_stone" }
                                                                            } },   -- Подбор в зз
      [ "tutorial_page_4" ] = { shown = 0, noskip = false, posx = 250, posy = 450, arrows = { 
                                                                              { pos_x = 450, pos_y = 300, ang =  -0.5 },
                                                                              { pos_x = 0, pos_y = -70, ang =  3.14, target = "sub_int_inventory_stone" }
                                                                            } },   -- Применение в зз
      [ "tutorial_page_5" ] = { shown = 0, noskip = false, posx = 300, posy = 300, arrows = { 
                                                                                { pos_x = -70, pos_y = -30, ang =  -2.3, target = "obj_int_button_hint_impl" }
                                                                             } },   -- Нажать хинт
      [ "tutorial_page_6" ] = { shown = 0, noskip = false, posx = 250, posy = 450, arrows = { 
                                                                               { pos_x = -50, pos_y = -100, ang =  -2.5, target = "gho_closedroom_darkcorner" }
                                                                             } },   -- Открытие ХО
      [ "tutorial_page_7" ] = { shown = 0, noskip = false, posx = 400, posy = 350, arrows = { 
                                                                              { pos_x = 0, pos_y = -70, ang =  3.14, target = "obj_int_button_task" }
                                                                              } },   -- Нажать на таск
      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 450, posy = 350, arrows = { 
                                                                               { pos_x = 120, pos_y = -30, ang =  2, target = "obj_int_button_info" }
                                                                            } },   -- Инфо в МГ
      [ "tutorial_page_811" ] = { shown = 0, noskip = false, posx = 450, posy = 350, arrows = { 
                                                                               { pos_x = 120, pos_y = -30, ang =  2, target = "obj_int_button_reset" }
                                                                            } },   -- Инфо в МГ
      [ "tutorial_page_9" ] = { shown = 0, noskip = false, posx = 800, posy = 200, arrows = { 
                                                                              { pos_x = -60, pos_y = -60, ang =  3.7, target = "obj_int_button_skip_impl" }
                                                                            } },   -- Скип в МГ
      [ "tutorial_page_10" ] = { shown = 0, noskip = false, posx = 400, posy = 350, arrows = { 
                                                                              { pos_x = 0, pos_y = -70, ang =  3.14, target = "sub_int_inventory_wire" }
                                                                            } },   -- Открыть сложный предмет
      [ "tutorial_page_11" ] = { shown = 0, noskip = false, posx = 350, posy = 450, arrows = { 
                                                                              { pos_x = -150, pos_y = 100, ang =  -1, target = "obj_deploy_inv_wire_clk_wire_1"  }
                                                                            } },   -- Клик в сложном инвентаре
      [ "tutorial_page_12" ] = { shown = 0, noskip = false, posx = 350, posy = 450, arrows = { 
                                                                              { pos_x = 80, pos_y = -90, ang =  2.5, target = "obj_int_button_map_button"  }
                                                                            } },   -- Открыть карту
      [ "tutorial_page_13" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = {} },   -- локация в карте
      [ "tutorial_page_14" ] = { shown = 0, noskip = true, posx = 512, posy = 300, arrows = {} },   -- ХО
      [ "tutorial_page_15" ] = { shown = 0, noskip = true, posx = 512, posy = 300, arrows = {} },   -- ХО собрать целековый объект
      [ "tutorial_page_16" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = {} },   -- ХО пары
      [ "tutorial_page_17" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = {} },   -- ХО тени

      [ "tutorial_page_18" ] = { shown = 0, noskip = false, posx = 550, posy = 280, arrows = { 
                                                                              { pos_x = 180, pos_y = 0, ang = 1, target = "obj_int_achievements_button" },
                                                                            } },   -- ачивки
      [ "tutorial_page_19" ] = { shown = 0, noskip = false, posx = 600, posy = 500, arrows = { 
                                                                              { pos_x = 150, pos_y = 0, ang =  1.6 }
                                                                            } },   -- Колекции1 подбор со сцены
      [ "tutorial_page_20" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = { 
                                                                              { pos_x = 0, pos_y = 0, ang =  -2, target = "obj_int_button_morph" }
                                                                            } },   -- Колекции1 на панельку
      [ "tutorial_page_21" ] = { shown = 0, noskip = false, posx = 450, posy = 450, arrows = { 
                                                                              { pos_x = 50, pos_y = 50, ang =  0.6, target = "obj_int_button_collectibles_root" }
                                                                            } },   -- Колекции1 открыть в комнате
      [ "tutorial_page_22" ] = { shown = 0, noskip = false, posx = 600, posy = 500, arrows = { 
                                                                              { pos_x = 150, pos_y = 0, ang =  1.6 }
                                                                            } },   -- Колекции2 подбор со сцены
      [ "tutorial_page_23" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = { 
                                                                              { pos_x = 430, pos_y = -50, ang =  2, target = "obj_int_button_collectibles2_root" }
                                                                            } },   -- Колекции2 на панельку
      [ "tutorial_page_25" ] = { shown = 0, noskip = false, posx = 600, posy = 500, arrows = { 
                                                                              { pos_x = 150, pos_y = 0, ang =  1.6 }
                                                                            } },   -- морф подбор со сцены
      [ "tutorial_page_26" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = { 
                                                                              { pos_x = 0, pos_y = 100, ang =  -1.3, target = "obj_int_button_morph" }
                                                                            } },   -- морф на панельку
      [ "tutorial_page_27" ] = { shown = 0, noskip = false, posx = 400, posy = 400, arrows = { 
                                                                              { pos_x = 80, pos_y = 300, ang =  1.5, target = "obj_int_slider_clk_left" }
                                                                            } },   -- сладер
    };
  
  end;
                                                                          
end;




