-- name=level1_inv
--*********************************************************************************************************************
function public.Init ()
  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level1_inv_hub");
    port.VideoResizeInRoom("level1_inv");
  end;
  
  private.wire_init();
  private.box_init();
  private.oldalbum_init();
  private.collar_init();
  private.firstaidkit_init();
  private.woodendoll_init();
  private.metalbeams_init(); 
  private.stick_init();
  private.torchnobatteries_init();
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level1_inv_deploy = function ()

    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    common_impl.TurnChildGfx( { "level1_inv_deploy" } , "level1_inv_deploy", res_sparkle_area );

  end;
  cmn.AddSubscriber( "update_game_mode_level1_inv_deploy", update_game_mode_level1_inv_deploy, nil );
  
end;
--*********************************************************************************************************************
function private.StringDivide ( string )  

  local table = { };
  local id = 1;
  local il = 1;

  for i = 1, string.len( string ) do

    if ( string.sub( string, i, i ) == "_" ) then

      table[ id ] = string.sub( string, il, i - 1 );
      il = i + 1;
      id = id + 1;

    end

    if ( i == string.len( string ) ) then

      table[id] = string.sub( string, il, i );
      il = i + 1;
      id = id + 1;

    end

  end

  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck ( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[4];  
  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;

--*********************************************************************************************************************
-- function *** wire *** () end;
--*********************************************************************************************************************
  function private.wire_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_wire_lockpick",       { event_mdown = private.get_lockpick } },
      { "obj_deploy_inv_wire_clk_wire_1",       { event_mdown = private.clk_wire_1 } },
      { "obj_deploy_inv_wire_clk_wire_2",       { event_mdown = private.clk_wire_2 } },
      
    } );
    
    --------------------------------------------------------------------------------------------
    -- function clk_wire_1 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_wire_1" ] = {
      type = "click",
      use_place = "obj_deploy_inv_wire_clk_wire_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_wire",
      zz_gate = "inv_wire"
    };
    
    local clk_wire_1_beg = function ()

      ObjDelete( "obj_deploy_inv_wire_clk_wire_1" );
    
    end;
    local clk_wire_1_end = function ()
    
      ObjDelete( "spr_deploy_inv_wire_1_2" );
      ObjMultiSet( { 
        { "spr_deploy_inv_wire_2",  { alp = 1, visible = true } },
        { "obj_deploy_inv_wire_clk_wire_2",  { input = true } },
      } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_wire_1",     clk_wire_1_beg );
    cmn.AddSubscriber( "clk_wire_1",     clk_wire_1_end, "inv_wire" );
    cmn.AddSubscriber( "clk_wire_1_beg", clk_wire_1_beg );
    cmn.AddSubscriber( "clk_wire_1_end", clk_wire_1_end, "inv_wire" );   
  
    --------------------------------------------------------------------------------------------
    -- function clk_wire_2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_wire_2" ] = {
      type = "click",
      use_place = "obj_deploy_inv_wire_clk_wire_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_wire",
      zz_gate = "inv_wire"
    };
    
    local clk_wire_2_beg = function ()

      ObjDelete( "obj_deploy_inv_wire_clk_wire_2" );
    
    end;
    local clk_wire_2_end = function ()
    
      ObjDelete( "spr_deploy_inv_wire_2" );
      ObjMultiSet( { 
        { "spr_deploy_inv_wire_lockpick",  { alp = 1, visible = true, input = true } },
      } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_wire_2",     clk_wire_2_beg );
    cmn.AddSubscriber( "clk_wire_2",     clk_wire_2_end, "inv_wire" );
    cmn.AddSubscriber( "clk_wire_2_beg", clk_wire_2_beg );
    cmn.AddSubscriber( "clk_wire_2_end", clk_wire_2_end, "inv_wire" );      
  
    --------------------------------------------------------------------------------------------
    -- function get_lockpick () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_lockpick" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_wire_lockpick",
        room = "int_deploy_inv",
        zz = "deploy_inv_wire",
        zz_gate = "inv_wire"
      };
      local get_lockpick_inv = function ()

        interface.InventoryItemRemove( "inv_wire" );
        interface.InventoryItemAdd( "inv_lockpick", "spr_deploy_inv_wire_lockpick" );

      end;
      local get_lockpick = function ()

        ObjDelete( "gfx_deploy_inv_wire_lockpick" );

      end;
      cmn.AddSubscriber( "get_lockpick", get_lockpick_inv );
      cmn.AddSubscriber( "get_lockpick", get_lockpick, "inv_wire" );
      
  end;
    
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_wire_1 ()
    
    cmn.CallEventHandler( "clk_wire_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_wire_1" );
      cmn.CallEventHandler( "clk_wire_1_end", "inv_wire" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_small", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_inv_wire_1_2", "alp",0,0, "", { 0, 0, 1,    0.4, 0, 0 } );
    ObjAnimate( "spr_deploy_inv_wire_1_1", "ang",0,0, "", { 0, 0, 0,    0.6, 0, 0.47 } );
    
    ObjSet( "spr_deploy_inv_wire_2", { alp = 0, visible = true } );
    ObjAnimate( "spr_deploy_inv_wire_2", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
    
  end;    
  
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_wire_2 ()
    
    cmn.CallEventHandler( "clk_wire_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_wire_2" );
      cmn.CallEventHandler( "clk_wire_2_end", "inv_wire" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_small", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_inv_wire_2", "alp",0,0, "", { 0, 0, 1,    0.4, 0, 0 } );
    
    ObjSet( "spr_deploy_inv_wire_lockpick", { alp = 0, visible = true } );
    ObjAnimate( "spr_deploy_inv_wire_lockpick", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
    
  end;    
   
  -- GET ------------------------------------------------------------------------------------------
  function private.get_lockpick ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_lockpick" );
    cmn.CallEventHandler( "get_lockpick", "inv_wire" );
    common_impl.HideDeployInv();

  end;


--*********************************************************************************************************************
-- function *** box *** () end;
--*********************************************************************************************************************
  function private.box_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_box_eye",         { event_mdown = private.get_eye } },
      { "obj_deploy_inv_box_clk_boxkey",  { event_mdown = private.clk_boxkey } },
      { "spr_deploy_inv_box_note",        { event_mdown = function () common_impl.NoteScale( "spr_deploy_inv_box_note" ); end; } },
      { "spr_deploy_inv_box_note_big",    { event_mdown = function () common_impl.NoteScale( "spr_deploy_inv_box_note" ); end; } },
    } );

    --------------------------------------------------------------------------------------------
    -- function use_boxkey () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_boxkey" ] = {
        type = "use",
        inv_obj = "inv_boxkey",
        use_place = "obj_deploy_inv_box_use_boxkey",
        room = "int_deploy_inv",
        zz = "deploy_inv_box",
        zz_gate = "inv_box"
      };    
      function use_boxkey_beg ()
        
        interface.InventoryItemRemove( "inv_boxkey" );
        ObjDelete( "obj_deploy_inv_box_use_boxkey" );
        
      end;
      function use_boxkey_end ()

        ObjMultiSet( {
          { "spr_deploy_inv_box_key_1", { alp = 1, visible = true } },
          { "obj_deploy_inv_box_clk_boxkey", { input = true } },
        } );
        
      end;
      cmn.AddSubscriber( "use_boxkey", use_boxkey_beg );
      cmn.AddSubscriber( "use_boxkey", use_boxkey_end, "inv_box" );
      cmn.AddSubscriber( "use_boxkey_beg", use_boxkey_beg );
      cmn.AddSubscriber( "use_boxkey_end", use_boxkey_end, "inv_box" );   
      
    --------------------------------------------------------------------------------------------
    -- function clk_boxkey () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_boxkey" ] = {
      type = "click",
      use_place = "obj_deploy_inv_box_clk_boxkey",
      room = "int_deploy_inv",
      zz = "deploy_inv_box",
      zz_gate = "inv_box"
    };
    
    local clk_boxkey_beg = function ()

      ObjDelete( "obj_deploy_inv_box_clk_boxkey" );
    
    end;
    local clk_boxkey_end = function ()
    
      ObjDelete( "spr_deploy_inv_box_key_1" );
      ObjDelete( "spr_deploy_inv_box_top_closed" );
      
      ObjMultiSet( { 
        { "spr_deploy_inv_box_top_open",  { alp = 1, visible = true } },
        { "spr_deploy_inv_box_key_2",  { alp = 1, visible = true } },
        { "spr_deploy_inv_box_bottom",  { input = true } },
      } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_boxkey",     clk_boxkey_beg );
    cmn.AddSubscriber( "clk_boxkey",     clk_boxkey_end, "inv_box" );
    cmn.AddSubscriber( "clk_boxkey_beg", clk_boxkey_beg );
    cmn.AddSubscriber( "clk_boxkey_end", clk_boxkey_end, "inv_box" );      
      
    --------------------------------------------------------------------------------------------
    -- function get_eye () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_eye" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_box_eye",
        room = "int_deploy_inv",
        zz = "deploy_inv_box",
        zz_gate = "inv_box"
      };
      local get_eye_inv = function ()
      
        interface.InventoryItemRemove( "inv_box" );
        interface.InventoryItemAdd( "inv_eye", "spr_deploy_inv_box_eye" );

      end;
      local get_eye = function ()

        ObjDelete( "gfx_deploy_inv_box_eye" );

      end;
      cmn.AddSubscriber( "get_eye", get_eye_inv );
      cmn.AddSubscriber( "get_eye", get_eye, "inv_box" );
      
  end;

  -- USE ---------------------------------------------------------------------------------------
  function public.use_boxkey ()

    local item = "inv_boxkey";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_box_use_boxkey" ) then

      cmn.CallEventHandler( "use_boxkey_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_boxkey" );
        cmn.CallEventHandler( "use_boxkey_end", "inv_box" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_key_small", 0, "", 0 );

      cmn.ItemFly( "spr_deploy_inv_box_key_1", func_end, -1.57 );
      
      return true; 

    end;

    return false;

  end;
  
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_boxkey ()
    
    cmn.CallEventHandler( "clk_boxkey_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_boxkey" );
      cmn.CallEventHandler( "clk_boxkey_end", "inv_box" ); 

    end;
    
    local func_end_2 = function ()
      
      ObjAnimate( "spr_deploy_inv_box_top_closed", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 1,    0.3, 0, 0 } );
      ObjSet( "spr_deploy_inv_box_top_open", { alp = 0, visible = true } );
      ObjAnimate( "spr_deploy_inv_box_top_open", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
            
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_opn_metal_box", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_inv_box_key_1", "alp",0,0, func_end_2, { 0, 0, 1,    0.1, 0, 1,    0.3, 0, 0 } );
    ObjSet( "spr_deploy_inv_box_key_2", { alp = 0, visible = true } );
    ObjAnimate( "spr_deploy_inv_box_key_2", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
    
  end;  
  
  -- GET ------------------------------------------------------------------------------------------
  function private.get_eye ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_eye" );
    cmn.CallEventHandler( "get_eye", "inv_box" );
    common_impl.HideDeployInv();

  end;
  
  
--*********************************************************************************************************************
-- function *** oldalbum *** () end;
--*********************************************************************************************************************
  function private.oldalbum_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_oldalbum_hotelsign",       { event_mdown = private.get_hotelsign  } },

      { "spr_deploy_inv_oldalbum_clk_oldalbum_1",  { event_mdown = private.clk_oldalbum_1 } },
      { "spr_deploy_inv_oldalbum_clk_oldalbum_2",  { event_mdown = private.clk_oldalbum_2 } },
      { "spr_deploy_inv_oldalbum_clk_oldalbum_3",  { event_mdown = private.clk_oldalbum_3 } },
      { "spr_deploy_inv_oldalbum_clk_oldalbum_4",  { event_mdown = private.clk_oldalbum_4 } },
      { "spr_deploy_inv_oldalbum_clk_oldalbum_5",  { event_mdown = private.clk_oldalbum_5 } },
      { "spr_deploy_inv_oldalbum_clk_oldalbum_6",  { event_mdown = private.clk_oldalbum_6 } },

      --- page 1 -----------------------------------------------------------------------------------------------------------------
      { "spr_deploy_inv_oldalbum_hat_1",     { event_startdrag = function() private.drag_oldalbum( "hat_1" );               end }},
      { "spr_deploy_inv_oldalbum_hat_2",     { event_startdrag = function() private.drag_oldalbum( "hat_2" );               end }},
      { "spr_deploy_inv_oldalbum_hat_3",     { event_startdrag = function() private.drag_oldalbum( "hat_3" );               end }},

      { "spr_deploy_inv_oldalbum_hat_1",     { event_dragdrop  = function() private.drop_use_oldalbum( "hat_1", 1, 1 );     end }},
      { "spr_deploy_inv_oldalbum_hat_2",     { event_dragdrop  = function() private.drop_use_oldalbum( "hat_2", 1, 2 );     end }},
      { "spr_deploy_inv_oldalbum_hat_3",     { event_dragdrop  = function() private.drop_use_oldalbum( "hat_3", 1, 3 );     end }},

      --- page 2-3 -----------------------------------------------------------------------------------------------------------------
      { "spr_deploy_inv_oldalbum_ribbon",    { event_startdrag = function() private.drag_oldalbum( "ribbon" );              end }},
      { "spr_deploy_inv_oldalbum_pince_nez", { event_startdrag = function() private.drag_oldalbum( "pince_nez" );           end }},
      { "spr_deploy_inv_oldalbum_tie",       { event_startdrag = function() private.drag_oldalbum( "tie" );                 end }},

      { "spr_deploy_inv_oldalbum_ribbon",    { event_dragdrop  = function() private.drop_use_oldalbum( "ribbon",    2, 1 ); end }},
      { "spr_deploy_inv_oldalbum_pince_nez", { event_dragdrop  = function() private.drop_use_oldalbum( "pince_nez", 2, 2 ); end }},
      { "spr_deploy_inv_oldalbum_tie",       { event_dragdrop  = function() private.drop_use_oldalbum( "tie",       2, 3 ); end }},

      --- page 4-5 -----------------------------------------------------------------------------------------------------------------
      { "spr_deploy_inv_oldalbum_bell",      { event_startdrag = function() private.drag_oldalbum( "bell" );                end }},
      { "spr_deploy_inv_oldalbum_candle",    { event_startdrag = function() private.drag_oldalbum( "candle" );              end }},
      { "spr_deploy_inv_oldalbum_parrot",    { event_startdrag = function() private.drag_oldalbum( "parrot" );              end }},

      { "spr_deploy_inv_oldalbum_bell",      { event_dragdrop = function() private.drop_use_oldalbum( "bell",   3, 1 );     end }},
      { "spr_deploy_inv_oldalbum_candle",    { event_dragdrop = function() private.drop_use_oldalbum( "candle", 3, 2 );     end }},
      { "spr_deploy_inv_oldalbum_parrot",    { event_dragdrop = function() private.drop_use_oldalbum( "parrot", 3, 3 );     end }},

      --- page 6-7 -----------------------------------------------------------------------------------------------------------------
      { "spr_deploy_inv_oldalbum_fireiron",  { event_startdrag = function() private.drag_oldalbum( "fireiron" );            end }},
      { "spr_deploy_inv_oldalbum_vineglass", { event_startdrag = function() private.drag_oldalbum( "vineglass" );           end }},
      { "spr_deploy_inv_oldalbum_photo",     { event_startdrag = function() private.drag_oldalbum( "photo" );               end }},

      { "spr_deploy_inv_oldalbum_fireiron",  { event_dragdrop = function() private.drop_use_oldalbum( "fireiron",  4, 1 );  end }},
      { "spr_deploy_inv_oldalbum_vineglass", { event_dragdrop = function() private.drop_use_oldalbum( "vineglass", 4, 2 );  end }},
      { "spr_deploy_inv_oldalbum_photo",     { event_dragdrop = function() private.drop_use_oldalbum( "photo",     4, 3 );  end }},

      --- page 8-9 -----------------------------------------------------------------------------------------------------------------
      { "spr_deploy_inv_oldalbum_bottle",    { event_startdrag = function() private.drag_oldalbum( "bottle" );              end }},
      { "spr_deploy_inv_oldalbum_cheese",    { event_startdrag = function() private.drag_oldalbum( "cheese" );              end }},
      { "spr_deploy_inv_oldalbum_crane",     { event_startdrag = function() private.drag_oldalbum( "crane" );               end }},

      { "spr_deploy_inv_oldalbum_bottle",    { event_dragdrop = function() private.drop_use_oldalbum( "bottle", 5, 1 );     end }},
      { "spr_deploy_inv_oldalbum_cheese",    { event_dragdrop = function() private.drop_use_oldalbum( "cheese", 5, 2 );     end }},
      { "spr_deploy_inv_oldalbum_crane",     { event_dragdrop = function() private.drop_use_oldalbum( "crane",  5, 3 );     end }},
    } );
    
    private.pos_page1  = { {  -96, -153 }, {  -39, -149 }, { -145, -162 } };  -- { hat_1    },{ hat_2     },{ hat_3  }
    private.pos_page23 = { {  155,  128 }, {  137,  -78 }, {  143,   -1 } };  -- { ribbon   },{ pince_nez },{ tie    }
    private.pos_page45 = { { -183,    6 }, { -218, -101 }, { -223, -173 } };  -- { bell     },{ candle    },{ parrot }
    private.pos_page67 = { {  166,  -83 }, {  120,  154 }, {  157, -198 } };  -- { fireiron },{ vineglass },{ photo  }
    private.pos_page89 = { {  -59,  -11 }, {  -64,  138 }, { -212,   88 } };  -- { bottle   },{ cheese    },{ crane  } 

    --------------------------------------------------------------------------------------------
    -- function clk_oldalbum_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_oldalbum_1" ] = {
        type = "click",
        use_place = "spr_deploy_inv_oldalbum_clk_oldalbum_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      
      local clk_oldalbum_1_beg = function ()

        ObjDelete( "spr_deploy_inv_oldalbum_clk_oldalbum_1" );
      
      end;
      local clk_oldalbum_1_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_oldalbum_old_album_open", { alp = 1, input = true } },
          { "obj_deploy_inv_oldalbum_page_1",         {          input = true } },

          { "obj_deploy_inv_oldalbum_use_hat_1",      { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_hat_2",      { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_hat_3",      { input = true, active = true, visible = true } },
          
          { "obj_deploy_inv_oldalbum_use_1",          { input = true, active = true, visible = true } },
        } );
        ObjDelete( "spr_deploy_inv_oldalbum_cover" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_oldalbum_1",     clk_oldalbum_1_beg );
      cmn.AddSubscriber( "clk_oldalbum_1",     clk_oldalbum_1_end, "inv_oldalbum" );
      cmn.AddSubscriber( "clk_oldalbum_1_beg", clk_oldalbum_1_beg );
      cmn.AddSubscriber( "clk_oldalbum_1_end", clk_oldalbum_1_end, "inv_oldalbum" ); 

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_hat_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_hat_1" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_hat_1",
        use_place = "obj_deploy_inv_oldalbum_use_hat_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_hat_1_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_hat_1" );
      
      end;
      local use_oldalbum_hat_1_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_hat_1", { pos_x = private.pos_page1[1][1], pos_y = private.pos_page1[1][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_hat_2" ) and cmn.IsEventDone( "use_oldalbum_hat_3" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_2", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_1" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_hat_1",     use_oldalbum_hat_1_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_hat_1",     use_oldalbum_hat_1_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_hat_1_beg", use_oldalbum_hat_1_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_hat_1_end", use_oldalbum_hat_1_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_hat_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_hat_2" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_hat_2",
        use_place = "obj_deploy_inv_oldalbum_use_hat_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_hat_2_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_hat_2" );
      
      end;
      local use_oldalbum_hat_2_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_hat_2", { pos_x = private.pos_page1[2][1], pos_y = private.pos_page1[2][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_hat_1" ) and cmn.IsEventDone( "use_oldalbum_hat_3" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_2", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_1" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_hat_2",     use_oldalbum_hat_2_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_hat_2",     use_oldalbum_hat_2_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_hat_2_beg", use_oldalbum_hat_2_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_hat_2_end", use_oldalbum_hat_2_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_hat_3 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_hat_3" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_hat_3",
        use_place = "obj_deploy_inv_oldalbum_use_hat_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_hat_3_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_hat_3" );
      
      end;
      local use_oldalbum_hat_3_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_hat_3", { pos_x = private.pos_page1[3][1], pos_y = private.pos_page1[3][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_hat_1" ) and cmn.IsEventDone( "use_oldalbum_hat_2" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_2", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_1" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_hat_3",     use_oldalbum_hat_3_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_hat_3",     use_oldalbum_hat_3_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_hat_3_beg", use_oldalbum_hat_3_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_hat_3_end", use_oldalbum_hat_3_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function clk_oldalbum_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_oldalbum_2" ] = {
        type = "click",
        use_place = "spr_deploy_inv_oldalbum_clk_oldalbum_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      
      local clk_oldalbum_2_beg = function ()

        ObjDelete( "spr_deploy_inv_oldalbum_clk_oldalbum_2" );
      
      end;
      local clk_oldalbum_2_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_oldalbum_page_2_3", { alp = 1, input = true } },

          { "obj_deploy_inv_oldalbum_use_ribbon",    { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_pince_nez", { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_tie",       { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_2",         { input = true, active = true, visible = true } },
        } );
        ObjDelete( "obj_deploy_inv_oldalbum_page_1"   );
        ObjDelete( "anm_deploy_inv_oldalbum_page_up1" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_oldalbum_2",     clk_oldalbum_2_beg );
      cmn.AddSubscriber( "clk_oldalbum_2",     clk_oldalbum_2_end, "inv_oldalbum" );
      cmn.AddSubscriber( "clk_oldalbum_2_beg", clk_oldalbum_2_beg );
      cmn.AddSubscriber( "clk_oldalbum_2_end", clk_oldalbum_2_end, "inv_oldalbum" );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_ribbon () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_ribbon" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_ribbon",
        use_place = "obj_deploy_inv_oldalbum_use_ribbon",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_ribbon_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_ribbon" );
      
      end;
      local use_oldalbum_ribbon_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_ribbon", { pos_x = private.pos_page23[1][1], pos_y = private.pos_page23[1][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_pince_nez" ) and cmn.IsEventDone( "use_oldalbum_tie" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_3", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_2" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_ribbon",     use_oldalbum_ribbon_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_ribbon",     use_oldalbum_ribbon_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_ribbon_beg", use_oldalbum_ribbon_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_ribbon_end", use_oldalbum_ribbon_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_pince_nez () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_pince_nez" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_pince_nez",
        use_place = "obj_deploy_inv_oldalbum_use_pince_nez",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_pince_nez_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_pince_nez" );
      
      end;
      local use_oldalbum_pince_nez_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_pince_nez", { pos_x = private.pos_page23[2][1], pos_y = private.pos_page23[2][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_ribbon" ) and cmn.IsEventDone( "use_oldalbum_tie" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_3", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_2" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_pince_nez",     use_oldalbum_pince_nez_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_pince_nez",     use_oldalbum_pince_nez_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_pince_nez_beg", use_oldalbum_pince_nez_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_pince_nez_end", use_oldalbum_pince_nez_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_tie () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_tie" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_tie",
        use_place = "obj_deploy_inv_oldalbum_use_tie",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_tie_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_tie" );
      
      end;
      local use_oldalbum_tie_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_tie", { pos_x = private.pos_page23[3][1], pos_y = private.pos_page23[3][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_ribbon" ) and cmn.IsEventDone( "use_oldalbum_pince_nez" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_3", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_2" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_tie",     use_oldalbum_tie_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_tie",     use_oldalbum_tie_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_tie_beg", use_oldalbum_tie_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_tie_end", use_oldalbum_tie_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function clk_oldalbum_3 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_oldalbum_3" ] = {
        type = "click",
        use_place = "spr_deploy_inv_oldalbum_clk_oldalbum_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      
      local clk_oldalbum_3_beg = function ()

        ObjDelete( "spr_deploy_inv_oldalbum_clk_oldalbum_3" );
      
      end;
      local clk_oldalbum_3_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_oldalbum_page_4_5", { alp = 1, input = true } },

          { "obj_deploy_inv_oldalbum_use_bell",   { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_candle", { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_parrot", { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_3",      { input = true, active = true, visible = true } },
        } );
        ObjDelete( "obj_deploy_inv_oldalbum_page_2_3" );
        ObjDelete( "anm_deploy_inv_oldalbum_page_up2" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_oldalbum_3",     clk_oldalbum_3_beg );
      cmn.AddSubscriber( "clk_oldalbum_3",     clk_oldalbum_3_end, "inv_oldalbum" );
      cmn.AddSubscriber( "clk_oldalbum_3_beg", clk_oldalbum_3_beg );
      cmn.AddSubscriber( "clk_oldalbum_3_end", clk_oldalbum_3_end, "inv_oldalbum" );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_bell () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_bell" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_bell",
        use_place = "obj_deploy_inv_oldalbum_use_bell",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_bell_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_bell" );
      
      end;
      local use_oldalbum_bell_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_bell", { pos_x = private.pos_page45[1][1], pos_y = private.pos_page45[1][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_candle" ) and cmn.IsEventDone( "use_oldalbum_parrot" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_4", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_3" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_bell",     use_oldalbum_bell_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_bell",     use_oldalbum_bell_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_bell_beg", use_oldalbum_bell_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_bell_end", use_oldalbum_bell_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_candle () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_candle" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_candle",
        use_place = "obj_deploy_inv_oldalbum_use_candle",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_candle_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_candle" );
      
      end;
      local use_oldalbum_candle_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_candle", { pos_x = private.pos_page45[2][1], pos_y = private.pos_page45[2][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_bell" ) and cmn.IsEventDone( "use_oldalbum_parrot" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_4", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_3" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_candle",     use_oldalbum_candle_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_candle",     use_oldalbum_candle_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_candle_beg", use_oldalbum_candle_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_candle_end", use_oldalbum_candle_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_parrot () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_parrot" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_parrot",
        use_place = "obj_deploy_inv_oldalbum_use_parrot",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_parrot_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_parrot" );
      
      end;
      local use_oldalbum_parrot_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_parrot", { pos_x = private.pos_page45[3][1], pos_y = private.pos_page45[3][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_bell" ) and cmn.IsEventDone( "use_oldalbum_candle" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_4", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_3" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_parrot",     use_oldalbum_parrot_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_parrot",     use_oldalbum_parrot_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_parrot_beg", use_oldalbum_parrot_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_parrot_end", use_oldalbum_parrot_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function clk_oldalbum_4 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_oldalbum_4" ] = {
        type = "click",
        use_place = "spr_deploy_inv_oldalbum_clk_oldalbum_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      
      local clk_oldalbum_4_beg = function ()

        ObjDelete( "spr_deploy_inv_oldalbum_clk_oldalbum_4" );
      
      end;
      local clk_oldalbum_4_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_oldalbum_page_6_7", { alp = 1, input = true } },

          { "obj_deploy_inv_oldalbum_use_fireiron",  { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_vineglass", { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_photo",     { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_4",         { input = true, active = true, visible = true } },
        } );
        ObjDelete( "obj_deploy_inv_oldalbum_page_4_5" );
        ObjDelete( "anm_deploy_inv_oldalbum_page_up3" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_oldalbum_4",     clk_oldalbum_4_beg );
      cmn.AddSubscriber( "clk_oldalbum_4",     clk_oldalbum_4_end, "inv_oldalbum" );
      cmn.AddSubscriber( "clk_oldalbum_4_beg", clk_oldalbum_4_beg );
      cmn.AddSubscriber( "clk_oldalbum_4_end", clk_oldalbum_4_end, "inv_oldalbum" );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_fireiron () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_fireiron" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_fireiron",
        use_place = "obj_deploy_inv_oldalbum_use_fireiron",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_fireiron_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_fireiron" );
      
      end;
      local use_oldalbum_fireiron_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_fireiron", { pos_x = private.pos_page67[1][1], pos_y = private.pos_page67[1][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_vineglass" ) and cmn.IsEventDone( "use_oldalbum_photo" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_5", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_4" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_fireiron",     use_oldalbum_fireiron_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_fireiron",     use_oldalbum_fireiron_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_fireiron_beg", use_oldalbum_fireiron_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_fireiron_end", use_oldalbum_fireiron_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_vineglass () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_vineglass" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_vineglass",
        use_place = "obj_deploy_inv_oldalbum_use_vineglass",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_vineglass_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_vineglass" );
      
      end;
      local use_oldalbum_vineglass_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_vineglass", { pos_x = private.pos_page67[2][1], pos_y = private.pos_page67[2][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_fireiron" ) and cmn.IsEventDone( "use_oldalbum_photo" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_5", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_4" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_vineglass",     use_oldalbum_vineglass_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_vineglass",     use_oldalbum_vineglass_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_vineglass_beg", use_oldalbum_vineglass_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_vineglass_end", use_oldalbum_vineglass_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_photo () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_photo" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_photo",
        use_place = "obj_deploy_inv_oldalbum_use_photo",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_photo_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_photo" );
      
      end;
      local use_oldalbum_photo_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_photo", { pos_x = private.pos_page67[3][1], pos_y = private.pos_page67[3][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_fireiron" ) and cmn.IsEventDone( "use_oldalbum_vineglass" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_5", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_4" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_photo",     use_oldalbum_photo_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_photo",     use_oldalbum_photo_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_photo_beg", use_oldalbum_photo_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_photo_end", use_oldalbum_photo_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function clk_oldalbum_5 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_oldalbum_5" ] = {
        type = "click",
        use_place = "spr_deploy_inv_oldalbum_clk_oldalbum_5",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      
      local clk_oldalbum_5_beg = function ()

        ObjDelete( "spr_deploy_inv_oldalbum_clk_oldalbum_5" );
      
      end;
      local clk_oldalbum_5_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_oldalbum_page_8_9", { alp = 1, input = true } },

          { "obj_deploy_inv_oldalbum_use_bottle", { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_cheese", { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_crane",  { input = true, active = true, visible = true } },
          { "obj_deploy_inv_oldalbum_use_5",      { input = true, active = true, visible = true } },
        } );
        ObjDelete( "obj_deploy_inv_oldalbum_page_6_7" );
        ObjDelete( "anm_deploy_inv_oldalbum_page_up4" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_oldalbum_5",     clk_oldalbum_5_beg );
      cmn.AddSubscriber( "clk_oldalbum_5",     clk_oldalbum_5_end, "inv_oldalbum" );
      cmn.AddSubscriber( "clk_oldalbum_5_beg", clk_oldalbum_5_beg );
      cmn.AddSubscriber( "clk_oldalbum_5_end", clk_oldalbum_5_end, "inv_oldalbum" );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_bottle () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_bottle" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_bottle",
        use_place = "obj_deploy_inv_oldalbum_use_bottle",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_bottle_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_bottle" );
      
      end;
      local use_oldalbum_bottle_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_bottle", { pos_x = private.pos_page89[1][1], pos_y = private.pos_page89[1][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_cheese" ) and cmn.IsEventDone( "use_oldalbum_crane" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_6", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_5" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_bottle",     use_oldalbum_bottle_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_bottle",     use_oldalbum_bottle_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_bottle_beg", use_oldalbum_bottle_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_bottle_end", use_oldalbum_bottle_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_cheese () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_cheese" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_cheese",
        use_place = "obj_deploy_inv_oldalbum_use_cheese",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_cheese_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_cheese" );
      
      end;
      local use_oldalbum_cheese_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_cheese", { pos_x = private.pos_page89[2][1], pos_y = private.pos_page89[2][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_bottle" ) and cmn.IsEventDone( "use_oldalbum_crane" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_6", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_5" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_cheese",     use_oldalbum_cheese_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_cheese",     use_oldalbum_cheese_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_cheese_beg", use_oldalbum_cheese_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_cheese_end", use_oldalbum_cheese_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function use_oldalbum_crane () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_oldalbum_crane" ] = {
        type = "use",
        inv_obj = "spr_deploy_inv_oldalbum_crane",
        use_place = "obj_deploy_inv_oldalbum_use_crane",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local use_oldalbum_crane_beg = function ()

        ObjDelete( "obj_deploy_inv_oldalbum_use_crane" );
      
      end;
      local use_oldalbum_crane_end = function ()

        ObjMultiSet({ 
          { "spr_deploy_inv_oldalbum_crane", { pos_x = private.pos_page89[3][1], pos_y = private.pos_page89[3][2], pos_z = 1, input = false }},
        });

        if ( cmn.IsEventDone( "use_oldalbum_bottle" ) and cmn.IsEventDone( "use_oldalbum_cheese" ) ) then

          ObjMultiSet({ 
            { "spr_deploy_inv_oldalbum_clk_oldalbum_6", { input = true, active = true, visible = true }},
          });
          ObjDelete( "obj_deploy_inv_oldalbum_use_5" );

        end;
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_oldalbum_crane",     use_oldalbum_crane_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_crane",     use_oldalbum_crane_end, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_crane_beg", use_oldalbum_crane_beg, private.room_objname );
      cmn.AddSubscriber( "use_oldalbum_crane_end", use_oldalbum_crane_end, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function clk_oldalbum_6 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_oldalbum_6" ] = {
        type = "click",
        use_place = "spr_deploy_inv_oldalbum_clk_oldalbum_6",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      
      local clk_oldalbum_6_beg = function ()

        ObjDelete( "spr_deploy_inv_oldalbum_clk_oldalbum_6" );
      
      end;
      local clk_oldalbum_6_end = function ()

        ObjMultiSet( {
          { "spr_deploy_inv_oldalbum_hotelsign", {  input = true } },
          { "gfx_deploy_inv_oldalbum_hotelsign", { active = true } },
        } );
        ObjDelete( "obj_deploy_inv_oldalbum_page_8_9" );
        ObjDelete( "anm_deploy_inv_oldalbum_page_up5" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_oldalbum_6",     clk_oldalbum_6_beg );
      cmn.AddSubscriber( "clk_oldalbum_6",     clk_oldalbum_6_end, "inv_oldalbum" );
      cmn.AddSubscriber( "clk_oldalbum_6_beg", clk_oldalbum_6_beg );
      cmn.AddSubscriber( "clk_oldalbum_6_end", clk_oldalbum_6_end, "inv_oldalbum" );

    --------------------------------------------------------------------------------------------
    -- function get_hotelsign () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_hotelsign" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_oldalbum_hotelsign",
        room = "int_deploy_inv",
        zz = "deploy_inv_oldalbum",
        zz_gate = "inv_oldalbum"
      };
      local get_hotelsign_inv = function ()

        interface.InventoryItemRemove( "inv_oldalbum" );
        interface.InventoryItemAdd( "inv_hotelsign", "spr_deploy_inv_oldalbum_hotelsign" );

      end;
      local get_hotelsign = function ()

        ObjDelete( "gfx_deploy_inv_oldalbum_hotelsign" );

      end;
      cmn.AddSubscriber( "get_hotelsign", get_hotelsign_inv );
      cmn.AddSubscriber( "get_hotelsign", get_hotelsign, "inv_oldalbum" );
      
  end;
     
  -- Drag USE ---------------------------------------------------------------------------------------
  function private.drag_oldalbum ( name )

    common_impl.PlayAudio( "sfx", "aud_take_inventory" );
    ObjSet( "spr_deploy_inv_oldalbum_"..name , { pos_z = 1000 } );
    
  end;

  -- Drop USE ---------------------------------------------------------------------------------------
  function private.drop_use_oldalbum( name, name_mas, position )

    local sprName = "spr_deploy_inv_oldalbum_"..name;
    local useName = "obj_deploy_inv_oldalbum_use_"..name;
    local eventName = "use_oldalbum_"..name;

    local masX = 0;
    local masY = 0;

        if name_mas == 1 then masX = private.pos_page1[position][1];  masY = private.pos_page1[position][2];
    elseif name_mas == 2 then masX = private.pos_page23[position][1]; masY = private.pos_page23[position][2];
    elseif name_mas == 3 then masX = private.pos_page45[position][1]; masY = private.pos_page45[position][2];
    elseif name_mas == 4 then masX = private.pos_page67[position][1]; masY = private.pos_page67[position][2];
    elseif name_mas == 5 then masX = private.pos_page89[position][1]; masY = private.pos_page89[position][2];
    end;

    if ObjIntersect( sprName , useName ) then

      cmn.CallEventHandler( eventName.."_beg" );

      local func_end = function ()

        cmn.Lock( false );
        cmn.SetEventDone( eventName );
        cmn.CallEventHandler( eventName.."_end" ); 

      end;
      
      cmn.Lock( true );
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper2", 0, "", 0 );

      ObjSet( sprName,  { pos_x = masX, pos_y = masY, input = false } );
      func_end ();

    else 

      common_impl.WrongApply();
      ObjSet( sprName, { pos_z = 0 } );

    end;

  end;

  -- CLK --------------------------------------------------------------------------------------------
  function private.clk_oldalbum_1 ()
    
    cmn.CallEventHandler( "clk_oldalbum_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_oldalbum_1" );
      cmn.CallEventHandler( "clk_oldalbum_1_end", "inv_oldalbum" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_book", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_oldalbum_cover",          "alp", 0, 0, func_end, { 0, 0, 1,  0.3, 0, 0 } );
    ObjAnimate( "spr_deploy_inv_oldalbum_old_album_open", "alp", 0, 0,       "", { 0, 0, 0,  0.3, 0, 1 } );   

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_oldalbum_2 ()
    
    cmn.CallEventHandler( "clk_oldalbum_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_oldalbum_2" );
      cmn.CallEventHandler( "clk_oldalbum_2_end", "inv_oldalbum" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page", 0, "", 0 );

    ObjMultiSet( {
      { "spr_deploy_inv_oldalbum_page_1",    { alp = 0 } },
      { "anm_deploy_inv_oldalbum_page_up1",  { alp = 1 } },
    } );

    AnimPlay( "anm_deploy_inv_oldalbum_page_up1", "page_up1", func_end )

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_oldalbum_3 ()
    
    cmn.CallEventHandler( "clk_oldalbum_3_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_oldalbum_3" );
      cmn.CallEventHandler( "clk_oldalbum_3_end", "inv_oldalbum" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page", 0, "", 0 );

    ObjMultiSet( {
      { "spr_deploy_inv_oldalbum_page_3",   { alp = 0 } }, 
      { "spr_deploy_inv_oldalbum_tie",      { alp = 0 } }, 
      { "spr_deploy_inv_oldalbum_ribbon",   { alp = 0 } }, 
      { "spr_deploy_inv_oldalbum_pince_nez",{ alp = 0 } }, 
      { "anm_deploy_inv_oldalbum_page_up2", { alp = 1 } },
    } );

    AnimPlay( "anm_deploy_inv_oldalbum_page_up2", "page_up2", func_end );

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_oldalbum_4 ()
    
    cmn.CallEventHandler( "clk_oldalbum_4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_oldalbum_4" );
      cmn.CallEventHandler( "clk_oldalbum_4_end", "inv_oldalbum" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page", 0, "", 0 );

    ObjMultiSet( {
      { "spr_deploy_inv_oldalbum_page_5",   { alp = 0 } }, 
      { "anm_deploy_inv_oldalbum_page_up3", { alp = 1 } },
    } );

    AnimPlay( "anm_deploy_inv_oldalbum_page_up3", "page_up3", func_end )

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_oldalbum_5 ()
    
    cmn.CallEventHandler( "clk_oldalbum_5_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_oldalbum_5" );
      cmn.CallEventHandler( "clk_oldalbum_5_end", "inv_oldalbum" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page", 0, "", 0 );

    ObjMultiSet( {
      { "spr_deploy_inv_oldalbum_page_7",    { alp = 0 } },
      { "spr_deploy_inv_oldalbum_fireiron",  { alp = 0 } }, 
      { "spr_deploy_inv_oldalbum_vineglass", { alp = 0 } }, 
      { "spr_deploy_inv_oldalbum_photo",     { alp = 0 } },  
      { "anm_deploy_inv_oldalbum_page_up4",  { alp = 1 } },
    } );

    AnimPlay( "anm_deploy_inv_oldalbum_page_up4", "page_up4", func_end )

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_oldalbum_6 ()
    
    cmn.CallEventHandler( "clk_oldalbum_6_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_oldalbum_6" );
      cmn.CallEventHandler( "clk_oldalbum_6_end", "inv_oldalbum" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page", 0, "", 0 );

    ObjMultiSet( {
      { "spr_deploy_inv_oldalbum_page_9",   { alp = 0 } }, 
      { "anm_deploy_inv_oldalbum_page_up5", { alp = 1 } },
    } );

    AnimPlay( "anm_deploy_inv_oldalbum_page_up5", "page_up5", func_end )

  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_hotelsign ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_hotelsign" );
    cmn.CallEventHandler( "get_hotelsign", "inv_oldalbum" );
    common_impl.HideDeployInv();

  end;

--*********************************************************************************************************************
-- function *** collar *** () end;
--*********************************************************************************************************************
  function private.collar_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_collar_diamond",       { event_mdown = private.get_diamond } },
    } );
    
    --------------------------------------------------------------------------------------------
    -- function get_diamond () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_diamond" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_collar_diamond",
        room = "int_deploy_inv",
        zz = "deploy_inv_collar",
        zz_gate = "inv_collar"
      };
      local get_diamond_inv = function ()

        interface.InventoryItemRemove( "inv_collar" );
        interface.InventoryItemAdd( "inv_diamond", "spr_deploy_inv_collar_diamond" );

      end;
      local get_diamond = function ()

        ObjDelete( "gfx_deploy_inv_collar_diamond" );

      end;
      cmn.AddSubscriber( "get_diamond", get_diamond_inv );
      cmn.AddSubscriber( "get_diamond", get_diamond, "inv_collar" );
      
  end;
      
  -- GET ------------------------------------------------------------------------------------------
  function private.get_diamond ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_diamond" );
    cmn.CallEventHandler( "get_diamond", "inv_collar" );
    common_impl.HideDeployInv();

  end;
  
--*********************************************************************************************************************
-- function *** firstaidkit *** () end;
--*********************************************************************************************************************
  function private.firstaidkit_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_firstaidkit_cutters",         { event_mdown = private.get_cutters     } },
      { "spr_deploy_inv_firstaidkit_salammoniac",     { event_mdown = private.get_salammoniac } },

      { "obj_deploy_inv_firstaidkit_clk_cross_1",     { event_mdown = private.clk_cross_1     } },
      { "obj_deploy_inv_firstaidkit_clk_cross_2",     { event_mdown = private.clk_cross_2     } },

      { "obj_deploy_inv_firstaidkit_use_cross_1",     { event_mdown = private.AnimUseCross1   } },
      { "obj_deploy_inv_firstaidkit_use_cross_2",     { event_mdown = private.AnimUseCross2   } },
    } );

    --------------------------------------------------------------------------------------------
    -- function use_cross_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_cross_1" ] = {
        type = "use",
        inv_obj = "inv_cross_1",
        use_place = "obj_deploy_inv_firstaidkit_use_cross_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
      };    
      function use_cross_1_beg ()
        
        interface.InventoryItemRemove( "inv_cross_1" );
        ObjDelete( "obj_deploy_inv_firstaidkit_use_cross_1" );
      
      end;
      function use_cross_1_end ()

        ObjMultiSet( {
          { "spr_deploy_inv_firstaidkit_ajar_1st_top", { alp = 1 } },
          { "obj_deploy_inv_firstaidkit_clk_cross_1",  { input = true, active = true, visible = true } },
        } );
        ObjDelete( "spr_deploy_inv_firstaidkit_first_aid_closed_1" )
        
      end;

      cmn.AddSubscriber( "use_cross_1", use_cross_1_beg );
      cmn.AddSubscriber( "use_cross_1", use_cross_1_end, "inv_firstaidkit" );
      cmn.AddSubscriber( "use_cross_1_beg", use_cross_1_beg );
      cmn.AddSubscriber( "use_cross_1_end", use_cross_1_end, "inv_firstaidkit" );   
    --------------------------------------------------------------------------------------------
    -- function clk_cross_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_cross_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_firstaidkit_clk_cross_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
      };
      
      local clk_cross_1_beg = function ()

        ObjDelete( "obj_deploy_inv_firstaidkit_clk_cross_1" );
      
      end;
      local clk_cross_1_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_firstaidkit_cutters",          {  input = true } },
          { "gfx_deploy_inv_firstaidkit_cutters",          { active = true } },
          { "spr_deploy_inv_firstaidkit_first_aid_open_1", {    alp = 1    } },
        } );
        ObjDelete( "spr_deploy_inv_firstaidkit_ajar_1st_top" )
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_cross_1",     clk_cross_1_beg );
      cmn.AddSubscriber( "clk_cross_1",     clk_cross_1_end, "inv_firstaidkit" );
      cmn.AddSubscriber( "clk_cross_1_beg", clk_cross_1_beg );
      cmn.AddSubscriber( "clk_cross_1_end", clk_cross_1_end, "inv_firstaidkit" ); 

    --------------------------------------------------------------------------------------------
    -- function get_cutters () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_cutters" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_firstaidkit_cutters",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
      };
      local get_cutters_inv = function ()
      
        interface.InventoryItemAdd( "inv_cutters", "spr_deploy_inv_firstaidkit_cutters" );
        cmn.SetInvPlusRGB( "firstaidkit", false );

      end;
      local get_cutters = function ()

        ObjDelete( "gfx_deploy_inv_firstaidkit_cutters" );

      end;
      cmn.AddSubscriber( "get_cutters", get_cutters_inv );
      cmn.AddSubscriber( "get_cutters", get_cutters, "inv_firstaidkit" );
      
    --------------------------------------------------------------------------------------------
    -- function use_cross_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_cross_2" ] = {
        type = "use",
        inv_obj = "inv_cross_2",
        use_place = "obj_deploy_inv_firstaidkit_use_cross_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
      };    
      function use_cross_2_beg ()
        
        interface.InventoryItemRemove( "inv_cross_2" );
        ObjDelete( "obj_deploy_inv_firstaidkit_use_cross_2" );
      
      end;
      function use_cross_2_end ()

        ObjMultiSet( {
          { "spr_deploy_inv_firstaidkit_ajar_2nd_top", { alp = 1 } },
          { "obj_deploy_inv_firstaidkit_clk_cross_2",  { input = true, active = true, visible = true } },
        } );
        ObjDelete( "spr_deploy_inv_firstaidkit_first_aid_closed_2" )
        
      end;
      cmn.AddSubscriber( "use_cross_2", use_cross_2_beg );
      cmn.AddSubscriber( "use_cross_2", use_cross_2_end, "inv_firstaidkit" );
      cmn.AddSubscriber( "use_cross_2_beg", use_cross_2_beg );
      cmn.AddSubscriber( "use_cross_2_end", use_cross_2_end, "inv_firstaidkit" ); 
    
    --------------------------------------------------------------------------------------------
    -- function clk_cross_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_cross_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_firstaidkit_clk_cross_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
      };
      
      local clk_cross_2_beg = function ()

        ObjDelete( "obj_deploy_inv_firstaidkit_clk_cross_2" );
      
      end;
      local clk_cross_2_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_firstaidkit_salammoniac",      {  input = true } },
          { "gfx_deploy_inv_firstaidkit_salammoniac",      { active = true } },
          { "spr_deploy_inv_firstaidkit_first_aid_open_2", {    alp = 1    } },
        } );
        ObjDelete( "spr_deploy_inv_firstaidkit_ajar_2nd_top" )
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_cross_2",     clk_cross_2_beg );
      cmn.AddSubscriber( "clk_cross_2",     clk_cross_2_end, "inv_firstaidkit" );
      cmn.AddSubscriber( "clk_cross_2_beg", clk_cross_2_beg );
      cmn.AddSubscriber( "clk_cross_2_end", clk_cross_2_end, "inv_firstaidkit" ); 

    --------------------------------------------------------------------------------------------
    -- function get_salammoniac () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_salammoniac" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_firstaidkit_salammoniac",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
      };
      local get_salammoniac_inv = function ()
      
        interface.InventoryItemRemove( "inv_firstaidkit" );
        interface.InventoryItemAdd( "inv_salammoniac", "spr_deploy_inv_firstaidkit_salammoniac" );

      end;
      local get_salammoniac = function ()

        ObjDelete( "gfx_deploy_inv_firstaidkit_salammoniac" );

      end;
      cmn.AddSubscriber( "get_salammoniac", get_salammoniac_inv );
      cmn.AddSubscriber( "get_salammoniac", get_salammoniac, "inv_firstaidkit" );      
      
  end;

  -- USE ---------------------------------------------------------------------------------------
  function public.use_cross_1 ()

    local item = "inv_cross_1";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_firstaidkit_use_cross_1" ) then

      cmn.CallEventHandler( "use_cross_1_beg" );

      local func_end = function ()
        
        local func_end_2 = function ()

          cmn.Lock( false );
          cmn.SetEventDone( "use_cross_1" );
          cmn.CallEventHandler( "use_cross_1_end", "inv_firstaidkit" );

        end;
        
        ObjAnimate( "spr_deploy_inv_firstaidkit_first_aid_closed_1", "alp", 0, 0, func_end_2, { 0, 0, 1,  0.3, 0, 0 } );
        ObjAnimate( "spr_deploy_inv_firstaidkit_ajar_1st_top",       "alp", 0, 0,         "", { 0, 0, 0,  0.3, 0, 1 } );

      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level1/sfx/aud_use_cross_1" );

      cmn.ItemFly( "spr_deploy_inv_firstaidkit_key_red", func_end, 1.5 );
      
      return true; 

    end;

    return false;

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_cross_1 ()
    
    cmn.CallEventHandler( "clk_cross_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_cross_1" );
      cmn.CallEventHandler( "clk_cross_1_end", "inv_firstaidkit" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_cross_1", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_firstaidkit_ajar_1st_top",     "alp", 0, 0, func_end, { 0, 0, 1,  0.3, 0, 0 } );
    ObjAnimate( "spr_deploy_inv_firstaidkit_first_aid_open_1", "alp", 0, 0,       "", { 0, 0, 0,  0.3, 0, 1 } );

  end; 

  -- GET ------------------------------------------------------------------------------------------
  function private.get_cutters ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_cutters" );
    cmn.CallEventHandler( "get_cutters", "inv_firstaidkit" );
    --common_impl.HideDeployInv();

  end;
  
  -- USE ---------------------------------------------------------------------------------------
  function public.use_cross_2 ()

    local item = "inv_cross_2";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_firstaidkit_use_cross_2" ) then

      cmn.CallEventHandler( "use_cross_2_beg" );

      local func_end = function ()
 
        local func_end_2 = function ()
       
          cmn.Lock( false );
          cmn.SetEventDone( "use_cross_2" );
          cmn.CallEventHandler( "use_cross_2_end", "inv_firstaidkit" );

        end;
        
        ObjAnimate( "spr_deploy_inv_firstaidkit_first_aid_closed_2", "alp", 0, 0, func_end_2, { 0, 0, 1,  0.3, 0, 0 } );
        ObjAnimate( "spr_deploy_inv_firstaidkit_ajar_2nd_top",       "alp", 0, 0,         "", { 0, 0, 0,  0.3, 0, 1 } );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level1/sfx/aud_use_cross_1" );

      cmn.ItemFly( "spr_deploy_inv_firstaidkit_key_blue", func_end, 1.5 );
      
      return true; 

    end;

    return false;

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_cross_2 ()
    
    cmn.CallEventHandler( "clk_cross_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_cross_2" );
      cmn.CallEventHandler( "clk_cross_2_end", "inv_firstaidkit" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_cross_1", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_firstaidkit_ajar_2nd_top",     "alp", 0, 0, func_end, { 0, 0, 1,  0.3, 0, 0 } );
    ObjAnimate( "spr_deploy_inv_firstaidkit_first_aid_open_2", "alp", 0, 0,       "", { 0, 0, 0,  0.3, 0, 1 } );

  end; 

  -- GET ------------------------------------------------------------------------------------------
  function private.get_salammoniac ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_salammoniac" );
    cmn.CallEventHandler( "get_salammoniac", "inv_firstaidkit" );
    common_impl.HideDeployInv();

  end;
    
  -- CLK HH ------------------------------------------------------------------------------------------
  function private.AnimUseCross1 ()
  
    local func_end = function ()
    
      cmn.Lock( false );
      common_impl.ShowBbt( 'bbt_deploy_inv_firstaidkit_use_cross_1' );
    
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_cross_1", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_firstaidkit_first_aid_closed_1", "scale_xy", 0, 1, func_end, { 
      0.0, 0,    1,    1,   
      0.3, 3, 1.01, 1.01,   
      0.6, 3,    1,    1,
    } );

  end;

  -- CLK HH ------------------------------------------------------------------------------------------
  function private.AnimUseCross2 ()
  
    local func_end = function ()
    
      cmn.Lock( false );
      common_impl.ShowBbt( 'bbt_deploy_inv_firstaidkit_use_cross_2' );
    
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_cross_2", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_firstaidkit_first_aid_closed_2", "scale_xy", 0, 1, func_end, { 
      0.0, 0,    1,    1,   
      0.3, 3, 1.01, 1.01,   
      0.6, 3,    1,    1, 
    } );

  end;

--*********************************************************************************************************************
-- function *** woodendoll *** () end;
--*********************************************************************************************************************
  function private.woodendoll_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_woodendoll_selfmadepen",         { event_mdown = private.get_selfmadepen } },
      { "obj_spr_deploy_inv_woodendoll_clk_selfmadepen", { event_mdown = private.clk_selfmadepen } },
    } );

    --------------------------------------------------------------------------------------------
    -- function clk_selfmadepen () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_selfmadepen" ] = {
        type = "click",
        use_place = "obj_spr_deploy_inv_woodendoll_clk_selfmadepen",
        room = "int_deploy_inv",
        zz = "deploy_inv_woodendoll",
        zz_gate = "inv_woodendoll"
      };
      
      local clk_selfmadepen_beg = function ()

        ObjDelete( "obj_spr_deploy_inv_woodendoll_clk_selfmadepen" );
      
      end;
      local clk_selfmadepen_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_woodendoll_selfmadepen", {  input = true } },
          { "gfx_deploy_inv_woodendoll_selfmadepen", { active = true } },
        } );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_selfmadepen",     clk_selfmadepen_beg );
      cmn.AddSubscriber( "clk_selfmadepen",     clk_selfmadepen_end, "inv_woodendoll" );
      cmn.AddSubscriber( "clk_selfmadepen_beg", clk_selfmadepen_beg );
      cmn.AddSubscriber( "clk_selfmadepen_end", clk_selfmadepen_end, "inv_woodendoll" ); 

    --------------------------------------------------------------------------------------------
    -- function get_selfmadepen () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_selfmadepen" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_woodendoll_selfmadepen",
        room = "int_deploy_inv",
        zz = "deploy_inv_woodendoll",
        zz_gate = "inv_woodendoll"
      };
      local get_selfmadepen_inv = function ()

        interface.InventoryItemRemove( "inv_woodendoll" );
        interface.InventoryItemAdd( "inv_selfmadepen", "spr_deploy_inv_woodendoll_selfmadepen" );

      end;
      local get_selfmadepen = function ()

        ObjDelete( "gfx_deploy_inv_woodendoll_selfmadepen"      );

      end;
      cmn.AddSubscriber( "get_selfmadepen", get_selfmadepen_inv );
      cmn.AddSubscriber( "get_selfmadepen", get_selfmadepen, "inv_woodendoll" );
      
  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_selfmadepen ()
    
    cmn.CallEventHandler( "clk_selfmadepen_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_selfmadepen" );
      cmn.CallEventHandler( "clk_selfmadepen_end", "inv_woodendoll" ); 
      
      private.get_selfmadepen();

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_doll1", 0, "", 0 );

    local param = ObjGet( "spr_deploy_inv_woodendoll_selfmadepen" );
    
    AnimPlay( "anm_deploy_inv_woodendoll_wooden_hand", "hand", func_end );

  end; 
 
  -- GET ------------------------------------------------------------------------------------------
  function private.get_selfmadepen ()

    cmn.Lock( false );

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_selfmadepen" );
    cmn.CallEventHandler( "get_selfmadepen", "inv_woodendoll" );
    common_impl.HideDeployInv();

  end;
  

--*********************************************************************************************************************
-- function *** metalbeams *** () end;
--*********************************************************************************************************************
  function private.metalbeams_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_metalbeams_ropeladder", { event_mdown = private.get_ropeladder } },

      { "obj_deploy_inv_metalbeams_clk_beams",  { event_mdown = private.clk_beams      } },
      { "obj_deploy_inv_metalbeams_clk_rope_1", { event_mdown = private.clk_rope_1     } },
      { "obj_deploy_inv_metalbeams_clk_rope_2", { event_mdown = private.clk_rope_2     } },
      { "obj_deploy_inv_metalbeams_clk_rope_3", { event_mdown = private.clk_rope_3     } },
      { "obj_deploy_inv_metalbeams_clk_rope_4", { event_mdown = private.clk_rope_4     } },
    } );

    --------------------------------------------------------------------------------------------
    -- function clk_beams () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_beams" ] = {
        type = "click",
        use_place = "obj_deploy_inv_metalbeams_clk_beams",
        room = "int_deploy_inv",
        zz = "deploy_inv_metalbeams",
        zz_gate = "inv_metalbeams"
      };
      
      local clk_beams_beg = function ()

        ObjDelete( "obj_deploy_inv_metalbeams_clk_beams" );
      
      end;
      local clk_beams_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_metalbeams_use_rope",     { input = true, active = true, visible = true } },
          { "spr_deploy_inv_metalbeams_beams_stairs", {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_metalbeams_beams" )
      
      end;
      local clk_beams_inv = function ()
        
        if ( not cmn.IsEventDone( "get_rope" ) ) then
          
          cmn.SetInvPlusRGB( "metalbeams", false );
          
        end;
        
      end;      
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_beams",     clk_beams_beg );
      cmn.AddSubscriber( "clk_beams",     clk_beams_end, "inv_metalbeams" );
      cmn.AddSubscriber( "clk_beams_beg", clk_beams_beg );
      cmn.AddSubscriber( "clk_beams_end", clk_beams_end, "inv_metalbeams" ); 
      cmn.AddSubscriber( "clk_beams",     clk_beams_inv );
      cmn.AddSubscriber( "clk_beams_inv", clk_beams_inv );

    --------------------------------------------------------------------------------------------
    -- function use_rope () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_rope" ] = {
        type = "use",
        inv_obj = "inv_rope",
        use_place = "obj_deploy_inv_metalbeams_use_rope",
        room = "int_deploy_inv",
        zz = "deploy_inv_metalbeams",
        zz_gate = "inv_metalbeams"
      };    
      function use_rope_beg ()
        
        interface.InventoryItemRemove( "inv_rope" );
        ObjDelete( "obj_deploy_inv_metalbeams_use_rope" );
      
      end;
      function use_rope_end ()

        ObjMultiSet( {
          { "obj_deploy_inv_metalbeams_clk_rope_1",   { input = true, active = true, visible = true } },
          { "spr_deploy_inv_metalbeams_rope_stairs1", {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_metalbeams_beams_stairs" )
        
      end;
      cmn.AddSubscriber( "use_rope", use_rope_beg );
      cmn.AddSubscriber( "use_rope", use_rope_end, "inv_metalbeams" );
      cmn.AddSubscriber( "use_rope_beg", use_rope_beg );
      cmn.AddSubscriber( "use_rope_end", use_rope_end, "inv_metalbeams" );   
    
    --------------------------------------------------------------------------------------------
    -- function clk_rope_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_rope_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_metalbeams_clk_rope_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_metalbeams",
        zz_gate = "inv_metalbeams"
      };
      
      local clk_rope_1_beg = function ()

        ObjDelete( "obj_deploy_inv_metalbeams_clk_rope_1" );
      
      end;
      local clk_rope_1_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_metalbeams_clk_rope_2",   { input = true, active = true, visible = true } },
          { "spr_deploy_inv_metalbeams_rope_stairs2", {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_metalbeams_rope_stairs1" )
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_rope_1",     clk_rope_1_beg );
      cmn.AddSubscriber( "clk_rope_1",     clk_rope_1_end, "inv_metalbeams" );
      cmn.AddSubscriber( "clk_rope_1_beg", clk_rope_1_beg );
      cmn.AddSubscriber( "clk_rope_1_end", clk_rope_1_end, "inv_metalbeams" ); 

    --------------------------------------------------------------------------------------------
    -- function clk_rope_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_rope_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_metalbeams_clk_rope_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_metalbeams",
        zz_gate = "inv_metalbeams"
      };
      
      local clk_rope_2_beg = function ()

        ObjDelete( "obj_deploy_inv_metalbeams_clk_rope_2" );
      
      end;
      local clk_rope_2_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_metalbeams_clk_rope_3",   { input = true, active = true, visible = true } },
          { "spr_deploy_inv_metalbeams_rope_stairs3", {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_metalbeams_rope_stairs2" )
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_rope_2",     clk_rope_2_beg );
      cmn.AddSubscriber( "clk_rope_2",     clk_rope_2_end, "inv_metalbeams" );
      cmn.AddSubscriber( "clk_rope_2_beg", clk_rope_2_beg );
      cmn.AddSubscriber( "clk_rope_2_end", clk_rope_2_end, "inv_metalbeams" ); 

    --------------------------------------------------------------------------------------------
    -- function clk_rope_3 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_rope_3" ] = {
        type = "click",
        use_place = "obj_deploy_inv_metalbeams_clk_rope_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_metalbeams",
        zz_gate = "inv_metalbeams"
      };
      
      local clk_rope_3_beg = function ()

        ObjDelete( "obj_deploy_inv_metalbeams_clk_rope_3" );
      
      end;
      local clk_rope_3_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_metalbeams_clk_rope_4",   { input = true, active = true, visible = true } },
          { "spr_deploy_inv_metalbeams_rope_stairs4", {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_metalbeams_rope_stairs3" )
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_rope_3",     clk_rope_3_beg );
      cmn.AddSubscriber( "clk_rope_3",     clk_rope_3_end, "inv_metalbeams" );
      cmn.AddSubscriber( "clk_rope_3_beg", clk_rope_3_beg );
      cmn.AddSubscriber( "clk_rope_3_end", clk_rope_3_end, "inv_metalbeams" ); 

    --------------------------------------------------------------------------------------------
    -- function clk_rope_4 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_rope_4" ] = {
        type = "click",
        use_place = "obj_deploy_inv_metalbeams_clk_rope_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_metalbeams",
        zz_gate = "inv_metalbeams"
      };
      
      local clk_rope_4_beg = function ()

        ObjDelete( "obj_deploy_inv_metalbeams_clk_rope_4" );
      
      end;
      local clk_rope_4_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_metalbeams_ropeladder", { alp = 1, input = true } },
          { "gfx_deploy_inv_metalbeams_ropeladder", {         active = true } },
        } );
        ObjDelete( "spr_deploy_inv_metalbeams_rope_stairs4" )
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_rope_4",     clk_rope_4_beg );
      cmn.AddSubscriber( "clk_rope_4",     clk_rope_4_end, "inv_metalbeams" );
      cmn.AddSubscriber( "clk_rope_4_beg", clk_rope_4_beg );
      cmn.AddSubscriber( "clk_rope_4_end", clk_rope_4_end, "inv_metalbeams" ); 

    --------------------------------------------------------------------------------------------
    -- function get_ropeladder () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_ropeladder" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_metalbeams_ropeladder",
        room = "int_deploy_inv",
        zz = "deploy_inv_metalbeams",
        zz_gate = "inv_metalbeams"
      };
      local get_ropeladder_inv = function ()
      
        interface.InventoryItemRemove( "inv_metalbeams" );
        interface.InventoryItemAdd( "inv_ropeladder", "spr_deploy_inv_metalbeams_ropeladder" );

      end;
      local get_ropeladder = function ()

        ObjDelete( "gfx_deploy_inv_metalbeams_ropeladder" );

      end;
      cmn.AddSubscriber( "get_ropeladder", get_ropeladder_inv );
      cmn.AddSubscriber( "get_ropeladder", get_ropeladder, "inv_metalbeams" );
      
  end;


  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_beams ()
    
    cmn.CallEventHandler( "clk_beams_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_beams" );
      cmn.CallEventHandler( "clk_beams_end", "inv_metalbeams" ); 
      cmn.CallEventHandler( "clk_beams_inv" );

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_bars", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_inv_metalbeams_beams",        "alp", 0, 0, func_end, { 0, 0, 1,  0.3, 0, 0 } );
    ObjAnimate( "spr_deploy_inv_metalbeams_beams_stairs", "alp", 0, 0,       "", { 0, 0, 0,  0.3, 0, 1 } );
    
  end; 

  -- USE ---------------------------------------------------------------------------------------
  function public.use_rope ()

    local item = "inv_rope";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_metalbeams_use_rope" ) and cmn.IsEventDone( "clk_beams" ) then

      cmn.CallEventHandler( "use_rope_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_rope" );
        cmn.CallEventHandler( "use_rope_end", "inv_metalbeams" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level1/sfx/aud_use_rope" );

      func_end(); 
      
      return true; 

    end;

    return false;

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_rope_1 ()
    
    cmn.CallEventHandler( "clk_rope_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_rope_1" );
      cmn.CallEventHandler( "clk_rope_1_end", "inv_metalbeams" ); 
     
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_rope2", 0, "", 0 );

    --ObjAnimate( "spr_deploy_inv_metalbeams_rope_stairs1", "alp", 0, 0, func_end, { 0, 0, 1,  0.3, 0, 0 } );
    --ObjAnimate( "spr_deploy_inv_metalbeams_rope_stairs2", "alp", 0, 0,       "", { 0, 0, 0,  0.3, 0, 1 } );

    func_end();    

  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_rope_2 ()
    
    cmn.CallEventHandler( "clk_rope_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_rope_2" );
      cmn.CallEventHandler( "clk_rope_2_end", "inv_metalbeams" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_rope2", 0, "", 0 );

    --ObjAnimate( "spr_deploy_inv_metalbeams_rope_stairs2", "alp", 0, 0, func_end, { 0, 0, 1,  0.3, 0, 0 } );
    --ObjAnimate( "spr_deploy_inv_metalbeams_rope_stairs3", "alp", 0, 0,       "", { 0, 0, 0,  0.3, 0, 1 } );

    func_end();       

  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_rope_3 ()
    
    cmn.CallEventHandler( "clk_rope_3_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_rope_3" );
      cmn.CallEventHandler( "clk_rope_3_end", "inv_metalbeams" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_rope2", 0, "", 0 );

    --ObjAnimate( "spr_deploy_inv_metalbeams_rope_stairs3", "alp", 0, 0, func_end, { 0, 0, 1,  0.3, 0, 0 } );
    --ObjAnimate( "spr_deploy_inv_metalbeams_rope_stairs4", "alp", 0, 0,       "", { 0, 0, 0,  0.3, 0, 1 } );

    func_end(); 
    
  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_rope_4 ()
    
    cmn.CallEventHandler( "clk_rope_4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_rope_4" );
      cmn.CallEventHandler( "clk_rope_4_end", "inv_metalbeams" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_rope2", 0, "", 0 );

    --ObjAnimate( "spr_deploy_inv_metalbeams_rope_stairs4", "alp", 0, 0, func_end, { 0, 0, 1,  0.3, 0, 0 } );
    --ObjAnimate( "spr_deploy_inv_metalbeams_ropeladder",   "alp", 0, 0,       "", { 0, 0, 0,  0.3, 0, 1 } );
 
    func_end(); 
     
  end; 

  -- GET ------------------------------------------------------------------------------------------
  function private.get_ropeladder ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_ropeladder" );
    cmn.CallEventHandler( "get_ropeladder", "inv_metalbeams" );
    common_impl.HideDeployInv();

  end;
  
  
--*********************************************************************************************************************
-- function *** stick *** () end;
--*********************************************************************************************************************
  function private.stick_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_stick_stickwithhook", { event_mdown = private.get_stickwithhook } },

      { "obj_deploy_inv_stick_clk_stick_1",   { event_mdown = private.clk_stick_1       } },
      { "obj_deploy_inv_stick_clk_stick_2",   { event_mdown = private.clk_stick_2       } },
    } );

    --------------------------------------------------------------------------------------------
    -- function clk_stick_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_stick_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_stick_clk_stick_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_stick",
        zz_gate = "inv_stick"
      };
      
      local clk_stick_1_beg = function ()

        ObjDelete( "obj_deploy_inv_stick_clk_stick_1" );
      
      end;
      local clk_stick_1_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_stick_clk_stick_2", { input = true, active = true, visible = true } },
        } );
        ObjDelete( "spr_deploy_inv_stick_rope" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_stick_1",     clk_stick_1_beg              );
      cmn.AddSubscriber( "clk_stick_1",     clk_stick_1_end, "inv_stick" );
      cmn.AddSubscriber( "clk_stick_1_beg", clk_stick_1_beg              );
      cmn.AddSubscriber( "clk_stick_1_end", clk_stick_1_end, "inv_stick" );

    --------------------------------------------------------------------------------------------
    -- function clk_stick_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_stick_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_stick_clk_stick_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_stick",
        zz_gate = "inv_stick"
      };
      
      local clk_stick_2_beg = function ()

        ObjDelete( "obj_deploy_inv_stick_clk_stick_2" );
      
      end;
      local clk_stick_2_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_stick_use_hook", { input = true, active = true, visible = true } },
        } );
        ObjDelete( "spr_deploy_inv_stick_branches" );
      
      end;
      local clk_stick_2_inv = function ()
        
        if ( not cmn.IsEventDone( "get_hook" ) ) then
          
          cmn.SetInvPlusRGB( "stick", false );
          
        end;
        
        ObjSet( "inv_stick", { res = "assets/levels/level1/inv_deploy/inv_stick/inv/inv_stickwithhook_2" }  )
        
      end;      
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_stick_2",     clk_stick_2_beg              );
      cmn.AddSubscriber( "clk_stick_2",     clk_stick_2_end, "inv_stick" );
      cmn.AddSubscriber( "clk_stick_2_beg", clk_stick_2_beg              );
      cmn.AddSubscriber( "clk_stick_2_end", clk_stick_2_end, "inv_stick" );
      cmn.AddSubscriber( "clk_stick_2",     clk_stick_2_inv              );
      cmn.AddSubscriber( "clk_stick_2_inv", clk_stick_2_inv              );
      
    --------------------------------------------------------------------------------------------
    -- function use_hook () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_hook" ] = {
        type = "use",
        inv_obj = "inv_hook",
        use_place = "obj_deploy_inv_stick_use_hook",
        room = "int_deploy_inv",
        zz = "deploy_inv_stick",
        zz_gate = "inv_stick"
      };    
      local use_hook_beg = function ()
        
        interface.InventoryItemRemove( "inv_hook" );
        ObjDelete( "obj_deploy_inv_stick_use_hook" );
      
      end;
      local use_hook_end = function ()

        ObjMultiSet( {
          { "spr_deploy_inv_stick_stickwithhook", {  input = true                         } },
          { "gfx_deploy_inv_stick_stickwithhook", { active = true                         } },
          { "spr_deploy_inv_stick_hook",          {    alp = 1, pos_x = 286, pos_y = -165 } },
        } );
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_hook",     use_hook_beg              );
      cmn.AddSubscriber( "use_hook",     use_hook_end, "inv_stick" );
      cmn.AddSubscriber( "use_hook_beg", use_hook_beg              );
      cmn.AddSubscriber( "use_hook_end", use_hook_end, "inv_stick" );   
    
    --------------------------------------------------------------------------------------------
    -- function get_stickwithhook () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_stickwithhook" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_stick_stickwithhook",
        room = "int_deploy_inv",
        zz = "deploy_inv_stick",
        zz_gate = "inv_stick"
      };
      local get_stickwithhook_inv = function ()
      
        interface.InventoryItemRemove( "inv_stick" );
        interface.InventoryItemAdd( "inv_stickwithhook", "spr_deploy_inv_stick_stickwithhook" );

      end;
      local get_stickwithhook = function ()

        ObjDelete( "gfx_deploy_inv_stick_stickwithhook" );

      end;
      cmn.AddSubscriber( "get_stickwithhook", get_stickwithhook_inv );
      cmn.AddSubscriber( "get_stickwithhook", get_stickwithhook, "inv_stick" );
      
  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_stick_1 ()
    
    cmn.CallEventHandler( "clk_stick_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_stick_1" );
      cmn.CallEventHandler( "clk_stick_1_end", "inv_stick" ); 
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_short", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_stick_rope", "alp", 0, 0, func_end, { 0.0,0, 1,  0.3,0, 0 } );
     
  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_stick_2 ()
    
    cmn.CallEventHandler( "clk_stick_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_stick_2" );
      cmn.CallEventHandler( "clk_stick_2_end", "inv_stick" ); 
      cmn.CallEventHandler( "clk_stick_2_inv" );

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_short", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_stick_branches", "pos_xy", 0, 0, func_end, { 
      0.0, 0, ObjGet( "spr_deploy_inv_stick_branches" ).pos_x, ObjGet( "spr_deploy_inv_stick_branches" ).pos_y,
      0.6, 0, -577, 334, 
    } );
    ObjAnimate( "spr_deploy_inv_stick_branches", "alp", 0, 0, "", { 
      0.0, 0, 1,
      0.3, 0, 1,
      0.6, 0, 0,
    } );
     
  end; 

  -- USE ---------------------------------------------------------------------------------------
  function public.use_hook ()

    local item = "inv_hook";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_stick_use_hook" ) and cmn.IsEventDone( "clk_stick_2" ) then

      cmn.CallEventHandler( "use_hook_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_hook" );
        cmn.CallEventHandler( "use_hook_end", "inv_stick" );
        
        common_impl.PlayAudio( "sfx","level1/sfx/aud_use_hook" );

      end;

      cmn.Lock( true );

      ObjAnimate( "spr_deploy_inv_stick_hook", "pos_xy", 0, 0, func_end, { 
        0.0, 0, ObjGet( "spr_deploy_inv_stick_hook" ).pos_x, ObjGet( "spr_deploy_inv_stick_hook" ).pos_y,
        0.3, 0, ObjGet( "spr_deploy_inv_stick_hook" ).pos_x, ObjGet( "spr_deploy_inv_stick_hook" ).pos_y,
        0.6, 0, 286, -165,
      } );
      ObjAnimate( "spr_deploy_inv_stick_hook", "alp", 0, 0, "", { 
        0.0, 0, 0,
        0.3, 0, 1,
        0.6, 0, 1,
      } );
      
      return true; 

    end;

    return false;

  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_stickwithhook ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_stickwithhook" );
    cmn.CallEventHandler( "get_stickwithhook", "inv_stick" );
    common_impl.HideDeployInv();

  end;
  
  
--*********************************************************************************************************************
-- function *** torchnobatteries *** () end;
--*********************************************************************************************************************
  function private.torchnobatteries_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_torchnobatteries_torch_2",         { event_mdown = private.get_torch_2 } },
      { "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_1", { event_mdown = private.clk_torchnobatteries_1 } },
      { "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_2", { event_mdown = private.clk_torchnobatteries_2 } },
      { "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_3", { event_mdown = private.clk_torchnobatteries_3 } },
      { "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_4", { event_mdown = private.clk_torchnobatteries_4 } },
      { "obj_deploy_inv_torchnobatteries_use_battery_1",   { event_mdown = function() private.TorchnobatteriesAnim( 1 ); end; } },
      { "obj_deploy_inv_torchnobatteries_use_battery_2",   { event_mdown = function() private.TorchnobatteriesAnim( 2 ); end; } },
        
    } );

    --------------------------------------------------------------------------------------------
    -- function use_battery_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_battery_1" ] = {
        type = "use",
        inv_obj = "inv_battery_1",
        use_place = "obj_deploy_inv_torchnobatteries_use_battery_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_torchnobatteries",
        zz_gate = "inv_torchnobatteries"
      };    
      function use_battery_1_beg ()
        
        interface.InventoryItemRemove( "inv_battery_1" );
        ObjDelete( "obj_deploy_inv_torchnobatteries_use_battery_1" );
      
      end;
      function use_battery_1_end ()
        
        if cmn.IsEventDone( "use_battery_2" ) then
          
          ObjMultiSet( { 
            { "spr_deploy_inv_torchnobatteries_battery_new_1",  { alp = 1, visible = true, pos_x = -28, pos_y = -20 } },
            { "spr_deploy_inv_torchnobatteries_battery_new_2",  { alp = 1, visible = true, pos_x = -143, pos_y = -62 } },
            { "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_3", { input = true } },
          } );
          
        else
          
          ObjMultiSet( { 
            { "spr_deploy_inv_torchnobatteries_battery_new_1",  { alp = 1, visible = true, pos_x = -28, pos_y = -20 } },
          } );
          
        end;
        
      end;
      function use_battery_1_inv ()
      
        if ( not cmn.IsEventDone( "get_battery_2" ) ) then
          
          cmn.SetInvPlusRGB( "torchnobatteries", false );

        end;
        
      end;     
      cmn.AddSubscriber( "use_battery_1", use_battery_1_beg );
      cmn.AddSubscriber( "use_battery_1", use_battery_1_end, "inv_torchnobatteries" );
      cmn.AddSubscriber( "use_battery_1_beg", use_battery_1_beg );
      cmn.AddSubscriber( "use_battery_1_end", use_battery_1_end, "inv_torchnobatteries" );   
      cmn.AddSubscriber( "use_battery_1", use_battery_1_inv );
      cmn.AddSubscriber( "use_battery_1_inv", use_battery_1_inv );
      
    --------------------------------------------------------------------------------------------
    -- function use_battery_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_battery_2" ] = {
        type = "use",
        inv_obj = "inv_battery_2",
        use_place = "obj_deploy_inv_torchnobatteries_use_battery_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_torchnobatteries",
        zz_gate = "inv_torchnobatteries"
      };    
      function use_battery_2_beg ()
        
        interface.InventoryItemRemove( "inv_battery_2" );
        ObjDelete( "obj_deploy_inv_torchnobatteries_use_battery_2" );
      
      end;
      function use_battery_2_end ()

        if cmn.IsEventDone( "use_battery_1" ) then
          
          ObjMultiSet( { 
            { "spr_deploy_inv_torchnobatteries_battery_new_1",  { alp = 1, visible = true, pos_x = -28, pos_y = -20 } },
            { "spr_deploy_inv_torchnobatteries_battery_new_2",  { alp = 1, visible = true, pos_x = -143, pos_y = -62 } },
            { "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_3", { input = true } },
          } );
          
        else
          
          ObjMultiSet( { 
            { "spr_deploy_inv_torchnobatteries_battery_new_1",  { alp = 1, visible = true, pos_x = -28, pos_y = -20 } },
          } );
          
        end;
        
      end;
      function use_battery_2_inv ()
      
        if ( not cmn.IsEventDone( "get_battery_1" ) ) then
          
          cmn.SetInvPlusRGB( "torchnobatteries", false );

        end;
        
      end;       
      cmn.AddSubscriber( "use_battery_2", use_battery_2_beg );
      cmn.AddSubscriber( "use_battery_2", use_battery_2_end, "inv_torchnobatteries" );
      cmn.AddSubscriber( "use_battery_2_beg", use_battery_2_beg );
      cmn.AddSubscriber( "use_battery_2_end", use_battery_2_end, "inv_torchnobatteries" );  
      cmn.AddSubscriber( "use_battery_2", use_battery_2_inv );
      cmn.AddSubscriber( "use_battery_2_inv", use_battery_2_inv );      
      
    --------------------------------------------------------------------------------------------
    -- function get_torch_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_torch_2" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_torchnobatteries_torch_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_torchnobatteries",
        zz_gate = "inv_torchnobatteries"
      };
      local get_torch_2_inv = function ()
      
        interface.InventoryItemRemove( "inv_torchnobatteries" );
        interface.InventoryItemAdd( "inv_torch_2", "spr_deploy_inv_torchnobatteries_torch_2" );

      end;
      local get_torch_2 = function ()

        ObjDelete( "gfx_deploy_inv_torchnobatteries_torch_2" );

      end;
      cmn.AddSubscriber( "get_torch_2", get_torch_2_inv );
      cmn.AddSubscriber( "get_torch_2", get_torch_2, "inv_torchnobatteries" );
      
    --------------------------------------------------------------------------------------------
    -- function clk_torchnobatteries_1 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_torchnobatteries_1" ] = {
      type = "click",
      use_place = "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_torchnobatteries",
      zz_gate = "inv_torchnobatteries"
    };
    
    local clk_torchnobatteries_1_beg = function ()

      ObjDelete( "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_1" );
    
    end;
    local clk_torchnobatteries_1_end = function ()
    
      ObjMultiSet( { 
        { "spr_deploy_inv_torchnobatteries_cover_patch",  { alp = 0 } },
        { "spr_deploy_inv_torchnobatteries_cover",  { pos_x = -451, pos_y = -195 } },
        { "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_2",  { input = true } },
      } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_torchnobatteries_1",     clk_torchnobatteries_1_beg );
    cmn.AddSubscriber( "clk_torchnobatteries_1",     clk_torchnobatteries_1_end, "inv_torchnobatteries" );
    cmn.AddSubscriber( "clk_torchnobatteries_1_beg", clk_torchnobatteries_1_beg );
    cmn.AddSubscriber( "clk_torchnobatteries_1_end", clk_torchnobatteries_1_end, "inv_torchnobatteries" ); 
    
    --------------------------------------------------------------------------------------------
    -- function clk_torchnobatteries_2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_torchnobatteries_2" ] = {
      type = "click",
      use_place = "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_torchnobatteries",
      zz_gate = "inv_torchnobatteries"
    };
    
    local clk_torchnobatteries_2_beg = function ()

      ObjDelete( "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_2" );
    
    end;
    local clk_torchnobatteries_2_end = function ()
    
      ObjDelete( "spr_deploy_inv_torchnobatteries_battery_old_1" );
      ObjDelete( "spr_deploy_inv_torchnobatteries_battery_old_2" );
      
      ObjMultiSet( { 
        { "obj_deploy_inv_torchnobatteries_use_battery_1",  { input = true } },
        { "obj_deploy_inv_torchnobatteries_use_battery_2",  { input = true } },
      } );
    
    end;
    local clk_torchnobatteries_2_inv = function ()
      
      if ( not cmn.IsEventDone( "get_battery_1" ) and
      not cmn.IsEventDone( "get_battery_2" ) ) then
        
        cmn.SetInvPlusRGB( "torchnobatteries", false );
        
      end;
      
    end;
    
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_torchnobatteries_2",     clk_torchnobatteries_2_beg );
    cmn.AddSubscriber( "clk_torchnobatteries_2",     clk_torchnobatteries_2_end, "inv_torchnobatteries" );
    cmn.AddSubscriber( "clk_torchnobatteries_2_beg", clk_torchnobatteries_2_beg );
    cmn.AddSubscriber( "clk_torchnobatteries_2_end", clk_torchnobatteries_2_end, "inv_torchnobatteries" ); 
    cmn.AddSubscriber( "clk_torchnobatteries_2", clk_torchnobatteries_2_inv );    
    cmn.AddSubscriber( "clk_torchnobatteries_2_inv", clk_torchnobatteries_2_inv );
    
    --------------------------------------------------------------------------------------------
    -- function clk_torchnobatteries_3 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_torchnobatteries_3" ] = {
      type = "click",
      use_place = "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_torchnobatteries",
      zz_gate = "inv_torchnobatteries"
    };
    
    local clk_torchnobatteries_3_beg = function ()

      ObjDelete( "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_3" );
    
    end;
    local clk_torchnobatteries_3_end = function ()
    
      ObjMultiSet( { 
        { "spr_deploy_inv_torchnobatteries_cover_patch",  { alp = 1 } },
        { "spr_deploy_inv_torchnobatteries_cover",  { pos_x = -215, pos_y = -98 } },
        { "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_4",  { input = true } },
      } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_torchnobatteries_3",     clk_torchnobatteries_3_beg );
    cmn.AddSubscriber( "clk_torchnobatteries_3",     clk_torchnobatteries_3_end, "inv_torchnobatteries" );
    cmn.AddSubscriber( "clk_torchnobatteries_3_beg", clk_torchnobatteries_3_beg );
    cmn.AddSubscriber( "clk_torchnobatteries_3_end", clk_torchnobatteries_3_end, "inv_torchnobatteries" );     
    
    --------------------------------------------------------------------------------------------
    -- function clk_torchnobatteries_4 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_torchnobatteries_4" ] = {
      type = "click",
      use_place = "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_4",
      room = "int_deploy_inv",
      zz = "deploy_inv_torchnobatteries",
      zz_gate = "inv_torchnobatteries"
    };
    
    local clk_torchnobatteries_4_beg = function ()

      ObjDelete( "obj_deploy_inv_torchnobatteries_clk_torchnobatteries_4" );
    
    end;
    local clk_torchnobatteries_4_end = function ()
    
      ObjMultiSet( { 
        { "spr_deploy_inv_torchnobatteries_light",  { alp = 1, visible = true } },
        { "spr_deploy_inv_torchnobatteries_button",  { pos_x = -12, pos_y = -65 } },
        { "spr_deploy_inv_torchnobatteries_torch_2",  { input = true } },
        { "gfx_deploy_inv_torchnobatteries_torch_2",  { active = true } },
      } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_torchnobatteries_4",     clk_torchnobatteries_4_beg );
    cmn.AddSubscriber( "clk_torchnobatteries_4",     clk_torchnobatteries_4_end, "inv_torchnobatteries" );
    cmn.AddSubscriber( "clk_torchnobatteries_4_beg", clk_torchnobatteries_4_beg );
    cmn.AddSubscriber( "clk_torchnobatteries_4_end", clk_torchnobatteries_4_end, "inv_torchnobatteries" );     
    
  end;

  -- USE ---------------------------------------------------------------------------------------
  function public.use_battery_1 ()
    
    local curBattery = "spr_deploy_inv_torchnobatteries_battery_new_1";
    local curPosition = { 
                          { pos_x = -351, pos_y = -153 },
                          { pos_x = -28, pos_y = -20 }
                        };
    
    if cmn.IsEventDone( "use_battery_2" ) then
      
      curBattery = "spr_deploy_inv_torchnobatteries_battery_new_2";
      curPosition = { 
                          { pos_x = -351, pos_y = -153 },
                          { pos_x = -143, pos_y = -62 }
                        };     
    end;

    local item = "inv_battery_1";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_torchnobatteries_use_battery_1" ) and
    cmn.IsEventDone( "clk_torchnobatteries_2" ) ) then

      cmn.CallEventHandler( "use_battery_1_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_battery_1" );
        cmn.CallEventHandler( "use_battery_1_end", "inv_torchnobatteries" );
        cmn.CallEventHandler( "use_battery_1_inv" );
        
      end;
      
      local func_end_2 = function ()
        
        ObjAnimate( curBattery, "pos_xy",0,0, func_end, { 0, 3, curPosition[1].pos_x, curPosition[1].pos_y,    
                                                        0.6, 3, curPosition[2].pos_x, curPosition[2].pos_y } );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level1/sfx/aud_use_battery" );

      cmn.ItemFly( curBattery, func_end_2, 3.67 );
      
      return true; 

    end;

    return false;

  end;
  
  -- USE ---------------------------------------------------------------------------------------
  function public.use_battery_2 ()
    
    local curBattery = "spr_deploy_inv_torchnobatteries_battery_new_1";
    local curPosition = { 
                          { pos_x = -351, pos_y = -153 },
                          { pos_x = -28, pos_y = -20 }
                        };
    
    if cmn.IsEventDone( "use_battery_1" ) then
      
      curBattery = "spr_deploy_inv_torchnobatteries_battery_new_2";
      curPosition = { 
                          { pos_x = -351, pos_y = -153 },
                          { pos_x = -143, pos_y = -62 }
                        };     
    end;
    
    local item = "inv_battery_2";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_torchnobatteries_use_battery_2" ) and
    cmn.IsEventDone( "clk_torchnobatteries_2" ) ) then

      cmn.CallEventHandler( "use_battery_2_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_battery_2" );
        cmn.CallEventHandler( "use_battery_2_end", "inv_torchnobatteries" );
        cmn.CallEventHandler( "use_battery_2_inv" );
        
      end;
      
      local func_end_2 = function ()
        
        ObjAnimate( curBattery, "pos_xy",0,0, func_end, { 0, 3, curPosition[1].pos_x, curPosition[1].pos_y,    
                                                        0.6, 3, curPosition[2].pos_x, curPosition[2].pos_y } );
        
      end;
      
      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level1/sfx/aud_use_battery" );

      cmn.ItemFly( curBattery, func_end_2, 3.67 );
      
      return true; 

    end;

    return false;

  end;  
  
  -- GET ------------------------------------------------------------------------------------------
  function private.get_torch_2 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_torch_2" );
    cmn.CallEventHandler( "get_torch_2", "inv_torchnobatteries" );
    common_impl.HideDeployInv();

  end;
  

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_torchnobatteries_1 ()
    
    cmn.CallEventHandler( "clk_torchnobatteries_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_torchnobatteries_1" );
      cmn.CallEventHandler( "clk_torchnobatteries_1_end", "inv_torchnobatteries" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_small_cover", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_inv_torchnobatteries_cover", "pos_xy",0,0, func_end, { 0, 3, -215, -98,    0.6, 3, -451, -195 } );
    ObjAnimate( "spr_deploy_inv_torchnobatteries_cover_patch", "alp",0,0, "", { 0, 0, 1,    0.2, 0, 0 } );
    
  end;

  
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_torchnobatteries_2 ()
    
    cmn.CallEventHandler( "clk_torchnobatteries_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_torchnobatteries_2" );
      cmn.CallEventHandler( "clk_torchnobatteries_2_end", "inv_torchnobatteries" ); 
      cmn.CallEventHandler( "clk_torchnobatteries_2_inv" );

    end;
    
    local func_end_2 = function ()
      
      ObjAnimate( "spr_deploy_inv_torchnobatteries_battery_old_1", "pos_xy",0,0, func_end, { 0, 3, -28, -20,    0.4, 3, -333, -152,    1.0, 3, -780, 103 } );
    
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_battery", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_inv_torchnobatteries_battery_old_2", "pos_xy",0,0, func_end_2, { 0, 3, -143, -62,    0.4, 3, -332, -148,    1.0, 3, -850, 201 } );
    
  end;
  
  
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_torchnobatteries_3 ()
    
    cmn.CallEventHandler( "clk_torchnobatteries_3_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_torchnobatteries_3" );
      cmn.CallEventHandler( "clk_torchnobatteries_3_end", "inv_torchnobatteries" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_small_cover", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_inv_torchnobatteries_cover", "pos_xy",0,0, func_end, { 0, 3, -451, -195,    0.6, 3, -215, -98 } );
    ObjAnimate( "spr_deploy_inv_torchnobatteries_cover_patch", "alp",0,0, "", { 0, 0, 0,    0.4, 0, 0,    0.6, 0, 1 } );
    
  end;
  

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_torchnobatteries_4 ()
    
    cmn.CallEventHandler( "clk_torchnobatteries_4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_torchnobatteries_4" );
      cmn.CallEventHandler( "clk_torchnobatteries_4_end", "inv_torchnobatteries" ); 

    end;
    
    local func_end_2 = function ()
      
      ObjSet( "spr_deploy_inv_torchnobatteries_light", { alp = 0, visible = true } );
      ObjAnimate( "spr_deploy_inv_torchnobatteries_light", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_flashlight2", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_inv_torchnobatteries_button", "pos_xy",0,0, func_end_2, { 0, 3, -32, -73,    0.3, 3, -12, -65 } );
    
  end;
  
  -- FEEDBACK ANIM ----------------------------------------------------------------------------------
  function private.TorchnobatteriesAnim ( id )
    
    common_impl.ShowBbt( "bbt_deploy_inv_torchnobatteries_use_battery_"..id );
    
    local func_end = function ()

      cmn.Lock( false );
      
    end;
        
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "aud_clk_xx", 0, "", 0 );
  
    ObjAnimate( "spr_deploy_inv_torchnobatteries_button", "pos_xy",0,0, func_end, { 0, 3, -32, -73,    0.2, 3, -12, -65,    0.4, 3, -32, -73 } );
    
  end;  
--*********************************************************************************************************************