-- name=rm_closedroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_closedroom";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_entrancedoor", "room_hub" );
  ObjAttach( "zz_sink", "room_hub" );
  ObjAttach( "zz_ventilationwindow", "room_hub" );
  ObjAttach( "zz_floorlamp", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  private.FloorlampLogicInit(); 

  private.audioRmClosedroom = false;
  
  ObjMultiSet({ 
    { "spr_entrancedoor_stone",               { event_mdown = private.get_stone                    }},
    { "obj_entrancedoor_use_lockpick",        { event_mdown = private.UseLockpick                  }},
    
    { "spr_sink_torch",                       { event_mdown = private.get_torch                    }},
    { "obj_sink_wire",                        { event_mdown = private.get_wire                     }},
    { "spr_sink_cork",                        { event_mdown = private.get_cork                     }},
    { "spr_sink_lionhead_1",                  { event_mdown = private.get_lionhead_1               }},
    { "spr_sink_room_313_key",                { event_mdown = private.get_room_313_key             }},
    { "spr_sink_tongs",                       { event_mdown = private.get_tongs                    }},
    { "obj_sink_use_corkscrew",               { event_mdown = private.UseCorkscrew                 }},
    { "obj_sink_use_screen",                  { event_mdown = private.UseScreen                    }},
    { "obj_sink_use_ornamental_chandelier",   { event_mdown = private.UseOrnamental                }},
    { "obj_sink_use_stone",                   { event_mdown = private.UseStone                     }},
    { "obj_sink_use_magnet",                  { event_mdown = private.UseMagnet                    }},
    { "obj_sink_see_scare",                   { event_mdown = private.see_sink_scare               }},
    
    { "spr_ventilationwindow_magnet",         { event_mdown = private.get_magnet                   }},
    { "spr_ventilationwindow_carvedamulet_1", { event_mdown = private.get_carvedamulet_1           }},
    { "spr_ventilationwindow_tinywire",       { event_mdown = private.get_tinywire                 }},
    { "spr_ventilationwindow_pallet",         { event_mdown = private.get_pallet                   }},
    { "obj_ventilationwindow_use_rubbertoy",  { event_mdown = private.UseRubbertoy                 }},
    { "obj_ventilationwindow_use_sharptooth", { event_mdown = private.UseSharptooth                }},
    { "obj_ventilationwindow_use_button",     { event_mdown = private.UseButton                    }},
    { "obj_ventilationwindow_clk_button",     { event_mdown = private.clk_ventilationwindow_button }},
    
    { "spr_floorlamp_button",                 { event_mdown = private.get_button                   }},
    
    { "obj_closedroom_clk_entrancedoor",      { event_mdown = private.see_closedroom_1             }},
    { "obj_closedroom_clk_crate_1",           { event_mdown = private.clk_closedroom_crate_1       }},
    { "obj_closedroom_clk_crate_2",           { event_mdown = private.clk_closedroom_crate_2       }},
    { "obj_entrancedoor_see_door",            { event_mdown = private.see_entrancedoor             }},
    { "obj_closedroom_see_destruction",       { event_mdown = private.see_closedroom_destruction   }},
    { "obj_closedroom_use_torch",             { event_mdown = private.UseTorch                     }},
    
    { "obj_floorlamp_clk_floorlamp_1",        { event_mdown = private.clk_floorlamp_1              }},
    { "obj_floorlamp_clk_floorlamp_2",        { event_mdown = private.clk_floorlamp_2              }},
    { "obj_floorlamp_use_tinywire",           { event_mdown = private.UseTinywire                  }},
    { "obj_floorlamp_use_eye",                { event_mdown = private.UseEye                       }},
    
    { "spr_closedroom_collect_morph_item",    { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_1" ); end } },
    { "spr_sink_collect2_item_2",             { event_mdown = private.get_collect2_item_2   } }, 
    
    { "spr_ventilationwindow_collect2_item_1",{ event_mdown = private.get_collect2_item_1   } },
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_closedroom = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
  local gates = 
  {
    "gho_closedroom_darkcorner",
    "gmg_closedroom_scaryhead",
    "gzz_closedroom_entrancedoor",
    "gzz_closedroom_sink",
    "gzz_closedroom_ventilationwindow",
    "gzz_closedroom_floorlamp"
  };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_entrancedoor",
      "zz_sink",
      "zz_ventilationwindow",
      "zz_floorlamp",
      "zz_sink_1",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_closedroom", update_game_mode_closedroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_closedroom = function ()

  local effects_table = 
  {
    "obj_closedroom_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_closedroom", update_performance_mode_closedroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_closedroom () end;
  --------------------------------------------------------------------------------------------
  local opn_closedroom_map = function ()

    common_impl.VisitMapRoom( "closedroom" );

  end;
  cmn.AddSubscriber( "opn_closedroom", opn_closedroom_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_stone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stone" ] = {
    type = "get",
    get_obj = "spr_entrancedoor_stone",
    room = private.room_objname,
    zz = "zz_entrancedoor",
    zz_gate = "gzz_closedroom_entrancedoor"
  };
  
  local get_stone_inv = function ()
  
    interface.InventoryItemAdd( "inv_stone", "spr_entrancedoor_stone" );
  
  end;
  
  local get_stone_closezz = function ()
  
    ObjDelete( "gfx_entrancedoor_stone" );
  
  end;
  
  cmn.AddSubscriber( "get_stone", get_stone_inv );
  cmn.AddSubscriber( "get_stone", get_stone_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_torch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_torch" ] = {
    type = "get",
    get_obj = "spr_sink_torch",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  
  local get_torch_inv = function ()
  
    interface.InventoryItemAdd( "inv_torch", "spr_sink_torch" );
  
  end;
  
  local get_torch_closezz = function ()
  
    ObjDelete( "gfx_sink_torch" );
  
  end;
  
  cmn.AddSubscriber( "get_torch", get_torch_inv );
  cmn.AddSubscriber( "get_torch", get_torch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wire" ] = {
    type = "get",
    get_obj = "obj_sink_wire",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  
  local get_wire_inv = function ()
  
    interface.InventoryItemAdd( "inv_wire", "obj_sink_wire" );
    ObjSet( "inv_wire", { drag = false } );
  
  end;
  
  local get_wire_closezz = function ()
  
    ObjDelete( "gfx_sink_wire" );
  
  end;
  
  cmn.AddSubscriber( "get_wire", get_wire_inv );
  cmn.AddSubscriber( "get_wire", get_wire_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cork" ] = {
    type = "get",
    get_obj = "spr_sink_cork",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  
  local get_cork_inv = function ()
  
    interface.InventoryItemAdd( "inv_cork", "spr_sink_cork" );
  
  end;
  
  local get_cork_closezz = function ()
  
    ObjDelete( "gfx_sink_cork" );
  
  end;
  
  cmn.AddSubscriber( "get_cork", get_cork_inv );
  cmn.AddSubscriber( "get_cork", get_cork_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lionhead_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lionhead_1" ] = {
    type = "get",
    get_obj = "spr_sink_lionhead_1",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  
  local get_lionhead_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_lionhead_1", "spr_sink_lionhead_1" );
  
  end;
  
  local get_lionhead_1_closezz = function ()
  
    ObjDelete( "gfx_sink_lionhead_1" );
  
  end;
  
  cmn.AddSubscriber( "get_lionhead_1", get_lionhead_1_inv );
  cmn.AddSubscriber( "get_lionhead_1", get_lionhead_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_room_313_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_room_313_key" ] = {
    type = "get",
    get_obj = "spr_sink_room_313_key",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  
  local get_room_313_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_room_313_key", "spr_sink_room_313_key" );
  
  end;
  
  local get_room_313_key_closezz = function ()
  
    ObjDelete( "gfx_sink_room_313_key" );
  
  end;
  
  local get_room_313_key_loc = function ()
  
    ObjSet( "obj_thirdfloorcorridor_see_gargoyle", { input = true } );
  
  end;  
  
  cmn.AddSubscriber( "get_room_313_key", get_room_313_key_inv );
  cmn.AddSubscriber( "get_room_313_key", get_room_313_key_closezz, private.room_objname );
  cmn.AddSubscriber( "get_room_313_key",   get_room_313_key_loc, "rm_thirdfloorcorridor"   ); 
  cmn.AddSubscriber( "get_room_313_key_loc", get_room_313_key_loc, "rm_thirdfloorcorridor"   ); 
  --------------------------------------------------------------------------------------------
  -- function get_tongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tongs" ] = {
    type = "get",
    get_obj = "spr_sink_tongs",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink", 
    subzz = "zz_sink_1",
    subzz_gate = "gzz_sink_sink_1"
  };
  
  local get_tongs_inv = function ()
  
    interface.InventoryItemAdd( "inv_tongs", "spr_sink_tongs" );
  
  end;
  
  local get_tongs_closezz = function ()
      
    if ( cmn.IsEventDone( "get_cork" ) and
         cmn.IsEventDone( "get_torch" ) and
         cmn.IsEventDone( "get_room_313_key" ) and
         cmn.IsEventDone( "get_lionhead_1" ) and
         cmn.IsEventDone( "get_wire" ) and
         cmn.IsGetCollect2( "get_collect2_item_2" ) ) then     
      
         ObjDelete( "gzz_sink_sink_1" );
         ObjDelete( "gzz_closedroom_sink" );
         
    else
      
         ObjDelete( "gzz_sink_sink_1" );
      
    end; 
  
  end;
  
  cmn.AddSubscriber( "get_tongs", get_tongs_inv );
  cmn.AddSubscriber( "get_tongs", get_tongs_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magnet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magnet" ] = {
    type = "get",
    get_obj = "spr_ventilationwindow_magnet",
    room = private.room_objname,
    zz = "zz_ventilationwindow",
    zz_gate = "gzz_closedroom_ventilationwindow"
  };
  
  local get_magnet_inv = function ()
  
    interface.InventoryItemAdd( "inv_magnet", "spr_ventilationwindow_magnet" );
  
  end;
  
  local get_magnet_closezz = function ()
  
    ObjDelete( "gfx_ventilationwindow_magnet" );
    ObjDelete( "spr_closedroom_magnet" );
    
  end;
  
  cmn.AddSubscriber( "get_magnet", get_magnet_inv );
  cmn.AddSubscriber( "get_magnet", get_magnet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_carvedamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_carvedamulet_1" ] = {
    type = "get",
    get_obj = "spr_ventilationwindow_carvedamulet_1",
    room = private.room_objname,
    zz = "zz_ventilationwindow",
    zz_gate = "gzz_closedroom_ventilationwindow"
  };
  
  local get_carvedamulet_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_carvedamulet_1", "spr_ventilationwindow_carvedamulet_1" );
  
  end;
  
  local get_carvedamulet_1_closezz = function ()
  
    ObjDelete( "gfx_ventilationwindow_carvedamulet_1" );
  
  end;
  
  cmn.AddSubscriber( "get_carvedamulet_1", get_carvedamulet_1_inv );
  cmn.AddSubscriber( "get_carvedamulet_1", get_carvedamulet_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tinywire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tinywire" ] = {
    type = "get",
    get_obj = "spr_ventilationwindow_tinywire",
    room = private.room_objname,
    zz = "zz_ventilationwindow",
    zz_gate = "gzz_closedroom_ventilationwindow"
  };
  
  local get_tinywire_inv = function ()
  
    interface.InventoryItemAdd( "inv_tinywire", "spr_ventilationwindow_tinywire" );
  
  end;
  
  local get_tinywire_closezz = function ()
  
    ObjDelete( "gfx_ventilationwindow_tinywire" );
    ObjMultiSet( { 
      { "obj_ventilationwindow_use_button",  { visible = true, input = true } },
    } );
    
  end;
  
  cmn.AddSubscriber( "get_tinywire", get_tinywire_inv );
  cmn.AddSubscriber( "get_tinywire", get_tinywire_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pallet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pallet" ] = {
    type = "get",
    get_obj = "spr_ventilationwindow_pallet",
    room = private.room_objname,
    zz = "zz_ventilationwindow",
    zz_gate = "gzz_closedroom_ventilationwindow"
  };
  
  local get_pallet_inv = function ()
  
    interface.InventoryItemAdd( "inv_pallet", "spr_ventilationwindow_pallet" );
  
  end;
  
  local get_pallet_closezz = function ()
  
    ObjDelete( "gfx_ventilationwindow_pallet" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_1" ) ) then
      
      ObjDelete( "gzz_closedroom_ventilationwindow" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_pallet", get_pallet_inv );
  cmn.AddSubscriber( "get_pallet", get_pallet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button" ] = {
    type = "get",
    get_obj = "spr_floorlamp_button",
    room = private.room_objname,
    zz = "zz_floorlamp",
    zz_gate = "gzz_closedroom_floorlamp"
  };
  
  local get_button_inv = function ()
  
    interface.InventoryItemAdd( "inv_button", "spr_floorlamp_button" );
  
  end;
  
  local get_button_closezz = function ()
  
    ObjDelete( "gfx_floorlamp_button" );
  
  end;
  
  cmn.AddSubscriber( "get_button", get_button_inv );
  cmn.AddSubscriber( "get_button", get_button_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_floorlamp_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_floorlamp_1" ] = {
    type = "click",
    use_place = "obj_floorlamp_clk_floorlamp_1",
    room = private.room_objname,
    zz = "zz_floorlamp",
    zz_gate = "gzz_closedroom_floorlamp"
  };
  
  local clk_floorlamp_1_beg = function ()

    ObjDelete( "obj_floorlamp_clk_floorlamp_1" );
  
  end;
  local clk_floorlamp_1_end = function ()
    
    ObjDelete( "spr_floorlamp_cap_lamp" );
    
    ObjMultiSet( { 
      { "anm_floorlamp_first_click",  { alp = 1, visible = true } },
      { "obj_floorlamp_clk_floorlamp_2",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_floorlamp_1",     clk_floorlamp_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floorlamp_1",     clk_floorlamp_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_floorlamp_1_beg", clk_floorlamp_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floorlamp_1_end", clk_floorlamp_1_end, private.room_objname );    
  
  --------------------------------------------------------------------------------------------
  -- function clk_floorlamp_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_floorlamp_2" ] = {
    type = "click",
    use_place = "obj_floorlamp_clk_floorlamp_2",
    room = private.room_objname,
    zz = "zz_floorlamp",
    zz_gate = "gzz_closedroom_floorlamp"
  };
  
  local clk_floorlamp_2_beg = function ()

    ObjDelete( "obj_floorlamp_clk_floorlamp_2" );
  
  end;
  local clk_floorlamp_2_end = function ()
    
    ObjDelete( "anm_floorlamp_first_click" );
    ObjDelete( "spr_closedroom_panel" );    
    
    ObjMultiSet( { 
      { "obj_floorlamp_use_tinywire",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_floorlamp_2",     clk_floorlamp_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floorlamp_2",     clk_floorlamp_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_floorlamp_2_beg", clk_floorlamp_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floorlamp_2_end", clk_floorlamp_2_end, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function clk_ventilationwindow_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_ventilationwindow_button" ] = {
    type = "click",
    use_place = "obj_ventilationwindow_clk_button",
    room = private.room_objname,
    zz = "zz_ventilationwindow",
    zz_gate = "gzz_closedroom_ventilationwindow"
  };
  
  local clk_ventilationwindow_button_beg = function ()

    ObjDelete( "obj_ventilationwindow_clk_button" );
  
  end;
  local clk_ventilationwindow_button_end = function ()
    
    ObjMultiSet( { 
      { "spr_ventilationwindow_magnet",           { visible = true, input = true } },
      { "gfx_ventilationwindow_magnet",           {  active = true               } },
      { "vid_ventilationwindow_ventilationstop",  {     alp = 1                  } },
      { "anm_ventilationwindow_button_2",         {   frame = 300                } },
      { "spr_closedroom_ventilationcycle",        {     alp = 1                  } },
    } );
    ObjDelete( "vid_ventilationwindow_ventilationcycle" );
    ObjDelete( "vid_closedroom_ventilationcycle" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_ventilationwindow_button",     clk_ventilationwindow_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ventilationwindow_button",     clk_ventilationwindow_button_end, private.room_objname );
  cmn.AddSubscriber( "clk_ventilationwindow_button_beg", clk_ventilationwindow_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ventilationwindow_button_end", clk_ventilationwindow_button_end, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function clk_closedroom_crate_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_closedroom_crate_1" ] = {
    type = "click",
    use_place = "obj_closedroom_clk_crate_1",
    room = private.room_objname
  };
  
  local clk_closedroom_crate_1_beg = function ()

    ObjDelete( "obj_closedroom_clk_crate_1" );
  
  end;
  local clk_closedroom_crate_1_end = function ()
    
    ObjMultiSet( { 
      { "obj_closedroom_clk_crate_2", { input = true } },
      { "anm_closedroom_crate_2",     {   alp = 1    } },
    } );
    ObjDelete( "anm_closedroom_crate_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_closedroom_crate_1",     clk_closedroom_crate_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_closedroom_crate_1",     clk_closedroom_crate_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_closedroom_crate_1_beg", clk_closedroom_crate_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_closedroom_crate_1_end", clk_closedroom_crate_1_end, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function clk_closedroom_crate_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_closedroom_crate_2" ] = {
    type = "click",
    use_place = "obj_closedroom_clk_crate_2",
    room = private.room_objname
  };
  
  local clk_closedroom_crate_2_beg = function ()

    ObjDelete( "obj_closedroom_clk_crate_2" );
  
  end;
  local clk_closedroom_crate_2_end = function ()
    
    ObjMultiSet( { 
      { "gzz_closedroom_sink",     { active = true, visible = true, input = true } },
      { "anm_closedroom_crate_2",  {  frame = 300                                } },
    } );
    ObjDelete( "obj_closedroom_block_zz" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_closedroom_crate_2",     clk_closedroom_crate_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_closedroom_crate_2",     clk_closedroom_crate_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_closedroom_crate_2_beg", clk_closedroom_crate_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_closedroom_crate_2_end", clk_closedroom_crate_2_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function use_lockpick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lockpick" ] = {
    type = "use",
    inv_obj = "inv_lockpick",
    use_place = "obj_entrancedoor_use_lockpick",
    room = private.room_objname,
    zz = "zz_entrancedoor",
    zz_gate = "gzz_closedroom_entrancedoor"
  };
  local use_lockpick_inv = function ()
  
    interface.InventoryItemRemove( "inv_lockpick" );
  
  end;
  local use_lockpick_beg = function ()
  
    ObjDelete( "obj_entrancedoor_use_lockpick" );
    ObjDelete( "anm_entrancedoor_wire_hh" );
  
  end;
  local use_lockpick_end = function ()
  
    ObjDelete( "spr_entrancedoor_door"       );
    ObjDelete( "spr_closedroom_door"         );
    ObjDelete( "gzz_closedroom_entrancedoor" );
    ObjMultiSet( { 
      { "grm_closedroom_thirdfloorcorridor",  { visible = true, input = true } },
      { "spr_closedroom_door_open",           {     alp = 1                  } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_closedroom_thirdfloorcorridor_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockpick", use_lockpick_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick", use_lockpick_inv );
  cmn.AddSubscriber( "use_lockpick", use_lockpick_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_inv", use_lockpick_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_beg", use_lockpick_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_end", use_lockpick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stone" ] = {
    type = "use",
    inv_obj = "inv_stone",
    use_place = "obj_sink_use_stone",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  local use_stone_inv = function ()
  
    interface.InventoryItemRemove( "inv_stone" );
  
  end;
  local use_stone_beg = function ()
  
    ObjDelete( "obj_sink_use_stone" );
  
  end;
  local use_stone_end = function ()
  
    ObjMultiSet( { 
      { "spr_sink_torch",               { visible = true, input = true } },
      { "obj_sink_use_corkscrew",       { visible = true, input = true } },
      { "anm_sink_mirror",              {   frame = 300                } },
      { "spr_closedroom_broken_mirror", {     alp = 1                  } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stone", use_stone_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone", use_stone_inv );
  cmn.AddSubscriber( "use_stone", use_stone_end, private.room_objname );
  cmn.AddSubscriber( "use_stone_inv", use_stone_inv, private.room_objname );
  cmn.AddSubscriber( "use_stone_beg", use_stone_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_end", use_stone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet_1" ] = {
    type = "use",
    inv_obj = "inv_magnet",
    use_place = "obj_sink_use_magnet",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  local use_magnet_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_magnet_2" ) ) then
      
      interface.InventoryItemRemove( "inv_magnet" );
      
    end;

  end;
  local use_magnet_1_beg = function ()
  
    ObjDelete( "obj_sink_use_magnet" );
  
  end;
  local use_magnet_1_end = function ()
  
    ObjMultiSet( { 
      { "anm_sink_wire",  { frame = 300  } },
      { "obj_sink_wire",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet_1", use_magnet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1", use_magnet_1_inv );
  cmn.AddSubscriber( "use_magnet_1", use_magnet_1_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1_inv", use_magnet_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1_beg", use_magnet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1_end", use_magnet_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_corkscrew () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_corkscrew" ] = {
    type = "use",
    inv_obj = "inv_corkscrew",
    use_place = "obj_sink_use_corkscrew",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  local use_corkscrew_inv = function ()
  
    interface.InventoryItemRemove( "inv_corkscrew" );
  
  end;
  local use_corkscrew_beg = function ()
  
    ObjDelete( "obj_sink_use_corkscrew" );
    ObjDelete( "spr_sink_bung_patch" );
    
    ObjMultiSet( { 
      { "spr_sink_cork",  { input = true, pos_x = 347, pos_y = -153 } },
    } );
  
  end;
  local use_corkscrew_end = function ()
  
    ObjDelete( "vid_sink_corkscrew" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_corkscrew", use_corkscrew_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew", use_corkscrew_inv );
  cmn.AddSubscriber( "use_corkscrew", use_corkscrew_end, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_inv", use_corkscrew_inv, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_beg", use_corkscrew_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_end", use_corkscrew_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screen" ] = {
    type = "use",
    inv_obj = "inv_screen",
    use_place = "obj_sink_use_screen",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  local use_screen_inv = function ()
  
    interface.InventoryItemRemove( "inv_screen" );
  
  end;
  local use_screen_beg = function ()
  
    ObjDelete( "obj_sink_use_screen" );
  
  end;
  local use_screen_end = function ()
  
    ObjMultiSet( { 
      { "spr_sink_lionhead_1",    { visible = true, input = true } },
      { "spr_sink_room_313_key",  { visible = true, input = true } },
      { "gfx_sink_room_313_key",  {  active = true               } },
      { "gfx_sink_lionhead_1",    {  active = true               } },
      { "anm_sink_rat_end",       {     alp = 1                  } },
    } );
    ObjDelete( "anm_sink_rat" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screen", use_screen_beg, private.room_objname );
  cmn.AddSubscriber( "use_screen", use_screen_inv );
  cmn.AddSubscriber( "use_screen", use_screen_end, private.room_objname );
  cmn.AddSubscriber( "use_screen_inv", use_screen_inv, private.room_objname );
  cmn.AddSubscriber( "use_screen_beg", use_screen_beg, private.room_objname );
  cmn.AddSubscriber( "use_screen_end", use_screen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ornamental_chandelier () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ornamental_chandelier" ] = {
    type = "use",
    inv_obj = "inv_ornamental_chandelier",
    use_place = "obj_sink_use_ornamental_chandelier",
    room = private.room_objname,
    zz = "zz_sink",
    zz_gate = "gzz_closedroom_sink"
  };
  local use_ornamental_chandelier_inv = function ()
  
    interface.InventoryItemRemove( "inv_ornamental_chandelier" );
  
  end;
  local use_ornamental_chandelier_beg = function ()
  
    ObjDelete( "obj_sink_use_ornamental_chandelier" );
  
  end;
  local use_ornamental_chandelier_end = function ()
    
    ObjDelete( "spr_sink_patch_door_2" );  
    ObjMultiSet( { 
      { "spr_sink_rose",    {    alp = 1                                  } },
      { "gzz_sink_sink_1",  { active = true, input = true, visible = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ornamental_chandelier", use_ornamental_chandelier_beg, private.room_objname );
  cmn.AddSubscriber( "use_ornamental_chandelier", use_ornamental_chandelier_inv );
  cmn.AddSubscriber( "use_ornamental_chandelier", use_ornamental_chandelier_end, private.room_objname );
  cmn.AddSubscriber( "use_ornamental_chandelier_inv", use_ornamental_chandelier_inv, private.room_objname );
  cmn.AddSubscriber( "use_ornamental_chandelier_beg", use_ornamental_chandelier_beg, private.room_objname );
  cmn.AddSubscriber( "use_ornamental_chandelier_end", use_ornamental_chandelier_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rubbertoy () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_rubbertoy" ] = {
    type = "use",
    inv_obj = "inv_rubbertoy",
    use_place = "obj_ventilationwindow_use_rubbertoy",
    room = private.room_objname,
    zz = "zz_ventilationwindow",
    zz_gate = "gzz_closedroom_ventilationwindow"
  };
  local use_rubbertoy_inv = function ()
  
    interface.InventoryItemRemove( "inv_rubbertoy" );
  
  end;
  local use_rubbertoy_beg = function ()
  
    ObjDelete( "obj_ventilationwindow_use_rubbertoy" );
    ObjDelete( "vid_ventilationwindow_wire" );
  
  end;
  local use_rubbertoy_end = function ()
  
    ObjMultiSet( { 
      { "spr_ventilationwindow_tinywire",    { visible = true, input = true } }
    } );
    ObjDelete( "vid_ventilationwindow_wire_balloon" );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rubbertoy", use_rubbertoy_beg, private.room_objname );
  cmn.AddSubscriber( "use_rubbertoy", use_rubbertoy_inv );
  cmn.AddSubscriber( "use_rubbertoy", use_rubbertoy_end, private.room_objname );
  cmn.AddSubscriber( "use_rubbertoy_inv", use_rubbertoy_inv, private.room_objname );
  cmn.AddSubscriber( "use_rubbertoy_beg", use_rubbertoy_beg, private.room_objname );
  cmn.AddSubscriber( "use_rubbertoy_end", use_rubbertoy_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button" ] = {
    type = "use",
    inv_obj = "inv_button",
    use_place = "obj_ventilationwindow_use_button",
    room = private.room_objname,
    zz = "zz_ventilationwindow",
    zz_gate = "gzz_closedroom_ventilationwindow"
  };
  local use_button_inv = function ()
  
    interface.InventoryItemRemove( "inv_button" );
  
  end;
  local use_button_beg = function ()
  
    ObjDelete( "obj_ventilationwindow_use_button" );
  
  end;
  local use_button_end = function ()
  
    ObjMultiSet( { 
      { "anm_ventilationwindow_button_2",   {   alp = 1    } },
      { "obj_ventilationwindow_clk_button", { input = true } },
    } );
    ObjDelete( "anm_ventilationwindow_spring" );
    ObjDelete( "anm_ventilationwindow_button_1" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button", use_button_inv );
  cmn.AddSubscriber( "use_button", use_button_end, private.room_objname );
  cmn.AddSubscriber( "use_button_inv", use_button_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_beg", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_end", use_button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sharptooth () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sharptooth" ] = {
    type = "use",
    inv_obj = "inv_sharptooth",
    use_place = "obj_ventilationwindow_use_sharptooth",
    room = private.room_objname,
    zz = "zz_ventilationwindow",
    zz_gate = "gzz_closedroom_ventilationwindow"
  };
  local use_sharptooth_inv = function ()
  
    interface.InventoryItemRemove( "inv_sharptooth" );
  
  end;
  local use_sharptooth_beg = function ()
  
    ObjDelete( "obj_ventilationwindow_use_sharptooth" );
  
  end;
  local use_sharptooth_end = function ()
  
    ObjMultiSet( { 
      { "spr_ventilationwindow_pallet",  { input = true               } },
      { "obj_ventilationwindow_open",    { input = true               } },
      { "spr_ventilationwindow_door_1",  { pos_x = 345,  pos_y = 120  } },
      { "spr_ventilationwindow_door_2",  { pos_x = 230,  pos_y = 73   } },
    } ); 
    ObjDelete( "anm_ventilationwindow_rope" );
    ObjDelete( "spr_ventilationwindow_rope" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sharptooth", use_sharptooth_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharptooth", use_sharptooth_inv );
  cmn.AddSubscriber( "use_sharptooth", use_sharptooth_end, private.room_objname );
  cmn.AddSubscriber( "use_sharptooth_inv", use_sharptooth_inv, private.room_objname );
  cmn.AddSubscriber( "use_sharptooth_beg", use_sharptooth_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharptooth_end", use_sharptooth_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tinywire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tinywire" ] = {
    type = "use",
    inv_obj = "inv_tinywire",
    use_place = "obj_floorlamp_use_tinywire",
    room = private.room_objname,
    zz = "zz_floorlamp",
    zz_gate = "gzz_closedroom_floorlamp"
  };
  local use_tinywire_inv = function ()
  
    interface.InventoryItemRemove( "inv_tinywire" );
  
  end;
  local use_tinywire_beg = function ()
  
    ObjDelete( "obj_floorlamp_use_tinywire" );
  
  end;
  local use_tinywire_end = function ()
  
    ObjDelete( "anm_floorlamp_wire_off" );
    
    ObjMultiSet( { 
      { "anm_floorlamp_new_wire",  { alp = 1, visible = true, frame = 500 } },
      { "obj_floorlamp_mmg",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tinywire", use_tinywire_beg, private.room_objname );
  cmn.AddSubscriber( "use_tinywire", use_tinywire_inv );
  cmn.AddSubscriber( "use_tinywire", use_tinywire_end, private.room_objname );
  cmn.AddSubscriber( "use_tinywire_inv", use_tinywire_inv, private.room_objname );
  cmn.AddSubscriber( "use_tinywire_beg", use_tinywire_beg, private.room_objname );
  cmn.AddSubscriber( "use_tinywire_end", use_tinywire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_eye () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_eye" ] = {
    type = "use",
    inv_obj = "inv_eye",
    use_place = "obj_floorlamp_use_eye",
    room = private.room_objname,
    zz = "zz_floorlamp",
    zz_gate = "gzz_closedroom_floorlamp"
  };
  local use_eye_inv = function ()
  
    interface.InventoryItemRemove( "inv_eye" );
  
  end;
  local use_eye_beg = function ()
  
    ObjDelete( "obj_floorlamp_use_eye" );
  
  end;
  local use_eye_end = function ()
  
    ObjDelete( "gzz_closedroom_floorlamp" );
    ObjMultiSet( { 
      { "anm_floorlamp_eye",  { alp = 1, visible = true, frame = 500 } },
      { "gmg_closedroom_scaryhead",  { visible = true, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_eye", use_eye_beg, private.room_objname );
  cmn.AddSubscriber( "use_eye", use_eye_inv );
  cmn.AddSubscriber( "use_eye", use_eye_end, private.room_objname );
  cmn.AddSubscriber( "use_eye_inv", use_eye_inv, private.room_objname );
  cmn.AddSubscriber( "use_eye_beg", use_eye_beg, private.room_objname );
  cmn.AddSubscriber( "use_eye_end", use_eye_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_torch_11 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_torch_11" ] = {
    type = "use",
    inv_obj = "inv_torch",
    use_place = "obj_closedroom_use_torch",
    room = private.room_objname
  };
  local use_torch_11_inv = function ()
  
    if ( cmn.IsEventDone( "use_torch_12" ) ) then
      
      interface.InventoryItemRemove( "inv_torch" );
      
    end;
    
  end;
  local use_torch_11_beg = function ()
  
    ObjDelete( "obj_closedroom_use_torch" );
  
  end;
  local use_torch_11_end = function ()
    
    ObjDelete( "anm_closedroom_flashlight" );
    ObjMultiSet( { 
      { "gho_closedroom_darkcorner",  { visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_torch_11", use_torch_11_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch_11", use_torch_11_inv );
  cmn.AddSubscriber( "use_torch_11", use_torch_11_end, private.room_objname );
  cmn.AddSubscriber( "use_torch_11_inv", use_torch_11_inv, private.room_objname );
  cmn.AddSubscriber( "use_torch_11_beg", use_torch_11_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch_11_end", use_torch_11_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function see_intro () end;
  --------------------------------------------------------------------------------------------
  local see_intro = function ()
  
    ObjSet( "obj_closedroom_clk_entrancedoor", { input = true } );
  
  end;
  cmn.AddSubscriber( "see_intro", see_intro, private.room_objname );    
  
  --------------------------------------------------------------------------------------------
  -- function see_closedroom_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_closedroom_1" ] = {
    type = "click",
    use_place = "obj_closedroom_clk_entrancedoor",
    room = private.room_objname
  };
  local see_closedroom_1 = function ()
    
    ObjDelete( "anm_closedroom_closed_number_1"  );
    ObjDelete( "obj_closedroom_clk_entrancedoor" );
    ObjMultiSet( { 
      { "gzz_closedroom_entrancedoor",  { visible = true, input = true } },
    } );
  
  end;
  cmn.AddSubscriber( "see_closedroom_1", see_closedroom_1, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function see_closedroom_bats () end;
  --------------------------------------------------------------------------------------------
  local see_closedroom_bats = function ()
    
    ObjDelete( "anm_closedroom_bat_1" ); 
    
  end;
  cmn.AddSubscriber( "see_closedroom_bats", see_closedroom_bats, private.room_objname );    
  
  --------------------------------------------------------------------------------------------
  -- function see_closedroom_lamp () end;
  --------------------------------------------------------------------------------------------
  local see_closedroom_lamp = function ()
    
    ObjDelete( "anm_closedroom_lamp" ); 
    ObjDelete( "spr_floorlamp_path_lamp_light" ); 
    
  end;
  cmn.AddSubscriber( "see_closedroom_lamp", see_closedroom_lamp, private.room_objname );    
    
  --------------------------------------------------------------------------------------------
  -- function see_closedroom_destruction () end;
  --------------------------------------------------------------------------------------------
  local see_closedroom_destruction = function ()
    
    ObjDelete( "anm_closedroom_destruction" ); 
    ObjDelete( "obj_closedroom_see_destruction" ); 
    
  end;
  cmn.AddSubscriber( "see_closedroom_destruction", see_closedroom_destruction, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function see_sink_scare () end;
  --------------------------------------------------------------------------------------------
  local see_sink_scare = function ()
    
    ObjDelete( "anm_sink_hand" ); 
    ObjDelete( "obj_sink_see_scare" ); 
    
  end;
  cmn.AddSubscriber( "see_sink_scare", see_sink_scare, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function see_entrancedoor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_entrancedoor" ] = {
    type = "click",
    use_place = "obj_entrancedoor_see_door",
    room = private.room_objname,
    zz = "zz_entrancedoor",
    zz_gate = "gzz_closedroom_entrancedoor"
  };
  local see_entrancedoor = function ()
  
    ObjDelete( "obj_entrancedoor_see_door" );
    ObjDelete( "anm_entrancedoor_door"     );

    ObjMultiSet( { 
      { "obj_entrancedoor_use_lockpick", { input = true, active = true, visible = true } },
      { "spr_entrancedoor_stone",        { input = true                                } },
      { "gfx_entrancedoor_stone",        {               active = true                 } },
    } );                

  end;
  cmn.AddSubscriber( "see_entrancedoor", see_entrancedoor,private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function win_floorlamp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_floorlamp" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_floorlamp",
      zz_gate = "gzz_closedroom_floorlamp"
  };

  local win_floorlamp = function ()

    if ( cmn.IsEventDone( "win_floorlamp" ) ) then
      
      ObjDelete( "spr_floorlamp_button_before" );
      ObjDelete( "spr_floorlamp_patch_button" );
      ObjDelete( "spr_floorlamp_doll_dark" );
      ObjDelete( "anm_floorlamp_lightbad" );
      ObjDelete( "anm_floorlamp_all_dark" );
      
      ObjMultiSet( { 
        { "spr_floorlamp_button",           {   alp = 1, visible = true, input = true } },
        { "spr_floorlamp_back_light",       {   alp = 1, visible = true               } },
        { "spr_floorlamp_path_lamp_light",  {   alp = 1, visible = true               } },
        { "obj_floorlamp_mmg",              { input = false                           } },
        { "anm_closedroom_lamp",            {   alp = 1                               } },
      } );
      
    end;

  end;

  cmn.AddSubscriber( "win_floorlamp", win_floorlamp, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function win_sink_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_sink_1" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_sink",
      zz_gate = "gzz_closedroom_sink", 
      subzz = "zz_sink_1",
      subzz_gate = "gzz_sink_sink_1"
  };

  local win_sink_1 = function ()

    if ( cmn.IsEventDone( "win_sink_1" ) ) then
      
      ObjDelete( "obj_sink_1_mmg" );
      ObjMultiSet( { 
        { "spr_sink_tongs",               { input = true } },
        { "spr_closedroom_broken_mirror", {   alp = 1    } },
      } );
      
    end;

  end;

  cmn.AddSubscriber( "win_sink_1", win_sink_1, private.room_objname );     
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1 = function ()
  
    ObjDelete( "obj_closedroom_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_1", get_collect_morph_item_1, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_2 = function ()
  
    ObjDelete( "obj_sink_collect2_item_2" ); 

    if ( cmn.IsEventDone( "get_cork" ) and
         cmn.IsEventDone( "get_torch" ) and
         cmn.IsEventDone( "get_room_313_key" ) and
         cmn.IsEventDone( "get_lionhead_1" ) and
         cmn.IsEventDone( "get_wire" ) and
         cmn.IsEventDone( "get_tongs" ) ) then   
      
      ObjDelete( "gzz_closedroom_sink" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_2", get_collect2_item_2, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_1 = function ()
  
    ObjDelete( "obj_ventilationwindow_collect2_item_1" ); 
  
    if ( cmn.IsEventDone( "get_pallet" ) ) then
      
      ObjDelete( "gzz_closedroom_ventilationwindow" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_1", get_collect2_item_1, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_floorlamp () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_floorlamp" );
    
    function zz_floorlamp.Open ()
            
    end;  
    -------------------------------------------------
    function zz_floorlamp.PreOpen ()

      if ( cmn.IsEventStart( "win_floorlamp" ) and not cmn.IsEventDone( "win_floorlamp" ) ) then

        cmn.MiniGameShow( "floorlamp" );
        common_impl.PassingMgStart( "floorlamp" );

      end;

      private.FloorlampLoad();
      private.FloorlampUpdate(); 

    end;  
    -------------------------------------------------
    function zz_floorlamp.PreClose ()      
      
      if ( cmn.IsEventStart( "win_floorlamp" ) and not cmn.IsEventDone( "win_floorlamp" ) ) then

        cmn.MiniGameHide( "floorlamp" );
        common_impl.PassingMgStop( "floorlamp" );

      end;

    end; 
    ------------------------------------------------- 
    function zz_floorlamp.Close ()
      
    end;
    -------------------------------------------------
    function zz_floorlamp.Reset ()
      
      private.FloorlampDefault();
      private.FloorlampLoad(); 
      private.FloorlampUpdate();

    end;
    -------------------------------------------------
    function zz_floorlamp.Skip ()

      private.gamedata_floorlamp.states = private.win_floorlamp;
      
      private.FloorlampLoad(); 
      private.FloorlampUpdate();
      
    end; 
  --*******************************************************************************************************************
  --*** function zz_sink () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_sink" );
    
    function zz_sink.Open ()
      
      if cmn.IsEventStart( "see_tutorial" ) and cmn.IsEventDone( "get_stone" ) and not cmn.IsEventDone( "use_stone" ) then
      
        common_impl.TutorialShow( "tutorial_page_4" );
        
      end;
      
    end;  
    -------------------------------------------------
    function zz_sink.PreOpen ()

    end;  
    -------------------------------------------------
    function zz_sink.PreClose ()      

    end; 
    ------------------------------------------------- 
    function zz_sink.Close ()
      
      if cmn.IsEventStart( "see_tutorial" ) and cmn.IsEventDone( "get_torch" ) then
      
        common_impl.TutorialShow( "tutorial_page_5" );
        
      end;
      
    end;

  --*******************************************************************************************************************
  --*** function zz_sink_1 () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_sink_1" );
    
    function zz_sink_1.Open ()
      
      if cmn.IsEventStart( "see_tutorial" ) then
      
        common_impl.TutorialShow( "tutorial_page_4" );
        
      end;
      
    end;  
    -------------------------------------------------
    function zz_sink_1.PreOpen ()

      if ( not cmn.IsEventDone( "win_sink_1" ) ) then

        cmn.MiniGameShow( "sink_1" );
        common_impl.PassingMgStart( "sink_1" );

      end;

      private.Sink1Load();
      private.Sink1Update(); 

    end;  
    -------------------------------------------------
    function zz_sink_1.PreClose ()      
      
      if ( not cmn.IsEventDone( "win_sink_1" ) ) then

        cmn.MiniGameHide( "sink_1" );
        common_impl.PassingMgStop( "sink_1" );

      end;

    end; 
    ------------------------------------------------- 
    function zz_sink_1.Close ()
      
      if cmn.IsEventStart( "see_tutorial" ) and cmn.IsEventDone( "get_torch" ) then
      
        common_impl.TutorialShow( "tutorial_page_5" );
        
      end;
      
    end;
    -------------------------------------------------
    function zz_sink_1.Reset ()
      
      private.Sink1Default();
      private.Sink1Load(); 
      private.Sink1Update();

    end;
    -------------------------------------------------
    function zz_sink_1.Skip ()

      private.gamedata_sink_1.states = private.win_sink_1;
      
      private.Sink1Load(); 
      private.Sink1Update();
      
    end;  
    
  --*******************************************************************************************************************
  --*** function zz_entrancedoor () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_entrancedoor" );
    
    function zz_entrancedoor.Open ()
            
    end;  
    -------------------------------------------------
    function zz_entrancedoor.PreOpen ()

      if cmn.IsEventStart( "see_tutorial" ) and cmn.IsEventDone( "see_entrancedoor" ) and not cmn.IsEventDone( "get_stone" ) then
      
        common_impl.TutorialShow( "tutorial_page_3" );
        
      end;
      
    end;  
    -------------------------------------------------
    function zz_entrancedoor.PreClose ()      
      
    end; 
    ------------------------------------------------- 
    function zz_entrancedoor.Close ()
      
    end;

  --*******************************************************************************************************************
  --*** function zz_ventilationwindow () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_ventilationwindow" );
    
    function zz_ventilationwindow.Open ()
    end;  
    -------------------------------------------------
    function zz_ventilationwindow.PreOpen ()

      if not cmn.IsEventDone( "clk_ventilationwindow_button" ) then
        common_impl.PlayAudio( "env", "level1/env/aud_ventilation_env", 1, "", 0 );
      end;

      if not cmn.IsEventDone( "use_rubbertoy" ) then
        common_impl.PlayAudio( "env", "level1/env/aud_electr_env", 1, "", 0 );
      end;

    end;  
    -------------------------------------------------
    function zz_ventilationwindow.PreClose ()    

      if not cmn.IsEventDone( "clk_ventilationwindow_button" ) then
        common_impl.StopAudio( "env", "level1/env/aud_ventilation_env", 0.5 );
      end;

      if not cmn.IsEventDone( "use_rubbertoy" ) then
        common_impl.StopAudio( "env", "level1/env/aud_electr_env",  0.5 );
      end;
  
    end; 
    ------------------------------------------------- 
    function zz_ventilationwindow.Close ()
    end;
    
end;
--*********************************************************************************************************************
function public.Open ()

  if not cmn.IsEventStart( "see_tutorial" ) and cmn.IsEventDone( "see_closedroom_1" ) then

    common_impl.TutorialShow( "tutorial_page_1" );

  elseif cmn.IsEventStart( "see_tutorial" ) then

    if not cmn.IsEventDone( "get_stone" ) then

      common_impl.TutorialShow( "tutorial_page_2" );

    end;
    
    if cmn.IsEventDone( "get_torch" ) and not cmn.IsEventDone( "use_torch_11" ) then

      common_impl.TutorialShow( "tutorial_page_5" );

    end;
    
    if cmn.IsEventDone( "use_torch_11" ) and not cmn.IsEventDone( "win_darkcorner" ) then

      common_impl.TutorialShow( "tutorial_page_6" );

    end;
    
    if cmn.IsEventDone( "win_darkcorner" )  then

      common_impl.TutorialShow( "tutorial_page_7" );

    end;



  end;
  
  private.opn_closedroom();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  
  if ( not cmn.IsEventDone( "see_intro" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( private.room_objname, { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_closedroom_intro", private.room_objname );
    ObjSet( "tmr_closedroom_intro",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntro(); end
    } );

  end;  
    
  if ( cmn.IsEventDone( "win_floorlamp" ) and not cmn.IsEventDone( "see_closedroom_lamp" ) ) then  
    private.see_closedroom_lamp();
  end;
    
  common_impl.EnvPlay( { "level1/env/aud_closedroom_env" }, "", 0.5 );

  if ( cmn.IsEventDone( "see_intro" ) ) then private.StartAnimSteps() end;

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level1/env/aud_closedroom_env", 0.5 );

  private.StopAnimSteps();

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lockpick ()

  local item = "inv_lockpick";

  if ( cmn.ApplyObj( item, "gzz_closedroom_entrancedoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_entrancedoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_entrancedoor_use_lockpick" ) ) then

    cmn.CallEventHandler( "use_lockpick_inv" );
    cmn.CallEventHandler( "use_lockpick_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_lockpick" );
      cmn.CallEventHandler( "use_lockpick_end" );
      
      common.CloseSubRoom();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_wood_door", 0, "", 0 );

    ObjSet( "anm_entrancedoor_wire", { alp = 1 } );
    AnimPlay( "anm_entrancedoor_wire", "wire", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stone ()

  local item = "inv_stone";

  if ( cmn.ApplyObj( item, "gzz_closedroom_sink" )  and (ObjGet("gzz_closedroom_sink").input == true)) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sink" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sink_use_stone" ) ) then

    cmn.CallEventHandler( "use_stone_inv" );
    cmn.CallEventHandler( "use_stone_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_stone" );
      cmn.CallEventHandler( "use_stone_end" );
      
      cmn.SetEventDone( "see_sink_scare" );
      cmn.CallEventHandler( "see_sink_scare" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_break_glass", 0, "", 0 );

    AnimPlay( "anm_sink_mirror", "mirror", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_magnet_1 ()

  local item = "inv_magnet";

  if ( cmn.ApplyObj( item, "gzz_closedroom_sink" ) and (ObjGet("gzz_closedroom_sink").input == true)) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sink" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sink_use_magnet" ) ) then

    cmn.CallEventHandler( "use_magnet_1_inv" );
    cmn.CallEventHandler( "use_magnet_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_magnet_1" );
      cmn.CallEventHandler( "use_magnet_1_end" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_magnet", 0, "", 0 );

    AnimPlay( "anm_sink_wire", "wire", func_end  );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_corkscrew ()

  local item = "inv_corkscrew";

  if ( cmn.ApplyObj( item, "gzz_closedroom_sink" ) and (ObjGet("gzz_closedroom_sink").input == true) and
       cmn.IsEventDone( "use_stone" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sink" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sink_use_corkscrew" ) and
           cmn.IsEventDone( "use_stone" ) ) then

    cmn.CallEventHandler( "use_corkscrew_inv" );
    cmn.CallEventHandler( "use_corkscrew_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_corkscrew" );
      cmn.CallEventHandler( "use_corkscrew_end" );
      private.get_cork();
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_corkscrew", 0, "", 0 );

    ObjSet( "vid_sink_corkscrew", { alp = 1 } );
    VidPlay( "vid_sink_corkscrew", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_screen ()

  local item = "inv_screen";

  if ( cmn.ApplyObj( item, "gzz_closedroom_sink" ) and (ObjGet("gzz_closedroom_sink").input == true) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sink" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sink_use_screen" ) ) then

    cmn.CallEventHandler( "use_screen_inv" );
    cmn.CallEventHandler( "use_screen_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_screen" );
      cmn.CallEventHandler( "use_screen_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_metal_slide", 0, "", 0 );

    AnimPlay( "anm_sink_rat", "rat_flap", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ornamental_chandelier ()

  local item = "inv_ornamental_chandelier";

  if ( cmn.ApplyObj( item, "gzz_closedroom_sink" ) and (ObjGet("gzz_closedroom_sink").input == true) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sink" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sink_use_ornamental_chandelier" ) ) then

    cmn.CallEventHandler( "use_ornamental_chandelier_inv" );
    cmn.CallEventHandler( "use_ornamental_chandelier_beg" );

    local func_end = function ()

      local func_end_2 = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_ornamental_chandelier" );
        cmn.CallEventHandler( "use_ornamental_chandelier_end" );
      
      end;
      
      ObjAnimate( "spr_sink_patch_door_2", "pos_xy", 0, 0, func_end_2, { 0, 0, -171, 170,   1, 3, -195, 86 } );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_flower_amulet", 0, "", 0 );

    cmn.ItemFly( "spr_sink_rose", func_end, 1.5, 60 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_rubbertoy ()

  local item = "inv_rubbertoy";

  if ( cmn.ApplyObj( item, "gzz_closedroom_ventilationwindow" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ventilationwindow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ventilationwindow_use_rubbertoy" ) ) then

    cmn.CallEventHandler( "use_rubbertoy_inv" );
    cmn.CallEventHandler( "use_rubbertoy_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_rubbertoy" );
      cmn.CallEventHandler( "use_rubbertoy_end" );
      private.get_tinywire();
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_rubber", 0, "", 0 );
    common_impl.StopAudio( "env", "level1/env/aud_electr_env",  0.5 );

    ObjSet( "vid_ventilationwindow_wire_balloon", { alp = 1 } );
    VidPlay( "vid_ventilationwindow_wire_balloon", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_button ()

  local item = "inv_button";

  if ( cmn.ApplyObj( item, "gzz_closedroom_ventilationwindow" ) and
       cmn.IsEventDone( "get_tinywire" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ventilationwindow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ventilationwindow_use_button" ) and
           cmn.IsEventDone( "get_tinywire" ) ) then

    cmn.CallEventHandler( "use_button_inv" );
    cmn.CallEventHandler( "use_button_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_button" );
      cmn.CallEventHandler( "use_button_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_button", 0, "", 0 );
    
    ObjMultiSet( { 
      { "anm_ventilationwindow_button_1", { alp = 1 } },
      { "anm_ventilationwindow_spring",   { alp = 0 } },
    } );
    
    AnimPlay( "anm_ventilationwindow_button_1", "button_1", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sharptooth ()

  local item = "inv_sharptooth";

  if ( cmn.ApplyObj( item, "gzz_closedroom_ventilationwindow" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ventilationwindow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ventilationwindow_use_sharptooth" ) ) then

    cmn.CallEventHandler( "use_sharptooth_inv" );
    cmn.CallEventHandler( "use_sharptooth_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
      
        cmn.Lock( false );

        cmn.SetEventDone( "use_sharptooth" );
        cmn.CallEventHandler( "use_sharptooth_end" );
      
      end;
      
      ObjMultiSet( { 
        { "spr_ventilationwindow_rope", { alp = 0 } },
        { "anm_ventilationwindow_rope", { alp = 0 } },
      } );       
      ObjAnimate( "spr_ventilationwindow_door_2", "pos_xy", 0, 0, func_end_2, { 0, 0, 253, 80,   0.6, 3, 230, 73 } );
      ObjAnimate( "spr_ventilationwindow_door_1", "pos_xy", 0, 0, "", { 0, 0, 306, 102,   0.6, 3, 345, 120 } );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_tooth", 0, "", 0 );
    ObjMultiSet( { 
      { "anm_ventilationwindow_rope",       { alp = 1 } },
    } );   
    AnimPlay( "anm_ventilationwindow_rope", "rope", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tinywire ()

  local item = "inv_tinywire";

  if ( cmn.ApplyObj( item, "gzz_closedroom_floorlamp" ) and
  cmn.IsEventDone( "clk_floorlamp_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floorlamp" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_floorlamp_use_tinywire" ) and
  cmn.IsEventDone( "clk_floorlamp_2" ) ) then

    cmn.CallEventHandler( "use_tinywire_inv" );
    cmn.CallEventHandler( "use_tinywire_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tinywire" );
      cmn.CallEventHandler( "use_tinywire_end" );
      
      cmn.MiniGameShow( "floorlamp" );
      common_impl.PassingMgStart( "floorlamp" );
      
      common_impl.TutorialShow( "tutorial_page_8" );
        
    end;
    
    local func_end_2 = function ()
      
      ObjMultiSet( { 
        { "anm_floorlamp_wire_off",  { alp = 0, visible = false } },
        { "anm_floorlamp_new_wire",  { alp = 1, visible = true } },
      } );
      
      AnimPlay( "anm_floorlamp_new_wire", "new_wire", func_end );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_wire", 0, "", 0 );

    AnimPlay( "anm_floorlamp_wire_off", "wire_off", func_end_2 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_eye ()

  local item = "inv_eye";

  if ( cmn.ApplyObj( item, "gzz_closedroom_floorlamp" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floorlamp" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_floorlamp_use_eye" ) ) then

    cmn.CallEventHandler( "use_eye_inv" );
    cmn.CallEventHandler( "use_eye_beg" );

    local func_end = function ()

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_button", 0, "", 0 );

      cmn.Lock( false );
      cmn.SetEventDone( "use_eye" );
      cmn.CallEventHandler( "use_eye_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom( "mg_scaryhead" );

    end;

    cmn.Lock( true );

    AnimPlay( "anm_floorlamp_eye", "eye", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_torch_11 ()

  local item = "inv_torch";

  if ( cmn.ApplyObj( item, "obj_closedroom_use_torch" ) ) then

    cmn.CallEventHandler( "use_torch_11_inv" );
    cmn.CallEventHandler( "use_torch_11_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_torch_11" );
      cmn.CallEventHandler( "use_torch_11_end" );

      common_impl.TutorialShow( "tutorial_page_6" );
      --cmn.GotoRoom( "ho_darkcorner" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_flashlight", 0, "", 0 );

    AnimPlay( "anm_closedroom_flashlight", "flashlight", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_stone ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stone" );
  cmn.CallEventHandler( "get_stone" );

end;
--------------------------------------------------------------------------------------------
function private.get_torch ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_torch" );
  cmn.CallEventHandler( "get_torch" );

end;
--------------------------------------------------------------------------------------------
function private.get_wire ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wire" );
  cmn.CallEventHandler( "get_wire" );
  
  common_impl.TutorialShow( "tutorial_page_10" );

end;
--------------------------------------------------------------------------------------------
function private.get_cork ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cork" );
  cmn.CallEventHandler( "get_cork" );

end;
--------------------------------------------------------------------------------------------
function private.get_lionhead_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lionhead_1" );
  cmn.CallEventHandler( "get_lionhead_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_room_313_key ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_room_313_key" );
  cmn.CallEventHandler( "get_room_313_key" );
  cmn.CallEventHandler( "get_room_313_key_loc" );
    
  if port.isPortable()==1 then
    iOS_RateMe();
  end; 
  
end;
--------------------------------------------------------------------------------------------
function private.get_tongs ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_shadow", 0, "", 0 );

  cmn.SetEventDone( "get_tongs" );
  cmn.CallEventHandler( "get_tongs" );
  
  if ( cmn.IsEventDone( "get_cork" ) and
       cmn.IsEventDone( "get_torch" ) and
       cmn.IsEventDone( "get_room_313_key" ) and
       cmn.IsEventDone( "get_lionhead_1" ) and
       cmn.IsEventDone( "get_wire" ) and
       cmn.IsGetCollect2( "get_collect2_item_2" ) ) then     
    
    common.CloseSubRoomAll(); 
    
  else
    
    common.CloseSubRoom();
    
  end;  

end;
--------------------------------------------------------------------------------------------
function private.get_magnet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_magnet" );
  cmn.CallEventHandler( "get_magnet" );

end;
--------------------------------------------------------------------------------------------
function private.get_carvedamulet_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_carvedamulet_1" );
  cmn.CallEventHandler( "get_carvedamulet_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_tinywire ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tinywire" );
  cmn.CallEventHandler( "get_tinywire" );

end;
--------------------------------------------------------------------------------------------
function private.get_pallet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pallet" );
  cmn.CallEventHandler( "get_pallet" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_1" ) ) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_button ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button" );
  cmn.CallEventHandler( "get_button" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_2 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_2" ); 

  end;

  common_impl.PlayEffectHO( "spr_sink_collect2_item_2", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_2" );
  
  if ( cmn.IsEventDone( "get_cork" ) and
       cmn.IsEventDone( "get_torch" ) and
       cmn.IsEventDone( "get_room_313_key" ) and
       cmn.IsEventDone( "get_lionhead_1" ) and
       cmn.IsEventDone( "get_wire" ) and
       cmn.IsEventDone( "get_tongs" ) ) then    

    common.CloseSubRoom();

  end; 
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_1 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_1" ); 

  end;

  common_impl.PlayEffectHO( "spr_ventilationwindow_collect2_item_1", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_1" );
  
  if ( cmn.IsEventDone( "get_pallet" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_floorlamp_1 ()
  
  cmn.CallEventHandler( "clk_floorlamp_1_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_floorlamp_1" );
    cmn.CallEventHandler( "clk_floorlamp_1_end" ); 
    
  end;
  
  local func_end_2 = function ()
    
    ObjAnimate( "spr_floorlamp_cap_lamp", "pos_y",0,0, func_end, { 0, 3, 26,    0.4, 3, 33 } );
    ObjAnimate( "spr_floorlamp_cap_lamp", "ang",0,0, "", { 0, 0, 0,    0.4, 0, 0.02 } );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_opn_metal_panel_mid", 0, "", 0 );
  
  ObjAnimate( "spr_floorlamp_button_before", "pos_x",0,0, func_end_2, { 0, 3, 96,    0.1, 3, 104,    0.2, 3, 96 } );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_floorlamp_2 ()
  
  cmn.CallEventHandler( "clk_floorlamp_2_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_floorlamp_2" );
    cmn.CallEventHandler( "clk_floorlamp_2_end" ); 
  
  end;
  
  local func_end_2 = function ()
    
    local trgAfter = "";
    
    for i = 1, 5, 1 do 
      
      if ( i == 5 ) then 
        
        trgAfter = func_end;
        
      end;
    
      local curRunnerLight = "spr_floorlamp_button_"..i.."_light";
      ObjAnimate( curRunnerLight, "alp",0,0, trgAfter, { 0, 3, 0,    0.6, 3, 1,    1.0, 3, 0,    1.5, 3, 1,    2.6, 3, 0 } );
      
    end;
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_opn_metal_panel2_mid", 0, "", 0 );
  
  AnimPlay( "anm_floorlamp_first_click", "first_click", func_end_2 );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_ventilationwindow_button ()
  
  cmn.CallEventHandler( "clk_ventilationwindow_button_beg" );

  local func_end = function ()
    
    local func_end_2 = function () 
      
      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_ventilationwindow_button" );
      cmn.CallEventHandler( "clk_ventilationwindow_button_end" ); 
    
    end;  
    
    ObjAnimate( "vid_ventilationwindow_ventilationcycle", "alp", 0, 0, "", { 0, 0, 1,   0.3, 3, 0 } );  
    ObjAnimate( "vid_ventilationwindow_ventilationstop", "alp", 0, 0, "", { 0, 0, 0,   0.3, 3, 1 } );    
    VidPlay( "vid_ventilationwindow_ventilationstop", func_end_2 );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_vent_off", 0, "", 0 );
  common_impl.StopAudio( "env", "level1/env/aud_ventilation_env", 0 );
  
  AnimPlay( "anm_ventilationwindow_button_2", "button_2", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_closedroom_crate_1 ()
  
  cmn.CallEventHandler( "clk_closedroom_crate_1_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_closedroom_crate_1" );
    cmn.CallEventHandler( "clk_closedroom_crate_1_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_wood_low", 0, "", 0 );
  
  AnimPlay( "anm_closedroom_crate_1", "crate_1", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_closedroom_crate_2 ()
  
  cmn.CallEventHandler( "clk_closedroom_crate_2_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_closedroom_crate_2" );
    cmn.CallEventHandler( "clk_closedroom_crate_2_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_wood2_low", 0, "", 0 );
  
  AnimPlay( "anm_closedroom_crate_2", "crate_2", func_end );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** MMG FLOORLAMP *** () end;
--*********************************************************************************************************************

  private.gamedata_floorlamp = {};

  -- balls color ID: 0 - white, 1 - orange, 
  -- 2 - blue, 3 - pink, 4 - green, 5 - red 
  private.win_floorlamp = { 1, 5, 3, 0, 4, 2 }; 

  private.slots_coordinates_floorlamp = {
                                          { pos_x = 67, pos_y = -45 },
                                          { pos_x = 110, pos_y = -44 },
                                          { pos_x = 154, pos_y = -42 },
                                          { pos_x = 110, pos_y = 24 },
                                          { pos_x = 65, pos_y = 80 },
                                          { pos_x = 154, pos_y = 90 },
                                        }; 

  private.slots_links_floorlamp = {
                                    { 2, 5 },
                                    { 1, 3, 4 },
                                    { 2, 6 },
                                    { 2, 5, 6 },
                                    { 1, 4, 6 },
                                    { 3, 4, 5 }
                                  };


  private.FLOORLAMP_RUNNER_NAME = "spr_floorlamp_button_";

  private.FLOORLAMP_RUNNERS_COUNT = 5;
  private.FLOORLAMP_SLOTS_COUNT = 6;
  private.FLOORLAMP_EMPTY_SLOT = 0;


  --*******************************************************************************************************************
  function private.FloorlampDefault ()

    ng_global.progress[ "std" ][ "win_floorlamp" ].states = { 5, 4, 2, 0, 3, 1 };

  end; 


  --*******************************************************************************************************************
  function private.FloorlampLoad ()

    if ( not ng_global.progress[ "std" ][ "win_floorlamp" ].states ) then 

      private.FloorlampDefault();

    end; 

    private.gamedata_floorlamp = ng_global.progress[ "std" ][ "win_floorlamp" ];
    
  end;


  --*******************************************************************************************************************
  function private.FloorlampLogicInit ()   

    for i = 1, private.FLOORLAMP_RUNNERS_COUNT, 1 do

      local curRunner = private.FLOORLAMP_RUNNER_NAME..i;

      ObjSet( curRunner, { 
                            input = true,
                            event_mdown = function () private.FloorlampClick( i ); end,
                            event_menter = function () private.FloorlampEnter( i ); end,
                            event_mleave = function () private.FloorlampLeave( i ); end
                       } );

    end;

  end;


  --*******************************************************************************************************************
  function private.FloorlampEnter ( runnerID )
   
    SetCursor( CURSOR_HAND );

    local current = private.FLOORLAMP_RUNNER_NAME..runnerID.."_focus";
    local alpha = ObjGet( current ).alp;
    ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

  end;


  --*******************************************************************************************************************
  function private.FloorlampLeave ( runnerID )  

    SetCursor( CURSOR_DEFAULT );
    
    local current = private.FLOORLAMP_RUNNER_NAME..runnerID.."_focus";
    local alpha = ObjGet( current ).alp;
    ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );

  end;
  

  --*******************************************************************************************************************
  function private.FloorlampClick ( runnerID ) 
    
    local func_end = function()

      cmn.Lock( false );
      private.FloorlampUpdate();
   
    end;  

    local curSlotID = private.FloorlampGettingSlotID( runnerID );
    local nextSlotID = private.FloorlampGettingNextSlotID( curSlotID );

    if nextSlotID then

      local curRunner = private.FLOORLAMP_RUNNER_NAME..runnerID;

      local curSlotX = private.slots_coordinates_floorlamp[ curSlotID ].pos_x;
      local curSlotY = private.slots_coordinates_floorlamp[ curSlotID ].pos_y;

      local nextSlotX = private.slots_coordinates_floorlamp[ nextSlotID ].pos_x;
      local nextSlotY = private.slots_coordinates_floorlamp[ nextSlotID ].pos_y;

      local temp = private.gamedata_floorlamp.states[ curSlotID ];
      private.gamedata_floorlamp.states[ curSlotID ] = private.FLOORLAMP_EMPTY_SLOT;
      private.gamedata_floorlamp.states[ nextSlotID ] = temp;

      cmn.Lock( true );
      
      ObjAnimate( curRunner, "pos_xy",0,0, func_end, { 0, 3, curSlotX, curSlotY,    0.4, 3, nextSlotX, nextSlotY } );
      
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_plastic_button", 0, "", 0 );

    end; 

  end; 


  --*******************************************************************************************************************
  function private.FloorlampGettingSlotID ( runnerID ) 

    local slotID = 1; 

    for i = 1, private.FLOORLAMP_SLOTS_COUNT, 1 do

      if runnerID == private.gamedata_floorlamp.states[ i ] then

        slotID = i;
        break; 

      end;

    end;

    return slotID; 

  end;


  --*******************************************************************************************************************
  function private.FloorlampGettingNextSlotID ( curSlotID )  

    local curSlotLinks = private.slots_links_floorlamp[ curSlotID ];
    local nextSlotID = nil;

    for i = 1, #curSlotLinks, 1 do

      local nextRunnerID = private.gamedata_floorlamp.states[ curSlotLinks[ i ] ];

      if nextRunnerID == private.FLOORLAMP_EMPTY_SLOT then

        nextSlotID = curSlotLinks[ i ];
        break; 

      end; 

    end;

    return nextSlotID; 

  end; 
    

  --*******************************************************************************************************************
  function private.FloorlampUpdate () 

    for i = 1, private.FLOORLAMP_SLOTS_COUNT, 1 do
      
      local curRunnerID = private.gamedata_floorlamp.states[ i ];
      
      if curRunnerID ~= private.FLOORLAMP_EMPTY_SLOT then 

        local curRunner = private.FLOORLAMP_RUNNER_NAME..curRunnerID;
        local curRunnerX = private.slots_coordinates_floorlamp[ i ].pos_x;
        local curRunnerY = private.slots_coordinates_floorlamp[ i ].pos_y;

        ObjSet( curRunner, { pos_x = curRunnerX, pos_y = curRunnerY } );

      end;

    end; 

    if ( private.FloorlampCheckWin() and 
    not cmn.IsEventDone( "win_floorlamp" ) ) then

      private.FloorlampWin(); 

    end; 

  end;


  --*********************************************************************************************************************
  function private.FloorlampCheckWin ()

    local count = 0;
    local result = false; 

    for i = 1, private.FLOORLAMP_SLOTS_COUNT, 1 do

      if private.win_floorlamp[ i ] == private.gamedata_floorlamp.states[ i ] then 

        count = count + 1; 

      end;

    end; 

    if count == private.FLOORLAMP_SLOTS_COUNT then 

      result = true; 

    end;

    return result; 

  end;


  --*******************************************************************************************************************
  function private.FloorlampWin () 
    
    cmn.MiniGameHide( "floorlamp" );
    
    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "win_floorlamp" );
      cmn.CallEventHandler( "win_floorlamp" );
      
      common_impl.PassingMgWin( "floorlamp" );       
            
    end;  
    
    local func_end_3 = function ()
      
      ObjAnimate( "spr_floorlamp_doll_dark", "alp",0,0, func_end, { 0, 0, 1,    0.1, 0, 1,    0.6, 0, 0 } );
      
      ObjMultiSet( { 
        { "spr_floorlamp_back_light",  { alp = 0, visible = true } },
        { "spr_floorlamp_path_lamp_light",  { alp = 0, visible = true } },
        { "spr_floorlamp_button",  { alp = 1, visible = true } },
        { "anm_floorlamp_lightbad",  { alp = 0, visible = false } },
      } );
      
      ObjAnimate( "spr_floorlamp_back_light", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 1 } );
      ObjAnimate( "spr_floorlamp_path_lamp_light", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 1 } );
     
    end;
    
    local func_end_2 = function ()
      
      ObjMultiSet( { 
        { "anm_floorlamp_lightbad",  { alp = 1, visible = true } },
        { "spr_floorlamp_button_before",  { alp = 0, visible = false } },
      } );
      AnimPlay( "anm_floorlamp_lightbad", "lightbad", func_end_3 );
      
    end;
    
    cmn.Lock( true );
    
    common_impl.PlayAudio( "sfx", "aud_win_mmg" );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_win_lamp", 0, "", 0 );
    
    local trgAfter = "";
    
    for i = 1, 5, 1 do 
      
      if ( i == 5 ) then 
        
        trgAfter = func_end_2;
        
      end;
    
      local curRunnerLight = private.FLOORLAMP_RUNNER_NAME..i.."_light";
      ObjAnimate( curRunnerLight, "alp",0,0, trgAfter, { 0, 3, 0,    0.6, 3, 1,    1.0, 3, 0,    1.5, 3, 1,    2.6, 3, 0 } );
      
    end;
    
  end;

--*********************************************************************************************************************
-- function *** MMG SINK1 *** () end;
--*********************************************************************************************************************

  private.gamedata_sink_1 = {};

  private.win_sink_1  = { 1, 2, 3, 5, 4, 6 }; 

  private.slots_coordinates_sink_1  = {
                                          { pos_x = -110, pos_y = -45 },
                                          { pos_x = -3, pos_y = -45 },
                                          { pos_x = 104, pos_y = -45 },
                                          { pos_x = -108, pos_y = 55 },
                                          { pos_x = 1, pos_y = 55 },
                                          { pos_x = 107, pos_y = 55 },
                                        }; 

  private.SINK_1_RUNNER_NAME   = "spr_sink_1_flower_";
  private.SINK_1_RUNNERS       = { 0, 0 };
  private.SINK_1_RUNNERS_COUNT = 6;

  --*******************************************************************************************************************
  function private.Sink1Default ()

    ng_global.progress[ "std" ][ "win_sink_1" ].states = { 3, 5, 6, 1, 2, 4 };

  end; 


  --*******************************************************************************************************************
  function private.Sink1Load ()

    if ( not ng_global.progress[ "std" ][ "win_sink_1" ].states ) then 

      private.Sink1Default();

    end; 

    private.gamedata_sink_1 = ng_global.progress[ "std" ][ "win_sink_1" ];
    private.Sink1LogicInit(); 
    
  end;


  --*******************************************************************************************************************
  function private.Sink1LogicInit ()   

    for i = 1, private.SINK_1_RUNNERS_COUNT, 1 do

      local curRunner = private.SINK_1_RUNNER_NAME..i;
      
      ObjSet( curRunner, { 
                            input = true,
                            event_mdown = function () private.Sink1Click( i ); end,
                            event_menter = function () private.Sink1Enter( i ); end,
                            event_mleave = function () private.Sink1Leave( i ); end
                       } );
                            
    end;
                          
    for i = 5, 6 do

      local curRunner   = private.SINK_1_RUNNER_NAME..i;
                            
      ObjSet( curRunner, { 
                            event_menter = function () private.Sink1Enter(); end,
                            event_mleave = function () private.Sink1Leave(); end
                       } );
                            
    end;
                          
  end;


  --*******************************************************************************************************************
  function private.Sink1Enter ( runnerID )
 
    SetCursor( CURSOR_HAND );
    
    --if ( runnerID ) then 
    --  
    --  local current = private.SINK_1_RUNNER_NAME..runnerID;
    --  local scale = ObjGet( current );
    --  ObjAnimate( current, "scale_xy",0,0, "", { 0, 0, scale.scale_x, scale.scale_y,    0.2 * ( 1.5 - scale.scale_x ), 0, 1.05, 1.05 } );
    --
    --end;
  
  end;


  --*******************************************************************************************************************
  function private.Sink1Leave ( runnerID )
      
    SetCursor( CURSOR_DEFAULT );
    
    --if ( runnerID ) then 
    --  
    --  local current = private.SINK_1_RUNNER_NAME..runnerID;
    --  local scale = ObjGet( current );
    --  ObjAnimate( current, "scale_xy",0,0, "", { 0, 0, scale.scale_x, scale.scale_y,    0.2 * ( 1.5 - scale.scale_x ), 0, 1, 1 } );
    --
    --end;
  
  end;
  

  --*******************************************************************************************************************
  function private.Sink1Click ( runnerID ) 
    
    local flag = false;
    
    for i = 1,#private.SINK_1_RUNNERS do
      
      if ( private.SINK_1_RUNNERS[ i ] == 0 ) then
        
       if not ( i == 1 and ( runnerID == 5 or runnerID == 6 ) ) then
        
         local current = private.SINK_1_RUNNER_NAME..runnerID;       
         private.SINK_1_RUNNERS[ i ] = runnerID;
         ObjSet( current, { input = false } );
         
         if ( runnerID ) then 
           
           local current = private.SINK_1_RUNNER_NAME..runnerID;
           local scale = ObjGet( current );
           ObjAnimate( current, "scale_xy",0,0, "", { 0, 0, scale.scale_x, scale.scale_y,    0.2 * ( 1.5 - scale.scale_x ), 0, 1.1, 1.1 } );
       
           common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_button2", 0, "", 0 );

         end;
         
         if ( i == 2 ) then
          flag = true;
         end;
        
         break
         
       else 
         
         break
         
       end;
       
      end;
    
    end;
     
    if ( flag ) then  

      local curSlotID1 = private.Sink1GettingSlotID( private.SINK_1_RUNNERS[ 1 ] );
      local curSlotID2 = private.Sink1GettingSlotID( private.SINK_1_RUNNERS[ 2 ] );
      
      local func_end = function()

        cmn.Lock( false );
        
        local tmp1 = private.gamedata_sink_1.states[ curSlotID1 ];
        local tmp2 = private.gamedata_sink_1.states[ curSlotID2 ];
        
        private.gamedata_sink_1.states[ curSlotID1 ] = tmp2;
        private.gamedata_sink_1.states[ curSlotID2 ] = tmp1;
        
        private.Sink1Update();
     
      end;  
      
      local curRunner1 = private.SINK_1_RUNNER_NAME..private.SINK_1_RUNNERS[ 1 ];
      local curRunner2 = private.SINK_1_RUNNER_NAME..private.SINK_1_RUNNERS[ 2 ];
 
      local curSlot  = private.slots_coordinates_sink_1[ curSlotID1 ];
      local nextSlot = private.slots_coordinates_sink_1[ curSlotID2 ];

      cmn.Lock( true );
      
      ObjSet( curRunner1, { pos_z = 5 } );
      ObjSet( curRunner2, { pos_z = 5 } );
      
      ObjAnimate( curRunner1, "pos_xy",0,0, "", { 0, 3, curSlot.pos_x, curSlot.pos_y,    1.2, 3, nextSlot.pos_x, nextSlot.pos_y } );
      ObjAnimate( curRunner2, "pos_xy",0,0, "", { 0, 3, nextSlot.pos_x, nextSlot.pos_y,    1.2, 3, curSlot.pos_x, curSlot.pos_y } );
      
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_flower_button", 0, "", 0 );

      local scale1 = ObjGet( curRunner1 );
      local scale2 = ObjGet( curRunner2 );
      
      ObjAnimate( curRunner1, "scale_xy",0,0, "", { 0, 0, scale1.scale_x, scale1.scale_y,    0.6, 0, 1.2, 1.2,    1.2, 0, 1, 1 } ); 
      ObjAnimate( curRunner2, "scale_xy",0,0, "", { 0, 0, scale2.scale_x, scale2.scale_y,    0.6, 0, 1.2, 1.2,    1.2, 0, 1, 1 } ); 
      ObjAnimate( "obj_sink_1_mmg", "alp",0,0, func_end, { 0, 0, 1,     1.2, 0, 1 } ); 
      
    end;
    
  end; 


  --*******************************************************************************************************************
  function private.Sink1GettingSlotID ( runnerID ) 

    local slotID = 1; 

    for i = 1, private.SINK_1_RUNNERS_COUNT, 1 do

      if runnerID == private.gamedata_sink_1.states[ i ] then

        slotID = i;
        break; 

      end;

    end;

    return slotID; 

  end;

  --*******************************************************************************************************************
  function private.Sink1Update () 
    
    private.SINK_1_RUNNERS = { 0, 0 };
    
    for i = 1, private.SINK_1_RUNNERS_COUNT, 1 do
      
      local curRunnerID = private.gamedata_sink_1.states[ i ];
      
      local curRunner = private.SINK_1_RUNNER_NAME..curRunnerID; 
      
      if curRunnerID ~= private.SINK_1_EMPTY_SLOT then 

        local curRunnerX = private.slots_coordinates_sink_1[ i ].pos_x;
        local curRunnerY = private.slots_coordinates_sink_1[ i ].pos_y;

        ObjSet( curRunner, { pos_x = curRunnerX, pos_y = curRunnerY, pos_z = 2, input = true, scale_x = 1, scale_y = 1 } );
        
      end;

    end; 
     
    if ( private.Sink1CheckWin() and 
      not cmn.IsEventDone( "win_sink_1" ) ) then

      private.Sink1Win(); 

    end; 

  end;


  --*********************************************************************************************************************
  function private.Sink1CheckWin ()

    local count = 0;
    local result = false; 

    if ( private.win_sink_1[ 1 ] == private.gamedata_sink_1.states[ 1 ] and
         private.win_sink_1[ 2 ] == private.gamedata_sink_1.states[ 2 ] and
         private.win_sink_1[ 3 ] == private.gamedata_sink_1.states[ 3 ] and
         private.win_sink_1[ 5 ] == private.gamedata_sink_1.states[ 5 ] ) then 

      result = true; 

    end;

    return result; 

  end;


  --*******************************************************************************************************************
  function private.Sink1Win () 
    
    cmn.MiniGameHide( "sink_1" );
    
    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "win_sink_1" );
      cmn.CallEventHandler( "win_sink_1" );

      common_impl.PassingMgWin( "sink_1" );  
      
    end;  
    
    cmn.Lock( true );
    
    common_impl.PlayAudio( "sfx", "aud_win_mmg" );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_flower_panel", 0, "", 0 );

    ObjAnimate( "spr_sink_1_door", "pos_y",0,0, func_end, { 0, 3, 18,    1.5, 3, -300 } );
    
  end;

--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;

--*********************************************************************************************************************
function private.SeeIntro ()

  ObjDelete( "tmr_closedroom_intro" ); 

  local func_end = function ( skip )
  
    if skip then
  
      --common_impl.StopAudio( "mus", "level1/mus/aud_intro_mus",  0.2 );
      --common_impl.StopAudio( "voc", "level1/voc/aud_intro_porch_voc",  0.2 );
      common_impl.StopAudio( "sfx", "level1/sfx/aud_intro_lvl1",      0.2 );
      
    end;
    
    ObjSet( private.room_objname, { color_r = 1, color_g = 1, color_b = 1 } );

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

    cmn.SetEventDone( "see_intro" );
    cmn.CallEventHandler( "see_intro" );
    
    interface.KeyTaskAdd( "escape" );

    common_impl.ShowBbt( 'bbt_entrancedoor_see_intro' );

    private.StartAnimSteps();

  end;

  --common_impl.PlayAudio( "voc", "level1/voc/aud_intro_porch_voc",  0, "", 0 );
  --common_impl.PlayAudio( "mus", "level1/mus/aud_intro_mus",  0, "", 0 );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_intro_lvl1",      0, "", 0 );

  cmn.PlayDialogVideo( "vid_closedroom_intro", func_end );

end;

--*********************************************************************************************************************
function private.see_closedroom_1 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_closedroom_1" );
    cmn.CallEventHandler( "see_closedroom_1" );
 
    common_impl.ShowBbt( 'bbt_closedroom_see_closedroom_1' );
    
    common_impl.TutorialShow( "tutorial_page_1" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_closed_door", 0, "", 0 );

  ObjSet( "anm_closedroom_closed_number_1", { alp = 1 } );
  AnimPlay( "anm_closedroom_closed_number_1", "DoAnim", func_end );

end;

--------------------------------------------------------------------------------------------
function private.see_entrancedoor ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_entrancedoor" );
    cmn.CallEventHandler( "see_entrancedoor" );

    common_impl.ShowBbt( 'bbt_entrancedoor_see_entrancedoor' );
    
    common_impl.TutorialShow( "tutorial_page_3" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_door", 0, "", 0 );

  ObjSet( "anm_entrancedoor_door", { alp = 1 } );
  AnimPlay( "anm_entrancedoor_door", "DoAnim", func_end );
  ObjAnimate( "anm_entrancedoor_dust", "alp", 0, 0, "", { 0, 0, 1,   0.5, 3, 0,   3.4, 3, 0,  3.7, 3, 1 } );
  
end;
--------------------------------------------------------------------------------------------
function private.see_closedroom_lamp ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_closedroom_lamp" );
    cmn.CallEventHandler( "see_closedroom_lamp" );

    common_impl.ShowBbt( 'bbt_closedroom_see_closedroom_lamp' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_lamp", 0, "", 0 );

  AnimPlay( "anm_closedroom_lamp", "blowing", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_closedroom_bats ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_closedroom_bats" );
    cmn.CallEventHandler( "see_closedroom_bats" );

    common_impl.ShowBbt( 'bbt_closedroom_see_closedroom_bats' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_bat", 0, "", 0 );

  AnimPlay( "anm_closedroom_bat_1", "bat_1", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_closedroom_destruction ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_closedroom_destruction" );
    cmn.CallEventHandler( "see_closedroom_destruction" );

    common_impl.ShowBbt( 'bbt_closedroom_see_closedroom_destruction' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_destruction", 0, "", 0 );

  AnimPlay( "anm_closedroom_destruction", "destruction", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_sink_scare ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_sink_scare" );
    cmn.CallEventHandler( "see_sink_scare" );

    common_impl.ShowBbt( 'bbt_closedroom_see_sink_scare' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_mirror_water", 0, "", 0 );

  AnimPlay( "anm_sink_hand", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_closedroom ()

  if not ( cmn.IsEventDone( "opn_closedroom" ) ) then

    cmn.SetEventDone( "opn_closedroom" );
    
  else 
    
    if not ( cmn.IsEventDone( "see_closedroom_bats" ) ) then

      private.see_closedroom_bats();
      
    end;
  
  end;
  cmn.CallEventHandler( "opn_closedroom" ); 
  private.dark = 1;
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
  cmn.AnimateAmbientLight( "spr_floorlamp_light" );

end;
--------------------------------------------------------------------------------------------
function private.StartAnimSteps ()

  AnimPlay( "anm_closedroom_steps", "steps", "" );

  if private.audioRmClosedroom == false  then
    private.audioRmClosedroom = true;
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_footstep", 0, "", 0 );
  end;

end;
--------------------------------------------------------------------------------------------
function private.StopAnimSteps ()

  AnimStop( "anm_closedroom_steps" );
  common_impl.StopAudio( "sfx", "level1/sfx/aud_sc_footstep", 0.5 );

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.UseRubbertoy ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_ventilationwindow_use_rubbertoy' );
    
    ObjMultiSet( {
  
      { "vid_ventilationwindow_wire_hh", { alp = 0 } };
      { "vid_ventilationwindow_wire", { alp = 1 } };
    
    } );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_electr", 0, "", 0 );

  ObjMultiSet( {
  
    { "vid_ventilationwindow_wire_hh", { alp = 1 } };
    { "vid_ventilationwindow_wire", { alp = 0 } };
  
  } );
  
  VidPlay( "vid_ventilationwindow_wire_hh", func_end )
  
end;
--------------------------------------------------------------------------------------------
function private.UseSharptooth ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_ventilationwindow_use_sharptooth' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_panel_mid", 0, "", 0 );

  ObjAnimate( "spr_ventilationwindow_door_1", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1,1,   0.4, 3, 0, 0 } );
  ObjAnimate( "spr_ventilationwindow_rope", "pos_xy", 0, 1, "", { 0, 0, 0, 0,   0.2, 3, -2,-1,   0.4, 3, 0, 0 } );
  ObjAnimate( "spr_ventilationwindow_door_2", "pos_xy", 0, 1, "", { 0, 0, 0, 0,   0.2, 3, -1,-1,   0.4, 3, 0, 0 } );
  
end;
--------------------------------------------------------------------------------------------
function private.UseButton ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_ventilationwindow_use_button' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_spring", 0, "", 0 );

  AnimPlay( "anm_ventilationwindow_spring", "spring", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.UseCorkscrew ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_sink_use_corkscrew' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_cork", 0, "", 0 );

  ObjAnimate( "spr_sink_cork", "scale_xy", 0, 1, func_end, { 0, 0, 1, 1,   0.2, 3, 0.95, 1,   0.4, 3, 1, 1 } );
  
end;
--------------------------------------------------------------------------------------------
function private.UseScreen ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_sink_use_screen' );
    AnimPlay( "anm_sink_rat", "rat_static", "" );  
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_rat", 0, "", 0 );
  AnimPlay( "anm_sink_rat", "rat_click", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.UseTorch ()
  
  local func_end = function ()
    
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_closedroom_use_torch' );
    
  end;
  
  if private.dark == 3 then
    
    private.dark = 1;
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_shadow", 0, "", 0 );
    AnimPlay( "anm_closedroom_horror", "horror", func_end );
    
  else
    
    private.dark = private.dark + 1;
    common_impl.ShowBbt( 'bbt_closedroom_use_torch' );
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.UseOrnamental ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_sink_use_ornamental_chandelier' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_mid", 0, "", 0 );

  ObjAnimate( "spr_sink_patch_door_2", "scale_xy", 0, 1, func_end, { 0, 0, 1, 1,   0.2, 3, 0.97, 0.97,   0.4, 3, 1, 1 } );
  
end;
--------------------------------------------------------------------------------------------
function private.UseTinywire ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_floorlamp_use_tinywire' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_high", 0, "", 0 );

  ObjAnimate( "anm_floorlamp_wire_off", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1,0,   0.4, 3, 0, 0 } );
  
end;
--------------------------------------------------------------------------------------------
function private.UseEye ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_floorlamp_use_eye' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_laugh", 0, "", 0 );

  AnimPlay( "anm_floorlamp_jowl", "jowl", func_end )
  
end;
--------------------------------------------------------------------------------------------
function private.UseStone ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_sink_use_stone' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_mirror", 0, "", 0 );

  AnimPlay( "anm_sink_mirror", "mirror_click", func_end )
  
end;
--------------------------------------------------------------------------------------------
function private.UseMagnet ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_sink_use_magnet' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal4", 0, "", 0 );

  AnimPlay( "anm_sink_wire", "wire_click", func_end )
  
end;
--------------------------------------------------------------------------------------------
function private.UseLockpick ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_entrancedoor_use_lockpick' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_low_door", 0, "", 0 );

  AnimPlay( "anm_entrancedoor_wire_hh", "hh", func_end )
  
end;