-- name=rm_demo
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "rm_demo";
  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.InitAnimations();
  
  ObjSet( "btn_demo_buttons", { 
    event_mdown = function () private.ButtonMouseClick(); end,
    event_menter = function () private.ButtonMouseEnter(); end,
    event_mleave = function () private.ButtonMouseLeave(); end 
  });
  
  if IsSurveyEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_survey" } );

  elseif IsDemoEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_demo" } );

  end;
  
  common_impl.hint[ "opn_demo" ] = {
    room = private.room_objname
  };

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  --[[if not ( cmn.IsEventDone( "opn_demo" ) ) then
    cmn.SetEventDone( "opn_demo" );
  end;]]


  if not ( ( IsSurveyEdition() ) or ( IsDemoEdition() ) ) then

    SetCursor(CURSOR_DEFAULT);
    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level2";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;

    common.LevelSwitch( level );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  ObjSet( "spr_demo_ce", { visible = IsCollectorsEdition() } );

  local mas_widgets = {

    InterfaceWidget_BtnMenu
    ,InterfaceWidget_BtnHint
    ,InterfaceWidget_BtnSkip
    ,InterfaceWidget_BtnInfo
    ,InterfaceWidget_BtnReset
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_TaskPanel
    ,InterfaceWidget_BtnMap
    ,InterfaceWidget_DialogHo
    ,InterfaceWidget_ItemPanel 
    ,InterfaceWidget_Popup
    ,InterfaceWidget_Window
    ,InterfaceWidget_Map
    ,InterfaceWidget_Deploy_Inv
    ,InterfaceWidget_Dialog_Hint
    ,InterfaceWidget_BlackBarText

  };

  if IsCollectorsEdition() or IsSurveyEdition() then

    if IsCollectorsEdition() then

      table.insert( mas_widgets, InterfaceWidget_BtnGuide );

    end;

    table.insert( mas_widgets, InterfaceWidget_collectibles2 );
    table.insert( mas_widgets, InterfaceWidget_collectibles );
    table.insert( mas_widgets, InterfaceWidget_achievements );
    table.insert( mas_widgets, InterfaceWidget_morph );

  end;

  local prg = ng_global.currentprogress;

  if ng_global.progress[ prg ].common.chapter == "levelext" then

    table.insert( mas_widgets, InterfaceWidget_Slider );

  end;

  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[i], false, true );   
    interface.WidgetSetInput( mas_widgets[i], false );    

  end;

  if string.find( common.GetCurrentRoom(), "ho_" ) then
    ObjSet( "obj_int_inventory_impl_root", { visible = false, input = false } );
  end;

  if ( (IsSurveyEdition() ) or ( IsDemoEdition()) ) then

    ObjAnimate( "rm_demo", "color_rgb", 0, 0, "", 
    { 
      0.0, 0, 0, 0, 0,
      0.3, 0, 0, 0, 0,
      0.5, 0, 1, 1, 1
    } );

    interface.InterfaceSetInput( 0 ); 
    interface.InterfaceSetVisible( 0, 0 );

  else

    ObjSet( "rm_demo", 
    { 
      color_r = 0.0,
      color_g = 0.0,
      color_b = 0.0
    } );

    interface.InterfaceSetInput( 0 ); 
    interface.InterfaceSetVisible( 0, 0 );

  end;

  common_impl.PlayAudio( "mus", "aud_main_theme_mus", 1 );
  common_impl.PlayAudio( "env", "aud_mainmenu_env", 1, "", 0 );

end;
--*********************************************************************************************************************
function public.Close()

  local mas_widgets = {

    InterfaceWidget_BtnMenu
    ,InterfaceWidget_BtnHint
    ,InterfaceWidget_BtnSkip
    ,InterfaceWidget_BtnInfo
    ,InterfaceWidget_BtnReset
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_TaskPanel
    ,InterfaceWidget_BtnMap
    ,InterfaceWidget_DialogHo
    ,InterfaceWidget_ItemPanel 
    ,InterfaceWidget_Popup
    ,InterfaceWidget_Window
    ,InterfaceWidget_Map
    ,InterfaceWidget_Deploy_Inv
    ,InterfaceWidget_Dialog_Hint
    ,InterfaceWidget_BlackBarText

  };

  if IsCollectorsEdition() or IsSurveyEdition() then

    if IsCollectorsEdition() then

      table.insert( mas_widgets, InterfaceWidget_BtnGuide );

    end;

    table.insert( mas_widgets, InterfaceWidget_collectibles2 );
    table.insert( mas_widgets, InterfaceWidget_collectibles );
    table.insert( mas_widgets, InterfaceWidget_achievements );
    table.insert( mas_widgets, InterfaceWidget_morph );

  end;

  local prg = ng_global.currentprogress;

  if ng_global.progress[ prg ].common.chapter == "levelext" then

    table.insert( mas_widgets, InterfaceWidget_Slider );

  end;

  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[i], true, true );   
    interface.WidgetSetInput( mas_widgets[i], true );    

  end;

  if string.find( common.GetCurrentRoom(), "ho_" ) then
    ObjSet( "obj_int_inventory_impl_root", { visible = true, input = true } );
  end;

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.ButtonMouseEnter()

  SetCursor( CURSOR_HAND );  
  local but_name = "spr_demo_ok_focus";
  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - but_alp ) ), 0, 1 } );

end;
--*********************************************************************************************************************
function private.ButtonMouseLeave()

  SetCursor( CURSOR_DEFAULT );  
  local but_name = "spr_demo_ok_focus";
  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * but_alp ), 0, 0 } );

end;
--*********************************************************************************************************************
function private.ButtonMouseClick()

  if ( IsSurveyEdition() ) then

    --local guide_url = GetGuideUrl();
    --OpenBrowser( guide_url );

    Quit();

  else

    SaveProfiles();
    SaveSettings();

--  common.SaveInterfaceTimers();
    SetCursor( CURSOR_DEFAULT );
    common.LevelSwitch( "menu", "game" );

  end;  

end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
end;