-- name=rm_hall
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hall";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_recepton", "room_hub" );
  ObjAttach( "zz_fountain", "room_hub" );
  ObjAttach( "zz_luster",   "room_hub" );
  ObjAttach( "zz_portrait", "room_hub" );
  ObjAttach( "zz_winch",    "room_hub" );

  private.Init_Subroom();
  private.InitAnimations();
  
  private.anim_ghost = false;
  private.winch_cap_close = false;
  
  ObjMultiSet({ 
    { "spr_recepton_battery_1",           { event_mdown = private.get_battery_1         }},
    { "spr_fountain_lock",                { event_mdown = private.get_lock              }},
    { "spr_fountain_battery_2",           { event_mdown = private.get_battery_2         }},

    { "obj_hall_clk_outro",               { event_mdown = private.see_hall_outro        }},

    { "obj_portrait_use_familyportrait",  { event_mdown = private.AnimUseFamilyportrait }},
    { "obj_portrait_clk_portrait_symbol", { event_mdown = private.clk_portrait_symbol   }},
    { "obj_fountain_use_pruners",         { event_mdown = private.AnimUsePruners        }},  
    { "obj_luster_use_lock",              { event_mdown = private.AnimUseLock           }},  
    { "obj_recepton_use_screwdriver",     { event_mdown = private.AnimUseScrewdriver    }},  
    { "obj_recepton_use_cleaningagen",    { event_mdown = private.AnimUseCleaningagen   }},  
    
    { "obj_winch_clk_close",              { event_mdown = private.WinchCapClose         }},  
    { "obj_winch_clk_open",               { event_mdown = private.WinchCapOpen          }},  
    
    { "spr_hall_collect_morph_item",      { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_5" ); end } },
      
    { "spr_fountain_collect2_item_3",     { event_mdown = private.get_collect2_item_3   } },
    
    { "spr_hall_letter",                  { event_mdown = function() cmn.NoteScale( "spr_hall_letter" ) end; }},
    { "spr_hall_letter_big",              { event_mdown = function() cmn.NoteScale( "spr_hall_letter" ) end; }},

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_hall = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gho_hall_portraithall",
      "gzz_hall_recepton",
      "gzz_hall_fountain",
      "gzz_hall_luster",
      "gzz_hall_portrait",
      "gzz_hall_winch",
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_recepton",
      "zz_fountain",
      "zz_luster",
      "zz_portrait",
      "zz_winch",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_hall", update_game_mode_hall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_hall = function ()

    local effects_table = 
    {
      "obj_hall_anim", 
      "obj_hall_anim1" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_hall", update_performance_mode_hall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_hall () end;
  --------------------------------------------------------------------------------------------
  local opn_hall_map = function ()

    common_impl.VisitMapRoom( "hall" );

  end;
  cmn.AddSubscriber( "opn_hall", opn_hall_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_battery_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_battery_1" ] = {
    type = "get",
    get_obj = "spr_recepton_battery_1",
    room = private.room_objname,
    zz = "zz_recepton",
    zz_gate = "gzz_hall_recepton"
  };
  
  local get_battery_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_battery_1", "spr_recepton_battery_1" );
    cmn.SetInvPlusRGB( "torchnobatteries", true );
  
  end;
  
  local get_battery_1_closezz = function ()
  
    ObjDelete( "gfx_recepton_battery_1" );
    ObjDelete( "gzz_hall_recepton" );
  
  end;
  
  cmn.AddSubscriber( "get_battery_1", get_battery_1_inv );
  cmn.AddSubscriber( "get_battery_1", get_battery_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lock () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lock" ] = {
    type = "get",
    get_obj = "spr_fountain_lock",
    room = private.room_objname,
    zz = "zz_fountain",
    zz_gate = "gzz_hall_fountain"
  };
  
  local get_lock_inv = function ()
  
    interface.InventoryItemAdd( "inv_lock", "spr_fountain_lock" );
  
  end;
  
  local get_lock_closezz = function ()
  
    ObjDelete( "gfx_fountain_lock" );
    ObjDelete( "spr_hall_states_zz_fountain_lock" );
    
    if ( cmn.IsEventDone( "get_battery_2" ) and
    cmn.IsGetCollect2( "get_collect2_item_3" ) ) then
      
      ObjDelete( "gzz_hall_fountain" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_lock", get_lock_inv );
  cmn.AddSubscriber( "get_lock", get_lock_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_battery_2" ] = {
    type = "get",
    get_obj = "spr_fountain_battery_2",
    room = private.room_objname,
    zz = "zz_fountain",
    zz_gate = "gzz_hall_fountain"
  };
  
  local get_battery_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_battery_2", "spr_fountain_battery_2" );
    cmn.SetInvPlusRGB( "torchnobatteries", true );
  
  end;
  
  local get_battery_2_closezz = function ()
  
    ObjDelete( "gfx_fountain_battery_2" );
    
    if ( cmn.IsEventDone( "get_lock" ) and 
    cmn.IsGetCollect2( "get_collect2_item_3" ) ) then
      
      ObjDelete( "gzz_hall_fountain" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_battery_2", get_battery_2_inv );
  cmn.AddSubscriber( "get_battery_2", get_battery_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_2" ] = {
    type = "use",
    inv_obj = "inv_screwdriver",
    use_place = "obj_recepton_use_screwdriver",
    room = private.room_objname,
    zz = "zz_recepton",
    zz_gate = "gzz_hall_recepton"
  };
  local use_screwdriver_2_inv = function ()
  
    if ( cmn.IsEventDone( "use_screwdriver_1" ) ) then

      interface.InventoryItemRemove( "inv_screwdriver" );
      
    end;
  
  end;
  local use_screwdriver_2_beg = function ()
  
    ObjDelete( "obj_recepton_use_screwdriver" );
  
  end;
  local use_screwdriver_2_end = function ()
   
    ObjMultiSet( { 
      { "spr_recepton_battery_1", {  input = true } },
      { "gfx_recepton_battery_1", { active = true } },
      { "spr_hall_states_zz_recepton_patch_fan_2", { alp = 1, visible = true } },
    } );

    ObjDelete( "spr_recepton_door" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_2", use_screwdriver_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2", use_screwdriver_2_inv );
  cmn.AddSubscriber( "use_screwdriver_2", use_screwdriver_2_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_inv", use_screwdriver_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_beg", use_screwdriver_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_end", use_screwdriver_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cleaningagen_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cleaningagen_2" ] = {
    type = "use",
    inv_obj = "inv_cleaningagen",
    use_place = "obj_recepton_use_cleaningagen",
    room = private.room_objname,
    zz = "zz_recepton",
    zz_gate = "gzz_hall_recepton"
  };
  local use_cleaningagen_2_inv = function ()
  
  end;
  local use_cleaningagen_2_beg = function ()
  
    ObjDelete( "obj_recepton_use_cleaningagen" );
  
  end;
  local use_cleaningagen_2_end = function ()
  
    ObjMultiSet( { 
      { "obj_recepton_use_screwdriver",  { input = true, active = true, visible = true } },
    } );
    ObjDelete( "vid_recepton_cleanser" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cleaningagen_2", use_cleaningagen_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagen_2", use_cleaningagen_2_inv );
  cmn.AddSubscriber( "use_cleaningagen_2", use_cleaningagen_2_end, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagen_2_inv", use_cleaningagen_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagen_2_beg", use_cleaningagen_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagen_2_end", use_cleaningagen_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pruners_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pruners_2" ] = {
    type = "use",
    inv_obj = "inv_pruners",
    use_place = "obj_fountain_use_pruners",
    room = private.room_objname,
    zz = "zz_fountain",
    zz_gate = "gzz_hall_fountain"
  };
  local use_pruners_2_inv = function ()
  
    if ( cmn.IsEventDone( "use_pruners_1" ) ) then

      interface.InventoryItemRemove( "inv_pruners" );
      
    end;
    
  end;
  local use_pruners_2_beg = function ()
  
    ObjDelete( "obj_fountain_use_pruners" );
  
  end;
  local use_pruners_2_end = function ()
  
    ObjDelete( "spr_hall_states_zz_fountain_branches" );
     
    ObjMultiSet( { 
      { "spr_fountain_lock",       {  input = true } },
      { "gfx_fountain_lock",       { active = true } },
      { "spr_fountain_battery_2",  {  input = true } },
      { "gfx_fountain_battery_2",  { active = true } },
      { "anm_fountain_pruner",     {  frame = 700  } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pruners_2", use_pruners_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners_2", use_pruners_2_inv );
  cmn.AddSubscriber( "use_pruners_2", use_pruners_2_end, private.room_objname );
  cmn.AddSubscriber( "use_pruners_2_inv", use_pruners_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_pruners_2_beg", use_pruners_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners_2_end", use_pruners_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lock () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lock" ] = {
    type = "use",
    inv_obj = "inv_lock",
    use_place = "obj_luster_use_lock",
    room = private.room_objname,
    zz = "zz_luster",
    zz_gate = "gzz_hall_luster"
  };
  local use_lock_inv = function ()
  
    interface.InventoryItemRemove( "inv_lock" );
  
  end;
  local use_lock_beg = function ()
  
    ObjDelete( "obj_luster_use_lock" );
  
  end;
  local use_lock_end = function ()
  
    ObjDelete( "gzz_hall_luster" );
    ObjMultiSet( { 
      { "obj_hall_use_curvedstick",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lock", use_lock_beg, private.room_objname );
  cmn.AddSubscriber( "use_lock", use_lock_inv );
  cmn.AddSubscriber( "use_lock", use_lock_end, private.room_objname );
  cmn.AddSubscriber( "use_lock_inv", use_lock_inv, private.room_objname );
  cmn.AddSubscriber( "use_lock_beg", use_lock_beg, private.room_objname );
  cmn.AddSubscriber( "use_lock_end", use_lock_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_familyportrait () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_familyportrait" ] = {
    type = "use",
    inv_obj = "inv_familyportrait",
    use_place = "obj_portrait_use_familyportrait",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_hall_portrait"
  };
  local use_familyportrait_inv = function ()
  
    interface.InventoryItemRemove( "inv_familyportrait" );
  
  end;
  local use_familyportrait_beg = function ()
  
    ObjDelete( "obj_portrait_use_familyportrait" );
  
  end;
  local use_familyportrait_end = function ()
  
    ObjDelete( "spr_portrait_door" );
    ObjDelete( "gzz_hall_portrait" );
    ObjMultiSet( { 
      { "gho_hall_portraithall",  { visible = true, input = true  } },
      { "spr_portrait_hook",      {   pos_x = -13,  pos_y = - 158 } },
      { "spr_portrait_portrait",  {     alp = 1                   } },
      { "spr_hall_states_zz_portrait_pain",  { alp = 1, visible = true } },
      { "spr_hall_states_zz_portrait_ho_door",  { alp = 1, visible = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_familyportrait", use_familyportrait_beg, private.room_objname );
  cmn.AddSubscriber( "use_familyportrait", use_familyportrait_inv );
  cmn.AddSubscriber( "use_familyportrait", use_familyportrait_end, private.room_objname );
  cmn.AddSubscriber( "use_familyportrait_inv", use_familyportrait_inv, private.room_objname );
  cmn.AddSubscriber( "use_familyportrait_beg", use_familyportrait_beg, private.room_objname );
  cmn.AddSubscriber( "use_familyportrait_end", use_familyportrait_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_curvedstick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_curvedstick" ] = {
    type = "click",
    use_place = "obj_winch_use_curvedstick",
    room = private.room_objname,
    zz = "zz_winch",
    zz_gate = "gzz_hall_winch"
  };
  local use_curvedstick_inv = function ()
  
    interface.InventoryItemRemove( "inv_curvedstick" );
  
  end;
  local use_curvedstick_beg = function ()
  
    ObjDelete( "obj_winch_use_curvedstick" );
  
  end;
  local use_curvedstick_end = function ()
  
    ObjMultiSet( { 
      { "obj_hall_clk_outro",  { input = true } },
      { "vid_hall_mechazm",  { alp = 1 } }
    } );
    
    ObjDelete( "gzz_hall_winch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_curvedstick", use_curvedstick_beg, private.room_objname );
  cmn.AddSubscriber( "use_curvedstick", use_curvedstick_inv );
  cmn.AddSubscriber( "use_curvedstick", use_curvedstick_end, private.room_objname );
  cmn.AddSubscriber( "use_curvedstick_inv", use_curvedstick_inv, private.room_objname );
  cmn.AddSubscriber( "use_curvedstick_beg", use_curvedstick_beg, private.room_objname );
  cmn.AddSubscriber( "use_curvedstick_end", use_curvedstick_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_portrait_symbol () end;
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_portrait_symbol" ] = {
      type = "click",
      use_place = "obj_portrait_clk_portrait_symbol",
      room = private.room_objname,
      zz = "zz_portrait",
      zz_gate = "gzz_hall_portrait"
    };
    
    local clk_portrait_symbol_beg = function ()

      ObjDelete( "obj_portrait_clk_portrait_symbol" );
      ObjDelete( "anm_portrait_symbol_static" );
    
    end;
    local clk_portrait_symbol_end = function ()

      ObjMultiSet( { 
        { "obj_portrait_use_familyportrait", { input = true } },
      } );
      ObjDelete( "anm_portrait_symbol_away" );
      ObjDelete( "anm_hall_states_zz_portrait_pain" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_portrait_symbol",     clk_portrait_symbol_beg );
    cmn.AddSubscriber( "clk_portrait_symbol",     clk_portrait_symbol_end );
    cmn.AddSubscriber( "clk_portrait_symbol_beg", clk_portrait_symbol_beg );
    cmn.AddSubscriber( "clk_portrait_symbol_end", clk_portrait_symbol_end ); 

  --------------------------------------------------------------------------------------------
  -- function see_hall_outro () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_hall_outro" ] = {
    type = "click",
    use_place = "obj_hall_clk_outro",
    room = private.room_objname,
  };  
  
  local see_hall_outro = function ()
    
    ObjDelete( "obj_hall_clk_outro" );
  
  end;
  cmn.AddSubscriber( "see_hall_outro", see_hall_outro, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_hall_ghost () end;
  --------------------------------------------------------------------------------------------
  
  local see_hall_ghost = function ()
  
    ObjDelete( "anm_hall_ghost" );         

  end;
  
  cmn.AddSubscriber( "see_hall_ghost", see_hall_ghost, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_hall_clark () end;
  --------------------------------------------------------------------------------------------
  
  local see_hall_clark = function ()
  
    ObjSet( "vid_hall_clark", { frame = 90 } );

  end;
  
  cmn.AddSubscriber( "see_hall_clark", see_hall_clark, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_hall_chandelier () end;
  --------------------------------------------------------------------------------------------
  
  local see_hall_chandelier = function ()
  
    ObjSet( "vid_hall_mechazm",  { frame = 59 } );
    ObjDelete( "vid_hall_clark" );

  end;
  
  cmn.AddSubscriber( "see_hall_chandelier", see_hall_chandelier, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_5 = function ()
  
    ObjDelete( "obj_hall_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_5", get_collect_morph_item_5, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_3 = function ()
  
    ObjDelete( "obj_fountain_collect2_item_3" ); 
  
    if ( cmn.IsEventDone( "get_battery_2" ) and 
    cmn.IsEventDone( "get_lock" ) ) then
      
      ObjDelete( "gzz_hall_fountain" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_3", get_collect2_item_3, private.room_objname );  
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_recepton () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_recepton" );  
    ------------------------------------------------- 
    function zz_recepton.Close ()
      
      if private.anim_ghost then
        
        private.see_hall_ghost();
        
      end;
      
    end; 
    
  --*******************************************************************************************************************
  --*** function zz_winch () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_winch" );  
    ------------------------------------------------- 
    function zz_winch.Close ()
      
      if cmn.IsEventDone( "use_curvedstick" ) and not cmn.IsEventDone( "see_hall_chandelier" ) then
        
        private.see_hall_chandelier();
        
      end;
      
    end; 
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_hall();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if not cmn.IsEventDone( "see_hall_clark" ) then
  
    private.see_hall_clark()
  
  end;
  
  if cmn.IsEventDone( "use_curvedstick" ) and not cmn.IsEventDone( "see_hall_chandelier" ) then
        
    private.see_hall_chandelier();
        
  end;

  if (iOS_IsBought() == 1 and cmn.IsEventDone( "see_hall_outro" )) then
    
    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level2";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;

    common.LevelSwitch( level );
    
  end;
    
    
end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "level1/env/aud_hall_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()
  
  common_impl.StopAudio( "env", "level1/env/aud_hall_env", 0.5 );
  
  cmn.NoteScaleClose( { "spr_hall_letter" } );
  
end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_screwdriver_2 ()

  local item = "inv_screwdriver";

  if ( cmn.ApplyObj( item, "gzz_hall_recepton" ) and cmn.IsEventDone( "use_cleaningagen_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_recepton" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_recepton_use_screwdriver" ) and cmn.IsEventDone( "use_cleaningagen_2" ) ) then

    cmn.CallEventHandler( "use_screwdriver_2_inv" );
    cmn.CallEventHandler( "use_screwdriver_2_beg" );

    local func_open = function ()
    
      local func_end = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_screwdriver_2" );
        cmn.CallEventHandler( "use_screwdriver_2_end" );

      end;
      
      ObjAnimate( "spr_recepton_door", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 0, 0 } );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_screwdriver2", 0, "", 0 );

    VidPlay( "vid_recepton_screw", func_open );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cleaningagen_2 ()

  local item = "inv_cleaningagen";

  if ( cmn.ApplyObj( item, "gzz_hall_recepton" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_recepton" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_recepton_use_cleaningagen" ) ) then

    cmn.CallEventHandler( "use_cleaningagen_2_inv" );
    cmn.CallEventHandler( "use_cleaningagen_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_cleaningagen_2" );
      cmn.CallEventHandler( "use_cleaningagen_2_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_cleanser2", 0, "", 0 );

    VidPlay( "vid_recepton_cleanser", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pruners_2 ()

  local item = "inv_pruners";

  if ( cmn.ApplyObj( item, "gzz_hall_fountain" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fountain" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fountain_use_pruners" ) ) then

    cmn.CallEventHandler( "use_pruners_2_inv" );
    cmn.CallEventHandler( "use_pruners_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_pruners_2" );
      cmn.CallEventHandler( "use_pruners_2_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_pruners_2", 0, "", 0 );

    AnimPlay( "anm_fountain_pruner", "pruner", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lock ()

  local item = "inv_lock";

  if ( cmn.ApplyObj( item, "gzz_hall_luster" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_luster" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_luster_use_lock" ) ) then

    cmn.CallEventHandler( "use_lock_inv" );
    cmn.CallEventHandler( "use_lock_beg" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "use_lock" );
      cmn.CallEventHandler( "use_lock_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_lock", 0, "", 0 );

    AnimPlay( "anm_luster_lock", "lock", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_familyportrait ()

  local item = "inv_familyportrait";

  if ( cmn.ApplyObj( item, "gzz_hall_portrait" ) and cmn.IsEventDone( "clk_portrait_symbol" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_portrait" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_portrait_use_familyportrait" ) and cmn.IsEventDone( "clk_portrait_symbol" ) ) then

    cmn.CallEventHandler( "use_familyportrait_inv" );
    cmn.CallEventHandler( "use_familyportrait_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_familyportrait" );
        cmn.CallEventHandler( "use_familyportrait_end" );
        
        common.CloseSubRoom();

      end;

      ObjAnimate( "spr_portrait_hook", "pos_xy", 0, 0, func_end_2, {  
        0.0, 0, -13, -158,
        0.3, 0,  -6,  -95,
        0.6, 0, -13, -158,
        0.9, 0, -13, -158,
      });
      ObjAnimate( "spr_portrait_door", "pos_xy", 0, 0, "", {  
        0.0, 0, 194, 15,
        0.3, 0, 194, 15,
        0.6, 0, 388, 51,
        0.9, 0, 388, 51,
      });

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_familyportrait", 0, "", 0 );

    cmn.ItemFly( "spr_portrait_portrait", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_curvedstick ()

  local item = "inv_curvedstick";

  if ( cmn.ApplyObj( item, "gzz_hall_winch" ) and cmn.IsEventDone( "use_lock" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_winch","under_frame" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_winch_use_curvedstick" ) and
    cmn.IsEventDone( "use_lock" ) and private.winch_cap_close ) then

    cmn.CallEventHandler( "use_curvedstick_inv" );
    cmn.CallEventHandler( "use_curvedstick_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_curvedstick" );
      cmn.CallEventHandler( "use_curvedstick_end" );
      
      common.CloseSubRoom();

    end;
      
    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_winch", 0, "", 0 );

    ObjAnimate( "spr_winch_key", "pos_xy", 0, 0, func_end, { 0, 0, -18, -345,   0.5, 3, 37, -47 } )
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_battery_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_battery_1" );
  cmn.CallEventHandler( "get_battery_1" );
  
  common.CloseSubRoom();
  
  private.anim_ghost = true;

end;
--------------------------------------------------------------------------------------------
function private.get_lock ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lock" );
  cmn.CallEventHandler( "get_lock" );
  
  if ( cmn.IsEventDone( "get_battery_2" ) and
  cmn.IsGetCollect2( "get_collect2_item_3" ) ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_battery_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_battery_2" );
  cmn.CallEventHandler( "get_battery_2" );
  
  if ( cmn.IsEventDone( "get_lock" ) and
  cmn.IsGetCollect2( "get_collect2_item_3" ) ) then
    
    common.CloseSubRoom();

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_3 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_3" ); 

  end;

  common_impl.PlayEffectHO( "spr_fountain_collect2_item_3", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_3" );
  
  if ( cmn.IsEventDone( "get_battery_2" ) and 
  cmn.IsEventDone( "get_lock" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_portrait_symbol ()
  
  cmn.CallEventHandler( "clk_portrait_symbol_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_portrait_symbol" );
    cmn.CallEventHandler( "clk_portrait_symbol_end" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_fire_symbol", 0, "", 0 );

  ObjSet( "anm_portrait_symbol_away", { alp = 1 } );
  AnimPlay( "anm_portrait_symbol_away", "symbol_static", func_end );

end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;

--*********************************************************************************************************************
function private.see_hall_outro ()
  
  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "level1/voc/aud_outro_voc",  0.2 );
      common_impl.StopAudio( "sfx", "level1/sfx/aud_outro",      0.2 );
      
    end;

    cmn.SetEventDone( "see_hall_outro" );
    cmn.CallEventHandler( "see_hall_outro" );

    --common.GotoRoom( "rm_demo" );
     if (iOS_IsBought() == 0) then
        
      iOS_LogEvents(1);
      common.LevelSwitch("menu","unlock");
        
    else
      
      local prg = ng_global.currentprogress;
      ng_global.progress[ prg ].common.chapter = "level2";
      ng_global.progress[ prg ].common.currentroom = nil;
      local level = ng_global.progress[ prg ].common.chapter;

      common.LevelSwitch( level );
      
    end;
    
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_outro",      0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_outro_voc",  0, "", 0 );
  --common_impl.PlayAudio( "mus", "level1/mus/aud_intro_mus",  0, "", 0 );

  cmn.PlayDialogVideo( "vid_hall_outro", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_hall_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_hall_ghost" );
    cmn.CallEventHandler( "see_hall_ghost" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_hanged", 0, "", 0 );

  AnimPlay( "anm_hall_ghost", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_hall_clark ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_hall_clark" );
    cmn.CallEventHandler( "see_hall_clark" );
    
    common_impl.ShowBbt( 'bbt_hall_opn_hall' );
    
    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "obstacle" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_drop_chandelier", 0, "", 0 );

  VidPlay( "vid_hall_clark", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_hall_chandelier ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_hall_chandelier" );
    cmn.CallEventHandler( "see_hall_chandelier" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_hanged", 0, "", 0 );

  ObjSet( "vid_hall_clark", { alp = 0 } );
  
  VidPlay( "vid_hall_mechazm", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_hall ()

  if not ( cmn.IsEventDone( "opn_hall" ) ) then

    cmn.SetEventDone( "opn_hall" );
    
  end;
  cmn.CallEventHandler( "opn_hall" ); 
  
end;
--*********************************************************************************************************************
function private.WinchCapOpen ()

  local func_end = function()
  
    cmn.Lock( false );
  
    ObjMultiSet({
      { "obj_winch_clk_close", { input = true } },
      { "obj_winch_clk_open", { input = false } },
      { "obj_winch_use_curvedstick", { input = false, pos_x = -112, pos_y = 76 } },
    });
    
    common_impl.hint[ "use_curvedstick" ] = {
      type = "click",
      use_place = "obj_winch_use_curvedstick",
      room = private.room_objname,
      zz = "zz_winch",
      zz_gate = "gzz_hall_winch"
    };
  
    private.winch_cap_close = false;
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_groove1", 0, "", 0 );

  ObjAnimate( "spr_winch_cap", "pos_xy", 0, 0, func_end, { 0, 0, 15, 53,   0.3, 3, -89, 75 } )
  
end;
--*********************************************************************************************************************
function private.WinchCapClose ()

  local func_end = function()
  
    cmn.Lock( false );
  
    ObjMultiSet({
      { "obj_winch_clk_close", { input = false } },
      { "obj_winch_clk_open", { input = true } },
      { "obj_winch_use_curvedstick", { input = true, pos_x = 76, pos_y = 19 } },
    });
    
    common_impl.hint[ "use_curvedstick" ] = {
      type = "use",
      inv_obj = "inv_curvedstick",
      use_place = "obj_winch_use_curvedstick",
      room = private.room_objname,
      zz = "zz_winch",
      zz_gate = "gzz_hall_winch"
    };
  
    private.winch_cap_close = true;
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_groove2", 0, "", 0 );

  ObjAnimate( "spr_winch_cap", "pos_xy", 0, 0, func_end, { 0, 0, -89, 75,   0.3, 3, 15, 53 } )
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.AnimUseFamilyportrait ()

  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_portrait_use_familyportrait' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_hook_in_wall", 0, "", 0 );

  ObjAnimate( "spr_portrait_hook", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.3,3,2,15,  0.6,3,0,0, } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUsePruners ()

  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_fountain_use_pruners' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_rustle", 0, "", 0 );

  ObjAnimate( "anm_fountain_pruner", "pos_y", 0, 1, func_end, { 0.0,0,0,  0.3,3,5,  0.6,3,0, } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseLock ()

  --local func_end = function ()
  --
  --  cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_luster_use_lock' );
--  
--  end;
--  
--  cmn.Lock( true );
--  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );
--
--  ObjAnimate( "spr_luster_chain", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,3,-8,  0.4,3,0,0, } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseScrewdriver()

  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_recepton_use_screwdriver' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_high", 0, "", 0 );

  ObjAnimate( "spr_recepton_door", "pos_y", 0, 1, func_end, { 0.0,0,0,  0.2,3,-3,  0.4,3,0 } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseCleaningagen()

  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_recepton_use_cleaningagen' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_high", 0, "", 0 );

  ObjAnimate( "spr_recepton_battery_1", "pos_y", 0, 1, func_end, { 0.0,0,0,  0.2,3,-2,  0.4,3,0 } );

end;
--*********************************************************************************************************************