-- name=rm_room_211
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_room_211";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_lockeddoor",     "room_hub" );
  ObjAttach( "zz_floorhole",      "room_hub" );
  ObjAttach( "zz_threewaymirror", "room_hub" );
  ObjAttach( "zz_symbols",        "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_lockeddoor_broom",                { event_mdown = private.get_broom                  }},
    { "obj_lockeddoor_clk_cleaningagen",     { event_mdown = private.clk_cleaningagen_1         }},
    { "obj_lockeddoor_clk_fireaxe",          { event_mdown = private.clk_fireaxe                }},
    { "obj_lockeddoor_use_cleaningagen",     { event_mdown = private.AnimUseCleaningagen        }},
    { "obj_lockeddoor_use_fireaxe",          { event_mdown = private.AnimUseFireaxe             }},
    
    { "spr_lockeddoor_photo",                { event_mdown = function() cmn.NoteScale( "spr_lockeddoor_photo" ) end }},
    { "spr_lockeddoor_photo_big",            { event_mdown = function() cmn.NoteScale( "spr_lockeddoor_photo" ) end }},
    
    { "obj_threewaymirror_use_hexagon",      { event_mdown = private.AnimUseHexagon             }},
    { "obj_weathervane_use_weathervanepart", { event_mdown = private.AnimUseWeathervanepart     }},
    
    { "spr_floorhole_ladle",                 { event_mdown = private.get_ladle                  }},
    { "spr_floorhole_universalkey",          { event_mdown = private.get_universalkey           }},
    
    { "spr_symbols_jewel",                   { event_mdown = private.get_jewel                  }},
    { "obj_symbols_use_acid",                { event_mdown = private.UseAcid                    }},
    { "obj_symbols_clk_paper",               { event_mdown = private.clk_room_211_paper         }},
    { "obj_symbols_clk_room_211_symbols"    ,{ event_mdown = private.clk_room_211_symbols       }},
    { "spr_room_211_rope",                   { event_mdown = private.get_rope                   }},
    { "obj_room_211_use_pruners",            { event_mdown = private.see_room_211_ghost         }},
    { "obj_room_211_use_ladleofboilingwater",{ event_mdown = private.AnimUseLadleofboilingwater }},
    { "obj_room_211_scare",                  { event_mdown = private.see_room_211_scare         }},
    { "obj_room_211_scare_2",                { event_mdown = private.see_room_211_scare_2       }},
    { "obj_room_211_see_room_211_1",         { event_mdown = private.see_room_211_1             }},
    { "obj_room_211_boy",                    { event_mdown = private.see_room_211_maidghost     }},
    
    
    
    { "spr_room_211_collect_morph_item", { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_6" ); end } },
      
    { "spr_symbols_collect2_item_4",         { event_mdown = private.get_collect2_item_4   } }, 
      
  }); 
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_room_211 = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gho_room_211_minibar",
      "gmg_room_211_inthreewaymirror",
      "gzz_room_211_threewaymirror",
      "gzz_room_211_lockeddoor",
      "gzz_room_211_floorhole",
      "gzz_room_211_symbols",
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_lockeddoor",
      "zz_floorhole",
      "zz_threewaymirror",
      "zz_symbols",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_room_211", update_game_mode_room_211, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_room_211 = function ()

    local effects_table = 
    {
      "" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_room_211", update_performance_mode_room_211, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_room_211 () end;
  --------------------------------------------------------------------------------------------
  local opn_room_211_map = function ()

    common_impl.VisitMapRoom( "room_211" );

  end;
  cmn.AddSubscriber( "opn_room_211", opn_room_211_map );
  
  --------------------------------------------------------------------------------------------
  -- function clk_room_211_symbols () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_room_211_symbols" ] = {
    type = "click",
    use_place = "obj_symbols_clk_room_211_symbols",
    room = private.room_objname,
    zz = "zz_symbols",
    zz_gate = "gzz_room_211_symbols"
  };
  
  local clk_room_211_symbols_beg = function ()

    ObjDelete( "obj_symbols_clk_room_211_symbols" );
  
  end;
  local clk_room_211_symbols_end = function ()

    ObjMultiSet( { 
      { "obj_symbols_clk_paper",  { input = true } },
    } );
    ObjDelete( "anm_symbols_symbol" );
    ObjDelete( "anm_room_211_symbol" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_room_211_symbols",     clk_room_211_symbols_beg, private.room_objname );
  cmn.AddSubscriber( "clk_room_211_symbols",     clk_room_211_symbols_end, private.room_objname );
  cmn.AddSubscriber( "clk_room_211_symbols_beg", clk_room_211_symbols_beg, private.room_objname );
  cmn.AddSubscriber( "clk_room_211_symbols_end", clk_room_211_symbols_end, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function clk_room_211_paper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_room_211_paper" ] = {
    type = "click",
    use_place = "obj_symbols_clk_paper",
    room = private.room_objname,
    zz = "zz_symbols",
    zz_gate = "gzz_room_211_symbols"
  };
  
  local clk_room_211_paper_beg = function ()

    ObjDelete( "obj_symbols_clk_paper" );
  
  end;
  local clk_room_211_paper_end = function ()

    ObjMultiSet( { 
      { "obj_symbols_use_acid",  { input = true } },
    } );
    ObjDelete( "anm_symbols_paper" );
    ObjDelete( "spr_room_211_safe_safepatch" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_room_211_paper",     clk_room_211_paper_beg, private.room_objname );
  cmn.AddSubscriber( "clk_room_211_paper",     clk_room_211_paper_end, private.room_objname );
  cmn.AddSubscriber( "clk_room_211_paper_beg", clk_room_211_paper_beg, private.room_objname );
  cmn.AddSubscriber( "clk_room_211_paper_end", clk_room_211_paper_end, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function clk_cleaningagen_1 () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_cleaningagen_1" ] = {
    type = "click",
    use_place = "obj_lockeddoor_clk_cleaningagen",
    room = private.room_objname,
    zz = "zz_lockeddoor",
    zz_gate = "gzz_room_211_lockeddoor"
  };

  local clk_cleaningagen_1_beg = function ()

    ObjDelete( "obj_lockeddoor_clk_cleaningagen" );
  
  end;
  local clk_cleaningagen_1_end = function ()

    ObjDelete( "spr_lockeddoor_locker" )
    ObjDelete( "spr_room_211_rusty_locker" )

    ObjMultiSet( { 
      { "spr_lockeddoor_locker_open", {    alp = 1    } },
      { "spr_room_211_open_locker",   {    alp = 1    } },
      { "spr_lockeddoor_broom",       {  input = true } },
      { "gfx_lockeddoor_broom",       { active = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_cleaningagen_1",     clk_cleaningagen_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cleaningagen_1",     clk_cleaningagen_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_cleaningagen_1_beg", clk_cleaningagen_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cleaningagen_1_end", clk_cleaningagen_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_fireaxe () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_fireaxe" ] = {
    type = "click",
    use_place = "obj_lockeddoor_clk_fireaxe",
    room = private.room_objname,
    zz = "zz_lockeddoor",
    zz_gate = "gzz_room_211_lockeddoor"
  };

  local clk_fireaxe_beg = function ()

    ObjDelete( "obj_lockeddoor_clk_cleaningagen" );
  
  end;
  local clk_fireaxe_end = function ()

    ObjDelete( "obj_lockeddoor_boards"   );
    ObjDelete( "gzz_room_211_lockeddoor" );
    ObjDelete( "spr_room_211_broken_door" );
    ObjDelete( "spr_room_211_board" );
    ObjDelete( "anm_room_211_light_broken_door_2" );
    
    ObjMultiSet( { 
      { "grm_room_211_hall",                 { visible = true, input = true } },
      { "anm_room_211_light_broken_door_4",  {     alp = 1                  } },
    } );

    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_room_211_hall_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_fireaxe",     clk_fireaxe_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fireaxe",     clk_fireaxe_end, private.room_objname );
  cmn.AddSubscriber( "clk_fireaxe_beg", clk_fireaxe_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fireaxe_end", clk_fireaxe_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_broom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_broom" ] = {
    type = "get",
    get_obj = "spr_lockeddoor_broom",
    room = private.room_objname,
    zz = "zz_lockeddoor",
    zz_gate = "gzz_room_211_lockeddoor"
  };
  
  local get_broom_inv = function ()
  
    interface.InventoryItemAdd( "inv_broom", "spr_lockeddoor_broom" );
  
  end;
  
  local get_broom_closezz = function ()
  
    ObjDelete( "gfx_lockeddoor_broom" );
    ObjDelete( "spr_room_211_broom" );
    ObjSet( "spr_lockeddoor_photo", { input = true } );
    
  end;
  
  cmn.AddSubscriber( "get_broom", get_broom_inv );
  cmn.AddSubscriber( "get_broom", get_broom_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ladle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ladle" ] = {
    type = "get",
    get_obj = "spr_floorhole_ladle",
    room = private.room_objname,
    zz = "zz_floorhole",
    zz_gate = "gzz_room_211_floorhole"
  };
  
  local get_ladle_inv = function ()
  
    interface.InventoryItemAdd( "inv_ladle", "spr_floorhole_ladle" );
  
  end;
  
  local get_ladle_closezz = function ()
  
    ObjDelete( "gfx_floorhole_ladle" );
    ObjDelete( "spr_room_211_ladle" );
    
  end;
  
  cmn.AddSubscriber( "get_ladle", get_ladle_inv );
  cmn.AddSubscriber( "get_ladle", get_ladle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_universalkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_universalkey" ] = {
    type = "get",
    get_obj = "spr_floorhole_universalkey",
    room = private.room_objname,
    zz = "zz_floorhole",
    zz_gate = "gzz_room_211_floorhole"
  };
  
  local get_universalkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_universalkey", "spr_floorhole_universalkey" );
  
  end;
  
  local get_universalkey_closezz = function ()
  
    ObjDelete( "gfx_floorhole_universalkey" );
    ObjDelete( "spr_room_211_key" );
    
  end;
  
  cmn.AddSubscriber( "get_universalkey", get_universalkey_inv );
  cmn.AddSubscriber( "get_universalkey", get_universalkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_jewel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_jewel" ] = {
    type = "get",
    get_obj = "spr_symbols_jewel",
    room = private.room_objname,
    zz = "zz_symbols",
    zz_gate = "gzz_room_211_symbols"
  };
  
  local get_jewel_inv = function ()
  
    interface.InventoryItemAdd( "inv_jewel", "spr_symbols_jewel" );
  
  end;
  
  local get_jewel_closezz = function ()
  
    ObjDelete( "gfx_symbols_jewel" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_4" ) ) then
      
      ObjDelete( "gzz_room_211_symbols" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_jewel", get_jewel_inv );
  cmn.AddSubscriber( "get_jewel", get_jewel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rope" ] = {
    type = "get",
    get_obj = "spr_room_211_rope",
    room = private.room_objname
  };
  
  local get_rope_inv = function ()
  
    interface.InventoryItemAdd( "inv_rope", "spr_room_211_rope" );
    cmn.SetInvPlusRGB( "metalbeams", true );
  
  end;
  
  local get_rope_closezz = function ()
  
    ObjDelete( "gfx_room_211_rope" );
  
  end;
  
  cmn.AddSubscriber( "get_rope", get_rope_inv );
  cmn.AddSubscriber( "get_rope", get_rope_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cleaningagen_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cleaningagen_1" ] = {
    type = "use",
    inv_obj = "inv_cleaningagen",
    use_place = "obj_lockeddoor_use_cleaningagen",
    room = private.room_objname,
    zz = "zz_lockeddoor",
    zz_gate = "gzz_room_211_lockeddoor"
  };
  local use_cleaningagen_1_inv = function ()
  
  end;
  local use_cleaningagen_1_beg = function ()
  
    ObjDelete( "obj_lockeddoor_use_cleaningagen" );
    ObjDelete( "spr_lockeddoor_rusty_locker" );
    ObjSet( "spr_lockeddoor_locker", {   alp = 1 } )
  
  end;
  local use_cleaningagen_1_end = function ()
  
    ObjMultiSet( { 
      { "obj_lockeddoor_clk_cleaningagen", { input = true, active = true, visible = true } },
      { "spr_room_211_locker",             {   alp = 1                                   } },
    } );
    ObjDelete( "vid_lockeddoor_cleanser" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cleaningagen_1", use_cleaningagen_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagen_1", use_cleaningagen_1_inv );
  cmn.AddSubscriber( "use_cleaningagen_1", use_cleaningagen_1_end, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagen_1_inv", use_cleaningagen_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagen_1_beg", use_cleaningagen_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagen_1_end", use_cleaningagen_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fireaxe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fireaxe" ] = {
    type = "use",
    inv_obj = "inv_fireaxe",
    use_place = "obj_lockeddoor_use_fireaxe",
    room = private.room_objname,
    zz = "zz_lockeddoor",
    zz_gate = "gzz_room_211_lockeddoor"
  };
  local use_fireaxe_inv = function ()
  
    interface.InventoryItemRemove( "inv_fireaxe" );
  
  end;
  local use_fireaxe_beg = function ()
  
    ObjDelete( "obj_lockeddoor_use_fireaxe" );
    ObjDelete( "anm_lockeddoor_hh" );
  
  end;
  local use_fireaxe_end = function ()
    
    ObjDelete( "spr_room_211_broken_door_patch" );
    ObjDelete( "anm_lockeddoor_axe" );
    ObjDelete( "anm_lockeddoor_light" );
    ObjDelete( "anm_room_211_light_broken_door_1" );
    
    ObjMultiSet( {
      { "obj_lockeddoor_clk_fireaxe",       { input = true } };
      { "anm_lockeddoor_door",              {   alp = 1    } };
      { "anm_room_211_light_broken_door_2", {   alp = 1    } };    
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fireaxe", use_fireaxe_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireaxe", use_fireaxe_inv );
  cmn.AddSubscriber( "use_fireaxe", use_fireaxe_end, private.room_objname );
  cmn.AddSubscriber( "use_fireaxe_inv", use_fireaxe_inv, private.room_objname );
  cmn.AddSubscriber( "use_fireaxe_beg", use_fireaxe_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireaxe_end", use_fireaxe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ropeladder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ropeladder" ] = {
    type = "use",
    inv_obj = "inv_ropeladder",
    use_place = "obj_floorhole_use_ropeladder",
    room = private.room_objname,
    zz = "zz_floorhole",
    zz_gate = "gzz_room_211_floorhole"
  };
  local use_ropeladder_inv = function ()
  
    interface.InventoryItemRemove( "inv_ropeladder" );
  
  end;
  local use_ropeladder_beg = function ()
  
    ObjDelete( "obj_floorhole_use_ropeladder" );
  
  end;
  local use_ropeladder_end = function ()
  
    ObjDelete( "gzz_room_211_floorhole" );
    ObjMultiSet( { 
      { "grm_room_211_serviceroom",  { visible = true, input = true } },
      { "spr_floorhole_rope_ladder", {     alp = 1                  } },
      { "anm_room_211_rope_ladder",  {     alp = 1                  } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_room_211_serviceroom_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ropeladder", use_ropeladder_beg, private.room_objname );
  cmn.AddSubscriber( "use_ropeladder", use_ropeladder_inv );
  cmn.AddSubscriber( "use_ropeladder", use_ropeladder_end, private.room_objname );
  cmn.AddSubscriber( "use_ropeladder_inv", use_ropeladder_inv, private.room_objname );
  cmn.AddSubscriber( "use_ropeladder_beg", use_ropeladder_beg, private.room_objname );
  cmn.AddSubscriber( "use_ropeladder_end", use_ropeladder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hexagon () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hexagon" ] = {
    type = "use",
    inv_obj = "inv_hexagon",
    use_place = "obj_threewaymirror_use_hexagon",
    room = private.room_objname,
    zz = "zz_threewaymirror",
    zz_gate = "gzz_room_211_threewaymirror"
  };
  local use_hexagon_inv = function ()
  
    interface.InventoryItemRemove( "inv_hexagon" );
  
  end;
  local use_hexagon_beg = function ()
  
    ObjDelete( "obj_threewaymirror_use_hexagon" );
  
  end;
  local use_hexagon_end = function ()
  
    ObjDelete( "gzz_room_211_threewaymirror" );
    ObjMultiSet( { 
      { "gmg_room_211_inthreewaymirror",  { visible = true, input = true } },
      { "anm_threewaymirror_amulet",      {   frame = 100                } },
      { "spr_room_211_shelv_amulet",      {     alp = 1                  } },
      { "spr_room_211_patch_1_mg",        {     alp = 1                  } },      
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hexagon", use_hexagon_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexagon", use_hexagon_inv );
  cmn.AddSubscriber( "use_hexagon", use_hexagon_end, private.room_objname );
  cmn.AddSubscriber( "use_hexagon_inv", use_hexagon_inv, private.room_objname );
  cmn.AddSubscriber( "use_hexagon_beg", use_hexagon_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexagon_end", use_hexagon_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_acid () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_acid" ] = {
    type = "use",
    inv_obj = "inv_acid",
    use_place = "obj_symbols_use_acid",
    room = private.room_objname,
    zz = "zz_symbols",
    zz_gate = "gzz_room_211_symbols"
  };
  local use_acid_inv = function ()
  
    interface.InventoryItemRemove( "inv_acid" );
  
  end;
  local use_acid_beg = function ()
  
    ObjDelete( "obj_symbols_use_acid" );
  
  end;
  local use_acid_end = function ()
    
    ObjDelete( "spr_symbols_door_closed" );
    ObjDelete( "spr_room_211_safe_closedoor" );
    ObjMultiSet( { 
      { "spr_symbols_jewel",        { visible = true, input = true } },
      { "spr_symbols_door_opened",  {     alp = 1                  } },
      { "spr_room_211_safe_safe",   {     alp = 1                  } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_acid", use_acid_beg, private.room_objname );
  cmn.AddSubscriber( "use_acid", use_acid_inv );
  cmn.AddSubscriber( "use_acid", use_acid_end, private.room_objname );
  cmn.AddSubscriber( "use_acid_inv", use_acid_inv, private.room_objname );
  cmn.AddSubscriber( "use_acid_beg", use_acid_beg, private.room_objname );
  cmn.AddSubscriber( "use_acid_end", use_acid_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ladleofboilingwater () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ladleofboilingwater" ] = {
    type = "use",
    inv_obj = "inv_ladleofboilingwater",
    use_place = "obj_room_211_use_ladleofboilingwater",
    room = private.room_objname
  };
  local use_ladleofboilingwater_inv = function ()
  
    interface.InventoryItemRemove( "inv_ladleofboilingwater" );
  
  end;
  local use_ladleofboilingwater_beg = function ()
  
    ObjDelete( "spr_room_211_state_ise" );
    ObjDelete( "obj_room_211_use_ladleofboilingwater" );
  
  end;
  local use_ladleofboilingwater_end = function ()
    
    ObjDelete( "spr_room_211_state_ise" );
    ObjMultiSet( { 
      { "gho_room_211_minibar",       { visible = true, input = true } },
      { "spr_room_211_patch_opened",  {     alp = 1                  } },
      { "anm_room_211_az",            {     alp = 1                  } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ladleofboilingwater", use_ladleofboilingwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_ladleofboilingwater", use_ladleofboilingwater_inv );
  cmn.AddSubscriber( "use_ladleofboilingwater", use_ladleofboilingwater_end, private.room_objname );
  cmn.AddSubscriber( "use_ladleofboilingwater_inv", use_ladleofboilingwater_inv, private.room_objname );
  cmn.AddSubscriber( "use_ladleofboilingwater_beg", use_ladleofboilingwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_ladleofboilingwater_end", use_ladleofboilingwater_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pruners_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pruners_1" ] = {
    type = "use",
    inv_obj = "inv_pruners",
    use_place = "obj_room_211_use_pruners",
    room = private.room_objname
  };
  local use_pruners_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_pruners_2" ) ) then

      interface.InventoryItemRemove( "inv_pruners" );
      
    end;
    
  end;
  local use_pruners_1_beg = function ()
  
    ObjDelete( "obj_room_211_use_pruners" );
  
  end;
  local use_pruners_1_end = function ()
    
    ObjDelete( "anm_room_211_rope" );  
    ObjMultiSet( { 
      { "spr_room_211_rope",        { alp = 1, input = true } },
      { "anm_room_211_rope_2_all",  { alp = 1               } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pruners_1", use_pruners_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners_1", use_pruners_1_inv );
  cmn.AddSubscriber( "use_pruners_1", use_pruners_1_end, private.room_objname );
  cmn.AddSubscriber( "use_pruners_1_inv", use_pruners_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_pruners_1_beg", use_pruners_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners_1_end", use_pruners_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_6 = function ()
  
    ObjDelete( "obj_room_211_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_6", get_collect_morph_item_6, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function see_room_211_scare () end;
  --------------------------------------------------------------------------------------------
  local see_room_211_scare = function ()
    
    ObjDelete( "obj_room_211_scare" );
    ObjDelete( "anm_room_211_scare_face" );    

  end;
  cmn.AddSubscriber( "see_room_211_scare", see_room_211_scare, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function see_room_211_scare_2 () end;
  --------------------------------------------------------------------------------------------
  local see_room_211_scare_2 = function ()
    
    ObjDelete( "obj_room_211_scare_2" );
    ObjDelete( "anm_room_211_garbage" );    

  end;
  cmn.AddSubscriber( "see_room_211_scare_2", see_room_211_scare_2, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function see_room_211_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_room_211_1" ] = {
    type = "click",
    use_place = "obj_room_211_see_room_211_1",
    room = private.room_objname
  };  
  
  local see_room_211_1 = function ()
    
    ObjDelete( "obj_room_211_see_room_211_1" );
    ObjMultiSet( { 
      { "anm_room_211_wood",  { frame = 300 } },
    } );
  
  end;
  cmn.AddSubscriber( "see_room_211_1", see_room_211_1, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_room_211_ghost () end;
  --------------------------------------------------------------------------------------------
  
  local see_room_211_ghost = function ()
    
    ObjDelete( "anm_room_211_ghost" );
    ObjSet( "obj_room_211_use_pruners", { event_mdown = private.AnimUsePruners  } )
    
  end;
  cmn.AddSubscriber( "see_room_211_ghost", see_room_211_ghost, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function see_room_211_maidghost () end;
  --------------------------------------------------------------------------------------------
  
  local see_room_211_maidghost = function ()
    
    ObjDelete( "anm_room_211_maidghost" );
    ObjSet( "obj_room_211_boy", { event_mdown = function() common_impl.ShowBbt( 'bbt_room_211_boy' ) end  } );
    
  end;
  cmn.AddSubscriber( "see_room_211_maidghost", see_room_211_maidghost, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_4 = function ()
  
    ObjDelete( "obj_symbols_collect2_item_4" ); 
  
    if ( cmn.IsEventDone( "get_jewel" ) ) then
      
      ObjDelete( "gzz_room_211_symbols" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_4", get_collect2_item_4, private.room_objname );
  
end; 

--*********************************************************************************************************************
function public.Load ()
  
  --*******************************************************************************************************************
  --*** function zz_lockeddoor () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_lockeddoor" );
    ------------------------------------------------- 
    function zz_lockeddoor.Close ()
      
      if ( cmn.IsEventDone( "get_broom" ) ) then

        cmn.NoteScaleClose( { "spr_lockeddoor_photo" } );

      end;
      
    end;
  
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_room_211();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "level1/env/aud_room_313_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.StopAudio( "env", "level1/env/aud_room_313_env", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_cleaningagen_1 ()

  local item = "inv_cleaningagen";

  if ( cmn.ApplyObj( item, "gzz_room_211_lockeddoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lockeddoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_lockeddoor_use_cleaningagen" ) ) then

    cmn.CallEventHandler( "use_cleaningagen_1_inv" );
    cmn.CallEventHandler( "use_cleaningagen_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_cleaningagen_1" );
      cmn.CallEventHandler( "use_cleaningagen_1_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_cleanser", 0, "", 0 );

    ObjSet( "vid_lockeddoor_cleanser", { alp = 1 } );
    VidPlay( "vid_lockeddoor_cleanser", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fireaxe ()

  local item = "inv_fireaxe";

  if ( cmn.ApplyObj( item, "gzz_room_211_lockeddoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lockeddoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_lockeddoor_use_fireaxe" ) ) then

    cmn.CallEventHandler( "use_fireaxe_inv" );
    cmn.CallEventHandler( "use_fireaxe_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_fireaxe" );
      cmn.CallEventHandler( "use_fireaxe_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_axe", 0, "", 0 );

    ObjSet( "anm_lockeddoor_axe", { alp = 1 } );
    AnimPlay( "anm_lockeddoor_axe", "axe", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ropeladder ()

  local item = "inv_ropeladder";

  if ( cmn.ApplyObj( item, "gzz_room_211_floorhole" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floorhole" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_floorhole_use_ropeladder" ) ) then

    cmn.CallEventHandler( "use_ropeladder_inv" );
    cmn.CallEventHandler( "use_ropeladder_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_ropeladder" );
      cmn.CallEventHandler( "use_ropeladder_end" );
      
      cmn.SetEventDone( "see_room_211_maidghost" );
      cmn.CallEventHandler( "see_room_211_maidghost" );
      
      common.CloseSubRoom();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_bars", 0, "", 0 );

    cmn.ItemFly( "spr_floorhole_rope_ladder", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hexagon ()

  local item = "inv_hexagon";

  if ( cmn.ApplyObj( item, "gzz_room_211_threewaymirror" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_threewaymirror" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_threewaymirror_use_hexagon" ) ) then

    cmn.CallEventHandler( "use_hexagon_inv" );
    cmn.CallEventHandler( "use_hexagon_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hexagon" );
      cmn.CallEventHandler( "use_hexagon_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom( "mg_inthreewaymirror" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hexagon", 0, "", 0 );

    ObjSet( "anm_threewaymirror_amulet", { alp = 1 } );
    AnimPlay( "anm_threewaymirror_amulet", "amulet", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_acid ()

  local item = "inv_acid";

  if ( cmn.ApplyObj( item, "gzz_room_211_symbols" ) and
       cmn.IsEventDone( "clk_room_211_paper" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_symbols" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_symbols_use_acid" ) and
           cmn.IsEventDone( "clk_room_211_paper" ) ) then

    cmn.CallEventHandler( "use_acid_inv" );
    cmn.CallEventHandler( "use_acid_beg" );

    local func_open = function ()
      
      local func_end = function ()
      
        cmn.Lock( false );

        cmn.SetEventDone( "use_acid" );
        cmn.CallEventHandler( "use_acid_end" );
      
      end;  
    
      ObjAnimate( "spr_symbols_door_closed", "alp", 0, 0, func_end, { 
        0.0, 0, 1,
        0.3, 0, 0,
      } );  
      
      ObjAnimate( "spr_symbols_door_opened", "alp", 0, 0, "", { 
        0.0, 0, 0,
        0.3, 0, 1,
      } ); 
    
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_acid", 0, "", 0 );

    VidPlay( "vid_symbols_door_closed_lock", func_open );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ladleofboilingwater ()

  local item = "inv_ladleofboilingwater";

  if ( cmn.ApplyObj( item, "obj_room_211_use_ladleofboilingwater" ) ) then

    cmn.CallEventHandler( "use_ladleofboilingwater_inv" );
    cmn.CallEventHandler( "use_ladleofboilingwater_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_ladleofboilingwater" );
      cmn.CallEventHandler( "use_ladleofboilingwater_end" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_water_hot", 0, "", 0 );

    ObjSet( "vid_room_211_ice", { alp = 1 } );
    VidPlay( "vid_room_211_ice", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pruners_1 ()

  local item = "inv_pruners";

  if ( cmn.ApplyObj( item, "obj_room_211_use_pruners" ) ) then

    cmn.CallEventHandler( "use_pruners_1_inv" );
    cmn.CallEventHandler( "use_pruners_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_pruners_1" );
      cmn.CallEventHandler( "use_pruners_1_end" );
      ObjSet( "anm_room_211_rope_2_all", { frame = 0 } );
      
      cmn.SetEventDone( "see_room_211_ghost" );
      cmn.CallEventHandler( "see_room_211_ghost" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_pruners_1", 0, "", 0 );

    AnimPlay( "anm_room_211_rope", "rope_off", func_end );
  
    return true;

  end;
  
  return false;
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_broom ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_broom" );
  cmn.CallEventHandler( "get_broom" );

end;
--------------------------------------------------------------------------------------------
function private.get_ladle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ladle" );
  cmn.CallEventHandler( "get_ladle" );

end;
--------------------------------------------------------------------------------------------
function private.get_universalkey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_universalkey" );
  cmn.CallEventHandler( "get_universalkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_jewel ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_jewel" );
  cmn.CallEventHandler( "get_jewel" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_4" ) ) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_rope ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rope" );
  cmn.CallEventHandler( "get_rope" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_4 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_4" ); 

  end;

  common_impl.PlayEffectHO( "spr_symbols_collect2_item_4", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_4" );
  
  if ( cmn.IsEventDone( "get_jewel" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_room_211_paper ()
  
  cmn.CallEventHandler( "clk_room_211_paper_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_room_211_paper" );
    cmn.CallEventHandler( "clk_room_211_paper_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_tear_paper", 0, "", 0 );

  AnimPlay( "anm_symbols_paper", "paper", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_cleaningagen_1 ()
  
  cmn.CallEventHandler( "clk_cleaningagen_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_cleaningagen_1" );
    cmn.CallEventHandler( "clk_cleaningagen_1_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_wood_door_small", 0, "", 0 );

  ObjAnimate( "spr_lockeddoor_locker_open", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );
  ObjAnimate( "spr_lockeddoor_locker",      "alp", 0, 0,       "", { 0, 0, 1,   0.3, 0, 0 } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_fireaxe ()
  
  cmn.CallEventHandler( "clk_fireaxe_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_fireaxe" );
    cmn.CallEventHandler( "clk_fireaxe_end" ); 
    
    common.CloseSubRoom();
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_hall_door", 0, "", 0 );
  
  AnimPlay( "anm_lockeddoor_door", "light", func_end );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;
--*********************************************************************************************************************
function private.see_room_211_scare ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_room_211_scare" );
    cmn.CallEventHandler( "see_room_211_scare" );
 
    common_impl.ShowBbt( 'bbt_room_211_see_room_211_scare' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_shadow", 0, "", 0 );
  AnimPlay( "anm_room_211_scare_face", "scare_face", func_end );

end;
--------------------------------------------------------------------------------------------
function private.see_room_211_scare_2 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_room_211_scare_2" );
    cmn.CallEventHandler( "see_room_211_scare_2" );
 
    common_impl.ShowBbt( 'bbt_room_211_see_room_211_scare_2' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_destruction3", 0, "", 0 );
  AnimPlay( "anm_room_211_garbage", "garbage", func_end );

end;
--------------------------------------------------------------------------------------------
function private.see_room_211_1 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_room_211_1" );
    cmn.CallEventHandler( "see_room_211_1" );
 
    common_impl.ShowBbt( 'bbt_room_211_see_room_211' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_shadow", 0, "", 0 );
  AnimPlay( "anm_room_211_wood", "wood", func_end );

end;
--------------------------------------------------------------------------------------------
function private.see_room_211_ghost ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_room_211_ghost" );
    cmn.CallEventHandler( "see_room_211_ghost" );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_hanged", 0, "", 0 );

  ObjSet( "anm_room_211_ghost", { alp = 1 } );
  AnimPlay( "anm_room_211_ghost", "DoAnim", func_end )

end;
--------------------------------------------------------------------------------------------
function private.see_room_211_maidghost ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_room_211_maidghost" );
    cmn.CallEventHandler( "see_room_211_maidghost" );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_maid", 0, "", 0 );

  ObjSet( "anm_room_211_maidghost", { alp = 1 } );
  AnimPlay( "anm_room_211_maidghost", "DoAnim", func_end )

end;
--*********************************************************************************************************************
function private.clk_room_211_symbols ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_room_211_symbols" );
    cmn.CallEventHandler( "clk_room_211_symbols" );
 
    --common_impl.ShowBbt( 'bbt_room_211_see_room_211_scare' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_fire_symbol", 0, "", 0 );
  AnimPlay( "anm_symbols_symbol", "symbol_static", func_end );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_room_211 ()

  if not ( cmn.IsEventDone( "opn_room_211" ) ) then

    cmn.SetEventDone( "opn_room_211" );
    common_impl.ShowBbt( 'bbt_room_211_opn_room_211' );
    
    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "help_stranger" );

  end;
  cmn.CallEventHandler( "opn_room_211" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.UseAcid ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_symbols_use_acid' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_small_box1", 0, "", 0 );

  ObjAnimate( "vid_symbols_door_closed_lock", "pos_y", 0, 1, func_end, { 0, 0, 0,   0.2, 3, 1,   0.4, 3, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseHexagon ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_threewaymirror_use_hexagon' );

    ObjSet( "anm_threewaymirror_hh", { alp = 0 } );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_drawer", 0, "", 0 );

  ObjSet( "anm_threewaymirror_hh", { alp = 1 } );
  AnimPlay( "anm_threewaymirror_hh", "hh", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseCleaningagen ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_lockeddoor_use_cleaningagen' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_small_box", 0, "", 0 );

  ObjAnimate( "spr_lockeddoor_rusty_latch", "pos_x", 0, 1, func_end, { 0.0,0,0, 0.2,3,3, 0.4,3,0, } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseFireaxe ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_lockeddoor_use_fireaxe' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_wood_old_door", 0, "", 0 );

  AnimPlay( "anm_lockeddoor_hh", "door_click", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUsePruners ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_room_211_use_pruners' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_rope", 0, "", 0 );

  ObjAnimate( "spr_room_211_ropes", "pos_y", 0, 1, func_end, { 0.0,0,0, 0.2,3,3, 0.4,3,0, } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseWeathervanepart ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_weathervane_use_weathervanepart' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_grill", 0, "", 0 );

  AnimPlay( "anm_weathervane_star", "hh", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseLadleofboilingwater ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_weathervane_use_ladleofboilingwater' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_ice", 0, "", 0 );

  AnimPlay( "anm_room_211_ice", "hh", func_end );

end;
--*********************************************************************************************************************