-- name=rm_room_313
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_room_313";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_couch", "room_hub" );
  ObjAttach( "zz_ritualsigns", "room_hub" );
  ObjAttach( "zz_bobby", "room_hub" );
  ObjAttach( "zz_reverse", "room_hub" );
  ObjAttach( "zz_room_313_window", "room_hub" );
  ObjAttach( "zz_underceiling", "room_hub" );
  ObjAttach( "zz_toy", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  private.audioRmRoom313 = false;

  ObjMultiSet({ 
    { "spr_couch_bracedrill",                   { event_mdown = private.get_bracedrill       }},
    { "spr_couch_valve",                        { event_mdown = private.get_valve            }},
    { "spr_couch_torchnobatteries",             { event_mdown = private.get_torchnobatteries }},
    { "spr_couch_carvedamulet_2",               { event_mdown = private.get_carvedamulet_2   }},
    { "spr_couch_firstaidkit",                  { event_mdown = private.get_firstaidkit      }},
    { "spr_couch_clasp",                        { event_mdown = private.get_clasp            }},
    { "spr_couch_wood_2",                       { event_mdown = private.get_wood_2           }},
    { "obj_couch_clk_wheel",                    { event_mdown = private.clk_couch_wheel      }},
    { "obj_couch_clk_chair",                    { event_mdown = private.clk_couch_chair      }},
    { "obj_couch_use_codepart",                 { event_mdown = private.UseCodepart          }},
    { "obj_couch_use_statuette",                { event_mdown = private.UseStatuette         }},
    { "obj_couch_use_hammer",                   { event_mdown = private.UseCouchHammer         }},
    
    { "obj_ritualsigns_clk_ritualsigns_signs",  { event_mdown = private.clk_ritualsigns_signs}},
    
    { "spr_ritualsigns_bobbyamulet",            { event_mdown = private.get_bobbyamulet      }},
    { "spr_ritualsigns_collar",                 { event_mdown = private.get_collar           }},
    { "obj_ritualsigns_use_hotelsign",          { event_mdown = private.UseHotelsign         }},
    { "obj_ritualsigns_use_tongs",              { event_mdown = private.UseTongs             }},
    { "obj_ritualsigns_use_tongs",              { event_mdown = private.UseTongs             }},
    
    { "spr_bobby_matches",                      { event_mdown = private.get_matches          }},
    { "spr_bobby_codepart3",                    { event_mdown = private.get_codepart3        }},
    { "obj_bobby_use_bobbyamulet",              { event_mdown = private.UseBobbyamulet       }},
    { "obj_bobby_use_paperpin",                 { event_mdown = private.UsePaperpin          }},
    { "obj_bobby_clk_hand",                     { event_mdown = private.ClkHand              }},
    
    { "spr_bobby_note",                         { event_mdown = function() cmn.NoteScale( "spr_bobby_note" ) end }},
    { "spr_bobby_note_big",                     { event_mdown = function() cmn.NoteScale( "spr_bobby_note" ) end }},
    
    { "spr_bobby_photo",                        { event_mdown = function() cmn.NoteScale( "spr_bobby_photo" ) end }},
    { "spr_bobby_photo_big",                    { event_mdown = function() cmn.NoteScale( "spr_bobby_photo" ); ObjSet( "spr_bobby_photo_big1", { alp = 1, input = true } ) end }},
    { "spr_bobby_photo_big1",                   { event_mdown = private.BobbyPhotoClick }},
    
    { "spr_reverse_statuette",                  { event_mdown = private.get_statuette        }},
    { "spr_reverse_ring",                       { event_mdown = private.get_ring             }},
    { "obj_reverse_clk_key",                    { event_mdown = private.clk_reverse_key      }},
    { "obj_reverse_use_universalkey",           { event_mdown = private.UseUniversalkey      }},
    
    { "obj_room_313_window_code",               { event_mdown = private.get_codepart_1       }},
    { "obj_room_313_window_amulet",             { event_mdown = private.get_cross_1          }},
    { "obj_room_313_clk_bobby",                 { event_mdown = private.see_fb_bobby         }},
    { "obj_room_313_window_use_cutters",        { event_mdown = private.UseCutters           }},
    { "obj_room_313_window_use_knittingneedle", { event_mdown = private.UseKnittingneedle    }},
    
    { "spr_underceiling_codepart2",             { event_mdown = private.get_codepart2        }},
    { "obj_underceiling_1_wheel",               { event_mdown = private.get_wheel            }},
    { "spr_underceiling_paperpin",              { event_mdown = private.get_paperpin         }},
    { "spr_underceiling_knittingneedle",        { event_mdown = private.get_knittingneedle   }},
    { "spr_underceiling_nails",                 { event_mdown = private.get_nails            }},
    { "obj_underceiling_use_ring",              { event_mdown = private.UseRing              }},
    { "obj_underceiling_1_use_breadcrust",      { event_mdown = private.UseBreadcrust        }},
    
    { "obj_toy_clk_door",                       { event_mdown = private.clk_toy_door         }},    
    { "spr_toy_wood_1",                         { event_mdown = private.get_wood_1           }},
    { "spr_toy_lionhead_2",                     { event_mdown = private.get_lionhead_2       }},
    { "spr_toy_weathervanepart",                { event_mdown = private.get_weathervanepart  }},
    { "spr_toy_woodendoll",                     { event_mdown = private.get_woodendoll       }},
    { "obj_toy_use_toyplane",                   { event_mdown = private.UseToyplane          }},
    { "obj_toy_use_hammer",                     { event_mdown = private.UseHammer            }},
    { "obj_toy_use_symbol",                     { event_mdown = private.UseSymbol            }},
    { "obj_toy_use_woodenamulet",               { event_mdown = private.UseWoodenamulet      }},
   
    { "obj_room_313_az_clk",                    { event_mdown = private.ClkPlayAudioRoom313  }},

    { "spr_room_313_collect_morph_item",    { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_3" ); end } },
      
    { "spr_couch_collect2_item_7",              { event_mdown = private.get_collect2_item_7   } }, 
      
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_room_313 = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
  local gates = 
  {
    "gho_room_313_signs",
    "gzz_room_313_ritualsigns",
    "gzz_room_313_reverse",
    "gzz_room_313_room_313_window",
    "gzz_room_313_underceiling",
    "gzz_room_313_toy",
    "gzz_room_313_bobby",
    "gzz_room_313_couch"
  };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_couch",
      "zz_ritualsigns",
      "zz_bobby",
      "zz_reverse",
      "zz_room_313_window",
      "zz_underceiling",
      "zz_toy",
      "zz_underceiling_1",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_room_313", update_game_mode_room_313, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_room_313 = function ()

  local effects_table = 
  {
    "" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_room_313", update_performance_mode_room_313, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_room_313 () end;
  --------------------------------------------------------------------------------------------
  local opn_room_313_map = function ()

    common_impl.VisitMapRoom( "room_313" );

  end;
  cmn.AddSubscriber( "opn_room_313", opn_room_313_map );

  --------------------------------------------------------------------------------------------
  -- function clk_couch_wheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_couch_wheel" ] = {
    type = "click",
    use_place = "obj_couch_clk_wheel",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  
  local clk_couch_wheel_beg = function ()

    ObjDelete( "obj_couch_clk_wheel" );
  
  end;
  local clk_couch_wheel_end = function ()

    ObjMultiSet( { 
      { "obj_couch_use_wheel",           { input = true  } },
      { "obj_couch_chair_big",           {   ang = -0.17 } },
      { "obj_couch_chair_big_over",      {   ang = -0.17 } },
      { "spr_room_313_1",                {   ang = -0.15 } },
      { "obj_room_313_chair",            {   ang = -0.15 } },
      { "spr_room_313_zz_couch_curtain", {   alp = 1     } }, 
      { "anm_room_313_chair",            {   alp = 0     } },    
      { "spr_room_313_patch",            {   alp = 0     } },  
    } );
    ObjDelete( "obj_couch_books" );
    ObjDelete( "spr_room_313_books" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_couch_wheel",     clk_couch_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_couch_wheel",     clk_couch_wheel_end, private.room_objname );
  cmn.AddSubscriber( "clk_couch_wheel_beg", clk_couch_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_couch_wheel_end", clk_couch_wheel_end, private.room_objname );   
 
  --------------------------------------------------------------------------------------------
  -- function clk_couch_chair () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_couch_chair" ] = {
    type = "click",
    use_place = "obj_couch_clk_chair",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  
  local clk_couch_chair_beg = function ()

    ObjDelete( "obj_couch_clk_chair" );
  
  end;
  local clk_couch_chair_end = function ()

    ObjMultiSet( { 
      { "obj_couch_use_hammer",  {   input = true                             } },
      { "obj_couch_chair",       {   pos_x = -442, pos_y = -14, input = false } },
      { "spr_couch_wheel",       {   res = "assets/levels/level1/rm_room_313/zz_couch/layers/wheel_light_back_2", pos_y = -116 } },
    } );
    ObjDelete( "obj_couch_clk_chair" );
    ObjDelete( "vid_couch_chair" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_couch_chair",     clk_couch_chair_beg, private.room_objname );
  cmn.AddSubscriber( "clk_couch_chair",     clk_couch_chair_end, private.room_objname );
  cmn.AddSubscriber( "clk_couch_chair_beg", clk_couch_chair_beg, private.room_objname );
  cmn.AddSubscriber( "clk_couch_chair_end", clk_couch_chair_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function clk_toy_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_toy_door" ] = {
    type = "click",
    use_place = "obj_toy_clk_door",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  
  local clk_toy_door_beg = function ()

    ObjDelete( "obj_toy_clk_door" );
  
  end;
  local clk_toy_door_end = function ()

    ObjMultiSet( { 
      { "spr_toy_lionhead_2",       { input = true } },
      { "obj_toy_open_1",           { input = true } },
      { "spr_toy_door_left_open",   {   alp = 1    } },
      { "spr_room_313_4",           {   alp = 1    } },
    } );
    ObjDelete( "spr_toy_door_left_closed" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_toy_door",     clk_toy_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_toy_door",     clk_toy_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_toy_door_beg", clk_toy_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_toy_door_end", clk_toy_door_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function clk_reverse_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_reverse_key" ] = {
    type = "click",
    use_place = "obj_reverse_clk_key",
    room = private.room_objname,
    zz = "zz_reverse",
    zz_gate = "gzz_room_313_reverse"
  };
  
  local clk_reverse_key_beg = function ()

    ObjDelete( "obj_reverse_clk_key" );
  
  end;
  local clk_reverse_key_end = function ()

    ObjMultiSet( { 
      { "spr_reverse_door_open",            {     alp = 1                  } },
      { "grm_room_313_thirdfloorcorridor",  { visible = true, input = true } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_room_313_thirdfloorcorridor_focus");
    end;
    
    ObjDelete( "spr_reverse_key_universal_1" );
    ObjDelete( "gzz_room_313_reverse" );
    common_impl.LockMapRoom( "thirdfloorcorridor", false );
    common_impl.LockMapRoom( "closedroom", false );   
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_reverse_key",     clk_reverse_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reverse_key",     clk_reverse_key_end, private.room_objname );
  cmn.AddSubscriber( "clk_reverse_key_beg", clk_reverse_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reverse_key_end", clk_reverse_key_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function clk_ritualsigns_signs () end;
  --------------------------------------------------------------------------------------------
  
  local clk_ritualsigns_signs_beg = function ()

    ObjDelete( "obj_ritualsigns_clk_ritualsigns_signs" );
  
  end;
  local clk_ritualsigns_signs_end = function ()

    ObjDelete( "anm_ritualsigns_signs" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_ritualsigns_signs",     clk_ritualsigns_signs_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ritualsigns_signs",     clk_ritualsigns_signs_end, private.room_objname );
  cmn.AddSubscriber( "clk_ritualsigns_signs_beg", clk_ritualsigns_signs_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ritualsigns_signs_end", clk_ritualsigns_signs_end, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function win_couch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_couch" ] =
  {
    type = "click",
    clk_obj = "obj_couch_mmg",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  --*********************************************************************************************************************
  local win_couch = function ()

    if ( cmn.IsEventDone( "win_couch" ) ) then
   
      ObjMultiSet( { 
        { "spr_couch_door_left_opened",  {   alp = 1, input = true } },
        { "spr_room_313_door_left_open", {   alp = 1               } },
        { "obj_couch_mmg_switch",        { input = false           } },
      } );
      
    else 

      private.CouchLoad();
      
    end;
    
  end;

  cmn.AddSubscriber( "win_couch", win_couch, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_toy () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_toy" ] =
  {
    type = "click",
    clk_obj = "obj_toy_mmg",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  --*********************************************************************************************************************
  local win_toy = function ()

    if ( cmn.IsEventDone( "win_toy" ) ) then
   
      ObjMultiSet( { 
        { "obj_toy_use_hammer", { input = true } },
        { "spr_toy_switch_1",   {   alp = 1    } },
        { "spr_toy_switch_2",   {   alp = 1    } },
        { "spr_toy_switch_3",   {   alp = 1    } },
      } );
      ObjDelete( "obj_toy_mmg" );
      ObjDelete( "spr_room_313_1_1" );
      
    else 

      private.ToyLoad();
      
    end;
    
  end;

  cmn.AddSubscriber( "win_toy", win_toy, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_bracedrill () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bracedrill" ] = {
    type = "get",
    get_obj = "spr_couch_bracedrill",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  
  local get_bracedrill_inv = function ()
  
    interface.InventoryItemAdd( "inv_bracedrill", "spr_couch_bracedrill" );
  
  end;
  
  local get_bracedrill_closezz = function ()
  
    ObjDelete( "gfx_couch_bracedrill" );
    ObjDelete( "spr_couch_drill_dark" );
    ObjDelete( "spr_couch_lantern_2" );
    ObjDelete( "obj_couch_chair_big_over" );
    ObjDelete( "spr_room_313_drill" );
    ObjDelete( "spr_room_313_lantern_light" );
    
    ObjMultiSet( { 
      { "spr_couch_torchnobatteries",  {    alp = 1, input = true } },
      { "gfx_couch_torchnobatteries",  { active = true            } },
      { "spr_room_313_lantern_dark",   {    alp = 1               } },
    } );
    
  end;
  
  cmn.AddSubscriber( "get_bracedrill", get_bracedrill_inv );
  cmn.AddSubscriber( "get_bracedrill", get_bracedrill_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_valve" ] = {
    type = "get",
    get_obj = "spr_couch_valve",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  
  local get_valve_inv = function ()
  
    interface.InventoryItemAdd( "inv_valve", "spr_couch_valve" );
  
  end;
  
  local get_valve_closezz = function ()
  
    ObjDelete( "gfx_couch_valve" );
    
    if ( cmn.IsEventDone( "get_wood_2" ) and 
    cmn.IsGetCollect2( "get_collect2_item_7" ) ) then     
      
      ObjDelete( "gzz_room_313_couch" );
      
    end;  
  
  end;
  
  cmn.AddSubscriber( "get_valve", get_valve_inv );
  cmn.AddSubscriber( "get_valve", get_valve_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_torchnobatteries () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_torchnobatteries" ] = {
    type = "get",
    get_obj = "spr_couch_torchnobatteries",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  
  local get_torchnobatteries_inv = function ()
  
    interface.InventoryItemAdd( "inv_torchnobatteries", "spr_couch_torchnobatteries" );
    ObjSet( "inv_torchnobatteries", { drag = false } );
  
  end;
  
  local get_torchnobatteries_closezz = function ()
  
    ObjDelete( "gfx_couch_torchnobatteries" );
    ObjDelete( "spr_room_313_lantern_dark" );
    
  end;
  
  cmn.AddSubscriber( "get_torchnobatteries", get_torchnobatteries_inv );
  cmn.AddSubscriber( "get_torchnobatteries", get_torchnobatteries_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_carvedamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_carvedamulet_2" ] = {
    type = "get",
    get_obj = "spr_couch_carvedamulet_2",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  
  local get_carvedamulet_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_carvedamulet_2", "spr_couch_carvedamulet_2" );
  
  end;
  
  local get_carvedamulet_2_closezz = function ()
  
    ObjDelete( "gfx_couch_carvedamulet_2" );
    ObjDelete( "spr_room_313_amulet" );
    
  end;
  
  cmn.AddSubscriber( "get_carvedamulet_2", get_carvedamulet_2_inv );
  cmn.AddSubscriber( "get_carvedamulet_2", get_carvedamulet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_firstaidkit () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_firstaidkit" ] = {
    type = "get",
    get_obj = "spr_couch_firstaidkit",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  
  local get_firstaidkit_inv = function ()
  
    interface.InventoryItemAdd( "inv_firstaidkit", "spr_couch_firstaidkit" );
    ObjSet( "inv_firstaidkit", { drag = false } );
  
  end;
  
  local get_firstaidkit_closezz = function ()
  
    ObjDelete( "gfx_couch_firstaidkit" );
    ObjDelete( "spr_room_313_firstaidkit" );
    
  end;
  
  cmn.AddSubscriber( "get_firstaidkit", get_firstaidkit_inv );
  cmn.AddSubscriber( "get_firstaidkit", get_firstaidkit_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clasp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clasp" ] = {
    type = "get",
    get_obj = "spr_couch_clasp",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  
  local get_clasp_inv = function ()
  
    interface.InventoryItemAdd( "inv_clasp", "spr_couch_clasp" );
  
  end;
  
  local get_clasp_closezz = function ()
  
    ObjDelete( "gfx_couch_clasp" );
    ObjDelete( "spr_room_313_clip" );
    
  end;
  
  cmn.AddSubscriber( "get_clasp", get_clasp_inv );
  cmn.AddSubscriber( "get_clasp", get_clasp_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wood_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wood_2" ] = {
    type = "get",
    get_obj = "spr_couch_wood_2",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  
  local get_wood_2_inv = function ()

    local count = 0;
    
    for i = 1, 4, 1 do
      
      if ( cmn.IsEventDone( "get_wood_"..i ) ) then
        
        count = count + 1;
        
      end;
      
    end;
  
    ObjSet( "anm_wood",   { frame = ObjGet( "anm_wood" ).frame + 1 } );
    ObjSet( "inv_wood_2", {   alp = 1                              } );  
    
    interface.InventoryItemAdd( "inv_wood", "spr_couch_wood_2", "assets/levels/level1/rm_room_313/zz_couch/inv/inv_wood_4_6" );

    if count == 4 then
      ObjSet( "inv_wood", { drag = true } );
    else 
      ObjSet( "inv_wood", { drag = false } );
    end;    
    
  end;
  
  local get_wood_2_closezz = function ()
  
    ObjDelete( "gfx_couch_wood_2" );
    ObjDelete( "spr_room_313_wood_1" );
    ObjDelete( "spr_room_313_wood_2" );
    
    if ( cmn.IsEventDone( "get_valve" ) and 
    cmn.IsGetCollect2( "get_collect2_item_7" ) ) then     
      
      ObjDelete( "gzz_room_313_couch" );
      
    end;  
    
  end;
  
  cmn.AddSubscriber( "get_wood_2", get_wood_2_inv );
  cmn.AddSubscriber( "get_wood_2", get_wood_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bobbyamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bobbyamulet" ] = {
    type = "get",
    get_obj = "spr_ritualsigns_bobbyamulet",
    room = private.room_objname,
    zz = "zz_ritualsigns",
    zz_gate = "gzz_room_313_ritualsigns"
  };
  
  local get_bobbyamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_bobbyamulet", "spr_ritualsigns_bobbyamulet" );
  
  end;
  
  local get_bobbyamulet_closezz = function ()
  
    ObjDelete( "gfx_ritualsigns_bobbyamulet" );
  
  end;
  
  cmn.AddSubscriber( "get_bobbyamulet", get_bobbyamulet_inv );
  cmn.AddSubscriber( "get_bobbyamulet", get_bobbyamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_collar" ] = {
    type = "get",
    get_obj = "spr_ritualsigns_collar",
    room = private.room_objname,
    zz = "zz_ritualsigns",
    zz_gate = "gzz_room_313_ritualsigns"
  };
  
  local get_collar_inv = function ()
  
    interface.InventoryItemAdd( "inv_collar", "spr_ritualsigns_collar" );
    ObjSet( "inv_collar", { drag = false } );
  
  end;
  
  local get_collar_closezz = function ()
  
    ObjDelete( "gfx_ritualsigns_collar" );
  
  end;
  
  cmn.AddSubscriber( "get_collar", get_collar_inv );
  cmn.AddSubscriber( "get_collar", get_collar_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_matches () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_matches" ] = {
    type = "get",
    get_obj = "spr_bobby_matches",
    room = private.room_objname,
    zz = "zz_bobby",
    zz_gate = "gzz_room_313_bobby"
  };
  
  local get_matches_inv = function ()
  
    interface.InventoryItemAdd( "inv_matches", "spr_bobby_matches" );
  
  end;
  
  local get_matches_closezz = function ()
  
    ObjDelete( "gfx_bobby_matches" );
  
  end;
  
  cmn.AddSubscriber( "get_matches", get_matches_inv );
  cmn.AddSubscriber( "get_matches", get_matches_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_codepart3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_codepart3" ] = {
    type = "get",
    get_obj = "spr_bobby_codepart3",
    room = private.room_objname,
    zz = "zz_bobby",
    zz_gate = "gzz_room_313_bobby"
  };
  
  local get_codepart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_codepart3", "spr_bobby_codepart3" );
  
  end;
  
  local get_codepart3_closezz = function ()
  
    ObjDelete( "gfx_bobby_codepart3" );
    ObjSet( "spr_bobby_note", { input = true } );
  
  end;
  
  cmn.AddSubscriber( "get_codepart3", get_codepart3_inv );
  cmn.AddSubscriber( "get_codepart3", get_codepart3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_statuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_statuette" ] = {
    type = "get",
    get_obj = "spr_reverse_statuette",
    room = private.room_objname,
    zz = "zz_reverse",
    zz_gate = "gzz_room_313_reverse"
  };
  
  local get_statuette_inv = function ()
  
    interface.InventoryItemAdd( "inv_statuette", "spr_reverse_statuette" );
  
  end;
  
  local get_statuette_closezz = function ()
  
    ObjDelete( "gfx_reverse_statuette" );
  
  end;
  
  cmn.AddSubscriber( "get_statuette", get_statuette_inv );
  cmn.AddSubscriber( "get_statuette", get_statuette_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ring" ] = {
    type = "get",
    get_obj = "spr_reverse_ring",
    room = private.room_objname,
    zz = "zz_reverse",
    zz_gate = "gzz_room_313_reverse"
  };
  
  local get_ring_inv = function ()
  
    interface.InventoryItemAdd( "inv_ring", "spr_reverse_ring" );
  
  end;
  
  local get_ring_closezz = function ()
  
    ObjDelete( "gfx_reverse_ring" );
  
  end;
  
  cmn.AddSubscriber( "get_ring", get_ring_inv );
  cmn.AddSubscriber( "get_ring", get_ring_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_codepart_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_codepart_1" ] = {
    type = "get",
    get_obj = "obj_room_313_window_code",
    room = private.room_objname,
    zz = "zz_room_313_window",
    zz_gate = "gzz_room_313_room_313_window"
  };
  
  local get_codepart_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_codepart_1", "obj_room_313_window_code" );
  
  end;
  
  local get_codepart_1_closezz = function ()
  
    ObjDelete( "gfx_room_313_window_codepart_1" );
  
  end;
  
  cmn.AddSubscriber( "get_codepart_1", get_codepart_1_inv );
  cmn.AddSubscriber( "get_codepart_1", get_codepart_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cross_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cross_1" ] = {
    type = "get",
    get_obj = "obj_room_313_window_amulet",
    room = private.room_objname,
    zz = "zz_room_313_window",
    zz_gate = "gzz_room_313_room_313_window"
  };
  
  local get_cross_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_cross_1", "obj_room_313_window_amulet" );
    cmn.SetInvPlusRGB( "firstaidkit", true );
  
  end;
  
  local get_cross_1_closezz = function ()
  
    ObjDelete( "gfx_room_313_window_cross_1" );
  
  end;
  
  cmn.AddSubscriber( "get_cross_1", get_cross_1_inv );
  cmn.AddSubscriber( "get_cross_1", get_cross_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_codepart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_codepart2" ] = {
    type = "get",
    get_obj = "spr_underceiling_codepart2",
    room = private.room_objname,
    zz = "zz_underceiling",
    zz_gate = "gzz_room_313_underceiling"
  };
  
  local get_codepart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_codepart2", "spr_underceiling_codepart2" );
  
  end;
  
  local get_codepart2_closezz = function ()
  
    ObjDelete( "gfx_underceiling_codepart2" );
  
  end;
  
  cmn.AddSubscriber( "get_codepart2", get_codepart2_inv );
  cmn.AddSubscriber( "get_codepart2", get_codepart2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wheel" ] = {
    type = "get",
    get_obj = "obj_underceiling_1_wheel",
    room = private.room_objname,
    zz = "zz_underceiling",
    zz_gate = "gzz_room_313_underceiling", 
    subzz = "zz_underceiling_1",
    subzz_gate = "gzz_underceiling_underceiling_1"
  };
  
  local get_wheel_inv = function ()
  
    interface.InventoryItemAdd( "inv_wheel", "obj_underceiling_1_wheel" );
  
  end;
  
  local get_wheel_closezz = function ()
  
    ObjDelete( "gfx_underceiling_wheel" );
    ObjDelete( "gzz_room_313_underceiling" );
    ObjDelete( "gzz_underceiling_underceiling_1" );
    
  end;
  
  cmn.AddSubscriber( "get_wheel", get_wheel_inv );
  cmn.AddSubscriber( "get_wheel", get_wheel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_paperpin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_paperpin" ] = {
    type = "get",
    get_obj = "spr_underceiling_paperpin",
    room = private.room_objname,
    zz = "zz_underceiling",
    zz_gate = "gzz_room_313_underceiling"
  };
  
  local get_paperpin_inv = function ()
  
    interface.InventoryItemAdd( "inv_paperpin", "spr_underceiling_paperpin" );
  
  end;
  
  local get_paperpin_closezz = function ()
  
    ObjDelete( "gfx_underceiling_paperpin" );
  
  end;
  
  cmn.AddSubscriber( "get_paperpin", get_paperpin_inv );
  cmn.AddSubscriber( "get_paperpin", get_paperpin_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_knittingneedle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_knittingneedle" ] = {
    type = "get",
    get_obj = "spr_underceiling_knittingneedle",
    room = private.room_objname,
    zz = "zz_underceiling",
    zz_gate = "gzz_room_313_underceiling"
  };
  
  local get_knittingneedle_inv = function ()
  
    interface.InventoryItemAdd( "inv_knittingneedle", "spr_underceiling_knittingneedle" );
  
  end;
  
  local get_knittingneedle_closezz = function ()
  
    ObjDelete( "gfx_underceiling_knittingneedle" );
  
  end;
  
  cmn.AddSubscriber( "get_knittingneedle", get_knittingneedle_inv );
  cmn.AddSubscriber( "get_knittingneedle", get_knittingneedle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nails () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nails" ] = {
    type = "get",
    get_obj = "spr_underceiling_nails",
    room = private.room_objname,
    zz = "zz_underceiling",
    zz_gate = "gzz_room_313_underceiling"
  };
  
  local get_nails_inv = function ()
  
    interface.InventoryItemAdd( "inv_nails", "spr_underceiling_nails" );
  
  end;
  
  local get_nails_closezz = function ()
  
    ObjDelete( "gfx_underceiling_nails" );
  
  end;
  
  cmn.AddSubscriber( "get_nails", get_nails_inv );
  cmn.AddSubscriber( "get_nails", get_nails_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wood_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wood_1" ] = {
    type = "get",
    get_obj = "obj_toy_wood",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  
  local get_wood_1_inv = function ()
  
    local count = 0;
    
    for i = 1, 4, 1 do
      
      if ( cmn.IsEventDone( "get_wood_"..i ) ) then
        
        count = count + 1;
        
      end;
      
    end;
  
    ObjSet( "anm_wood",   { frame = ObjGet( "anm_wood" ).frame + 1 } );
    ObjSet( "inv_wood_1", {   alp = 1                              } );  
    interface.InventoryItemAdd( "inv_wood", "obj_toy_wood", "assets/levels/level1/rm_room_313/zz_toy/inv/inv_wood_2_6" );

    if count == 4 then
      ObjSet( "inv_wood", { drag = true } );
    else 
      ObjSet( "inv_wood", { drag = false } );
    end;
  
  end;
  
  local get_wood_1_closezz = function ()
  
    ObjDelete( "gfx_toy_wood_1" );
    ObjDelete( "obj_room_313_woods" );
    
  end;
  
  cmn.AddSubscriber( "get_wood_1", get_wood_1_inv );
  cmn.AddSubscriber( "get_wood_1", get_wood_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lionhead_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lionhead_2" ] = {
    type = "get",
    get_obj = "spr_toy_lionhead_2",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  
  local get_lionhead_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_lionhead_2", "spr_toy_lionhead_2" );
  
  end;
  
  local get_lionhead_2_closezz = function ()
  
    ObjDelete( "gfx_toy_lionhead_2" );
    ObjDelete( "spr_room_313_wooden" );
    ObjMultiSet( { 
      { "obj_toy_use_woodenamulet", { input = true } },
    } );
    
  end;
  
  cmn.AddSubscriber( "get_lionhead_2", get_lionhead_2_inv );
  cmn.AddSubscriber( "get_lionhead_2", get_lionhead_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_weathervanepart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_weathervanepart" ] = {
    type = "get",
    get_obj = "spr_toy_weathervanepart",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  
  local get_weathervanepart_inv = function ()
  
    interface.InventoryItemAdd( "inv_weathervanepart", "spr_toy_weathervanepart" );
  
  end;
  
  local get_weathervanepart_closezz = function ()
  
    ObjDelete( "gfx_toy_weathervanepart" );
    ObjDelete( "spr_room_313_weather_vane_part" );
    
  end;
  
  cmn.AddSubscriber( "get_weathervanepart", get_weathervanepart_inv );
  cmn.AddSubscriber( "get_weathervanepart", get_weathervanepart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_woodendoll () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_woodendoll" ] = {
    type = "get",
    get_obj = "spr_toy_woodendoll",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  
  local get_woodendoll_inv = function ()
  
    interface.InventoryItemAdd( "inv_woodendoll", "spr_toy_woodendoll" );
    ObjSet( "inv_woodendoll", { drag = false } );
  
  end;
  
  local get_woodendoll_closezz = function ()
  
    ObjDelete( "gfx_toy_woodendoll" );
    ObjDelete( "gzz_room_313_toy" );
    ObjDelete( "spr_room_313_doll" );
    
  end;
  
  cmn.AddSubscriber( "get_woodendoll", get_woodendoll_inv );
  cmn.AddSubscriber( "get_woodendoll", get_woodendoll_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_torch_12 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_torch_12" ] = {
    type = "use",
    inv_obj = "inv_torch",
    use_place = "obj_couch_use_torch",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  local use_torch_12_inv = function ()
    
    if ( cmn.IsEventDone( "use_torch_11" ) ) then
      
      interface.InventoryItemRemove( "inv_torch" );
      
    end;
  
  end;
  local use_torch_12_beg = function ()
  
    ObjDelete( "obj_couch_use_torch" );
  
  end;
  local use_torch_12_end = function ()
  
    ObjMultiSet( { 
      { "spr_couch_bracedrill",               { visible = true, input = true } },
      { "spr_couch_lantern_2",                { alp = 1, input = true        } },
      { "obj_couch_chair_big_over",           { alp = 1                      } },
      { "spr_couch_drill_dark_up_side_light", { alp = 1                      } },
      { "spr_room_313_lantern_light",         { alp = 1                      } },
      { "spr_room_313_drill",                 { alp = 1                      } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_torch_12", use_torch_12_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch_12", use_torch_12_inv );
  cmn.AddSubscriber( "use_torch_12", use_torch_12_end, private.room_objname );
  cmn.AddSubscriber( "use_torch_12_inv", use_torch_12_inv, private.room_objname );
  cmn.AddSubscriber( "use_torch_12_beg", use_torch_12_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch_12_end", use_torch_12_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_statuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_statuette" ] = {
    type = "use",
    inv_obj = "inv_statuette",
    use_place = "obj_couch_use_statuette",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  local use_statuette_inv = function ()
  
    interface.InventoryItemRemove( "inv_statuette" );
  
  end;
  local use_statuette_beg = function ()
  
    ObjDelete( "obj_couch_use_statuette" );
  
  end;
  local use_statuette_end = function ()
  
    ObjMultiSet( { 
      { "spr_couch_door_right_opened",    { alp = 1, input = true } },
      { "spr_room_313_door_righft_open",  { alp = 1               } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_statuette", use_statuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuette", use_statuette_inv );
  cmn.AddSubscriber( "use_statuette", use_statuette_end, private.room_objname );
  cmn.AddSubscriber( "use_statuette_inv", use_statuette_inv, private.room_objname );
  cmn.AddSubscriber( "use_statuette_beg", use_statuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuette_end", use_statuette_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_codepart_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_codepart_1" ] = {
    type = "use",
    inv_obj = "inv_codepart_1",
    use_place = "obj_couch_use_codepart",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  local use_codepart_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_codepart_1" );
  
  end;
  local use_codepart_1_beg = function ()
  
    --ObjDelete( "obj_couch_use_codepart_1" );
  
  end;
  local use_codepart_1_end = function ()
    
    ObjMultiSet( { 
      { "spr_couch_paper_01",         { alp = 1 } },
      { "spr_room_313_paper_part_1",  { alp = 1 } },
    } );
      
    if ( cmn.IsEventDone( "use_codepart2" ) and 
    cmn.IsEventDone( "use_codepart3" ) ) then
    
      ObjMultiSet( { 
        { "obj_couch_mmg",  { input = true } },
      } );
      ObjDelete( "obj_couch_use_codepart" );
    
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_codepart_1", use_codepart_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_codepart_1", use_codepart_1_inv );
  cmn.AddSubscriber( "use_codepart_1", use_codepart_1_end, private.room_objname );
  cmn.AddSubscriber( "use_codepart_1_inv", use_codepart_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_codepart_1_beg", use_codepart_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_codepart_1_end", use_codepart_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_codepart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_codepart2" ] = {
    type = "use",
    inv_obj = "inv_codepart2",
    use_place = "obj_couch_use_codepart",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  local use_codepart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_codepart2" );
  
  end;
  local use_codepart2_beg = function ()
  
    --ObjDelete( "obj_couch_use_codepart2" );
  
  end;
  local use_codepart2_end = function ()
    
    ObjMultiSet( { 
      { "spr_couch_paper_02",         { alp = 1 } },
      { "spr_room_313_paper_part_2",  { alp = 1 } },
    } );
    
    if ( cmn.IsEventDone( "use_codepart_1" ) and 
    cmn.IsEventDone( "use_codepart3" ) ) then
    
      ObjMultiSet( { 
        { "obj_couch_mmg",  { input = true } },
      } );
      ObjDelete( "obj_couch_use_codepart" );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_codepart2", use_codepart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_codepart2", use_codepart2_inv );
  cmn.AddSubscriber( "use_codepart2", use_codepart2_end, private.room_objname );
  cmn.AddSubscriber( "use_codepart2_inv", use_codepart2_inv, private.room_objname );
  cmn.AddSubscriber( "use_codepart2_beg", use_codepart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_codepart2_end", use_codepart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_codepart3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_codepart3" ] = {
    type = "use",
    inv_obj = "inv_codepart3",
    use_place = "obj_couch_use_codepart",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  local use_codepart3_inv = function ()
  
    interface.InventoryItemRemove( "inv_codepart3" );
  
  end;
  local use_codepart3_beg = function ()
  
    --ObjDelete( "obj_couch_use_codepart3" );
  
  end;
  local use_codepart3_end = function ()
    
    ObjMultiSet( { 
      { "spr_couch_paper_03",         { alp = 1 } },
      { "spr_room_313_paper_part_3",  { alp = 1 } },
    } );
    
    if ( cmn.IsEventDone( "use_codepart_1" ) and 
    cmn.IsEventDone( "use_codepart2" ) ) then
    
      ObjMultiSet( { 
        { "obj_couch_mmg",  { input = true } },
      } );
      ObjDelete( "obj_couch_use_codepart" );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_codepart3", use_codepart3_beg, private.room_objname );
  cmn.AddSubscriber( "use_codepart3", use_codepart3_inv );
  cmn.AddSubscriber( "use_codepart3", use_codepart3_end, private.room_objname );
  cmn.AddSubscriber( "use_codepart3_inv", use_codepart3_inv, private.room_objname );
  cmn.AddSubscriber( "use_codepart3_beg", use_codepart3_beg, private.room_objname );
  cmn.AddSubscriber( "use_codepart3_end", use_codepart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wheel" ] = {
    type = "use",
    inv_obj = "inv_wheel",
    use_place = "obj_couch_use_wheel",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  local use_wheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_wheel" );
  
  end;
  local use_wheel_beg = function ()
  
    ObjDelete( "obj_couch_use_wheel" );
  
  end;
  local use_wheel_end = function ()
    
    ObjDelete( "spr_room_313_zz_couch_curtain" );
    ObjMultiSet( { 
      { "obj_couch_clk_chair",       { input = true } },
      { "spr_couch_wheel",           {   alp = 1    } },
      { "obj_couch_chair_big",       {   ang = 0    } },
      { "obj_couch_chair_big_over",  {   ang = 0    } },
      { "spr_room_313_1",            {   ang = 0    } },
      { "obj_room_313_chair",        {   ang = 0    } },
      { "spr_room_313_wheel",        {   alp = 1    } },
      { "spr_room_313_patch",        {   alp = 1    } },  
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wheel", use_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel", use_wheel_inv );
  cmn.AddSubscriber( "use_wheel", use_wheel_end, private.room_objname );
  cmn.AddSubscriber( "use_wheel_inv", use_wheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_wheel_beg", use_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel_end", use_wheel_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_hammer_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_2" ] = {
    type = "use",
    inv_obj = "inv_hammer",
    use_place = "obj_couch_use_hammer",
    room = private.room_objname,
    zz = "zz_couch",
    zz_gate = "gzz_room_313_couch"
  };
  local use_hammer_2_inv = function ()
    
    if ( cmn.IsEventDone( "use_hammer_1" ) and
    cmn.IsEventDone( "use_hammer_3" ) and
    cmn.IsEventDone( "use_hammer_4" ) ) then

      interface.InventoryItemRemove( "inv_hammer" );
      
    end;
    
    ObjDelete( "anm_couch_wood_hh" );
  
  end;
  local use_hammer_2_beg = function ()
  
    ObjDelete( "obj_couch_use_hammer" );
  
  end;
  local use_hammer_2_end = function ()
    
    ObjDelete( "anm_couch_wood" );
    ObjDelete( "spr_room_313_1" );
    
    ObjMultiSet( { 
       { "spr_couch_wood_2",     {    alp = 1, input = true } },
       { "spr_couch_valve",      {  input = true            } },
       { "gfx_couch_wood_2",     { active = true            } },
       { "gfx_couch_valve",      { active = true            } },
       { "anm_couch_wood_after", {    alp = 1               } },
       { "spr_room_313_2",       {    alp = 1               } },
       { "spr_room_313_wood_1",  {    alp = 1               } },
       { "spr_room_313_wood_2",  {    alp = 1               } },
       { "obj_room_313_chair",   {   pos_x = 175, pos_y = 561 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammer_2", use_hammer_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_2", use_hammer_2_inv );
  cmn.AddSubscriber( "use_hammer_2", use_hammer_2_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_2_inv", use_hammer_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_2_beg", use_hammer_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_2_end", use_hammer_2_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function use_tongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tongs" ] = {
    type = "use",
    inv_obj = "inv_tongs",
    use_place = "obj_ritualsigns_use_tongs",
    room = private.room_objname,
    zz = "zz_ritualsigns",
    zz_gate = "gzz_room_313_ritualsigns"
  };
  local use_tongs_inv = function ()
  
    interface.InventoryItemRemove( "inv_tongs" );
  
  end;
  local use_tongs_beg = function ()
  
    ObjDelete( "obj_ritualsigns_use_tongs" );
  
  end;
  local use_tongs_end = function ()
  
    ObjMultiSet( { 
      { "spr_ritualsigns_bobbyamulet",  { alp = 1, input = true } },
    } );
    ObjDelete( "spr_ritualsigns_bobbyamulet_2" );
    ObjDelete( "spr_ritualsigns_patchnew" );
    ObjDelete( "anm_ritualsigns_amulet" );
    ObjDelete( "anm_ritualsigns_amulet_hh" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tongs", use_tongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs", use_tongs_inv );
  cmn.AddSubscriber( "use_tongs", use_tongs_end, private.room_objname );
  cmn.AddSubscriber( "use_tongs_inv", use_tongs_inv, private.room_objname );
  cmn.AddSubscriber( "use_tongs_beg", use_tongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs_end", use_tongs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_carvedamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_carvedamulet_1" ] = {
    type = "use",
    inv_obj = "inv_carvedamulet_1",
    use_place = "obj_ritualsigns_use_carvedamulet_1",
    room = private.room_objname,
    zz = "zz_ritualsigns",
    zz_gate = "gzz_room_313_ritualsigns"
  };
  local use_carvedamulet_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_carvedamulet_1" );
  
  end;
  local use_carvedamulet_1_beg = function ()
  
    ObjDelete( "obj_ritualsigns_use_carvedamulet_1" );
  
  end;
  local use_carvedamulet_1_end = function ()
    
    ObjDelete( "vid_ritualsigns_angel" );
    ObjDelete( "spr_room_313_zz_signs_first" );
    ObjMultiSet( { 
      { "spr_ritualsigns_amulet1",  { alp = 1 } },
      { "spr_room_313_symbvol2",    { alp = 1 } },
      { "spr_room_313_zz_signs_2",  { alp = 1 } },
    } );
     
    if ( cmn.IsEventDone( "use_carvedamulet_2" ) ) then
      
      ObjDelete( "gzz_room_313_ritualsigns" );
      ObjDelete( "spr_room_313_zz_signs_2" );
      ObjMultiSet( { 
        { "gho_room_313_signs",       { visible = true, input = true } },
        { "spr_room_313_zz_signs_3",  {     alp = 1                  } },
      } );
    
    end; 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_carvedamulet_1", use_carvedamulet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_carvedamulet_1", use_carvedamulet_1_inv );
  cmn.AddSubscriber( "use_carvedamulet_1", use_carvedamulet_1_end, private.room_objname );
  cmn.AddSubscriber( "use_carvedamulet_1_inv", use_carvedamulet_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_carvedamulet_1_beg", use_carvedamulet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_carvedamulet_1_end", use_carvedamulet_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_carvedamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_carvedamulet_2" ] = {
    type = "use",
    inv_obj = "inv_carvedamulet_2",
    use_place = "obj_ritualsigns_use_carvedamulet_2",
    room = private.room_objname,
    zz = "zz_ritualsigns",
    zz_gate = "gzz_room_313_ritualsigns"
  };
  local use_carvedamulet_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_carvedamulet_2" );
  
  end;
  local use_carvedamulet_2_beg = function ()
  
    ObjDelete( "obj_ritualsigns_use_carvedamulet_2" );
  
  end;
  local use_carvedamulet_2_end = function ()
    
    ObjDelete( "vid_ritualsigns_angel" );
    ObjDelete( "spr_room_313_zz_signs_first" );
    ObjMultiSet( { 
      { "spr_ritualsigns_amulet2",  { alp = 1 } },
      { "spr_room_313_symbvol1",    { alp = 1 } },
      { "spr_room_313_zz_signs_2",  { alp = 1 } },
    } );
    
    if ( cmn.IsEventDone( "use_carvedamulet_1" ) ) then
      
      ObjDelete( "gzz_room_313_ritualsigns" );
      ObjDelete( "spr_room_313_zz_signs_2" );
      ObjMultiSet( { 
        { "gho_room_313_signs",       { visible = true, input = true } },
        { "spr_room_313_zz_signs_3",  {     alp = 1                  } },
      } );

    end;     
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_carvedamulet_2", use_carvedamulet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_carvedamulet_2", use_carvedamulet_2_inv );
  cmn.AddSubscriber( "use_carvedamulet_2", use_carvedamulet_2_end, private.room_objname );
  cmn.AddSubscriber( "use_carvedamulet_2_inv", use_carvedamulet_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_carvedamulet_2_beg", use_carvedamulet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_carvedamulet_2_end", use_carvedamulet_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hotelsign () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hotelsign" ] = {
    type = "use",
    inv_obj = "inv_hotelsign",
    use_place = "obj_ritualsigns_use_hotelsign",
    room = private.room_objname,
    zz = "zz_ritualsigns",
    zz_gate = "gzz_room_313_ritualsigns"
  };
  local use_hotelsign_inv = function ()
  
    interface.InventoryItemRemove( "inv_hotelsign" );
  
  end;
  local use_hotelsign_beg = function ()
  
    ObjDelete( "obj_ritualsigns_use_hotelsign" );
  
  end;
  local use_hotelsign_end = function ()
  
    ObjMultiSet( { 
      { "spr_ritualsigns_collar",     { visible = true, input = true } },
      { "gfx_ritualsigns_collar",     {  active = true               } },
      { "anm_ritualsigns_open_door",  {     alp = 1, frame = 300     } },
    } );
    ObjDelete( "spr_ritualsigns_door" );
    ObjDelete( "anm_ritualsigns_open_door_hh" );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hotelsign", use_hotelsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotelsign", use_hotelsign_inv );
  cmn.AddSubscriber( "use_hotelsign", use_hotelsign_end, private.room_objname );
  cmn.AddSubscriber( "use_hotelsign_inv", use_hotelsign_inv, private.room_objname );
  cmn.AddSubscriber( "use_hotelsign_beg", use_hotelsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotelsign_end", use_hotelsign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bobbyamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bobbyamulet" ] = {
    type = "use",
    inv_obj = "inv_bobbyamulet",
    use_place = "obj_bobby_use_bobbyamulet",
    room = private.room_objname,
    zz = "zz_bobby",
    zz_gate = "gzz_room_313_bobby"
  };
  local use_bobbyamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_bobbyamulet" );
  
  end;
  local use_bobbyamulet_beg = function ()
  
    ObjDelete( "obj_bobby_use_bobbyamulet" );
  
  end;
  local use_bobbyamulet_end = function ()
  
    ObjDelete( "anm_bobby_amulet" );
    ObjMultiSet( { 
      { "spr_bobby_pocket1",             { alp = 1, visible = true, input = true } },
      { "spr_room_313_zz_bobby_amulet",  { alp = 1                               } },
      { "spr_room_313_zz_bobby_pocket1", { alp = 1                               } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bobbyamulet", use_bobbyamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bobbyamulet", use_bobbyamulet_inv );
  cmn.AddSubscriber( "use_bobbyamulet", use_bobbyamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_bobbyamulet_inv", use_bobbyamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_bobbyamulet_beg", use_bobbyamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bobbyamulet_end", use_bobbyamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_paperpin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_paperpin" ] = {
    type = "use",
    inv_obj = "inv_paperpin",
    use_place = "obj_bobby_use_paperpin",
    room = private.room_objname,
    zz = "zz_bobby",
    zz_gate = "gzz_room_313_bobby"
  };
  local use_paperpin_inv = function ()
  
    interface.InventoryItemRemove( "inv_paperpin" );
  
  end;
  local use_paperpin_beg = function ()
  
    ObjDelete( "obj_bobby_use_paperpin" );
  
  end;
  local use_paperpin_end = function ()
  
    ObjDelete( "anm_bobby_pocket" );
    ObjMultiSet( { 
      { "obj_bobby_pocket_bottom",        { alp = 1, visible = true, input = true } },
      { "spr_room_313_zz_bobbu_pocket2",  { alp = 1                               } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_paperpin", use_paperpin_beg, private.room_objname );
  cmn.AddSubscriber( "use_paperpin", use_paperpin_inv );
  cmn.AddSubscriber( "use_paperpin", use_paperpin_end, private.room_objname );
  cmn.AddSubscriber( "use_paperpin_inv", use_paperpin_inv, private.room_objname );
  cmn.AddSubscriber( "use_paperpin_beg", use_paperpin_beg, private.room_objname );
  cmn.AddSubscriber( "use_paperpin_end", use_paperpin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_diamond () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_diamond" ] = {
    type = "use",
    inv_obj = "inv_diamond",
    use_place = "obj_reverse_use_diamond",
    room = private.room_objname,
    zz = "zz_reverse",
    zz_gate = "gzz_room_313_reverse"
  };
  local use_diamond_inv = function ()
  
    interface.InventoryItemRemove( "inv_diamond" );
  
  end;
  local use_diamond_beg = function ()
  
    ObjDelete( "obj_reverse_use_diamond" );
  
  end;
  local use_diamond_end = function ()
    
    ObjDelete( "anm_reverse_brilliant" );
    ObjMultiSet( { 
      { "obj_reverse_hole",       {     alp = true, input = true } },
      { "spr_reverse_statuette",  { visible = true, input = true } },
      { "spr_reverse_ring",       { visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_diamond", use_diamond_beg, private.room_objname );
  cmn.AddSubscriber( "use_diamond", use_diamond_inv );
  cmn.AddSubscriber( "use_diamond", use_diamond_end, private.room_objname );
  cmn.AddSubscriber( "use_diamond_inv", use_diamond_inv, private.room_objname );
  cmn.AddSubscriber( "use_diamond_beg", use_diamond_beg, private.room_objname );
  cmn.AddSubscriber( "use_diamond_end", use_diamond_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_universalkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_universalkey" ] = {
    type = "use",
    inv_obj = "inv_universalkey",
    use_place = "obj_reverse_use_universalkey",
    room = private.room_objname,
    zz = "zz_reverse",
    zz_gate = "gzz_room_313_reverse"
  };
  local use_universalkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_universalkey" );
  
  end;
  local use_universalkey_beg = function ()
  
    ObjDelete( "obj_reverse_use_universalkey" );
    ObjDelete( "anm_reverse_hh" );
  
  end;
  local use_universalkey_end = function ()
    
    ObjMultiSet( { 
      { "anm_reverse_key",      { frame = 300  } },
      { "obj_reverse_clk_key",  { input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_universalkey", use_universalkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_universalkey", use_universalkey_inv );
  cmn.AddSubscriber( "use_universalkey", use_universalkey_end, private.room_objname );
  cmn.AddSubscriber( "use_universalkey_inv", use_universalkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_universalkey_beg", use_universalkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_universalkey_end", use_universalkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_paperandpencil () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_paperandpencil" ] = {
    type = "use",
    inv_obj = "inv_paperandpencil",
    use_place = "obj_room_313_window_use_paperandpencil",
    room = private.room_objname,
    zz = "zz_room_313_window",
    zz_gate = "gzz_room_313_room_313_window"
  };
  local use_paperandpencil_inv = function ()
  
    interface.InventoryItemRemove( "inv_paperandpencil" );
  
  end;
  local use_paperandpencil_beg = function ()
  
    ObjDelete( "obj_room_313_window_use_paperandpencil" );
  
  end;
  local use_paperandpencil_end = function ()
    
    ObjDelete( "anm_room_313_window_code" );
    ObjMultiSet( { 
      { "obj_room_313_window_code",        {  input = true } },
      { "gfx_room_313_window_codepart_1",  { active = true } },
      { "anm_room_313_window_code_after",  {    alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_paperandpencil", use_paperandpencil_beg, private.room_objname );
  cmn.AddSubscriber( "use_paperandpencil", use_paperandpencil_inv );
  cmn.AddSubscriber( "use_paperandpencil", use_paperandpencil_end, private.room_objname );
  cmn.AddSubscriber( "use_paperandpencil_inv", use_paperandpencil_inv, private.room_objname );
  cmn.AddSubscriber( "use_paperandpencil_beg", use_paperandpencil_beg, private.room_objname );
  cmn.AddSubscriber( "use_paperandpencil_end", use_paperandpencil_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_knittingneedle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knittingneedle" ] = {
    type = "use",
    inv_obj = "inv_knittingneedle",
    use_place = "obj_room_313_window_use_knittingneedle",
    room = private.room_objname,
    zz = "zz_room_313_window",
    zz_gate = "gzz_room_313_room_313_window"
  };
  local use_knittingneedle_inv = function ()
  
    interface.InventoryItemRemove( "inv_knittingneedle" );
  
  end;
  local use_knittingneedle_beg = function ()
  
    ObjDelete( "obj_room_313_window_use_knittingneedle" );
  
  end;
  local use_knittingneedle_end = function ()
    
    ObjDelete( "anm_room_313_window_amulet" );  
    ObjMultiSet( { 
      { "obj_room_313_window_amulet",   {    alp = 1, input = true } },
      { "gfx_room_313_window_cross_1",  { active = true            } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knittingneedle", use_knittingneedle_beg, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedle", use_knittingneedle_inv );
  cmn.AddSubscriber( "use_knittingneedle", use_knittingneedle_end, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedle_inv", use_knittingneedle_inv, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedle_beg", use_knittingneedle_beg, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedle_end", use_knittingneedle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cutters () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cutters" ] = {
    type = "use",
    inv_obj = "inv_cutters",
    use_place = "obj_room_313_window_use_cutters",
    room = private.room_objname,
    zz = "zz_room_313_window",
    zz_gate = "gzz_room_313_room_313_window"
  };
  local use_cutters_inv = function ()
  
    interface.InventoryItemRemove( "inv_cutters" );
  
  end;
  local use_cutters_beg = function ()
  
    ObjDelete( "obj_room_313_window_use_cutters" );
  
  end;
  local use_cutters_end = function ()
  
    ObjDelete( "gzz_room_313_room_313_window" );
    ObjDelete( "obj_room_313_window" );
    ObjDelete( "spr_room_313_window_2" );
    
    ObjMultiSet( { 
      { "grm_room_313_terrace",  { visible = true, input = true } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_room_313_terrace_focus");
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cutters", use_cutters_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutters", use_cutters_inv );
  cmn.AddSubscriber( "use_cutters", use_cutters_end, private.room_objname );
  cmn.AddSubscriber( "use_cutters_inv", use_cutters_inv, private.room_objname );
  cmn.AddSubscriber( "use_cutters_beg", use_cutters_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutters_end", use_cutters_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clasp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clasp" ] = {
    type = "use",
    inv_obj = "inv_clasp",
    use_place = "obj_underceiling_use_clasp",
    room = private.room_objname,
    zz = "zz_underceiling",
    zz_gate = "gzz_room_313_underceiling"
  };
  local use_clasp_inv = function ()
  
    interface.InventoryItemRemove( "inv_clasp" );
  
  end;
  local use_clasp_beg = function ()
  
    ObjDelete( "obj_underceiling_use_clasp" );
  
  end;
  local use_clasp_end = function ()
    
    ObjDelete( "anm_underceiling_needle" );
    ObjMultiSet( { 
      { "spr_underceiling_knittingneedle",  { visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clasp", use_clasp_beg, private.room_objname );
  cmn.AddSubscriber( "use_clasp", use_clasp_inv );
  cmn.AddSubscriber( "use_clasp", use_clasp_end, private.room_objname );
  cmn.AddSubscriber( "use_clasp_inv", use_clasp_inv, private.room_objname );
  cmn.AddSubscriber( "use_clasp_beg", use_clasp_beg, private.room_objname );
  cmn.AddSubscriber( "use_clasp_end", use_clasp_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ring" ] = {
    type = "use",
    inv_obj = "inv_ring",
    use_place = "obj_underceiling_use_ring",
    room = private.room_objname,
    zz = "zz_underceiling",
    zz_gate = "gzz_room_313_underceiling"
  };
  local use_ring_inv = function ()
  
    interface.InventoryItemRemove( "inv_ring" );
  
  end;
  local use_ring_beg = function ()
  
    ObjDelete( "obj_underceiling_use_ring" );
  
  end;
  local use_ring_end = function ()
  
    ObjMultiSet( { 
      { "spr_underceiling_paperpin",  { visible = true, input = true } },
      { "spr_underceiling_nails",     { visible = true, input = true } },
      { "spr_underceiling_codepart2", { visible = true, input = true } },
      { "obj_underceiling_use_clasp", {   input = true               } },
      { "spr_underceiling_door_open", {     alp = 1                  } },
      { "spr_room_313_door_open",     {     alp = 1                  } },
      { "anm_room_313_after_open",    {     alp = 1                  } },
    } );
    ObjDelete( "spr_underceiling_door" );  
    ObjDelete( "spr_room_313_door3" ); 
    ObjDelete( "anm_room_313_before_open" ); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ring", use_ring_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring", use_ring_inv );
  cmn.AddSubscriber( "use_ring", use_ring_end, private.room_objname );
  cmn.AddSubscriber( "use_ring_inv", use_ring_inv, private.room_objname );
  cmn.AddSubscriber( "use_ring_beg", use_ring_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_end", use_ring_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_breadcrust () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_breadcrust" ] = {
    type = "use",
    inv_obj = "inv_breadcrust",
    use_place = "obj_underceiling_1_use_breadcrust",
    room = private.room_objname,
    zz = "zz_underceiling",
    zz_gate = "gzz_room_313_underceiling", 
    subzz = "zz_underceiling_1",
    subzz_gate = "gzz_underceiling_underceiling_1"
  };
  local use_breadcrust_inv = function ()
  
    interface.InventoryItemRemove( "inv_breadcrust" );
  
  end;
  local use_breadcrust_beg = function ()
  
    ObjDelete( "obj_underceiling_1_use_breadcrust" );
  
  end;
  local use_breadcrust_end = function ()
    
    ObjDelete( "anm_underceiling_1_bird" );  
    ObjMultiSet( { 
      { "gfx_underceiling_wheel",       { active = true              } },
      { "anm_underceiling_1_bird_eat",  {    alp = 1, playing = true } },
      { "obj_underceiling_1_wheel",     {  input = true,  alp = 1    } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_breadcrust", use_breadcrust_beg, private.room_objname );
  cmn.AddSubscriber( "use_breadcrust", use_breadcrust_inv );
  cmn.AddSubscriber( "use_breadcrust", use_breadcrust_end, private.room_objname );
  cmn.AddSubscriber( "use_breadcrust_inv", use_breadcrust_inv, private.room_objname );
  cmn.AddSubscriber( "use_breadcrust_beg", use_breadcrust_beg, private.room_objname );
  cmn.AddSubscriber( "use_breadcrust_end", use_breadcrust_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hammer_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_1" ] = {
    type = "use",
    inv_obj = "inv_hammer",
    use_place = "obj_toy_use_hammer",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  local use_hammer_1_inv = function ()
    
    if ( cmn.IsEventDone( "use_hammer_2" ) and
    cmn.IsEventDone( "use_hammer_3" ) and
    cmn.IsEventDone( "use_hammer_4" ) ) then

      interface.InventoryItemRemove( "inv_hammer" );
      
    end;
    
  end;
  local use_hammer_1_beg = function ()
  
    ObjDelete( "obj_toy_use_hammer" );
  
  end;
  local use_hammer_1_end = function ()
      
    ObjMultiSet( { 
      { "obj_toy_use_symbol", { input = true } },
      { "obj_toy_clk_door",   { input = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammer_1", use_hammer_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_1", use_hammer_1_inv );
  cmn.AddSubscriber( "use_hammer_1", use_hammer_1_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_1_inv", use_hammer_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_1_beg", use_hammer_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_1_end", use_hammer_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toyplane () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toyplane" ] = {
    type = "use",
    inv_obj = "inv_toyplane",
    use_place = "obj_toy_use_toyplane",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  local use_toyplane_inv = function ()
  
    interface.InventoryItemRemove( "inv_toyplane" );
  
  end;
  local use_toyplane_beg = function ()
  
    ObjDelete( "obj_toy_use_toyplane" );
  
  end;
  local use_toyplane_end = function ()
  
    ObjMultiSet( { 
      { "spr_toy_figure_3",           {   alp = 1    } },
      { "obj_toy_mmg",                { input = true } },
      { "spr_room_313_strings_part",  {   alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toyplane", use_toyplane_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyplane", use_toyplane_inv );
  cmn.AddSubscriber( "use_toyplane", use_toyplane_end, private.room_objname );
  cmn.AddSubscriber( "use_toyplane_inv", use_toyplane_inv, private.room_objname );
  cmn.AddSubscriber( "use_toyplane_beg", use_toyplane_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyplane_end", use_toyplane_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_symbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_symbol" ] = {
    type = "use",
    inv_obj = "inv_symbol",
    use_place = "obj_toy_use_symbol",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  local use_symbol_inv = function ()
  
    interface.InventoryItemRemove( "inv_symbol" );
  
  end;
  local use_symbol_beg = function ()
  
    ObjDelete( "obj_toy_use_symbol" );
  
  end;
  local use_symbol_end = function ()
  
    ObjMultiSet( { 
      { "spr_toy_weathervanepart",  { input = true } },
      { "obj_toy_open_2",           { input = true } },
      { "spr_toy_door_right_open",  {   alp = 1    } },
      { "spr_room_313_4_3",         {   alp = 1    } },
    } );
    ObjDelete( "spr_toy_door_right_closed" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_symbol", use_symbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_symbol", use_symbol_inv );
  cmn.AddSubscriber( "use_symbol", use_symbol_end, private.room_objname );
  cmn.AddSubscriber( "use_symbol_inv", use_symbol_inv, private.room_objname );
  cmn.AddSubscriber( "use_symbol_beg", use_symbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_symbol_end", use_symbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_woodenamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_woodenamulet" ] = {
    type = "use",
    inv_obj = "inv_woodenamulet",
    use_place = "obj_toy_use_woodenamulet",
    room = private.room_objname,
    zz = "zz_toy",
    zz_gate = "gzz_room_313_toy"
  };
  local use_woodenamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_woodenamulet" );
  
  end;
  local use_woodenamulet_beg = function ()
  
    ObjDelete( "obj_toy_use_woodenamulet" );
  
  end;
  local use_woodenamulet_end = function ()
  
    ObjMultiSet( { 
      { "spr_toy_woodendoll",      { input = true } },
      { "spr_room_313_doll_hole",  {   alp = 1    } },
    } );
    ObjDelete( "spr_toy_door_little" );
    ObjDelete( "anm_toy_open_1_door_open" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_woodenamulet", use_woodenamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_woodenamulet", use_woodenamulet_inv );
  cmn.AddSubscriber( "use_woodenamulet", use_woodenamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_woodenamulet_inv", use_woodenamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_woodenamulet_beg", use_woodenamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_woodenamulet_end", use_woodenamulet_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function see_fb_bobby () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_fb_bobby" ] = {
    type = "click",
    use_place = "obj_room_313_clk_bobby",
    room = private.room_objname
  };  
  
  local see_fb_bobby = function ()
    
    ObjDelete( "obj_room_313_clk_bobby" );
    ObjDelete( "spr_room_313_bag_01" );
    ObjMultiSet( { 
      { "gzz_room_313_bobby",               { visible = true, input = true   } },
      { "spr_room_313_zz_bobby_bag",        {     alp = 1                    } },
    } );
  
  end;
  cmn.AddSubscriber( "see_fb_bobby", see_fb_bobby, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function see_room_313_1 () end;
  --------------------------------------------------------------------------------------------
  local see_room_313_1 = function ()
    
    ObjDelete( "anm_room_313_anim" );
    ObjMultiSet( { 
      { "grm_room_313_thirdfloorcorridor",  { visible = false, input = false } },
      { "gzz_room_313_reverse",             { visible = true, input = true   } },
      { "anm_room_313_lamp",                {     alp = 1                    } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_room_313_thirdfloorcorridor_focus");
    end;
    
    common_impl.LockMapRoom( "thirdfloorcorridor", true );
    common_impl.LockMapRoom( "closedroom", true );
    
  end;
  cmn.AddSubscriber( "see_room_313_1", see_room_313_1, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function see_room_313_piano () end;
  --------------------------------------------------------------------------------------------
  local see_room_313_piano = function ()
    
    ObjDelete( "anm_room_313_piano" );
    
  end;
  cmn.AddSubscriber( "see_room_313_piano", see_room_313_piano, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function see_room_313_portrait () end;
  --------------------------------------------------------------------------------------------
  local see_room_313_portrait = function ()
    
    ObjMultiSet( { 
      { "anm_room_313_portrait", { frame = 300 } },
    } );
    
  end;
  cmn.AddSubscriber( "see_room_313_portrait", see_room_313_portrait, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3 = function ()
  
    ObjDelete( "obj_room_313_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_3", get_collect_morph_item_3, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_7 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_7 = function ()
  
    ObjDelete( "obj_couch_collect2_item_7" ); 
  
    if ( cmn.IsEventDone( "get_wood_2" ) and 
    cmn.IsEventDone( "get_valve" ) ) then
      
      ObjDelete( "gzz_room_313_couch" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_7", get_collect2_item_7, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_ritualsigns () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_ritualsigns" );
    ------------------------------------------------- 
    function zz_ritualsigns.Close ()
      
      if ( cmn.IsEventDone( "get_collar" ) and not cmn.IsEventDone( "see_room_313_1" ) ) then

        private.see_room_313_1();

      end;
      
    end;
    
  --*******************************************************************************************************************
  --*** function zz_couch () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_couch" );  
    -------------------------------------------------
    function zz_couch.PreOpen ()
      
      if ( cmn.IsEventDone( "use_codepart_1" ) and
           cmn.IsEventDone( "use_codepart2" ) and
           cmn.IsEventDone( "use_codepart3" ) and
           not cmn.IsEventDone( "win_couch" ) ) then 
        
        cmn.MiniGameShow( "couch" );
        common_impl.PassingMgStart( "couch" );
        
      end;

    end; 
    -------------------------------------------
    function zz_couch.PreClose ()

      if ( cmn.IsEventDone( "use_codepart_1" ) and
           cmn.IsEventDone( "use_codepart2" ) and
           cmn.IsEventDone( "use_codepart3" ) and
           not cmn.IsEventDone( "win_couch" ) ) then 
        
        cmn.MiniGameHide( "couch" );
        common_impl.PassingMgStop( "couch" );
        
      end;

    end; 
    ------------------------------------------------- 
    function zz_couch.Close ()
    end; 
    ------------------------------------------------- 
    function zz_couch.Skip ()
      
      private.CouchWin();
    
    end;
    -------------------------------------------------
    function zz_couch.Reset ()
     
      ng_global.progress[ "std" ][ "win_couch" ].state = { 1, 1, 1, 1 }
      ng_global.progress[ "std" ][ "win_couch" ].state2 = { 1, 1, 1 }   
      private.CouchLoad();
      
    end;
    
  --*******************************************************************************************************************
  --*** function zz_toy () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_toy" );  
    -------------------------------------------------
    function zz_toy.PreOpen ()
      
      if cmn.IsEventDone( "use_toyplane" ) and
         not cmn.IsEventDone( "win_toy" ) then 
        
        cmn.MiniGameShow( "toy" );
        common_impl.PassingMgStart( "toy" );
        
      end;

    end; 
    -------------------------------------------
    function zz_toy.PreClose ()

      if cmn.IsEventDone( "use_toyplane" ) and
         not cmn.IsEventDone( "win_toy" ) then 
        
        cmn.MiniGameHide( "toy" );
        common_impl.PassingMgStop( "toy" );
        
      end;

    end; 
    ------------------------------------------------- 
    function zz_toy.Close ()
    end; 
    ------------------------------------------------- 
    function zz_toy.Skip ()
      
      private.ToyWin();
    
    end;
    -------------------------------------------------
    function zz_toy.Reset ()
     
      ng_global.progress[ "std" ][ "win_toy" ].stage = 1;   
      private.ToyLoad();
      
    end;
    
  --*******************************************************************************************************************
  --*** function zz_bobby () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_bobby" );  
    -------------------------------------------------
    function zz_bobby.PreClose ()
      
      if ( not cmn.IsEventDone( "see_room_313_portrait" ) ) then
        
        private.see_room_313_portrait();
        
      end;

    end; 
    ------------------------------------------------- 
    function zz_bobby.Close ()
      
      local tb = {};
      
      table.insert( tb, "spr_bobby_photo" );
      ObjSet( "spr_bobby_photo_big1", { alp = 1, input = true } );
      
      if cmn.IsEventDone( "get_codepart3" ) then
        
        table.insert( tb, "spr_bobby_note" );
        
      end;
      
      cmn.NoteScaleClose( tb );
      
    end; 
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_room_313();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( cmn.IsEventDone( "get_collar" ) and not cmn.IsEventDone( "see_room_313_1" ) ) then

    private.see_room_313_1();

  end;
  
  if (iOS_IsBought() == 0) then
        
      iOS_LogEvents(1);
      common.LevelSwitch("menu","unlock");
        
  end;
      
end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  private.InitBird();
  private.InitGhost();
  
  common_impl.EnvPlay( { "level1/env/aud_room_313_env" }, "", 0.5 );

  private.StartAnimBobby ()

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level1/env/aud_room_313_env", 0.5 );
  private.StopAnimBobby ()

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_torch_12 ()

  local item = "inv_torch";

  if ( cmn.ApplyObj( item, "gzz_room_313_couch" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_couch" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_couch_use_torch" ) ) then

    cmn.CallEventHandler( "use_torch_12_inv" );
    cmn.CallEventHandler( "use_torch_12_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_torch_12" );
      cmn.CallEventHandler( "use_torch_12_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_flashlight2", 0, "", 0 );
    
    ObjAnimate( "spr_couch_lantern_2", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } );
    ObjAnimate( "spr_couch_drill_dark_up_side_light", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_statuette ()

  local item = "inv_statuette";

  if ( cmn.ApplyObj( item, "gzz_room_313_couch" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_couch" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_couch_use_statuette" ) ) then

    cmn.CallEventHandler( "use_statuette_inv" );
    cmn.CallEventHandler( "use_statuette_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_statuette" );
        cmn.CallEventHandler( "use_statuette_end" );
        
      end;    
    
      ObjAnimate( "spr_couch_door_right_opened", "alp", 0, 0, func_end_2, { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );  
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_statuette", 0, "", 0 );

    cmn.ItemFly( "spr_couch_amulet_part", func_end, 20, -1 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_codepart_1 ()

  local item = "inv_codepart_1";

  if ( cmn.ApplyObj( item, "gzz_room_313_couch" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_couch" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_couch_use_codepart" ) ) then

    cmn.CallEventHandler( "use_codepart_1_inv" );
    cmn.CallEventHandler( "use_codepart_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_codepart_1" );
      cmn.CallEventHandler( "use_codepart_1_end" );
      
      if ( cmn.IsEventDone( "use_codepart2" ) and
           cmn.IsEventDone( "use_codepart3" )) then
        
        private.CouchLoad();
        cmn.MiniGameShow( "couch" );
        common_impl.PassingMgStart( "couch" );
      
      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper1", 0, "", 0 );
    
    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_couch_paper_01", func_end, 2.5, 20, 1.1 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_codepart2 ()

  local item = "inv_codepart2";

  if ( cmn.ApplyObj( item, "gzz_room_313_couch" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_couch" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_couch_use_codepart" ) ) then

    cmn.CallEventHandler( "use_codepart2_inv" );
    cmn.CallEventHandler( "use_codepart2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_codepart2" );
      cmn.CallEventHandler( "use_codepart2_end" );
      
      if ( cmn.IsEventDone( "use_codepart_1" ) and
           cmn.IsEventDone( "use_codepart3" )) then
        
        private.CouchLoad();
        cmn.MiniGameShow( "couch" );
        common_impl.PassingMgStart( "couch" );
      
      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper1", 0, "", 0 );
      
    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_couch_paper_02", func_end, 2.5, 20, 1.1 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_codepart3 ()

  local item = "inv_codepart3";

  if ( cmn.ApplyObj( item, "gzz_room_313_couch" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_couch" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_couch_use_codepart" ) ) then

    cmn.CallEventHandler( "use_codepart3_inv" );
    cmn.CallEventHandler( "use_codepart3_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_codepart3" );
      cmn.CallEventHandler( "use_codepart3_end" );
      
      if ( cmn.IsEventDone( "use_codepart_1" ) and
           cmn.IsEventDone( "use_codepart2" )) then
        
        private.CouchLoad();
        cmn.MiniGameShow( "couch" );
        common_impl.PassingMgStart( "couch" );
      
      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper1", 0, "", 0 );
      
    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_couch_paper_03", func_end, 2.5, 20, 1.1 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wheel ()

  local item = "inv_wheel";

  if ( cmn.ApplyObj( item, "gzz_room_313_couch" ) and
       cmn.IsEventDone( "clk_couch_wheel" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_couch" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_couch_use_wheel" ) and
           cmn.IsEventDone( "clk_couch_wheel" ) ) then

    cmn.CallEventHandler( "use_wheel_inv" );
    cmn.CallEventHandler( "use_wheel_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_wheel" );
      cmn.CallEventHandler( "use_wheel_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_wheel", 0, "", 0 );

    cmn.ItemFly( "spr_couch_wheel", func_end, 10, -1 );
    
    ObjAnimate( "obj_couch_chair_big", "ang", 0, 0, "", { 
      0.0, 0, -0.17,
      0.8, 0, 0,
    } ); 

    ObjAnimate( "obj_couch_chair_big_over", "ang", 0, 0, "", { 
      0.0, 0, -0.17,
      0.8, 0, 0,
    } );   
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hammer_2 ()

  local item = "inv_hammer";

  if ( cmn.ApplyObj( item, "gzz_room_313_couch" )  and
       cmn.IsEventDone( "clk_couch_chair" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_couch" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_couch_use_hammer" )  and
           cmn.IsEventDone( "clk_couch_chair" ) ) then

    cmn.CallEventHandler( "use_hammer_2_inv" );
    cmn.CallEventHandler( "use_hammer_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hammer_2" );
      cmn.CallEventHandler( "use_hammer_2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hammer5", 0, "", 0 );
    ObjSet( "anm_couch_wood", { pos_z = 26 } );
    AnimPlay( "anm_couch_wood", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tongs ()

  local item = "inv_tongs";

  if ( cmn.ApplyObj( item, "gzz_room_313_ritualsigns" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualsigns" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualsigns_use_tongs" ) ) then

    cmn.CallEventHandler( "use_tongs_inv" );
    cmn.CallEventHandler( "use_tongs_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tongs" );
      cmn.CallEventHandler( "use_tongs_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_tweezers", 0, "", 0 );

    ObjMultiSet( { 
      { "anm_ritualsigns_amulet",    { alp = 1 } },
      { "anm_ritualsigns_amulet_hh", { alp = 0 } },
    } );
    
    AnimPlay( "anm_ritualsigns_amulet", "amulet_click", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_carvedamulet_1 ()

  local item = "inv_carvedamulet_1";

  if ( cmn.ApplyObj( item, "gzz_room_313_ritualsigns" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualsigns" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualsigns_use_carvedamulet_1" ) ) then

    cmn.CallEventHandler( "use_carvedamulet_1_inv" );
    cmn.CallEventHandler( "use_carvedamulet_1_beg" );

    local func_end = function ()
      
      if ( cmn.IsEventDone( "use_carvedamulet_2" ) ) then  
        
        local func_end_2 = function ()
        
          cmn.Lock( false );

          cmn.SetEventDone( "use_carvedamulet_1" );
          cmn.CallEventHandler( "use_carvedamulet_1_end" );
          common.CloseSubRoom();
          
        end;  
        
        ObjAnimate( "vid_ritualsigns_wall", "alp", 0, 0, "", { 
          0.0, 0, 0,
          0.3, 0, 1,
        } );            
        VidPlay( "vid_ritualsigns_wall", func_end_2 );
        
      else 
        
        local func_end_2 = function ()
        
          cmn.Lock( false );

          cmn.SetEventDone( "use_carvedamulet_1" );
          cmn.CallEventHandler( "use_carvedamulet_1_end" );
        
        end;  
    
        VidPlay( "vid_ritualsigns_angel", func_end_2 );
        
      end;  
    
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_carvedamulet_1", 0, "", 0 );

    cmn.ItemFly( "spr_ritualsigns_amulet1", func_end, -1, 10 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_carvedamulet_2 ()

  local item = "inv_carvedamulet_2";

  if ( cmn.ApplyObj( item, "gzz_room_313_ritualsigns" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualsigns" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualsigns_use_carvedamulet_2" ) ) then

    cmn.CallEventHandler( "use_carvedamulet_2_inv" );
    cmn.CallEventHandler( "use_carvedamulet_2_beg" );

    local func_end = function ()

      if ( cmn.IsEventDone( "use_carvedamulet_1" ) ) then  
        
        local func_end_2 = function ()
        
          cmn.Lock( false );

          cmn.SetEventDone( "use_carvedamulet_2" );
          cmn.CallEventHandler( "use_carvedamulet_2_end" );
          common.CloseSubRoom();
          
        end;  
        
        ObjAnimate( "vid_ritualsigns_wall", "alp", 0, 0, "", { 
          0.0, 0, 0,
          0.3, 0, 1,
        } );          
        VidPlay( "vid_ritualsigns_wall", func_end_2 );
        
      else 
        
        local func_end_2 = function ()
        
          cmn.Lock( false );

          cmn.SetEventDone( "use_carvedamulet_2" );
          cmn.CallEventHandler( "use_carvedamulet_2_end" );
        
        end;  
        
        VidPlay( "vid_ritualsigns_angel", func_end_2 );
      
      end;  
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_carvedamulet_2", 0, "", 0 );

    cmn.ItemFly( "spr_ritualsigns_amulet2", func_end, -1, 10 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hotelsign ()

  local item = "inv_hotelsign";

  if ( cmn.ApplyObj( item, "gzz_room_313_ritualsigns" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualsigns" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualsigns_use_hotelsign" ) ) then

    cmn.CallEventHandler( "use_hotelsign_inv" );
    cmn.CallEventHandler( "use_hotelsign_beg" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "use_hotelsign" );
      cmn.CallEventHandler( "use_hotelsign_end" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_sun", 0, "", 0 );
    
    ObjMultiSet( { 
      { "anm_ritualsigns_open_door",    { alp = 1 } },
      { "anm_ritualsigns_open_door_hh", { alp = 0 } },
    } );
    
    AnimPlay( "anm_ritualsigns_open_door", "door", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bobbyamulet ()

  local item = "inv_bobbyamulet";

  if ( cmn.ApplyObj( item, "gzz_room_313_bobby" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bobby" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bobby_use_bobbyamulet" ) ) then

    cmn.CallEventHandler( "use_bobbyamulet_inv" );
    cmn.CallEventHandler( "use_bobbyamulet_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bobbyamulet" );
      cmn.CallEventHandler( "use_bobbyamulet_end" );

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_amulet2", 0, "", 0 );

    AnimPlay( "anm_bobby_amulet", "amulet", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_paperpin ()

  local item = "inv_paperpin";

  if ( cmn.ApplyObj( item, "gzz_room_313_bobby" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bobby" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bobby_use_paperpin" ) ) then

    cmn.CallEventHandler( "use_paperpin_inv" );
    cmn.CallEventHandler( "use_paperpin_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_paperpin" );
      cmn.CallEventHandler( "use_paperpin_end" );

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_paperpin", 0, "", 0 );

    ObjSet( "anm_bobby_pocket", { alp = 1 } );
    AnimPlay( "anm_bobby_pocket", "pocket", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_diamond ()

  local item = "inv_diamond";

  if ( cmn.ApplyObj( item, "gzz_room_313_reverse" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reverse" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_reverse_use_diamond" ) ) then

    cmn.CallEventHandler( "use_diamond_inv" );
    cmn.CallEventHandler( "use_diamond_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_diamond" );
        cmn.CallEventHandler( "use_diamond_end" );
        
      end;
      
      ObjAnimate( "obj_reverse_hole", "alp", 0, 0, func_end_2, { 
        0.0, 0, 0,
        0.5, 0, 1,
      } );  
    
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_glasscutter", 0, "", 0 );

    AnimPlay( "anm_reverse_brilliant", "DoAnim", func_end );  
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_universalkey ()

  local item = "inv_universalkey";

  if ( cmn.ApplyObj( item, "gzz_room_313_reverse" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reverse" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_reverse_use_universalkey" ) ) then

    cmn.CallEventHandler( "use_universalkey_inv" );
    cmn.CallEventHandler( "use_universalkey_beg" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "use_universalkey" );
      cmn.CallEventHandler( "use_universalkey_end" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_key_in313", 0, "", 0 );

    AnimPlay( "anm_reverse_key", "DoAnim", func_end );  
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_paperandpencil ()

  local item = "inv_paperandpencil";

  if ( cmn.ApplyObj( item, "gzz_room_313_room_313_window" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_room_313_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_room_313_window_use_paperandpencil" ) ) then

    cmn.CallEventHandler( "use_paperandpencil_inv" );
    cmn.CallEventHandler( "use_paperandpencil_beg" );

    local func_end = function ()
        
      cmn.Lock( false );

      cmn.SetEventDone( "use_paperandpencil" );
      cmn.CallEventHandler( "use_paperandpencil_end" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_pencil", 0, "", 0 );

    AnimPlay( "anm_room_313_window_code", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_knittingneedle ()

  local item = "inv_knittingneedle";

  if ( cmn.ApplyObj( item, "gzz_room_313_room_313_window" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_room_313_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_room_313_window_use_knittingneedle" ) ) then

    cmn.CallEventHandler( "use_knittingneedle_inv" );
    cmn.CallEventHandler( "use_knittingneedle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_knittingneedle" );
      cmn.CallEventHandler( "use_knittingneedle_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_knitingneedle", 0, "", 0 );

    AnimPlay( "anm_room_313_window_amulet", "DoAnim", func_end );  
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cutters ()

  local item = "inv_cutters";

  if ( cmn.ApplyObj( item, "gzz_room_313_room_313_window" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_room_313_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_room_313_window_use_cutters" ) ) then

    cmn.CallEventHandler( "use_cutters_inv" );
    cmn.CallEventHandler( "use_cutters_beg" );

    local func_end = function ()
        
      cmn.Lock( false );

      cmn.SetEventDone( "use_cutters" );
      cmn.CallEventHandler( "use_cutters_end" );
      
      common.CloseSubRoom();
        
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_cutters", 0, "", 0 );

    AnimPlay( "anm_room_313_window_exit", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_clasp ()

  local item = "inv_clasp";

  if ( cmn.ApplyObj( item, "gzz_room_313_underceiling" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_underceiling" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_underceiling_use_clasp" ) ) then

    cmn.CallEventHandler( "use_clasp_inv" );
    cmn.CallEventHandler( "use_clasp_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_clasp" );
      cmn.CallEventHandler( "use_clasp_end" );
      private.get_knittingneedle();
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_clasp", 0, "", 0 );

    AnimPlay( "anm_underceiling_needle", "needle1", func_end );
  
    return true;
    
  elseif ( ObjIntersect( item, "obj_deploy_inv_firstaidkit_use_cross_1" ) or 
  ObjIntersect( item, "obj_deploy_inv_firstaidkit_use_cross_2" ) ) then
  
    DbgTrace( "trolololo" );
    
    common_impl.ShowBbt( "bbt_use_clasp_wrongapply_on_cross_1" );
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ring ()

  local item = "inv_ring";

  if ( cmn.ApplyObj( item, "gzz_room_313_underceiling" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_underceiling" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_underceiling_use_ring" ) ) then

    cmn.CallEventHandler( "use_ring_inv" );
    cmn.CallEventHandler( "use_ring_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_ring" );
        cmn.CallEventHandler( "use_ring_end" );
      
      end; 
    
      ObjAnimate( "spr_underceiling_door_open", "alp", 0, 0, func_end_2, { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );  
      
      ObjAnimate( "spr_underceiling_door", "alp", 0, 0, "", { 
        0.0, 0, 1,
        0.3, 0, 0,
      } ); 
    
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_ring", 0, "", 0 );

    cmn.ItemFly( "spr_underceiling_ring", func_end, -1, 20 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_breadcrust ()

  local item = "inv_breadcrust";

  if ( cmn.ApplyObj( item, "gzz_room_313_underceiling" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_underceiling" );

    return true;
    
  elseif ( cmn.ApplyObj( item, "gzz_underceiling_underceiling_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_underceiling_1', 'not_frame', { { x = 620, y = 170 },{ x = 235, y = 280 } }, { x = 163, y = -163 } );

    return true;
    
  elseif ( cmn.ApplyObj( item, "obj_underceiling_1_use_breadcrust" ) ) then

    cmn.CallEventHandler( "use_breadcrust_inv" );
    cmn.CallEventHandler( "use_breadcrust_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_breadcrust" );
      cmn.CallEventHandler( "use_breadcrust_end" );
    
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_breadcrust", 0, "", 0 );

    AnimPlay( "anm_underceiling_1_bird", "bird_bread", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hammer_1 ()

  local item = "inv_hammer";

  if ( cmn.ApplyObj( item, "gzz_room_313_toy" ) and
       cmn.IsEventDone( "win_toy" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_toy_use_hammer" ) and
           cmn.IsEventDone( "win_toy" ) ) then

    cmn.CallEventHandler( "use_hammer_1_inv" );
    cmn.CallEventHandler( "use_hammer_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hammer_1" );
      cmn.CallEventHandler( "use_hammer_1_end" );
      private.get_wood_1();
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hammer_1", 0, "", 0 );

    AnimPlay( "anm_toy_wood", "DoAnim1", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_toyplane ()

  local item = "inv_toyplane";

  if ( cmn.ApplyObj( item, "gzz_room_313_toy" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_toy_use_toyplane" ) ) then

    cmn.CallEventHandler( "use_toyplane_inv" );
    cmn.CallEventHandler( "use_toyplane_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_toyplane" );
      cmn.CallEventHandler( "use_toyplane_end" );
      private.ToyLoad();
      cmn.MiniGameShow( "toy" );
      common_impl.PassingMgStart( "toy" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_toyplane", 0, "", 0 );

    cmn.ItemFly( "spr_toy_figure_3", func_end, 10, -1 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_symbol ()

  local item = "inv_symbol";

  if ( cmn.ApplyObj( item, "gzz_room_313_toy" ) and 
       cmn.IsEventDone( "use_hammer_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_toy_use_symbol" ) and 
           cmn.IsEventDone( "use_hammer_1" ) ) then

    cmn.CallEventHandler( "use_symbol_inv" );
    cmn.CallEventHandler( "use_symbol_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_symbol" );
        cmn.CallEventHandler( "use_symbol_end" );
        
      end;        
      
      ObjAnimate( "spr_toy_door_right_open", "alp", 0, 0, func_end_2, { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );  
      
      ObjAnimate( "spr_toy_door_right_closed", "alp", 0, 0, "", { 
        0.0, 0, 1,
        0.3, 0, 0,
      } );  
    
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_symbol", 0, "", 0 );

    cmn.ItemFly( "spr_toy_closed_wood_ditail", func_end, 10, -1 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_woodenamulet ()

  local item = "inv_woodenamulet";

  if ( cmn.ApplyObj( item, "gzz_room_313_toy" ) and
       cmn.IsEventDone( "get_weathervanepart" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_toy_use_woodenamulet" ) and
           cmn.IsEventDone( "get_weathervanepart" ) ) then

    cmn.CallEventHandler( "use_woodenamulet_inv" );
    cmn.CallEventHandler( "use_woodenamulet_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
      
        cmn.Lock( false );

        cmn.SetEventDone( "use_woodenamulet" );
        cmn.CallEventHandler( "use_woodenamulet_end" );
      
      end;
      
      ObjSet( "anm_toy_open_1_door_open", { alp = 1 } );
      ObjSet( "spr_toy_door_little",      { alp = 0 } );
      AnimPlay( "anm_toy_open_1_door_open", "DoAnim", func_end_2 );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_slide_opn_wood", 0, "", 0 );

    cmn.ItemFly( "spr_toy_wooden_amulet", func_end, 10, -1 );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_bracedrill ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bracedrill" );
  cmn.CallEventHandler( "get_bracedrill" );

end;
--------------------------------------------------------------------------------------------
function private.get_valve ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_valve" );
  cmn.CallEventHandler( "get_valve" );
  
  if ( cmn.IsEventDone( "get_wood_2" ) and
  cmn.IsGetCollect2( "get_collect2_item_7" ) ) then     
    
    common.CloseSubRoom();
    
  end;  
  
end;
--------------------------------------------------------------------------------------------
function private.get_torchnobatteries ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_torchnobatteries" );
  cmn.CallEventHandler( "get_torchnobatteries" );

end;
--------------------------------------------------------------------------------------------
function private.get_carvedamulet_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_carvedamulet_2" );
  cmn.CallEventHandler( "get_carvedamulet_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_firstaidkit ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_firstaidkit" );
  cmn.CallEventHandler( "get_firstaidkit" );

end;
--------------------------------------------------------------------------------------------
function private.get_clasp ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_clasp" );
  cmn.CallEventHandler( "get_clasp" );

end;
--------------------------------------------------------------------------------------------
function private.get_wood_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wood_2" );
  cmn.CallEventHandler( "get_wood_2" );
  
  if ( cmn.IsEventDone( "get_valve" ) and 
  cmn.IsGetCollect2( "get_collect2_item_7" ) ) then     
    
    common.CloseSubRoom();
    
  end;  
  
end;
--------------------------------------------------------------------------------------------
function private.get_bobbyamulet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bobbyamulet" );
  cmn.CallEventHandler( "get_bobbyamulet" );

end;
--------------------------------------------------------------------------------------------
function private.get_collar ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_collar" );
  cmn.CallEventHandler( "get_collar" );

end;
--------------------------------------------------------------------------------------------
function private.get_matches ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_matches" );
  cmn.CallEventHandler( "get_matches" );

end;
--------------------------------------------------------------------------------------------
function private.get_codepart3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_codepart3" );
  cmn.CallEventHandler( "get_codepart3" );

end;
--------------------------------------------------------------------------------------------
function private.get_statuette ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_statuette" );
  cmn.CallEventHandler( "get_statuette" );

end;
--------------------------------------------------------------------------------------------
function private.get_ring ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ring" );
  cmn.CallEventHandler( "get_ring" );

end;
--------------------------------------------------------------------------------------------
function private.get_codepart_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_codepart_1" );
  cmn.CallEventHandler( "get_codepart_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_cross_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cross_1" );
  cmn.CallEventHandler( "get_cross_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_codepart2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_codepart2" );
  cmn.CallEventHandler( "get_codepart2" );

end;
--------------------------------------------------------------------------------------------
function private.get_wheel ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wheel" );
  cmn.CallEventHandler( "get_wheel" );
  
  common.CloseSubRoomAll();

end;
--------------------------------------------------------------------------------------------
function private.get_paperpin ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_paperpin" );
  cmn.CallEventHandler( "get_paperpin" );

end;
--------------------------------------------------------------------------------------------
function private.get_knittingneedle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_knittingneedle" );
  cmn.CallEventHandler( "get_knittingneedle" );

end;
--------------------------------------------------------------------------------------------
function private.get_nails ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_nails" );
  cmn.CallEventHandler( "get_nails" );

end;
--------------------------------------------------------------------------------------------
function private.get_wood_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wood_1" );
  cmn.CallEventHandler( "get_wood_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_lionhead_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lionhead_2" );
  cmn.CallEventHandler( "get_lionhead_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_weathervanepart ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_weathervanepart" );
  cmn.CallEventHandler( "get_weathervanepart" );

end;
--------------------------------------------------------------------------------------------
function private.get_woodendoll ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_woodendoll" );
  cmn.CallEventHandler( "get_woodendoll" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_7 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_7" ); 

  end;

  common_impl.PlayEffectHO( "spr_couch_collect2_item_7", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_7" );
  
  if ( cmn.IsEventDone( "get_wood_2" ) and 
  cmn.IsEventDone( "get_valve" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_couch_wheel ()
  
  cmn.CallEventHandler( "clk_couch_wheel_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_couch_wheel" );
    cmn.CallEventHandler( "clk_couch_wheel_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_drop_chair", 0, "", 0 );

  ObjAnimate( "obj_couch_books", "pos_xy", 0, 0, func_end, { 
    0.0, 0, 0,  0,
    1.0, 0, 263, 96,
  } );  
  
  ObjAnimate( "spr_couch_books_shadow", "alp", 0, 0, "", { 
    0.0, 0, 1,
    0.3, 0, 0,
  } );  
  
  ObjAnimate( "obj_couch_chair_big", "ang", 0, 0, "", { 
    0.0, 0, 0,
    0.5, 0, -0.17,
  } ); 
  
  ObjAnimate( "obj_couch_chair_big_over", "ang", 0, 0, "", { 
    0.0, 0, 0,
    0.5, 0, -0.17,
  } ); 

  ObjAnimate( "spr_couch_books", "alp", 0, 0, "", { 
    0.0, 0, 0,
    0.1, 0, 1,
  } );  
  
end;

--------------------------------------------------------------------------------------------
function private.clk_couch_chair ()
  
  cmn.CallEventHandler( "clk_couch_chair_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_couch_chair" );
    cmn.CallEventHandler( "clk_couch_chair_end" );
    
    ObjSet( "obj_couch_chair", { alp = 1 } );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_chair", 0, "", 0 );
  
  ObjSet( "vid_couch_chair", { alp = 1 } );
  ObjSet( "obj_couch_chair", { alp = 0 } );
  VidPlay( "vid_couch_chair", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_toy_door ()
  
  cmn.CallEventHandler( "clk_toy_door_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_toy_door" );
    cmn.CallEventHandler( "clk_toy_door_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_wood_small_door", 0, "", 0 );
  
  ObjAnimate( "spr_toy_door_left_open", "alp", 0, 0, func_end, { 
    0.0, 0, 0,
    0.3, 0, 1,
  } );  
  
  ObjAnimate( "spr_toy_door_left_closed", "alp", 0, 0, "", { 
    0.0, 0, 1,
    0.3, 0, 0,
  } );  
  
end;
--------------------------------------------------------------------------------------------
function private.clk_reverse_key ()
  
  cmn.CallEventHandler( "clk_reverse_key_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_reverse_key" );
    cmn.CallEventHandler( "clk_reverse_key_end" ); 
    common.CloseSubRoom();
      
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_wood_door1", 0, "", 0 );
  
  ObjAnimate( "spr_reverse_door_open", "alp", 0, 0, func_end, { 
    0.0, 0, 0,
    0.3, 0, 1,
  } );  
  
  ObjAnimate( "anm_reverse_key", "alp", 0, 0, "", { 
    0.0, 0, 1,
    0.3, 0, 0,
  } );  
  
end;
--------------------------------------------------------------------------------------------
function private.clk_ritualsigns_signs ()
  
  cmn.CallEventHandler( "clk_ritualsigns_signs_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_ritualsigns_signs" );
    cmn.CallEventHandler( "clk_ritualsigns_signs_end" );
      
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_fire_symbol", 0, "", 0 );
  
  AnimPlay( "anm_ritualsigns_signs", "signs", func_end );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;

--*********************************************************************************************************************
function private.see_fb_bobby ()
  
  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "level1/voc/aud_flashback_bobby_voc",  0.2 );
      common_impl.StopAudio( "sfx", "level1/sfx/aud_flashback_bobby",      0.2 );
      
    end;

    cmn.SetEventDone( "see_fb_bobby" );
    cmn.CallEventHandler( "see_fb_bobby" );
    private.InitGhost();
    common_impl.ShowBbt( 'bbt_room_313_see_fb_bobby' );
    
    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "what_happened" );
    
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_flashback_bobby",      0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_flashback_bobby_voc",  0, "", 0 );

  cmn.PlayDialogVideo( "vid_room_313_fb_bobby", func_end );
  
end;

--*********************************************************************************************************************
function private.see_room_313_1 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_room_313_1" );
    cmn.CallEventHandler( "see_room_313_1" );
 
    common_impl.ShowBbt( 'bbt_room_313_see_room_313_1' );
    ObjMultiSet( { 
      { "anm_room_313_lamp",  { frame = 0 } },
    } );
    
    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "escape_trap" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_room313_1", 0, "", 0 );
  
  ObjMultiSet( { 
    { "anm_room_313_anim",  { alp = 1 } },
    { "anm_room_313_lamp",  { alp = 0 } },
  } );
  AnimPlay( "anm_room_313_anim", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function private.see_room_313_piano ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_room_313_piano" );
    cmn.CallEventHandler( "see_room_313_piano" );
 
    common_impl.ShowBbt( 'bbt_room_313_see_piano' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_see_room_313_piano", 0, "", 0 );
  
  AnimPlay( "anm_room_313_piano", "piano", func_end );

end;
--------------------------------------------------------------------------------------------
function private.see_room_313_portrait ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_room_313_portrait" );
    cmn.CallEventHandler( "see_room_313_portrait" );
 
    common_impl.ShowBbt( 'bbt_room_313_see_portrait' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_portrait", 0, "", 0 );
  
  AnimPlay( "anm_room_313_portrait", "portrait", func_end );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_room_313 ()

  if not ( cmn.IsEventDone( "opn_room_313" ) ) then

    cmn.SetEventDone( "opn_room_313" );
    common_impl.ShowBbt( 'bbt_room_313_opn_room_313' );
    
  else
    
    if ( not cmn.IsEventDone( "see_room_313_piano" ) ) then
      
      private.see_room_313_piano();
      
    end;
    
  end;
  cmn.CallEventHandler( "opn_room_313" ); 
  
end;
--------------------------------------------------------------------------------------------
function private.InitGhost ()

  if ( not cmn.IsEventDone( "clk_couch_wheel" ) and cmn.IsEventDone( "see_fb_bobby" ) ) then
 
    local time = math.random( 25, 40 );
    ObjAnimate( "anm_room_313_chair", "alp", 0, 0, "", { 0, 0, 1,   0.3, 3, 1 } );
    AnimPlay( "anm_room_313_chair", "chair", "" );
    ObjSet( "tmr_room_313_ghost", { time = time, playing = true, endtrig = private.InitGhost } );

  else
    
    ObjSet( "anm_room_313_chair", { frame = 0 } );    
     
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.BobbyPhotoClick ()

  local func_end = function ()
  
    cmn.Lock( false );
    
    ObjSet( "spr_bobby_photo_big1", { input = false } );
  
  end;
  
  cmn.Lock( true );
  
  ObjAnimate( "spr_bobby_photo_big", "scale_x", 0, 0, func_end, { 0, 0, 1,   0.2, 3, 0,   0.4, 3, 1 } );
  ObjAnimate( "spr_bobby_photo_big1", "alp", 0, 0, "", { 0, 0, 1,   0.2, 3, 1,   0.2, 3, 0 } );
  
end;
--*********************************************************************************************************************
-- function *** MMG COUCH *** () end;
--*********************************************************************************************************************
  function private.CouchLoad ()

    if not ( ng_global.progress[ "std" ][ "win_couch" ].state ) then
      
      ng_global.progress[ "std" ][ "win_couch" ].state = { 1, 1, 1, 1 }
      ng_global.progress[ "std" ][ "win_couch" ].state2 = { 1, 1, 1 }   
      
    end;

    private.win      = { 2, 2, 2, 2 };
    private.state    = { 1, 1, 1, 1 }; 
    private.state2   = { 1, 1, 1    }; 
    private.switch  =  { { 1, 4 }, { 3 }, { 2, 3 } };  

    for i = 1, 3 do
      
      for j = 1, 2 do    
        
        ObjSet( "spr_couch_mmg_switch_"..j.."_"..i, { alp = 0, input = false } );
        ObjSet( "spr_couch_mmg_switch_"..j.."_"..i, { event_mdown = function() private.PartClkCouples( i ); end, input = true } );  
          
      end;
      
      local part = ng_global.progress[ "std" ][ "win_couch" ].state2[ i ];
      
      --ObjSet( "spr_couch_mmg_switch_"..part.."_"..i, { event_mdown = function() private.PartClkCouples( i ); end, input = true } );
      
      ObjSet( "spr_couch_mmg_switch_"..part.."_"..i, { alp = 1 } );
      private.state2[ i ] = part;

    end;
    
    for i = 1, 4 do
      
      for j = 1, 2 do    
        
        ObjSet( "spr_couch_mmg_light_"..j.."_"..i, { alp = 0 } );
        
      end;
      
      local part = ng_global.progress[ "std" ][ "win_couch" ].state[ i ];
      
      ObjSet( "spr_couch_mmg_light_"..part.."_"..i, { alp = 1 } );
      private.state[ i ] = part;
      
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  function private.CouchIsWin ()
    
    for i = 1, 4 do

      if ( private.state[ i ] ~= private.win[ i ] ) then
        
        return false;
        
      end;
      
    end;
    
    return true;
    
  end;
  --------------------------------------------------------------------------------------------
  function private.PartClkCouples ( idx ) 
    
    private.PartClk( idx ); 
    
  end;
  --------------------------------------------------------------------------------------------
  function private.PartClk ( idx ) 

    if ( private.state2[ idx ] == 1 ) then

      private.state2[ idx ] = 2;
      
    else
     
      private.state2[ idx ] = 1;
      
    end;
    
    private.CouchAnim( private.state2[ idx ], idx );
    
  end;

  --------------------------------------------------------------------------------------------
  function private.CouchAnim ( old, idx )

    local func_end = function ()
    
      private.CouchLightAnim( idx );
      
    end;  
    
    local part = ng_global.progress[ "std" ][ "win_couch" ].state2[ idx ];
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_plastic_button", 0, "", 0 );

    ObjAnimate( "spr_couch_mmg_switch_"..part.."_"..idx, "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 3, 0 } );
    ObjAnimate( "spr_couch_mmg_switch_"..old.."_"..idx, "alp", 0, 0, "", { 0, 0, 0,   0.3, 3, 1 } );
    ObjMultiSet( { 
      { "spr_couch_mmg_switch_"..part.."_"..idx,  { input = true  } },
      { "spr_couch_mmg_switch_"..old.."_"..idx,   { input = false } },
    } );
    
  end;  
  --------------------------------------------------------------------------------------------
  function private.CouchLightAnim ( idx )

    local func_end = function ()
    
      cmn.Lock( false );
      
      if ( private.CouchIsWin() ) then
        
        private.CouchWin();

      else 
      
        ng_global.progress[ "std" ][ "win_couch" ].state2[ idx ] = private.state2[ idx ];
        ng_global.progress[ "std" ][ "win_couch" ].state[ idx ]  = private.state[ idx ];
        
      end;
      
    end; 
    local old = private.state[ private.switch[ idx ][ 1 ] ];
    
    for i = 1, #private.switch[ idx ] do

      if ( private.state[ private.switch[ idx ][ i ] ] == 1 ) then
     
        old = private.state[ private.switch[ idx ][ i ] ];
        private.state[ private.switch[ idx ][ i ] ] = 2;
        
      else
            
        old = private.state[ private.switch[ idx ][ i ] ];        
        private.state[ private.switch[ idx ][ i ] ] = 1;
              
      end;
    
      ObjAnimate( "spr_couch_mmg_light_"..private.state[ private.switch[ idx ][ i ] ].."_"..private.switch[ idx ][ i ], "alp", 0, 0, "", { 0, 0, 0,   0.3, 3, 1 } );
      ObjAnimate( "spr_couch_mmg_light_"..old.."_"..private.switch[ idx ][ i ], "alp", 0, 0, "", { 0, 0, 1,   0.3, 3, 0 } );
      
    end;
    
    ObjAnimate( "obj_couch_mmg_light", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 3, 1 } );
    
  end;  
  --------------------------------------------------------------------------------------------
  function private.CouchWin ()

    local func_end = function ()
    
      cmn.MiniGameHide( "couch" );
      common_impl.PassingMgWin( "couch" );
      cmn.SetEventDone( "win_couch" );
      cmn.CallEventHandler( "win_couch" );

      common_impl.PlayAudio( "sfx", "aud_win_mmg" );

      cmn.Lock( false );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_wood_door_small", 0, "", 0 );

    ObjAnimate( "spr_couch_door_left_opened", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 3, 1 } );
      
  end;
--*********************************************************************************************************************
-- function *** MMG TOY *** () end;
--*********************************************************************************************************************
  function private.ToyLoad ()

    if not ( ng_global.progress[ "std" ][ "win_toy" ].stage ) then
      
      ng_global.progress[ "std" ][ "win_toy" ].stage = 1;   
      
    end;

    private.win   = { 4, 5, 3, 2, 1 };
    private.state = { 0, 0, 0, 0, 0 }; 
    private.allst = { { 5, 2, 1, 3, 4 }, { 3, 2, 5, 1, 4 }, { 4, 5, 3, 2, 1 } };  
    private.coor  = { { 75, 150 }, { 55, 150 }, { 33, 150 }, { 10, 150 }, { 0, 150 } };  
    
    private.stage = ng_global.progress[ "std" ][ "win_toy" ].stage;
    
    ObjMultiSet( { 
      { "spr_toy_switch_1", { alp = 0 } },
      { "spr_toy_switch_2", { alp = 0 } },
      { "spr_toy_switch_3", { alp = 0 } },
    } );
      
    for i = 1, 5 do
      
      ObjSet( "obj_toy_rope_"..i, { input = true, pos_y = 0; event_mdown = function() private.ToyClk( i ); end } );

    end;
   
    if ( private.stage ~= 1 ) then
      
      for i = 1, private.stage - 1 do
      
        ObjSet( "spr_toy_switch_"..i, { alp = 1 } );
        
      end;
        
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  function private.ToyIsWin ()

    for i = 1, 5 do

      if ( private.state[ i ] ~= private.win[ i ] or 
           private.stage ~= 3 ) then
        
        return false;
        
      end;
      
    end;
      
    return true;
    
  end;
    --------------------------------------------------------------------------------------------
    function private.ToyStageIsWin ()
    
    local stage = ng_global.progress[ "std" ][ "win_toy" ].stage;
    
    for i = 1, 5 do

      if ( private.state[ i ] ~= private.allst[ stage ][ i ] ) then
        
        return false;
        
      end;
      
    end;
    
    return true;
    
  end;
  --------------------------------------------------------------------------------------------
  function private.ToyClk ( idx ) 
   
    private.ToyAnim( idx );
    
  end;

  --------------------------------------------------------------------------------------------
  function private.ToyAnim ( idx )

    local func_end = function ()
    
      cmn.Lock( false );
      
      private.ToyCheck( idx );
        
    end;  
    
    local pos = ObjGet( "obj_toy_rope_"..idx );
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_toyplane", 0, "", 0 );
    
    ObjSet( "obj_toy_rope_"..idx, { input = false } );
    ObjAnimate( "obj_toy_rope_"..idx, "pos_xy", 0, 0, func_end, { 0, 0, pos.pos_x, pos.pos_y,   0.3, 3, private.coor[ idx ][ 1 ], private.coor[ idx ][ 2 ] } );    
    
  end;  
  --------------------------------------------------------------------------------------------
  function private.ToySave ( idx )
    
    local stage = ng_global.progress[ "std" ][ "win_toy" ].stage;

    for i = 1,5 do

      if ( private.state[ i ] == 0 ) then
        
        private.state[ i ] = idx;
           
        if ( private.ToyIsWin() ) then
          
          private.ToyWin();
          
        else 
          
          if private.ToyStageIsWin() then
            
            common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter_toy", 0, "", 0 );

            local alp = ObjGet( "spr_toy_switch_"..stage ).alp;
            ObjAnimate( "spr_toy_switch_"..stage, "alp", 0, 0, "", { 0, 0, alp,   0.3, 3, 1 } ); 
            ng_global.progress[ "std" ][ "win_toy" ].stage = ng_global.progress[ "std" ][ "win_toy" ].stage + 1;
            private.ToyBack()
            
          end;
          
        end;
        
        if ( private.state[ i ] ~= private.allst[ stage ][ i ] ) then
          
          private.ToyBack();
          common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );

        end;
        
        break;
        
      end;
    
    end;

  end;  
  --------------------------------------------------------------------------------------------
  function private.ToyBack ()

    local func_end = function ()
      
      cmn.Lock( false );   
      
    end;  
    
    private.state = { 0, 0, 0, 0, 0 }; 
    private.stage = ng_global.progress[ "std" ][ "win_toy" ].stage; 
  
    for i = 1, 5 do
      
      local pos = ObjGet( "obj_toy_rope_"..i );
      ObjAnimate( "obj_toy_rope_"..i, "pos_xy", 0, 0, "", { 0, 0, pos.pos_x, pos.pos_y,   0.3, 3, 0, 0 } ); 
      ObjSet( "obj_toy_rope_"..i, { input = true } );
      
    end; 

    cmn.Lock( true );
    ObjAnimate( "obj_toy_mmg", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 3, 1 } );   
    
  end; 
  --------------------------------------------------------------------------------------------
  function private.ToyCheck ( idx )
 
    local func_end = function ()
      
      cmn.Lock( false );
      private.ToySave( idx );
      
    end;  
    
    cmn.Lock( true );
    ObjAnimate( "obj_toy_mmg", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 3, 1 } );     
    
  end;  
  --------------------------------------------------------------------------------------------
  function private.ToyWin ()

    local func_end = function ()
    
      cmn.MiniGameHide( "toy" );
      common_impl.PassingMgWin( "toy" );
      cmn.SetEventDone( "win_toy" );
      cmn.CallEventHandler( "win_toy" );

      common_impl.PlayAudio( "sfx", "aud_win_mmg" );

      cmn.Lock( false );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter_toy", 0, "", 0 );

    ObjAnimate( "obj_toy_rope_1", "pos_x", 0, 0, "", { 0, 0, 0,   1, 3, 200 } ); 
    ObjAnimate( "obj_toy_rope_5", "pos_x", 0, 0, "", { 0, 0, 0,   2, 3, -200 } ); 
    ObjAnimate( "obj_toy_rope_2", "pos_x", 0, 0, "", { 0, 0, 0,  0.5, 0, 0,   1.5, 3, 250 } ); 
    ObjAnimate( "obj_toy_rope_4", "pos_x", 0, 0, "", { 0, 0, 0,  0.5, 0, 0,   1.5, 3, -250 } );
    ObjAnimate( "obj_toy_rope_3", "pos_x", 0, 0, func_end, { 0, 0, 0,  0.8, 0, 0,   1.8, 3, -460 } );  
    
  end;
--------------------------------------------------------------------------------------------
function private.InitBird()
  
  local time = math.random( 8, 12 );

  AnimPlay( "anm_underceiling_bird", "bird", "" );
  ObjSet( "tmr_underceiling_bird", { time = time, playing = true, endtrig = private.InitBird } );    
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
  cmn.AnimateAmbientLight( "spr_toy_light" ); 
  cmn.AnimateAmbientLight( "spr_room_313_window_light" ); 
  
end;
--------------------------------------------------------------------------------------------
function private.StartAnimBobby ()

  AnimPlay( "anm_room_313_bobby", "bobby", "" );

  if private.audioRmRoom313 == false  then
    private.audioRmRoom313 = true;
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_bobby", 0, "", 0 );
  end;

end;
--------------------------------------------------------------------------------------------
function private.StopAnimBobby ()

  AnimStop( "anm_room_313_bobby" );
  common_impl.StopAudio( "sfx", "level1/sfx/aud_sc_bobby", 0.5 );

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.UseToyplane ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_toy_use_toyplane' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_rope", 0, "", 0 );

  ObjAnimate( "obj_toy_mmg", "pos_y", 0, 1, func_end, { 0, 0, 0,   0.2, 3, 5,   0.4, 3, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseHammer ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_toy_use_hammer' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood2", 0, "", 0 );

  ObjAnimate( "anm_toy_wood", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1,1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseSymbol ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_toy_use_symbol' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_small_door", 0, "", 0 );

  ObjAnimate( "spr_toy_door_right_closed", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1,1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseWoodenamulet ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_toy_use_woodenamulet' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_door_small", 0, "", 0 );

  ObjAnimate( "spr_toy_door_little", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1,1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseKnittingneedle ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_room_313_window_use_knittingneedle' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood2", 0, "", 0 );

  ObjAnimate( "obj_room_313_window", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1,1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseCutters ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_room_313_window_use_cutters' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood2", 0, "", 0 );

  ObjAnimate( "obj_room_313_window", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1,1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseHotelsign ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_ritualsigns_use_hotelsign' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_stone2", 0, "", 0 );

  AnimPlay( "anm_ritualsigns_open_door_hh", "hh1", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseTongs ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_ritualsigns_use_tongs' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_pick2", 0, "", 0 );

  AnimPlay( "anm_ritualsigns_amulet_hh", "hh2", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseRing ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_underceiling_use_ring' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_wood2", 0, "", 0 );

  ObjAnimate( "spr_underceiling_door", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1, 1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseBreadcrust ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_underceiling_use_breadcrust' ); 
    
    ObjMultiSet( { 
      { "anm_underceiling_static_head",        { alp = 1, frame = 0 } },
      { "anm_underceiling_static_head_click",  { alp = 0            } },
    } );
    AnimPlay( "anm_underceiling_static_head", "bird_static_head", func_end );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_crow", 0, "", 0 );
  
  ObjSet( "anm_underceiling_static_head_click", { playing = false } );
  ObjMultiSet( { 
    { "anm_underceiling_static_head",        { alp = 0 } },
    { "anm_underceiling_static_head_click",  { alp = 1 } },
  } );
  AnimPlay( "anm_underceiling_static_head_click", "bird_static_head_click", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseBobbyamulet ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_bobby_use_bobbyamulet' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_cloth", 0, "", 0 );

  AnimPlay( "anm_bobby_amulet", "hh_amulet", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UsePaperpin ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_bobby_use_paperpin' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_pick", 0, "", 0 );

  AnimPlay( "anm_bobby_pocket", "hh_pocket", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseStatuette ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_couch_use_statuette' );
    ObjMultiSet( { 
      { "anm_couch_click_1",  { alp = 0 } },
    } );  
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_chair2", 0, "", 0 );
  ObjMultiSet( { 
    { "anm_couch_click_1",  { alp = 1 } },
  } );
  AnimPlay( "anm_couch_click_1", "click_1", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseHammer ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_toy_use_hammer' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_chair2", 0, "", 0 );

  ObjAnimate( "anm_toy_wood", "pos_y", 0, 1, func_end, { 0, 0, 0,   0.2, 3, 2,   0.4, 3, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseCouchHammer ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_couch_use_hammer' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood3", 0, "", 0 );

  AnimPlay( "anm_couch_wood_hh", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseCodepart ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_couch_use_codepart_1' );
    ObjMultiSet( { 
      { "anm_couch_click_2",  { alp = 0 } },
    } );  
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_chair", 0, "", 0 );
  ObjMultiSet( { 
    { "anm_couch_click_2",  { alp = 1 } },
  } );
  AnimPlay( "anm_couch_click_2", "click_2", func_end );

end;
--------------------------------------------------------------------------------------------
function private.ClkHand ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_bobby_clk_hand' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx", 0, "", 0 );
  AnimPlay( "anm_bobby_hand", "hand", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseUniversalkey ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_reverse_use_universalkey' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_closet_door", 0, "", 0 );

  AnimPlay( "anm_reverse_hh", "hh", func_end );

end;

--------------------------------------------------------------------------------------------
function private.ClkPlayAudioRoom313()

  local func_end = function ()

    ObjSet( "obj_room_313_az_clk", { input = true } );

    common_impl.StopAudio( "voc", "level1/voc/aud_bobby_loc_voc", 0.2 );
    
  end;

  common_impl.ShowBbt( 'bbt_room_313_bobby' );
  common_impl.PlayAudio( "voc", "level1/voc/aud_bobby_loc_voc", 0, "", 0 );

  ObjSet( "obj_room_313_az_clk", {             input = false                    } );
  ObjSet( "tmr_room_313_az_clk", { time = 2, playing = true, endtrig = func_end } );

end;