-- name=rm_serviceroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_serviceroom";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_boxes",     "room_hub" );
  ObjAttach( "zz_workbench", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  private.torch_anim = false;
  
  ObjMultiSet({ 
    { "spr_boxes_cross_2",                  { event_mdown = private.get_cross_2             }},
    
    { "spr_boxes_familyportrait",           { event_mdown = private.ScalePhoto              }},
    { "spr_boxes_familyportrait_big",       { event_mdown = private.get_familyportrait      }},
    
    { "spr_boxes_metalcarcass",             { event_mdown = private.get_metalcarcass        }},
    { "spr_workbench_fireaxe",              { event_mdown = private.get_fireaxe             }},
    { "spr_workbench_acid",                 { event_mdown = private.get_acid                }},
    { "spr_serviceroom_stick",              { event_mdown = private.get_stick               }},

    { "obj_boxes_clk_bloodyamulet",         { event_mdown = private.clk_bloodyamulet        }},
    { "obj_boxes_clk_jewel",                { event_mdown = private.clk_jewel               }},

    { "obj_serviceroom_clk_clark_2",        { event_mdown = private.dlg_serviceroom_clark_2 }},
    { "obj_serviceroom_clk_clark_2_focus",  { event_mdown = private.dlg_serviceroom_clark_2 }},  
    { "obj_serviceroom_see_serviceroom_1",  { event_mdown = private.see_serviceroom_1       }},  
    
    { "obj_workbench_use_screwdriver",      { event_mdown = private.AnimFireaxeFeedback     }},
    { "obj_boxes_use_bloodyamulet",         { event_mdown = private.AnimUseBloodyamulet     }},
    { "obj_boxes_use_jewel",                { event_mdown = private.AnimUseJewel            }},
    
    { "obj_serviceroom_block",              { event_mdown = private.AnimAudioServiceRoom    }},

    { "spr_serviceroom_collect_morph_item", { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_7" ); end } },
      
    { "spr_boxes_collect2_item_5",          { event_mdown = private.get_collect2_item_5   } }, 
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_serviceroom = function ()
  
    table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gmg_serviceroom_onworkbench",
      "gzz_serviceroom_workbench",
      "gzz_serviceroom_boxes",
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_boxes",
      "zz_workbench",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_serviceroom", update_game_mode_serviceroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_serviceroom = function ()

    local effects_table = 
    {
      "obj_serviceroom_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_serviceroom", update_performance_mode_serviceroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_serviceroom () end;
  --------------------------------------------------------------------------------------------
  local opn_serviceroom_map = function ()

    common_impl.VisitMapRoom( "serviceroom" );

  end;
  cmn.AddSubscriber( "opn_serviceroom", opn_serviceroom_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_cross_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cross_2" ] = {
    type = "get",
    get_obj = "spr_boxes_cross_2",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_serviceroom_boxes"
  };
  
  local get_cross_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_cross_2", "spr_boxes_cross_2" );
    cmn.SetInvPlusRGB( "firstaidkit", true );
  
  end;
  
  local get_cross_2_closezz = function ()
  
    ObjDelete( "gfx_boxes_cross_2" );
  
  end;
  
  cmn.AddSubscriber( "get_cross_2", get_cross_2_inv );
  cmn.AddSubscriber( "get_cross_2", get_cross_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_familyportrait () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_familyportrait" ] = {
    type = "get",
    get_obj = "spr_boxes_familyportrait",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_serviceroom_boxes"
  };
  
  local get_familyportrait_inv = function ()
  
    interface.InventoryItemAdd( "inv_familyportrait", "spr_boxes_familyportrait_big" );
  
  end;
  
  local get_familyportrait_closezz = function ()
  
    ObjDelete( "gfx_boxes_familyportrait_big" );
    ObjDelete( "spr_boxes_familyportrait" );
  
  end;
  
  cmn.AddSubscriber( "get_familyportrait", get_familyportrait_inv );
  cmn.AddSubscriber( "get_familyportrait", get_familyportrait_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_metalcarcass () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_metalcarcass" ] = {
    type = "get",
    get_obj = "spr_boxes_metalcarcass",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_serviceroom_boxes"
  };
  
  local get_metalcarcass_inv = function ()
  
    interface.InventoryItemAdd( "inv_metalcarcass", "spr_boxes_metalcarcass" );
  
  end;
  
  local get_metalcarcass_closezz = function ()
  
    ObjDelete( "gfx_boxes_metalcarcass" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_5" ) ) then
      
      ObjDelete( "gzz_serviceroom_boxes" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_metalcarcass", get_metalcarcass_inv );
  cmn.AddSubscriber( "get_metalcarcass", get_metalcarcass_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fireaxe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fireaxe" ] = {
    type = "get",
    get_obj = "spr_workbench_fireaxe",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_serviceroom_workbench"
  };
  
  local get_fireaxe_inv = function ()
  
    interface.InventoryItemAdd( "inv_fireaxe", "spr_workbench_fireaxe" );
  
  end;
  
  local get_fireaxe_closezz = function ()
  
    ObjDelete( "gfx_workbench_fireaxe" );
    ObjDelete( "spr_serviceroom_axe" );
    
  end;
  
  cmn.AddSubscriber( "get_fireaxe", get_fireaxe_inv );
  cmn.AddSubscriber( "get_fireaxe", get_fireaxe_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_acid () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_acid" ] = {
    type = "get",
    get_obj = "spr_workbench_acid",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_serviceroom_workbench"
  };
  
  local get_acid_inv = function ()
  
    interface.InventoryItemAdd( "inv_acid", "spr_workbench_acid" );
  
  end;
  
  local get_acid_closezz = function ()
  
    ObjDelete( "gfx_workbench_acid" );
    ObjDelete( "spr_workbench_shadow" );
    ObjSet( "spr_workbench_shadow1", { visible = true } );
  
  end;
  
  cmn.AddSubscriber( "get_acid", get_acid_inv );
  cmn.AddSubscriber( "get_acid", get_acid_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stick" ] = {
    type = "get",
    get_obj = "spr_serviceroom_stick",
    room = private.room_objname
  };
  
  local get_stick_inv = function ()
  
    interface.InventoryItemAdd( "inv_stick", "spr_serviceroom_stick" );
    ObjSet( "inv_stick", { drag = false } );
  
  end;
  
  local get_stick_closezz = function ()
  
    ObjDelete( "gfx_serviceroom_stick" );
  
  end;
  
  cmn.AddSubscriber( "get_stick", get_stick_inv );
  cmn.AddSubscriber( "get_stick", get_stick_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_hexagon () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hexagon" ] = {
    type = "get",
    get_obj = "spr_serviceroom_hexagon",
    room = private.room_objname
  };
  
  local get_hexagon_inv = function ()
  
    interface.InventoryItemAdd( "inv_hexagon", "spr_serviceroom_hexagon" );
  
  end;
  
  local get_hexagon_closezz = function ()
  
    ObjDelete( "gfx_serviceroom_hexagon" );
  
  end;
  
  cmn.AddSubscriber( "get_hexagon", get_hexagon_inv );
  cmn.AddSubscriber( "get_hexagon", get_hexagon_closezz, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function use_jewel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_jewel" ] = {
    type = "use",
    inv_obj = "inv_jewel",
    use_place = "obj_boxes_use_jewel",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_serviceroom_boxes"
  };
  local use_jewel_inv = function ()
  
    interface.InventoryItemRemove( "inv_jewel" );
  
  end;
  local use_jewel_beg = function ()
  
    ObjDelete( "obj_boxes_use_jewel" );
  
  end;
  local use_jewel_end = function ()
  
    ObjMultiSet( { 
      { "obj_boxes_clk_jewel",      {  input = true, active = true, visible = true } },
      { "spr_serviceroom_open_box", {    alp = 1                                   } },
    } );
    ObjDelete( "spr_boxes_door_2" );
    ObjDelete( "spr_serviceroom_lock_1" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jewel", use_jewel_beg, private.room_objname );
  cmn.AddSubscriber( "use_jewel", use_jewel_inv );
  cmn.AddSubscriber( "use_jewel", use_jewel_end, private.room_objname );
  cmn.AddSubscriber( "use_jewel_inv", use_jewel_inv, private.room_objname );
  cmn.AddSubscriber( "use_jewel_beg", use_jewel_beg, private.room_objname );
  cmn.AddSubscriber( "use_jewel_end", use_jewel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bloodyamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bloodyamulet" ] = {
    type = "use",
    inv_obj = "inv_bloodyamulet",
    use_place = "obj_boxes_use_bloodyamulet",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_serviceroom_boxes"
  };
  local use_bloodyamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_bloodyamulet" );
  
  end;
  local use_bloodyamulet_beg = function ()
  
    ObjDelete( "obj_boxes_use_bloodyamulet" );
  
  end;
  local use_bloodyamulet_end = function ()
  
    ObjMultiSet( { 
      { "spr_boxes_metalcarcass", {  input = true             } },
      { "gfx_boxes_metalcarcass", { active = true             } },
      { "spr_boxes_lattice",      {  pos_x = 105, pos_y = -77 } },
      { "spr_boxes_jaw",          {    alp = 1,     ang = 0   } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bloodyamulet", use_bloodyamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bloodyamulet", use_bloodyamulet_inv );
  cmn.AddSubscriber( "use_bloodyamulet", use_bloodyamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_bloodyamulet_inv", use_bloodyamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_bloodyamulet_beg", use_bloodyamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bloodyamulet_end", use_bloodyamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_1" ] = {
    type = "use",
    inv_obj = "inv_screwdriver",
    use_place = "obj_workbench_use_screwdriver",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_serviceroom_workbench"
  };
  local use_screwdriver_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_screwdriver_2" ) ) then
      
      interface.InventoryItemRemove( "inv_screwdriver" );
      
    end;
  
  end;
  local use_screwdriver_1_beg = function ()
  
    ObjDelete( "obj_workbench_use_screwdriver" );
  
  end;
  local use_screwdriver_1_end = function ()
  
    ObjMultiSet( { 
      { "spr_workbench_fireaxe",  { input = true } },
    } );
    
    ObjDelete( "obj_workbench_loop" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_1", use_screwdriver_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1", use_screwdriver_1_inv );
  cmn.AddSubscriber( "use_screwdriver_1", use_screwdriver_1_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1_inv", use_screwdriver_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1_beg", use_screwdriver_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1_end", use_screwdriver_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_metalcarcass () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_metalcarcass" ] = {
    type = "use",
    inv_obj = "inv_metalcarcass",
    use_place = "obj_workbench_use_metalcarcass",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_serviceroom_workbench"
  };
  local use_metalcarcass_inv = function ()
  
    interface.InventoryItemRemove( "inv_metalcarcass" );
  
  end;
  local use_metalcarcass_beg = function ()
  
    ObjDelete( "obj_workbench_use_metalcarcass" );
  
  end;
  local use_metalcarcass_end = function ()
  
    ObjDelete( "gzz_serviceroom_workbench" );
    ObjMultiSet( { 
      { "gmg_serviceroom_onworkbench",  { visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_metalcarcass", use_metalcarcass_beg, private.room_objname );
  cmn.AddSubscriber( "use_metalcarcass", use_metalcarcass_inv );
  cmn.AddSubscriber( "use_metalcarcass", use_metalcarcass_end, private.room_objname );
  cmn.AddSubscriber( "use_metalcarcass_inv", use_metalcarcass_inv, private.room_objname );
  cmn.AddSubscriber( "use_metalcarcass_beg", use_metalcarcass_beg, private.room_objname );
  cmn.AddSubscriber( "use_metalcarcass_end", use_metalcarcass_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_torch_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_torch_2" ] = {
    type = "use",
    inv_obj = "inv_torch_2",
    use_place = "obj_workbench_use_torch_2",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_serviceroom_workbench"
  };
  local use_torch_2_inv = function ()
  
    --interface.InventoryItemRemove( "inv_torch_2" );
  
  end;
  local use_torch_2_beg = function ()
  
    ObjDelete( "obj_workbench_use_torch_2" );
  
  end;
  local use_torch_2_end = function ()
  
    ObjMultiSet( { 
      { "spr_workbench_acid",  { input = true } },
      { "spr_workbench_shadow",  { visible = true } },
      { "spr_workbench_shadow1",  { visible = false } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_torch_2", use_torch_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch_2", use_torch_2_inv );
  cmn.AddSubscriber( "use_torch_2", use_torch_2_end, private.room_objname );
  cmn.AddSubscriber( "use_torch_2_inv", use_torch_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_torch_2_beg", use_torch_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch_2_end", use_torch_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_broom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_broom" ] = {
    type = "use",
    inv_obj = "inv_broom",
    use_place = "obj_serviceroom_use_broom",
    room = private.room_objname
  };
  local use_broom_inv = function ()
  
    interface.InventoryItemRemove( "inv_broom" );
  
  end;
  local use_broom_beg = function ()
  
    ObjDelete( "obj_serviceroom_use_broom" );
  
  end;
  local use_broom_end = function ()
    
    ObjDelete( "anm_serviceroom_web" );  
    ObjMultiSet( { 
      { "spr_serviceroom_stick",  { visible = true, input = true } },
      { "gzz_serviceroom_boxes",  { visible = true, input = true } },
      { "gzz_serviceroom_workbench",  { visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_broom", use_broom_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom", use_broom_inv );
  cmn.AddSubscriber( "use_broom", use_broom_end, private.room_objname );
  cmn.AddSubscriber( "use_broom_inv", use_broom_inv, private.room_objname );
  cmn.AddSubscriber( "use_broom_beg", use_broom_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom_end", use_broom_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_salammoniac () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_salammoniac" ] = {
    type = "use",
    inv_obj = "inv_salammoniac",
    use_place = "obj_serviceroom_use_salammoniac",
    room = private.room_objname
  };
  local use_salammoniac_inv = function ()
  
    interface.InventoryItemRemove( "inv_salammoniac" );
  
  end;
  local use_salammoniac_beg = function ()
  
    ObjDelete( "obj_serviceroom_use_salammoniac" );
  
  end;
  local use_salammoniac_end = function ()
    
    ObjDelete( "anm_serviceroom_man_1" );
    ObjDelete( "anm_serviceroom_smoke" );
    
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_salammoniac", use_salammoniac_beg, private.room_objname );
  cmn.AddSubscriber( "use_salammoniac", use_salammoniac_inv );
  cmn.AddSubscriber( "use_salammoniac", use_salammoniac_end, private.room_objname );
  cmn.AddSubscriber( "use_salammoniac_inv", use_salammoniac_inv, private.room_objname );
  cmn.AddSubscriber( "use_salammoniac_beg", use_salammoniac_beg, private.room_objname );
  cmn.AddSubscriber( "use_salammoniac_end", use_salammoniac_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_bloodyamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bloodyamulet" ] = {
    type = "click",
    use_place = "obj_boxes_clk_bloodyamulet",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_serviceroom_boxes"
  };
  
  local clk_bloodyamulet_beg = function ()

    ObjDelete( "obj_boxes_clk_bloodyamulet" );
  
  end;
  local clk_bloodyamulet_end = function ()

    ObjDelete( "spr_boxes_door" );
    ObjDelete( "spr_serviceroom_door_box" );
    ObjMultiSet( { 
      { "obj_boxes_use_bloodyamulet",  { input = true, active = true, visible = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bloodyamulet",     clk_bloodyamulet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bloodyamulet",     clk_bloodyamulet_end, private.room_objname );
  cmn.AddSubscriber( "clk_bloodyamulet_beg", clk_bloodyamulet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bloodyamulet_end", clk_bloodyamulet_end, private.room_objname );

 --------------------------------------------------------------------------------------------
  -- function clk_jewel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_jewel" ] = {
    type = "click",
    use_place = "obj_boxes_clk_jewel",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_serviceroom_boxes"
  };
  
  local clk_jewel_beg = function ()

    ObjDelete( "obj_boxes_clk_jewel" );
  
  end;
  local clk_jewel_end = function ()
    
    ObjDelete( "spr_serviceroom_lock_1" );
    ObjMultiSet( { 
      { "spr_boxes_familyportrait", {  input = true, pos_x = -135, pos_y = -87 } },
      { "gfx_boxes_familyportrait", { active = true                            } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_jewel",     clk_jewel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_jewel",     clk_jewel_end, private.room_objname );
  cmn.AddSubscriber( "clk_jewel_beg", clk_jewel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_jewel_end", clk_jewel_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function dlg_serviceroom_clark_1 () end;
  --------------------------------------------------------------------------------------------
 
  local dlg_serviceroom_clark_1 = function ()
    
    ObjDelete( "anm_serviceroom_man_1" );
    ObjDelete( "anm_serviceroom_man_2" );
    ObjDelete( "obj_serviceroom_block" );
    
    ObjSet( "anm_serviceroom_man_3",             {   alp = 1    } );
    ObjSet( "obj_serviceroom_see_serviceroom_1", { input = true } );
    
  end;  

  cmn.AddSubscriber( "dlg_serviceroom_clark_1", dlg_serviceroom_clark_1, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function dlg_serviceroom_clark_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_serviceroom_clark_2" ] = {
    type = "click",
    use_place = "obj_serviceroom_clk_clark_2",
    room = private.room_objname,
  };
 
  local dlg_serviceroom_clark_2 = function ()
    
    ObjDelete( "obj_serviceroom_clk_clark_2" );
    ObjDelete( "anm_serviceroom_lamp_before" );
    ObjDelete( "anm_serviceroom_man_4" );
    
    ObjMultiSet( { 
      { "anm_serviceroom_collapse", { frame = 300 } },
      { "anm_serviceroom_lamp_after",    {   alp = 1   } },
    } );

  end;  
  cmn.AddSubscriber( "dlg_serviceroom_clark_2", dlg_serviceroom_clark_2, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function see_serviceroom_1 () end;
  --------------------------------------------------------------------------------------------
   common_impl.hint[ "see_serviceroom_1" ] = {
    type = "click",
    use_place = "obj_serviceroom_see_serviceroom_1",
    room = private.room_objname,
  };
  
  local see_serviceroom_1 = function ()
    
    ObjDelete( "obj_serviceroom_see_serviceroom_1" );
    ObjDelete( "anm_serviceroom_lamp_before" );      
    ObjDelete( "anm_serviceroom_collapse" );  
    ObjDelete( "anm_serviceroom_man_3" );  
    
    ObjMultiSet( { 
      { "obj_serviceroom_clk_clark_2",  { input = true } },
      { "anm_serviceroom_lamp_after",   {   alp = 1    } },
      { "anm_serviceroom_last_frame",   {   alp = 1    } },
      { "anm_serviceroom_man_4",        {   alp = 1    } },
    } );
  
  end;
  local see_serviceroom_loc = function ()
    
    ObjDelete( "anm_serviceroom_ceiling_before" );    
    ObjDelete( "anm_room_211_light_after" );    
    ObjMultiSet( { 
      { "anm_room_211_light_before", { alp = 1 } },
      { "spr_room_211_abatis",       { alp = 1 } },
    } );
  
  end;
  cmn.AddSubscriber( "see_serviceroom_1", see_serviceroom_1, private.room_objname );     
  cmn.AddSubscriber( "see_serviceroom_1",   see_serviceroom_loc, "rm_room_211"   ); 
  cmn.AddSubscriber( "see_serviceroom_loc", see_serviceroom_loc, "rm_room_211"   ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_serviceroom_ceiling () end;
  --------------------------------------------------------------------------------------------
  local see_serviceroom_ceiling = function ()
    
    ObjMultiSet( { 
      { "anm_serviceroom_ceiling",     { frame = 300 } },
    } );
  
  end;

  cmn.AddSubscriber( "see_serviceroom_ceiling", see_serviceroom_ceiling, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function see_serviceroom_ghost () end;
  --------------------------------------------------------------------------------------------
  local see_serviceroom_ghost = function ()
    
    ObjDelete( "vid_serviceroom_ghost" );
  
  end;

  cmn.AddSubscriber( "see_serviceroom_ghost", see_serviceroom_ghost, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_7 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_7 = function ()
  
    ObjDelete( "obj_serviceroom_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_7", get_collect_morph_item_7, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_5 = function ()
  
    ObjDelete( "obj_boxes_collect2_item_5" ); 
  
    if ( cmn.IsEventDone( "get_metalcarcass" ) ) then
      
      ObjDelete( "gzz_serviceroom_boxes" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_5", get_collect2_item_5, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_workbench () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_workbench" );
    
    function zz_workbench.Open ()
    
      if not private.torch_anim and cmn.IsEventDone( "use_torch_2" ) and not cmn.IsEventDone( "get_acid" ) then
        
        private.torch_anim = true;
        private.AnimTorch();
        
      end;
    
    end;  
    -------------------------------------------------
    function zz_workbench.PreOpen ()
    end;  
    -------------------------------------------------
    function zz_workbench.PreClose ()      
    end; 
    ------------------------------------------------- 
    function zz_workbench.Close ()
      
      if not cmn.IsEventDone( "see_serviceroom_ghost" ) then
        
        private.see_serviceroom_ghost();
        
      end;
      
    end;
  
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_serviceroom();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( cmn.IsEventDone( "use_salammoniac" ) and not cmn.IsEventDone( "dlg_serviceroom_clark_1" ) ) then
    
    private.dlg_serviceroom_clark_1();
    
  end; 
  
end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "level1/env/aud_serviceroom_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.StopAudio( "env", "level1/env/aud_serviceroom_env", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_jewel ()

  local item = "inv_jewel";

  if ( cmn.ApplyObj( item, "gzz_serviceroom_boxes" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes_use_jewel" ) ) then

    cmn.CallEventHandler( "use_jewel_inv" );
    cmn.CallEventHandler( "use_jewel_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        local func_end_3 = function ()

          cmn.Lock( false );
          cmn.SetEventDone( "use_jewel" );
          cmn.CallEventHandler( "use_jewel_end" );

        end;

        ObjAnimate( "spr_boxes_door_2", "pos_xy", 0, 0, func_end_3, { 
          0.0, 0, ObjGet("spr_boxes_door_2").pos_x, ObjGet("spr_boxes_door_2").pos_y,
          0.3, 0,                             -196,                             -423,
        } );

      end;

      ObjAnimate( "spr_boxes_lock", "pos_xy", 0, 0, func_end_2, { 
        0.0, 0, ObjGet("spr_boxes_lock").pos_x, ObjGet("spr_boxes_lock").pos_y,
        0.3, 0,                            -84,                             23,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_jewel", 0, "", 0 );

    cmn.ItemFly( "spr_boxes_decoration", func_end, 1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bloodyamulet ()

  local item = "inv_bloodyamulet";

  if ( cmn.ApplyObj( item, "gzz_serviceroom_boxes" ) and cmn.IsEventDone( "clk_bloodyamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes_use_bloodyamulet" ) and cmn.IsEventDone( "clk_bloodyamulet" ) ) then

    cmn.CallEventHandler( "use_bloodyamulet_inv" );
    cmn.CallEventHandler( "use_bloodyamulet_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        local func_end_3 = function ()

          cmn.Lock( false );
          cmn.SetEventDone( "use_bloodyamulet" );
          cmn.CallEventHandler( "use_bloodyamulet_end" );

        end;

        ObjAnimate( "spr_boxes_lattice", "pos_xy", 0, 0, func_end_3, { 
          0.0, 0, ObjGet("spr_boxes_lattice").pos_x, ObjGet("spr_boxes_lattice").pos_y,
          0.3, 0,                               105,                               -77,
        } );

      end;

      ObjAnimate( "spr_boxes_jaw", "ang", 0, 0, func_end_2, { 
        0.0, 0, ObjGet("spr_boxes_jaw").ang, 
        0.3, 0,                          0 ,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_bloodyamulet", 0, "", 0 );

    cmn.ItemFly( "spr_boxes_jaw", func_end, -2, 20, 1.1 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver_1 ()

  local item = "inv_screwdriver";

  if ( cmn.ApplyObj( item, "gzz_serviceroom_workbench" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_workbench" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_workbench_use_screwdriver" ) ) then

    cmn.CallEventHandler( "use_screwdriver_1_inv" );
    cmn.CallEventHandler( "use_screwdriver_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_screwdriver_1" );
      cmn.CallEventHandler( "use_screwdriver_1_end" );
      private.get_fireaxe();
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_screwdriver", 0, "", 0 );

    VidPlay( "vid_workbench_screw", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_metalcarcass ()

  local item = "inv_metalcarcass";

  if ( cmn.ApplyObj( item, "gzz_serviceroom_workbench" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_workbench" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_workbench_use_metalcarcass" ) ) then

    cmn.CallEventHandler( "use_metalcarcass_inv" );
    cmn.CallEventHandler( "use_metalcarcass_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_metalcarcass" );
      cmn.CallEventHandler( "use_metalcarcass_end" );
      
      common.CloseSubRoom();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_use_metal", 0, "", 0 );

    cmn.ItemFly( "spr_workbench_lever", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_torch_2 ()

  local item = "inv_torch_2";

  if ( cmn.ApplyObj( item, "gzz_serviceroom_workbench" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_workbench" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_workbench_use_torch_2" ) ) then

    cmn.CallEventHandler( "use_torch_2_inv" );
    cmn.CallEventHandler( "use_torch_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_torch_2" );
      cmn.CallEventHandler( "use_torch_2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_short", 0, "", 0 );

    func_end();
    
    private.torch_anim = true;
    private.AnimTorch();

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_broom ()

  local item = "inv_broom";

  if ( cmn.ApplyObj( item, "obj_serviceroom_use_broom" ) ) then

    cmn.CallEventHandler( "use_broom_inv" );
    cmn.CallEventHandler( "use_broom_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_broom" );
      cmn.CallEventHandler( "use_broom_end" );
      
      private.get_stick(); 

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_broom", 0, "", 0 );
    
    AnimPlay( "anm_serviceroom_web", "web", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_salammoniac ()

  local item = "inv_salammoniac";

  if ( cmn.ApplyObj( item, "obj_serviceroom_use_salammoniac" ) ) then

    cmn.CallEventHandler( "use_salammoniac_inv" );
    cmn.CallEventHandler( "use_salammoniac_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_salammoniac" );
      cmn.CallEventHandler( "use_salammoniac_end" );
      
      private.dlg_serviceroom_clark_1(); 

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_salammoniac", 0, "", 0 );
    
    ObjMultiSet( { 
      { "anm_serviceroom_man_1", { alp = 0 } },
      { "anm_serviceroom_man_2", { alp = 1 } },
    } );
    
    AnimPlay( "anm_serviceroom_man_2", "clark_2", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_cross_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cross_2" );
  cmn.CallEventHandler( "get_cross_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_familyportrait ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_familyportrait" );
  cmn.CallEventHandler( "get_familyportrait" );

end;
--------------------------------------------------------------------------------------------
function private.get_metalcarcass ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_metalcarcass" );
  cmn.CallEventHandler( "get_metalcarcass" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_5" ) ) then
  
    common.CloseSubRoom();
    
  end;


end;
--------------------------------------------------------------------------------------------
function private.get_fireaxe ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fireaxe" );
  cmn.CallEventHandler( "get_fireaxe" );

end;
--------------------------------------------------------------------------------------------
function private.get_acid ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_acid" );
  cmn.CallEventHandler( "get_acid" );
  
  private.torch_anim = false;

end;
--------------------------------------------------------------------------------------------
function private.get_stick ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stick" );
  cmn.CallEventHandler( "get_stick" );

end;
--------------------------------------------------------------------------------------------
function private.get_hexagon ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hexagon" );
  cmn.CallEventHandler( "get_hexagon" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_5 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_5" ); 

  end;

  common_impl.PlayEffectHO( "spr_boxes_collect2_item_5", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_5" );
  
  if ( cmn.IsEventDone( "get_metalcarcass" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_bloodyamulet ()
  
  cmn.CallEventHandler( "clk_bloodyamulet_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_bloodyamulet" );
    cmn.CallEventHandler( "clk_bloodyamulet_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_wood_cover", 0, "", 0 );

  ObjAnimate( "spr_boxes_door", "pos_xy", 0, 0, func_end, { 
    0.0, 0, ObjGet("spr_boxes_door").pos_x, ObjGet("spr_boxes_door").pos_y,   
    0.3, 0,                           -112,                              3 
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_jewel ()
  
  cmn.CallEventHandler( "clk_jewel_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_jewel" );
    cmn.CallEventHandler( "clk_jewel_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_slide_paper", 0, "", 0 );

  ObjAnimate( "spr_boxes_familyportrait", "pos_xy", 0, 0, func_end, { 
    0.0, 0, ObjGet("spr_boxes_familyportrait").pos_x, ObjGet("spr_boxes_familyportrait").pos_y,   
    0.3, 0,                                     -135,                                      -87,
  } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
function private.dlg_serviceroom_clark_1 ()

  common_impl.dialog_character_loc = "anm_serviceroom_man_2";
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "clark_1", 5, nil, nil, true, private.dlg_serviceroom_clark_1_end ); 
  ObjDelete( "anm_serviceroom_man_2" );
  
end;
--------------------------------------------------------------------------------------------
function private.dlg_serviceroom_clark_1_end ()
  
  cmn.CallEventHandler( "dlg_serviceroom_clark_1" ); 
  common_impl.ShowBbt( 'bbt_serviceroom_after_dlg_clark_1' );

  
end;
--*********************************************************************************************************************
function private.dlg_serviceroom_clark_2 ()
  
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "clark_2", 3, nil, nil, true, private.dlg_serviceroom_clark_2_end ); 
  common_impl.dialog_character_loc = "obj_serviceroom_man";
  
end;
--------------------------------------------------------------------------------------------
function private.dlg_serviceroom_clark_2_end ()

  cmn.CallEventHandler( "dlg_serviceroom_clark_2" ); 
  common_impl.ShowBbt( 'bbt_serviceroom_after_dlg_clark_2' );

  ObjSet( "spr_serviceroom_hexagon", { alp = 1, visible = true } );
  private.get_hexagon();
  
  interface.KeyTaskDone( true );
  interface.KeyTaskAdd( "meet_clark" );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
  
  if ( dlg_name == "clark_1" ) then
    
    if ( count_txt == 1 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_serviceroom_clark_1_1",  { alp = 1, visible = true } },
        { "vid_dlg_serviceroom_clark_1_2",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_1_3",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_1_4",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_serviceroom_clark_1_1", "" );
      
    elseif ( count_txt == 2 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_serviceroom_clark_1_1",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_1_2",  { alp = 1, visible = true } },
        { "vid_dlg_serviceroom_clark_1_3",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_1_4",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_serviceroom_clark_1_2", "" );
      
    elseif ( count_txt == 3 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_serviceroom_clark_1_1",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_1_2",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_1_3",  { alp = 1, visible = true } },
        { "vid_dlg_serviceroom_clark_1_4",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_serviceroom_clark_1_3", "" );
      
    elseif ( count_txt == 4 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_serviceroom_clark_1_1",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_1_2",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_1_3",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_1_4",  { alp = 1, visible = true } },
      } );
      
      VidPlay( "vid_dlg_serviceroom_clark_1_4", "" );
      
    end;
    
  end;  
-------------------------------------------  
-------------------------------------------   
  if ( dlg_name == "clark_2" ) then
    
    if ( count_txt == 1 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_serviceroom_clark_2_1",  { alp = 1, visible = true } },
        { "vid_dlg_serviceroom_clark_2_2",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_serviceroom_clark_2_1", "" );
      
    elseif ( count_txt == 2 ) then
      
      ObjSet( "anm_serviceroom_clark_2_give", { alp = 1 } );
      AnimPlay( "anm_serviceroom_clark_2_give", "give", "" );
      
      ObjMultiSet( { 
        { "vid_dlg_serviceroom_clark_2_1",  { alp = 0, visible = false } },
        { "vid_dlg_serviceroom_clark_2_2",  { alp = 1, visible = true } },
      } );
      
      VidPlay( "vid_dlg_serviceroom_clark_2_2", "" );
      
    end;
    
  end;
   
end;
--*********************************************************************************************************************
function private.see_serviceroom_1 ()
  
  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "see_serviceroom_1" );
    cmn.CallEventHandler( "see_serviceroom_1" ); 
    cmn.CallEventHandler( "see_serviceroom_loc" ); 
    
    ObjMultiSet( { 
      { "anm_serviceroom_collapse", { frame = 0 } },
    } );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_serviceroom",               0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_clark_anm_serviceroom_voc", 0, "", 0 );
  common_impl.ShowBbt( 'sub_clark_anm_serviceroom' );

  AnimPlay( "anm_serviceroom_collapse", "DoAnim", func_end );
  ObjMultiSet( { 
    { "anm_serviceroom_man_3",          { alp = 0 } },
    { "anm_serviceroom_lamp_before",    { alp = 0 } },
    { "anm_serviceroom_ceiling_before", { alp = 0 } },
    { "anm_serviceroom_collapse",       { alp = 1 } },
  } );
  common_impl.dialog_character_loc = "obj_serviceroom_man";

end;
--------------------------------------------------------------------------------------------
function private.see_serviceroom_ceiling ()
  
  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "see_serviceroom_ceiling" );
    cmn.CallEventHandler( "see_serviceroom_ceiling" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_destruction", 0, "", 0 );

  AnimPlay( "anm_serviceroom_ceiling", "ceiling", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_serviceroom_ghost ()
  
  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "see_serviceroom_ghost" );
    cmn.CallEventHandler( "see_serviceroom_ghost" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_shadow", 0, "", 0 );

  VidPlay( "vid_serviceroom_ghost", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_serviceroom ()

  if not ( cmn.IsEventDone( "opn_serviceroom" ) ) then

    local func_end = function ()
    
      cmn.Lock( false );
      cmn.SetEventDone( "opn_serviceroom" );

      common_impl.ShowBbt( 'bbt_serviceroom_opn_serviceroom' );
      
    end;
    
    cmn.Lock( true );  
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_zoom", 0, "", 0 );
    ObjAnimate( "rm_serviceroom", "scale_xy",0,0, func_end, { 0, 3, 1, 1,    0.6, 3, 1.3, 1.3,    2.0, 3, 1.3, 1.3,    2.4, 3, 1, 1 } );
    ObjAnimate( "rm_serviceroom", "pos_xy",0,0, "", { 0, 3, 0, 0,    0.6, 3, -54, -214,    2.0, 3, -54, -214,    2.4, 3, 0, 0 } ); 
    
  else
    
    if ( not cmn.IsEventDone( "see_serviceroom_ceiling" ) ) then
      
      private.see_serviceroom_ceiling();
      
    end
    
  end;
  
  cmn.CallEventHandler( "opn_serviceroom" ); 
  
end;
--------------------------------------------------------------------------------------------
function private.AnimTorch ()

  local func_end = function()
  
    if private.torch_anim then
  
      private.AnimTorch();
      
    end;
  
  end;
  
  local pos = GetZoomCursorPos();
  local param_cur = ObjGet( "spr_workbench_shadow" );
  
  ObjAnimate( "spr_workbench_shadow", "pos_xy", 0, 0, func_end, {
  
    0, 0, param_cur.pos_x, param_cur.pos_y,
    00.1, 3, pos[1] - 512, pos[2] - 384,
    
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.ScalePhoto ()

  local func_end = function()
  
    cmn.Lock( false );
    
    ObjSet( "spr_boxes_familyportrait", { input = false } );
    ObjSet( "spr_boxes_familyportrait_big", { input = true } );
  
  end;
  
  cmn.Lock( true );
  
  local param_big = ObjGet( "spr_boxes_familyportrait_big" );
  
  ObjAnimate( "spr_boxes_familyportrait", "alp", 0, 0, "", { 
    0.0, 0, 1, 
    0.3, 0, 0 
  } );

  ObjAnimate( "spr_boxes_familyportrait_big", "pos_xy", 0, 0, "", {
    0.0, 3, param_big.pos_x, param_big.pos_y,
    0.3, 3, 0, 0 
  } );

  ObjAnimate( "spr_boxes_familyportrait_big", "scale_xy", 0, 0, func_end, { 
    0.0, 3, 0, 0,
    0.3, 3, 1, 1 
  } );
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--------------------------------------------------------------------------------------------
function private.AnimAudioServiceRoom ()

  local func_end = function ()

    ObjSet( "obj_serviceroom_block", { input = true } );

    common_impl.StopAudio( "sfx", "level1/sfx/", 0.2 );
    
  end;

  common_impl.ShowBbt( 'bbt_serviceroom_block' );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_hand_ho", 0, "", 0 );

  ObjSet( "obj_serviceroom_block", {             input = false                    } );
  ObjSet( "tmr_serviceroom_clk",   { time = 2, playing = true, endtrig = func_end } );

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.AnimFireaxeFeedback ()

  local func_end = function()
  
    cmn.Lock( false );
    
    common_impl.ShowBbt( 'bbt_workbench_use_screwdriver' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_axe", 0, "", 0 );
  ObjAnimate( "spr_workbench_fireaxe", "pos_x", 0, 1, func_end, {
    0, 0, 0,
    0.2, 3, -2,
    0.4, 3, 0,
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.AnimUseBloodyamulet ()

  local func_end = function()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_boxes_use_bloodyamulet' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_panel_mid", 0, "", 0 );
  ObjAnimate( "spr_boxes_lattice", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,-3,-1,  0.4,3,0,0, } );
  
end;
--------------------------------------------------------------------------------------------
function private.AnimUseJewel ()

  local func_end = function()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_boxes_use_jewel' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_part_box", 0, "", 0 );
  ObjAnimate( "spr_boxes_lock", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,1,1,  0.4,3,0,0, } );
  
end;
--*********************************************************************************************************************