-- name=rm_terrace
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_terrace";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_balconyflowerbed", "room_hub" );
  ObjAttach( "zz_attic",            "room_hub" );
  ObjAttach( "zz_weathervane",      "room_hub" );
  ObjAttach( "zz_brokenfloor",      "room_hub" );

  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_balconyflowerbed_pruners",            { event_mdown = private.get_pruners          }},
    { "spr_balconyflowerbed_hammer",             { event_mdown = private.get_hammer           }},
    { "spr_balconyflowerbed_cleaningagen",       { event_mdown = private.get_cleaningagen     }},
    { "obj_balconyflowerbed_clk_oldselfmadepen", { event_mdown = private.clk_oldselfmadepen   }},
    { "obj_balconyflowerbed_use_selfmadepen",    { event_mdown = private.AnimUseSelfmadepen   }},
    
    { "spr_balconyflowerbed_letter",             { event_mdown = function() cmn.NoteScale( "spr_balconyflowerbed_letter" ) end }},
    { "spr_balconyflowerbed_letter_big",         { event_mdown = function() cmn.NoteScale( "spr_balconyflowerbed_letter" ) end }},
   
    { "spr_attic_symbol",                        { event_mdown = private.get_symbol           }},
    { "spr_attic_wood_4",                        { event_mdown = private.get_wood_4           }},
    { "spr_attic_screwdriver",                   { event_mdown = private.get_screwdriver      }},
    { "obj_attic_clk_carvedhandle",              { event_mdown = private.clk_carvedhandle     }},
    { "obj_attic_use_lionhead_1",                { event_mdown = private.AnimUseLionhead1     }},
    { "obj_attic_use_lionhead_2",                { event_mdown = private.AnimUseLionhead2     }},
    { "obj_attic_use_carvedhandle",              { event_mdown = private.AnimUseCarvedhandle  }},
    { "obj_attic_use_hammer",                    { event_mdown = private.UseHammer2           }},
    
    { "spr_weathervane_phoenixfigurine",         { event_mdown = private.get_phoenixfigurine  }},
    { "spr_weathervane_breadcrust",              { event_mdown = private.get_breadcrust       }},
    
    { "spr_brokenfloor_toyplane",                { event_mdown = private.get_toyplane         }},
    { "obj_brokenfloor_use_nails",               { event_mdown = private.UseNails             }},
    { "obj_brokenfloor_use_hammer",              { event_mdown = private.UseHammer            }},
    
    { "grm_terrace_room_211",                    { event_mdown = private.see_room_211         }},
    { "spr_terrace_wood_3",                      { event_mdown = private.get_wood_3           }},
    { "obj_terrace_clk_terrace",                 { event_mdown = private.see_terrace_1        }},

    { "spr_terrace_collect_morph_item",    { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_4" ); end } },
      
    { "spr_balconyflowerbed_collect2_item_6",    { event_mdown = private.get_collect2_item_6   } }, 
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_terrace = function ()
  
    table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gzz_terrace_balconyflowerbed",
      "gzz_terrace_weathervane",
      "gzz_terrace_brokenfloor",
      "gzz_terrace_attic",
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_balconyflowerbed",
      "zz_attic",
      "zz_weathervane",
      "zz_brokenfloor",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_terrace", update_game_mode_terrace, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_terrace = function ()

    local effects_table = 
    {
      "obj_terrace_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_terrace", update_performance_mode_terrace, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_terrace () end;
  --------------------------------------------------------------------------------------------
  local opn_terrace_map = function ()

    common_impl.VisitMapRoom( "terrace" );

  end;
  cmn.AddSubscriber( "opn_terrace", opn_terrace_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_pruners () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pruners" ] = {
    type = "get",
    get_obj = "spr_balconyflowerbed_pruners",
    room = private.room_objname,
    zz = "zz_balconyflowerbed",
    zz_gate = "gzz_terrace_balconyflowerbed"
  };
  
  local get_pruners_inv = function ()
  
    interface.InventoryItemAdd( "inv_pruners", "spr_balconyflowerbed_pruners" );
  
  end;
  
  local get_pruners_closezz = function ()
  
    ObjDelete( "gfx_balconyflowerbed_pruners" );
    ObjDelete( "spr_terrace_prunerr" );
    
    if ( cmn.IsEventDone( "get_cleaningagen" ) and 
    cmn.IsGetCollect2( "get_collect2_item_6" ) ) then
      
      ObjDelete( "gzz_terrace_balconyflowerbed" );

    end;  
  
  end;
  
  cmn.AddSubscriber( "get_pruners", get_pruners_inv );
  cmn.AddSubscriber( "get_pruners", get_pruners_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hammer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hammer" ] = {
    type = "get",
    get_obj = "spr_balconyflowerbed_hammer",
    room = private.room_objname,
    zz = "zz_balconyflowerbed",
    zz_gate = "gzz_terrace_balconyflowerbed"
  };
  
  local get_hammer_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammer", "spr_balconyflowerbed_hammer" );
  
  end;
  
  local get_hammer_closezz = function ()
  
    ObjDelete( "gfx_balconyflowerbed_hammer" );
    ObjDelete( "spr_terrace_hammer" );
    
  end;
  
  cmn.AddSubscriber( "get_hammer", get_hammer_inv );
  cmn.AddSubscriber( "get_hammer", get_hammer_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cleaningagen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cleaningagen" ] = {
    type = "get",
    get_obj = "spr_balconyflowerbed_cleaningagen",
    room = private.room_objname,
    zz = "zz_balconyflowerbed",
    zz_gate = "gzz_terrace_balconyflowerbed"
  };
  
  local get_cleaningagen_inv = function ()
  
    interface.InventoryItemAdd( "inv_cleaningagen", "spr_balconyflowerbed_cleaningagen" );
  
  end;
  
  local get_cleaningagen_closezz = function ()
  
    ObjDelete( "gfx_balconyflowerbed_cleaningagen" );
    ObjDelete( "spr_terrace_cleanser" );
    
    if ( cmn.IsEventDone( "get_pruners" ) and 
    cmn.IsGetCollect2( "get_collect2_item_6" ) ) then
      
      ObjDelete( "gzz_terrace_balconyflowerbed" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_cleaningagen", get_cleaningagen_inv );
  cmn.AddSubscriber( "get_cleaningagen", get_cleaningagen_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_symbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_symbol" ] = {
    type = "get",
    get_obj = "spr_attic_symbol",
    room = private.room_objname,
    zz = "zz_attic",
    zz_gate = "gzz_terrace_attic"
  };
  
  local get_symbol_inv = function ()
  
    interface.InventoryItemAdd( "inv_symbol", "spr_attic_symbol" );
  
  end;
  
  local get_symbol_closezz = function ()
  
    ObjDelete( "gfx_attic_symbol" );
    ObjDelete( "spr_terrace_4" );
    ObjSet( "obj_attic_use_hammer", { input = true, active = true, visible = true } );
    
  end;
  
  cmn.AddSubscriber( "get_symbol", get_symbol_inv );
  cmn.AddSubscriber( "get_symbol", get_symbol_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_wood_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wood_3" ] = {
    type = "get",
    get_obj = "spr_terrace_wood_3",
    room = private.room_objname
  };
  
  local get_wood_3_inv = function ()
  
    local count = 0;
    
    for i = 1, 4, 1 do
      
      if ( cmn.IsEventDone( "get_wood_"..i ) ) then
        
        count = count + 1;
        
      end;
      
    end;
  
    ObjSet( "anm_wood",   { frame = ObjGet( "anm_wood" ).frame + 1 } );
    ObjSet( "inv_wood_3", {   alp = 1                              } );  
    interface.InventoryItemAdd( "inv_wood", "spr_terrace_wood_3", "assets/levels/level1/rm_terrace/inv/inv_wood_5_6" );

    if count == 4 then
      ObjSet( "inv_wood", { drag = true } );
    else 
      ObjSet( "inv_wood", { drag = false } );
    end;
  
  end;
  
  local get_wood_3_closezz = function ()
  
    ObjDelete( "gfx_terrace_wood_3" );
  
  end;
  
  cmn.AddSubscriber( "get_wood_3", get_wood_3_inv );
  cmn.AddSubscriber( "get_wood_3", get_wood_3_closezz, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function get_wood_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wood_4" ] = {
    type = "get",
    get_obj = "spr_attic_wood_4",
    room = private.room_objname,
    zz = "zz_attic",
    zz_gate = "gzz_terrace_attic"
  };
  
  local get_wood_4_inv = function ()
  
    local count = 0;
    
    for i = 1, 4, 1 do
      
      if ( cmn.IsEventDone( "get_wood_"..i ) ) then
        
        count = count + 1;
        
      end;
      
    end;
  
    ObjSet( "anm_wood",   { frame = ObjGet( "anm_wood" ).frame + 1 } );
    ObjSet( "inv_wood_4", {   alp = 1                              } );  
    interface.InventoryItemAdd( "inv_wood", "spr_attic_wood_4", "assets/levels/level1/rm_terrace/zz_attic/inv/inv_wood_6_6" );
    DbgTrace("count - "..count);
    if count == 4 then
      ObjSet( "inv_wood", { drag = true } );
    else 
      ObjSet( "inv_wood", { drag = false } );
    end;
    
  end;
  
  local get_wood_4_closezz = function ()
  
    ObjDelete( "gfx_attic_wood_4" );
    ObjDelete( "spr_terrace_5" );
    
  end;
  
  cmn.AddSubscriber( "get_wood_4", get_wood_4_inv );
  cmn.AddSubscriber( "get_wood_4", get_wood_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriver" ] = {
    type = "get",
    get_obj = "spr_attic_screwdriver",
    room = private.room_objname,
    zz = "zz_attic",
    zz_gate = "gzz_terrace_attic"
  };
  
  local get_screwdriver_inv = function ()
  
    interface.InventoryItemAdd( "inv_screwdriver", "spr_attic_screwdriver" );
  
  end;
  
  local get_screwdriver_closezz = function ()
  
    ObjDelete( "gfx_attic_screwdriver" );
    ObjDelete( "gzz_terrace_attic" );
  
  end;
  
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_inv );
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_phoenixfigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_phoenixfigurine" ] = {
    type = "get",
    get_obj = "spr_weathervane_phoenixfigurine",
    room = private.room_objname,
    zz = "zz_weathervane",
    zz_gate = "gzz_terrace_weathervane"
  };
  
  local get_phoenixfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_phoenixfigurine", "spr_weathervane_phoenixfigurine" );
  
  end;
  
  local get_phoenixfigurine_closezz = function ()
  
    ObjDelete( "gfx_weathervane_phoenixfigurine" );
    ObjDelete( "gzz_terrace_weathervane" );
  
  end;
  
  cmn.AddSubscriber( "get_phoenixfigurine", get_phoenixfigurine_inv );
  cmn.AddSubscriber( "get_phoenixfigurine", get_phoenixfigurine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_breadcrust () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_breadcrust" ] = {
    type = "get",
    get_obj = "spr_weathervane_breadcrust",
    room = private.room_objname,
    zz = "zz_weathervane",
    zz_gate = "gzz_terrace_weathervane"
  };
  
  local get_breadcrust_inv = function ()
  
    interface.InventoryItemAdd( "inv_breadcrust", "spr_weathervane_breadcrust" );
  
  end;
  
  local get_breadcrust_closezz = function ()
  
    ObjDelete( "gfx_weathervane_breadcrust" );
  
  end;
  
  cmn.AddSubscriber( "get_breadcrust", get_breadcrust_inv );
  cmn.AddSubscriber( "get_breadcrust", get_breadcrust_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toyplane () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toyplane" ] = {
    type = "get",
    get_obj = "spr_brokenfloor_toyplane",
    room = private.room_objname,
    zz = "zz_brokenfloor",
    zz_gate = "gzz_terrace_brokenfloor"
  };
  
  local get_toyplane_inv = function ()
  
    interface.InventoryItemAdd( "inv_toyplane", "spr_brokenfloor_toyplane" );
  
  end;
  
  local get_toyplane_closezz = function ()
  
    ObjDelete( "anm_brokenfloor_angel" );
    ObjDelete( "gfx_brokenfloor_toyplane" );
    ObjMultiSet( { 
      { "obj_brokenfloor_use_wood",  { input = true } },
    } );
    
  end;
  
  cmn.AddSubscriber( "get_toyplane", get_toyplane_inv );
  cmn.AddSubscriber( "get_toyplane", get_toyplane_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_selfmadepen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_selfmadepen" ] = {
    type = "use",
    inv_obj = "inv_selfmadepen",
    use_place = "obj_balconyflowerbed_use_selfmadepen",
    room = private.room_objname,
    zz = "zz_balconyflowerbed",
    zz_gate = "gzz_terrace_balconyflowerbed"
  };
  local use_selfmadepen_inv = function ()
  
    interface.InventoryItemRemove( "inv_selfmadepen" );
  
  end;
  local use_selfmadepen_beg = function ()
  
    ObjDelete( "obj_balconyflowerbed_use_selfmadepen" );
  
  end;
  local use_selfmadepen_end = function ()
  
    ObjMultiSet( { 
      { "spr_balconyflowerbed_pruners",       {  input = true } },
      { "gfx_balconyflowerbed_pruners",       { active = true } },
      { "spr_balconyflowerbed_cleaningagen",  {  input = true } },
      { "gfx_balconyflowerbed_cleaningagen",  { active = true } },
      { "obj_balconyflowerbed_lastframe",     {    alp = 1    } },
      { "spr_terrace_shelv2",                 {    alp = 1    } },
    } );
    ObjDelete( "anm_balconyflowerbed_new_holder" )
    ObjDelete( "spr_terrace_shelv1" )
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_selfmadepen", use_selfmadepen_beg, private.room_objname );
  cmn.AddSubscriber( "use_selfmadepen", use_selfmadepen_inv );
  cmn.AddSubscriber( "use_selfmadepen", use_selfmadepen_end, private.room_objname );
  cmn.AddSubscriber( "use_selfmadepen_inv", use_selfmadepen_inv, private.room_objname );
  cmn.AddSubscriber( "use_selfmadepen_beg", use_selfmadepen_beg, private.room_objname );
  cmn.AddSubscriber( "use_selfmadepen_end", use_selfmadepen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lionhead_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lionhead_1" ] = {
    type = "use",
    inv_obj = "inv_lionhead_1",
    use_place = "obj_attic_use_lionhead_1",
    room = private.room_objname,
    zz = "zz_attic",
    zz_gate = "gzz_terrace_attic"
  };
  local use_lionhead_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_lionhead_1" );
  
  end;
  local use_lionhead_1_beg = function ()
  
    ObjDelete( "obj_attic_use_lionhead_1" );
  
  end;
  local use_lionhead_1_end = function ()
    
    ObjMultiSet( { 
      { "spr_terrace_2",    { alp = 1 } },
      { "spr_attic_lion_1", { alp = 1 } },
    } );  
      
    if ( cmn.IsEventDone( "use_lionhead_2" ) ) then
      
      ObjMultiSet( { 
        { "spr_attic_flap_1_open",      {    alp = 1                                  } },
        { "spr_attic_flap_2_open",      {    alp = 1                                  } },
        { "spr_terrace_6",              {    alp = 1                                  } },
        { "spr_attic_symbol",           {  input = true                               } },
        { "gfx_attic_symbol",           {               active = true                 } },
        { "obj_attic_clk_carvedhandle", { input = true, active = true, visible = true } },
      } );

      ObjDelete( "spr_attic_flap_1" );
      ObjDelete( "spr_attic_flap_2" );
      ObjDelete( "spr_terrace_1" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lionhead_1", use_lionhead_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_1", use_lionhead_1_inv );
  cmn.AddSubscriber( "use_lionhead_1", use_lionhead_1_end, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_1_inv", use_lionhead_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_1_beg", use_lionhead_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_1_end", use_lionhead_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_carvedhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_carvedhandle" ] = {
    type = "use",
    inv_obj = "inv_carvedhandle",
    use_place = "obj_attic_use_carvedhandle",
    room = private.room_objname,
    zz = "zz_attic",
    zz_gate = "gzz_terrace_attic"
  };
  local use_carvedhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_carvedhandle" );
  
  end;
  local use_carvedhandle_beg = function ()
  
    ObjDelete( "obj_attic_use_carvedhandle" );
  
  end;
  local use_carvedhandle_end = function ()
  
    ObjMultiSet( { 
      { "spr_attic_screwdriver", {  input = true } },
      { "anm_attic_new_handle",  {  frame = 300  } },
      { "gfx_attic_screwdriver", { active = true } },
    } );
    ObjDelete( "spr_attic_top_box" );
    ObjDelete( "anm_attic_handle_off" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_carvedhandle", use_carvedhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_carvedhandle", use_carvedhandle_inv );
  cmn.AddSubscriber( "use_carvedhandle", use_carvedhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_carvedhandle_inv", use_carvedhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_carvedhandle_beg", use_carvedhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_carvedhandle_end", use_carvedhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hammer_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_3" ] = {
    type = "use",
    inv_obj = "inv_hammer",
    use_place = "obj_attic_use_hammer",
    room = private.room_objname,
    zz = "zz_attic",
    zz_gate = "gzz_terrace_attic"
  };
  local use_hammer_3_inv = function ()
  
    if ( cmn.IsEventDone( "use_hammer_1" ) and
    cmn.IsEventDone( "use_hammer_2" ) and
    cmn.IsEventDone( "use_hammer_4" ) ) then

      interface.InventoryItemRemove( "inv_hammer" );
      
    end;
  
  end;
  local use_hammer_3_beg = function ()
  
    ObjDelete( "obj_attic_use_hammer" );
  
  end;
  local use_hammer_3_end = function ()
  
    ObjMultiSet( { 
      { "spr_attic_wood_4", {  input = true } },
      { "gfx_attic_wood_4", { active = true } },
    } );
    ObjDelete( "obj_attic_nails" );
    ObjDelete( "anm_attic_hummerjob" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammer_3", use_hammer_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_3", use_hammer_3_inv );
  cmn.AddSubscriber( "use_hammer_3", use_hammer_3_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_3_inv", use_hammer_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_3_beg", use_hammer_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_3_end", use_hammer_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lionhead_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lionhead_2" ] = {
    type = "use",
    inv_obj = "inv_lionhead_2",
    use_place = "obj_attic_use_lionhead_2",
    room = private.room_objname,
    zz = "zz_attic",
    zz_gate = "gzz_terrace_attic"
  };
  local use_lionhead_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_lionhead_2" );
  
  end;
  local use_lionhead_2_beg = function ()
  
    ObjDelete( "obj_attic_use_lionhead_2" );
  
  end;
  local use_lionhead_2_end = function ()
    
    ObjMultiSet( { 
      { "spr_terrace_3",    { alp = 1 } },
      { "spr_attic_lion_2", { alp = 1 } },
    } );  
    
    if ( cmn.IsEventDone( "use_lionhead_1" ) ) then
      
      ObjMultiSet( { 
        { "spr_attic_flap_1_open",      {    alp = 1                                  } },
        { "spr_terrace_6",              {    alp = 1                                  } },
        { "spr_attic_flap_2_open",      {    alp = 1                                  } },
        { "spr_attic_symbol",           {  input = true                               } },
        { "gfx_attic_symbol",           {               active = true                 } },
        { "obj_attic_clk_carvedhandle", { input = true, active = true, visible = true } },
      } );

      ObjDelete( "spr_attic_flap_1" );
      ObjDelete( "spr_attic_flap_2" );
      ObjDelete( "spr_terrace_1" );
      
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lionhead_2", use_lionhead_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_2", use_lionhead_2_inv );
  cmn.AddSubscriber( "use_lionhead_2", use_lionhead_2_end, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_2_inv", use_lionhead_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_2_beg", use_lionhead_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_2_end", use_lionhead_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_weathervanepart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_weathervanepart" ] = {
    type = "use",
    inv_obj = "inv_weathervanepart",
    use_place = "obj_weathervane_use_weathervanepart",
    room = private.room_objname,
    zz = "zz_weathervane",
    zz_gate = "gzz_terrace_weathervane"
  };
  local use_weathervanepart_inv = function ()
  
    interface.InventoryItemRemove( "inv_weathervanepart" );
  
  end;
  local use_weathervanepart_beg = function ()
  
    ObjDelete( "obj_weathervane_use_weathervanepart" );
  
  end;
  local use_weathervanepart_end = function ()
  
    ObjMultiSet( { 
      { "spr_weathervane_breadcrust",      { input = true } },
      { "anm_weathervane_star_lastframe",  {   alp = 1    } },
      { "spr_terrace_star",                {   alp = 1    } },
      { "spr_terrace_opendoor",            {   alp = 1    } },
    } );
    
    ObjDelete( "anm_weathervane_star" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_weathervanepart", use_weathervanepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_weathervanepart", use_weathervanepart_inv );
  cmn.AddSubscriber( "use_weathervanepart", use_weathervanepart_end, private.room_objname );
  cmn.AddSubscriber( "use_weathervanepart_inv", use_weathervanepart_inv, private.room_objname );
  cmn.AddSubscriber( "use_weathervanepart_beg", use_weathervanepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_weathervanepart_end", use_weathervanepart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stickwithhook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stickwithhook" ] = {
    type = "use",
    inv_obj = "inv_stickwithhook",
    use_place = "obj_weathervane_use_stickwithhook",
    room = private.room_objname,
    zz = "zz_weathervane",
    zz_gate = "gzz_terrace_weathervane"
  };
  local use_stickwithhook_inv = function ()
  
    interface.InventoryItemRemove( "inv_stickwithhook" );
  
  end;
  local use_stickwithhook_beg = function ()
  
    ObjDelete( "obj_weathervane_use_stickwithhook" );
  
  end;
  local use_stickwithhook_end = function ()
  
    ObjDelete( "anm_weathervane_bird" );
  
    ObjMultiSet( { 
      { "spr_weathervane_phoenixfigurine",  { alp = 1, input = true } },
      { "spr_weathervane_phoenixfigurine_over",  { alp = 1 } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stickwithhook", use_stickwithhook_beg, private.room_objname );
  cmn.AddSubscriber( "use_stickwithhook", use_stickwithhook_inv );
  cmn.AddSubscriber( "use_stickwithhook", use_stickwithhook_end, private.room_objname );
  cmn.AddSubscriber( "use_stickwithhook_inv", use_stickwithhook_inv, private.room_objname );
  cmn.AddSubscriber( "use_stickwithhook_beg", use_stickwithhook_beg, private.room_objname );
  cmn.AddSubscriber( "use_stickwithhook_end", use_stickwithhook_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_hammer_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_4" ] = {
    type = "use",
    inv_obj = "inv_hammer",
    use_place = "obj_brokenfloor_use_hammer",
    room = private.room_objname,
    zz = "zz_brokenfloor",
    zz_gate = "gzz_terrace_brokenfloor"
  };
  local use_hammer_4_inv = function ()
  
    if ( cmn.IsEventDone( "use_hammer_1" ) and
    cmn.IsEventDone( "use_hammer_2" ) and
    cmn.IsEventDone( "use_hammer_3" ) ) then

      interface.InventoryItemRemove( "inv_hammer" );
      
    end;
    
  end;
  local use_hammer_4_beg = function ()
  
    ObjDelete( "obj_brokenfloor_use_hammer" );
  
  end;
  local use_hammer_4_end = function ()
  
    ObjDelete( "gzz_terrace_brokenfloor" );
    ObjMultiSet( { 
      { "grm_terrace_room_211",  { visible = true, input = true } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_terrace_room_211_focus");
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammer_4", use_hammer_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4", use_hammer_4_inv );
  cmn.AddSubscriber( "use_hammer_4", use_hammer_4_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_inv", use_hammer_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_beg", use_hammer_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_end", use_hammer_4_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function use_nails () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nails" ] = {
    type = "use",
    inv_obj = "inv_nails",
    use_place = "obj_brokenfloor_use_nails",
    room = private.room_objname,
    zz = "zz_brokenfloor",
    zz_gate = "gzz_terrace_brokenfloor"
  };
  local use_nails_inv = function ()
  
    interface.InventoryItemRemove( "inv_nails" );
  
  end;
  local use_nails_beg = function ()
  
    ObjDelete( "obj_brokenfloor_use_nails" );
  
  end;
  local use_nails_end = function ()
    
    ObjDelete( "anm_brokenfloor_nails" );    
    ObjMultiSet( { 
      { "obj_brokenfloor_use_hammer",  { input = true } },
      { "anm_brokenfloor_hammer",      {   alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nails", use_nails_beg, private.room_objname );
  cmn.AddSubscriber( "use_nails", use_nails_inv );
  cmn.AddSubscriber( "use_nails", use_nails_end, private.room_objname );
  cmn.AddSubscriber( "use_nails_inv", use_nails_inv, private.room_objname );
  cmn.AddSubscriber( "use_nails_beg", use_nails_beg, private.room_objname );
  cmn.AddSubscriber( "use_nails_end", use_nails_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wood () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wood" ] = {
    type = "use",
    inv_obj = "inv_wood",
    use_place = "obj_brokenfloor_use_wood",
    room = private.room_objname,
    zz = "zz_brokenfloor",
    zz_gate = "gzz_terrace_brokenfloor"
  };
  local use_wood_inv = function ()
  
    interface.InventoryItemRemove( "inv_wood" );
  
  end;
  local use_wood_beg = function ()
  
    ObjDelete( "obj_brokenfloor_use_wood" );
  
  end;
  local use_wood_end = function ()
    
    ObjDelete( "anm_brokenfloor_rain_no_boards" );    
    ObjMultiSet( { 
      { "obj_brokenfloor_use_nails",   { input = true } },
      { "anm_brokenfloor_woods",       { frame = 300  } },
      { "anm_brokenfloor_rain_boards", {   alp = 1    } },
      { "spr_terrace_patch",           {   alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wood", use_wood_beg, private.room_objname );
  cmn.AddSubscriber( "use_wood", use_wood_inv );
  cmn.AddSubscriber( "use_wood", use_wood_end, private.room_objname );
  cmn.AddSubscriber( "use_wood_inv", use_wood_inv, private.room_objname );
  cmn.AddSubscriber( "use_wood_beg", use_wood_beg, private.room_objname );
  cmn.AddSubscriber( "use_wood_end", use_wood_end, private.room_objname );

--------------------------------------------------------------------------------------------
  -- function clk_oldselfmadepen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_oldselfmadepen" ] = {
    type = "click",
    use_place = "obj_balconyflowerbed_clk_oldselfmadepen",
    room = private.room_objname,
    zz = "zz_balconyflowerbed",
    zz_gate = "gzz_terrace_balconyflowerbed"
  };
  
  local clk_oldselfmadepen_beg = function ()

    ObjDelete( "obj_balconyflowerbed_clk_oldselfmadepen" );
  
  end;
  local clk_oldselfmadepen_end = function ()

    ObjDelete( "anm_balconyflowerbed_holder_broke" );
    ObjDelete( "spr_terrace_holder1" );
    ObjMultiSet( { 
      { "obj_balconyflowerbed_use_selfmadepen",  { input = true, active = true, visible = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_oldselfmadepen",     clk_oldselfmadepen_beg, private.room_objname );
  cmn.AddSubscriber( "clk_oldselfmadepen",     clk_oldselfmadepen_end, private.room_objname );
  cmn.AddSubscriber( "clk_oldselfmadepen_beg", clk_oldselfmadepen_beg, private.room_objname );
  cmn.AddSubscriber( "clk_oldselfmadepen_end", clk_oldselfmadepen_end, private.room_objname );

--------------------------------------------------------------------------------------------
  -- function clk_carvedhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_carvedhandle" ] = {
    type = "click",
    use_place = "obj_attic_clk_carvedhandle",
    room = private.room_objname,
    zz = "zz_attic",
    zz_gate = "gzz_terrace_attic"
  };
  
  local clk_carvedhandle_beg = function ()

    ObjDelete( "obj_attic_clk_carvedhandle" );
  
  end;
  local clk_carvedhandle_end = function ()

    ObjDelete( "spr_attic_handle" );
    ObjDelete( "anm_attic_handle_off" );
    
    ObjMultiSet( { 
      { "obj_attic_use_carvedhandle",  { input = true, active = true, visible = true } },
      { "anm_attic_new_handle",        {   alp = 1                                   } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_carvedhandle",     clk_carvedhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carvedhandle",     clk_carvedhandle_end, private.room_objname );
  cmn.AddSubscriber( "clk_carvedhandle_beg", clk_carvedhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carvedhandle_end", clk_carvedhandle_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_room_211 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_room_211" ] = {
    type = "click",
    use_place = "grm_terrace_room_211",
    room = private.room_objname
  };  
  
  local see_room_211 = function ()
    
    ObjMultiSet( { 
      { "grm_terrace_room_211",  { event_mdown = function() cmn.GotoRoom( "rm_room_211" ); end; } },
    } );
  
  end;
  cmn.AddSubscriber( "see_room_211", see_room_211, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function see_terrace_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_terrace_1" ] = {
    type = "click",
    use_place = "obj_terrace_clk_terrace",
    room = private.room_objname
  };
  local see_terrace_1 = function ()
    
    ObjDelete( "obj_terrace_clk_terrace"    );
    ObjDelete( "anm_terrace_anim_terrace_1" );
  
  end;
  cmn.AddSubscriber( "see_terrace_1", see_terrace_1, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function see_terrace_suicide1 () end;
  --------------------------------------------------------------------------------------------

  local see_terrace_suicide1 = function ()
    
    ObjDelete( "anm_terrace_suicide1" );
  
  end;
  cmn.AddSubscriber( "see_terrace_suicide1", see_terrace_suicide1, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_terrace_suicide2 () end;
  --------------------------------------------------------------------------------------------

  local see_terrace_suicide2 = function ()
    
    ObjDelete( "anm_terrace_suicide2" );
  
  end;
  cmn.AddSubscriber( "see_terrace_suicide2", see_terrace_suicide2, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4 = function ()
  
    ObjDelete( "obj_terrace_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_4", get_collect_morph_item_4, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_6 = function ()
  
    ObjDelete( "obj_balconyflowerbed_collect2_item_6" ); 
  
    if ( cmn.IsEventDone( "get_cleaningagen" ) and
    cmn.IsEventDone( "get_pruners" ) ) then
      
      ObjDelete( "gzz_terrace_balconyflowerbed" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_6", get_collect2_item_6, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_balconyflowerbed () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_balconyflowerbed" );
    ------------------------------------------------- 
    function zz_balconyflowerbed.Close ()
      
      cmn.NoteScaleClose( { "spr_balconyflowerbed_letter" } );
      
    end;
  
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_terrace();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "level1/env/aud_terrace_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level1/env/aud_terrace_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_selfmadepen ()

  local item = "inv_selfmadepen";

  if ( cmn.ApplyObj( item, "gzz_terrace_balconyflowerbed" ) and cmn.IsEventDone( "clk_oldselfmadepen" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_balconyflowerbed" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_balconyflowerbed_use_selfmadepen" ) and cmn.IsEventDone( "clk_oldselfmadepen" ) ) then

    cmn.CallEventHandler( "use_selfmadepen_inv" );
    cmn.CallEventHandler( "use_selfmadepen_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_selfmadepen" );
      cmn.CallEventHandler( "use_selfmadepen_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hand_doll", 0, "", 0 );

    ObjSet( "anm_balconyflowerbed_new_holder", { alp = 1 } );
    AnimPlay( "anm_balconyflowerbed_new_holder", "new_holder", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lionhead_1 ()

  local item = "inv_lionhead_1";

  if ( cmn.ApplyObj( item, "gzz_terrace_attic" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_attic" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_attic_use_lionhead_1" ) ) then

    cmn.CallEventHandler( "use_lionhead_1_inv" );
    cmn.CallEventHandler( "use_lionhead_1_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_lionhead_1" );
        cmn.CallEventHandler( "use_lionhead_1_end" );

      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_use_part", 0, "", 0 );

      if cmn.IsEventDone( "use_lionhead_2" ) then

        common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_opn_chest", 0, "", 0 );

        ObjAnimate( "spr_attic_flap_1_open", "alp", 0, 0, func_end_2, { 0, 0, 0,   0.3, 0, 1 } );
        ObjAnimate( "spr_attic_flap_2_open", "alp", 0, 0,         "", { 0, 0, 0,   0.3, 0, 1 } );
        ObjAnimate( "spr_attic_flap_1",      "alp", 0, 0,         "", { 0, 0, 1,   0.3, 0, 0 } );
        ObjAnimate( "spr_attic_flap_2",      "alp", 0, 0,         "", { 0, 0, 1,   0.3, 0, 0 } );
      else func_end_2();
      end;

    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_attic_lion_1", func_end, -1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_carvedhandle ()

  local item = "inv_carvedhandle";

  if ( cmn.ApplyObj( item, "gzz_terrace_attic" ) and cmn.IsEventDone( "clk_carvedhandle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_attic" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_attic_use_carvedhandle" ) and cmn.IsEventDone( "clk_carvedhandle" ) ) then

    cmn.CallEventHandler( "use_carvedhandle_inv" );
    cmn.CallEventHandler( "use_carvedhandle_beg" );

    local func_end = function ()

      --local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_carvedhandle" );
        cmn.CallEventHandler( "use_carvedhandle_end" );

--      end;
--
--      ObjAnimate( "spr_attic_top_box", "pos_xy", 0, 0, func_end_2, { 0.0,0,21,48, 0.6,0,-20,-153 } );
--      ObjAnimate( "spr_attic_top_box",    "alp", 0, 0,         "", { 0.0,0,1,  0.3,0,1,  0.6,0,0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_carvedhandle", 0, "", 0 );

    AnimPlay( "anm_attic_new_handle", "new_handle", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hammer_3 ()

  local item = "inv_hammer";

  if ( cmn.ApplyObj( item, "gzz_terrace_attic" ) and 
       cmn.IsEventDone( "use_lionhead_1" ) and 
       cmn.IsEventDone( "use_lionhead_2" ) and 
       cmn.IsEventDone( "get_symbol" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_attic" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_attic_use_hammer" ) and 
           cmn.IsEventDone( "use_lionhead_1" ) and 
           cmn.IsEventDone( "use_lionhead_2" ) and 
           cmn.IsEventDone( "get_symbol" ) ) then

    cmn.CallEventHandler( "use_hammer_3_inv" );
    cmn.CallEventHandler( "use_hammer_3_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_hammer_3" );
      cmn.CallEventHandler( "use_hammer_3_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hammer_3", 0, "", 0 );
    ObjSet( "obj_attic_wood", { pos_z = 5 } );
    AnimPlay( "anm_attic_hummerjob", "hummerjob", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lionhead_2 ()

  local item = "inv_lionhead_2";

  if ( cmn.ApplyObj( item, "gzz_terrace_attic" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_attic" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_attic_use_lionhead_2" ) ) then

    cmn.CallEventHandler( "use_lionhead_2_inv" );
    cmn.CallEventHandler( "use_lionhead_2_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_lionhead_2" );
        cmn.CallEventHandler( "use_lionhead_2_end" );

      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_use_part", 0, "", 0 );

      if cmn.IsEventDone( "use_lionhead_1" ) then

        common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_opn_chest", 0, "", 0 );

        ObjAnimate( "spr_attic_flap_1_open", "alp", 0, 0, func_end_2, { 0, 0, 0,   0.3, 0, 1 } );
        ObjAnimate( "spr_attic_flap_2_open", "alp", 0, 0,         "", { 0, 0, 0,   0.3, 0, 1 } );
        ObjAnimate( "spr_attic_flap_1",      "alp", 0, 0,         "", { 0, 0, 1,   0.3, 0, 0 } );
        ObjAnimate( "spr_attic_flap_2",      "alp", 0, 0,         "", { 0, 0, 1,   0.3, 0, 0 } );
      else func_end_2();
      end;

    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_attic_lion_2", func_end, 1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_weathervanepart ()

  local item = "inv_weathervanepart";

  if ( cmn.ApplyObj( item, "gzz_terrace_weathervane" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_weathervane" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_weathervane_use_weathervanepart" ) ) then

    cmn.CallEventHandler( "use_weathervanepart_inv" );
    cmn.CallEventHandler( "use_weathervanepart_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_weathervanepart" );
      cmn.CallEventHandler( "use_weathervanepart_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_weathervanepart", 0, "", 0 );

    AnimPlay( "anm_weathervane_star", "star", func_end )
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stickwithhook ()

  local item = "inv_stickwithhook";

  if ( cmn.ApplyObj( item, "gzz_terrace_weathervane" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_weathervane" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_weathervane_use_stickwithhook" ) ) then

    cmn.CallEventHandler( "use_stickwithhook_inv" );
    cmn.CallEventHandler( "use_stickwithhook_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_stickwithhook" );
      cmn.CallEventHandler( "use_stickwithhook_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_stickwithhook", 0, "", 0 );

    AnimPlay( "anm_weathervane_bird", "bird", func_end );
  
    return true;

  end;
  
  return false;
  
end;


--------------------------------------------------------------------------------------------
function public.use_hammer_4 ()

  local item = "inv_hammer";

  if ( cmn.ApplyObj( item, "gzz_terrace_brokenfloor" ) and
       cmn.IsEventDone( "use_nails" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_brokenfloor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_brokenfloor_use_hammer" ) and
           cmn.IsEventDone( "use_nails" ) ) then
           
    cmn.CallEventHandler( "use_hammer_4_inv" );
    cmn.CallEventHandler( "use_hammer_4_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hammer_4" );
      cmn.CallEventHandler( "use_hammer_4_end" );
      common.CloseSubRoom();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hammer_4", 0, "", 0 );

    AnimPlay( "anm_brokenfloor_hammer", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;


--------------------------------------------------------------------------------------------
function public.use_nails ()

  local item = "inv_nails";

  if ( cmn.ApplyObj( item, "gzz_terrace_brokenfloor" ) and
       cmn.IsEventDone( "use_wood" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_brokenfloor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_brokenfloor_use_nails" ) and
           cmn.IsEventDone( "use_wood" ) ) then

    cmn.CallEventHandler( "use_nails_inv" );
    cmn.CallEventHandler( "use_nails_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_nails" );
      cmn.CallEventHandler( "use_nails_end" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_nails", 0, "", 0 );

    AnimPlay( "anm_brokenfloor_nails", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wood ()

  local item = "inv_wood";

  if ( cmn.ApplyObj( item, "gzz_terrace_brokenfloor" ) and
       cmn.IsEventDone( "get_toyplane" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_brokenfloor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_brokenfloor_use_wood" ) and
           cmn.IsEventDone( "get_toyplane" ) ) then

    cmn.CallEventHandler( "use_wood_inv" );
    cmn.CallEventHandler( "use_wood_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_wood" );
      cmn.CallEventHandler( "use_wood_end" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_wood", 0, "", 0 );

    AnimPlay( "anm_brokenfloor_woods", "DoAnim", func_end );
    ObjAnimate( "anm_brokenfloor_rain_boards", "alp", 0, 0,         "", { 0, 0, 0,   1.5, 0, 1 } );
    ObjAnimate( "anm_brokenfloor_rain_no_boards",      "alp", 0, 0,         "", { 0, 0, 1,   1.5, 0, 0 } );  
    
    return true;

  end;
  
  return false;
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_pruners ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pruners" );
  cmn.CallEventHandler( "get_pruners" );
  
  if ( cmn.IsEventDone( "get_cleaningagen" ) and
  cmn.IsGetCollect2( "get_collect2_item_6" ) ) then
    
    common.CloseSubRoom();

  end;  

end;
--------------------------------------------------------------------------------------------
function private.get_hammer ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hammer" );
  cmn.CallEventHandler( "get_hammer" );

end;
--------------------------------------------------------------------------------------------
function private.get_cleaningagen ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cleaningagen" );
  cmn.CallEventHandler( "get_cleaningagen" );
  
  if ( cmn.IsEventDone( "get_pruners" ) and
  cmn.IsGetCollect2( "get_collect2_item_6" ) ) then
    
    common.CloseSubRoom();

  end;  
  
end;
--------------------------------------------------------------------------------------------
function private.get_symbol ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_symbol" );
  cmn.CallEventHandler( "get_symbol" );

end;
--------------------------------------------------------------------------------------------
function private.get_wood_3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wood_3" );
  cmn.CallEventHandler( "get_wood_3" );
  
  private.see_terrace_suicide1();

end;
--------------------------------------------------------------------------------------------
function private.get_wood_4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wood_4" );
  cmn.CallEventHandler( "get_wood_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_screwdriver ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_screwdriver" );
  cmn.CallEventHandler( "get_screwdriver" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_phoenixfigurine ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_phoenixfigurine" );
  cmn.CallEventHandler( "get_phoenixfigurine" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_breadcrust ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_breadcrust" );
  cmn.CallEventHandler( "get_breadcrust" );

end;
--------------------------------------------------------------------------------------------
function private.get_toyplane ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_toyplane" );
  cmn.CallEventHandler( "get_toyplane" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_6 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_6" ); 

  end;

  common_impl.PlayEffectHO( "spr_balconyflowerbed_collect2_item_6", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_6" );
  
  if ( cmn.IsEventDone( "get_cleaningagen" ) and
  cmn.IsEventDone( "get_pruners" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_oldselfmadepen ()
  
  cmn.CallEventHandler( "clk_oldselfmadepen_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_oldselfmadepen" );
    cmn.CallEventHandler( "clk_oldselfmadepen_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_break_lever", 0, "", 0 );

  AnimPlay( "anm_balconyflowerbed_holder_broke", "holder_broke", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_carvedhandle ()
  
  cmn.CallEventHandler( "clk_carvedhandle_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_carvedhandle" );
    cmn.CallEventHandler( "clk_carvedhandle_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_break_handle", 0, "", 0 );

  AnimPlay( "anm_attic_handle_off", "handle_off", func_end );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;

--*********************************************************************************************************************
function private.see_room_211 ()
  
  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "level1/voc/aud_room_211_voc", 0.2 );
      common_impl.StopAudio( "sfx", "level1/sfx/aud_room_211",     0.2 );
      
    end;

    cmn.SetEventDone( "see_room_211" );
    cmn.CallEventHandler( "see_room_211" );

    common_impl.ShowBbt( 'bbt_terrace_see_room_211' );
    
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_room_211",     0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_room_211_voc", 0, "", 0 );
  --common_impl.PlayAudio( "mus", "level1/mus/aud_intro_mus",  0, "", 0 );


  cmn.PlayDialogVideo( "vid_terrace_room_211", func_end );
  
end;

--*********************************************************************************************************************
function private.see_terrace_1 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_terrace_1" );
    cmn.CallEventHandler( "see_terrace_1" );

    common_impl.ShowBbt( 'bbt_terrace_see_terrace_1' );
    
    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "repair_floor" );
 
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_collapse", 0, "", 0 );

  AnimPlay( "anm_terrace_anim_terrace_1", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.see_terrace_suicide1 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_terrace_suicide1" );
    cmn.CallEventHandler( "see_terrace_suicide1" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_girl_cry", 0, "", 0 );

  AnimPlay( "anm_terrace_suicide1", "suicide1", func_end );

end;
--*********************************************************************************************************************
function private.see_terrace_suicide2 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_terrace_suicide2" );
    cmn.CallEventHandler( "see_terrace_suicide2" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_girl_fall", 0, "", 0 );

  ObjSet( "anm_terrace_suicide2", { alp = 1 } );
  AnimPlay( "anm_terrace_suicide2", "suicide2", func_end );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_terrace ()

  if not ( cmn.IsEventDone( "opn_terrace" ) ) then

    cmn.SetEventDone( "opn_terrace" );
    common_impl.ShowBbt( 'bbt_terrace_opn_terrace' );

  end;
  
  if not cmn.IsEventDone( "see_terrace_suicide2" ) and
    ( cmn.IsEventDone( "get_wood_1" ) and cmn.IsEventDone( "get_wood_2" ) and
    cmn.IsEventDone( "get_wood_3" ) and cmn.IsEventDone( "get_wood_4" ) ) then

    private.see_terrace_suicide2();

  end;
  
  cmn.CallEventHandler( "opn_terrace" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
  cmn.AnimateAmbientLight( "spr_brokenfloor_light" ); 
  
end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.UseNails ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_brokenfloor_use_nails' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );

  ObjAnimate( "obj_brokenfloor_wood", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1, 1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseHammer ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_brokenfloor_use_hammer' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );

  ObjAnimate( "obj_brokenfloor_wood", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1, 1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseHammer2 ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_attic_use_hammer' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_nails", 0, "", 0 );

  AnimPlay( "anm_attic_hummerjob", "hh2", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.AnimUseSelfmadepen ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_balconyflowerbed_use_selfmadepen' );
    ObjSet( "anm_balconyflowerbed_hh", { alp = 0 } );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_drawer", 0, "", 0 );

  ObjSet( "anm_balconyflowerbed_hh", { alp = 1 } );
  AnimPlay( "anm_balconyflowerbed_hh", "hh", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseLionhead1 ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_attic_use_lionhead_1' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_stone_door", 0, "", 0 );
  
  ObjAnimate( "spr_attic_flap_1", "pos_x", 0, 1, func_end, { 0,0,0, 0.2,3,-3,   0.4,3,0, } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseLionhead2 ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_attic_use_lionhead_2' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_stone_door", 0, "", 0 );
  
  ObjAnimate( "spr_attic_flap_2", "pos_x", 0, 1, func_end, { 0,0,0, 0.2,3,3, 0.4,3,0, } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseCarvedhandle ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_attic_use_carvedhandle' );
    ObjSet( "anm_attic_handle_hh",  { alp = 0 } );  
    ObjSet( "anm_attic_new_handle", { alp = 1 } ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_wood_low2", 0, "", 0 );
  
  ObjSet( "anm_attic_handle_hh",  { alp = 1 } );    
  ObjSet( "anm_attic_new_handle", { alp = 0 } );  
  AnimPlay( "anm_attic_handle_hh", "hh", func_end );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************