-- name=rm_thirdfloorcorridor
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_thirdfloorcorridor";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_room_313_door", "room_hub" );
  ObjAttach( "zz_mirror",        "room_hub" );
  ObjAttach( "zz_wall",          "room_hub" );
  ObjAttach( "zz_heatingunit",   "room_hub" );

  private.Init_Subroom();
  private.InitAnimations();

  private.audioRmThirdfloorcorridor = false;

  ObjMultiSet({ 
    { "spr_room_313_door_box",                       { event_mdown = private.get_box                         }},
    { "spr_mirror_corkscrew",                        { event_mdown = private.get_corkscrew                   }},
    { "spr_mirror_boxkey",                           { event_mdown = private.get_boxkey                      }},
    { "spr_mirror_oldalbum",                         { event_mdown = private.get_oldalbum                    }},
    { "spr_wall_screen",                             { event_mdown = private.get_screen                      }},
    { "spr_wall_ornamental_chandelier",              { event_mdown = private.get_ornamental_chandelier       }},
    { "spr_wall_carvedhandle",                       { event_mdown = private.get_carvedhandle                }},
    { "spr_heatingunit_ladleofboilingwater",         { event_mdown = private.get_ladleofboilingwater         }},
    { "obj_heatingunit_use_valve",                   { event_mdown = private.AnimUseValve                    }},
    --{ "spr_wall_metalbeams",                         { event_mdown = private.get_metalbeams                  }},
    
    { "spr_mirror_card",                             { event_mdown = function() cmn.NoteScale( "spr_mirror_card" ) end; }},
    { "spr_mirror_card_big",                         { event_mdown = function() cmn.NoteScale( "spr_mirror_card" ) end; }},

    { "obj_heatingunit_clk_valve",                   { event_mdown = private.clk_valve                       }},
    { "obj_mirror_clk_mirror_door",                  { event_mdown = private.clk_mirror_door                 }},
    { "obj_room_313_door_clk_room_313_key",          { event_mdown = private.clk_room_313_key                }},

    { "obj_room_313_door_see_room_313_door",         { event_mdown = private.see_room_313_door               }},
    { "obj_room_313_door_see_room_313_door_spiders", { event_mdown = private.see_room_313_door_spiders       }},
    { "obj_thirdfloorcorridor_see_gargoyle",         { event_mdown = private.see_thirdfloorcorridor_gargoyle }},
    { "obj_thirdfloorcorridor_see_ghost",            { event_mdown = private.see_thirdfloorcorridor_ghost    }},
    
    { "obj_mirror_use_cork",                         { event_mdown = private.AnimUseCork                     }},
    { "obj_mirror_use_magnet",                       { event_mdown = private.AnimUseMagnet                   }},
    { "obj_wall_use_bracedrill",                     { event_mdown = private.AnimUseBracedrill               }},
    { "obj_wall_use_phoenixfigurine",                { event_mdown = private.AnimUsePhoenixfigurine          }},
    { "obj_wall_use_phoenixfigurine1",               { event_mdown = private.AnimUsePhoenixfigurine          }},
    { "obj_wall_use_pallet",                         { event_mdown = private.AnimUsePallet                   }},
    { "obj_wall_clk_drill",                          { event_mdown = private.clk_drill                       }},
    
    { "spr_thirdfloorcorridor_collect_morph_item",   { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_2" ); end } },
      
    { "spr_heatingunit_collect2_item_8",             { event_mdown = private.get_collect2_item_8   } }, 
  });

  --------------------------------------------------------------------------------------------------------------------
  --- MiniHO zz_wall -------------------------------------------------------------------------------------------------
  private.mini_ho_array = { 
    "spr_wall_beam_1", 
    "spr_wall_beam_2", 
    "spr_wall_beam_3",
    "spr_wall_beam_4",
    "spr_wall_beam_5" 
  };

  for i = 1, 5, 1 do 
    ObjSet( "spr_wall_beam_"..i, { 
      event_mdown = function() 
                      int_button_mini_ho.MiniHoTaskFind( "get_metalbeams", "wall", "spr_wall_beam_"..i, 5 ); 
                    end; 
    } );
  end;
  --------------------------------------------------------------------------------------------------------------------
  --- MMG zz_wall ----------------------------------------------------------------------------------------------------
  private.angTube = { 0, -1.58, -3.14, -4.71, -6.28 };
  private.WinPositions =  { 9, 9, 4, 2, 1,
                            1, 9, 1, 9, 1,
                            3, 2, 2, 9, 1,
                            9, 9, 9, 9, 9 };
  private.FirstPositions = { 0, 2, 3, 1, 2,
                             1, 4, 2, 2, 2,
                             4, 1, 4, 1, 2,
                             1, 4, 1, 2, 0 };
  private.Type = { 0, 2, 2, 1, 2,
                   1, 2, 1, 1, 1,
                   2, 1, 2, 1, 1,
                   1, 2, 1, 2, 0 };

  private.rightWay = { 6, 11, 12, 13, 8, 3, 4, 5, 10, 15 };

  for i = 2,19 do 
    ObjSet( "spr_wall_back_mmg1_"..i, { event_mdown = function () private.Rotate( i ); end; 
                                        event_menter = common_impl.SetCursor( CURSOR_HAND );
                                        event_mleave = common_impl.SetCursor( CURSOR_DEFAULT );
                                      });
  end;
  --------------------------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_thirdfloorcorridor = function ()
  
    table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gzz_thirdfloorcorridor_room_313_door",
      "gzz_thirdfloorcorridor_heatingunit",
      "gzz_thirdfloorcorridor_mirror",
      "gzz_thirdfloorcorridor_wall",
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_room_313_door",
      "zz_mirror",
      "zz_wall",
      "zz_heatingunit",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_thirdfloorcorridor", update_game_mode_thirdfloorcorridor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_thirdfloorcorridor = function ()

    local effects_table = 
    {
      "obj_thirdfloorcorridor_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_thirdfloorcorridor", update_performance_mode_thirdfloorcorridor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_thirdfloorcorridor () end;
  --------------------------------------------------------------------------------------------
  local opn_thirdfloorcorridor_map = function ()

    common_impl.VisitMapRoom( "thirdfloorcorridor" );

  end;
  cmn.AddSubscriber( "opn_thirdfloorcorridor", opn_thirdfloorcorridor_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_box () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_box" ] = {
    type = "get",
    get_obj = "spr_room_313_door_box",
    room = private.room_objname,
    zz = "zz_room_313_door",
    zz_gate = "gzz_thirdfloorcorridor_room_313_door"
  };
  
  local get_box_inv = function ()
  
    interface.InventoryItemAdd( "inv_box", "spr_room_313_door_box" );
    ObjSet( "inv_box", { drag = false } );
  
  end;
  
  local get_box_closezz = function ()
  
    ObjDelete( "gfx_room_313_door_box" );
  
  end;
  
  cmn.AddSubscriber( "get_box", get_box_inv );
  cmn.AddSubscriber( "get_box", get_box_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_corkscrew () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_corkscrew" ] = {
    type = "get",
    get_obj = "spr_mirror_corkscrew",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_thirdfloorcorridor_mirror"
  };
  
  local get_corkscrew_inv = function ()
  
    interface.InventoryItemAdd( "inv_corkscrew", "spr_mirror_corkscrew" );
  
  end;
  
  local get_corkscrew_closezz = function ()
  
    ObjDelete( "gfx_mirror_corkscrew" );
  
  end;
  
  cmn.AddSubscriber( "get_corkscrew", get_corkscrew_inv );
  cmn.AddSubscriber( "get_corkscrew", get_corkscrew_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boxkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boxkey" ] = {
    type = "get",
    get_obj = "spr_mirror_boxkey",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_thirdfloorcorridor_mirror"
  };
  
  local get_boxkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_boxkey", "spr_mirror_boxkey" );
    cmn.SetInvPlusRGB( "box", true );
  
  end;
  
  local get_boxkey_closezz = function ()
  
    ObjDelete( "gfx_mirror_boxkey"     );
    ObjDelete( "spr_mirror_key_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_boxkey", get_boxkey_inv );
  cmn.AddSubscriber( "get_boxkey", get_boxkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oldalbum () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oldalbum" ] = {
    type = "get",
    get_obj = "spr_mirror_oldalbum",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_thirdfloorcorridor_mirror"
  };
  
  local get_oldalbum_inv = function ()
  
    interface.InventoryItemAdd( "inv_oldalbum", "spr_mirror_oldalbum" );
    ObjSet( "inv_oldalbum", { drag = false } );
  
  end;
  
  local get_oldalbum_closezz = function ()
  
    ObjSet( "spr_mirror_card", { input = true } );
    ObjSet( "spr_thirdfloorcorridor_photo", { alp = 1 } );
    ObjDelete( "gfx_mirror_oldalbum"    );
    ObjDelete( "spr_mirror_book_shadow" );
    ObjDelete( "spr_thirdfloorcorridor_book" );
  
  end;
  
  cmn.AddSubscriber( "get_oldalbum", get_oldalbum_inv );
  cmn.AddSubscriber( "get_oldalbum", get_oldalbum_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screen" ] = {
    type = "get",
    get_obj = "spr_wall_screen",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_thirdfloorcorridor_wall"
  };
  
  local get_screen_inv = function ()
  
    interface.InventoryItemAdd( "inv_screen", "spr_wall_screen" );
  
  end;
  
  local get_screen_closezz = function ()
  
    ObjDelete( "gfx_wall_screen" );
    ObjDelete( "spr_thirdfloorcorridor_flap_patch" );
    
    ObjMultiSet( { 
      { "obj_wall_use_bracedrill",  {  input = true, active = true, visible = true } },
      { "obj_wall_clk_drill",  { 
        inputrect_x = -423,
        inputrect_y = -445,
        inputrect_w = 497,
        inputrect_h = 494
      } },
    } );
  
  end;
  
  cmn.AddSubscriber( "get_screen", get_screen_inv );
  cmn.AddSubscriber( "get_screen", get_screen_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ornamental_chandelier () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ornamental_chandelier" ] = {
    type = "get",
    get_obj = "spr_wall_ornamental_chandelier",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_thirdfloorcorridor_wall"
  };
  
  local get_ornamental_chandelier_inv = function ()
  
    interface.InventoryItemAdd( "inv_ornamental_chandelier", "spr_wall_ornamental_chandelier" );
  
  end;
  
  local get_ornamental_chandelier_closezz = function ()
  
    ObjDelete( "gfx_wall_ornamental_chandelier" );
  
  end;
  
  cmn.AddSubscriber( "get_ornamental_chandelier", get_ornamental_chandelier_inv );
  cmn.AddSubscriber( "get_ornamental_chandelier", get_ornamental_chandelier_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_metalbeams () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_metalbeams" ] = {
    type = "get",
    get_obj = "spr_wall_win",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_thirdfloorcorridor_wall"
  };
  
  local get_metalbeams_inv = function ()
  
    interface.InventoryItemAdd( "inv_metalbeams", "spr_wall_win" );
    ObjSet( "inv_metalbeams", { drag = false } );
  
  end;
  
  local get_metalbeams_closezz = function ()
  
    ObjDelete( "gfx_wall_metalbeams" );

    ObjMultiSet( { 
      { "obj_wall_use_phoenixfigurine",   { input = true, active = true, visible = true } }
    } );

    for i = 1, #private.mini_ho_array, 1 do 
      ObjDelete( private.mini_ho_array[ i ] ); 
    end;
  
  end;
  
  cmn.AddSubscriber( "get_metalbeams", get_metalbeams_inv );
  cmn.AddSubscriber( "get_metalbeams", get_metalbeams_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_carvedhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_carvedhandle" ] = {
    type = "get",
    get_obj = "spr_wall_carvedhandle",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_thirdfloorcorridor_wall"
  };
  
  local get_carvedhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_carvedhandle", "spr_wall_carvedhandle" );
  
  end;
  
  local get_carvedhandle_closezz = function ()
  
    ObjDelete( "gfx_wall_carvedhandle" );
    ObjDelete( "gzz_thirdfloorcorridor_wall" );
  
  end;
  
  cmn.AddSubscriber( "get_carvedhandle", get_carvedhandle_inv );
  cmn.AddSubscriber( "get_carvedhandle", get_carvedhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ladleofboilingwater () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ladleofboilingwater" ] = {
    type = "get",
    get_obj = "spr_heatingunit_ladleofboilingwater",
    room = private.room_objname,
    zz = "zz_heatingunit",
    zz_gate = "gzz_thirdfloorcorridor_heatingunit"
  };
  
  local get_ladleofboilingwater_inv = function ()
  
    interface.InventoryItemAdd( "inv_ladleofboilingwater", "spr_heatingunit_ladleofboilingwater" );
  
  end;
  
  local get_ladleofboilingwater_closezz = function ()
  
    ObjDelete( "gfx_heatingunit_ladleofboilingwater" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_8" ) ) then
      
      ObjDelete( "gzz_thirdfloorcorridor_heatingunit" );
      
    end; 
  
  end;
  
  cmn.AddSubscriber( "get_ladleofboilingwater", get_ladleofboilingwater_inv );
  cmn.AddSubscriber( "get_ladleofboilingwater", get_ladleofboilingwater_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_room_313_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_room_313_key" ] = {
    type = "use",
    inv_obj = "inv_room_313_key",
    use_place = "obj_room_313_door_use_room_313_key",
    room = private.room_objname,
    zz = "zz_room_313_door",
    zz_gate = "gzz_thirdfloorcorridor_room_313_door"
  };
  local use_room_313_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_room_313_key" );
  
  end;
  local use_room_313_key_beg = function ()
  
    ObjDelete( "obj_room_313_door_use_room_313_key" );
  
  end;
  local use_room_313_key_end = function ()
  
    ObjMultiSet( { 
      { "obj_room_313_door_clk_room_313_key",{ input = true, active = true, visible = true } },
      { "spr_room_313_key_2",                {   alp = 1                                   } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_room_313_key", use_room_313_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_room_313_key", use_room_313_key_inv );
  cmn.AddSubscriber( "use_room_313_key", use_room_313_key_end, private.room_objname );
  cmn.AddSubscriber( "use_room_313_key_inv", use_room_313_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_room_313_key_beg", use_room_313_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_room_313_key_end", use_room_313_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet_2" ] = {
    type = "use",
    inv_obj = "inv_magnet",
    use_place = "obj_mirror_use_magnet",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_thirdfloorcorridor_mirror"
  };
  local use_magnet_2_inv = function ()
  
    if ( cmn.IsEventDone( "use_magnet_1" ) ) then
      
      interface.InventoryItemRemove( "inv_magnet" );

    end;
  
  end;
  local use_magnet_2_beg = function ()
  
    ObjDelete( "obj_mirror_use_magnet" );
  
  end;
  local use_magnet_2_end = function ()
    
    ObjDelete( "anm_mirror_key" );
    ObjMultiSet( { 
      { "spr_mirror_boxkey",    {  input = true } },
      { "anm_mirror_key_after", {    alp = 1    } },
      { "gfx_mirror_boxkey",    { active = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet_2", use_magnet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2", use_magnet_2_inv );
  cmn.AddSubscriber( "use_magnet_2", use_magnet_2_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2_inv", use_magnet_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2_beg", use_magnet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2_end", use_magnet_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cork" ] = {
    type = "use",
    inv_obj = "inv_cork",
    use_place = "obj_mirror_use_cork",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_thirdfloorcorridor_mirror"
  };
  local use_cork_inv = function ()
  
    interface.InventoryItemRemove( "inv_cork" );
  
  end;
  local use_cork_beg = function ()
  
    ObjDelete( "obj_mirror_use_cork" );
    ObjDelete( "anm_mirror_open_leftdoor_hh" );
  
  end;
  local use_cork_end = function ()
  
    ObjMultiSet( { 
      { "obj_mirror_use_magnet",    { active = true, visible = true, input = true } },
      { "obj_mirror_use_matches",   { active = true, visible = true, input = true } },
      { "anm_mirror_open_leftdoor", {  frame = 300, alp = 1                       } },
    } );

    ObjDelete( "spr_mirror_close_left_door" );
    ObjDelete( "spr_thirdfloorcorridor_leftdoor_closed" );
    ObjDelete( "anm_mirror_bung" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cork", use_cork_beg, private.room_objname );
  cmn.AddSubscriber( "use_cork", use_cork_inv );
  cmn.AddSubscriber( "use_cork", use_cork_end, private.room_objname );
  cmn.AddSubscriber( "use_cork_inv", use_cork_inv, private.room_objname );
  cmn.AddSubscriber( "use_cork_beg", use_cork_beg, private.room_objname );
  cmn.AddSubscriber( "use_cork_end", use_cork_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_matches () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_matches" ] = {
    type = "use",
    inv_obj = "inv_matches",
    use_place = "obj_mirror_use_matches",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_thirdfloorcorridor_mirror"
  };
  local use_matches_inv = function ()
  
    interface.InventoryItemRemove( "inv_matches" );
  
  end;
  local use_matches_beg = function ()
  
    ObjDelete( "obj_mirror_use_matches" );
    ObjSet( "anm_mirror_cockroaches_run", { active = true, visible = true } );
  
  end;
  local use_matches_end = function ()
  
    ObjMultiSet( { 
      { "spr_mirror_oldalbum",                  {           input = true } },
      { "gfx_mirror_oldalbum",                  {          active = true } },
      { "spr_mirror_light_candle",              { alp = 1,  input = true } },
    } );
    
    ObjDelete( "anm_mirror_cockroaches_spray" );
    ObjDelete( "anm_mirror_cockroaches_static" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_matches", use_matches_beg, private.room_objname );
  cmn.AddSubscriber( "use_matches", use_matches_inv );
  cmn.AddSubscriber( "use_matches", use_matches_end, private.room_objname );
  cmn.AddSubscriber( "use_matches_inv", use_matches_inv, private.room_objname );
  cmn.AddSubscriber( "use_matches_beg", use_matches_beg, private.room_objname );
  cmn.AddSubscriber( "use_matches_end", use_matches_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pallet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pallet" ] = {
    type = "use",
    inv_obj = "inv_pallet",
    use_place = "obj_wall_use_pallet",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_thirdfloorcorridor_wall"
  };
  local use_pallet_inv = function ()
  
    interface.InventoryItemRemove( "inv_pallet" );
  
  end;
  local use_pallet_beg = function ()
  
    ObjDelete( "obj_wall_use_pallet" );
  
  end;
  local use_pallet_end = function ()
  
    ObjMultiSet( { 
      { "spr_wall_screen",                  {  input = true } },
      { "gfx_wall_screen",                  { active = true } },
      { "spr_thirdfloorcorridor_zz_wall_2", {    alp = 1    } },
    } );
    ObjDelete( "obj_wall_plaster"                 );
    ObjDelete( "spr_thirdfloorcorridor_zz_wall_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pallet", use_pallet_beg, private.room_objname );
  cmn.AddSubscriber( "use_pallet", use_pallet_inv );
  cmn.AddSubscriber( "use_pallet", use_pallet_end, private.room_objname );
  cmn.AddSubscriber( "use_pallet_inv", use_pallet_inv, private.room_objname );
  cmn.AddSubscriber( "use_pallet_beg", use_pallet_beg, private.room_objname );
  cmn.AddSubscriber( "use_pallet_end", use_pallet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bracedrill () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bracedrill" ] = {
    type = "use",
    inv_obj = "inv_bracedrill",
    use_place = "obj_wall_use_bracedrill",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_thirdfloorcorridor_wall"
  };
  local use_bracedrill_inv = function ()
  
    interface.InventoryItemRemove( "inv_bracedrill" );
  
  end;
  local use_bracedrill_beg = function ()
  
    ObjDelete( "obj_wall_use_bracedrill" );
    ObjDelete( "spr_wall_plate" );
  
  end;
  local use_bracedrill_end = function ()
  
    ObjMultiSet( { 
      { "obj_wall_beam",                    {  input = true } },
      { "spr_wall_ornamental_chandelier",   {  input = true } },
      { "gfx_wall_ornamental_chandelier",   { active = true } },
      { "spr_thirdfloorcorridor_zz_wall_3", {    alp = 1    } },
    } );
    ObjDelete( "spr_thirdfloorcorridor_zz_wall_2" );
    ObjDelete( "vid_wall_drill"                   );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bracedrill", use_bracedrill_beg, private.room_objname );
  cmn.AddSubscriber( "use_bracedrill", use_bracedrill_inv );
  cmn.AddSubscriber( "use_bracedrill", use_bracedrill_end, private.room_objname );
  cmn.AddSubscriber( "use_bracedrill_inv", use_bracedrill_inv, private.room_objname );
  cmn.AddSubscriber( "use_bracedrill_beg", use_bracedrill_beg, private.room_objname );
  cmn.AddSubscriber( "use_bracedrill_end", use_bracedrill_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_phoenixfigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_phoenixfigurine" ] = {
    type = "use",
    inv_obj = "inv_phoenixfigurine",
    use_place = "obj_wall_use_phoenixfigurine",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_thirdfloorcorridor_wall"
  };
  local use_phoenixfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_phoenixfigurine" );
  
  end;
  local use_phoenixfigurine_beg = function ()
  
    ObjDelete( "obj_wall_use_phoenixfigurine" );
    ObjDelete( "anm_wall_panel_hh" );
  
  end;
  local use_phoenixfigurine_end = function ()

    ObjMultiSet( { 
      { "obj_wall_mmg",                     {   alp = 1, input = true } },
      { "anm_wall_panel_up",                { frame = 300             } },     
      { "spr_thirdfloorcorridor_zz_wall_4", {   alp = 1               } },
    } );
    ObjDelete( "spr_thirdfloorcorridor_zz_wall_3" );
    ObjDelete( "spr_wall_cache_1_closed"          );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_phoenixfigurine", use_phoenixfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_phoenixfigurine", use_phoenixfigurine_inv );
  cmn.AddSubscriber( "use_phoenixfigurine", use_phoenixfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_phoenixfigurine_inv", use_phoenixfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_phoenixfigurine_beg", use_phoenixfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_phoenixfigurine_end", use_phoenixfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_valve" ] = {
    type = "use",
    inv_obj = "inv_valve",
    use_place = "obj_heatingunit_use_valve",
    room = private.room_objname,
    zz = "zz_heatingunit",
    zz_gate = "gzz_thirdfloorcorridor_heatingunit"
  };
  local use_valve_inv = function ()
  
    interface.InventoryItemRemove( "inv_valve" );
  
  end;
  local use_valve_beg = function ()
  
    ObjDelete( "obj_heatingunit_use_valve" );
  
  end;
  local use_valve_end = function ()
  
    if ( cmn.IsEventDone( "use_ladle" ) ) then
      ObjMultiSet( { 
        { "obj_heatingunit_clk_valve",  { active = true, visible = true, input = true } },
      } );
    end;

    ObjMultiSet( { 
      { "spr_heatingunit_valve",        { alp = 1 } },
      { "spr_thirdfloorcorridor_valve", { alp = 1 } },
    } );
 
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_valve", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve", use_valve_inv );
  cmn.AddSubscriber( "use_valve", use_valve_end, private.room_objname );
  cmn.AddSubscriber( "use_valve_inv", use_valve_inv, private.room_objname );
  cmn.AddSubscriber( "use_valve_beg", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve_end", use_valve_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ladle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ladle" ] = {
    type = "use",
    inv_obj = "inv_ladle",
    use_place = "obj_heatingunit_use_ladle",
    room = private.room_objname,
    zz = "zz_heatingunit",
    zz_gate = "gzz_thirdfloorcorridor_heatingunit"
  };
  local use_ladle_inv = function ()
  
    interface.InventoryItemRemove( "inv_ladle" );
  
  end;
  local use_ladle_beg = function ()
  
    ObjDelete( "obj_heatingunit_use_ladle" );
  
  end;
  local use_ladle_end = function ()
  
    if ( cmn.IsEventDone( "use_valve" ) ) then
      ObjMultiSet( { 
        { "obj_heatingunit_clk_valve",  { active = true, visible = true, input = true } },
      } );
    end;

    ObjMultiSet( { 
      { "spr_heatingunit_ladleofboilingwater", { alp = 1 } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ladle", use_ladle_beg, private.room_objname );
  cmn.AddSubscriber( "use_ladle", use_ladle_inv );
  cmn.AddSubscriber( "use_ladle", use_ladle_end, private.room_objname );
  cmn.AddSubscriber( "use_ladle_inv", use_ladle_inv, private.room_objname );
  cmn.AddSubscriber( "use_ladle_beg", use_ladle_beg, private.room_objname );
  cmn.AddSubscriber( "use_ladle_end", use_ladle_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_valve () end;
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_valve" ] = {
      type = "click",
      use_place = "obj_heatingunit_clk_valve",
      room = private.room_objname,
      zz = "zz_heatingunit",
      zz_gate = "gzz_thirdfloorcorridor_heatingunit"
    };
    
    local clk_valve_beg = function ()

      ObjDelete( "obj_heatingunit_clk_valve" );
    
    end;
    local clk_valve_end = function ()

      ObjMultiSet( { 
        { "spr_heatingunit_ladleofboilingwater", { input = true } },
        { "gfx_heatingunit_ladleofboilingwater", { active = true } },
        { "vid_heatingunit_ladleofboilingwater_water", { active = true, visible = true, playing = true } },
      } );
      ObjDelete( "vid_heatingunit_water" )
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_valve",     clk_valve_beg );
    cmn.AddSubscriber( "clk_valve",     clk_valve_end );
    cmn.AddSubscriber( "clk_valve_beg", clk_valve_beg );
    cmn.AddSubscriber( "clk_valve_end", clk_valve_end ); 

  --------------------------------------------------------------------------------------------
  -- function clk_mirror_door () end; 
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_mirror_door" ] = {
      type = "click",
      use_place = "obj_mirror_clk_mirror_door",
      room = private.room_objname,
      zz = "zz_mirror",
      zz_gate = "gzz_thirdfloorcorridor_mirror"
    };
    
    local clk_mirror_door_beg = function ()

      ObjDelete( "obj_mirror_clk_mirror_door" );
    
    end;
    local clk_mirror_door_end = function ()

      ObjMultiSet( { 
        --{ "spr_mirror_open_right_door",        {    alp = 1    } },
        --{ "spr_mirror_open_right_door_shadow", {    alp = 1    } },
        { "spr_mirror_corkscrew",              {  input = true } },
        { "gfx_mirror_corkscrew",              { active = true } },
        { "anm_mirror_open_rightdoor",         {  frame = 300  } },
      } );
      ObjDelete( "spr_thirdfloorcorridor_rightdoor_closed" )
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_mirror_door",     clk_mirror_door_beg );
    cmn.AddSubscriber( "clk_mirror_door",     clk_mirror_door_end );
    cmn.AddSubscriber( "clk_mirror_door_beg", clk_mirror_door_beg );
    cmn.AddSubscriber( "clk_mirror_door_end", clk_mirror_door_end );

  --------------------------------------------------------------------------------------------
  -- function clk_room_313_key () end; 
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_room_313_key" ] = {
      type = "click",
      use_place = "obj_room_313_door_clk_room_313_key",
      room = private.room_objname,
      zz = "zz_room_313_door",
      zz_gate = "gzz_thirdfloorcorridor_room_313_door"
    };
    
    local clk_room_313_key_beg = function ()

      ObjDelete( "obj_room_313_door_clk_room_313_key" );
    
    end;
    local clk_room_313_key_end = function ()

      ObjDelete( "spr_thirdfloorcorridor_zz_room_313_door" );
      ObjDelete( "spr_room_313_door"                       );
      ObjDelete( "gzz_thirdfloorcorridor_room_313_door"    );
      ObjMultiSet( { 
        { "spr_room_313_open_door",                       {     alp = 1                  } },
        { "spr_thirdfloorcorridor_zz_room_313_door_open", {     alp = 1                  } },
        { "grm_thirdfloorcorridor_room_313",              { visible = true, input = true } },
      } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_thirdfloorcorridor_room_313_focus");
      end;
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_room_313_key",     clk_room_313_key_beg );
    cmn.AddSubscriber( "clk_room_313_key",     clk_room_313_key_end );
    cmn.AddSubscriber( "clk_room_313_key_beg", clk_room_313_key_beg );
    cmn.AddSubscriber( "clk_room_313_key_end", clk_room_313_key_end );

  --------------------------------------------------------------------------------------------
  -- function clk_drill () end; 
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_drill" ] = {
      type = "click",
      use_place = "obj_wall_clk_drill",
      room = private.room_objname,
      zz = "zz_wall",
      zz_gate = "gzz_thirdfloorcorridor_wall"
    };
    
    local clk_drill_beg = function ()

      ObjDelete( "obj_wall_clk_drill" );
    
    end;
    local clk_drill_end = function ()

      ObjDelete( "anm_wall_plate_drill" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_drill",     clk_drill_beg );
    cmn.AddSubscriber( "clk_drill",     clk_drill_end );
    cmn.AddSubscriber( "clk_drill_beg", clk_drill_beg );
    cmn.AddSubscriber( "clk_drill_end", clk_drill_end );

  --------------------------------------------------------------------------------------------
  -- function win_wall () end
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_wall" ] = {
    type = "win",    
    use_place = "obj_wall_mmg",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_thirdfloorcorridor_wall"
  };
  local win_wall = function ()

    if ( cmn.IsEventDone( "win_wall" ) ) then  

      ObjMultiSet( { 
        { "spr_wall_carvedhandle", {  input = true } },
        { "gfx_wall_carvedhandle", { active = true } },
        { "anm_wall_panel_down",   {  frame = 300  } },
      } );

      ObjDelete( "obj_wall_mmg" );

    else

      for i = 2,19 do
        ObjSet( "spr_wall_back_mmg1_"..i, { ang = private.angTube[ ng_global.progress["std"]["win_wall"].PlayerPositions[i] ] }); 
      end;

    end;

  end;

  cmn.AddSubscriber( "win_wall", win_wall, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_room_313_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_room_313_door" ] = {
    type = "click",
    use_place = "obj_room_313_door_see_room_313_door",
    room = private.room_objname,
    zz = "zz_room_313_door",
    zz_gate = "gzz_thirdfloorcorridor_room_313_door"
  };
  
  local see_room_313_door = function ()
  
    ObjDelete( "obj_room_313_door_see_room_313_door" );
    ObjDelete( "anm_room_313_door_anm_313"           );

    ObjMultiSet( { 
      { "obj_room_313_door_use_room_313_key", { input = true, active = true, visible = true } },
      { "spr_room_313_door_box",              { input = true                                } },
      { "gfx_room_313_door_box",              {               active = true                 } },
    } );                

  end;
  
  cmn.AddSubscriber( "see_room_313_door", see_room_313_door,private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_room_313_door_spiders () end;
  --------------------------------------------------------------------------------------------
  local see_room_313_door_spiders = function ()
  
    ObjMultiSet( { 
      { "anm_room_313_door_spiders", { frame = 300 } },
    } );    
    ObjDelete( "obj_room_313_door_see_room_313_door_spiders" );
    
  end;
  
  cmn.AddSubscriber( "see_room_313_door_spiders", see_room_313_door_spiders,private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_thirdfloorcorridor_gargoyle () end;
  --------------------------------------------------------------------------------------------
  
  local see_thirdfloorcorridor_gargoyle = function ()
  
    ObjDelete( "anm_thirdfloorcorridor_gargoyle" );
    ObjDelete( "obj_thirdfloorcorridor_see_gargoyle" );
    ObjMultiSet( { 
      { "anm_thirdfloorcorridor_gargoyle_static", { alp = 1 } },
    } );                

  end;
  
  cmn.AddSubscriber( "see_thirdfloorcorridor_gargoyle", see_thirdfloorcorridor_gargoyle, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_thirdfloorcorridor_ghost () end;
  --------------------------------------------------------------------------------------------
  
  local see_thirdfloorcorridor_ghost = function ()
  
    ObjDelete( "anm_thirdfloorcorridor_ghost" );
    ObjDelete( "obj_thirdfloorcorridor_see_ghost" );               

  end;
  
  cmn.AddSubscriber( "see_thirdfloorcorridor_ghost", see_thirdfloorcorridor_ghost, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_thirdfloorcorridor_bobby () end;
  --------------------------------------------------------------------------------------------
  local see_thirdfloorcorridor_bobby = function ()
  
    ObjDelete( "anm_thirdfloorcorridor_bobby" );
    ObjSet( "spr_thirdfloorcorridor_zz_room_313_door", {     alp = 1    } );              
    
  end;

  cmn.AddSubscriber( "see_thirdfloorcorridor_bobby", see_thirdfloorcorridor_bobby,private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2 = function ()
  
    ObjDelete( "obj_thirdfloorcorridor_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_2", get_collect_morph_item_2, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_8 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_8 = function ()
  
    ObjDelete( "obj_heatingunit_collect2_item_8" ); 
  
    if ( cmn.IsEventDone( "get_ladleofboilingwater" ) ) then
      
      ObjDelete( "gzz_thirdfloorcorridor_heatingunit" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_8", get_collect2_item_8, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*******************************************************************************************************************
  --*** function zz_wall () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_wall" );  
    -------------------------------------------------
    function zz_wall.PreOpen ()

      if ( not cmn.IsEventDone( "get_metalbeams" ) and cmn.IsEventDone( "use_bracedrill" ) ) then 
        int_button_mini_ho.Show( "get_metalbeams", "wall", 5, "spr_wall_metalbeams_panel", private.mini_ho_array ); 
      end;

      if ( not cmn.IsEventDone( "win_wall" ) and cmn.IsEventDone( "use_phoenixfigurine" ) ) then 
        cmn.MiniGameShow( "wall" );
        common_impl.PassingMgStart( "wall" );
      end;

    end; 
    ------------------------------------------------- 
    function zz_wall.Open ()
      
      if ( not cmn.IsEventDone( "win_wall" ) and cmn.IsEventDone( "use_phoenixfigurine" ) ) then 
        private.Check();
      end;
      
    end;
    -------------------------------------------------
    function zz_wall.PreClose ()

      if ( not cmn.IsEventDone( "get_metalbeams" ) and cmn.IsEventDone( "use_bracedrill" ) ) then 
        int_button_mini_ho.Hide(); 
      end;

      if ( not cmn.IsEventDone( "win_wall" ) and cmn.IsEventDone( "use_phoenixfigurine" ) ) then 
        cmn.MiniGameHide( "wall" );
        common_impl.PassingMgStop( "wall" );
      end;

    end; 
    ------------------------------------------------- 
    function zz_wall.Close ()
    end;
    ------------------------------------------------- 
    function zz_wall.Skip ()

      private.RotateSkip ()

    end;
    ------------------------------------------------- 
    function zz_wall.Reset ()

      private.RotateReset ()

    end;
    
--*******************************************************************************************************************
  --*** function zz_mirror () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_mirror" );  
    -------------------------------------------------
    function zz_mirror.PreOpen ()
    end; 
    ------------------------------------------------- 
    function zz_mirror.Open ()
    end;
    -------------------------------------------------
    function zz_mirror.PreClose ()
    end; 
    ------------------------------------------------- 
    function zz_mirror.Close ()
      
      if cmn.IsEventDone( "get_oldalbum" ) then
      
        cmn.NoteScaleClose( { "spr_mirror_card" } );
        
      end;
      
    end;
    ------------------------------------------------- 

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_thirdfloorcorridor();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  if cmn.IsEventDone( "opn_thirdfloorcorridor" ) and not cmn.IsEventDone( "see_thirdfloorcorridor_bobby" ) then
    private.see_thirdfloorcorridor_bobby ();
  end;   

  common_impl.EnvPlay( { "level1/env/aud_thirdfloorcorridor_env" }, "", 0.5 );

  if cmn.IsEventDone( "see_thirdfloorcorridor_bobby" ) then
    private.StartAnimThirdfloorcorridor();
  end;   
  
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level1/env/aud_thirdfloorcorridor_env", 0.5 );
  private.StopAnimThirdfloorcorridor ();

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_room_313_key ()

  local item = "inv_room_313_key";

  if ( cmn.ApplyObj( item, "gzz_thirdfloorcorridor_room_313_door" ) and cmn.IsEventDone( "get_box" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_room_313_door" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_room_313_door_use_room_313_key" ) and cmn.IsEventDone( "get_box" ) ) then

    cmn.CallEventHandler( "use_room_313_key_inv" );
    cmn.CallEventHandler( "use_room_313_key_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_room_313_key" );
      cmn.CallEventHandler( "use_room_313_key_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_key_in313", 0, "", 0 );

    cmn.ItemFly( "spr_room_313_key_2", func_end, 3 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_magnet_2 ()

  local item = "inv_magnet";

  if ( cmn.ApplyObj( item, "gzz_thirdfloorcorridor_mirror" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mirror" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mirror_use_magnet" ) ) then

    cmn.CallEventHandler( "use_magnet_2_inv" );
    cmn.CallEventHandler( "use_magnet_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_magnet_2" );
      cmn.CallEventHandler( "use_magnet_2_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_magnet", 0, "", 0 );

    AnimPlay( "anm_mirror_key", "key_magnit", func_end );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cork ()

  local item = "inv_cork";

  if ( cmn.ApplyObj( item, "gzz_thirdfloorcorridor_mirror" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mirror" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mirror_use_cork" ) ) then

    cmn.CallEventHandler( "use_cork_inv" );
    cmn.CallEventHandler( "use_cork_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_cork" );
        cmn.CallEventHandler( "use_cork_end" );
      
      end;      
    
      ObjMultiSet( { 
        { "anm_mirror_bung",            { alp = 0 } },
        { "spr_mirror_close_left_door", { alp = 0 } },
        { "anm_mirror_open_leftdoor",   { alp = 1 } },
      } );
      AnimPlay( "anm_mirror_open_leftdoor", "open_leftdoor", func_end_2 );
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_cork", 0, "", 0 );
    
    ObjSet( "spr_mirror_close_left_door", { alp = 1 } );
    AnimPlay( "anm_mirror_bung", "bung", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_matches ()

  local item = "inv_matches";

  if ( cmn.ApplyObj( item, "gzz_thirdfloorcorridor_mirror" ) and cmn.IsEventDone( "get_boxkey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mirror" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mirror_use_matches" ) and cmn.IsEventDone( "get_boxkey" ) ) then

    cmn.CallEventHandler( "use_matches_inv" );
    cmn.CallEventHandler( "use_matches_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_matches" );
      cmn.CallEventHandler( "use_matches_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_spray", 0, "", 0 );

    ObjSet( "anm_mirror_cockroaches_spray", { alp = 1 } );
    AnimPlay( "anm_mirror_cockroaches_spray", "use_spray", func_end );
    ObjAnimate( "anm_mirror_cockroaches_static", "alp", 0, 0, "", { 0, 0, 1,   3.5, 0, 1,   3.8, 0, 0 } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pallet ()

  local item = "inv_pallet";

  if ( cmn.ApplyObj( item, "gzz_thirdfloorcorridor_wall" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wall_use_pallet" ) ) then

    cmn.CallEventHandler( "use_pallet_inv" );
    cmn.CallEventHandler( "use_pallet_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_pallet" );
      cmn.CallEventHandler( "use_pallet_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_putty_knife", 0, "", 0 );

    AnimPlay( "anm_wall_spatel", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bracedrill ()

  local item = "inv_bracedrill";

  if ( cmn.ApplyObj( item, "gzz_thirdfloorcorridor_wall" ) and cmn.IsEventDone( "get_screen" ) and cmn.IsEventDone( "clk_drill" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wall_use_bracedrill" ) and cmn.IsEventDone( "get_screen" ) and cmn.IsEventDone( "clk_drill" ) ) then

    cmn.CallEventHandler( "use_bracedrill_inv" );
    cmn.CallEventHandler( "use_bracedrill_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_bracedrill" );
      cmn.CallEventHandler( "use_bracedrill_end" );

      int_button_mini_ho.Show( "get_metalbeams", "wall", 5, "spr_wall_metalbeams_panel", private.mini_ho_array );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_drill", 0, "", 0 );

    ObjSet( "vid_wall_drill", { alp = 1 } );
    VidPlay( "vid_wall_drill", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_phoenixfigurine ()

  local item = "inv_phoenixfigurine";

  if ( cmn.ApplyObj( item, "gzz_thirdfloorcorridor_wall" ) and cmn.IsEventDone( "get_metalbeams" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wall_use_phoenixfigurine" ) and cmn.IsEventDone( "get_metalbeams" ) ) then

    cmn.CallEventHandler( "use_phoenixfigurine_inv" );
    cmn.CallEventHandler( "use_phoenixfigurine_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_phoenixfigurine" );
      cmn.CallEventHandler( "use_phoenixfigurine_end" );

      private.InitWallMMG();

      cmn.MiniGameShow( "wall" );
      common_impl.PassingMgStart( "wall" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_phoenixfigurine", 0, "", 0 );

    AnimPlay( "anm_wall_panel_up", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_valve ()

  local item = "inv_valve";

  if ( cmn.ApplyObj( item, "gzz_thirdfloorcorridor_heatingunit" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_heatingunit" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_heatingunit_use_valve" ) ) then

    cmn.CallEventHandler( "use_valve_inv" );
    cmn.CallEventHandler( "use_valve_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_valve" );
      cmn.CallEventHandler( "use_valve_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_valve", 0, "", 0 );

    cmn.ItemFly( "spr_heatingunit_valve", func_end, 0.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ladle ()

  local item = "inv_ladle";

  if ( cmn.ApplyObj( item, "gzz_thirdfloorcorridor_heatingunit" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_heatingunit" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_heatingunit_use_ladle" ) ) then

    cmn.CallEventHandler( "use_ladle_inv" );
    cmn.CallEventHandler( "use_ladle_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_ladle" );
      cmn.CallEventHandler( "use_ladle_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_ladle", 0, "", 0 );

    cmn.ItemFly( "spr_heatingunit_ladleofboilingwater", func_end, 1 );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_box ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_box" );
  cmn.CallEventHandler( "get_box" );

end;
--------------------------------------------------------------------------------------------
function private.get_corkscrew ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_corkscrew" );
  cmn.CallEventHandler( "get_corkscrew" );
  
  common_impl.TutorialShow( "tutorial_page_12" );

end;
--------------------------------------------------------------------------------------------
function private.get_boxkey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_boxkey" );
  cmn.CallEventHandler( "get_boxkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_oldalbum ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_oldalbum" );
  cmn.CallEventHandler( "get_oldalbum" );

end;
--------------------------------------------------------------------------------------------
function private.get_screen ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_screen" );
  cmn.CallEventHandler( "get_screen" );

end;
--------------------------------------------------------------------------------------------
function private.get_ornamental_chandelier ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ornamental_chandelier" );
  cmn.CallEventHandler( "get_ornamental_chandelier" );

end;
--------------------------------------------------------------------------------------------
function private.get_metalbeams ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_metalbeams" );
  cmn.CallEventHandler( "get_metalbeams" );

end;
--------------------------------------------------------------------------------------------
function private.get_carvedhandle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_carvedhandle" );
  cmn.CallEventHandler( "get_carvedhandle" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_ladleofboilingwater ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ladleofboilingwater" );
  cmn.CallEventHandler( "get_ladleofboilingwater" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_8" ) ) then
    
    common.CloseSubRoom();
    
  end; 

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_8 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_8" ); 

  end;

  common_impl.PlayEffectHO( "spr_heatingunit_collect2_item_8", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_8" );
  
  if ( cmn.IsEventDone( "get_ladleofboilingwater" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_valve ()
  
  cmn.CallEventHandler( "clk_valve_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_valve" );
    cmn.CallEventHandler( "clk_valve_end" ); 
    
    ObjSet( "spr_heatingunit_valve", { alp = 1 } );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_valve", 0, "", 0 );

  ObjMultiSet( {
  
    { "vid_heatingunit_water", { alp = 1 } },
    { "spr_heatingunit_valve", { alp = 0 } },
  
  } );
  VidPlay( "vid_heatingunit_water", func_end );

end; 
--------------------------------------------------------------------------------------------
function private.clk_mirror_door ()
  
  cmn.CallEventHandler( "clk_mirror_door_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_mirror_door" );
    cmn.CallEventHandler( "clk_mirror_door_end" ); 

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_wood_small_door", 0, "", 0 );

  --ObjAnimate( "spr_mirror_open_right_door",        "alp", 0, 0, func_end,{ 0.0, 0, 0,   0.3, 0, 1 } );
  --ObjAnimate( "spr_mirror_open_right_door_shadow", "alp", 0, 0, "",      { 0.0, 0, 0,   0.3, 0, 1 } );
  AnimPlay( "anm_mirror_open_rightdoor", "open_rightdoor", func_end );

end;
--------------------------------------------------------------------------------------------
function private.clk_room_313_key ()
  
  cmn.CallEventHandler( "clk_room_313_key_beg" );

  local func_end = function ()

    local func_end_2 = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_room_313_key" );
      cmn.CallEventHandler( "clk_room_313_key_end" ); 

      common.CloseSubRoom();

    end;

    ObjAnimate( "spr_room_313_open_door", "alp", 0, 0, func_end_2,{ 0.0, 0, 0,   0.3, 0, 1 } );
    ObjAnimate( "spr_room_313_door",      "alp", 0, 0, "",        { 0.0, 0, 1,   0.3, 0, 0 } );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_opn_wood_door", 0, "", 0 );

  ObjAnimate( "spr_room_313_key_3", "alp", 0, 0, func_end,{ 0.0, 0, 0,   0.3, 0, 1 } );
  ObjAnimate( "spr_room_313_key_2", "alp", 0, 0, "",      { 0.0, 0, 1,   0.3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_drill ()
  
  cmn.CallEventHandler( "clk_drill_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_drill" );
    cmn.CallEventHandler( "clk_drill_end" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_drop_chip", 0, "", 0 );

  AnimPlay( "anm_wall_plate_drill", "DoAnim", func_end );

end;

--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
function private.InitWallMMG()

  if not ( ng_global.progress[ "std" ][ "win_wall" ].state ) then
    
    ng_global.progress["std"]["win_wall"].PlayerPositions = { 0, 2, 3, 1, 2,
                                                              1, 4, 2, 2, 2,
                                                              4, 1, 4, 1, 2,
                                                              1, 4, 1, 2, 0 };
  end;

  private.Light();

end;

--------------------------------------------------------------------------------------------
function private.RotateSkip ()

  for i = 2,19 do
    if private.WinPositions[i]~=9 then
      ObjSet( "spr_wall_back_mmg1_"..i, { ang = private.angTube[ private.WinPositions[i] ] }); 
    end;
    ng_global.progress["std"]["win_wall"].PlayerPositions[i] = private.WinPositions[i];
  end;

  private.Light();
  
  local func_end = function ()
 
    private.Check();
      
  end;
  ObjAnimate("obj_wall_mmg","alp",0, 0, func_end, { 0.0,0,1, 0.5,0,1 } ) ;  
  
end;
--------------------------------------------------------------------------------------------
function private.RotateReset ()

  for i = 2,19 do
    ObjSet( "spr_wall_back_mmg1_"..i, { ang = private.angTube[ private.FirstPositions[i] ] }); 
    ng_global.progress["std"]["win_wall"].PlayerPositions[i] = private.FirstPositions[i];
  end;

  private.Light();

end;
--------------------------------------------------------------------------------------------
function private.Light ()

  local count = 0;

  for i = 1,#private.rightWay do

    if ( private.WinPositions[ private.rightWay[i] ] == ng_global.progress["std"]["win_wall"].PlayerPositions[ private.rightWay[i] ] ) then

      count = count + 1;

      if( ObjGet("spr_wall_back_mmg1_light_"..private.rightWay[i]).alp < 1 and count == i ) then
        ObjAnimate("spr_wall_back_mmg1_light_"..private.rightWay[i],"alp",0, 0, "", { 0.0,0,0, 0.3,0,1 } ) ;  
      end;

    else

      if( ObjGet("spr_wall_back_mmg1_light_"..private.rightWay[i]).alp > 0 ) then
        ObjAnimate("spr_wall_back_mmg1_light_"..private.rightWay[i],"alp",0, 0, "", { 0.0,0,1, 0.3,0,0 } ) ;  
      end;

      for j = i,#private.rightWay do

        if( ObjGet("spr_wall_back_mmg1_light_"..private.rightWay[j]).alp > 0 ) then
          ObjAnimate("spr_wall_back_mmg1_light_"..private.rightWay[j],"alp",0, 0, "", { 0.0,0,1, 0.3,0,0 } ) ;  
        end;

      end;

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.Rotate ( position )

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_plastic_button", 0, "", 0 );

  local type = private.Type[position];
  local rotate = ng_global.progress["std"]["win_wall"].PlayerPositions[position];

  local func_after = function ()

    if ( type == 1 ) then
  
          if ( rotate == 1 ) then ng_global.progress["std"]["win_wall"].PlayerPositions[position] = 2;
      elseif ( rotate == 2 ) then ng_global.progress["std"]["win_wall"].PlayerPositions[position] = 1;
      end;

    elseif ( type == 2 ) then

      if ( rotate == 4 ) then ng_global.progress["std"]["win_wall"].PlayerPositions[position] = 1;
                              ObjSet("spr_wall_back_mmg1_"..position, { ang = 0 } );
      else  
        ng_global.progress["std"]["win_wall"].PlayerPositions[position] = rotate + 1;
      end;

    end;

    cmn.Lock(false);
    private.Light();
    local func_end = function ()
   
      private.Check();
        
    end;
    ObjAnimate("spr_wall_back_mmg1_pipes","alp",0, 0, func_end, { 0.0,0,1, 0.8,0,1 } ) ;  

  end;

  local angNow = ObjGet( "spr_wall_back_mmg1_"..position ).ang;
  local angNew;

  if ( type == 1 ) then

        if ( rotate == 1 ) then angNew = private.angTube[2];
    elseif ( rotate == 2 ) then angNew = private.angTube[1];
    end;

  elseif ( type == 2 ) then
      angNew = private.angTube[rotate+1]
  end;

  cmn.Lock( true );

  ObjAnimate("spr_wall_back_mmg1_"..position,"ang",0,0,func_after, { 0.0,0,angNow,  0.3,0,angNew } ) ;

end;
--------------------------------------------------------------------------------------------
function private.Check ()
  
  if private.CheckWin() == true then 
    
    ObjAnimate("obj_wall_mmg","alp",0, 0, "", { 0.0,0,1, 0.2,0,1, 0.5,0,0  } ) ; 
    private.WinAnim()
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.CheckWin ()
  
  for i = 2,19 do
    if private.WinPositions[i]~=9 then 
      if ng_global.progress["std"]["win_wall"].PlayerPositions[i] == private.WinPositions[i] then
      else return false;
      end;
    end;
  end;
    
  return true;
  
end;
--------------------------------------------------------------------------------------------
function private.WinAnim ()

  local func_end = function ()
 
    cmn.MiniGameHide( "wall" );
    common_impl.PassingMgWin( "wall" );

    cmn.SetEventDone( "win_wall" );
    cmn.CallEventHandler( "win_wall" );

    common_impl.PlayAudio( "sfx", "aud_win_mmg" );
    cmn.Lock( false );
      
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_slide_stones4", 0, "", 0 );
  
  AnimPlay( "anm_wall_panel_down", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
end;
--------------------------------------------------------------------------------------------
function private.see_thirdfloorcorridor_bobby ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_thirdfloorcorridor_bobby" );
    cmn.CallEventHandler( "see_thirdfloorcorridor_bobby" );

    common_impl.ShowBbt( 'bbt_thirdfloorcorridor_see_thirdfloorcorridor_bobby' );
    private.StartAnimThirdfloorcorridor();
    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "find_man" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "voc", "level1/voc/aud_sc_3floor_voc", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_3floor",     0, "", 0 );

  common_impl.ShowBbt( 'sub_thirdfloorcorridor_bobby_help' );

  ObjSet( "anm_thirdfloorcorridor_bobby", { alp = 1 } );
  AnimPlay( "anm_thirdfloorcorridor_bobby", "DoAnim", func_end );
  
  ObjAnimate( "rm_thirdfloorcorridor", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.6, 3, 1.3, 1.3,    2.4, 3, 1.3, 1.3,    3.0, 3, 1, 1 } );
  ObjAnimate( "rm_thirdfloorcorridor", "pos_xy",0,0, "", { 0, 3, 0, 0,    0.6, 3, -313, -214,    2.4, 3, -313, -214,    3.0, 3, 0, 0 } );
  
end;
--------------------------------------------------------------------------------------------
function private.see_room_313_door ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_room_313_door" );
    cmn.CallEventHandler( "see_room_313_door" );

    common_impl.ShowBbt( 'bbt_thirdfloorcorridor_see_room_313_door' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_313_door", 0, "", 0 );

  ObjSet( "anm_room_313_door_anm_313", { alp = 1 } );
  AnimPlay( "anm_room_313_door_anm_313", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_room_313_door_spiders ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_room_313_door_spiders" );
    cmn.CallEventHandler( "see_room_313_door_spiders" );

    common_impl.ShowBbt( 'bbt_thirdfloorcorridor_see_room_313_door_spiders' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_drop_plate", 0, "", 0 );

  AnimPlay( "anm_room_313_door_spiders", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_thirdfloorcorridor_gargoyle ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_thirdfloorcorridor_gargoyle" );
    cmn.CallEventHandler( "see_thirdfloorcorridor_gargoyle" );

    common_impl.ShowBbt( 'bbt_thirdfloorcorridor_see_gargoyle' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_gorgulie", 0, "", 0 );

  AnimPlay( "anm_thirdfloorcorridor_gargoyle", "gargoyle_turns", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_thirdfloorcorridor_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_thirdfloorcorridor_ghost" );
    cmn.CallEventHandler( "see_thirdfloorcorridor_ghost" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_closed_door", 0, "", 0 );

  AnimPlay( "anm_thirdfloorcorridor_ghost", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_thirdfloorcorridor ()

  if not ( cmn.IsEventDone( "opn_thirdfloorcorridor" ) ) then

    cmn.SetEventDone( "opn_thirdfloorcorridor" );
    private.see_thirdfloorcorridor_bobby ();

  end;
  cmn.CallEventHandler( "opn_thirdfloorcorridor" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
end;
--------------------------------------------------------------------------------------------
function private.StartAnimThirdfloorcorridor ()

  AnimPlay( "anm_thirdfloorcorridor_people", "DoAnim", "" );

  if private.audioRmThirdfloorcorridor == false  then
    private.audioRmThirdfloorcorridor = true;
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_cry_men", 0, "", 0 );
  end;

end;
--------------------------------------------------------------------------------------------
function private.StopAnimThirdfloorcorridor ()

  AnimStop( "anm_thirdfloorcorridor_people" );
  common_impl.StopAudio( "sfx", "level1/sfx/aud_sc_cry_men", 0.5 );

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.AnimUseCork ()

  common_impl.ShowBbt( 'bbt_mirror_use_cork' );

  local func_end = function ()

    cmn.Lock( false );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_small_door", 0, "", 0 );
  
  AnimPlay( "anm_mirror_open_leftdoor_hh", "hh_leftdoor", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseMagnet ()

  common_impl.ShowBbt( 'bbt_mirror_use_magnet' );

  local func_end = function ()

    cmn.Lock( false );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal2_mid", 0, "", 0 );
  
  AnimPlay( "anm_mirror_key", "key_hh", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseBracedrill ()

  common_impl.ShowBbt( 'bbt_wall_use_bracedrill' );

  local func_end = function ()

    cmn.Lock( false );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_metal_low", 0, "", 0 );
  
  ObjAnimate( "spr_wall_plate", "pos_x", 0, 1, func_end, { 0, 0, 0,   0.2, 3, -2,   0.4, 3, 0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUsePhoenixfigurine ()

  local func_end = function ()

    cmn.Lock( false );
    
    common_impl.ShowBbt( 'bbt_wall_use_phoenixfigurine' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_stone_cover", 0, "", 0 );
  
  AnimPlay( "anm_wall_panel_hh", "panel_click", func_end )

end;
--------------------------------------------------------------------------------------------
function private.AnimUsePallet ()

  local func_end = function ()

    cmn.Lock( false );
    
    common_impl.ShowBbt( 'bbt_wall_use_pallet' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_plate", 0, "", 0 );
  
  ObjAnimate( "spr_wall_screen", "pos_x", 0, 1, func_end, { 0, 0, 0,   0.2, 3, 2,   0.4, 3, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseValve ()

  common_impl.ShowBbt( 'bbt_heatingunit_use_valve' );

  local func_end = function ()

    cmn.Lock( false );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_waterdrop", 0, "", 0 );
  
  AnimPlay( "anm_heatingunit_click", "click", func_end );

end;
--*********************************************************************************************************************