-- name=ho_baths
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "baths" );
  game.relations[ "ho_baths" ].exitroom = "rm_toilets";
  private.room_objname = "ho_baths";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  
    { "spr_baths_mirror", { event_mdown = function() private.TaskComplete( 'mirror' ) end } },
    { "spr_baths_gargoyle", { event_mdown = function() private.TaskComplete( 'gargoyle' ) end } },
    { "spr_baths_hairbrush", { event_mdown = function() private.TaskComplete( 'hairbrush' ) end } },
    { "spr_baths_hanger", { event_mdown = function() private.TaskComplete( 'hanger' ) end } },
    { "spr_baths_ladder", { event_mdown = function() private.TaskComplete( 'ladder' ) end } },
    { "spr_baths_laddle_1", { event_mdown = function() private.TaskComplete( 'laddle', 1 ) end } },
    { "spr_baths_laddle_2", { event_mdown = function() private.TaskComplete( 'laddle', 2 ) end } },
    { "spr_baths_laddle_3", { event_mdown = function() private.TaskComplete( 'laddle', 3 ) end } },
    { "spr_baths_lion", { event_mdown = function() private.TaskComplete( 'lion' ) end } },
    { "spr_baths_mop", { event_mdown = function() private.TaskComplete( 'mop' ) end } },
    { "spr_baths_ovenfork", { event_mdown = function() private.TaskComplete( 'ovenfork' ) end } },
    { "spr_baths_candle", { event_mdown = function() private.TaskComplete( 'candle' ) end } },
    { "spr_baths_towel_1", { event_mdown = function() private.TaskComplete( 'towel', 1 ) end } },
    { "spr_baths_towel_2", { event_mdown = function() private.TaskComplete( 'towel', 2 ) end } },
    { "spr_baths_towel_3", { event_mdown = function() private.TaskComplete( 'towel', 3 ) end } },
    { "spr_baths_bucket", { event_dragdrop = function() private.DropBucket() end } },
    { "spr_baths_loupe", { event_dragdrop = function() private.DropLoupe() end } },
  
  } );
  --------------------------------------------------------------------------------------------
  -- function win_baths () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_baths" ] = {
    type = "win",
    room = "rm_toilets",
    zz = "ho_baths",
    zz_gate = "gho_toilets_baths"
  };
  local win_baths_inv = function ()
  
    if ( cmn.IsEventDone( "win_baths" ) ) then
    
      interface.InventoryItemAdd( "inv_ovenfork", "spr_baths_win" );    
    
    end;
    
  end;
  local win_baths_loc = function ()
  
    if ( cmn.IsEventDone( "win_baths" ) ) then
    
      ObjDelete( "gho_toilets_baths" );   
    
    end;
    
  end;

  cmn.AddSubscriber( "win_baths", win_baths_inv );
  cmn.AddSubscriber( "win_baths", win_baths_loc, "rm_toilets" );
  --------------------------------------------------------------------------------------------------
  local start_baths_func = function ()

  if ( cmn.IsEventStart( "win_baths" ) ) then

    common_impl.ProcessHoStart( "baths" );

    if ( cmn.IsUnmarkedTask( "baths", "bucket" ) ) then
      cmn.CallEventHandler( "unmark_baths_bucket" );
    elseif ( cmn.IsUnmarkedTask( "baths", "candle" ) ) then
      cmn.CallEventHandler( "unmark_baths_candle" );
    end;

  end;

  end;
  cmn.AddSubscriber( "win_baths", start_baths_func, private.room_objname ); 
  --------------------------------------------------------------------------------------------------
  local unmark_bucket_func = function ()    

    ObjDelete( "obj_baths_use_bucket" );
    ObjSet( "spr_baths_bucket",
    {
      event_mdown = function() private.TaskComplete( 'bucket' ) end,
      drag = false
    } );
    ObjSet( "spr_baths_bucket_water", { alp = 1 } );
    
  end;
  cmn.AddSubscriber( "unmark_baths_bucket", unmark_bucket_func, "ho_baths" );  
   --------------------------------------------------------------------------------------------------
  local unmark_candle_func = function ()    

      ObjDelete( "spr_baths_loupe" );
      ObjDelete( "obj_baths_use_loupe" );
      ObjSet( "spr_baths_candle", { input = true } );
      ObjSet( "anm_baths_candle", { visible = true } );    

  end;
  cmn.AddSubscriber( "unmark_baths_candle", unmark_candle_func, "ho_baths" );   

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayMusEnvHO();

  if ( not cmn.IsEventDone( "opn_baths" ) ) then
  
    cmn.InitHo( "baths" );
    cmn.SetEventDone( "opn_baths" );
    cmn.SetMarkedTask( "baths", "bucket" );
    cmn.SetMarkedTask( "baths", "candle" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "mirror",        1, 0, { { "spr_baths_mirror" } } );
  interface.TaskPanelTaskAdd( ho_items, "gargoyle",      1, 0, { { "spr_baths_gargoyle" } } );
  interface.TaskPanelTaskAdd( ho_items, "hairbrush",     1, 0, { { "spr_baths_hairbrush" } } );
  interface.TaskPanelTaskAdd( ho_items, "hanger",        1, 0, { { "spr_baths_hanger" } } );
  interface.TaskPanelTaskAdd( ho_items, "ladder",        1, 0, { { "spr_baths_ladder" } } );
  interface.TaskPanelTaskAdd( ho_items, "laddle",        3, 0, { { "spr_baths_laddle_1" }, { "spr_baths_laddle_2" }, { "spr_baths_laddle_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "lion",          1, 0, { { "spr_baths_lion" } } );
  interface.TaskPanelTaskAdd( ho_items, "mop",           1, 0, { { "spr_baths_mop" } } );
  interface.TaskPanelTaskAdd( ho_items, "ovenfork",      1, 0, { { "spr_baths_ovenfork" } } );
  interface.TaskPanelTaskAdd( ho_items, "towel",         3, 0, { { "spr_baths_towel_1" }, { "spr_baths_towel_2" }, { "spr_baths_towel_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "candle",        1, 1, { { "spr_baths_loupe", "obj_baths_use_loupe" }, { "spr_baths_candle" } } );
  interface.TaskPanelTaskAdd( ho_items, "bucket",        1, 1, { { "spr_baths_bucket", "obj_baths_use_bucket" }, { "spr_baths_bucket" } } );
  
  interface.TaskPanelShow( ho_items );  

end;
--*********************************************************************************************************************
function public.PreClose ()
  
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()
  
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close ()
  
  cmn.PlayMusEnv();
  common_impl.PassingHoStop();
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin(); 
  
end;
--*********************************************************************************************************************
function private.TaskComplete ( task_name, part )
  
  local object = "spr_baths_"..task_name;
  if ( part ) then
    object = object.."_"..part;
  end;
  cmn.HoTaskFind( object, task_name );
  if ( task_name == "bucket" ) then
    ObjDelete( "spr_baths_bucket_shadow" );
  end;
  
end;
--*********************************************************************************************************************
function private.DropLoupe (  )
  
  if ( cmn.ApplyObj( "obj_baths_loupe_apply", "obj_baths_use_loupe" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "baths", "candle" );
      cmn.CallEventHandler( "unmark_baths_candle" );
      ObjDelete( "anm_baths_use_loupe" );
      
    end;
    
    cmn.Lock( true );
    ObjDelete( "spr_baths_loupe" );
    ObjSet( "anm_baths_use_loupe", { visible = true } );
    AnimPlay( "anm_baths_use_loupe", "loupe", func_end );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_candle", 0, "", 0 );
    
  else
    ObjSet( "spr_baths_loupe", { pos_z = 2 } );
    common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );
  end;
  
end;
--*********************************************************************************************************************
function private.DropBucket (  )
  
  if ( cmn.ApplyObj( "spr_baths_bucket", "obj_baths_use_bucket" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "baths", "bucket" );
      cmn.CallEventHandler( "unmark_baths_bucket" );
      ObjSet( "spr_baths_bucket", { alp = 1 } );
      ObjSet( "spr_baths_bucket_shadow", { alp = 1 } );
      ObjDelete( "anm_baths_use_bucket" );
      
      private.see_baths_ghost();

    end;
    
    cmn.Lock( true );
    ObjSet( "spr_baths_bucket", { alp = 0 } );
    ObjSet( "anm_baths_use_bucket", { visible = true } );
    AnimPlay( "anm_baths_use_bucket", "bucket", func_end );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_bucket", 0, "", 0 );
    
  else
    ObjSet( "spr_baths_bucket", { pos_z = 1 } );
    ObjSet( "spr_baths_bucket_shadow", { alp = 1 } );
    common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );
  end;
  
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.see_baths_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_baths_see_ghost' );
    
    ObjDelete( "anm_baths_ghost" );

  end;
    
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_water_ghost_sc", 0, "", 0 );

  ObjSet( "anm_baths_ghost", { alp = 1 } );
  AnimPlay( "anm_baths_ghost", "DoAnim", func_end );
  
end;
