-- name=ho_underbookcase
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "underbookcase" );
  game.relations[ "ho_underbookcase" ].exitroom = "rm_library";
  private.room_objname = "ho_underbookcase";
  --------------------------------------------------------------------------------------------------
  private.TASKPANEL_LEFT = -250;
  private.TASKPANEL_DIFF = 120;
  private.TASKPANEL_COUNT = 5;
  
  private.tasks = { 
                    "bottle", "bug", "crest", "fang", "glasses", "moon", 
                    "napkin", "pen", "ring", "picture", "star", "spiral", "tongs"
                  };

  ObjMultiSet( { 
    { "spr_underbookcase_bottle",        { event_mdown = function() private.TaskComplete( "bottle" ); end } },
    { "spr_underbookcase_bug",           { event_mdown = function() private.TaskComplete( "bug" );    end } },
    { "spr_underbookcase_crest",         { event_mdown = function() private.TaskComplete( "crest" );  end } },
    { "spr_underbookcase_fang",          { event_mdown = function() private.TaskComplete( "fang" );   end } },
    { "spr_underbookcase_glasses",       { event_mdown = function() private.TaskComplete( "glasses" );end } },
    { "spr_underbookcase_moon",          { event_mdown = function() private.TaskComplete( "moon" );   end } },
    { "spr_underbookcase_napkin",        { event_mdown = function() private.TaskComplete( "napkin" ); end } },
    { "spr_underbookcase_pen",           { event_mdown = function() private.TaskComplete( "pen" );    end } },
    { "spr_underbookcase_picture",       { event_mdown = function() private.TaskComplete( "picture" );end } },
    { "spr_underbookcase_ring",          { event_mdown = function() private.TaskComplete( "ring" );   end } },
    { "spr_underbookcase_star",          { event_mdown = function() private.TaskComplete( "star" );   end } },
    { "spr_underbookcase_spiral",        { event_mdown = function() private.TaskComplete( "spiral" ); end } },
    { "spr_underbookcase_tongs",         { event_mdown = function() private.TaskComplete( "tongs" );  end } },    
    
  } );
  
  for i = 1, #private.tasks do

    local itemInput = false;
    
    if ( i <= private.TASKPANEL_COUNT ) then 
      
      itemInput = true;
      
    end;
    
    local curItem = "spr_underbookcase_"..private.tasks[ i ];
    local curPanelItem = "spr_underbookcase_taskpanel_"..private.tasks[ i ];
    
    ObjMultiSet( { 
      { curItem,  { input = itemInput } },
      { curPanelItem,  { pos_x = private.TASKPANEL_LEFT + ( i - 1 ) * private.TASKPANEL_DIFF } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  -- function win_underbookcase () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_underbookcase" ] = {
    type = "win",
    room = "rm_library",
    zz = "ho_underbookcase",
    zz_gate = "gho_library_underbookcase"
  };
  local win_underbookcase_inv = function ()
  
    if ( cmn.IsEventDone( "win_underbookcase" ) ) then
    
      interface.InventoryItemAdd( "inv_boathook", "spr_underbookcase_win" ); 
      ObjMultiSet( { 
        { "grm_underbookcase_library",  { event_mdown = function() cmn.GotoRoom( "rm_library" ); end  } },
      } );  
      common_impl.LockMapRoom( "winecellar", false );
      common_impl.LockMapRoom( "eventshall", false );
      common_impl.LockMapRoom( "toilets", false );
      common_impl.LockMapRoom( "library", false );
        
    end;
    
  end;
  local win_underbookcase_loc = function ()
  
    if ( cmn.IsEventDone( "win_underbookcase" ) ) then
    
      ObjDelete( "anm_library_scary_cycle" ); 
      ObjDelete( "anm_library_light" ); 
      ObjDelete( "gho_library_underbookcase" ); 
      ObjDelete( "anm_library_chandelier_scary" ); 
      ObjMultiSet( { 
        { "gzz_library_wallstash",        { visible = true, input = true } },
        { "gzz_library_clarksstuff",      { visible = true, input = true } },
        { "gzz_library_readingdesk",      { visible = true, input = true } },
        { "anm_library_chandelier",       {     alp = 1                  } },
      } );  
    
    end;
    
  end;

  cmn.AddSubscriber( "win_underbookcase", win_underbookcase_inv );
  cmn.AddSubscriber( "win_underbookcase", win_underbookcase_loc, "rm_library" );
  --------------------------------------------------------------------------------------------------
  local start_underbookcase_func = function ()

  if ( cmn.IsEventStart( "win_underbookcase" ) ) then

      common_impl.ProcessHoStart( "underbookcase" );
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_underbookcase" ].found;

      for i = 1, #ho_found, 1 do
        
        ObjDelete( ho_found[ i ][ "object" ] );
        
        for k = 1, #private.tasks do
          
          if ( ho_found[ i ].task == private.tasks[ k ] ) then
            
            ObjDelete( "spr_underbookcase_taskpanel_"..private.tasks[ k ] );
            
            for j = k, #private.tasks do
              
              if ( ObjGet( "spr_underbookcase_taskpanel_"..private.tasks[ j ] ) ) then
         
                ObjSet( "spr_underbookcase_taskpanel_"..private.tasks[ j ], { pos_x = ObjGet( "spr_underbookcase_taskpanel_"..private.tasks[ j ] ).pos_x - private.TASKPANEL_DIFF } ); 
                
                if ( ObjGet( "spr_underbookcase_taskpanel_"..private.tasks[ j ] ).pos_x < private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF ) then
                  
                  ObjSet( "spr_underbookcase_"..private.tasks[ j ], { input = true } );
                  
                end;
              
              end;
              
            end;
          
          end;
          
        end;
      
      end;
      
    

  end;

  end;
  cmn.AddSubscriber( "win_underbookcase", start_underbookcase_func, private.room_objname );  

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayMusEnvHO();

  if ( not cmn.IsEventDone( "opn_underbookcase" ) ) then
  
    cmn.InitHo( "underbookcase" );
    cmn.SetEventDone( "opn_underbookcase" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bottle",     1, 0, { { "spr_underbookcase_bottle" } } );
  interface.TaskPanelTaskAdd( ho_items, "bug",        1, 0, { { "spr_underbookcase_bug" } } );
  interface.TaskPanelTaskAdd( ho_items, "crest",      1, 0, { { "spr_underbookcase_crest" } } );
  interface.TaskPanelTaskAdd( ho_items, "fang",       1, 0, { { "spr_underbookcase_fang" } } );
  interface.TaskPanelTaskAdd( ho_items, "glasses",    1, 0, { { "spr_underbookcase_glasses" } } );
  interface.TaskPanelTaskAdd( ho_items, "moon",       1, 0, { { "spr_underbookcase_moon" } } );
  interface.TaskPanelTaskAdd( ho_items, "napkin",     1, 0, { { "spr_underbookcase_napkin" } } );
  interface.TaskPanelTaskAdd( ho_items, "pen",        1, 0, { { "spr_underbookcase_pen" } } );
  interface.TaskPanelTaskAdd( ho_items, "picture",    1, 0, { { "spr_underbookcase_picture" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring",       1, 0, { { "spr_underbookcase_ring" } } );
  interface.TaskPanelTaskAdd( ho_items, "star",       1, 0, { { "spr_underbookcase_star" } } );
  interface.TaskPanelTaskAdd( ho_items, "spiral",     1, 0, { { "spr_underbookcase_spiral" } } );
  interface.TaskPanelTaskAdd( ho_items, "tongs",     1, 0, { { "spr_underbookcase_tongs" } } );

  interface.TaskPanelShow( ho_items );
  
  ObjAttach( "obj_underbookcase_taskpanel", "spr_int_taskpanel" );
  ObjSet( "obj_int_taskpanel", { visible = false } );
  ObjSet( "txt_int_taskpanel", { visible = false } );
  
  common_impl.LockMapRoom( "winecellar", true );
  common_impl.LockMapRoom( "eventshall", true );
  common_impl.LockMapRoom( "toilets", true );
  common_impl.LockMapRoom( "library", true );
  
  ObjMultiSet( { 
    { "grm_underbookcase_library",  { event_mdown = function() common_impl.ShowBbt( 'bbt_underbookcase_ghost' ); end  } },
  } );  
        
end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  if ( not private.opn_underbookcase ) then
    private.AnmHorror();
    private.opn_underbookcase = true;
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { visible = true } );
  ObjSet( "txt_int_taskpanel", { visible = true } );

  ObjAttach( "obj_underbookcase_taskpanel", "ho_underbookcase" );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();
  ObjDelete( "obj_underbookcase_gates" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete ( task_name, part )
  
  cmn.HoTaskFind( "spr_underbookcase_"..task_name, task_name );

  local func_move = function () 
    
    private.TaskPanelUpdate( task_name ); 
    
  end;

  ObjAnimate( "spr_underbookcase_taskpanel_"..task_name, "alp", 0, 0, func_move,
  { 
    0.0, 0, 1.0,
    0.4, 0, 1.0,
    0.6, 0, 0.0
  } );
  
end;
--*********************************************************************************************************************
function private.TaskPanelUpdate ( task_name )

  ObjDelete( "spr_underbookcase_taskpanel_"..task_name );
  
  local index = private.FindIndex( private.tasks, task_name ); 
  
  for j = index, #private.tasks do

    local params = ObjGet( "spr_underbookcase_taskpanel_"..private.tasks[ j ] );
    
    if ( params ) then
      
      local func_end = "";

      if ( not ObjGet( "spr_underbookcase_"..private.tasks[ j ] ).input ) then

        func_end = function()
          
          local limitX = private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF;
          
          if ( ObjGet( "spr_underbookcase_taskpanel_"..private.tasks[ j ] ) and 
          ( ObjGet( "spr_underbookcase_taskpanel_"..private.tasks[ j ] ).pos_x < limitX ) and 
          ( ObjGet( "spr_underbookcase_"..private.tasks[ j ] ).alp == 1 ) ) then
            
            ObjSet( "spr_underbookcase_"..private.tasks[ j ], { input = true } );
            
          end;

        end;
    
      end;  

      if ( not private.IsFound( private.tasks[ j ] ) ) then
        
        ObjAnimate( "spr_underbookcase_taskpanel_"..private.tasks[ j ], "pos_x", 0, 0, func_end, 
        { 
          0.0, 3, params.pos_x, 
          0.4, 3, params.pos_x - private.TASKPANEL_DIFF
        } );
        
      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.FindIndex ( arr, elem ) 

  for i = 1, #arr do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
function private.IsFound ( task ) 

  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_underbookcase" ].found;
  
  for i = 1, #progress do
    
    if ( progress[ i ].task == task ) then

      return true;

    end;
    
  end;
  
  return false;  

end;
--*********************************************************************************************************************
function private.AnmHorror (  ) 
  
  local anim_morph_1 = {
                          { anim = "glasses", func = "small_objects" },
                          { anim = "sun", func = "small_objects" },
                          { anim = "napkin", func = "large_objects" },
                          { anim = "leaf", func = "small_objects" },
                          { anim = "picture", func = "big_objects" },
                          { anim = "triangle", func = "big_objects" },
                          { anim = "bottle", func = "large_objects" },
                          { anim = "spiral", func = "big_objects" },
                          { anim = "coin", func = "small_objects" },
                          { anim = "crest", func = "big_objects" },
                          { anim = "keys", func = "small_objects" },
                          { anim = "pen", func = "pen" } 
                        }; 
  
  ObjSet( "anm_underbookcase_horror", { frame = 0 } );
  ObjSet( "anm_underbookcase_eyes_burns", { frame = 0 } );
  AnimPlay( "anm_underbookcase_horror", "behind_all", private.AnmHorrorEnd );
  AnimPlay( "anm_underbookcase_eyes_burns", "eyes_burns", "" );
  ObjAnimate( "obj_underbookcase_morph1", "alp", 0, 0, "",
  {
    0.0, 0, 1,
    0.4, 0, 0
  } );
  ObjAnimate( "obj_underbookcase_morph2", "alp", 0, 0, "",
  {
    0.0, 0, 0,
    0.4, 0, 1
  } );
  ObjSet( "obj_underbookcase_morph1", { input = false } );
  ObjSet( "obj_underbookcase_morph2", { input = true } );
  
  for i = 1, #anim_morph_1, 1 do 
  
    if not private.IsFound( anim_morph_1[ i ].anim )  then
    
      local curAnim = "anm_underbookcase_"..anim_morph_1[ i ].anim;  
      local curFunc = anim_morph_1[ i ].func;
      
      local curSpr = "spr_underbookcase_"..anim_morph_1[ i ].anim; 
      local curX = ObjGet( curSpr ).pos_x;
      local curY = ObjGet( curSpr ).pos_y;
      
      ObjSet( curAnim, { pos_x = curX, pos_y = curY } );
      AnimPlay( curAnim, curFunc, "" );
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.AnmHorrorEnd (  ) 
  
  local anim_morph_2 = {
                          { anim = "moon", func = "small_objects" },
                          { anim = "eye", func = "small_objects" },
                          { anim = "star", func = "big_objects" },
                          { anim = "picture2", func = "big_objects" },
                          { anim = "fang", func = "small_objects" },
                          { anim = "blood", func = "large_objects" },
                          { anim = "smithers", func = "large_objects" },
                          { anim = "mousetrap", func = "big_objects" },
                          { anim = "bug", func = "small_objects" },
                          { anim = "can", func = "big_objects" },
                          { anim = "ring", func = "small_objects" },
                          { anim = "knife", func = "knife" }
                        };                             
                           
  ObjAnimate( "obj_underbookcase_morph2", "alp", 0, 0, private.AnmHorror,
  {
    0.0, 0, 1,
    0.4, 0, 0,
    5.0, 0, 0
  } );
  ObjAnimate( "obj_underbookcase_morph1", "alp", 0, 0, "",
  {
    0.0, 0, 0,
    0.4, 0, 1
  } );
  ObjSet( "obj_underbookcase_morph2", { input = false } );
  ObjSet( "obj_underbookcase_morph1", { input = true } ); 
  
  for i = 1, #anim_morph_2, 1 do 
  
    if not private.IsFound( anim_morph_2[ i ].anim )  then
      
      local curAnim = "anm_underbookcase_"..anim_morph_2[ i ].anim;  
      local curFunc = anim_morph_2[ i ].func;
      
      local curSpr = "spr_underbookcase_"..anim_morph_2[ i ].anim; 
      local curX = ObjGet( curSpr ).pos_x;
      local curY = ObjGet( curSpr ).pos_y;
      
      ObjSet( curAnim, { pos_x = curX, pos_y = curY } );
      AnimPlay( curAnim, curFunc, "" );
      
    end;
    
  end;
  
end;

