-- name=ho_winecollection
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "winecollection" );
  game.relations[ "ho_winecollection" ].exitroom = "rm_winecellar";
  private.room_objname = "ho_winecollection";
  --------------------------------------------------------------------------------------------------
  
  private.TASKPANEL_LEFT = -250;
  private.TASKPANEL_DIFF = 120;
  private.TASKPANEL_COUNT = 5;

  private.tasks = { 
                    "chain", "bat", "wineglass", "corkscrew", "leaf", "hat", "knife", 
                    "mushroom", "symbol_1", "symbol_2", "medallion", "crane"
                  };

  local table_set = {};
  for i = 1, #private.tasks do
    table.insert( table_set,  { "spr_winecollection_"..private.tasks[ i ], { event_mdown = function() private.TaskComplete( private.tasks[ i ] ); end } } )
  end;

  table.insert( table_set,  { "spr_winecollection_letter", { event_mdown = function() cmn.NoteScale( "spr_winecollection_letter" ) end } } )
  table.insert( table_set,  { "spr_winecollection_letter_big", { event_mdown = function() cmn.NoteScale( "spr_winecollection_letter" ) end } } )

  ObjMultiSet( table_set );

  for i = 1, #private.tasks do

    local itemInput = false;
    
    if ( i <= private.TASKPANEL_COUNT ) then 
      
      itemInput = true;
      
    end;
    
    local curItem = "spr_winecollection_"..private.tasks[ i ];
    local curPanelItem = "spr_winecollection_taskpanel_"..private.tasks[ i ];
    
    ObjMultiSet( { 
      { curItem,  { input = itemInput } },
      { curPanelItem,  { pos_x = private.TASKPANEL_LEFT + ( i - 1 ) * private.TASKPANEL_DIFF } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  -- function win_winecollection () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_winecollection" ] = {
    type = "win",
    room = "rm_winecellar",
    zz = "ho_winecollection",
    zz_gate = "gho_winecellar_winecollection"
  };
  local win_winecollection_inv = function ()
  
    if ( cmn.IsEventDone( "win_winecollection" ) ) then
    
      interface.InventoryItemAdd( "inv_chainwithhook", "spr_winecollection_win" );   
    
    end;
    
  end;
  local win_winecollection_loc = function ()
  
    if ( cmn.IsEventDone( "win_winecollection" ) ) then
    
      ObjDelete( "gho_winecellar_winecollection" );   
    
    end;
    
  end;

  cmn.AddSubscriber( "win_winecollection", win_winecollection_inv );
  cmn.AddSubscriber( "win_winecollection", win_winecollection_loc, "rm_winecellar" );
  --------------------------------------------------------------------------------------------------
  local start_winecollection_func = function ()

  if ( cmn.IsEventStart( "win_winecollection" ) ) then

    local ho_found = ng_global.progress[ "std" ][ "win_winecollection" ].found;

    for i = 1, #ho_found, 1 do
    
      ObjDelete( ho_found[ i ][ "object" ] );
      if ( ho_found[ i ].task == "bat" ) then
        ObjDelete( "anm_winecollection_bat" )
      elseif ( ho_found[ i ].task == "mushroom" ) then
        ObjDelete( "anm_winecollection_mushroom" )
      end;

      for k = 1, 12 do
          
        if ( ho_found[ i ].task == private.tasks[ k ] ) then
          
          ObjDelete( "spr_winecollection_taskpanel_"..private.tasks[ k ] );
          
          for j = k, 12 do
            
            if ( ObjGet( "spr_winecollection_taskpanel_"..private.tasks[ j ] ) ) then
       
              ObjSet( "spr_winecollection_taskpanel_"..private.tasks[ j ], { pos_x = ObjGet( "spr_winecollection_taskpanel_"..private.tasks[ j ] ).pos_x - private.TASKPANEL_DIFF } ); 
              
              if ( ObjGet( "spr_winecollection_taskpanel_"..private.tasks[ j ] ).pos_x < private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF ) then
                
                ObjSet( "spr_winecollection_"..private.tasks[ j ], { input = true } );
                
              end;
            
            end;
            
          end;
        
        end;
        
      end;
    
    end;

  end;

  end;
  cmn.AddSubscriber( "win_winecollection", start_winecollection_func, private.room_objname );  

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();

  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level2/env/aud_winecellar_env", 0, "", 0 );
  common_impl.PlayMusEnvHO();

  if ( not cmn.IsEventDone( "opn_winecollection" ) ) then
  
    cmn.InitHo( "winecollection" );
    cmn.SetEventDone( "opn_winecollection" );
  
  end;

  local ho_items = {};

  for i = 1, 12 do
    interface.TaskPanelTaskAdd( ho_items, private.tasks[ i ],          1, 0, { { "spr_winecollection_"..private.tasks[ i ] } } );
  end;
  --for i = 2, 12 do
  --  interface.TaskPanelTaskAdd( ho_items, private.tasks[ i ],          1, 0, { { "spr_winecollection_"..private.tasks[ i ] } } );
  --end;
  --interface.TaskPanelTaskAdd( ho_items, "chain_hook",          1, 0, { { "obj_winecollection_chain_hook_hint" } } );
  
  interface.TaskPanelShow( ho_items );

  ObjAttach( "obj_winecollection_taskpanel", "spr_int_taskpanel" );
  ObjSet( "obj_int_taskpanel", { visible = false } );
  ObjSet( "txt_int_taskpanel", { visible = false } );

  private.InitAnimations();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { visible = true } );
  ObjSet( "txt_int_taskpanel", { visible = true } );

  ObjAttach( "obj_winecollection_taskpanel", "ho_winecollection" );

  cmn.NoteScaleClose( { "spr_winecollection_letter" } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin()
  
end;
--*********************************************************************************************************************
function private.TaskComplete ( task_name )

  cmn.HoTaskFind( "spr_winecollection_"..task_name, task_name );

  if ( task_name == "bat" ) then
    ObjDelete( "anm_winecollection_bat" );

  elseif ( task_name == "mushroom" ) then

    ObjDelete( "anm_winecollection_mushroom" );

  elseif ( task_name == "hat" ) then

    cmn.Lock( true );

  end;

  local func_move = function () 
    
    private.TaskPanelUpdate( task_name ); 

    if ( task_name == "hat" ) then
      common_impl.PlayAudio( "sfx", "level2/sfx/aud_scull_ghost_sc", 0, "", 0 );
      AnimPlay( "anm_winecollection_skull", "skull", function () cmn.Lock( false ); end )
    end;
    
  end;

  ObjAnimate( "spr_winecollection_taskpanel_"..task_name, "alp", 0, 0, func_move,
  { 
    0.0, 0, 1.0,
    0.4, 0, 1.0,
    0.6, 0, 0.0
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TaskPanelUpdate ( task_name )

  ObjDelete( "spr_winecollection_taskpanel_"..task_name );
  
  local index = private.FindIndex( private.tasks, task_name ); 
  
  for j = index, #private.tasks do

    local params = ObjGet( "spr_winecollection_taskpanel_"..private.tasks[ j ] );
    
    if ( params ) then

      local func_end = "";

      if ( not ObjGet( "spr_winecollection_"..private.tasks[ j ] ).input ) then

        func_end = function()
          
          local limitX = private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF;
          
          if ( ObjGet( "spr_winecollection_taskpanel_"..private.tasks[ j ] ) and 
          ( ObjGet( "spr_winecollection_taskpanel_"..private.tasks[ j ] ).pos_x < limitX ) and 
          ( ObjGet( "spr_winecollection_"..private.tasks[ j ] ).alp == 1 ) ) then
            
            ObjSet( "spr_winecollection_"..private.tasks[ j ], { input = true } );
            
          end;

        end;

      end;          

      if ( not private.IsFound( private.tasks[ j ] ) ) then
        
        ObjAnimate( "spr_winecollection_taskpanel_"..private.tasks[ j ], "pos_x", 0, 0, func_end, 
        { 
          0.0, 3, params.pos_x, 
          0.4, 3, params.pos_x - private.TASKPANEL_DIFF
        } );
        
      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.FindIndex( arr, elem ) -- поиск по таблице 

  for i = 1, #arr do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
function private.IsFound( task ) -- поиск по таблице 

  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_winecollection" ].found;
  
  for i = 1, #progress do
    
    if ( progress[ i ].task == task ) then

      return true;

    end;
    
  end;
  
  return false;  

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_winecollection_chain_hook", "ang", 1, 0, "", { 0, 3, 0, 3, 3, -0.03, 6, 3, 0 } )

end;