-- name=level2
function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause,    10000000 );
  interface.WidgetAdd( InterfaceWidget_BtnMenu,        21 );

  if IsCollectorsEdition() then
    interface.WidgetAdd( InterfaceWidget_BtnGuide,     20 );
  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint,        11 );
  interface.WidgetAdd( InterfaceWidget_BtnSkip,        12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo,         9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset,        9 );
  interface.WidgetAdd( InterfaceWidget_Inventory,       9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel,      10 );
  interface.WidgetAdd( InterfaceWidget_Effects,        11 );
  interface.WidgetAdd( InterfaceWidget_BtnMap,         20 );
  interface.WidgetAdd( InterfaceWidget_DialogHo,       22 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom,    8 );
  interface.WidgetAdd( InterfaceWidget_ItemPanel          );
  interface.WidgetAdd( InterfaceWidget_Popup,          27 );
  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,         26 );
  interface.WidgetAdd( InterfaceWidget_DialogVideo,    26 );
  interface.WidgetAdd( InterfaceWidget_DialogStory        );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 9 );
  interface.WidgetAdd( InterfaceWidget_StrategyGuide,  28 );
  interface.WidgetAdd( InterfaceWidget_Window             );
  interface.WidgetAdd( InterfaceWidget_Tutorial,       27 );
  interface.WidgetAdd( InterfaceWidget_Map,            26 );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.BtnMiniHOAdd( 18 );
  interface.SliderAdd( -1 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 18 );
    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
    interface.BtnMorphAdd( 18 );

  end;
   
  private.Init();
  ModLoad( "assets/levels/level2/mod_level2_inv" );
  level2_inv.Init();

  common.LevelLoad( "level2", "std", "rm_winecellar", param, private.menu_moduls );

  common_impl.CollectiblesMusicLoadOnLocation(); 
  common_impl.Collectibles2Load();
  common_impl.MorphLoad();
  
  private.TutorialSetParams();
  interface.KeyUpdate();

  cmn.PlayMusEnv();

end;

function private.Init ()
  
  game = {};
  game.room_names =
  {
     "rm_winecellar"
    ,"rm_toilets"
    ,"rm_eventshall"
    ,"rm_library"
    ,"rm_stairflight"
    ,"rm_cemetery"
    ,"ho_winecollection"
    ,"mg_chain"
    ,"mg_librarysecret"
    ,"ho_baths"
    ,"ho_underbookcase"
    ,"mg_incabinet"
    ,"ho_withflashlight"
  };

  game.progress_names_room =
  {
     { "beg_level2"                   }
    ,{ "see_intro_2"                  }
    ,{ "opn_winecellar"               }
    ,{ "see_winecellar_fire",         "rm_winecellar"   }
    ,{ "use_cleaner_lvl2",            "rm_winecellar",    { "opn_winecellar"                                   } }
    ,{ "get_tumbler",                 "rm_winecellar",    { "use_cleaner_lvl2"                                 } }
    ,{ "get_sandpaper",               "rm_winecellar",    { "opn_winecellar"                                   } }
    ,{ "get_rod",                     "rm_winecellar",    { "opn_winecellar"                                   } }
    ,{ "use_tumbler",                 "rm_winecellar",    { "get_tumbler"                                      } }
    ,{ "clk_tumbler",                 "rm_winecellar",    { "use_tumbler"                                      } }
    ,{ "get_scoop",                   "rm_winecellar",    { "clk_tumbler"                                      } }
    ,{ "clk_scoop",                   "rm_winecellar",    { "opn_winecellar"                                   } }
    ,{ "use_scoop",                   "rm_winecellar",    { "get_scoop", "clk_scoop"                           } }
    ,{ "get_scoop_2",                 "rm_winecellar",    { "use_scoop"                                        } }
    ,{ "use_rod",                     }
    ,{ "get_symbol_lvl2",             }
    ,{ "get_skull1",                  }
    ,{ "get_metalballs",              }
    ,{ "get_glass2",                  "rm_winecellar",    { "opn_winecellar"                                   } }
    ,{ "clk_rug",                     "rm_winecellar",    { "opn_winecellar"                                   } }
    ,{ "use_symbol_lvl2",             "rm_winecellar",    { "clk_rug", "get_symbol_lvl2"                       } }
    ,{ "get_wheel_lvl2",              "rm_winecellar",    { "use_symbol_lvl2"                                  } }
    ,{ "use_wheel_lvl2",              "rm_winecellar",    { "get_wheel_lvl2"                                   } }
    ,{ "get_lever",                   "rm_winecellar",    { "use_wheel_lvl2"                                   } }
    ,{ "clk_lever",                   "rm_winecellar",    { "use_cleaner_lvl2"                                 } }
    ,{ "use_lever",                   "rm_winecellar",    { "get_lever", "clk_lever"                           } }
    ,{ "get_grapesleaf1",             "rm_winecellar",    { "use_lever"                                        } }
    ,{ "use_grapesleaf1",             "rm_winecellar",    { "get_grapesleaf1"                                  } }
    ,{ "get_glass3",                  "rm_winecellar",    { "use_grapesleaf1"                                  } }
    ,{ "use_glass2",                  "rm_winecellar",    { "get_glass2"                                       } }
    ,{ "use_glass3",                  "rm_winecellar",    { "get_glass3"                                       } }
    ,{ "get_patternfragment",         "rm_winecellar",    { "use_glass2", "use_glass3"                         } }
    ,{ "use_patternfragment",         "rm_winecellar",    { "get_patternfragment"                              } }
    ,{ "get_pliers",                  "rm_winecellar",    { "use_patternfragment"                              } }
    ,{ "use_pliers_1",                "rm_winecellar",    { "get_pliers", "use_lever"                          } }
    ,{ "get_rawmaterial",             "rm_winecellar",    { "use_pliers_1"                                     } }
    ,{ "use_sandpaper",               }
    ,{ "clk_corkscrew_handle",        }
    ,{ "get_corkscrew_handle",        }
    ,{ "use_corkscrew_handle",        "rm_winecellar",    { "get_corkscrew_handle", "use_glass2", "use_glass3" } }
    ,{ "get_corkscrew_lvl2",          "rm_winecellar",    { "use_corkscrew_handle"                             } }
    ,{ "use_corkscrew_lvl2",          "rm_winecellar",    { "get_corkscrew_lvl2"                               } }
    ,{ "clk_corkscrew_lvl2",          "rm_winecellar",    { "use_corkscrew_lvl2"                               } }
    ,{ "get_rubber",                  "rm_winecellar",    { "clk_corkscrew_lvl2"                               } }
    ,{ "get_skull2",                  "rm_winecellar",    { "clk_corkscrew_lvl2"                               } }
    ,{ "use_rubber",                  }
    ,{ "clk_rubber_1",                }
    ,{ "clk_rubber_2",                }
    ,{ "use_metalballs",              }
    ,{ "get_slingshot",               }
    ,{ "see_winecellar_ghost",        "rm_winecellar"   }
    ,{ "use_slingshot",               "rm_winecellar",    { "get_slingshot"                                    } }
    ,{ "win_winecellar",              "rm_winecellar",    { "use_slingshot"                                    } }
    ,{ "opn_winecollection"           }
    ,{ "win_winecollection",          "rm_winecellar",    { "win_winecellar"                                   } }
    ,{ "use_chainwithhook",           "rm_winecellar",    { "win_winecollection"                               } }
    ,{ "win_chain",                   "rm_winecellar",    { "use_chainwithhook"                                } }
    ,{ "see_winecellar",              "rm_winecellar"   }
    ,{ "opn_eventshall"               }
    ,{ "see_eventshall_horror",       "rm_eventshall"   }
    ,{ "see_eventshall_ghost",        "rm_eventshall"   }
    ,{ "get_whistle",                 "rm_eventshall",    { "opn_eventshall"                                   } }
    ,{ "clk_stage_box",               "rm_eventshall",    { "opn_eventshall"                                   } }
    ,{ "get_stainedglasspart1",       "rm_eventshall",    { "clk_stage_box"                                    } }
    ,{ "use_whistle",                 "rm_eventshall",    { "opn_eventshall", "get_whistle"                    } }
    ,{ "get_grapesleaf2",             "rm_eventshall",    { "use_whistle"                                      } }
    ,{ "use_grapesleaf2",             "rm_winecellar",    { "get_grapesleaf2"                                  } }
    ,{ "get_spoon",                   "rm_winecellar",    { "use_grapesleaf2"                                  } }
    ,{ "clk_kitchen_handle",          "rm_eventshall",    { "opn_eventshall"                                   } }
    ,{ "use_spoon",                   "rm_eventshall",    { "clk_kitchen_handle", "get_spoon"                  } }
    ,{ "get_hook_lvl2",               "rm_eventshall",    { "use_spoon"                                        } }
    ,{ "use_hook_lvl2",               "rm_eventshall",    { "get_hook_lvl2"                                    } }
    ,{ "get_turner",                  "rm_eventshall",    { "use_hook_lvl2"                                    } }
    ,{ "use_turner",                  "rm_winecellar",    { "get_turner"                                       } }
    ,{ "get_stainedglasspart2",       "rm_winecellar",    { "use_turner", "use_glass2", "use_glass3"           } }
    ,{ "get_stainedglasspart3",       "rm_eventshall",    { "opn_eventshall"                                   } }
    ,{ "use_stainedglasspart1",       "rm_eventshall",    { "get_stainedglasspart1"   } }
    ,{ "use_stainedglasspart2",       "rm_eventshall",    { "get_stainedglasspart2"   } }
    ,{ "use_stainedglasspart3",       "rm_eventshall",    { "get_stainedglasspart3"   } }
    ,{ "clk_old_gear",                "rm_eventshall",    { "use_stainedglasspart1", "use_stainedglasspart2", 
                                                            "use_stainedglasspart3"                            } }
    ,{ "get_ironhandle",              "rm_eventshall",    { "use_stainedglasspart1", "use_stainedglasspart2", 
                                                            "use_stainedglasspart3"                            } }
    ,{ "clk_oven_handle",             "rm_eventshall",    { "use_spoon"                                        } }
    ,{ "use_ironhandle",              "rm_eventshall",    { "get_ironhandle", "clk_oven_handle"                } }
    ,{ "get_rod_2",                   "rm_eventshall",    { "use_ironhandle"                                   } }
    ,{ "use_pliers_2",                }
    ,{ "get_bentrod",                 }
    ,{ "use_bentrod",                 "rm_winecellar",    { "get_bentrod"                                      } }
    ,{ "clk_bentrod",                 "rm_winecellar",    { "use_bentrod"                                      } }
    ,{ "get_lockpart",                "rm_winecellar",    { "clk_bentrod"                                      } }
    ,{ "use_lockpart",                "rm_winecellar",    { "get_lockpart"                                     } }
    ,{ "opn_toilets"                  }
    ,{ "see_toilets_down",            "rm_toilets"      }
    ,{ "get_saw",                     "rm_toilets",       { "opn_toilets"                                      } }
    ,{ "use_saw",                     "rm_eventshall",    { "get_saw"                                          } }
    ,{ "get_longstick",               "rm_eventshall",    { "use_saw"                                          } }
    ,{ "use_longstick",               "rm_toilets",       { "get_longstick"                                    } }
    ,{ "opn_baths"                    }
    ,{ "win_baths",                   "rm_toilets",       { "use_longstick"                                    } }
    ,{ "use_ovenfork",                "rm_eventshall",    { "win_baths"                                        } }
    ,{ "get_dutchoven",               "rm_eventshall",    { "use_ovenfork"                                     } }
    ,{ "get_duster",                  "rm_toilets",       { "opn_toilets"                                      } }
    ,{ "see_toilets_ghost",           "rm_toilets"      }
    ,{ "use_duster",                  }
    ,{ "clk_kazan",                   }
    ,{ "clk_kazan_2",                 }
    ,{ "get_oldkey",                  }
    ,{ "use_oldkey",                  "rm_eventshall",    { "get_oldkey"                                       } }
    ,{ "clk_oldkey",                  "rm_eventshall",    { "use_oldkey"                                       } }
    ,{ "see_eventshall_open",         "rm_eventshall"   }
    ,{ "opn_library"                  }
    ,{ "see_library_ghost",           "rm_library"      }
    ,{ "see_library_scary",           "rm_library"      }
    ,{ "opn_underbookcase"            }
    ,{ "win_underbookcase",           "rm_library",       { "see_library_scary"                                } }
    ,{ "use_boathook",                "rm_library",       { "win_underbookcase"                                } }
    ,{ "get_thread",                  "rm_library",       { "use_boathook"                                     } }
    ,{ "get_sprayer",                 "rm_library",       { "use_boathook"                                     } }
    ,{ "use_thread",                  "rm_eventshall",    { "get_thread"                                       } }
    ,{ "get_oldamulet",               "rm_eventshall",    { "use_thread"                                       } }
    ,{ "get_figurineshape",           "rm_eventshall",    { "use_thread"                                       } }
    ,{ "clk_wallstash_books",         "rm_library",       { "win_underbookcase"                                } }
    ,{ "use_oldamulet",               "rm_library",       { "get_oldamulet", "clk_wallstash_books"             } }
    ,{ "get_collectorsjug",           "rm_library",       { "use_oldamulet"                                    } }
    ,{ "get_skull3",                  "rm_library",       { "use_oldamulet"                                    } }
    ,{ "get_sappershovel",            "rm_library",       { "win_underbookcase"                                } }
    ,{ "use_collectorsjug",           "rm_toilets",       { "get_collectorsjug"                                } }
    ,{ "use_sappershovel",            "rm_toilets",       { "get_sappershovel", "use_collectorsjug"            } }
    ,{ "get_jugwithclay",             "rm_toilets",       { "use_sappershovel"                                 } }
    ,{ "use_figurineshape",           "rm_eventshall",    { "get_figurineshape"                                } }
    ,{ "use_jugwithclay",             "rm_eventshall",    { "use_figurineshape", "get_jugwithclay"             } }
    ,{ "win_kitchen",                 "rm_eventshall",    { "use_jugwithclay"                                  } }
    ,{ "get_animalstatuette",         "rm_eventshall",    { "win_kitchen"                                      } }
    ,{ "use_animalstatuette",         "rm_winecellar",    { "get_animalstatuette"                              } }
    ,{ "get_feed",                    "rm_winecellar",    { "use_animalstatuette"                              } }
    ,{ "use_feed",                    "rm_library",       { "get_feed"                                         } }
    ,{ "get_awlhandle",               "rm_library",       { "use_feed"                                         } }
    ,{ "use_awlhandle",               "rm_eventshall",    { "get_awlhandle"                                    } }
    ,{ "get_awl",                     "rm_eventshall",    { "use_awlhandle"                                    } }
    ,{ "see_fb_clark"                 }
    ,{ "use_awl",                     "rm_library",       { "get_awl"                                          } }
    ,{ "get_decorativeelement",       "rm_library",       { "use_awl"                                          } }
    ,{ "use_decorativeelement",       "rm_toilets",       { "get_decorativeelement"                            } }
    ,{ "clk_decorativeelement",       "rm_toilets",       { "use_decorativeelement"                            } }
    ,{ "use_pliers_3",                "rm_toilets",       { "clk_decorativeelement"                            } }
    ,{ "win_incabinet",               "rm_toilets",       { "use_pliers_3"                                     } }
    ,{ "get_squarekey",               "rm_toilets",       { "win_incabinet"                                    } }
    ,{ "use_squarekey",               "rm_toilets",       { "get_squarekey"                                    } }
    ,{ "clk_squarekey",               "rm_toilets",       { "use_squarekey"                                    } }
    ,{ "see_toilets_ghost2",          "rm_toilets"      }
    ,{ "opn_stairflight"              }
    ,{ "see_stairflight_collaps",     "rm_stairflight"  }
    ,{ "see_stairflight_face",        "rm_stairflight"  }
    ,{ "see_stairflight_bats",        "rm_stairflight"  }
    ,{ "use_flashlight_lvl2_2",       "rm_stairflight",   { "opn_stairflight"                                  } }
    ,{ "opn_withflashlight"           }
    ,{ "win_withflashlight",          "rm_stairflight",   { "use_flashlight_lvl2_2"                            } }
    ,{ "get_flask",                   "rm_toilets",       { "opn_toilets"                                      } }
    ,{ "use_ironleaf",                "rm_toilets",       { "win_withflashlight"                               } }
    ,{ "get_trashcan",                "rm_toilets",       { "use_ironleaf"                                     } }
    ,{ "clk_trashcan_1",              }
    ,{ "clk_trashcan_2",              }
    ,{ "get_amuletleaf",              }
    ,{ "clk_amuletleaf",              "rm_stairflight",   { "opn_stairflight"                                  } }
    ,{ "use_amuletleaf",              "rm_stairflight",   { "get_amuletleaf", "clk_amuletleaf"                 } }
    ,{ "get_gardenglove",             "rm_stairflight",   { "use_amuletleaf"                                   } }
    ,{ "use_gardenglove",             "rm_toilets",       { "get_gardenglove"                                  } }
    ,{ "get_file",                    "rm_toilets",       { "use_gardenglove"                                  } }
    ,{ "use_file",                    "rm_stairflight",   { "get_file"                                         } }
    ,{ "clk_things",                  "rm_stairflight",   { "use_file"                                         } }
    ,{ "get_wrench",                  "rm_stairflight",   { "clk_things"                                       } }
    ,{ "get_skull4",                  "rm_stairflight",   { "clk_things"                                       } }
    ,{ "clk_portrait",                "rm_stairflight",   { "opn_stairflight"                                  } }
    ,{ "use_wrench",                  "rm_stairflight",   { "get_wrench", "clk_portrait"                       } }
    ,{ "get_button_lvl2",             "rm_stairflight",   { "use_wrench"                                       } }
    ,{ "use_button_lvl2",             "rm_eventshall",    { "get_button_lvl2"                                  } }
    ,{ "clk_button_lvl2",             "rm_eventshall",    { "use_button_lvl2"                                  } }
    ,{ "get_cleaner",                 "rm_eventshall",    { "clk_button_lvl2"                                  } }
    ,{ "use_cleaner",                 }
    ,{ "use_sprayer",                 }
    ,{ "get_cleaningsprayer",         }
    ,{ "use_cleaningsprayer",         "rm_stairflight",   { "get_cleaningsprayer"                              } }
    ,{ "clk_cleaningsprayer",         "rm_stairflight",   { "use_cleaningsprayer"                              } }
    ,{ "get_pattern",                 "rm_stairflight",   { "clk_cleaningsprayer"                              } }
    ,{ "get_skull5",                  "rm_stairflight",   { "clk_cleaningsprayer"                              } }
    ,{ "use_pattern",                 "rm_library",       { "get_pattern"                                      } }
    ,{ "get_rubbedkey",               "rm_library",       { "use_pattern"                                      } }
    ,{ "use_rubbedkey",               "rm_stairflight",   { "get_rubbedkey"                                    } }
    ,{ "clk_rubbedkey",               "rm_stairflight",   { "use_rubbedkey"                                    } }
    ,{ "get_decoration",              "rm_stairflight",   { "clk_rubbedkey"                                    } }
    ,{ "get_artificialeye",           }
    ,{ "use_artificialeye",           "rm_library",       { "get_artificialeye"                                } }
    ,{ "win_librarysecret",           "rm_library",       { "use_artificialeye"                                } }
    ,{ "get_skull6",                  "rm_library",       { "win_librarysecret"                                } }
    ,{ "see_toilets_birds",           "rm_toilets"      }
    ,{ "use_skull",                   "rm_toilets",       { "get_skull1", "get_skull2", "get_skull3", 
                                                            "get_skull4", "get_skull5", "get_skull6"           } }
    ,{ "win_windowunderceiling",      "rm_toilets",       { "use_skull"                                        } }
    ,{ "opn_cemetery"                 }
    ,{ "see_cemetery_outro_2"         }
    
    ,{ "get_collect_morph_item_8"     } --"rm_winecellar"
    ,{ "get_collect_morph_item_9"     } --"rm_toilets"
    ,{ "get_collect_morph_item_10"    } --"rm_eventshall"
    ,{ "get_collect_morph_item_11"    } --"rm_library"
    ,{ "get_collect_morph_item_12"    } --"rm_stairflight"
    ,{ "get_collect_morph_item_13"    } --"rm_cemetery"
  };
    
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
    
  game.relations = {};
  private.menu_moduls = { "rm_credits" };

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = { "rm_collectibles2",
                             "rm_collectibles",
                             "rm_achievements"
                           };

    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;  
  
end;

function private.TutorialSetParams ()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;
  
  end;
                                                                          
end;
