-- name=level2_inv
--*********************************************************************************************************************
function public.Init ()

  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level2_inv_hub");
    port.VideoResizeInRoom("level2_inv");
  end;
  
  private.scoop_2_init();
  private.rawmaterial_init();
  private.rod_2_init(); 
  private.dutchoven_init(); 
  private.trashcan_init();
  private.flask_init(); 
  private.decoration_init(); 
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level2_inv_deploy = function ()

    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    common_impl.TurnChildGfx( { "level2_inv_deploy" } , "level2_inv_deploy", res_sparkle_area );

  end;
  cmn.AddSubscriber( "update_game_mode_level2_inv_deploy", update_game_mode_level2_inv_deploy, nil );
  
end;
--*********************************************************************************************************************
function private.StringDivide ( string )  

  local table = { };
  local id = 1;
  local il = 1;

  for i = 1, string.len( string ) do

    if ( string.sub( string, i, i ) == "_" ) then

      table[ id ] = string.sub( string, il, i - 1 );
      il = i + 1;
      id = id + 1;

    end

    if ( i == string.len( string ) ) then

      table[id] = string.sub( string, il, i );
      il = i + 1;
      id = id + 1;

    end

  end

  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck ( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[4];  
  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;


--*********************************************************************************************************************
-- function *** scoop_2 *** () end;
--*********************************************************************************************************************
  function private.scoop_2_init ()

    ObjMultiSet( { 
      { "obj_deploy_inv_scoop_2_metalballs", { event_mdown = private.get_metalballs  } },
      { "spr_deploy_inv_scoop_2_skull1",     { event_mdown = private.get_skull1      } },
      { "spr_deploy_inv_scoop_2_symbol",     { event_mdown = private.get_symbol_lvl2 } },
    } );

    --------------------------------------------------------------------------------------------
    -- function use_rod () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_rod" ] = {
        type = "use",
        inv_obj = "inv_rod",
        use_place = "obj_deploy_inv_scoop_2_use_rod",
        room = "int_deploy_inv",
        zz = "deploy_inv_scoop_2",
        zz_gate = "inv_scoop_2"
      };    
      function use_rod_beg ()
        
        interface.InventoryItemRemove( "inv_rod" );
        ObjDelete( "obj_deploy_inv_scoop_2_use_rod" );
        
      end;
      function use_rod_end ()

        ObjMultiSet( {
          { "obj_deploy_inv_scoop_2_metalballs", {  input = true } },
          { "gfx_deploy_inv_scoop_2_metalballs", { active = true } },
          { "spr_deploy_inv_scoop_2_skull1",     {  input = true } },
          { "spr_deploy_inv_scoop_2_skull1",     { active = true } },
          { "spr_deploy_inv_scoop_2_symbol",     {  input = true } },
          { "spr_deploy_inv_scoop_2_symbol",     { active = true } },
          { "anm_deploy_inv_scoop_2_stick",      {  frame = 500  } },
        } );
        ObjDelete( "anm_deploy_inv_scoop_2_coals_glow_1" );      

      end;
      cmn.AddSubscriber( "use_rod",     use_rod_beg                );
      cmn.AddSubscriber( "use_rod",     use_rod_end, "inv_scoop_2" );
      cmn.AddSubscriber( "use_rod_beg", use_rod_beg                );
      cmn.AddSubscriber( "use_rod_end", use_rod_end, "inv_scoop_2" );   
            
    --------------------------------------------------------------------------------------------
    -- function get_metalballs () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_metalballs" ] = {
        type = "get",
        get_obj = "obj_deploy_inv_scoop_2_metalballs",
        room = "int_deploy_inv",
        zz = "deploy_inv_scoop_2",
        zz_gate = "inv_scoop_2"
      };
      local get_metalballs_inv = function ()
      
        if ( cmn.IsEventDone( "get_skull1" ) and cmn.IsEventDone( "get_symbol_lvl2" ) ) then
          interface.InventoryItemRemove( "inv_scoop_2" );
        end;
        
        interface.InventoryItemAdd( "inv_metalballs", "obj_deploy_inv_scoop_2_metalballs" );
        
        if cmn.IsEventDone( "clk_rubber_2" ) then
        
          cmn.SetInvPlusRGB( "rawmaterial", false );
          
        end;

      end;
      local get_metalballs = function ()

        ObjDelete( "gfx_deploy_inv_scoop_2_metalballs" );

      end;
      cmn.AddSubscriber( "get_metalballs", get_metalballs_inv );
      cmn.AddSubscriber( "get_metalballs", get_metalballs, "inv_scoop_2" );
      
    --------------------------------------------------------------------------------------------
    -- function get_skull1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_skull1" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_scoop_2_skull1",
        room = "int_deploy_inv",
        zz = "deploy_inv_scoop_2",
        zz_gate = "inv_scoop_2"
      };
      local get_skull1_inv = function ()
      
        if ( cmn.IsEventDone( "get_metalballs" ) and cmn.IsEventDone( "get_symbol_lvl2" ) ) then
          interface.InventoryItemRemove( "inv_scoop_2" );   
        end;
        
        local count = 0;
        
        for i = 1, 6 do
          
          if ( cmn.IsEventDone( "get_skull"..i ) ) then
            
            count = count + 1;
            
          end;
          
        end;

        ObjSet( "inv_skull", { res = "assets/levels/level2/inv_deploy/inv_scoop_2/inv/inv_skull"..count } );
        interface.InventoryItemAdd( "inv_skull", "spr_deploy_inv_scoop_2_skull1", "assets/levels/level2/inv_deploy/inv_scoop_2/inv/inv_skull" );

        if count == 6 then
          
          ObjSet( "inv_skull", { drag = true } );
          
        else 
          
          ObjSet( "inv_skull", { drag = false } );

        end;  
    
      end;
      local get_skull1 = function ()

        ObjDelete( "gfx_deploy_inv_scoop_2_skull1" );

      end;
      cmn.AddSubscriber( "get_skull1", get_skull1_inv );
      cmn.AddSubscriber( "get_skull1", get_skull1, "inv_scoop_2" );
      
    --------------------------------------------------------------------------------------------
    -- function get_symbol_lvl2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_symbol_lvl2" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_scoop_2_symbol",
        room = "int_deploy_inv",
        zz = "deploy_inv_scoop_2",
        zz_gate = "inv_scoop_2"
      };
      local get_symbol_lvl2_inv = function ()
      
        if ( cmn.IsEventDone( "get_metalballs" ) and cmn.IsEventDone( "get_skull1" ) ) then
          interface.InventoryItemRemove( "inv_scoop_2" ); 
        end;
        
        interface.InventoryItemAdd( "inv_symbol_lvl2", "spr_deploy_inv_scoop_2_symbol" );

      end;
      local get_symbol_lvl2 = function ()

        ObjDelete( "gfx_deploy_inv_scoop_2_symbol_lvl2" );

      end;
      cmn.AddSubscriber( "get_symbol_lvl2", get_symbol_lvl2_inv );
      cmn.AddSubscriber( "get_symbol_lvl2", get_symbol_lvl2, "inv_scoop_2" );
      
  end;

  -- USE ---------------------------------------------------------------------------------------
  function public.use_rod ()

    local item = "inv_rod";
    
    if private.ObjIntersectCheck( item, "obj_deploy_inv_scoop_2_use_rod", "deploy_inv_scoop_2" ) then

      cmn.CallEventHandler( "use_rod_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_rod" );
        cmn.CallEventHandler( "use_rod_end", "inv_scoop_2" );

      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level2/sfx/aud_wood_stick", 0, "", 0 );

      ObjMultiSet( {
        { "anm_deploy_inv_scoop_2_coals_glow_1", { alp = 0 } },
        { "anm_deploy_inv_scoop_2_stick",        { alp = 1 } },
      } );
      AnimPlay( "anm_deploy_inv_scoop_2_stick", "stick", func_end );
      
      return true; 

    end;

    return false;

  end;
  
  -- GET ------------------------------------------------------------------------------------------
  function private.get_metalballs ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_metalballs" );
    cmn.CallEventHandler( "get_metalballs", "inv_scoop_2" );
    
    if ( cmn.IsEventDone( "get_skull1" ) and cmn.IsEventDone( "get_symbol_lvl2" ) ) then    
      common_impl.HideDeployInv();   
    end;

  end;
  
  -- GET ------------------------------------------------------------------------------------------
  function private.get_skull1 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_skull1" );
    cmn.CallEventHandler( "get_skull1", "inv_scoop_2" );
    
    if ( cmn.IsEventDone( "get_metalballs" ) and cmn.IsEventDone( "get_symbol_lvl2" ) ) then
      common_impl.HideDeployInv(); 
    end;

  end;
  
  -- GET ------------------------------------------------------------------------------------------
  function private.get_symbol_lvl2 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_symbol_lvl2" );
    cmn.CallEventHandler( "get_symbol_lvl2", "inv_scoop_2" );
    
    if ( cmn.IsEventDone( "get_metalballs" ) and cmn.IsEventDone( "get_skull1" ) ) then  
      common_impl.HideDeployInv();
    end;

  end;  
  

--*********************************************************************************************************************
-- function *** rawmaterial *** () end;
--*********************************************************************************************************************
  function private.rawmaterial_init ()

    private.rawmaterial_define ();

    ObjMultiSet( { 
      { "spr_deploy_inv_rawmaterial_corkscrew_handle",     { event_mdown = private.get_corkscrew_handle } },
      { "obj_deploy_inv_rawmaterial_slingshot",            { event_mdown = private.get_slingshot        } },

      { "obj_deploy_inv_rawmaterial_clk_corkscrew_handle", { event_mdown = private.clk_corkscrew_handle } },
      { "obj_deploy_inv_rawmaterial_clk_rubber_1",         { event_mdown = private.clk_rubber_1         } },
      { "obj_deploy_inv_rawmaterial_clk_rubber_2",         { event_mdown = private.clk_rubber_2         } },
    } );

    --------------------------------------------------------------------------------------------
    -- function use_sandpaper () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_sandpaper" ] = {
        type = "use",
        inv_obj = "inv_sandpaper",
        use_place = "obj_deploy_inv_rawmaterial_use_sandpaper",
        room = "int_deploy_inv",
        zz = "deploy_inv_rawmaterial",
        zz_gate = "inv_rawmaterial"
      };
      function use_sandpaper_beg ()
        
        interface.InventoryItemRemove( "inv_sandpaper" );
        ObjDelete( "obj_deploy_inv_rawmaterial_use_sandpaper" );
        
      end;
      function use_sandpaper_end ()
        if (ObjGet("inv_rawmaterial")) then
          ObjMultiSet( {
            { "obj_deploy_inv_rawmaterial_clk_corkscrew_handle", { input = true, active = true, visible = true } },
            { "inv_rawmaterial", { res = "assets/levels/level2/inv_deploy/inv_rawmaterial/inv/inv_slingshot1" } },
          } );
          ObjDelete( "anm_deploy_inv_rawmaterial_sandpaper" );        
        end;
      end;
      cmn.AddSubscriber( "use_sandpaper",     use_sandpaper_beg                    );
      cmn.AddSubscriber( "use_sandpaper",     use_sandpaper_end);--, "inv_rawmaterial" );
      cmn.AddSubscriber( "use_sandpaper_beg", use_sandpaper_beg                    );
      cmn.AddSubscriber( "use_sandpaper_end", use_sandpaper_end, "inv_rawmaterial" );   

    --------------------------------------------------------------------------------------------
    -- function clk_corkscrew_handle () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_corkscrew_handle" ] = {
        type = "click",
        use_place = "obj_deploy_inv_rawmaterial_clk_corkscrew_handle",
        room = "int_deploy_inv",
        zz = "deploy_inv_rawmaterial",
        zz_gate = "inv_rawmaterial"
      };
      
      local clk_corkscrew_handle_beg = function ()

        ObjDelete( "obj_deploy_inv_rawmaterial_clk_corkscrew_handle" );
      
      end;
      local clk_corkscrew_handle_end = function ()

        if (ObjGet("inv_rawmaterial")) then
          ObjMultiSet( { 
            { "spr_deploy_inv_rawmaterial_corkscrew_handle", { input = true, pos_x = -155, pos_y = -159, ang = 0.2 } },
            { "gfx_deploy_inv_rawmaterial_corkscrew_handle", {               active = true                         } },
            { "inv_rawmaterial", { res = "assets/levels/level2/inv_deploy/inv_rawmaterial/inv/inv_slingshot2" } },
          } );
        end;
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_corkscrew_handle",     clk_corkscrew_handle_beg                    );
      cmn.AddSubscriber( "clk_corkscrew_handle",     clk_corkscrew_handle_end);--, "inv_rawmaterial" );
      cmn.AddSubscriber( "clk_corkscrew_handle_beg", clk_corkscrew_handle_beg                    );
      cmn.AddSubscriber( "clk_corkscrew_handle_end", clk_corkscrew_handle_end, "inv_rawmaterial" ); 

    --------------------------------------------------------------------------------------------
    -- function get_corkscrew_handle () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_corkscrew_handle" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_rawmaterial_corkscrew_handle",
        room = "int_deploy_inv",
        zz = "deploy_inv_rawmaterial",
        zz_gate = "inv_rawmaterial"
      };
      local get_corkscrew_handle_inv = function ()
          
        interface.InventoryItemAdd( "inv_corkscrew_handle", "spr_deploy_inv_rawmaterial_corkscrew_handle" );
        
        if not cmn.IsEventDone( "get_rubber" ) then
      
          cmn.SetInvPlusRGB( "rawmaterial", false );
      
        end;

      end;
      local get_corkscrew_handle = function ()

        ObjDelete( "gfx_deploy_inv_rawmaterial_corkscrew_handle" );

        ObjMultiSet( { 
          { "obj_deploy_inv_rawmaterial_use_rubber", { input = true, active = true, visible = true } },
        } );

      end;
      cmn.AddSubscriber( "get_corkscrew_handle", get_corkscrew_handle_inv );
      cmn.AddSubscriber( "get_corkscrew_handle", get_corkscrew_handle, "inv_rawmaterial" );

    --------------------------------------------------------------------------------------------
    -- function use_rubber () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_rubber" ] = {
        type = "use",
        inv_obj = "inv_rubber",
        use_place = "obj_deploy_inv_rawmaterial_use_rubber",
        room = "int_deploy_inv",
        zz = "deploy_inv_rawmaterial",
        zz_gate = "inv_rawmaterial"
      };    
      function use_rubber_beg ()
        
        interface.InventoryItemRemove( "inv_rubber" );
        ObjDelete( "obj_deploy_inv_rawmaterial_use_rubber" );
        
      end;
      function use_rubber_end ()

        ObjMultiSet( { 
          { "spr_deploy_inv_rawmaterial_elastic_2",    {   alp = 1                                   } },
          { "obj_deploy_inv_rawmaterial_clk_rubber_1", { input = true, active = true, visible = true } },
        } );

      end;
      cmn.AddSubscriber( "use_rubber",     use_rubber_beg                    );
      cmn.AddSubscriber( "use_rubber",     use_rubber_end, "inv_rawmaterial" );
      cmn.AddSubscriber( "use_rubber_beg", use_rubber_beg                    );
      cmn.AddSubscriber( "use_rubber_end", use_rubber_end, "inv_rawmaterial" );  
      
    --------------------------------------------------------------------------------------------
    -- function clk_rubber_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_rubber_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_rawmaterial_clk_rubber_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_rawmaterial",
        zz_gate = "inv_rawmaterial"
      };
      
      local clk_rubber_1_beg = function ()

        ObjDelete( "obj_deploy_inv_rawmaterial_clk_rubber_1" );
      
      end;
      local clk_rubber_1_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_rawmaterial_elastic_3",    {   alp = 1                                   } },
          { "obj_deploy_inv_rawmaterial_clk_rubber_2", { input = true, active = true, visible = true } },
        } );
        ObjDelete( "spr_deploy_inv_rawmaterial_elastic_2" )
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_rubber_1",     clk_rubber_1_beg                    );
      cmn.AddSubscriber( "clk_rubber_1",     clk_rubber_1_end, "inv_rawmaterial" );
      cmn.AddSubscriber( "clk_rubber_1_beg", clk_rubber_1_beg                    );
      cmn.AddSubscriber( "clk_rubber_1_end", clk_rubber_1_end, "inv_rawmaterial" ); 

    --------------------------------------------------------------------------------------------
    -- function clk_rubber_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_rubber_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_rawmaterial_clk_rubber_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_rawmaterial",
        zz_gate = "inv_rawmaterial"
      };
      
      local clk_rubber_2_beg = function ()

        ObjDelete( "obj_deploy_inv_rawmaterial_clk_rubber_2" );
        
        if not cmn.IsEventDone( "get_metalballs" ) then
      
          cmn.SetInvPlusRGB( "rawmaterial", false );
      
        end;
      
      end;
      local clk_rubber_2_end = function ()
        if (ObjGet("inv_rawmaterial")) then
          ObjMultiSet( { 
            { "spr_deploy_inv_rawmaterial_elastic",        {   alp = 1                                   } },
            { "obj_deploy_inv_rawmaterial_use_metalballs", { input = true, active = true, visible = true } },
            { "inv_rawmaterial", { res = "assets/levels/level2/inv_deploy/inv_rawmaterial/inv/inv_slingshot" } },
          } );
          ObjDelete( "spr_deploy_inv_rawmaterial_elastic_3" )
        end;
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_rubber_2",     clk_rubber_2_beg                    );
      cmn.AddSubscriber( "clk_rubber_2",     clk_rubber_2_end);--, "inv_rawmaterial" );
      cmn.AddSubscriber( "clk_rubber_2_beg", clk_rubber_2_beg                    );
      cmn.AddSubscriber( "clk_rubber_2_end", clk_rubber_2_end, "inv_rawmaterial" ); 

    --------------------------------------------------------------------------------------------
    -- function use_metalballs () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_metalballs" ] = {
        type = "use",
        inv_obj = "inv_metalballs",
        use_place = "obj_deploy_inv_rawmaterial_use_metalballs",
        room = "int_deploy_inv",
        zz = "deploy_inv_rawmaterial",
        zz_gate = "inv_rawmaterial"
      };    
      function use_metalballs_beg ()
        
        interface.InventoryItemRemove( "inv_metalballs" );
        ObjDelete( "obj_deploy_inv_rawmaterial_use_metalballs" );
        
      end;
      function use_metalballs_end ()

        ObjMultiSet( {
          { "obj_deploy_inv_rawmaterial_slingshot",   {  input = true                        } },
          { "gfx_deploy_inv_rawmaterial_slingshot",   { active = true                        } },
          { "spr_deploy_inv_rawmaterial_metal_balls", {    alp = 1, pos_x = 366, pos_y = -98 } },
          { "spr_deploy_inv_rawmaterial_ball_1",      {    alp = 1, pos_x = 141, pos_y = 28  } },
        } );

      end;
      cmn.AddSubscriber( "use_metalballs",     use_metalballs_beg                    );
      cmn.AddSubscriber( "use_metalballs",     use_metalballs_end, "inv_rawmaterial" );
      cmn.AddSubscriber( "use_metalballs_beg", use_metalballs_beg                    );
      cmn.AddSubscriber( "use_metalballs_end", use_metalballs_end, "inv_rawmaterial" );         
      
    --------------------------------------------------------------------------------------------
    -- function get_slingshot () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_slingshot" ] = {
        type = "get",
        get_obj = "obj_deploy_inv_rawmaterial_slingshot",
        room = "int_deploy_inv",
        zz = "deploy_inv_rawmaterial",
        zz_gate = "inv_rawmaterial"
      };
      local get_slingshot_inv = function ()
              
        interface.InventoryItemRemove( "inv_rawmaterial" );        
        interface.InventoryItemAdd( "inv_slingshot", "obj_deploy_inv_rawmaterial_slingshot" );

      end;
      local get_slingshot = function ()

        ObjDelete( "gfx_deploy_inv_rawmaterial_slingshot" );

      end;
      cmn.AddSubscriber( "get_slingshot", get_slingshot_inv );
      cmn.AddSubscriber( "get_slingshot", get_slingshot, "inv_rawmaterial" );
   
  end;

  -- USE ---------------------------------------------------------------------------------------
  function public.use_sandpaper ()

    local item = "inv_sandpaper";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_rawmaterial_use_sandpaper" ) then

      cmn.CallEventHandler( "use_sandpaper_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_sandpaper" );
        cmn.CallEventHandler( "use_sandpaper_end", "inv_rawmaterial" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level2/sfx/aud_use_sandpaper", 0, "", 0 );

      AnimPlay( "anm_deploy_inv_rawmaterial_sandpaper", "DoAnim", func_end );
      
      return true; 

    end;

    return false;

  end;
  
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_corkscrew_handle ()
    
    cmn.CallEventHandler( "clk_corkscrew_handle_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_corkscrew_handle" );
      cmn.CallEventHandler( "clk_corkscrew_handle_end", "inv_rawmaterial" ); 

      private.get_corkscrew_handle();

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_break_wood", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_rawmaterial_corkscrew_handle", "pos_xy", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_corkscrew_handle" ).pos_x, ObjGet( "spr_deploy_inv_rawmaterial_corkscrew_handle" ).pos_y,
      0.3, 0, -155, -159,
    } );
    ObjAnimate( "spr_deploy_inv_rawmaterial_corkscrew_handle", "ang", 0, 0, "", { 
      0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_corkscrew_handle" ).ang,  
      0.3, 0, 0.2,
    } );

  end; 

  -- GET ------------------------------------------------------------------------------------------
  function private.get_corkscrew_handle ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_corkscrew_handle" );
    cmn.CallEventHandler( "get_corkscrew_handle", "inv_rawmaterial" );
        
  end;

  -- USE ---------------------------------------------------------------------------------------
  function public.use_rubber ()

    local item = "inv_rubber";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_rawmaterial_use_rubber" ) and cmn.IsEventDone( "get_corkscrew_handle" ) then

      cmn.CallEventHandler( "use_rubber_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_rubber" );
        cmn.CallEventHandler( "use_rubber_end", "inv_rawmaterial" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level2/sfx/aud_xx_short_whoosh", 0, "", 0 );

      cmn.ItemFly( "spr_deploy_inv_rawmaterial_elastic_2", func_end, -1.5 );
      
      return true; 

    end;

    return false;

  end;  
  
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_rubber_1 ()
    
    cmn.CallEventHandler( "clk_rubber_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_rubber_1" );
      cmn.CallEventHandler( "clk_rubber_1_end", "inv_rawmaterial" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_rope3", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_rawmaterial_elastic_2", "alp", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_elastic_2" ).alp,
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_deploy_inv_rawmaterial_elastic_3", "alp", 0, 0, "", { 
      0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_elastic_3" ).alp,  
      0.3, 0, 1 
    } );

  end; 
  
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_rubber_2 ()
    
    cmn.CallEventHandler( "clk_rubber_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_rubber_2" );
      cmn.CallEventHandler( "clk_rubber_2_end", "inv_rawmaterial" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_rope3", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_rawmaterial_elastic_3", "alp", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_elastic_3" ).alp,
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_deploy_inv_rawmaterial_elastic", "alp", 0, 0, "", { 
      0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_elastic" ).alp,  
      0.3, 0, 1 
    } );

  end; 

  -- USE ---------------------------------------------------------------------------------------
  function public.use_metalballs ()

    local item = "inv_metalballs";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_rawmaterial_use_metalballs" ) and 
                                                    cmn.IsEventDone( "clk_rubber_1" ) and 
                                                    cmn.IsEventDone( "clk_rubber_2" ) then

      cmn.CallEventHandler( "use_metalballs_beg" );

      local func_end = function ()
        
        local func_end_2 = function ()

          cmn.Lock( false );
          cmn.SetEventDone( "use_metalballs" );
          cmn.CallEventHandler( "use_metalballs_end", "inv_rawmaterial" );

        end;

        ObjAnimate( "spr_deploy_inv_rawmaterial_ball_1", "pos_xy", 0, 0, func_end_2, { 
          0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_ball_1" ).pos_x, ObjGet( "spr_deploy_inv_rawmaterial_ball_1" ).pos_y, 
          0.6, 0, 141, 28, 
        } );
  
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level2/sfx/aud_xx_clk_rope4", 0, "", 0 );

      ObjAnimate( "spr_deploy_inv_rawmaterial_metal_balls", "alp", 0, 0, "", { 
        0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_metal_balls" ).alp,
        0.3, 0, 1, 
      } );
      ObjAnimate( "spr_deploy_inv_rawmaterial_ball_1", "alp", 0, 0, "", { 
        0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_ball_1" ).alp,
        0.3, 0, 1, 
      } );
      ObjAnimate( "spr_deploy_inv_rawmaterial_metal_balls", "pos_xy", 0, 0, func_end, { 
        0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_metal_balls" ).pos_x, ObjGet( "spr_deploy_inv_rawmaterial_metal_balls" ).pos_y,
        0.6, 0, 366, -98, 
      } );
      ObjAnimate( "spr_deploy_inv_rawmaterial_ball_1", "pos_xy", 0, 0, "", { 
        0.0, 0, ObjGet( "spr_deploy_inv_rawmaterial_ball_1" ).pos_x, ObjGet( "spr_deploy_inv_rawmaterial_ball_1" ).pos_y,
        0.6, 0, 303, -193,
      } );

      return true; 

    end;

    return false;

  end;  
  
   -- GET ------------------------------------------------------------------------------------------
  function private.get_slingshot ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_slingshot" );
    cmn.CallEventHandler( "get_slingshot", "inv_rawmaterial" );
        
    common_impl.HideDeployInv();
   
  end; 
    
  -- define ----------------------------------------------------------------------------------------
  function  private.rawmaterial_define ()

    int_deploy_inv.Define( "rawmaterial" ); 
    --------------------------------------------------------
    function rawmaterial.PreOpen ()   
    end;
    --------------------------------------------------------
    function rawmaterial.Open ()
    end;
    --------------------------------------------------------
    function rawmaterial.PreClose ()
    end;
    --------------------------------------------------------
    function rawmaterial.Close ()

      if ( cmn.IsEventDone( "get_slingshot" ) and not cmn.IsEventDone( "see_winecellar_ghost" ) ) then

        rm_winecellar.see_winecellar_ghost();
      
      end;

    end;
    --------------------------------------------------------

  end;

--*********************************************************************************************************************
-- function *** rod_2 *** () end;
--*********************************************************************************************************************
  function private.rod_2_init ()

    ObjMultiSet( { 
      { "obj_deploy_inv_rod_2_bentrod", { event_mdown = private.get_bentrod } },
    } );

    --------------------------------------------------------------------------------------------
    -- function use_pliers_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_pliers_2" ] = {
        type = "use",
        inv_obj = "inv_pliers",
        use_place = "obj_deploy_inv_rod_2_use_pliers",
        room = "int_deploy_inv",
        zz = "deploy_inv_rod_2",
        zz_gate = "inv_rod_2"
      };    
      function use_pliers_2_beg ()
        
        if ( cmn.IsEventDone( "use_pliers_1" ) and
        cmn.IsEventDone( "use_pliers_3" ) ) then
          
          interface.InventoryItemRemove( "inv_pliers" );
          
        end;
        
        ObjDelete( "obj_deploy_inv_rod_2_use_pliers" );
        
      end;
      function use_pliers_2_end ()
      
        ObjMultiSet( {
          { "obj_deploy_inv_rod_2_bentrod", {  input = true, alp = 1 } },
          { "gfx_deploy_inv_rod_2_bentrod", { active = true          } },
        } );
        ObjDelete( "anm_deploy_inv_rod_2_curved" );
                  
      end;
      cmn.AddSubscriber( "use_pliers_2", use_pliers_2_beg );
      cmn.AddSubscriber( "use_pliers_2", use_pliers_2_end, "inv_rod_2" );
      cmn.AddSubscriber( "use_pliers_2_beg", use_pliers_2_beg );
      cmn.AddSubscriber( "use_pliers_2_end", use_pliers_2_end, "inv_rod_2" );  
       
    --------------------------------------------------------------------------------------------
    -- function get_bentrod () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_bentrod" ] = {
        type = "get",
        get_obj = "obj_deploy_inv_rod_2_bentrod",
        room = "int_deploy_inv",
        zz = "deploy_inv_rod_2",
        zz_gate = "inv_rod_2"
      };
      local get_bentrod_inv = function ()
              
        interface.InventoryItemRemove( "inv_rod_2" );        
        interface.InventoryItemAdd( "inv_bentrod", "obj_deploy_inv_rod_2_bentrod" );

      end;
      local get_bentrod = function ()

        ObjDelete( "gfx_deploy_inv_rod_2_bentrod" );

      end;
      cmn.AddSubscriber( "get_bentrod", get_bentrod_inv );
      cmn.AddSubscriber( "get_bentrod", get_bentrod, "inv_rod_2" );
   
  end;
  
  -- USE ---------------------------------------------------------------------------------------
  function public.use_pliers_2 ()
    
    local item = "inv_pliers";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_rod_2_use_pliers", "deploy_inv_rod_2" ) then

      cmn.CallEventHandler( "use_pliers_2_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_pliers_2" );
        cmn.CallEventHandler( "use_pliers_2_end", "inv_rod_2" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level2/sfx/aud_use_pliers2", 0, "", 0 );

      AnimPlay( "anm_deploy_inv_rod_2_curved", "DoAnim", func_end )
      
      return true; 

    end;

    return false;

  end; 
  
   -- GET ------------------------------------------------------------------------------------------
  function private.get_bentrod ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_bentrod" );
    cmn.CallEventHandler( "get_bentrod", "inv_rod_2" );
        
    common_impl.HideDeployInv();
   
  end;     
  

--*********************************************************************************************************************
-- function *** dutchoven *** () end;
--*********************************************************************************************************************
  function private.dutchoven_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_dutchoven_oldkey",      { event_mdown = private.get_oldkey  } },

      { "obj_deploy_inv_dutchoven_clk_kazan",   { event_mdown = private.clk_kazan   } },
      { "obj_deploy_inv_dutchoven_clk_kazan_2", { event_mdown = private.clk_kazan_2 } },
    } );

    --------------------------------------------------------------------------------------------
    -- function use_duster () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_duster" ] = {
        type = "use",
        inv_obj = "inv_duster",
        use_place = "obj_deploy_inv_dutchoven_use_duster",
        room = "int_deploy_inv",
        zz = "deploy_inv_dutchoven",
        zz_gate = "inv_dutchoven"
      };    
      function use_duster_beg ()
    
        interface.InventoryItemRemove( "inv_duster" );
        ObjDelete( "obj_deploy_inv_dutchoven_use_duster" );
        
      end;
      function use_duster_end ()
      
        ObjMultiSet( { 
          { "obj_deploy_inv_dutchoven_clk_kazan", { input = true, active = true, visible = true } },
        } );
        ObjDelete( "anm_deploy_inv_dutchoven_open_cap" );
        ObjDelete( "anm_deploy_inv_dutchoven_cap_hot"  );
                  
      end;
      cmn.AddSubscriber( "use_duster", use_duster_beg );
      cmn.AddSubscriber( "use_duster", use_duster_end, "inv_dutchoven" );
      cmn.AddSubscriber( "use_duster_beg", use_duster_beg );
      cmn.AddSubscriber( "use_duster_end", use_duster_end, "inv_dutchoven" );  
       
    --------------------------------------------------------------------------------------------
    -- function clk_kazan () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_kazan" ] = {
        type = "click",
        use_place = "obj_deploy_inv_dutchoven_clk_kazan",
        room = "int_deploy_inv",
        zz = "deploy_inv_dutchoven",
        zz_gate = "inv_dutchoven"
      };
      
      local clk_kazan_beg = function ()

        ObjDelete( "obj_deploy_inv_dutchoven_clk_kazan" );
      
      end;
      local clk_kazan_end = function ()

        ObjMultiSet( { 
          { "anm_deploy_inv_dutchoven_bones_last_frame", {   alp = 1                                   } },
          { "obj_deploy_inv_dutchoven_clk_kazan_2",      { input = true, active = true, visible = true } },
        } );
        ObjDelete( "anm_deploy_inv_dutchoven_bones" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_kazan",     clk_kazan_beg                  );
      cmn.AddSubscriber( "clk_kazan",     clk_kazan_end, "inv_dutchoven" );
      cmn.AddSubscriber( "clk_kazan_beg", clk_kazan_beg                  );
      cmn.AddSubscriber( "clk_kazan_end", clk_kazan_end, "inv_dutchoven" ); 

    --------------------------------------------------------------------------------------------
    -- function clk_kazan_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_kazan_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_dutchoven_clk_kazan_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_dutchoven",
        zz_gate = "inv_dutchoven"
      };
      
      local clk_kazan_2_beg = function ()

        ObjDelete( "obj_deploy_inv_dutchoven_clk_kazan_2" );
      
      end;
      local clk_kazan_2_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_dutchoven_oldkey", {  input = true, alp = 1 } },
          { "gfx_deploy_inv_dutchoven_oldkey", { active = true          } },
        } );
        ObjDelete( "anm_deploy_inv_dutchoven_key_hot"  );
        ObjDelete( "anm_deploy_inv_dutchoven_take_key" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_kazan_2",     clk_kazan_2_beg                  );
      cmn.AddSubscriber( "clk_kazan_2",     clk_kazan_2_end, "inv_dutchoven" );
      cmn.AddSubscriber( "clk_kazan_2_beg", clk_kazan_2_beg                  );
      cmn.AddSubscriber( "clk_kazan_2_end", clk_kazan_2_end, "inv_dutchoven" ); 

    --------------------------------------------------------------------------------------------
    -- function get_oldkey () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_oldkey" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_dutchoven_oldkey",
        room = "int_deploy_inv",
        zz = "deploy_inv_dutchoven",
        zz_gate = "inv_dutchoven"
      };
      local get_oldkey_inv = function ()
              
        interface.InventoryItemRemove( "inv_dutchoven" );        
        interface.InventoryItemAdd( "inv_oldkey", "spr_deploy_inv_dutchoven_oldkey" );

      end;
      local get_oldkey = function ()

        ObjDelete( "gfx_deploy_inv_dutchoven_oldkey"   );

      end;
      cmn.AddSubscriber( "get_oldkey", get_oldkey_inv );
      cmn.AddSubscriber( "get_oldkey", get_oldkey, "inv_dutchoven" );
   
  end;
  
  -- USE ---------------------------------------------------------------------------------------
  function public.use_duster ()

    local item = "inv_duster";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_dutchoven_use_duster" ) then

      cmn.CallEventHandler( "use_duster_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_duster" );
        cmn.CallEventHandler( "use_duster_end", "inv_dutchoven" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level2/sfx/aud_opn_pan", 0, "", 0 );

      ObjMultiSet( { 
        { "anm_deploy_inv_dutchoven_cap_hot", { alp = 0 } },
      } );
      AnimPlay( "anm_deploy_inv_dutchoven_open_cap", "open_cap", func_end );
      
      return true; 

    end;

    return false;

  end; 
  
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_kazan ()
    
    cmn.CallEventHandler( "clk_kazan_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_kazan" );
      cmn.CallEventHandler( "clk_kazan_end", "inv_dutchoven" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_stick", 0, "", 0 );

    AnimPlay( "anm_deploy_inv_dutchoven_bones", "bones", func_end );

  end; 

 -- CLK ------------------------------------------------------------------------------------------
  function private.clk_kazan_2 ()
    
    cmn.CallEventHandler( "clk_kazan_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_kazan_2" );
      cmn.CallEventHandler( "clk_kazan_2_end", "inv_dutchoven" ); 

      private.get_oldkey();

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_take_key", 0, "", 0 );

    ObjMultiSet( { 
      { "anm_deploy_inv_dutchoven_key_hot",  { alp = 0 } },
      { "anm_deploy_inv_dutchoven_take_key", { alp = 1 } }
    } );
    AnimPlay( "anm_deploy_inv_dutchoven_take_key", "take_key", func_end );
   
  end; 

   -- GET ------------------------------------------------------------------------------------------
  function private.get_oldkey ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_oldkey" );
    cmn.CallEventHandler( "get_oldkey", "inv_dutchoven" );
        
    common_impl.HideDeployInv();

  end;     
  
--*********************************************************************************************************************
-- function *** trashcan *** () end;
--*********************************************************************************************************************
  function private.trashcan_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_trashcan_amuletleaf",     { event_mdown = private.get_amuletleaf } },
      { "obj_deploy_inv_trashcan_clk_trashcan_1", { event_mdown = private.clk_trashcan_1 } },
      { "obj_deploy_inv_trashcan_clk_trashcan_2", { event_mdown = private.clk_trashcan_2 } },
    } );
       
    --------------------------------------------------------------------------------------------
    -- function clk_trashcan_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_trashcan_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_trashcan_clk_trashcan_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_trashcan",
        zz_gate = "inv_trashcan"
      };
      
      local clk_trashcan_1_beg = function ()

        ObjDelete( "obj_deploy_inv_trashcan_clk_trashcan_1" );
      
      end;
      local clk_trashcan_1_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_trashcan_top_open",       {   alp = 1                                   } },
          { "obj_deploy_inv_trashcan_clk_trashcan_2", { input = true, active = true, visible = true } },
        } );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_trashcan_1",     clk_trashcan_1_beg );
      cmn.AddSubscriber( "clk_trashcan_1",     clk_trashcan_1_end, "inv_trashcan" );
      cmn.AddSubscriber( "clk_trashcan_1_beg", clk_trashcan_1_beg );
      cmn.AddSubscriber( "clk_trashcan_1_end", clk_trashcan_1_end, "inv_trashcan" ); 

    --------------------------------------------------------------------------------------------
    -- function clk_trashcan_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_trashcan_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_trashcan_clk_trashcan_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_trashcan",
        zz_gate = "inv_trashcan"
      };
      
      local clk_trashcan_2_beg = function ()

        ObjDelete( "obj_deploy_inv_trashcan_clk_trashcan_2" );
      
      end;
      local clk_trashcan_2_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_trashcan_amuletleaf", {  input = true } },
          { "gfx_deploy_inv_trashcan_amuletleaf", { active = true } },
        } );
        ObjDelete( "obj_deploy_inv_trashcan_trash" )
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_trashcan_2",     clk_trashcan_2_beg );
      cmn.AddSubscriber( "clk_trashcan_2",     clk_trashcan_2_end, "inv_trashcan" );
      cmn.AddSubscriber( "clk_trashcan_2_beg", clk_trashcan_2_beg );
      cmn.AddSubscriber( "clk_trashcan_2_end", clk_trashcan_2_end, "inv_trashcan" ); 

    --------------------------------------------------------------------------------------------
    -- function get_amuletleaf () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_amuletleaf" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_trashcan_amuletleaf",
        room = "int_deploy_inv",
        zz = "deploy_inv_trashcan",
        zz_gate = "inv_trashcan"
      };
      local get_amuletleaf_inv = function ()
              
        interface.InventoryItemRemove( "inv_trashcan" );        
        interface.InventoryItemAdd( "inv_amuletleaf", "spr_deploy_inv_trashcan_amuletleaf" );

      end;
      local get_amuletleaf = function ()

        ObjDelete( "gfx_deploy_inv_trashcan_amuletleaf" );

      end;
      cmn.AddSubscriber( "get_amuletleaf", get_amuletleaf_inv );
      cmn.AddSubscriber( "get_amuletleaf", get_amuletleaf, "inv_trashcan" );
   
  end; 
   
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_trashcan_1 ()
    
    cmn.CallEventHandler( "clk_trashcan_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_trashcan_1" );
      cmn.CallEventHandler( "clk_trashcan_1_end", "inv_trashcan" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_bucket", 0, "", 0 );

    ObjAnimate( "obj_deploy_inv_trashcan_top_open", "alp", 0, 0, func_end, { 0.0,0,0,  0.3,0,1 } );

  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_trashcan_2 ()

    cmn.CallEventHandler( "clk_trashcan_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_trashcan_2" );
      cmn.CallEventHandler( "clk_trashcan_2_end", "inv_trashcan" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_debris", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_trashcan_trash_1", "pos_xy", 0, 0, func_end, { 
      0.0,0,ObjGet("spr_deploy_inv_trashcan_trash_1").pos_x, ObjGet("spr_deploy_inv_trashcan_trash_1").pos_y,  
      0.6,0,ObjGet("spr_deploy_inv_trashcan_trash_1").pos_x, ObjGet("spr_deploy_inv_trashcan_trash_1").pos_y, 
      0.9,0,51, -126 
    } );
    ObjAnimate( "spr_deploy_inv_trashcan_trash_2", "pos_xy", 0, 0,       "", { 
      0.0,0, ObjGet("spr_deploy_inv_trashcan_trash_2").pos_x, ObjGet("spr_deploy_inv_trashcan_trash_2").pos_y,
      0.4,0, ObjGet("spr_deploy_inv_trashcan_trash_2").pos_x, ObjGet("spr_deploy_inv_trashcan_trash_2").pos_y, 
      0.7,0, 50, -123, 
    } );
    ObjAnimate( "spr_deploy_inv_trashcan_trash_3", "pos_xy", 0, 0,       "", { 
      0.0,0, ObjGet("spr_deploy_inv_trashcan_trash_3").pos_x, ObjGet("spr_deploy_inv_trashcan_trash_3").pos_y,
      0.2,0, ObjGet("spr_deploy_inv_trashcan_trash_3").pos_x, ObjGet("spr_deploy_inv_trashcan_trash_3").pos_y,   
      0.5,0,-75, -135, 
    } );
    ObjAnimate( "spr_deploy_inv_trashcan_trash_4", "pos_xy", 0, 0,       "", { 
      0.0,0, ObjGet("spr_deploy_inv_trashcan_trash_4").pos_x, ObjGet("spr_deploy_inv_trashcan_trash_4").pos_y,  
      0.3,0, -15, -123 
    } );

  end;

   -- GET ------------------------------------------------------------------------------------------
  function private.get_amuletleaf ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_amuletleaf" );
    cmn.CallEventHandler( "get_amuletleaf", "inv_trashcan" );
        
    common_impl.HideDeployInv();
   
  end;     
  

--*********************************************************************************************************************
-- function *** flask *** () end;
--*********************************************************************************************************************
  function private.flask_init ()

    ObjMultiSet( { 
      { "obj_deploy_inv_flask_cleaningsprayer", { event_mdown = private.get_cleaningsprayer } },
    } );

    --------------------------------------------------------------------------------------------
    -- function use_sprayer () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_sprayer" ] = {
        type = "use",
        inv_obj = "inv_sprayer",
        use_place = "obj_deploy_inv_flask_use_sprayer",
        room = "int_deploy_inv",
        zz = "deploy_inv_flask",
        zz_gate = "inv_flask"
      };    
      function use_sprayer_beg ()
        
        interface.InventoryItemRemove( "inv_sprayer" );
        ObjDelete( "obj_deploy_inv_flask_use_sprayer" );
        
      end;
      function use_sprayer_end ()

        ObjMultiSet( {
          { "obj_deploy_inv_flask_cleaningsprayer",   {  input = true } },
          { "gfx_deploy_inv_flask_cleaningsprayer",   { active = true } },

          { "spr_deploy_inv_flask_sprayer_back_part", { alp = 1, pos_x = -1,  pos_y = -84  } },
          { "spr_deploy_inv_flask_sprayer_top_part",  { alp = 1, pos_x = -26, pos_y = -247 } }
        } );
        
      end;
      cmn.AddSubscriber( "use_sprayer",     use_sprayer_beg              );
      cmn.AddSubscriber( "use_sprayer",     use_sprayer_end, "inv_flask" );
      cmn.AddSubscriber( "use_sprayer_beg", use_sprayer_beg              );
      cmn.AddSubscriber( "use_sprayer_end", use_sprayer_end, "inv_flask" );  
      
    --------------------------------------------------------------------------------------------
    -- function use_cleaner () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_cleaner" ] = {
        type = "use",
        inv_obj = "inv_cleaner",
        use_place = "obj_deploy_inv_flask_use_cleaner",
        room = "int_deploy_inv",
        zz = "deploy_inv_flask",
        zz_gate = "inv_flask"
      };    
      function use_cleaner_beg ()
        
        interface.InventoryItemRemove( "inv_cleaner" );
        ObjDelete( "obj_deploy_inv_flask_use_cleaner" );
        
        if not cmn.IsEventDone( "get_sprayer" ) then
    
          cmn.SetInvPlusRGB( "flask", false );
      
        end;
        
      end;
      function use_cleaner_end ()

        ObjMultiSet( {
          { "obj_deploy_inv_flask_use_sprayer",          { visible = true, input = true, active = true } },
          { "spr_deploy_inv_flask_cleaner_liquid",       {     alp = 1                                 } },
          { "spr_deploy_inv_flask_cleaner_liquid_patch", {     alp = 1                                 } },
          { "obj_deploy_inv_flask_cleaningsprayer",      {     alp = 1                                 } },
        } );
        ObjDelete( "vid_deploy_inv_flask_flacon" );

      end;
      cmn.AddSubscriber( "use_cleaner",     use_cleaner_beg              );
      cmn.AddSubscriber( "use_cleaner",     use_cleaner_end, "inv_flask" );
      cmn.AddSubscriber( "use_cleaner_beg", use_cleaner_beg              );
      cmn.AddSubscriber( "use_cleaner_end", use_cleaner_end, "inv_flask" );         
       
    --------------------------------------------------------------------------------------------
    -- function get_cleaningsprayer () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_cleaningsprayer" ] = {
        type = "get",
        get_obj = "obj_deploy_inv_flask_cleaningsprayer",
        room = "int_deploy_inv",
        zz = "deploy_inv_flask",
        zz_gate = "inv_flask"
      };
      local get_cleaningsprayer_inv = function ()
              
        interface.InventoryItemRemove( "inv_flask" );        
        interface.InventoryItemAdd( "inv_cleaningsprayer", "obj_deploy_inv_flask_cleaningsprayer" );

      end;
      local get_cleaningsprayer = function ()

        ObjDelete( "gfx_deploy_inv_flask_cleaningsprayer" );

      end;
      cmn.AddSubscriber( "get_cleaningsprayer", get_cleaningsprayer_inv );
      cmn.AddSubscriber( "get_cleaningsprayer", get_cleaningsprayer, "inv_flask" );
   
  end;
  
  -- USE ---------------------------------------------------------------------------------------
  function public.use_sprayer ()

    local item = "inv_sprayer";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_flask_use_sprayer" ) and cmn.IsEventDone( "use_cleaner" ) then

      cmn.CallEventHandler( "use_sprayer_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_sprayer" );
        cmn.CallEventHandler( "use_sprayer_end", "inv_flask" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level2/sfx/aud_use_sprayer" );

      ObjAnimate( "spr_deploy_inv_flask_sprayer_top_part", "alp", 0, 0, "", { 
        0.0, 0, ObjGet( "spr_deploy_inv_flask_sprayer_top_part" ).alp,
        0.3, 0, 1, 
      } );
      ObjAnimate( "spr_deploy_inv_flask_sprayer_back_part", "alp", 0, 0, "", { 
        0.0, 0, ObjGet( "spr_deploy_inv_flask_sprayer_back_part" ).alp,
        0.3, 0, 1, 
      } );
      
      ObjAnimate( "spr_deploy_inv_flask_sprayer_top_part", "pos_xy", 0, 0, func_end, { 
        0.0, 0, ObjGet( "spr_deploy_inv_flask_sprayer_top_part" ).pos_x, ObjGet( "spr_deploy_inv_flask_sprayer_top_part" ).pos_y,
        0.6, 0, -26, -247,
      } );
      ObjAnimate( "spr_deploy_inv_flask_sprayer_back_part", "pos_xy", 0, 0, "", { 
        0.0, 0, ObjGet( "spr_deploy_inv_flask_sprayer_back_part" ).pos_x, ObjGet( "spr_deploy_inv_flask_sprayer_back_part" ).pos_y,
        0.6, 0, -1, -84,
      } );      
      
      return true; 

    end;

    return false;

  end;  
  
  -- USE ---------------------------------------------------------------------------------------
  function public.use_cleaner ()

    local item = "inv_cleaner";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_flask_use_cleaner" ) then

      cmn.CallEventHandler( "use_cleaner_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_cleaner" );
        cmn.CallEventHandler( "use_cleaner_end", "inv_flask" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level2/sfx/aud_use_cleaner" );

      VidPlay( "vid_deploy_inv_flask_flacon", func_end );
      
      return true; 

    end;

    return false;

  end;  
  
   -- GET ------------------------------------------------------------------------------------------
  function private.get_cleaningsprayer ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_cleaningsprayer" );
    cmn.CallEventHandler( "get_cleaningsprayer", "inv_flask" );
        
    common_impl.HideDeployInv();
   
  end;     
  

--*********************************************************************************************************************
-- function *** decoration *** () end;
--*********************************************************************************************************************
  function private.decoration_init ()

    ObjMultiSet( { 
      { "spr_deploy_inv_decoration_artificialeye",         { event_mdown = private.get_artificialeye } },
    } );
       
    --------------------------------------------------------------------------------------------
    -- function get_artificialeye () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_artificialeye" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_decoration_artificialeye",
        room = "int_deploy_inv",
        zz = "deploy_inv_decoration",
        zz_gate = "inv_decoration"
      };
      local get_artificialeye_inv = function ()
              
        interface.InventoryItemRemove( "inv_decoration" );        
        interface.InventoryItemAdd( "inv_artificialeye", "spr_deploy_inv_decoration_artificialeye" );

      end;
      local get_artificialeye = function ()

        ObjDelete( "gfx_deploy_inv_decoration_artificialeye" );

      end;
      cmn.AddSubscriber( "get_artificialeye", get_artificialeye_inv );
      cmn.AddSubscriber( "get_artificialeye", get_artificialeye, "inv_decoration" );
   
  end; 
   
   -- GET ------------------------------------------------------------------------------------------
  function private.get_artificialeye ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_artificialeye" );
    cmn.CallEventHandler( "get_artificialeye", "inv_decoration" );
        
    common_impl.HideDeployInv();
   
  end;     

  
  
  
  