-- name=rm_cemetery
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cemetery";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet( { 
    { "obj_cemetery_clk_outro",          { event_mdown = private.see_cemetery_outro_2 }},
    { "spr_cemetery_collect_morph_item", { event_mdown = function() 
                                                            common_impl.GetMorphItem( "get_collect_morph_item_13" ); 
                                                         end } },
  } );
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_cemetery = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_cemetery", update_game_mode_cemetery, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_cemetery = function ()

  local effects_table = 
  {
    "obj_cemetery_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_cemetery", update_performance_mode_cemetery, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_cemetery () end;
  --------------------------------------------------------------------------------------------
  local opn_cemetery_map = function ()

    common_impl.VisitMapRoom( "cemetery" );

  end;
  cmn.AddSubscriber( "opn_cemetery", opn_cemetery_map );
  
 --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_13 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_13 = function ()
  
    ObjDelete( "obj_cemetery_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_13", get_collect_morph_item_13, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function see_cemetery_outro_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_cemetery_outro_2" ] = {
    type = "click",
    use_place = "obj_cemetery_clk_outro",
    room = private.room_objname,
  };  
  local see_cemetery_outro_2 = function ()

    ObjDelete( "obj_cemetery_clk_outro" );

  end;
  cmn.AddSubscriber( "see_cemetery_outro_2", see_cemetery_outro_2, private.room_objname );    
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_cemetery();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  if cmn.IsEventDone( "opn_cemetery" ) and not cmn.IsEventDone( "see_cemetery_outro_2" ) then
    private.see_cemetery_outro_2 ();
  end;

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt ) 
end;
--*********************************************************************************************************************
function private.see_cemetery_outro_2 ()
  
  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "level2/voc/aud_cemetery_outro2_voc",  0.2 );
      common_impl.StopAudio( "sfx", "level2/sfx/aud_cemetery_outro2",      0.2 );
      
    end;

    cmn.SetEventDone( "see_cemetery_outro_2" );
    cmn.CallEventHandler( "see_cemetery_outro_2" );

    SetCursor(CURSOR_DEFAULT);
    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level3";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;

    common.LevelSwitch( level );
    
  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_cemetery_outro2", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level2/voc/aud_cemetery_outro2_voc",  0, "", 0 );

  cmn.PlayDialogVideo( "vid_cemetery_outro_2", func_end );
  
end;

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_cemetery ()

  if not ( cmn.IsEventDone( "opn_cemetery" ) ) then

    cmn.SetEventDone( "opn_cemetery" );

    private.see_cemetery_outro_2();

  end;
  cmn.CallEventHandler( "opn_cemetery" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************