-- name=rm_eventshall
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_eventshall";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_stainedglass", "room_hub" );
  ObjAttach( "zz_kitchen", "room_hub" );
  ObjAttach( "zz_tablewithfood", "room_hub" );
  ObjAttach( "zz_stage", "room_hub" );
  ObjAttach( "zz_librarydoor", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  private.InitKitchen();
  
  ObjMultiSet({ 
    { "spr_stainedglass_ironhandle",         { event_mdown = private.get_ironhandle        }},
    { "spr_stainedglass_oldamulet",          { event_mdown = private.get_oldamulet         }},
    { "spr_stainedglass_turner",             { event_mdown = private.get_turner            }},
    { "spr_stainedglass_figurineshape",      { event_mdown = private.get_figurineshape     }},
    { "obj_stainedglass_clk_old_gear",       { event_mdown = private.clk_old_gear          }},
    { "obj_stainedglass_use_thread",         { event_mdown = private.UseThread             }},
    { "spr_kitchen_rod_2",                   { event_mdown = private.get_rod_2             }},
    { "spr_kitchen_hook",                    { event_mdown = private.get_hook_lvl2         }},
    { "spr_kitchen_animalstatuette",         { event_mdown = private.get_animalstatuette   }},
    { "spr_kitchen_dutchoven",               { event_mdown = private.get_dutchoven         }},
    { "obj_kitchen_clk_kitchen_handle",      { event_mdown = private.clk_kitchen_handle    }},
    { "obj_kitchen_clk_oven_handle",         { event_mdown = private.clk_oven_handle       }},
    
    { "spr_tablewithfood_longstick",         { event_mdown = private.get_longstick         }},
    { "spr_tablewithfood_stainedglasspart3", { event_mdown = private.get_stainedglasspart3 }},
    { "spr_tablewithfood_awl_needle",        { event_mdown = private.get_awl               }},
    { "spr_tablewithfood_awl_handle",        { event_mdown = private.get_awl               }},
    { "obj_tablewithfood_use_awlhandle",     { event_mdown = private.UseAwlhandle          }},
    { "obj_tablewithfood_use_saw",           { event_mdown = private.UseSaw                }},
    
    { "spr_stage_whistle",                   { event_mdown = private.get_whistle           }},
    { "spr_stage_stainedglasspart1",         { event_mdown = private.get_stainedglasspart1 }},
    { "spr_stage_cleaner",                   { event_mdown = private.get_cleaner           }},
    { "obj_stage_clk_stage_box",             { event_mdown = private.clk_stage_box         }},
    { "obj_stage_clk_button_lvl2",           { event_mdown = private.clk_button_lvl2       }},
    { "obj_stage_use_button",                { event_mdown = private.AnimUseButton         }},
    
    { "spr_eventshall_grapesleaf2",          { event_mdown = private.get_grapesleaf2       }},
    { "obj_eventshall_use_whistle",          { event_mdown = private.UseWhistle            }},
    
    { "obj_librarydoor_clk_oldkey",          { event_mdown = private.clk_oldkey            }},
      
    { "spr_eventshall_collect_morph_item",   { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_10" ); end } },
      
    { "spr_stage_collect2_item_13",          { event_mdown = private.get_collect2_item_13   } },
    { "spr_tablewithfood_collect2_item_14",  { event_mdown = private.get_collect2_item_14   } },    
      
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_eventshall = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gzz_eventshall_stainedglass",
      "gzz_eventshall_kitchen",
      "gzz_eventshall_tablewithfood",
      "gzz_eventshall_stage",
      "gzz_eventshall_librarydoor",
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_stainedglass",
      "zz_kitchen",
      "zz_tablewithfood",
      "zz_stage",
      "zz_librarydoor",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_eventshall", update_game_mode_eventshall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_eventshall = function ()

  local effects_table = 
  {
    "obj_eventshall_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_eventshall", update_performance_mode_eventshall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_eventshall () end;
  --------------------------------------------------------------------------------------------
  local opn_eventshall_map = function ()

    common_impl.VisitMapRoom( "eventshall" );

  end;
  cmn.AddSubscriber( "opn_eventshall", opn_eventshall_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_10 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_10 = function ()
  
    ObjDelete( "obj_eventshall_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_10", get_collect_morph_item_10, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_ironhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ironhandle" ] = {
    type = "get",
    get_obj = "spr_stainedglass_ironhandle",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  
  local get_ironhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_ironhandle", "spr_stainedglass_ironhandle" );
  
  end;
  
  local get_ironhandle_closezz = function ()
  
    ObjDelete( "gfx_stainedglass_ironhandle" );
    ObjDelete( "spr_stainedglass_patch_handle" );
    
  end;
  
  cmn.AddSubscriber( "get_ironhandle", get_ironhandle_inv );
  cmn.AddSubscriber( "get_ironhandle", get_ironhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oldamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oldamulet" ] = {
    type = "get",
    get_obj = "spr_stainedglass_oldamulet",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  
  local get_oldamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_oldamulet", "spr_stainedglass_oldamulet" );
  
  end;
  
  local get_oldamulet_closezz = function ()
  
    ObjDelete( "gfx_stainedglass_oldamulet" );
    
    if ( cmn.IsEventDone( "get_figurineshape" ) ) then
      
      ObjDelete( "gzz_eventshall_stainedglass" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_oldamulet", get_oldamulet_inv );
  cmn.AddSubscriber( "get_oldamulet", get_oldamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurineshape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurineshape" ] = {
    type = "get",
    get_obj = "spr_stainedglass_figurineshape",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  
  local get_figurineshape_inv = function ()
  
    interface.InventoryItemAdd( "inv_figurineshape", "spr_stainedglass_figurineshape" );
  
  end;
  
  local get_figurineshape_closezz = function ()
  
    ObjDelete( "gfx_stainedglass_figurineshape" );
    
    if ( cmn.IsEventDone( "get_oldamulet" ) ) then
      
      ObjDelete( "gzz_eventshall_stainedglass" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_figurineshape", get_figurineshape_inv );
  cmn.AddSubscriber( "get_figurineshape", get_figurineshape_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hook_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hook_lvl2" ] = {
    type = "get",
    get_obj = "spr_kitchen_hook",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  
  local get_hook_lvl2_inv = function ()
  
    interface.InventoryItemAdd( "inv_hook_lvl2", "spr_kitchen_hook" );
  
  end;
  
  local get_hook_lvl2_closezz = function ()
  
    ObjDelete( "gfx_kitchen_hook" );
  
  end;
  
  cmn.AddSubscriber( "get_hook_lvl2", get_hook_lvl2_inv );
  cmn.AddSubscriber( "get_hook_lvl2", get_hook_lvl2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_animalstatuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_animalstatuette" ] = {
    type = "get",
    get_obj = "spr_kitchen_animalstatuette",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  
  local get_animalstatuette_inv = function ()
  
    interface.InventoryItemAdd( "inv_animalstatuette", "spr_kitchen_animalstatuette" );
  
  end;
  
  local get_animalstatuette_closezz = function ()
  
    ObjDelete( "gfx_kitchen_animalstatuette" );
    ObjDelete( "gzz_eventshall_kitchen" );
  
  end;
  
  cmn.AddSubscriber( "get_animalstatuette", get_animalstatuette_inv );
  cmn.AddSubscriber( "get_animalstatuette", get_animalstatuette_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dutchoven () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dutchoven" ] = {
    type = "get",
    get_obj = "spr_kitchen_dutchoven",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  
  local get_dutchoven_inv = function ()
  
    interface.InventoryItemAdd( "inv_dutchoven", "spr_kitchen_dutchoven" );
    ObjSet( "inv_dutchoven", { drag = false } );
    
    if not cmn.IsEventDone( "get_duster" ) then
    
      cmn.SetInvPlusRGB( "dutchoven", false );
      
    end;
  
  end;
  
  local get_dutchoven_closezz = function ()
  
    ObjDelete( "gfx_kitchen_dutchoven" );
  
  end;
  
  cmn.AddSubscriber( "get_dutchoven", get_dutchoven_inv );
  cmn.AddSubscriber( "get_dutchoven", get_dutchoven_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_longstick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_longstick" ] = {
    type = "get",
    get_obj = "spr_tablewithfood_longstick",
    room = private.room_objname,
    zz = "zz_tablewithfood",
    zz_gate = "gzz_eventshall_tablewithfood"
  };
  
  local get_longstick_inv = function ()
  
    interface.InventoryItemAdd( "inv_longstick", "spr_tablewithfood_longstick" );
  
  end;
  
  local get_longstick_closezz = function ()
  
    ObjDelete( "gfx_tablewithfood_longstick" );
    ObjDelete( "spr_eventshall_chearstick" );
    
  end;
  
  cmn.AddSubscriber( "get_longstick", get_longstick_inv );
  cmn.AddSubscriber( "get_longstick", get_longstick_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stainedglasspart3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stainedglasspart3" ] = {
    type = "get",
    get_obj = "spr_tablewithfood_stainedglasspart3",
    room = private.room_objname,
    zz = "zz_tablewithfood",
    zz_gate = "gzz_eventshall_tablewithfood"
  };
  
  local get_stainedglasspart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_stainedglasspart3", "spr_tablewithfood_stainedglasspart3" );
  
  end;
  
  local get_stainedglasspart3_closezz = function ()
  
    ObjDelete( "gfx_tablewithfood_stainedglasspart3" );
      
  end;
  
  cmn.AddSubscriber( "get_stainedglasspart3", get_stainedglasspart3_inv );
  cmn.AddSubscriber( "get_stainedglasspart3", get_stainedglasspart3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_awl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_awl" ] = {
    type = "get",
    get_obj = "obj_tablewithfood_awl",
    room = private.room_objname,
    zz = "zz_tablewithfood",
    zz_gate = "gzz_eventshall_tablewithfood"
  };
  
  local get_awl_inv = function ()
  
    interface.InventoryItemAdd( "inv_awl", "obj_tablewithfood_awl" );
  
  end;
  
  local get_awl_closezz = function ()
  
    ObjDelete( "gfx_tablewithfood_awl" );
    ObjDelete( "spr_tablewithfood_awl_over" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_14" ) ) then
      
      ObjDelete( "gzz_eventshall_tablewithfood" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_awl", get_awl_inv );
  cmn.AddSubscriber( "get_awl", get_awl_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_whistle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_whistle" ] = {
    type = "get",
    get_obj = "spr_stage_whistle",
    room = private.room_objname,
    zz = "zz_stage",
    zz_gate = "gzz_eventshall_stage"
  };
  
  local get_whistle_inv = function ()
  
    interface.InventoryItemAdd( "inv_whistle", "spr_stage_whistle" );
  
  end;
  
  local get_whistle_closezz = function ()
  
    ObjDelete( "gfx_stage_whistle" );
  
  end;
  
  cmn.AddSubscriber( "get_whistle", get_whistle_inv );
  cmn.AddSubscriber( "get_whistle", get_whistle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stainedglasspart1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stainedglasspart1" ] = {
    type = "get",
    get_obj = "spr_stage_stainedglasspart1",
    room = private.room_objname,
    zz = "zz_stage",
    zz_gate = "gzz_eventshall_stage"
  };
  
  local get_stainedglasspart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_stainedglasspart1", "spr_stage_stainedglasspart1" );
  
  end;
  
  local get_stainedglasspart1_closezz = function ()
  
    ObjDelete( "gfx_stage_stainedglasspart1" );
  
  end;
  
  cmn.AddSubscriber( "get_stainedglasspart1", get_stainedglasspart1_inv );
  cmn.AddSubscriber( "get_stainedglasspart1", get_stainedglasspart1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cleaner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cleaner" ] = {
    type = "get",
    get_obj = "spr_stage_cleaner",
    room = private.room_objname,
    zz = "zz_stage",
    zz_gate = "gzz_eventshall_stage"
  };
  
  local get_cleaner_inv = function ()
  
    interface.InventoryItemAdd( "inv_cleaner", "spr_stage_cleaner" );
    cmn.SetInvPlusRGB( "flask", true );
  
  end;
  
  local get_cleaner_closezz = function ()
  
    ObjDelete( "gfx_stage_cleaner" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_13" ) ) then
      
      ObjDelete( "gzz_eventshall_stage" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_cleaner", get_cleaner_inv );
  cmn.AddSubscriber( "get_cleaner", get_cleaner_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_grapesleaf2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_grapesleaf2" ] = {
    type = "get",
    get_obj = "spr_eventshall_grapesleaf2",
    room = private.room_objname
  };
  
  local get_grapesleaf2_inv = function ()
  
    interface.InventoryItemAdd( "inv_grapesleaf2", "spr_eventshall_grapesleaf2" );
  
  end;
  
  local get_grapesleaf2_closezz = function ()
  
    ObjDelete( "gfx_eventshall_grapesleaf2" );
  
  end;
  
  cmn.AddSubscriber( "get_grapesleaf2", get_grapesleaf2_inv );
  cmn.AddSubscriber( "get_grapesleaf2", get_grapesleaf2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_turner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_turner" ] = {
    type = "get",
    get_obj = "spr_stainedglass_turner",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  
  local get_turner_inv = function ()
  
    interface.InventoryItemAdd( "inv_turner", "spr_stainedglass_turner" );
  
  end;
  
  local get_turner_closezz = function ()
  
    ObjDelete( "gfx_stainedglass_turner" );
    ObjDelete( "spr_stainedglass_turner_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_turner", get_turner_inv );
  cmn.AddSubscriber( "get_turner", get_turner_closezz, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_rod_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rod_2" ] = {
    type = "get",
    get_obj = "spr_kitchen_rod_2",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  
  local get_rod_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_rod_2", "spr_kitchen_rod_2" );
    ObjSet( "inv_rod_2", { drag = false } );
  
  end;
  
  local get_rod_2_closezz = function ()
  
    ObjDelete( "gfx_kitchen_rod_2" );
  
  end;
  
  cmn.AddSubscriber( "get_rod_2", get_rod_2_inv );
  cmn.AddSubscriber( "get_rod_2", get_rod_2_closezz, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_13 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_13 = function ()
  
    ObjDelete( "obj_stage_collect2_item_13" ); 
  
    if ( cmn.IsEventDone( "get_cleaner" ) ) then
      
      ObjDelete( "gzz_eventshall_stage" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_13", get_collect2_item_13, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_14 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_14 = function ()
  
    ObjDelete( "obj_tablewithfood_collect2_item_14" ); 
  
    if ( cmn.IsEventDone( "get_awl" ) ) then
      
      ObjDelete( "gzz_eventshall_tablewithfood" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_14", get_collect2_item_14, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function use_stainedglasspart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stainedglasspart2" ] = {
    type = "use",
    inv_obj = "inv_stainedglasspart2",
    use_place = "obj_stainedglass_use_stainedglasspart2",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  local use_stainedglasspart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_stainedglasspart2" );
  
  end;
  local use_stainedglasspart2_beg = function ()
  
    ObjDelete( "obj_stainedglass_use_stainedglasspart2" );
  
  end;
  local use_stainedglasspart2_end = function ()
  
    if ( cmn.IsEventDone( "use_stainedglasspart1" ) and 
    cmn.IsEventDone( "use_stainedglasspart3" ) ) then
    
      ObjDelete( "obj_stainedglass_stainedglass_use" )
      ObjDelete( "obj_stainedglass_stainedglass" );
      ObjDelete( "obj_stainedglass_stainedglass_game" )
      ObjDelete( "spr_eventshall_mosaic" )
      ObjSet( "spr_stainedglass_ironhandle", { input = true, active = true } )
      ObjSet( "obj_stainedglass_clk_old_gear", { input = true, active = true } )

    end;

    ObjMultiSet( { 
      { "spr_stainedglass_mosaic_piece_2",  { alp = 1 } },
      { "spr_eventshall_piece_1",           { alp = 1 } },
    } );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stainedglasspart2", use_stainedglasspart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart2", use_stainedglasspart2_inv );
  cmn.AddSubscriber( "use_stainedglasspart2", use_stainedglasspart2_end, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart2_inv", use_stainedglasspart2_inv, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart2_beg", use_stainedglasspart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart2_end", use_stainedglasspart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stainedglasspart1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stainedglasspart1" ] = {
    type = "use",
    inv_obj = "inv_stainedglasspart1",
    use_place = "obj_stainedglass_use_stainedglasspart1",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  local use_stainedglasspart1_inv = function ()
  
    interface.InventoryItemRemove( "inv_stainedglasspart1" );
  
  end;
  local use_stainedglasspart1_beg = function ()
  
    ObjDelete( "obj_stainedglass_use_stainedglasspart1" );
  
  end;
  local use_stainedglasspart1_end = function ()
  
    if ( cmn.IsEventDone( "use_stainedglasspart2" ) and 
    cmn.IsEventDone( "use_stainedglasspart3" ) ) then
    
      ObjDelete( "obj_stainedglass_stainedglass_use" )
      ObjDelete( "obj_stainedglass_stainedglass" );
      ObjDelete( "obj_stainedglass_stainedglass_game" )
      ObjDelete( "spr_eventshall_mosaic" )
      ObjSet( "spr_stainedglass_ironhandle", { input = true, active = true } )
      ObjSet( "obj_stainedglass_clk_old_gear", { input = true, active = true } )
      
    end;

    ObjMultiSet( { 
      { "spr_stainedglass_mosaic_piece_1",  { alp = 1 } },
      { "spr_eventshall_piece_3",           { alp = 1 } },
    } );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stainedglasspart1", use_stainedglasspart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart1", use_stainedglasspart1_inv );
  cmn.AddSubscriber( "use_stainedglasspart1", use_stainedglasspart1_end, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart1_inv", use_stainedglasspart1_inv, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart1_beg", use_stainedglasspart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart1_end", use_stainedglasspart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stainedglasspart3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stainedglasspart3" ] = {
    type = "use",
    inv_obj = "inv_stainedglasspart3",
    use_place = "obj_stainedglass_use_stainedglasspart3",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  local use_stainedglasspart3_inv = function ()
  
    interface.InventoryItemRemove( "inv_stainedglasspart3" );
  
  end;
  local use_stainedglasspart3_beg = function ()
  
    ObjDelete( "obj_stainedglass_use_stainedglasspart3" );
  
  end;
  local use_stainedglasspart3_end = function ()
  
    if ( cmn.IsEventDone( "use_stainedglasspart1" ) and 
    cmn.IsEventDone( "use_stainedglasspart2" ) ) then
    
      ObjDelete( "obj_stainedglass_stainedglass_use" )
      ObjDelete( "obj_stainedglass_stainedglass_use" )
      ObjDelete( "obj_stainedglass_stainedglass" );
      ObjDelete( "obj_stainedglass_stainedglass_game" )
      ObjDelete( "spr_eventshall_mosaic" )
      ObjSet( "spr_stainedglass_ironhandle", { input = true, active = true } )
      ObjSet( "obj_stainedglass_clk_old_gear", { input = true, active = true } )

    end;

    ObjMultiSet( { 
      { "spr_stainedglass_mosaic_piece_3",  { alp = 1 } },
      { "spr_eventshall_piece_2",           { alp = 1 } },
    } );    
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stainedglasspart3", use_stainedglasspart3_beg, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart3", use_stainedglasspart3_inv );
  cmn.AddSubscriber( "use_stainedglasspart3", use_stainedglasspart3_end, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart3_inv", use_stainedglasspart3_inv, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart3_beg", use_stainedglasspart3_beg, private.room_objname );
  cmn.AddSubscriber( "use_stainedglasspart3_end", use_stainedglasspart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_thread () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_thread" ] = {
    type = "use",
    inv_obj = "inv_thread",
    use_place = "obj_stainedglass_use_thread",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  local use_thread_inv = function ()
  
    interface.InventoryItemRemove( "inv_thread" );
  
  end;
  local use_thread_beg = function ()
  
    ObjDelete( "obj_stainedglass_use_thread" );
  
  end;
  local use_thread_end = function ()
  
    ObjMultiSet( { 
      { "spr_stainedglass_oldamulet",     { active = true, input = true } },
      { "spr_stainedglass_figurineshape", { active = true, input = true } },
      { "spr_stainedglass_hole",          {  pos_y = -42                } },
      { "spr_stainedglass_gear",          {    alp = 1                  } },
      { "spr_stainedglass_chain1",        {    alp = 1                  } },
      { "spr_stainedglass_chain2",        {    alp = 1                  } },
      { "spr_eventshall_jaw",             {    alp = 1                  } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_thread", use_thread_beg, private.room_objname );
  cmn.AddSubscriber( "use_thread", use_thread_inv );
  cmn.AddSubscriber( "use_thread", use_thread_end, private.room_objname );
  cmn.AddSubscriber( "use_thread_inv", use_thread_inv, private.room_objname );
  cmn.AddSubscriber( "use_thread_beg", use_thread_beg, private.room_objname );
  cmn.AddSubscriber( "use_thread_end", use_thread_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spoon () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spoon" ] = {
    type = "use",
    inv_obj = "inv_spoon",
    use_place = "obj_kitchen_use_spoon",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  local use_spoon_inv = function ()
  
    interface.InventoryItemRemove( "inv_spoon" );
  
  end;
  local use_spoon_beg = function ()
  
    ObjDelete( "obj_kitchen_use_spoon" );
  
  end;
  local use_spoon_end = function ()
  
    ObjMultiSet( { 
      { "spr_kitchen_hook",  { active = true, input = true } },
      { "spr_kitchen_door_opened",  { alp = 1 } },
      { "spr_eventshall_door", { alp = 1 } },
      { "obj_kitchen_clk_oven_handle",  { visible = true, input = true } },
    } );
    ObjDelete( "spr_kitchen_door_closed" )
    ObjDelete( "vid_kitchen_spoon" )
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spoon", use_spoon_beg, private.room_objname );
  cmn.AddSubscriber( "use_spoon", use_spoon_inv );
  cmn.AddSubscriber( "use_spoon", use_spoon_end, private.room_objname );
  cmn.AddSubscriber( "use_spoon_inv", use_spoon_inv, private.room_objname );
  cmn.AddSubscriber( "use_spoon_beg", use_spoon_beg, private.room_objname );
  cmn.AddSubscriber( "use_spoon_end", use_spoon_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ironhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ironhandle" ] = {
    type = "use",
    inv_obj = "inv_ironhandle",
    use_place = "obj_kitchen_use_ironhandle",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  local use_ironhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_ironhandle" );
  
  end;
  local use_ironhandle_beg = function ()
  
    ObjDelete( "obj_kitchen_use_ironhandle" );
  
  end;
  local use_ironhandle_end = function ()
  
    ObjMultiSet( { 
      { "spr_kitchen_rod_2",  { visible = true, input = true } },
      { "obj_kitchen_use_ovenfork",  { input = true } },
      { "spr_kitchen_oven_open",  { alp = 1 } },
      { "anm_kitchen_use_ovenfork",  { alp = 1 } },
      { "obj_kitchen_oven_close",  { alp = 0 } },
    } );
    ObjDelete( "anm_kitchen_get_rod" )
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ironhandle", use_ironhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_ironhandle", use_ironhandle_inv );
  cmn.AddSubscriber( "use_ironhandle", use_ironhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_ironhandle_inv", use_ironhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_ironhandle_beg", use_ironhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_ironhandle_end", use_ironhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_figurineshape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_figurineshape" ] = {
    type = "use",
    inv_obj = "inv_figurineshape",
    use_place = "obj_kitchen_use_figurineshape",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  local use_figurineshape_inv = function ()
  
    interface.InventoryItemRemove( "inv_figurineshape" );
  
  end;
  local use_figurineshape_beg = function ()
  
    ObjDelete( "obj_kitchen_use_figurineshape" );
  
  end;
  local use_figurineshape_end = function ()
  
    ObjMultiSet( { 
      { "obj_kitchen_use_jugwithclay",  { input = true } },
      { "anm_kitchen_get_horse",  { alp = 1 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_figurineshape", use_figurineshape_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurineshape", use_figurineshape_inv );
  cmn.AddSubscriber( "use_figurineshape", use_figurineshape_end, private.room_objname );
  cmn.AddSubscriber( "use_figurineshape_inv", use_figurineshape_inv, private.room_objname );
  cmn.AddSubscriber( "use_figurineshape_beg", use_figurineshape_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurineshape_end", use_figurineshape_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ovenfork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ovenfork" ] = {
    type = "use",
    inv_obj = "inv_ovenfork",
    use_place = "obj_kitchen_use_ovenfork",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  local use_ovenfork_inv = function ()
  
    interface.InventoryItemRemove( "inv_ovenfork" );
  
  end;
  local use_ovenfork_beg = function ()
  
    ObjDelete( "obj_kitchen_use_ovenfork" );
  
  end;
  local use_ovenfork_end = function ()
  
    ObjMultiSet( { 
      { "obj_kitchen_use_figurineshape",  { input = true } },
      { "spr_kitchen_dutchoven",  { visible = true, input = true } },
    } );
    ObjDelete( "anm_kitchen_use_ovenfork" )
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ovenfork", use_ovenfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_ovenfork", use_ovenfork_inv );
  cmn.AddSubscriber( "use_ovenfork", use_ovenfork_end, private.room_objname );
  cmn.AddSubscriber( "use_ovenfork_inv", use_ovenfork_inv, private.room_objname );
  cmn.AddSubscriber( "use_ovenfork_beg", use_ovenfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_ovenfork_end", use_ovenfork_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_jugwithclay () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_jugwithclay" ] = {
    type = "use",
    inv_obj = "inv_jugwithclay",
    use_place = "obj_kitchen_use_jugwithclay",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  local use_jugwithclay_inv = function ()
  
    interface.InventoryItemRemove( "inv_jugwithclay" );
  
  end;
  local use_jugwithclay_beg = function ()
  
    ObjDelete( "obj_kitchen_use_jugwithclay" );
  
  end;
  local use_jugwithclay_end = function ()
      
    ObjMultiSet( { 
      { "obj_kitchen_minigame",  { alp = 1, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jugwithclay", use_jugwithclay_beg, private.room_objname );
  cmn.AddSubscriber( "use_jugwithclay", use_jugwithclay_inv );
  cmn.AddSubscriber( "use_jugwithclay", use_jugwithclay_end, private.room_objname );
  cmn.AddSubscriber( "use_jugwithclay_inv", use_jugwithclay_inv, private.room_objname );
  cmn.AddSubscriber( "use_jugwithclay_beg", use_jugwithclay_beg, private.room_objname );
  cmn.AddSubscriber( "use_jugwithclay_end", use_jugwithclay_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_saw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_saw" ] = {
    type = "use",
    inv_obj = "inv_saw",
    use_place = "obj_tablewithfood_use_saw",
    room = private.room_objname,
    zz = "zz_tablewithfood",
    zz_gate = "gzz_eventshall_tablewithfood"
  };
  local use_saw_inv = function ()
  
    interface.InventoryItemRemove( "inv_saw" );
  
  end;
  local use_saw_beg = function ()
  
    ObjDelete( "obj_tablewithfood_use_saw" );
  
  end;
  local use_saw_end = function ()
  
    ObjMultiSet( { 
      { "spr_tablewithfood_longstick", { alp = 1, active = true, input = true } },
    } );
    ObjDelete( "anm_tablewithfood_saw_nag_chair" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_saw", use_saw_beg, private.room_objname );
  cmn.AddSubscriber( "use_saw", use_saw_inv );
  cmn.AddSubscriber( "use_saw", use_saw_end, private.room_objname );
  cmn.AddSubscriber( "use_saw_inv", use_saw_inv, private.room_objname );
  cmn.AddSubscriber( "use_saw_beg", use_saw_beg, private.room_objname );
  cmn.AddSubscriber( "use_saw_end", use_saw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_awlhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_awlhandle" ] = {
    type = "use",
    inv_obj = "inv_awlhandle",
    use_place = "obj_tablewithfood_use_awlhandle",
    room = private.room_objname,
    zz = "zz_tablewithfood",
    zz_gate = "gzz_eventshall_tablewithfood"
  };
  local use_awlhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_awlhandle" );
  
  end;
  local use_awlhandle_beg = function ()
  
    ObjDelete( "obj_tablewithfood_use_awlhandle" );
  
  end;
  local use_awlhandle_end = function ()
  
    ObjMultiSet( { 
      { "obj_tablewithfood_awl",  { input = true } },
      { "gfx_tablewithfood_awl",  { active = true } },
      { "spr_tablewithfood_awl_handle",  { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_awlhandle", use_awlhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_awlhandle", use_awlhandle_inv );
  cmn.AddSubscriber( "use_awlhandle", use_awlhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_awlhandle_inv", use_awlhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_awlhandle_beg", use_awlhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_awlhandle_end", use_awlhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_lvl2" ] = {
    type = "use",
    inv_obj = "inv_button_lvl2",
    use_place = "obj_stage_use_button",
    room = private.room_objname,
    zz = "zz_stage",
    zz_gate = "gzz_eventshall_stage"
  };
  local use_button_lvl2_inv = function ()
  
    interface.InventoryItemRemove( "inv_button_lvl2" );
  
  end;
  local use_button_lvl2_beg = function ()
  
    ObjDelete( "obj_stage_use_button" );
  
  end;
  local use_button_lvl2_end = function ()
  
    ObjMultiSet( { 
      { "anm_stage_button_press",    {   alp = 1                                   } },
      { "obj_stage_clk_button_lvl2", { input = true, active = true, visible = true } },
      { "anm_stage_button", { alp = 0 }}, 
    } );
    ObjDelete( "spr_stage_cap"    );
    --ObjDelete( "anm_stage_button" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_lvl2", use_button_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_lvl2", use_button_lvl2_inv );
  cmn.AddSubscriber( "use_button_lvl2", use_button_lvl2_end, private.room_objname );
  cmn.AddSubscriber( "use_button_lvl2_inv", use_button_lvl2_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_lvl2_beg", use_button_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_lvl2_end", use_button_lvl2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oldkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oldkey" ] = {
    type = "use",
    inv_obj = "inv_oldkey",
    use_place = "obj_librarydoor_use_oldkey",
    room = private.room_objname,
    zz = "zz_librarydoor",
    zz_gate = "gzz_eventshall_librarydoor"
  };
  local use_oldkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_oldkey" );
  
  end;
  local use_oldkey_beg = function ()
  
    ObjDelete( "obj_librarydoor_use_oldkey" );
  
  end;
  local use_oldkey_end = function ()

    ObjMultiSet( { 
      { "obj_librarydoor_key",        {   alp = 1    } },
      { "obj_librarydoor_clk_oldkey", { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oldkey", use_oldkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_oldkey", use_oldkey_inv );
  cmn.AddSubscriber( "use_oldkey", use_oldkey_end, private.room_objname );
  cmn.AddSubscriber( "use_oldkey_inv", use_oldkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_oldkey_beg", use_oldkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_oldkey_end", use_oldkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_whistle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_whistle" ] = {
    type = "use",
    inv_obj = "inv_whistle",
    use_place = "obj_eventshall_use_whistle",
    room = private.room_objname
  };
  local use_whistle_inv = function ()
  
    interface.InventoryItemRemove( "inv_whistle" );
  
  end;
  local use_whistle_beg = function ()
  
    ObjDelete( "obj_eventshall_use_whistle" );
  
  end;
  local use_whistle_end = function ()
    
    ObjDelete( "anm_eventshall_rat" );
    ObjMultiSet( { 
      { "spr_eventshall_grapesleaf2",  { visible = true, input = true } },
      { "gfx_eventshall_grapesleaf2",  {  active = true               } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_whistle", use_whistle_beg, private.room_objname );
  cmn.AddSubscriber( "use_whistle", use_whistle_inv );
  cmn.AddSubscriber( "use_whistle", use_whistle_end, private.room_objname );
  cmn.AddSubscriber( "use_whistle_inv", use_whistle_inv, private.room_objname );
  cmn.AddSubscriber( "use_whistle_beg", use_whistle_beg, private.room_objname );
  cmn.AddSubscriber( "use_whistle_end", use_whistle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hook_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hook_lvl2" ] = {
    type = "use",
    inv_obj = "inv_hook_lvl2",
    use_place = "obj_stainedglass_use_hook",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  local use_hook_lvl2_inv = function ()
  
    interface.InventoryItemRemove( "inv_hook_lvl2" );
  
  end;
  local use_hook_lvl2_beg = function ()
  
    ObjDelete( "obj_stainedglass_use_hook" );
  
  end;
  local use_hook_lvl2_end = function ()
  
    ObjMultiSet( { 
      { "spr_stainedglass_turner",  { input = true, visible = true } },
      { "spr_stainedglass_turner_shadow",  { visible = true } },
    } );
    ObjDelete( "anm_stainedglass_use_hook" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hook_lvl2", use_hook_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl2", use_hook_lvl2_inv );
  cmn.AddSubscriber( "use_hook_lvl2", use_hook_lvl2_end, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl2_inv", use_hook_lvl2_inv, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl2_beg", use_hook_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl2_end", use_hook_lvl2_end, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function win_stainedglass () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_stainedglass" ] = {
    type = "click",
    use_place = "obj_stainedglass_stainedglass_game",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  local win_stainedglass = function ()
  
    if ( cmn.IsEventDone( "win_stainedglass" ) ) then
      ObjDelete( "obj_stainedglass_stainedglass" );
      ObjDelete( "obj_stainedglass_stainedglass_game" )
      ObjDelete( "spr_eventshall_mosaic" )
      ObjSet( "spr_stainedglass_ironhandle", { input = true, active = true } )
      ObjSet( "obj_stainedglass_clk_old_gear", { input = true, active = true } )
    else
      
      for i = 1, 7 do
        if ( ng_global.progress[ "std" ][ "win_stainedglass" ].state[ i ] ) then
          ObjSet( "spr_stainedglass_puzzle_get_"..i, { input = false, visible = false } );
          ObjSet( "spr_stainedglass_puzzle_set_"..i, { alp = 1 } );
        end;
      end;

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_stainedglass", win_stainedglass, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_kitchen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_kitchen" ] = {
    type = "click",
    use_place = "obj_kitchen_minigame",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  local win_kitchen = function ()
  
    if ( cmn.IsEventDone( "win_kitchen" ) ) then

      ObjDelete( "obj_kitchen_minigame" );
      ObjDelete( "obj_kitchen_oven_close" );
      ObjDelete( "anm_kitchen_get_horse" );
      ObjSet( "spr_kitchen_form", { visible = true, input = true } );
      ObjSet( "spr_kitchen_oven_open", { alp = 1 } );

    else
      
      private.runner_pos = ng_global.progress[ "std" ][ "win_kitchen" ].current_pos;
      private.curernt_progress = ng_global.progress[ "std" ][ "win_kitchen" ].curernt_progress;
      
      ObjSet( "spr_kitchen_runner", { pos_x = private.runner_pos } );
      ObjSet( "spr_kitchen_progress_bar", { croprect_w = private.CROP_STEP * private.curernt_progress - 1 } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_kitchen", win_kitchen, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_old_gear () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_old_gear" ] = {
    type = "click",
    use_place = "spr_stainedglass_old_gear",
    room = private.room_objname,
    zz = "zz_stainedglass",
    zz_gate = "gzz_eventshall_stainedglass"
  };
  local clk_old_gear = function ()
  
    ObjDelete( "spr_stainedglass_old_gear" );
    ObjDelete( "spr_stainedglass_old_gear_patch" );
    ObjDelete( "obj_stainedglass_clk_old_gear" );
    ObjSet( "obj_stainedglass_use_thread", { input = true, active = true } )
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_old_gear", clk_old_gear, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_kitchen_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_kitchen_handle" ] = {
    type = "click",
    use_place = "obj_kitchen_clk_kitchen_handle",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  local clk_kitchen_handle = function ()
  
    ObjDelete( "obj_kitchen_clk_kitchen_handle" );
    ObjDelete( "spr_kitchen_handle" );
    ObjSet( "obj_kitchen_use_spoon", { input = true, active = true } )
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_kitchen_handle", clk_kitchen_handle, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_oven_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_oven_handle" ] = {
    type = "click",
    use_place = "obj_kitchen_clk_oven_handle",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_eventshall_kitchen"
  };
  local clk_oven_handle = function ()
  
    ObjDelete( "obj_kitchen_clk_oven_handle" );
    ObjDelete( "spr_kitchen_rustypart_1" );
    ObjDelete( "spr_kitchen_rustypart_2" );
    ObjSet( "obj_kitchen_use_ironhandle", { input = true, active = true } )
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_oven_handle", clk_oven_handle, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_oldkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_oldkey" ] = {
    type = "click",
    use_place = "obj_librarydoor_clk_oldkey",
    room = private.room_objname,
    zz = "zz_librarydoor",
    zz_gate = "gzz_eventshall_zz_librarydoor"
  };
  local clk_oldkey = function ()
    
    ObjDelete( "obj_librarydoor_clk_oldkey" );  
    ObjDelete( "gzz_eventshall_librarydoor" );
    ObjMultiSet( { 
      { "grm_eventshall_library",  { visible = true, input = true } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_eventshall_library_focus");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_oldkey", clk_oldkey, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_stage_box () end; 
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_stage_box" ] = {
      type = "click",
      use_place = "obj_stage_clk_stage_box",
      room = private.room_objname,
      zz = "zz_stage",
      zz_gate = "gzz_eventshall_stage"
    };
    local clk_stage_box_beg = function ()

      ObjDelete( "obj_stage_clk_stage_box" );
    
    end;
    local clk_stage_box_end = function ()

      ObjMultiSet( {
        { "spr_stage_stainedglasspart1", {  input = true } },
        { "gfx_stage_stainedglasspart1", { active = true } },
        { "spr_stage_door_2",            {    alp = 1    } },
      } );

      ObjDelete( "spr_stage_door" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_stage_box",     clk_stage_box_beg );
    cmn.AddSubscriber( "clk_stage_box",     clk_stage_box_end );
    cmn.AddSubscriber( "clk_stage_box_beg", clk_stage_box_beg );
    cmn.AddSubscriber( "clk_stage_box_end", clk_stage_box_end );

  --------------------------------------------------------------------------------------------
  -- function clk_button_lvl2 () end; 
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_button_lvl2" ] = {
      type = "click",
      use_place = "obj_stage_clk_button_lvl2",
      room = private.room_objname,
      zz = "zz_stage",
      zz_gate = "gzz_eventshall_stage"
    };
    local clk_button_lvl2_beg = function ()

      ObjDelete( "obj_stage_clk_button_lvl2" );
    
    end;
    local clk_button_lvl2_end = function ()

      ObjMultiSet( { 
        { "spr_stage_cleaner", {  input = true } },
        { "gfx_stage_cleaner", { active = true } },
        { "anm_stage_button",  { alp = 1 } },
      } );
      ObjDelete( "anm_stage_button_press" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_button_lvl2",     clk_button_lvl2_beg );
    cmn.AddSubscriber( "clk_button_lvl2",     clk_button_lvl2_end );
    cmn.AddSubscriber( "clk_button_lvl2_beg", clk_button_lvl2_beg );
    cmn.AddSubscriber( "clk_button_lvl2_end", clk_button_lvl2_end );

  --------------------------------------------------------------------------------------------
  -- function see_eventshall_horror () end;
  --------------------------------------------------------------------------------------------
    local see_eventshall_horror = function ()
    
      ObjDelete( "anm_eventshall_horror" );

    end;
    
    cmn.AddSubscriber( "see_eventshall_horror", see_eventshall_horror, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_eventshall_open () end;
  --------------------------------------------------------------------------------------------
    local see_eventshall_open = function ()
    
      ObjSet( "anm_eventshall_lastshot", { alp = 1 } );
      ObjDelete( "anm_eventshall_openes" );
      
    end;
    
    cmn.AddSubscriber( "see_eventshall_open", see_eventshall_open, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_eventshall_ghost () end;
  --------------------------------------------------------------------------------------------
    local see_eventshall_ghost = function ()
    
      ObjDelete( "anm_eventshall_ghost" );

    end;
    
    cmn.AddSubscriber( "see_eventshall_ghost", see_eventshall_ghost, private.room_objname ); 

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_kitchen () end ****
  --*******************************************************************************************************************

    subroom.Define( "zz_kitchen" );
    ------------------------------------------------- 
    function zz_kitchen.PreOpen ()
      
      if ( cmn.IsEventStart( "win_kitchen" ) and not cmn.IsEventDone( "win_kitchen" ) ) then

        cmn.MiniGameShow( "kitchen" );
        common_impl.PassingMgStart( "kitchen" );
        private.KitchenMoveRunner();

      end;
      
    end;
    ------------------------------------------------- 
    function zz_kitchen.PreClose ()
      
      if ( cmn.IsEventStart( "win_kitchen" ) and not cmn.IsEventDone( "win_kitchen" ) ) then


        cmn.MiniGameHide( "kitchen" );
        common_impl.PassingMgStop( "kitchen" )

      end;
      
    end;
    -----------------------------------------------------
    function zz_kitchen.Skip ()

      private.KitchenWinAnim();

    end;
    -----------------------------------------------------
    function zz_kitchen.Reset ()

      ng_global.progress[ "std" ][ "win_kitchen" ].current_pos = 0;
      ng_global.progress[ "std" ][ "win_kitchen" ].curernt_progress = 0;

      private.runner_pos = 0;
      private.curernt_progress = 0;

      ObjStopAnimate( "spr_kitchen_runner", "pos_x" );
      ObjSet( "spr_kitchen_runner", { pos_x = 0 } );
      ObjStopAnimate( "spr_kitchen_progress_bar", "croprect_w" );
      ObjSet( "spr_kitchen_progress_bar", { croprect_w = -1 } );
      ObjSet( "tmr_kitchen_runner", { playing = false } );

      private.KitchenMoveRunner();

    end;
    
    ------------------------------------------------- 
    function zz_kitchen.Close ()

      if ( not cmn.IsEventDone( "see_eventshall_horror" ) ) then

        private.see_eventshall_horror();
      
      end;
      
    end;
    
  --*******************************************************************************************************************
  --*** function zz_librarydoor () end ****
  --*******************************************************************************************************************
  
    subroom.Define( "zz_librarydoor" );
    ------------------------------------------------- 
    function zz_librarydoor.Close ()

      if ( cmn.IsEventDone( "clk_oldkey" ) and not cmn.IsEventDone( "see_eventshall_open" ) ) then

        private.see_eventshall_open();
      
      end;
      
    end;

 --*******************************************************************************************************************
  --*** function zz_stage () end ****
  --*******************************************************************************************************************
  
    subroom.Define( "zz_stage" );
    ------------------------------------------------- 
    function zz_stage.Close ()

      if ( not cmn.IsEventDone( "see_eventshall_ghost" ) ) then

        private.see_eventshall_ghost();
      
      end;
      
    end;
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_eventshall();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  if ( cmn.IsEventDone( "clk_oldkey" ) and not cmn.IsEventDone( "see_eventshall_open" ) ) then

    private.see_eventshall_open();
  
  end;

  common_impl.EnvPlay( { "level1/env/aud_terrace_env" }, "", 0.5 );
      
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level1/env/aud_terrace_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_stainedglasspart2 ()

  local item = "inv_stainedglasspart2";

  if ( cmn.ApplyObj( item, "gzz_eventshall_stainedglass" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stainedglass" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stainedglass_use_stainedglasspart2" ) ) then

    cmn.CallEventHandler( "use_stainedglasspart2_inv" );
    cmn.CallEventHandler( "use_stainedglasspart2_beg" );

    local func_end_2 = function ()    
      
      cmn.Lock( false );

      cmn.SetEventDone( "use_stainedglasspart2" );
      cmn.CallEventHandler( "use_stainedglasspart2_end" );
      
    end;
      
    local func_end = function ()
      
      if ( cmn.IsEventDone( "use_stainedglasspart1" ) and 
      cmn.IsEventDone( "use_stainedglasspart3" ) ) then
      
        common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_stone_safe", 0, "", 0 );

        ObjSet( "spr_stainedglass_back_mosaic", { visible = false } );
        ObjSet( "obj_stainedglass_stainedglass_game", { visible = false } );
        ObjSet( "obj_stainedglass_stainedglass_use", { visible = false } );
        ObjSet( "obj_stainedglass_stainedglass_win", { alp = 1 } );

        ObjAnimate( "spr_stainedglass_mosaic_1", "pos_y", 0, 1, "", { 0, 0, 0, 0.1, 0, 20, 0.5, 0, 190 } );
        ObjAnimate( "spr_stainedglass_mosaic_1", "ang", 0, 1, "", { 0, 0, 0, 0.03, 0, 0.01, 0.07, 0, -0.01 } );

        ObjAnimate( "spr_stainedglass_mosaic_2", "pos_xy", 0, 1, "", { 0, 0, 0, 0, 0.1, 0, -30, -20, 0.5, 0, -120, -120 } );
        ObjAnimate( "spr_stainedglass_mosaic_2", "ang", 0, 1, "", { 0, 0, 0, 0.03, 0, 0.01, 0.07, 0, -0.01 } );

        ObjAnimate( "spr_stainedglass_mosaic_3", "pos_xy", 0, 1, func_end_2, { 0, 0, 0, 0, 0.1, 0, 30, -20, 0.5, 0, 120, -120 } );
        ObjAnimate( "spr_stainedglass_mosaic_3", "ang", 0, 1, "", { 0, 0, 0, 0.03, 0, 0.01, 0.07, 0, -0.01 } );
        
      else 
        
        func_end_2();
        
      end;

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_use_stone3", 0, "", 0 );

    cmn.ItemFly( "spr_stainedglass_mosaic_piece_2", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stainedglasspart1 ()

  local item = "inv_stainedglasspart1";

  if ( cmn.ApplyObj( item, "gzz_eventshall_stainedglass" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stainedglass" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stainedglass_use_stainedglasspart1" ) ) then

    cmn.CallEventHandler( "use_stainedglasspart1_inv" );
    cmn.CallEventHandler( "use_stainedglasspart1_beg" );
    
    local func_end_2 = function ()    
      
      cmn.Lock( false );

      cmn.SetEventDone( "use_stainedglasspart1" );
      cmn.CallEventHandler( "use_stainedglasspart1_end" );
      
    end;
      
    local func_end = function ()
      
      if ( cmn.IsEventDone( "use_stainedglasspart2" ) and 
      cmn.IsEventDone( "use_stainedglasspart3" ) ) then
      
        common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_stone_safe", 0, "", 0 );

        ObjSet( "spr_stainedglass_back_mosaic", { visible = false } );
        ObjSet( "obj_stainedglass_stainedglass_game", { visible = false } );
        ObjSet( "obj_stainedglass_stainedglass_use", { visible = false } );
        ObjSet( "obj_stainedglass_stainedglass_win", { alp = 1 } );

        ObjAnimate( "spr_stainedglass_mosaic_1", "pos_y", 0, 1, "", { 0, 0, 0, 0.1, 0, 20, 0.5, 0, 190 } );
        ObjAnimate( "spr_stainedglass_mosaic_1", "ang", 0, 1, "", { 0, 0, 0, 0.03, 0, 0.01, 0.07, 0, -0.01 } );

        ObjAnimate( "spr_stainedglass_mosaic_2", "pos_xy", 0, 1, "", { 0, 0, 0, 0, 0.1, 0, -30, -20, 0.5, 0, -120, -120 } );
        ObjAnimate( "spr_stainedglass_mosaic_2", "ang", 0, 1, "", { 0, 0, 0, 0.03, 0, 0.01, 0.07, 0, -0.01 } );

        ObjAnimate( "spr_stainedglass_mosaic_3", "pos_xy", 0, 1, func_end_2, { 0, 0, 0, 0, 0.1, 0, 30, -20, 0.5, 0, 120, -120 } );
        ObjAnimate( "spr_stainedglass_mosaic_3", "ang", 0, 1, "", { 0, 0, 0, 0.03, 0, 0.01, 0.07, 0, -0.01 } );
        
      else 
        
        func_end_2();
        
      end;

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_use_stone3", 0, "", 0 );

    cmn.ItemFly( "spr_stainedglass_mosaic_piece_1", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stainedglasspart3 ()

  local item = "inv_stainedglasspart3";

  if ( cmn.ApplyObj( item, "gzz_eventshall_stainedglass" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stainedglass" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stainedglass_use_stainedglasspart3" ) ) then

    cmn.CallEventHandler( "use_stainedglasspart3_inv" );
    cmn.CallEventHandler( "use_stainedglasspart3_beg" );

    local func_end_2 = function ()    
      
      cmn.Lock( false );

      cmn.SetEventDone( "use_stainedglasspart3" );
      cmn.CallEventHandler( "use_stainedglasspart3_end" );
      
    end;
      
    local func_end = function ()
      
      if ( cmn.IsEventDone( "use_stainedglasspart1" ) and 
        cmn.IsEventDone( "use_stainedglasspart2" ) ) then
      
        common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_stone_safe", 0, "", 0 );

        ObjSet( "spr_stainedglass_back_mosaic", { visible = false } );
        ObjSet( "obj_stainedglass_stainedglass_game", { visible = false } );
        ObjSet( "obj_stainedglass_stainedglass_use", { visible = false } );
        ObjSet( "obj_stainedglass_stainedglass_win", { alp = 1 } );

        ObjAnimate( "spr_stainedglass_mosaic_1", "pos_y", 0, 1, "", { 0, 0, 0, 0.1, 0, 20, 0.5, 0, 190 } );
        ObjAnimate( "spr_stainedglass_mosaic_1", "ang", 0, 1, "", { 0, 0, 0, 0.03, 0, 0.01, 0.07, 0, -0.01 } );

        ObjAnimate( "spr_stainedglass_mosaic_2", "pos_xy", 0, 1, "", { 0, 0, 0, 0, 0.1, 0, -30, -20, 0.5, 0, -120, -120 } );
        ObjAnimate( "spr_stainedglass_mosaic_2", "ang", 0, 1, "", { 0, 0, 0, 0.03, 0, 0.01, 0.07, 0, -0.01 } );

        ObjAnimate( "spr_stainedglass_mosaic_3", "pos_xy", 0, 1, func_end_2, { 0, 0, 0, 0, 0.1, 0, 30, -20, 0.5, 0, 120, -120 } );
        ObjAnimate( "spr_stainedglass_mosaic_3", "ang", 0, 1, "", { 0, 0, 0, 0.03, 0, 0.01, 0.07, 0, -0.01 } );
        
      else 
        
        func_end_2();
        
      end;

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_use_stone3", 0, "", 0 );

    cmn.ItemFly( "spr_stainedglass_mosaic_piece_3", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_thread ()

  local item = "inv_thread";

  if ( cmn.ApplyObj( item, "gzz_eventshall_stainedglass" ) and cmn.IsEventDone( "clk_old_gear" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stainedglass" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stainedglass_use_thread" ) and cmn.IsEventDone( "clk_old_gear" ) ) then

    cmn.CallEventHandler( "use_thread_inv" );
    cmn.CallEventHandler( "use_thread_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_thread" );
      cmn.CallEventHandler( "use_thread_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_small_gear", 0, "", 0 );

    local func_middle = function ()

      ObjAnimate( "spr_stainedglass_chain2", "ang", 0, 0, "",       { 0, 0, 0.1,  0.8, 0, -0.01 } )
      ObjAnimate( "spr_stainedglass_chain1", "ang", 0, 0, "",       { 0, 0, 0.07, 0.8, 0, 0.25  } )
      ObjAnimate( "spr_stainedglass_gear",   "ang", 0, 0, "",       { 0, 0, 0,    0.8, 0, -3.14 } )
      ObjAnimate( "spr_stainedglass_hole", "pos_y", 0, 0, func_end, { 0, 0, -93,  0.8, 0, -42   } )

    end;

    cmn.ItemFly( "spr_stainedglass_gear", func_middle, 0, 0 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_spoon ()

  local item = "inv_spoon";

  if ( cmn.ApplyObj( item, "gzz_eventshall_kitchen" ) and cmn.IsEventDone( "clk_kitchen_handle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_use_spoon" ) and cmn.IsEventDone( "clk_kitchen_handle" ) ) then

    cmn.CallEventHandler( "use_spoon_inv" );
    cmn.CallEventHandler( "use_spoon_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_spoon" );
      cmn.CallEventHandler( "use_spoon_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_spoon", 0, "", 0 );

    VidPlay( "vid_kitchen_spoon", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ironhandle ()

  local item = "inv_ironhandle";

  if ( cmn.ApplyObj( item, "gzz_eventshall_kitchen" ) and cmn.IsEventDone( "clk_oven_handle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_use_ironhandle" ) and cmn.IsEventDone( "clk_oven_handle" ) ) then

    cmn.CallEventHandler( "use_ironhandle_inv" );
    cmn.CallEventHandler( "use_ironhandle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_ironhandle" );
      cmn.CallEventHandler( "use_ironhandle_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_metal_handle", 0, "", 0 );

    local func_fall = function ()
      AnimPlay( "anm_kitchen_get_rod", "DoAnim", func_end )
    end;

    local func_open = function ()

      ObjAnimate( "spr_kitchen_oven_handle", "alp", 0, 0, "", { 0, 0, 1, 0.2, 0, 0 } );
      ObjAnimate( "spr_kitchen_oven_handle_open", "alp", 0, 0, "", { 0, 0, 0, 0.2, 0, 1 } );

      ObjAnimate( "obj_kitchen_oven_close", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 1, 0.6, 0, 0 } );
      ObjAnimate( "spr_kitchen_oven_open", "alp", 0, 0, func_fall, { 0, 0, 0, 0.3, 0, 0, 0.6, 0, 1 } );
      ObjAnimate( "anm_kitchen_use_ovenfork", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 0, 0.6, 0, 1 } );
      
    end;

    cmn.ItemFly( "spr_kitchen_oven_handle", func_open, -1, 100 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_figurineshape ()

  local item = "inv_figurineshape";

  if ( cmn.ApplyObj( item, "gzz_eventshall_kitchen" ) and cmn.IsEventDone( "get_dutchoven" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_use_figurineshape" ) and cmn.IsEventDone( "get_dutchoven" ) ) then

    cmn.CallEventHandler( "use_figurineshape_inv" );
    cmn.CallEventHandler( "use_figurineshape_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_figurineshape" );
      cmn.CallEventHandler( "use_figurineshape_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_short_whoosh", 0, "", 0 );

    ObjAnimate( "anm_kitchen_get_horse", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } )
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ovenfork ()

  local item = "inv_ovenfork";

  if ( cmn.ApplyObj( item, "gzz_eventshall_kitchen" ) and cmn.IsEventDone( "use_ironhandle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_use_ovenfork" ) and cmn.IsEventDone( "use_ironhandle" ) ) then

    cmn.CallEventHandler( "use_ovenfork_inv" );
    cmn.CallEventHandler( "use_ovenfork_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_ovenfork" );
      cmn.CallEventHandler( "use_ovenfork_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_ovenfork", 0, "", 0 );

    AnimPlay( "anm_kitchen_use_ovenfork", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_jugwithclay ()

  local item = "inv_jugwithclay";

  if ( cmn.ApplyObj( item, "gzz_eventshall_kitchen" ) and cmn.IsEventDone( "use_figurineshape" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_use_jugwithclay" )  and cmn.IsEventDone( "use_figurineshape" ) ) then

    cmn.CallEventHandler( "use_jugwithclay_inv" );
    cmn.CallEventHandler( "use_jugwithclay_beg" );

    local func_end = function ()

      cmn.Lock( false );

      ng_global.progress[ "std" ][ "win_kitchen" ].current_pos = 0;
      ng_global.progress[ "std" ][ "win_kitchen" ].curernt_progress = 0;

      private.runner_pos = 0;
      private.curernt_progress = 0;

      cmn.SetEventDone( "use_jugwithclay" );
      cmn.CallEventHandler( "use_jugwithclay_end" );

      cmn.MiniGameShow( "kitchen" );
      common_impl.PassingMgStart( "kitchen" );

      private.KitchenMoveRunner();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_bucket3", 0, "", 0 );

    local func_close = function ()

      ObjAnimate( "obj_kitchen_oven_close",       "alp", 0, 0,       "", { 0, 0, 0,   0.3, 0, 1            } );
      ObjAnimate( "spr_kitchen_oven_open",        "alp", 0, 0,       "", { 0, 0, 1,   0.3, 0, 0            } );
      
      ObjAnimate( "spr_kitchen_oven_handle",      "alp", 0, 0,       "", { 0, 0, 0,   0.4, 0, 0, 0.6, 0, 1 } );
      ObjAnimate( "spr_kitchen_oven_handle_open", "alp", 0, 0,       "", { 0, 0, 1,   0.4, 0, 1, 0.6, 0, 0 } );
      ObjAnimate( "obj_kitchen_minigame",         "alp", 0, 0, func_end, { 0, 0, 0,   0.6, 0, 0, 0.9, 0, 1 } )

    end;

    local func_middle = function ()

      AnimPlay( "anm_kitchen_get_horse", "DoAnim1", func_close )

    end;

    AnimPlay( "anm_kitchen_get_horse", "DoAnim", func_middle )
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_saw ()

  local item = "inv_saw";

  if ( cmn.ApplyObj( item, "gzz_eventshall_tablewithfood" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tablewithfood" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tablewithfood_use_saw" ) ) then

    cmn.CallEventHandler( "use_saw_inv" );
    cmn.CallEventHandler( "use_saw_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_saw" );
      cmn.CallEventHandler( "use_saw_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_saw", 0, "", 0 );

    AnimPlay( "anm_tablewithfood_saw_nag_chair", "saw_nag_chair", func_end )
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_awlhandle ()

  local item = "inv_awlhandle";
  local item_wrong = "inv_pliers";

  if ( cmn.ApplyObj( item, "gzz_eventshall_tablewithfood" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tablewithfood" );

    return true;

  elseif ( cmn.ApplyObj( item_wrong, "obj_tablewithfood_use_awlhandle" ) ) then

    common_impl.ShowBbt( "bbt_ivn_pliers_wrong_use_lvl2" );
    return true;

  elseif ( cmn.ApplyObj( item, "obj_tablewithfood_use_awlhandle" ) ) then

    cmn.CallEventHandler( "use_awlhandle_inv" );
    cmn.CallEventHandler( "use_awlhandle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_awlhandle" );
      cmn.CallEventHandler( "use_awlhandle_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_awlhandle", 0, "", 0 );

    cmn.ItemFly( "spr_tablewithfood_awl_handle", func_end, 1.1, 250 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_button_lvl2 ()

  local item = "inv_button_lvl2";

  if ( cmn.ApplyObj( item, "gzz_eventshall_stage" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_stage' , 'under_frame' )

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stage_use_button" ) ) then

    cmn.CallEventHandler( "use_button_lvl2_inv" );
    cmn.CallEventHandler( "use_button_lvl2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_button_lvl2" );
      cmn.CallEventHandler( "use_button_lvl2_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_button", 0, "", 0 );

    AnimPlay( "anm_stage_button", "button", func_end )
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_oldkey ()

  local item = "inv_oldkey";

  if ( cmn.ApplyObj( item, "gzz_eventshall_librarydoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_librarydoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_librarydoor_use_oldkey" ) ) then

    cmn.CallEventHandler( "use_oldkey_inv" );
    cmn.CallEventHandler( "use_oldkey_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_oldkey" );
      cmn.CallEventHandler( "use_oldkey_end" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_key_to_library", 0, "", 0 );

    cmn.ItemFly( "obj_librarydoor_key", func_end, -1.7, 70 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_whistle ()

  local item = "inv_whistle";

  if ( cmn.ApplyObj( item, "obj_eventshall_use_whistle" ) ) then

    cmn.CallEventHandler( "use_whistle_inv" );
    cmn.CallEventHandler( "use_whistle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_whistle" );
      cmn.CallEventHandler( "use_whistle_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_whistle", 0, "", 0 );

    AnimPlay( "anm_eventshall_rat", "rat_away", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hook_lvl2 ()

  local item = "inv_hook_lvl2";

  if ( cmn.ApplyObj( item, "gzz_eventshall_stainedglass" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stainedglass" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stainedglass_use_hook" ) ) then

    cmn.CallEventHandler( "use_hook_lvl2_inv" );
    cmn.CallEventHandler( "use_hook_lvl2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hook_lvl2" );
      cmn.CallEventHandler( "use_hook_lvl2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_hook2", 0, "", 0 );

    AnimPlay( "anm_stainedglass_use_hook", "DoAnim", func_end )
  
    return true;

  end;
  
  return false;
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_ironhandle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ironhandle" );
  cmn.CallEventHandler( "get_ironhandle" );

end;
--------------------------------------------------------------------------------------------
function private.get_oldamulet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_oldamulet" );
  cmn.CallEventHandler( "get_oldamulet" );
  
  if ( cmn.IsEventDone( "get_figurineshape" ) ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_figurineshape ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_figurineshape" );
  cmn.CallEventHandler( "get_figurineshape" );
  
  if ( cmn.IsEventDone( "get_oldamulet" ) ) then
    
    common.CloseSubRoom();

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_hook_lvl2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hook_lvl2" );
  cmn.CallEventHandler( "get_hook_lvl2" );

end;
--------------------------------------------------------------------------------------------
function private.get_animalstatuette ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_animalstatuette" );
  cmn.CallEventHandler( "get_animalstatuette" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_dutchoven ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_dutchoven" );
  cmn.CallEventHandler( "get_dutchoven" );

  if port.isPortable()==1 then
    iOS_RateMe();
  end;
    
end;
--------------------------------------------------------------------------------------------
function private.get_longstick ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_longstick" );
  cmn.CallEventHandler( "get_longstick" );

end;
--------------------------------------------------------------------------------------------
function private.get_stainedglasspart3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stainedglasspart3" );
  cmn.CallEventHandler( "get_stainedglasspart3" );

end;
--------------------------------------------------------------------------------------------
function private.get_awl ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_awl" );
  cmn.CallEventHandler( "get_awl" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_14" ) ) then
    
    common.CloseSubRoom();
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_whistle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_whistle" );
  cmn.CallEventHandler( "get_whistle" );

end;
--------------------------------------------------------------------------------------------
function private.get_stainedglasspart1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stainedglasspart1" );
  cmn.CallEventHandler( "get_stainedglasspart1" );

end;
--------------------------------------------------------------------------------------------
function private.get_cleaner ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cleaner" );
  cmn.CallEventHandler( "get_cleaner" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_13" ) ) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_grapesleaf2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_grapesleaf2" );
  cmn.CallEventHandler( "get_grapesleaf2" );

end;
--------------------------------------------------------------------------------------------
function private.get_turner ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_turner" );
  cmn.CallEventHandler( "get_turner" );

end;
--------------------------------------------------------------------------------------------
function private.get_rod_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rod_2" );
  cmn.CallEventHandler( "get_rod_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_13 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_13" ); 

  end;

  common_impl.PlayEffectHO( "spr_stage_collect2_item_13", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_13" );
  
  if ( cmn.IsEventDone( "get_cleaner" ) ) then

    common.CloseSubRoom();

  end; 
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_14 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_14" ); 

  end;

  common_impl.PlayEffectHO( "spr_tablewithfood_collect2_item_14", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_14" );
  
  if ( cmn.IsEventDone( "get_awl" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_old_gear ()

  cmn.Lock( true );
  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_old_gear" );
    cmn.CallEventHandler( "clk_old_gear" );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_break_metal", 0, "", 0 );
  ObjAnimate( "spr_stainedglass_old_gear", "ang", 0, 0, "", { 
    0.0, 0, 0,
    0.1, 0, -0.01,
    0.3, 0, 0.01,
    0.4, 3, 0 
  } );
  ObjAnimate( "spr_stainedglass_old_gear", "pos_y", 0, 1, func_end, { 
    0.0, 0, 0,
    0.3, 0, 0,
    0.8, 0, 50
  } );

end;

--------------------------------------------------------------------------------------------
function private.clk_kitchen_handle ()

  cmn.Lock( true );
  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_kitchen_handle" );
    cmn.CallEventHandler( "clk_kitchen_handle" );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_break_wood", 0, "", 0 );

  ObjAnimate( "spr_kitchen_handle", "ang", 0, 0, "", { 
    0.0, 0, 0,
    0.8, 3, 0.2 
  } );
  ObjAnimate( "spr_kitchen_handle", "pos_y", 0, 1, "", { 
    0.0, 0, 0,
    0.3, 0, 0,
    0.8, 0, 100
  } );
  ObjAnimate( "spr_kitchen_handle", "alp", 0, 1, func_end, { 
    0.0, 0, 1,
    0.5, 0, 1,
    0.8, 0, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_oven_handle ()

  cmn.Lock( true );
  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_oven_handle" );
    cmn.CallEventHandler( "clk_oven_handle" );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_break_metal", 0, "", 0 );

  ObjAnimate( "spr_kitchen_rustypart_1", "ang", 0, 0, "", { 
    0.0, 0, 0,
    0.8, 3, 1.25 
  } );
  ObjAnimate( "spr_kitchen_rustypart_1", "pos_y", 0, 1, "", { 
    0.0, 0, 0,
    0.3, 0, 0,
    0.8, 0, 90
  } );
  ObjAnimate( "spr_kitchen_rustypart_1", "alp", 0, 1, func_end, { 
    0.0, 0, 1,
    0.5, 0, 1,
    0.8, 0, 0
  } );
  ObjAnimate( "spr_kitchen_rustypart_2", "ang", 0, 0, "", { 
    0.0, 0, 0,
    0.8, 3, -1.2 
  } );
  ObjAnimate( "spr_kitchen_rustypart_2", "pos_y", 0, 1, "", { 
    0.0, 0, 0,
    0.3, 0, 0,
    0.7, 0, 70,
    0.8, 0, 70
  } );
  ObjAnimate( "spr_kitchen_rustypart_2", "alp", 0, 1, "", { 
    0.0, 0, 1,
    0.3, 0, 1,
    0.7, 0, 0,
    0.8, 0, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_oldkey ()

  cmn.Lock( true );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_oldkey" );
    cmn.CallEventHandler( "clk_oldkey" );
    common.CloseSubRoom();
    
  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_key_to_library", 0, "", 0 );

  ObjAnimate( "spr_librarydoor_key", "alp", 0, 0, "", { 
    0.0, 0, 1,
    0.3, 3, 0 
  } );
  ObjAnimate( "spr_librarydoor_key_2", "alp", 0, 0, func_end, { 
    0.0, 0, 0,
    0.3, 3, 1 
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_stage_box ()
  
  cmn.CallEventHandler( "clk_stage_box_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_stage_box" );
    cmn.CallEventHandler( "clk_stage_box_end" ); 

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_opn_wood_safe", 0, "", 0 );

  ObjAnimate( "spr_stage_door_2", "alp", 0, 0, func_end,{ 0.0, 0, 0,   0.3, 0, 1 } );
  ObjAnimate( "spr_stage_door",   "alp", 0, 0, "",      { 0.0, 0, 1,   0.3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_button_lvl2 ()
  
  cmn.CallEventHandler( "clk_button_lvl2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_button_lvl2" );
    cmn.CallEventHandler( "clk_button_lvl2_end" ); 

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_microphonebutton", 0, "", 0 );

  AnimPlay( "anm_stage_button_press", "button_press", func_end );

end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** KITCHEN *** () end;
--*********************************************************************************************************************
function private.InitKitchen ()

  private.LEFT = -1;
  private.RIGHT = 1;

  private.PROGRESS_SPEED = 1;
  private.DEGRESS_SPEED = -4;
  private.MOVE_SPEED = 36;
  private.ARROW_CHANGE = 60;  

  private.MIN = -243;
  private.MAX = 249;
  private.MIN_GREEN = -84;
  private.MAX_GREEN = 76;

  private.MIN_CROP = -1;
  private.MAX_CROP = 590;
  private.CROP_STEP = 59;

  private.TIME = 0.3

  private.curernt_progress = 0;
  private.runner_pos = 0;

  ObjSet( "spr_kitchen_arrow_lft",
  {
    event_menter    = function () private.KitchenArrowEnter( "spr_kitchen_arrow_lft" ) end,
    event_mleave    = function () private.KitchenArrowLeave( "spr_kitchen_arrow_lft" ) end,
    event_mdown     = function () private.KitchenArrowDown( private.LEFT ) end,
  } );

  ObjSet( "spr_kitchen_arrow_rgt",
  {
    event_menter    = function () private.KitchenArrowEnter( "spr_kitchen_arrow_rgt" ) end,
    event_mleave    = function () private.KitchenArrowLeave( "spr_kitchen_arrow_rgt" ) end,
    event_mdown     = function () private.KitchenArrowDown( private.RIGHT ) end,
  } );

end;
--*********************************************************************************************************************
function private.KitchenArrowEnter ( name )

  ObjSet( name.."_focus", { alp = 1 } );
  common_impl.SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************
function private.KitchenArrowLeave ( name )

  ObjSet( name.."_focus", { alp = 0 } );
  common_impl.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
function private.KitchenArrowDown ( move_side )

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_button", 0, "", 0 );

  ObjSet( "tmr_kitchen_runner", { playing = false } );

  local func_end = function ()
  
    cmn.Lock( false );
    private.KitchenMoveRunner( move_side );

  end;

  local start_pos = ObjGet( "spr_kitchen_runner" ).pos_x;
  local new_pos = private.runner_pos + ( private.ARROW_CHANGE + math.random( 7 ) - 4 ) * move_side;
  if ( new_pos > 0 ) then
    new_pos = math.min( new_pos, private.MAX );
  else
    new_pos = math.max( new_pos, private.MIN );
  end;
  
  private.runner_pos = new_pos;
  ObjAnimate( "spr_kitchen_runner", "pos_x", 0, 0, func_end, { 0, 0, start_pos, private.TIME, 0, new_pos } );

  local progress_change = private.PROGRESS_SPEED;
  local start_crop = ObjGet( "spr_kitchen_progress_bar" ).croprect_w;
  if ( private.runner_pos < private.MIN_GREEN ) or ( private.runner_pos > private.MAX_GREEN ) then
    progress_change = private.DEGRESS_SPEED;
  end;
  private.curernt_progress = start_crop/private.CROP_STEP + progress_change;
  if ( private.curernt_progress < 0 ) then
    private.curernt_progress = 0;
  elseif ( private.curernt_progress > 100 ) then
    private.curernt_progress = 100;
  end;
  local new_crop = private.curernt_progress * private.CROP_STEP;
  if ( new_crop == 0 ) then new_crop = -1; end;
  ObjAnimate( "spr_kitchen_progress_bar", "croprect_w", 0, 0, "", { 0, 0, start_crop, private.TIME, 0, new_crop } );

end;
--*********************************************************************************************************************
function private.KitchenMoveRunner ( move_side )

  if ( private.curernt_progress == 10 ) then
    private.KitchenWinAnim();
    return;
  else
    private.KitchenSave();
  end;

  ObjSet( "tmr_kitchen_runner", { time = private.TIME, endtrig = function () private.KitchenMoveRunner() end, playing = true } );

  if ( not move_side ) then
    
    if ( private.runner_pos == 0 ) then
      move_side = math.random( 0, 1 );
      if ( move_side == 0 ) then move_side = -1; end;
    else
      move_side = private.runner_pos/math.abs( private.runner_pos );
    end;

  end;

  local start_pos = private.runner_pos;
  local new_pos = private.runner_pos + ( private.MOVE_SPEED + math.random( 7 ) - 4 ) * move_side;
  if ( new_pos > 0 ) then
    new_pos = math.min( new_pos, private.MAX );
  else
    new_pos = math.max( new_pos, private.MIN );
  end;

  private.runner_pos = new_pos;
  ObjAnimate( "spr_kitchen_runner", "pos_x", 0, 0, "", { 0, 0, start_pos, private.TIME, 0, new_pos } )

  local progress_change = private.PROGRESS_SPEED;
  if ( private.runner_pos < private.MIN_GREEN ) or ( private.runner_pos > private.MAX_GREEN ) then
    progress_change = private.DEGRESS_SPEED;
  end;
  private.curernt_progress = private.curernt_progress + progress_change;
  if ( private.curernt_progress < 0 ) then
    private.curernt_progress = 0;
  elseif ( private.curernt_progress > 10 ) then
    private.curernt_progress = 10;
  end;
  local start_crop = ObjGet( "spr_kitchen_progress_bar" ).croprect_w;
  local new_crop = private.curernt_progress * private.CROP_STEP;
  if ( new_crop == 0 ) then new_crop = -1; end;
  ObjAnimate( "spr_kitchen_progress_bar", "croprect_w", 0, 0, "", { 0, 0, start_crop, private.TIME, 0, new_crop } );

end;
-----------------------------------------------------
function private.KitchenWinAnim ()

  cmn.Lock( true )
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_oven", 0, "", 0 );

  local func_export = function ()

    AnimPlay( "anm_kitchen_get_horse", "DoAnim2", private.KitchenWinEnd );

  end;

  ObjSet( "tmr_kitchen_runner", { playing = false } );

  ObjAnimate( "obj_kitchen_minigame",         "alp", 0, 0,          "", { 0, 0, 1,  0.2, 0, 0             } );

  ObjAnimate( "spr_kitchen_oven_handle",      "alp", 0, 0,          "", { 0, 0, 1,  0.2, 0, 0             } );
  ObjAnimate( "spr_kitchen_oven_handle_open", "alp", 0, 0,          "", { 0, 0, 0,  0.2, 0, 1             } );

  ObjAnimate( "obj_kitchen_oven_close",       "alp", 0, 0,          "", { 0, 0, 1,  0.3, 0, 1,  0.6, 0, 0 } );
  ObjAnimate( "spr_kitchen_oven_open",        "alp", 0, 0, func_export, { 0, 0, 0,  0.3, 0, 0,  0.6, 0, 1 } );

end;
-----------------------------------------------------
function private.KitchenWinEnd ()

  cmn.Lock( false )

  common_impl.PlayAudio( "sfx", "aud_win_mg" );

  cmn.MiniGameHide( "kitchen" );
  common_impl.PassingMgWin( "kitchen" );

  cmn.SetEventDone( "win_kitchen" );
  cmn.CallEventHandler( "win_kitchen" );

end;
-----------------------------------------------------
function private.KitchenSave ()

  ng_global.progress[ "std" ][ "win_kitchen" ].current_pos = private.runner_pos;
  ng_global.progress[ "std" ][ "win_kitchen" ].curernt_progress = private.curernt_progress;

end;
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;
--------------------------------------------------------------------------------------------
function private.see_eventshall_horror ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_eventshall_horror" );
    --cmn.CallEventHandler( "see_eventshall_horror" );

    common_impl.ShowBbt( 'bbt_eventshall_see_horror' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );

  AnimPlay( "anm_eventshall_horror", "horror", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_eventshall_open ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_eventshall_open" );
    --cmn.CallEventHandler( "see_eventshall_open" );

    common_impl.ShowBbt( 'bbt_eventshall_see_open' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_big_door", 0, "", 0 );

  AnimPlay( "anm_eventshall_openes", "openes", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_eventshall_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_eventshall_ghost" );
    --cmn.CallEventHandler( "see_eventshall_ghost" );

    common_impl.ShowBbt( 'bbt_eventshall_see_ghost' );
    
  end;
    
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_dance_ghost_sc", 0, "", 0 );

  ObjSet( "anm_eventshall_ghost", { alp = 1 } );
  AnimPlay( "anm_eventshall_ghost", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_eventshall ()

  if not ( cmn.IsEventDone( "opn_eventshall" ) ) then

    cmn.SetEventDone( "opn_eventshall" );
    common_impl.ShowBbt( 'bbt_eventshall_opn_eventshall' );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl2_find_place" );

  end;
  cmn.CallEventHandler( "opn_eventshall" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.UseWhistle ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_eventshall_use_whistle' );
    ObjMultiSet( { 
      { "anm_eventshall_rat",  { animfunc = "rat_static", playing = true } },
    } );  
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_rat", 0, "", 0 );

  AnimPlay( "anm_eventshall_rat", "rat_click", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseAwlhandle ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_tablewithfood_use_awlhandle' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_high", 0, "", 0 );

  ObjAnimate( "obj_tablewithfood_awl", "scale_xy", 0, 0, func_end, { 0, 0, 1, 1, 0.2, 0, 0.95, 0.94, 0.4, 0, 1, 1 } );
  ObjAnimate( "obj_tablewithfood_awl", "pos_xy", 0, 1, "", { 0, 0, 0, 0, 0.2, 0, 1, 1, 0.4, 0, 0, 0 } );
end;
--------------------------------------------------------------------------------------------
function private.UseSaw ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_tablewithfood_use_saw' );
    
    ObjMultiSet( { 
      { "anm_tablewithfood_saw_nag_chair",  { alp = 1 } },
      { "anm_tablewithfood_stick_chair_hh", { alp = 0 } },
    } );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_mid3", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_tablewithfood_saw_nag_chair",  { alp = 0 } },
    { "anm_tablewithfood_stick_chair_hh", { alp = 1 } },
  } );

  AnimPlay( "anm_tablewithfood_stick_chair_hh", "stick_chair_hh", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseButton ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_stage_use_button' );

    ObjMultiSet( { 
      { "anm_stage_spring_hh", { alp = 0 } },
      { "anm_stage_button",    { alp = 1 } },
    } );  
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_spring2", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_stage_button",    { alp = 0 } },
    { "anm_stage_spring_hh", { alp = 1 } },
  } );  

  AnimPlay( "anm_stage_spring_hh", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseThread ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_stainedglass_use_thread' );

  end;

  if cmn.IsEventDone( "get_ironhandle" ) then 
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_part2", 0, "", 0 );

    ObjAnimate( "spr_stainedglass_hole", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0, 0.2, 0, 0, 3, 0.4, 0, 0, 0 } );
  
  else 
  
    func_end();
    
  end;

end;
