-- name=rm_library
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_library";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_wallstash", "room_hub" );
  ObjAttach( "zz_metalladder", "room_hub" );
  ObjAttach( "zz_clarksstuff", "room_hub" );
  ObjAttach( "zz_readingdesk", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_wallstash_collectorsjug",       { event_mdown = private.get_collectorsjug         }},
    { "spr_wallstash_skull3",              { event_mdown = private.get_skull3                }},
    { "obj_wallstash_use_oldamulet",       { event_mdown = private.WallstashClkDoor1         }},
    { "obj_wallstash_clk_door_2",          { event_mdown = private.WallstashClkDoor2         }},
    { "obj_wallstash_clk_books",           { event_mdown = private.clk_wallstash_books       }},
    { "spr_wallstash_photo",               { event_mdown = function() cmn.NoteScale( "spr_wallstash_photo" ) end }},
    { "spr_wallstash_photo_big",           { event_mdown = function() cmn.NoteScale( "spr_wallstash_photo" ) end }},

    { "spr_metalladder_thread",            { event_mdown = private.get_thread                }},
    { "spr_metalladder_cat_awlhandle",     { event_mdown = private.get_awlhandle             }},
    { "spr_metalladder_sprayer",           { event_mdown = private.get_sprayer               }},
    { "obj_metalladder_cat_use_feed",      { event_mdown = private.UseFeed                   }}, 

    { "spr_clarksstuff_sappershovel",      { event_mdown = private.get_sappershovel          }},
    { "spr_clarksstuff_rubbedkey",         { event_mdown = private.get_rubbedkey             }},
    { "spr_clarksstuff_small_photo",       { event_mdown = private.ClkPhoto                  }},
    { "spr_clarksstuff_photo",             { event_mdown = private.ClkBigPhoto               }},
    { "spr_clarksstuff_photo2",            { event_mdown = private.ClkPhotoClose             }}, 
    { "obj_clarksstuff_use_pattern",       { event_mdown = private.UsePattern                }},

    { "spr_readingdesk_decorativeelement", { event_mdown = private.get_decorativeelement     }},
    { "obj_readingdesk_fb_clark",          { event_mdown = private.see_fb_clark              }}, 
    { "obj_readingdesk_use_awl",           { event_mdown = private.ClkBox                    }}, 
    { "spr_readingdesk_box_close",         { event_mdown = private.ClkBox                    }}, 

    { "obj_library_see_scary",             { event_mdown = private.see_library_scary         }}, 

    { "spr_library_collect_morph_item",    { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_11" ); end } },
    
    { "spr_clarksstuff_collect2_item_15",  { event_mdown = private.get_collect2_item_15      }}, 
    { "spr_readingdesk_collect2_item_9",   { event_mdown = private.get_collect2_item_9       }},
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_library = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gho_library_underbookcase",
      "gmg_library_librarysecret",
      "gzz_library_wallstash",
      "gzz_library_metalladder",
      "gzz_library_clarksstuff",
      "gzz_library_readingdesk",
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_wallstash",
      "zz_metalladder",
      "zz_clarksstuff",
      "zz_readingdesk",
      "zz_metalladder_cat"
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_library", update_game_mode_library, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_library = function ()

  local effects_table = 
  {
    "obj_library_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_library", update_performance_mode_library, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_library () end;
  --------------------------------------------------------------------------------------------
  local opn_library_map = function ()

    common_impl.VisitMapRoom( "library" );

  end;
  cmn.AddSubscriber( "opn_library", opn_library_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_11 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_11 = function ()
  
    ObjDelete( "obj_library_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_11", get_collect_morph_item_11, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_collectorsjug () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_collectorsjug" ] = {
    type = "get",
    get_obj = "spr_wallstash_collectorsjug",
    room = private.room_objname,
    zz = "zz_wallstash",
    zz_gate = "gzz_library_wallstash"
  };
  
  local get_collectorsjug_inv = function ()
  
    interface.InventoryItemAdd( "inv_collectorsjug", "spr_wallstash_collectorsjug" );
  
  end;
  
  local get_collectorsjug_closezz = function ()
  
    ObjDelete( "gfx_wallstash_collectorsjug" );
  
  end;
  
  cmn.AddSubscriber( "get_collectorsjug", get_collectorsjug_inv );
  cmn.AddSubscriber( "get_collectorsjug", get_collectorsjug_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_skull3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_skull3" ] = {
    type = "get",
    get_obj = "spr_wallstash_skull3",
    room = private.room_objname,
    zz = "zz_wallstash",
    zz_gate = "gzz_library_wallstash"
  };
  
  local get_skull3_inv = function ()
  
    local count = 0;
    
    for i = 1, 6 do
      
      if ( cmn.IsEventDone( "get_skull"..i ) ) then
        
        count = count + 1;
        
      end;
      
    end;

    interface.InventoryItemAdd( "inv_skull", "spr_wallstash_skull3", "assets/levels/level2/inv_deploy/inv_scoop_2/inv/inv_skull" );

    if count == 6 then
      
      ObjSet( "inv_skull", { drag = true } );
      
    else 
      
      ObjSet( "inv_skull", { drag = false } );

    end;  
    
    ObjSet( "inv_skull", { res = "assets/levels/level2/inv_deploy/inv_scoop_2/inv/inv_skull"..count } );
    
  end;
  
  local get_skull3_closezz = function ()
    
    if (cmn.IsEventDone("use_artificialeye") and ObjGet("gzz_library_wallstash")) then
      ObjDelete( "gzz_library_wallstash" );
    end;
    ObjDelete( "gfx_wallstash_skull3" );
  
  end;
  
  cmn.AddSubscriber( "get_skull3", get_skull3_inv );
  cmn.AddSubscriber( "get_skull3", get_skull3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_thread () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_thread" ] = {
    type = "get",
    get_obj = "spr_metalladder_thread",
    room = private.room_objname,
    zz = "zz_metalladder",
    zz_gate = "gzz_library_metalladder"
  };
  
  local get_thread_inv = function ()
  
    interface.InventoryItemAdd( "inv_thread", "spr_metalladder_thread" );
  
  end;
  
  local get_thread_closezz = function ()
  
    ObjDelete( "gfx_metalladder_thread" );
  
  end;
  
  cmn.AddSubscriber( "get_thread", get_thread_inv );
  cmn.AddSubscriber( "get_thread", get_thread_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_awlhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_awlhandle" ] = {
    type = "get",
    get_obj = "spr_metalladder_cat_awlhandle",
    room = private.room_objname,
    zz = "zz_metalladder",
    zz_gate = "gzz_library_metalladder",
    subzz = "zz_metalladder_cat",
    subzz_gate = "gzz_metalladder_metalladder_cat"
  };
  
  local get_awlhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_awlhandle", "spr_metalladder_cat_awlhandle" );
  
  end;
  
  local get_awlhandle_closezz = function ()
  
    ObjDelete( "gfx_metalladder_cat_awlhandle" );
    ObjDelete( "gzz_library_metalladder" );
  
  end;
  
  cmn.AddSubscriber( "get_awlhandle", get_awlhandle_inv );
  cmn.AddSubscriber( "get_awlhandle", get_awlhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sprayer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sprayer" ] = {
    type = "get",
    get_obj = "spr_metalladder_sprayer",
    room = private.room_objname,
    zz = "zz_metalladder",
    zz_gate = "gzz_library_metalladder"
  };
  
  local get_sprayer_inv = function ()
  
    interface.InventoryItemAdd( "inv_sprayer", "spr_metalladder_sprayer" );
    
    if cmn.IsEventDone( "use_cleaner" ) then
    
      cmn.SetInvPlusRGB( "flask", true );
      
    end;
  
  end;
  
  local get_sprayer_closezz = function ()
  
    ObjDelete( "gfx_metalladder_sprayer" );
    ObjSet( "gzz_metalladder_metalladder_cat", { input = true, visible = true } );
  
  end;
  
  cmn.AddSubscriber( "get_sprayer", get_sprayer_inv );
  cmn.AddSubscriber( "get_sprayer", get_sprayer_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sappershovel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sappershovel" ] = {
    type = "get",
    get_obj = "spr_clarksstuff_sappershovel",
    room = private.room_objname,
    zz = "zz_clarksstuff",
    zz_gate = "gzz_library_clarksstuff"
  };
  
  local get_sappershovel_inv = function ()
  
    interface.InventoryItemAdd( "inv_sappershovel", "spr_clarksstuff_sappershovel" );
  
  end;
  
  local get_sappershovel_closezz = function ()
  
    ObjDelete( "gfx_clarksstuff_sappershovel" );
    ObjDelete( "spr_clarksstuff_sappershovel_shadow" );
    ObjDelete( "spr_library_shovel_patch" );
    
  end;
  
  cmn.AddSubscriber( "get_sappershovel", get_sappershovel_inv );
  cmn.AddSubscriber( "get_sappershovel", get_sappershovel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rubbedkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rubbedkey" ] = {
    type = "get",
    get_obj = "spr_clarksstuff_rubbedkey",
    room = private.room_objname,
    zz = "zz_clarksstuff",
    zz_gate = "gzz_library_clarksstuff"
  };
  
  local get_rubbedkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_rubbedkey", "spr_clarksstuff_rubbedkey" );
  
  end;
  
  local get_rubbedkey_closezz = function ()
  
    ObjDelete( "gfx_clarksstuff_rubbedkey" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_15" ) ) then
      
      ObjDelete( "gzz_library_clarksstuff" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_rubbedkey", get_rubbedkey_inv );
  cmn.AddSubscriber( "get_rubbedkey", get_rubbedkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_decorativeelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_decorativeelement" ] = {
    type = "get",
    get_obj = "spr_readingdesk_decorativeelement",
    room = private.room_objname,
    zz = "zz_readingdesk",
    zz_gate = "gzz_library_readingdesk"
  };
  
  local get_decorativeelement_inv = function ()
  
    interface.InventoryItemAdd( "inv_decorativeelement", "spr_readingdesk_decorativeelement" );
  
  end;
  
  local get_decorativeelement_closezz = function ()
  
    ObjDelete( "gfx_readingdesk_decorativeelement" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_9" ) ) then 
      
      ObjDelete( "gzz_library_readingdesk" );
      
    end; 
    
  end;
  
  cmn.AddSubscriber( "get_decorativeelement", get_decorativeelement_inv );
  cmn.AddSubscriber( "get_decorativeelement", get_decorativeelement_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_9 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_9 = function ()
  
    ObjDelete( "obj_readingdesk_collect2_item_9" ); 
  
    if ( cmn.IsEventDone( "get_decorativeelement" ) ) then
      
      ObjDelete( "gzz_library_readingdesk" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_9", get_collect2_item_9, private.room_objname );    
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_15 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_15 = function ()
  
    ObjDelete( "obj_clarksstuff_collect2_item_15" ); 
  
    if ( cmn.IsEventDone( "get_rubbedkey" ) ) then
      
      ObjDelete( "gzz_library_clarksstuff" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_15", get_collect2_item_15, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function use_oldamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oldamulet" ] = {
    type = "use",
    inv_obj = "inv_oldamulet",
    use_place = "obj_wallstash_use_oldamulet",
    room = private.room_objname,
    zz = "zz_wallstash",
    zz_gate = "gzz_library_wallstash"
  };
  local use_oldamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_oldamulet" );
  
  end;
  local use_oldamulet_beg = function ()
  
    ObjDelete( "obj_wallstash_use_oldamulet" );
  
  end;
  local use_oldamulet_end = function ()
  
    ObjMultiSet( { 
      { "obj_wallstash_stash_1",  { visible = true, input = true } },
    } );
    ObjDelete( "spr_wallstash_door_1" )
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oldamulet", use_oldamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_oldamulet", use_oldamulet_inv );
  cmn.AddSubscriber( "use_oldamulet", use_oldamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_oldamulet_inv", use_oldamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_oldamulet_beg", use_oldamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_oldamulet_end", use_oldamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_artificialeye () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_artificialeye" ] = {
    type = "use",
    inv_obj = "inv_artificialeye",
    use_place = "obj_wallstash_use_artificialeye",
    room = private.room_objname,
    zz = "zz_wallstash",
    zz_gate = "gzz_library_wallstash"
  };
  local use_artificialeye_inv = function ()
  
    interface.InventoryItemRemove( "inv_artificialeye" );
  
  end;
  local use_artificialeye_beg = function ()
  
    ObjDelete( "obj_wallstash_use_artificialeye" );
  
  end;
  local use_artificialeye_end = function ()
  
    if (cmn.IsEventDone("get_skull3") and ObjGet("gzz_library_wallstash")) then
      ObjDelete( "gzz_library_wallstash" );
    end;
    ObjMultiSet( { 
      { "gmg_library_librarysecret",  { visible = true, input = true } },
      { "anm_wallstash_eye",          {   frame = 300                } },
      { "obj_wallstash_clk_books",  { visible = false, input = false, alp = 0 } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_artificialeye", use_artificialeye_beg, private.room_objname );
  cmn.AddSubscriber( "use_artificialeye", use_artificialeye_inv );
  cmn.AddSubscriber( "use_artificialeye", use_artificialeye_end, private.room_objname );
  cmn.AddSubscriber( "use_artificialeye_inv", use_artificialeye_inv, private.room_objname );
  cmn.AddSubscriber( "use_artificialeye_beg", use_artificialeye_beg, private.room_objname );
  cmn.AddSubscriber( "use_artificialeye_end", use_artificialeye_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_feed () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_feed" ] = {
    type = "use",
    inv_obj = "inv_feed",
    use_place = "obj_metalladder_cat_use_feed",
    room = private.room_objname,
    zz = "zz_metalladder",
    zz_gate = "gzz_library_metalladder",
    subzz = "zz_metalladder_cat",
    subzz_gate = "gzz_metalladder_metalladder_cat"
  };
  local use_feed_inv = function ()
  
    interface.InventoryItemRemove( "inv_feed" );
  
  end;
  local use_feed_beg = function ()
  
    ObjDelete( "obj_metalladder_cat_use_feed" );
  
  end;
  local use_feed_end = function ()
    
    ObjDelete( "anm_metalladder_cat_food" );  
    ObjDelete( "anm_metalladder_cat_cat" );
    ObjDelete( "anm_metalladder_cat" );
    
    ObjMultiSet( { 
      { "spr_metalladder_cat_awlhandle",  { input = true, active = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_feed", use_feed_beg, private.room_objname );
  cmn.AddSubscriber( "use_feed", use_feed_inv );
  cmn.AddSubscriber( "use_feed", use_feed_end, private.room_objname );
  cmn.AddSubscriber( "use_feed_inv", use_feed_inv, private.room_objname );
  cmn.AddSubscriber( "use_feed_beg", use_feed_beg, private.room_objname );
  cmn.AddSubscriber( "use_feed_end", use_feed_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pattern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pattern" ] = {
    type = "use",
    inv_obj = "inv_pattern",
    use_place = "obj_clarksstuff_use_pattern",
    room = private.room_objname,
    zz = "zz_clarksstuff",
    zz_gate = "gzz_library_clarksstuff"
  };
  local use_pattern_inv = function ()
  
    interface.InventoryItemRemove( "inv_pattern" );
  
  end;
  local use_pattern_beg = function ()
  
    ObjDelete( "obj_clarksstuff_use_pattern" );
  
  end;
  local use_pattern_end = function ()
  
    ObjDelete( "spr_clarksstuff_purse_close" );
    ObjMultiSet( { 
      { "spr_clarksstuff_purse_open", { visible = true, input = true } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pattern", use_pattern_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern", use_pattern_inv );
  cmn.AddSubscriber( "use_pattern", use_pattern_end, private.room_objname );
  cmn.AddSubscriber( "use_pattern_inv", use_pattern_inv, private.room_objname );
  cmn.AddSubscriber( "use_pattern_beg", use_pattern_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern_end", use_pattern_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_awl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_awl" ] = {
    type = "use",
    inv_obj = "inv_awl",
    use_place = "obj_readingdesk_use_awl",
    room = private.room_objname,
    zz = "zz_readingdesk",
    zz_gate = "gzz_library_readingdesk"
  };
  local use_awl_inv = function ()
  
    interface.InventoryItemRemove( "inv_awl" );
  
  end;
  local use_awl_beg = function ()
  
    ObjDelete( "obj_readingdesk_use_awl" );
  
  end;
  local use_awl_end = function ()
  
    ObjDelete( "spr_readingdesk_box_close" );
    ObjMultiSet( { 
      { "spr_readingdesk_box_open",  { visible = true, input = true } },
      { "spr_library_opened",        {     alp = 1                  } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_awl", use_awl_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl", use_awl_inv );
  cmn.AddSubscriber( "use_awl", use_awl_end, private.room_objname );
  cmn.AddSubscriber( "use_awl_inv", use_awl_inv, private.room_objname );
  cmn.AddSubscriber( "use_awl_beg", use_awl_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl_end", use_awl_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_boathook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boathook" ] = {
    type = "use",
    inv_obj = "inv_boathook",
    use_place = "obj_library_use_boathook",
    room = private.room_objname
  };
  local use_boathook_inv = function ()
  
    interface.InventoryItemRemove( "inv_boathook" );
  
  end;
  local use_boathook_beg = function ()
  
    ObjDelete( "obj_library_use_boathook" );
  
  end;
  local use_boathook_end = function ()
  
    ObjMultiSet( { 
      { "gzz_library_metalladder",  { visible = true, input = true } },
      { "anm_library_stairs",       {   frame = 300                } };
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boathook", use_boathook_beg, private.room_objname );
  cmn.AddSubscriber( "use_boathook", use_boathook_inv );
  cmn.AddSubscriber( "use_boathook", use_boathook_end, private.room_objname );
  cmn.AddSubscriber( "use_boathook_inv", use_boathook_inv, private.room_objname );
  cmn.AddSubscriber( "use_boathook_beg", use_boathook_beg, private.room_objname );
  cmn.AddSubscriber( "use_boathook_end", use_boathook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_fb_clark () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_fb_clark" ] = {
    type = "click",
    use_place = "obj_readingdesk_fb_clark",
    room = private.room_objname,
    zz = "zz_readingdesk",
    zz_gate = "gzz_library_readingdesk"
  };
  
  local see_fb_clark = function ()
    
    ObjDelete( "spr_readingdesk_book_close" );
    ObjDelete( "obj_readingdesk_fb_clark" );
    ObjSet( "spr_readingdesk_book_open", { visible = true } );
    ObjSet( "spr_library_book_2",        {     alp = 1    } );

  end;
  cmn.AddSubscriber( "see_fb_clark", see_fb_clark, private.room_objname );   
  --------------------------------------------------------------------------------------------
  -- function clk_wallstash_books () end;
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_wallstash_books" ] = {
      type = "click",
      use_place = "obj_wallstash_clk_books",
      room = private.room_objname,
      zz = "zz_wallstash",
      zz_gate = "gzz_library_wallstash"
    };
      
    local clk_wallstash_books = function ()
    
      ObjDelete( "obj_wallstash_clk_books" );
      ObjDelete( "obj_wallstash_books" );
      ObjDelete( "spr_library_on" );
      
      ObjSet( "obj_wallstash_use_oldamulet", { input = true } );
      ObjSet( "obj_wallstash_use_artificialeye", { input = true } );
      ObjSet( "spr_library_off", { alp = 1 } );
      
    end;
    
    cmn.AddSubscriber( "clk_wallstash_books", clk_wallstash_books, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function see_library_ghost () end;
  --------------------------------------------------------------------------------------------
    local see_library_ghost = function ()
    
      ObjDelete( "anm_library_ghost" );
      ObjSet( "obj_library_see_scary", { input = true } );
      
    end;
    
    cmn.AddSubscriber( "see_library_ghost", see_library_ghost, private.room_objname ); 
    
  --------------------------------------------------------------------------------------------
  -- function see_library_scary () end;
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "see_library_scary" ] = {
      type = "click",
      use_place = "obj_library_use_boathook",
      room = private.room_objname
    };
    local see_library_scary = function ()
    
      ObjDelete( "obj_library_see_scary" );
      ObjDelete( "anm_library_scary" );
      ObjMultiSet( { 
        { "gho_library_underbookcase",     { visible = true, input = true                          } },
        { "anm_library_scary_cycle",       {     alp = 1, playing = true                           } },
        { "tmr_library_light",             { playing = true, time = 10, endtrig = private.SeeLight } },
        { "anm_library_chandelier",        {     alp = 0                                           } },
        { "anm_library_chandelier_scary",  {     alp = 1                                           } },
      } );
      
    end;
    
    cmn.AddSubscriber( "see_library_scary", see_library_scary, private.room_objname ); 
    
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*******************************************************************************************************************
  --*** function zz_wallstash () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_wallstash" );
    ------------------------------------------------- 
    function zz_wallstash.Close ()
      
      if ( cmn.IsEventDone( "use_oldamulet" ) ) then

        cmn.NoteScaleClose( { "spr_wallstash_photo" } );

      end;
      
    end;
    
  --*******************************************************************************************************************
  --*** function zz_readingdesk () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_readingdesk" );
    ------------------------------------------------- 
    function zz_readingdesk.Close ()
      
      if ( not cmn.IsEventDone( "see_library_ghost" ) ) then

        private.see_library_ghost();
      
      end;
      
    end;
    
  --*******************************************************************************************************************
  --*** function zz_clarksstuff () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_clarksstuff" );
    ------------------------------------------------- 
    function zz_clarksstuff.Close ()
    
        ObjSet( "spr_clarksstuff_photo", { input = false, visible = false } );
        ObjSet( "spr_clarksstuff_photo2", { input = false, visible = false } );
        ObjSet( "spr_clarksstuff_small_photo", { input = true, pos_x = -110, pos_y = -32 } );
    
    end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_library();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "level2/env/aud_library_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level2/env/aud_library_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_oldamulet ()

  local item = "inv_oldamulet";

  if ( cmn.ApplyObj( item, "gzz_library_wallstash" ) ) and ( cmn.IsEventDone( "clk_wallstash_books" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wallstash", "under_frame" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wallstash_use_oldamulet" ) ) and ( cmn.IsEventDone( "clk_wallstash_books" ) ) then

    cmn.CallEventHandler( "use_oldamulet_inv" );
    cmn.CallEventHandler( "use_oldamulet_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_oldamulet" );
      cmn.CallEventHandler( "use_oldamulet_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_old_amulet", 0, "", 0 );

    local func_stash = function ()

      ObjAnimate( "spr_wallstash_door_1", "pos_y", 0, 1, func_end, { 0, 0, 0, 0.4, 2, -200 } )

    end;

    cmn.ItemFly( "spr_wallstash_old_amulet", func_stash, 2.3, 100 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_artificialeye ()

  local item = "inv_artificialeye";

  if ( cmn.ApplyObj( item, "gzz_library_wallstash" ) ) and ( cmn.IsEventDone( "clk_wallstash_books" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wallstash", "under_frame" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wallstash_use_artificialeye" ) ) and ( cmn.IsEventDone( "clk_wallstash_books" ) ) then

    cmn.CallEventHandler( "use_artificialeye_inv" );
    cmn.CallEventHandler( "use_artificialeye_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_artificialeye" );
        cmn.CallEventHandler( "use_artificialeye_end" );
        
        common.CloseSubRoom();
        cmn.GotoRoom( "mg_librarysecret" );
      
      end;
    
      ObjAnimate( "spr_wallstash_door_2", "pos_x", 0, 1, func_end_2, { 0, 0, 0, 0.3, 0, 0, 0.6, 0, -400, 0.8, 0, -400 } )
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_eye2", 0, "", 0 );
    
    ObjSet( "anm_wallstash_eye", { pos_z = 12 } );
    AnimPlay( "anm_wallstash_eye", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_feed ()

  local item = "inv_feed";

  if ( cmn.ApplyObj( item, "gzz_library_metalladder" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_metalladder' );

    return true;
    
  elseif ( cmn.ApplyObj( item, "gzz_metalladder_metalladder_cat" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_metalladder_cat", "not_frame", { nil, { x = 800, y = 300 } }, { x = 200, y = -155 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_metalladder_cat_use_feed" ) ) then

    cmn.CallEventHandler( "use_feed_inv" );
    cmn.CallEventHandler( "use_feed_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
      
        cmn.Lock( false );

        cmn.SetEventDone( "use_feed" );
        cmn.CallEventHandler( "use_feed_end" );

      end; 
      
      ObjSet( "anm_metalladder_cat_food", { alp = 0 } );  
      AnimPlay( "anm_metalladder_cat_cat", "cat_eatandgo", func_end_2 );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_cat_food", 0, "", 0 );

    AnimPlay( "anm_metalladder_cat_food", "cat_food", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pattern ()

  local item = "inv_pattern";

  if ( cmn.ApplyObj( item, "gzz_library_clarksstuff" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_clarksstuff" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_clarksstuff_use_pattern" ) ) then

    cmn.CallEventHandler( "use_pattern_inv" );
    cmn.CallEventHandler( "use_pattern_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_pattern" );
      cmn.CallEventHandler( "use_pattern_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_wallet", 0, "", 0 );

    ObjAnimate( "spr_clarksstuff_pattern", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );
    
    ObjAnimate( "spr_clarksstuff_purse_close", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1,
      0.5, 0, 1,
      0.8, 0, 0
    } );
    
    ObjSet( "spr_clarksstuff_purse_open", { visible = true } );
    ObjAnimate( "spr_clarksstuff_purse_open", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      0.5, 0, 0,
      0.8, 0, 1
    } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_awl ()

  local item = "inv_awl";

  if ( cmn.ApplyObj( item, "gzz_library_readingdesk" ) ) and cmn.IsEventDone( "see_fb_clark" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_readingdesk" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_readingdesk_use_awl" ) and cmn.IsEventDone( "see_fb_clark" ) ) then

    cmn.CallEventHandler( "use_awl_inv" );
    cmn.CallEventHandler( "use_awl_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_awl" );
      cmn.CallEventHandler( "use_awl_end" );
      
      ObjDelete( "anm_readingdesk_awl" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_awl", 0, "", 0 );

    ObjSet( "anm_readingdesk_awl",      { visible = true } );
    ObjSet( "spr_readingdesk_box_open", { visible = true } );
    AnimPlay( "anm_readingdesk_awl", "DoAnim", "" );
    
    ObjAnimate( "spr_readingdesk_box_close", "alp", 0, 0, func_end,{
      0.0, 0, 1,
      1.2, 0, 1,
      1.5, 0, 0
    } );
    ObjAnimate( "spr_readingdesk_box_open", "alp", 0, 0, "",{
      0.0, 0, 0,
      1.2, 0, 0,
      1.5, 0, 1
    } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_boathook ()

  local item = "inv_boathook";

  if ( cmn.ApplyObj( item, "obj_library_use_boathook" ) and
       cmn.IsEventDone( "see_library_scary" ) ) then

    cmn.CallEventHandler( "use_boathook_inv" );
    cmn.CallEventHandler( "use_boathook_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_boathook" );
      cmn.CallEventHandler( "use_boathook_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_hookstick2", 0, "", 0 );
    
    AnimPlay( "anm_library_stairs", "stairs", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_collectorsjug ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_collectorsjug" );
  cmn.CallEventHandler( "get_collectorsjug" );

end;
--------------------------------------------------------------------------------------------
function private.get_skull3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_skull3" );
  cmn.CallEventHandler( "get_skull3" );

end;
--------------------------------------------------------------------------------------------
function private.get_thread ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_thread" );
  cmn.CallEventHandler( "get_thread" );

end;
--------------------------------------------------------------------------------------------
function private.get_awlhandle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_awlhandle" );
  cmn.CallEventHandler( "get_awlhandle" );
  
  ObjDelete( "spr_metalladder_awlhandle" );

  common.CloseSubRoomAll();
  
end;
--------------------------------------------------------------------------------------------
function private.get_sprayer ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sprayer" );
  cmn.CallEventHandler( "get_sprayer" );
  
  cmn.GotoSubRoom( "zz_metalladder_cat", "not_frame", { nil, { x = 800, y = 300 } }, { x = 200, y = -155 } );

end;
--------------------------------------------------------------------------------------------
function private.get_sappershovel ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sappershovel" );
  cmn.CallEventHandler( "get_sappershovel" );

end;
--------------------------------------------------------------------------------------------
function private.get_rubbedkey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rubbedkey" );
  cmn.CallEventHandler( "get_rubbedkey" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_15" ) ) then
    
    common.CloseSubRoom();
    
  end; 

end;
--------------------------------------------------------------------------------------------
function private.get_decorativeelement ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_decorativeelement" );
  cmn.CallEventHandler( "get_decorativeelement" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_9" ) ) then
    
    common.CloseSubRoom();

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_9 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_9" ); 

  end;

  common_impl.PlayEffectHO( "spr_readingdesk_collect2_item_9", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_9" );
  
  if ( cmn.IsEventDone( "get_decorativeelement" ) ) then

    common.CloseSubRoom();

  end; 
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_15 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_15" ); 

  end;

  common_impl.PlayEffectHO( "spr_clarksstuff_collect2_item_15", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_15" );
  
  if ( cmn.IsEventDone( "get_rubbedkey" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_wallstash_books ()

  cmn.Lock( true );

  local func_end = function ()  

    cmn.Lock( false );

    cmn.SetEventDone( "clk_wallstash_books" );
    cmn.CallEventHandler( "clk_wallstash_books" );

  end;
  
  ObjAnimate( "spr_wallstash_book_4", "pos_xy", 0, 1, "", 
  { 
    0.0, 0, 0, 0, 
    0.3, 3, 120, 0, 
    0.8, 3, 120, -400 } );

  ObjAnimate( "spr_wallstash_book_3", "pos_xy", 0, 1, "", 
  { 
    0.0, 0, 0, 0, 
    0.5, 3, 0, 0,
    0.8, 3, 120, 0, 
    1.3, 3, 120, -450 } );

  ObjAnimate( "spr_wallstash_book_2", "pos_xy", 0, 1, "", 
  { 
    0.0, 0, 0, 0, 
    1.0, 3, 0, 0,
    1.3, 3, 120, 0, 
    1.8, 3, 120, -420 } );

  ObjAnimate( "spr_wallstash_book_1", "pos_xy", 0, 1, func_end, 
  { 
    0.0, 0, 0, 0, 
    1.5, 3, 0, 0,
    1.8, 3, 60, 0, 
    2.3, 3, 60, -300 } );

end;

--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;

--*********************************************************************************************************************
function private.see_fb_clark ()
  
  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "level2/voc/aud_fb_clark_voc",  0.2 );
      common_impl.StopAudio( "sfx", "level2/sfx/aud_fb_clark",      0.2 );
      
    end;

    cmn.SetEventDone( "see_fb_clark" );
    cmn.CallEventHandler( "see_fb_clark" );

    common_impl.ShowBbt( 'bbt_library_see_fb_clark' );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl2_stop_clarck" );

    --cmn.GotoSubRoom( "zz_readingdesk" );
    
  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_fb_clark",      0, "", 0 );
  common_impl.PlayAudio( "voc", "level2/voc/aud_fb_clark_voc",  0, "", 0 );
  
  --common.CloseSubRoom();

  cmn.PlayDialogVideo( "vid_library_fb_clark", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_library_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_library_ghost" );
    cmn.CallEventHandler( "see_library_ghost" );

    common_impl.ShowBbt( 'bbt_library_see_ghost' );
    
  end;
    
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_library_ghost_sc", 0, "", 0 );

  ObjSet( "anm_library_ghost", { alp = 1 } );
  AnimPlay( "anm_library_ghost", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_library_scary ()

  local func_end = function ()
    
    common_impl.ShowBbt( 'bbt_library_see_scary' );
    
    local func_end_2 = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "see_library_scary" );
  
    end;
    
    cmn.CallEventHandler( "see_library_scary" );
    
    ObjAnimate( private.room_objname, "pos_xy", 0, 0, func_end_2, {
      0,   0,  0,    0,
      0.2, 1, 51, -227,
      1.2, 3, 50, -226,
      2.4, 3, 52, -225,
      3,   3, 50, -226,
      3.4, 3,  0,    0,
    } );
    
    ObjAnimate( private.room_objname, "scale_xy", 0, 0, "", {
      0,   0, 1,   1,
      0.2, 1, 1.3, 1.3,
      3,   3, 1.3, 1.3,
      3.4, 3, 1,   1,
    } );
    
  end;
    
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_begin_ghost_sc", 0, "", 0 );
  
  AnimPlay( "anm_library_scary", "scary", func_end );
  ObjSet( "obj_library_see_scary", { input = false } );
  ObjSet( "anm_library_chandelier", { alp = 0 } );
  ObjSet( "anm_library_chandelier_scary", { alp = 1 } );
  
end;

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_library ()

  if not ( cmn.IsEventDone( "opn_library" ) ) then

    cmn.SetEventDone( "opn_library" );
    common_impl.ShowBbt( 'bbt_library_opn_library' );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl2_find_clark_looking" );

  end;
  cmn.CallEventHandler( "opn_library" ); 
  
end;
-----------------------------------------------------------------------------------------------------------------------
function private.WallstashClkDoor1 ()

  cmn.Lock( true );

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_wallstash_use_oldamulet' );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_shelf1", 0, "", 0 );
  ObjAnimate( "spr_wallstash_door_1", "pos_y", 0, 1, func_end, { 
    0.0, 0, 0,
    0.1, 0, -2,
    0.3, 0, 2,
    0.5, 0, -2,
    0.6, 0, 0
  } );

end;
-----------------------------------------------------------------------------------------------------------------------
function private.WallstashClkDoor2 ()

  cmn.Lock( true );

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_wallstash_use_artificialeye' );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_shelf2", 0, "", 0 );
  ObjAnimate( "spr_wallstash_door_2", "pos_x", 0, 1, func_end, { 
    0.0, 0, 0,
    0.1, 0, -2,
    0.3, 0, 2,
    0.5, 0, -2,
    0.6, 0, 0
  } );

end;
-----------------------------------------------------------------------------------------------------------------------
function private.ClkPhoto ()
  
  cmn.Lock( true );
  ObjAnimate( "spr_clarksstuff_small_photo", "ang", 0, 0, "",
  {
    0.0, 0, 0,
    0.1, 0, 0.05,
    0.2, 0, -0.05,
    0.3, 0, 0.05,
    0.4, 0, -0.05,
    0.5, 0, 0,
  } );
  
  ObjSet( "spr_clarksstuff_small_photo", { input = false } );
  ObjAnimate( "spr_clarksstuff_small_photo", "pos_xy", 0, 0, "",
  {
    0.0, 0, -110, -32,
    0.5, 0, -69, -159
  } );
  
  ObjSet( "spr_clarksstuff_photo", { input = true, visible = true } );
  
  ObjAnimate( "spr_clarksstuff_photo", "alp", 0, 0, "",
  {
    0.0, 0, 0,
    0.5, 0, 0,
    0.7, 0, 1, 
  } );  
  
  ObjAnimate( "spr_clarksstuff_photo", "pos_xy", 0, 0, function() cmn.Lock( false ); end,
  {
    0.0, 0, -67, -72,
    0.7, 0, -67, -72,
    1.2, 3, 0, 0
  } );
  
  ObjAnimate( "spr_clarksstuff_photo", "scale_xy", 0, 0, "",
  {
    0.0, 0, 0.36, 0.36,
    0.7, 0, 0.36, 0.36,
    1.2, 3, 1, 1
  } );
  
  ObjAnimate( "spr_clarksstuff_photo", "ang", 0, 0, "",
  {
    0.0, 0, -0.27,
    0.7, 0, -0.27,
    1.2, 3, 0
  } );
  
end;
-----------------------------------------------------------------------------------------------------------------------
function private.ClkBigPhoto ()
  
  cmn.Lock( true );
  
  ObjSet( "spr_clarksstuff_photo2", { input = true, visible = true } );
  ObjAnimate( "spr_clarksstuff_photo2", "alp", 0, 0, function() cmn.Lock( false ); end,
  {
    0.0, 0, 0,
    0.3, 0, 1, 
  } );  
  
end;
-----------------------------------------------------------------------------------------------------------------------
function private.ClkPhotoClose ()
  
  local func_end =function()
    
    cmn.Lock( false );
    ObjSet( "spr_clarksstuff_photo", { input = false, visible = false } );
    ObjSet( "spr_clarksstuff_photo2", { input = false, visible = false } );
    
  end;
  
  cmn.Lock( true );
  ObjAnimate( "spr_clarksstuff_small_photo", "ang", 0, 0, "",
  {
    0.0, 0, 0,
    0.9, 0, 0,
    1.0, 0, 0.05,
    1.1, 0, -0.05,
    1.2, 0, 0.05,
    1.3, 0, -0.05,
    1.4, 0, 0,
  } );
  
  ObjSet( "spr_clarksstuff_small_photo", { input = true } );
  
  ObjAnimate( "spr_clarksstuff_photo2", "alp", 0, 0, "",
  {
    0.0, 0, 1,
    0.2, 0, 0
  } );
  
  ObjAnimate( "spr_clarksstuff_small_photo", "pos_xy", 0, 0, func_end,
  {
    0.0, 0, -69, -159,
    0.9, 0, -69, -159,
    1.4, 0, -110, -32,
  } );
  
  ObjAnimate( "spr_clarksstuff_photo", "pos_xy", 0, 0, "",
  {
    0.0, 0, 0, 0,
    0.2, 0, 0, 0,
    0.7, 0, -67, -72
  } );
  
  ObjAnimate( "spr_clarksstuff_photo", "scale_xy", 0, 0, "",
  {
    0.0, 0, 1, 1,
    0.2, 0, 1, 1,
    0.7, 0, 0.36, 0.36
  } );
  
  ObjAnimate( "spr_clarksstuff_photo", "ang", 0, 0, "",
  {
    0.0, 0, 0,
    0.2, 0, 0,
    0.7, 0, -0.27
  } );
  
  ObjAnimate( "spr_clarksstuff_photo", "alp", 0, 0, "",
  {
    0.0, 0, 1,
    0.7, 0, 1,
    0.9, 3, 0
  } );
  
end;
-----------------------------------------------------------------------------------------------------------------------
function private.ClkBox ()
  
  cmn.Lock( true );
  common_impl.ShowBbt( 'bbt_readingdesk_use_awl' );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_drawer", 0, "", 0 );

  ObjAnimate( "spr_readingdesk_box_close", "pos_y", 0, 1, function() cmn.Lock( false ); end,{
    0.0, 0, 0,
    0.2, 0, 2,
    0.4, 0, 0
  } );
  
end;
-----------------------------------------------------------------------------------------------------------------------
function private.SeeLight ()
  
  AnimPlay( "anm_library_light", "light", "" );
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.UsePattern ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_clarksstuff_use_pattern' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wallet", 0, "", 0 );

  AnimPlay( "anm_clarksstuff_purse", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseFeed ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_metalladder_cat_use_feed' );
    ObjSet( "anm_metalladder_cat_cat", { animfunc = "cat_sit", playing = true } );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_angry_cat", 0, "", 0 );

  AnimPlay( "anm_metalladder_cat_cat", "cat_evil", func_end );

end;