-- name=rm_toilets
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_toilets";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_cabinet",            "room_hub" );
  ObjAttach( "zz_sink_lvl2",          "room_hub" );
  ObjAttach( "zz_windowunderceiling", "room_hub" );
  ObjAttach( "zz_draining",           "room_hub" );
  
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_cabinet_saw",                    { event_mdown = private.get_saw                       }},
    { "obj_cabinet_clk_decorativeelement",  { event_mdown = private.clk_decorativeelement         }},
    { "obj_cabinet_use_pliers",             { event_mdown = private.CabinetUsePliers              }},
    
    { "spr_sink_lvl2_duster",               { event_mdown = private.get_duster                    }},
    { "spr_sink_lvl2_file",                 { event_mdown = private.get_file                      }},
    { "obj_sink_lvl2_use_gardenglove",      { event_mdown = private.SinkLvl2UseGardenglove        }},
    
    { "spr_windowunderceiling_jugwithclay", { event_mdown = private.get_jugwithclay               }},
    { "obj_windowunderceiling_use_skull1",  { event_mdown = function() private.UseSkull( 1 ); end }},
    { "obj_windowunderceiling_use_skull2",  { event_mdown = function() private.UseSkull( 2 ); end }},
    { "obj_windowunderceiling_use_skull3",  { event_mdown = function() private.UseSkull( 3 ); end }},
    { "obj_windowunderceiling_use_skull4",  { event_mdown = function() private.UseSkull( 4 ); end }},
    { "obj_windowunderceiling_use_skull5",  { event_mdown = function() private.UseSkull( 5 ); end }},
    { "obj_windowunderceiling_use_skull6",  { event_mdown = function() private.UseSkull( 6 ); end }},
       
    { "obj_toilets_clk_squarekey",          { event_mdown = private.clk_squarekey                 }},
    { "obj_toilets_use_longstick",          { event_mdown = private.UseLongstick                  }},
       
    { "spr_draining_trashcan",              { event_mdown = private.get_trashcan                  }},
    { "spr_draining_flask",                 { event_mdown = private.get_flask                     }},
    { "obj_draining_clk_hh",                { event_mdown = private.DrainingClkHH                 }},
    
    { "spr_draining_collect2_item_11",      { event_mdown = private.get_collect2_item_11          }}, 
 
    { "spr_toilets_collect_morph_item",     { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_9" ); end } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_toilets = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gho_toilets_baths",
      "gmg_toilets_incabinet",
      "gzz_toilets_cabinet",
      "gzz_toilets_sink_lvl2",
      "gzz_toilets_windowunderceiling",
      "gzz_toilets_draining"
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_cabinet",
      "zz_sink_lvl2",
      "zz_windowunderceiling",
      "zz_draining",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_toilets", update_game_mode_toilets, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_toilets = function ()

  local effects_table = 
  {
    "obj_toilets_anim", 
    "obj_toilets_anim_over"
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_toilets", update_performance_mode_toilets, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_toilets () end;
  --------------------------------------------------------------------------------------------
  local opn_toilets_map = function ()

    common_impl.VisitMapRoom( "toilets" );

  end;
  cmn.AddSubscriber( "opn_toilets", opn_toilets_map );
  
  --------------------------------------------------------------------------------------------
  -- function win_windowunderceiling () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_windowunderceiling" ] =
  {
    type = "click",
    clk_obj = "obj_windowunderceiling_mmg",
    room = private.room_objname,
    zz = "zz_windowunderceiling",
    zz_gate = "gzz_toilets_windowunderceiling"
  };
  --*********************************************************************************************************************
  local win_windowunderceiling = function ()

    if ( cmn.IsEventDone( "win_windowunderceiling" ) ) then
      
      ObjMultiSet( { 
        { "grm_toilets_cemetery", { input = true, visible = true } },
      } );    
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_toilets_cemetery_focus");
      end;   
      ObjDelete( "spr_windowunderceiling_grille" );
      ObjDelete( "obj_windowunderceiling_mmg" );
      ObjDelete( "gzz_toilets_windowunderceiling" );
      ObjDelete( "spr_toilets_grille_3" );
      
    else 

      private.WindowunderceilingLoad();
      
    end;
    
  end;

  cmn.AddSubscriber( "win_windowunderceiling", win_windowunderceiling, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_9 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_9 = function ()
  
    ObjDelete( "obj_toilets_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_9", get_collect_morph_item_9, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_saw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_saw" ] = {
    type = "get",
    get_obj = "spr_cabinet_saw",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_toilets_cabinet"
  };
  
  local get_saw_inv = function ()
  
    interface.InventoryItemAdd( "inv_saw", "spr_cabinet_saw" );
  
  end;
  
  local get_saw_closezz = function ()
  
    ObjDelete( "gfx_cabinet_saw" );
    ObjDelete( "spr_toilets_saw" );
    
  end;
  
  cmn.AddSubscriber( "get_saw", get_saw_inv );
  cmn.AddSubscriber( "get_saw", get_saw_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_duster () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_duster" ] = {
    type = "get",
    get_obj = "spr_sink_lvl2_duster",
    room = private.room_objname,
    zz = "zz_sink_lvl2",
    zz_gate = "gzz_toilets_sink_lvl2"
  };
  
  local get_duster_inv = function ()
  
    interface.InventoryItemAdd( "inv_duster", "spr_sink_lvl2_duster" );
    cmn.SetInvPlusRGB( "dutchoven", true );
  
  end;
  
  local get_duster_closezz = function ()
  
    ObjDelete( "gfx_sink_lvl2_duster" );
  
  end;
  
  cmn.AddSubscriber( "get_duster", get_duster_inv );
  cmn.AddSubscriber( "get_duster", get_duster_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_file () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_file" ] = {
    type = "get",
    get_obj = "spr_sink_lvl2_file",
    room = private.room_objname,
    zz = "zz_sink_lvl2",
    zz_gate = "gzz_toilets_sink_lvl2"
  };
  
  local get_file_inv = function ()
  
    interface.InventoryItemAdd( "inv_file", "spr_sink_lvl2_file" );
  
  end;
  
  local get_file_closezz = function ()
  
    ObjDelete( "gfx_sink_lvl2_file" );
    ObjDelete( "gzz_toilets_sink_lvl2" );
    ObjDelete( "spr_toilets_file" );
    
  end;
  
  cmn.AddSubscriber( "get_file", get_file_inv );
  cmn.AddSubscriber( "get_file", get_file_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_jugwithclay () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_jugwithclay" ] = {
    type = "get",
    get_obj = "spr_windowunderceiling_jugwithclay",
    room = private.room_objname,
    zz = "zz_windowunderceiling",
    zz_gate = "gzz_toilets_windowunderceiling"
  };
  
  local get_jugwithclay_inv = function ()
  
    interface.InventoryItemAdd( "inv_jugwithclay", "spr_windowunderceiling_jugwithclay" );
  
  end;
  
  local get_jugwithclay_closezz = function ()
  
    ObjDelete( "gfx_windowunderceiling_jugwithclay" );
  
  end;
  
  cmn.AddSubscriber( "get_jugwithclay", get_jugwithclay_inv );
  cmn.AddSubscriber( "get_jugwithclay", get_jugwithclay_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_trashcan () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_trashcan" ] = {
    type = "get",
    get_obj = "gfx_draining_trashcan",
    room = private.room_objname,
    zz = "zz_draining",
    zz_gate = "gzz_toilets_draining"
  };
  
  local get_trashcan_inv = function ()
  
    interface.InventoryItemAdd( "inv_trashcan", "spr_draining_trashcan" );
    ObjSet( "inv_trashcan", { drag = false } );
  
  end;
  
  local get_trashcan_closezz = function ()
  
    ObjDelete( "gfx_draining_trashcan" );
    
    if ( cmn.IsEventDone( "get_flask" ) and
    cmn.IsGetCollect2( "get_collect2_item_11" ) ) then
      
      ObjDelete( "gzz_toilets_draining" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_trashcan", get_trashcan_inv );
  cmn.AddSubscriber( "get_trashcan", get_trashcan_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flask () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flask" ] = {
    type = "get",
    get_obj = "gfx_draining_flask",
    room = private.room_objname,
    zz = "zz_draining",
    zz_gate = "gzz_toilets_draining"
  };
  
  local get_flask_inv = function ()
  
    interface.InventoryItemAdd( "inv_flask", "spr_draining_flask" );
    ObjSet( "inv_flask", { drag = false } );
    
    if not cmn.IsEventDone( "get_cleaner" ) then
    
      cmn.SetInvPlusRGB( "flask", false );
      
    end;
  
  end;
  
  local get_flask_closezz = function ()
  
    ObjDelete( "gfx_draining_flask" );
    ObjDelete( "spr_toilets_bottle" );
    
    if ( cmn.IsEventDone( "get_trashcan" ) and
    cmn.IsGetCollect2( "get_collect2_item_11" ) ) then
      
      ObjDelete( "gzz_toilets_draining" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_flask", get_flask_inv );
  cmn.AddSubscriber( "get_flask", get_flask_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_11 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_11 = function ()
  
    ObjDelete( "obj_draining_collect2_item_11" ); 
  
    if ( cmn.IsEventDone( "get_flask" ) and
    cmn.IsEventDone( "get_trashcan" ) ) then

      ObjDelete( "gzz_toilets_draining" );

    end; 
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_11", get_collect2_item_11, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function use_pliers_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pliers_3" ] = {
    type = "use",
    inv_obj = "inv_pliers",
    use_place = "obj_cabinet_use_pliers",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_toilets_cabinet"
  };
  local use_pliers_3_inv = function ()
  
    if ( cmn.IsEventDone( "use_pliers_1" ) and
    cmn.IsEventDone( "use_pliers_2" ) ) then
      
      interface.InventoryItemRemove( "inv_pliers" );
      
    end;
    
  end;
  local use_pliers_3_beg = function ()
  
    ObjDelete( "obj_cabinet_use_pliers" );
  
  end;
  local use_pliers_3_end = function ()
    
    ObjDelete( "anm_cabinet_pliers" );
    
    ObjDelete( "gzz_toilets_cabinet" );
    ObjMultiSet( { 
      { "gmg_toilets_incabinet",  { visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pliers_3", use_pliers_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers_3", use_pliers_3_inv );
  cmn.AddSubscriber( "use_pliers_3", use_pliers_3_end, private.room_objname );
  cmn.AddSubscriber( "use_pliers_3_inv", use_pliers_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_pliers_3_beg", use_pliers_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers_3_end", use_pliers_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_decorativeelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_decorativeelement" ] = {
    type = "use",
    inv_obj = "inv_decorativeelement",
    use_place = "obj_cabinet_use_decorativeelement",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_toilets_cabinet"
  };
  local use_decorativeelement_inv = function ()
  
    interface.InventoryItemRemove( "inv_decorativeelement" );
  
  end;
  local use_decorativeelement_beg = function ()
  
    ObjDelete( "obj_cabinet_use_decorativeelement" );
  
  end;
  local use_decorativeelement_end = function ()
  
    ObjMultiSet( { 
      { "spr_cabinet_fish",  { alp = 1, visible = true } },
      { "obj_cabinet_clk_decorativeelement",  { input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_decorativeelement", use_decorativeelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_decorativeelement", use_decorativeelement_inv );
  cmn.AddSubscriber( "use_decorativeelement", use_decorativeelement_end, private.room_objname );
  cmn.AddSubscriber( "use_decorativeelement_inv", use_decorativeelement_inv, private.room_objname );
  cmn.AddSubscriber( "use_decorativeelement_beg", use_decorativeelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_decorativeelement_end", use_decorativeelement_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gardenglove () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gardenglove" ] = {
    type = "use",
    inv_obj = "inv_gardenglove",
    use_place = "obj_sink_lvl2_use_gardenglove",
    room = private.room_objname,
    zz = "zz_sink_lvl2",
    zz_gate = "gzz_toilets_sink_lvl2"
  };
  local use_gardenglove_inv = function ()
  
    interface.InventoryItemRemove( "inv_gardenglove" );
  
  end;
  local use_gardenglove_beg = function ()
  
    ObjDelete( "obj_sink_lvl2_use_gardenglove" );
  
  end;
  local use_gardenglove_end = function ()
  
    ObjDelete( "anm_sink_lvl2_thorns" );
    ObjDelete( "spr_sink_lvl2_thorns_shadow" );
    ObjDelete( "vid_sink_lvl2_glowe" );
    
    ObjDelete( "spr_toilets_thorns" );
    
    ObjMultiSet( { 
      { "spr_sink_lvl2_file",  { input = true } },
      { "gfx_sink_lvl2_file",  { active = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gardenglove", use_gardenglove_beg, private.room_objname );
  cmn.AddSubscriber( "use_gardenglove", use_gardenglove_inv );
  cmn.AddSubscriber( "use_gardenglove", use_gardenglove_end, private.room_objname );
  cmn.AddSubscriber( "use_gardenglove_inv", use_gardenglove_inv, private.room_objname );
  cmn.AddSubscriber( "use_gardenglove_beg", use_gardenglove_beg, private.room_objname );
  cmn.AddSubscriber( "use_gardenglove_end", use_gardenglove_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_skull () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_skull" ] = {
    type = "use",
    inv_obj = "inv_skull",
    use_place = "obj_windowunderceiling_use_skull3",
    room = private.room_objname,
    zz = "zz_windowunderceiling",
    zz_gate = "gzz_toilets_windowunderceiling"
  };
  local use_skull_inv = function ()
  
    interface.InventoryItemRemove( "inv_skull" );
  
  end;
  local use_skull_beg = function ()
  
    ObjDelete( "obj_windowunderceiling_use_skull" );
  
  end;
  local use_skull_end = function ()
    
    ObjMultiSet( { 
      { "spr_windowunderceiling_skull_1", {   alp = 1    } },
      { "spr_windowunderceiling_skull_2", {   alp = 1    } },
      { "spr_windowunderceiling_skull_3", {   alp = 1    } },
      { "spr_windowunderceiling_skull_4", {   alp = 1    } },
      { "spr_windowunderceiling_skull_5", {   alp = 1    } },
      { "spr_windowunderceiling_skull_6", {   alp = 1    } },
      { "obj_windowunderceiling_mmg",     { input = true } },
    } );    
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_skull", use_skull_beg, private.room_objname );
  cmn.AddSubscriber( "use_skull", use_skull_inv );
  cmn.AddSubscriber( "use_skull", use_skull_end, private.room_objname );
  cmn.AddSubscriber( "use_skull_inv", use_skull_inv, private.room_objname );
  cmn.AddSubscriber( "use_skull_beg", use_skull_beg, private.room_objname );
  cmn.AddSubscriber( "use_skull_end", use_skull_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_collectorsjug () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_collectorsjug" ] = {
    type = "use",
    inv_obj = "inv_collectorsjug",
    use_place = "obj_windowunderceiling_use_collectorsjug",
    room = private.room_objname,
    zz = "zz_windowunderceiling",
    zz_gate = "gzz_toilets_windowunderceiling"
  };
  local use_collectorsjug_inv = function ()
  
    interface.InventoryItemRemove( "inv_collectorsjug" );
  
  end;
  local use_collectorsjug_beg = function ()
  
    ObjDelete( "obj_windowunderceiling_use_collectorsjug" );
  
  end;
  local use_collectorsjug_end = function ()
    
    ObjDelete( "anm_windowunderceiling_clay" );    
    ObjDelete( "spr_windowunderceiling_jugwithclay_2" );   
    
    ObjMultiSet( { 
      { "obj_windowunderceiling_use_sappershovel", { visible = true, input = true } },
      { "spr_windowunderceiling_jugwithclay",      {     alp = 1                  } },
      { "anm_windowunderceiling_shovel",           {     alp = 1                  } },
    } );
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_collectorsjug", use_collectorsjug_beg, private.room_objname );
  cmn.AddSubscriber( "use_collectorsjug", use_collectorsjug_inv );
  cmn.AddSubscriber( "use_collectorsjug", use_collectorsjug_end, private.room_objname );
  cmn.AddSubscriber( "use_collectorsjug_inv", use_collectorsjug_inv, private.room_objname );
  cmn.AddSubscriber( "use_collectorsjug_beg", use_collectorsjug_beg, private.room_objname );
  cmn.AddSubscriber( "use_collectorsjug_end", use_collectorsjug_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sappershovel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sappershovel" ] = {
    type = "use",
    inv_obj = "inv_sappershovel",
    use_place = "obj_windowunderceiling_use_sappershovel",
    room = private.room_objname,
    zz = "zz_windowunderceiling",
    zz_gate = "gzz_toilets_windowunderceiling"
  };
  local use_sappershovel_inv = function ()
  
    interface.InventoryItemRemove( "inv_sappershovel" );
  
  end;
  local use_sappershovel_beg = function ()
  
    ObjDelete( "obj_windowunderceiling_use_sappershovel" );
  
  end;
  local use_sappershovel_end = function ()
    
    ObjDelete( "spr_windowunderceiling_crop_grille" );
    ObjMultiSet( { 
      { "spr_windowunderceiling_jugwithclay", { visible = true, input = true } },
      { "anm_windowunderceiling_shovel",      {   frame = 300                } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sappershovel", use_sappershovel_beg, private.room_objname );
  cmn.AddSubscriber( "use_sappershovel", use_sappershovel_inv );
  cmn.AddSubscriber( "use_sappershovel", use_sappershovel_end, private.room_objname );
  cmn.AddSubscriber( "use_sappershovel_inv", use_sappershovel_inv, private.room_objname );
  cmn.AddSubscriber( "use_sappershovel_beg", use_sappershovel_beg, private.room_objname );
  cmn.AddSubscriber( "use_sappershovel_end", use_sappershovel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ironleaf () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ironleaf" ] = {
    type = "use",
    inv_obj = "inv_ironleaf",
    use_place = "obj_draining_1_use_ironleaf",
    room = private.room_objname,
    zz = "zz_draining",
    zz_gate = "gzz_toilets_draining",
    subzz = "zz_draining_1",
    subzz_gate = "gzz_draining_draining_1"
  };
  local use_ironleaf_inv = function ()
  
    interface.InventoryItemRemove( "inv_ironleaf" );
  
  end;
  local use_ironleaf_beg = function ()
  
    ObjDelete( "obj_draining_1_use_ironleaf" );
  
  end;
  local use_ironleaf_end = function ()
  
    ObjDelete( "anm_draining_1_mini_steam" );
    ObjDelete( "anm_draining_steam" );
    ObjDelete( "gzz_draining_draining_1" );
    
    ObjMultiSet( { 
      { "anm_draining_1_tray",  { alp = 1, visible = true, frame = 500 } },
      { "spr_draining_trashcan",  { input = true } },
      { "gfx_draining_trashcan",  { active = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ironleaf", use_ironleaf_beg, private.room_objname );
  cmn.AddSubscriber( "use_ironleaf", use_ironleaf_inv );
  cmn.AddSubscriber( "use_ironleaf", use_ironleaf_end, private.room_objname );
  cmn.AddSubscriber( "use_ironleaf_inv", use_ironleaf_inv, private.room_objname );
  cmn.AddSubscriber( "use_ironleaf_beg", use_ironleaf_beg, private.room_objname );
  cmn.AddSubscriber( "use_ironleaf_end", use_ironleaf_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_longstick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_longstick" ] = {
    type = "use",
    inv_obj = "inv_longstick",
    use_place = "obj_toilets_use_longstick",
    room = private.room_objname 
  };
  local use_longstick_inv = function ()
  
    interface.InventoryItemRemove( "inv_longstick" );
  
  end;
  local use_longstick_beg = function ()
  
    ObjDelete( "obj_toilets_use_longstick" );
  
  end;
  local use_longstick_end = function ()
  
    ObjMultiSet( { 
      { "gho_toilets_baths",     { visible = true, input = true } },
      { "anm_toilets_bathdoor",  {   frame = 300                } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_longstick", use_longstick_beg, private.room_objname );
  cmn.AddSubscriber( "use_longstick", use_longstick_inv );
  cmn.AddSubscriber( "use_longstick", use_longstick_end, private.room_objname );
  cmn.AddSubscriber( "use_longstick_inv", use_longstick_inv, private.room_objname );
  cmn.AddSubscriber( "use_longstick_beg", use_longstick_beg, private.room_objname );
  cmn.AddSubscriber( "use_longstick_end", use_longstick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_squarekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_squarekey" ] = {
    type = "use",
    inv_obj = "inv_squarekey",
    use_place = "obj_toilets_use_squarekey",
    room = private.room_objname 
  };
  local use_squarekey_inv = function ()
  
    interface.InventoryItemRemove( "inv_squarekey" );
  
  end;
  local use_squarekey_beg = function ()
  
    ObjDelete( "obj_toilets_use_squarekey" );
  
  end;
  local use_squarekey_end = function ()
  
    ObjMultiSet( { 
      { "obj_toilets_clk_squarekey",  { input = true } },
      { "spr_toilets_door_key",       {   alp = 1    } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_squarekey", use_squarekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_squarekey", use_squarekey_inv );
  cmn.AddSubscriber( "use_squarekey", use_squarekey_end, private.room_objname );
  cmn.AddSubscriber( "use_squarekey_inv", use_squarekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_squarekey_beg", use_squarekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_squarekey_end", use_squarekey_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_decorativeelement () end;
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_decorativeelement" ] = {
      type = "click",
      use_place = "obj_cabinet_clk_decorativeelement",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_toilets_cabinet"
    };
    
    local clk_decorativeelement_beg = function ()

      ObjDelete( "obj_cabinet_clk_decorativeelement" );
    
    end;
    local clk_decorativeelement_end = function ()
      
      ObjMultiSet( { 
        { "spr_cabinet_open",        {   alp = 1, visible = true } },
        { "obj_cabinet_use_pliers",  { input = true              } },
        { "spr_toilets_cupboard",    {   alp = 1                 } },
      } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_decorativeelement",     clk_decorativeelement_beg, private.room_objname );
    cmn.AddSubscriber( "clk_decorativeelement",     clk_decorativeelement_end, private.room_objname );
    cmn.AddSubscriber( "clk_decorativeelement_beg", clk_decorativeelement_beg, private.room_objname );
    cmn.AddSubscriber( "clk_decorativeelement_end", clk_decorativeelement_end, private.room_objname ); 
    
  --------------------------------------------------------------------------------------------
  -- function clk_squarekey () end;
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_squarekey" ] = {
      type = "click",
      use_place = "obj_toilets_clk_squarekey",
      room = private.room_objname,
    };
    
    local clk_squarekey_beg = function ()

      ObjDelete( "obj_toilets_clk_squarekey" );
    
    end;
    local clk_squarekey_end = function ()
      
      ObjDelete( "obj_toilets_az_door" );      
      ObjMultiSet( { 
        { "grm_toilets_stairflight",  { visible = true, input = true } },
        { "anm_toilets_front_door",   {   frame = 300                } },
      } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_toilets_stairflight_focus");
      end;
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_squarekey",     clk_squarekey_beg, private.room_objname );
    cmn.AddSubscriber( "clk_squarekey",     clk_squarekey_end, private.room_objname );
    cmn.AddSubscriber( "clk_squarekey_beg", clk_squarekey_beg, private.room_objname );
    cmn.AddSubscriber( "clk_squarekey_end", clk_squarekey_end, private.room_objname );   
    
  --------------------------------------------------------------------------------------------
  -- function see_toilets_down () end;
  --------------------------------------------------------------------------------------------
    local see_toilets_down = function ()
    
      ObjDelete( "anm_toilets_horror_down" );
      
    end;
    
    cmn.AddSubscriber( "see_toilets_down", see_toilets_down, private.room_objname ); 
    
  --------------------------------------------------------------------------------------------
  -- function see_toilets_birds () end;
  --------------------------------------------------------------------------------------------
    local see_toilets_birds = function ()
    
      ObjDelete( "anm_toilets_birds" );
      
    end;
    
    cmn.AddSubscriber( "see_toilets_birds", see_toilets_birds, private.room_objname ); 
    
  --------------------------------------------------------------------------------------------
  -- function see_toilets_ghost () end;
  --------------------------------------------------------------------------------------------
    local see_toilets_ghost = function ()
    
      ObjDelete( "anm_toilets_ghost" );

    end;
    
    cmn.AddSubscriber( "see_toilets_ghost", see_toilets_ghost, private.room_objname ); 
    
  --------------------------------------------------------------------------------------------
  -- function see_toilets_ghost2 () end;
  --------------------------------------------------------------------------------------------
    local see_toilets_ghost2 = function ()
    
      ObjDelete( "vid_toilets_ghoust" );

    end;
    
    cmn.AddSubscriber( "see_toilets_ghost2", see_toilets_ghost2, private.room_objname ); 
    
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_windowunderceiling () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_windowunderceiling" );  
    -------------------------------------------------
    function zz_windowunderceiling.PreOpen ()
      
      if cmn.IsEventDone( "use_skull" ) and
         not cmn.IsEventDone( "win_windowunderceiling" ) then 
        
        cmn.MiniGameShow( "windowunderceiling" );
        common_impl.PassingMgStart( "windowunderceiling" );
        
      end;

    end; 
    -------------------------------------------
    function zz_windowunderceiling.PreClose ()

      if cmn.IsEventDone( "use_skull" ) and
         not cmn.IsEventDone( "win_windowunderceiling" ) then 
        
        cmn.MiniGameHide( "windowunderceiling" );
        common_impl.PassingMgStop( "windowunderceiling" );
        
      end;

    end; 
    ------------------------------------------------- 
    function zz_windowunderceiling.Skip ()
      
      private.WindowunderceilingWin();
    
    end;
    -------------------------------------------------
    function zz_windowunderceiling.Reset ()
     
      ng_global.progress[ "std" ][ "win_windowunderceiling" ].stage = 3;   
      private.WindowunderceilingLoad();
      private.WindowunderceilingBack();
      
    end;
    -------------------------------------------------
    function zz_windowunderceiling.Close ()
      
      if ( cmn.IsEventDone( "win_windowunderceiling" ) and
           not cmn.IsEventDone( "see_toilets_birds" ) ) then

        private.see_toilets_birds();
      
      end;  
      
    end;   
  --*******************************************************************************************************************
  --*** function zz_cabinet () end ****
  --*******************************************************************************************************************
  
    subroom.Define( "zz_cabinet" );
    ------------------------------------------------- 
    function zz_cabinet.Close ()

      if ( not cmn.IsEventDone( "see_toilets_down" ) ) then

        private.see_toilets_down();
      
      end;
      
    end;

  --*******************************************************************************************************************
  --*** function zz_sink_lvl2 () end ****
  --*******************************************************************************************************************
  
    subroom.Define( "zz_sink_lvl2" );
    ------------------------------------------------- 
    function zz_sink_lvl2.Close ()

      if ( cmn.IsEventDone( "get_duster" ) and not cmn.IsEventDone( "see_toilets_ghost" ) ) then

        private.see_toilets_ghost();
      
      end;
      
    end;

  --*******************************************************************************************************************
  --*** function zz_draining () end ****
  --*******************************************************************************************************************  
    subroom.Define( "zz_draining" );
    ------------------------------------------------- 
    function zz_draining.Open ()
      if ( not cmn.IsEventDone( "use_ironleaf" ) ) then
        common_impl.PlayAudio( "env", "level2/env/aud_steam_env", 1, "", 0 );
      end;
    end;
    ------------------------------------------------- 
    function zz_draining.Close ()
      if ( not cmn.IsEventDone( "use_ironleaf" ) ) then
        common_impl.StopAudio( "env", "level2/env/aud_steam_env", 0.2 );
      end;
    end;
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_toilets();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  if ( cmn.IsEventDone( "win_windowunderceiling" ) and
       not cmn.IsEventDone( "see_toilets_birds" ) ) then

    private.see_toilets_birds();
  
  end;  

  common_impl.EnvPlay( { "level2/env/aud_toilets_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level2/env/aud_toilets_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_pliers_3 ()

  local item = "inv_pliers";

  if ( cmn.ApplyObj( item, "gzz_toilets_cabinet" ) and
  cmn.IsEventDone( "clk_decorativeelement" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cabinet" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_pliers" ) and
  cmn.IsEventDone( "clk_decorativeelement" ) ) then

    cmn.CallEventHandler( "use_pliers_3_inv" );
    cmn.CallEventHandler( "use_pliers_3_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_pliers_3" );
      cmn.CallEventHandler( "use_pliers_3_end" );
      
      common.CloseSubRoom();
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_pliers3", 0, "", 0 );

    AnimPlay( "anm_cabinet_pliers", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_decorativeelement ()

  local item = "inv_decorativeelement";

  if ( cmn.ApplyObj( item, "gzz_toilets_cabinet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cabinet" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_decorativeelement" ) ) then

    cmn.CallEventHandler( "use_decorativeelement_inv" );
    cmn.CallEventHandler( "use_decorativeelement_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_decorativeelement" );
      cmn.CallEventHandler( "use_decorativeelement_end" );
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_fishamulet", 0, "", 0 );

    cmn.ItemFly( "spr_cabinet_fish", func_end, 1.22 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_gardenglove ()

  local item = "inv_gardenglove";

  if ( cmn.ApplyObj( item, "gzz_toilets_sink_lvl2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sink_lvl2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sink_lvl2_use_gardenglove" ) ) then

    cmn.CallEventHandler( "use_gardenglove_inv" );
    cmn.CallEventHandler( "use_gardenglove_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_gardenglove" );
      cmn.CallEventHandler( "use_gardenglove_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_glove", 0, "", 0 );

    ObjMultiSet( { 
      { "vid_sink_lvl2_glowe",  { alp = 1, visible = true  } },
      { "anm_sink_lvl2_thorns", { alp = 0, visible = false } },
    } );
    
    VidPlay( "vid_sink_lvl2_glowe", func_end );
    ObjAnimate( "spr_sink_lvl2_thorns_shadow", "alp",0,0, "", { 0, 0, 1,    1.0, 0, 1,    1.2, 0, 0 } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_collectorsjug ()

  local item = "inv_collectorsjug";

  if ( cmn.ApplyObj( item, "gzz_toilets_windowunderceiling" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowunderceiling" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowunderceiling_use_collectorsjug" ) ) then

    cmn.CallEventHandler( "use_collectorsjug_inv" );
    cmn.CallEventHandler( "use_collectorsjug_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_collectorsjug" );
      cmn.CallEventHandler( "use_collectorsjug_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_bucket2", 0, "", 0 );

    cmn.ItemFly( "spr_windowunderceiling_jugwithclay", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sappershovel ()

  local item = "inv_sappershovel";

  if ( cmn.ApplyObj( item, "gzz_toilets_windowunderceiling" ) and
       cmn.IsEventDone( "use_collectorsjug" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowunderceiling" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowunderceiling_use_sappershovel" ) and
           cmn.IsEventDone( "use_collectorsjug" ) ) then

    cmn.CallEventHandler( "use_sappershovel_inv" );
    cmn.CallEventHandler( "use_sappershovel_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_sappershovel" );
      cmn.CallEventHandler( "use_sappershovel_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_shovel", 0, "", 0 );

    AnimPlay( "anm_windowunderceiling_shovel", "shovel", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_skull ()

  local item = "inv_skull";

  if ( cmn.ApplyObj( item, "gzz_toilets_windowunderceiling" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowunderceiling" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowunderceiling_use_skull" ) ) then

    cmn.CallEventHandler( "use_skull_inv" );
    cmn.CallEventHandler( "use_skull_beg" );
    
    local count = 1;
    
    local func_end_2 = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_skull" );
      cmn.CallEventHandler( "use_skull_end" );
        
      private.WindowunderceilingLoad();
      cmn.MiniGameShow( "windowunderceiling" );
      common_impl.PassingMgStart( "windowunderceiling" );
        
    end;
    
    local func_end = function ()
      
  --    if count ~= 7 then
  --      
  --      count = count + 1;
  --
  --    else 
  --      
  --      func_end_2();
  --      
  --    end; 
    
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_sculls", 0, "", 0 );

    cmn.ItemFly( "spr_windowunderceiling_skull_1", func_end, 1.22 ); 
    cmn.ItemFly( "spr_windowunderceiling_skull_2", func_end, 1.22 );  
    cmn.ItemFly( "spr_windowunderceiling_skull_3", func_end, 1.22 );  
    cmn.ItemFly( "spr_windowunderceiling_skull_4", func_end, 1.22 );  
    cmn.ItemFly( "spr_windowunderceiling_skull_5", func_end, 1.22 );  
    cmn.ItemFly( "spr_windowunderceiling_skull_6", func_end_2, 1.22 );   

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ironleaf ()

  local item = "inv_ironleaf";
  local item_wrong = "inv_duster";

  if ( cmn.ApplyObj( item, "gzz_toilets_draining" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_draining', 'under_frame' )

    return true;
   
  elseif ( cmn.ApplyObj( item, "gzz_draining_draining_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_draining_1', 'not_frame', { { x = 600, y = 300 },{ x = 800, y = 300 } }, { x = 201, y = -154 } ); 
    
    return true;

  elseif ( cmn.ApplyObj( item_wrong, "obj_draining_1_use_ironleaf" ) ) then

    common_impl.ShowBbt( 'bbt_draining_use_ironleaf_wrong' );
    return true;

  elseif ( cmn.ApplyObj( item, "obj_draining_1_use_ironleaf" ) ) then

    cmn.CallEventHandler( "use_ironleaf_inv" );
    cmn.CallEventHandler( "use_ironleaf_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_ironleaf" );
      cmn.CallEventHandler( "use_ironleaf_end" );
      
      common.CloseSubRoom();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_tray", 0, "", 0 );
    common_impl.StopAudio( "env", "level2/env/aud_steam_env", 0.2 );

    ObjMultiSet( { 
      { "anm_draining_1_tray",  { alp = 1, visible = true } },
      { "anm_draining_1_mini_steam",  { alp = 0, visible = false } },
    } );
    
    AnimPlay( "anm_draining_1_tray", "tray", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_longstick ()

  local item = "inv_longstick";

  if ( cmn.ApplyObj( item, "obj_toilets_use_longstick" ) ) then

    cmn.CallEventHandler( "use_longstick_inv" );
    cmn.CallEventHandler( "use_longstick_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_longstick" );
      cmn.CallEventHandler( "use_longstick_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_lever2", 0, "", 0 );

    AnimPlay( "anm_toilets_bathdoor", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_squarekey ()

  local item = "inv_squarekey";

  if ( cmn.ApplyObj( item, "obj_toilets_use_squarekey" ) ) then

    cmn.CallEventHandler( "use_squarekey_inv" );
    cmn.CallEventHandler( "use_squarekey_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_squarekey" );
      cmn.CallEventHandler( "use_squarekey_end" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_key_to_library", 0, "", 0 );

    cmn.ItemFly( "spr_toilets_door_key", func_end, 1.6, 60 );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_saw ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_saw" );
  cmn.CallEventHandler( "get_saw" );

end;
--------------------------------------------------------------------------------------------
function private.get_duster ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_duster" );
  cmn.CallEventHandler( "get_duster" );

end;
--------------------------------------------------------------------------------------------
function private.get_file ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_file" );
  cmn.CallEventHandler( "get_file" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_jugwithclay ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_jugwithclay" );
  cmn.CallEventHandler( "get_jugwithclay" );

end;
--------------------------------------------------------------------------------------------
function private.get_trashcan ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_trashcan" );
  cmn.CallEventHandler( "get_trashcan" );

  if ( cmn.IsEventDone( "get_flask" ) ) then
    
    common.CloseSubRoom();

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_flask ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_flask" );
  cmn.CallEventHandler( "get_flask" );
  
  if ( cmn.IsEventDone( "get_trashcan" ) ) then
    
    common.CloseSubRoom();

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_11 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_11" ); 

  end;

  common_impl.PlayEffectHO( "spr_draining_collect2_item_11", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_11" );
  
  if ( cmn.IsEventDone( "get_flask" ) and
  cmn.IsEventDone( "get_trashcan" ) ) then

    common.CloseSubRoom();

  end; 
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_decorativeelement ()
  
  cmn.CallEventHandler( "clk_decorativeelement_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_decorativeelement" );
    cmn.CallEventHandler( "clk_decorativeelement_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_fishamulet", 0, "", 0 );
  
  ObjSet( "spr_cabinet_open", { alp = 0, visible = true } );
  ObjAnimate( "spr_cabinet_open", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_squarekey ()
  
  cmn.CallEventHandler( "clk_squarekey_beg" );

  local func_end = function ()
    
    local func_end_2 = function ()  
      
      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_squarekey" );
      cmn.CallEventHandler( "clk_squarekey_end" ); 
      private.see_toilets_ghost2();
      
    end; 
    
    ObjSet( "spr_toilets_door", { alp = 0 } );
    AnimPlay( "anm_toilets_front_door", "DoAnim", func_end_2 );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_old_door", 0, "", 0 );
  
  ObjAnimate( "spr_toilets_door_key", "alp",0,0, "", { 0, 0, 1,    0.3, 0, 0 } );
  ObjAnimate( "spr_toilets_door_key_2", "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1 } );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;
--------------------------------------------------------------------------------------------
function private.see_toilets_down ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_toilets_down" );

    common_impl.ShowBbt( 'bbt_toilets_see_down' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );

  AnimPlay( "anm_toilets_horror_down", "horror_down_back", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_toilets_birds ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_toilets_birds" );

    common_impl.ShowBbt( 'bbt_toilets_see_birds' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );

  AnimPlay( "anm_toilets_birds", "birds_back", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_toilets_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_toilets_ghost" );
    --cmn.CallEventHandler( "see_toilets_ghost" );

    common_impl.ShowBbt( 'bbt_toilets_see_ghost' );
    
  end;
    
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_maid_ghost_sc", 0, "", 0 );

  ObjSet( "anm_toilets_ghost", { alp = 1 } );
  AnimPlay( "anm_toilets_ghost", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_toilets_ghost2 ()

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "see_toilets_ghost2" );
    --cmn.CallEventHandler( "see_toilets_ghost" );

    common_impl.ShowBbt( 'bbt_toilets_see_ghost2' );
    
  end;
    
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_shadow", 0, "", 0 );

  VidPlay( "vid_toilets_ghoust", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_toilets ()

  if not ( cmn.IsEventDone( "opn_toilets" ) ) then

    cmn.SetEventDone( "opn_toilets" );
    common_impl.ShowBbt( 'bbt_toilets_opn_toilets' );

  end;
  cmn.CallEventHandler( "opn_toilets" ); 
  
end;

--*********************************************************************************************************************
-- function *** MMG Windowunderceiling *** () end;
--*********************************************************************************************************************
  function private.WindowunderceilingLoad ()

    if not ( ng_global.progress[ "std" ][ "win_windowunderceiling" ].stage ) then
      
      ng_global.progress[ "std" ][ "win_windowunderceiling" ].stage = 3;   
      
    end;

    private.win      = { 4, 5, 3, 2, 1, 6 };
    private.state    = { 0, 0, 0, 0, 0, 0 }; 
    private.allst    = { { 5, 2, 6, 3, 4, 1 }, { 3, 6, 5, 1, 4, 2 }, { 4, 5, 3, 2, 1, 6 } };  
    private.coor     = { { -192, -159 }, { -107, -141 }, { -33, -122 }, { 30, -108 }, { 85, -94 }, { 136, -83 } };   
    private.coorold  = { { -194, -57 }, { -106, -46 }, { -32, -34 }, { 34, -24 }, { 89, -16 }, { 142, -9 } };       
    private.stage    = ng_global.progress[ "std" ][ "win_windowunderceiling" ].stage;
    
    --ObjMultiSet( { 
    --  { "spr_toy_switch_1", { alp = 0 } },
    --  { "spr_toy_switch_2", { alp = 0 } },
    --  { "spr_toy_switch_3", { alp = 0 } },
    --} );
      
    for i = 1, #private.win do
      
      ObjSet( "spr_windowunderceiling_circle_"..i, { input = true, event_mdown = function() private.WindowunderceilingClk( i ); end } );

    end;
   
    --if ( private.stage ~= 1 ) then
    --  
    --  local light = private.stage - 1;
    --  ObjSet( "spr_toy_switch_"..light, { alp = 1 } );
    --    
    --end;
    
  end;
  --------------------------------------------------------------------------------------------
  function private.WindowunderceilingIsWin ()

    for i = 1, #private.win do

      if ( private.state[ i ] ~= private.win[ i ] or 
           private.stage ~= 3 ) then
        
        return false;
        
      end;
      
    end;
      
    return true;
    
  end;
  --------------------------------------------------------------------------------------------
  function private.WindowunderceilingStageIsWin ()
  
    local stage = ng_global.progress[ "std" ][ "win_windowunderceiling" ].stage;

    for i = 1, #private.win do

      if ( private.state[ i ] ~= private.allst[ stage ][ i ] ) then
        
        return false;
        
      end;
      
    end;

    return true;

  end;
  --------------------------------------------------------------------------------------------
  function private.WindowunderceilingClk ( idx ) 
   
    private.WindowunderceilingAnim( idx );
    
  end;

  --------------------------------------------------------------------------------------------
  function private.WindowunderceilingAnim ( idx )

    local func_end = function ()
    
      cmn.Lock( false );
      
      private.WindowunderceilingCheck( idx );
        
    end;  
    
    local pos = ObjGet( "spr_windowunderceiling_circle_"..idx );
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_toyplane", 0, "", 0 );
    
    ObjSet( "spr_windowunderceiling_circle_"..idx, { input = false } );
    ObjAnimate( "spr_windowunderceiling_circle_"..idx, "pos_xy", 0, 0, func_end, { 0, 0, pos.pos_x, pos.pos_y,   0.3, 3, private.coor[ idx ][ 1 ], private.coor[ idx ][ 2 ] } );    
    
  end;  
  --------------------------------------------------------------------------------------------
  function private.WindowunderceilingSave ( idx )

    local stage = ng_global.progress[ "std" ][ "win_windowunderceiling" ].stage;

    for i = 1,#private.win do

      if ( private.state[ i ] == 0 ) then

        private.state[ i ] = idx;
           
        if ( private.WindowunderceilingIsWin() ) then

          private.WindowunderceilingWin();
          
        else 

          if private.WindowunderceilingStageIsWin() then

            common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter_toy", 0, "", 0 );

            --local alp = ObjGet( "spr_toy_switch_"..stage ).alp;
            --ObjAnimate( "spr_toy_switch_"..stage, "alp", 0, 0, "", { 0, 0, alp,   0.3, 3, 1 } ); 
            ng_global.progress[ "std" ][ "win_windowunderceiling" ].stage = ng_global.progress[ "std" ][ "win_windowunderceiling" ].stage + 1;
            private.WindowunderceilingBack()
            
          end;
          
        end;
        
        if ( private.state[ i ] ~= private.allst[ stage ][ i ] ) then

          private.WindowunderceilingBack();
          common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );

        end;
        
        break;
        
      end;
    
    end;

  end;  
  --------------------------------------------------------------------------------------------
  function private.WindowunderceilingBack ()

    local func_end = function ()
      
      cmn.Lock( false );   
      
    end;  
    
    private.state = { 0, 0, 0, 0, 0, 0 }; 
    private.stage = ng_global.progress[ "std" ][ "win_windowunderceiling" ].stage; 
  
    for i = 1, #private.win do
      
      local pos = ObjGet( "spr_windowunderceiling_circle_"..i );
      ObjAnimate( "spr_windowunderceiling_circle_"..i, "pos_xy", 0, 0, "", { 0, 0, pos.pos_x, pos.pos_y,   0.3, 3, private.coorold[ i ][ 1 ], private.coorold[ i ][ 2 ] } ); 
      ObjSet( "spr_windowunderceiling_circle_"..i, { input = true } );
      
    end; 

    cmn.Lock( true );
    ObjAnimate( "obj_windowunderceiling_mmg", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 3, 1 } );   
    
  end; 
  --------------------------------------------------------------------------------------------
  function private.WindowunderceilingCheck ( idx )
 
    local func_end = function ()
      
      cmn.Lock( false );
      private.WindowunderceilingSave( idx );
      
    end;  

    cmn.Lock( true );
    ObjAnimate( "obj_windowunderceiling_mmg", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 3, 1 } );     
    
  end;  
  --------------------------------------------------------------------------------------------
  function private.WindowunderceilingWin ()

    local func_end = function ()
    
      cmn.MiniGameHide( "windowunderceiling" );
      common_impl.PassingMgWin( "windowunderceiling" );
      cmn.SetEventDone( "win_windowunderceiling" );
      cmn.CallEventHandler( "win_windowunderceiling" );

      common_impl.PlayAudio( "sfx", "aud_win_mmg" );

      cmn.Lock( false );
      common.CloseSubRoom();
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter_toy", 0, "", 0 );

    ObjAnimate( "spr_windowunderceiling_grille", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   1, 3, -17, -495 } ); 
    ObjAnimate( "obj_windowunderceiling_mmg", "pos_xy", 0, 1, "", { 0, 0, 0, 0,   1, 3, -18, -439 } ); 

  end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.SinkLvl2UseGardenglove ()
  
  local func_end = function ()
    
    cmn.Lock( false );

  end;

  common_impl.ShowBbt( "bbt_sink_lvl2_use_gardenglove" );
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_rustle2", 0, "", 0 );

  AnimPlay( "anm_sink_lvl2_thorns", "DoAnim", func_end );
    
end;
--------------------------------------------------------------------------------------------
function private.CabinetUsePliers ()

  common_impl.ShowBbt( "bbt_cabinet_use_pliers" );
  
  local obj = "anm_cabinet_pliers";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_grill3", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;
--------------------------------------------------------------------------------------------
function private.UseLongstick ()

  local func_end = function ()
    
    cmn.Lock( false );
    ObjSet( "anm_toilets_bathdoor_hh", { alp = 0 } );
    ObjSet( "anm_toilets_bathdoor", { alp = 1 } );
    common_impl.ShowBbt( "bbt_toilets_use_longstick" );  
    
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_handle2", 0, "", 0 );

  AnimPlay( "anm_toilets_bathdoor_hh", "DoAnim", func_end );
  ObjSet( "anm_toilets_bathdoor_hh", { alp = 1 } );
  ObjSet( "anm_toilets_bathdoor", { alp = 0 } );
  
end;
--------------------------------------------------------------------------------------------
function private.UseSkull ( id )
  
  local obj = "spr_windowunderceiling_circle_"..id;
  local skull = 6;
  
  local func_end = function ()
    
    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_windowunderceiling_use_skull" );  
    
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_part3", 0, "", 0 );

  ObjAnimate( obj, "pos_xy",0,1, func_end, { 0,0,0,0, 0.1,0, 0.5 ,id - skull, 0.2,0,0,0 }); 
  
end;
--------------------------------------------------------------------------------------------
function private.DrainingClkHH ()

  common_impl.ShowBbt( "bbt_draining_clk_hh" );

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_mid", 0, "", 0 );

  AnimPlay( "anm_draining_hh", "hh", func_end ); 
  
end;

