-- name=rm_winecellar
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_winecellar";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_heavydoor", "room_hub" );
  ObjAttach( "zz_barrel",    "room_hub" );
  ObjAttach( "zz_grid",      "room_hub" );
  ObjAttach( "zz_stand",     "room_hub" );
  ObjAttach( "zz_kiln",      "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  private.WinecellarLogicInit();    
  
  ObjMultiSet({ 
    { "spr_heavydoor_wheel",               { event_mdown = private.get_wheel_lvl2              }},
    { "spr_heavydoor_glass2",              { event_mdown = private.get_glass2                  }},
    { "spr_heavydoor_pliers",              { event_mdown = private.get_pliers                  }},
    { "obj_heavydoor_clk_rug",             { event_mdown = private.clk_rug                     }},
    { "obj_heavydoor_use_symbol",          { event_mdown = private.HeavydoorUseSymbol          }},
    { "obj_heavydoor_use_patternfragment", { event_mdown = private.HeavydoorUsePatternfragment }},

    { "spr_barrel_lever",                  { event_mdown = private.get_lever                   }},
    { "spr_barrel_glass3",                 { event_mdown = private.get_glass3                  }},
    { "spr_barrel_rubber",                 { event_mdown = private.get_rubber                  }},
    { "spr_barrel_skull2",                 { event_mdown = private.get_skull2                  }},
    { "spr_barrel_spoon",                  { event_mdown = private.get_spoon                   }},
    { "obj_barrel_clk_corkscrew",          { event_mdown = private.clk_corkscrew_lvl2          }},
    { "obj_barrel_use_grapesleaf1",        { event_mdown = private.BarrelUseGrapesleaf1        }},
    { "obj_barrel_use_grapesleaf2",        { event_mdown = private.BarrelUseGrapesleaf2        }},
    { "obj_barrel_use_corkscrew",          { event_mdown = private.BarrelUseCorkscrew          }},

    { "spr_grid_grapesleaf1",              { event_mdown = private.get_grapesleaf1             }},
    { "spr_grid_tumbler",                  { event_mdown = private.get_tumbler                 }},
    { "spr_grid_rawmaterial",              { event_mdown = private.get_rawmaterial             }},
    { "obj_grid_clk_lever",                { event_mdown = private.clk_lever                   }},
    { "obj_grid_external_gride_hh",        { event_mdown = private.GridExternalGrille          }},
    { "obj_grid_use_lockpart",             { event_mdown = private.GridUseLockpart             }},
    { "obj_grid_use_lever",                { event_mdown = private.GridUseLever                }},
    { "obj_grid_use_cleaner",              { event_mdown = private.GridUseCleaner              }},
    { "spr_stand_patternfragment",         { event_mdown = private.get_patternfragment         }},
    { "spr_stand_corkscrew",               { event_mdown = private.get_corkscrew_lvl2          }},
    { "spr_stand_corkscrew_stick",         { event_mdown = private.get_corkscrew_lvl2          }},
    { "spr_stand_sandpaper",               { event_mdown = private.get_sandpaper               }},
    { "spr_stand_rod",                     { event_mdown = private.get_rod                     }},
    { "spr_stand_scoop",                   { event_mdown = private.get_scoop                   }},
    { "spr_stand_stainedglasspart2",       { event_mdown = private.get_stainedglasspart2       }},
    { "obj_stand_clk_tumbler",             { event_mdown = private.clk_tumbler                 }},
    { "obj_stand_use_glass2",              { event_mdown = private.StandUseGlass               }},
    { "obj_stand_use_glass3",              { event_mdown = private.StandUseGlass3              }},
    { "obj_stand_use_tumbler",             { event_mdown = private.StandUseTumbler             }},
    { "obj_stand_use_corkscrew_handle",    { event_mdown = private.StandUseCorkscrewHandle     }},
    { "obj_stand_use_turner",              { event_mdown = private.StandUseTurner              }},

    { "spr_kiln_lockpart",                 { event_mdown = private.get_lockpart                }},
    { "spr_kiln_scoop_2",                  { event_mdown = private.get_scoop_2                 }},
    { "spr_kiln_feed",                     { event_mdown = private.get_feed                    }},
    { "obj_kiln_clk_scoop",                { event_mdown = private.clk_scoop                   }},
    { "obj_kiln_clk_bentrod",              { event_mdown = private.clk_bentrod                 }},
    { "obj_kiln_use_bentrod",              { event_mdown = private.KilnUseBentrod              }},
    { "obj_kiln_use_animalstatuette",      { event_mdown = private.KilnUseAnimalstatuette      }},
    
    { "obj_winecellar_use_wheel",          { event_mdown = private.UseWheel                    }},
    { "obj_winecellar_use_slingshot",      { event_mdown = private.UseSlingshot                }},
    { "obj_winecellar_use_slingshot",      { event_mdown = private.UseSlingshot                }},
 
    { "spr_barrel_collect2_item_12",       { event_mdown = private.get_collect2_item_12        }}, 
   
    { "spr_winecellar_collect_morph_item", { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_8" ); end } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_winecellar = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gho_winecellar_winecollection",
      "gmg_winecellar_chain",
      "gzz_winecellar_heavydoor",
      "gzz_winecellar_barrel",
      "gzz_winecellar_grid",
      "gzz_winecellar_stand",
      "gzz_winecellar_kiln"
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_heavydoor",
      "zz_barrel",
      "zz_grid",
      "zz_stand",
      "zz_kiln",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_winecellar", update_game_mode_winecellar, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_winecellar = function ()

  local effects_table = 
  {
    "obj_winecellar_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_winecellar", update_performance_mode_winecellar, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_winecellar () end;
  --------------------------------------------------------------------------------------------
  local opn_winecellar_map = function ()

    common_impl.VisitMapRoom( "winecellar" );

  end;
  cmn.AddSubscriber( "opn_winecellar", opn_winecellar_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_8 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_8 = function ()
  
    ObjDelete( "obj_winecellar_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_8", get_collect_morph_item_8, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function get_wheel_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wheel_lvl2" ] = {
    type = "get",
    get_obj = "spr_heavydoor_wheel",
    room = private.room_objname,
    zz = "zz_heavydoor",
    zz_gate = "gzz_winecellar_heavydoor"
  };
  
  local get_wheel_lvl2_inv = function ()
  
    interface.InventoryItemAdd( "inv_wheel_lvl2", "spr_heavydoor_wheel" );
  
  end;
  
  local get_wheel_lvl2_closezz = function ()
  
    ObjDelete( "gfx_heavydoor_wheel" );
  
  end;
  
  cmn.AddSubscriber( "get_wheel_lvl2", get_wheel_lvl2_inv );
  cmn.AddSubscriber( "get_wheel_lvl2", get_wheel_lvl2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glass2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glass2" ] = {
    type = "get",
    get_obj = "spr_heavydoor_glass2",
    room = private.room_objname,
    zz = "zz_heavydoor",
    zz_gate = "gzz_winecellar_heavydoor"
  };
  
  local get_glass2_inv = function ()
  
    interface.InventoryItemAdd( "inv_glass2", "spr_heavydoor_glass2" );
  
  end;
  
  local get_glass2_closezz = function ()
  
    ObjDelete( "gfx_heavydoor_glass2" );
    ObjDelete( "spr_winecellar_zz_heavydoor_cup" );
  
  end;
  
  cmn.AddSubscriber( "get_glass2", get_glass2_inv );
  cmn.AddSubscriber( "get_glass2", get_glass2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pliers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pliers" ] = {
    type = "get",
    get_obj = "spr_heavydoor_pliers",
    room = private.room_objname,
    zz = "zz_heavydoor",
    zz_gate = "gzz_winecellar_heavydoor"
  };
  
  local get_pliers_inv = function ()
  
    interface.InventoryItemAdd( "inv_pliers", "spr_heavydoor_pliers" );
  
  end;
  
  local get_pliers_closezz = function ()
  
    ObjDelete( "gfx_heavydoor_pliers" );
    ObjDelete( "spr_winecellar_zz_heavydoor_nippers" );
  
  end;
  
  cmn.AddSubscriber( "get_pliers", get_pliers_inv );
  cmn.AddSubscriber( "get_pliers", get_pliers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lever" ] = {
    type = "get",
    get_obj = "spr_barrel_lever",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_winecellar_barrel"
  };
  
  local get_lever_inv = function ()
  
    interface.InventoryItemAdd( "inv_lever", "spr_barrel_lever" );
  
  end;
  
  local get_lever_closezz = function ()
  
    ObjDelete( "spr_winecellar_zz_barrel_lever" );
    ObjDelete( "gfx_barrel_lever" );
  
  end;
  
  cmn.AddSubscriber( "get_lever", get_lever_inv );
  cmn.AddSubscriber( "get_lever", get_lever_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glass3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glass3" ] = {
    type = "get",
    get_obj = "spr_barrel_glass3",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_winecellar_barrel"
  };
  
  local get_glass3_inv = function ()
  
    interface.InventoryItemAdd( "inv_glass3", "spr_barrel_glass3" );
  
  end;
  
  local get_glass3_closezz = function ()
  
    ObjDelete( "spr_winecellar_zz_barrel_cup" );
    ObjDelete( "gfx_barrel_glass3" );
  
  end;
  
  cmn.AddSubscriber( "get_glass3", get_glass3_inv );
  cmn.AddSubscriber( "get_glass3", get_glass3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rubber () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rubber" ] = {
    type = "get",
    get_obj = "spr_barrel_rubber",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_winecellar_barrel"
  };
  
  local get_rubber_inv = function ()
  
    interface.InventoryItemAdd( "inv_rubber", "spr_barrel_rubber" );
    
    if cmn.IsEventDone( "get_corkscrew_handle" ) then
    
      cmn.SetInvPlusRGB( "rawmaterial", true );
      
    end;
  
  end;
  
  local get_rubber_closezz = function ()
  
    ObjDelete( "spr_winecellar_zz_barrel_slingshot" );
    ObjDelete( "gfx_barrel_rubber" );
   
  end;
  
  cmn.AddSubscriber( "get_rubber", get_rubber_inv );
  cmn.AddSubscriber( "get_rubber", get_rubber_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_skull2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_skull2" ] = {
    type = "get",
    get_obj = "spr_barrel_skull2",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_winecellar_barrel"
  };
  
  local get_skull2_inv = function ()
  
    local count = 0;
    
    for i = 1, 6 do
      
      if ( cmn.IsEventDone( "get_skull"..i ) ) then
        
        count = count + 1;
        
      end;
      
    end;

    interface.InventoryItemAdd( "inv_skull", "spr_barrel_skull2", "assets/levels/level2/inv_deploy/inv_scoop_2/inv/inv_skull" );

    if count == 6 then
      
      ObjSet( "inv_skull", { drag = true } );
      
    else 
      
      ObjSet( "inv_skull", { drag = false } );

    end; 
    
    ObjSet( "inv_skull", { res = "assets/levels/level2/inv_deploy/inv_scoop_2/inv/inv_skull"..count } );
    
  end;
  
  local get_skull2_closezz = function ()
  
    ObjDelete( "spr_winecellar_zz_barrel_skull" );
    ObjDelete( "gfx_barrel_skull2" );
  
    if ( cmn.IsGetCollect2( "get_collect2_item_12" ) and cmn.IsEventDone("get_spoon") ) then
      
      ObjDelete( "gzz_winecellar_barrel" );
      
    end;
    
  end;
  
  cmn.AddSubscriber( "get_skull2", get_skull2_inv );
  cmn.AddSubscriber( "get_skull2", get_skull2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spoon () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spoon" ] = {
    type = "get",
    get_obj = "spr_barrel_spoon",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_winecellar_barrel"
  };
  
  local get_spoon_inv = function ()
  
    interface.InventoryItemAdd( "inv_spoon", "spr_barrel_spoon" );
  
  end;
  
  local get_spoon_closezz = function ()
  
    ObjDelete( "gfx_barrel_spoon" );
    ObjDelete( "spr_winecellar_zz_barrel_spoon" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_12" ) and cmn.IsEventDone("get_skull2") ) then
      
      ObjDelete( "gzz_winecellar_barrel" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_spoon", get_spoon_inv );
  cmn.AddSubscriber( "get_spoon", get_spoon_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_grapesleaf1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_grapesleaf1" ] = {
    type = "get",
    get_obj = "spr_grid_grapesleaf1",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_winecellar_grid"
  };
  
  local get_grapesleaf1_inv = function ()
  
    interface.InventoryItemAdd( "inv_grapesleaf1", "spr_grid_grapesleaf1" );
  
  end;
  
  local get_grapesleaf1_closezz = function ()
  
    ObjDelete( "gfx_grid_grapesleaf1" );
  
  end;
  
  cmn.AddSubscriber( "get_grapesleaf1", get_grapesleaf1_inv );
  cmn.AddSubscriber( "get_grapesleaf1", get_grapesleaf1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tumbler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tumbler" ] = {
    type = "get",
    get_obj = "spr_grid_tumbler",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_winecellar_grid"
  };
  
  local get_tumbler_inv = function ()
  
    interface.InventoryItemAdd( "inv_tumbler", "spr_grid_tumbler" );
  
  end;
  
  local get_tumbler_closezz = function ()
  
    ObjDelete( "gfx_grid_tumbler" );
  
  end;
  
  cmn.AddSubscriber( "get_tumbler", get_tumbler_inv );
  cmn.AddSubscriber( "get_tumbler", get_tumbler_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rawmaterial () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rawmaterial" ] = {
    type = "get",
    get_obj = "spr_grid_rawmaterial",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_winecellar_grid"
  };
  
  local get_rawmaterial_inv = function ()
  
    interface.InventoryItemAdd( "inv_rawmaterial", "spr_grid_rawmaterial" );
    ObjSet( "inv_rawmaterial", { drag = false } );
    
    if not cmn.IsEventDone( "get_sandpaper" ) then
      
      cmn.SetInvPlusRGB( "rawmaterial", false );
      
    end;
  
  end;
  
  local get_rawmaterial_closezz = function ()
  
    ObjDelete( "gfx_grid_rawmaterial" );
  
  end;
  
  cmn.AddSubscriber( "get_rawmaterial", get_rawmaterial_inv );
  cmn.AddSubscriber( "get_rawmaterial", get_rawmaterial_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_patternfragment () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_patternfragment" ] = {
    type = "get",
    get_obj = "spr_stand_patternfragment",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  
  local get_patternfragment_inv = function ()
  
    interface.InventoryItemAdd( "inv_patternfragment", "spr_stand_patternfragment" );
  
  end;
  
  local get_patternfragment_closezz = function ()
  
    ObjDelete( "gfx_stand_patternfragment" );
  
  end;
  
  cmn.AddSubscriber( "get_patternfragment", get_patternfragment_inv );
  cmn.AddSubscriber( "get_patternfragment", get_patternfragment_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_corkscrew_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_corkscrew_lvl2" ] = {
    type = "get",
    get_obj = "spr_stand_corkscrew",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  
  local get_corkscrew_lvl2_inv = function ()
  
    interface.InventoryItemAdd( "inv_corkscrew_lvl2", "spr_stand_corkscrew" );
  
  end;
  
  local get_corkscrew_lvl2_closezz = function ()
  
    ObjDelete( "gfx_stand_corkscrew"        );
    ObjDelete( "spr_stand_corkscrew_shadow" );
    ObjSet( "obj_stand_use_turner", { input = true } );  
  
  end;
  
  cmn.AddSubscriber( "get_corkscrew_lvl2", get_corkscrew_lvl2_inv );
  cmn.AddSubscriber( "get_corkscrew_lvl2", get_corkscrew_lvl2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sandpaper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sandpaper" ] = {
    type = "get",
    get_obj = "spr_stand_sandpaper",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  
  local get_sandpaper_inv = function ()
  
    interface.InventoryItemAdd( "inv_sandpaper", "spr_stand_sandpaper" );
    cmn.SetInvPlusRGB( "rawmaterial", true );
  
  end;
  
  local get_sandpaper_closezz = function ()
  
    ObjDelete( "gfx_stand_sandpaper" );
    ObjDelete( "spr_winecellar_zz_stand_sandpaper" );
  
  end;
  
  cmn.AddSubscriber( "get_sandpaper", get_sandpaper_inv );
  cmn.AddSubscriber( "get_sandpaper", get_sandpaper_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rod () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rod" ] = {
    type = "get",
    get_obj = "spr_stand_rod",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  
  local get_rod_inv = function ()
  
    interface.InventoryItemAdd( "inv_rod", "spr_stand_rod" );
    cmn.SetInvPlusRGB( "scoop_2", true );
  
  end;
  
  local get_rod_closezz = function ()
  
    ObjDelete( "gfx_stand_rod" );
    ObjDelete( "spr_winecellar_zz_stand_stick" );
  
  end;
  
  cmn.AddSubscriber( "get_rod", get_rod_inv );
  cmn.AddSubscriber( "get_rod", get_rod_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scoop () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scoop" ] = {
    type = "get",
    get_obj = "spr_stand_scoop",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  
  local get_scoop_inv = function ()
  
    interface.InventoryItemAdd( "inv_scoop", "spr_stand_scoop" );
  
  end;
  
  local get_scoop_closezz = function ()
  
    ObjDelete( "gfx_stand_scoop" );
  
  end;
  
  cmn.AddSubscriber( "get_scoop", get_scoop_inv );
  cmn.AddSubscriber( "get_scoop", get_scoop_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stainedglasspart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stainedglasspart2" ] = {
    type = "get",
    get_obj = "spr_stand_stainedglasspart2",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  
  local get_stainedglasspart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_stainedglasspart2", "spr_stand_stainedglasspart2" );
  
  end;
  
  local get_stainedglasspart2_closezz = function ()
  
    ObjDelete( "gfx_stand_stainedglasspart2" );
    ObjDelete( "gzz_winecellar_stand" );
    ObjDelete( "spr_winecellar_zz_stand_piece" );
  
  end;
  
  cmn.AddSubscriber( "get_stainedglasspart2", get_stainedglasspart2_inv );
  cmn.AddSubscriber( "get_stainedglasspart2", get_stainedglasspart2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lockpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lockpart" ] = {
    type = "get",
    get_obj = "spr_kiln_lockpart",
    room = private.room_objname,
    zz = "zz_kiln",
    zz_gate = "gzz_winecellar_kiln"
  };
  
  local get_lockpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_lockpart", "spr_kiln_lockpart" );
  
  end;
  
  local get_lockpart_closezz = function ()
  
    ObjDelete( "gfx_kiln_lockpart" );
  
  end;
  
  cmn.AddSubscriber( "get_lockpart", get_lockpart_inv );
  cmn.AddSubscriber( "get_lockpart", get_lockpart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scoop_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scoop_2" ] = {
    type = "get",
    get_obj = "spr_kiln_scoop_2",
    room = private.room_objname,
    zz = "zz_kiln",
    zz_gate = "gzz_winecellar_kiln"
  };
  
  local get_scoop_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_scoop_2", "spr_kiln_scoop_2" );
    ObjSet( "inv_scoop_2", { drag = false } );
    
    if not cmn.IsEventDone( "get_rod" ) then
    
      cmn.SetInvPlusRGB( "scoop_2", false );
      
    end;
  
  end;
  
  local get_scoop_2_closezz = function ()
  
    ObjDelete( "gfx_kiln_scoop_2" );
  
  end;
  
  cmn.AddSubscriber( "get_scoop_2", get_scoop_2_inv );
  cmn.AddSubscriber( "get_scoop_2", get_scoop_2_closezz, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_feed () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_feed" ] = {
    type = "get",
    get_obj = "spr_kiln_feed",
    room = private.room_objname,
    zz = "zz_kiln",
    zz_gate = "gzz_winecellar_kiln"
  };
  
  local get_feed_inv = function ()
  
    interface.InventoryItemAdd( "inv_feed", "spr_kiln_feed" );
  
  end;
  
  local get_feed_closezz = function ()
  
    ObjDelete( "gfx_kiln_feed" );
    ObjDelete( "gzz_winecellar_kiln" );
    ObjDelete( "spr_kiln_cat_eat_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_feed", get_feed_inv );
  cmn.AddSubscriber( "get_feed", get_feed_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_12 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_12 = function ()
  
    ObjDelete( "obj_barrel_collect2_item_12" ); 
  
    if ( cmn.IsEventDone( "get_spoon" ) and cmn.IsEventDone("get_skull2")) then
      
      ObjDelete( "gzz_winecellar_barrel" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_12", get_collect2_item_12, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function clk_rug () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_rug" ] = {
    type = "click",
    use_place = "obj_heavydoor_clk_rug",
    room = private.room_objname,
    zz = "zz_heavydoor",
    zz_gate = "gzz_winecellar_heavydoor"
  };
  
  local clk_rug_beg = function ()

    ObjDelete( "obj_heavydoor_clk_rug" );
  
  end;
  local clk_rug_end = function ()
    
    ObjDelete( "spr_heavydoor_rug" );
    ObjMultiSet( { 
      { "obj_heavydoor_use_symbol",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_rug",     clk_rug_beg, private.room_objname );
  cmn.AddSubscriber( "clk_rug",     clk_rug_end, private.room_objname );
  cmn.AddSubscriber( "clk_rug_beg", clk_rug_beg, private.room_objname );
  cmn.AddSubscriber( "clk_rug_end", clk_rug_end, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function clk_corkscrew_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_corkscrew_lvl2" ] = {
    type = "click",
    use_place = "obj_barrel_clk_corkscrew",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_winecellar_barrel"
  };
  
  local clk_corkscrew_lvl2_beg = function ()

    ObjDelete( "obj_barrel_clk_corkscrew" );
  
  end;
  local clk_corkscrew_lvl2_end = function ()
    
    ObjDelete( "anm_barrel_brocken_doors"        );
    ObjDelete( "spr_winecellar_zz_barrel_closed" );  

    ObjMultiSet( { 
      { "spr_barrel_skull2",  { input = true } },
      { "spr_barrel_rubber",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_corkscrew_lvl2",     clk_corkscrew_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_corkscrew_lvl2",     clk_corkscrew_lvl2_end, private.room_objname );
  cmn.AddSubscriber( "clk_corkscrew_lvl2_beg", clk_corkscrew_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_corkscrew_lvl2_end", clk_corkscrew_lvl2_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function clk_scoop () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_scoop" ] = {
    type = "click",
    use_place = "obj_kiln_clk_scoop",
    room = private.room_objname,
    zz = "zz_kiln",
    zz_gate = "gzz_winecellar_kiln"
  };
  
  local clk_scoop_beg = function ()

    ObjDelete( "obj_kiln_clk_scoop" );
  
  end;
  local clk_scoop_end = function ()
    
    ObjMultiSet( { 
      { "spr_kiln_box_open",  { pos_x = 189, pos_y = 93 } },
      { "obj_kiln_use_scoop",  { input = true } },
      { "spr_winecellar_zz_kiln_box_open",  { alp = 1 } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_scoop",     clk_scoop_beg, private.room_objname );
  cmn.AddSubscriber( "clk_scoop",     clk_scoop_end, private.room_objname );
  cmn.AddSubscriber( "clk_scoop_beg", clk_scoop_beg, private.room_objname );
  cmn.AddSubscriber( "clk_scoop_end", clk_scoop_end, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function clk_bentrod () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bentrod" ] = {
    type = "click",
    use_place = "obj_kiln_clk_bentrod",
    room = private.room_objname,
    zz = "zz_kiln",
    zz_gate = "gzz_winecellar_kiln"
  };
  
  local clk_bentrod_beg = function ()

    ObjDelete( "obj_kiln_clk_bentrod" );
  
  end;
  local clk_bentrod_end = function ()
    
    ObjDelete( "anm_kiln_take_key_part" );
    ObjDelete( "anm_kiln_open_door" );
    ObjDelete( "spr_kiln_lockpart_hot" );
    
    ObjMultiSet( { 
      { "spr_kiln_door_open",  { alp = 1, visible = true } },
      { "spr_kiln_lockpart",  { alp = 1, visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bentrod",     clk_bentrod_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bentrod",     clk_bentrod_end, private.room_objname );
  cmn.AddSubscriber( "clk_bentrod_beg", clk_bentrod_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bentrod_end", clk_bentrod_end, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function clk_lever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_lever" ] = {
    type = "click",
    use_place = "obj_grid_clk_lever",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_winecellar_grid"
  };
  
  local clk_lever_beg = function ()

    ObjDelete( "obj_grid_clk_lever" );
  
  end;
  local clk_lever_end = function ()
    
    ObjDelete( "anm_grid_lever" );
    
    ObjMultiSet( { 
      { "obj_grid_use_lever",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lever",     clk_lever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lever",     clk_lever_end, private.room_objname );
  cmn.AddSubscriber( "clk_lever_beg", clk_lever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lever_end", clk_lever_end, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function clk_tumbler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_tumbler" ] = {
    type = "click",
    use_place = "obj_stand_clk_tumbler",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  
  local clk_tumbler_beg = function ()

    ObjDelete( "obj_stand_clk_tumbler" );
  
  end;
  local clk_tumbler_end = function ()
    
    ObjMultiSet( { 
      { "spr_stand_scoop",             { input = true          } },
      { "spr_stand_box",               { input = true, alp = 1 } },
      { "spr_winecellar_zz_stand_box", {               alp = 1 } },
      { "anm_stand_key_2",             { frame = 500,  alp = 1 } },
    } );
    ObjDelete( "anm_stand_key"   );
 
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_tumbler",     clk_tumbler_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tumbler",     clk_tumbler_end, private.room_objname );
  cmn.AddSubscriber( "clk_tumbler_beg", clk_tumbler_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tumbler_end", clk_tumbler_end, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function use_chainwithhook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chainwithhook" ] = {
    type = "use",
    inv_obj = "inv_chainwithhook",
    use_place = "obj_heavydoor_use_chainwithhook",
    room = private.room_objname,
    zz = "zz_heavydoor",
    zz_gate = "gzz_winecellar_heavydoor"
  };
  local use_chainwithhook_inv = function ()
  
    interface.InventoryItemRemove( "inv_chainwithhook" );
  
  end;
  local use_chainwithhook_beg = function ()
  
    ObjDelete( "obj_heavydoor_use_chainwithhook" );
  
  end;
  local use_chainwithhook_end = function ()
  
    ObjDelete( "gzz_winecellar_heavydoor" );
    ObjMultiSet( { 
      { "spr_heavydoor_door_lock_part",  { alp = 1, visible = true } },
      { "gmg_winecellar_chain",  { visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chainwithhook", use_chainwithhook_beg, private.room_objname );
  cmn.AddSubscriber( "use_chainwithhook", use_chainwithhook_inv );
  cmn.AddSubscriber( "use_chainwithhook", use_chainwithhook_end, private.room_objname );
  cmn.AddSubscriber( "use_chainwithhook_inv", use_chainwithhook_inv, private.room_objname );
  cmn.AddSubscriber( "use_chainwithhook_beg", use_chainwithhook_beg, private.room_objname );
  cmn.AddSubscriber( "use_chainwithhook_end", use_chainwithhook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_symbol_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_symbol_lvl2" ] = {
    type = "use",
    inv_obj = "inv_symbol_lvl2",
    use_place = "obj_heavydoor_use_symbol",
    room = private.room_objname,
    zz = "zz_heavydoor",
    zz_gate = "gzz_winecellar_heavydoor"
  };
  local use_symbol_lvl2_inv = function ()
  
    interface.InventoryItemRemove( "inv_symbol_lvl2" );
  
  end;
  local use_symbol_lvl2_beg = function ()
  
    ObjDelete( "obj_heavydoor_use_symbol" );
  
  end;
  local use_symbol_lvl2_end = function ()
  
    ObjDelete( "spr_heavydoor_door_2" );
    ObjMultiSet( { 
      { "spr_heavydoor_wheel",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_symbol_lvl2", use_symbol_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_symbol_lvl2", use_symbol_lvl2_inv );
  cmn.AddSubscriber( "use_symbol_lvl2", use_symbol_lvl2_end, private.room_objname );
  cmn.AddSubscriber( "use_symbol_lvl2_inv", use_symbol_lvl2_inv, private.room_objname );
  cmn.AddSubscriber( "use_symbol_lvl2_beg", use_symbol_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_symbol_lvl2_end", use_symbol_lvl2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_patternfragment () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_patternfragment" ] = {
    type = "use",
    inv_obj = "inv_patternfragment",
    use_place = "obj_heavydoor_use_patternfragment",
    room = private.room_objname,
    zz = "zz_heavydoor",
    zz_gate = "gzz_winecellar_heavydoor"
  };
  local use_patternfragment_inv = function ()
  
    interface.InventoryItemRemove( "inv_patternfragment" );
  
  end;
  local use_patternfragment_beg = function ()
  
    ObjDelete( "obj_heavydoor_use_patternfragment" );
  
  end;
  local use_patternfragment_end = function ()
  
    ObjDelete( "spr_heavydoor_nippers_door" );
    ObjDelete( "spr_winecellar_zz_heavydoor_door_little" );
    ObjMultiSet( { 
      { "spr_heavydoor_pliers",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_patternfragment", use_patternfragment_beg, private.room_objname );
  cmn.AddSubscriber( "use_patternfragment", use_patternfragment_inv );
  cmn.AddSubscriber( "use_patternfragment", use_patternfragment_end, private.room_objname );
  cmn.AddSubscriber( "use_patternfragment_inv", use_patternfragment_inv, private.room_objname );
  cmn.AddSubscriber( "use_patternfragment_beg", use_patternfragment_beg, private.room_objname );
  cmn.AddSubscriber( "use_patternfragment_end", use_patternfragment_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_grapesleaf2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_grapesleaf2" ] = {
    type = "use",
    inv_obj = "inv_grapesleaf2",
    use_place = "obj_barrel_use_grapesleaf2",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_winecellar_barrel"
  };
  local use_grapesleaf2_inv = function ()
  
    interface.InventoryItemRemove( "inv_grapesleaf2" );
  
  end;
  local use_grapesleaf2_beg = function ()
  
    ObjDelete( "obj_barrel_use_grapesleaf2" );
  
  end;
  local use_grapesleaf2_end = function ()
  
    ObjDelete( "spr_barrel_door_left" );
    ObjDelete( "spr_winecellar_zz_barrel_leaf_left_slot" );
    
    ObjMultiSet( { 
      { "spr_barrel_spoon",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_grapesleaf2", use_grapesleaf2_beg, private.room_objname );
  cmn.AddSubscriber( "use_grapesleaf2", use_grapesleaf2_inv );
  cmn.AddSubscriber( "use_grapesleaf2", use_grapesleaf2_end, private.room_objname );
  cmn.AddSubscriber( "use_grapesleaf2_inv", use_grapesleaf2_inv, private.room_objname );
  cmn.AddSubscriber( "use_grapesleaf2_beg", use_grapesleaf2_beg, private.room_objname );
  cmn.AddSubscriber( "use_grapesleaf2_end", use_grapesleaf2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_grapesleaf1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_grapesleaf1" ] = {
    type = "use",
    inv_obj = "inv_grapesleaf1",
    use_place = "obj_barrel_use_grapesleaf1",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_winecellar_barrel"
  };
  local use_grapesleaf1_inv = function ()
  
    interface.InventoryItemRemove( "inv_grapesleaf1" );
  
  end;
  local use_grapesleaf1_beg = function ()
  
    ObjDelete( "obj_barrel_use_grapesleaf1" );
  
  end;
  local use_grapesleaf1_end = function ()
  
    ObjDelete( "spr_barrel_door_right" );
    ObjDelete( "spr_winecellar_zz_barrel_leaf_right_slot" );
    
    ObjMultiSet( { 
      { "spr_barrel_glass3",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_grapesleaf1", use_grapesleaf1_beg, private.room_objname );
  cmn.AddSubscriber( "use_grapesleaf1", use_grapesleaf1_inv );
  cmn.AddSubscriber( "use_grapesleaf1", use_grapesleaf1_end, private.room_objname );
  cmn.AddSubscriber( "use_grapesleaf1_inv", use_grapesleaf1_inv, private.room_objname );
  cmn.AddSubscriber( "use_grapesleaf1_beg", use_grapesleaf1_beg, private.room_objname );
  cmn.AddSubscriber( "use_grapesleaf1_end", use_grapesleaf1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_corkscrew_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_corkscrew_lvl2" ] = {
    type = "use",
    inv_obj = "inv_corkscrew_lvl2",
    use_place = "obj_barrel_use_corkscrew",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_winecellar_barrel"
  };
  local use_corkscrew_lvl2_inv = function ()
  
    interface.InventoryItemRemove( "inv_corkscrew_lvl2" );
  
  end;
  local use_corkscrew_lvl2_beg = function ()
  
    ObjDelete( "obj_barrel_use_corkscrew" );
  
  end;
  local use_corkscrew_lvl2_end = function ()
  
    ObjDelete( "anm_barrel_fuse_out" );
    ObjDelete( "spr_barrel_fuse" );
    ObjDelete( "spr_barrel_hole_little_door_up_side" );
    ObjDelete( "spr_winecellar_zz_barrel_cork" );
    
    ObjMultiSet( { 
      { "obj_barrel_clk_corkscrew",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_corkscrew_lvl2", use_corkscrew_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_lvl2", use_corkscrew_lvl2_inv );
  cmn.AddSubscriber( "use_corkscrew_lvl2", use_corkscrew_lvl2_end, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_lvl2_inv", use_corkscrew_lvl2_inv, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_lvl2_beg", use_corkscrew_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_lvl2_end", use_corkscrew_lvl2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pliers_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pliers_1" ] = {
    type = "use",
    inv_obj = "inv_pliers",
    use_place = "obj_grid_use_pliers",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_winecellar_grid"
  };
  local use_pliers_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_pliers_2" ) and
    cmn.IsEventDone( "use_pliers_3" ) ) then
      
      interface.InventoryItemRemove( "inv_pliers" );
      
    end;
  
  end;
  local use_pliers_1_beg = function ()
  
    ObjDelete( "obj_grid_use_pliers" );
    ObjDelete( "vid_grid_vent_loop" );
  
  end;
  local use_pliers_1_end = function ()
  
    ObjDelete( "vid_grid_vent" );
    ObjDelete( "vid_winecellar_cycle_loc" );
    
    ObjMultiSet( { 
      { "obj_grid_use_lockpart",  { input = true } },
      { "spr_grid_rawmaterial",  { input = true } },
      { "gfx_grid_rawmaterial",  { active = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pliers_1", use_pliers_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers_1", use_pliers_1_inv );
  cmn.AddSubscriber( "use_pliers_1", use_pliers_1_end, private.room_objname );
  cmn.AddSubscriber( "use_pliers_1_inv", use_pliers_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_pliers_1_beg", use_pliers_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers_1_end", use_pliers_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lever" ] = {
    type = "use",
    inv_obj = "inv_lever",
    use_place = "obj_grid_use_lever",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_winecellar_grid"
  };
  local use_lever_inv = function ()
  
    interface.InventoryItemRemove( "inv_lever" );
  
  end;
  local use_lever_beg = function ()
  
    ObjDelete( "obj_grid_use_lever" );
  
  end;
  local use_lever_end = function ()
  
    ObjDelete( "spr_grid_grille" );
    ObjDelete( "spr_grid_lever_clean" );
    ObjDelete( "spr_grid_lever_new" );
    ObjDelete( "spr_grid_patch" );
    ObjDelete( "obj_grid_external_gride_hh" );
    ObjDelete( "spr_winecellar_zz_grid_patch_1" );
    ObjDelete( "spr_winecellar_zz_grid_lever_all" );
    
    ObjMultiSet( { 
      { "anm_grid_grid",  { alp = 1, visible = true, frame = 500 } },
      { "spr_winecellar_zz_grid_lever_all_2",  { alp = 1 } },
      { "obj_grid_use_pliers",  { input = true } },
      { "spr_grid_grapesleaf1",  { input = true } },
      { "gfx_grid_grapesleaf1",  { active = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lever", use_lever_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever", use_lever_inv );
  cmn.AddSubscriber( "use_lever", use_lever_end, private.room_objname );
  cmn.AddSubscriber( "use_lever_inv", use_lever_inv, private.room_objname );
  cmn.AddSubscriber( "use_lever_beg", use_lever_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever_end", use_lever_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cleaner_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cleaner_lvl2" ] = {
    type = "use",
    inv_obj = "inv_cleaner_lvl2",
    use_place = "obj_grid_use_cleaner",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_winecellar_grid"
  };
  local use_cleaner_lvl2_inv = function ()
  
    interface.InventoryItemRemove( "inv_cleaner_lvl2" );
  
  end;
  local use_cleaner_lvl2_beg = function ()
  
    ObjDelete( "obj_grid_use_cleaner" );
  
  end;
  local use_cleaner_lvl2_end = function ()
  
    ObjDelete( "spr_grid_lever_dirty" );
    ObjDelete( "spr_winecellar_zz_grid_lever_basis" );
    ObjDelete( "vid_grid_cleanser" );
    
    ObjMultiSet( { 
      { "obj_grid_clk_lever",  { input = true } },
      { "spr_grid_tumbler",  { input = true } },
      { "gfx_grid_tumbler",  { active = true } },
      { "spr_winecellar_zz_grid_lever_all",  { alp = 1 } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cleaner_lvl2", use_cleaner_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaner_lvl2", use_cleaner_lvl2_inv );
  cmn.AddSubscriber( "use_cleaner_lvl2", use_cleaner_lvl2_end, private.room_objname );
  cmn.AddSubscriber( "use_cleaner_lvl2_inv", use_cleaner_lvl2_inv, private.room_objname );
  cmn.AddSubscriber( "use_cleaner_lvl2_beg", use_cleaner_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaner_lvl2_end", use_cleaner_lvl2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lockpart" ] = {
    type = "use",
    inv_obj = "inv_lockpart",
    use_place = "obj_grid_use_lockpart",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_winecellar_grid"
  };
  local use_lockpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_lockpart" );
  
  end;
  local use_lockpart_beg = function ()
  
    ObjDelete( "obj_grid_use_lockpart" );
  
  end;
  local use_lockpart_end = function ()
  
    ObjDelete( "obj_grid_grille_2" );
    ObjDelete( "gzz_winecellar_grid" );
    ObjDelete( "spr_winecellar_zz_grid_patch_2" );
    ObjMultiSet( { 
      { "grm_winecellar_toilets",  { visible = true, input = true } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_winecellar_toilets_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockpart", use_lockpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpart", use_lockpart_inv );
  cmn.AddSubscriber( "use_lockpart", use_lockpart_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpart_inv", use_lockpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpart_beg", use_lockpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpart_end", use_lockpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glass2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glass2" ] = {
    type = "use",
    inv_obj = "inv_glass2",
    use_place = "obj_stand_use_glass2",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  local use_glass2_inv = function ()
  
    interface.InventoryItemRemove( "inv_glass2" );
  
  end;
  local use_glass2_beg = function ()
  
    ObjDelete( "obj_stand_use_glass2" );
  
  end;
  local use_glass2_end = function ()
  
    if ( cmn.IsEventDone( "use_glass3" ) ) then
    
      ObjMultiSet( { 
        { "spr_stand_patternfragment",  { input = true } },
        { "obj_stand_use_corkscrew_handle",  { input = true } },
      } );
      
      ObjDelete( "spr_stand_cover_right" );
      ObjDelete( "spr_winecellar_zz_stand_cach_2" );
      
    end; 
    
    ObjSet( "spr_winecellar_zz_stand_mug_1", { alp = 1 } );
    ObjSet( "anm_stand_mug_2", { frame = 500 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glass2", use_glass2_beg, private.room_objname );
  cmn.AddSubscriber( "use_glass2", use_glass2_inv );
  cmn.AddSubscriber( "use_glass2", use_glass2_end, private.room_objname );
  cmn.AddSubscriber( "use_glass2_inv", use_glass2_inv, private.room_objname );
  cmn.AddSubscriber( "use_glass2_beg", use_glass2_beg, private.room_objname );
  cmn.AddSubscriber( "use_glass2_end", use_glass2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glass3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glass3" ] = {
    type = "use",
    inv_obj = "inv_glass3",
    use_place = "obj_stand_use_glass3",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  local use_glass3_inv = function ()
  
    interface.InventoryItemRemove( "inv_glass3" );
  
  end;
  local use_glass3_beg = function ()
  
    ObjDelete( "obj_stand_use_glass3" );
  
  end;
  local use_glass3_end = function ()
  
    if ( cmn.IsEventDone( "use_glass2" ) ) then
    
      ObjMultiSet( { 
        { "spr_stand_patternfragment",  { input = true } },
        { "obj_stand_use_corkscrew_handle",  { input = true } },
      } );
      
      ObjDelete( "spr_stand_cover_right" );
      ObjDelete( "spr_winecellar_zz_stand_cach_2" );
      
    end; 
    
    ObjSet( "spr_winecellar_zz_stand_mug_2", { alp = 1 } );
    ObjSet( "anm_stand_mug_3", { frame = 500 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glass3", use_glass3_beg, private.room_objname );
  cmn.AddSubscriber( "use_glass3", use_glass3_inv );
  cmn.AddSubscriber( "use_glass3", use_glass3_end, private.room_objname );
  cmn.AddSubscriber( "use_glass3_inv", use_glass3_inv, private.room_objname );
  cmn.AddSubscriber( "use_glass3_beg", use_glass3_beg, private.room_objname );
  cmn.AddSubscriber( "use_glass3_end", use_glass3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tumbler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tumbler" ] = {
    type = "use",
    inv_obj = "inv_tumbler",
    use_place = "obj_stand_use_tumbler",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  local use_tumbler_inv = function ()
  
    interface.InventoryItemRemove( "inv_tumbler" );
  
  end;
  local use_tumbler_beg = function ()
  
    ObjDelete( "obj_stand_use_tumbler" );
  
  end;
  local use_tumbler_end = function ()
  
    ObjMultiSet( { 
      { "anm_stand_key",          {   alp = 1,      frame = 500                 } },
      { "obj_stand_clk_tumbler",  { input = true, visible = true, active = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tumbler", use_tumbler_beg, private.room_objname );
  cmn.AddSubscriber( "use_tumbler", use_tumbler_inv );
  cmn.AddSubscriber( "use_tumbler", use_tumbler_end, private.room_objname );
  cmn.AddSubscriber( "use_tumbler_inv", use_tumbler_inv, private.room_objname );
  cmn.AddSubscriber( "use_tumbler_beg", use_tumbler_beg, private.room_objname );
  cmn.AddSubscriber( "use_tumbler_end", use_tumbler_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_corkscrew_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_corkscrew_handle" ] = {
    type = "use",
    inv_obj = "inv_corkscrew_handle",
    use_place = "obj_stand_use_corkscrew_handle",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  local use_corkscrew_handle_inv = function ()
  
    interface.InventoryItemRemove( "inv_corkscrew_handle" );
  
  end;
  local use_corkscrew_handle_beg = function ()
  
    ObjDelete( "obj_stand_use_corkscrew_handle" );
  
  end;
  local use_corkscrew_handle_end = function ()
  
    ObjMultiSet( { 
      { "spr_stand_corkscrew",        { alp = 1,  input = true } },
      { "spr_stand_corkscrew_stick",  { alp = 1                } },
      { "spr_stand_corkscrew_shadow", { alp = 1                } },
      { "gfx_stand_corkscrew",        {          active = true } },
    } );
    ObjDelete( "anm_stand_corkscrew" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_corkscrew_handle", use_corkscrew_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_handle", use_corkscrew_handle_inv );
  cmn.AddSubscriber( "use_corkscrew_handle", use_corkscrew_handle_end, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_handle_inv", use_corkscrew_handle_inv, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_handle_beg", use_corkscrew_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew_handle_end", use_corkscrew_handle_end, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function use_scoop () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scoop" ] = {
    type = "use",
    inv_obj = "inv_scoop",
    use_place = "obj_kiln_use_scoop",
    room = private.room_objname,
    zz = "zz_kiln",
    zz_gate = "gzz_winecellar_kiln"
  };
  local use_scoop_inv = function ()
  
    interface.InventoryItemRemove( "inv_scoop" );
  
  end;
  local use_scoop_beg = function ()
  
    ObjDelete( "obj_kiln_use_scoop" );
  
  end;
  local use_scoop_end = function ()
  
    ObjMultiSet( { 
      { "anm_kiln_take_coal_scoop",  { frame = 500 } },
      { "obj_kiln_box_open_crop",  { input = true } },
      { "gfx_kiln_scoop_2",  { active = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scoop", use_scoop_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoop", use_scoop_inv );
  cmn.AddSubscriber( "use_scoop", use_scoop_end, private.room_objname );
  cmn.AddSubscriber( "use_scoop_inv", use_scoop_inv, private.room_objname );
  cmn.AddSubscriber( "use_scoop_beg", use_scoop_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoop_end", use_scoop_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bentrod () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bentrod" ] = {
    type = "use",
    inv_obj = "inv_bentrod",
    use_place = "obj_kiln_use_bentrod",
    room = private.room_objname,
    zz = "zz_kiln",
    zz_gate = "gzz_winecellar_kiln"
  };
  local use_bentrod_inv = function ()
  
    interface.InventoryItemRemove( "inv_bentrod" );
  
  end;
  local use_bentrod_beg = function ()
  
    ObjDelete( "obj_kiln_use_bentrod" );
  
  end;
  local use_bentrod_end = function ()
  
    ObjDelete( "anm_kiln_open_door_hh" );
    ObjDelete( "spr_winecellar_zz_kiln_door_closed" );
   
    ObjMultiSet( { 
      { "anm_kiln_open_door",  { alp = 1, visible = true, frame = 500 } },
      { "obj_kiln_clk_bentrod",  { input = true } },
      { "spr_winecellar_zz_kiln_door_open",  { alp = 1 } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bentrod", use_bentrod_beg, private.room_objname );
  cmn.AddSubscriber( "use_bentrod", use_bentrod_inv );
  cmn.AddSubscriber( "use_bentrod", use_bentrod_end, private.room_objname );
  cmn.AddSubscriber( "use_bentrod_inv", use_bentrod_inv, private.room_objname );
  cmn.AddSubscriber( "use_bentrod_beg", use_bentrod_beg, private.room_objname );
  cmn.AddSubscriber( "use_bentrod_end", use_bentrod_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_animalstatuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_animalstatuette" ] = {
    type = "use",
    inv_obj = "inv_animalstatuette",
    use_place = "obj_kiln_use_animalstatuette",
    room = private.room_objname,
    zz = "zz_kiln",
    zz_gate = "gzz_winecellar_kiln"
  };
  local use_animalstatuette_inv = function ()
  
    interface.InventoryItemRemove( "inv_animalstatuette" );
  
  end;
  local use_animalstatuette_beg = function ()
  
    ObjDelete( "obj_kiln_use_animalstatuette" );
  
  end;
  local use_animalstatuette_end = function ()
  
    ObjDelete( "spr_kiln_door_closed_breadbox" );
    
    ObjMultiSet( { 
      { "spr_kiln_door_open_breadbox",  { alp = 1, visible = true, input = true } },
      { "spr_kiln_red_horse",  { alp = 1, visible = true } },
      { "spr_kiln_postament_right",  { pos_y = 4 } },
      { "spr_kiln_postament_left",  { pos_y = 29 } },
      { "spr_winecellar_zz_kiln_open",  { alp = 1 } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_animalstatuette", use_animalstatuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_animalstatuette", use_animalstatuette_inv );
  cmn.AddSubscriber( "use_animalstatuette", use_animalstatuette_end, private.room_objname );
  cmn.AddSubscriber( "use_animalstatuette_inv", use_animalstatuette_inv, private.room_objname );
  cmn.AddSubscriber( "use_animalstatuette_beg", use_animalstatuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_animalstatuette_end", use_animalstatuette_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wheel_lvl2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wheel_lvl2" ] = {
    type = "use",
    inv_obj = "inv_wheel_lvl2",
    use_place = "obj_winecellar_use_wheel",
    room = private.room_objname 
  };
  local use_wheel_lvl2_inv = function ()
  
    interface.InventoryItemRemove( "inv_wheel_lvl2" );
  
  end;
  local use_wheel_lvl2_beg = function ()
  
    ObjDelete( "obj_winecellar_use_wheel" );
  
  end;
  local use_wheel_lvl2_end = function ()
    
    ObjDelete( "anm_winecellar_rag" );
    ObjMultiSet( { 
      { "gzz_winecellar_barrel",  { visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wheel_lvl2", use_wheel_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel_lvl2", use_wheel_lvl2_inv );
  cmn.AddSubscriber( "use_wheel_lvl2", use_wheel_lvl2_end, private.room_objname );
  cmn.AddSubscriber( "use_wheel_lvl2_inv", use_wheel_lvl2_inv, private.room_objname );
  cmn.AddSubscriber( "use_wheel_lvl2_beg", use_wheel_lvl2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel_lvl2_end", use_wheel_lvl2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_slingshot () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_slingshot" ] = {
    type = "use",
    inv_obj = "inv_slingshot",
    use_place = "obj_winecellar_use_slingshot",
    room = private.room_objname
  };
  local use_slingshot_inv = function ()
  
    interface.InventoryItemRemove( "inv_slingshot" );
  
  end;
  local use_slingshot_beg = function ()
  
    ObjDelete( "obj_winecellar_use_slingshot" );
  
  end;
  local use_slingshot_end = function ()
  
    ObjDelete( "anm_winecellar_slingshot_mmg_chain_click" );
    ObjMultiSet( { 
      { "obj_winecellar_slingshot_mmg",  { alp = 1, visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_slingshot", use_slingshot_beg, private.room_objname );
  cmn.AddSubscriber( "use_slingshot", use_slingshot_inv );
  cmn.AddSubscriber( "use_slingshot", use_slingshot_end, private.room_objname );
  cmn.AddSubscriber( "use_slingshot_inv", use_slingshot_inv, private.room_objname );
  cmn.AddSubscriber( "use_slingshot_beg", use_slingshot_beg, private.room_objname );
  cmn.AddSubscriber( "use_slingshot_end", use_slingshot_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_turner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_turner" ] = {
    type = "use",
    inv_obj = "inv_turner",
    use_place = "obj_stand_use_turner",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_winecellar_stand"
  };
  local use_turner_inv = function ()
  
    interface.InventoryItemRemove( "inv_turner" );
  
  end;
  local use_turner_beg = function ()
  
    ObjDelete( "obj_stand_use_turner" );
  
  end;
  local use_turner_end = function ()

    ObjMultiSet( { 
      { "spr_stand_stainedglasspart2",  { input = true } },
      { "spr_winecellar_zz_stand_v",  { alp = 1 } },
      { "anm_stand_use_turner", { frame = 500 } },
    } );
    
    ObjDelete( "spr_stand_cover_left" );
    ObjDelete( "spr_winecellar_zz_stand_cach_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_turner", use_turner_beg, private.room_objname );
  cmn.AddSubscriber( "use_turner", use_turner_inv );
  cmn.AddSubscriber( "use_turner", use_turner_end, private.room_objname );
  cmn.AddSubscriber( "use_turner_inv", use_turner_inv, private.room_objname );
  cmn.AddSubscriber( "use_turner_beg", use_turner_beg, private.room_objname );
  cmn.AddSubscriber( "use_turner_end", use_turner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_intro_2 () end;
  --------------------------------------------------------------------------------------------
  local see_intro_2 = function ()
  
  end;
  cmn.AddSubscriber( "see_intro_2", see_intro_2, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function see_winecellar () end;
  --------------------------------------------------------------------------------------------
    local see_winecellar = function ()
    
      ObjMultiSet( { 
        { "anm_winecellar_winecellar",  { frame = 300 } },
      } );  
      
    end;
    
    cmn.AddSubscriber( "see_winecellar", see_winecellar, private.room_objname ); 
    
  --------------------------------------------------------------------------------------------
  -- function see_winecellar_fire () end;
  --------------------------------------------------------------------------------------------
  local see_winecellar_fire = function ()
      
      ObjDelete( "anm_winecellar_fire" );    
      ObjMultiSet( { 
        { "anm_winecellar_fire_cicle",  { alp = 1 } },
      } );  
      
    end;
    
    cmn.AddSubscriber( "see_winecellar_fire", see_winecellar_fire, private.room_objname ); 
    
  --------------------------------------------------------------------------------------------
  -- function see_winecellar_ghost () end;
  --------------------------------------------------------------------------------------------
    local see_winecellar_ghost = function ()
    
      ObjDelete( "anm_winecellar_ghost" );

    end;
    
    cmn.AddSubscriber( "see_winecellar_ghost", see_winecellar_ghost, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function win_winecellar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_winecellar" ] =
  {
      type = "win",
      room = private.room_objname 
  };

  local win_winecellar = function ()

    if ( cmn.IsEventDone( "win_winecellar" ) ) then
      
      ObjDelete( "anm_winecellar_slingshot_mmg_chain_static" );
      
      ObjMultiSet( { 
        { "anm_winecellar_slingshot_mmg_shot_win",  { alp = 1, visible = true, frame = 500 } },
        { "obj_winecellar_slingshot_mmg",  { alp = 0, visible = false, input = false } },
        { "gho_winecellar_winecollection",  { visible = true, input = true } },
      } );
      
    end;

  end;

  cmn.AddSubscriber( "win_winecellar", win_winecellar, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*******************************************************************************************************************
  --*** function zz_grid () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_grid" );  
    ------------------------------------------------- 
    function zz_grid.PreOpen ()

      if not cmn.IsEventDone( "use_pliers_1" ) then  
        common_impl.PlayAudio( "env", "level1/env/aud_ventilation_env", 1, "", 0 ); 
      end;

    end;
    ------------------------------------------------- 
    function zz_grid.PreClose ()

      if not cmn.IsEventDone( "use_pliers_1" ) then  
        common_impl.StopAudio( "env", "level1/env/aud_ventilation_env", 0.5 );
      end;

    end;
    -------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_winecellar();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  
  if ( not cmn.IsEventDone( "see_intro_2" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( private.room_objname, { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_winecellar_intro_2", private.room_objname );
    ObjSet( "tmr_winecellar_intro_2",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntro2(); end
    } );

  end; 
    
  if ( not cmn.IsEventDone( "beg_level2" ) ) then

    cmn.SetEventDone( "beg_level2" );
    cmn.CallEventHandler( "beg_level2" ); 
  
  end;
  
  if ( cmn.IsEventDone( "get_slingshot" ) and not cmn.IsEventDone( "see_winecellar_ghost" ) ) then

    public.see_winecellar_ghost();
  
  end;
  
  if not cmn.IsEventDone( "win_winecellar" ) then 

    if cmn.IsEventDone( "use_slingshot" ) then 
      
      cmn.MiniGameShow();
      common_impl.PassingMgStart( "winecellar" );
      
    end;

    private.WinecellarLoad();
    private.WinecellarUpdate();

  end;

  common_impl.EnvPlay( { "level2/env/aud_winecellar_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()
  
  if ( not cmn.IsEventDone( "win_winecellar" ) and
  cmn.IsEventDone( "use_slingshot" ) ) then 

    cmn.MiniGameHide();
    common_impl.PassingMgStop( "winecellar" );

  end;

  common_impl.StopAudio( "env", "level2/env/aud_winecellar_env", 0.5 );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_chainwithhook ()

  local item = "inv_chainwithhook";

  if ( cmn.ApplyObj( item, "gzz_winecellar_heavydoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_heavydoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_heavydoor_use_chainwithhook" ) ) then

    cmn.CallEventHandler( "use_chainwithhook_inv" );
    cmn.CallEventHandler( "use_chainwithhook_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_chainwithhook" );
      cmn.CallEventHandler( "use_chainwithhook_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom( "mg_chain" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_tube", 0, "", 0 );

    cmn.ItemFly( "spr_heavydoor_door_lock_part", func_end, -3.14 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_symbol_lvl2 ()

  local item = "inv_symbol_lvl2";

  if ( cmn.ApplyObj( item, "gzz_winecellar_heavydoor" ) and 
  cmn.IsEventDone( "clk_rug" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_heavydoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_heavydoor_use_symbol" ) and 
  cmn.IsEventDone( "clk_rug" ) ) then

    cmn.CallEventHandler( "use_symbol_lvl2_inv" );
    cmn.CallEventHandler( "use_symbol_lvl2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_symbol_lvl2" );
      cmn.CallEventHandler( "use_symbol_lvl2_end" );

    end;
    
    local func_end_2 = function ()
      
      ObjAnimate( "spr_heavydoor_door_2", "pos_xy",0,0, func_end, { 0, 3, 22, 192,    0.6, 3, 65, 302 } );
      
    end; 

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_move_stone", 0, "", 0 );
    
    ObjSet( "spr_heavydoor_symbol", { alp = 0, visible = true } );
    ObjAnimate( "spr_heavydoor_symbol", "alp",0,0, func_end_2, { 0, 0, 0,    0.6, 0, 1 } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_patternfragment ()

  local item = "inv_patternfragment";

  if ( cmn.ApplyObj( item, "gzz_winecellar_heavydoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_heavydoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_heavydoor_use_patternfragment" ) ) then

    cmn.CallEventHandler( "use_patternfragment_inv" );
    cmn.CallEventHandler( "use_patternfragment_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_patternfragment" );
      cmn.CallEventHandler( "use_patternfragment_end" );

    end;
    
    local func_end_2 = function ()
      
      ObjAnimate( "spr_heavydoor_nippers_door", "pos_xy",0,0, func_end, { 0, 3, -59, -34,    0.6, 3, -91, -145 } );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_patternfragment", 0, "", 0 );

    cmn.ItemFly( "spr_heavydoor_amulet_part", func_end_2, -3.14 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_grapesleaf2 ()

  local item = "inv_grapesleaf2";

  if ( cmn.ApplyObj( item, "gzz_winecellar_barrel" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barrel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_barrel_use_grapesleaf2" ) ) then

    cmn.CallEventHandler( "use_grapesleaf2_inv" );
    cmn.CallEventHandler( "use_grapesleaf2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_grapesleaf2" );
      cmn.CallEventHandler( "use_grapesleaf2_end" );

    end;
    
    local func_end_2 = function ()
      
      ObjAnimate( "spr_barrel_door_left", "pos_xy",0,0, func_end, { 0, 3, 112, -158,    0.6, 3, 118, -358 } );
      
    end; 

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_leaf_amulet", 0, "", 0 );
    
    ObjSet( "spr_barrel_leaf_amulet_left", { alp = 0, visible = true } );
    ObjAnimate( "spr_barrel_leaf_amulet_left", "alp",0,0, func_end_2, { 0, 0, 0,    0.6, 0, 1 } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_grapesleaf1 ()

  local item = "inv_grapesleaf1";

  if ( cmn.ApplyObj( item, "gzz_winecellar_barrel" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barrel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_barrel_use_grapesleaf1" ) ) then

    cmn.CallEventHandler( "use_grapesleaf1_inv" );
    cmn.CallEventHandler( "use_grapesleaf1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_grapesleaf1" );
      cmn.CallEventHandler( "use_grapesleaf1_end" );

    end;
    
    local func_end_2 = function ()
      
      ObjAnimate( "spr_barrel_door_right", "pos_y",0,0, func_end, { 0, 3, -153,    0.6, 3, -381 } );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_leaf_amulet", 0, "", 0 );

    ObjSet( "spr_barrel_leaf_right", { alp = 0, visible = true } );
    ObjAnimate( "spr_barrel_leaf_right", "alp",0,0, func_end_2, { 0, 0, 0,    0.6, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_corkscrew ()

  local item = "inv_corkscrew_lvl2";

  if ( cmn.ApplyObj( item, "gzz_winecellar_barrel" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barrel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_barrel_use_corkscrew" ) ) then

    cmn.CallEventHandler( "use_corkscrew_lvl2_inv" );
    cmn.CallEventHandler( "use_corkscrew_lvl2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_corkscrew_lvl2" );
      cmn.CallEventHandler( "use_corkscrew_lvl2_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_corkscrew2", 0, "", 0 );

    ObjMultiSet( { 
      { "anm_barrel_fuse_out",  { alp = 1, visible = true } },
      { "spr_barrel_fuse",  { alp = 0, visible = false } },
    } );
    
    AnimPlay( "anm_barrel_fuse_out", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pliers_1 ()

  local item = "inv_pliers";

  if ( cmn.ApplyObj( item, "gzz_winecellar_grid" ) and
  cmn.IsEventDone( "use_lever" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grid" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_grid_use_pliers" ) and
  cmn.IsEventDone( "use_lever" ) ) then

    cmn.CallEventHandler( "use_pliers_1_inv" );
    cmn.CallEventHandler( "use_pliers_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_pliers_1" );
      cmn.CallEventHandler( "use_pliers_1_end" );
      common_impl.StopAudio( "env", "level1/env/aud_ventilation_env", 0.5 );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_pliers", 0, "", 0 );

    ObjSet( "vid_grid_vent", { alp = 1 } );
    VidPlay( "vid_grid_vent", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lever ()

  local item = "inv_lever";

  if ( cmn.ApplyObj( item, "gzz_winecellar_grid" ) and 
  cmn.IsEventDone( "clk_lever" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grid" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_grid_use_lever" ) and 
    cmn.IsEventDone( "clk_lever" ) ) then

    cmn.CallEventHandler( "use_lever_inv" );
    cmn.CallEventHandler( "use_lever_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_lever" );
      cmn.CallEventHandler( "use_lever_end" );

    end;
    
    local func_end_2 = function ()
        
      ObjMultiSet( { 
        { "anm_grid_grid",  { alp = 1, visible = true } },
        { "spr_grid_grille",  { alp = 0, visible = false } },
        { "spr_grid_lever_clean",  { alp = 0, visible = false } },
        { "spr_grid_lever_new",  { alp = 0, visible = false } },
        { "spr_grid_patch",  { alp = 0, visible = false } },
      } );
      
      AnimPlay( "anm_grid_grid", "grid", func_end );
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_lever", 0, "", 0 );

    cmn.ItemFly( "spr_grid_lever_new", func_end_2, 1.22 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cleaner_lvl2 ()

  local item = "inv_cleaner_lvl2";

  if ( cmn.ApplyObj( item, "gzz_winecellar_grid" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grid" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_grid_use_cleaner" ) ) then

    cmn.CallEventHandler( "use_cleaner_lvl2_inv" );
    cmn.CallEventHandler( "use_cleaner_lvl2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_cleaner_lvl2" );
      cmn.CallEventHandler( "use_cleaner_lvl2_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_cleaner_lvl2", 0, "", 0 );

    VidPlay( "vid_grid_cleanser", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lockpart ()

  local item = "inv_lockpart";

  if ( cmn.ApplyObj( item, "gzz_winecellar_grid" ) and 
  cmn.IsEventDone( "use_pliers_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grid" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_grid_use_lockpart" ) and 
  cmn.IsEventDone( "use_pliers_1" ) ) then

    cmn.CallEventHandler( "use_lockpart_inv" );
    cmn.CallEventHandler( "use_lockpart_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_lockpart" );
      cmn.CallEventHandler( "use_lockpart_end" );
      
      common.CloseSubRoom();
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_triangle_key", 0, "", 0 );
    
    AnimPlay( "anm_grid_key", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_glass2 ()

  local item = "inv_glass2";

  if ( cmn.ApplyObj( item, "gzz_winecellar_stand" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand_use_glass2" ) ) then

    cmn.CallEventHandler( "use_glass2_inv" );
    cmn.CallEventHandler( "use_glass2_beg" );

    local func_open = function ()
    
      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_glass2" );
        cmn.CallEventHandler( "use_glass2_end" );

      end;
      
      if cmn.IsEventDone( "use_glass3" ) then
        
        common_impl.PlayAudio( "sfx", "level2/sfx/aud_slide_xx_wood_cover", 0, "", 0 );
        ObjAnimate( "spr_stand_cover_right", "pos_y", 0, 0, func_end, { 0, 0, -215,   0.8, 3, -373 } )
        
      else
        
        func_end();
        
      end;
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_cup", 0, "", 0 );

    AnimPlay( "anm_stand_mug_2", "mug_2", func_open );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_glass3 ()

  local item = "inv_glass3";

  if ( cmn.ApplyObj( item, "gzz_winecellar_stand" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand_use_glass3" ) ) then

    cmn.CallEventHandler( "use_glass3_inv" );
    cmn.CallEventHandler( "use_glass3_beg" );

    local func_open = function ()
    
      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_glass3" );
        cmn.CallEventHandler( "use_glass3_end" );

      end;
      
      if cmn.IsEventDone( "use_glass2" ) then
        
        common_impl.PlayAudio( "sfx", "level2/sfx/aud_slide_xx_wood_cover", 0, "", 0 );
        ObjAnimate( "spr_stand_cover_right", "pos_y", 0, 0, func_end, { 0, 0, -215,   0.8, 3, -373 } )
        
      else
        
        func_end();
        
      end;
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_cup", 0, "", 0 );

    AnimPlay( "anm_stand_mug_3", "mug_3", func_open );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tumbler ()

  local item = "inv_tumbler";

  if ( cmn.ApplyObj( item, "gzz_winecellar_stand" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand_use_tumbler" ) ) then

    cmn.CallEventHandler( "use_tumbler_inv" );
    cmn.CallEventHandler( "use_tumbler_beg" );

    local func_open = function ()
    
      cmn.Lock( false );
      cmn.SetEventDone( "use_tumbler" );
      cmn.CallEventHandler( "use_tumbler_end" );
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_small_key", 0, "", 0 );

    AnimPlay( "anm_stand_key", "key", func_open );
  
    return true;

  end;
  
  return false;
  
end;

--------------------------------------------------------------------------------------------
function public.use_corkscrew_handle ()

  local item = "inv_corkscrew_handle";
  local item_wrong = "inv_pliers";

  if ( cmn.ApplyObj( item, "gzz_winecellar_stand" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand" );

    return true;

  elseif ( cmn.ApplyObj( item_wrong, "obj_stand_use_corkscrew_handle" ) ) then

    common_impl.ShowBbt( "bbt_ivn_pliers_wrong_use_lvl2" );
    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand_use_corkscrew_handle" ) ) then

    cmn.CallEventHandler( "use_corkscrew_handle_inv" );
    cmn.CallEventHandler( "use_corkscrew_handle_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_corkscrew_handle" );
      cmn.CallEventHandler( "use_corkscrew_handle_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_handle_wood", 0, "", 0 );

    AnimPlay( "anm_stand_corkscrew", "corkscrew", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_scoop ()

  local item = "inv_scoop";

  if ( cmn.ApplyObj( item, "gzz_winecellar_kiln" ) and
  cmn.IsEventDone( "clk_scoop" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kiln" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kiln_use_scoop" ) and
  cmn.IsEventDone( "clk_scoop" ) ) then

    cmn.CallEventHandler( "use_scoop_inv" );
    cmn.CallEventHandler( "use_scoop_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_scoop" );
      cmn.CallEventHandler( "use_scoop_end" );
      
      ObjSet( "anm_kiln_take_coal_scoop", { pos_x = -482, pos_y = -361, pos_z = 0 } );
      ObjAttach( "anm_kiln_take_coal_scoop", "spr_kiln_scoop_2" );
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_small_shovel", 0, "", 0 );
    
    ObjSet( "anm_kiln_take_coal_scoop", { pos_x = -350, pos_y = -275, pos_z = 200 } );
    ObjAttach( "anm_kiln_take_coal_scoop", "obj_kiln_crop" );
    
    AnimPlay( "anm_kiln_take_coal_scoop", "take_coal_scoop", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bentrod ()

  local item = "inv_bentrod";

  if ( cmn.ApplyObj( item, "gzz_winecellar_kiln" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kiln" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kiln_use_bentrod" ) ) then

    cmn.CallEventHandler( "use_bentrod_inv" );
    cmn.CallEventHandler( "use_bentrod_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bentrod" );
      cmn.CallEventHandler( "use_bentrod_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_poker", 0, "", 0 );

    ObjMultiSet( { 
      { "anm_kiln_open_door",  { alp = 1, visible = true } },
      { "anm_kiln_open_door_hh",  { alp = 0, visible = false } },
    } );
    
    AnimPlay( "anm_kiln_open_door", "open_door", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_animalstatuette ()

  local item = "inv_animalstatuette";

  if ( cmn.ApplyObj( item, "gzz_winecellar_kiln" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kiln" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kiln_use_animalstatuette" ) ) then

    cmn.CallEventHandler( "use_animalstatuette_inv" );
    cmn.CallEventHandler( "use_animalstatuette_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_animalstatuette" );
      cmn.CallEventHandler( "use_animalstatuette_end" );

    end;
    
    local func_end_3 = function ()
      
      ObjAnimate( "spr_kiln_door_closed_breadbox", "alp",0,0, func_end, { 0, 0, 1,    0.4, 0, 0 } );
      ObjSet( "spr_kiln_door_open_breadbox", { alp = 0, visible = true } );
      ObjAnimate( "spr_kiln_door_open_breadbox", "alp",0,0, "", { 0, 0, 0,    0.4, 0, 1 } );
      
    end;
    
    local func_end_2 = function ()
      
      ObjAnimate( "spr_kiln_postament_right", "pos_y", 0, 0, func_end_3, { 0, 3, 0,   0.6, 3, 4  } );
      ObjAnimate( "spr_kiln_postament_left",  "pos_y", 0, 0,         "", { 0, 3, 26,  0.6, 3, 29 } );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_horse", 0, "", 0 );

    cmn.ItemFly( "spr_kiln_red_horse", func_end_2, 1.22 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wheel_lvl2 ()

  local item = "inv_wheel_lvl2";

  if ( cmn.ApplyObj( item, "obj_winecellar_use_wheel" ) ) then

    cmn.CallEventHandler( "use_wheel_lvl2_inv" );
    cmn.CallEventHandler( "use_wheel_lvl2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_wheel_lvl2" );
      cmn.CallEventHandler( "use_wheel_lvl2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_knife", 0, "", 0 );

    AnimPlay( "anm_winecellar_rag", "rag", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_slingshot ()

  local item = "inv_slingshot";

  if ( cmn.ApplyObj( item, "obj_winecellar_use_slingshot" ) ) then

    cmn.CallEventHandler( "use_slingshot_inv" );
    cmn.CallEventHandler( "use_slingshot_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_slingshot" );
      cmn.CallEventHandler( "use_slingshot_end" );
      
      cmn.MiniGameShow();
      common_impl.PassingMgStart( "winecellar" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_short_whoosh", 0, "", 0 );

    ObjSet( "obj_winecellar_slingshot_mmg", { alp = 0, visible = true } );
    ObjAnimate( "obj_winecellar_slingshot_mmg", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
  
    return true;

  end;
  
  return false;
  
end;

--------------------------------------------------------------------------------------------
function public.use_turner ()

  local item = "inv_turner";

  if ( cmn.ApplyObj( item, "gzz_winecellar_stand" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand_use_turner" ) ) then

    cmn.CallEventHandler( "use_turner_inv" );
    cmn.CallEventHandler( "use_turner_beg" );

    local func_open = function ()
    
      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_turner" );
        cmn.CallEventHandler( "use_turner_end" );

      end;
      
      ObjAnimate( "spr_stand_cover_left", "pos_y", 0, 0, func_end, { 0, 0, -243,   0.5, 3, -341 } )
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_turner", 0, "", 0 );

    AnimPlay( "anm_stand_use_turner", "v", func_open );
  
    return true;

  end;
  
  return false;
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_wheel_lvl2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wheel_lvl2" );
  cmn.CallEventHandler( "get_wheel_lvl2" );

end;
--------------------------------------------------------------------------------------------
function private.get_glass2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_glass2" );
  cmn.CallEventHandler( "get_glass2" );

end;
--------------------------------------------------------------------------------------------
function private.get_pliers ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pliers" );
  cmn.CallEventHandler( "get_pliers" );

end;
--------------------------------------------------------------------------------------------
function private.get_lever ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lever" );
  cmn.CallEventHandler( "get_lever" );

end;
--------------------------------------------------------------------------------------------
function private.get_glass3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_glass3" );
  cmn.CallEventHandler( "get_glass3" );

end;
--------------------------------------------------------------------------------------------
function private.get_rubber ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rubber" );
  cmn.CallEventHandler( "get_rubber" );
  
end;
--------------------------------------------------------------------------------------------
function private.get_skull2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_skull2" );
  cmn.CallEventHandler( "get_skull2" );

end;
--------------------------------------------------------------------------------------------
function private.get_spoon ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_spoon" );
  cmn.CallEventHandler( "get_spoon" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_12" ) ) then 
    
    common.CloseSubRoom();
  
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_grapesleaf1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_grapesleaf1" );
  cmn.CallEventHandler( "get_grapesleaf1" );

end;
--------------------------------------------------------------------------------------------
function private.get_tumbler ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tumbler" );
  cmn.CallEventHandler( "get_tumbler" );

end;
--------------------------------------------------------------------------------------------
function private.get_rawmaterial ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rawmaterial" );
  cmn.CallEventHandler( "get_rawmaterial" );

end;
--------------------------------------------------------------------------------------------
function private.get_patternfragment ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_patternfragment" );
  cmn.CallEventHandler( "get_patternfragment" );
  
end;
--------------------------------------------------------------------------------------------
function private.get_corkscrew_lvl2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_corkscrew_lvl2" );
  cmn.CallEventHandler( "get_corkscrew_lvl2" );

end;
--------------------------------------------------------------------------------------------
function private.get_sandpaper ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sandpaper" );
  cmn.CallEventHandler( "get_sandpaper" );

end;
--------------------------------------------------------------------------------------------
function private.get_rod ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rod" );
  cmn.CallEventHandler( "get_rod" );

end;
--------------------------------------------------------------------------------------------
function private.get_scoop ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scoop" );
  cmn.CallEventHandler( "get_scoop" );

end;
--------------------------------------------------------------------------------------------
function private.get_stainedglasspart2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stainedglasspart2" );
  cmn.CallEventHandler( "get_stainedglasspart2" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_lockpart ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lockpart" );
  cmn.CallEventHandler( "get_lockpart" );

end;
--------------------------------------------------------------------------------------------
function private.get_scoop_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scoop_2" );
  cmn.CallEventHandler( "get_scoop_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_feed ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_feed" );
  cmn.CallEventHandler( "get_feed" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_12 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_12" ); 

  end;

  common_impl.PlayEffectHO( "spr_barrel_collect2_item_12", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_12" );
  
  if ( cmn.IsEventDone( "get_spoon" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_rug ()
  
  cmn.CallEventHandler( "clk_rug_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_rug" );
    cmn.CallEventHandler( "clk_rug_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_move_slide_mat", 0, "", 0 );
  
  ObjAnimate( "spr_heavydoor_rug", "pos_xy",0,0, func_end, { 0, 3, -10, 168,    0.6, 3, 115, 391 } );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_corkscrew_lvl2 ()
  
  cmn.CallEventHandler( "clk_corkscrew_lvl2_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_corkscrew_lvl2" );
    cmn.CallEventHandler( "clk_corkscrew_lvl2_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_break_wood", 0, "", 0 );
  
  AnimPlay( "anm_barrel_brocken_doors", "DoAnim", func_end );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_scoop ()
  
  cmn.CallEventHandler( "clk_scoop_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_scoop" );
    cmn.CallEventHandler( "clk_scoop_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_slide_xx_metal", 0, "", 0 );
  
  ObjAnimate( "spr_kiln_box_open", "pos_xy",0,0, func_end, { 0, 3, 138, 33,    0.6, 3, 189, 93 } );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_bentrod ()
  
  cmn.CallEventHandler( "clk_bentrod_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_bentrod" );
    cmn.CallEventHandler( "clk_bentrod_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_poker", 0, "", 0 );
  
  ObjMultiSet( { 
    { "anm_kiln_take_key_part",  { alp = 1, visible = true } },
    { "spr_kiln_door_open",  { alp = 1, visible = true } },
    { "spr_kiln_lockpart_hot",  { alp = 0, visible = false } },
    { "anm_kiln_open_door",  { alp = 0, visible = false } },
  } );
  
  AnimPlay( "anm_kiln_take_key_part", "take_key_part", func_end );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_lever ()
  
  cmn.CallEventHandler( "clk_lever_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_lever" );
    cmn.CallEventHandler( "clk_lever_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_lever", 0, "", 0 );
  
  AnimPlay( "anm_grid_lever", "lever", func_end );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_tumbler ()
  
  cmn.CallEventHandler( "clk_tumbler_beg" );

  local func_end = function ()
    
    local func_end_2 = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_tumbler" );
      cmn.CallEventHandler( "clk_tumbler_end" ); 

    end;

    ObjMultiSet( {
      { "anm_stand_key",      { alp = 0 } },
      { "obj_stand_key_last", { alp = 1 } },
    } );
    ObjAnimate( "spr_stand_box", "alp", 0, 0, func_end_2, { 
      0.0, 0, 0,   
      0.3, 0, 1 
    } );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_small_key_drawer", 0, "", 0 );
  
    ObjMultiSet( {
      { "anm_stand_key",   { alp = 0 } },
      { "anm_stand_key_2", { alp = 1 } },
    } );
    AnimPlay( "anm_stand_key_2", "key1", func_end );
  
end;
--*********************************************************************************************************************
-- function *** MMG WINECELLAR *** () end;
--*********************************************************************************************************************

  private.gamedata_winecellar = {};
  
  private.coordinates_winecellar = {
                                      gorizontal = { 
                                                      { start_pos = 321, end_pos = 463 },
                                                      { start_pos = 340, end_pos = 441 },
                                                      { start_pos = 361, end_pos = 423 },
                                                      { start_pos = 382, end_pos = 401 } 
                                                   },
                                      vertical = { 
                                                    
                                                    { start_pos = 245, end_pos = 386 },
                                                    { start_pos = 264, end_pos = 365 },
                                                    { start_pos = 284, end_pos = 345 },
                                                    { start_pos = 306, end_pos = 325 } 
                                                 } 
                                   };
                                                
  private.gamemode_winecellar = "gorizontal";
  
  
  private.WINECELLAR_HORIZONTAL_RUNNER = "spr_winecellar_slingshot_mmg_runner_horizontal";
  private.WINECELLAR_VERTICAL_RUNNER = "spr_winecellar_slingshot_mmg_runner_vertical";
  private.WINECELLAR_WIN_LIGHT = "spr_winecellar_slingshot_mmg_win_light";
  private.WINECELLAR_BACK = "spr_winecellar_slingshot_mmg_interface";
  
  private.WINECELLAR_BACK_PATH = "assets/levels/level2/rm_winecellar/layers/back_az_";
  private.WINECELLAR_LEVEL_COUNT = 4;
  
  private.WINECELLAR_HORIZONTAL_START = 279;
  private.WINECELLAR_HORIZONTAL_END = 501;
  
  private.WINECELLAR_VERTICAL_START = 204;
  private.WINECELLAR_VERTICAL_END = 429;
  
  
  --*******************************************************************************************************************
  function private.WinecellarDefault ()

    ng_global.progress[ "std" ][ "win_winecellar" ].cur_level = 1;

  end; 


  --*******************************************************************************************************************
  function private.WinecellarLoad ()

    if ( not ng_global.progress[ "std" ][ "win_winecellar" ].cur_level ) then 

      private.WinecellarDefault();

    end; 

    private.gamedata_winecellar = ng_global.progress[ "std" ][ "win_winecellar" ];
    
  end;


  --*******************************************************************************************************************
  function private.WinecellarLogicInit ()   

    ObjSet( "obj_winecellar_slingshot_mmg_click", { 
                                                      input = true,
                                                      event_mdown = function () private.WinecellarClick(); end,
                                                      event_menter = function () private.WinecellarEnter(); end,
                                                      event_mleave = function () private.WinecellarLeave(); end
                                                 } );


  end;


  --*******************************************************************************************************************
  function private.WinecellarEnter ()
   
    SetCursor( CURSOR_HAND );

  end;


  --*******************************************************************************************************************
  function private.WinecellarLeave ()  

    SetCursor( CURSOR_DEFAULT );
    
  end;


  --*******************************************************************************************************************
  function private.WinecellarClick () 
    
    common_impl.PlayAudio( "sfx", "aud_menter_menu", 0, "", 0 );

    local func_end_gorizontal = function ()
      
      cmn.Lock( false );
      private.WinecellarUpdate();
      
    end;
    
    local func_end_vertical = function ()
      
      if ( private.gamedata_winecellar.cur_level <= 4 ) then 
          
        AnimPlay( "anm_winecellar_slingshot_mmg_static", "static", "" );
        private.WinecellarWinLightClearing();
        
        ObjSet( "anm_winecellar_slingshot_mmg_chain_static", { alp = 1 } );        
          
      end;
      
      cmn.Lock( false );
      private.WinecellarUpdate();
      
    end;
    
    local curLevel = private.gamedata_winecellar.cur_level;
    local horizontalWinLight = private.WINECELLAR_WIN_LIGHT..curLevel.."_2";
    local verticalWinLight = private.WINECELLAR_WIN_LIGHT..curLevel.."_1";
    
    if ( private.gamemode_winecellar == "gorizontal" ) then
      
      private.gamemode_winecellar = "vertical";
      ObjStopAnimate( private.WINECELLAR_HORIZONTAL_RUNNER, 0 );
      
      if private.IsShotSuccessful() == "WIN_HORIZONTAL" then
        
        cmn.Lock( true );
        ObjAnimate( horizontalWinLight, "alp",0,0, func_end_gorizontal, { 0, 0, 0,    0.3, 0, 1 } );
        
      else
        
        func_end_gorizontal();
        
      end;
      
    elseif ( private.gamemode_winecellar == "vertical" ) then
      
      cmn.Lock( true );
      
      private.gamemode_winecellar = "gorizontal";
      ObjStopAnimate( private.WINECELLAR_VERTICAL_RUNNER, 1 );
      
      if private.IsShotSuccessful() == "WIN_ALL" then
        
        ObjSet( "anm_winecellar_slingshot_mmg_chain_static", { alp = 0 } );
        ObjAnimate( verticalWinLight, "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
        
        private.gamedata_winecellar.cur_level = private.gamedata_winecellar.cur_level + 1;
        
        if ( private.gamedata_winecellar.cur_level > 4 ) then 
          
          ObjMultiSet( { 
            { "anm_winecellar_slingshot_mmg_shot_win",  { alp = 1, visible = true } },
            { "anm_winecellar_slingshot_mmg_static",  { alp = 0, visible = false } },
          } );
          
          common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_lock2", 0, "", 0 );
          AnimPlay( "anm_winecellar_slingshot_mmg_shot_win", "shot_win", func_end_vertical );
          
        else 

          common_impl.PlayAudio( "sfx", "level2/sfx/aud_slingshot_hit", 0, "", 0 );
          AnimPlay( "anm_winecellar_slingshot_mmg_static", "shot_success", func_end_vertical );
          
        end;
        
      else
        
        if private.IsShotSuccessful() == "WIN_VERTICAL" then
          
          ObjAnimate( verticalWinLight, "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
        
        end;
        
        common_impl.PlayAudio( "sfx", "level2/sfx/aud_slingshot_fail", 0, "", 0 );
        AnimPlay( "anm_winecellar_slingshot_mmg_static", "shot_failed", func_end_vertical );
        
      end;
      
    end;
    
  end;

  
  --*******************************************************************************************************************
  function private.IsShotSuccessful ()
  
    local result = "NOTHING";
    local curLevel = private.gamedata_winecellar.cur_level;
    
    local horizontalRunnerPosition = ObjGet( private.WINECELLAR_HORIZONTAL_RUNNER ).pos_x;
    local verticalRunnerPosition = ObjGet( private.WINECELLAR_VERTICAL_RUNNER ).pos_y;
    
    local rightHorizontalRunnerPositionStart = private.coordinates_winecellar.gorizontal[ curLevel ].start_pos;
    local rightHorizontalRunnerPositionEnd = private.coordinates_winecellar.gorizontal[ curLevel ].end_pos;
    
    local rightVerticalRunnerPositionStart = private.coordinates_winecellar.vertical[ curLevel ].start_pos;
    local rightVerticalRunnerPositionEnd = private.coordinates_winecellar.vertical[ curLevel ].end_pos;
    
    local condition_1 = rightHorizontalRunnerPositionStart <= horizontalRunnerPosition;
    local condition_2 = horizontalRunnerPosition <= rightHorizontalRunnerPositionEnd;
    local condition_3 = rightVerticalRunnerPositionStart <= verticalRunnerPosition;
    local condition_4 = verticalRunnerPosition <= rightVerticalRunnerPositionEnd;
    
    if ( condition_1 and condition_2 ) then
      
      result = "WIN_HORIZONTAL";
      
      if ( condition_3 and condition_4 ) then
      
        result = "WIN_ALL";
        
      end;
      
    elseif ( condition_3 and condition_4 ) then
      
      result = "WIN_VERTICAL";
      
    end;
    
    return result; 
    
  end;
  
  
  --*******************************************************************************************************************
  function private.WinecellarRunnerMoving ()  
    
    if ( private.gamemode_winecellar == "gorizontal" ) then
      
      ObjMultiSet( { 
        { private.WINECELLAR_HORIZONTAL_RUNNER,  { pos_x = private.WINECELLAR_HORIZONTAL_START } },
        { private.WINECELLAR_VERTICAL_RUNNER,  { pos_y = private.WINECELLAR_VERTICAL_START } },
      } );
      
      ObjAnimate( private.WINECELLAR_HORIZONTAL_RUNNER, "pos_x",1,0, "", { 0, 1, private.WINECELLAR_HORIZONTAL_START,    
                                                                         1.2, 1, private.WINECELLAR_HORIZONTAL_END,
                                                                         2.4, 1, private.WINECELLAR_HORIZONTAL_START } );
      
    elseif ( private.gamemode_winecellar == "vertical" ) then
      
      ObjAnimate( private.WINECELLAR_VERTICAL_RUNNER, "pos_y",1,0, "", { 0, 1, private.WINECELLAR_VERTICAL_START,    
                                                                       1.2, 1, private.WINECELLAR_VERTICAL_END,
                                                                       2.4, 1, private.WINECELLAR_VERTICAL_START } );

    end;
    
  end;


  --*******************************************************************************************************************
  function private.WinecellarWinLightClearing () 
    
    for i = 1, private.WINECELLAR_LEVEL_COUNT, 1 do 
      
      local horizontalWinLight = private.WINECELLAR_WIN_LIGHT..i.."_2";
      local verticalWinLight = private.WINECELLAR_WIN_LIGHT..i.."_1";
      
      ObjMultiSet( { 
        { horizontalWinLight,  { alp = 0 } },
        { verticalWinLight,  { alp = 0 } },
      } );
        
    end;
   
  end;
  
  
  --*******************************************************************************************************************
  function private.WinecellarUpdate () 
   
    local curLevel = private.gamedata_winecellar.cur_level;
    
    for i = 1, private.WINECELLAR_LEVEL_COUNT, 1 do 
      
      local curButton = private.WINECELLAR_WIN_LIGHT.."_"..i;
      
      if i < curLevel then 
        ObjSet( curButton, { alp = 1 } );
        
      else
        ObjSet( curButton, { alp = 0 } );
        
      end;
      
    end;
    
    if ( curLevel > 4 ) then
      
      private.WinecellarWin();
      
    else 
      
      private.WinecellarRunnerMoving(); 
      
      local curResource = private.WINECELLAR_BACK_PATH..curLevel;
      ObjSet( private.WINECELLAR_BACK, { res = curResource } ); 
    
    end;
    
  end;

    
  --*******************************************************************************************************************
  function private.WinecellarWin () 
    
    local func_end = function()

      cmn.SetEventDone( "win_winecellar" );
      cmn.CallEventHandler( "win_winecellar" );

      cmn.Lock( false );
      common_impl.PassingMgWin( "winecellar" );

    end; 
    
    --common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_gate", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "aud_win_mg" );
    
    cmn.MiniGameHide();
    cmn.Lock( true );
    
    ObjAnimate( "obj_winecellar_slingshot_mmg", "alp",0,0, func_end, { 0, 0, 1,    0.6, 0, 0 } );
    
  end;


  --*********************************************************************************************************************
  function public.Reset ()
    
    ObjStopAnimate( private.WINECELLAR_HORIZONTAL_RUNNER, 0 );
    ObjStopAnimate( private.WINECELLAR_VERTICAL_RUNNER, 1 );
    
    private.gamemode_winecellar = "gorizontal";
    private.WinecellarWinLightClearing(); 

    private.WinecellarDefault(); 
    private.WinecellarLoad();
    private.WinecellarUpdate(); 

  end; 


  --*********************************************************************************************************************
  function public.Skip ()
    
    private.gamedata_winecellar.cur_level = 5;
    
    local func_end = function()
        
      cmn.Lock( false );
      
      private.WinecellarLoad();
      private.WinecellarUpdate(); 
      
    end;
    
    cmn.Lock( true );
    
    ObjStopAnimate( private.WINECELLAR_HORIZONTAL_RUNNER, 0 );
    ObjStopAnimate( private.WINECELLAR_VERTICAL_RUNNER, 1 );
    
    ObjMultiSet( { 
      { "anm_winecellar_slingshot_mmg_shot_win",  { alp = 1, visible = true } },
      { "anm_winecellar_slingshot_mmg_static",  { alp = 0, visible = false } },
      { "anm_winecellar_slingshot_mmg_chain_static",  { alp = 0 } },
    } );
    
    AnimPlay( "anm_winecellar_slingshot_mmg_shot_win", "shot_win", func_end );    

  end;


--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;

--------------------------------------------------------------------------------------------
function private.see_winecellar ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_winecellar" );

    common_impl.ShowBbt( 'bbt_winecellar_see_winecellar' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_door_ghost_sc", 0, "", 0 );

  AnimPlay( "anm_winecellar_winecellar", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_winecellar_fire ()

  local func_end = function ()
    
    local func_end_2 = function () 
      
      cmn.Lock( false );
      cmn.SetEventDone( "see_winecellar_fire" );
      cmn.CallEventHandler( "see_winecellar_fire" );
      --common_impl.ShowBbt( 'bbt_winecellar_see_winecellar_fire' );
    end;
    
    AnimPlay( "anm_winecellar_fire", "fire_on", func_end_2 );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );
  ObjAnimate( "anm_winecellar_fire", "alp",0,0, func_end, { 0, 0, 1,    2, 0, 1 } );
  
end;
--*********************************************************************************************************************
function private.SeeIntro2 ()

  ObjDelete( "tmr_winecellar_intro_2" ); 

  local func_end = function ( skip )
  
    if skip then
  
      common_impl.StopAudio( "voc", "level2/voc/aud_intro_lvl2_voc",  0.2 );
      common_impl.StopAudio( "sfx", "level2/sfx/aud_intro_lvl2",      0.2 );
      
    end;
    
    ObjSet( private.room_objname, { color_r = 1, color_g = 1, color_b = 1 } );

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

    cmn.SetEventDone( "see_intro_2" );
    cmn.CallEventHandler( "see_intro_2" );

    interface.KeyTaskAdd( "lvl2_get_out" );

    common_impl.ShowBbt( 'bbt_winecellar_see_intro_2' );
    private.see_winecellar_fire();

    private.WineCellarPlayEnv( 1 );
    
  end;

  common_impl.PlayAudio( "voc", "level2/voc/aud_intro_lvl2_voc",  0, "", 0 );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_intro_lvl2",      0, "", 0 );

  cmn.PlayDialogVideo( "vid_winecellar_intro_2", func_end );

end;

--------------------------------------------------------------------------------------------
function public.see_winecellar_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_winecellar_ghost" );
    --cmn.CallEventHandler( "see_winecellar_ghost" );

    common_impl.ShowBbt( 'bbt_winecellar_see_ghost' );
    
  end;
    
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_man_ghost_sc", 0, "", 0 );

  ObjSet( "anm_winecellar_ghost", { alp = 1 } );
  AnimPlay( "anm_winecellar_ghost", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_winecellar ()

  if not ( cmn.IsEventDone( "opn_winecellar" ) ) then

    cmn.SetEventDone( "opn_winecellar" );
    
  end;
  cmn.CallEventHandler( "opn_winecellar" ); 
  
  if ( cmn.IsEventDone( "win_chain" ) and not cmn.IsEventDone( "see_winecellar" ) ) then

    private.see_winecellar();
  
  end;  
  
end;
--------------------------------------------------------------------------------------------
-- function beg_level2 () end;
--------------------------------------------------------------------------------------------
  local beg_level2 = function ()

    interface.InventoryItemAdd( "inv_cleaner_lvl2" );
    interface.InventoryItemAdd( "inv_flashlight_lvl2" );
    
  end;
  cmn.AddSubscriber( "beg_level2", beg_level2 );
  
  
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

  cmn.AnimateAmbientLight( "spr_heavydoor_light" );
  cmn.AnimateAmbientLight( "spr_barrel_light" );
  cmn.AnimateAmbientLight( "spr_grid_light" );
  
end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************

function private.HeavydoorUseSymbol ()

  common_impl.ShowBbt( "bbt_heavydoor_use_symbol" );
  
  local obj = "spr_heavydoor_door_2";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_metal_door", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;


--*********************************************************************************************************************
function private.HeavydoorUsePatternfragment ()

  common_impl.ShowBbt( "bbt_heavydoor_use_patternfragment" );
  
  local obj = "spr_heavydoor_nippers_door";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_wood2", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;


--*********************************************************************************************************************
function private.BarrelUseGrapesleaf1 ()

  common_impl.ShowBbt( "bbt_barrel_use_grapesleaf1" );
  
  local obj = "spr_barrel_door_right";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_part", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;


--*********************************************************************************************************************
function private.BarrelUseGrapesleaf2 ()

  common_impl.ShowBbt( "bbt_barrel_use_grapesleaf2" );
  
  local obj = "spr_barrel_door_left";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_part", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;


--*********************************************************************************************************************
function private.BarrelUseCorkscrew ()

  common_impl.ShowBbt( "bbt_barrel_use_corkscrew" );
  
  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_cork", 0, "", 0 );

  ObjAnimate( "spr_barrel_fuse", "pos_x",0,0, func_end, { 0, 3, -164,    0.1, 3, -172,    0.2, 3, -164 } ); 
  
end;


--*********************************************************************************************************************
function private.KilnUseBentrod ()

  common_impl.ShowBbt( "bbt_kiln_use_bentrod" );
  
  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal4_mid_door", 0, "", 0 );

  AnimPlay( "anm_kiln_open_door_hh", "open_door_hh", func_end );
  
end;


--*********************************************************************************************************************
function private.KilnUseAnimalstatuette ()

  common_impl.ShowBbt( "bbt_kiln_use_animalstatuette" );
  
  local obj = "spr_kiln_door_closed_breadbox";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_mid2", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;


--*********************************************************************************************************************
function private.GridUseLockpart ()

  common_impl.ShowBbt( "bbt_grid_use_lockpart" );
  
  local obj = "obj_grid_grille_2";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_low", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;


--*********************************************************************************************************************
function private.GridExternalGrille ()
  
  if ( not cmn.IsEventDone( "use_cleaner_lvl2" ) ) then
    common_impl.ShowBbt( "bbt_grid_use_cleaner" );
    
  else 
    common_impl.ShowBbt( "bbt_grid_use_lever" );
    
  end;
  
  local obj = "spr_grid_grille";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_mid_door", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;
--*********************************************************************************************************************
function private.GridUseLever ()
  
  common_impl.ShowBbt( 'bbt_grid_use_lever' );
  
  local obj = "spr_grid_tumbler";
  local obj2 = "spr_grid_lever_clean";
  
  local time = 0.3;
  local dx = 1;
  local dy = 1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_high2", 0, "", 0 );

  ObjAnimate( obj2, "ang",0,1, func_end, { 0,0,0, time/4,0,-0.1, 3/4*time,0,0.1, time,0,0 }); 
  
end;
--*********************************************************************************************************************
function private.GridUseCleaner ()
  
  common_impl.ShowBbt( 'bbt_grid_use_cleaner' );
  
--  local obj = "spr_grid_tumbler";
--  
--  local time = 0.3;
--  local dx = 1;
--  local dy = 1;
--
--  local func_end = function ()
--    
--    cmn.Lock( false );
--
--  end;
--
--  cmn.Lock( true );
--  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx", 0, "", 0 );
--
--  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
--  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;
--*********************************************************************************************************************
function private.StandUseGlass ()
  
  local func_end = function ()
    
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_stand_use_glass2' );

    ObjMultiSet( { 
      { "anm_stand_mug_2",  { alp = 1 } },
      { "anm_stand_hook_2", { alp = 0 } },
    } );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_cutters", 0, "", 0 );
 
  ObjMultiSet( { 
    { "anm_stand_mug_2",  { alp = 0 } },
    { "anm_stand_hook_2", { alp = 1 } },
  } );
  
  AnimPlay( "anm_stand_hook_2", "hook_1", func_end );

end;
--*********************************************************************************************************************
function private.StandUseGlass3 ()
  
  local func_end = function ()
    
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_stand_use_glass3' );

    ObjMultiSet( { 
      { "anm_stand_mug_3",  { alp = 1 } },
      { "anm_stand_hook_3", { alp = 0 } },
    } );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_cutters", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_stand_mug_3",  { alp = 0 } },
    { "anm_stand_hook_3", { alp = 1 } },
  } );
  
  AnimPlay( "anm_stand_hook_3", "hook_2", func_end );

end;
--*********************************************************************************************************************

function private.StandUseTurner ()
  
  local func_end = function ()
    
    cmn.Lock( false );
    
    common_impl.ShowBbt( 'bbt_stand_use_turner' );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_water", 0, "", 0 );

  ObjAnimate( "spr_stand_cover_left", "pos_y", 0, 1, func_end, { 0, 0, 0,   0.3, 3, -3,   0.6, 3, 0 } );
  
end;
--*********************************************************************************************************************

function private.StandUseTumbler()

  local func_end = function ()
    
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_stand_use_tumbler' );

    ObjMultiSet( { 
      { "anm_stand_key",    { alp = 1 } },
      { "anm_stand_key_hh", { alp = 0 } },
    } );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_mid_door", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_stand_key",    { alp = 0 } },
    { "anm_stand_key_hh", { alp = 1 } },
  } );

  AnimPlay( "anm_stand_key_hh", "hh", func_end );
  
end;

--*********************************************************************************************************************
function private.StandUseCorkscrewHandle()

  local func_end = function ()
    
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_stand_use_corkscrewhandle' );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_cork", 0, "", 0 );

  ObjAnimate( "anm_stand_corkscrew", "pos_xy", 0, 1, func_end, { 
    0.0, 0,  0, 0,
    0.3, 3, -2, 2,
    0.6, 3,  0, 0,
  } );

end;
--*********************************************************************************************************************
function private.StandUseTurner()

  local func_end = function ()
    
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_stand_use_turner' );

    ObjMultiSet( { 
      { "anm_stand_use_turner",    { alp = 1 } },
      { "anm_stand_use_turner_hh", { alp = 0 } },
    } );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_use_part", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_stand_use_turner",    { alp = 0 } },
    { "anm_stand_use_turner_hh", { alp = 1 } },
  } );

  AnimPlay( "anm_stand_use_turner_hh", "v_2", func_end );
  
end;

--*********************************************************************************************************************
function private.UseSlingshot ()
  
  common_impl.ShowBbt( "bbt_winecellar_use_slingshot" );
  
  local func_end = function ()
    
    cmn.Lock( false );
    
    ObjMultiSet( { 
      { "anm_winecellar_slingshot_mmg_chain_click",  { alp = 0 } },
      { "anm_winecellar_slingshot_mmg_chain_static",  { alp = 1 } },
    } );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_grill", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_winecellar_slingshot_mmg_chain_click",  { alp = 1 } },
    { "anm_winecellar_slingshot_mmg_chain_static",  { alp = 0 } },
  } );
  
  AnimPlay( "anm_winecellar_slingshot_mmg_chain_click", "chain_click", func_end );
  
end;
--*********************************************************************************************************************
function private.UseWheel ()
  
  common_impl.ShowBbt( 'bbt_winecellar_use_wheel' );
  
  local func_end = function ()
    
    cmn.Lock( false );
    
    --ObjMultiSet( { 
    --  { "anm_winecellar_slingshot_mmg_chain_click",  { alp = 0 } },
    --  { "anm_winecellar_slingshot_mmg_chain_static",  { alp = 1 } },
    --} );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_rope_2", 0, "", 0 );

  --ObjMultiSet( { 
  --  { "anm_winecellar_slingshot_mmg_chain_click",  { alp = 1 } },
  --  { "anm_winecellar_slingshot_mmg_chain_static",  { alp = 0 } },
  --} );
  
  AnimPlay( "anm_winecellar_rag", "rag_hh", func_end );
  
end;
--*********************************************************************************************************************
-- function *** Audio *** () end;
--*********************************************************************************************************************
function private.WineCellarPlayEnv( i )

  if i == 1 then

    common_impl.StopMusEnv();
    common_impl.PlayAudio( "mus_env", "mus_env/aud_danger_mus_env",  0, "", 0 );
    ObjSet( "tmr_winecellar_musenv", { playing = true, time = 150, endtrig = function() private.WineCellarPlayEnv( i+1 ) end } );

  else

    cmn.PlayMusEnv();

  end;

end;
--*********************************************************************************************************************