-- name=ho_in_safe
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "in_safe" );
  game.relations[ "ho_in_safe" ].exitroom = "rm_lucien_room";
  private.room_objname = "ho_in_safe";
  --------------------------------------------------------------------------------------------------
  
  private.TASKPANEL_LEFT = -250;
  private.TASKPANEL_DIFF = 120;
  private.TASKPANEL_COUNT = 5;
  
  private.tasks = { 
                    "bead", "beetle", "candlestick", "crest", "cup", "door_amulet", 
                    "fork", "metal_part", "spoon", "spyglass", "star", "tiara"
                  };

  ObjMultiSet( { 
                  { "spr_in_safe_bead",  { event_mdown = function() private.TaskComplete( "bead" ); end } },
                  { "spr_in_safe_beetle",  { event_mdown = function() private.TaskComplete( "beetle" ); end } },
                  { "spr_in_safe_candlestick",  { event_mdown = function() private.TaskComplete( "candlestick" ); end } },
                  { "spr_in_safe_crest",  { event_mdown = function() private.TaskComplete( "crest" ); end } },
                  { "spr_in_safe_cup",  { event_mdown = function() private.TaskComplete( "cup" ); end } },
                  { "spr_in_safe_door_amulet",  { event_mdown = function() private.TaskComplete( "door_amulet" ); end } },
                  { "spr_in_safe_fork",  { event_mdown = function() private.TaskComplete( "fork" ); end } },
                  { "spr_in_safe_metal_part",  { event_mdown = function() private.TaskComplete( "metal_part" ); end } },
                  { "spr_in_safe_spoon",  { event_mdown = function() private.TaskComplete( "spoon" ); end } },
                  { "spr_in_safe_spyglass",  { event_mdown = function() private.TaskComplete( "spyglass" ); end } },
                  { "spr_in_safe_star",  { event_mdown = function() private.TaskComplete( "star" ); end } },
                  { "spr_in_safe_tiara",  { event_mdown = function() private.TaskComplete( "tiara" ); end } },
  } );
  
  for i = 1, #private.tasks do

    local itemInput = false;
    
    if ( i <= private.TASKPANEL_COUNT ) then 
      
      itemInput = true;
      
    end;
    
    local curItem = "spr_in_safe_"..private.tasks[ i ];
    local curPanelItem = "spr_in_safe_taskpanel_"..private.tasks[ i ];
    
    ObjMultiSet( { 
      { curItem,  { input = itemInput } },
      { curPanelItem,  { pos_x = private.TASKPANEL_LEFT + ( i - 1 ) * private.TASKPANEL_DIFF } },
    } );
    
  end;
  
  --------------------------------------------------------------------------------------------
  -- function win_in_safe () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_in_safe" ] = {
    type = "win",
    room = "rm_lucien_room",
    zz = "ho_in_safe",
    zz_gate = "gho_lucien_room_in_safe"
  };
  local win_in_safe_inv = function ()
  
    if ( cmn.IsEventDone( "win_in_safe" ) ) then
    
      interface.InventoryItemAdd( "inv_gothic_pattern", "spr_in_safe_win" );    
    
    end;
    
  end;
  local win_in_safe_loc = function ()
  
    if ( cmn.IsEventDone( "win_in_safe" ) ) then
    
      ObjDelete( "gho_lucien_room_in_safe" );   
    
    end;
    
  end;

  cmn.AddSubscriber( "win_in_safe", win_in_safe_inv );
  cmn.AddSubscriber( "win_in_safe", win_in_safe_loc, "rm_lucien_room" );
  --------------------------------------------------------------------------------------------------
  local start_in_safe_func = function ()

    if ( cmn.IsEventStart( "win_in_safe" ) ) then
    
      common_impl.ProcessHoStart( "in_safe" );
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_in_safe" ].found;

      for i = 1, #ho_found, 1 do
        
        ObjDelete( ho_found[ i ][ "object" ] );
        
        for k = 1, 12 do
          
          if ( ho_found[ i ].task == private.tasks[ k ] ) then
            
            ObjDelete( "spr_in_safe_taskpanel_"..private.tasks[ k ] );
            
            for j = k, 12 do
              
              if ( ObjGet( "spr_in_safe_taskpanel_"..private.tasks[ j ] ) ) then
         
                ObjSet( "spr_in_safe_taskpanel_"..private.tasks[ j ], { pos_x = ObjGet( "spr_in_safe_taskpanel_"..private.tasks[ j ] ).pos_x - private.TASKPANEL_DIFF } ); 
                
                if ( ObjGet( "spr_in_safe_taskpanel_"..private.tasks[ j ] ).pos_x < private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF ) then
                  
                  ObjSet( "spr_in_safe_"..private.tasks[ j ], { input = true } );
                  
                end;
              
              end;
              
            end;
          
          end;
          
        end;
      
      end;
      
    end;

  end;
  cmn.AddSubscriber( "win_in_safe", start_in_safe_func, private.room_objname );  

end;


--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopMusEnv();
  common_impl.StopAllMus();

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level3/env/aud_lucien_room_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_in_safe" ) ) then
  
    cmn.InitHo( "in_safe" );
    cmn.SetEventDone( "opn_in_safe" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bead",          1, 0, { { "spr_in_safe_bead" } } );
  interface.TaskPanelTaskAdd( ho_items, "beetle",        1, 0, { { "spr_in_safe_beetle" } } );
  interface.TaskPanelTaskAdd( ho_items, "candlestick",   1, 0, { { "spr_in_safe_candlestick" } } );
  interface.TaskPanelTaskAdd( ho_items, "crest",         1, 0, { { "spr_in_safe_crest" } } );
  interface.TaskPanelTaskAdd( ho_items, "cup",           1, 0, { { "spr_in_safe_cup" } } );
  interface.TaskPanelTaskAdd( ho_items, "door_amulet",   1, 0, { { "spr_in_safe_door_amulet" } } );
  interface.TaskPanelTaskAdd( ho_items, "fork",          1, 0, { { "spr_in_safe_fork" } } );
  interface.TaskPanelTaskAdd( ho_items, "metal_part",    1, 0, { { "spr_in_safe_metal_part" } } );
  interface.TaskPanelTaskAdd( ho_items, "spoon",         1, 0, { { "spr_in_safe_spoon" } } );
  interface.TaskPanelTaskAdd( ho_items, "spyglass",      1, 0, { { "spr_in_safe_spyglass" } } );
  interface.TaskPanelTaskAdd( ho_items, "star",          1, 0, { { "spr_in_safe_star" } } );
  interface.TaskPanelTaskAdd( ho_items, "tiara",         1, 0, { { "spr_in_safe_tiara" } } );
  
  interface.TaskPanelShow( ho_items );
  
  ObjAttach( "obj_in_safe_taskpanel", "spr_int_taskpanel" );
  ObjSet( "obj_int_taskpanel", { visible = false } );
  ObjSet( "txt_int_taskpanel", { visible = false } );

end;


--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  
end;


--*********************************************************************************************************************
function public.PreClose ()
  
  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { visible = true } );
  ObjSet( "txt_int_taskpanel", { visible = true } );

  ObjAttach( "obj_in_safe_taskpanel", "ho_in_safe" );

end;


--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();
  ObjDelete( "obj_in_safe_gates" );
  
end;


--*********************************************************************************************************************
function private.TaskComplete( task_name, part )
  
  cmn.HoTaskFind( "spr_in_safe_"..task_name, task_name );

  local func_move = function () 
    
    private.TaskPanelUpdate( task_name ); 
    
  end;

  ObjAnimate( "spr_in_safe_taskpanel_"..task_name, "alp", 0, 0, func_move,
  { 
    0.0, 0, 1.0,
    0.4, 0, 1.0,
    0.6, 0, 0.0
  } );
  
end;
--*********************************************************************************************************************
function private.TaskPanelUpdate ( task_name )

  ObjDelete( "spr_in_safe_taskpanel_"..task_name );
  
  local index = private.FindIndex( private.tasks, task_name ); 
  
  for j = index, #private.tasks do

    local params = ObjGet( "spr_in_safe_taskpanel_"..private.tasks[ j ] );
    
    if ( params ) then

      local func_end = "";

      if ( not ObjGet( "spr_in_safe_"..private.tasks[ j ] ).input ) then

        func_end = function()
          
          local limitX = private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF;
          
          if ( ObjGet( "spr_in_safe_taskpanel_"..private.tasks[ j ] ) and 
          ( ObjGet( "spr_in_safe_taskpanel_"..private.tasks[ j ] ).pos_x < limitX ) and 
          ( ObjGet( "spr_in_safe_"..private.tasks[ j ] ).alp == 1 ) ) then
            
            ObjSet( "spr_in_safe_"..private.tasks[ j ], { input = true } );
            
          end;

        end;

      end;          

      if ( not private.IsFound( private.tasks[ j ] ) ) then
        
        ObjAnimate( "spr_in_safe_taskpanel_"..private.tasks[ j ], "pos_x", 0, 0, func_end, 
        { 
          0.0, 3, params.pos_x, 
          0.4, 3, params.pos_x - private.TASKPANEL_DIFF
        } );
        
      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.FindIndex( arr, elem ) -- поиск по таблице 

  for i = 1, #arr do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
function private.IsFound( task ) -- поиск по таблице 

  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_in_safe" ].found;
  
  for i = 1, #progress do
    
    if ( progress[ i ].task == task ) then

      return true;

    end;
    
  end;
  
  return false;  

end;



