-- name=ho_knight_arrmor
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "knight_arrmor" );
  game.relations[ "ho_knight_arrmor" ].exitroom = "rm_weapon_room";
  private.room_objname = "ho_knight_arrmor";
  --------------------------------------------------------------------------------------------------

  private.task_name = "win_knight_arrmor";
  private.cover_count = 12;
  private.item_count = 6;
  
  for i = 1, private.cover_count, 1 do 

    local curCover = "spr_knight_arrmor_piece_"..i.."_cover";  
    ObjSet( curCover, { input = true, event_mdown = function() private.CoverClick( i ); end } );
 
  end; 
                   
  for i = 1, private.item_count, 1 do 

    local curItem = "spr_knight_arrmor_piece_"..i.."_item";
    ObjSet( curItem, { input = false, 
                       event_mdown = function() private.ItemClick( i ); end, 
                       event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
                       event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                     } );

  end;   
                     
  ObjSet( "spr_knight_arrmor_sword", { input = false, 
                                       event_mdown = function() cmn.HoTaskFind( "spr_knight_arrmor_sword", "sword" ); end, 
                                       event_menter = function () common_impl.SetCursor( CURSOR_GET ); end,
                                       event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                                     } );    
  
  --------------------------------------------------------------------------------------------
  -- function win_knight_arrmor () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_knight_arrmor" ] = {
    type = "win",
    room = "rm_weapon_room",
    zz = "ho_knight_arrmor",
    zz_gate = "gho_weapon_room_knight_arrmor"
  };
  local win_knight_arrmor_inv = function ()
  
    if ( cmn.IsEventDone( "win_knight_arrmor" ) ) then
    
      interface.InventoryItemAdd( "inv_sword", "spr_knight_arrmor_win" );    
    
    end;
    
  end;
  local win_knight_arrmor_loc = function ()

    if ( cmn.IsEventDone( "win_knight_arrmor" ) ) then
    
      ObjDelete( "gho_weapon_room_knight_arrmor" );   
      ObjDelete( "spr_weapon_room_sword" );   
      
    end;
    
  end;

  cmn.AddSubscriber( "win_knight_arrmor", win_knight_arrmor_inv );
  cmn.AddSubscriber( "win_knight_arrmor", win_knight_arrmor_loc, "rm_weapon_room" );
  
  --------------------------------------------------------------------------------------------------
  local start_knight_arrmor_func = function ()

  if ( cmn.IsEventStart( "win_knight_arrmor" ) ) then

    local ho_found = ng_global.progress[ "std" ][ "win_knight_arrmor" ].found;

    for i = 1, #ho_found, 1 do
    
      ObjDelete( ho_found[ i ][ "object" ] );
    
    end;
    
    local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;

    local winCount = 0;

    for i = 1, #foundItems, 1 do 

      if ( foundItems[ i ].is_piece_found ) then 

        winCount = winCount + 1;

        local curItemID = foundItems[ i ].id_part;
        local curPart = "spr_knight_arrmor_piece_"..curItemID;
        ObjSet( curPart, { alp = 1 } );

      else 

        local curItemID = foundItems[ i ].id_part;
        local curItem = "spr_knight_arrmor_piece_"..curItemID.."_item";
        ObjSet( curItem, { input = true } );

      end; 

    end;

    if ( winCount == private.item_count and #foundItems == private.cover_count ) then 

      ObjMultiSet( { 
        { "spr_knight_arrmor_sword",  { alp = 1, visible = true, input = true } },
        { "obj_knight_arrmor_pieces",  { alp = 0, visible = false, input = false } },
      } );

    end;     

  end;

  end;
  local start_knight_arrmor_func_loc = function ()

  if ( cmn.IsEventStart( "win_knight_arrmor" ) ) then

    local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;

    local winCount = 0;
  
    for i = 1, #foundItems, 1 do 

      if ( foundItems[ i ].is_piece_found ) then 
  
        winCount = winCount + 1;
    
      end; 

    end;
    
    if ( winCount == private.item_count and #foundItems == private.cover_count ) then 

      ObjMultiSet( { 
        { "spr_weapon_room_sword",  { alp = 1 } },
      } );

    end;     

  end;

  end;
  cmn.AddSubscriber( "win_knight_arrmor", start_knight_arrmor_func, private.room_objname );   
  cmn.AddSubscriber( "win_knight_arrmor", start_knight_arrmor_func_loc, "rm_weapon_room" );
  
end;


--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopMusEnv();
  common_impl.StopAllMus();
  int_slider.InitSlider( private.room_objname );

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level2/env/aud_hall_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_knight_arrmor" ) ) then
  
    cmn.InitHo( "knight_arrmor" );
    cmn.SetEventDone( "opn_knight_arrmor" );

    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items = {};
  
  end;

  local ho_items = {};

  for i = 1, private.cover_count, 1 do 
    
    local curCover = "spr_knight_arrmor_piece_"..i.."_cover";
    local curCoverTask = "piece_"..i.."_cover";
     
    interface.TaskPanelTaskAdd( ho_items, curCoverTask,             1, 0, { { curCover } } );

  end; 

  for i = 1, private.item_count, 1 do 

    local curItem = "spr_knight_arrmor_piece_"..i.."_item";
    local curItemTask = "piece_"..i.."_item";
    interface.TaskPanelTaskAdd( ho_items, curItemTask,              1, 0, { { curItem } } );

  end; 
  
  interface.TaskPanelTaskAdd( ho_items, "sword",                    1, 0, { { "spr_knight_arrmor_sword" } } );
  interface.TaskPanelShow( ho_items );  

  ObjAttach( "obj_int_taskpanel_knight_arrmor", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 

end;


--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  
end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();
  
  if not ( cmn.IsEventDone( "win_knight_arrmor" ) ) then
    
    cmn.CallEventHandler( "win_knight_arrmor" );
    
  end;
  
end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_knight_arrmor" );

end;


--*********************************************************************************************************************
function public.HoComplete ()
  
  common_impl.PassingHoWin(); 
  
end;


--*********************************************************************************************************************
function private.CoverClick ( id )

  local curCover = "spr_knight_arrmor_piece_"..id.."_cover";
  local curCoverTask = "piece_"..id.."_cover";

  cmn.HoTaskFind( curCover, curCoverTask );
  
  if ( id <= private.item_count ) then 

    local curItem = "spr_knight_arrmor_piece_"..id.."_item";
    ObjSet( curItem, { input = true } );

  end; 

  local element = { id_part = id, is_piece_found = false }; 
  table.insert( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items, element ); 
  
  if ( private.CheckingOnAllItemsFound() and
  private.CheckingOnAllCoversFound() ) then 

    ObjMultiSet( { 
      { "spr_knight_arrmor_sword",  { alp = 1, visible = true, input = true } },
      { "obj_knight_arrmor_pieces",  { alp = 0, visible = false, input = false } },
    } );
    
  end; 
  
  private.TaskPanelUpdate(); 

end;


--*********************************************************************************************************************
function private.ItemClick ( id )

  local func_end = function () 

    cmn.Lock( false );

  end;

  local curItem = "spr_knight_arrmor_piece_"..id.."_item";
  local curItemTask = "piece_"..id.."_item";
  
  cmn.HoTaskFind( curItem, curItemTask );

  local curPiece = "spr_knight_arrmor_piece_"..id;

  cmn.Lock( true );
  ObjAnimate( curPiece, "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1 } );

  private.MarkingFoundItem( id );
  
  if ( private.CheckingOnAllItemsFound() and
  private.CheckingOnAllCoversFound() ) then 

    ObjMultiSet( { 
      { "spr_knight_arrmor_sword",  { alp = 1, visible = true, input = true } },
      { "obj_knight_arrmor_pieces",  { alp = 0, visible = false, input = false } },
    } );
    
  end;
  
  private.TaskPanelUpdate();

end;


--*********************************************************************************************************************
function private.TaskPanelUpdate () 

  if private.CheckingOnAllCoversFound() then 

    ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );
    ObjSet( "txt_knight_arrmor_taskpanel", { alp = 1, visible = true } );

    local count = private.item_count - private.GettingFoundItemsCount();

    ObjSet( "txt_knight_arrmor_taskpanel",
    {
       text   = "str_knight_arrmor_task",
       param0 = count
    } );

    if count == 0 then 
    
      ObjSet( "txt_knight_arrmor_taskpanel", { text = "str_knight_arrmor_final" } );

    end;

  end;

end;


--*********************************************************************************************************************
function private.MarkingFoundItem ( id )

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].id_part == id ) and ( not foundItems[ i ].is_piece_found ) then 

      foundItems[ i ].is_piece_found = true; 
      break; 

    end; 

  end; 

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items = foundItems; 

end; 


--*********************************************************************************************************************
function private.CheckingOnAllItemsFound ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local result = false; 
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].is_piece_found ) then 

      count = count + 1; 

    end; 

  end; 

  if private.item_count == count then 

    result = true;

  end;

  return result;

end; 


--*********************************************************************************************************************
function private.CheckingOnAllCoversFound ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local result = false; 
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ] ) then 

      count = count + 1; 

    end; 

  end; 

  if private.cover_count == count then 

    result = true;

  end;

  return result;

end; 


--*********************************************************************************************************************
function private.GettingFoundItemsCount ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].is_piece_found ) then 

      count = count + 1; 

    end; 

  end; 

  return count;

end; 


