-- name=mg_clock
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_clock";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_tower" } );

  private.LogicInit();   
  
  --------------------------------------------------------------------------------------------
  -- function win_clock () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_clock" ] = {
    type = "win",
    use_place = "gmg_tower_clock",
    room = "rm_tower",
    zz_gate = "gmg_tower_clock"
  };   
  
  local win_clock = function ()

    if ( cmn.IsEventDone( "win_clock" ) ) then  

    end;

  end;
  local win_clock_loc = function ()

    if ( cmn.IsEventDone( "win_clock" ) ) then  

      ObjDelete( "gmg_tower_clock" );
--      ObjMultiSet( { 
--        { "grm_tower_barber_room",  { visible = true, input = true } },
--      } );

    end;

  end;
  cmn.AddSubscriber( "win_clock", win_clock, private.room_objname );
  cmn.AddSubscriber( "win_clock", win_clock_loc, "rm_tower" );  
  --------------------------------------------------------------------------------------------
end;


--*********************************************************************************************************************
function public.Open () 

end;


--*********************************************************************************************************************
function public.PreOpen ()

  --common_impl.EnvPlay( { "level1/env/aud_porch_env" }, "", 0.5 );
  
  int_slider.InitSlider( private.room_objname );
    
  if not cmn.IsEventDone( "win_clock" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

  private.Load();
  private.Update();

end;


--*********************************************************************************************************************
function public.Close ()

end;


--*********************************************************************************************************************
function public.PreClose ()

  --common_impl.StopAudio( "env", "level1/env/aud_porch_env", 0.5 );
    
  if not cmn.IsEventDone( "win_clock" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;


--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

private.gamedata = {};

private.win_cells = { 6, 7, 10, 11 };

-- connections between buttons and list of field cells, 
-- which are linked with current button 
private.links = {
                  { 1, 2, 5, 6 },
                  { 3, 4, 7, 8 },
                  { 6, 7, 10, 11 },
                  { 9, 10, 13, 14 },
                  { 11, 12, 15, 16 } 
                };
                
-- runners coorditanes in current button 
private.coordinates = {
                        { pos_x = -67.1751, pos_y = -67.1751 },
                        { pos_x = 67.1751, pos_y = -67.1751 },
                        { pos_x = -67.1751, pos_y = 67.1751 },
                        { pos_x = 67.1751, pos_y = 67.1751 } 
                      };  

-- colors for buttons in hardcore mode                    
private.button_colors = {
                          { color_r = 0.698, color_g = 0.1333, color_b = 0.1333 },
                          { color_r = 0.2628, color_g = 0.8039, color_b = 0.5019 },
                          { color_r = 1, color_g = 1, color_b = 1 }, 
                          { color_r = 0.1176, color_g = 0.5647, color_b = 1 },
                          { color_r = 0.6, color_g = 0.1961, color_b = 0.8 } 
                        }; 
                        
-- colors for runners in hardcore mode                   
private.runner_colors = {
                          { color_r = 0.698, color_g = 0.1333, color_b = 0.1333 },
                          { color_r = 0.2628, color_g = 0.8039, color_b = 0.5019 },
                          { color_r = 0.1176, color_g = 0.5647, color_b = 1 },
                          { color_r = 0.6, color_g = 0.1961, color_b = 0.8 } 
                        }; 
                  
                  
private.BUTTON_NAME = "spr_clock_button_";
private.CONTEINER_NAME = "obj_clock_conteiner_";
private.RUNNER_NAME = "spr_clock_runner_";
private.MODE_BUTTON_NAME = "spr_clock_plate_";

private.BUTTON_COUNT = 5;
private.RUNNER_COUNT = 16;

private.RUNNER_COUNT_IN_CONTEINER = 4;
private.ANGLE_DELTA = -math.pi * 2 / private.RUNNER_COUNT_IN_CONTEINER; 


--*******************************************************************************************************************
function private.Default ()

  ng_global.progress[ "std" ][ "win_clock" ].mode = "casual";
  ng_global.progress[ "std" ][ "win_clock" ].conteiner_angles = { 0, 0, 0, 0, 0 };
  ng_global.progress[ "std" ][ "win_clock" ].field = { 
                                                        1, 2, 5, 6,
                                                        7, 8, 9, 10,
                                                        11, 12, 3, 13, 
                                                        14, 4, 15, 16
                                                     };
                                                      
  ng_global.progress[ "std" ][ "win_clock" ].runner_info = { 
                                                              { conteiner = 1, angle = 1, kind = "win" },
                                                              { conteiner = 1, angle = 2, kind = "win" },
                                                              { conteiner = 5, angle = 1, kind = "win" },
                                                              { conteiner = 4, angle = 3, kind = "win" },
                                                              { conteiner = 2, angle = 0, kind = "usual" },
                                                              { conteiner = 2, angle = 0, kind = "usual" },
                                                              { conteiner = 1, angle = 0, kind = "usual" },
                                                              { conteiner = 1, angle = 0, kind = "usual" },
                                                              { conteiner = 2, angle = 0, kind = "usual" },
                                                              { conteiner = 2, angle = 0, kind = "usual" },
                                                              { conteiner = 4, angle = 0, kind = "usual" },
                                                              { conteiner = 4, angle = 0, kind = "usual" },
                                                              { conteiner = 5, angle = 0, kind = "usual" },
                                                              { conteiner = 4, angle = 0, kind = "usual" },
                                                              { conteiner = 5, angle = 0, kind = "usual" },
                                                              { conteiner = 5, angle = 0, kind = "usual" } 
                                                           };

end; 


--*******************************************************************************************************************
function private.Load ()

  if ( not ng_global.progress[ "std" ][ "win_clock" ].mode or 
  not ng_global.progress[ "std" ][ "win_clock" ].conteiner_angles or 
  not ng_global.progress[ "std" ][ "win_clock" ].field or 
  not ng_global.progress[ "std" ][ "win_clock" ].runner_info ) then 

    private.Default();

  end; 

  private.gamedata = ng_global.progress[ "std" ][ "win_clock" ];

end;


--*******************************************************************************************************************
function private.LogicInit ()  

  for i = 1, private.BUTTON_COUNT, 1 do 
    
    local curButton = private.BUTTON_NAME..i;
    ObjSet( curButton, { 
                          input = true,
                          event_mdown = function () private.ButtonClick( i ); end,
                          event_menter = function () private.Enter( curButton ); end,
                          event_mleave = function () private.Leave( curButton ); end
                      } );
  end;
  
  local mode = { "hardcore", "casual" };       
                        
  for i = 1, #mode, 1 do 
    
    local curModeButton = private.MODE_BUTTON_NAME..mode[ i ];
    ObjSet( curModeButton, { 
                              input = true,
                              event_mdown = function () private.ChangeMode( mode[ i ] ); end,
                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
                          } );
                              
  end;      
  --------------------------------------------     
  --------------------------------------------   
  for i = 1, private.RUNNER_COUNT, 1 do 
    
    local curRunnerText = "txt_clock_runner_"..i;
    ObjSet( curRunnerText, { alp = 0, visible = false } ); 
   
  end; 
  
  
end;
                      

--*******************************************************************************************************************
function private.Enter ( nameFocus )
 
  SetCursor( CURSOR_HAND );
  
  local current = nameFocus.."_light";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );
  
end;


--*******************************************************************************************************************
function private.Leave ( nameFocus )  

  SetCursor( CURSOR_DEFAULT );
  
  local current = nameFocus.."_light";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );
  
end;


--*******************************************************************************************************************
function private.ChangeMode ( newMode ) 
  
  local func_end = function()

    cmn.Lock( false );
    private.Update(); 

  end; 
  
  local oldFocus = "";
  local newFocus = "";
  local isNeedAnim = false;
  
  if ( newMode ~= private.gamedata.mode ) then
    
    isNeedAnim = true;
    
  end;
  
  if ( newMode == "hardcore" ) then
    
    private.gamedata.mode = "hardcore";
    oldFocus = "spr_clock_plate_casual_light";
    newFocus = "spr_clock_plate_hardcore_light";  
    
  else
    
    private.gamedata.mode = "casual";
    oldFocus = "spr_clock_plate_hardcore_light";
    newFocus = "spr_clock_plate_casual_light";
    
  end;
  
  if isNeedAnim then
    
    cmn.Lock( true );
    
    ObjAnimate( oldFocus, "alp",0,0, func_end, { 0, 1, 1,    0.3, 1, 0 } );
    ObjAnimate( newFocus, "alp",0,0, "", { 0, 1, 0,    0.3, 1, 1 } );
    
  else
    
    func_end();
    
  end;
  
end;


--*******************************************************************************************************************
function private.ButtonClick ( buttonID ) 

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_move_part5", 0, "", 0 );

  local conteiner = private.CONTEINER_NAME..buttonID;
  
  local func_end = function()

    ObjSet( conteiner, { pos_z = 10 } );
    
    cmn.Lock( false );
    private.Update(); 

  end; 
  
  private.ChangeRunnerAngles( buttonID );
  
  local conteinerOldAngle = private.gamedata.conteiner_angles[ buttonID ] * private.ANGLE_DELTA;
  private.gamedata.conteiner_angles[ buttonID ] = private.gamedata.conteiner_angles[ buttonID ] + 1;
  local conteinerNewAngle = private.gamedata.conteiner_angles[ buttonID ] * private.ANGLE_DELTA;
  
  if ( private.gamedata.conteiner_angles[ buttonID ] >= private.RUNNER_COUNT_IN_CONTEINER ) then
    
    private.gamedata.conteiner_angles[ buttonID ] = 0;
    
  end;
  
  for i = 1, #private.links[ buttonID ], 1 do 
      
    local curCell = private.links[ buttonID ][ i ];
    local curRunnerID = private.gamedata.field[ curCell ];
    
    local curRunner = private.RUNNER_NAME..curRunnerID;
    ObjAttach( curRunner, conteiner );
    
    local curRunnerX = private.coordinates[ i ].pos_x * math.cos( conteinerOldAngle ) - private.coordinates[ i ].pos_y * math.sin( conteinerOldAngle ); 
    local curRunnerY = private.coordinates[ i ].pos_x * math.sin( conteinerOldAngle ) + private.coordinates[ i ].pos_y * math.cos( conteinerOldAngle );
    
    private.gamedata.runner_info[ curRunnerID ].conteiner = buttonID;
    ObjSet( curRunner, { pos_x = curRunnerX, pos_y = curRunnerY } );
      
  end;
  
  private.ChangeField( buttonID ); 
  
  cmn.Lock( true );
  ObjSet( conteiner, { pos_z = 15 } );
  ObjAnimate( conteiner, "ang",0,0, func_end, { 0, 0, conteinerOldAngle,    0.4, 0, conteinerNewAngle } );
  
end;


--*******************************************************************************************************************
-- changing runners ID in field-array, when button rotation happens 

function private.ChangeField ( buttonID )
  
  local tempArray = { 0, 0, 0, 0 };
  
  for i = 1, #private.links[ buttonID ], 1 do 
      
    local curCell = private.links[ buttonID ][ i ];
    local curRunnerID = private.gamedata.field[ curCell ];
    
    tempArray[ i ] = curRunnerID;
 
  end;
  
  private.gamedata.field[ private.links[ buttonID ][ 1 ] ] = tempArray[ 3 ];
  private.gamedata.field[ private.links[ buttonID ][ 2 ] ] = tempArray[ 1 ];
  private.gamedata.field[ private.links[ buttonID ][ 3 ] ] = tempArray[ 4 ];
  private.gamedata.field[ private.links[ buttonID ][ 4 ] ] = tempArray[ 2 ];
  
end;


--*******************************************************************************************************************
-- changing own runners angles, when button rotation happens 

function private.ChangeRunnerAngles ( buttonID )
  
  for i = 1, #private.links[ buttonID ], 1 do 
      
    local curCell = private.links[ buttonID ][ i ];
    local curRunnerID = private.gamedata.field[ curCell ];
    local curRunnerConteiner = private.gamedata.runner_info[ curRunnerID ].conteiner;
    
    if ( buttonID ~= curRunnerConteiner ) then
      
      local generalAngle = private.gamedata.conteiner_angles[ curRunnerConteiner ] + private.gamedata.runner_info[ curRunnerID ].angle;
      local newGeneralAngle = private.gamedata.conteiner_angles[ buttonID ]; 
      
      local newAngle = generalAngle - newGeneralAngle;
      newAngle = private.CheckingOnExitFromRange( newAngle ); 
      
      private.gamedata.runner_info[ curRunnerID ].angle = newAngle;
      local newRunnerAngle = newAngle * private.ANGLE_DELTA;
      
      local curRunner = private.RUNNER_NAME..curRunnerID;
      ObjSet( curRunner, { ang = newRunnerAngle } );
      
    end;
 
  end;  
  
end;


--*******************************************************************************************************************
-- that angle would not go into infinity

function private.CheckingOnExitFromRange ( angle )
  
  local correctAngle = angle;
  
  while ( correctAngle >= private.RUNNER_COUNT_IN_CONTEINER ) do
  
    correctAngle = correctAngle - private.RUNNER_COUNT_IN_CONTEINER;
  
  end;
  
  while ( correctAngle <= -private.RUNNER_COUNT_IN_CONTEINER ) do
  
    correctAngle = correctAngle + private.RUNNER_COUNT_IN_CONTEINER;
  
  end;

  return correctAngle; 
  
end;


--*******************************************************************************************************************
function private.Update ()

  for i = 1, private.BUTTON_COUNT, 1 do 
    
    if ( private.gamedata.mode == "hardcore" ) then 
      
      ObjMultiSet( { 
        { "spr_clock_plate_hardcore_light",  { alp = 1 } },
        { "spr_clock_plate_casual_light",  { alp = 0 } },
      } );
      
      if ( i ~= 3 ) then
        
        local curButton = private.BUTTON_NAME..i;
        ObjSet( curButton, private.button_colors[ i ] );
      
      end;
      
      if ( private.gamedata.runner_info[ i ].kind == "win" ) then 
        
        local curColorRunner = private.RUNNER_NAME..i.."_hardcore";
   
        ObjMultiSet( { 
          { curColorRunner,  { alp = 1, visible = true } },
          { curColorRunner,  private.runner_colors[ i ] },
        } );     
        
      end;
      
    else 
      
      ObjMultiSet( { 
        { "spr_clock_plate_casual_light",  { alp = 1 } },
        { "spr_clock_plate_hardcore_light",  { alp = 0 } },
      } );
      
      if ( i ~= 3 ) then
       
        local curButton = private.BUTTON_NAME..i;
        ObjSet( curButton, private.button_colors[ 3 ] );
      
      end;
      
      if ( private.gamedata.runner_info[ i ].kind == "win" ) then 
          
        local curColorRunner = private.RUNNER_NAME..i.."_hardcore";
        
        ObjMultiSet( { 
          { curColorRunner,  { alp = 0, visible = false } },
        } );      
        
      end;
      
    end;
    ------------------------------------------------------
    ------------------------------------------------------
    local curConteiner = private.CONTEINER_NAME..i;
    local curConteinerAngle = private.ANGLE_DELTA * private.gamedata.conteiner_angles[ i ];
    
    ObjSet( curConteiner, { ang = curConteinerAngle } );   
    
    for j = 1, #private.links[ i ], 1 do 
      
      local curCell = private.links[ i ][ j ];
      local curRunnerID = private.gamedata.field[ curCell ];
      local curRunnerConteiner = private.gamedata.runner_info[ curRunnerID ].conteiner;
  
      if ( i == curRunnerConteiner ) then 
        
        local curRunner = private.RUNNER_NAME..curRunnerID;
        local curRunnerAngle = private.ANGLE_DELTA * private.gamedata.runner_info[ curRunnerID ].angle;
        ObjAttach( curRunner, curConteiner );
        
        local curRunnerX = private.coordinates[ j ].pos_x * math.cos( curConteinerAngle ) - private.coordinates[ j ].pos_y * math.sin( curConteinerAngle ); 
        local curRunnerY = private.coordinates[ j ].pos_x * math.sin( curConteinerAngle ) + private.coordinates[ j ].pos_y * math.cos( curConteinerAngle );
        
        ObjSet( curRunner, { pos_x = curRunnerX, pos_y = curRunnerY, ang = curRunnerAngle } );
       
      end; 
      
    end;
    
  end;
  
  if private.CheckWin() then
    
    private.Win();
    
  end;
  
end;


--*******************************************************************************************************************
function private.CheckWin ()
  
  local count = 0;
  local result = false;
  
  if ( private.gamedata.mode == "hardcore" ) then 
    
    for i = 1, #private.win_cells, 1 do 
      
      local curCell = private.win_cells[ i ];
      local curRunnerID = private.gamedata.field[ curCell ]; 
      
      if ( private.gamedata.runner_info[ curRunnerID ].kind == "win" and
      i == curRunnerID ) then
        
        count = count + 1;
        
      end; 
      
    end;
    
  else
    
    for i = 1, #private.win_cells, 1 do 
      
      local curCell = private.win_cells[ i ];
      local curRunnerID = private.gamedata.field[ curCell ]; 
      
      if ( private.gamedata.runner_info[ curRunnerID ].kind == "win" ) then
        
        count = count + 1;
        
      end; 
      
    end;
    
  end;
  
  if ( count == private.RUNNER_COUNT_IN_CONTEINER  ) then 
    
    result = true;
    
  end;
  
  return result;
  
end;


--*******************************************************************************************************************
function private.Win () 
  
  local func_end = function()

    cmn.SetEventDone( "win_clock" );
    cmn.CallEventHandler( "win_clock" );

    cmn.Lock( false );
    common_impl.PassingMgWin();

    cmn.GotoRoom( "rm_tower" );

  end; 
  
  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_gate", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
  cmn.MiniGameHide();
  cmn.Lock( true );
  
  for i = 1, private.BUTTON_COUNT, 1 do
    
    local trgAfter = "";
    
    if i == private.BUTTON_COUNT then
      
      trgAfter = func_end;
      
    end;
    
    local curButtonLight = private.BUTTON_NAME..i.."_light";
    ObjAnimate( curButtonLight, "alp",0,0, trgAfter, { 0, 3, 0,    0.6, 3, 1,    1.0, 3, 0,    1.5, 3, 1,    2.6, 3, 0 } );
    
  end;
  
end;


--*********************************************************************************************************************
function public.Reset ()

  local oldMode = private.gamedata.mode;
  
  private.Default(); 
  private.gamedata.mode = oldMode;
  
  private.Load();
  private.Update(); 

end; 


--*********************************************************************************************************************
function public.Skip ()

  private.gamedata.field = { 
                              5, 6, 7, 8,
                              9, 1, 2, 10,
                              11, 3, 4, 12, 
                              13, 14, 15, 16
                            };
                            
  private.gamedata.runner_info = { 
                                    { conteiner = 1, angle = 1, kind = "win" },
                                    { conteiner = 2, angle = 2, kind = "win" },
                                    { conteiner = 4, angle = 1, kind = "win" },
                                    { conteiner = 5, angle = 3, kind = "win" },
                                    { conteiner = 1, angle = 0, kind = "usual" },
                                    { conteiner = 1, angle = 0, kind = "usual" },
                                    { conteiner = 2, angle = 0, kind = "usual" },
                                    { conteiner = 2, angle = 0, kind = "usual" },
                                    { conteiner = 1, angle = 0, kind = "usual" },
                                    { conteiner = 2, angle = 0, kind = "usual" },
                                    { conteiner = 4, angle = 0, kind = "usual" },
                                    { conteiner = 5, angle = 0, kind = "usual" },
                                    { conteiner = 4, angle = 0, kind = "usual" },
                                    { conteiner = 4, angle = 0, kind = "usual" },
                                    { conteiner = 5, angle = 0, kind = "usual" },
                                    { conteiner = 5, angle = 0, kind = "usual" } 
                                 };

  private.Load();
  private.Update(); 
  
end;








