-- name=level3
function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause,     10000000 );
  interface.WidgetAdd( InterfaceWidget_BtnMenu,         21 );

  if IsCollectorsEdition() then
    interface.WidgetAdd( InterfaceWidget_BtnGuide,      20 );
  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint,         11 );
  interface.WidgetAdd( InterfaceWidget_BtnSkip,         12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo,          9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset,         9 );
  interface.WidgetAdd( InterfaceWidget_Inventory,        9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel,       10 );
  interface.WidgetAdd( InterfaceWidget_Effects,         11 );
  interface.WidgetAdd( InterfaceWidget_BtnMap,          20 );
  interface.WidgetAdd( InterfaceWidget_DialogHo,        22 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom,     8 );
  interface.WidgetAdd( InterfaceWidget_ItemPanel           );
  interface.WidgetAdd( InterfaceWidget_Popup,           27 );
  interface.WidgetAdd( InterfaceWidget_BlackBarText,  1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,          26 );
  interface.WidgetAdd( InterfaceWidget_DialogVideo,     26 );
  interface.WidgetAdd( InterfaceWidget_DialogStory         );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter,  9 );
  interface.WidgetAdd( InterfaceWidget_StrategyGuide,   28 );
  interface.WidgetAdd( InterfaceWidget_Window              );
  interface.WidgetAdd( InterfaceWidget_Tutorial,        27 );
  interface.WidgetAdd( InterfaceWidget_Map,             26 );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.BtnMiniHOAdd( 18 );
  interface.SliderAdd( -1 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 18 );
    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
    interface.BtnMorphAdd( 18 );

  end;
   
  private.Init();
  ModLoad( "assets/levels/level3/mod_level3_inv" );
  level3_inv.Init();

  common.LevelLoad( "level3", "std", "mg_catacomb", param, private.menu_moduls );

  common_impl.CollectiblesMusicLoadOnLocation(); 
  common_impl.Collectibles2Load();
  common_impl.MorphLoad();
  
  private.TutorialSetParams();
  interface.KeyUpdate();

  cmn.PlayMusEnv();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_cemetery_3"
    ,"rm_lucien_room"
    ,"rm_tower"
    ,"rm_brook"
    ,"rm_barber_room"
    ,"rm_weapon_room"
    ,"ho_in_safe"
    ,"ho_lucien_table"
    ,"mg_catacomb"
    ,"ho_knight_arrmor"
    ,"ho_weapon"
    ,"mg_clock"
    ,"mg_boss_fight"
  };

  game.progress_names_room =
  {
     { "get_maggie",                  "rm_lucien_room"  }
    ,{ "get_dungeon_map",             "rm_lucien_room"  }
    ,{ "use_dungeon_map",             "rm_lucien_room",   { "get_dungeon_map"                          } }
    ,{ "win_catacomb",                "rm_lucien_room",   { "use_dungeon_map"                          } }
    ,{ "opn_lucien_room"              }
    ,{ "see_scare_window",            "rm_lucien_room"  }
    ,{ "get_disk",                    "rm_lucien_room",   { "opn_lucien_room"                          } }
    ,{ "see_lucien_room_1",           "rm_lucien_room"  }
    ,{ "use_maggie",                  "rm_lucien_room",   { "opn_lucien_room", "get_maggie"            } }
    ,{ "use_disk",                    "rm_lucien_room",   { "get_disk"                                 } }
    ,{ "get_chisel",                  "rm_lucien_room",   { "use_disk"                                 } }
    ,{ "get_flag_1",                  "rm_lucien_room",   { "use_disk"                                 } }
    ,{ "get_crumpled_paper",          "rm_lucien_room",   { "opn_lucien_room"                          } }
    ,{ "clk_coffee_table_clock",      "rm_lucien_room",   { "opn_lucien_room"                          } }
    ,{ "get_hands",                   "rm_lucien_room",   { "clk_coffee_table_clock"                   } }
    ,{ "use_chisel",                  "rm_lucien_room",   { "get_chisel"                               } }
    ,{ "get_figurine",                "rm_lucien_room",   { "use_chisel"                               } }
    ,{ "clk_window_handle",           "rm_lucien_room",   { "opn_lucien_room"                          } }
    ,{ "use_figurine",                "rm_lucien_room",   { "get_figurine"                             } }
    ,{ "get_wrought_handle",          "rm_lucien_room",   { "clk_window_handle"                        } }
    ,{ "clk_window_open",             "rm_lucien_room",   { "use_figurine", "get_wrought_handle"       } }
    ,{ "clk_wrought_handle",          "rm_lucien_room",   { "opn_lucien_room"                          } }
    ,{ "use_wrought_handle",          "rm_lucien_room",   { "clk_wrought_handle", "get_wrought_handle" } }
    ,{ "get_torn_shirt",              "rm_lucien_room",   { "use_wrought_handle"                       } }
    ,{ "clk_torn_shirt_1"             }
    ,{ "clk_torn_shirt_2"             }
    ,{ "get_cloth_bandage"            }
    ,{ "use_cloth_bandage",           "rm_lucien_room",   { "get_cloth_bandage"                        } }
    ,{ "dlg_lucien_room_maggie",      "rm_lucien_room",   { "use_cloth_bandage"                        } }
    ,{ "get_decorative_fragment",     "rm_lucien_room",   { "dlg_lucien_room_maggie"                   } }
    ,{ "see_scare_window_2",          "rm_lucien_room"  }
    ,{ "use_decorative_fragment",     "rm_lucien_room",   { "get_decorative_fragment"                  } }
    ,{ "get_coal",                    "rm_lucien_room",   { "use_decorative_fragment"                  } }
    ,{ "opn_cemetery_3"               }
    ,{ "use_crumpled_paper",          "rm_cemetery_3",    { "opn_cemetery_3", "get_crumpled_paper"     } }
    ,{ "use_coal",                    "rm_cemetery_3",    { "use_crumpled_paper", "get_coal"           } }
    ,{ "get_code",                    "rm_cemetery_3",    { "use_coal"                                 } }
    ,{ "use_code",                    "rm_lucien_room",   { "get_code"                                 } }
    ,{ "win_safe",                    "rm_lucien_room",   { "use_code"                                 } }
    ,{ "opn_in_safe"                  }
    ,{ "win_in_safe",                 "rm_lucien_room",   { "win_safe"                                 } }
    ,{ "use_gothic_pattern",          "rm_cemetery_3",    { "win_in_safe"                              } }
    ,{ "get_pincers",                 "rm_cemetery_3",    { "use_gothic_pattern"                       } }
    ,{ "see_wooden_coffin_ghost",     "rm_cemetery_3"   }
    ,{ "use_pincers",                 "rm_cemetery_3",    { "get_pincers"                              } }
    ,{ "clk_wooden_coffin_cap",       "rm_cemetery_3",    { "use_pincers"                              } }
    ,{ "get_sapling",                 "rm_cemetery_3",    { "clk_wooden_coffin_cap"                    } }
    ,{ "get_stone_1",                 "rm_cemetery_3",    { "clk_wooden_coffin_cap"                    } }
    ,{ "use_sapling",                 "rm_lucien_room",   { "get_sapling"                              } }
    ,{ "get_amulet_part_1",           "rm_lucien_room",   { "use_sapling"                              } }
    ,{ "see_lucien_room_2",           "rm_lucien_room"  }
    ,{ "use_amulet_part_1_ghost",     "rm_lucien_room",   { "get_amulet_part_1"                        } }
    ,{ "win_dark",                    "rm_lucien_room",   { "use_amulet_part_1_ghost"                  } }
    ,{ "opn_weapon_room"              }
    ,{ "get_wool_piece",              "rm_weapon_room",   { "opn_weapon_room"                          } }
    ,{ "use_wool_piece",              "rm_cemetery_3",    { "get_wool_piece"                           } }
    ,{ "get_maggie_sign",             "rm_cemetery_3",    { "use_wool_piece"                           } }
    ,{ "use_maggie_sign",             "rm_cemetery_3",    { "get_maggie_sign"                          } }
    ,{ "clk_maurce_tomb_bag",         "rm_cemetery_3",    { "use_maggie_sign"                          } }
    ,{ "clk_maurce_tomb_trash",       "rm_cemetery_3",    { "clk_maurce_tomb_bag"                      } }
    ,{ "get_tweezers",                "rm_cemetery_3",    { "clk_maurce_tomb_trash"                    } }
    ,{ "use_tweezers",                "rm_cemetery_3",    { "get_tweezers", "clk_wooden_coffin_cap"    } }
    ,{ "get_hillmark_monogram",       "rm_cemetery_3",    { "use_tweezers"                             } }
    ,{ "use_hillmark_monogram",       "rm_lucien_room",   { "get_hillmark_monogram"                    } }
    ,{ "get_can",                     "rm_lucien_room",   { "use_hillmark_monogram"                    } }
    ,{ "get_opener",                  "rm_weapon_room",   { "opn_weapon_room"                          } }
    ,{ "use_opener"                   }
    ,{ "clk_opener"                   }
    ,{ "get_opened_can"               }    
    ,{ "use_opened_can",              "rm_cemetery_3",    { "get_opened_can"                           } }
    ,{ "get_black_cat",               "rm_cemetery_3",    { "use_opened_can"                           } }
    ,{ "use_black_cat_1",             "rm_cemetery_3",    { "get_black_cat"                            } }
    ,{ "get_hunter_horn",             "rm_cemetery_3",    { "use_black_cat_1"                          } }
    ,{ "see_trophy_ghost",            "rm_weapon_room", }
    ,{ "use_hunter_horn",             "rm_weapon_room",   { "get_hunter_horn"                          } }
    ,{ "get_steering_wheel",          "rm_weapon_room",   { "use_hunter_horn"                          } }
    ,{ "get_flag_2",                  "rm_weapon_room",   { "use_hunter_horn"                          } }
    ,{ "use_steering_wheel",          "rm_lucien_room",   { "get_steering_wheel"                       } }
    ,{ "get_golden_key",              "rm_lucien_room",   { "use_steering_wheel"                       } }
    ,{ "use_golden_key",              "rm_lucien_room",   { "get_golden_key"                           } }
    ,{ "get_ship_model",              "rm_lucien_room",   { "use_golden_key"                           } }
    ,{ "use_ship_model",              "rm_weapon_room",   { "get_ship_model"                           } }
    ,{ "get_compass",                 "rm_weapon_room",   { "use_ship_model"                           } }
    ,{ "clk_compass_1"                }
    ,{ "clk_compass_2"                }
    ,{ "get_magnet_lvl3"              }
    ,{ "get_rusty_medallion"          }    
    ,{ "use_rusty_medallion",         "rm_weapon_room",   { "get_rusty_medallion"                      } }
    ,{ "get_hillmark_medallion",      "rm_weapon_room",   { "use_rusty_medallion"                      } }
    ,{ "use_hillmark_medallion",      "rm_weapon_room",   { "get_hillmark_medallion"                   } }
    ,{ "see_fb_conflict",             "rm_weapon_room"  }
    ,{ "get_leather_purse",           "rm_weapon_room",   { "use_hillmark_medallion"                   } }
    ,{ "clk_leather"                  }
    ,{ "get_fire_striker"             }  
    ,{ "clk_leather_papers"           }
    ,{ "get_shopwindow_lock_part"     }  
    ,{ "use_shopwindow_lock_part",    "rm_weapon_room",   { "get_shopwindow_lock_part"                 } }
    ,{ "win_weapons_window",          "rm_weapon_room",   { "use_shopwindow_lock_part"                 } }
    ,{ "opn_weapon"                   }
    ,{ "win_weapon",                  "rm_weapon_room",   { "win_weapons_window"                       } }
    ,{ "use_cannon_ball",             "rm_weapon_room",   { "win_weapon"                               } }
    ,{ "use_fire_striker",            "rm_weapon_room",   { "get_fire_striker", "use_cannon_ball"      } }
    ,{ "see_weapon_room_1",           "rm_weapon_room", }
    ,{ "opn_tower"                    }
    ,{ "see_tower_ghost",             "rm_tower"  }
    ,{ "see_tower_spyglass",          "rm_tower"  }
    ,{ "get_ink_pen",                 "rm_tower",         { "opn_tower"                                } }
    ,{ "use_ink_pen",                 "rm_lucien_room",   { "get_ink_pen"                              } }
    ,{ "get_will",                    "rm_lucien_room",   { "use_ink_pen"                              } }
    ,{ "see_lucien_appearance",       "rm_lucien_room"  }
    ,{ "dlg_lucien_room_lucien_1",    "rm_lucien_room",   { "get_will" ,"see_lucien_appearance"        } }
    ,{ "get_white_ghost_amulet",      "rm_lucien_room",   { "dlg_lucien_room_lucien_1"                 } }
    ,{ "clk_will_1"                   }
    ,{ "clk_will_2"                   }
    ,{ "get_strange_shard"            }
    ,{ "clk_will_3"                   }
    ,{ "clk_will_4"                   }
    ,{ "use_strange_shard",           "rm_tower",         { "get_strange_shard"                        } }
    ,{ "use_hands",                   "rm_tower",         { "use_strange_shard", "get_hands"           } }
    ,{ "get_amulet_part_2",           "rm_tower",         { "use_hands"                                } }
    ,{ "get_oil",                     "rm_tower",         { "use_hands"                                } }
    ,{ "use_oil",                     "rm_tower",         { "get_oil"                                  } }
    ,{ "get_adjustable_wrench",       "rm_tower",         { "use_oil"                                  } }
    ,{ "use_adjustable_wrench",       "rm_weapon_room",   { "get_adjustable_wrench"                    } }
    ,{ "get_stone_2",                 "rm_weapon_room",   { "use_adjustable_wrench"                    } }
    ,{ "use_stone_1",                 "rm_cemetery_3",    { "get_stone_1"                              } }
    ,{ "use_stone_2",                 "rm_cemetery_3",    { "get_stone_2"                              } }
    ,{ "get_fang",                    "rm_cemetery_3",    { "use_stone_1", "use_stone_2"               } }
    ,{ "use_fang",                    "rm_weapon_room",   { "get_fang"                                 } }
    ,{ "get_flag_3",                  "rm_weapon_room",   { "use_fang"                                 } }
    ,{ "use_flag_1",                  "rm_lucien_room",   { "get_flag_1"                               } }
    ,{ "use_flag_2",                  "rm_lucien_room",   { "get_flag_2"                               } }
    ,{ "use_flag_3",                  "rm_lucien_room",   { "get_flag_3"                               } }
    ,{ "win_coffee_table",            "rm_lucien_room",   { "use_flag_1", "use_flag_2", "use_flag_3"   } }
    ,{ "opn_lucien_table"             }
    ,{ "win_lucien_table",            "rm_lucien_room",   { "win_coffee_table"                         } }   
    ,{ "use_clock_part",              "rm_tower",         { "win_lucien_table"                         } }
    ,{ "win_clock",                   "rm_tower",         { "use_clock_part"                           } }
    ,{ "see_tower_hatch_openes",      "rm_tower"        }
    ,{ "opn_barber_room"              }
    ,{ "get_lucien_signet",           "rm_barber_room",   { "opn_barber_room"                          } }
    ,{ "use_lucien_signet",           "rm_lucien_room",   { "get_lucien_signet"                        } }
    ,{ "get_barber_key",              "rm_lucien_room",   { "use_lucien_signet"                        } }
    ,{ "get_amulet_part_3",           "rm_lucien_room",   { "use_lucien_signet"                        } }
    ,{ "see_gauges_ghost",            "rm_barber_room"  }
    ,{ "get_glass_cutter_base",       "rm_barber_room",   { "opn_barber_room"                          } }
    ,{ "use_barber_key",              "rm_barber_room",   { "get_barber_key"                           } }
    ,{ "clk_garbage_gauges",          "rm_barber_room",   { "use_barber_key"                           } }
    ,{ "get_cross",                   "rm_barber_room",   { "clk_garbage_gauges"                       } }
    ,{ "use_cross",                   "rm_cemetery_3",    { "get_cross"                                } }
    ,{ "get_bone",                    "rm_cemetery_3",    { "use_cross"                                } }
    ,{ "use_bone",                    "rm_tower",         { "get_bone"                                 } }
    ,{ "use_black_cat_2",             "rm_tower",         { "get_black_cat", "use_bone"                } }
    ,{ "get_feathers",                "rm_tower",         { "use_black_cat_2"                          } }
    ,{ "use_feathers",                "rm_weapon_room",   { "get_feathers"                             } }
    ,{ "get_amulet_part_4",           "rm_weapon_room",   { "use_feathers"                             } }
    ,{ "get_bottle",                  "rm_weapon_room",   { "use_feathers"                             } }
    ,{ "use_bottle",                  "rm_barber_room",   { "get_bottle"                               } }
    ,{ "get_release_tool",            "rm_barber_room",   { "use_bottle"                               } }
    ,{ "use_release_tool",            "rm_weapon_room",   { "get_release_tool"                         } }
    ,{ "get_ring_lvl3",               "rm_weapon_room",   { "use_release_tool"                         } }
    ,{ "clk_ring_lvl3",               "rm_tower",         { "opn_tower"                                } }
    ,{ "use_ring_lvl3",               "rm_tower",         { "get_ring_lvl3", "clk_ring_lvl3"           } }
    ,{ "get_eyepiece",                "rm_tower",         { "use_ring_lvl3"                            } }
    ,{ "use_eyepiece",                "rm_barber_room",   { "get_eyepiece"                             } }
    ,{ "win_gauges2",                 "rm_barber_room",   { "use_eyepiece"                             } }
    ,{ "get_bas_relief",              "rm_barber_room",   { "win_gauges2"                              } }
    ,{ "use_magnet_lvl3",             "rm_weapon_room",   { "get_magnet_lvl3"                          } }
    ,{ "get_amulet_part_5",           "rm_weapon_room",   { "use_magnet_lvl3"                          } }  
    ,{ "use_bas_relief",              "rm_lucien_room",   { "get_bas_relief"                           } }
    ,{ "win_window",                  "rm_lucien_room",   { "use_bas_relief"                           } }
    ,{ "get_diamond_lvl3",            "rm_lucien_room",   { "win_window"                               } }
    ,{ "use_diamond_lvl3"             }
    ,{ "get_glass_cutter"             }    
    ,{ "use_glass_cutter",            "rm_barber_room",   { "get_glass_cutter"                         } }
    ,{ "get_amulet_part_6",           "rm_barber_room",   { "use_glass_cutter"                         } }
    ,{ "get_sword_hilt",              "rm_barber_room",   { "use_glass_cutter"                         } }
    ,{ "use_sword_hilt",              "rm_weapon_room",   { "get_sword_hilt"                           } }
    ,{ "clk_knight",                  "rm_weapon_room",   { "use_sword_hilt"                           } }
    ,{ "see_weapon_room_knight",      "rm_weapon_room"  }
    ,{ "opn_knight_arrmor"            }
    ,{ "win_knight_arrmor",           "rm_weapon_room",   { "clk_knight"                               } }
    ,{ "use_sword",                   "rm_barber_room",   { "win_knight_arrmor"                        } }
    ,{ "get_rope_lvl3",               "rm_barber_room",   { "use_sword"                                } }
    ,{ "use_rope_lvl3",               "rm_tower",         { "get_rope_lvl3"                            } }
    ,{ "opn_brook"                    }
    ,{ "see_brook_clark",             "rm_brook"        }
    ,{ "dlg_brook_maurice_1",         "rm_brook",         { "opn_brook"                                } }
    ,{ "use_amulet_part_1"            }
    ,{ "use_amulet_part_2"            }
    ,{ "use_amulet_part_3"            }
    ,{ "use_amulet_part_4"            }
    ,{ "use_amulet_part_5"            }
    ,{ "use_amulet_part_6"            }
    ,{ "get_white_ghost_amulet_full"  }    
    ,{ "use_white_ghost_amulet_full", "rm_brook",         { "get_white_ghost_amulet_full"              } }
    ,{ "win_boss_fight",              "rm_brook",         { "use_white_ghost_amulet_full"              } }
    ,{ "see_outro_3",                 "rm_brook"       }

    ,{ "get_collect_morph_item_13"    } --"rm_cemetery3"
    ,{ "get_collect_morph_item_14"    } --"rm_lucien_room"
    ,{ "get_collect_morph_item_15"    } --"rm_tower"
    ,{ "get_collect_morph_item_16"    } --"rm_brook"
    ,{ "get_collect_morph_item_17"    } --"rm_weapon_room"
  };
  
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
    
  game.relations = {};
  private.menu_moduls = { "rm_credits"};

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = { "rm_collectibles2",
                             "rm_collectibles",
                             "rm_achievements"
                           };

    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;  

end;

function private.TutorialSetParams ()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;
  
  end;
                                                                          
end;
  