-- name=level3_inv
--*********************************************************************************************************************
function public.Init ()


  
    private.init_torn_shirt();
    private.init_can();
    private.init_leather_purse();
    private.init_compass();
    private.init_will();
    private.init_glass_cutter_base();
    private.init_white_ghost_amulet();
    
    ObjAnimate( "spr_white_ghost_amulet_full_glow", "alp", 1, 0, "", { 0, 0, 1,    0.3, 0, 0,   0.6, 0, 1 } );
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level3_inv_deploy = function ()

    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    common_impl.TurnChildGfx( { "level3_inv_deploy" } , "level3_inv_deploy", res_sparkle_area );

  end;
  cmn.AddSubscriber( "update_game_mode_level3_inv_deploy", update_game_mode_level3_inv_deploy, nil );
  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level3_inv_hub");
    port.VideoResizeInRoom("level3_inv");
  end;
end;
--*********************************************************************************************************************
function private.StringDivide ( string )  

  local table = { };
  local id = 1;
  local il = 1;

  for i = 1, string.len( string ) do

    if ( string.sub( string, i, i ) == "_" ) then

      table[ id ] = string.sub( string, il, i - 1 );
      il = i + 1;
      id = id + 1;

    end

    if ( i == string.len( string ) ) then

      table[id] = string.sub( string, il, i );
      il = i + 1;
      id = id + 1;

    end

  end

  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck ( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[4];  
  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;

--*********************************************************************************************************************
-- function *** torn_shirt *** () end;
--*********************************************************************************************************************
  function private.init_torn_shirt()
    
    ObjMultiSet( { 
      { "spr_deploy_inv_torn_shirt_cloth_bandage",    { event_mdown = private.get_cloth_bandage } },

      { "obj_deploy_inv_torn_shirt_clk_torn_shirt_1", { event_mdown = private.clk_torn_shirt_1  } },
      { "obj_deploy_inv_torn_shirt_clk_torn_shirt_2", { event_mdown = private.clk_torn_shirt_2  } },
    } );

    --------------------------------------------------------------------------------------------
    -- function clk_torn_shirt_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_torn_shirt_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_torn_shirt_clk_torn_shirt_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_torn_shirt",
        zz_gate = "inv_torn_shirt"
      };
      
      local clk_torn_shirt_1_beg = function ()

        ObjDelete( "obj_deploy_inv_torn_shirt_clk_torn_shirt_1" );
      
      end;
      local clk_torn_shirt_1_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_torn_shirt_clk_torn_shirt_2", { input = true, active = true, visible = true } },
          { "spr_deploy_inv_torn_shirt_cloth_2",          {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_torn_shirt_cloth_1" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_torn_shirt_1",     clk_torn_shirt_1_beg                   );
      cmn.AddSubscriber( "clk_torn_shirt_1",     clk_torn_shirt_1_end, "inv_torn_shirt" );
      cmn.AddSubscriber( "clk_torn_shirt_1_beg", clk_torn_shirt_1_beg                   );
      cmn.AddSubscriber( "clk_torn_shirt_1_end", clk_torn_shirt_1_end, "inv_torn_shirt" );

    --------------------------------------------------------------------------------------------
    -- function clk_torn_shirt_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_torn_shirt_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_torn_shirt_clk_torn_shirt_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_torn_shirt",
        zz_gate = "inv_torn_shirt"
      };
      
      local clk_torn_shirt_2_beg = function ()

        ObjDelete( "obj_deploy_inv_torn_shirt_clk_torn_shirt_2" );
      
      end;
      local clk_torn_shirt_2_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_torn_shirt_cloth_bandage", { alp = 1, input = true } },
          { "gfx_deploy_inv_torn_shirt_cloth_bandage", {         active = true } },
        } );
        ObjDelete( "obj_deploy_inv_torn_shirt_cloth" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_torn_shirt_2",     clk_torn_shirt_2_beg                   );
      cmn.AddSubscriber( "clk_torn_shirt_2",     clk_torn_shirt_2_end, "inv_torn_shirt" );
      cmn.AddSubscriber( "clk_torn_shirt_2_beg", clk_torn_shirt_2_beg                   );
      cmn.AddSubscriber( "clk_torn_shirt_2_end", clk_torn_shirt_2_end, "inv_torn_shirt" );

    --------------------------------------------------------------------------------------------
    -- function get_cloth_bandage () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_cloth_bandage" ] = {
      type = "get",
      get_obj = "spr_deploy_inv_torn_shirt_cloth_bandage",
      room = "int_deploy_inv",
      zz = "deploy_inv_torn_shirt",
      zz_gate = "inv_torn_shirt"
    };
    
    local get_cloth_bandage_inv = function ()
    
      interface.InventoryItemAdd( "inv_cloth_bandage", "spr_deploy_inv_torn_shirt_cloth_bandage" );
      interface.InventoryItemRemove( "inv_torn_shirt" ); 
    
    end;
    
    local get_cloth_bandage_closezz = function ()
    
      ObjDelete( "gfx_deploy_inv_torn_shirt_cloth_bandage" );
    
    end;
    
    cmn.AddSubscriber( "get_cloth_bandage", get_cloth_bandage_inv );
    cmn.AddSubscriber( "get_cloth_bandage", get_cloth_bandage_closezz, "inv_torn_shirt" );

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_torn_shirt_1 ()
    
    cmn.CallEventHandler( "clk_torn_shirt_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_torn_shirt_1" );
      cmn.CallEventHandler( "clk_torn_shirt_1_end", "inv_torn_shirt" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_tear_cloth", 0, "", 0 );

    --ObjAnimate( "spr_deploy_inv_torn_shirt_cloth_1", "alp", 0, 0, func_end, {
    --  0.0, 0, ObjGet( "spr_deploy_inv_torn_shirt_cloth_1" ).alp,
    --  0.3, 0, 0,
    --} );
    --ObjAnimate( "spr_deploy_inv_torn_shirt_cloth_2", "alp", 0, 0, "", { 
    --  0.0, 0, ObjGet( "spr_deploy_inv_torn_shirt_cloth_2" ).alp,  
    --  0.3, 0, 1,
    --} );

    func_end();

  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_torn_shirt_2 ()
    
    cmn.CallEventHandler( "clk_torn_shirt_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_torn_shirt_2" );
      cmn.CallEventHandler( "clk_torn_shirt_2_end", "inv_torn_shirt" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_tear_cloth2", 0, "", 0 );

    --ObjAnimate( "obj_deploy_inv_torn_shirt_cloth", "alp", 0, 0, func_end, {
    --  0.0, 0, ObjGet( "obj_deploy_inv_torn_shirt_cloth" ).alp,
    --  0.3, 0, 0,
    --} );
    --ObjAnimate( "spr_deploy_inv_torn_shirt_cloth_bandage", "alp", 0, 0, "", { 
    --  0.0, 0, ObjGet( "spr_deploy_inv_torn_shirt_cloth_bandage" ).alp,  
    --  0.3, 0, 1,
    --} );

    func_end();

  end; 

  -- GET ------------------------------------------------------------------------------------------
  function private.get_cloth_bandage()
  
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
    cmn.SetEventDone( "get_cloth_bandage" );
    cmn.CallEventHandler( "get_cloth_bandage", "inv_torn_shirt" );
    
    common_impl.HideDeployInv();
  
  end;
  
--*********************************************************************************************************************
-- function *** can *** () end;
--*********************************************************************************************************************
  function private.init_can()
    
    ObjMultiSet( { 
      { "spr_deploy_inv_can_opened_can", { event_mdown = private.get_opened_can } },

      { "obj_deploy_inv_can_clk_opener", { event_mdown = private.clk_opener     } },
    } );
    --------------------------------------------------------------------------------------------
    -- function get_opened_can () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_opened_can" ] = {
      type = "get",
      get_obj = "spr_deploy_inv_can_opened_can",
      room = "int_deploy_inv",
      zz = "deploy_inv_can",
      zz_gate = "inv_can"
    };
    
    local get_opened_can_inv = function ()
    
      interface.InventoryItemAdd( "inv_opened_can", "spr_deploy_inv_can_opened_can" );
      interface.InventoryItemRemove( "inv_can" ); 
      
    end;
    
    local get_opened_can_closezz = function ()
    
      ObjDelete( "gfx_deploy_inv_can_opened_can" );
    
    end;
    
    cmn.AddSubscriber( "get_opened_can", get_opened_can_inv                );
    cmn.AddSubscriber( "get_opened_can", get_opened_can_closezz, "inv_can" );

    --------------------------------------------------------------------------------------------
    -- function use_opener () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_opener" ] = {
      type = "use",
      inv_obj = "inv_opener",
      use_place = "obj_deploy_inv_can_use_opener",
      room = "int_deploy_inv",
      zz = "deploy_inv_can",
      zz_gate = "inv_can"
    };
    
    local use_opener_beg = function ()
    
      interface.InventoryItemRemove( "inv_opener" );
      ObjDelete( "obj_deploy_inv_can_use_opener" );
    
    end;
    local use_opener_end = function ()
    
      ObjMultiSet( { 
        { "obj_deploy_inv_can_clk_opener", { visible = true, input = true, active = true } },
        { "anm_deploy_inv_can_pieces",     {     alp = 1                                 } },
      } );
      ObjDelete( "anm_deploy_inv_can_opener" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_opener",     use_opener_beg            );
    cmn.AddSubscriber( "use_opener",     use_opener_end, "inv_can" );
    cmn.AddSubscriber( "use_opener_beg", use_opener_beg            );
    cmn.AddSubscriber( "use_opener_end", use_opener_end, "inv_can" );

    --------------------------------------------------------------------------------------------
    -- function clk_opener () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_opener" ] = {
        type = "click",
        use_place = "obj_deploy_inv_can_clk_opener",
        room = "int_deploy_inv",
        zz = "deploy_inv_can",
        zz_gate = "inv_can"
      };
      
      local clk_opener_beg = function ()

        ObjDelete( "obj_deploy_inv_can_clk_opener" );
      
      end;
      local clk_opener_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_can_opened_can", { alp = 1, input = true } },
          { "gfx_deploy_inv_can_opened_can", {         active = true } },
        } );
        ObjDelete( "anm_deploy_inv_can_pieces" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_opener",     clk_opener_beg            );
      cmn.AddSubscriber( "clk_opener",     clk_opener_end, "inv_can" );
      cmn.AddSubscriber( "clk_opener_beg", clk_opener_beg            );
      cmn.AddSubscriber( "clk_opener_end", clk_opener_end, "inv_can" );

  end;

  -- USE ------------------------------------------------------------------------------------------
  function public.use_opener()
  
    local item = "inv_opener";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_can_use_opener" ) ) then
  
      cmn.CallEventHandler( "use_opener_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_opener" );
        cmn.CallEventHandler( "use_opener_end", "inv_can" );
      
      end;
  
      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level3/sfx/aud_use_canopener" );

      AnimPlay( "anm_deploy_inv_can_opener", "can_opener", func_end );

      return true;
  
    end;
  
    return false;
    
  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_opener ()
    
    cmn.CallEventHandler( "clk_opener_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_opener" );
      cmn.CallEventHandler( "clk_opener_end", "inv_can" ); 

      private.get_opened_can();

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_can", 0, "", 0 );

    AnimPlay( "anm_deploy_inv_can_pieces", "can_pieces", func_end );

  end; 

  -- GET ------------------------------------------------------------------------------------------
  function private.get_opened_can()
  
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
    cmn.SetEventDone( "get_opened_can" );
    cmn.CallEventHandler( "get_opened_can", "inv_can" );
    
    common_impl.HideDeployInv();
  
  end;

--*********************************************************************************************************************
-- function *** leather_purse *** () end;
--*********************************************************************************************************************
  function private.init_leather_purse()
    
    ObjMultiSet( { 
      { "spr_deploy_inv_leather_purse_shopwindow_lock_part", { event_mdown = private.get_shopwindow_lock_part } },
      { "spr_deploy_inv_leather_purse_fire_striker",         { event_mdown = private.get_fire_striker         } },

      { "obj_deploy_inv_leather_clk_leather",                { event_mdown = private.clk_leather              } },
      { "obj_deploy_inv_leather_clk_leather_papers",         { event_mdown = private.clk_leather_papers       } },
    } );

    --------------------------------------------------------------------------------------------
    -- function clk_leather () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_leather" ] = {
        type = "click",
        use_place = "obj_deploy_inv_leather_clk_leather",
        room = "int_deploy_inv",
        zz = "deploy_inv_leather_purse",
        zz_gate = "inv_leather_purse"
      };

      local clk_leather_beg = function ()

        ObjDelete( "obj_deploy_inv_leather_clk_leather" );
      
      end;
      local clk_leather_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_leather_purse_fire_striker",         {  input = true } },
          { "gfx_deploy_inv_leather_purse_fire_striker",         { active = true } },
          { "spr_deploy_inv_leather_bag_open",                   {    alp = 1    } },
        } );
        ObjDelete( "spr_deploy_inv_leather_bag_close" );      

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_leather",     clk_leather_beg                      );
      cmn.AddSubscriber( "clk_leather",     clk_leather_end, "inv_leather_purse" );
      cmn.AddSubscriber( "clk_leather_beg", clk_leather_beg                      );
      cmn.AddSubscriber( "clk_leather_end", clk_leather_end, "inv_leather_purse" );
  
    --------------------------------------------------------------------------------------------
    -- function clk_leather_papers () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_leather_papers" ] = {
        type = "click",
        use_place = "obj_deploy_inv_leather_clk_leather_papers",
        room = "int_deploy_inv",
        zz = "deploy_inv_leather_purse",
        zz_gate = "inv_leather_purse"
      };

      local clk_leather_papers_beg = function ()

        ObjDelete( "obj_deploy_inv_leather_clk_leather_papers" );
      
      end;
      local clk_leather_papers_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_leather_purse_shopwindow_lock_part", {  input = true } },
          { "gfx_deploy_inv_leather_purse_shopwindow_lock_part", { active = true } },

          { "spr_deploy_inv_leather_papper3", { pos_x = -57, pos_y = -17 } },
          { "spr_deploy_inv_leather_papper2", { pos_x = -34, pos_y = 24  } },
          { "spr_deploy_inv_leather_papper1", { pos_x = 9,   pos_y = 17  } },
        } );
        ObjDelete( "spr_deploy_inv_leather_bag_close" );      

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_leather_papers",     clk_leather_papers_beg                      );
      cmn.AddSubscriber( "clk_leather_papers",     clk_leather_papers_end, "inv_leather_purse" );
      cmn.AddSubscriber( "clk_leather_papers_beg", clk_leather_papers_beg                      );
      cmn.AddSubscriber( "clk_leather_papers_end", clk_leather_papers_end, "inv_leather_purse" );
    
    --------------------------------------------------------------------------------------------
    -- function get_shopwindow_lock_part () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_shopwindow_lock_part" ] = {
      type = "get",
      get_obj = "spr_deploy_inv_leather_purse_shopwindow_lock_part",
      room = "int_deploy_inv",
      zz = "deploy_inv_leather_purse",
      zz_gate = "inv_leather_purse"
    };
    
    local get_shopwindow_lock_part_inv = function ()
    
      interface.InventoryItemAdd( "inv_shopwindow_lock_part", "spr_deploy_inv_leather_purse_shopwindow_lock_part" ); 
      interface.InventoryItemRemove( "inv_leather_purse" );
      
    end;
    
    local get_shopwindow_lock_part_closezz = function ()
    
      ObjDelete( "gfx_deploy_inv_leather_purse_shopwindow_lock_part" );
    
    end;
    
    cmn.AddSubscriber( "get_shopwindow_lock_part", get_shopwindow_lock_part_inv );
    cmn.AddSubscriber( "get_shopwindow_lock_part", get_shopwindow_lock_part_closezz, "inv_leather_purse" );

    --------------------------------------------------------------------------------------------
    -- function get_fire_striker () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_fire_striker" ] = {
      type = "get",
      get_obj = "spr_deploy_inv_leather_purse_fire_striker",
      room = "int_deploy_inv",
      zz = "deploy_inv_leather_purse",
      zz_gate = "inv_leather_purse"
    };
    
    local get_fire_striker_inv = function ()
    
      interface.InventoryItemAdd( "inv_fire_striker", "spr_deploy_inv_leather_purse_fire_striker" );
      
    end;
    
    local get_fire_striker_closezz = function ()
    
      ObjDelete( "gfx_deploy_inv_leather_purse_fire_striker" );

      ObjMultiSet( { 
        { "obj_deploy_inv_leather_clk_leather_papers", { input = true, active = true, visible = true } },
      } );

    end;
    
    cmn.AddSubscriber( "get_fire_striker", get_fire_striker_inv );
    cmn.AddSubscriber( "get_fire_striker", get_fire_striker_closezz, "inv_leather_purse" );

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_leather ()
    
    cmn.CallEventHandler( "clk_leather_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_leather" );
      cmn.CallEventHandler( "clk_leather_end", "inv_leather_purse" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_opn_wallet", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_leather_bag_close", "alp", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_leather_bag_close" ).alp,
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_deploy_inv_leather_bag_open", "alp", 0, 0, "", { 
      0.0, 0, ObjGet( "spr_deploy_inv_leather_bag_open" ).alp,  
      0.3, 0, 1,
    } );

  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_leather_papers ()
    
    cmn.CallEventHandler( "clk_leather_papers_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_leather_papers" );
      cmn.CallEventHandler( "clk_leather_papers_end", "inv_leather_purse" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_wallet3", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_leather_papper1", "pos_xy", 0, 0, "", {
      0.0, 0, ObjGet( "spr_deploy_inv_leather_papper1" ).pos_x, ObjGet( "spr_deploy_inv_leather_papper1" ).pos_y,
      0.3, 0, 9, 17,
    } );
    ObjAnimate( "spr_deploy_inv_leather_papper2", "pos_xy", 0, 0, "", {
      0.0, 0, ObjGet( "spr_deploy_inv_leather_papper2" ).pos_x, ObjGet( "spr_deploy_inv_leather_papper2" ).pos_y,
      0.5, 0, -34, 24,
    } );
    ObjAnimate( "spr_deploy_inv_leather_papper3", "pos_xy", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_leather_papper3" ).pos_x, ObjGet( "spr_deploy_inv_leather_papper3" ).pos_y,
      0.7, 0, -57, -17,
    } );

  end; 

  -- GET ------------------------------------------------------------------------------------------
  function private.get_shopwindow_lock_part()
  
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
    cmn.SetEventDone( "get_shopwindow_lock_part" );
    cmn.CallEventHandler( "get_shopwindow_lock_part", "inv_leather_purse" );
    
    common_impl.HideDeployInv();
    
  end;
  -- GET ------------------------------------------------------------------------------------------
  function private.get_fire_striker()
  
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
    cmn.SetEventDone( "get_fire_striker" );
    cmn.CallEventHandler( "get_fire_striker", "inv_leather_purse" );
  
  end;

--*********************************************************************************************************************
-- function *** compass *** () end;
--*********************************************************************************************************************
  function private.init_compass()

    ObjMultiSet( { 
      { "spr_deploy_inv_compass_magnet",           { event_mdown = private.get_magnet_lvl3     } },
      { "spr_deploy_inv_compass_rusty_medallion",  { event_mdown = private.get_rusty_medallion } },

      { "obj_deploy_inv_compass_clk_compass_1",    { event_mdown = private.clk_compass_1       } },
      { "obj_deploy_inv_compass_clk_compass_2",    { event_mdown = private.clk_compass_2       } },
    } );
    
    --------------------------------------------------------------------------------------------
    -- function clk_compass_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_compass_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_compass_clk_compass_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_compass",
        zz_gate = "inv_compass"
      };
      
      local clk_compass_1_beg = function ()

        ObjDelete( "obj_deploy_inv_compass_clk_compass_1" );
      
      end;
      local clk_compass_1_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_compass_clk_compass_2", { input = true, active = true, visible = true } },
          { "spr_deploy_inv_compass_compas_back",   {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_compass_compas_front" );      

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_compass_1",     clk_compass_1_beg                );
      cmn.AddSubscriber( "clk_compass_1",     clk_compass_1_end, "inv_compass" );
      cmn.AddSubscriber( "clk_compass_1_beg", clk_compass_1_beg                );
      cmn.AddSubscriber( "clk_compass_1_end", clk_compass_1_end, "inv_compass" );

    --------------------------------------------------------------------------------------------
    -- function clk_compass_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_compass_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_compass_clk_compass_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_compass",
        zz_gate = "inv_compass"
      };
      
      local clk_compass_2_beg = function ()

        ObjDelete( "obj_deploy_inv_compass_clk_compass_2" );
      
      end;
      local clk_compass_2_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_compass_compas_back_inside", {    alp = 1    } },
          { "spr_deploy_inv_compass_rusty_medallion",    {  input = true } },
          { "gfx_deploy_inv_compass_rusty_medallion",    { active = true } },
          { "spr_deploy_inv_compass_magnet",             {  input = true } },
          { "gfx_deploy_inv_compass_magnet",             { active = true } },
        } );   

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_compass_2",     clk_compass_2_beg                );
      cmn.AddSubscriber( "clk_compass_2",     clk_compass_2_end, "inv_compass" );
      cmn.AddSubscriber( "clk_compass_2_beg", clk_compass_2_beg                );
      cmn.AddSubscriber( "clk_compass_2_end", clk_compass_2_end, "inv_compass" );

    --------------------------------------------------------------------------------------------
    -- function get_magnet_lvl3 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_magnet_lvl3" ] = {
      type = "get",
      get_obj = "spr_deploy_inv_compass_magnet",
      room = "int_deploy_inv",
      zz = "deploy_inv_compass",
      zz_gate = "inv_compass"
    };
    
    local get_magnet_lvl3_inv = function ()
    
      interface.InventoryItemAdd( "inv_magnet_lvl3", "spr_deploy_inv_compass_magnet" );
      
      if ( cmn.IsEventDone( "get_rusty_medallion" ) ) then
        interface.InventoryItemRemove( "inv_compass" ); 
      end;
    
    end;
    
    local get_magnet_lvl3_closezz = function ()
    
      ObjDelete( "gfx_deploy_inv_compass_magnet" );
    
    end;
    
    cmn.AddSubscriber( "get_magnet_lvl3", get_magnet_lvl3_inv );
    cmn.AddSubscriber( "get_magnet_lvl3", get_magnet_lvl3_closezz, "inv_compass" );
    
    --------------------------------------------------------------------------------------------
    -- function get_rusty_medallion () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_rusty_medallion" ] = {
      type = "get",
      get_obj = "spr_deploy_inv_compass_rusty_medallion",
      room = "int_deploy_inv",
      zz = "deploy_inv_compass",
      zz_gate = "inv_compass"
    };
    
    local get_rusty_medallion_inv = function ()
    
      interface.InventoryItemAdd( "inv_rusty_medallion", "spr_deploy_inv_compass_rusty_medallion" );
      
      if ( cmn.IsEventDone( "get_magnet_lvl3" ) ) then
        interface.InventoryItemRemove( "inv_compass" );        
      end;
      
    end;
    
    local get_rusty_medallion_closezz = function ()
    
      ObjDelete( "gfx_deploy_inv_compass_rusty_medallion" );
    
    end;
    
    cmn.AddSubscriber( "get_rusty_medallion", get_rusty_medallion_inv );
    cmn.AddSubscriber( "get_rusty_medallion", get_rusty_medallion_closezz, "inv_compass" );

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_compass_1 ()
    
    cmn.CallEventHandler( "clk_compass_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_compass_1" );
      cmn.CallEventHandler( "clk_compass_1_end", "inv_compass" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_compas", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_compass_compas_front", "alp", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_compass_compas_front" ).alp,
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_deploy_inv_compass_compas_back", "alp", 0, 0, "", { 
      0.0, 0, ObjGet( "spr_deploy_inv_compass_compas_back" ).alp,  
      0.3, 0, 1,
    } );

  end; 
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_compass_2 ()
    
    cmn.CallEventHandler( "clk_compass_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_compass_2" );
      cmn.CallEventHandler( "clk_compass_2_end", "inv_compass" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_compas2", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_compass_compas_back_inside", "alp", 0, 0, func_end, { 
      0.0, 0, ObjGet( "spr_deploy_inv_compass_compas_back_inside" ).alp,  
      0.3, 0, 1,
    } );

  end;

  --------------------------------------------------------------------------------------------
  function private.get_magnet_lvl3()
  
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
    cmn.SetEventDone( "get_magnet_lvl3" );
    cmn.CallEventHandler( "get_magnet_lvl3", "inv_compass" );
    
    if ( cmn.IsEventDone( "get_rusty_medallion" ) ) then
      common_impl.HideDeployInv();      
    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.get_rusty_medallion()
  
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
    cmn.SetEventDone( "get_rusty_medallion" );
    cmn.CallEventHandler( "get_rusty_medallion", "inv_compass" );
    
    if ( cmn.IsEventDone( "get_magnet_lvl3" ) ) then
      common_impl.HideDeployInv();      
    end;    
  
  end;

--*********************************************************************************************************************
-- function *** will *** () end;
--*********************************************************************************************************************
  function private.init_will()
    
    ObjMultiSet( { 
      { "spr_deploy_inv_will_strange_shard", { event_mdown = private.get_strange_shard } },

      { "obj_deploy_inv_will_clk_will_1",    { event_mdown = private.clk_will_1        } },
      { "obj_deploy_inv_will_clk_will_2",    { event_mdown = private.clk_will_2        } },
      { "obj_deploy_inv_will_clk_will_3",    { event_mdown = private.clk_will_3        } },
      { "obj_deploy_inv_will_clk_will_4",    { event_mdown = private.clk_will_4        } },
    } );

    --------------------------------------------------------------------------------------------
    -- function clk_will_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_will_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_will_clk_will_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_will",
        zz_gate = "inv_will"
      };
      
      local clk_will_1_beg = function ()

        ObjDelete( "obj_deploy_inv_will_clk_will_1" );
      
      end;
      local clk_will_1_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_will_clk_will_2",    { input = true, active = true, visible = true } },
          { "obj_deploy_inv_will_envelope_open", {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_will_envelope" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_will_1",     clk_will_1_beg             );
      cmn.AddSubscriber( "clk_will_1",     clk_will_1_end, "inv_will" );
      cmn.AddSubscriber( "clk_will_1_beg", clk_will_1_beg             );
      cmn.AddSubscriber( "clk_will_1_end", clk_will_1_end, "inv_will" );

    --------------------------------------------------------------------------------------------
    -- function clk_will_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_will_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_will_clk_will_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_will",
        zz_gate = "inv_will"
      };
      
      local clk_will_2_beg = function ()

        ObjDelete( "obj_deploy_inv_will_clk_will_2" );
      
      end;
      local clk_will_2_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_will_strange_shard", {  input = true, pos_x = -9,  pos_y = -121 } },
          { "gfx_deploy_inv_will_strange_shard", { active = true                            } },
          { "spr_deploy_inv_will_letter_2",      {    ang = 0,    pos_x = -17, pos_y = -162 } }
        } );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_will_2",     clk_will_2_beg             );
      cmn.AddSubscriber( "clk_will_2",     clk_will_2_end, "inv_will" );
      cmn.AddSubscriber( "clk_will_2_beg", clk_will_2_beg             );
      cmn.AddSubscriber( "clk_will_2_end", clk_will_2_end, "inv_will" );

    --------------------------------------------------------------------------------------------
    -- function clk_will_3 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_will_3" ] = {
        type = "click",
        use_place = "obj_deploy_inv_will_clk_will_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_will",
        zz_gate = "inv_will"
      };
      
      local clk_will_3_beg = function ()

        ObjDelete( "obj_deploy_inv_will_clk_will_3" );
      
      end;
      local clk_will_3_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_will_clk_will_4", { input = true, active = true, visible = true } },
          { "spr_deploy_inv_will_letter_3",   {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_will_letter_2" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_will_3",     clk_will_3_beg             );
      cmn.AddSubscriber( "clk_will_3",     clk_will_3_end, "inv_will" );
      cmn.AddSubscriber( "clk_will_3_beg", clk_will_3_beg             );
      cmn.AddSubscriber( "clk_will_3_end", clk_will_3_end, "inv_will" );

    --------------------------------------------------------------------------------------------
    -- function clk_will_4 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_will_4" ] = {
        type = "click",
        use_place = "obj_deploy_inv_will_clk_will_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_will",
        zz_gate = "inv_will"
      };

      local clk_will_4_inv = function ()

        interface.InventoryItemRemove( "inv_will" );    --cmn.CallEventHandler( "use_pruners_2_inv" );
      
      end;      
      local clk_will_4_beg = function ()

        ObjDelete( "obj_deploy_inv_will_clk_will_4" );
      
      end;
      local clk_will_4_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_will_letter_4", { alp = 1 } },
        } );
        ObjDelete( "spr_deploy_inv_will_letter_3" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_will_4",     clk_will_4_beg             );
      cmn.AddSubscriber( "clk_will_4",     clk_will_4_end, "inv_will" );
      cmn.AddSubscriber( "clk_will_4",     clk_will_4_inv             );
      cmn.AddSubscriber( "clk_will_4_inv", clk_will_4_inv             );
      cmn.AddSubscriber( "clk_will_4_beg", clk_will_4_beg             );
      cmn.AddSubscriber( "clk_will_4_end", clk_will_4_end, "inv_will" );

    --------------------------------------------------------------------------------------------
    -- function get_strange_shard () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_strange_shard" ] = {
      type = "get",
      get_obj = "spr_deploy_inv_will_strange_shard",
      room = "int_deploy_inv",
      zz = "deploy_inv_will",
      zz_gate = "inv_will"
    };
    
    local get_strange_shard_inv = function ()
    
      interface.InventoryItemAdd( "inv_strange_shard", "spr_deploy_inv_will_strange_shard" );
      --interface.InventoryItemRemove( "inv_will" );
      
    end;
    
    local get_strange_shard_closezz = function ()
    
      ObjMultiSet( { 
        { "obj_deploy_inv_will_clk_will_3", { input = true, active = true, visible = true } },
      } );
      ObjDelete( "gfx_deploy_inv_will_strange_shard" );

    end;
    
    cmn.AddSubscriber( "get_strange_shard", get_strange_shard_inv );
    cmn.AddSubscriber( "get_strange_shard", get_strange_shard_closezz, "inv_will" );

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_will_1 ()
    
    cmn.CallEventHandler( "clk_will_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_will_1" );
      cmn.CallEventHandler( "clk_will_1_end", "inv_will" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper1", 0, "", 0 );

    --ObjAnimate( "spr_deploy_inv_will_envelope", "alp", 0, 0, func_end, {
    --  0.0, 0, ObjGet( "spr_deploy_inv_will_envelope" ).alp,
    --  0.3, 0, 0,
    --} );
    --ObjAnimate( "obj_deploy_inv_will_envelope_open", "alp", 0, 0, "", { 
    --  0.0, 0, ObjGet( "obj_deploy_inv_will_envelope_open" ).alp,  
    --  0.3, 0, 1,
    --} );

    func_end();

  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_will_2 ()
    
    cmn.CallEventHandler( "clk_will_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_will_2" );
      cmn.CallEventHandler( "clk_will_2_end", "inv_will" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper2", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_will_letter_2", "pos_xy", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_will_letter_2" ).pos_x, ObjGet( "spr_deploy_inv_will_letter_2" ).pos_y,
      0.5, 0, -17, -162,
    } );
    ObjAnimate( "spr_deploy_inv_will_letter_2", "ang", 0, 0, "", { 
      0.0, 0, ObjGet( "spr_deploy_inv_will_letter_2" ).ang,  
      0.5, 0, 0,
    } );
    ObjAnimate( "spr_deploy_inv_will_strange_shard", "pos_xy", 0, 0, "", {
      0.0, 0, ObjGet( "spr_deploy_inv_will_strange_shard" ).pos_x, ObjGet( "spr_deploy_inv_will_strange_shard" ).pos_y,
      0.5, 0, -9, -121,
    } );

  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_will_3 ()
    
    cmn.CallEventHandler( "clk_will_3_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_will_3" );
      cmn.CallEventHandler( "clk_will_3_end", "inv_will" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper2", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_will_letter_2", "alp", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_will_letter_2" ).alp,
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_deploy_inv_will_letter_3", "alp", 0, 0, "", { 
      0.0, 0, ObjGet( "spr_deploy_inv_will_letter_3" ).alp,  
      0.3, 0, 1,
    } );

  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_will_4 ()
    
    cmn.CallEventHandler( "clk_will_4_beg" );
    cmn.CallEventHandler( "clk_will_4_inv" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_will_4" );
      cmn.CallEventHandler( "clk_will_4_end", "inv_will" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper2", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_will_letter_3", "alp", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_will_letter_3" ).alp,
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_deploy_inv_will_letter_4", "alp", 0, 0, "", { 
      0.0, 0, ObjGet( "spr_deploy_inv_will_letter_4" ).alp,  
      0.3, 0, 1,
    } );

  end; 

  -- GET ------------------------------------------------------------------------------------------
  function private.get_strange_shard()
  
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
    cmn.SetEventDone( "get_strange_shard" );
    cmn.CallEventHandler( "get_strange_shard", "inv_will" );
    
    --common_impl.HideDeployInv();
  
  end;
  
--*********************************************************************************************************************
-- function *** glass_cutter_base *** () end;
--*********************************************************************************************************************
  function private.init_glass_cutter_base()
    
    ObjMultiSet( { 
      { "obj_deploy_inv_glass_cutter_base_glass_cutter", { event_mdown = private.get_glass_cutter } },
    } );

    --------------------------------------------------------------------------------------------
    -- function get_glass_cutter () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_glass_cutter" ] = {
      type = "get",
      get_obj = "obj_deploy_inv_glass_cutter_base_glass_cutter",
      room = "int_deploy_inv",
      zz = "deploy_inv_glass_cutter_base",
      zz_gate = "inv_glass_cutter_base"
    };
    
    local get_glass_cutter_inv = function ()
    
      interface.InventoryItemAdd( "inv_glass_cutter", "obj_deploy_inv_glass_cutter_base_glass_cutter" );
      interface.InventoryItemRemove( "inv_glass_cutter_base" ); 
    
    end;
    
    local get_glass_cutter_closezz = function ()
    
      ObjDelete( "gfx_deploy_inv_glass_cutter_base_glass_cutter" );
    
    end;
    
    cmn.AddSubscriber( "get_glass_cutter", get_glass_cutter_inv );
    cmn.AddSubscriber( "get_glass_cutter", get_glass_cutter_closezz, "inv_glass_cutter_base" );

    --------------------------------------------------------------------------------------------
    -- function use_diamond_lvl3 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_diamond_lvl3" ] = {
      type = "use",
      inv_obj = "inv_diamond_lvl3",
      use_place = "obj_deploy_inv_glass_cutter_base_use_diamond",
      room = "int_deploy_inv",
      zz = "deploy_inv_glass_cutter_base",
      zz_gate = "inv_glass_cutter_base"
    };
    
    local use_diamond_lvl3_beg = function ()
    
      interface.InventoryItemRemove( "inv_diamond_lvl3" );
      ObjDelete( "obj_deploy_inv_glass_cutter_base_use_diamond" );
    
    end;
    local use_diamond_lvl3_end = function ()
    
      ObjMultiSet( { 
        { "obj_deploy_inv_glass_cutter_base_glass_cutter", {  input = true } },
        { "gfx_deploy_inv_glass_cutter_base_glass_cutter", { active = true } },
        { "spr_deploy_inv_glass_diamond",                  {    alp = 1    } },
      } );
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_diamond_lvl3", use_diamond_lvl3_beg );
    cmn.AddSubscriber( "use_diamond_lvl3", use_diamond_lvl3_end, "inv_glass_cutter_base" );
    cmn.AddSubscriber( "use_diamond_lvl3_beg", use_diamond_lvl3_beg );
    cmn.AddSubscriber( "use_diamond_lvl3_end", use_diamond_lvl3_end, "inv_glass_cutter_base" );

  end;

  -- USE ------------------------------------------------------------------------------------------
  function public.use_diamond_lvl3()
  
    local item = "inv_diamond_lvl3";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_glass_cutter_base_use_diamond", "deploy_inv_glass_cutter_base" ) ) then
  
      cmn.CallEventHandler( "use_diamond_lvl3_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );     
        cmn.SetEventDone( "use_diamond_lvl3" );
        cmn.CallEventHandler( "use_diamond_lvl3_end", "inv_glass_cutter_base" );
        common_impl.PlayAudio( "sfx","level2/sfx/aud_xx_clk_part3" );
      
      end;
  
      cmn.Lock( true );
      cmn.ItemFly( "spr_deploy_inv_glass_diamond", func_end, -2 );
    
      return true;
  
    end;
  
    return false;
    
  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_glass_cutter()
  
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
    cmn.SetEventDone( "get_glass_cutter" );
    cmn.CallEventHandler( "get_glass_cutter", "inv_glass_cutter_base" );
    
    common_impl.HideDeployInv();
  
  end;
  
--*********************************************************************************************************************
-- function *** white_ghost_amulet *** () end;
--*********************************************************************************************************************
  function private.init_white_ghost_amulet()
    
    ObjSet( "obj_deploy_inv_white_ghost_amulet_white_ghost_amulet_full", { event_mdown = private.get_white_ghost_amulet_full } );
    
    --------------------------------------------------------------------------------------------
    function private.AreUseAllPartsGhostAmulet ()
      
      local result = false;
      
      if ( cmn.IsEventDone( "use_amulet_part_1" ) and cmn.IsEventDone( "use_amulet_part_2" ) and 
           cmn.IsEventDone( "use_amulet_part_3" ) and cmn.IsEventDone( "use_amulet_part_4" ) and 
           cmn.IsEventDone( "use_amulet_part_5" ) and cmn.IsEventDone( "use_amulet_part_6" ) 
          ) then
      
        result = true;
        
      end; 
 
      return result;   
      
    end;
    
    --------------------------------------------------------------------------------------------
    -- function get_white_ghost_amulet_full () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_white_ghost_amulet_full" ] = {
      type = "get",
      get_obj = "obj_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",
      room = "int_deploy_inv",
      zz = "deploy_inv_white_ghost_amulet",
      zz_gate = "inv_white_ghost_amulet"
    };
    
    local get_white_ghost_amulet_full_inv = function ()
    
      interface.InventoryItemAdd( "inv_white_ghost_amulet_full", "obj_deploy_inv_white_ghost_amulet_white_ghost_amulet_full" );
      interface.InventoryItemRemove( "inv_white_ghost_amulet" ); 
      
    end;
    
    local get_white_ghost_amulet_full_closezz = function ()
    
      ObjDelete( "gfx_deploy_inv_white_ghost_amulet_white_ghost_amulet_full" );
    
    end;
    
    cmn.AddSubscriber( "get_white_ghost_amulet_full", get_white_ghost_amulet_full_inv );
    cmn.AddSubscriber( "get_white_ghost_amulet_full", get_white_ghost_amulet_full_closezz, "inv_white_ghost_amulet" );

    --------------------------------------------------------------------------------------------
    -- function use_amulet_part_1 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amulet_part_1" ] = {
      type = "use",
      inv_obj = "inv_amulet_part_1",
      use_place = "obj_deploy_inv_white_ghost_amulet_use_amulet_part_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_white_ghost_amulet",
      zz_gate = "inv_white_ghost_amulet"
    };
    
    local use_amulet_part_1_beg = function ()
    
      interface.InventoryItemRemove( "inv_amulet_part_1" );
      ObjDelete( "obj_deploy_inv_white_ghost_amulet_use_amulet_part_1" );
    
    end;
    local use_amulet_part_1_end = function ()
    
      ObjMultiSet( { 
        { "spr_deploy_inv_white_part_1", { alp = 1, pos_x = -67, pos_y = 6 } }, 
        { "spr_white_ghost_amulet_part_1", { alp = 1 } }, 
      } );

      if not (int_inventory.checkItemPart("amulet_part")) then
        cmn.SetInvPlusRGB( "white_ghost_amulet", false );
      end;
      
      if ( private.AreUseAllPartsGhostAmulet() ) then
        ObjMultiSet( { 
          { "obj_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  {  input = true } }, 
          { "gfx_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  { active = true } },
          
        } );
      end;
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amulet_part_1", use_amulet_part_1_beg );
    cmn.AddSubscriber( "use_amulet_part_1", use_amulet_part_1_end, "inv_white_ghost_amulet" );
    cmn.AddSubscriber( "use_amulet_part_1_beg", use_amulet_part_1_beg );
    cmn.AddSubscriber( "use_amulet_part_1_end", use_amulet_part_1_end, "inv_white_ghost_amulet" );
    --------------------------------------------------------------------------------------------
    -- function use_amulet_part_2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amulet_part_2" ] = {
      type = "use",
      inv_obj = "inv_amulet_part_2",
      use_place = "obj_deploy_inv_white_ghost_amulet_use_amulet_part_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_white_ghost_amulet",
      zz_gate = "inv_white_ghost_amulet"
    };
    
    local use_amulet_part_2_beg = function ()
    
      interface.InventoryItemRemove( "inv_amulet_part_2" );
      ObjDelete( "obj_deploy_inv_white_ghost_amulet_use_amulet_part_2" );
    
    end;
    local use_amulet_part_2_end = function ()
    
      ObjMultiSet( { 
        { "spr_deploy_inv_white_part_2", { alp = 1, pos_x = 0, pos_y = 66 } }, 
        { "spr_white_ghost_amulet_part_2", { alp = 1 } },
      } );

      if not (int_inventory.checkItemPart("amulet_part")) then
        cmn.SetInvPlusRGB( "white_ghost_amulet", false );
      end;
      
      if ( private.AreUseAllPartsGhostAmulet() ) then
        ObjMultiSet( { 
          { "obj_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  {  input = true } }, 
          { "gfx_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  { active = true } },
        } );
      end;
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amulet_part_2", use_amulet_part_2_beg );
    cmn.AddSubscriber( "use_amulet_part_2", use_amulet_part_2_end, "inv_white_ghost_amulet" );
    cmn.AddSubscriber( "use_amulet_part_2_beg", use_amulet_part_2_beg );
    cmn.AddSubscriber( "use_amulet_part_2_end", use_amulet_part_2_end, "inv_white_ghost_amulet" );
    --------------------------------------------------------------------------------------------
    -- function use_amulet_part_3 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amulet_part_3" ] = {
      type = "use",
      inv_obj = "inv_amulet_part_3",
      use_place = "obj_deploy_inv_white_ghost_amulet_use_amulet_part_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_white_ghost_amulet",
      zz_gate = "inv_white_ghost_amulet"
    };
    
    local use_amulet_part_3_beg = function ()
    
      interface.InventoryItemRemove( "inv_amulet_part_3" );
      ObjDelete( "obj_deploy_inv_white_ghost_amulet_use_amulet_part_3" );
    
    end;
    local use_amulet_part_3_end = function ()
    
      ObjMultiSet( { 
        { "spr_deploy_inv_white_part_3", { alp = 1, pos_x = 14, pos_y = 1 } }, 
        { "spr_white_ghost_amulet_part_6", { alp = 1 } },
      } );
      
      if not (int_inventory.checkItemPart("amulet_part")) then
        cmn.SetInvPlusRGB( "white_ghost_amulet", false );
      end;

      if ( private.AreUseAllPartsGhostAmulet() ) then
        ObjMultiSet( { 
          { "obj_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  {  input = true } }, 
          { "gfx_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  { active = true } },
        } );
      end;
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amulet_part_3", use_amulet_part_3_beg );
    cmn.AddSubscriber( "use_amulet_part_3", use_amulet_part_3_end, "inv_white_ghost_amulet" );
    cmn.AddSubscriber( "use_amulet_part_3_beg", use_amulet_part_3_beg );
    cmn.AddSubscriber( "use_amulet_part_3_end", use_amulet_part_3_end, "inv_white_ghost_amulet" );
    --------------------------------------------------------------------------------------------
    -- function use_amulet_part_4 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amulet_part_4" ] = {
      type = "use",
      inv_obj = "inv_amulet_part_4",
      use_place = "obj_deploy_inv_white_ghost_amulet_use_amulet_part_4",
      room = "int_deploy_inv",
      zz = "deploy_inv_white_ghost_amulet",
      zz_gate = "inv_white_ghost_amulet"
    };
    
    local use_amulet_part_4_beg = function ()
    
      interface.InventoryItemRemove( "inv_amulet_part_4" );
      ObjDelete( "obj_deploy_inv_white_ghost_amulet_use_amulet_part_4" );
    
    end;
    local use_amulet_part_4_end = function ()
    
      ObjMultiSet( { 
        { "spr_deploy_inv_white_part_4", { alp = 1, pos_x = 66, pos_y = 1 } },
        { "spr_white_ghost_amulet_part_4", { alp = 1 } }, 
      } );
      
      if not (int_inventory.checkItemPart("amulet_part")) then
        cmn.SetInvPlusRGB( "white_ghost_amulet", false );
      end;
      

      if ( private.AreUseAllPartsGhostAmulet() ) then
        ObjMultiSet( { 
          { "obj_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  {  input = true } }, 
          { "gfx_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  { active = true } },
        } );
      end;
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amulet_part_4", use_amulet_part_4_beg );
    cmn.AddSubscriber( "use_amulet_part_4", use_amulet_part_4_end, "inv_white_ghost_amulet" );
    cmn.AddSubscriber( "use_amulet_part_4_beg", use_amulet_part_4_beg );
    cmn.AddSubscriber( "use_amulet_part_4_end", use_amulet_part_4_end, "inv_white_ghost_amulet" );
    --------------------------------------------------------------------------------------------
    -- function use_amulet_part_5 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amulet_part_5" ] = {
      type = "use",
      inv_obj = "inv_amulet_part_5",
      use_place = "obj_deploy_inv_white_ghost_amulet_use_amulet_part_5",
      room = "int_deploy_inv",
      zz = "deploy_inv_white_ghost_amulet",
      zz_gate = "inv_white_ghost_amulet"
    };
    
    local use_amulet_part_5_beg = function ()
    
      interface.InventoryItemRemove( "inv_amulet_part_5" );
      ObjDelete( "obj_deploy_inv_white_ghost_amulet_use_amulet_part_5" );
    
    end;
    local use_amulet_part_5_end = function ()
    
      ObjMultiSet( { 
        { "spr_deploy_inv_white_part_5", { alp = 1, pos_x = 4, pos_y = -63 } }, 
        { "spr_white_ghost_amulet_part_5", { alp = 1 } },
      } );

      if not (int_inventory.checkItemPart("amulet_part")) then
        cmn.SetInvPlusRGB( "white_ghost_amulet", false );
      end;
      
      if ( private.AreUseAllPartsGhostAmulet() ) then
        ObjMultiSet( { 
          { "obj_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  {  input = true } }, 
          { "gfx_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  { active = true } },
        } );
      end;
      
      
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amulet_part_5", use_amulet_part_5_beg );
    cmn.AddSubscriber( "use_amulet_part_5", use_amulet_part_5_end, "inv_white_ghost_amulet" );
    cmn.AddSubscriber( "use_amulet_part_5_beg", use_amulet_part_5_beg );
    cmn.AddSubscriber( "use_amulet_part_5_end", use_amulet_part_5_end, "inv_white_ghost_amulet" );
    --------------------------------------------------------------------------------------------
    -- function use_amulet_part_6 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amulet_part_6" ] = {
      type = "use",
      inv_obj = "inv_amulet_part_6",
      use_place = "obj_deploy_inv_white_ghost_amulet_use_amulet_part_6",
      room = "int_deploy_inv",
      zz = "deploy_inv_white_ghost_amulet",
      zz_gate = "inv_white_ghost_amulet"
    };
    
    local use_amulet_part_6_beg = function ()
    
      interface.InventoryItemRemove( "inv_amulet_part_6" );
      ObjDelete( "obj_deploy_inv_white_ghost_amulet_use_amulet_part_6" );
    
    end;
    local use_amulet_part_6_end = function ()
    
      ObjMultiSet( { 
        { "spr_deploy_inv_white_part_6", { alp = 1, pos_x = -11, pos_y = 1 } }, 
        { "spr_white_ghost_amulet_part_3", { alp = 1 } },
      } );

      if not (int_inventory.checkItemPart("amulet_part")) then
        cmn.SetInvPlusRGB( "white_ghost_amulet", false );
      end;
      
      if ( private.AreUseAllPartsGhostAmulet() ) then
        ObjMultiSet( { 
          { "obj_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  {  input = true } }, 
          { "gfx_deploy_inv_white_ghost_amulet_white_ghost_amulet_full",  { active = true } },
        } );
      end;
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amulet_part_6", use_amulet_part_6_beg );
    cmn.AddSubscriber( "use_amulet_part_6", use_amulet_part_6_end, "inv_white_ghost_amulet" );
    cmn.AddSubscriber( "use_amulet_part_6_beg", use_amulet_part_6_beg );
    cmn.AddSubscriber( "use_amulet_part_6_end", use_amulet_part_6_end, "inv_white_ghost_amulet" );

  end;

  -- USE ------------------------------------------------------------------------------------------
  function public.use_amulet_part_1()
  
    local item = "inv_amulet_part_1";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_white_ghost_amulet_use_amulet_part_1", "deploy_inv_white_ghost_amulet" ) ) then
  
      cmn.CallEventHandler( "use_amulet_part_1_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_amulet_part_1" );
        cmn.CallEventHandler( "use_amulet_part_1_end", "inv_white_ghost_amulet" );
        common_impl.PlayAudio( "sfx","level1/sfx/aud_xx_clk_metal4" );

      end;
  
      cmn.Lock( true );
  
      ObjAnimate( "spr_deploy_inv_white_part_1", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_1" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_white_part_1", "pos_xy", 0, 0, func_end, { 
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_1" ).pos_x, ObjGet( "spr_deploy_inv_white_part_1" ).pos_y, 
        0.6, 0, -67, 6,
      } );
    
      return true;
  
    end;
  
    return false;
    
  end;
  -- USE ------------------------------------------------------------------------------------------
  function public.use_amulet_part_2()
  
    local item = "inv_amulet_part_2";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_white_ghost_amulet_use_amulet_part_2", "deploy_inv_white_ghost_amulet" ) ) then
  
      cmn.CallEventHandler( "use_amulet_part_2_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_amulet_part_2" );
        cmn.CallEventHandler( "use_amulet_part_2_end", "inv_white_ghost_amulet" );
        common_impl.PlayAudio( "sfx","level1/sfx/aud_xx_clk_metal4" );

      end;
  
      cmn.Lock( true );

      ObjAnimate( "spr_deploy_inv_white_part_2", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_2" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_white_part_2", "pos_xy", 0, 0, func_end, { 
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_2" ).pos_x, ObjGet( "spr_deploy_inv_white_part_2" ).pos_y, 
        0.6, 0, 0, 66,
      } );
    
      return true;
  
    end;
  
    return false;
    
  end;
  -- USE ------------------------------------------------------------------------------------------
  function public.use_amulet_part_3()
  
    local item = "inv_amulet_part_3";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_white_ghost_amulet_use_amulet_part_3", "deploy_inv_white_ghost_amulet" ) ) then
  
      cmn.CallEventHandler( "use_amulet_part_3_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_amulet_part_3" );
        cmn.CallEventHandler( "use_amulet_part_3_end", "inv_white_ghost_amulet" );
        common_impl.PlayAudio( "sfx","level1/sfx/aud_xx_clk_metal4" );
      
      end;
  
      cmn.Lock( true );
  
      ObjAnimate( "spr_deploy_inv_white_part_3", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_3" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_white_part_3", "pos_xy", 0, 0, func_end, { 
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_3" ).pos_x, ObjGet( "spr_deploy_inv_white_part_3" ).pos_y, 
        0.6, 0, 14, 1,
      } );
    
      return true;
  
    end;
  
    return false;
    
  end;
  -- USE ------------------------------------------------------------------------------------------
  function public.use_amulet_part_4()
  
    local item = "inv_amulet_part_4";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_white_ghost_amulet_use_amulet_part_4", "deploy_inv_white_ghost_amulet" ) ) then
  
      cmn.CallEventHandler( "use_amulet_part_4_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_amulet_part_4" );
        cmn.CallEventHandler( "use_amulet_part_4_end", "inv_white_ghost_amulet" );
        common_impl.PlayAudio( "sfx","level1/sfx/aud_xx_clk_metal4" );
      
      end;
  
      cmn.Lock( true );
  
      ObjAnimate( "spr_deploy_inv_white_part_4", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_4" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_white_part_4", "pos_xy", 0, 0, func_end, { 
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_4" ).pos_x, ObjGet( "spr_deploy_inv_white_part_4" ).pos_y, 
        0.6, 0, 66, 1,
      } );
    
      return true;
  
    end;
  
    return false;
    
  end;
  -- USE ------------------------------------------------------------------------------------------
  function public.use_amulet_part_5()
  
    local item = "inv_amulet_part_5";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_white_ghost_amulet_use_amulet_part_5", "deploy_inv_white_ghost_amulet" ) ) then
  
      cmn.CallEventHandler( "use_amulet_part_5_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_amulet_part_5" );
        cmn.CallEventHandler( "use_amulet_part_5_end", "inv_white_ghost_amulet" );
        common_impl.PlayAudio( "sfx","level1/sfx/aud_xx_clk_metal4" );
      
      end;
  
      cmn.Lock( true );
  
      ObjAnimate( "spr_deploy_inv_white_part_5", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_5" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_white_part_5", "pos_xy", 0, 0, func_end, { 
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_5" ).pos_x, ObjGet( "spr_deploy_inv_white_part_5" ).pos_y, 
        0.6, 0, 4, -63,
      } );
    
      return true;
  
    end;
  
    return false;
    
  end;
  -- USE ------------------------------------------------------------------------------------------
  function public.use_amulet_part_6()
  
    local item = "inv_amulet_part_6";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_white_ghost_amulet_use_amulet_part_6", "deploy_inv_white_ghost_amulet" ) ) then
  
      cmn.CallEventHandler( "use_amulet_part_6_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_amulet_part_6" );
        cmn.CallEventHandler( "use_amulet_part_6_end", "inv_white_ghost_amulet" );
        common_impl.PlayAudio( "sfx","level1/sfx/aud_xx_clk_metal4" );
      
      end;
  
      cmn.Lock( true );
  
      ObjAnimate( "spr_deploy_inv_white_part_6", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_6" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_white_part_6", "pos_xy", 0, 0, func_end, { 
        0.0, 0, ObjGet( "spr_deploy_inv_white_part_6" ).pos_x, ObjGet( "spr_deploy_inv_white_part_6" ).pos_y, 
        0.6, 0, -11, 1,
      } );
    
      return true;
  
    end;
  
    return false;
    
  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_white_ghost_amulet_full()
  
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  
    cmn.SetEventDone( "get_white_ghost_amulet_full" );
    cmn.CallEventHandler( "get_white_ghost_amulet_full", "inv_white_ghost_amulet" );
    
    common_impl.HideDeployInv();
  
  end;
  
--*********************************************************************************************************************