-- name=rm_barber_room
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_barber_room";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_dryer",  "room_hub" );
  ObjAttach( "zz_gauges", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_dryer_amulet_part_6",      { event_mdown = private.get_amulet_part_6     }},
    { "spr_dryer_lucien_signet",      { event_mdown = private.get_lucien_signet     }},
    { "spr_dryer_sword_hilt",         { event_mdown = private.get_sword_hilt        }},
    
    { "spr_gauges_glass_cutter_base", { event_mdown = private.get_glass_cutter_base }},
    { "spr_gauges_cross",             { event_mdown = private.get_cross             }},
    { "spr_gauges2_bas_relief",       { event_mdown = private.get_bas_relief        }},
    { "spr_gauges_release_tool",      { event_mdown = private.get_release_tool      }},
    { "obj_gauges_use_bottle",        { event_mdown = private.AnimUseBottle         }},
    { "obj_gauges_use_barber_key",    { event_mdown = private.AnimUseBarberKey      }},
    { "obj_gauges_clk_garbage",       { event_mdown = private.clk_garbage_gauges    }},
    { "obj_gauges2_use_eyepiece",     { event_mdown = private.AnimUseEyepiece       }},
    
    { "spr_barber_room_rope",         { event_mdown = private.get_rope_lvl3         }},
    { "obj_barber_room_use_sword",    { event_mdown = private.AnimUseSword          }},
    
    { "obj_dryer_use_glass_cutter",   { event_mdown = private.DryerUseGlassCutter   }},
    { "obj_barber_room_clk_gauges",   { event_mdown = private.see_gauges_ghost      }},  
   
    { "spr_dryer_collect2_item_18",  { event_mdown = private.get_collect2_item_18      }},
    { "spr_gauges_collect2_item_19",  { event_mdown = private.get_collect2_item_19      }},  
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_barber_room = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gzz_barber_room_dryer",
      "gzz_barber_room_gauges"
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_dryer",
      "zz_gauges",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_barber_room", update_game_mode_barber_room, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_barber_room = function ()

    local effects_table = 
    {
      "anm_barber_spider",
      "anm_barber_rat",
      "anm_barber_room_all",
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_barber_room", update_performance_mode_barber_room, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_barber_room () end;
  --------------------------------------------------------------------------------------------
  local opn_barber_room_map = function ()

    common_impl.VisitMapRoom( "barber_room" );

  end;
  cmn.AddSubscriber( "opn_barber_room", opn_barber_room_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_amulet_part_6 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulet_part_6" ] = {
    type = "get",
    get_obj = "spr_dryer_amulet_part_6",
    room = private.room_objname,
    zz = "zz_dryer",
    zz_gate = "gzz_barber_room_dryer"
  };
  
  local get_amulet_part_6_inv = function ()
  
    interface.InventoryItemAdd( "inv_amulet_part_6", "spr_dryer_amulet_part_6" );
    
    --if ( cmn.IsEventDone( "get_amulet_part_1" ) and cmn.IsEventDone( "get_amulet_part_2" ) and 
    --     cmn.IsEventDone( "get_amulet_part_3" ) and cmn.IsEventDone( "get_amulet_part_4" ) and 
    --     cmn.IsEventDone( "get_amulet_part_5" ) and cmn.IsEventDone( "get_amulet_part_6" )
    --    ) then
    --
    --    cmn.SetInvPlusRGB( "white_ghost_amulet", true );
    --    
    --end;
    cmn.SetInvPlusRGB( "white_ghost_amulet", true );
  end;
  
  local get_amulet_part_6_closezz = function ()
  
    ObjDelete( "gfx_dryer_amulet_part_6" );
    
    if ( cmn.IsEventDone( "get_sword_hilt" ) and
    cmn.IsGetCollect2( "get_collect2_item_18" ) ) then
      
      ObjDelete( "gzz_barber_room_dryer" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_amulet_part_6", get_amulet_part_6_inv );
  cmn.AddSubscriber( "get_amulet_part_6", get_amulet_part_6_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lucien_signet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lucien_signet" ] = {
    type = "get",
    get_obj = "spr_dryer_lucien_signet",
    room = private.room_objname,
    zz = "zz_dryer",
    zz_gate = "gzz_barber_room_dryer"
  };
  
  local get_lucien_signet_inv = function ()
  
    interface.InventoryItemAdd( "inv_lucien_signet", "spr_dryer_lucien_signet" );
  
  end;
  
  local get_lucien_signet_closezz = function ()
  
    ObjDelete( "gfx_dryer_lucien_signet" );
    ObjDelete( "spr_barber_room_signetring" );
    
  end;
  
  cmn.AddSubscriber( "get_lucien_signet", get_lucien_signet_inv );
  cmn.AddSubscriber( "get_lucien_signet", get_lucien_signet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sword_hilt () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sword_hilt" ] = {
    type = "get",
    get_obj = "spr_dryer_sword_hilt",
    room = private.room_objname,
    zz = "zz_dryer",
    zz_gate = "gzz_barber_room_dryer"
  };
  
  local get_sword_hilt_inv = function ()
  
    interface.InventoryItemAdd( "inv_sword_hilt", "spr_dryer_sword_hilt" );
  
  end;
  
  local get_sword_hilt_closezz = function ()
  
    ObjDelete( "gfx_dryer_sword_hilt" );
    
    if ( cmn.IsEventDone( "get_amulet_part_6" ) and 
    cmn.IsGetCollect2( "get_collect2_item_18" ) ) then
      
      ObjDelete( "gzz_barber_room_dryer" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_sword_hilt", get_sword_hilt_inv );
  cmn.AddSubscriber( "get_sword_hilt", get_sword_hilt_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glass_cutter_base () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glass_cutter_base" ] = {
    type = "get",
    get_obj = "spr_gauges_glass_cutter_base",
    room = private.room_objname,
    zz = "zz_gauges",
    zz_gate = "gzz_barber_room_gauges"
  };
  
  local get_glass_cutter_base_inv = function ()
  
    interface.InventoryItemAdd( "inv_glass_cutter_base", "spr_gauges_glass_cutter_base" );
    ObjSet( "inv_glass_cutter_base", { drag = false } );
    
    if not cmn.IsEventDone( "get_diamond_lvl3" ) then
    
      cmn.SetInvPlusRGB( "glass_cutter_base", false );
      
    end;
    
  end;
  
  local get_glass_cutter_base_closezz = function ()
  
    ObjDelete( "gfx_gauges_glass_cutter_base" );
    ObjDelete( "spr_barber_room_glasscutter" );  
    
  end;
  
  cmn.AddSubscriber( "get_glass_cutter_base", get_glass_cutter_base_inv );
  cmn.AddSubscriber( "get_glass_cutter_base", get_glass_cutter_base_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cross () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cross" ] = {
    type = "get",
    get_obj = "spr_gauges_cross",
    room = private.room_objname,
    zz = "zz_gauges",
    zz_gate = "gzz_barber_room_gauges"
  };
  
  local get_cross_inv = function ()
  
    interface.InventoryItemAdd( "inv_cross", "spr_gauges_cross" );
  
  end;
  
  local get_cross_closezz = function ()
  
    ObjDelete( "gfx_gauges_cross" );
  
  end;
  
  cmn.AddSubscriber( "get_cross", get_cross_inv );
  cmn.AddSubscriber( "get_cross", get_cross_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bas_relief () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bas_relief" ] = {
    type = "get",
    get_obj = "spr_gauges2_bas_relief",
    room = private.room_objname,
    zz = "zz_gauges",
    zz_gate = "gzz_barber_room_gauges",
    subzz = "zz_gauges2",
    subzz_gate = "gzz_gauges_gauges2"
  };
  
  local get_bas_relief_inv = function ()
  
    interface.InventoryItemAdd( "inv_bas_relief", "spr_gauges2_bas_relief" );
  
  end;
  
  local get_bas_relief_closezz = function ()
  
    ObjDelete( "gfx_gauges_bas_relief" );
    ObjDelete( "gzz_gauges_gauges2" );  
    ObjDelete( "spr_barber_room_barelef" );  
    ObjDelete( "spr_gauges_barelief_zz" ); 
    
    if ( cmn.IsGetCollect2( "get_collect2_item_19" ) ) then
      
      ObjDelete( "gzz_barber_room_gauges" );
      
    end;
    
  end;
  
  cmn.AddSubscriber( "get_bas_relief", get_bas_relief_inv );
  cmn.AddSubscriber( "get_bas_relief", get_bas_relief_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_release_tool () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_release_tool" ] = {
    type = "get",
    get_obj = "spr_gauges_release_tool",
    room = private.room_objname,
    zz = "zz_gauges",
    zz_gate = "gzz_barber_room_gauges"
  };
  
  local get_release_tool_inv = function ()
  
    interface.InventoryItemAdd( "inv_release_tool", "spr_gauges_release_tool" );
  
  end;
  
  local get_release_tool_closezz = function ()
  
    ObjDelete( "gfx_gauges_release_tool" );
  
  end;
  
  cmn.AddSubscriber( "get_release_tool", get_release_tool_inv );
  cmn.AddSubscriber( "get_release_tool", get_release_tool_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rope_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rope_lvl3" ] = {
    type = "get",
    get_obj = "spr_barber_room_rope",
    room = private.room_objname 
  };
  
  local get_rope_lvl3_inv = function ()
  
    interface.InventoryItemAdd( "inv_rope_lvl3", "spr_barber_room_rope" );
  
  end;
  
  local get_rope_lvl3_closezz = function ()
  
    ObjDelete( "gfx_barber_room_rope" );
  
  end;
  
  cmn.AddSubscriber( "get_rope_lvl3", get_rope_lvl3_inv );
  cmn.AddSubscriber( "get_rope_lvl3", get_rope_lvl3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_18 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_18 = function ()
  
    ObjDelete( "obj_dryer_collect2_item_18" ); 
  
    if ( cmn.IsEventDone( "get_amulet_part_6" ) and
    cmn.IsEventDone( "get_sword_hilt" ) ) then
      
      ObjDelete( "gzz_barber_room_dryer" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_18", get_collect2_item_18, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_19 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_19 = function ()
  
    ObjDelete( "obj_gauges_collect2_item_19" ); 
  
    if ( cmn.IsEventDone( "get_bas_relief" ) ) then
      
      ObjDelete( "gzz_barber_room_gauges" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_19", get_collect2_item_19, private.room_objname );    
  --------------------------------------------------------------------------------------------
  -- function use_glass_cutter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glass_cutter" ] = {
    type = "use",
    inv_obj = "inv_glass_cutter",
    use_place = "obj_dryer_use_glass_cutter",
    room = private.room_objname,
    zz = "zz_dryer",
    zz_gate = "gzz_barber_room_dryer"
  };
  local use_glass_cutter_inv = function ()
  
    interface.InventoryItemRemove( "inv_glass_cutter" );
  
  end;
  local use_glass_cutter_beg = function ()
  
    ObjDelete( "obj_dryer_use_glass_cutter" );
  
  end;
  local use_glass_cutter_end = function ()
    
    ObjMultiSet( { 
      { "anm_dryer_glass",           { frame = 205  } },
      { "spr_dryer_amulet_part_6",   { input = true } },
      { "spr_dryer_sword_hilt",      { input = true } },
      { "spr_barber_room_glasshole", {   alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glass_cutter", use_glass_cutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_glass_cutter", use_glass_cutter_inv );
  cmn.AddSubscriber( "use_glass_cutter", use_glass_cutter_end, private.room_objname );
  cmn.AddSubscriber( "use_glass_cutter_inv", use_glass_cutter_inv, private.room_objname );
  cmn.AddSubscriber( "use_glass_cutter_beg", use_glass_cutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_glass_cutter_end", use_glass_cutter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_barber_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_barber_key" ] = {
    type = "use",
    inv_obj = "inv_barber_key",
    use_place = "obj_gauges_use_barber_key",
    room = private.room_objname,
    zz = "zz_gauges",
    zz_gate = "gzz_barber_room_gauges"
  };
  local use_barber_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_barber_key" );
  
  end;
  local use_barber_key_beg = function ()
  
    ObjDelete( "obj_gauges_use_barber_key" );
  
  end;
  local use_barber_key_end = function ()
    
    ObjDelete( "anm_gauges_key" );
    ObjMultiSet( { 
      { "obj_gauges_clk_garbage",       { input = true } },
      { "obj_gauges_down",              {   alp = 1    } },
      { "spr_gauges_open_patch",        {   alp = 1    } },
      { "spr_barber_room_open_downbox", {   alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_barber_key", use_barber_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_barber_key", use_barber_key_inv );
  cmn.AddSubscriber( "use_barber_key", use_barber_key_end, private.room_objname );
  cmn.AddSubscriber( "use_barber_key_inv", use_barber_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_barber_key_beg", use_barber_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_barber_key_end", use_barber_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bottle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bottle" ] = {
    type = "use",
    inv_obj = "inv_bottle",
    use_place = "obj_gauges_use_bottle",
    room = private.room_objname,
    zz = "zz_gauges",
    zz_gate = "gzz_barber_room_gauges"
  };
  local use_bottle_inv = function ()
  
    interface.InventoryItemRemove( "inv_bottle" );
  
  end;
  local use_bottle_beg = function ()
  
    ObjDelete( "obj_gauges_use_bottle" );
  
  end;
  local use_bottle_end = function ()
    
    ObjDelete( "anm_gauges_flacon" );
    ObjMultiSet( { 
      { "spr_gauges_release_tool",    { input = true            } },
      { "obj_gauges_top",             {   alp = 1, input = true } },
      { "spr_gauges_flacon",          {   alp = 1               } },
      { "spr_gauges_flaconshadow",    {   alp = 0.61            } },
      { "spr_barber_room_flacon",     {   alp = 1               } },
      { "spr_barber_room_open_topbox",{   alp = 1               } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bottle", use_bottle_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle", use_bottle_inv );
  cmn.AddSubscriber( "use_bottle", use_bottle_end, private.room_objname );
  cmn.AddSubscriber( "use_bottle_inv", use_bottle_inv, private.room_objname );
  cmn.AddSubscriber( "use_bottle_beg", use_bottle_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_end", use_bottle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_eyepiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_eyepiece" ] = {
    type = "use",
    inv_obj = "inv_eyepiece",
    use_place = "obj_gauges2_use_eyepiece",
    room = private.room_objname,
    zz = "zz_gauges",
    zz_gate = "gzz_barber_room_gauges",
    subzz = "zz_gauges2",
    subzz_gate = "gzz_gauges_gauges2"
  };
  local use_eyepiece_inv = function ()
  
    interface.InventoryItemRemove( "inv_eyepiece" );
  
  end;
  local use_eyepiece_beg = function ()
  
    ObjDelete( "obj_gauges2_use_eyepiece" );
  
  end;
  local use_eyepiece_end = function ()
  
    ObjMultiSet( { 
      { "anm_gauges2_eyepiece", { frame = 300  } },
      { "obj_gauges2_mmg",      { input = true } },
      { "spr_barber_room_lens", {   alp = 1    } },
      { "spr_gauges_state_lens", {   alp = 1   } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_eyepiece", use_eyepiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_eyepiece", use_eyepiece_inv );
  cmn.AddSubscriber( "use_eyepiece", use_eyepiece_end, private.room_objname );
  cmn.AddSubscriber( "use_eyepiece_inv", use_eyepiece_inv, private.room_objname );
  cmn.AddSubscriber( "use_eyepiece_beg", use_eyepiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_eyepiece_end", use_eyepiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sword () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sword" ] = {
    type = "use",
    inv_obj = "inv_sword",
    use_place = "obj_barber_room_use_sword",
    room = private.room_objname 
  };
  local use_sword_inv = function ()
  
    interface.InventoryItemRemove( "inv_sword" );
  
  end;
  local use_sword_beg = function ()
  
    ObjDelete( "obj_barber_room_use_sword" );
  
  end;
  local use_sword_end = function ()
    
    ObjDelete( "anm_barber_room_rope_static" );  
    ObjMultiSet( { 
      { "spr_barber_room_rope",               { input = true            } },
      { "anm_barber_room_rope_static_after",  {   alp = 1               } },
      { "anm_barber_room_rope",               {   alp = 1, frame = 300  } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sword", use_sword_beg, private.room_objname );
  cmn.AddSubscriber( "use_sword", use_sword_inv );
  cmn.AddSubscriber( "use_sword", use_sword_end, private.room_objname );
  cmn.AddSubscriber( "use_sword_inv", use_sword_inv, private.room_objname );
  cmn.AddSubscriber( "use_sword_beg", use_sword_beg, private.room_objname );
  cmn.AddSubscriber( "use_sword_end", use_sword_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_garbage_gauges () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_garbage_gauges" ] = {
    type = "click",
    use_place = "obj_gauges_clk_garbage",
    room = private.room_objname,
    zz = "zz_gauges",
    zz_gate = "gzz_barber_room_gauges"
  };
  
  local clk_garbage_gauges_beg = function ()

    ObjDelete( "obj_gauges_clk_garbage" );
  
  end;
  local clk_garbage_gauges_end = function ()
    ObjDelete( "anm_gauges_take_cross" );
    ObjMultiSet( { 
      { "spr_gauges_cross",             {  input = true } },
      { "gfx_gauges_cross",             { active = true } },
      { "spr_gauges_down_things",       {    alp = 0    } },
      { "anm_gauges_last_frame_crosss", {    alp = 1    } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_garbage_gauges",     clk_garbage_gauges_beg, private.room_objname );
  cmn.AddSubscriber( "clk_garbage_gauges",     clk_garbage_gauges_end, private.room_objname );
  cmn.AddSubscriber( "clk_garbage_gauges_beg", clk_garbage_gauges_beg, private.room_objname );
  cmn.AddSubscriber( "clk_garbage_gauges_end", clk_garbage_gauges_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_gauges2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_gauges2" ] =
  {
    type = "click",
    clk_obj = "obj_gauges2_mmg",
    room = private.room_objname,
    zz = "zz_gauges",
    zz_gate = "gzz_barber_room_gauges",
    subzz = "zz_gauges2",
    subzz_gate = "gzz_gauges_gauges2"
  };
  --*********************************************************************************************************************
  local win_gauges2 = function ()

    if ( cmn.IsEventDone( "win_gauges2" ) ) then
   
      ObjMultiSet( { 
        { "gfx_gauges_bas_relief",     { active = true            } },
        { "spr_gauges2_bas_relief",    {  input = true            } },
        { "obj_gauges2_mmg_line_crop", {  input = false           } },
        { "spr_gauges2_mmg_line_1",    {  pos_x = 12, pos_y = -72 } },
        { "spr_gauges2_mmg_line_2",    {  pos_x = 7, pos_y = -24  } },
        { "spr_gauges2_mmg_line_3",    {  pos_x = 4, pos_y = 0    } },
        { "spr_barber_room_open_safe", {    alp = 1               } },
      } );
      
      ObjDelete( "spr_gauges2_mmg_door" );
      ObjDelete( "anm_gauges2_eyepiece" ); 
      ObjDelete( "spr_barber_room_lens" );  
      ObjDelete( "spr_gauges_chear_safedoor" );   
      ObjDelete( "spr_gauges_state_lens" ); 
      
    else 

      private.Gauges2Load();
      
    end;
    
  end;
  
  local win_gauges2_end = function ()

    ObjMultiSet( { 
      { "gfx_gauges_bas_relief",   { active = true  } },
      { "spr_gauges2_bas_relief",  {  input = true  } },
      { "obj_gauges2_mmg",         {  input = false } },
    } );
    
    ObjDelete( "spr_gauges2_mmg_door" );
    ObjDelete( "anm_gauges2_eyepiece" ); 
    ObjDelete( "spr_barber_room_lens" );   
    ObjDelete( "spr_gauges_chear_safedoor" );   
    ObjDelete( "spr_gauges_state_lens" ); 
      
  end;
  
  cmn.AddSubscriber( "win_gauges2", win_gauges2, private.room_objname ); 
  cmn.AddSubscriber( "win_gauges2_end", win_gauges2_end, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function see_gauges_ghost () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_gauges_ghost" ] = {
    type = "click",
    use_place = "obj_barber_room_clk_gauges",
    room = private.room_objname
  };

  local see_gauges_ghost = function ()
  
    ObjDelete( "obj_barber_room_clk_gauges"   );
    ObjDelete( "anm_barber_room_gauges_ghost" );
    ObjMultiSet( { 
      { "gzz_barber_room_gauges", { input = true, active = true, visible = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_gauges_ghost", see_gauges_ghost, private.room_objname ); 

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_gauges2 () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_gauges2" );
    -------------------------------------------------
    function zz_gauges2.PreOpen ()
      
      if ( cmn.IsEventDone( "use_eyepiece" ) and not cmn.IsEventDone( "win_gauges2" ) ) then 
        
        cmn.MiniGameShow( "gauges2" );
        common_impl.PassingMgStart( "gauges2" );
    
      end;

    end; 
    -------------------------------------------
    function zz_gauges2.PreClose ()

      if ( cmn.IsEventDone( "use_eyepiece" ) and not cmn.IsEventDone( "win_gauges2" ) ) then 
        
        cmn.MiniGameHide( "gauges2" );
        common_impl.PassingMgStop( "gauges2" );
        
      end;
            
    end; 
    -------------------------------------------
    function zz_gauges2.Skip ()
      
      if ( cmn.IsEventDone( "use_eyepiece" ) and not cmn.IsEventDone( "win_gauges2" ) ) then 
        
       private.state = { 9, 7, 6 }; 
        
       cmn.Lock( false );
       private.Gauges2Win();
       
      end;
     
    end;
    -------------------------------------------------
    function zz_gauges2.Reset ()
      
      if ( cmn.IsEventDone( "use_eyepiece" ) and not cmn.IsEventDone( "win_gauges2" ) ) then 
        
        ng_global.progress[ "std" ][ "win_gauges2" ].state = { 2, 3, 8 };
        private.state = { 2, 3, 8 }; 
        private.Gauges2Load();
        
      end; 
      
    end;     
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_barber_room();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "level3/env/aud_barber_room_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level3/env/aud_barber_room_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_glass_cutter ()

  local item = "inv_glass_cutter";

  if ( cmn.ApplyObj( item, "gzz_barber_room_dryer" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dryer" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dryer_use_glass_cutter" ) ) then

    cmn.CallEventHandler( "use_glass_cutter_inv" );
    cmn.CallEventHandler( "use_glass_cutter_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_glass_cutter" );
      cmn.CallEventHandler( "use_glass_cutter_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_glasscutter3", 0, "", 0 );

    AnimPlay( "anm_dryer_glass", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_barber_key ()

  local item = "inv_barber_key";

  if ( cmn.ApplyObj( item, "gzz_barber_room_gauges" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gauges" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gauges_use_barber_key" ) ) then

    cmn.CallEventHandler( "use_barber_key_inv" );
    cmn.CallEventHandler( "use_barber_key_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_barber_key" );
      cmn.CallEventHandler( "use_barber_key_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_drawer", 0, "", 0 );

    ObjMultiSet( { 
      { "anm_gauges_key",        { alp = 1 } },
      { "spr_gauges_open_patch", { alp = 0 } },
    } );
    AnimPlay( "anm_gauges_key", "key", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bottle ()

  local item = "inv_bottle";

  if ( cmn.ApplyObj( item, "gzz_barber_room_gauges" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gauges" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gauges_use_bottle" ) ) then

    cmn.CallEventHandler( "use_bottle_inv" );
    cmn.CallEventHandler( "use_bottle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bottle" );
      cmn.CallEventHandler( "use_bottle_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_bottle", 0, "", 0 );
    ObjMultiSet( { 
      { "anm_gauges_flacon",  { alp = 1 } },
    } );    
    AnimPlay( "anm_gauges_flacon", "flacon", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_eyepiece ()

  local item = "inv_eyepiece";

  if ( cmn.ApplyObj( item, "gzz_barber_room_gauges" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gauges" );

    return true;
    
  elseif ( cmn.ApplyObj( item, "gzz_gauges_gauges2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_gauges2', 'not_frame', { { x = 400, y = 180 },{ x = 220, y = 320 } }, { x = 204, y = -158 } ); 
    
    return true;
    
  elseif ( cmn.ApplyObj( item, "obj_gauges2_use_eyepiece" ) ) then

    cmn.CallEventHandler( "use_eyepiece_inv" );
    cmn.CallEventHandler( "use_eyepiece_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_eyepiece" );
      cmn.CallEventHandler( "use_eyepiece_end" );
      private.Gauges2Load();
      cmn.MiniGameShow( "gauges2" );
      common_impl.PassingMgStart( "gauges2" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_loupe", 0, "", 0 );

    AnimPlay( "anm_gauges2_eyepiece", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sword ()

  local item = "inv_sword";

  if ( cmn.ApplyObj( item, "obj_barber_room_use_sword" ) ) then

    cmn.CallEventHandler( "use_sword_inv" );
    cmn.CallEventHandler( "use_sword_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_sword" );
      cmn.CallEventHandler( "use_sword_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_cut_rope", 0, "", 0 );
    
    ObjMultiSet( { 
      { "anm_barber_room_rope_static", { alp = 0 } },
      { "anm_barber_room_rope",        { alp = 1 } },
    } );
    
    AnimPlay( "anm_barber_room_rope", "rope", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_amulet_part_6 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_amulet_part_6" );
  cmn.CallEventHandler( "get_amulet_part_6" );
  
  if ( cmn.IsEventDone( "get_sword_hilt" ) and
  cmn.IsGetCollect2( "get_collect2_item_18" ) ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_lucien_signet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lucien_signet" );
  cmn.CallEventHandler( "get_lucien_signet" );

end;
--------------------------------------------------------------------------------------------
function private.get_sword_hilt ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sword_hilt" );
  cmn.CallEventHandler( "get_sword_hilt" );
  
  if ( cmn.IsEventDone( "get_amulet_part_6" ) and
  cmn.IsGetCollect2( "get_collect2_item_18" ) ) then
    
    common.CloseSubRoom();

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_glass_cutter_base ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_glass_cutter_base" );
  cmn.CallEventHandler( "get_glass_cutter_base" );

end;
--------------------------------------------------------------------------------------------
function private.get_cross ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cross" );
  cmn.CallEventHandler( "get_cross" );

end;
--------------------------------------------------------------------------------------------
function private.get_bas_relief ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bas_relief" );
  cmn.CallEventHandler( "get_bas_relief" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_19" ) ) then
    
    common.CloseSubRoomAll();
    
  end; 
  
end;
--------------------------------------------------------------------------------------------
function private.get_release_tool ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_release_tool" );
  cmn.CallEventHandler( "get_release_tool" );

end;
--------------------------------------------------------------------------------------------
function private.get_rope_lvl3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rope_lvl3" );
  cmn.CallEventHandler( "get_rope_lvl3" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_18 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_18" ); 

  end;

  common_impl.PlayEffectHO( "spr_dryer_collect2_item_18", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_18" );
  
  if ( cmn.IsEventDone( "get_amulet_part_6" ) and
  cmn.IsEventDone( "get_sword_hilt" ) ) then

    common.CloseSubRoom();

  end; 
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_19 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_19" ); 

  end;

  common_impl.PlayEffectHO( "spr_gauges_collect2_item_19", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_19" );
  
  if ( cmn.IsEventDone( "get_bas_relief" ) ) then

    common.CloseSubRoomAll();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_garbage_gauges ()
  
  cmn.CallEventHandler( "clk_garbage_gauges_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_garbage_gauges" );
    cmn.CallEventHandler( "clk_garbage_gauges_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_slide_parts", 0, "", 0 );
  
  AnimPlay( "anm_gauges_take_cross", "take_cross", func_end );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG GAUGES2 *** () end;
--*********************************************************************************************************************
function private.Gauges2Load ()
  
  if not ( ng_global.progress[ "std" ][ "win_gauges2" ].state ) then
    
    ng_global.progress[ "std" ][ "win_gauges2" ].state = { 2, 3, 8 };
    
  end;

  private.pos_xy = { { -8, 118 }, { -5, 95 }, { -2, 72 }, { 0, 48 }, { 2, 23 }, { 4, 0 }, { 7, -24 }, { 9, -49 }, { 12, -72 }, { 14, -96 }, { 15, -121 } }
  private.state = { 2, 3, 8 }; 
  private.win   = { 9, 7, 6 }; 
  
  for i = 1, 3 do 
    
    ObjSet( "obj_gauges2_mmg_line_"..i, { event_mdown = function() private.Gauges2Clk( i ); end } );
    
    local line = ng_global.progress[ "std" ][ "win_gauges2" ].state[ i ];
    ObjSet( "spr_gauges2_mmg_line_"..i, { pos_x = private.pos_xy[ line ][ 1 ], pos_y = private.pos_xy[ line ][ 2 ] } );
    private.state[ i ] = line; 

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.Gauges2IsWin ()

  for i = 1, 3 do

    if ( private.state[ i ] ~= private.win[ i ] ) then
    
      return false;
      
    end;
    
  end;
  
  return true;
  
end;
--------------------------------------------------------------------------------------------
function private.Gauges2Clk ( id ) 

  private.state[ id ] = private.state[ id ] + 1;
  private.Gauges2Anim( id );
  
end;
--------------------------------------------------------------------------------------------
function private.Gauges2Anim ( id )

  common_impl.PlayAudio( "sfx", "aud_xx_click1", 0, "", 0 );

  local func_end = function ()
  
    cmn.Lock( false );
    
    if ( private.state[ id ] ) == 11 then
    
      private.state[ id ] = 1;
      local line = private.state[ id ];
      ObjSet( "spr_gauges2_mmg_line_"..id, { pos_x = private.pos_xy[ line ][ 1 ], pos_y = private.pos_xy[ line ][ 2 ] } );    
    
    end;
    
    if ( private.Gauges2IsWin() ) then
      
      private.Gauges2Win();

    else 
      
      ng_global.progress[ "std" ][ "win_gauges2" ].state[ id ] = private.state[ id ];
   
    end;
    
  end;  
  
  local pos_old = ObjGet( "spr_gauges2_mmg_line_"..id );
  local pos_new = private.pos_xy[ private.state[ id ] ];
    
  cmn.Lock( true );
  ObjAnimate( "spr_gauges2_mmg_line_"..id, "pos_xy", 0, 0, func_end, { 0, 0, pos_old.pos_x, pos_old.pos_y,   0.3, 3, pos_new[ 1 ], pos_new[ 2 ]} );

end;  
--------------------------------------------------------------------------------------------
function private.Gauges2Win ()

  local func_end = function ()
  
    cmn.MiniGameHide( "gauges2" );
    common_impl.PassingMgWin( "gauges2" );
    cmn.SetEventDone( "win_gauges2" );
    cmn.CallEventHandler( "win_gauges2" );

    common_impl.PlayAudio( "sfx", "aud_win_mmg" );

    cmn.Lock( false );
    
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_slide", 0, "", 0 );

  ObjAnimate( "spr_gauges2_mmg_door", "pos_xy", 0, 0, func_end, { 0, 0, -12, 15,   1.0, 0, 190, 184 } );
  ObjAnimate( "anm_gauges2_eyepiece", "alp", 0, 0, "", { 0, 0, 1,   0.4, 0, 0 } );
  
end; 

--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt ) 
end;
--------------------------------------------------------------------------------------------
function private.see_gauges_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_gauges_ghost" );
    cmn.CallEventHandler( "see_gauges_ghost" );

    common_impl.ShowBbt( 'bbt_barber_room_see_gauges_ghost' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_barber_ghost_sc", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_barber_room_gauges_ghost", { alp = 1 } },
  } );

  AnimPlay( "anm_barber_room_gauges_ghost", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_barber_room ()

  if not ( cmn.IsEventDone( "opn_barber_room" ) ) then

    cmn.SetEventDone( "opn_barber_room" );
    common_impl.ShowBbt( 'bbt_barber_room_opn_barber_room' );

  end;
  cmn.CallEventHandler( "opn_barber_room" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.AnimUseSword()

  common_impl.ShowBbt( 'bbt_barber_room_use_sword' );

  local func_end = function ()

    cmn.Lock( false );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_rope_2", 0, "", 0 );
  
  ObjAnimate( "anm_barber_room_rope_static", "pos_xy", 0, 1, func_end, { 
    0.0, 0, 0, 0,   
    0.2, 3, 0, 1,   
    0.4, 3, 0, 0, 
  });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseBottle()

  common_impl.ShowBbt( 'bbt_gauges_use_bottle' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wallet", 0, "", 0 );
  
  ObjAnimate( "spr_gauges_top_box", "pos_xy", 0, 1, func_end, { 
    0.0, 0, 0, 0,   
    0.2, 3, 1, 0,   
    0.4, 3, 0, 0, 
  });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseBarberKey()

  common_impl.ShowBbt( 'bbt_gauges_use_barber_key' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_opn_wood_safe", 0, "", 0 );
  
  ObjAnimate( "spr_gauges_down_box", "pos_xy", 0, 1, func_end, { 
    0.0, 0, 0, 0,   
    0.2, 3, 1, 0,   
    0.4, 3, 0, 0, 
  });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseEyepiece()

  common_impl.ShowBbt( 'bbt_gauges_use_eyepiece' );

  local func_end = function ()

    cmn.Lock( false );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_fang", 0, "", 0 );
  
  ObjAnimate( "spr_gauges2_mmg_door", "pos_xy", 0, 1, func_end, { 
    0.0, 0, 0, 0,   
    0.2, 3, 1, 0,   
    0.4, 3, 0, 0, 
  });

end;
--*********************************************************************************************************************
function private.DryerUseGlassCutter ()

  common_impl.ShowBbt( "bbt_dryer_use_glass_cutter" );
  
  local obj_1 = "spr_dryer_amulet_part_6";
  local obj_2 = "spr_dryer_sword_hilt";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_water", 0, "", 0 );

  ObjAnimate( obj_1, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj_1, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
  ObjAnimate( obj_2, "pos_x",0,1, "", { 0,0,0, time/4,0,-dx, 3/4*time,0,dx, time,0,0 });  
  ObjAnimate( obj_2, "pos_y",0,1, "", { 0,0,0, time/4,0,-dy, 3/4*time,0,dy, time,0,0 });  
  
end;









