-- name=rm_brook
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_brook";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet( { 
    { "obj_brook_clk_clark",           { event_mdown = private.see_brook_clark     }},
    { "obj_brook_clk_maurice_1",       { event_mdown = private.dlg_brook_maurice_1 }},
    { "obj_brook_clk_maurice_1_focus", { event_mdown = private.dlg_brook_maurice_1 }},    
    
    { "spr_brook_collect_morph_item",  { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_16" ); end } },
  } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_brook = function ()
  
    table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gmg_brook_boss_fight",
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_brook", update_game_mode_brook, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_brook = function ()

    local effects_table = 
    {
      "anm_brook_clark",
      "obj_brook_anim_room",
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_brook", update_performance_mode_brook, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_brook () end;
  --------------------------------------------------------------------------------------------
  local opn_brook_map = function ()

    common_impl.VisitMapRoom( "brook" );

  end;
  cmn.AddSubscriber( "opn_brook", opn_brook_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_16 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_16 = function ()
  
    ObjDelete( "obj_brook_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_16", get_collect_morph_item_16, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function use_white_ghost_amulet_full () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_white_ghost_amulet_full" ] = {
    type = "use",
    inv_obj = "inv_white_ghost_amulet_full",
    use_place = "obj_brook_use_white_ghost_amulet_full",
    room = private.room_objname 
  };
  local use_white_ghost_amulet_full_inv = function ()
  
    interface.InventoryItemRemove( "inv_white_ghost_amulet_full" );
  
  end;
  local use_white_ghost_amulet_full_beg = function ()
  
    ObjDelete( "obj_brook_use_white_ghost_amulet_full" );
  
  end;
  local use_white_ghost_amulet_full_end = function ()
  
    ObjMultiSet( { 
      { "gmg_brook_boss_fight",  { visible = true, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_white_ghost_amulet_full", use_white_ghost_amulet_full_beg, private.room_objname );
  cmn.AddSubscriber( "use_white_ghost_amulet_full", use_white_ghost_amulet_full_inv );
  cmn.AddSubscriber( "use_white_ghost_amulet_full", use_white_ghost_amulet_full_end, private.room_objname );
  cmn.AddSubscriber( "use_white_ghost_amulet_full_inv", use_white_ghost_amulet_full_inv, private.room_objname );
  cmn.AddSubscriber( "use_white_ghost_amulet_full_beg", use_white_ghost_amulet_full_beg, private.room_objname );
  cmn.AddSubscriber( "use_white_ghost_amulet_full_end", use_white_ghost_amulet_full_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function see_brook_clark () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_brook_clark" ] = {
    type = "click",
    use_place = "obj_brook_clk_clark",
    room = private.room_objname
  };  
  
  local see_brook_clark = function ()
 
    ObjDelete( "obj_brook_clk_clark"  ); 
    ObjDelete( "anm_brook_clark_back" ); 
    ObjMultiSet( { 
      { "obj_brook_clk_maurice_1", {            input = true } },
      { "anm_brook_clark",         { alp = 1, playing = true } },
    } );
    
  end;
  cmn.AddSubscriber( "see_brook_clark", see_brook_clark, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function dlg_brook_maurice_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_brook_maurice_1" ] = {
    type = "click",
    use_place = "obj_brook_clk_maurice_1_focus",
    room = private.room_objname,
  };  
  
  local dlg_brook_maurice_1 = function ()
    
    ObjDelete( "obj_brook_clk_maurice_1" );
    ObjMultiSet( { 
      { "obj_brook_use_white_ghost_amulet_full", { input = true, active = true, visible = true } },
    } );
    
  end;  
  cmn.AddSubscriber( "dlg_brook_maurice_1", dlg_brook_maurice_1, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_brook();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "level3/env/aud_cemetery_3_env" }, "", 0.5 );

  if ( cmn.IsEventDone( "dlg_brook_maurice_1" ) ) then

    common_impl.StopMusEnv();
    common_impl.PlayAudio( "mus_env", "mus_env/aud_danger2_mus_env", 1, "", 0 );

  end;
  
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level3/env/aud_cemetery_3_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_white_ghost_amulet_full ()

  local item = "inv_white_ghost_amulet_full";

  if ( cmn.ApplyObj( item, "obj_brook_use_white_ghost_amulet_full" ) and cmn.IsEventDone( "dlg_brook_maurice_1" ) ) then

    cmn.CallEventHandler( "use_white_ghost_amulet_full_inv" );
    cmn.CallEventHandler( "use_white_ghost_amulet_full_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_white_ghost_amulet_full" );
      cmn.CallEventHandler( "use_white_ghost_amulet_full_end" );

      cmn.GotoRoom( "mg_boss_fight" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_loupe", 0, "", 0 );

    AnimPlay( "anm_brook_amulet", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
function private.dlg_brook_maurice_1 ()

  common_impl.dialog_character_loc = "";
  
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "maurice_1", 4, nil, nil, true, private.dlg_brook_maurice_1_end ); 
  
end;
--------------------------------------------------------------------------------------------
function private.dlg_brook_maurice_1_end ()
  
  cmn.CallEventHandler( "dlg_brook_maurice_1" );
 
  common_impl.ShowBbt( 'bbt_brook_dlg_brook_maurice_1' );

  common_impl.StopMusEnv();
  common_impl.PlayAudio( "mus_env", "mus_env/aud_danger2_mus_env", 1, "", 0 );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )  
  
if ( dlg_name == "maurice_1" ) then
    
    if ( count_txt == 1 ) then
      
      VidPlay( "vid_dlg_brook_maurice_1_static_1", "" );
      
    elseif ( count_txt == 2 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_brook_maurice_1_static_2",  { alp = 1, visible = true } },
        { "vid_dlg_brook_maurice_1_static_1",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_brook_maurice_1_static_2", "" );
      
    elseif ( count_txt == 3 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_brook_maurice_1_static_3",  { alp = 1, visible = true } },
        { "vid_dlg_brook_maurice_1_static_2",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_brook_maurice_1_static_3", "" );
   
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.see_brook_clark ()
  
  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "level3/voc/aud_clark_brook_voc",  0.2 );
      common_impl.StopAudio( "sfx", "level3/sfx/aud_clark_brook",      0.2 );
      
    end;

    cmn.SetEventDone( "see_brook_clark" );
    cmn.CallEventHandler( "see_brook_clark" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl3_defeat_ghost" );
    
  end;

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clark_brook",      0, "", 0 );
  common_impl.PlayAudio( "voc", "level3/voc/aud_clark_brook_voc",  0, "", 0 );
  
  cmn.PlayDialogVideo( "vid_brook_clark", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_brook ()

  if not ( cmn.IsEventDone( "opn_brook" ) ) then

    cmn.SetEventDone( "opn_brook" );
    common_impl.ShowBbt( 'bbt_brook_opn_brook' );

  end;
  cmn.CallEventHandler( "opn_brook" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************