-- name=rm_cemetery_3
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cemetery_3";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_crypt",         "room_hub" );
  ObjAttach( "zz_maurce_tomb",   "room_hub" );
  ObjAttach( "zz_wooden_coffin", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_crypt_pincers",                   { event_mdown = private.get_pincers           }},
    { "spr_crypt_maggie_sign",               { event_mdown = private.get_maggie_sign       }},
    { "spr_crypt_hunter_horn",               { event_mdown = private.get_hunter_horn       }},
    { "spr_crypt_fang",                      { event_mdown = private.get_fang              }},
    { "spr_crypt_bone",                      { event_mdown = private.get_bone              }},
    { "obj_crypt_use_gothic_pattern",        { event_mdown = private.UsePattern            }},
    { "obj_crypt_use_wool_piece",            { event_mdown = private.UseWoolPiece          }},
    { "obj_crypt_use_black_cat",             { event_mdown = private.UseBlackCat           }},
    { "obj_crypt_use_stone_1",               { event_mdown = private.UseStone              }},
    { "obj_crypt_use_stone_2",               { event_mdown = private.UseStone              }},
    { "obj_crypt_use_cross",                 { event_mdown = private.UseCross              }},
    
    { "spr_maurce_tomb_code",                { event_mdown = private.get_code              }},
    { "spr_maurce_tomb_tweezers",            { event_mdown = private.get_tweezers          }},
    { "obj_maurce_tomb_clk_bag",             { event_mdown = private.clk_maurce_tomb_bag   }},
    { "obj_maurce_tomb_clk_trash",           { event_mdown = private.clk_maurce_tomb_trash }},
    { "spr_maurce_tomb_note",                { event_mdown = function() cmn.NoteScale( "spr_maurce_tomb_note" ) end }},
    { "spr_maurce_tomb_note_big",            { event_mdown = function() cmn.NoteScale( "spr_maurce_tomb_note" ) end }},
    { "spr_maurce_tomb_token",               { event_mdown = function() cmn.NoteScale( "spr_maurce_tomb_token" ); 
                                                                        ObjSet( "spr_maurce_tomb_token_big1", { alp = 0, input = false } ); 
                                                                        ObjSet( "spr_maurce_tomb_token_big2", { alp = 1                } ); 
                                                             end }},
    { "spr_maurce_tomb_token_big1",          { event_mdown = function() cmn.NoteScale( "spr_maurce_tomb_token" ) end }},
    { "spr_maurce_tomb_token_big",           { event_mdown = private.TokenClick            }},
    { "obj_maurce_tomb_use_maggie_sign",     { event_mdown = private.UseMaggieSign         }},
    
    { "spr_wooden_coffin_stone_1",           { event_mdown = private.get_stone_1           }},
    { "spr_wooden_coffin_sapling",           { event_mdown = private.get_sapling           }},
    { "spr_wooden_coffin_hillmark_monogram", { event_mdown = private.get_hillmark_monogram }},
    { "obj_wooden_coffin_use_tweezers",      { event_mdown = private.UseTweezers           }},
    { "obj_wooden_coffin_use_pincers",       { event_mdown = private.UsePincers            }},
    { "obj_wooden_coffin_clk_cap",           { event_mdown = private.clk_wooden_coffin_cap }},
    
    { "spr_cemetery_3_black_cat",            { event_mdown = private.get_black_cat         }},
    { "obj_cemetery_3_use_opened_can",       { event_mdown = private.AnimUseOpenedCan      }},

    { "obj_cemetery_3_clk_wooden_coffin_ghost", { event_mdown = private.see_wooden_coffin_ghost }},

    { "spr_cemetery_3_collect_morph_item",   { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_13" ); end } },
      
    { "spr_maurce_tomb_collect2_item_20",  { event_mdown = private.get_collect2_item_20      }}, 
    { "spr_crypt_collect2_item_22",  { event_mdown = private.get_collect2_item_22      }}, 
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_cemetery_3 = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gzz_cemetery_3_crypt",
      "gzz_cemetery_3_maurce_tomb",
      "gzz_cemetery_3_wooden_coffin"
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_crypt",
      "zz_maurce_tomb",
      "zz_wooden_coffin",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_cemetery_3", update_game_mode_cemetery_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_cemetery_3 = function ()

    local effects_table = 
    {
      "anm_cemetery_3_forest",
      "anm_cemetery_3_sky"  
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_cemetery_3", update_performance_mode_cemetery_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_cemetery_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_cemetery_3_map = function ()

    common_impl.VisitMapRoom( "cemetery_3" );

  end;
  cmn.AddSubscriber( "opn_cemetery_3", opn_cemetery_3_map );
  
 --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_13 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_13 = function ()
  
    ObjDelete( "obj_cemetery_3_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_13", get_collect_morph_item_13, private.room_objname ); 


  --------------------------------------------------------------------------------------------
  -- function clk_maurce_tomb_bag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_maurce_tomb_bag" ] = {
    type = "click",
    use_place = "obj_maurce_tomb_clk_bag",
    room = private.room_objname,
    zz = "zz_maurce_tomb",
    zz_gate = "gzz_cemetery_3_maurce_tomb"
  };
  
  local clk_maurce_tomb_bag_beg = function ()

    ObjDelete( "obj_maurce_tomb_clk_bag" );
  
  end;
  local clk_maurce_tomb_bag_end = function ()

    ObjMultiSet( { 
      { "obj_maurce_tomb_clk_trash", { input = true             } },
      { "obj_maurce_tomb_bag",       {   alp = 1, input = true  } },
      { "spr_cemetery_3_open_bag",   {   alp = 1                } },
    } );
    ObjDelete( "spr_maurce_tomb_bag" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_maurce_tomb_bag",     clk_maurce_tomb_bag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_maurce_tomb_bag",     clk_maurce_tomb_bag_end, private.room_objname );
  cmn.AddSubscriber( "clk_maurce_tomb_bag_beg", clk_maurce_tomb_bag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_maurce_tomb_bag_end", clk_maurce_tomb_bag_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function clk_maurce_tomb_trash () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_maurce_tomb_trash" ] = {
    type = "click",
    use_place = "obj_maurce_tomb_clk_trash",
    room = private.room_objname,
    zz = "zz_maurce_tomb",
    zz_gate = "gzz_cemetery_3_maurce_tomb"
  };
  
  local clk_maurce_tomb_trash_beg = function ()

    ObjDelete( "obj_maurce_tomb_clk_trash" );
  
  end;
  local clk_maurce_tomb_trash_end = function ()

    ObjMultiSet( { 
      { "spr_maurce_tomb_tweezers", {  input = true             } },
      { "spr_maurce_tomb_note",     {  input = true             } },
      { "gfx_maurce_tomb_tweezers", { active = true             } },
      { "spr_maurce_tomb_comb",     {  pos_x = 284, pos_y = -69 } },
      { "spr_maurce_tomb_bracelet", {  pos_x = 267, pos_y = -48 } },
      { "spr_maurce_tomb_pen",      {  pos_x = 180, pos_y = -37 } },
      { "spr_maurce_tomb_perfume",  {  pos_x = 172, pos_y = -39 } },
    } );
    ObjDelete( "spr_maurce_tomb_bag"       );
    ObjDelete( "obj_maurce_tomb_clk_trash" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_maurce_tomb_trash",     clk_maurce_tomb_trash_beg, private.room_objname );
  cmn.AddSubscriber( "clk_maurce_tomb_trash",     clk_maurce_tomb_trash_end, private.room_objname );
  cmn.AddSubscriber( "clk_maurce_tomb_trash_beg", clk_maurce_tomb_trash_beg, private.room_objname );
  cmn.AddSubscriber( "clk_maurce_tomb_trash_end", clk_maurce_tomb_trash_end, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function clk_wooden_coffin_cap() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_wooden_coffin_cap" ] = {
    type = "click",
    use_place = "obj_wooden_coffin_clk_cap",
    room = private.room_objname,
    zz = "zz_wooden_coffin",
    zz_gate = "gzz_cemetery_3_wooden_coffin"
  };
  
  local clk_wooden_coffin_cap_beg = function ()

    ObjDelete( "obj_wooden_coffin_clk_cap" );
  
  end;
  local clk_wooden_coffin_cap_end = function ()

    ObjMultiSet( { 
      { "obj_wooden_coffin_use_tweezers", { input = true                 } },
      { "spr_wooden_coffin_stone_1",      { visible = true, input = true } },
      { "spr_wooden_coffin_sapling",      { visible = true, input = true } },
      { "spr_cemetery_3_coffin_open",     {     alp = 1                  } },
    } );
    ObjDelete( "obj_wooden_coffin_clk_cap" );
    ObjDelete( "obj_wooden_coffin_close"   );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_wooden_coffin_cap",     clk_wooden_coffin_cap_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wooden_coffin_cap",     clk_wooden_coffin_cap_end, private.room_objname );
  cmn.AddSubscriber( "clk_wooden_coffin_cap_beg", clk_wooden_coffin_cap_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wooden_coffin_cap_end", clk_wooden_coffin_cap_end, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_pincers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pincers" ] = {
    type = "get",
    get_obj = "spr_crypt_pincers",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  
  local get_pincers_inv = function ()
  
    interface.InventoryItemAdd( "inv_pincers", "spr_crypt_pincers" );
  
  end;
  
  local get_pincers_closezz = function ()
  
    ObjDelete( "gfx_crypt_pincers" );
  
  end;
  
  cmn.AddSubscriber( "get_pincers", get_pincers_inv );
  cmn.AddSubscriber( "get_pincers", get_pincers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_maggie_sign () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_maggie_sign" ] = {
    type = "get",
    get_obj = "spr_crypt_maggie_sign",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  
  local get_maggie_sign_inv = function ()
  
    interface.InventoryItemAdd( "inv_maggie_sign", "spr_crypt_maggie_sign" );
  
  end;
  
  local get_maggie_sign_closezz = function ()
  
    ObjDelete( "gfx_crypt_maggie_sign" );
  
  end;
  
  cmn.AddSubscriber( "get_maggie_sign", get_maggie_sign_inv );
  cmn.AddSubscriber( "get_maggie_sign", get_maggie_sign_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hunter_horn () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hunter_horn" ] = {
    type = "get",
    get_obj = "spr_crypt_hunter_horn",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  
  local get_hunter_horn_inv = function ()
  
    interface.InventoryItemAdd( "inv_hunter_horn", "spr_crypt_hunter_horn" );
  
  end;
  
  local get_hunter_horn_closezz = function ()
  
    ObjDelete( "gfx_crypt_hunter_horn" );
  
  end;
  
  cmn.AddSubscriber( "get_hunter_horn", get_hunter_horn_inv );
  cmn.AddSubscriber( "get_hunter_horn", get_hunter_horn_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fang () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fang" ] = {
    type = "get",
    get_obj = "spr_crypt_fang",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  
  local get_fang_inv = function ()
  
    interface.InventoryItemAdd( "inv_fang", "spr_crypt_fang" );
  
  end;
  
  local get_fang_closezz = function ()
  
    ObjDelete( "gfx_crypt_fang" );
  
  end;
  
  cmn.AddSubscriber( "get_fang", get_fang_inv );
  cmn.AddSubscriber( "get_fang", get_fang_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bone" ] = {
    type = "get",
    get_obj = "spr_crypt_bone",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  
  local get_bone_inv = function ()
  
    interface.InventoryItemAdd( "inv_bone", "spr_crypt_bone" );
  
  end;
  
  local get_bone_closezz = function ()
  
    ObjDelete( "gfx_crypt_bone" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_22" ) ) then
      
      ObjDelete( "gzz_cemetery_3_crypt" );
      
    end;  
    
  end;
  
  cmn.AddSubscriber( "get_bone", get_bone_inv );
  cmn.AddSubscriber( "get_bone", get_bone_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_code () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_code" ] = {
    type = "get",
    get_obj = "spr_maurce_tomb_code",
    room = private.room_objname,
    zz = "zz_maurce_tomb",
    zz_gate = "gzz_cemetery_3_maurce_tomb"
  };
  
  local get_code_inv = function ()
  
    interface.InventoryItemAdd( "inv_code", "spr_maurce_tomb_code" );
  
  end;
  
  local get_code_closezz = function ()
  
    ObjDelete( "gfx_maurce_tomb_code" );
  
  end;
  
  cmn.AddSubscriber( "get_code", get_code_inv );
  cmn.AddSubscriber( "get_code", get_code_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tweezers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tweezers" ] = {
    type = "get",
    get_obj = "spr_maurce_tomb_tweezers",
    room = private.room_objname,
    zz = "zz_maurce_tomb",
    zz_gate = "gzz_cemetery_3_maurce_tomb"
  };
  
  local get_tweezers_inv = function ()
  
    interface.InventoryItemAdd( "inv_tweezers", "spr_maurce_tomb_tweezers" );
  
  end;
  
  local get_tweezers_closezz = function ()
  
    ObjDelete( "gfx_maurce_tomb_tweezers" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_20" ) ) then
      
      ObjDelete( "gzz_cemetery_3_maurce_tomb" );
      
    end;  
    
  end;
  
  cmn.AddSubscriber( "get_tweezers", get_tweezers_inv );
  cmn.AddSubscriber( "get_tweezers", get_tweezers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stone_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stone_1" ] = {
    type = "get",
    get_obj = "spr_wooden_coffin_stone_1",
    room = private.room_objname,
    zz = "zz_wooden_coffin",
    zz_gate = "gzz_cemetery_3_wooden_coffin"
  };
  
  local get_stone_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_stone_1", "spr_wooden_coffin_stone_1" );
  
  end;
  
  local get_stone_1_closezz = function ()
  
    ObjDelete( "gfx_wooden_coffin_stone_1" );
  
  end;
  
  cmn.AddSubscriber( "get_stone_1", get_stone_1_inv );
  cmn.AddSubscriber( "get_stone_1", get_stone_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sapling () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sapling" ] = {
    type = "get",
    get_obj = "spr_wooden_coffin_sapling",
    room = private.room_objname,
    zz = "zz_wooden_coffin",
    zz_gate = "gzz_cemetery_3_wooden_coffin"
  };
  
  local get_sapling_inv = function ()
  
    interface.InventoryItemAdd( "inv_sapling", "spr_wooden_coffin_sapling" );
  
  end;
  
  local get_sapling_closezz = function ()
  
    ObjDelete( "gfx_wooden_coffin_sapling" );
  
  end;
  
  cmn.AddSubscriber( "get_sapling", get_sapling_inv );
  cmn.AddSubscriber( "get_sapling", get_sapling_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hillmark_monogram () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hillmark_monogram" ] = {
    type = "get",
    get_obj = "spr_wooden_coffin_hillmark_monogram",
    room = private.room_objname,
    zz = "zz_wooden_coffin",
    zz_gate = "gzz_cemetery_3_wooden_coffin"
  };
  
  local get_hillmark_monogram_inv = function ()
  
    interface.InventoryItemAdd( "inv_hillmark_monogram", "spr_wooden_coffin_hillmark_monogram" );
  
  end;
  
  local get_hillmark_monogram_closezz = function ()
  
    ObjDelete( "gfx_wooden_coffin_hillmark_monogram" );
    ObjDelete( "gzz_cemetery_3_wooden_coffin" );
  
  end;
  
  cmn.AddSubscriber( "get_hillmark_monogram", get_hillmark_monogram_inv );
  cmn.AddSubscriber( "get_hillmark_monogram", get_hillmark_monogram_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_black_cat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_black_cat" ] = {
    type = "get",
    get_obj = "spr_cemetery_3_black_cat",
    room = private.room_objname 
  };
  
  local get_black_cat_inv = function ()
  
    interface.InventoryItemAdd( "inv_black_cat", "spr_cemetery_3_black_cat" );
  
  end;
  
  local get_black_cat_closezz = function ()
  
    ObjDelete( "gfx_cemetery_3_black_cat" );
  
  end;
  
  cmn.AddSubscriber( "get_black_cat", get_black_cat_inv );
  cmn.AddSubscriber( "get_black_cat", get_black_cat_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_20 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_20 = function ()
  
    ObjDelete( "obj_maurce_tomb_collect2_item_20" ); 
  
    if ( cmn.IsEventDone( "get_tweezers" ) ) then
      
      ObjDelete( "gzz_cemetery_3_maurce_tomb" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_20", get_collect2_item_20, private.room_objname );   
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_22 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_22 = function ()
  
    ObjDelete( "obj_crypt_collect2_item_22" ); 
  
    if ( cmn.IsEventDone( "get_bone" ) ) then
      
      ObjDelete( "gzz_cemetery_3_crypt" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_22", get_collect2_item_22, private.room_objname );   
  --------------------------------------------------------------------------------------------
  -- function use_black_cat_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_black_cat_1" ] = {
    type = "use",
    inv_obj = "inv_black_cat",
    use_place = "obj_crypt_use_black_cat",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  local use_black_cat_1_inv = function ()
    
    if ( cmn.IsEventDone( "use_black_cat_2" ) ) then

      interface.InventoryItemRemove( "inv_black_cat" );
      
    end;  
    
  end;
  local use_black_cat_1_beg = function ()
  
    ObjDelete( "obj_crypt_use_black_cat" );
  
  end;
  local use_black_cat_1_end = function ()
  
    ObjMultiSet( { 
      { "spr_crypt_hunter_horn", { pos_x = 113, pos_y = 82, alp = 1,  input = true } },
      { "gfx_crypt_hunter_horn", {                                   active = true } }
    } );
    ObjDelete( "anm_crypt_use_cat" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_black_cat_1", use_black_cat_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_black_cat_1", use_black_cat_1_inv );
  cmn.AddSubscriber( "use_black_cat_1", use_black_cat_1_end, private.room_objname );
  cmn.AddSubscriber( "use_black_cat_1_inv", use_black_cat_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_black_cat_1_beg", use_black_cat_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_black_cat_1_end", use_black_cat_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gothic_pattern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gothic_pattern" ] = {
    type = "use",
    inv_obj = "inv_gothic_pattern",
    use_place = "obj_crypt_use_gothic_pattern",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  local use_gothic_pattern_inv = function ()
  
    interface.InventoryItemRemove( "inv_gothic_pattern" );
  
  end;
  local use_gothic_pattern_beg = function ()
  
    ObjDelete( "obj_crypt_use_gothic_pattern" );
  
  end;
  local use_gothic_pattern_end = function ()
  
    ObjMultiSet( { 
      { "spr_crypt_pincers",  { input = true } },
    } );
    ObjDelete( "spr_crypt_door"            );
    ObjDelete( "anm_crypt_door"            );
    ObjDelete( "spr_cemetery_3_door_crypt" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gothic_pattern", use_gothic_pattern_beg, private.room_objname );
  cmn.AddSubscriber( "use_gothic_pattern", use_gothic_pattern_inv );
  cmn.AddSubscriber( "use_gothic_pattern", use_gothic_pattern_end, private.room_objname );
  cmn.AddSubscriber( "use_gothic_pattern_inv", use_gothic_pattern_inv, private.room_objname );
  cmn.AddSubscriber( "use_gothic_pattern_beg", use_gothic_pattern_beg, private.room_objname );
  cmn.AddSubscriber( "use_gothic_pattern_end", use_gothic_pattern_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wool_piece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wool_piece" ] = {
    type = "use",
    inv_obj = "inv_wool_piece",
    use_place = "obj_crypt_use_wool_piece",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  local use_wool_piece_inv = function ()
  
    interface.InventoryItemRemove( "inv_wool_piece" );
  
  end;
  local use_wool_piece_beg = function ()
  
    ObjDelete( "obj_crypt_use_wool_piece" );
  
  end;
  local use_wool_piece_end = function ()
    
    ObjDelete( "spr_crypt_web" );
    ObjDelete( "anm_crypt_web" );
    ObjMultiSet( { 
      { "spr_crypt_maggie_sign",  {    alp = 1, input = true } },
      { "gfx_crypt_maggie_sign",  { active = true            } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wool_piece", use_wool_piece_beg, private.room_objname );
  cmn.AddSubscriber( "use_wool_piece", use_wool_piece_inv );
  cmn.AddSubscriber( "use_wool_piece", use_wool_piece_end, private.room_objname );
  cmn.AddSubscriber( "use_wool_piece_inv", use_wool_piece_inv, private.room_objname );
  cmn.AddSubscriber( "use_wool_piece_beg", use_wool_piece_beg, private.room_objname );
  cmn.AddSubscriber( "use_wool_piece_end", use_wool_piece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stone_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stone_1" ] = {
    type = "use",
    inv_obj = "inv_stone_1",
    use_place = "obj_crypt_use_stone_1",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  local use_stone_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_stone_1" );
  
  end;
  local use_stone_1_beg = function ()
  
    ObjDelete( "obj_crypt_use_stone_1" );
  
  end;
  local use_stone_1_end = function ()
    
    ObjMultiSet( { 
      { "spr_crypt_stone1",  { alp = 1 } },
    } );
    
    if ( cmn.IsEventDone( "use_stone_2" ) ) then
      
      ObjDelete( "spr_crypt_fang_hh" );      
      ObjMultiSet( { 
        { "spr_crypt_fang",  {  input = true           } },
        { "anm_crypt_tooth", {    alp = 1, frame = 300 } },
        { "gfx_crypt_fang",  { active = true           } },
      } );
        
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stone_1", use_stone_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_1", use_stone_1_inv );
  cmn.AddSubscriber( "use_stone_1", use_stone_1_end, private.room_objname );
  cmn.AddSubscriber( "use_stone_1_inv", use_stone_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_stone_1_beg", use_stone_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_1_end", use_stone_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stone_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stone_2" ] = {
    type = "use",
    inv_obj = "inv_stone_2",
    use_place = "obj_crypt_use_stone_2",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  local use_stone_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_stone_2" );
  
  end;
  local use_stone_2_beg = function ()
  
    ObjDelete( "obj_crypt_use_stone_2" );
  
  end;
  local use_stone_2_end = function ()
    
    ObjMultiSet( { 
      { "spr_crypt_stone2",  { alp = 1 } },
    } );
    
    if ( cmn.IsEventDone( "use_stone_1" ) ) then
      
      ObjDelete( "spr_crypt_fang_hh" );
      ObjMultiSet( { 
        { "spr_crypt_fang",  {  input = true           } },
        { "anm_crypt_tooth", {    alp = 1, frame = 300 } },
        { "gfx_crypt_fang",  { active = true           } },
      } );
        
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stone_2", use_stone_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_2", use_stone_2_inv );
  cmn.AddSubscriber( "use_stone_2", use_stone_2_end, private.room_objname );
  cmn.AddSubscriber( "use_stone_2_inv", use_stone_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_stone_2_beg", use_stone_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_2_end", use_stone_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cross () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cross" ] = {
    type = "use",
    inv_obj = "inv_cross",
    use_place = "obj_crypt_use_cross",
    room = private.room_objname,
    zz = "zz_crypt",
    zz_gate = "gzz_cemetery_3_crypt"
  };
  local use_cross_inv = function ()
  
    interface.InventoryItemRemove( "inv_cross" );
  
  end;
  local use_cross_beg = function ()
  
    ObjDelete( "obj_crypt_use_cross" );
  
  end;
  local use_cross_end = function ()
    
    ObjDelete( "spr_crypt_wall" );
    ObjMultiSet( { 
      { "spr_crypt_cross", {    alp = 1    } },
      { "spr_crypt_bone",  {  input = true } },
      { "gfx_crypt_bone",  { active = true } },
      { "anm_crypt_bone",  {  frame = 300  } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cross", use_cross_beg, private.room_objname );
  cmn.AddSubscriber( "use_cross", use_cross_inv );
  cmn.AddSubscriber( "use_cross", use_cross_end, private.room_objname );
  cmn.AddSubscriber( "use_cross_inv", use_cross_inv, private.room_objname );
  cmn.AddSubscriber( "use_cross_beg", use_cross_beg, private.room_objname );
  cmn.AddSubscriber( "use_cross_end", use_cross_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_maggie_sign () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_maggie_sign" ] = {
    type = "use",
    inv_obj = "inv_maggie_sign",
    use_place = "obj_maurce_tomb_use_maggie_sign",
    room = private.room_objname,
    zz = "zz_maurce_tomb",
    zz_gate = "gzz_cemetery_3_maurce_tomb"
  };
  local use_maggie_sign_inv = function ()
  
    interface.InventoryItemRemove( "inv_maggie_sign" );
  
  end;
  local use_maggie_sign_beg = function ()
  
    ObjDelete( "obj_maurce_tomb_use_maggie_sign" );
  
  end;
  local use_maggie_sign_end = function ()
  
    ObjMultiSet( { 
      { "spr_maurce_tomb_fox",     {   alp = 1 } },
      { "obj_maurce_tomb_clk_bag", { input = 1 } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_maggie_sign", use_maggie_sign_beg, private.room_objname );
  cmn.AddSubscriber( "use_maggie_sign", use_maggie_sign_inv );
  cmn.AddSubscriber( "use_maggie_sign", use_maggie_sign_end, private.room_objname );
  cmn.AddSubscriber( "use_maggie_sign_inv", use_maggie_sign_inv, private.room_objname );
  cmn.AddSubscriber( "use_maggie_sign_beg", use_maggie_sign_beg, private.room_objname );
  cmn.AddSubscriber( "use_maggie_sign_end", use_maggie_sign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crumpled_paper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crumpled_paper" ] = {
    type = "use",
    inv_obj = "inv_crumpled_paper",
    use_place = "obj_maurce_tomb_use_crumpled_paper",
    room = private.room_objname,
    zz = "zz_maurce_tomb",
    zz_gate = "gzz_cemetery_3_maurce_tomb"
  };
  local use_crumpled_paper_inv = function ()
  
    interface.InventoryItemRemove( "inv_crumpled_paper" );
  
  end;
  local use_crumpled_paper_beg = function ()
  
    ObjDelete( "obj_maurce_tomb_use_crumpled_paper" );
  
  end;
  local use_crumpled_paper_end = function ()
    
    ObjMultiSet( { 
      { "anm_maurce_coal",          {   alp = 1    } },
      { "anm_maurce_paper",         { frame = 300  } },
      { "obj_maurce_tomb_use_coal", { input = true } },
    } );
        
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crumpled_paper", use_crumpled_paper_beg, private.room_objname );
  cmn.AddSubscriber( "use_crumpled_paper", use_crumpled_paper_inv );
  cmn.AddSubscriber( "use_crumpled_paper", use_crumpled_paper_end, private.room_objname );
  cmn.AddSubscriber( "use_crumpled_paper_inv", use_crumpled_paper_inv, private.room_objname );
  cmn.AddSubscriber( "use_crumpled_paper_beg", use_crumpled_paper_beg, private.room_objname );
  cmn.AddSubscriber( "use_crumpled_paper_end", use_crumpled_paper_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coal () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coal" ] = {
    type = "use",
    inv_obj = "inv_coal",
    use_place = "obj_maurce_tomb_use_coal",
    room = private.room_objname,
    zz = "zz_maurce_tomb",
    zz_gate = "gzz_cemetery_3_maurce_tomb"
  };
  local use_coal_inv = function ()
  
    interface.InventoryItemRemove( "inv_coal" );
  
  end;
  local use_coal_beg = function ()
  
    ObjDelete( "obj_maurce_tomb_use_coal" );
  
  end;
  local use_coal_end = function ()
  
    ObjMultiSet( { 
      { "spr_maurce_tomb_code",       {  input = true } },
      { "anm_maurce_coal",            {  frame = 300  } },
      { "gfx_maurce_tomb_code",       { active = true } },
    } );
        
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coal", use_coal_beg, private.room_objname );
  cmn.AddSubscriber( "use_coal", use_coal_inv );
  cmn.AddSubscriber( "use_coal", use_coal_end, private.room_objname );
  cmn.AddSubscriber( "use_coal_inv", use_coal_inv, private.room_objname );
  cmn.AddSubscriber( "use_coal_beg", use_coal_beg, private.room_objname );
  cmn.AddSubscriber( "use_coal_end", use_coal_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pincers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pincers" ] = {
    type = "use",
    inv_obj = "inv_pincers",
    use_place = "obj_wooden_coffin_use_pincers",
    room = private.room_objname,
    zz = "zz_wooden_coffin",
    zz_gate = "gzz_cemetery_3_wooden_coffin"
  };
  local use_pincers_inv = function ()
  
    interface.InventoryItemRemove( "inv_pincers" );
  
  end;
  local use_pincers_beg = function ()
  
    ObjDelete( "obj_wooden_coffin_use_pincers" );
  
  end;
  local use_pincers_end = function ()
    
    ObjDelete( "anm_wooden_coffin_nippers" );
    ObjMultiSet( { 
      { "obj_wooden_coffin_clk_cap",  { input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pincers", use_pincers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pincers", use_pincers_inv );
  cmn.AddSubscriber( "use_pincers", use_pincers_end, private.room_objname );
  cmn.AddSubscriber( "use_pincers_inv", use_pincers_inv, private.room_objname );
  cmn.AddSubscriber( "use_pincers_beg", use_pincers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pincers_end", use_pincers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers" ] = {
    type = "use",
    inv_obj = "inv_tweezers",
    use_place = "obj_wooden_coffin_use_tweezers",
    room = private.room_objname,
    zz = "zz_wooden_coffin",
    zz_gate = "gzz_cemetery_3_wooden_coffin"
  };
  local use_tweezers_inv = function ()
  
    interface.InventoryItemRemove( "inv_tweezers" );
  
  end;
  local use_tweezers_beg = function ()
  
    ObjDelete( "obj_wooden_coffin_use_tweezers" );
  
  end;
  local use_tweezers_end = function ()
    
    ObjDelete( "spr_wooden_coffin_hillmark_monogram_dub" );
    ObjDelete( "spr_wooden_coffin_patch" );
    
    ObjMultiSet( { 
      { "spr_wooden_coffin_hillmark_monogram", {    alp = 1, input = true } },
      { "anm_wooden_coffin_tweezers",          {    alp = 1, frame = 300  } },
      { "gfx_wooden_coffin_hillmark_monogram", { active = true            } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers", use_tweezers_inv );
  cmn.AddSubscriber( "use_tweezers", use_tweezers_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_inv", use_tweezers_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_beg", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_end", use_tweezers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_opened_can () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_opened_can" ] = {
    type = "use",
    inv_obj = "inv_opened_can",
    use_place = "obj_cemetery_3_use_opened_can",
    room = private.room_objname 
  };
  local use_opened_can_inv = function ()
  
    interface.InventoryItemRemove( "inv_opened_can" );
  
  end;
  local use_opened_can_beg = function ()
  
    ObjDelete( "obj_cemetery_3_use_opened_can" );
  
  end;
  local use_opened_can_end = function ()
  
    ObjMultiSet( { 
      { "spr_cemetery_3_black_cat",  {  input = true, alp = 1 } },
      { "gfx_cemetery_3_black_cat",  { active = true          } },
    } );
    ObjDelete( "obj_cemetery_3_anim_cat" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_opened_can", use_opened_can_beg, private.room_objname );
  cmn.AddSubscriber( "use_opened_can", use_opened_can_inv );
  cmn.AddSubscriber( "use_opened_can", use_opened_can_end, private.room_objname );
  cmn.AddSubscriber( "use_opened_can_inv", use_opened_can_inv, private.room_objname );
  cmn.AddSubscriber( "use_opened_can_beg", use_opened_can_beg, private.room_objname );
  cmn.AddSubscriber( "use_opened_can_end", use_opened_can_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_wooden_coffin_ghost () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_wooden_coffin_ghost" ] = {
    type = "click",
    use_place = "obj_cemetery_3_clk_wooden_coffin_ghost",
    room = private.room_objname
  };

  local see_wooden_coffin_ghost = function ()
  
    ObjDelete( "obj_cemetery_3_clk_wooden_coffin_ghost" );
    ObjDelete( "anm_cemetery_3_wooden_coffin_ghost"     );
    ObjMultiSet( { 
      { "gzz_cemetery_3_wooden_coffin", { input = true, active = true, visible = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_wooden_coffin_ghost", see_wooden_coffin_ghost, private.room_objname ); 

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_maurce_tomb () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_maurce_tomb" );  
    ------------------------------------------------- 
    function zz_maurce_tomb.Close ()
      
      local tb = {};
      
      table.insert( tb, "spr_maurce_tomb_token" );
      
      if cmn.IsEventDone( "clk_maurce_tomb_trash" ) then
        
        table.insert( tb, "spr_maurce_tomb_note" );
        
      end;
      
      cmn.NoteScaleClose( tb );
      
    end; 
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_cemetery_3();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level3/env/aud_cemetery_3_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level3/env/aud_cemetery_3_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_black_cat_1 ()

  local item = "inv_black_cat";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_crypt" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crypt" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_crypt_use_black_cat" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    cmn.CallEventHandler( "use_black_cat_1_inv" );
    cmn.CallEventHandler( "use_black_cat_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_black_cat_1" );
      cmn.CallEventHandler( "use_black_cat_1_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_cat1", 0, "", 0 );

    AnimPlay( "anm_crypt_use_cat", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_gothic_pattern ()

  local item = "inv_gothic_pattern";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_crypt" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crypt" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_crypt_use_gothic_pattern" ) ) then

    cmn.CallEventHandler( "use_gothic_pattern_inv" );
    cmn.CallEventHandler( "use_gothic_pattern_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_gothic_pattern" );
        cmn.CallEventHandler( "use_gothic_pattern_end" );
        
      end;
      
      ObjMultiSet( { 
        { "spr_crypt_door",  { alp = 0 } },
        { "anm_crypt_door",  { alp = 1 } },
      } );
      AnimPlay( "anm_crypt_door", "door", func_end_2 );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_gothic_pattern", 0, "", 0 );

    cmn.ItemFly( "spr_crypt_door_amulet", func_end, 1.22, 60 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wool_piece ()

  local item = "inv_wool_piece";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_crypt" ) ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crypt" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_crypt_use_wool_piece" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    cmn.CallEventHandler( "use_wool_piece_inv" );
    cmn.CallEventHandler( "use_wool_piece_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_wool_piece" );
      cmn.CallEventHandler( "use_wool_piece_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_broom3", 0, "", 0 );

    AnimPlay( "anm_crypt_web", "web", func_end ); 
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stone_1 ()

  local item = "inv_stone_1";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_crypt" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crypt" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_crypt_use_stone_1" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    cmn.CallEventHandler( "use_stone_1_inv" );
    cmn.CallEventHandler( "use_stone_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_stone_1" );
      cmn.CallEventHandler( "use_stone_1_end" );

    end;
    local func_end_2 = function ()
      
      if ( cmn.IsEventDone( "use_stone_2" ) ) then
        
        ObjMultiSet( { 
          { "spr_crypt_fang_hh", { alp = 0 } },
          { "anm_crypt_tooth",   { alp = 1 } },
        } );       
        AnimPlay( "anm_crypt_tooth", "tooth", func_end );
        
      else   
      
        func_end();
        
      end;
    
    end;
  
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_stone_part", 0, "", 0 );

    cmn.ItemFly( "spr_crypt_stone1", func_end_2, - 1.22 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stone_2 ()

  local item = "inv_stone_2";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_crypt" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crypt" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_crypt_use_stone_2" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    cmn.CallEventHandler( "use_stone_2_inv" );
    cmn.CallEventHandler( "use_stone_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_stone_2" );
      cmn.CallEventHandler( "use_stone_2_end" );

    end;
    
    local func_end_2 = function ()
      
      if ( cmn.IsEventDone( "use_stone_1" ) ) then
        
        ObjMultiSet( { 
          { "spr_crypt_fang_hh", { alp = 0 } },
          { "anm_crypt_tooth",   { alp = 1 } },
        } );       
        AnimPlay( "anm_crypt_tooth", "tooth", func_end );
        
      else   
      
        func_end();
        
      end;
    
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_stone_part", 0, "", 0 );

    cmn.ItemFly( "spr_crypt_stone2", func_end_2, 1.22 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cross ()

  local item = "inv_cross";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_crypt" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crypt" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_crypt_use_cross" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    cmn.CallEventHandler( "use_cross_inv" );
    cmn.CallEventHandler( "use_cross_beg" );

    local func_end = function ()

      local func_end_2 = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_cross" );
        cmn.CallEventHandler( "use_cross_end" );
        
      end;
      
      AnimPlay( "anm_crypt_bone", "bone", func_end_2 );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_cross", 0, "", 0 );

    cmn.ItemFly( "spr_crypt_cross", func_end, 1.22, 60 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_maggie_sign ()

  local item = "inv_maggie_sign";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_maurce_tomb" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_maurce_tomb" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_maurce_tomb_use_maggie_sign" ) ) then

    cmn.CallEventHandler( "use_maggie_sign_inv" );
    cmn.CallEventHandler( "use_maggie_sign_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_maggie_sign" );
      cmn.CallEventHandler( "use_maggie_sign_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_high", 0, "", 0 );

    cmn.ItemFly( "spr_maurce_tomb_fox", func_end, -1.22, 50 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_crumpled_paper ()

  local item = "inv_crumpled_paper";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_maurce_tomb" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_maurce_tomb" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_maurce_tomb_use_crumpled_paper" ) ) then

    cmn.CallEventHandler( "use_crumpled_paper_inv" );
    cmn.CallEventHandler( "use_crumpled_paper_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_crumpled_paper" );
      cmn.CallEventHandler( "use_crumpled_paper_end" );

      common_impl.PlayAudio( "sfx", "aud_clk_paper", 0, "", 0 );

    end;

    cmn.Lock( true );

    AnimPlay( "anm_maurce_paper", "paper", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_coal ()

  local item = "inv_coal";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_maurce_tomb" ) and 
       cmn.IsEventDone( "use_crumpled_paper" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_maurce_tomb" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_maurce_tomb_use_coal" ) and 
           cmn.IsEventDone( "use_crumpled_paper" ) ) then

    cmn.CallEventHandler( "use_coal_inv" );
    cmn.CallEventHandler( "use_coal_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_coal" );
      cmn.CallEventHandler( "use_coal_end" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_coal", 0, "", 0 );

    AnimPlay( "anm_maurce_coal", "coat", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pincers ()

  local item = "inv_pincers";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_wooden_coffin" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wooden_coffin" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wooden_coffin_use_pincers" ) ) then

    cmn.CallEventHandler( "use_pincers_inv" );
    cmn.CallEventHandler( "use_pincers_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_pincers" );
      cmn.CallEventHandler( "use_pincers_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_boltcutter", 0, "", 0 );

    AnimPlay( "anm_wooden_coffin_nippers", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tweezers ()

  local item = "inv_tweezers";

  if ( cmn.ApplyObj( item, "gzz_cemetery_3_wooden_coffin" ) and 
       cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wooden_coffin" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wooden_coffin_use_tweezers" ) and 
           cmn.IsEventDone( "clk_wooden_coffin_cap" ) ) then

    cmn.CallEventHandler( "use_tweezers_inv" );
    cmn.CallEventHandler( "use_tweezers_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tweezers" );
      cmn.CallEventHandler( "use_tweezers_end" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_tweezers", 0, "", 0 );
    ObjMultiSet( { 
      { "anm_wooden_coffin_tweezers",              { alp = 1 } },
      { "spr_wooden_coffin_hillmark_monogram_dub", { alp = 0 } },
      { "spr_wooden_coffin_patch",                 { alp = 0 } },
    } );
    AnimPlay( "anm_wooden_coffin_tweezers", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_opened_can ()

  local item = "inv_opened_can";

  if ( cmn.ApplyObj( item, "obj_cemetery_3_use_opened_can" ) ) then

    cmn.CallEventHandler( "use_opened_can_inv" );
    cmn.CallEventHandler( "use_opened_can_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_opened_can" );
      cmn.CallEventHandler( "use_opened_can_end" );

      private.get_black_cat();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_can", 0, "", 0 );

    ObjMultiSet( { 
      { "anm_cemetery_3_cat", { alp = 0 } },
      { "anm_cemetery_3_eat", { alp = 1 } },
    } );  
    AnimPlay( "anm_cemetery_3_eat", "eat", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_pincers ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pincers" );
  cmn.CallEventHandler( "get_pincers" );

end;
--------------------------------------------------------------------------------------------
function private.get_maggie_sign ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_maggie_sign" );
  cmn.CallEventHandler( "get_maggie_sign" );

end;
--------------------------------------------------------------------------------------------
function private.get_hunter_horn ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hunter_horn" );
  cmn.CallEventHandler( "get_hunter_horn" );

end;
--------------------------------------------------------------------------------------------
function private.get_fang ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fang" );
  cmn.CallEventHandler( "get_fang" );

end;
--------------------------------------------------------------------------------------------
function private.get_bone ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bone" );
  cmn.CallEventHandler( "get_bone" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_22" ) ) then
    
    common.CloseSubRoom();
    
  end; 

end;
--------------------------------------------------------------------------------------------
function private.get_code ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_code" );
  cmn.CallEventHandler( "get_code" );

end;
--------------------------------------------------------------------------------------------
function private.get_tweezers ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tweezers" );
  cmn.CallEventHandler( "get_tweezers" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_20" ) ) then
    
    common.CloseSubRoom();
    
  end; 
  

end;
--------------------------------------------------------------------------------------------
function private.get_stone_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stone_1" );
  cmn.CallEventHandler( "get_stone_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_sapling ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sapling" );
  cmn.CallEventHandler( "get_sapling" );

end;
--------------------------------------------------------------------------------------------
function private.get_hillmark_monogram ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hillmark_monogram" );
  cmn.CallEventHandler( "get_hillmark_monogram" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_black_cat ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_black_cat" );
  cmn.CallEventHandler( "get_black_cat" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_20 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_20" ); 

  end;

  common_impl.PlayEffectHO( "spr_maurce_tomb_collect2_item_20", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_20" );
  
  if ( cmn.IsEventDone( "get_tweezers" ) ) then

    common.CloseSubRoom();

  end; 
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_22 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_22" ); 

  end;

  common_impl.PlayEffectHO( "spr_crypt_collect2_item_22", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_22" );
  
  if ( cmn.IsEventDone( "get_bone" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_maurce_tomb_bag ()
  
  cmn.CallEventHandler( "clk_maurce_tomb_bag_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_maurce_tomb_bag" );
    cmn.CallEventHandler( "clk_maurce_tomb_bag_end" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_bag", 0, "", 0 );
  
  ObjAnimate( "obj_maurce_tomb_bag", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 3, 1 } );
  ObjAnimate( "spr_maurce_tomb_bag", "alp", 0, 0, "", { 0, 0, 1,   0.3, 3, 0 } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_maurce_tomb_trash ()
  
  cmn.CallEventHandler( "clk_maurce_tomb_trash_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_maurce_tomb_trash" );
    cmn.CallEventHandler( "clk_maurce_tomb_trash_end" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_maurce_tomb_trash", 0, "", 0 );

  ObjAnimate( "spr_maurce_tomb_comb", "pos_xy", 0, 0, "", { 
    0.0, 0, ObjGet( "spr_maurce_tomb_comb" ).pos_x, ObjGet( "spr_maurce_tomb_comb" ).pos_y, 
    0.3, 3, 284, -69,
  } );
  ObjAnimate( "spr_maurce_tomb_bracelet", "pos_xy", 0, 0, "", { 
    0.0, 0, ObjGet( "spr_maurce_tomb_bracelet" ).pos_x, ObjGet( "spr_maurce_tomb_bracelet" ).pos_y,
    0.1, 0, ObjGet( "spr_maurce_tomb_bracelet" ).pos_x, ObjGet( "spr_maurce_tomb_bracelet" ).pos_y, 
    0.4, 3, 267, -48,
  } );
  ObjAnimate( "spr_maurce_tomb_pen", "pos_xy", 0, 0, "", { 
    0.0, 0, ObjGet( "spr_maurce_tomb_pen" ).pos_x, ObjGet( "spr_maurce_tomb_pen" ).pos_y, 
    0.2, 0, ObjGet( "spr_maurce_tomb_pen" ).pos_x, ObjGet( "spr_maurce_tomb_pen" ).pos_y, 
    0.5, 3, 180, -37,
  } );
  ObjAnimate( "spr_maurce_tomb_perfume", "pos_xy", 0, 0, func_end, { 
    0.0, 0, ObjGet( "spr_maurce_tomb_perfume" ).pos_x, ObjGet( "spr_maurce_tomb_perfume" ).pos_y, 
    0.3, 0, ObjGet( "spr_maurce_tomb_perfume" ).pos_x, ObjGet( "spr_maurce_tomb_perfume" ).pos_y,
    0.6, 3, 172, -39, 
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_wooden_coffin_cap ()
  
  cmn.CallEventHandler( "clk_wooden_coffin_cap_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_wooden_coffin_cap" );
    cmn.CallEventHandler( "clk_wooden_coffin_cap_end" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_slide_wood_cover", 0, "", 0 );
  
  ObjAnimate( "obj_wooden_coffin_close", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   1.2, 3, 200, 560 } );
  
end;--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )  
end;
--------------------------------------------------------------------------------------------
function private.see_wooden_coffin_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_wooden_coffin_ghost" );
    cmn.CallEventHandler( "see_wooden_coffin_ghost" );

    common_impl.ShowBbt( 'bbt_cemetery_3_see_wooden_coffin_ghost' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_girls_ghost_sc", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_cemetery_3_wooden_coffin_ghost", { alp = 1 } },
  } );

  AnimPlay( "anm_cemetery_3_wooden_coffin_ghost", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_cemetery_3 ()

  if not ( cmn.IsEventDone( "opn_cemetery_3" ) ) then

    cmn.SetEventDone( "opn_cemetery_3" );

    common_impl.ShowBbt( 'bbt_cemetery_3_opn_cemetery_3' );

  end;
  cmn.CallEventHandler( "opn_cemetery_3" ); 
  
end;
--------------------------------------------------------------------------------------------
function private.TokenClick ()

  local func_end = function ()
  
    cmn.Lock( false );
    
    ObjSet( "spr_maurce_tomb_token_big1", { input = true } );
  
  end;
  
  cmn.Lock( true );
  
  ObjAnimate( "spr_maurce_tomb_token_big", "scale_y", 0, 0, func_end, { 0, 0, 1,   0.2, 3, 0,   0.4, 3, 1 } );
  ObjAnimate( "spr_maurce_tomb_token_big1", "alp", 0, 0, "", { 0, 0, 0,   0.2, 3, 0,   0.2, 3, 1 } );
  ObjAnimate( "spr_maurce_tomb_token_big2", "alp", 0, 0, "", { 0, 0, 1,   0.2, 3, 1,   0.2, 3, 0 } );  
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.UseMaggieSign ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_maurce_tomb_use_maggie_sign' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_bag", 0, "", 0 );

  ObjAnimate( "spr_maurce_tomb_bag", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 0, 1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseTweezers ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_wooden_coffin_use_tweezers' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_opn_clock", 0, "", 0 );

  ObjAnimate( "spr_wooden_coffin_hillmark_monogram_dub", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1, -1,   0.4, 3, 0, 0 } );
  
end;
--------------------------------------------------------------------------------------------
function private.UsePincers ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_wooden_coffin_use_pincers' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_low_door", 0, "", 0 );

  ObjAnimate( "obj_wooden_coffin_close", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 1, 2,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UsePattern ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_crypt_use_gothic_pattern' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_stone_door2", 0, "", 0 );

  ObjAnimate( "spr_crypt_door", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 2, 0,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseWoolPiece ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_crypt_use_wool_piece' );
    ObjMultiSet( { 
      { "anm_crypt_web",         { alp = 1 } },
      { "spr_crypt_web",         { alp = 0 } },
      { "spr_crypt_maggie_sign", { alp = 0 } },
    } ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_net", 0, "", 0 );
  
  ObjMultiSet( { 
    { "anm_crypt_web",         { alp = 0 } },
    { "spr_crypt_web",         { alp = 1 } },
    { "spr_crypt_maggie_sign", { alp = 1 } },
  } );  
  ObjAnimate( "spr_crypt_web", "scale_xy", 0, 0, func_end, { 0, 0, 1, 1,   0.2, 3, 1.02,1.02,   0.4, 3, 1, 1 } );
  ObjAnimate( "spr_crypt_web2", "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.2, 3, 0.94,0.94,   0.4, 3, 1, 1 } );
  
end;
--------------------------------------------------------------------------------------------
function private.UseBlackCat ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_crypt_use_black_cat' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx", 0, "", 0 );

  ObjAnimate( "spr_crypt_hunter_horn", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, -2, -1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseStone ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_crypt_use_stone_1' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_fang", 0, "", 0 );

  ObjAnimate( "spr_crypt_fang_hh", "ang", 0, 1, func_end, { 0, 0, 0,  0.2, 3, 0.06,   0.4, 3, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseCross ()
  
  --local func_end = function ()
  --
  --  cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_crypt_use_cross' );
--  
--  end;
--  
--  cmn.Lock( true );
--  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx", 0, "", 0 );
--
--  ObjAnimate( "spr_crypt_wall", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, -1, 0,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseOpenedCan ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_cemetery_3_use_opened_can' );
    ObjMultiSet( { 
      { "anm_cemetery_3_cat",       { alp = 1 } },
      { "anm_cemetery_3_cat_click", { alp = 0 } },
    } ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_kitten", 0, "", 0 );
  
  ObjMultiSet( { 
    { "anm_cemetery_3_cat",       { alp = 0 } },
    { "anm_cemetery_3_cat_click", { alp = 1 } },
  } );  
  AnimPlay( "anm_cemetery_3_cat_click", "cat_click", func_end );
  
end;
--------------------------------------------------------------------------------------------