-- name=rm_lucien_room
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lucien_room";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_safe",                "room_hub" );
  ObjAttach( "zz_coffee_table",        "room_hub" );
  ObjAttach( "zz_bedroom_drawerchest", "room_hub" );
  ObjAttach( "zz_window",              "room_hub" );

  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_coffee_table_will",                          { event_mdown = private.get_will                  }},
    { "spr_coffee_table_crumpled_paper",                { event_mdown = private.get_crumpled_paper        }},
    { "spr_coffee_table_hands",                         { event_mdown = private.get_hands                 }},
    { "spr_coffee_table_figurine",                      { event_mdown = private.get_figurine              }},
    { "spr_coffee_table_ship_model",                    { event_mdown = private.get_ship_model            }},
    { "obj_coffee_table_clk_clock",                     { event_mdown = private.clk_coffee_table_clock    }},
    { "obj_coffee_table_use_chisel",                    { event_mdown = private.AnimUseChisel             }},
    { "obj_coffee_table_use_golden_key",                { event_mdown = private.AnimUseGoldenKey          }},
    { "obj_coffee_table_use_flag_1",                    { event_mdown = private.AnimUseFlags              }},
    { "obj_coffee_table_use_flag_2",                    { event_mdown = private.AnimUseFlags              }},
    { "obj_coffee_table_use_flag_3",                    { event_mdown = private.AnimUseFlags              }},
    
    { "spr_bedroom_drawerchest_torn_shirt",             { event_mdown = private.get_torn_shirt            }},
    { "spr_bedroom_drawerchest_can",                    { event_mdown = private.get_can                   }},
    { "spr_bedroom_drawerchest_amulet_part_3",          { event_mdown = private.get_amulet_part_3         }},
    { "spr_bedroom_drawerchest_disk",                   { event_mdown = private.get_disk                  }},
    { "spr_bedroom_drawerchest_barber_key",             { event_mdown = private.get_barber_key            }},
    { "obj_bedroom_drawerchest_clk_wrought_handle",     { event_mdown = private.clk_wrought_handle        }},
    { "obj_bedroom_drawerchest_use_hillmark_monogram",  { event_mdown = private.AnimUseHillmarkMonogram   }},
    { "obj_bedroom_drawerchest_use_lucien_signet",      { event_mdown = private.AnimUseLucienSignet       }},
    { "obj_bedroom_drawerchest_use_wrought_handle",     { event_mdown = private.AnimUseWroughtHandle      }},
 
    { "spr_window_diamond",                             { event_mdown = private.get_diamond_lvl3          }},
    { "spr_window_amulet_part_1",                       { event_mdown = private.get_amulet_part_1         }},
    { "spr_window_coal",                                { event_mdown = private.get_coal                  }},
    { "obj_window_handle",                              { event_mdown = private.get_wrought_handle        }},
    { "spr_window_chisel",                              { event_mdown = private.get_chisel                }},
    { "spr_window_flag_1",                              { event_mdown = private.get_flag_1                }},
    { "obj_window_use_bas_relief",                      { event_mdown = private.AnimUseBasRelief          }},
    { "obj_window_see_scare",                           { event_mdown = private.see_scare_window          }},
    { "obj_window_use_disk",                            { event_mdown = private.AnimUseDisk               }},
    { "obj_window_use_decorative_fragment",             { event_mdown = private.AnimUseDecorativeFragment }},
    { "obj_window_clk_handle",                          { event_mdown = private.clk_window_handle         }},
    { "obj_window_clk_window",                          { event_mdown = private.clk_window_open           }},
    
    { "spr_lucien_room_golden_key",                     { event_mdown = private.get_golden_key            }},
    { "obj_lucien_room_clk_lucien_1",                   { event_mdown = private.dlg_lucien_room_lucien_1  }},
    { "obj_lucien_room_clk_lucien_1_focus",             { event_mdown = private.dlg_lucien_room_lucien_1  }},

    { "spr_lucien_room_collect_morph_item",   { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_14" ); end } },
      
    { "spr_bedroom_drawerchest_collect2_item_21",  { event_mdown = private.get_collect2_item_21      }}, 
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_lucien_room = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gho_lucien_room_in_safe",
      "gho_lucien_room_lucien_table",
      "gzz_lucien_room_safe",
      "gzz_lucien_room_coffee_table",
      "gzz_lucien_room_bedroom_drawerchest",
      "gzz_lucien_room_window",
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_safe",
      "zz_coffee_table",
      "zz_bedroom_drawerchest",
      "zz_window",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_lucien_room", update_game_mode_lucien_room, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_lucien_room = function ()

    local effects_table = 
    {
      "obj_lucien_room_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_lucien_room", update_performance_mode_lucien_room, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_lucien_room () end;
  --------------------------------------------------------------------------------------------
  local opn_lucien_room_map = function ()

    common_impl.VisitMapRoom( "lucien_room" );

  end;
  cmn.AddSubscriber( "opn_lucien_room", opn_lucien_room_map );
  
 --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_14 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_14 = function ()
  
    ObjDelete( "obj_lucien_room_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_14", get_collect_morph_item_14, private.room_objname ); 


  --------------------------------------------------------------------------------------------
  -- function get_will () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_will" ] = {
    type = "get",
    get_obj = "spr_coffee_table_will",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  
  local get_will_inv = function ()
  
    interface.InventoryItemAdd( "inv_will", "spr_coffee_table_will" );
    ObjSet( "inv_will", { drag = false } );
  
  end;
  
  local get_will_closezz = function ()
  
    ObjDelete( "gfx_coffee_table_will" );
  
  end;
  
  cmn.AddSubscriber( "get_will", get_will_inv );
  cmn.AddSubscriber( "get_will", get_will_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crumpled_paper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crumpled_paper" ] = {
    type = "get",
    get_obj = "spr_coffee_table_crumpled_paper",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  
  local get_crumpled_paper_inv = function ()
  
    interface.InventoryItemAdd( "inv_crumpled_paper", "spr_coffee_table_crumpled_paper" );
  
  end;
  
  local get_crumpled_paper_closezz = function ()
  
    ObjDelete( "gfx_coffee_table_crumpled_paper" );
    ObjDelete( "spr_lucien_room_table_papper" );
    ObjMultiSet( { 
      { "obj_coffee_table_use_chisel",  { input = true } },
    } );
    
  end;
  
  cmn.AddSubscriber( "get_crumpled_paper", get_crumpled_paper_inv );
  cmn.AddSubscriber( "get_crumpled_paper", get_crumpled_paper_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hands () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hands" ] = {
    type = "get",
    get_obj = "spr_coffee_table_hands",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  
  local get_hands_inv = function ()
  
    interface.InventoryItemAdd( "inv_hands", "spr_coffee_table_hands" );
  
  end;
  
  local get_hands_closezz = function ()
  
    ObjDelete( "gfx_coffee_table_hands" );
  
  end;
  
  cmn.AddSubscriber( "get_hands", get_hands_inv );
  cmn.AddSubscriber( "get_hands", get_hands_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurine" ] = {
    type = "get",
    get_obj = "spr_coffee_table_figurine",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  
  local get_figurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_figurine", "spr_coffee_table_figurine" );
  
  end;
  
  local get_figurine_closezz = function ()
  
    ObjDelete( "gfx_coffee_table_figurine" );
    ObjDelete( "spr_lucien_room_table_slice" );
  
  end;
  
  cmn.AddSubscriber( "get_figurine", get_figurine_inv );
  cmn.AddSubscriber( "get_figurine", get_figurine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ship_model () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ship_model" ] = {
    type = "get",
    get_obj = "spr_coffee_table_ship_model",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  
  local get_ship_model_inv = function ()
  
    interface.InventoryItemAdd( "inv_ship_model", "spr_coffee_table_ship_model" );
  
  end;
  
  local get_ship_model_closezz = function ()
  
    ObjDelete( "gfx_coffee_table_ship_model" );
  
  end;
  
  cmn.AddSubscriber( "get_ship_model", get_ship_model_inv );
  cmn.AddSubscriber( "get_ship_model", get_ship_model_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_torn_shirt () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_torn_shirt" ] = {
    type = "get",
    get_obj = "spr_bedroom_drawerchest_torn_shirt",
    room = private.room_objname,
    zz = "zz_bedroom_drawerchest",
    zz_gate = "gzz_lucien_room_bedroom_drawerchest"
  };
  
  local get_torn_shirt_inv = function ()
  
    interface.InventoryItemAdd( "inv_torn_shirt", "spr_bedroom_drawerchest_torn_shirt" );
    ObjSet( "inv_torn_shirt", { drag = false } );
    
  end;
  
  local get_torn_shirt_closezz = function ()
  
    ObjDelete( "gfx_bedroom_drawerchest_torn_shirt" );
    ObjDelete( "spr_lucien_room_short" );
    ObjMultiSet( { 
      { "obj_bedroom_drawerchest_use_hillmark_monogram", { input = true, active = true, visible = true } },
      { "obj_bedroom_drawerchest_use_lucien_signet",     { input = true, active = true, visible = true } },
    } );
  
  end;
  
  cmn.AddSubscriber( "get_torn_shirt", get_torn_shirt_inv );
  cmn.AddSubscriber( "get_torn_shirt", get_torn_shirt_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_can () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_can" ] = {
    type = "get",
    get_obj = "spr_bedroom_drawerchest_can",
    room = private.room_objname,
    zz = "zz_bedroom_drawerchest",
    zz_gate = "gzz_lucien_room_bedroom_drawerchest"
  };
  
  local get_can_inv = function ()
  
    interface.InventoryItemAdd( "inv_can", "spr_bedroom_drawerchest_can" );
    ObjSet( "inv_can", { drag = false } );
    
    if not cmn.IsEventDone( "get_opener" ) then
    
      cmn.SetInvPlusRGB( "can", false );
      
    end;
    
  end;
  
  local get_can_closezz = function ()
  
    ObjDelete( "gfx_bedroom_drawerchest_can" );
  
  end;
  
  cmn.AddSubscriber( "get_can", get_can_inv );
  cmn.AddSubscriber( "get_can", get_can_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulet_part_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulet_part_3" ] = {
    type = "get",
    get_obj = "spr_bedroom_drawerchest_amulet_part_3",
    room = private.room_objname,
    zz = "zz_bedroom_drawerchest",
    zz_gate = "gzz_lucien_room_bedroom_drawerchest"
  };
  
  local get_amulet_part_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_amulet_part_3", "spr_bedroom_drawerchest_amulet_part_3" );
    
    --if ( cmn.IsEventDone( "get_amulet_part_1" ) and cmn.IsEventDone( "get_amulet_part_2" ) and 
    --     cmn.IsEventDone( "get_amulet_part_3" ) and cmn.IsEventDone( "get_amulet_part_4" ) and 
    --     cmn.IsEventDone( "get_amulet_part_5" ) and cmn.IsEventDone( "get_amulet_part_6" )
    --    ) then
    --
    --    cmn.SetInvPlusRGB( "white_ghost_amulet", true );
    --    
    --end;
    cmn.SetInvPlusRGB( "white_ghost_amulet", true );    
  end;
  
  local get_amulet_part_3_closezz = function ()
  
    ObjDelete( "gfx_bedroom_drawerchest_amulet_part_3" );
    ObjDelete( "spr_lucien_room_amulet_part" );
    
    if ( cmn.IsEventDone( "get_barber_key" ) and
    cmn.IsGetCollect2( "get_collect2_item_21" ) ) then
      
      ObjDelete( "gzz_lucien_room_bedroom_drawerchest" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_amulet_part_3", get_amulet_part_3_inv );
  cmn.AddSubscriber( "get_amulet_part_3", get_amulet_part_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_disk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_disk" ] = {
    type = "get",
    get_obj = "spr_bedroom_drawerchest_disk",
    room = private.room_objname,
    zz = "zz_bedroom_drawerchest",
    zz_gate = "gzz_lucien_room_bedroom_drawerchest"
  };
  
  local get_disk_inv = function ()
  
    interface.InventoryItemAdd( "inv_disk", "spr_bedroom_drawerchest_disk" );
  
  end;
  
  local get_disk_closezz = function ()
  
    ObjDelete( "gfx_bedroom_drawerchest_disk" );
    ObjDelete( "spr_lucien_room_disk" );
    
  end;
  
  cmn.AddSubscriber( "get_disk", get_disk_inv );
  cmn.AddSubscriber( "get_disk", get_disk_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_barber_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_barber_key" ] = {
    type = "get",
    get_obj = "spr_bedroom_drawerchest_barber_key",
    room = private.room_objname,
    zz = "zz_bedroom_drawerchest",
    zz_gate = "gzz_lucien_room_bedroom_drawerchest"
  };
  
  local get_barber_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_barber_key", "spr_bedroom_drawerchest_barber_key" );
  
  end;
  
  local get_barber_key_closezz = function ()
  
    ObjDelete( "gfx_bedroom_drawerchest_barber_key" );
    
    if ( cmn.IsEventDone( "get_amulet_part_3" ) and
    cmn.IsGetCollect2( "get_collect2_item_21" ) ) then
      
      ObjDelete( "gzz_lucien_room_bedroom_drawerchest" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_barber_key", get_barber_key_inv );
  cmn.AddSubscriber( "get_barber_key", get_barber_key_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_diamond_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_diamond_lvl3" ] = {
    type = "get",
    get_obj = "spr_window_diamond",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  
  local get_diamond_lvl3_inv = function ()
  
    interface.InventoryItemAdd( "inv_diamond_lvl3", "spr_window_diamond" );
    cmn.SetInvPlusRGB( "glass_cutter_base", true );  
    
  end;
  
  local get_diamond_lvl3_closezz = function ()
  
    ObjDelete( "gfx_window_diamond" );
    ObjDelete( "gzz_lucien_room_window" );
  
  end;
  
  cmn.AddSubscriber( "get_diamond_lvl3", get_diamond_lvl3_inv );
  cmn.AddSubscriber( "get_diamond_lvl3", get_diamond_lvl3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulet_part_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulet_part_1" ] = {
    type = "get",
    get_obj = "spr_window_amulet_part_1",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window",
    subzz = "zz_window2",
    subzz_gate = "gzz_window_window2"
  };
  
  local get_amulet_part_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_amulet_part_1", "spr_window_amulet_part_1" );
    
    --if ( cmn.IsEventDone( "get_amulet_part_1" ) and cmn.IsEventDone( "get_amulet_part_2" ) and 
    --     cmn.IsEventDone( "get_amulet_part_3" ) and cmn.IsEventDone( "get_amulet_part_4" ) and 
    --     cmn.IsEventDone( "get_amulet_part_5" ) and cmn.IsEventDone( "get_amulet_part_6" ) 
    --    ) then
    --
    --    cmn.SetInvPlusRGB( "white_ghost_amulet", true );
    --  
    --end;
    cmn.SetInvPlusRGB( "white_ghost_amulet", true );
  end;
  
  local get_amulet_part_1_closezz = function ()
  
    ObjDelete( "gfx_window_amulet_part_1" );
    ObjDelete( "gzz_window_window2" );
    ObjDelete( "anm_window_back" );    
    ObjMultiSet( { 
      { "anm_window_back2", { alp = true, active = true, visible = true } },
    } );
    
  end;
  
  cmn.AddSubscriber( "get_amulet_part_1", get_amulet_part_1_inv );
  cmn.AddSubscriber( "get_amulet_part_1", get_amulet_part_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coal () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coal" ] = {
    type = "get",
    get_obj = "spr_window_coal",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  
  local get_coal_inv = function ()
  
    interface.InventoryItemAdd( "inv_coal", "spr_window_coal" );
  
  end;
  
  local get_coal_closezz = function ()
  
    ObjDelete( "gfx_window_coal" );
  
  end;
  
  cmn.AddSubscriber( "get_coal", get_coal_inv );
  cmn.AddSubscriber( "get_coal", get_coal_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wrought_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wrought_handle" ] = {
    type = "get",
    get_obj = "obj_window_handle",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  
  local get_wrought_handle_inv = function ()
  
    interface.InventoryItemAdd( "inv_wrought_handle", "obj_window_handle" );
  
  end;
  
  local get_wrought_handle_closezz = function ()
  
    ObjDelete( "gfx_window_wrought_handle" );
  
  end;
  
  cmn.AddSubscriber( "get_wrought_handle", get_wrought_handle_inv );
  cmn.AddSubscriber( "get_wrought_handle", get_wrought_handle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chisel" ] = {
    type = "get",
    get_obj = "spr_window_chisel",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  
  local get_chisel_inv = function ()
  
    interface.InventoryItemAdd( "inv_chisel", "spr_window_chisel" );
  
  end;
  
  local get_chisel_closezz = function ()
  
    ObjDelete( "gfx_window_chisel" );
    
    if ( cmn.IsEventDone( "get_flag_1" ) ) then
      
      ObjMultiSet( { 
        { "obj_window_use_decorative_fragment", { input = true } },
      } );

    end; 
    
  end;
  
  cmn.AddSubscriber( "get_chisel", get_chisel_inv );
  cmn.AddSubscriber( "get_chisel", get_chisel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flag_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flag_1" ] = {
    type = "get",
    get_obj = "spr_window_flag_1",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  
  local get_flag_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_flag_1", "spr_window_flag_1" );
  
  end;
  
  local get_flag_1_closezz = function ()
  
    ObjDelete( "gfx_window_flag_1" );
    
    if ( cmn.IsEventDone( "get_chisel" ) ) then
      
      ObjMultiSet( { 
        { "obj_window_use_decorative_fragment", { input = true } },
      } );

    end;  
    
    ObjDelete( "spr_lucien_room_window_flag" ); 
    
  end;
  
  cmn.AddSubscriber( "get_flag_1", get_flag_1_inv );
  cmn.AddSubscriber( "get_flag_1", get_flag_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_golden_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_golden_key" ] = {
    type = "get",
    get_obj = "spr_lucien_room_golden_key",
    room = private.room_objname 
  };
  
  local get_golden_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_golden_key", "spr_lucien_room_golden_key" );
  
  end;
  
  local get_golden_key_closezz = function ()
  
    ObjDelete( "gfx_lucien_room_golden_key" );
  
  end;
  
  cmn.AddSubscriber( "get_golden_key", get_golden_key_inv );
  cmn.AddSubscriber( "get_golden_key", get_golden_key_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_decorative_fragment () end;
  --------------------------------------------------------------------------------------------
  local get_decorative_fragment_inv = function ()
  
    interface.InventoryItemAdd( "inv_decorative_fragment", "spr_lucien_room_decorative_fragment" );
  
  end;
  
  local get_decorative_fragment_closezz = function ()
  
    ObjDelete( "gfx_lucien_room_decorative_fragment" );
  
  end;
  
  cmn.AddSubscriber( "get_decorative_fragment", get_decorative_fragment_inv );
  cmn.AddSubscriber( "get_decorative_fragment", get_decorative_fragment_closezz, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function get_white_ghost_amulet () end;
  --------------------------------------------------------------------------------------------
  local get_white_ghost_amulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_white_ghost_amulet", "spr_lucien_room_white_ghost_amulet" );
    
    ObjSet( "inv_white_ghost_amulet", { drag = false } );
    if ( not cmn.IsEventDone( "get_amulet_part_1" ) or not cmn.IsEventDone( "get_amulet_part_2" ) or 
         not cmn.IsEventDone( "get_amulet_part_3" ) or not cmn.IsEventDone( "get_amulet_part_4" ) or 
         not cmn.IsEventDone( "get_amulet_part_5" ) or not cmn.IsEventDone( "get_amulet_part_6" ) 
        ) then
    
      cmn.SetInvPlusRGB( "white_ghost_amulet", false );
      
    end;
    
  end;
  
  local get_white_ghost_amulet_closezz = function ()
  
    ObjDelete( "gfx_lucien_room_white_ghost_amulet" );
  
  end;
  
  cmn.AddSubscriber( "get_white_ghost_amulet", get_white_ghost_amulet_inv );
  cmn.AddSubscriber( "get_white_ghost_amulet", get_white_ghost_amulet_closezz, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_21 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_21 = function ()
  
    ObjDelete( "obj_bedroom_drawerchest_collect2_item_21" ); 
  
    if ( cmn.IsEventDone( "get_barber_key" ) and
    cmn.IsEventDone( "get_amulet_part_3" ) ) then
      
      ObjDelete( "gzz_lucien_room_bedroom_drawerchest" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_21", get_collect2_item_21, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function use_code () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_code" ] = {
    type = "use",
    inv_obj = "inv_code",
    use_place = "obj_safe_use_code",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_lucien_room_safe"
  };
  local use_code_inv = function ()
  
    interface.InventoryItemRemove( "inv_code" );
  
  end;
  local use_code_beg = function ()
  
    ObjDelete( "obj_safe_use_code" );
  
  end;
  local use_code_end = function ()
  
    ObjMultiSet( { 
      { "obj_safe_mmg",                  { input = true } },
      { "spr_safe_paper",                {   alp = 1    } },
      { "spr_lucien_room_zz_safe_paper", {   alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_code", use_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_code", use_code_inv );
  cmn.AddSubscriber( "use_code", use_code_end, private.room_objname );
  cmn.AddSubscriber( "use_code_inv", use_code_inv, private.room_objname );
  cmn.AddSubscriber( "use_code_beg", use_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_code_end", use_code_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_golden_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_golden_key" ] = {
    type = "use",
    inv_obj = "inv_golden_key",
    use_place = "obj_coffee_table_use_golden_key",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  local use_golden_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_golden_key" );
  
  end;
  local use_golden_key_beg = function ()
  
    ObjDelete( "obj_coffee_table_use_golden_key" );
  
  end;
  local use_golden_key_end = function ()
    
    ObjDelete( "anm_coffee_table_key" );  
    ObjMultiSet( { 
      { "gfx_coffee_table_ship_model",  { active = true            } },
      { "spr_lucien_room_opn_box",      {    alp = 1               } },
      { "obj_coffee_table_box",         {    alp = 1, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_golden_key", use_golden_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_golden_key", use_golden_key_inv );
  cmn.AddSubscriber( "use_golden_key", use_golden_key_end, private.room_objname );
  cmn.AddSubscriber( "use_golden_key_inv", use_golden_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_golden_key_beg", use_golden_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_golden_key_end", use_golden_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel" ] = {
    type = "use",
    inv_obj = "inv_chisel",
    use_place = "obj_coffee_table_use_chisel",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  local use_chisel_inv = function ()
  
    interface.InventoryItemRemove( "inv_chisel" );
  
  end;
  local use_chisel_beg = function ()
  
    ObjDelete( "obj_coffee_table_use_chisel" );
  
  end;
  local use_chisel_end = function ()
  
    ObjMultiSet( { 
      { "obj_coffee_table_figurine",          {  input = true } },
      { "gfx_coffee_table_figurine",          { active = true } },
      { "anm_coffee_table_figurine",          {  frame = 300  } },
      { "spr_lucien_room_broken_slice_table", {     alp = 1   } },
      { "spr_lucien_room_table_slice", { pos_x = -8, pos_y = 33 } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel", use_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel", use_chisel_inv );
  cmn.AddSubscriber( "use_chisel", use_chisel_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_inv", use_chisel_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_beg", use_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_end", use_chisel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ink_pen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ink_pen" ] = {
    type = "use",
    inv_obj = "inv_ink_pen",
    use_place = "obj_coffee_table_use_ink_pen",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  local use_ink_pen_inv = function ()
  
    interface.InventoryItemRemove( "inv_ink_pen" );
  
  end;
  local use_ink_pen_beg = function ()
  
    ObjDelete( "obj_coffee_table_use_ink_pen" );
  
  end;
  local use_ink_pen_end = function ()
  
    ObjMultiSet( { 
      { "obj_coffee_table_box_2",   {    alp = 1, input = true              } },
      { "spr_lucien_room_pen",      {    alp = 1                            } },
      { "spr_lucien_room_opn_safe", {    alp = 1                            } },
      { "gfx_coffee_table_will",    { active = true                         } },
      { "spr_coffee_table_pen",     {    alp = 1, pos_x = 117, pos_y = -171 } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ink_pen", use_ink_pen_beg, private.room_objname );
  cmn.AddSubscriber( "use_ink_pen", use_ink_pen_inv );
  cmn.AddSubscriber( "use_ink_pen", use_ink_pen_end, private.room_objname );
  cmn.AddSubscriber( "use_ink_pen_inv", use_ink_pen_inv, private.room_objname );
  cmn.AddSubscriber( "use_ink_pen_beg", use_ink_pen_beg, private.room_objname );
  cmn.AddSubscriber( "use_ink_pen_end", use_ink_pen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flag_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flag_1" ] = {
    type = "use",
    inv_obj = "inv_flag_1",
    use_place = "obj_coffee_table_use_flag_1",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  local use_flag_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_flag_1" );
  
  end;
  local use_flag_1_beg = function ()
  
    ObjDelete( "obj_coffee_table_use_flag_1" );
  
  end;
  local use_flag_1_end = function ()
    
    ObjMultiSet( { 
      { "obj_coffe_table_flag_2", { alp = 1 } },
      { "spr_lucien_room_flag2",  { alp = 1 } },
    } );        
      
    if ( cmn.IsEventDone( "use_flag_2" ) and 
    cmn.IsEventDone( "use_flag_3" ) ) then
      
      ObjMultiSet( { 
        { "obj_coffee_table_mmg",   { input = true } },
      } );        
      
    end;   
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flag_1", use_flag_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_flag_1", use_flag_1_inv );
  cmn.AddSubscriber( "use_flag_1", use_flag_1_end, private.room_objname );
  cmn.AddSubscriber( "use_flag_1_inv", use_flag_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_flag_1_beg", use_flag_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_flag_1_end", use_flag_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flag_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flag_2" ] = {
    type = "use",
    inv_obj = "inv_flag_2",
    use_place = "obj_coffee_table_use_flag_2",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  local use_flag_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_flag_2" );
  
  end;
  local use_flag_2_beg = function ()
  
    ObjDelete( "obj_coffee_table_use_flag_2" );
  
  end;
  local use_flag_2_end = function ()
    
    ObjMultiSet( { 
      { "obj_coffe_table_flag_3", { alp = 1 } },
      { "spr_lucien_room_flag3",  { alp = 1 } },
    } );     
    
    if ( cmn.IsEventDone( "use_flag_1" ) and 
    cmn.IsEventDone( "use_flag_3" ) ) then
      
      ObjMultiSet( { 
        { "obj_coffee_table_mmg",   { input = true } },
      } );   
      
    end;  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flag_2", use_flag_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_flag_2", use_flag_2_inv );
  cmn.AddSubscriber( "use_flag_2", use_flag_2_end, private.room_objname );
  cmn.AddSubscriber( "use_flag_2_inv", use_flag_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_flag_2_beg", use_flag_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_flag_2_end", use_flag_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flag_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flag_3" ] = {
    type = "use",
    inv_obj = "inv_flag_3",
    use_place = "obj_coffee_table_use_flag_3",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  local use_flag_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_flag_3" );
  
  end;
  local use_flag_3_beg = function ()
  
    ObjDelete( "obj_coffee_table_use_flag_3" );
  
  end;
  local use_flag_3_end = function ()
    
    ObjMultiSet( { 
      { "obj_coffe_table_flag_1", { alp = 1 } },
      { "spr_lucien_room_flag1",  { alp = 1 } },
    } );      
    
    if ( cmn.IsEventDone( "use_flag_1" ) and 
    cmn.IsEventDone( "use_flag_2" ) ) then
      
      ObjMultiSet( { 
        { "obj_coffee_table_mmg",   { input = true } },
      } );     
      
    end;  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flag_3", use_flag_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_flag_3", use_flag_3_inv );
  cmn.AddSubscriber( "use_flag_3", use_flag_3_end, private.room_objname );
  cmn.AddSubscriber( "use_flag_3_inv", use_flag_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_flag_3_beg", use_flag_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_flag_3_end", use_flag_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hillmark_monogram () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hillmark_monogram" ] = {
    type = "use",
    inv_obj = "inv_hillmark_monogram",
    use_place = "obj_bedroom_drawerchest_use_hillmark_monogram",
    room = private.room_objname,
    zz = "zz_bedroom_drawerchest",
    zz_gate = "gzz_lucien_room_bedroom_drawerchest"
  };
  local use_hillmark_monogram_inv = function ()
  
    interface.InventoryItemRemove( "inv_hillmark_monogram" );
  
  end;
  local use_hillmark_monogram_beg = function ()
  
    ObjDelete( "obj_bedroom_drawerchest_use_hillmark_monogram" );
  
  end;
  local use_hillmark_monogram_end = function ()
  
    ObjMultiSet( { 
      { "spr_bedroom_drawerchest_can",      {          input = true } },
      { "gfx_bedroom_drawerchest_can",      {         active = true } },
      { "anm_bedroom_drawerchest_minidoor", { alp = 1, frame = 500  } },
    } );
    ObjDelete( "spr_bedroom_drawerchest_minidoor" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hillmark_monogram", use_hillmark_monogram_beg, private.room_objname );
  cmn.AddSubscriber( "use_hillmark_monogram", use_hillmark_monogram_inv );
  cmn.AddSubscriber( "use_hillmark_monogram", use_hillmark_monogram_end, private.room_objname );
  cmn.AddSubscriber( "use_hillmark_monogram_inv", use_hillmark_monogram_inv, private.room_objname );
  cmn.AddSubscriber( "use_hillmark_monogram_beg", use_hillmark_monogram_beg, private.room_objname );
  cmn.AddSubscriber( "use_hillmark_monogram_end", use_hillmark_monogram_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrought_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrought_handle" ] = {
    type = "use",
    inv_obj = "inv_wrought_handle",
    use_place = "obj_bedroom_drawerchest_use_wrought_handle",
    room = private.room_objname,
    zz = "zz_bedroom_drawerchest",
    zz_gate = "gzz_lucien_room_bedroom_drawerchest"
  };
  local use_wrought_handle_inv = function ()
  
    interface.InventoryItemRemove( "inv_wrought_handle" );
  
  end;
  local use_wrought_handle_beg = function ()
  
    ObjDelete( "obj_bedroom_drawerchest_use_wrought_handle" );
  
  end;
  local use_wrought_handle_end = function ()
  
    ObjMultiSet( { 
      { "spr_bedroom_drawerchest_torn_shirt", {  input = true } },
      { "gfx_bedroom_drawerchest_torn_shirt", { active = true } },
      { "spr_lucien_room_open_shelf",         {    alp = 1    } },
    } ); 
    
    ObjDelete( "spr_bedroom_drawerchest_door" );
    ObjDelete( "anm_bedroom_drawerchest_door" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrought_handle", use_wrought_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrought_handle", use_wrought_handle_inv );
  cmn.AddSubscriber( "use_wrought_handle", use_wrought_handle_end, private.room_objname );
  cmn.AddSubscriber( "use_wrought_handle_inv", use_wrought_handle_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrought_handle_beg", use_wrought_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrought_handle_end", use_wrought_handle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lucien_signet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lucien_signet" ] = {
    type = "use",
    inv_obj = "inv_lucien_signet",
    use_place = "obj_bedroom_drawerchest_use_lucien_signet",
    room = private.room_objname,
    zz = "zz_bedroom_drawerchest",
    zz_gate = "gzz_lucien_room_bedroom_drawerchest"
  };
  local use_lucien_signet_inv = function ()
  
    interface.InventoryItemRemove( "inv_lucien_signet" );
  
  end;
  local use_lucien_signet_beg = function ()
  
    ObjDelete( "obj_bedroom_drawerchest_use_lucien_signet" );
  
  end;
  local use_lucien_signet_end = function ()
  
    ObjMultiSet( { 
      { "spr_bedroom_drawerchest_amulet_part_3", {  input = true } },
      { "spr_lucien_room_open_minidoor",         {    alp = 1    } },
      { "gfx_bedroom_drawerchest_amulet_part_3", { active = true } },
      { "spr_bedroom_drawerchest_barber_key",    {  input = true } },
      { "gfx_bedroom_drawerchest_barber_key",    { active = true } },
    } );
    ObjDelete( "spr_bedroom_drawerchest_minidoor2" );
    ObjDelete( "spr_lucien_room_minidoor" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lucien_signet", use_lucien_signet_beg, private.room_objname );
  cmn.AddSubscriber( "use_lucien_signet", use_lucien_signet_inv );
  cmn.AddSubscriber( "use_lucien_signet", use_lucien_signet_end, private.room_objname );
  cmn.AddSubscriber( "use_lucien_signet_inv", use_lucien_signet_inv, private.room_objname );
  cmn.AddSubscriber( "use_lucien_signet_beg", use_lucien_signet_beg, private.room_objname );
  cmn.AddSubscriber( "use_lucien_signet_end", use_lucien_signet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sapling () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sapling" ] = {
    type = "use",
    inv_obj = "inv_sapling",
    use_place = "obj_window_use_sapling",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window",
    subzz = "zz_window2",
    subzz_gate = "gzz_window_window2"
  };
  local use_sapling_inv = function ()
  
    interface.InventoryItemRemove( "inv_sapling" );
  
  end;
  local use_sapling_beg = function ()
  
    ObjDelete( "obj_window_use_sapling" );
  
  end;
  local use_sapling_end = function ()
  
    ObjMultiSet( { 
      { "spr_window_amulet_part_1",  { visible = true, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sapling", use_sapling_beg, private.room_objname );
  cmn.AddSubscriber( "use_sapling", use_sapling_inv );
  cmn.AddSubscriber( "use_sapling", use_sapling_end, private.room_objname );
  cmn.AddSubscriber( "use_sapling_inv", use_sapling_inv, private.room_objname );
  cmn.AddSubscriber( "use_sapling_beg", use_sapling_beg, private.room_objname );
  cmn.AddSubscriber( "use_sapling_end", use_sapling_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_disk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_disk" ] = {
    type = "use",
    inv_obj = "inv_disk",
    use_place = "obj_window_use_disk",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  local use_disk_inv = function ()
  
    interface.InventoryItemRemove( "inv_disk" );
  
  end;
  local use_disk_beg = function ()
  
    ObjDelete( "obj_window_use_disk" );
  
  end;
  local use_disk_end = function ()
  
    ObjDelete( "spr_window_cache_door" );  
    ObjDelete( "anm_window_open_secret" );
    ObjMultiSet( { 
      { "spr_window_cache_door_disk", {    alp = 1    } },
      { "spr_lucien_room_opensecret", {    alp = 1    } },
      { "spr_window_chisel",          {  input = true } },
      { "spr_window_flag_1",          {  input = true } },
      { "gfx_window_chisel",          { active = true } },
      { "gfx_window_flag_1",          { active = true } },
    } );
    
    ObjDelete( "spr_lucien_room_window_door" ); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_disk", use_disk_beg, private.room_objname );
  cmn.AddSubscriber( "use_disk", use_disk_inv );
  cmn.AddSubscriber( "use_disk", use_disk_end, private.room_objname );
  cmn.AddSubscriber( "use_disk_inv", use_disk_inv, private.room_objname );
  cmn.AddSubscriber( "use_disk_beg", use_disk_beg, private.room_objname );
  cmn.AddSubscriber( "use_disk_end", use_disk_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_figurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_figurine" ] = {
    type = "use",
    inv_obj = "inv_figurine",
    use_place = "obj_window_use_figurine",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  local use_figurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_figurine" );
  
  end;
  local use_figurine_beg = function ()
  
    ObjDelete( "obj_window_use_figurine" );
  
  end;
  local use_figurine_end = function ()
    
    ObjDelete( "anm_window_broken" );
    ObjMultiSet( { 
      { "obj_window_clk_window", { input = true } },
      { "anm_window_open",       {   alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_figurine", use_figurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurine", use_figurine_inv );
  cmn.AddSubscriber( "use_figurine", use_figurine_end, private.room_objname );
  cmn.AddSubscriber( "use_figurine_inv", use_figurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_figurine_beg", use_figurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurine_end", use_figurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_decorative_fragment () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_decorative_fragment" ] = {
    type = "use",
    inv_obj = "inv_decorative_fragment",
    use_place = "obj_window_use_decorative_fragment",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  local use_decorative_fragment_inv = function ()
  
    interface.InventoryItemRemove( "inv_decorative_fragment" );
  
  end;
  local use_decorative_fragment_beg = function ()
  
    ObjDelete( "obj_window_use_decorative_fragment" );
  
  end;
  local use_decorative_fragment_end = function ()
    
    ObjDelete( "spr_window_cache_door2" );  
    ObjDelete( "spr_lucien_room_opensecret" );  
    ObjDelete( "anm_window_cache" );  
    
    ObjMultiSet( { 
      { "spr_window_coal",             {  input = true } },
      { "gfx_window_coal",             { active = true } },
      { "spr_window_amulet_pattern",   {    alp = 1    } },
      { "spr_lucien_room_opensecret2", {    alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_decorative_fragment", use_decorative_fragment_beg, private.room_objname );
  cmn.AddSubscriber( "use_decorative_fragment", use_decorative_fragment_inv );
  cmn.AddSubscriber( "use_decorative_fragment", use_decorative_fragment_end, private.room_objname );
  cmn.AddSubscriber( "use_decorative_fragment_inv", use_decorative_fragment_inv, private.room_objname );
  cmn.AddSubscriber( "use_decorative_fragment_beg", use_decorative_fragment_beg, private.room_objname );
  cmn.AddSubscriber( "use_decorative_fragment_end", use_decorative_fragment_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bas_relief () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bas_relief" ] = {
    type = "use",
    inv_obj = "inv_bas_relief",
    use_place = "obj_window_use_bas_relief",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  local use_bas_relief_inv = function ()
  
    interface.InventoryItemRemove( "inv_bas_relief" );
  
  end;
  local use_bas_relief_beg = function ()
  
    ObjDelete( "obj_window_use_bas_relief" );
  
  end;
  local use_bas_relief_end = function ()
  
    ObjMultiSet( { 
      { "spr_window_basrelief",          {   alp = 1    } },
      { "obj_window_mmg_slots",          { input = true } },
      { "spr_lucien_room_broken_window", {   alp = 1    } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bas_relief", use_bas_relief_beg, private.room_objname );
  cmn.AddSubscriber( "use_bas_relief", use_bas_relief_inv );
  cmn.AddSubscriber( "use_bas_relief", use_bas_relief_end, private.room_objname );
  cmn.AddSubscriber( "use_bas_relief_inv", use_bas_relief_inv, private.room_objname );
  cmn.AddSubscriber( "use_bas_relief_beg", use_bas_relief_beg, private.room_objname );
  cmn.AddSubscriber( "use_bas_relief_end", use_bas_relief_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_maggie () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_maggie" ] = {
    type = "use",
    inv_obj = "inv_maggie",
    use_place = "obj_lucien_room_use_maggie",
    room = private.room_objname
  };
  local use_maggie_inv = function ()
  
    interface.InventoryItemRemove( "inv_maggie" );
  
  end;
  local use_maggie_beg = function ()
  
    ObjDelete( "obj_lucien_room_use_maggie" );
  
  end;
  local use_maggie_end = function ()
  
    ObjDelete( "anm_lucien_room_use_maggee" );
    ObjMultiSet( { 
      { "anm_lucien_room_maggee_cry",  { active = true, visible = true } },
      { "obj_lucien_room_use_cloth_bandage",  { input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_maggie", use_maggie_beg, private.room_objname );
  cmn.AddSubscriber( "use_maggie", use_maggie_inv );
  cmn.AddSubscriber( "use_maggie", use_maggie_end, private.room_objname );
  cmn.AddSubscriber( "use_maggie_inv", use_maggie_inv, private.room_objname );
  cmn.AddSubscriber( "use_maggie_beg", use_maggie_beg, private.room_objname );
  cmn.AddSubscriber( "use_maggie_end", use_maggie_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cloth_bandage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cloth_bandage" ] = {
    type = "use",
    inv_obj = "inv_cloth_bandage",
    use_place = "obj_lucien_room_use_cloth_bandage",
    room = private.room_objname 
  };
  local use_cloth_bandage_inv = function ()
  
    interface.InventoryItemRemove( "inv_cloth_bandage" );
    ObjDelete( "anm_lucien_room_maggee_cry" );
  
  end;
  local use_cloth_bandage_beg = function ()
  
    ObjDelete( "obj_lucien_room_use_cloth_bandage" );
  
  end;
  local use_cloth_bandage_end = function ()
  
    ObjDelete( "anm_lucien_room_maggee_bandage" );
    ObjSet( "anm_lucien_room_maggee_statics", { active = true, visible = true } );
 
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cloth_bandage", use_cloth_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "use_cloth_bandage", use_cloth_bandage_inv );
  cmn.AddSubscriber( "use_cloth_bandage", use_cloth_bandage_end, private.room_objname );
  cmn.AddSubscriber( "use_cloth_bandage_inv", use_cloth_bandage_inv, private.room_objname );
  cmn.AddSubscriber( "use_cloth_bandage_beg", use_cloth_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "use_cloth_bandage_end", use_cloth_bandage_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_steering_wheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_steering_wheel" ] = {
    type = "use",
    inv_obj = "inv_steering_wheel",
    use_place = "obj_lucien_room_use_steering_wheel",
    room = private.room_objname 
  };
  local use_steering_wheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_steering_wheel" );
  
  end;
  local use_steering_wheel_beg = function ()
  
    ObjDelete( "obj_lucien_room_use_steering_wheel" );
  
  end;
  local use_steering_wheel_end = function ()
  
    ObjMultiSet( { 
      { "spr_lucien_room_golden_key",  { visible = true, input = true } },
      { "anm_lucien_room_steering_wheel",  { frame = 85 } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_steering_wheel", use_steering_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_steering_wheel", use_steering_wheel_inv );
  cmn.AddSubscriber( "use_steering_wheel", use_steering_wheel_end, private.room_objname );
  cmn.AddSubscriber( "use_steering_wheel_inv", use_steering_wheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_steering_wheel_beg", use_steering_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_steering_wheel_end", use_steering_wheel_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_wrought_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_wrought_handle" ] = {
    type = "click",
    use_place = "obj_bedroom_drawerchest_clk_wrought_handle",
    room = private.room_objname,
    zz = "zz_bedroom_drawerchest",
    zz_gate = "gzz_lucien_room_bedroom_drawerchest"
  };
  
  local clk_wrought_handle_beg = function ()

    ObjDelete( "obj_bedroom_drawerchest_clk_wrought_handle" );
  
  end;
  local clk_wrought_handle_end = function ()
    
    ObjMultiSet( { 
      { "obj_bedroom_drawerchest_use_wrought_handle", { input = true, active = true, visible = true } },
      { "obj_lucien_room_zz_bedroom_drawerchest",     {   alp = 1                                   } },
    } );
    ObjDelete( "anm_bedroom_drawerchest_handle" );  
    ObjDelete( "spr_lucien_room_handle" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_wrought_handle",     clk_wrought_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wrought_handle",     clk_wrought_handle_end, private.room_objname );
  cmn.AddSubscriber( "clk_wrought_handle_beg", clk_wrought_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wrought_handle_end", clk_wrought_handle_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_window_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_window_handle" ] = {
    type = "click",
    use_place = "obj_window_clk_handle",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  
  local clk_window_handle_beg = function ()

    ObjDelete( "obj_window_clk_handle" );
  
  end;
  local clk_window_handle_end = function ()
    
    ObjDelete( "spr_lucien_room_handle_window" );
    ObjMultiSet( { 
      { "anm_window_handle",         {  frame = 300  } },
      { "obj_window_handle",         {  input = true } },
      { "obj_window_use_figurine",   {  input = true } },
      { "gfx_window_wrought_handle", { active = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_window_handle",     clk_window_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_window_handle",     clk_window_handle_end, private.room_objname );
  cmn.AddSubscriber( "clk_window_handle_beg", clk_window_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_window_handle_end", clk_window_handle_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_window_open () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_window_open" ] = {
    type = "click",
    use_place = "obj_window_clk_window",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  
  local clk_window_open_beg = function ()

    ObjDelete( "obj_window_clk_window" );
  
  end;
  local clk_window_open_end = function ()
    
    ObjDelete( "spr_lucien_room_broken_window" );    
    ObjMultiSet( { 
      { "anm_window_open",             {  frame = 300                                } },
      { "spr_lucien_room_open_window", {    alp = 1                                  } },
      { "gzz_window_window2",          { active = true, input = true, visible = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_window_open",     clk_window_open_beg, private.room_objname );
  cmn.AddSubscriber( "clk_window_open",     clk_window_open_end, private.room_objname );
  cmn.AddSubscriber( "clk_window_open_beg", clk_window_open_beg, private.room_objname );
  cmn.AddSubscriber( "clk_window_open_end", clk_window_open_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_coffee_table_clock () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_coffee_table_clock" ] = {
    type = "click",
    use_place = "obj_coffee_table_clk_clock",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  
  local clk_coffee_table_clock_beg = function ()

    ObjDelete( "obj_coffee_table_clk_clock" );
  
  end;
  local clk_coffee_table_clock_end = function ()
    
    ObjDelete( "spr_coffee_table_cap_close" );    
    ObjMultiSet( { 
      { "obj_coffee_table_clock", {  input = true } },
      { "gfx_coffee_table_hands", { active = true } },
      { "spr_coffee_table_cap",   {    alp = 1    } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_coffee_table_clock",     clk_coffee_table_clock_beg, private.room_objname );
  cmn.AddSubscriber( "clk_coffee_table_clock",     clk_coffee_table_clock_end, private.room_objname );
  cmn.AddSubscriber( "clk_coffee_table_clock_beg", clk_coffee_table_clock_beg, private.room_objname );
  cmn.AddSubscriber( "clk_coffee_table_clock_end", clk_coffee_table_clock_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_amulet_part_1_ghost () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amulet_part_1_ghost" ] = {
    type = "use",
    inv_obj = "inv_amulet_part_1",
    use_place = "obj_lucien_room_use_amulet_part_1_ghost",
    room = private.room_objname 
  };
  local use_amulet_part_1_ghost_inv = function ()
  
    if ( cmn.IsEventDone( "use_amulet_part_1" ) ) then
      
      interface.InventoryItemRemove( "inv_amulet_part_1" );
      
    end;
  
  end;
  local use_amulet_part_1_ghost_beg = function ()
  
    ObjDelete( "obj_lucien_room_use_amulet_part_1_ghost" );
  
  end;
  local use_amulet_part_1_ghost_end = function ()
  
    ObjMultiSet( { 
      { "anm_lucien_room_amulet_statics", { active = true, visible = true } },
      { "obj_lucien_room_mmg", { alp = 1, input = true } },
    } );
    
    ObjDelete( "anm_lucien_room_amulet_use" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amulet_part_1_ghost", use_amulet_part_1_ghost_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulet_part_1_ghost", use_amulet_part_1_ghost_inv );
  cmn.AddSubscriber( "use_amulet_part_1_ghost", use_amulet_part_1_ghost_end, private.room_objname );
  cmn.AddSubscriber( "use_amulet_part_1_ghost_inv", use_amulet_part_1_ghost_inv, private.room_objname );
  cmn.AddSubscriber( "use_amulet_part_1_ghost_beg", use_amulet_part_1_ghost_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulet_part_1_ghost_end", use_amulet_part_1_ghost_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function dlg_lucien_room_maggie () end;
  --------------------------------------------------------------------------------------------
  local dlg_lucien_room_maggie = function ()
    
  end;  

  cmn.AddSubscriber( "dlg_lucien_room_maggie", dlg_lucien_room_maggie, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function dlg_lucien_room_lucien_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_lucien_room_lucien_1" ] = {
    type = "click",
    use_place = "obj_lucien_room_clk_lucien_1_focus",
    room = private.room_objname,
  };  
  
  local dlg_lucien_room_lucien_1 = function ()
    
    ObjDelete( "obj_lucien_room_clk_lucien_1" );
    ObjDelete( "anm_lucien_room_lucien" );
    
  end;  

  cmn.AddSubscriber( "dlg_lucien_room_lucien_1", dlg_lucien_room_lucien_1, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function see_scare_window () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_scare_window" ] = {
    type = "click",
    use_place = "obj_window_see_scare",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  local see_scare_window = function ()
  
    ObjDelete( "obj_window_see_scare" );  
  
  end;
  local see_scare_window_end = function ()
    
    ObjDelete( "obj_window_see_scare" );    
    ObjDelete( "anm_window_lucien_room_window2" ); 
    ObjMultiSet( { 
      { "anm_window_back",    { alp = 1, frame = 0 } },
    } );
    
  end;
  cmn.AddSubscriber( "see_scare_window", see_scare_window, private.room_objname );
  cmn.AddSubscriber( "see_scare_window", see_scare_window_end, private.room_objname );
  cmn.AddSubscriber( "see_scare_window_end", see_scare_window_end, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function see_scare_window_2 () end;
  --------------------------------------------------------------------------------------------
  local see_scare_window_2 = function ()
    
    ObjDelete( "anm_window_lucien_room_window" );
    ObjMultiSet( { 
      { "grm_lucien_room_cemetery_3",  { visible = true, input = true } },
    } );                
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_lucien_room_cemetery_3_focus");
    end;
  end;
  cmn.AddSubscriber( "see_scare_window_2", see_scare_window_2, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function see_lucien_room_1 () end;
  --------------------------------------------------------------------------------------------
  local see_lucien_room_1 = function ()
  
    ObjDelete( "anm_lucien_room_lucien_1" );            

  end;
  cmn.AddSubscriber( "see_lucien_room_1", see_lucien_room_1, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_lucien_room_2 () end;
  --------------------------------------------------------------------------------------------
  local see_lucien_room_2 = function ()
  
    ObjMultiSet( { 
      { "obj_lucien_room_use_amulet_part_1_ghost",  { input = true } },
      { "anm_lucien_room_dark_statics",  { active = true, visible = true } },
      { "gzz_lucien_room_safe", { input = false, visible = false } },
      { "gzz_lucien_room_coffee_table", { input = false, visible = false } },
      { "gzz_lucien_room_bedroom_drawerchest", { input = false, visible = false } },
      { "gzz_lucien_room_window", { input = false, visible = false } },
    } );                

    ObjDelete( "anm_lucien_room_dark_emergence" );
    
    common_impl.LockMapRoom( "cemetery_3", true );
    
  end;
  cmn.AddSubscriber( "see_lucien_room_2", see_lucien_room_2, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_lucien_appearance () end;
  --------------------------------------------------------------------------------------------
  local see_lucien_appearance = function ()
 
    ObjMultiSet( { 
      { "anm_lucien_room_lucien",  { active = true, visible = true } },
      { "obj_lucien_room_clk_lucien_1",  { input = true } },
    } ); 
    
  end;
  cmn.AddSubscriber( "see_lucien_appearance", see_lucien_appearance, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function win_safe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_safe" ] =
  {
    type = "click",
    clk_obj = "obj_safe_mmg",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_lucien_room_safe"
  };
  --*********************************************************************************************************************
  local win_safe = function ()

    if ( cmn.IsEventDone( "win_safe" ) ) then
   
      ObjMultiSet( { 
          { "obj_safe_mmg",             {   input = false              } },
          { "gho_lucien_room_in_safe",  { visible = true, input = true } },
          { "spr_lucien_room_ho_safe",  {     alp = 1                  } },
        } );
        
      ObjDelete( "gzz_lucien_room_safe" );
        
    else 

      private.SafeLoad();
      
    end;
    
  end;

  cmn.AddSubscriber( "win_safe", win_safe, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function win_window () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_window" ] =
  {
    type = "click",
    clk_obj = "obj_window_mmg",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_lucien_room_window"
  };
  --*********************************************************************************************************************
  local win_window = function ()

    if ( cmn.IsEventDone( "win_window" ) ) then
      
      ObjDelete( "obj_window_mmg_doors" );
      ObjDelete( "obj_window_mmg_slots" );
      ObjMultiSet( { 
        { "obj_window_mmg",      {  input = false } },
        { "spr_window_diamond",  {  input = true  } },
        { "gfx_window_diamond",  { active = true  } },
      } );
    
    else 

      private.WindowLoad();
      
    end;
    
  end;

  cmn.AddSubscriber( "win_window", win_window, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function win_coffee_table () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_coffee_table" ] =
  {
    type = "click",
    clk_obj = "obj_coffee_table_mmg",
    room = private.room_objname,
    zz = "zz_coffee_table",
    zz_gate = "gzz_lucien_room_coffee_table"
  };
  --*********************************************************************************************************************
  local win_coffee_table = function ()

    if ( cmn.IsEventDone( "win_coffee_table" ) ) then
      
      ObjDelete( "gzz_lucien_room_coffee_table" );
      ObjMultiSet( { 
        { "gho_lucien_room_lucien_table",   { visible = true, input = true, active = true } },
        { "obj_coffee_table_mmg",           {   input = false                             } },
        { "spr_lucien_room_flag1",          {   pos_x = -57, pos_y = 33                   } },
        { "spr_lucien_room_flag2",          {   pos_x = -48, pos_y = 42                   } },
        { "spr_lucien_room_flag3",          {   pos_x = -39, pos_y = 35                   } },
        { "spr_lucien_room_ho_table_layer", {     alp = 1                                 } },        
      } );
    
    else 

      private.CoffeeTableLoad();
      
    end;
    
  end;

  cmn.AddSubscriber( "win_coffee_table", win_coffee_table, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function win_dark () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_dark" ] =
  {
      type = "win",
      room = private.room_objname 
  };

  local win_dark = function ()

    if ( cmn.IsEventDone( "win_dark" ) ) then
      
    ObjMultiSet( { 
      { "anm_lucien_room_disappearance_cupboard", { frame = 151 } },
      { "grm_lucien_room_weapon_room",  { visible = true, input = true } },
      { "gzz_lucien_room_safe", { input = true, visible = true } },
      { "gzz_lucien_room_coffee_table", { input = true, visible = true } },
      { "gzz_lucien_room_bedroom_drawerchest", { input = true, visible = true } },
      { "gzz_lucien_room_window", { input = true, visible = true } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_lucien_room_weapon_room_focus");
    end;
    
    ObjDelete( "obj_lucien_room_mmg" );
    ObjDelete( "anm_lucien_room_dark_statics" );
    ObjDelete( "anm_lucien_room_amulet_statics" );
    ObjDelete( "anm_lucien_room_dark_disappearance" );
    
    common_impl.LockMapRoom( "cemetery_3", false );
            
    end;

  end;

  cmn.AddSubscriber( "win_dark", win_dark, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_window () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_window" );
    -------------------------------------------------
    function zz_window.PreOpen ()
      
      if ( cmn.IsEventDone( "use_bas_relief" ) and not cmn.IsEventDone( "win_window" ) ) then 
        
        cmn.MiniGameShow( "window" );
        common_impl.PassingMgStart( "window" );
    
      end;

    end; 
    ------------------------------------------------- 
    function zz_window.Open ()
      
      if ( cmn.IsEventDone( "clk_window_open" ) and
      not cmn.IsEventDone( "see_scare_window_2" ) ) then
        
        private.see_scare_window_2(); 

      end;
            
    end;   
    --------------------------------------------------------------------------------------------
    function zz_window.Close ()
      
      if ( cmn.IsEventDone( "get_amulet_part_1" ) and
      not cmn.IsEventDone( "see_lucien_room_2" ) ) then
        
        private.see_lucien_room_2(); 

      end;
            
    end; 
    -------------------------------------------
    function zz_window.PreClose ()

      if ( cmn.IsEventDone( "use_bas_relief" ) and not cmn.IsEventDone( "win_window" ) ) then 
        
        cmn.MiniGameHide( "window" );
        common_impl.PassingMgStop( "window" );
        
      end;
            
    end; 
    -------------------------------------------
    function zz_window.Skip ()
      
      if ( cmn.IsEventDone( "use_bas_relief" ) and not cmn.IsEventDone( "win_window" ) ) then 
        
       private.state = { 0, 0, 0, 0, 0, 0, 0, 0, 0 }; 
        
       cmn.Lock( false );
       private.WindowWin();
       
      end;
     
    end;
    -------------------------------------------------
    function zz_window.Reset ()
      
      if ( cmn.IsEventDone( "use_bas_relief" ) and not cmn.IsEventDone( "win_window" ) ) then 
        
        ng_global.progress[ "std" ][ "win_window" ].state = { 1, 2, 2, 1, 3, 4, 3, 5, 4 }; 
        private.state = { 1, 2, 2, 1, 3, 4, 3, 5, 4 }; 
        private.WindowDefault();
        
      end; 
      
    end;     
  --*******************************************************************************************************************
  --*** function zz_coffee_table () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_coffee_table" );
    --------------------------------------------------------------------------------------------
    
    function zz_coffee_table.Close ()
      
      if ( cmn.IsEventDone( "get_will" ) and 
      not cmn.IsEventDone( "see_lucien_appearance" ) ) then

        private.see_lucien_appearance();
      
      end;
            
    end;
   -------------------------------------------------------------------------------------------- 
    function zz_coffee_table.PreOpen ()
      
      if ( cmn.IsEventDone( "use_flag_1" ) and 
           cmn.IsEventDone( "use_flag_2" ) and
           cmn.IsEventDone( "use_flag_3" ) and 
           not cmn.IsEventDone( "win_coffee_table" ) ) then 
        
        cmn.MiniGameShow( "coffee_table" );
        common_impl.PassingMgStart( "coffee_table" );
    
      end;

    end; 
    -------------------------------------------
    function zz_coffee_table.PreClose ()

      if ( cmn.IsEventDone( "use_flag_1" ) and 
           cmn.IsEventDone( "use_flag_2" ) and
           cmn.IsEventDone( "use_flag_3" ) and 
           not cmn.IsEventDone( "win_coffee_table" ) ) then 
        
        cmn.MiniGameHide( "coffee_table" );
        common_impl.PassingMgStop( "coffee_table" );
        
      end;
            
    end; 
    -------------------------------------------
    function zz_coffee_table.Skip ()
      
      if ( cmn.IsEventDone( "use_flag_1" ) and 
           cmn.IsEventDone( "use_flag_2" ) and
           cmn.IsEventDone( "use_flag_3" ) and 
           not cmn.IsEventDone( "win_coffee_table" ) ) then 
        
       private.state = { 2, 3, 2 }; 
       ng_global.progress[ "std" ][ "win_coffee_table" ].state = { 2, 3, 2 }; 
       cmn.Lock( false );
       private.CoffeeTableWin();
       
       
      end;
     
    end;
    -------------------------------------------------
    function zz_coffee_table.Reset ()
      
      if ( cmn.IsEventDone( "use_flag_1" ) and 
           cmn.IsEventDone( "use_flag_2" ) and
           cmn.IsEventDone( "use_flag_3" ) and 
           not cmn.IsEventDone( "win_coffee_table" ) ) then 
        
        private.CoffeeTableDefault();
        
      end; 
      
    end;        
  --*******************************************************************************************************************
  --*** function zz_bedroom_drawerchest () end ****
  --*********************************************************************************************************************
    subroom.Define( "zz_bedroom_drawerchest" );
    --------------------------------------------------------------------------------------------
    
    function zz_bedroom_drawerchest.Close ()
          
      if ( cmn.IsEventDone( "get_disk" ) and 
      not cmn.IsEventDone( "see_lucien_room_1" ) ) then
        private.see_lucien_room_1();
      end;
                
    end; 
    
 
  --*******************************************************************************************************************
  --*** function zz_safe () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_safe" );  
    -------------------------------------------------
    function zz_safe.PreOpen ()
      
      if ( cmn.IsEventDone( "use_code" ) and not cmn.IsEventDone( "win_safe" ) ) then 
        
        cmn.MiniGameShow( "safe" );
        common_impl.PassingMgStart( "safe" );
    
      end;

    end; 
    -------------------------------------------
    function zz_safe.PreClose ()

      if ( cmn.IsEventDone( "use_code" ) and not cmn.IsEventDone( "win_safe" ) ) then 
        
        cmn.MiniGameHide( "safe" );
        common_impl.PassingMgStop( "safe" );
        
      end;
            
    end; 
    ------------------------------------------------- 
    function zz_safe.Skip ()
      
      if ( cmn.IsEventDone( "use_code" ) and not cmn.IsEventDone( "win_safe" ) ) then 
        
        private.state   = { 12, 8, 4, 10, 11 }; 
        
       cmn.Lock( false );
       private.SafeWin();
       
      end;
     
    end;
    -------------------------------------------------
    function zz_safe.Reset ()
      
      if ( cmn.IsEventDone( "use_code" ) and not cmn.IsEventDone( "win_safe" ) ) then 
        
        private.SafeDefault();
        
      end; 
      
    end;
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_lucien_room();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( cmn.IsEventDone( "use_cloth_bandage" ) and not cmn.IsEventDone( "dlg_lucien_room_maggie" ) ) then
    
    private.dlg_lucien_room_maggie();
    
  end; 


  if cmn.IsEventDone( "use_amulet_part_1_ghost" ) and not cmn.IsEventDone( "win_dark" ) then 

    cmn.StopMusEnv();
    common_impl.PlayAudio( "mus_env", "mus_env/aud_danger2_mus_env", 1, "", 0 );

  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level3/env/aud_lucien_room_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();
  
--  if ( cmn.IsEventDone( "get_decorative_fragment" ) and
--  not cmn.IsEventDone( "see_scare_window_2" ) ) then
--    
--    private.see_scare_window_2(); 
--
--  end;
  
  if ( cmn.IsEventDone( "get_amulet_part_1" ) and
  not cmn.IsEventDone( "see_lucien_room_2" ) ) then
    
    private.see_lucien_room_2(); 

  end;
  
  if ( cmn.IsEventDone( "get_will" ) and 
  not cmn.IsEventDone( "see_lucien_appearance" ) ) then

    private.see_lucien_appearance();
  
  end;

  if ( cmn.IsEventDone( "get_disk" ) and 
  not cmn.IsEventDone( "see_lucien_room_1" ) ) then
    private.see_lucien_room_1();
  end;
  
  if not cmn.IsEventDone( "win_dark" ) then 

    if cmn.IsEventDone( "use_amulet_part_1_ghost" ) then 
      
      cmn.MiniGameShow( "dark" );
      common_impl.PassingMgStart( "dark" );
      
    end;

    private.DarkLoad();
    private.DarkUpdate();
    
    if private.gamedata.turn == 2 then      
      private.DarkIO()     
    end;

  end;

  if cmn.IsEventDone( "use_maggie" ) and not cmn.IsEventDone( "use_cloth_bandage" ) then
    common_impl.PlayAudio( "env", "level3/env/aud_sobs_env", 1, "", 0 ); 
  end;
  
end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
  
  common_impl.StopAudio( "env", "level3/env/aud_lucien_room_env", 0.5 );

  if ( not cmn.IsEventDone( "win_dark" ) and
  cmn.IsEventDone( "use_amulet_part_1_ghost" ) ) then 

    cmn.MiniGameHide( "dark" );
    common_impl.PassingMgStop( "dark" );

  end;

  if cmn.IsEventDone( "use_maggie" ) and not cmn.IsEventDone( "use_cloth_bandage" ) then
    common_impl.StopAudio( "env", "level3/env/aud_sobs_env", 0.5 );
  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_code ()

  local item = "inv_code";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_safe" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_safe" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_safe_use_code" ) ) then

    cmn.CallEventHandler( "use_code_inv" );
    cmn.CallEventHandler( "use_code_beg" );

    local func_end = function ()

      common_impl.PlayAudio( "sfx", "aud_clk_paper", 0, "", 0 );

      cmn.Lock( false );
      cmn.SetEventDone( "use_code" );
      cmn.CallEventHandler( "use_code_end" );
      
      private.SafeLoad();
      cmn.MiniGameShow( "safe" );
      common_impl.PassingMgStart( "safe" );

    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_safe_paper", func_end, 1.22 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_golden_key ()

  local item = "inv_golden_key";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_coffee_table" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffee_table" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_coffee_table_use_golden_key" ) ) then

    cmn.CallEventHandler( "use_golden_key_inv" );
    cmn.CallEventHandler( "use_golden_key_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_golden_key" );
      cmn.CallEventHandler( "use_golden_key_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_key3lvl", 0, "", 0 );
    
    ObjMultiSet( { 
      { "anm_coffee_table_key",           { alp = 1 } },
      { "spr_coffee_table_box_left_face", { alp = 0 } },
    } );
    AnimPlay( "anm_coffee_table_key", "key", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_chisel ()

  local item = "inv_chisel";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_coffee_table" ) and 
       cmn.IsEventDone( "get_crumpled_paper" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffee_table" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_coffee_table_use_chisel" ) and 
           cmn.IsEventDone( "get_crumpled_paper" ) ) then

    cmn.CallEventHandler( "use_chisel_inv" );
    cmn.CallEventHandler( "use_chisel_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_chisel" );
      cmn.CallEventHandler( "use_chisel_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_chisel", 0, "", 0 );

    AnimPlay( "anm_coffee_table_figurine", "doloto1", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ink_pen ()

  local item = "inv_ink_pen";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_coffee_table" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffee_table" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_coffee_table_use_ink_pen" ) ) then

    cmn.CallEventHandler( "use_ink_pen_inv" );
    cmn.CallEventHandler( "use_ink_pen_beg" );
    
    local func_end = function ()
      
      local func_end_2 = function ()
        
        local func_end_3 = function ()
          
          cmn.Lock( false );
          cmn.SetEventDone( "use_ink_pen" );
          cmn.CallEventHandler( "use_ink_pen_end" );
        
        end;
        
        ObjAnimate( "obj_coffee_table_box_2", "alp", 0, 0, func_end_3, { 0.0,0,0,  0.3,3,1 });
    
      end;
      
      ObjAnimate( "spr_coffee_table_pen", "pos_xy", 0, 0, func_end_2, { 0.0,0,104,-207,  0.5,3,117,-171 });   
      
    end;
  
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_pen", 0, "", 0 );

    cmn.ItemFly( "spr_coffee_table_pen", func_end, 1.22, 50 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_flag_1 ()

  local item = "inv_flag_1";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_coffee_table" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffee_table" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_coffee_table_use_flag_1" ) ) then

    cmn.CallEventHandler( "use_flag_1_inv" );
    cmn.CallEventHandler( "use_flag_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_flag_1" );
      cmn.CallEventHandler( "use_flag_1_end" );
      
      if ( cmn.IsEventDone( "use_flag_2" ) and 
      cmn.IsEventDone( "use_flag_3" ) ) then
        
        cmn.MiniGameShow( "coffee_table" );
        common_impl.PassingMgStart( "coffee_table" );
        private.CoffeeTableStart();
        
      end; 
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_flag", 0, "", 0 );

    cmn.ItemFly( "obj_coffe_table_flag_2", func_end, 1.22, 40 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_flag_2 ()

  local item = "inv_flag_2";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_coffee_table" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffee_table" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_coffee_table_use_flag_2" ) ) then

    cmn.CallEventHandler( "use_flag_2_inv" );
    cmn.CallEventHandler( "use_flag_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_flag_2" );
      cmn.CallEventHandler( "use_flag_2_end" );
      
      if ( cmn.IsEventDone( "use_flag_1" ) and 
      cmn.IsEventDone( "use_flag_3" ) ) then
        
        cmn.MiniGameShow( "coffee_table" );
        common_impl.PassingMgStart( "coffee_table" );
        private.CoffeeTableStart();
        
      end; 
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_flag", 0, "", 0 );
    
    cmn.ItemFly( "obj_coffe_table_flag_3", func_end, 1.22, 40 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_flag_3 ()

  local item = "inv_flag_3";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_coffee_table" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffee_table" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_coffee_table_use_flag_3" ) ) then

    cmn.CallEventHandler( "use_flag_3_inv" );
    cmn.CallEventHandler( "use_flag_3_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_flag_3" );
      cmn.CallEventHandler( "use_flag_3_end" );
      
      if ( cmn.IsEventDone( "use_flag_1" ) and 
      cmn.IsEventDone( "use_flag_2" ) ) then
        
        cmn.MiniGameShow( "coffee_table" );
        common_impl.PassingMgStart( "coffee_table" );
        private.CoffeeTableStart();   
        
      end; 
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_flag", 0, "", 0 );

    cmn.ItemFly( "obj_coffe_table_flag_1", func_end, 1.22, 40 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hillmark_monogram ()

  local item = "inv_hillmark_monogram";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_bedroom_drawerchest" ) and cmn.IsEventDone( "get_torn_shirt" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedroom_drawerchest" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bedroom_drawerchest_use_hillmark_monogram" )  and cmn.IsEventDone( "get_torn_shirt" )) then

    cmn.CallEventHandler( "use_hillmark_monogram_inv" );
    cmn.CallEventHandler( "use_hillmark_monogram_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_hillmark_monogram" );
        cmn.CallEventHandler( "use_hillmark_monogram_end" );

      end;

      ObjMultiSet( { 
        { "spr_bedroom_drawerchest_minidoor", { alp = 0 } },
        { "anm_bedroom_drawerchest_minidoor", { alp = 1 } },
      } );

      AnimPlay( "anm_bedroom_drawerchest_minidoor", "minidoor", func_end_2 );   

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_hilmark_monogram", 0, "", 0 );

    cmn.ItemFly( "spr_bedroom_drawerchest_h", func_end, -1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wrought_handle ()

  local item = "inv_wrought_handle";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_bedroom_drawerchest" ) and cmn.IsEventDone( "clk_wrought_handle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedroom_drawerchest" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bedroom_drawerchest_use_wrought_handle" ) and cmn.IsEventDone( "clk_wrought_handle" ) ) then

    cmn.CallEventHandler( "use_wrought_handle_inv" );
    cmn.CallEventHandler( "use_wrought_handle_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_wrought_handle" );
      cmn.CallEventHandler( "use_wrought_handle_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_handle_drawer", 0, "", 0 );

    ObjMultiSet( { 
      { "spr_bedroom_drawerchest_door", { alp = 0 } },
      { "anm_bedroom_drawerchest_door", { alp = 1 } },
    } );

    AnimPlay( "anm_bedroom_drawerchest_door", "door", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lucien_signet ()

  local item = "inv_lucien_signet";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_bedroom_drawerchest" )  and cmn.IsEventDone( "get_torn_shirt" )) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedroom_drawerchest" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bedroom_drawerchest_use_lucien_signet" )  and cmn.IsEventDone( "get_torn_shirt" )) then

    cmn.CallEventHandler( "use_lucien_signet_inv" );
    cmn.CallEventHandler( "use_lucien_signet_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_lucien_signet" );
        cmn.CallEventHandler( "use_lucien_signet_end" );

      end;

      ObjAnimate( "spr_bedroom_drawerchest_minidoor2", "alp",0,0, func_end_2, { 0.0,0,1, 0.3,0,0, } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_ring3", 0, "", 0 );

    cmn.ItemFly( "spr_bedroom_drawerchest_ring", func_end, -1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sapling ()

  local item = "inv_sapling";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_window" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window" );

    return true;
    
  elseif ( cmn.ApplyObj( item, "gzz_window_window2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_window2', 'not_frame', { { x = 400, y = 120 },{ x = 280, y = 320 } }, { x = 201, y = -156 } ); 
    
    return true;
    
  elseif ( cmn.ApplyObj( item, "obj_window_use_sapling" ) ) then

    cmn.CallEventHandler( "use_sapling_inv" );
    cmn.CallEventHandler( "use_sapling_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_sapling" );
      cmn.CallEventHandler( "use_sapling_end" );
      private.get_amulet_part_1();
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_sapling", 0, "", 0 );

    AnimPlay( "anm_window2_branch", "get_amulet", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_disk ()

  local item = "inv_disk";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_window" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window_use_disk" ) ) then

    cmn.CallEventHandler( "use_disk_inv" );
    cmn.CallEventHandler( "use_disk_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_disk" );
        cmn.CallEventHandler( "use_disk_end" );
      
      end;
      
      ObjMultiSet( { 
        { "spr_window_cache_door",  { alp = 0 } },
        { "anm_window_open_secret", { alp = 1 } },
      } );
      AnimPlay( "anm_window_open_secret", "open_secret", func_end_2 );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_bird_amulet", 0, "", 0 );

    cmn.ItemFly( "spr_window_cache_door_disk", func_end, -1.22, 70 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_figurine ()

  local item = "inv_figurine";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_window" ) and
       cmn.IsEventDone( "clk_window_handle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window_use_figurine" ) and
           cmn.IsEventDone( "clk_window_handle" ) ) then

    cmn.CallEventHandler( "use_figurine_inv" );
    cmn.CallEventHandler( "use_figurine_beg" );

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "use_figurine" );
      cmn.CallEventHandler( "use_figurine_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_figurine", 0, "", 0 );
    
    AnimPlay( "anm_window_broken", "window_broken", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_decorative_fragment ()

  local item = "inv_decorative_fragment";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_window" ) and 
       cmn.IsEventDone( "get_flag_1" ) and
       cmn.IsEventDone( "get_chisel" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window_use_decorative_fragment" ) and 
       cmn.IsEventDone( "get_flag_1" ) and
       cmn.IsEventDone( "get_chisel" ) ) then

    cmn.CallEventHandler( "use_decorative_fragment_inv" );
    cmn.CallEventHandler( "use_decorative_fragment_beg" );

    local func_end = function ()
       
      cmn.Lock( false );
      cmn.SetEventDone( "use_decorative_fragment" );
      cmn.CallEventHandler( "use_decorative_fragment_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_decorative_fragment", 0, "", 0 );

    ObjMultiSet( { 
      { "spr_window_cache_door2", { alp = 0 } },
      { "anm_window_cache",       { alp = 1 } },
    } );
    AnimPlay( "anm_window_cache", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bas_relief ()

  local item = "inv_bas_relief";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_window" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window_use_bas_relief" ) ) then

    cmn.CallEventHandler( "use_bas_relief_inv" );
    cmn.CallEventHandler( "use_bas_relief_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bas_relief" );
      cmn.CallEventHandler( "use_bas_relief_end" );
      
      private.WindowLoad();
      cmn.MiniGameShow( "window" );
      common_impl.PassingMgStart( "window" );
      
      common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_cutters", 0, "", 0 );

    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_window_basrelief", func_end, -1.22, 60 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_maggie ()

  local item = "inv_maggie";

  if ( cmn.ApplyObj( item, "obj_lucien_room_use_maggie" ) ) then

    cmn.CallEventHandler( "use_maggie_inv" );
    cmn.CallEventHandler( "use_maggie_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_maggie" );
      cmn.CallEventHandler( "use_maggie_end" );

      interface.KeyTaskDone( true );
      interface.KeyTaskAdd( "lvl3_help_maggie" );

      common_impl.PlayAudio( "env", "level3/env/aud_sobs_env", 1, "", 0 ); 

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_maggie", 0, "", 0 );

    ObjSet( "anm_lucien_room_use_maggee", { alp = 1 } );
    AnimPlay( "anm_lucien_room_use_maggee", "use_maggee", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cloth_bandage ()

  local item = "inv_cloth_bandage";

  if ( cmn.ApplyObj( item, "obj_lucien_room_use_cloth_bandage" ) and cmn.IsEventDone( "use_maggie" ) ) then

    cmn.CallEventHandler( "use_cloth_bandage_inv" );
    cmn.CallEventHandler( "use_cloth_bandage_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_cloth_bandage" );
      cmn.CallEventHandler( "use_cloth_bandage_end" );

      private.dlg_lucien_room_maggie();
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_bandage", 0, "", 0 );
    common_impl.StopAudio( "env", "level3/env/aud_sobs_env", 0.5 );

    ObjSet( "anm_lucien_room_maggee_bandage", { alp = 1 } );
    AnimPlay( "anm_lucien_room_maggee_bandage", "maggee_bandage", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_steering_wheel ()

  local item = "inv_steering_wheel";

  if ( cmn.ApplyObj( item, "obj_lucien_room_use_steering_wheel" ) ) then

    cmn.CallEventHandler( "use_steering_wheel_inv" );
    cmn.CallEventHandler( "use_steering_wheel_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_steering_wheel" );
      cmn.CallEventHandler( "use_steering_wheel_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_wheel3", 0, "", 0 );

    AnimPlay( "anm_lucien_room_steering_wheel", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_amulet_part_1_ghost ()

  local item = "inv_amulet_part_1";

  if ( cmn.ApplyObj( item, "obj_lucien_room_use_amulet_part_1_ghost" ) ) then

    cmn.CallEventHandler( "use_amulet_part_1_ghost_inv" );
    cmn.CallEventHandler( "use_amulet_part_1_ghost_beg" );

    local func_open = function ()
    
      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_amulet_part_1_ghost" );
        cmn.CallEventHandler( "use_amulet_part_1_ghost_end" );
        
        cmn.MiniGameShow( "dark" );
        common_impl.PassingMgStart( "dark" );
        
        private.DarkLoad();
        private.DarkUpdate();

        cmn.StopMusEnv();
        common_impl.PlayAudio( "mus_env", "mus_env/aud_danger2_mus_env", 1, "", 0 );

      end;
      
      ObjAnimate( "obj_lucien_room_mmg", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_amulet_part_1_ghost", 0, "", 0 );

    AnimPlay( "anm_lucien_room_amulet_use", "amulet_use", func_open )
  
    return true;

  end;
  
  return false;
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_will ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_will" );
  cmn.CallEventHandler( "get_will" );

end;
--------------------------------------------------------------------------------------------
function private.get_crumpled_paper ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_crumpled_paper" );
  cmn.CallEventHandler( "get_crumpled_paper" );

end;
--------------------------------------------------------------------------------------------
function private.get_hands ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hands" );
  cmn.CallEventHandler( "get_hands" );

end;
--------------------------------------------------------------------------------------------
function private.get_figurine ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_figurine" );
  cmn.CallEventHandler( "get_figurine" );

end;
--------------------------------------------------------------------------------------------
function private.get_ship_model ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ship_model" );
  cmn.CallEventHandler( "get_ship_model" );

end;
--------------------------------------------------------------------------------------------
function private.get_torn_shirt ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_torn_shirt" );
  cmn.CallEventHandler( "get_torn_shirt" );

end;
--------------------------------------------------------------------------------------------
function private.get_can ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_can" );
  cmn.CallEventHandler( "get_can" );

end;
--------------------------------------------------------------------------------------------
function private.get_amulet_part_3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_amulet_part_3" );
  cmn.CallEventHandler( "get_amulet_part_3" );
  
  if ( cmn.IsEventDone( "get_barber_key" ) and
  cmn.IsGetCollect2( "get_collect2_item_21" ) ) then
    
    common.CloseSubRoom();

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_disk ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_disk" );
  cmn.CallEventHandler( "get_disk" );

end;
--------------------------------------------------------------------------------------------
function private.get_barber_key ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_barber_key" );
  cmn.CallEventHandler( "get_barber_key" );
  
  if ( cmn.IsEventDone( "get_amulet_part_3" ) and
  cmn.IsGetCollect2( "get_collect2_item_21" ) ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_diamond_lvl3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_diamond_lvl3" );
  cmn.CallEventHandler( "get_diamond_lvl3" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_amulet_part_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_amulet_part_1" );
  cmn.CallEventHandler( "get_amulet_part_1" );
  common.CloseSubRoomAll();
  
end;
--------------------------------------------------------------------------------------------
function private.get_coal ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_coal" );
  cmn.CallEventHandler( "get_coal" );

end;
--------------------------------------------------------------------------------------------
function private.get_wrought_handle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wrought_handle" );
  cmn.CallEventHandler( "get_wrought_handle" );

end;
--------------------------------------------------------------------------------------------
function private.get_chisel ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_chisel" );
  cmn.CallEventHandler( "get_chisel" );

end;
--------------------------------------------------------------------------------------------
function private.get_flag_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_flag_1" );
  cmn.CallEventHandler( "get_flag_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_golden_key ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_golden_key" );
  cmn.CallEventHandler( "get_golden_key" );

end;
--------------------------------------------------------------------------------------------
function private.get_decorative_fragment ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_decorative_fragment" );
  cmn.CallEventHandler( "get_decorative_fragment" );

end;
--------------------------------------------------------------------------------------------
function private.get_white_ghost_amulet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_white_ghost_amulet" );
  cmn.CallEventHandler( "get_white_ghost_amulet" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_21 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_21" ); 

  end;

  common_impl.PlayEffectHO( "spr_bedroom_drawerchest_collect2_item_21", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_21" );
  
  if ( cmn.IsEventDone( "get_barber_key" ) and
  cmn.IsEventDone( "get_amulet_part_3" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_wrought_handle ()
  
  cmn.CallEventHandler( "clk_wrought_handle_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_wrought_handle" );
    cmn.CallEventHandler( "clk_wrought_handle_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_break_handle_safe", 0, "", 0 );
  
  AnimPlay( "anm_bedroom_drawerchest_handle", "handle", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_window_handle ()
  
  cmn.CallEventHandler( "clk_window_handle_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_window_handle" );
    cmn.CallEventHandler( "clk_window_handle_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_break_handle_window", 0, "", 0 );
  
  AnimPlay( "anm_window_handle", "handle", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_window_open ()
  
  cmn.CallEventHandler( "clk_window_open_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_window_open" );
    cmn.CallEventHandler( "clk_window_open_end" ); 
    private.see_scare_window_2(); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_window_zm", 0, "", 0 );
  
  AnimPlay( "anm_window_open", "window_open", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_coffee_table_clock ()
  
  cmn.CallEventHandler( "clk_coffee_table_clock_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_coffee_table_clock" );
    cmn.CallEventHandler( "clk_coffee_table_clock_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_opn_clock", 0, "", 0 );
  
  ObjAnimate( "spr_coffee_table_cap", "alp", 0, 0, func_end, { 0.0,0,0,  0.3,3,1 });
  ObjAnimate( "spr_coffee_table_cap_close", "alp", 0, 0, "", { 0.0,0,1,  0.3,3,0 }); 
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG SAFE *** () end;
--*********************************************************************************************************************
function private.SafeLoad ()
  
  private.state = { 0, 0, 0, 0, 0 }; 
  private.win   = { 12, 8, 4, 10, 11 }; 
  
  for i = 1, 12 do 
      
    ObjSet( "obj_safe_num_"..i, { input = true, event_mdown = function() private.SafeClk( i ); end } );   
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.SafeIsWin ()

  for i = 1, 5 do

    if ( private.state[ i ] ~= private.win[ i ] ) then
    
      return false;
      
    end;
    
  end;
  
  return true;
  
end;
--------------------------------------------------------------------------------------------
function private.SafeClk ( id ) 

  for i = 1,5 do 
    
    if ( private.state[ i ] == 0 ) then
      
      private.state[ i ] = id;
      break;
      
    end;
    
  end;
  
  private.SafeAnim( id );
  
end;
--------------------------------------------------------------------------------------------
function private.SafeDefault ()
  
  local func_end = function ()
    
    cmn.Lock( false );
    
  end;
  
  private.state = { 0, 0, 0, 0, 0 }; 
  
  cmn.Lock( true );
  
  for i = 1, 12 do 
    
    ObjSet( "obj_safe_num_"..i, { input = true } );   
    local alp = ObjGet( "spr_safe_num_"..i.."_light" ).alp
    ObjAnimate( "spr_safe_num_"..i.."_light", "alp", 0, 0, "", {
      0.0, 0, alp,
      0.1, 0, 0,
      0.2, 0, 1,
      0.3, 0, 0,
      0.4, 0, 1,
      0.5, 0, 0
    }); 
  
  end;
  
  ObjAnimate( "obj_safe_mmg", "alp", 0, 0, func_end, {
    0.0, 0, 1,
    0.6, 0, 1,
  }); 
  
end;
--------------------------------------------------------------------------------------------
function private.SafeAnim ( id )

  common_impl.PlayAudio( "sfx", "aud_xx_click1", 0, "", 0 );

  local func_end = function ()
    
      cmn.Lock( false );
      
      if ( private.state[ 5 ] ~= 0 ) then
      
        if ( private.SafeIsWin() ) then
          
          private.SafeWin();
          
        else 
        
          common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );  
          private.SafeDefault();
          
        end;
        
      end;
    
  end;  
  
  cmn.Lock( true );
  local alp = ObjGet( "spr_safe_num_"..id.."_light" ).alp
  
  if ( alp ~= 0 ) then
    
    ObjAnimate( "spr_safe_num_"..id.."_light", "alp", 0, 0, func_end, { 0, 0, alp,   0.2, 3, 0,   0.5, 3, 1 } ); 
    
  else 
    
    ObjAnimate( "spr_safe_num_"..id.."_light", "alp", 0, 0, func_end, { 0, 0, alp,   0.3, 3, 1 } );     
    
  end;
  
end;  
--------------------------------------------------------------------------------------------
function private.SafeWin ()

  local func_end = function ()
    
    cmn.MiniGameHide( "safe" );
    cmn.SetEventDone( "win_safe" );
    cmn.CallEventHandler( "win_safe" );
    common_impl.PassingMgWin( "safe" );
    common_impl.PlayAudio( "sfx", "aud_win_mmg" );
    cmn.Lock( false );
    
    common.CloseSubRoom();
    
  end;

  cmn.Lock( true );
  
  for i = 1, 12 do
    
    local alp = ObjGet( "spr_safe_num_"..i.."_light" ).alp
      
    ObjAnimate( "spr_safe_num_"..i.."_light", "alp", 0, 0, "", { 0, 0, alp,   0.3, 3, 0 } );    
    
  end;  
  
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_box", 0, "", 0 );
  --AnimPlay( "anm_safe_door_open", "door_open", func_end );
  ObjAnimate( "obj_safe_mmg", "alp", 0, 0, func_end, { 0, 0, 1,   0.5, 3, 1 } ); 
    
end; 
--*********************************************************************************************************************
-- function *** MMG COFFEETABLE *** () end;
--*********************************************************************************************************************
function private.CoffeeTableStart ()
  
  if not ( ng_global.progress[ "std" ][ "win_coffee_table" ].state ) then
    
    ng_global.progress[ "std" ][ "win_coffee_table" ].state = { 1, 1, 1 }; 
    
  end;
  
  private.state    = { 1, 1, 1 }; 
  private.win      = { 2, 3, 2 };  
  private.wincor   = { { -254, -106 }, { -195, -93 }, { -136, -71 } };  
  private.statecor = { { -254, -133 }, { -195, -120 }, { -136, -98 } };    
  for i = 1, #private.win do 
    
    private.state[ i ] = ng_global.progress[ "std" ][ "win_coffee_table" ].state[ i ];    
    local pos = ObjGet( "obj_coffe_table_"..i.."_"..private.state[ i ] );
    ObjSet( "obj_coffe_table_flag_"..i, { pos_x = pos.pos_x, pos_y = pos.pos_y, event_mdown = function() private.CoffeeTableClk( i ); end } );   
    
    if private.state[ i ] == private.win[ i ] then
      
      local pos = ObjGet( "spr_coffee_table_mmg_flagshtoc_"..i );
      
      ObjSet( "spr_coffee_table_mmg_flagshtoc_"..i, { input = false } );
      ObjAnimate( "spr_coffee_table_mmg_flagshtoc_"..i, "pos_x", 0, 0, "", { 0, 0, pos.pos_x,   0.3, 3, private.wincor[ i ][ 1 ] } ); 
      ObjAnimate( "spr_coffee_table_mmg_flagshtoc_"..i, "pos_y", 0, 0, "", { 0, 0, pos.pos_y,   0.3, 3, private.wincor[ i ][ 1 ] } ); 
      
    end;
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.CoffeeTableLoad ()
  
  if not ( ng_global.progress[ "std" ][ "win_coffee_table" ].state ) then
    
    ng_global.progress[ "std" ][ "win_coffee_table" ].state = { 1, 1, 1 }; 
    
  end;
  
  private.state    = { 1, 1, 1 }; 
  private.win      = { 2, 3, 2 };  
  private.wincor   = { { -254, -106 }, { -195, -93 }, { -136, -71 } };  
  private.statecor = { { -254, -133 }, { -195, -120 }, { -136, -98 } };    
  for i = 1, #private.win do 
    
    private.state[ i ] = ng_global.progress[ "std" ][ "win_coffee_table" ].state[ i ];    
    local pos = ObjGet( "obj_coffe_table_"..i.."_"..private.state[ i ] );
    ObjSet( "obj_coffe_table_flag_"..i, { pos_x = pos.pos_x, pos_y = pos.pos_y, event_mdown = function() private.CoffeeTableClk( i ); end } );   
    
    if private.state[ i ] == private.win[ i ] then
      
      ObjSet( "spr_coffee_table_mmg_flagshtoc_"..i, { input = false, pos_x = private.wincor[ i ][ 1 ], pos_y = private.wincor[ i ][ 2 ] } );   
      
    end;
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.CoffeeTableIsWin ()

  for i = 1, #private.win do

    if ( private.state[ i ] ~= private.win[ i ] ) then
    
      return false;
      
    end;
    
  end;
  
  return true;
  
end;
--------------------------------------------------------------------------------------------
function private.CoffeeTableClk ( id ) 

  private.state[ id ] = private.state[ id ] + 1;
  
  private.CoffeeTableAnim( id );
  
end;
--------------------------------------------------------------------------------------------
function private.CoffeeTableDefault ()
  
  local func_end = function ()
          
    cmn.Lock( false );
    private.CoffeeTableStart();
      
  end;  
  
  private.state = { 1, 1, 1 }; 
  ng_global.progress[ "std" ][ "win_coffee_table" ].state = { 1, 1, 1 }; 
  
  cmn.Lock( true );
  
  for i = 1, #private.win do 
    
    local pos_old = ObjGet( "obj_coffe_table_flag_"..i );
    local pos_new = ObjGet( "obj_coffe_table_"..i.."_"..private.state[ i ] );
    
    common_impl.PlayAudio( "sfx", "aud_clk", 0, "", 0 );    
    ObjAnimate( "obj_coffe_table_flag_"..i, "pos_xy", 0, 0, "", { 0, 0, pos_old.pos_x, pos_old.pos_y,   0.3, 3, pos_new.pos_x, pos_new.pos_y } );    
    local pos = ObjGet( "spr_coffee_table_mmg_flagshtoc_"..i );
    ObjSet( "spr_coffee_table_mmg_flagshtoc_"..i, { input = true } );
    ObjAnimate( "spr_coffee_table_mmg_flagshtoc_"..i, "pos_x", 0, 0, "", { 0, 0, pos.pos_x,   0.3, 3, private.statecor[ i ][ 1 ] } ); 
    ObjAnimate( "spr_coffee_table_mmg_flagshtoc_"..i, "pos_y", 0, 0, "", { 0, 0, pos.pos_y,   0.3, 3, private.statecor[ i ][ 2 ] } ); 
    
  end;
  
  ObjAnimate( "obj_coffee_table_mmg", "alp", 0, 0, func_end, {
    0.0, 0, 1,
    0.6, 0, 1,
  }); 
  
end;
--------------------------------------------------------------------------------------------
function private.CoffeeTableAnim ( id )

  common_impl.PlayAudio( "sfx", "aud_xx_click1", 0, "", 0 );
  
  local func_end_2 = function ()
    
    if ( private.CoffeeTableIsWin() ) then
      
      private.CoffeeTableWin();
      
    else 
    
      common_impl.PlayAudio( "sfx", "aud_clk", 0, "", 0 );  
      ng_global.progress[ "std" ][ "win_coffee_table" ].state[ id ] = private.state[ id ];
      
    end;
      
  end;
  
  local func_end = function ()
    
    cmn.Lock( false );
    
    if private.state[ id ] == private.win[ id ] then
      
      local pos = ObjGet( "spr_coffee_table_mmg_flagshtoc_"..id );
      
      ObjSet( "spr_coffee_table_mmg_flagshtoc_"..id, { input = false } );
      ObjAnimate( "spr_coffee_table_mmg_flagshtoc_"..id, "pos_x", 0, 0, func_end_2, { 0, 0, pos.pos_x,   0.3, 3, private.wincor[ id ][ 1 ] } ); 
      ObjAnimate( "spr_coffee_table_mmg_flagshtoc_"..id, "pos_y", 0, 0, "", { 0, 0, pos.pos_y,   0.3, 3, private.wincor[ id ][ 2 ] } ); 
      
    else 
    
      func_end_2();
      
    end;   
      
  end;  
  
  cmn.Lock( true );
  
  local pos_old = ObjGet( "obj_coffe_table_flag_"..id );
  local pos_new = ObjGet( "obj_coffe_table_"..id.."_"..private.state[ id ] );
  
  common_impl.PlayAudio( "sfx", "aud_clk", 0, "", 0 );    
  ObjAnimate( "obj_coffe_table_flag_"..id, "pos_xy", 0, 0, func_end, { 0, 0, pos_old.pos_x, pos_old.pos_y,   0.3, 3, pos_new.pos_x, pos_new.pos_y } );     
    
end;  
--------------------------------------------------------------------------------------------
function private.CoffeeTableWin ()

  local func_end = function ()
    
    cmn.MiniGameHide( "coffee_table" );
    cmn.SetEventDone( "win_coffee_table" );
    cmn.CallEventHandler( "win_coffee_table" );
    common_impl.PassingMgWin( "coffee_table" );
    common_impl.PlayAudio( "sfx", "aud_win_mmg" );
    common.CloseSubRoom();
    cmn.Lock( false );
      
  end;

  cmn.Lock( true );
  
  for i = 1, #private.win do
    
    local pos_old = ObjGet( "obj_coffe_table_flag_"..i );
    local pos_new = ObjGet( "obj_coffe_table_"..i.."_"..private.state[ i ] );
      
    ObjAnimate( "obj_coffe_table_flag_"..i, "pos_xy", 0, 0, "", { 0, 0, pos_old.pos_x, pos_old.pos_y,   0.3, 3, pos_new.pos_x, pos_new.pos_y } );    
    local pos = ObjGet( "spr_coffee_table_mmg_flagshtoc_"..i );
    ObjSet( "spr_coffee_table_mmg_flagshtoc_"..i, { input = true } );
    ObjAnimate( "spr_coffee_table_mmg_flagshtoc_"..i, "pos_x", 0, 0, "", { 0, 0, pos.pos_x,   0.3, 3, private.wincor[ i ][ 1 ] } );
    ObjAnimate( "spr_coffee_table_mmg_flagshtoc_"..i, "pos_y", 0, 0, "", { 0, 0, pos.pos_y,   0.3, 3, private.wincor[ i ][ 2 ] } );
    
  end;  
  
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_box", 0, "", 0 );
  --AnimPlay( "anm_safe_door_open", "door_open", func_end );
  ObjAnimate( "obj_coffee_table_mmg", "alp", 0, 0, func_end, { 0, 0, 1,   0.5, 3, 1 } ); 
    
end; 
--*********************************************************************************************************************
-- function *** MMG WINDOW *** () end;
--*********************************************************************************************************************
function private.WindowLoad ()
  
  if not ( ng_global.progress[ "std" ][ "win_window" ].state ) then
    
    ng_global.progress[ "std" ][ "win_window" ].state = { 1, 2, 2, 1, 3, 4, 3, 5, 4 }; 
    
  end;
                                                          
  private.state = { 0, 0, 0, 0, 0, 0, 0, 0, 0 }; 
  private.win   = { 0, 0, 0, 0, 0, 0, 0, 5, 0 }; 
  private.pair  = { 0, 0 }; 
  
  for i = 1,#private.win do 
      
    ObjSet( "obj_window_slot_"..i, { event_mdown = function() private.WindowClk( i ); end } );   
    private.state[ i ] = ng_global.progress[ "std" ][ "win_window" ].state[ i ];
    
    if private.state[ i ] == 0 then
      
      ObjSet( "obj_window_slot_"..i, { input = false } );   
      ObjSet( "spr_window_door_"..i, {   alp = 0     } );  
      
    end;
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.WindowIsWin ()

  for i = 1,#private.win do

    if ( private.state[ i ] ~= private.win[ i ] ) then
    
      return false;
      
    end;
    
  end;
  
  return true;
  
end;
--------------------------------------------------------------------------------------------
function private.WindowClk ( id ) 

  --for i = 1,2 do 
    
    if ( private.pair[ 1 ] == 0 ) then
      
      private.pair[ 1 ] = id;
      private.state[ private.pair[ 1 ] ] = 0;
      
    else
      
      private.pair[ 2 ] = id;  
      private.state[ private.pair[ 2 ] ] = 0;
      
    end;
    
  --end;
  
  private.WindowAnim( id );
  
end;
--------------------------------------------------------------------------------------------
function private.WindowSave ()
   
  local func_end = function ()
    
    cmn.Lock( false );
    
  end;
  
  if ( ng_global.progress[ "std" ][ "win_window" ].state[ private.pair[ 1 ] ] == ng_global.progress[ "std" ][ "win_window" ].state[ private.pair[ 2 ] ] ) then 
    
    for i = 1,#private.pair do 

        ng_global.progress[ "std" ][ "win_window" ].state[ private.pair[ i ] ] = 0;
                
    end;
    
  end;
    
  if ( private.WindowIsWin() ) then
    
    private.WindowWin();
    
  else
    
    private.WindowDefault();
    
  end;  
  
end;
--------------------------------------------------------------------------------------------
function private.WindowDefault ()

  local func_end = function ()
    
    cmn.Lock( false );
    
  end;
  
  cmn.Lock( true );
  
  for i = 1,#private.win do 
    
    if ( ng_global.progress[ "std" ][ "win_window" ].state[ i ] ~= 0 ) then

      private.state[ i ] = ng_global.progress[ "std" ][ "win_window" ].state[ i ];    
      ObjSet( "obj_window_slot_"..i, { input = true } );   
      local alp = ObjGet( "spr_window_door_"..i ).alp
      ObjAnimate( "spr_window_door_"..i, "alp", 0, 0, "", {
        0.0, 0, alp,
        0.3, 0, 1
      }); 
    
    end;
  
  end;
  
  ObjAnimate( "obj_window_mmg", "alp", 0, 0, func_end, {
    0.0, 0, 1,
    0.6, 0, 1,
  }); 
  
  private.pair = { 0, 0 }; 
  
end;
--------------------------------------------------------------------------------------------
function private.WindowAnim ( id )

  common_impl.PlayAudio( "sfx", "aud_xx_click1", 0, "", 0 );
  
  local func_end = function ()
    
      cmn.Lock( false );
      
      if ( private.pair[ 2 ] ~= 0 ) then
      
        if ( private.WindowIsWin() ) then
          
          private.WindowWin();
          
        else 
        
          --common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );  
          private.WindowSave();
          
        end;
        
      end;
    
  end;  
  
  cmn.Lock( true );
  local alp = ObjGet( "spr_window_door_"..id ).alp
  ObjMultiSet( { 
    { "obj_window_slot_"..id,  { input = false } },
  } );   
  ObjAnimate( "spr_window_door_"..id, "alp", 0, 0, func_end, { 0, 0, alp,   0.3, 3, 0 } );  
  
end;  
--------------------------------------------------------------------------------------------
function private.WindowWin ()

  local func_end = function ()
    
    cmn.MiniGameHide( "window" );
    cmn.SetEventDone( "win_window" );
    cmn.CallEventHandler( "win_window" );
    common_impl.PassingMgWin( "window" );
    common_impl.PlayAudio( "sfx", "aud_win_mmg" );
    cmn.Lock( false );
      
  end;

  cmn.Lock( true );
  
  for i = 1, #private.win do
    
    local alp = ObjGet( "spr_window_door_"..i ).alp
      
    ObjAnimate( "spr_window_door_"..i, "alp", 0, 0, "", { 0, 0, alp,   0.3, 3, 0 } );    
     
  end;  
  
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_box", 0, "", 0 );
  --AnimPlay( "anm_safe_door_open", "door_open", func_end );
  ObjAnimate( "obj_window_mmg", "alp", 0, 0, func_end, { 0, 0, 1,   0.5, 3, 1 } ); 
  
end; 
--*********************************************************************************************************************
-- function *** MMG DARK *** () end;
--*********************************************************************************************************************

-- 0 - край поля
-- 1 - пустая ячейка
-- 2 - зеленая(наша) ячейка
-- 3 - красная(враг) ячейка

private.pos_start = { 354, 222 };
private.pos_increase = 65;
private.cell_activ = {};

for i = 3, 8 do
  
  for j = 3, 8 do
    
    ObjClone( "obj_lucien_room_mmg_cell", "_"..i.."_"..j, true, "obj_lucien_room_mmg_cells" );
    
    ObjSet( "obj_lucien_room_mmg_cell_"..i.."_"..j, {
    
      pos_x = private.pos_start[ 1 ] + private.pos_increase * ( i - 3 ),
      pos_y = private.pos_start[ 2 ] + private.pos_increase * ( j - 3 ),
      event_mdown = function() private.DarkCellClick( i, j ) end
    
    } )
    
  end;
  
end;
--*********************************************************************************************************************
function public.Skip ()
  
  private.DarkWin();
  
end;
--*********************************************************************************************************************
function public.Reset ()
  
  private.DarkDefault();
  private.DarkUpdate();
  
end;
--------------------------------------------------------------------------------------------
function private.DarkDefault ()
  
  ng_global.progress[ "std" ][ "win_dark" ].panel = {

    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 3, 1, 1, 1, 1, 1, 0, 0 },
    { 0, 0, 1, 1, 1, 1, 1, 1, 0, 0 },
    { 0, 0, 1, 1, 1, 1, 1, 1, 0, 0 },
    { 0, 0, 1, 1, 1, 1, 1, 1, 0, 0 },
    { 0, 0, 1, 1, 1, 1, 1, 1, 0, 0 },
    { 0, 0, 1, 1, 1, 1, 1, 2, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }

  };
  
  ng_global.progress[ "std" ][ "win_dark" ].turn = 1;
  
end;
--------------------------------------------------------------------------------------------
function private.DarkLoad ()

  if ( not ng_global.progress[ "std" ][ "win_dark" ].panel ) then 

    private.DarkDefault();

  end; 

  private.gamedata = ng_global.progress[ "std" ][ "win_dark" ];

end;
--------------------------------------------------------------------------------------------
function private.DarkCellsDefault ( i, j )
  
  local tb = {};
  
  for i = 3, 8 do
    
    for j  = 3, 8 do
      
      table.insert( tb, { "spr_lucien_room_mmg_cell_green_focus_"..i.."_"..j, { visible = false } } );
      table.insert( tb, { "spr_lucien_room_mmg_cell_step_"..i.."_"..j, { visible = false } } );
      table.insert( tb, { "spr_lucien_room_mmg_cell_jump_"..i.."_"..j, { visible = false } } );
      
    end;
    
  end;
  
  ObjMultiSet( tb );
  private.DarkUpdate();

end;
--------------------------------------------------------------------------------------------
function private.DarkUpdate ()
  
  local tb = {};
  
  for i = 3, 8 do
    
    for j = 3, 8 do
    
      if private.gamedata.panel[ i ][ j ] == 2 then
        
        table.insert( tb, { "obj_lucien_room_mmg_cell_"..i.."_"..j, { input = true } } );
        table.insert( tb, { "spr_lucien_room_mmg_cell_green_"..i.."_"..j, { alp = 1 } } );
        table.insert( tb, { "spr_lucien_room_mmg_cell_red_"..i.."_"..j, { alp = 0 } } );
        
      elseif private.gamedata.panel[ i ][ j ] == 3 then
        
        table.insert( tb, { "obj_lucien_room_mmg_cell_"..i.."_"..j, { input = false } } );
        table.insert( tb, { "spr_lucien_room_mmg_cell_red_"..i.."_"..j, { alp = 1 } } );
        table.insert( tb, { "spr_lucien_room_mmg_cell_green_"..i.."_"..j, { alp = 0 } } );
        
      elseif private.gamedata.panel[ i ][ j ] == 1 then
        
        table.insert( tb, { "obj_lucien_room_mmg_cell_"..i.."_"..j, { input = false } } );
        table.insert( tb, { "spr_lucien_room_mmg_cell_red_"..i.."_"..j, { alp = 0 } } );
        table.insert( tb, { "spr_lucien_room_mmg_cell_green_"..i.."_"..j, { alp = 0 } } );
        
      end;
      
    end;
    
  end;
  
  ObjMultiSet( tb );

end;
--------------------------------------------------------------------------------------------
function private.DarkCellClick ( i, j )
  
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_button2", 0, "", 0 );
  private.DarkCellsDefault();
  
  if private.cell_activ[ 1 ] == i and private.cell_activ[ 2 ] == j then
    
    private.cell_activ = {};
    return
    
  elseif private.gamedata.panel[ i ][ j ] == 1 then
    
    private.DarkMove( private.cell_activ, { i, j } );
    
    private.cell_activ = {};
    return
    
  end;
  
  private.cell_activ = { i, j };
  
  local tb = {};
  
  table.insert( tb, { "spr_lucien_room_mmg_cell_green_focus_"..i.."_"..j, { visible = true } } );
  
  for di = -2, 2 do
    
    for dj = -2, 2 do
      
      if ( not ( ( di == 0 ) and ( dj == 0 ) ) ) then
        
        if private.gamedata.panel[ i + di ][ j + dj ] == 1 then
          
          if ( ( math.abs( di ) == 2 ) or ( math.abs( dj ) == 2 ) ) then
          
            table.insert( tb, { "spr_lucien_room_mmg_cell_jump_"..i + di.."_"..j + dj, { visible = true } } );
            
          else
            
            table.insert( tb, { "spr_lucien_room_mmg_cell_step_"..i + di.."_"..j + dj, { visible = true } } );
            
          end;
          
          table.insert( tb, { "obj_lucien_room_mmg_cell_"..i + di.."_"..j + dj, { input = true } } );
          
        end;
        
      end;
      
    end;
    
  end;
  
  ObjMultiSet( tb );

end;
--------------------------------------------------------------------------------------------
function private.DarkMove ( cell_start, cell_end )
  
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_green_button", 0, "", 0 );

  if ( math.abs( cell_end[ 1 ] - cell_start[ 1 ] ) == 2 ) or ( math.abs( cell_end[ 2 ] - cell_start[ 2 ] ) == 2 ) then
    
    private.DarkMoveJump( cell_start, cell_end );
    
  else
    
    private.DarkMoveStep( cell_start, cell_end );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.DarkMoveJump ( cell_start, cell_end )

  local func_end = function()
  
    cmn.Lock( false );
    
    ObjDelete( "obj_lucien_room_mmg_appearance_"..cell_start[1].."_"..cell_start[2] );
    ObjDelete( "obj_lucien_room_mmg_appearance_"..cell_end[1].."_"..cell_end[2] );
  
    private.gamedata.panel[ cell_start[1] ][ cell_start[2] ] = 1;
    private.gamedata.panel[ cell_end[1] ][ cell_end[2] ] = private.gamedata.turn + 1;
    
    private.DarkUpdate();
    
    private.DarkCellCatch ( cell_end );
    
  end;
  
  cmn.Lock( true );
  
  ObjClone( "obj_lucien_room_mmg_appearance", "_"..cell_start[1].."_"..cell_start[2], true, "obj_lucien_room_mmg_cell_"..cell_start[1].."_"..cell_start[2] );
  ObjClone( "obj_lucien_room_mmg_appearance", "_"..cell_end[1].."_"..cell_end[2], true, "obj_lucien_room_mmg_cell_"..cell_end[1].."_"..cell_end[2] );
  
  ObjSet( "spr_lucien_room_mmg_cell_red_"..cell_start[1].."_"..cell_start[2], { alp = 0 } );
  ObjSet( "spr_lucien_room_mmg_cell_green_"..cell_start[1].."_"..cell_start[2], { alp = 0 } );
  
  ObjAnimate( "spr_lucien_room_mmg_appearance_"..private.gamedata.turn.."_"..cell_start[1].."_"..cell_start[2], "alp", 0, 0, "", {
  
    0.0, 0, 1,
    0.2, 0, 0
  
  } );
  
  ObjAnimate( "spr_lucien_room_mmg_appearance_"..private.gamedata.turn.."_"..cell_end[1].."_"..cell_end[2], "alp", 0, 0, func_end, {
  
    0.0, 0, 0,
    0.2, 0, 1
  
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.DarkMoveStep ( cell_start, cell_end )

  local func_end = function()
  
    cmn.Lock( false );
    
    ObjDelete( "obj_lucien_room_mmg_appearance_"..cell_end[1].."_"..cell_end[2] );
    
    private.gamedata.panel[ cell_end[1] ][ cell_end[2] ] = private.gamedata.turn + 1;
    
    private.DarkUpdate();
    
    private.DarkCellCatch ( cell_end );
  
  end;
  
  cmn.Lock( true );
  
  ObjClone( "obj_lucien_room_mmg_appearance", "_"..cell_end[1].."_"..cell_end[2], true, "obj_lucien_room_mmg_cell_"..cell_end[1].."_"..cell_end[2] );
  
  ObjAnimate( "spr_lucien_room_mmg_appearance_"..private.gamedata.turn.."_"..cell_end[1].."_"..cell_end[2], "alp", 0, 0, func_end, {
  
    0.0, 0, 0,
    0.2, 0, 1
  
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.DarkCellCatch ( cell_end )
  
  common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );

  local found_id = 3;
  local found_cell = {};
  local func = "";
  
  local func_end = function()
  
    cmn.Lock( false );
    
    for i = 1, #found_cell do
    
      ObjDelete( "obj_lucien_room_mmg_change_"..found_cell[i][1].."_"..found_cell[i][2] );
      
      private.gamedata.panel[ found_cell[i][1] ][ found_cell[i][2] ] = private.gamedata.turn + 1;
      
    end;
    
    private.DarkUpdate();
    private.DarkChangeTurn();
  
  end;
  
  cmn.Lock( true );
  
  if private.gamedata.turn == 2 then
    
    found_id = 2;
    
  end;
  
  for i = -1, 1 do
    
    for j = -1, 1 do
      
      if private.gamedata.panel[ cell_end[ 1 ] + i ][ cell_end[ 2 ] + j ] == found_id then
        
        table.insert( found_cell, { cell_end[ 1 ] + i, cell_end[ 2 ] + j } );
        
      end;
      
    end;
    
  end;
  
  if #found_cell ~= 0 then
    
    for i = 1, #found_cell do
      
      if i == #found_cell then
        
        func = func_end;
        
      end;
      
      ObjClone( "obj_lucien_room_mmg_change", "_"..found_cell[i][1].."_"..found_cell[i][2], true, "obj_lucien_room_mmg_cell_"..found_cell[i][1].."_"..found_cell[i][2] );
      
      ObjAnimate( "spr_lucien_room_mmg_change_"..private.gamedata.turn.."_"..found_cell[i][1].."_"..found_cell[i][2], "alp", 0, 0, func, {
      
        0.0, 0, 0,
        0.2, 0, 1
      
      } );
      
      local second = 1;
      
      if private.gamedata.turn == 1 then
        
        second = 2;
        
      end;
      
      ObjAnimate( "spr_lucien_room_mmg_change_"..second.."_"..found_cell[i][1].."_"..found_cell[i][2], "alp", 0, 0, "", {
      
        0.0, 0, 1,
        0.2, 0, 0
      
      } );
      
    end;
    
  else
      
    func_end();
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.DarkIO ()
  
  --{ стартовая координата, конечная координата, приоритет }
  local best_move = { { 1, 1 }, { 1, 1  }, -2 };
  
  for i = 3, 8 do
    
    for j = 3, 8 do
      
      if private.gamedata.panel[i][j] == 3 then
        
        for di = 2, -2, -1 do
          
          for dj = 2, -2, -1 do
            
            if ( not ( ( di == 0 ) and ( dj == 0 ) ) ) then
              
              if private.gamedata.panel[ i + di ][ j + dj ] == 1 then
                
                local count = 0;
                
                for ddi = -1, 1 do
                  
                  for ddj = -1, 1 do
                    
                    if ( not ( ( ddi == 0 ) and ( ddj == 0 ) ) ) then
                      
                      if private.gamedata.panel[ i + di + ddi ][ j + dj + ddj ] == 2 then
                        
                        count = count + 1;
                        
                      end;
                      
                    end;
                    
                  end;
                  
                end;
                
                local jump = 0;
                
                if ( ( math.abs( di ) == 2 ) or ( math.abs( dj ) == 2 ) ) then
                  
                  jump = 1;
                  
                end;
                
                if best_move[3] < count - jump then
                  
                  best_move[1] = { i, j };
                  best_move[2] = { i + di, j + dj };
                  best_move[3] = count - jump;
                  
                end;
                
              end;
              
            end;
            
          end;
          
        end;
        
      end;
      
    end;
    
  end;
  
  private.DarkMove( best_move[1], best_move[2] );
  
end;
--------------------------------------------------------------------------------------------
function private.DarkChangeTurn ()
  
  if private.DarkCheckStep() then
  
    if private.gamedata.turn == 1 then
      
      private.gamedata.turn = 2;
      
      ObjSet( "tmr_lucien_room_mmg_io", { playing = true, time = 0.2, endtrig = private.DarkIO } );

    else
      
      private.DarkCheckStep()
      
      private.gamedata.turn = 1;
      
    end;
    
  else
    
    local func_end = function ()
    
      cmn.Lock( false );
      
      private.DarkUpdate();
    
      private.DarkCheckWin();
      
    end;
    
    for i = 3, 8 do
    
      for j = 3, 8 do
        
        if private.gamedata.panel[ i ][ j ] == 1 then
          
          private.gamedata.panel[ i ][ j ] = private.gamedata.turn + 1;
          
        end;
        
      end;
      
    end;
    
    func_end();
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.DarkCheckStep ()
  
  local player = 0;
  local io = 0;
  local empty = 0;
  
  for i = 3, 8 do
    
    for j = 3, 8 do
      
      if private.gamedata.panel[ i ][ j ] == 2 then
        
        player = player + 1;
        
      elseif private.gamedata.panel[ i ][ j ] == 3 then
        
        io = io + 1;
        
      elseif private.gamedata.panel[ i ][ j ] == 1 then
        
        empty = empty + 1;
        
      end;
      
    end;
    
  end;
  
  if empty == 0 or player == 0 or io == 0 then
    
    return false;
    
  end;
  
  local second = 2;
  
  if private.gamedata.turn == 1 then
    
    second = 3;
    
  end;
  
  for i = 3, 8 do
    
    for j = 3, 8 do
      
      if private.gamedata.panel[ i ][ j ] == second then
        
        for di = -2, 2 do
          
          for dj = -2, 2 do
            
            if private.gamedata.panel[ i + di ][ j + dj ] == 1 then
              
              return true;
              
            end;
            
          end;
          
        end;
        
      end;
      
    end;
    
  end;

  return false;
  
end;

--------------------------------------------------------------------------------------------
function private.DarkCheckWin ()
  
  local player = 0;
  local io = 0;
  
  for i = 3, 8 do
    
    for j = 3, 8 do
      
      if private.gamedata.panel[ i ][ j ] == 2 then
        
        player = player + 1;
        
      elseif private.gamedata.panel[ i ][ j ] == 3 then
        
        io = io + 1;
        
      end;
      
    end;
    
  end;
  
  if player > io then
    
    private.DarkWin();
    
  else
    
    private.DarkLose();
    
  end;
  
end;

--------------------------------------------------------------------------------------------
function private.DarkLose ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    ObjMultiSet( {
  
      { "anm_lucien_room_mg_loss", { active = false, visible = false } },
      { "anm_lucien_room_amulet_statics", { active = true, visible = true } },
      { "anm_lucien_room_dark_statics", { active = true, visible = true } },
  
    } );
    
    public.Reset();
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_morrice_attack", 0, "", 0 );

  ObjMultiSet( {
  
    { "anm_lucien_room_mg_loss", { active = true, visible = true } },
    { "anm_lucien_room_amulet_statics", { active = false, visible = false } },
    { "anm_lucien_room_dark_statics", { active = false, visible = false } },
  
  } );
  
  AnimPlay( "anm_lucien_room_mg_loss", "mg_loss", func_end );
  
  ObjAnimate( "obj_lucien_room_mmg", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0,   3, 0, 0,   3.3, 0, 1 } );
  
end;
--------------------------------------------------------------------------------------------
function private.DarkWin ()
  
  local func_end = function()
  
    cmn.SetEventDone( "win_dark" );
    cmn.CallEventHandler( "win_dark" );
  
    cmn.Lock( false );
    
    common_impl.PassingMgWin( "dark" );

    common_impl.ShowBbt( 'bbt_lucien_room_we_meet_again_win' );  

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl3_track_ghost" );
  
  end;
  
  cmn.MiniGameHide( "dark" );
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_room_animation3",     0, "", 0 );
  common_impl.PlayAudio( "voc", "level3/voc/aud_room_animation3_voc", 0, "", 0 );

  cmn.StopMusEnv();
  common_impl.StopAudio( "mus_env", "mus_env/aud_danger2_mus_env", 0.5 );
  common_impl.PlayMusEnv();

  ObjMultiSet( {
    { "anm_lucien_room_amulet_statics",     { active = false, visible = false } },
    { "anm_lucien_room_dark_statics",       { active = false, visible = false } },
    { "anm_lucien_room_dark_disappearance", {    alp = 1                      } },
  } );
  
  AnimPlay( "anm_lucien_room_dark_disappearance", "disappearance", func_end );
  AnimPlay( "anm_lucien_room_disappearance_cupboard", "disappearance_cupboard", "" );

  common_impl.ShowBbt( 'sub_lucien_room_we_meet_again' );  

  ObjAnimate( "obj_lucien_room_mmg", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 } );
  
end;
  
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
function private.dlg_lucien_room_maggie ()

  common_impl.dialog_character_loc = "obj_lucien_room_magge";
  
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "maggie", 5, nil, nil, true, private.dlg_lucien_room_maggie_end ); 
  
end;
--------------------------------------------------------------------------------------------
function private.dlg_lucien_room_maggie_end ()
  
  private.get_decorative_fragment();
  cmn.CallEventHandler( "dlg_lucien_room_maggie" );

  common_impl.ShowBbt( 'bbt_lucien_room_dlg_lucien_room_maggie' );

  interface.KeyTaskDone( true );
  interface.KeyTaskAdd( "lvl3_find_and_save_clark" );
  
end;

--*********************************************************************************************************************
function private.dlg_lucien_room_lucien_1 ()

  common_impl.dialog_character_loc = "anm_lucien_room_lucien";
  
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "lucien_1", 5, nil, nil, true, private.dlg_lucien_room_lucien_1_end ); 
  
end;
--------------------------------------------------------------------------------------------
function private.dlg_lucien_room_lucien_1_end ()
  
  private.get_white_ghost_amulet();
  cmn.CallEventHandler( "dlg_lucien_room_lucien_1" ); 
  
  ObjSet( "anm_lucien_room_lucien_disappeared", { alp = 1 } );
  AnimPlay( "anm_lucien_room_lucien_disappeared", "lucien_disappeared", "" );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_lucien_disappearance", 0, "", 0 );

  common_impl.ShowBbt( 'bbt_lucien_room_dlg_lucien_room_lucien_1' );

  interface.KeyTaskDone( true );
  interface.KeyTaskAdd( "lvl3_restore_amulet_ghost" );
  
end;


--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
  if ( dlg_name == "maggie" ) then
    
    if ( count_txt == 1 ) then
      
      VidPlay( "vid_dlg_lucien_room_maggie_static_1", "" );
      
    elseif ( count_txt == 2 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_lucien_room_maggie_static_2",  { alp = 1, visible = true } },
        { "vid_dlg_lucien_room_maggie_static_1",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_lucien_room_maggie_static_2", "" );
      
    elseif ( count_txt == 3 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_lucien_room_maggie_static_3",  { alp = 1, visible = true } },
        { "vid_dlg_lucien_room_maggie_static_2",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_lucien_room_maggie_static_3", "" );
      
    elseif ( count_txt == 4 ) then
      
      ObjMultiSet( { 
        { "anm_dlg_lucien_room_maggie_give",  { alp = 1, visible = true } },
        { "anm_dlg_lucien_room_maggie_static",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_lucien_room_maggie_static_4", "" );
   
    end;
  
  elseif ( dlg_name == "lucien_1" ) then
    
    if ( count_txt == 1 ) then
      
      VidPlay( "vid_dlg_lucien_room_lucien_1_static_1", "" );
      
    elseif ( count_txt == 2 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_lucien_room_lucien_1_static_2",  { alp = 1, visible = true } },
        { "vid_dlg_lucien_room_lucien_1_static_1",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_lucien_room_lucien_1_static_2", "" );
      
    elseif ( count_txt == 3 ) then
      
      ObjMultiSet( { 
        { "vid_dlg_lucien_room_lucien_1_static_3",  { alp = 1, visible = true } },
        { "vid_dlg_lucien_room_lucien_1_static_2",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_lucien_room_lucien_1_static_3", "" );
      
    elseif ( count_txt == 4 ) then
      
      ObjMultiSet( { 
        { "anm_dlg_lucien_room_lucien_1_give",  { alp = 1, visible = true } },
        { "anm_dlg_lucien_room_lucien_1_static",  { alp = 0, visible = false } },
      } );
      
      VidPlay( "vid_dlg_lucien_room_lucien_1_static_4", "" );
   
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.see_scare_window ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_scare_window" );
    cmn.CallEventHandler( "see_scare_window_end" ); 
    
    common_impl.ShowBbt( 'bbt_window_see_scare_window' );

  end;
  
  cmn.Lock( true );
  
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_ghosts_window", 0, "", 0 );
  ObjMultiSet( { 
    { "anm_window_lucien_room_window2",  { alp = 1 } },
  } );
  AnimPlay( "anm_window_lucien_room_window2", "DoAnim", func_end );
  
  
end;
--*********************************************************************************************************************
function private.see_scare_window_2 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_scare_window_2" );
    cmn.CallEventHandler( "see_scare_window_2" );

    common_impl.ShowBbt( 'bbt_window_see_scare_window_2' );

  end;
  
  cmn.Lock( true );
  
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_scare_window_2", 0, "", 0 );
  ObjMultiSet( { 
    { "anm_window_lucien_room_window",  { alp = 1 } },
  } );
  AnimPlay( "anm_window_lucien_room_window", "DoAnim", func_end );
  
  
end;
--*********************************************************************************************************************
function private.see_lucien_room_1 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_lucien_room_1" );
    cmn.CallEventHandler( "see_lucien_room_1" );

    common_impl.ShowBbt( 'bbt_lucien_room_see_lucien_room_1' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_lucien_room_1", 0, "", 0 );

  ObjSet( "anm_lucien_room_lucien_1", { alp = 1 } );
  AnimPlay( "anm_lucien_room_lucien_1", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
function private.see_lucien_room_2 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_lucien_room_2" );
    cmn.CallEventHandler( "see_lucien_room_2" );

    common_impl.ShowBbt( 'bbt_lucien_room_see_lucien_room_2' );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl3_ghost" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_lucien_room_2",     0, "", 0 );
  common_impl.PlayAudio( "voc", "level3/voc/aud_lucien_room_2_voc", 0, "", 0 );

  AnimPlay( "anm_lucien_room_dark_emergence", "emergence", func_end )

  common_impl.ShowBbt( 'sub_lucien_room_prepare_to_die' );
  
end;
--*********************************************************************************************************************
function private.see_lucien_appearance ()
  
  local func_end = function( skip )
    
    if skip then
  
      --common_impl.StopAudio( "voc", "level1/voc/aud_outro_voc",  0.2 );
      common_impl.StopAudio( "sfx", "level3/sfx/aud_lucien_appearance",      0.2 );
      
    end;

    cmn.SetEventDone( "see_lucien_appearance" );
    cmn.CallEventHandler( "see_lucien_appearance" );

    common_impl.ShowBbt( 'bbt_lucien_room_see_lucien_appearance' );
    
  end;

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_lucien_appearance", 0, "", 0 );
  --common_impl.PlayAudio( "mus", "level1/mus/aud_intro_mus",  0, "", 0 );
  --common_impl.PlayAudio( "voc", "level1/voc/aud_outro_voc",  0, "", 0 );
  
  cmn.PlayDialogVideo( "vid_lucien_room_lucien_appearance", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lucien_room ()

  if not ( cmn.IsEventDone( "opn_lucien_room" ) ) then

    cmn.SetEventDone( "opn_lucien_room" );

    common_impl.ShowBbt( 'bbt_lucien_room_opn_lucien_room' );

  end;
  cmn.CallEventHandler( "opn_lucien_room" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.AnimUseHillmarkMonogram ()

  common_impl.ShowBbt( 'bbt_bedroom_drawerchest_use_hillmark_monogram' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wallet", 0, "", 0 );
  
  ObjAnimate( "spr_bedroom_drawerchest_minidoor", "pos_x", 0, 1, func_end, { 0.0,0,0,  0.2,3,-2,  0.4,3,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseLucienSignet ()

  common_impl.ShowBbt( 'bbt_bedroom_drawerchest_use_lucien_signet' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_opn_wood_safe", 0, "", 0 );
  
  ObjAnimate( "spr_bedroom_drawerchest_minidoor2", "pos_x", 0, 1, func_end, { 0.0,0,0,  0.2,3,2,  0.4,3,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseWroughtHandle ()

  common_impl.ShowBbt( 'bbt_bedroom_drawerchest_use_wrought_handle' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_wood_mid_3", 0, "", 0 );
  
  ObjAnimate( "spr_bedroom_drawerchest_door", "pos_x", 0, 1, func_end, { 0.0,0,0,  0.2,3,-2,  0.4,3,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseBasRelief ()

  common_impl.ShowBbt( 'bbt_window_use_bas_relief' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );

  if cmn.IsEventDone("use_figurine") then

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_small_box1", 0, "", 0 );
    ObjAnimate( "obj_window_mmg_doors", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,0,1,1,  0.4,3,0,0 });

  else func_end();
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimUseDisk ()

  common_impl.ShowBbt( 'bbt_window_use_disk' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_wood_mid_4", 0, "", 0 );
  
  ObjAnimate( "spr_window_cache_door", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,0,-1,1,  0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseDecorativeFragment ()

  common_impl.ShowBbt( 'bbt_window_use_decorative_fragment' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wallet", 0, "", 0 );

  ObjAnimate( "spr_window_cache_door2", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,0,-1,1,  0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseChisel ()

  common_impl.ShowBbt( 'bbt_coffee_table_use_chisel' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_wood_high1", 0, "", 0 );
  
  ObjAnimate( "spr_coffee_table_figurine", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,0,-1,0,  0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseGoldenKey ()

  common_impl.ShowBbt( 'bbt_coffee_table_use_golden_key' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_drawer", 0, "", 0 );
  
  ObjAnimate( "spr_coffee_table_box_left_face", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,0,-1,1,  0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseFlags ()

  common_impl.ShowBbt( 'bbt_coffee_table_use_flag_1' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_wood_button2", 0, "", 0 );
  
  ObjAnimate( "spr_coffee_table_mmg_flagshtoc_1", "pos_y", 0, 1, func_end, { 0.0,0,0,0,  0.2,0,0,2,  0.4,3,0,0 });
  ObjAnimate( "spr_coffee_table_mmg_flagshtoc_2", "pos_y", 0, 1, "", { 0.0,0,0,  0.2,0,6,  0.4,3,0 });
  ObjAnimate( "spr_coffee_table_mmg_flagshtoc_3", "pos_y", 0, 1, "", { 0.0,0,0,  0.2,0,4,  0.4,3,0 });
  
end;
--*********************************************************************************************************************