-- name=rm_tower
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_tower";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_spyglass",        "room_hub" );
  ObjAttach( "zz_clock_mechanism", "room_hub" );
  ObjAttach( "zz_clockface",       "room_hub" );

  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_spyglass_ink_pen",                  { event_mdown = private.get_ink_pen           }},
    { "spr_spyglass_eyepiece",                 { event_mdown = private.get_eyepiece          }},
    { "obj_spyglass_clk_ring",                 { event_mdown = private.clk_ring_lvl3         }},
    { "obj_spyglass_use_ring",                 { event_mdown = private.AnimUseRing           }},

    { "spr_clock_mechanism_amulet_part_2",     { event_mdown = private.get_amulet_part_2     }},
    { "spr_clock_mechanism_oil",               { event_mdown = private.get_oil               }},
    { "obj_clock_mechanism_use_strange_shard", { event_mdown = private.AnimUseStrangeShard   }},  
    { "obj_clock_mechanism_use_clock_part",    { event_mdown = private.AnimUseClockPart      }},  
    { "obj_clock_mechanism_use_hands",         { event_mdown = private.AnimUseHands          }}, 

    { "spr_clockface_adjustable_wrench",       { event_mdown = private.get_adjustable_wrench }},
    { "spr_clockface_feathers",                { event_mdown = private.get_feathers          }},
    { "obj_clockface_use_oil",                 { event_mdown = private.AnimUseOil            }},
    { "obj_clockface_use_black_cat",           { event_mdown = private.AnimUseBlackCat       }},

    { "obj_tower_clk_tower_ghost",             { event_mdown = private.see_tower_ghost       }},
    { "obj_tower_clk_tower_spyglass",          { event_mdown = private.see_tower_spyglass    }},

    { "spr_tower_collect_morph_item",          { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_15" ); end } },
    { "spr_spyglass_collect2_item_16",         { event_mdown = private.get_collect2_item_16      }}, 
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_tower = function ()
  
    table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gmg_tower_clock",
      "gzz_tower_spyglass",
      "gzz_tower_clock_mechanism",
      "gzz_tower_clockface",
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_spyglass",
      "zz_clock_mechanism",
      "zz_clockface",
      "zz_clockface_2",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_tower", update_game_mode_tower, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_tower = function ()

    local effects_table = 
    {
      "obj_tower_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_tower", update_performance_mode_tower, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_tower () end;
  --------------------------------------------------------------------------------------------
  local opn_tower_map = function ()

    common_impl.VisitMapRoom( "tower" );

  end;
  cmn.AddSubscriber( "opn_tower", opn_tower_map );
  
 --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_15 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_15 = function ()
  
    ObjDelete( "obj_tower_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_15", get_collect_morph_item_15, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_16 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_16 = function ()
    
    ObjDelete( "obj_spyglass_collect2_item_16" ); 
  
    if ( cmn.IsEventDone( "get_eyepiece" ) ) then
      
      ObjDelete( "gzz_tower_spyglass" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_16", get_collect2_item_16, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function get_ink_pen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ink_pen" ] = {
    type = "get",
    get_obj = "spr_spyglass_ink_pen",
    room = private.room_objname,
    zz = "zz_spyglass",
    zz_gate = "gzz_tower_spyglass"
  };
  
  local get_ink_pen_inv = function ()
  
    interface.InventoryItemAdd( "inv_ink_pen", "spr_spyglass_ink_pen" );
  
  end;
  
  local get_ink_pen_closezz = function ()
  
    ObjDelete( "gfx_spyglass_ink_pen"      );
    ObjDelete( "spr_tower_zz_spyglass_pen" );

  end;
  
  cmn.AddSubscriber( "get_ink_pen", get_ink_pen_inv );
  cmn.AddSubscriber( "get_ink_pen", get_ink_pen_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_eyepiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_eyepiece" ] = {
    type = "get",
    get_obj = "spr_spyglass_eyepiece",
    room = private.room_objname,
    zz = "zz_spyglass",
    zz_gate = "gzz_tower_spyglass"
  };
  
  local get_eyepiece_inv = function ()
  
    interface.InventoryItemAdd( "inv_eyepiece", "spr_spyglass_eyepiece" );
  
  end;
  
  local get_eyepiece_closezz = function ()
  
    ObjDelete( "gfx_spyglass_eyepiece"         );
    ObjDelete( "spr_tower_zz_spyglass_lens_in" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_16" ) ) then
      
      ObjDelete( "gzz_tower_spyglass" );
      
    end;    

  end;
  
  cmn.AddSubscriber( "get_eyepiece", get_eyepiece_inv );
  cmn.AddSubscriber( "get_eyepiece", get_eyepiece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulet_part_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulet_part_2" ] = {
    type = "get",
    get_obj = "spr_clock_mechanism_amulet_part_2",
    room = private.room_objname,
    zz = "zz_clock_mechanism",
    zz_gate = "gzz_tower_clock_mechanism"
  };
  
  local get_amulet_part_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_amulet_part_2", "spr_clock_mechanism_amulet_part_2" );
    
    --if ( cmn.IsEventDone( "get_amulet_part_1" ) and cmn.IsEventDone( "get_amulet_part_2" ) and 
    --     cmn.IsEventDone( "get_amulet_part_3" ) and cmn.IsEventDone( "get_amulet_part_4" ) and 
    --     cmn.IsEventDone( "get_amulet_part_5" ) and cmn.IsEventDone( "get_amulet_part_6" )
    --    ) then
    --
    --    cmn.SetInvPlusRGB( "white_ghost_amulet", true );
    --    
    --end;
    cmn.SetInvPlusRGB( "white_ghost_amulet", true );  
  end;
  
  local get_amulet_part_2_closezz = function ()
  
    ObjDelete( "gfx_clock_mechanism_amulet_part_2" );
    if cmn.IsEventDone("use_clock_part") and ObjGet("gzz_tower_clock_mechanism") then
      ObjDelete( "gzz_tower_clock_mechanism" );
    end;
  end;
  
  cmn.AddSubscriber( "get_amulet_part_2", get_amulet_part_2_inv );
  cmn.AddSubscriber( "get_amulet_part_2", get_amulet_part_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oil () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oil" ] = {
    type = "get",
    get_obj = "spr_clock_mechanism_oil",
    room = private.room_objname,
    zz = "zz_clock_mechanism",
    zz_gate = "gzz_tower_clock_mechanism"
  };
  
  local get_oil_inv = function ()
  
    interface.InventoryItemAdd( "inv_oil", "spr_clock_mechanism_oil" );
  
  end;
  
  local get_oil_closezz = function ()
  
    ObjDelete( "gfx_clock_mechanism_oil" );
  
  end;
  
  cmn.AddSubscriber( "get_oil", get_oil_inv );
  cmn.AddSubscriber( "get_oil", get_oil_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_adjustable_wrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_adjustable_wrench" ] = {
    type = "get",
    get_obj = "spr_clockface_adjustable_wrench",
    room = private.room_objname,
    zz = "zz_clockface",
    zz_gate = "gzz_tower_clockface"
  };
  
  local get_adjustable_wrench_inv = function ()
  
    interface.InventoryItemAdd( "inv_adjustable_wrench", "spr_clockface_adjustable_wrench" );
  
  end;
  
  local get_adjustable_wrench_closezz = function ()
  
    ObjDelete( "gfx_clockface_adjustable_wrench"          );
    ObjDelete( "spr_tower_zz_clockface_adjustable_wrench" );

  end;
  
  cmn.AddSubscriber( "get_adjustable_wrench", get_adjustable_wrench_inv );
  cmn.AddSubscriber( "get_adjustable_wrench", get_adjustable_wrench_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_feathers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_feathers" ] = {
    type = "get",
    get_obj = "spr_clockface_feathers",
    room = private.room_objname,
    zz = "zz_clockface",
    zz_gate = "gzz_tower_clockface"
  };
  
  local get_feathers_inv = function ()
  
    interface.InventoryItemAdd( "inv_feathers", "spr_clockface_feathers" );
  
  end;
  
  local get_feathers_closezz = function ()
  
    ObjDelete( "gfx_clockface_feathers"          );
    ObjDelete( "spr_tower_zz_clockface_feathers" );
  
  end;
  
  cmn.AddSubscriber( "get_feathers", get_feathers_inv );
  cmn.AddSubscriber( "get_feathers", get_feathers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ring_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ring_lvl3" ] = {
    type = "use",
    inv_obj = "inv_ring_lvl3",
    use_place = "obj_spyglass_use_ring",
    room = private.room_objname,
    zz = "zz_spyglass",
    zz_gate = "gzz_tower_spyglass"
  };
  local use_ring_lvl3_inv = function ()
  
    interface.InventoryItemRemove( "inv_ring_lvl3" );
  
  end;
  local use_ring_lvl3_beg = function ()
  
    ObjDelete( "obj_spyglass_use_ring" );
  
  end;
  local use_ring_lvl3_end = function ()
  
    ObjMultiSet( { 
      { "spr_spyglass_eyepiece",     {  input = true             } },
      { "gfx_spyglass_eyepiece",     { active = true             } },
      { "anm_spyglass_open",         {  frame = 500              } },
      { "spr_tower_zz_spyglass_cap", {  pos_x = 700, pos_y = 266 } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ring_lvl3", use_ring_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_lvl3", use_ring_lvl3_inv );
  cmn.AddSubscriber( "use_ring_lvl3", use_ring_lvl3_end, private.room_objname );
  cmn.AddSubscriber( "use_ring_lvl3_inv", use_ring_lvl3_inv, private.room_objname );
  cmn.AddSubscriber( "use_ring_lvl3_beg", use_ring_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_lvl3_end", use_ring_lvl3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_strange_shard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_strange_shard" ] = {
    type = "use",
    inv_obj = "inv_strange_shard",
    use_place = "obj_clock_mechanism_use_strange_shard",
    room = private.room_objname,
    zz = "zz_clock_mechanism",
    zz_gate = "gzz_tower_clock_mechanism"
  };
  local use_strange_shard_inv = function ()
  
    interface.InventoryItemRemove( "inv_strange_shard" );
  
  end;
  local use_strange_shard_beg = function ()
  
    ObjDelete( "obj_clock_mechanism_use_strange_shard" );
  
  end;
  local use_strange_shard_end = function ()
    
    ObjMultiSet( { 
      { "obj_clock_mechanism_use_clock_part", { input = true, active = true, visible = true } },
      { "obj_clock_mechanism_use_hands",      { input = true, active = true, visible = true } },
      { "spr_tower_zz_clock_mechansm_open",   {   alp = 1                                   } },
    } );
    ObjDelete( "spr_tower_zz_clock_mechansm_closed" );  
    ObjDelete( "spr_clock_closed"                   );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_strange_shard",     use_strange_shard_beg, private.room_objname );
  cmn.AddSubscriber( "use_strange_shard",     use_strange_shard_inv                       );
  cmn.AddSubscriber( "use_strange_shard",     use_strange_shard_end, private.room_objname );
  cmn.AddSubscriber( "use_strange_shard_inv", use_strange_shard_inv, private.room_objname );
  cmn.AddSubscriber( "use_strange_shard_beg", use_strange_shard_beg, private.room_objname );
  cmn.AddSubscriber( "use_strange_shard_end", use_strange_shard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hands () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hands" ] = {
    type = "use",
    inv_obj = "inv_hands",
    use_place = "obj_clock_mechanism_use_hands",
    room = private.room_objname,
    zz = "zz_clock_mechanism",
    zz_gate = "gzz_tower_clock_mechanism"
  };
  local use_hands_inv = function ()
  
    interface.InventoryItemRemove( "inv_hands" );
  
  end;
  local use_hands_beg = function ()
  
    ObjDelete( "obj_clock_mechanism_use_hands" );
  
  end;
  local use_hands_end = function ()
  
    ObjMultiSet( { 
      { "spr_clock_mechanism_amulet_part_2", {  input = true } },
      { "gfx_clock_mechanism_amulet_part_2", { active = true } },
      { "spr_clock_mechanism_oil",           {  input = true } },
      { "gfx_clock_mechanism_oil",           { active = true } },
      { "anm_clock_arrow",                   {  frame = 500  } },
    } );
    ObjDelete( "spr_tower_zz_clock_mechanism_watch" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hands",     use_hands_beg, private.room_objname );
  cmn.AddSubscriber( "use_hands",     use_hands_inv                       );
  cmn.AddSubscriber( "use_hands",     use_hands_end, private.room_objname );
  cmn.AddSubscriber( "use_hands_inv", use_hands_inv, private.room_objname );
  cmn.AddSubscriber( "use_hands_beg", use_hands_beg, private.room_objname );
  cmn.AddSubscriber( "use_hands_end", use_hands_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clock_part () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clock_part" ] = {
    type = "use",
    inv_obj = "inv_clock_part",
    use_place = "obj_clock_mechanism_use_clock_part",
    room = private.room_objname,
    zz = "zz_clock_mechanism",
    zz_gate = "gzz_tower_clock_mechanism"
  };
  local use_clock_part_inv = function ()
  
    interface.InventoryItemRemove( "inv_clock_part" );
  
  end;
  local use_clock_part_beg = function ()
  
    ObjDelete( "obj_clock_mechanism_use_clock_part" );
  
  end;
  local use_clock_part_end = function ()
  
    ObjMultiSet( { 
      { "spr_tower_zz_clock_mechanism_weight_1", { pos_y = 479 } },
      { "spr_tower_zz_clock_mechanism_weight_2", {   alp = 1   } },
      { "anm_clock_weight",     {   frame = 500                } },
      { "gmg_tower_clock",      { visible = true, input = true } },
    } );
    ObjDelete( "spr_tower_zz_clock_mechanism_catch" );
    ObjDelete( "spr_clock_cach"                     );
    
    if cmn.IsEventDone("get_amulet_part_2") and ObjGet("gzz_tower_clock_mechanism") then
      ObjDelete( "gzz_tower_clock_mechanism" );
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clock_part",     use_clock_part_beg, private.room_objname );
  cmn.AddSubscriber( "use_clock_part",     use_clock_part_inv                       );
  cmn.AddSubscriber( "use_clock_part",     use_clock_part_end, private.room_objname );
  cmn.AddSubscriber( "use_clock_part_inv", use_clock_part_inv, private.room_objname );
  cmn.AddSubscriber( "use_clock_part_beg", use_clock_part_beg, private.room_objname );
  cmn.AddSubscriber( "use_clock_part_end", use_clock_part_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_black_cat_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_black_cat_2" ] = {
    type = "use",
    inv_obj = "inv_black_cat",
    use_place = "obj_clockface_use_black_cat",
    room = private.room_objname,
    zz = "zz_clockface",
    zz_gate = "gzz_tower_clockface"
  };
  local use_black_cat_2_inv = function ()
    
    if ( cmn.IsEventDone( "use_black_cat_1" ) ) then
      
      interface.InventoryItemRemove( "inv_black_cat" );
      
    end;
  
  end;
  local use_black_cat_2_beg = function ()
  
    ObjDelete( "obj_clockface_use_black_cat" );
  
  end;
  local use_black_cat_2_end = function ()
  
    ObjMultiSet( { 
      { "spr_clockface_feathers", {  input = true, alp = 1 } },
      { "gfx_clockface_feathers", { active = true          } },
    } );
    ObjDelete( "anm_clockface_cat_use" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_black_cat_2", use_black_cat_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_black_cat_2", use_black_cat_2_inv );
  cmn.AddSubscriber( "use_black_cat_2", use_black_cat_2_end, private.room_objname );
  cmn.AddSubscriber( "use_black_cat_2_inv", use_black_cat_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_black_cat_2_beg", use_black_cat_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_black_cat_2_end", use_black_cat_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rope_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_rope_lvl3" ] = {
    type = "use",
    inv_obj = "inv_rope_lvl3",
    use_place = "obj_clockface_use_rope",
    room = private.room_objname,
    zz = "zz_clockface",
    zz_gate = "gzz_tower_clockface"
  };
  local use_rope_lvl3_inv = function ()
  
    interface.InventoryItemRemove( "inv_rope_lvl3" );
  
  end;
  local use_rope_lvl3_beg = function ()
  
    ObjDelete( "obj_clockface_use_rope" );
  
  end;
  local use_rope_lvl3_end = function ()
  
    ObjDelete( "gzz_tower_clockface" );
    ObjMultiSet( { 
      { "grm_tower_brook",  { visible = true, input = true } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_tower_brook_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rope_lvl3", use_rope_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_rope_lvl3", use_rope_lvl3_inv );
  cmn.AddSubscriber( "use_rope_lvl3", use_rope_lvl3_end, private.room_objname );
  cmn.AddSubscriber( "use_rope_lvl3_inv", use_rope_lvl3_inv, private.room_objname );
  cmn.AddSubscriber( "use_rope_lvl3_beg", use_rope_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_rope_lvl3_end", use_rope_lvl3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bone" ] = {
    type = "use",
    inv_obj = "inv_bone",
    use_place = "obj_clockface_use_bone",
    room = private.room_objname,
    zz = "zz_clockface",
    zz_gate = "gzz_tower_clockface"
  };
  local use_bone_inv = function ()
  
    interface.InventoryItemRemove( "inv_bone" );
  
  end;
  local use_bone_beg = function ()
  
    ObjDelete( "obj_clockface_use_bone" );
  
  end;
  local use_bone_end = function ()
    
    ObjMultiSet( { 
      { "obj_clockface_use_rope",      { input = true, active = true, visible = true }},
      { "obj_clockface_use_black_cat", { input = true, active = true, visible = true }},
      { "anm_clockface_arrow_blocked", {    alp = 1,   plaing = true                 }},

      { "anm_tower_arrow_stopped",     {    alp = 1,   plaing = true                 }},
      { "spr_tower_zz_clockface_bone", {    alp = 1,                                 }},
    } );

    ObjDelete( "anm_tower_arrow_active"    );
    ObjDelete( "anm_clockface_arrow_move"  );
    ObjDelete( "anm_clockface_put_in_bone" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bone", use_bone_beg, private.room_objname );
  cmn.AddSubscriber( "use_bone", use_bone_inv );
  cmn.AddSubscriber( "use_bone", use_bone_end, private.room_objname );
  cmn.AddSubscriber( "use_bone_inv", use_bone_inv, private.room_objname );
  cmn.AddSubscriber( "use_bone_beg", use_bone_beg, private.room_objname );
  cmn.AddSubscriber( "use_bone_end", use_bone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oil () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oil" ] = {
    type = "use",
    inv_obj = "inv_oil",
    use_place = "obj_clockface_use_oil",
    room = private.room_objname,
    zz = "zz_clockface",
    zz_gate = "gzz_tower_clockface"
  };
  local use_oil_inv = function ()
  
    interface.InventoryItemRemove( "inv_oil" );
  
  end;
  local use_oil_beg = function ()
  
    ObjDelete( "obj_clockface_use_oil" );
  
  end;
  local use_oil_end = function ()
  
    ObjMultiSet( { 
      { "spr_clockface_adjustable_wrench", {  input = true } },
      { "gfx_clockface_adjustable_wrench", { active = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oil", use_oil_beg, private.room_objname );
  cmn.AddSubscriber( "use_oil", use_oil_inv );
  cmn.AddSubscriber( "use_oil", use_oil_end, private.room_objname );
  cmn.AddSubscriber( "use_oil_inv", use_oil_inv, private.room_objname );
  cmn.AddSubscriber( "use_oil_beg", use_oil_beg, private.room_objname );
  cmn.AddSubscriber( "use_oil_end", use_oil_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_ring_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_ring_lvl3" ] = {
    type = "click",
    use_place = "obj_spyglass_clk_ring",
    room = private.room_objname,
    zz = "zz_spyglass",
    zz_gate = "gzz_tower_spyglass"
  };
  
  local clk_ring_lvl3_beg = function ()

    ObjDelete( "obj_spyglass_clk_ring" );
  
  end;
  local clk_ring_lvl3_end = function ()
    
    ObjMultiSet( { 
      { "obj_spyglass_use_ring", { input = true, active = true, visible = true } },
      { "anm_spyglass_open",     {   alp = 1                                   } },
    } );

    ObjDelete( "anm_spyglass_clk" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_ring_lvl3",     clk_ring_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ring_lvl3",     clk_ring_lvl3_end, private.room_objname );
  cmn.AddSubscriber( "clk_ring_lvl3_beg", clk_ring_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ring_lvl3_end", clk_ring_lvl3_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_tower_ghost () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_tower_ghost" ] = {
    type = "click",
    use_place = "obj_tower_clk_tower_ghost",
    room = private.room_objname
  };

  local see_tower_ghost = function ()
  
    ObjDelete( "obj_tower_clk_tower_ghost"   );
    ObjDelete( "anm_tower_ghost_static"      );
    ObjDelete( "anm_tower_ghost"             );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_tower_ghost", see_tower_ghost, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function see_tower_spyglass () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_tower_spyglass" ] = {
    type = "click",
    use_place = "obj_tower_clk_tower_spyglass",
    room = private.room_objname
  };

  local see_tower_spyglass = function ()
  
    ObjDelete( "obj_tower_clk_tower_spyglass" );
    ObjDelete( "anm_tower_spyglass"           );
    ObjMultiSet( { 
      { "gzz_tower_spyglass", { input = true, active = true, visible = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_tower_spyglass", see_tower_spyglass, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function see_tower_hatch_openes () end;
  --------------------------------------------------------------------------------------------
  local see_tower_hatch_openes = function ()
  
    ObjDelete( "anm_tower_hatch_openes" );
    ObjMultiSet( { 
      { "anm_tower_final_shot",  {     alp = 1                  } },
      { "grm_tower_barber_room", { visible = true, input = true } },
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_tower_barber_room_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_tower_hatch_openes", see_tower_hatch_openes, private.room_objname ); 

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_tower();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "level3/env/aud_tower_env" }, "", 0.5 );

  if cmn.IsEventDone( "win_clock" ) and not cmn.IsEventDone( "see_tower_hatch_openes" ) then
    private.see_tower_hatch_openes()
  end;

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level3/env/aud_tower_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_ring_lvl3 ()

  local item = "inv_ring_lvl3";

  if ( cmn.ApplyObj( item, "gzz_tower_spyglass" ) and cmn.IsEventDone( "clk_ring_lvl3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_spyglass" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_spyglass_use_ring" ) and cmn.IsEventDone( "clk_ring_lvl3" ) ) then

    cmn.CallEventHandler( "use_ring_lvl3_inv" );
    cmn.CallEventHandler( "use_ring_lvl3_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_ring_lvl3" );
      cmn.CallEventHandler( "use_ring_lvl3_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_ring4", 0, "", 0 );

    AnimPlay( "anm_spyglass_open", "func_0033", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_strange_shard ()

  local item = "inv_strange_shard";

  if ( cmn.ApplyObj( item, "gzz_tower_clock_mechanism" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_clock_mechanism" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_clock_mechanism_use_strange_shard" ) ) then

    cmn.CallEventHandler( "use_strange_shard_inv" );
    cmn.CallEventHandler( "use_strange_shard_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_strange_shard" );
        cmn.CallEventHandler( "use_strange_shard_end" );

      end;

      ObjAnimate( "spr_clock_closed", "pos_xy",0,0, func_end_2, { 
        0.0, 0, ObjGet( "spr_clock_closed" ).pos_x,ObjGet( "spr_clock_closed" ).pos_y,    
        0.4, 0, 609, -89, 
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_moon", 0, "", 0 );

    cmn.ItemFly( "spr_clock_fragment", func_end, 1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hands ()

  local item = "inv_hands";

  if ( cmn.ApplyObj( item, "gzz_tower_clock_mechanism" ) and cmn.IsEventDone( "use_strange_shard" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_clock_mechanism" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_clock_mechanism_use_hands" ) and cmn.IsEventDone( "use_strange_shard" ) ) then

    cmn.CallEventHandler( "use_hands_inv" );
    cmn.CallEventHandler( "use_hands_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_hands" );
      cmn.CallEventHandler( "use_hands_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_arrows", 0, "", 0 );

    AnimPlay( "anm_clock_arrow", "arrow", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_clock_part ()

  local item = "inv_clock_part";

  if ( cmn.ApplyObj( item, "gzz_tower_clock_mechanism" ) and cmn.IsEventDone( "use_strange_shard" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_clock_mechanism" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_clock_mechanism_use_clock_part" ) and cmn.IsEventDone( "use_strange_shard" ) ) then

    cmn.CallEventHandler( "use_clock_part_inv" );
    cmn.CallEventHandler( "use_clock_part_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_clock_part" );
        cmn.CallEventHandler( "use_clock_part_end" );
        
        common.CloseSubRoom();
        cmn.GotoRoom( "mg_clock" );

      end;

      ObjAnimate( "spr_clock_cach", "pos_xy",0,0, func_end_2, { 
        0.0, 0, ObjGet( "spr_clock_cach" ).pos_x, ObjGet( "spr_clock_cach" ).pos_y,    
        0.3, 0, 36, 190, 
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_weight", 0, "", 0 );

    AnimPlay( "anm_clock_weight", "weight", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_black_cat_2 ()

  local item = "inv_black_cat";

  if ( cmn.ApplyObj( item, "gzz_tower_clockface" ) and cmn.IsEventDone( "use_bone" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_clockface" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_clockface_use_black_cat" ) and cmn.IsEventDone( "use_bone" ) ) then

    cmn.CallEventHandler( "use_black_cat_2_inv" );
    cmn.CallEventHandler( "use_black_cat_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_black_cat_2" );
      cmn.CallEventHandler( "use_black_cat_2_end" );

      private.get_feathers();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_cat2", 0, "", 0 );

    AnimPlay( "anm_clockface_cat_use", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_rope_lvl3 ()

  local item = "inv_rope_lvl3";

  if ( cmn.ApplyObj( item, "gzz_tower_clockface" ) and cmn.IsEventDone( "use_bone" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_clockface" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_clockface_use_rope" ) and cmn.IsEventDone( "use_bone" ) ) then

    cmn.CallEventHandler( "use_rope_lvl3_inv" );
    cmn.CallEventHandler( "use_rope_lvl3_beg" );

    local func_end = function ()
    
      local func_end_2 = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_rope_lvl3" );
        cmn.CallEventHandler( "use_rope_lvl3_end" );
        common.CloseSubRoomAll();
        
      end;
      
      cmn.GotoSubRoom( 'zz_clockface_2', 'not_frame', { { x = 680, y = 350 },{ x = 200, y = 360 } }, { x = 163, y = -163 } );

      AnimPlay( "anm_clockface_2_rope", "DoAnim", func_end_2 );
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_rope3", 0, "", 0 );
    
    AnimPlay( "anm_clockface_rope", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bone ()

  local item = "inv_bone";

  if ( cmn.ApplyObj( item, "gzz_tower_clockface" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_clockface" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_clockface_use_bone" ) ) then

    cmn.CallEventHandler( "use_bone_inv" );
    cmn.CallEventHandler( "use_bone_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_bone" );
      cmn.CallEventHandler( "use_bone_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_bone", 0, "", 0 );

    ObjMultiSet( { 
      { "anm_clockface_arrow_move",  { alp = 0 }},
      { "anm_clockface_put_in_bone", { alp = 1 }},
    } );

    AnimPlay( "anm_clockface_put_in_bone", "put_in_bone", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_oil ()

  local item = "inv_oil";

  if ( cmn.ApplyObj( item, "gzz_tower_clockface" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_clockface" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_clockface_use_oil" ) ) then

    cmn.CallEventHandler( "use_oil_inv" );
    cmn.CallEventHandler( "use_oil_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_oil" );
      cmn.CallEventHandler( "use_oil_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_oil", 0, "", 0 );

    VidPlay( "vid_clockface_oil", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_ink_pen ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ink_pen" );
  cmn.CallEventHandler( "get_ink_pen" );

end;
--------------------------------------------------------------------------------------------
function private.get_eyepiece ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_eyepiece" );
  cmn.CallEventHandler( "get_eyepiece" );

  if ( cmn.IsGetCollect2( "get_collect2_item_16" ) ) then
    
    common.CloseSubRoom();
    
  end; 
  
end;
--------------------------------------------------------------------------------------------
function private.get_amulet_part_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_amulet_part_2" );
  cmn.CallEventHandler( "get_amulet_part_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_oil ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_oil" );
  cmn.CallEventHandler( "get_oil" );

end;
--------------------------------------------------------------------------------------------
function private.get_adjustable_wrench ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_adjustable_wrench" );
  cmn.CallEventHandler( "get_adjustable_wrench" );

end;
--------------------------------------------------------------------------------------------
function private.get_feathers ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_feathers" );
  cmn.CallEventHandler( "get_feathers" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_16 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_16" ); 

  end;

  common_impl.PlayEffectHO( "spr_spyglass_collect2_item_16", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_16" );
  
  if ( cmn.IsEventDone( "get_eyepiece" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_ring_lvl3 ()
  
  cmn.CallEventHandler( "clk_ring_lvl3_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_ring_lvl3" );
    cmn.CallEventHandler( "clk_ring_lvl3_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_break_metal", 0, "", 0 );
  
  AnimPlay( "anm_spyglass_clk", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
end;
--------------------------------------------------------------------------------------------
function private.see_tower_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_tower_ghost" );
    cmn.CallEventHandler( "see_tower_ghost" );

    common_impl.ShowBbt( 'bbt_tower_see_tower' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_ghosts_tower", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_tower_ghost_static", { alp = 0 } },
    { "anm_tower_ghost",        { alp = 1 } },
  } );

  AnimPlay( "anm_tower_ghost", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_tower_spyglass ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_tower_spyglass" );
    cmn.CallEventHandler( "see_tower_spyglass" );

    common_impl.ShowBbt( 'bbt_tower_see_spyglass' );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl3_find_ghost" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_move_wood_low3", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_tower_spyglass", { alp = 1 } },
  } );

  AnimPlay( "anm_tower_spyglass", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_tower_hatch_openes ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_tower_hatch_openes" );
    cmn.CallEventHandler( "see_tower_hatch_openes" );
    common_impl.ShowBbt( 'bbt_tower_see_hatch_openes' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );

  AnimPlay( "anm_tower_hatch_openes", "hatch_openes", func_end );
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_tower ()

  if not ( cmn.IsEventDone( "opn_tower" ) ) then

    cmn.SetEventDone( "opn_tower" );
    common_impl.ShowBbt( 'bbt_tower_opn_tower' );

  end;
  cmn.CallEventHandler( "opn_tower" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.AnimUseStrangeShard ()

  common_impl.ShowBbt( 'bbt_clock_mechanism_use_strange_shard' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_mid_door", 0, "", 0 );
  
  ObjAnimate( "spr_clock_closed", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,-2,-2,  0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseClockPart ()

  common_impl.ShowBbt( 'bbt_clock_mechanism_use_clock_part' );

  local func_end = function ()

    cmn.Lock( false );
  
    ObjMultiSet( { 
      { "anm_clock_weight",    { alp = 1 } },
      { "anm_clock_hh_weight", { alp = 0 } },
    } );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_chair", 0, "", 0 );
  
  ObjMultiSet( { 
    { "anm_clock_hh_weight", { alp = 1 } },
    { "anm_clock_weight",    { alp = 0 } },
  } );
  AnimPlay( "anm_clock_hh_weight", "hh_weight", func_end );


end;
--------------------------------------------------------------------------------------------
function private.AnimUseHands ()

  common_impl.ShowBbt( 'bbt_clock_mechanism_use_hands' );

  local func_end = function ()

    cmn.Lock( false );

    ObjMultiSet( { 
      { "anm_clock_arrow",    { alp = 1 } },
      { "anm_clock_hh_watch", { alp = 0 } },
    } );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_grill", 0, "", 0 );
  
  ObjMultiSet( { 
    { "anm_clock_hh_watch", { alp = 1 } },
    { "anm_clock_arrow",    { alp = 0 } },
  } );
  AnimPlay( "anm_clock_hh_watch", "hh_watch", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseRing ()

  common_impl.ShowBbt( 'bbt_spyglass_use_ring' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_plate", 0, "", 0 );
  
  ObjAnimate( "anm_spyglass_open", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,10,-2,  0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseOil ()

  common_impl.ShowBbt( 'bbt_clockface_use_oil' );

  local func_end = function () cmn.Lock( false );end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_high2", 0, "", 0 );
  
  ObjAnimate( "spr_clockface_adjustable_wrench", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,2,-2,  0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseBlackCat ()

  common_impl.ShowBbt( 'bbt_clockface_use_black_cat' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx", 0, "", 0 );
  
  ObjAnimate( "anm_clockface_cat_use", "pos_y", 0, 1, func_end, { 0.0,0,0, 0.2,3,-2, 0.4,3,0 });

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************