-- name=rm_weapon_room
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_weapon_room";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_canon",          "room_hub" );
  ObjAttach( "zz_weapons_window", "room_hub" );
  ObjAttach( "zz_trophy",         "room_hub" );
  ObjAttach( "zz_dummy",          "room_hub" );
  ObjAttach( "zz_knight",         "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_canon_opener",                            { event_mdown = private.get_opener             }},
    { "spr_canon_stone_2",                           { event_mdown = private.get_stone_2            }},
    { "obj_canon_ring",                              { event_mdown = private.get_ring_lvl3          }},
    { "obj_canon_use_fire_striker",                  { event_mdown = private.AnimUseFireStriker     }},
    { "obj_canon_use_release_tool",                  { event_mdown = private.AnimUseReleaseTool     }},
    { "obj_canon2_use_adjustable_wrench",            { event_mdown = private.AnimUseAdjustableWrench}},
     
    { "spr_weapons_window_compass",                  { event_mdown = private.get_compass            }},
    { "spr_weapons_window_compass",                  { event_mdown = private.get_compass            }},
    { "spr_trophy_steering_wheel",                   { event_mdown = private.get_steering_wheel     }},
    { "spr_trophy_amulet_part_5",                    { event_mdown = private.get_amulet_part_5      }},
    { "spr_trophy_flag_2",                           { event_mdown = private.get_flag_2             }},
    { "obj_trophy_use_hunter_horn",                  { event_mdown = private.AnimUseHunterHorn      }},

    { "spr_dummy_amulet_part_4",                     { event_mdown = private.get_amulet_part_4      }},
    { "spr_dummy_wool_piece",                        { event_mdown = private.get_wool_piece         }},
    { "spr_dummy_flag_3",                            { event_mdown = private.get_flag_3             }},
    { "spr_dummy_bottle",                            { event_mdown = private.get_bottle             }},
    { "obj_dummy_use_fang",                          { event_mdown = private.AnimUseFang            }},
    { "obj_dummy_use_feathers",                      { event_mdown = private.AnimUseFeathers        }},
    
    { "spr_knight_leather_purse",                    { event_mdown = private.get_leather_purse      }},
    { "obj_knight_use_hillmark_medallion",           { event_mdown = private.AnimUseMedallion       }},
    { "obj_knight_use_sword_hilt",                   { event_mdown = private.AnimUseSwordHilt       }},
    { "obj_knight_clk_knight",                       { event_mdown = private.clk_knight             }},  
    
    { "spr_weapon_room_hillmark_medallion",          { event_mdown = private.get_hillmark_medallion }},
    { "obj_weapons_window_use_shopwindow_lock_part", { event_mdown = private.AnimUseLockPart        }},
    { "obj_weapons_window_use_ship_model",           { event_mdown = private.AnimUseShipModel       }},

    { "obj_weapon_room_clk_trophy_ghost",            { event_mdown = private.see_trophy_ghost       }},

    { "spr_weapon_room_collect_morph_item",  { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_17" ); end } },
      
    { "spr_canon_collect2_item_17",         { event_mdown = private.get_collect2_item_17      }},  
    { "spr_dummy_collect2_item_23",  { event_mdown = private.get_collect2_item_23      }},     
   
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_weapon_room = function ()
  
    table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gho_weapon_room_knight_arrmor",
      "gho_weapon_room_weapon",
      "gzz_weapon_room_canon",
      "gzz_weapon_room_weapons_window",
      "gzz_weapon_room_trophy",
      "gzz_weapon_room_dummy",
      "gzz_weapon_room_knight",
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_canon",
      "zz_weapons_window",
      "zz_trophy",
      "zz_dummy",
      "zz_knight",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_weapon_room", update_game_mode_weapon_room, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_weapon_room = function ()

    local effects_table = 
    {
      "obj_weapon_room_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_weapon_room", update_performance_mode_weapon_room, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_weapon_room () end;
  --------------------------------------------------------------------------------------------
  local opn_weapon_room_map = function ()

    common_impl.VisitMapRoom( "weapon_room" );

  end;
  cmn.AddSubscriber( "opn_weapon_room", opn_weapon_room_map );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_17 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_17 = function ()
  
    ObjDelete( "obj_weapon_room_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_17", get_collect_morph_item_17, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function win_weapons_window () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_weapons_window" ] =
  {
    type = "click",
    clk_obj = "obj_weapons_window_mmg",
    room = private.room_objname,
    zz = "zz_weapons_window",
    zz_gate = "gzz_weapon_room_weapons_window"
  };
  --*********************************************************************************************************************
  local win_weapons_window = function ()

    if ( cmn.IsEventDone( "win_weapons_window" ) ) then
   
      ObjMultiSet( { 
        { "obj_weapons_window_mmg",    { input = false } },
        { "spr_weapons_window_part_1", { ang = 0 } },
        { "spr_weapons_window_part_2", { ang = 0 } },
        { "spr_weapons_window_part_3", { ang = 0 } },
      } );
      
    ObjMultiSet( { 
      { "gho_weapon_room_weapon",  { visible = true, input = true } },
      { "spr_weapon_room_stuff",  { alp = 1 } },
    } );
    
    ObjDelete( "gzz_weapon_room_weapons_window" );
  
    else 

      private.WeaponsWindowLoad();
      
    end;
    
  end;
  
  cmn.AddSubscriber( "win_weapons_window", win_weapons_window, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function clk_knight () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_knight" ] = {
    type = "click",
    use_place = "obj_knight_clk_knight",
    room = private.room_objname,
    zz = "zz_knight",
    zz_gate = "gzz_weapon_room_knight"
  };
  
  local clk_knight_beg = function ()

    ObjDelete( "obj_knight_clk_knight" );
  
  end;
  local clk_knight_end = function ()

    ObjDelete( "gzz_weapon_room_knight" );
    ObjMultiSet( { 
      { "gho_weapon_room_knight_arrmor",  { visible = true, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_knight",     clk_knight_beg, private.room_objname );
  cmn.AddSubscriber( "clk_knight",     clk_knight_end, private.room_objname );
  cmn.AddSubscriber( "clk_knight_beg", clk_knight_beg, private.room_objname );
  cmn.AddSubscriber( "clk_knight_end", clk_knight_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function get_opener () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_opener" ] = {
    type = "get",
    get_obj = "spr_canon_opener",
    room = private.room_objname,
    zz = "zz_canon",
    zz_gate = "gzz_weapon_room_canon"
  };
  
  local get_opener_inv = function ()
  
    interface.InventoryItemAdd( "inv_opener", "spr_canon_opener" );
    cmn.SetInvPlusRGB( "can", true );
  
  end;
  
  local get_opener_closezz = function ()
  
    ObjDelete( "gfx_canon_opener" );
  
  end;
  
  cmn.AddSubscriber( "get_opener", get_opener_inv );
  cmn.AddSubscriber( "get_opener", get_opener_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stone_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stone_2" ] = {
    type = "get",
    get_obj = "spr_canon2_stone_2",
    room = private.room_objname,
    zz = "zz_canon2",
    zz_gate = "gzz_weapon_room_canon2"
  };
  
  local get_stone_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_stone_2", "spr_canon2_stone_2" );
  
  end;
  
  local get_stone_2_closezz = function ()
  
    ObjDelete( "gfx_canon2_stone_2" );
    ObjDelete( "gzz_canon_room_canon2" );  
    
  end;
  
  cmn.AddSubscriber( "get_stone_2", get_stone_2_inv );
  cmn.AddSubscriber( "get_stone_2", get_stone_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ring_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ring_lvl3" ] = {
    type = "get",
    get_obj = "obj_canon_ring",
    room = private.room_objname,
    zz = "zz_canon",
    zz_gate = "gzz_weapon_room_canon"
  };
  
  local get_ring_lvl3_inv = function ()
  
    interface.InventoryItemAdd( "inv_ring_lvl3", "obj_canon_ring" );
  
  end;
  
  local get_ring_lvl3_closezz = function ()
  
    ObjDelete( "gfx_canon_ring" );
    ObjDelete( "spr_weapon_room_ring" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_17" ) ) then
      
      ObjDelete( "gzz_weapon_room_canon" );
      
    end;
    
  end;
  
  cmn.AddSubscriber( "get_ring_lvl3", get_ring_lvl3_inv );
  cmn.AddSubscriber( "get_ring_lvl3", get_ring_lvl3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_compass () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_compass" ] = {
    type = "get",
    get_obj = "spr_weapons_window_compass",
    room = private.room_objname,
    zz = "zz_weapons_window",
    zz_gate = "gzz_weapon_room_weapons_window"
  };
  
  local get_compass_inv = function ()
  
    interface.InventoryItemAdd( "inv_compass", "spr_weapons_window_compass" );
    ObjSet( "inv_compass", { drag = false } );
  
  end;
  
  local get_compass_closezz = function ()
  
    ObjDelete( "gfx_weapons_window_compass" );
  
  end;
  
  cmn.AddSubscriber( "get_compass", get_compass_inv );
  cmn.AddSubscriber( "get_compass", get_compass_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_steering_wheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_steering_wheel" ] = {
    type = "get",
    get_obj = "spr_trophy_steering_wheel",
    room = private.room_objname,
    zz = "zz_trophy",
    zz_gate = "gzz_weapon_room_trophy"
  };
  
  local get_steering_wheel_inv = function ()
  
    interface.InventoryItemAdd( "inv_steering_wheel", "spr_trophy_steering_wheel" );
  
  end;
  
  local get_steering_wheel_closezz = function ()
  
    ObjDelete( "gfx_trophy_steering_wheel" );
    ObjDelete( "spr_weapon_room_wheel" );  
    
  end;
  
  cmn.AddSubscriber( "get_steering_wheel", get_steering_wheel_inv );
  cmn.AddSubscriber( "get_steering_wheel", get_steering_wheel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulet_part_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulet_part_5" ] = {
    type = "get",
    get_obj = "spr_trophy_amulet_part_5",
    room = private.room_objname,
    zz = "zz_trophy",
    zz_gate = "gzz_weapon_room_trophy"
  };
  
  local get_amulet_part_5_inv = function ()
  
    interface.InventoryItemAdd( "inv_amulet_part_5", "spr_trophy_amulet_part_5" );
    
    --if ( cmn.IsEventDone( "get_amulet_part_1" ) and cmn.IsEventDone( "get_amulet_part_2" ) and 
    --     cmn.IsEventDone( "get_amulet_part_3" ) and cmn.IsEventDone( "get_amulet_part_4" ) and 
    --     cmn.IsEventDone( "get_amulet_part_5" ) and cmn.IsEventDone( "get_amulet_part_6" )
    --    ) then
    --
    --    cmn.SetInvPlusRGB( "white_ghost_amulet", true );
    --    
    --end;
    cmn.SetInvPlusRGB( "white_ghost_amulet", true );  
  end;
  
  local get_amulet_part_5_closezz = function ()
  
    ObjDelete( "gfx_trophy_amulet_part_5" );
    ObjDelete( "gzz_weapon_room_trophy" );
  
  end;
  
  cmn.AddSubscriber( "get_amulet_part_5", get_amulet_part_5_inv );
  cmn.AddSubscriber( "get_amulet_part_5", get_amulet_part_5_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flag_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flag_2" ] = {
    type = "get",
    get_obj = "spr_trophy_flag_2",
    room = private.room_objname,
    zz = "zz_trophy",
    zz_gate = "gzz_weapon_room_trophy"
  };
  
  local get_flag_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_flag_2", "spr_trophy_flag_2" );
  
  end;
  
  local get_flag_2_closezz = function ()
  
    ObjDelete( "gfx_trophy_flag_2" );
    ObjDelete( "spr_weapon_room_flag_2" );  
    
  end;
  
  cmn.AddSubscriber( "get_flag_2", get_flag_2_inv );
  cmn.AddSubscriber( "get_flag_2", get_flag_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulet_part_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulet_part_4" ] = {
    type = "get",
    get_obj = "spr_dummy_amulet_part_4",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_weapon_room_dummy"
  };
  
  local get_amulet_part_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_amulet_part_4", "spr_dummy_amulet_part_4" );
    
    --if ( cmn.IsEventDone( "get_amulet_part_1" ) and cmn.IsEventDone( "get_amulet_part_2" ) and 
    --     cmn.IsEventDone( "get_amulet_part_3" ) and cmn.IsEventDone( "get_amulet_part_4" ) and 
    --     cmn.IsEventDone( "get_amulet_part_5" ) and cmn.IsEventDone( "get_amulet_part_6" )
    --    ) then
    --
    --    cmn.SetInvPlusRGB( "white_ghost_amulet", true );
    --    
    --end;
    cmn.SetInvPlusRGB( "white_ghost_amulet", true );  
  end;
  
  local get_amulet_part_4_closezz = function ()
  
    ObjDelete( "gfx_dummy_amulet_part_4" );
    
    if ( cmn.IsEventDone( "get_bottle" ) and
    cmn.IsGetCollect2( "get_collect2_item_23" ) ) then
      
      ObjDelete( "gzz_weapon_room_dummy" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_amulet_part_4", get_amulet_part_4_inv );
  cmn.AddSubscriber( "get_amulet_part_4", get_amulet_part_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wool_piece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wool_piece" ] = {
    type = "get",
    get_obj = "spr_dummy_wool_piece",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_weapon_room_dummy"
  };
  
  local get_wool_piece_inv = function ()
  
    interface.InventoryItemAdd( "inv_wool_piece", "spr_dummy_wool_piece" );
  
  end;
  
  local get_wool_piece_closezz = function ()
  
    ObjDelete( "gfx_dummy_wool_piece" );
  
  end;
  
  cmn.AddSubscriber( "get_wool_piece", get_wool_piece_inv );
  cmn.AddSubscriber( "get_wool_piece", get_wool_piece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flag_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flag_3" ] = {
    type = "get",
    get_obj = "spr_dummy_flag_3",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_weapon_room_dummy"
  };
  
  local get_flag_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_flag_3", "spr_dummy_flag_3" );
  
  end;
  
  local get_flag_3_closezz = function ()
  
    ObjDelete( "gfx_dummy_flag_3" );
  
  end;
  
  cmn.AddSubscriber( "get_flag_3", get_flag_3_inv );
  cmn.AddSubscriber( "get_flag_3", get_flag_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bottle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottle" ] = {
    type = "get",
    get_obj = "spr_dummy_bottle",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_weapon_room_dummy"
  };
  
  local get_bottle_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottle", "spr_dummy_bottle" );
  
  end;
  
  local get_bottle_closezz = function ()
  
    ObjDelete( "gfx_dummy_bottle" );
    
    if ( cmn.IsEventDone( "get_amulet_part_4" ) and
      cmn.IsGetCollect2( "get_collect2_item_23" ) ) then
      
      ObjDelete( "gzz_weapon_room_dummy" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_bottle", get_bottle_inv );
  cmn.AddSubscriber( "get_bottle", get_bottle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_leather_purse () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_leather_purse" ] = {
    type = "get",
    get_obj = "spr_knight_leather_purse",
    room = private.room_objname,
    zz = "zz_knight",
    zz_gate = "gzz_weapon_room_knight"
  };
  
  local get_leather_purse_inv = function ()
  
    interface.InventoryItemAdd( "inv_leather_purse", "spr_knight_leather_purse" );
    ObjSet( "inv_leather_purse", { drag = false } );
  
  end;
  
  local get_leather_purse_closezz = function ()
  
    ObjDelete( "gfx_knight_leather_purse" );
    ObjDelete( "spr_weapon_room_bag" );
    
  end;
  
  cmn.AddSubscriber( "get_leather_purse", get_leather_purse_inv );
  cmn.AddSubscriber( "get_leather_purse", get_leather_purse_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hillmark_medallion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hillmark_medallion" ] = {
    type = "get",
    get_obj = "spr_weapon_room_hillmark_medallion",
    room = private.room_objname 
  };
  
  local get_hillmark_medallion_inv = function ()
  
    interface.InventoryItemAdd( "inv_hillmark_medallion", "spr_weapon_room_hillmark_medallion" );
  
  end;
  
  local get_hillmark_medallion_closezz = function ()
  
    ObjDelete( "gfx_weapon_room_hillmark_medallion" );

  end;
  
  cmn.AddSubscriber( "get_hillmark_medallion", get_hillmark_medallion_inv );
  cmn.AddSubscriber( "get_hillmark_medallion", get_hillmark_medallion_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_17 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_17 = function ()
  
    ObjDelete( "obj_canon_collect2_item_17" ); 
  
    if ( cmn.IsEventDone( "get_ring_lvl3" ) ) then
      
      ObjDelete( "gzz_weapon_room_canon" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_17", get_collect2_item_17, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_23 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_23 = function ()
  
    ObjDelete( "obj_dummy_collect2_item_23" ); 
  
    if ( cmn.IsEventDone( "get_bottle" ) and 
    cmn.IsEventDone( "get_amulet_part_4" ) ) then
      
      ObjDelete( "gzz_weapon_room_dummy" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_23", get_collect2_item_23, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function use_fire_striker () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fire_striker" ] = {
    type = "use",
    inv_obj = "inv_fire_striker",
    use_place = "obj_canon_use_fire_striker",
    room = private.room_objname,
    zz = "zz_canon",
    zz_gate = "gzz_weapon_room_canon"
  };
  local use_fire_striker_inv = function ()
  
    interface.InventoryItemRemove( "inv_fire_striker" );
  
  end;
  local use_fire_striker_beg = function ()
  
    ObjDelete( "obj_canon_use_fire_striker" );
  
  end;
  local use_fire_striker_end = function ()
    
    ObjDelete( "spr_weapon_room_wick" );
    ObjDelete( "obj_canon_wick" );
    ObjMultiSet( { 
      { "spr_canon_key",  { visible = true, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fire_striker", use_fire_striker_beg, private.room_objname );
  cmn.AddSubscriber( "use_fire_striker", use_fire_striker_inv );
  cmn.AddSubscriber( "use_fire_striker", use_fire_striker_end, private.room_objname );
  cmn.AddSubscriber( "use_fire_striker_inv", use_fire_striker_inv, private.room_objname );
  cmn.AddSubscriber( "use_fire_striker_beg", use_fire_striker_beg, private.room_objname );
  cmn.AddSubscriber( "use_fire_striker_end", use_fire_striker_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cannon_ball () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cannon_ball" ] = {
    type = "use",
    inv_obj = "inv_cannon_ball",
    use_place = "obj_canon2_use_cannon_ball",
    room = private.room_objname,
    zz = "zz_canon",
    zz_gate = "gzz_weapon_room_canon",
    subzz = "zz_canon2",
    subzz_gate = "gzz_canon_room_canon2"
  };
  local use_cannon_ball_inv = function ()
  
    interface.InventoryItemRemove( "inv_cannon_ball" );
  
  end;
  local use_cannon_ball_beg = function ()
  
    ObjDelete( "obj_canon2_use_cannon_ball" );
  
  end;
  local use_cannon_ball_end = function ()
    
    ObjDelete( "anm_canon2_core" );
    ObjMultiSet( { 
      { "obj_canon_use_fire_striker", { input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cannon_ball", use_cannon_ball_beg, private.room_objname );
  cmn.AddSubscriber( "use_cannon_ball", use_cannon_ball_inv );
  cmn.AddSubscriber( "use_cannon_ball", use_cannon_ball_end, private.room_objname );
  cmn.AddSubscriber( "use_cannon_ball_inv", use_cannon_ball_inv, private.room_objname );
  cmn.AddSubscriber( "use_cannon_ball_beg", use_cannon_ball_beg, private.room_objname );
  cmn.AddSubscriber( "use_cannon_ball_end", use_cannon_ball_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_adjustable_wrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_adjustable_wrench" ] = {
    type = "use",
    inv_obj = "inv_adjustable_wrench",
    use_place = "obj_canon2_use_adjustable_wrench",
    room = private.room_objname,
    zz = "zz_canon",
    zz_gate = "gzz_weapon_room_canon",
    subzz = "zz_canon2",
    subzz_gate = "gzz_canon_room_canon2"
    
  };
  local use_adjustable_wrench_inv = function ()
  
    interface.InventoryItemRemove( "inv_adjustable_wrench" );
  
  end;
  local use_adjustable_wrench_beg = function ()
  
    ObjDelete( "obj_canon2_use_adjustable_wrench" );
  
  end;
  local use_adjustable_wrench_end = function ()
    
    ObjDelete( "obj_canon2_ring_part" );
    ObjDelete( "vid_canon2_key" );
    ObjDelete( "spr_canon_ring_part" );  
    ObjDelete( "spr_weapon_room_hoop" ); 
    ObjMultiSet( { 
      { "spr_canon2_stone_2",  { visible = true, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_adjustable_wrench", use_adjustable_wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_adjustable_wrench", use_adjustable_wrench_inv );
  cmn.AddSubscriber( "use_adjustable_wrench", use_adjustable_wrench_end, private.room_objname );
  cmn.AddSubscriber( "use_adjustable_wrench_inv", use_adjustable_wrench_inv, private.room_objname );
  cmn.AddSubscriber( "use_adjustable_wrench_beg", use_adjustable_wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_adjustable_wrench_end", use_adjustable_wrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_release_tool () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_release_tool" ] = {
    type = "use",
    inv_obj = "inv_release_tool",
    use_place = "obj_canon_use_release_tool",
    room = private.room_objname,
    zz = "zz_canon",
    zz_gate = "gzz_weapon_room_canon"
  };
  local use_release_tool_inv = function ()
  
    interface.InventoryItemRemove( "inv_release_tool" );
  
  end;
  local use_release_tool_beg = function ()
  
    ObjDelete( "obj_canon_use_release_tool" );
  
  end;
  local use_release_tool_end = function ()
    
    ObjDelete( "anm_canon_ring" );  
    ObjMultiSet( { 
      { "spr_canon_patch", {    alp = 1    } },
      { "anm_canon_last",  {    alp = 1    } },
      { "obj_canon_ring",  {  input = true } },
      { "gfx_canon_ring",  { active = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_release_tool", use_release_tool_beg, private.room_objname );
  cmn.AddSubscriber( "use_release_tool", use_release_tool_inv );
  cmn.AddSubscriber( "use_release_tool", use_release_tool_end, private.room_objname );
  cmn.AddSubscriber( "use_release_tool_inv", use_release_tool_inv, private.room_objname );
  cmn.AddSubscriber( "use_release_tool_beg", use_release_tool_beg, private.room_objname );
  cmn.AddSubscriber( "use_release_tool_end", use_release_tool_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shopwindow_lock_part () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shopwindow_lock_part" ] = {
    type = "use",
    inv_obj = "inv_shopwindow_lock_part",
    use_place = "obj_weapons_window_use_shopwindow_lock_part",
    room = private.room_objname,
    zz = "zz_weapons_window",
    zz_gate = "gzz_weapon_room_weapons_window"
  };
  local use_shopwindow_lock_part_inv = function ()
  
    interface.InventoryItemRemove( "inv_shopwindow_lock_part" );
  
  end;
  local use_shopwindow_lock_part_beg = function ()
  
    ObjDelete( "obj_weapons_window_use_shopwindow_lock_part" );
  
  end;
  local use_shopwindow_lock_part_end = function ()
  
    ObjDelete( "spr_weapons_window_mg_door1" );
    ObjDelete( "spr_weapons_window_lock_part_2" );
    ObjDelete( "spr_weapon_room_mg_door1" );
    ObjMultiSet( { 
      { "obj_weapons_window_open",  { input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shopwindow_lock_part", use_shopwindow_lock_part_beg, private.room_objname );
  cmn.AddSubscriber( "use_shopwindow_lock_part", use_shopwindow_lock_part_inv );
  cmn.AddSubscriber( "use_shopwindow_lock_part", use_shopwindow_lock_part_end, private.room_objname );
  cmn.AddSubscriber( "use_shopwindow_lock_part_inv", use_shopwindow_lock_part_inv, private.room_objname );
  cmn.AddSubscriber( "use_shopwindow_lock_part_beg", use_shopwindow_lock_part_beg, private.room_objname );
  cmn.AddSubscriber( "use_shopwindow_lock_part_end", use_shopwindow_lock_part_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ship_model () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ship_model" ] = {
    type = "use",
    inv_obj = "inv_ship_model",
    use_place = "obj_weapons_window_use_ship_model",
    room = private.room_objname,
    zz = "zz_weapons_window",
    zz_gate = "gzz_weapon_room_weapons_window"
  };
  local use_ship_model_inv = function ()
  
    interface.InventoryItemRemove( "inv_ship_model" );
  
  end;
  local use_ship_model_beg = function ()
  
    ObjDelete( "obj_weapons_window_use_ship_model" );
  
  end;
  local use_ship_model_end = function ()
    
    ObjDelete( "spr_weapons_window_door2" );
    ObjDelete( "spr_weapon_room_door2" );
    ObjMultiSet( { 
      { "spr_weapons_window_axe",     {     alp = 1                  } },
      { "spr_weapon_room_axe",        {     alp = 1                  } },
      { "spr_weapons_window_compass", { visible = true, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ship_model", use_ship_model_beg, private.room_objname );
  cmn.AddSubscriber( "use_ship_model", use_ship_model_inv );
  cmn.AddSubscriber( "use_ship_model", use_ship_model_end, private.room_objname );
  cmn.AddSubscriber( "use_ship_model_inv", use_ship_model_inv, private.room_objname );
  cmn.AddSubscriber( "use_ship_model_beg", use_ship_model_beg, private.room_objname );
  cmn.AddSubscriber( "use_ship_model_end", use_ship_model_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet_lvl3" ] = {
    type = "use",
    inv_obj = "inv_magnet_lvl3",
    use_place = "obj_trophy_use_magnet",
    room = private.room_objname,
    zz = "zz_trophy",
    zz_gate = "gzz_weapon_room_trophy"
  };
  local use_magnet_lvl3_inv = function ()
  
    interface.InventoryItemRemove( "inv_magnet_lvl3" );
  
  end;
  local use_magnet_lvl3_beg = function ()
  
    ObjDelete( "obj_trophy_use_magnet" );
  
  end;
  local use_magnet_lvl3_end = function ()
  
    ObjMultiSet( { 
      { "spr_trophy_amulet_part_5",  { alp = 1, input = true } },
      { "gfx_trophy_amulet_part_5",  {         active = true } },
    } );
    ObjDelete( "anm_trophy_magnit" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet_lvl3", use_magnet_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_lvl3", use_magnet_lvl3_inv );
  cmn.AddSubscriber( "use_magnet_lvl3", use_magnet_lvl3_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_lvl3_inv", use_magnet_lvl3_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_lvl3_beg", use_magnet_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_lvl3_end", use_magnet_lvl3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hunter_horn () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hunter_horn" ] = {
    type = "use",
    inv_obj = "inv_hunter_horn",
    use_place = "obj_trophy_use_hunter_horn",
    room = private.room_objname,
    zz = "zz_trophy",
    zz_gate = "gzz_weapon_room_trophy"
  };
  local use_hunter_horn_inv = function ()
  
    interface.InventoryItemRemove( "inv_hunter_horn" );
  
  end;
  local use_hunter_horn_beg = function ()
  
    ObjDelete( "obj_trophy_use_hunter_horn" );
  
  end;
  local use_hunter_horn_end = function ()
  
    ObjMultiSet( { 
      { "spr_trophy_steering_wheel",  {  input = true             } },
      { "gfx_trophy_steering_wheel",  { active = true             } },
      { "spr_trophy_flag_2",          {  input = true             } },
      { "gfx_trophy_flag_2",          { active = true             } },
      { "anm_trophy_horn",            {  frame = 500              } },
      { "spr_weapon_room_horn",       {    alp = 1                } },
      { "spr_weapon_room_rack",       {  pos_x = 324, pos_y = 392 } },
    } );
    ObjDelete( "spr_trophy_cach" );   
    ObjDelete( "spr_weapon_room_cach" );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hunter_horn", use_hunter_horn_beg, private.room_objname );
  cmn.AddSubscriber( "use_hunter_horn", use_hunter_horn_inv );
  cmn.AddSubscriber( "use_hunter_horn", use_hunter_horn_end, private.room_objname );
  cmn.AddSubscriber( "use_hunter_horn_inv", use_hunter_horn_inv, private.room_objname );
  cmn.AddSubscriber( "use_hunter_horn_beg", use_hunter_horn_beg, private.room_objname );
  cmn.AddSubscriber( "use_hunter_horn_end", use_hunter_horn_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fang () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fang" ] = {
    type = "use",
    inv_obj = "inv_fang",
    use_place = "obj_dummy_use_fang",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_weapon_room_dummy"
  };
  local use_fang_inv = function ()
  
    interface.InventoryItemRemove( "inv_fang" );
  
  end;
  local use_fang_beg = function ()
  
    ObjDelete( "obj_dummy_use_fang" );
  
  end;
  local use_fang_end = function ()
  
    ObjMultiSet( { 
      { "spr_dummy_flag_3",     {  input = true  } },
      { "spr_dummy_jaw",        {    ang = -0.24 } },
      { "spr_dummy_jaw_fang",   {    ang = -0.24 } },
      { "anm_dummy_fang",       {  frame = 300   } },
      { "gfx_dummy_flag_3",     { active = true  } },
      { "spr_weapon_room_jaw",  {    alp = 1     } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fang", use_fang_beg, private.room_objname );
  cmn.AddSubscriber( "use_fang", use_fang_inv );
  cmn.AddSubscriber( "use_fang", use_fang_end, private.room_objname );
  cmn.AddSubscriber( "use_fang_inv", use_fang_inv, private.room_objname );
  cmn.AddSubscriber( "use_fang_beg", use_fang_beg, private.room_objname );
  cmn.AddSubscriber( "use_fang_end", use_fang_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_feathers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_feathers" ] = {
    type = "use",
    inv_obj = "inv_feathers",
    use_place = "obj_dummy_use_feathers",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_weapon_room_dummy"
  };
  local use_feathers_inv = function ()
  
    interface.InventoryItemRemove( "inv_feathers" );
  
  end;
  local use_feathers_beg = function ()
  
    ObjDelete( "obj_dummy_use_feathers" );
  
  end;
  local use_feathers_end = function ()
    
    ObjDelete( "spr_dummy_bird_picture" );
    ObjDelete( "spr_weapon_room_picture" );
    ObjMultiSet( { 
      { "spr_dummy_amulet_part_4",  { visible = true, input = true } },
      { "spr_dummy_bottle",         { visible = true, input = true } },
      { "spr_weapon_room_feather",  {     alp = 1                  } },
      { "anm_dummy_feather",        {   frame = 300                } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_feathers", use_feathers_beg, private.room_objname );
  cmn.AddSubscriber( "use_feathers", use_feathers_inv );
  cmn.AddSubscriber( "use_feathers", use_feathers_end, private.room_objname );
  cmn.AddSubscriber( "use_feathers_inv", use_feathers_inv, private.room_objname );
  cmn.AddSubscriber( "use_feathers_beg", use_feathers_beg, private.room_objname );
  cmn.AddSubscriber( "use_feathers_end", use_feathers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hillmark_medallion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hillmark_medallion" ] = {
    type = "use",
    inv_obj = "inv_hillmark_medallion",
    use_place = "obj_knight_use_hillmark_medallion",
    room = private.room_objname,
    zz = "zz_knight",
    zz_gate = "gzz_weapon_room_knight"
  };
  local use_hillmark_medallion_inv = function ()
  
    interface.InventoryItemRemove( "inv_hillmark_medallion" );
  
  end;
  local use_hillmark_medallion_beg = function ()
  
    ObjDelete( "obj_knight_use_hillmark_medallion" );
  
  end;
  local use_hillmark_medallion_end = function ()
    
    ObjDelete( "spr_knight_knight_glow_2" );  
    ObjDelete( "spr_weapon_room_glow_closed" );
    ObjMultiSet( { 
      { "spr_knight_knight_glow_1",    {    alp = 1, input = true } },
      { "gfx_knight_leather_purse",    { active = true            } },
      { "spr_knight_medallion",        {    alp = 1               } },
      { "spr_weapon_room_glow_opened", {    alp = 1               } },
    } );
       
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hillmark_medallion", use_hillmark_medallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_hillmark_medallion", use_hillmark_medallion_inv );
  cmn.AddSubscriber( "use_hillmark_medallion", use_hillmark_medallion_end, private.room_objname );
  cmn.AddSubscriber( "use_hillmark_medallion_inv", use_hillmark_medallion_inv, private.room_objname );
  cmn.AddSubscriber( "use_hillmark_medallion_beg", use_hillmark_medallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_hillmark_medallion_end", use_hillmark_medallion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sword_hilt () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sword_hilt" ] = {
    type = "use",
    inv_obj = "inv_sword_hilt",
    use_place = "obj_knight_use_sword_hilt",
    room = private.room_objname,
    zz = "zz_knight",
    zz_gate = "gzz_weapon_room_knight"
  };
  local use_sword_hilt_inv = function ()
  
    interface.InventoryItemRemove( "inv_sword_hilt" );
  
  end;
  local use_sword_hilt_beg = function ()
  
    ObjDelete( "obj_knight_use_sword_hilt" );
  
  end;
  local use_sword_hilt_end = function ()
  
    ObjDelete( "spr_knight_knight" );  
    ObjMultiSet( { 
      { "spr_knight_efes",        {   alp = 1    } },
      { "spr_weapon_room_efes",   {   alp = 1    } },
      { "anm_knight_knight",      {   alp = 1    } },
      { "obj_knight_clk_knight",  { input = true } },
    } );    
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sword_hilt", use_sword_hilt_beg, private.room_objname );
  cmn.AddSubscriber( "use_sword_hilt", use_sword_hilt_inv );
  cmn.AddSubscriber( "use_sword_hilt", use_sword_hilt_end, private.room_objname );
  cmn.AddSubscriber( "use_sword_hilt_inv", use_sword_hilt_inv, private.room_objname );
  cmn.AddSubscriber( "use_sword_hilt_beg", use_sword_hilt_beg, private.room_objname );
  cmn.AddSubscriber( "use_sword_hilt_end", use_sword_hilt_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rusty_medallion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_rusty_medallion" ] = {
    type = "use",
    inv_obj = "inv_rusty_medallion",
    use_place = "obj_weapon_room_use_rusty_medallion",
    room = private.room_objname 
  };
  local use_rusty_medallion_inv = function ()
  
    interface.InventoryItemRemove( "inv_rusty_medallion" );
  
  end;
  local use_rusty_medallion_beg = function ()
  
    ObjDelete( "obj_weapon_room_use_rusty_medallion" );
  
  end;
  local use_rusty_medallion_end = function ()
  
    ObjMultiSet( { 
      { "spr_weapon_room_hillmark_medallion",  { visible = true, input = true } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rusty_medallion", use_rusty_medallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_rusty_medallion", use_rusty_medallion_inv );
  cmn.AddSubscriber( "use_rusty_medallion", use_rusty_medallion_end, private.room_objname );
  cmn.AddSubscriber( "use_rusty_medallion_inv", use_rusty_medallion_inv, private.room_objname );
  cmn.AddSubscriber( "use_rusty_medallion_beg", use_rusty_medallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_rusty_medallion_end", use_rusty_medallion_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function see_fb_conflict () end;
  --------------------------------------------------------------------------------------------
  local see_fb_conflict = function ()
    
    ObjMultiSet( { 
      { "spr_knight_leather_purse",  { input = true } },
    } );
    ObjDelete( "tmr_weapon_room_fb_conflict" );

  end;
  cmn.AddSubscriber( "see_fb_conflict", see_fb_conflict, private.room_objname );   

  --------------------------------------------------------------------------------------------
  -- function see_weapon_room_1 () end;
  --------------------------------------------------------------------------------------------
  local see_weapon_room_1 = function ()
    
    ObjDelete( "anm_weapon_shot" );    
    ObjMultiSet( { 
      { "anm_weapon_after",      { alp = 1 } }
    } );
    
  end;
  
  local see_weapon_room_1_lucien_room = function ()
    
    ObjMultiSet( { 
      { "grm_lucien_room_tower", { visible = true, input = true } },
      { "spr_lucien_room_break", { alp = 1 } },
      { "anm_weapon_after",      { alp = 1 } }
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_lucien_room_tower_focus");
    end;
  end;
  
  cmn.AddSubscriber( "see_weapon_room_1", see_weapon_room_1, private.room_objname );
  cmn.AddSubscriber( "see_weapon_room_1", see_weapon_room_1_lucien_room, "rm_lucien_room" );
  
  --------------------------------------------------------------------------------------------
  -- function see_trophy_ghost () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_trophy_ghost" ] = {
    type = "click",
    use_place = "obj_weapon_room_clk_trophy_ghost",
    room = private.room_objname
  };

  local see_trophy_ghost = function ()
  
    ObjDelete( "obj_weapon_room_clk_trophy_ghost" );
    ObjDelete( "anm_weapon_room_trophy_ghost"     );
    ObjMultiSet( { 
      { "gzz_weapon_room_trophy", { input = true, active = true, visible = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_trophy_ghost", see_trophy_ghost, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_weapon_room_knight () end;
  --------------------------------------------------------------------------------------------
  local see_weapon_room_knight = function ()
  
    ObjDelete( "obj_weapon_room_zz_knight" );
    ObjMultiSet( { 
      { "anm_weapon_room_knight", { alp = 1, frame = 100 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_weapon_room_knight", see_weapon_room_knight, private.room_objname ); 
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_weapons_window () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_weapons_window" );  
    -------------------------------------------------
    function zz_weapons_window.PreOpen ()
      
      if ( cmn.IsEventDone( "use_shopwindow_lock_part" ) and not cmn.IsEventDone( "win_weapons_window" ) ) then 
        
        cmn.MiniGameShow( "weapons_window" );
        common_impl.PassingMgStart( "weapons_window" );
        
      end;

    end; 
    -------------------------------------------
    function zz_weapons_window.PreClose ()
      
      if ( cmn.IsEventDone( "use_shopwindow_lock_part" ) and not cmn.IsEventDone( "win_weapons_window" ) ) then 
        
        cmn.MiniGameHide( "weapons_window" );
        common_impl.PassingMgStop( "weapons_window" );
        
      end;
      
    end; 
    ------------------------------------------------- 
    function zz_weapons_window.Skip ()
      
      if ( cmn.IsEventDone( "use_shopwindow_lock_part" ) and not cmn.IsEventDone( "win_weapons_window" ) ) then 
        
        for i = 1, 3 do
          
          local func_end = function ()
          
            cmn.Lock( false );
            private.WeaponsWindowWin();

          end;  
          
          --if ( private.state[ i ] ~= private.win_fix[ i ] ) then
            
            private.state[ i ] = 1;      
            
          --end;
        
          local ang_old = ObjGet( "spr_weapons_window_part_"..i ).ang;
          local ang_new = private.ang[ private.state[ i ] ];

        cmn.Lock( true );
        ObjAnimate( "spr_weapons_window_part_"..i, "ang", 0, 0, func_end, { 0, 0, ang_old,   0.3, 3, ang_new } ); 
          
        end;  
        
      end;
    
    end;
    -------------------------------------------------
    function zz_weapons_window.Reset ()
      
      if ( cmn.IsEventDone( "use_shopwindow_lock_part" ) and not cmn.IsEventDone( "win_weapons_window" ) ) then 
        
        ng_global.progress[ "std" ][ "win_weapons_window" ].state = { 3, 2, 3 };
        private.WeaponsWindowLoad();
        
      end;
      
    end;  
    
  --*******************************************************************************************************************
  --*** function zz_knight () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_knight" );  
    -------------------------------------------------
    function zz_knight.Close ()
      
      if ( cmn.IsEventDone( "clk_knight" ) and not cmn.IsEventDone( "see_weapon_room_knight" ) ) then 
        
        private.see_weapon_room_knight();
        
      end;

    end; 
    
  --*******************************************************************************************************************
  --*** function zz_canon () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_canon" );  
    -------------------------------------------------
    function zz_canon.Close ()
      
      if ( cmn.IsEventDone( "use_fire_striker" ) and not cmn.IsEventDone( "see_weapon_room_1" ) ) then 
        
        private.see_weapon_room_1();
        
      end;

    end; 
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_weapon_room();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level3/env/aud_weapon_room_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();
  
  if ( cmn.IsEventDone( "use_hillmark_medallion" ) and 
   not cmn.IsEventDone( "see_fb_conflict" ) ) then

    private.see_fb_conflict();

  end;
  
  if ( cmn.IsEventDone( "use_fire_striker" ) and 
       cmn.IsEventDone( "use_cannon_ball" ) and 
   not cmn.IsEventDone( "see_weapon_room_1" ) ) then

    private.see_weapon_room_1();
 
  end;

  if ( cmn.IsEventDone( "clk_knight" ) and 
   not cmn.IsEventDone( "see_weapon_room_knight" ) ) then 
    
    private.see_weapon_room_knight();
    
  end;
      
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level3/env/aud_weapon_room_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_fire_striker ()

  local item = "inv_fire_striker";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_canon" ) and 
       cmn.IsEventDone( "use_cannon_ball" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_canon" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_canon_use_fire_striker" ) and 
           cmn.IsEventDone( "use_cannon_ball" ) ) then

    cmn.CallEventHandler( "use_fire_striker_inv" );
    cmn.CallEventHandler( "use_fire_striker_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_fire_striker" );
      cmn.CallEventHandler( "use_fire_striker_end" );
      common.CloseSubRoom();
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_flint", 0, "", 0 );

    AnimPlay( "anm_canon_flint", "flint", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cannon_ball ()

  local item = "inv_cannon_ball";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_canon" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_canon" );

    return true;
    
  elseif ( cmn.ApplyObj( item, "gzz_canon_room_canon2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_canon2', 'not_frame', { { x = 480, y = 240 },{ x = 800, y = 300 } }, { x = 201, y = -156 } ); 
    
    return true;
    
  elseif ( cmn.ApplyObj( item, "obj_canon2_use_cannon_ball" ) ) then

    cmn.CallEventHandler( "use_cannon_ball_inv" );
    cmn.CallEventHandler( "use_cannon_ball_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_cannon_ball" );
      cmn.CallEventHandler( "use_cannon_ball_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_shell", 0, "", 0 );

    AnimPlay( "anm_canon2_core", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_adjustable_wrench ()

  local item = "inv_adjustable_wrench";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_canon" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_canon" );

    return true;
    
  elseif ( cmn.ApplyObj( item, "gzz_canon_room_canon2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_canon2', 'not_frame', { { x = 480, y = 240 },{ x = 800, y = 300 } }, { x = 201, y = -156 } ); 
    
    return true;
    
  elseif ( cmn.ApplyObj( item, "obj_canon2_use_adjustable_wrench" ) ) then

    cmn.CallEventHandler( "use_adjustable_wrench_inv" );
    cmn.CallEventHandler( "use_adjustable_wrench_beg" );

    local func_end_2 = function ()
      
      local func_end = function ()
      
        cmn.Lock( false );

        cmn.SetEventDone( "use_adjustable_wrench" );
        cmn.CallEventHandler( "use_adjustable_wrench_end" );
        private.get_stone_2();
      
      end;    
    
      ObjAnimate( "obj_canon2_ring_part", "alp", 0, 1, func_end, { 0.0,0,1,  0.3,3,0});
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_wrench3", 0, "", 0 );
    VidPlay( "vid_canon2_key", func_end_2 );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_release_tool ()

  local item = "inv_release_tool";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_canon" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_canon" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_canon_use_release_tool" ) ) then

    cmn.CallEventHandler( "use_release_tool_inv" );
    cmn.CallEventHandler( "use_release_tool_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_release_tool" );
      cmn.CallEventHandler( "use_release_tool_end" );
      
    end;

    cmn.Lock( true );
    
    ObjMultiSet( { 
      { "spr_canon_patch", { alp = 0 } },
    } );
    
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_pliers4", 0, "", 0 );
    AnimPlay( "anm_canon_ring", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_shopwindow_lock_part ()

  local item = "inv_shopwindow_lock_part";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_weapons_window" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_weapons_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_weapons_window_use_shopwindow_lock_part" ) ) then

    cmn.CallEventHandler( "use_shopwindow_lock_part_inv" );
    cmn.CallEventHandler( "use_shopwindow_lock_part_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        local func_end_3 = function ()   
        
          cmn.Lock( false );

          cmn.SetEventDone( "use_shopwindow_lock_part" );
          cmn.CallEventHandler( "use_shopwindow_lock_part_end" );
          
          private.WeaponsWindowLoad();
          cmn.MiniGameShow( "weapons_window" );
          common_impl.PassingMgStart( "weapons_window" );
        
        end;
        
        ObjAnimate( "spr_weapons_window_mg_door1", "pos_xy", 0, 1, func_end_3, { 0.0,0,0,0,  1,0,350,50 });  
        
      end;
      
      ObjAnimate( "spr_weapons_window_mg_door1", "ang", 0, 0, func_end_2, { 0.0,0,0,  0.2,3,0.3 });
      ObjSet( "spr_weapons_window_lock_part_2", { alp = 0 } );
      ObjSet( "spr_weapons_window_lock_part", { alp = 1 } );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_shopwindow_lock_part", 0, "", 0 );

    cmn.ItemFly( "spr_weapons_window_lock_part_2", func_end, -1, 60 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ship_model ()

  local item = "inv_ship_model";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_weapons_window" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_weapons_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_weapons_window_use_ship_model" ) ) then

    cmn.CallEventHandler( "use_ship_model_inv" );
    cmn.CallEventHandler( "use_ship_model_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
      
        cmn.Lock( false );
        cmn.SetEventDone( "use_ship_model" );
        cmn.CallEventHandler( "use_ship_model_end" );
      
      end;
    
      ObjAnimate( "spr_weapons_window_door2", "pos_xy",0,1, func_end_2, { 
        0.0, 0, 0, 0,    
        0.8, 0, -200, 0, 
      } );    
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_axe_amulet", 0, "", 0 );

    cmn.ItemFly( "spr_weapons_window_axe", func_end, -1.22 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_magnet_lvl3 ()

  local item = "inv_magnet_lvl3";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_trophy" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trophy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_trophy_use_magnet" ) ) then

    cmn.CallEventHandler( "use_magnet_lvl3_inv" );
    cmn.CallEventHandler( "use_magnet_lvl3_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_magnet_lvl3" );
      cmn.CallEventHandler( "use_magnet_lvl3_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_magnet3", 0, "", 0 );

    AnimPlay( "anm_trophy_magnit", "magnit", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hunter_horn ()

  local item = "inv_hunter_horn";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_trophy" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trophy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_trophy_use_hunter_horn" ) ) then

    cmn.CallEventHandler( "use_hunter_horn_inv" );
    cmn.CallEventHandler( "use_hunter_horn_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_hunter_horn" );
        cmn.CallEventHandler( "use_hunter_horn_end" );

      end;

      ObjAnimate( "spr_trophy_cach", "pos_xy",0,0, func_end_2, { 
        0.0, 0, ObjGet( "spr_trophy_cach" ).pos_x, ObjGet( "spr_trophy_cach" ).pos_y,    
        0.3, 0, 111, 427, 
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_horn", 0, "", 0 );

    AnimPlay( "anm_trophy_horn", "horn", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fang ()

  local item = "inv_fang";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_dummy" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dummy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dummy_use_fang" ) ) then

    cmn.CallEventHandler( "use_fang_inv" );
    cmn.CallEventHandler( "use_fang_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_fang" );
        cmn.CallEventHandler( "use_fang_end" );
      
      end;
      
      ObjAnimate( "spr_dummy_jaw_fang", "ang", 0, 0, func_end_2, { 0.0,0,0.24,  0.6,3,-0.24 });
      ObjAnimate( "spr_dummy_jaw", "ang", 0, 0, "", { 0.0,0,0.24,  0.6,3,-0.24 });
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_fang", 0, "", 0 );

    AnimPlay( "anm_dummy_fang", "fang", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_feathers ()

  local item = "inv_feathers";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_dummy" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dummy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dummy_use_feathers" ) ) then

    cmn.CallEventHandler( "use_feathers_inv" );
    cmn.CallEventHandler( "use_feathers_beg" );

    local func_end = function ()
    
      cmn.Lock( false );
      cmn.SetEventDone( "use_feathers" );
      cmn.CallEventHandler( "use_feathers_end" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_leaf_amulet3", 0, "", 0 );

    AnimPlay( "anm_dummy_feather", "feather", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hillmark_medallion ()

  local item = "inv_hillmark_medallion";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_knight" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_knight" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_knight_use_hillmark_medallion" ) ) then

    cmn.CallEventHandler( "use_hillmark_medallion_inv" );
    cmn.CallEventHandler( "use_hillmark_medallion_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
      
        cmn.Lock( false );

        cmn.SetEventDone( "use_hillmark_medallion" );
        cmn.CallEventHandler( "use_hillmark_medallion_end" );
        
        common.CloseSubRoom();
        private.see_fb_conflict();
      
      end;
      
      ObjAnimate( "spr_knight_knight_glow_1", "alp", 0, 0, func_end_2,  { 0.0,0,0,  0.3,3,1 });
      ObjAnimate( "spr_knight_knight_glow_2", "alp", 0, 0, "",          { 0.0,0,1,  0.3,3,0 });
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hillmark_medallion", 0, "", 0 );

    cmn.ItemFly( "spr_knight_medallion", func_end, 1.22, 60 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sword_hilt ()

  local item = "inv_sword_hilt";

  if ( cmn.ApplyObj( item, "gzz_weapon_room_knight" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_knight" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_knight_use_sword_hilt" ) ) then

    cmn.CallEventHandler( "use_sword_hilt_inv" );
    cmn.CallEventHandler( "use_sword_hilt_beg" );

    local func_end = function ()
      
      local func_end_2 = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_sword_hilt" );
        cmn.CallEventHandler( "use_sword_hilt_end" );
        
      end;
      
      ObjAnimate( "spr_knight_efes", "pos_xy", 0, 0, func_end_2, { 0.0,0,232,-100,  0.6,3,185,-13 }); 
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_slide_handle", 0, "", 0 );
    
    ObjMultiSet( { 
    { "spr_knight_efes",  { pos_x = 232, pos_y = -100 } },
    } );  
    cmn.ItemFly( "spr_knight_efes", func_end, 1.0, 0 );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_rusty_medallion ()

  local item = "inv_rusty_medallion";

  if ( cmn.ApplyObj( item, "obj_weapon_room_use_rusty_medallion" ) ) then

    cmn.CallEventHandler( "use_rusty_medallion_inv" );
    cmn.CallEventHandler( "use_rusty_medallion_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_rusty_medallion" );
      cmn.CallEventHandler( "use_rusty_medallion_end" );

      private.get_hillmark_medallion();
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_move_sharpen_wheel", 0, "", 0 );

    AnimPlay( "anm_weapon_grinding_machine", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_opener ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_opener" );
  cmn.CallEventHandler( "get_opener" );

end;
--------------------------------------------------------------------------------------------
function private.get_stone_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stone_2" );
  cmn.CallEventHandler( "get_stone_2" );
  
  common.CloseSubRoom();
    
end;
--------------------------------------------------------------------------------------------
function private.get_ring_lvl3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ring_lvl3" );
  cmn.CallEventHandler( "get_ring_lvl3" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_17" ) ) then
    
    common.CloseSubRoom();
    
  end; 

end;
--------------------------------------------------------------------------------------------
function private.get_compass ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_compass" );
  cmn.CallEventHandler( "get_compass" );

end;
--------------------------------------------------------------------------------------------
function private.get_steering_wheel ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_steering_wheel" );
  cmn.CallEventHandler( "get_steering_wheel" );

end;
--------------------------------------------------------------------------------------------
function private.get_amulet_part_5 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_amulet_part_5" );
  cmn.CallEventHandler( "get_amulet_part_5" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_flag_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_flag_2" );
  cmn.CallEventHandler( "get_flag_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_amulet_part_4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_amulet_part_4" );
  cmn.CallEventHandler( "get_amulet_part_4" );
  
  if ( cmn.IsEventDone( "get_bottle" ) and
  cmn.IsGetCollect2( "get_collect2_item_23" ) ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_wool_piece ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wool_piece" );
  cmn.CallEventHandler( "get_wool_piece" );

end;
--------------------------------------------------------------------------------------------
function private.get_flag_3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_flag_3" );
  cmn.CallEventHandler( "get_flag_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_bottle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bottle" );
  cmn.CallEventHandler( "get_bottle" );
  
  if ( cmn.IsEventDone( "get_amulet_part_4" ) and
  cmn.IsGetCollect2( "get_collect2_item_23" ) ) then
    
    common.CloseSubRoom();

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_leather_purse ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_leather_purse" );
  cmn.CallEventHandler( "get_leather_purse" );

end;
--------------------------------------------------------------------------------------------
function private.get_hillmark_medallion ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hillmark_medallion" );
  cmn.CallEventHandler( "get_hillmark_medallion" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_17 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_17" ); 

  end;

  common_impl.PlayEffectHO( "spr_canon_collect2_item_17", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_17" );
  
  if ( cmn.IsEventDone( "get_ring_lvl3" ) ) then

    common.CloseSubRoom();

  end; 
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_23 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_23" ); 

  end;

  common_impl.PlayEffectHO( "spr_dummy_collect2_item_23", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_23" );
  
  if ( cmn.IsEventDone( "get_bottle" ) and
  cmn.IsEventDone( "get_amulet_part_4" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_knight ()
  
  cmn.CallEventHandler( "clk_knight_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_knight" );
    cmn.CallEventHandler( "clk_knight_end" );
    common.CloseSubRoom();
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_metal_junk1", 0, "", 0 );
  
  AnimPlay( "anm_knight_knight", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG WEAPONWINDOW *** () end;
--*********************************************************************************************************************
function private.WeaponsWindowLoad ()
  
  if not ( ng_global.progress[ "std" ][ "win_weapons_window" ].state ) then
    
    ng_global.progress[ "std" ][ "win_weapons_window" ].state = { 3, 2, 3 };
    
  end;

  private.ang      = { 0, 1.57, 3.14, 4.71, 6.28 }
  private.state    = { 3, 2, 3 }; 
  private.win      = { 1, 1, 1 }; 
  --private.win_fix  = { 3, 3, 3 };   
  
  for i = 1, 3 do 
    
    ObjSet( "spr_weapons_window_part_"..i, { event_mdown = function() private.WeaponsWindowClk( i ); end } );
    
    local circle = ng_global.progress[ "std" ][ "win_weapons_window" ].state[ i ];
    ObjSet( "spr_weapons_window_part_"..i, { ang = private.ang[ circle ] } );
    private.state[ i ] = circle; 

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.WeaponsWindowIsWin ()
  
  for i = 1, 3 do

    if ( private.state[ i ] ~= private.win[ i ] ) then
      
      --if ( private.state[ i ] ~= private.win_fix[ i ] ) then  
        
        return false;
        
      --end;
    
    end;
    
  end;

  return true;
  
end;
--------------------------------------------------------------------------------------------
function private.WeaponsWindowClk ( id ) 

  private.state[ id ] = private.state[ id ] + 1;
  private.WeaponsWindowAnim( id );
  
end;
--------------------------------------------------------------------------------------------
function private.WeaponsWindowAnim ( id )

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_move_part4", 0, "", 0 );

  local func_end = function ()
  
    cmn.Lock( false );
    
    if ( private.state[ id ] ) == 5 then
    
      private.state[ id ] = 1;
      local circle = private.state[ id ];
      ObjSet( "spr_weapons_window_part_"..id, { ang = private.ang[ circle ] } );
      
    end;
    
    if ( private.WeaponsWindowIsWin() ) then
      
      private.WeaponsWindowWin();

    else 
      
      ng_global.progress[ "std" ][ "win_weapons_window" ].state[ id ] = private.state[ id ];
     
    end;
    
  end;  
  
  local ang_old = ObjGet( "spr_weapons_window_part_"..id ).ang;
  local ang_new = private.ang[ private.state[ id ] ];
    
  cmn.Lock( true );
  ObjAnimate( "spr_weapons_window_part_"..id, "ang", 0, 0, func_end, { 0, 0, ang_old,   0.3, 3, ang_new } ); 
  
end;  
--------------------------------------------------------------------------------------------
function private.WeaponsWindowWin ()

  local func_end = function ()
  
    cmn.MiniGameHide( "weapons_window" );
    common_impl.PassingMgWin( "weapons_window" );
    cmn.SetEventDone( "win_weapons_window" );
    cmn.CallEventHandler( "win_weapons_window" );

    common_impl.PlayAudio( "sfx", "aud_win_mmg" );
    cmn.Lock( false );
    
    common.CloseSubRoom();
      
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx", 0, "", 0 );

  ObjAnimate( "obj_weapons_window_mmg", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 3, 1 } )
    
end; 
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
end;
--------------------------------------------------------------------------------------------
function private.see_trophy_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_trophy_ghost" );
    cmn.CallEventHandler( "see_trophy_ghost" );

    common_impl.ShowBbt( 'bbt_trophy_see_trophy_ghost' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_armor_ghost_sc", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_weapon_room_trophy_ghost", { alp = 1 } },
  } );

  AnimPlay( "anm_weapon_room_trophy_ghost", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
function private.see_weapon_room_1 ()
  
  local func_end = function()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_weapon_room_1" );
    cmn.CallEventHandler( "see_weapon_room_1" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_shot", 0, "", 0 );
  
  AnimPlay( "anm_weapon_shot", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
function private.see_weapon_room_knight ()
  
  local func_end = function()
  
    cmn.Lock( false );
    
    cmn.SetEventDone( "see_weapon_room_knight" );
    cmn.CallEventHandler( "see_weapon_room_knight" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_metal_junk2", 0, "", 0 );
  ObjMultiSet( { 
    { "obj_weapon_room_zz_knight", { alp = 0 } },
    { "anm_weapon_room_knight",    { alp = 1 } },
  } );
  AnimPlay( "anm_weapon_room_knight", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
function private.see_fb_conflict ()
  
  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "level3/voc/aud_flashback_conflict_voc",  0.2 );
      common_impl.StopAudio( "sfx", "level3/sfx/aud_flashback_conflict",      0.2 );

    end;

    cmn.SetEventDone( "see_fb_conflict" );
    cmn.CallEventHandler( "see_fb_conflict" );
    cmn.GotoSubRoom( 'zz_knight' )
    
  end;

  common_impl.PlayAudio( "voc", "level3/voc/aud_flashback_conflict_voc", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_flashback_conflict",     0, "", 0 );

  ObjSet( "tmr_weapon_room_fb_conflict", { playing = true, 
                                             time = 29.5, 
                                          endtrig = function() 
                                                      cmn.PlayMusEnv( "mus_env/aud_sad_mus_env" ); 
                                                    end } );

  cmn.PlayDialogVideo( "vid_weapon_room_fb_conflict", func_end );
  
end;


--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_weapon_room ()

  if not ( cmn.IsEventDone( "opn_weapon_room" ) ) then

    cmn.SetEventDone( "opn_weapon_room" );
    common_impl.ShowBbt( 'bbt_weapon_room_opn_weapon_room' );

  end;
  cmn.CallEventHandler( "opn_weapon_room" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
  cmn.AnimateAmbientLight( "spr_weapons_window_light" );
  
end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.AnimUseHunterHorn ()

  common_impl.ShowBbt( 'bbt_trophy_use_hunter_horn' );

  local func_end = function ()

    cmn.Lock( false );

    ObjMultiSet( { 
      { "anm_trophy_horn", { alp = 1 } },
      { "anm_trophy_hh",   { alp = 0 } },
    } );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal_plate", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_trophy_horn", { alp = 0 } },
    { "anm_trophy_hh",   { alp = 1 } },
  } );

  AnimPlay( "anm_trophy_hh", "hh", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseLockPart ()

  common_impl.ShowBbt( 'bbt_weapons_window_use_shopwindow_lock_part' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_low", 0, "", 0 );
  
  ObjAnimate( "spr_weapons_window_mg_door1", "ang", 0, 1, func_end, { 0.0,0,0,  0.2,3,0.05,   0.4,3,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseShipModel ()

  common_impl.ShowBbt( 'bbt_weapons_window_use_ship_model' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_use_part", 0, "", 0 );
  
  ObjAnimate( "spr_weapons_window_door2", "pos_x", 0, 1, func_end, { 0.0,0,0,  0.2,3,-1,   0.4,3,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseFang ()

  common_impl.ShowBbt( 'bbt_dummy_use_fang' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_opn_chest", 0, "", 0 );
  
  ObjAnimate( "spr_dummy_jaw", "ang", 0, 1, func_end, { 0.0,0,0,  0.2,3,-0.06,   0.4,3,0 });
  ObjAnimate( "spr_dummy_jaw_fang", "ang", 0, 1, "",  { 0.0,0,0,  0.2,3,-0.06,   0.4,3,0 });
  
end;
--------------------------------------------------------------------------------------------
function private.AnimUseFeathers ()

  common_impl.ShowBbt( 'bbt_dummy_use_feathers' );

  local func_end = function ()

    cmn.Lock( false );
    ObjMultiSet( { 
      { "anm_dummy_feather",      { alp = 1 } },
      { "spr_dummy_bird_picture", { alp = 0 } },
    } );   
    
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_wood2", 0, "", 0 );
  
  ObjMultiSet( { 
    { "anm_dummy_feather",      { alp = 0 } },
    { "spr_dummy_bird_picture", { alp = 1 } },
  } ); 
  
  ObjAnimate( "spr_dummy_bird_picture", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,2,2,   0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseMedallion ()

  common_impl.ShowBbt( 'bbt_knight_use_hillmark_medallion' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_armor", 0, "", 0 );
 
  ObjAnimate( "spr_knight_knight_glow_2", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,1,1,   0.4,3,0,0 });
  ObjAnimate( "spr_knight_leather_purse", "pos_xy", 0, 1, "", { 0.0,0,0,0,  0.2,3,1,1,   0.4,3,0,0 });
  
end;
--------------------------------------------------------------------------------------------
function private.AnimUseSwordHilt ()

  common_impl.ShowBbt( 'bbt_knight_use_sword_hilt' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_use_part", 0, "", 0 );
 
  ObjAnimate( "spr_knight_blade", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,1,-3,   0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseFireStriker ()

  common_impl.ShowBbt( 'bbt_canon_use_fire_striker' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_wick", 0, "", 0 );
 
  ObjAnimate( "obj_canon_wick", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,2,2,   0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseReleaseTool ()

  common_impl.ShowBbt( 'bbt_canon_use_release_tool' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_ring", 0, "", 0 );
 
  ObjAnimate( "obj_canon_ring", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,0,1,   0.4,3,0,0 });

end;
--------------------------------------------------------------------------------------------
function private.AnimUseAdjustableWrench ()

  common_impl.ShowBbt( 'bbt_canon_use_adjustable_wrench' );

  local func_end = function () cmn.Lock( false ); end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_opn_clock", 0, "", 0 );
 
  ObjAnimate( "spr_canon2_stone_2", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,1,1,   0.4,3,0,0 });

end;
--*********************************************************************************************************************
