-- name=ho_stone_stash
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "stone_stash" );
  game.relations[ "ho_stone_stash" ].exitroom = "rm_park_lvl4";
  private.room_objname = "ho_stone_stash";
  --------------------------------------------------------------------------------------------------
   ObjMultiSet( {
    { "spr_stone_stash_seven",            { event_mdown = function() private.TaskComplete( 'seven'      ) end } },
    { "spr_stone_stash_bell",             { event_mdown = function() private.TaskComplete( 'bell'       ) end } },
    { "spr_stone_stash_boat",             { event_mdown = function() private.TaskComplete( 'boat'       ) end } },
    { "spr_stone_stash_butterfly",        { event_mdown = function() private.TaskComplete( 'butterfly'  ) end } },
    { "spr_stone_stash_chamomille",       { event_mdown = function() private.TaskComplete( 'chamomille' ) end } },
    { "spr_stone_stash_flute",            { event_mdown = function() private.TaskComplete( 'flute'      ) end } },
    { "spr_stone_stash_frog",             { event_mdown = function() private.TaskComplete( 'frog'       ) end } },
    { "spr_stone_stash_ring",             { event_mdown = function() private.TaskComplete( 'ring'       ) end } },
    { "spr_stone_stash_snail",            { event_mdown = function() private.TaskComplete( 'snail'      ) end } },
    { "spr_stone_stash_waterlilly",       { event_mdown = function() private.TaskComplete( 'waterlilly' ) end } },

    { "spr_stone_stash_coin_1",           { event_mdown = function() private.TaskComplete( 'coin',  1   ) end } },
    { "spr_stone_stash_coin_2",           { event_mdown = function() private.TaskComplete( 'coin',  2   ) end } },
    { "spr_stone_stash_coin_3",           { event_mdown = function() private.TaskComplete( 'coin',  3   ) end } },

    { "spr_stone_stash_leaf_1",           { event_mdown = function() private.TaskComplete( 'leaf',  1   ) end } },
    { "spr_stone_stash_leaf_2",           { event_mdown = function() private.TaskComplete( 'leaf',  2   ) end } },
    { "spr_stone_stash_leaf_3",           { event_mdown = function() private.TaskComplete( 'leaf',  3   ) end } },

    { "spr_stone_stash_pick",             { event_dragdrop = function() private.DropPick()                end } },
    { "spr_stone_stash_pruner",           { event_dragdrop = function() private.DropPruner()              end } },
  } );
  --------------------------------------------------------------------------------------------
  -- function win_stone_stash () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_stone_stash" ] = {
    type = "win",
    room = "rm_park_lvl4",
    zz = "ho_stone_stash",
    zz_gate = "gho_park_lvl4_stone_stash"
  };
  local win_stone_stash_inv = function ()
  
    if ( cmn.IsEventDone( "win_stone_stash" ) ) then
      interface.InventoryItemAdd( "inv_ring_lvl4", "spr_stone_stash_win" );    
    end;
    
  end;
  local win_stone_stash_loc = function ()
  
    if ( cmn.IsEventDone( "win_stone_stash" ) ) then
      ObjDelete( "gho_park_lvl4_stone_stash" );   
    end;
    
  end;
  cmn.AddSubscriber( "win_stone_stash", win_stone_stash_inv );
  cmn.AddSubscriber( "win_stone_stash", win_stone_stash_loc, "rm_park_lvl4" );
  --------------------------------------------------------------------------------------------------
  local start_stone_stash_func = function ()

    if ( cmn.IsEventStart( "win_stone_stash" ) ) then
      
      common_impl.ProcessHoStart( "stone_stash" );

      if ( cmn.IsUnmarkedTask( "stone_stash", "ring"       ) ) then cmn.CallEventHandler( "unmark_ring_func" );       end;
      if ( cmn.IsUnmarkedTask( "stone_stash", "chamomille" ) ) then cmn.CallEventHandler( "unmark_chamomille_func" ); end;

    end;

  end;
  cmn.AddSubscriber( "win_stone_stash", start_stone_stash_func, private.room_objname );  
  --------------------------------------------------------------------------------------------------
  local unmark_ring_func = function ()    

    ObjMultiSet( {
      { "spr_stone_stash_ring",         { alp = 1, input = true                                   } },
      { "spr_stone_stash_pick",         { alp = 0, input = false                                  } },
      { "spr_stone_stash_shadow_pick",  { alp = 0                                                 } },
      { "spr_stone_stash_stone_1",      { alp = 0                                                 } },
      { "spr_stone_stash_shadow_stone", { alp = 0                                                 } },
      { "anm_stone_stash_stone",        { alp = 1, frame = 300                                    } },
      { "obj_stone_stash_use_pick",     {          input = false, active = false, visible = false } },
    });

  end;
  cmn.AddSubscriber( "unmark_ring_func", unmark_ring_func, private.room_objname );  
  --------------------------------------------------------------------------------------------------
  local unmark_chamomille_func = function ()    

    ObjMultiSet( {
      { "spr_stone_stash_chamomille",       { alp = 1, input = true                                   } },
      { "spr_stone_stash_pruner",           { alp = 0, input = false                                  } },
      { "spr_stone_stash_patch_pruner",     {          input = false                                  } },
      { "spr_stone_stash_shadow_pruner",    { alp = 0                                                 } },
      { "spr_stone_stash_chamomile",        { alp = 0                                                 } },
      { "anm_stone_stash_cut",              { alp = 0                                                 } },
      { "spr_stone_stash_chamomille_2",     { alp = 1                                                 } },
      { "spr_stone_stash_patch_chamomille", { alp = 1                                                 } },
      { "obj_stone_stash_use_pruner",       {          input = false, active = false, visible = false } },
    });

  end;
  cmn.AddSubscriber( "unmark_chamomille_func", unmark_chamomille_func, private.room_objname );  
  --------------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "levelext/env/aud_park_lvl4_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_stone_stash" ) ) then
  
    cmn.InitHo( "stone_stash" );
    cmn.SetEventDone( "opn_stone_stash" );
  
    cmn.SetMarkedTask( "stone_stash", "ring"       );
    cmn.SetMarkedTask( "stone_stash", "chamomille" );

  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "seven",      1, 0, { { "spr_stone_stash_seven"      } } );
  interface.TaskPanelTaskAdd( ho_items, "bell",       1, 0, { { "spr_stone_stash_bell"       } } );
  interface.TaskPanelTaskAdd( ho_items, "boat",       1, 0, { { "spr_stone_stash_boat"       } } );
  interface.TaskPanelTaskAdd( ho_items, "butterfly",  1, 0, { { "spr_stone_stash_butterfly"  } } );
  interface.TaskPanelTaskAdd( ho_items, "flute",      1, 0, { { "spr_stone_stash_flute"      } } );
  interface.TaskPanelTaskAdd( ho_items, "frog",       1, 0, { { "spr_stone_stash_frog"       } } );
  interface.TaskPanelTaskAdd( ho_items, "snail",      1, 0, { { "spr_stone_stash_snail"      } } );
  interface.TaskPanelTaskAdd( ho_items, "waterlilly", 1, 0, { { "spr_stone_stash_waterlilly" } } );

  interface.TaskPanelTaskAdd( ho_items, "chamomille", 1, 1, { { "spr_stone_stash_pruner", "obj_stone_stash_use_pruner" }, 
                                                              { "spr_stone_stash_chamomille" } 
                                                            } );
  interface.TaskPanelTaskAdd( ho_items, "ring",       1, 1, { { "spr_stone_stash_pick",   "obj_stone_stash_use_pick"   }, 
                                                              { "spr_stone_stash_ring"} 
                                                            } );

  interface.TaskPanelTaskAdd( ho_items, "coin",       3, 0, { { "spr_stone_stash_coin_1" }, 
                                                              { "spr_stone_stash_coin_2" }, 
                                                              { "spr_stone_stash_coin_3" } 
                                                            } );
  interface.TaskPanelTaskAdd( ho_items, "leaf",       3, 0, { { "spr_stone_stash_leaf_1" }, 
                                                              { "spr_stone_stash_leaf_2" }, 
                                                              { "spr_stone_stash_leaf_3" } 
                                                            } );
  interface.TaskPanelShow( ho_items );

end;
--*********************************************************************************************************************
function public.Open () 
  common_impl.PassingHoStart();
end;
--*********************************************************************************************************************
function public.PreClose ()
  interface.TaskPanelHide();
end;
--*********************************************************************************************************************
function public.Close ()
  cmn.PlayMusEnv();
  common_impl.PassingHoStop();
end;
--*********************************************************************************************************************
function public.HoComplete ()
  common_impl.PassingHoWin(); 
end;
--*********************************************************************************************************************
function private.TaskComplete ( task_name, part )
  
  local object = "spr_stone_stash_"..task_name;
  if ( part ) then
    object = object.."_"..part;
  end;
  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function private.DropPick ()
  
  if ( ObjIntersect( "spr_stone_stash_pick", "obj_stone_stash_use_pick" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "stone_stash", "ring" );
      cmn.CallEventHandler( "unmark_ring_func" );

    end;
    
    ObjMultiSet( {
      { "spr_stone_stash_stone_1",      { alp = 0 } },
      { "spr_stone_stash_shadow_stone", { alp = 0 } },
      { "anm_stone_stash_stone",        { alp = 1 } },
      { "spr_stone_stash_pick",         { alp = 0 } },
      { "spr_stone_stash_shadow_pick",  { alp = 0 } },
    });   
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_hammer_ho_4lvl", 0, "", 0 );
    AnimPlay( "anm_stone_stash_stone", "stone", func_end );
    
  else
    
    ObjAttach( "spr_stone_stash_pick", "obj_stone_stash_anim" );
    ObjSet( "spr_stone_stash_pick",        { pos_z = 0 } );
    ObjSet( "spr_stone_stash_shadow_pick", {   alp = 1 } );
    
  end;
  
end;
--*********************************************************************************************************************
function private.DropPruner ()
  
  if ( ObjIntersect( "spr_stone_stash_pruner", "obj_stone_stash_use_pruner" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "stone_stash", "chamomille" );
      cmn.CallEventHandler( "unmark_chamomille_func" );
      
    end;
    
    ObjMultiSet( {
      { "spr_stone_stash_chamomille_2",  { alp = 0 } },
      { "spr_stone_stash_chamomile",     { alp = 0 } },
      { "anm_stone_stash_cut",           { alp = 1 } },
      { "spr_stone_stash_pruner",        { alp = 0 } },
      { "spr_stone_stash_shadow_pruner", { alp = 0 } },
    });
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_cutter_4lvl", 0, "", 0 );
    AnimPlay( "anm_stone_stash_cut", "cut", func_end );
    
  else  
    
    ObjSet( "spr_stone_stash_pruner",        { pos_z = 0 } );
    ObjSet( "spr_stone_stash_shadow_pruner", {   alp = 1 } );
    
  end;
  
end;
--*********************************************************************************************************************