-- name=ho_storage
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "storage" );
  game.relations[ "ho_storage" ].exitroom = "rm_porch";
  private.room_objname = "ho_storage";
  --------------------------------------------------------------------------------------------------
  
  private.TASKPANEL_LEFT = -250;
  private.TASKPANEL_DIFF = 120;
  private.TASKPANEL_COUNT = 5;
  
  private.tasks = { 
                    "basket", "bike", "broom", "candle", "doll", "elephant", 
                    "figure", "hat", "iron", "ladder", "skates", "opener"
                  };

  ObjMultiSet( { 
                  { "spr_storage_basket",  { event_mdown = function() private.TaskComplete( "basket" ); end } },
                  { "spr_storage_bike",  { event_mdown = function() private.TaskComplete( "bike" ); end } },
                  { "spr_storage_broom",  { event_mdown = function() private.TaskComplete( "broom" ); end } },
                  { "spr_storage_candle",  { event_mdown = function() private.TaskComplete( "candle" ); end } },
                  { "spr_storage_doll",  { event_mdown = function() private.TaskComplete( "doll" ); end } },
                  { "spr_storage_elephant",  { event_mdown = function() private.TaskComplete( "elephant" ); end } },
                  { "spr_storage_figure",  { event_mdown = function() private.TaskComplete( "figure" ); end } },
                  { "spr_storage_hat",  { event_mdown = function() private.TaskComplete( "hat" ); end } },
                  { "spr_storage_iron",  { event_mdown = function() private.TaskComplete( "iron" ); end } },
                  { "spr_storage_ladder",  { event_mdown = function() private.TaskComplete( "ladder" ); end } },
                  { "spr_storage_skates",  { event_mdown = function() private.TaskComplete( "skates" ); end } },
                  { "spr_storage_opener",  { event_mdown = function() private.TaskComplete( "opener" ); end } },
  } );
  
  for i = 1, #private.tasks do

    local itemInput = false;
    
    if ( i <= private.TASKPANEL_COUNT ) then 
      
      itemInput = true;
      
    end;
    
    local curItem = "spr_storage_"..private.tasks[ i ];
    local curPanelItem = "spr_storage_taskpanel_"..private.tasks[ i ];
    
    ObjMultiSet( { 
      { curItem,  { input = itemInput } },
      { curPanelItem,  { pos_x = private.TASKPANEL_LEFT + ( i - 1 ) * private.TASKPANEL_DIFF } },
    } );
    
  end;
  
  --------------------------------------------------------------------------------------------
  -- function win_storage () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_storage" ] = {
    type = "win",
    room = "rm_porch",
    zz = "ho_storage",
    zz_gate = "gho_porch_storage"
  };
  local win_storage_inv = function ()
  
    if ( cmn.IsEventDone( "win_storage" ) ) then
    
      interface.InventoryItemAdd( "inv_can_opener_lvl4", "spr_storage_win" );  
    
    end;
    
  end;
  local win_storage_loc = function ()
  
    if ( cmn.IsEventDone( "win_storage" ) ) then
    
      ObjDelete( "gho_porch_storage" );  
    
    end;
    
  end;

  cmn.AddSubscriber( "win_storage", win_storage_inv );
  cmn.AddSubscriber( "win_storage", win_storage_loc, "rm_porch" );
  --------------------------------------------------------------------------------------------------
  local start_storage_func = function ()

    if ( cmn.IsEventStart( "win_storage" ) ) then
    
      common_impl.ProcessHoStart( "storage" );
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_storage" ].found;

      for i = 1, #ho_found, 1 do
        
        ObjDelete( ho_found[ i ][ "object" ] );
        
        for k = 1, 12 do
          
          if ( ho_found[ i ].task == private.tasks[ k ] ) then
            
            ObjDelete( "spr_storage_taskpanel_"..private.tasks[ k ] );
            
            for j = k, 12 do
              
              if ( ObjGet( "spr_storage_taskpanel_"..private.tasks[ j ] ) ) then
         
                ObjSet( "spr_storage_taskpanel_"..private.tasks[ j ], { pos_x = ObjGet( "spr_storage_taskpanel_"..private.tasks[ j ] ).pos_x - private.TASKPANEL_DIFF } ); 
                
                if ( ObjGet( "spr_storage_taskpanel_"..private.tasks[ j ] ).pos_x < private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF ) then
                  
                  ObjSet( "spr_storage_"..private.tasks[ j ], { input = true } );
                  
                end;
              
              end;
              
            end;
          
          end;
          
        end;
      
      end;
      
    end;

  end;
  cmn.AddSubscriber( "win_storage", start_storage_func, private.room_objname );  

end;


--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopMusEnv();
  common_impl.StopAllMus();

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "levelext/env/aud_porch_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_storage" ) ) then
  
    cmn.InitHo( "storage" );
    cmn.SetEventDone( "opn_storage" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "basket",          1, 0, { { "spr_storage_basket" } } );
  interface.TaskPanelTaskAdd( ho_items, "bike",        1, 0, { { "spr_storage_bike" } } );
  interface.TaskPanelTaskAdd( ho_items, "broom",   1, 0, { { "spr_storage_broom" } } );
  interface.TaskPanelTaskAdd( ho_items, "candle",         1, 0, { { "spr_storage_candle" } } );
  interface.TaskPanelTaskAdd( ho_items, "doll",           1, 0, { { "spr_storage_doll" } } );
  interface.TaskPanelTaskAdd( ho_items, "elephant",   1, 0, { { "spr_storage_elephant" } } );
  interface.TaskPanelTaskAdd( ho_items, "figure",          1, 0, { { "spr_storage_figure" } } );
  interface.TaskPanelTaskAdd( ho_items, "hat",    1, 0, { { "spr_storage_hat" } } );
  interface.TaskPanelTaskAdd( ho_items, "iron",         1, 0, { { "spr_storage_iron" } } );
  interface.TaskPanelTaskAdd( ho_items, "ladder",      1, 0, { { "spr_storage_ladder" } } );
  interface.TaskPanelTaskAdd( ho_items, "skates",          1, 0, { { "spr_storage_skates" } } );
  interface.TaskPanelTaskAdd( ho_items, "opener",         1, 0, { { "spr_storage_opener" } } );
  
  interface.TaskPanelShow( ho_items );
  
  ObjAttach( "obj_storage_taskpanel", "spr_int_taskpanel" );
  ObjSet( "obj_int_taskpanel", { visible = false } );
  ObjSet( "txt_int_taskpanel", { visible = false } );

end;


--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  
end;
--*********************************************************************************************************************
function public.PreClose ()
  
  cmn.PlayMusEnv();
  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { visible = true } );
  ObjSet( "txt_int_taskpanel", { visible = true } );

  ObjAttach( "obj_storage_taskpanel", "ho_storage" );

end;


--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();
  ObjDelete( "obj_storage_gates" );
  
end;


--*********************************************************************************************************************
function private.TaskComplete( task_name, part )
  
  cmn.HoTaskFind( "spr_storage_"..task_name, task_name );

  local func_move = function () 
    
    private.TaskPanelUpdate( task_name ); 
    
  end;

  ObjAnimate( "spr_storage_taskpanel_"..task_name, "alp", 0, 0, func_move,
  { 
    0.0, 0, 1.0,
    0.4, 0, 1.0,
    0.6, 0, 0.0
  } );
  
end;
--*********************************************************************************************************************
function private.TaskPanelUpdate ( task_name )

  ObjDelete( "spr_storage_taskpanel_"..task_name );
  
  local index = private.FindIndex( private.tasks, task_name ); 
  
  for j = index, #private.tasks do

    local params = ObjGet( "spr_storage_taskpanel_"..private.tasks[ j ] );
    
    if ( params ) then

      local func_end = "";

      if ( not ObjGet( "spr_storage_"..private.tasks[ j ] ).input ) then

        func_end = function()
          
          local limitX = private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF;
          
          if ( ObjGet( "spr_storage_taskpanel_"..private.tasks[ j ] ) and 
          ( ObjGet( "spr_storage_taskpanel_"..private.tasks[ j ] ).pos_x < limitX ) and 
          ( ObjGet( "spr_storage_"..private.tasks[ j ] ).alp == 1 ) ) then
            
            ObjSet( "spr_storage_"..private.tasks[ j ], { input = true } );
            
          end;

        end;

      end;          

      if ( not private.IsFound( private.tasks[ j ] ) ) then
        
        ObjAnimate( "spr_storage_taskpanel_"..private.tasks[ j ], "pos_x", 0, 0, func_end, 
        { 
          0.0, 3, params.pos_x, 
          0.4, 3, params.pos_x - private.TASKPANEL_DIFF
        } );
        
      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.FindIndex( arr, elem ) -- поиск по таблице 

  for i = 1, #arr do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
function private.IsFound( task ) -- поиск по таблице 

  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_storage" ].found;
  
  for i = 1, #progress do
    
    if ( progress[ i ].task == task ) then

      return true;

    end;
    
  end;
  
  return false;  

end;



