-- name=mg_gates_lvl4
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_gates_lvl4";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_porch" } );
  
  private.InitAnimations();
  private.LogicInit(); 
  
  --------------------------------------------------------------------------------------------
  -- function win_gates_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_gates_lvl4" ] = {
    type = "win",
    use_place = "gmg_porch_gates_lvl4",
    room = "rm_porch",
    zz_gate = "gmg_porch_gates_lvl4"
  };  

  local win_gates_lvl4 = function ()

    if ( cmn.IsEventDone( "win_gates_lvl4" ) ) then  

    end;

  end;
  local win_gates_lvl4_loc = function ()

    if ( cmn.IsEventDone( "win_gates_lvl4" ) ) then  

      ObjDelete( "gmg_porch_gates_lvl4" );
      ObjSet( "grm_porch_park_lvl4", { input = true, visible = true, active = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_porch_park_lvl4_focus");
      end;
    end;

  end;
  cmn.AddSubscriber( "win_gates_lvl4", win_gates_lvl4, private.room_objname );
  cmn.AddSubscriber( "win_gates_lvl4", win_gates_lvl4_loc, "rm_porch" );  
  --------------------------------------------------------------------------------------------
end;


--*********************************************************************************************************************
function private.InitAnimations ()
  
  cmn.AnimateAmbientLight( "spr_gates_lvl4_light" ); 
  
end;


--*********************************************************************************************************************
function public.Open () 

end;


--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_porch_env" }, "", 0.5 );
  common_impl.PlayAudio( "env", "levelext/sfx/aud_move_gear_env", 1, "", 0 );

  int_slider.InitSlider( private.room_objname );
    
  if ( not cmn.IsEventDone( "win_gates_lvl4" ) ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

  private.Load();
  private.Update();

end;


--*********************************************************************************************************************
function public.Close ()

end;


--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "levelext/env/aud_porch_env", 0.5 );
  common_impl.StopAudio( "env", "levelext/env/aud_move_gear_env", 0.2 );
    
  if ( not cmn.IsEventDone( "win_gates_lvl4" ) ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;


--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

private.gamedata = {};
private.win_states = { 
                        0, 0, 0, 0, 0, 1, 0, 0, 0, 
                        0, 2, 0, 0, 0, 0, 0, 0, 5, 
                        0, 0, 0, 0, 0, 4, 0, 0, 0,
                        0, 3, 0, 0, 0, 0, 0, 0, 0,
                        6, 7, 8, 0   
                      };

private.win_moving = { 
                        { is_moving = true, direction = 1 },
                        { is_moving = true, direction = -1 },
                        { is_moving = true, direction = 1 },
                        { is_moving = true, direction = -1 },
                        { is_moving = true, direction = -1 },
                        { is_moving = true, direction = -1 },
                        { is_moving = true, direction = 1 },
                        { is_moving = true, direction = 1 }  
                     };

-- cells list for every branch 
private.branches = {
                      { 1, 2, 3, 4, 5, 6, 7, 8 }, -- 1 
                      { 7, 11, 32, 28, 33, 24, 40, 34, 35, 36 }, -- 2 
                      { 25, 21, 26, 27, 28, 29, 30, 31, 15 }, -- 3 
                      { 19, 20, 21, 22, 23, 24 }, -- 4 
                      { 9, 5, 10, 11, 12, 13, 14, 15, 16, 17, 18 } -- 5 
                   };

-- cells coordinates              
private.coordinates = {
                        { pos_x = 184, pos_y = 552 }, -- 1 
                        { pos_x = 247, pos_y = 495 }, -- 2 
                        { pos_x = 280, pos_y = 420 }, -- 3 
                        { pos_x = 300, pos_y = 348 }, -- 4 
                        { pos_x = 312, pos_y = 267 }, -- 5 
                        { pos_x = 330, pos_y = 182 }, -- 6 
                        { pos_x = 397, pos_y = 135 }, -- 7 
                        { pos_x = 477, pos_y = 106 }, -- 8 
                        { pos_x = 262, pos_y = 306 }, -- 9 
                        { pos_x = 375, pos_y = 219 }, -- 10
                        { pos_x = 440, pos_y = 180 }, -- 11 
                        { pos_x = 515, pos_y = 143 }, -- 12 
                        { pos_x = 598, pos_y = 118 }, -- 13 
                        { pos_x = 675, pos_y = 117 }, -- 14 
                        { pos_x = 751, pos_y = 132 }, -- 15 
                        { pos_x = 802, pos_y = 172 }, -- 16 
                        { pos_x = 836, pos_y = 223 }, -- 17 
                        { pos_x = 855, pos_y = 283 }, -- 18 
                        { pos_x = 356, pos_y = 610 }, -- 19 
                        { pos_x = 383, pos_y = 548 }, -- 20 
                        { pos_x = 416, pos_y = 490 }, -- 21 
                        { pos_x = 466, pos_y = 431 }, -- 22 
                        { pos_x = 524, pos_y = 382 }, -- 23 
                        { pos_x = 606, pos_y = 337 }, -- 24 
                        { pos_x = 445, pos_y = 596 }, -- 25 
                        { pos_x = 433, pos_y = 413 }, -- 26 
                        { pos_x = 467, pos_y = 334 }, -- 27 
                        { pos_x = 524, pos_y = 263 }, -- 28 
                        { pos_x = 574, pos_y = 220 }, -- 29 
                        { pos_x = 633, pos_y = 182 }, -- 30 
                        { pos_x = 686, pos_y = 155 }, -- 31 
                        { pos_x = 483, pos_y = 225 }, -- 32 
                        { pos_x = 559, pos_y = 300 }, -- 33 
                        { pos_x = 637, pos_y = 441 }, -- 34 
                        { pos_x = 648, pos_y = 496 }, -- 35 
                        { pos_x = 650, pos_y = 561 }, -- 36 
                        { pos_x = 94, pos_y = 249 }, -- 37 
                        { pos_x = 998, pos_y = 444 }, -- 38 
                        { pos_x = 747, pos_y = 322 }, -- 39 
                        { pos_x = 611, pos_y = 375 }, -- 40 
                      };

-- runner state for current moment                       
private.is_moving_now = { false, false, false, false, false, false, false, false };

-- information about all runners 
private.runners_radius = { 45, 65, 66, 66, 65, 176, 130, 55 };
                   
private.RUNNER_NAME = "spr_gates_lvl4_runner_";

private.ACTIVE_RUNNER_COUNT = 5;
private.RUNNER_COUNT = 8;
private.CELL_COUNT = 40; 
private.EMPTY_CELL = 0;
private.RUNNER_EXCEPTION_1 = 4;
private.RUNNER_EXCEPTION_2 = 5;
private.MOVING_TIME = 5;


--*******************************************************************************************************************
function private.Default ()

  -- there are all cells; if cell ~= 0 - it is contains runner 
  ng_global.progress[ "ext" ][ "win_gates_lvl4" ].states = { 
                                                              0, 0, 0, 0, 0, 0, 0, 1, 0, 
                                                              0, 0, 0, 0, 0, 0, 0, 5, 0, 
                                                              0, 0, 0, 0, 0, 4, 0, 0, 0,
                                                              0, 0, 0, 3, 0, 0, 0, 0, 2,
                                                              6, 7, 8, 0  
                                                            };
                                                            
  -- information about all runners: about its moving in current moment, about its 
  -- crossing in current moment with other runners, about its direction for future moving 
  -- and about ID of other runner, which is crossed with current runner 
  ng_global.progress[ "ext" ][ "win_gates_lvl4" ].moving = { 
                                                              { is_moving = false, direction = 1, is_crossing = false, last_cell = 0, crossing_runner = nil },
                                                              { is_moving = false, direction = 1, is_crossing = false, last_cell = 0, crossing_runner = nil },
                                                              { is_moving = false, direction = 1, is_crossing = true, last_cell = 25, crossing_runner = nil },
                                                              { is_moving = false, direction = 1, is_crossing = false, last_cell = 0, crossing_runner = nil },
                                                              { is_moving = false, direction = 1, is_crossing = true, last_cell = 18, crossing_runner = 3 },
                                                              { is_moving = true, direction = -1, is_crossing = false, last_cell = 0, crossing_runner = nil },
                                                              { is_moving = false, direction = 1, is_crossing = false, last_cell = 0, crossing_runner = nil },
                                                              { is_moving = false, direction = 1, is_crossing = false, last_cell = 0, crossing_runner = nil }, 
                                                              
                                                           };

end; 


--*******************************************************************************************************************
function private.Load ()

  if ( not ng_global.progress[ "ext" ][ "win_gates_lvl4" ].states or 
  not ng_global.progress[ "ext" ][ "win_gates_lvl4" ].moving ) then 

    private.Default();

  end; 

  private.gamedata = ng_global.progress[ "ext" ][ "win_gates_lvl4" ];

end;


--*******************************************************************************************************************
function private.LogicInit ()  

  for i = 1, private.ACTIVE_RUNNER_COUNT, 1 do 
    
    ObjSet( "txt_gates_lvl4_runner_"..i, { alp = 0, visible = false } );
    
    local curRunner = private.RUNNER_NAME..i;
    ObjSet( curRunner, { 
                          input = true,
                          event_mdown = function () private.RunnerClick( i ); end,
                          event_menter = function () private.Enter( curRunner ); end,
                          event_mleave = function () private.Leave( curRunner ); end
                      } );
                          
  end;
  
end;
      


--*******************************************************************************************************************
function private.Enter ( nameFocus )
 
  SetCursor( CURSOR_HAND );
  
  local current = nameFocus.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );
  
end;


--*******************************************************************************************************************
function private.Leave ( nameFocus )  

  SetCursor( CURSOR_DEFAULT );
  
  local current = nameFocus.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );
  
end;


--*******************************************************************************************************************
function private.RunnerClick ( runnerID ) 
  
  local func_end = function()

    common_impl.StopAudio( "sfx", "levelext/sfx/aud_move_gear_4lvl", 0.2 );

    cmn.Lock( false );
    private.Update(); 
    
  end; 
  
  local path = private.GettingPath( runnerID );
  
  if ( #path > 1 ) then 

    local movingArray = {};
    local time = 0;
    local timeDelta = 0.2;
    local interpolation = 0;
    
    for i = 1, #path, 1 do
      
      local curCell = path[ i ];
      local runnerX = private.coordinates[ curCell ].pos_x;
      local runnerY = private.coordinates[ curCell ].pos_y;
      
      table.insert( movingArray, time );
      table.insert( movingArray, interpolation );
      table.insert( movingArray, runnerX );
      table.insert( movingArray, runnerY );
      
      time = time + timeDelta;
      
    end;
    
    cmn.Lock( true );
    local curRunner = private.RUNNER_NAME..runnerID;
    
    ObjStopAnimate( curRunner, 7 );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_move_gear_4lvl", 1, "", 0 );

    ObjAnimate( curRunner, "pos_xy",0,0, func_end, movingArray );
    
  else
    
    private.Update(); 
    
  end;

end;


--*******************************************************************************************************************
-- getting array of moving points 

function private.GettingPath ( runnerID ) 
  
  local curCell = private.GettingCellByRunnerID( runnerID );
  local curBranch = private.branches[ runnerID ];
  local path = { curCell };
  
  if ( not private.IsRunnerInDeadlock( runnerID, curCell ) ) then 
    
    local startCell, delta, endCell = private.GettingMoveRange( runnerID, curCell, curBranch );
    
    if ( startCell ~= endCell ) then 
      
      local childRunner = private.GettingDependRunnerFromCurRunner( runnerID ); 
      
      for j = 1, #childRunner, 1 do
        
        private.gamedata.moving[ childRunner[ j ] ].crossing_runner = nil;
        
      end;
      
    end;
    
    local i = startCell;
    
    while ( i ~= endCell + delta ) do
      
      local branchCell = curBranch[ i ];
      local crossingRunner = private.IsCrossesWithRunners( runnerID, branchCell );
      
      if ( crossingRunner ) then 
        
        if ( ( runnerID == private.RUNNER_EXCEPTION_1 and branchCell == 24 ) or 
        ( runnerID == private.RUNNER_EXCEPTION_2 and branchCell == 18 ) ) then
          
          table.insert( path, branchCell );
          
        end;
        
        private.gamedata.states[ curCell ] = private.EMPTY_CELL;
        private.gamedata.states[ path[ #path ] ] = runnerID;
        
        private.gamedata.moving[ runnerID ].is_crossing = true;
        private.gamedata.moving[ runnerID ].crossing_runner = crossingRunner;
        
        if ( private.gamedata.moving[ crossingRunner ].is_moving ) then
          
          private.gamedata.moving[ runnerID ].is_moving = true;
          private.gamedata.moving[ runnerID ].direction = -private.gamedata.moving[ crossingRunner ].direction;
          private.is_moving_now[ runnerID ] = false;
          
        else 
          
          private.gamedata.moving[ runnerID ].is_moving = false;
          
        end;
        
        if ( #path > 1 ) then
          
          private.gamedata.moving[ runnerID ].last_cell = private.GettingDirection( delta, curBranch );
          
        end;
          
        return path; 
   
      else  
        
        table.insert( path, branchCell );
        
        if ( i == endCell ) then
          
          private.gamedata.states[ curCell ] = private.EMPTY_CELL;
          private.gamedata.states[ path[ #path ] ] = runnerID;
          
          private.gamedata.moving[ runnerID ].is_moving = false;
          private.gamedata.moving[ runnerID ].is_crossing = false;
          private.gamedata.moving[ runnerID ].crossing_runner = nil;
          
          private.gamedata.moving[ runnerID ].last_cell = private.GettingDirection( delta, curBranch );
        
        end;
        
      end;
      
      i = i + delta;
    
    end;
    
  end;
  
  return path;
  
end;


--*******************************************************************************************************************
-- check on crossing with other runners 

function private.IsCrossesWithRunners ( runnerID, branchCell ) 
  
  local crossingRunner = nil;
  local oldRadius = private.runners_radius[ runnerID ];
  
  local oldRunnerX = private.coordinates[ branchCell ].pos_x;
  local oldRunnerY = private.coordinates[ branchCell ].pos_y;
  
  for i = 1, private.RUNNER_COUNT, 1 do 
    
    if ( i ~= runnerID ) then
    
      local newRadius = private.runners_radius[ i ];
      local newCell = private.GettingCellByRunnerID( i ); 
      
      local newRunnerX = private.coordinates[ newCell ].pos_x;
      local newRunnerY = private.coordinates[ newCell ].pos_y; 
      
      local distance = math.sqrt( math.pow( newRunnerX - oldRunnerX, 2 ) + math.pow( newRunnerY - oldRunnerY, 2 ) );
      
      if ( distance <= oldRadius + newRadius ) then
      
        crossingRunner = i;
        return crossingRunner; 
      
      end;    
      
    end;
    
  end; 
  
  return crossingRunner; 
  
end;


--*******************************************************************************************************************
-- getting array of points on current branch, which are available
-- for potentional runner moving

function private.GettingMoveRange ( runnerID, curCell, curBranch ) 
  
  if ( private.gamedata.moving[ runnerID ].is_crossing ) then
    
    local lastCell = private.gamedata.moving[ runnerID ].last_cell;
    local lastCellIndex = private.GettingIndex( lastCell, curBranch ); 
    local curCellIndex = private.GettingIndex( curCell, curBranch ); 
    
    if ( curCellIndex < lastCellIndex ) then 
      return curCellIndex + 1, 1, lastCellIndex;
    
    else 
      return curCellIndex - 1, -1, lastCellIndex;
      
    end;
    
  else
    
    if ( curBranch[ 1 ] == curCell ) then
      
      return 2, 1, #curBranch;
      
    elseif ( curBranch[ #curBranch ] == curCell ) then
      
      return #curBranch - 1, -1, 1;
      
    end;
    
  end;
 
end;


--*******************************************************************************************************************
function private.GettingCellByRunnerID ( runnerID ) 
  
  for i = 1, private.CELL_COUNT, 1 do 
    
    if ( private.gamedata.states[ i ] == runnerID ) then
      
      return i;
      
    end;
    
  end;
  
end;


--*******************************************************************************************************************
-- getting index on branch by cell ID 

function private.GettingIndex( curCell, curBranch ) 
  
  for i = 1, #curBranch, 1 do 
    
    if ( curBranch[ i ] == curCell ) then
      
      return i;
      
    end;
    
  end;
  
end;


--*******************************************************************************************************************
-- getting direction for future moving 

function private.GettingDirection ( delta, curBranch ) 
  
  if ( delta > 0 ) then
    
    return curBranch[ 1 ];
    
  else
    
    return curBranch[ #curBranch ];
    
  end;
    
end;


--*******************************************************************************************************************
-- getting runner, which was encountered with current runner 

function private.GettingDependRunnerFromCurRunner ( runnerID ) 

  local childRunner = {};
  
  for i = 1, private.ACTIVE_RUNNER_COUNT, 1 do 
    
    if ( private.gamedata.moving[ i ].crossing_runner == runnerID ) then
      
      table.insert( childRunner, i );
      
    end;
    
  end;
  
  return childRunner;
  
end;


--*******************************************************************************************************************
-- checking on runner location in deadlock 

function private.IsRunnerInDeadlock ( runnerID, curCell ) 
  
  local result = false;
  
  local runnerFromDependsCurRunner = private.gamedata.moving[ runnerID ].crossing_runner;
  local dependRunnerFromCurRunner = private.GettingDependRunnerFromCurRunner( runnerID );

  if ( runnerFromDependsCurRunner and #dependRunnerFromCurRunner > 0 ) then
    
    result = true;
    
  end;
                 
  return result;
    
end;


--*******************************************************************************************************************
-- additional check on nearby moving or non-moving and appropriate 
-- moving activation or deactivation for current runner 

function private.ActivateMoving () 
  
  local exceptionRunner_1 = private.gamedata.states[ 18 ];
  
  if ( exceptionRunner_1 ~= private.EMPTY_CELL and
  private.gamedata.moving[ exceptionRunner_1 ].is_moving ) then
  
    private.gamedata.moving[ 7 ].is_moving = true;
    
  else
    
    private.gamedata.moving[ 7 ].is_moving = false;
    
  end; 
 
  local exceptionRunner_2 = private.gamedata.states[ 24 ];
  
  if ( exceptionRunner_2 ~= private.EMPTY_CELL and
  private.gamedata.moving[ exceptionRunner_2 ].is_moving ) then
  
    private.gamedata.moving[ 8 ].is_moving = true;
    
  else
    
    private.gamedata.moving[ 8 ].is_moving = false;
    
  end; 
  ----------------------------------------------------
  ---------------------------------------------------- 
  for i = 1, private.RUNNER_COUNT, 1 do 
   
    local runnerFromDependsCurRunner = private.gamedata.moving[ i ].crossing_runner;
    
    if ( runnerFromDependsCurRunner ) then
      
      if ( private.gamedata.moving[ runnerFromDependsCurRunner ].is_moving ) then
        
        private.gamedata.moving[ i ].is_moving = true;
        
      else 
        
        private.gamedata.moving[ i ].is_moving = false;
       
      end;
      
    end;
    
  end; 
  ----------------------------------------------------
  ---------------------------------------------------- 
  local exceptionRunner_1 = private.gamedata.states[ 18 ];
  
  if ( exceptionRunner_1 ~= private.EMPTY_CELL and
  private.gamedata.moving[ exceptionRunner_1 ].is_moving ) then
  
    private.gamedata.moving[ 7 ].is_moving = true;
    
  else
    
    private.gamedata.moving[ 7 ].is_moving = false;
    
  end; 
 
  local exceptionRunner_2 = private.gamedata.states[ 24 ];
  
  if ( exceptionRunner_2 ~= private.EMPTY_CELL and
  private.gamedata.moving[ exceptionRunner_2 ].is_moving ) then
  
    private.gamedata.moving[ 8 ].is_moving = true;
    
  else
    
    private.gamedata.moving[ 8 ].is_moving = false;
    
  end; 
  
end;


--*******************************************************************************************************************
function private.Update ()
  
  private.ActivateMoving();
  
  for i = 1, private.CELL_COUNT, 1 do 
    
    if ( private.gamedata.states[ i ] ~= private.EMPTY_CELL ) then 
      
      local runnerID = private.gamedata.states[ i ];
      local curRunner = private.RUNNER_NAME..runnerID;
 
      local runnerX = private.coordinates[ i ].pos_x;
      local runnerY = private.coordinates[ i ].pos_y;
      
      ObjMultiSet( { 
        { curRunner,  { pos_x = runnerX, pos_y = runnerY } },
      } );
      
      if ( private.gamedata.moving[ runnerID ].is_moving ) then
        
        if ( not private.is_moving_now[ runnerID ] ) then
        
          private.is_moving_now[ runnerID ] = true;
          
          local direction = private.gamedata.moving[ runnerID ].direction;
          ObjAnimate( curRunner, "ang",1,0, "", { 0, 0, 0,    private.MOVING_TIME, 0, 6.28*direction } );
    
        end;
        
      else
        
        private.is_moving_now[ runnerID ] = false;
        ObjStopAnimate( curRunner, 7 );
        
      end;
    
    end;  
    
  end;
    
  if private.CheckWin() then
    
    private.Win();
    
  end;
  
end;


--*******************************************************************************************************************
function private.CheckWin ()
  
  local result = false;
  local count = 0; 
  
  for i = 1, private.RUNNER_COUNT, 1 do 
    
    if ( private.gamedata.moving[ i ].is_moving ) then
      
      count = count + 1;
      
    end;
    
  end;
  
  if ( count == private.RUNNER_COUNT ) then
    
    result = true;
    
  end;
    
  return result;
                        
end;


--*******************************************************************************************************************
function private.Win () 
  
  local func_end = function()

    cmn.SetEventDone( "win_gates_lvl4" );
    cmn.CallEventHandler( "win_gates_lvl4" );

    cmn.Lock( false );
    common_impl.PassingMgWin();

    cmn.GotoRoom( "rm_porch" );

  end; 
  
  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_gate", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
  cmn.MiniGameHide();
  cmn.Lock( true );
  
  for i = 1, private.RUNNER_COUNT, 1 do
    
    local trgAfter = "";
    
    if i == private.RUNNER_COUNT then
      
      trgAfter = func_end;
      
    end;
    
  local curRunnerLight = private.RUNNER_NAME..i.."_focus";
  ObjAnimate( curRunnerLight, "alp",0,0, trgAfter, { 0, 3, 0,    0.6, 3, 1,    1.0, 3, 0,    1.5, 3, 1,    2.6, 3, 0 } );
    
  end;
  
end;


--*********************************************************************************************************************
function public.Reset ()
  
  private.Default(); 
  private.Load();
  private.Update(); 

end; 


--*********************************************************************************************************************
function public.Skip ()
  
  private.gamedata.states = private.win_states;
  private.gamedata.moving = private.win_moving;
  
  private.Load();
  private.Update(); 
  
end;





