-- name=mg_minigame_3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_minigame_3";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_weaponry" } );

  private.events_list = {
    "clk_door",
    "use_tablets",
    "use_acid",
    "use_bot",
    "use_hammer1",
    "use_funnel",
    "use_powder",
    "use_top",
    "use_hammer2",
    "use_knife",
    "use_rope"
  };
  private.shelf_open = false;

  ObjMultiSet({ 
    { "spr_minigame_3_bomb", { event_mdown = private.get_bomb }},
    { "obj_minigame_clk_shelf", { event_mdown = private.ChangeShelf }},
    { "spr_minigame_3_door", { event_mdown = private.clk_door }},
    { "spr_minigame_3_tablets", { 
      event_startdrag = private.drag_tablets,
      event_dragdrop = private.use_tablets
    }},
    { "spr_minigame_3_acid", { 
      event_startdrag = private.drag_acid,
      event_dragdrop = private.use_acid
    }},
    { "spr_minigame_3_cup", { 
      event_startdrag = private.drag_cup,
      event_dragdrop = private.use_cup
    }},
    { "spr_minigame_3_bot_part", { 
      event_startdrag = private.drag_bot,
      event_dragdrop = private.use_bot
    }},
    { "spr_minigame_3_hammer", { 
      event_startdrag = private.drag_hammer,
      event_dragdrop = private.use_hammer
    }},
    { "spr_minigame_3_funnel", { 
      event_startdrag = private.drag_funnel,
      event_dragdrop = private.use_funnel
    }},
    { "spr_minigame_3_top_part", { 
      event_startdrag = private.drag_top,
      event_dragdrop = private.use_top
    }},
    { "spr_minigame_3_knife", { 
      event_startdrag = private.drag_knife,
      event_dragdrop = private.use_knife
    }},
    { "spr_minigame_3_rope_part", { 
      event_startdrag = private.drag_rope,
      event_dragdrop = private.use_rope
    }},
  });

  --------------------------------------------------------------------------------------------
  -- function get_bomb () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bomb" ] = {
    type = "click",                    --special
    use_place = "spr_minigame_3_bomb", --special
    room = "rm_weaponry",
    zz = private.room_objname,
    zz_gate = "gmg_weaponry_minigame_3"
  };
  
  local get_bomb_inv = function ()
  
    interface.InventoryItemAdd( "inv_bomb", "spr_minigame_3_bomb" );
  
  end;
  
  local get_bomb_closezz = function ()
  
    ObjDelete( "gfx_minigame_3_bomb" );
  
  end;

  local get_bomb_loc = function ()

    ObjDelete( "gmg_weaponry_minigame_3" );
    ObjSet( "spr_weaponry_box_cover", { alp = 1 } );

  end;
  
  cmn.AddSubscriber( "get_bomb", get_bomb_inv );
  cmn.AddSubscriber( "get_bomb", get_bomb_closezz, private.room_objname );
  cmn.AddSubscriber( "get_bomb", get_bomb_loc, "rm_weaponry" ); 
  --------------------------------------------------------------------------------------------
  -- function win_minigame_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_minigame_3" ] = {
    type = "win",
    use_place = "gmg_weaponry_minigame_3",
    room = "rm_weaponry",
    zz_gate = "gmg_weaponry_minigame_3"
  }; 

  local win_minigame_3 = function ()

    if ( cmn.IsEventDone( "win_minigame_3" ) ) then  

      ObjSet( "spr_minigame_3_bomb", { input = true, visible = true } );

    end;

    for i = 1, #private.events_list do
      private.CallEventHandler( private.events_list[ i ] );
    end;

  end;
  local win_minigame_3_loc = function ()

    if ( cmn.IsEventDone( "win_minigame_3" ) ) then  

    end;

  end;
  cmn.AddSubscriber( "win_minigame_3", win_minigame_3, private.room_objname );
  cmn.AddSubscriber( "win_minigame_3", win_minigame_3_loc, "rm_weaponry" ); 
  --------------------------------------------------------------------------------------------
  function private.Handler_clk_door ()

    ObjSet( "spr_minigame_3_door", { input = false, visible = false } );
    --ObjDelete( "spr_minigame_3_door_over" );

    ObjSet( "spr_minigame_3_cup_over", { alp = 1 } )

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_tablets ()

    ObjSet( "anm_minigame_3_powder", { visible = false } );
    ObjSet( "anm_minigame_3_powder2", { visible = false } );
    ObjSet( "spr_minigame_3_tablets", { visible = false, input = false } );
    ObjSet( "obj_minigame_3_use_tablets", { input = false } );

    ObjSet( "spr_minigame_3_cup_powder", { visible = true } );
    ObjSet( "obj_minigame_3_use_acid", { input = true } );
    ObjSet( "spr_minigame_3_cup_over", { ang = -0.4363, pos_x = 30, pos_y = 71 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_acid ()

    ObjSet( "spr_minigame_3_acid", { visible = false, input = false } );
    ObjSet( "spr_minigame_3_acid2", { visible = true } );
    
    ObjSet( "vid_minigame_3_acid", { alp = 0 } );
    
    ObjSet( "obj_minigame_3_use_acid", { input = false } );

    ObjSet( "spr_minigame_3_cup", { input = true, drag = true } );

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_bot ()

    ObjSet( "spr_minigame_3_bot_part", { visible = false, input = false } );
    ObjSet( "obj_minigame_3_use_bot", { input = false } );

    ObjSet( "spr_minigame_3_bomb", { pos_x = 509, pos_y = 406, ang = 0 } );
    ObjSet( "spr_minigame_3_bomb_bot", { visible = true } );
    ObjSet( "obj_minigame_3_use_hammer", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_hammer1 ()

    ObjSet( "anm_minigame_3_bottom", { visible = false } );

    ObjSet( "spr_minigame_3_bomb_bot", { pos_y = 222 } );
    ObjSet( "obj_minigame_3_use_hammer", { input = false, event_mdown = function () common_impl.ShowBbt( 'bbt_minigame_3_use_hammer2' ); end } );

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_funnel ()

    ObjSet( "spr_minigame_3_funnel", { input = false, visible = false } );
    ObjSet( "spr_minigame_3_bomb_funnel", { visible = true } );
    ObjSet( "spr_minigame_3_bomb", { pos_y = 449 } );
    ObjSet( "obj_minigame_3_use_cup", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_powder ()

    ObjSet( "spr_minigame_3_bomb_funnel", { visible = false } );
    ObjSet( "spr_minigame_3_cup_powder", { visible = false } );
    
    ObjSet( "spr_minigame_3_cup_over", { alp = 0 } );
    
    ObjSet( "spr_minigame_3_funnel", { visible = true } );
    ObjSet( "spr_minigame_3_bomb", { pos_y = 406 } );
    ObjSet( "obj_minigame_3_use_top", { input = true } );
    ObjSet( "spr_minigame_3_cup", { input = false } );
    ObjSet( "vid_minigame_3_powder", { alp = 0 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_top ()

    ObjSet( "spr_minigame_3_top_part", { visible = false, input = false } );

    ObjSet( "spr_minigame_3_bomb_top", { visible = true } );
    ObjSet( "obj_minigame_3_use_hammer", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_hammer2 ()

    ObjSet( "anm_minigame_3_top", { visible = false, input = false } );
    ObjSet( "obj_minigame_3_use_hammer", { visible = false, input = false } );

    ObjSet( "spr_minigame_3_bomb_top", { visible = true } );
    ObjSet( "spr_minigame_3_hammer", { input = false } );
    ObjSet( "spr_minigame_3_bomb_top", { pos_y = -252 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_knife ()

    ObjSet( "anm_minigame_3_rope", { visible = false, input = false } );
    ObjSet( "spr_minigame_3_rope", { visible = false, input = false } );
    ObjSet( "spr_minigame_3_knife", { visible = false, input = false } );
    ObjSet( "spr_minigame_3_knife_shadow", { visible = false, input = false } );
    

    ObjSet( "spr_minigame_3_rope_part", { visible = true, input = true } ); 
    ObjSet( "obj_minigame_3_use_rope", { input = true } )
    ObjSet( "obj_minigame_3_use_knife", { input = false } );

  end;
  --------------------------------------------------------------------------------------------
  function private.Handler_use_rope ()

    ObjDelete( "spr_minigame_3_rope_part" );

    ObjSet( "spr_minigame_3_bomb_rope", { visible = true } );

  end;


end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open () 

  if not cmn.IsEventDone( "win_minigame_3" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_weaponry_env" }, "", 0.5 );

  if ( not cmn.IsEventStart( "win_minigame_3" ) ) then
    ng_global.progress[ "ext" ][ "win_minigame_3" ].state = {};
  end;

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "levelext/env/aud_weaponry_env", 0.5 );

  if not cmn.IsEventDone( "win_minigame_3" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_bomb ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bomb" );
  cmn.CallEventHandler( "get_bomb" );

  cmn.GotoRoom( "rm_weaponry" );

end;
--*********************************************************************************************************************
function public.Reset ()

  for i = 1, #private.events_list do
    ng_global.progress[ "ext" ][ "win_minigame_3" ].state[ private.events_list[ i ] ] = false;
  end;

  ObjSet( "spr_minigame_3_door", { input = true, visible = true, pos_y = 381 } );
  ObjSet( "spr_minigame_3_cup_over", { alp = 0, ang = 0, pos_x = -102, pos_y = 90 } )
  ObjSet( "spr_minigame_3_cup", { input = false } );
  

  ObjSet( "spr_minigame_3_tablets", { visible = true, input = true } );
  ObjSet( "spr_minigame_3_cup_powder", { visible = false } );
  ObjSet( "obj_minigame_3_use_tablets", { input = true } );
  ObjSet( "obj_minigame_3_use_acid", { input = false } );

  ObjSet( "spr_minigame_3_acid", { input = true, visible = true } );
  ObjSet( "spr_minigame_3_acid2", { visible = false } );

  ObjSet( "spr_minigame_3_bot_part", { visible = true, input = true } );
  ObjSet( "obj_minigame_3_use_bot", { input = true } );

  ObjSet( "spr_minigame_3_bomb", { pos_x = 353, pos_y = 382, ang = -0.17 } );
  ObjSet( "spr_minigame_3_bomb_bot", { visible = false, pos_y = 258 } );

  ObjSet( "obj_minigame_3_use_hammer", { event_mdown = function () common_impl.ShowBbt( 'bbt_minigame_3_use_hammer1' ); end } );
  ObjSet( "spr_minigame_3_funnel", { input = true } );

  ObjSet( "spr_minigame_3_top_part", { visible = true, input = true } );
  ObjSet( "spr_minigame_3_bomb_top", { visible = false, pos_y = -304 } );

  ObjSet( "spr_minigame_3_hammer", { input = true } );

  ObjSet( "spr_minigame_3_rope", { visible = true, input = true } );
  ObjSet( "spr_minigame_3_knife", { visible = false, input = true } );
  ObjSet( "spr_minigame_3_knife_shadow", { visible = true } );

  ObjSet( "spr_minigame_3_rope_part", { visible = false, input = false } ); 
  ObjSet( "obj_minigame_3_use_rope", { input = false } );

  private.shelf_open = false;
  ObjSet( "spr_minigame_3_tablets", { input = private.shelf_open } );
  ObjSet( "obj_minigame_3_use_knife", { input = private.shelf_open } );
  ObjSet( "spr_minigame_3_shelf2", { input = private.shelf_open, pos_x = 805 } );
  ObjSet( "spr_minigame_3_hammer", { input = not private.shelf_open } );
  ObjSet( "obj_minigame_clk_shelf", { pos_x = 719, event_menter = function () common_impl.SetCursor( CURSOR_LEFT ); end } );

  cmn.NoteScaleClose( { "spr_minigame_3_recipe" } )

end;
--*********************************************************************************************************************
function public.Skip ()

  for i = 1, #private.events_list do
    private.SetEventDone( private.events_list[ i ] );
    private.CallEventHandler( private.events_list[ i ] );
  end;

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd ()

  --common_impl.PlayAudio( "sfx", "aud_mg_win" );

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_minigame_3" );
  cmn.CallEventHandler( "win_minigame_3" );
  common_impl.PassingMgWin();

end;
--*********************************************************************************************************************
function private.Win ()

  private.WinEnd();

end;
--*********************************************************************************************************************
function private.ChangeShelf ()

  cmn.Lock( true );

  local func_end = function ()

    cmn.Lock( false );
    private.shelf_open = not private.shelf_open;
    
    if not private.IsEventDone( "use_tablets" ) then
    
      ObjSet( "spr_minigame_3_tablets", { input = private.shelf_open } );
      
    end;
    
    if not private.IsEventDone( "use_knife" ) then
      
      ObjSet( "obj_minigame_3_use_knife", { input = private.shelf_open } );
    
    end;
  
    ObjSet( "spr_minigame_3_shelf2", { input = private.shelf_open } );
    ObjSet( "spr_minigame_3_hammer", { input = not private.shelf_open } );

    local f_enter = function () common_impl.SetCursor( CURSOR_LEFT ); end;
    local pos_obj = 719;
    if ( private.shelf_open ) then
      pos_obj = 489;
      f_enter = function () common_impl.SetCursor( CURSOR_RIGHT ); end;
    end;
    ObjSet( "obj_minigame_clk_shelf", { pos_x = pos_obj, event_menter = f_enter } );

  end;

  local pos_start, pos_end = 575, 805;

  if ( not private.shelf_open ) then
    pos_start, pos_end = 805, 575;
  end;

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_move_safe_mg_4lvl", 0, "", 0 );
  ObjAnimate( "spr_minigame_3_shelf2", "pos_x", 0, 0, func_end, { 0, 0, pos_start, 0.4, 3, pos_end } )

end;
--*********************************************************************************************************************
--function door ()
-----------------------------------------------------------------------------------------------------------------------
  function private.clk_door ()

    local endfunc = function ()

      cmn.Lock( false )

      private.SetEventDone( "clk_door" );
      private.CallEventHandler( "clk_door" );

    end;

    cmn.Lock( true )
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_box_wood_4lvl", 0, "", 0 );
    ObjAnimate( "spr_minigame_3_door", "pos_y", 0, 1, endfunc, { 0, 0, 0, 1.1, 3, 800 } )
    ObjAnimate( "spr_minigame_3_cup_over", "alp", 0, 0, "", { 0, 0, 0, 0.5, 3, 0, 0.7, 0, 1 } )

  end;
--*********************************************************************************************************************
--function tablets ()
-----------------------------------------------------------------------------------------------------------------------
  function private.drag_tablets ()

    ObjAttach( "spr_minigame_3_tablets", "mg_minigame_3" );
    ObjSet( "spr_minigame_3_tablets", { pos_z = 50 } );
    common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  end;
  -----------------------------------------------------------------------------------------------------------------------
  function private.use_tablets ()

    local item = "spr_minigame_3_tablets";

    ObjAttach( item, "spr_minigame_3_shelf2" );
    ObjSet( item, { pos_z = 0 } );

    if ( cmn.ApplyObj( item, "obj_minigame_3_use_tablets" ) ) then

      ObjSet( item, { input = false, visible = false } );

      local endfunc = function ()

        cmn.Lock( false )

        ObjSet( "spr_minigame_3_cup", { visible = true } );

        private.SetEventDone( "use_tablets" );
        private.CallEventHandler( "use_tablets" );

      end;

      cmn.Lock( true )

      local midFunc = function ()

        ObjSet( "anm_minigame_3_powder", { visible = false } );
        ObjSet( "spr_minigame_3_cup", { visible = false } );

        ObjSet( "anm_minigame_3_powder2", { visible = true } );
        AnimPlay( "anm_minigame_3_powder2", "powder1", endfunc );

      end;

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_pills_4lvl", 0, "", 0 );
      ObjSet( "anm_minigame_3_powder", { visible = true } );
      AnimPlay( "anm_minigame_3_powder", "powder", midFunc );

    else

      common_impl.WrongApply();

    end

  end;
--*********************************************************************************************************************
--function acid ()
-----------------------------------------------------------------------------------------------------------------------
  function private.drag_acid ()

    ObjSet( "spr_minigame_3_acid", { pos_z = 50 } );
    common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  end;
  -----------------------------------------------------------------------------------------------------------------------
  function private.use_acid ()

    local item = "spr_minigame_3_acid";
    ObjSet( item, { pos_z = 0 } );

    if ( cmn.ApplyObj( item, "obj_minigame_3_use_acid" ) and ( private.IsEventDone( "use_tablets" ) ) ) then

      ObjSet( item, { input = false, visible = false } );

      local endfunc = function ()

        cmn.Lock( false )
        private.SetEventDone( "use_acid" );
        private.CallEventHandler( "use_acid" );

      end;

      cmn.Lock( true )
      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_acid_4lvl", 0, "", 0 );

      ObjSet( "vid_minigame_3_acid", { alp = 1 } );
      VidPlay( "vid_minigame_3_acid", endfunc );

    else

      common_impl.WrongApply();

    end

  end;
--*********************************************************************************************************************
--function cup ()
-----------------------------------------------------------------------------------------------------------------------
  function private.drag_cup ()

    ObjSet( "spr_minigame_3_cup", { pos_z = 50 } );
    ObjSet( "spr_minigame_3_cup_over", { visible = false } );
    common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  end;
  -----------------------------------------------------------------------------------------------------------------------
  function private.use_cup ()

    local item = "spr_minigame_3_cup";
    ObjSet( "spr_minigame_3_cup_over", { visible = true } );
    ObjSet( item, { pos_z = 0 } );

    if ( cmn.ApplyObj( item, "obj_minigame_3_use_cup" ) and ( private.IsEventDone( "use_funnel" ) ) and ( not private.shelf_open ) ) then

      ObjSet( item, { input = false, visible = false } );

      local endfunc = function ()

        cmn.Lock( false )

        private.SetEventDone( "use_powder" );
        private.CallEventHandler( "use_powder" );
        
        ObjSet( item, { visible = true } );

      end;

      cmn.Lock( true )

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_mixture_mg_4lvl", 0, "", 0 );
      ObjSet( "vid_minigame_3_powder", { alp = 1 } );
      VidPlay( "vid_minigame_3_powder", endfunc );

    else

      common_impl.WrongApply();

    end

  end;
--*********************************************************************************************************************
--function bot ()
-----------------------------------------------------------------------------------------------------------------------
  function private.drag_bot ()

    ObjSet( "spr_minigame_3_bot_part", { pos_z = 50 } );
    common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  end;
  -----------------------------------------------------------------------------------------------------------------------
  function private.use_bot ()

    local item = "spr_minigame_3_bot_part";
    ObjSet( item, { pos_z = 0 } );

    if ( cmn.ApplyObj( item, "obj_minigame_3_use_bot" ) ) then

      ObjSet( item, { input = false, visible = false } );

      local endfunc = function ()

        cmn.Lock( false )

        private.SetEventDone( "use_bot" );
        private.CallEventHandler( "use_bot" );

      end;

      cmn.Lock( true )

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_cork_4lvl", 0, "", 0 );
      ObjAnimate( "spr_minigame_3_bomb", "pos_xy", 0, 0, "", { 0, 0, 353, 382, 0.3, 3, 509, 406 } );
      ObjAnimate( "spr_minigame_3_bomb", "ang", 0, 0, "", { 0, 0, -0.17, 0.3, 3, 0 } );

      ObjSet( "spr_minigame_3_bomb_bot", { visible = true } )
      ObjAnimate( "spr_minigame_3_bomb_bot", "alp", 0, 0, "", { 0, 0, 0, 0.3, 3, 0, 0.6, 0, 1 } );
      ObjAnimate( "spr_minigame_3_bomb_bot", "pos_y", 0, 1, endfunc, { 0, 0, 100, 0.3, 3, 100, 0.6, 3, 0 } );

    else

      common_impl.WrongApply();

    end

  end;
--*********************************************************************************************************************
--function hammer ()
-----------------------------------------------------------------------------------------------------------------------
  function private.drag_hammer ()

    ObjSet( "spr_minigame_3_hammer", { pos_z = 50 } );
    common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  end;
  -----------------------------------------------------------------------------------------------------------------------
  function private.use_hammer ()

    local item = "spr_minigame_3_hammer";
    ObjSet( item, { pos_z = 0 } );

    if ( cmn.ApplyObj( item, "obj_minigame_3_use_hammer" ) and ( not private.IsEventDone( "use_hammer1" ) ) and ( private.IsEventDone( "use_bot" ) ) ) then

      local endfunc = function ()

        cmn.Lock( false )

        ObjSet( "spr_minigame_3_hammer", { visible = true } )
        ObjSet( "spr_minigame_3_bomb", { visible = true } )

        private.SetEventDone( "use_hammer1" );
        private.CallEventHandler( "use_hammer1" );

      end;

      cmn.Lock( true )
      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_hammer_mg_4lvl", 0, "", 0 );

      ObjSet( "spr_minigame_3_hammer", { visible = false } )
      ObjSet( "spr_minigame_3_bomb", { visible = false } )

      ObjSet( "anm_minigame_3_bottom", { visible = true } )
      AnimPlay( "anm_minigame_3_bottom", "bottom", endfunc )

    elseif ( cmn.ApplyObj( item, "obj_minigame_3_use_hammer" ) and ( not private.IsEventDone( "use_hammer2" ) ) and ( private.IsEventDone( "use_top" ) ) ) then

      local endfunc = function ()

        cmn.Lock( false )

        ObjSet( "spr_minigame_3_hammer", { visible = true } )
        ObjSet( "spr_minigame_3_bomb", { visible = true } )

        private.SetEventDone( "use_hammer2" );
        private.CallEventHandler( "use_hammer2" );

      end;

      cmn.Lock( true )
      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_hammer_mg_4lvl", 0, "", 0 );

      ObjSet( "spr_minigame_3_hammer", { visible = false } );
      ObjSet( "spr_minigame_3_bomb", { visible = false } );

      ObjSet( "anm_minigame_3_top", { visible = true } );
      AnimPlay( "anm_minigame_3_top", "top", endfunc );

    else

      common_impl.WrongApply();

    end

  end;
--*********************************************************************************************************************
--function top ()
-----------------------------------------------------------------------------------------------------------------------
  function private.drag_top ()

    ObjSet( "spr_minigame_3_top_part", { pos_z = 50 } );
    common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  end;
  -----------------------------------------------------------------------------------------------------------------------
  function private.use_top ()

    local item = "spr_minigame_3_top_part";
    ObjSet( item, { pos_z = 0 } );

    if ( cmn.ApplyObj( item, "obj_minigame_3_use_top" ) and ( private.IsEventDone( "use_powder" ) ) and ( not private.shelf_open ) ) then

      ObjSet( item, { input = false, visible = false } );

      local endfunc = function ()

        cmn.Lock( false )

        private.SetEventDone( "use_top" );
        private.CallEventHandler( "use_top" );

      end;

      cmn.Lock( true )

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_cork_4lvl", 0, "", 0 );
      ObjSet( "spr_minigame_3_bomb_top", { visible = true } )
      ObjAnimate( "spr_minigame_3_bomb_top", "alp", 0, 0, "", { 0, 0, 0, 0.3, 3, 1 } );
      ObjAnimate( "spr_minigame_3_bomb_top", "pos_y", 0, 1, endfunc, { 0, 0, -100, 0.5, 3, 0 } );

    else

      common_impl.WrongApply();

    end

  end;
--*********************************************************************************************************************
--function funnel ()
-----------------------------------------------------------------------------------------------------------------------
  function private.drag_funnel ()

    ObjSet( "spr_minigame_3_funnel", { pos_z = 50 } );
    common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  end;
  -----------------------------------------------------------------------------------------------------------------------
  function private.use_funnel ()

    local item = "spr_minigame_3_funnel";
    ObjSet( item, { pos_z = 0 } );

    if ( cmn.ApplyObj( item, "obj_minigame_3_use_funnel" ) and ( private.IsEventDone( "use_bot" ) ) and ( not private.shelf_open )  ) then

      ObjSet( item, { input = false, visible = false } );

      local endfunc = function ()

        cmn.Lock( false )

        private.SetEventDone( "use_funnel" );
        private.CallEventHandler( "use_funnel" );

      end;

      cmn.Lock( true )
      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_funnel_mg_4lvl", 0, "", 0 );

      ObjAnimate( "spr_minigame_3_bomb", "pos_y", 0, 0, endfunc, { 0, 0, 406, 0.4, 3, 449 } );

      ObjSet( "spr_minigame_3_bomb_funnel", { visible = true } )
      ObjAnimate( "spr_minigame_3_bomb_funnel", "alp", 0, 0, "", { 0, 0, 0, 0.3, 3, 0, 0.6, 0, 1 } );
      ObjAnimate( "spr_minigame_3_bomb_funnel", "pos_y", 0, 1, endfunc, { 0, 0, -100, 0.3, 3, -100, 0.6, 3, 0 } );

    else

      common_impl.WrongApply();

    end

  end;
--*********************************************************************************************************************
--function knife ()
-----------------------------------------------------------------------------------------------------------------------
  function private.drag_knife ()

    ObjSet( "spr_minigame_3_knife", { pos_z = 50, visible = true } );
    ObjSet( "spr_minigame_3_knife_shadow", { visible = false } );
    common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  end;
  -----------------------------------------------------------------------------------------------------------------------
  function private.use_knife ()

    local item = "spr_minigame_3_knife";
    ObjSet( item, { pos_z = 0, visible = false } );
    ObjSet( "spr_minigame_3_knife_shadow", { visible = true } );

    if ( cmn.ApplyObj( item, "obj_minigame_3_use_knife" ) and ( private.shelf_open )  ) then

      ObjSet( item, { input = false, visible = false } );
      ObjSet( "spr_minigame_3_knife_shadow", { visible = false } );
      ObjSet( "spr_minigame_3_rope", { visible = false } );

      local endfunc = function ()

        cmn.Lock( false )

        private.SetEventDone( "use_knife" );
        private.CallEventHandler( "use_knife" );

      end;

      cmn.Lock( true )

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_knife_mg_4lvl", 0, "", 0 );
      ObjSet( "anm_minigame_3_rope", { visible = true } )
      AnimPlay( "anm_minigame_3_rope", "rope", endfunc )

    else

      common_impl.WrongApply();

    end

  end;
--*********************************************************************************************************************
--function rope ()
-----------------------------------------------------------------------------------------------------------------------
  function private.drag_rope ()

    ObjSet( "spr_minigame_3_rope_part", { pos_z = 50 } );
    common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  end;
  -----------------------------------------------------------------------------------------------------------------------
  function private.use_rope ()

    local item = "spr_minigame_3_rope_part";
    ObjSet( item, { pos_z = 0 } );

    if ( cmn.ApplyObj( item, "obj_minigame_3_use_rope" ) and ( private.IsEventDone( "use_hammer2" ) ) and ( not private.shelf_open )  ) then

      ObjSet( item, { input = false, visible = false } );

      local endfunc = function ()

        cmn.Lock( false )

        private.SetEventDone( "use_rope" );
        private.CallEventHandler( "use_rope" );

        private.Win();

      end;

      cmn.Lock( true )

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_wick_mg_4lvl", 0, "", 0 );
      ObjSet( "spr_minigame_3_bomb_rope", { visible = true } )
      ObjAnimate( "spr_minigame_3_bomb_rope", "pos_y", 0, 1, endfunc, { 0, 0, -50, 0.6, 3, 0 } );

    else

      common_impl.WrongApply();

    end

  end;
--*********************************************************************************************************************
function private.SetEventDone ( event_name ) 

  ng_global.progress[ "ext" ][ "win_minigame_3" ].state[ event_name ] = true;

end;

function private.IsEventDone ( event_name ) 

  return ng_global.progress[ "ext" ][ "win_minigame_3" ].state[ event_name ];

end;

function private.CallEventHandler ( event_name ) 

  if ( private.IsEventDone( event_name ) ) then

    private[ "Handler_"..event_name ]();

  end;

end;

--*********************************************************************************************************************