-- name=levelext

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause,    10000000 );
  interface.WidgetAdd( InterfaceWidget_BtnMenu,        21 );

  if IsCollectorsEdition() then
    interface.WidgetAdd( InterfaceWidget_BtnGuide,     20 );
  end;
 
  interface.WidgetAdd( InterfaceWidget_BtnHint,        11 );
  interface.WidgetAdd( InterfaceWidget_BtnSkip,        12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo,         9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset,        9 );
  interface.WidgetAdd( InterfaceWidget_Inventory,       9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel,      10 );
  interface.WidgetAdd( InterfaceWidget_Effects,        11 );
  interface.WidgetAdd( InterfaceWidget_BtnMap,         20 );
  interface.WidgetAdd( InterfaceWidget_DialogHo,       22 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom,    8 );
  interface.WidgetAdd( InterfaceWidget_ItemPanel          );
  interface.WidgetAdd( InterfaceWidget_Popup,          27 );
  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,         26 );
  interface.WidgetAdd( InterfaceWidget_DialogVideo,    26 );
  interface.WidgetAdd( InterfaceWidget_DialogStory        );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 9 );
  interface.WidgetAdd( InterfaceWidget_StrategyGuide,  28 );
  interface.WidgetAdd( InterfaceWidget_Window             );
  interface.WidgetAdd( InterfaceWidget_Tutorial,       27 );
  interface.WidgetAdd( InterfaceWidget_Map,            26 );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.BtnMiniHOAdd( 18 );
  interface.SliderAdd( -1 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 18 );
    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
    interface.BtnMorphAdd( 18 );

  end;
   
  private.Init();
  ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  levelext_inv.Init();
  common.LevelLoad( "levelext", "ext", "rm_porch", param, private.menu_moduls );

  common_impl.CollectiblesMusicLoadOnLocation(); 
  common_impl.Collectibles2Load();
  common_impl.MorphLoad();

  private.TutorialSetParams();
  interface.KeyUpdate();

  cmn.PlayMusEnv();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_porch"
    ,"rm_hall_lvl4"
    ,"rm_park_lvl4"
    ,"rm_backyard"
    ,"rm_room_211_lvl4"
    ,"rm_graveyard"
    ,"rm_lucien_room_lvl4"
    ,"rm_weaponry"

    ,"ho_storage"
    ,"ho_stone_stash"
    ,"ho_in_chest"
    ,"ho_next_armchair"

    ,"mg_gates_lvl4"
    ,"mg_catacombs_fear"
    ,"mg_minigame_3"
    ,"mg_attack"
  };

  game.progress_names_room =
  {
     { "opn_porch"                          }
    ,{ "see_intro_lvl4",                    "rm_porch"            }
    ,{ "win_attack"                         }
    ,{ "see_porch_death",                   "rm_porch"            }
    ,{ "see_porch_anim_porch_1",            "rm_porch",            { "opn_porch"                                    } }
    ,{ "get_cylinder",                      "rm_porch",            { "opn_porch"                                    } }
    ,{ "get_sharp_iron",                    "rm_porch",            { "opn_porch"                                    } }
    ,{ "use_sharp_iron",                    "rm_porch",            { "get_sharp_iron"                               } }
    ,{ "get_necklace",                      "rm_porch",            { "use_sharp_iron"                               } }
    ,{ "clk_diamond_lvl4",                  }
    ,{ "get_diamond_lvl4",                  }
    ,{ "use_diamond_lvl4",                  "rm_porch",            { "get_diamond_lvl4"                             } }
    ,{ "clk_diamond_lvl4_mailbox",          "rm_porch",            { "use_diamond_lvl4"                             } }
    ,{ "get_tweezers_lvl4",                 "rm_porch",            { "clk_diamond_lvl4_mailbox"                     } }
    ,{ "use_tweezers_lvl4",                 "rm_porch",            { "get_tweezers_lvl4"                            } }
    ,{ "get_hotel_sign",                    "rm_porch",            { "use_tweezers_lvl4"                            } }
    ,{ "get_decor_part",                    "rm_porch",            { "use_tweezers_lvl4"                            } }
    ,{ "use_hotel_sign",                    "rm_porch",            { "get_hotel_sign"                               } }
    ,{ "see_porch_anim_porch_open",         "rm_porch",            { "use_hotel_sign"                               } }
    ,{ "opn_storage"                        }
    ,{ "win_storage"                        }
    ,{ "use_can_opener_lvl4",               "rm_porch",            { "win_storage"                                  } }
    ,{ "get_pulverizer",                    "rm_porch",            { "use_can_opener_lvl4"                          } }
    ,{ "use_pulverizer",                    }
    ,{ "get_burner",                        }
    ,{ "use_burner",                        "rm_porch",            { "get_burner"                                   } }
    ,{ "get_burner_2",                      "rm_porch",            { "use_burner"                                   } }
    ,{ "use_burner_2",                      "rm_porch",            { "get_burner_2"                                   } }
    ,{ "clk_mailbox_door3",                 "rm_porch",            { "use_burner_2"                                   } }
    ,{ "get_wrench_lvl4",                   "rm_porch",            { "clk_mailbox_door3"                            } }
    ,{ "use_wrench_lvl4",                   "rm_porch",            { "get_wrench_lvl4"                              } }
    ,{ "get_garden_glove",                  "rm_porch",            { "use_wrench_lvl4"                              } }
    ,{ "use_garden_glove",                  "rm_porch",            { "get_garden_glove"                             } }
    ,{ "get_gates_key",                     "rm_porch",            { "use_garden_glove"                             } }
    ,{ "use_gates_key",                     "rm_porch",            { "get_gates_key"                                } }
    ,{ "win_gates_lvl4"                     }
    ,{ "see_porch_anim_porch_open_2",       "rm_porch",           }
    ,{ "opn_park_lvl4"                      }
    ,{ "see_park_lvl4_anim_park_1",         "rm_park_lvl4",       }
    ,{ "get_twig",                          "rm_park_lvl4",        { "opn_park_lvl4"                                } }
    ,{ "use_twig",                          "rm_park_lvl4",        { "get_twig"                                     } }
    ,{ "get_blunt_knife",                   "rm_park_lvl4",        { "use_twig"                                     } }
    ,{ "use_blunt_knife",                   "rm_porch",            { "get_blunt_knife",                             } }
    ,{ "get_sharp_knife",                   "rm_porch",            { "use_blunt_knife"                              } }
    ,{ "use_sharp_knife",                   "rm_porch",            { "get_sharp_knife"                              } }
    ,{ "get_seeds",                         "rm_porch",            { "use_sharp_knife", "clk_ivy_stone"             } }
    ,{ "get_paper_piece",                   "rm_porch",            { "use_sharp_knife", "clk_ivy_stone"             } }
    ,{ "use_seeds",                         "rm_park_lvl4",        { "get_seeds"                                    } }
    ,{ "get_clock_amulet",                  "rm_park_lvl4",        { "use_seeds"                                    } }
    ,{ "use_clock_amulet",                  "rm_porch",            { "get_clock_amulet", "clk_diamond_lvl4_mailbox" } }
    ,{ "get_alarm_clock",                   "rm_porch",            { "use_clock_amulet"                             } }
    ,{ "clk_alarm_clock_1",                 }
    ,{ "clk_alarm_clock_2",                 }
    ,{ "clk_alarm_clock_3",                 }
    ,{ "get_gear_lvl4",                     }
    ,{ "clk_bridge_lever",                  "rm_park_lvl4",        { "opn_park_lvl4"                                } }
    ,{ "clk_bridge_gear",                   "rm_park_lvl4",        { "clk_bridge_lever"                             } }
    ,{ "use_gear_lvl4",                     "rm_park_lvl4",        { "clk_bridge_gear", "get_gear_lvl4"             } }
    ,{ "get_hook_lvl4",                     "rm_park_lvl4",        { "use_gear_lvl4"                                } }
    ,{ "use_hook_lvl4",                     "rm_park_lvl4",        { "get_hook_lvl4"                                } }
    ,{ "get_basket",                        "rm_park_lvl4",        { "use_hook_lvl4"                                } }
    ,{ "get_duster_lvl4",                   }
    ,{ "clk_basket_1",                      }
    ,{ "clk_basket_2",                      }
    ,{ "get_scheme_piece_1",                }
    ,{ "use_duster_lvl4",                   "rm_park_lvl4",        { "get_duster_lvl4"                              } }
    ,{ "get_torch_lvl4",                    "rm_park_lvl4",        { "use_duster_lvl4"                              } }
    ,{ "use_torch_lvl4",                    "rm_porch",            { "get_torch_lvl4"                               } }
    ,{ "get_lever_lvl4",                    "rm_porch",            { "use_torch_lvl4"                               } }
    ,{ "use_lever_lvl4",                    "rm_park_lvl4",        { "get_lever_lvl4", "clk_bridge_lever"           } }
    ,{ "see_park_lvl4_bridge",              "rm_park_lvl4",       }
    ,{ "opn_backyard"                       }
    ,{ "see_backyard_gangsters",            "rm_backyard",        }
    ,{ "see_backyard_bandits_away",         "rm_backyard",        }
    ,{ "get_stone_lvl4",                    "rm_backyard",         { "opn_backyard"                                 } }
    ,{ "use_stone_lvl4",                    "rm_park_lvl4",        { "get_stone_lvl4"                               } }
    ,{ "get_chain_lvl4",                    "rm_park_lvl4",        { "use_stone_lvl4"                               } }
    ,{ "clk_chain_lvl4_1",                  "rm_backyard",         { "opn_backyard"                                 } }
    ,{ "clk_chain_lvl4_2",                  "rm_backyard",         { "clk_chain_lvl4_1"                             } }
    ,{ "use_chain_lvl4",                    "rm_backyard",         { "clk_chain_lvl4_2", "get_chain_lvl4"           } }
    ,{ "clk_chain_lvl4_3",                  "rm_backyard",         { "use_chain_lvl4"                               } }
    ,{ "get_cross_1_lvl4",                  "rm_backyard",         { "clk_chain_lvl4_3"                             } }
    ,{ "use_cross_1_lvl4",                  "rm_backyard",         { "get_cross_1_lvl4"                             } }
    ,{ "get_sprinkler",                     "rm_backyard",         { "use_cross_1_lvl4"                             } }
    ,{ "use_sprinkler",                     "rm_backyard",         { "get_sprinkler"                                } }
    ,{ "get_honk",                          "rm_backyard",         { "use_sprinkler"                                } }
    ,{ "use_honk",                          "rm_backyard",         { "get_honk"                                     } }
    ,{ "get_feathers_lvl4",                 "rm_backyard",         { "use_honk"                                     } }
    ,{ "use_feathers_lvl4",                 "rm_park_lvl4",        { "get_feathers_lvl4"                            } }
    ,{ "get_decor_part_2",                  "rm_park_lvl4",        { "use_feathers_lvl4"                            } }
    ,{ "get_scheme_piece_2",                "rm_park_lvl4",        { "use_feathers_lvl4"                            } }
    ,{ "use_decor_part",                    "rm_park_lvl4",        { "get_decor_part"                               } }
    ,{ "use_decor_part_2",                  "rm_park_lvl4",        { "get_decor_part_2"                             } }
    ,{ "get_handle_lvl4",                   "rm_park_lvl4",        { "use_decor_part", "use_decor_part_2"           } }
    ,{ "use_handle_lvl4",                   "rm_backyard",         { "get_handle_lvl4"                              } }
    ,{ "get_rake",                          "rm_backyard",         { "use_handle_lvl4"                              } }
    ,{ "use_rake",                          "rm_park_lvl4",        { "get_rake"                                     } }
    ,{ "get_tool_bag",                      "rm_park_lvl4",        { "use_rake"                                     } }
    ,{ "clk_tool_bag_1",                    }
    ,{ "clk_tool_bag_2",                    }
    ,{ "clk_tool_bag_3",                    }
    ,{ "get_wooden_handle",                 }
    ,{ "use_wooden_handle",                 "rm_backyard",         { "get_wooden_handle"                            } }
    ,{ "get_screwdriver_lvl4",              "rm_backyard",         { "use_wooden_handle"                            } }
    ,{ "use_screwdriver_lvl4",              "rm_backyard",         { "get_screwdriver_lvl4"                         } }
    ,{ "get_decor_part_3",                  "rm_backyard",         { "use_screwdriver_lvl4"                         } }
    ,{ "use_decor_part_3",                  "rm_park_lvl4",        { "get_decor_part_3"                             } }
    ,{ "get_crowbar",                       "rm_park_lvl4",        { "use_decor_part_3"                             } }
    ,{ "use_crowbar",                       "rm_porch",            { "get_crowbar"                                  } }
    ,{ "clk_entrance_door",                 "rm_porch",            { "use_crowbar"                                  } }
    ,{ "opn_hall_lvl4"                      }
    ,{ "see_hall_picture",                  "rm_hall_lvl4",       }
    ,{ "get_key_lvl4",                      "rm_hall_lvl4",        { "opn_hall_lvl4"                                } }
    ,{ "use_key_lvl4",                      "rm_hall_lvl4",        { "get_key_lvl4"                                 } }
    ,{ "get_scheme_piece_3",                "rm_hall_lvl4",        { "use_key_lvl4"                                 } }
    ,{ "get_bulb",                          "rm_hall_lvl4",        { "use_key_lvl4"                                 } }
    ,{ "use_bulb",                          "rm_park_lvl4",        { "get_bulb"                                     } }
    ,{ "get_gothic_cross",                  "rm_park_lvl4",        { "use_bulb"                                     } }
    ,{ "use_gothic_cross",                  "rm_park_lvl4",        { "get_gothic_cross"                             } }
    ,{ "clk_gothic_cross",                  "rm_park_lvl4",        { "use_gothic_cross"                             } }
    ,{ "see_park_lvl4_gates",               "rm_park_lvl4",       }
    ,{ "opn_graveyard"                      }
    ,{ "see_graveyard_anim_graveyard_1",    "rm_graveyard",       }
    ,{ "get_stone_triangle",                "rm_graveyard",        { "opn_graveyard"                                } }
    ,{ "use_stone_triangle",                "rm_park_lvl4",        { "get_stone_triangle"                           } }
    ,{ "opn_stone_stash"                    }
    ,{ "win_stone_stash"                    }
    ,{ "use_ring_lvl4",                     "rm_hall_lvl4",        { "opn_hall_lvl4", "win_stone_stash"             } }
    ,{ "clk_ring_lvl4",                     "rm_hall_lvl4",        { "use_ring_lvl4"                                } }
    ,{ "get_tongs_lvl4",                    "rm_hall_lvl4",        { "clk_ring_lvl4"                                } }
    ,{ "get_scheme_piece_4",                "rm_hall_lvl4",        { "clk_ring_lvl4"                                } }
    ,{ "use_tongs_lvl4",                    "rm_graveyard",        { "get_tongs_lvl4"                               } }
    ,{ "get_glove_compartment_key",         "rm_graveyard",        { "use_tongs_lvl4"                               } }
    ,{ "use_glove_compartment_key",         "rm_backyard",         { "use_screwdriver_lvl4", 
                                                                     "get_glove_compartment_key"                    } }
    ,{ "get_box_wrench",                    "rm_backyard",         { "use_glove_compartment_key"                    } }
    ,{ "use_box_wrench",                    "rm_park_lvl4",        { "get_box_wrench"                               } }
    ,{ "clk_bench_lattice",                 "rm_park_lvl4",        { "use_box_wrench"                               } }
    ,{ "get_hotel_symbol",                  "rm_park_lvl4",        { "clk_bench_lattice"                            } }
    ,{ "use_hotel_symbol",                  "rm_hall_lvl4",        { "get_hotel_symbol"                             } }
    ,{ "get_adhesive_bandage",              "rm_hall_lvl4",        { "use_hotel_symbol"                             } }
    ,{ "use_adhesive_bandage",              "rm_hall_lvl4",        { "use_key_lvl4", "get_adhesive_bandage"         } }
    ,{ "clk_adhesive_bandage",              "rm_hall_lvl4",        { "use_adhesive_bandage"                         } }
    ,{ "get_scheme_piece_5",                "rm_hall_lvl4",        { "clk_adhesive_bandage"                         } }
    ,{ "get_chisel_lvl4",                   "rm_hall_lvl4",        { "clk_adhesive_bandage"                         } }
    ,{ "use_chisel_lvl4",                   "rm_graveyard",        { "get_chisel_lvl4"                              } }
    ,{ "get_letter_lvl4",                   "rm_graveyard",        { "use_chisel_lvl4"                              } }
    ,{ "use_letter_lvl4",                   "rm_backyard",         { "get_letter_lvl4"                              } }
    ,{ "get_scheme_piece_6",                "rm_backyard",         { "use_letter_lvl4"                              } }
    ,{ "use_scheme_piece",                  }
    ,{ "win_paper_piece",                   }
    ,{ "use_adhesive_bandage_2",            }
    ,{ "get_dungeon",                       }
    ,{ "clk_crypt_door",                    "rm_graveyard",        { "opn_graveyard", "get_stone_triangle"          } }
    ,{ "use_dungeon",                       "rm_graveyard",        { "clk_crypt_door", "get_dungeon"                } }
    ,{ "win_catacombs_fear"                 }
    ,{ "opn_lucien_room_lvl4"               }
    ,{ "get_spade",                         "rm_lucien_room_lvl4", { "opn_lucien_room_lvl4"                         } }
    ,{ "use_spade",                         "rm_graveyard",        { "get_spade"                                    } }
    ,{ "get_screcrow_outfit",               "rm_graveyard",        { "use_spade"                                    } }
    ,{ "use_screcrow_outfit",               "rm_lucien_room_lvl4", { "get_screcrow_outfit"                          } }
    ,{ "win_lucien_room_lvl4",              "rm_lucien_room_lvl4", { "use_screcrow_outfit"                          } }
    ,{ "get_round_key",                     "rm_lucien_room_lvl4", { "win_lucien_room_lvl4"                         } }
    ,{ "get_double_gun",                    "rm_lucien_room_lvl4", { "win_lucien_room_lvl4"                         } }
    ,{ "use_round_key",                     "rm_backyard",         { "use_letter_lvl4", "get_round_key"             } }
    ,{ "get_plate",                         "rm_backyard",         { "use_round_key"                                } }
    ,{ "use_plate",                         "rm_backyard",         { "get_plate"                                    } }
    ,{ "get_gargoyle_statuette",            "rm_backyard",         { "use_plate"                                    } }
    ,{ "use_gargoyle_statuette",            "rm_graveyard",        { "get_gargoyle_statuette"                       } }
    ,{ "get_flag_lvl4",                     "rm_graveyard",        { "use_gargoyle_statuette"                       } }
    ,{ "use_flag_lvl4",                     "rm_lucien_room_lvl4", { "get_flag_lvl4"                                } }
    ,{ "get_boy_scout_badge",               "rm_lucien_room_lvl4", { "use_flag_lvl4"                                } }
    ,{ "use_boy_scout_badge",               "rm_lucien_room_lvl4", { "get_boy_scout_badge"                          } }
    ,{ "get_box_lvl4",                      "rm_lucien_room_lvl4", { "use_boy_scout_badge"                          } }
    ,{ "clk_match",                         }
    ,{ "get_lit_match",                     }
    ,{ "use_lit_match",                     "rm_lucien_room_lvl4", { "get_lit_match"                                } }
    ,{ "opn_weaponry"                       }
    ,{ "clk_double_gun_1",                  }
    ,{ "clk_double_gun_2",                  }
    ,{ "clk_double_gun_3",                  }
    ,{ "clk_double_gun_4",                  }
    ,{ "clk_double_gun_5",                  }
    ,{ "clk_double_gun_6",                  }
    ,{ "clk_double_gun_7",                  }
    ,{ "clk_double_gun_8",                  }
    ,{ "get_twin_gun_with_blank_ammo",      }
    ,{ "use_twin_gun_with_blank_ammo",      "rm_weaponry",         { "get_twin_gun_with_blank_ammo"                 } }
    ,{ "get_cross_2_lvl4",                  "rm_weaponry",         { "use_twin_gun_with_blank_ammo"                 } }
    ,{ "use_cross_2_lvl4",                  "rm_backyard",         { "get_cross_2_lvl4"                             } }
    ,{ "get_scalpel",                       "rm_backyard",         { "use_cross_2_lvl4"                             } }
    ,{ "use_scalpel",                       "rm_lucien_room_lvl4", { "use_boy_scout_badge", "get_scalpel"           } }
    ,{ "clk_box_rope",                      "rm_lucien_room_lvl4", { "use_scalpel"                                  } }
    ,{ "get_silver_key",                    "rm_lucien_room_lvl4", { "clk_box_rope"                                 } }
    ,{ "use_silver_key",                    "rm_weaponry",         { "get_silver_key"                               } }
    ,{ "clk_silver_key",                    "rm_weaponry",         { "use_silver_key"                               } }
    ,{ "opn_in_chest"                       }
    ,{ "win_in_chest"                       }
    ,{ "see_backyard_anim_backyard_1",      "rm_backyard",         }
    ,{ "use_alarm_double_key",              "rm_backyard",         { "clk_chain_lvl4_3", "win_in_chest"             } }
    ,{ "clk_alarm_double_key",              "rm_backyard",         { "use_alarm_double_key"                         } }
    ,{ "get_recipe",                        "rm_backyard",         { "clk_alarm_double_key"                         } }
    ,{ "use_recipe",                        "rm_weaponry",         { "get_recipe"                                   } }
    ,{ "win_minigame_3"                     }
    ,{ "get_bomb",                          }
    ,{ "use_bomb",                          "rm_hall_lvl4",        { "get_bomb"                                     } }
    ,{ "get_planks",                        "rm_hall_lvl4",        { "use_bomb"                                     } }
    ,{ "use_planks",                        "rm_backyard",         { "get_planks"                                   } }
    ,{ "opn_room_211_lvl4"                  }
    ,{ "see_room_211_lvl4_anim_room_211_1", "rm_room_211_lvl4",   }
    ,{ "clk_room_211_lvl4",                 "rm_room_211_lvl4",    { "opn_room_211_lvl4"                            } }
    ,{ "win_room_211_lvl4",                 "rm_room_211_lvl4",    { "clk_room_211_lvl4"                            } }
    ,{ "see_room_211_lvl4_anim_room_211_2", "rm_room_211_lvl4",   }
    ,{ "get_sara_locket",                   "rm_room_211_lvl4",    { "win_room_211_lvl4"                            } }
    ,{ "clk_sara_locket",                   }
    ,{ "clk_sara_photo",                    }
    ,{ "get_sara_medallion",                }
    ,{ "clk_sara_medallion",                "rm_room_211_lvl4",    { "win_room_211_lvl4"                            } }
    ,{ "use_sara_medallion",                "rm_room_211_lvl4",    { "clk_sara_medallion", "get_sara_medallion"     } }
    ,{ "get_bag_lock_part",                 "rm_room_211_lvl4",    { "use_sara_medallion"                           } }
    ,{ "use_bag_lock_part",                 "rm_room_211_lvl4",    { "get_bag_lock_part"                            } }
    ,{ "clk_bag_lock_part_1",               "rm_room_211_lvl4",    { "use_bag_lock_part"                            } }
    ,{ "clk_bag_lock_part_2",               "rm_room_211_lvl4",    { "clk_bag_lock_part_1"                          } }
    ,{ "get_cane_umbrella",                 "rm_room_211_lvl4",    { "clk_bag_lock_part_2"                          } }
    ,{ "use_cane_umbrella",                 "rm_room_211_lvl4",    { "get_cane_umbrella"                            } }
    ,{ "get_armchair_lever",                "rm_room_211_lvl4",    { "use_cane_umbrella"                            } }
    ,{ "use_armchair_lever",                "rm_backyard",         { "use_screwdriver_lvl4", "get_armchair_lever"   } }
    ,{ "opn_next_armchair"                  }
    ,{ "win_next_armchair"                  }
    ,{ "use_cross_3_lvl4",                  "rm_backyard",         { "win_next_armchair"                            } }
    ,{ "get_sal_ammoniac",                  "rm_backyard",         { "use_cross_3_lvl4"                             } }
    ,{ "use_sal_ammoniac",                  "rm_room_211_lvl4",    { "get_sal_ammoniac"                             } }
    ,{ "see_room_211_lvl4_outro_lvl4",      "rm_room_211_lvl4",   }

    ,{ "get_collect_morph_item_18" }  --"rm_backyard"
    ,{ "get_collect_morph_item_19" }  --"rm_hall_lvl4"
    ,{ "get_collect_morph_item_20" }  --"rm_lucien_room_lvl4"
    ,{ "get_collect_morph_item_21" }  --"rm_park_lvl4"
    ,{ "get_collect_morph_item_22" }  --"rm_room_211_lvl4"
  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};
  private.menu_moduls = { "rm_credits" };

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = { "rm_collectibles2",
                             "rm_collectibles",
                             "rm_achievements"
                           };

    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;  

end;

function private.TutorialSetParams ()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
                                                           --
                                                         end;
  end;

end;

