-- name=levelext_inv
--*********************************************************************************************************************
function public.Init ()

  if port.isPortable() == 1 then
    port.InventoryPopupInit("levelext_inv_hub");
    port.VideoResizeInRoom("levelext_inv");
  end;
  
  private.init_necklace();
  private.init_cylinder();
  private.init_alarm_clock();
  private.init_basket();
  private.init_tool_bag();
  private.init_paper_piece();
  private.init_box_lvl4();
  private.init_double_gun();
  private.init_sara_locket();

  private.InitAnimations(); 
  
  private.burner_2_active = false;
  
  ObjSet( "inv_burner_2", {
  
    event_mdown = private.Burner_2Down,
    event_menter = private.Burner_2Enter,
    event_mleave = private.Burner_2Leave,
    event_dragdrop = private.Burner_2Dragdrop,
  
  } );
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_levelext_inv_deploy = function ()

    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    common_impl.TurnChildGfx( { "levelext_inv_deploy" } , "levelext_inv_deploy", res_sparkle_area );

  end;
  cmn.AddSubscriber( "update_game_mode_levelext_inv_deploy", update_game_mode_levelext_inv_deploy, nil );
  
end;
--*********************************************************************************************************************
function private.StringDivide ( string )  

  local table = { };
  local id = 1;
  local il = 1;

  for i = 1, string.len( string ) do

    if ( string.sub( string, i, i ) == "_" ) then
      table[ id ] = string.sub( string, il, i - 1 );
      il = i + 1;
      id = id + 1;
    end

    if ( i == string.len( string ) ) then
      table[id] = string.sub( string, il, i );
      il = i + 1;
      id = id + 1;
    end

  end

  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck ( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[4];  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;

--*********************************************************************************************************************
-- function *** inv_burner_2 *** () end;
--*********************************************************************************************************************
  function private.Burner_2Down ()

    private.burner_2_active = true;

  end;
  --------------------------------------------------------------------------------------------
  function private.Burner_2Dragdrop ()

    ObjSet( "vid_burner_2_fire", { active = false } );
    private.burner_2_active = false
    
    common_impl.UseItem( { rm_porch.use_burner_2, common_impl.WrongApply } )

  end;
  --------------------------------------------------------------------------------------------
  function private.Burner_2Enter ()

    common_impl.PopupShow( "burner_2" );
    ObjSet( "vid_burner_2_fire", { active = true } )

  end;
  --------------------------------------------------------------------------------------------
  function private.Burner_2Leave ()

    interface.PopupHide();
    
    if not private.burner_2_active then
    
      ObjSet( "vid_burner_2_fire", { active = false } );
      
    end;

  end;


--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
  ObjAnimate( "inv_torch_lvl4_add", "scale_xy",1,0, "", { 0, 3, 1, 1,    0.8, 3, 0.6, 0.6,    1.6, 3, 0.8, 0.8,    2.9, 3, 0.4, 0.4,    3.7, 3, 1, 1 } ); 
  
end;


--*********************************************************************************************************************
-- function *** necklace *** () end;
--*********************************************************************************************************************
  function private.init_necklace()

    ObjMultiSet( { 
      { "spr_deploy_inv_necklace_diamond_lvl4",     { event_mdown = private.get_diamond_lvl4 } },
      { "obj_deploy_inv_necklace_clk_diamond_lvl4", { event_mdown = private.clk_diamond_lvl4 } },
    } );
  
    --------------------------------------------------------------------------------------------
    -- function clk_diamond_lvl4 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_diamond_lvl4" ] = {
        type = "click",
        use_place = "obj_deploy_inv_necklace_clk_diamond_lvl4",
        room = "int_deploy_inv",
        zz = "deploy_inv_necklace",
        zz_gate = "inv_necklace"
      };
      local clk_diamond_lvl4_beg = function ()

        ObjDelete( "obj_deploy_inv_necklace_clk_diamond_lvl4" );
      
      end;
      local clk_diamond_lvl4_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_necklace_diamond_lvl4", { alp = 1, input = true } },
          { "gfx_deploy_inv_necklace_diamond_lvl4", {         active = true } },
          { "spr_deploy_inv_necklace_necklace",     { alp = 1               } },
        } );
        ObjDelete( "anm_deploy_inv_necklace_diamond_sanp_off" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_diamond_lvl4",     clk_diamond_lvl4_beg                 );
      cmn.AddSubscriber( "clk_diamond_lvl4",     clk_diamond_lvl4_end, "inv_necklace" );
      cmn.AddSubscriber( "clk_diamond_lvl4_beg", clk_diamond_lvl4_beg                 );
      cmn.AddSubscriber( "clk_diamond_lvl4_end", clk_diamond_lvl4_end, "inv_necklace" );

    --------------------------------------------------------------------------------------------
    -- function get_diamond_lvl4 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_diamond_lvl4" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_necklace_diamond_lvl4",
        room = "int_deploy_inv",
        zz = "deploy_inv_necklace",
        zz_gate = "inv_necklace"
      };
      local get_diamond_lvl4_inv = function ()

        interface.InventoryItemRemove( "inv_necklace" );
        interface.InventoryItemAdd( "inv_diamond_lvl4", "spr_deploy_inv_necklace_diamond_lvl4" );

      end;
      local get_diamond_lvl4 = function ()

        ObjDelete( "gfx_deploy_inv_necklace_diamond_lvl4" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_diamond_lvl4", get_diamond_lvl4_inv );
      cmn.AddSubscriber( "get_diamond_lvl4", get_diamond_lvl4, "inv_necklace" );
   
  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_diamond_lvl4 ()
    
    cmn.CallEventHandler( "clk_diamond_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_diamond_lvl4" );
      cmn.CallEventHandler( "clk_diamond_lvl4_end", "inv_necklace" ); 

      private.get_diamond_lvl4 ();

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_break_glass4", 0, "", 0 );

    AnimPlay( "anm_deploy_inv_necklace_diamond_sanp_off", "DoAnim", func_end );

  end; 

  -- GET ------------------------------------------------------------------------------------------
  function private.get_diamond_lvl4 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_diamond_lvl4" );
    cmn.CallEventHandler( "get_diamond_lvl4", "inv_necklace" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** cylinder *** () end;
--*********************************************************************************************************************
  function private.init_cylinder()

    ObjMultiSet( { 
      { "spr_deploy_inv_cylinder_burner", { event_mdown = private.get_burner  } },
      { "spr_deploy_inv_cylinder_spray",  { event_mdown = private.get_burner  } },
    } );
  
    --------------------------------------------------------------------------------------------
    -- function use_pulverizer () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_pulverizer" ] = {
        type = "use",
        inv_obj = "inv_pulverizer",
        use_place = "obj_deploy_inv_cylinder_use_pulverizer",
        room = "int_deploy_inv",
        zz = "deploy_inv_cylinder",
        zz_gate = "inv_cylinder"
      };
      
      local use_pulverizer_beg = function ()
      
        interface.InventoryItemRemove( "inv_pulverizer" );
        ObjDelete( "obj_deploy_inv_cylinder_use_pulverizer" );
      
      end;
      local use_pulverizer_end = function ()
      
        ObjMultiSet( { 
          { "spr_deploy_inv_cylinder_burner", {  input = true                                      } },
          { "spr_deploy_inv_cylinder_spray",  {  input = true, alp = 1, pos_x = -109, pos_y = -106 } },
          { "gfx_deploy_inv_cylinder_burner", { active = true                                      } },
        } );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_pulverizer",     use_pulverizer_beg                 );
      cmn.AddSubscriber( "use_pulverizer",     use_pulverizer_end, "inv_cylinder" );
      cmn.AddSubscriber( "use_pulverizer_beg", use_pulverizer_beg                 );
      cmn.AddSubscriber( "use_pulverizer_end", use_pulverizer_end, "inv_cylinder" );

    --------------------------------------------------------------------------------------------
    -- function get_burner () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_burner" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_cylinder_burner",
        room = "int_deploy_inv",
        zz = "deploy_inv_cylinder",
        zz_gate = "inv_cylinder"
      };
      local get_burner_inv = function ()

        interface.InventoryItemRemove( "inv_cylinder" );
        interface.InventoryItemAdd( "inv_burner", "spr_deploy_inv_cylinder_burner" );

      end;
      local get_burner = function ()

        ObjDelete( "gfx_deploy_inv_cylinder_burner" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_burner", get_burner_inv );
      cmn.AddSubscriber( "get_burner", get_burner, "inv_cylinder" );
   
  end;

  -- USE ------------------------------------------------------------------------------------------
  function public.use_pulverizer()
  
    local item = "inv_pulverizer";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_cylinder_use_pulverizer" ) ) then
  
      cmn.CallEventHandler( "use_pulverizer_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_pulverizer" );
        cmn.CallEventHandler( "use_pulverizer_end", "inv_cylinder" );
      
      end;
  
      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","levelext/sfx/aud_use_can_plastic" );

      ObjAnimate( "spr_deploy_inv_cylinder_spray", "pos_xy", 0, 0, func_end, {
        0.0, 0, ObjGet( "spr_deploy_inv_cylinder_spray" ).pos_x, ObjGet( "spr_deploy_inv_cylinder_spray" ).pos_y,
        0.3, 0, ObjGet( "spr_deploy_inv_cylinder_spray" ).pos_x, ObjGet( "spr_deploy_inv_cylinder_spray" ).pos_y,
        0.8, 0, -109, -106,
      } );
      ObjAnimate( "spr_deploy_inv_cylinder_spray", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_deploy_inv_cylinder_spray" ).alp,
        0.3, 0, 1,
        0.8, 0, 1,
      } );

      return true;
  
    end;
  
    return false;
    
  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_burner ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_burner" );
    cmn.CallEventHandler( "get_burner", "inv_cylinder" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** alarm_clock *** () end;
--*********************************************************************************************************************
  function private.init_alarm_clock()

    ObjMultiSet( { 
      { "spr_deploy_inv_alarm_clock_gear_lvl4",         { event_mdown = private.get_gear_lvl4     } },
      { "obj_deploy_inv_alarm_clock_clk_alarm_clock_1", { event_mdown = private.clk_alarm_clock_1 } },
      { "obj_deploy_inv_alarm_clock_clk_alarm_clock_2", { event_mdown = private.clk_alarm_clock_2 } },
      { "obj_deploy_inv_alarm_clock_clk_alarm_clock_3", { event_mdown = private.clk_alarm_clock_3 } },
    } );
  
    --------------------------------------------------------------------------------------------
    -- function clk_alarm_clock_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_alarm_clock_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_alarm_clock_clk_alarm_clock_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_alarm_clock",
        zz_gate = "inv_alarm_clock"
      };
      local clk_alarm_clock_1_beg = function ()

        ObjDelete( "obj_deploy_inv_alarm_clock_clk_alarm_clock_1" );
     
      end;
      local clk_alarm_clock_1_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_alarm_clock_clk_alarm_clock_2", { input = true, active = true, visible = true } },
          { "obj_deploy_inv_alarm_clock_behind",            {   alp = 1                                   } },
        } );
        ObjDelete( "spr_deploy_inv_alarm_clock_in_front" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_alarm_clock_1",     clk_alarm_clock_1_beg                    );
      cmn.AddSubscriber( "clk_alarm_clock_1",     clk_alarm_clock_1_end, "inv_alarm_clock" );
      cmn.AddSubscriber( "clk_alarm_clock_1_beg", clk_alarm_clock_1_beg                    );
      cmn.AddSubscriber( "clk_alarm_clock_1_end", clk_alarm_clock_1_end, "inv_alarm_clock" );

    --------------------------------------------------------------------------------------------
    -- function clk_alarm_clock_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_alarm_clock_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_alarm_clock_clk_alarm_clock_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_alarm_clock",
        zz_gate = "inv_alarm_clock"
      };
      local clk_alarm_clock_2_beg = function ()

        ObjDelete( "obj_deploy_inv_alarm_clock_clk_alarm_clock_2" );
      
      end;
      local clk_alarm_clock_2_end = function ()

        ObjMultiSet( { 
          { "obj_deploy_inv_alarm_clock_clk_alarm_clock_3", { input = true, active = true, visible = true } },
        } );
        ObjDelete( "spr_deploy_inv_alarm_clock_cap" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_alarm_clock_2",     clk_alarm_clock_2_beg                    );
      cmn.AddSubscriber( "clk_alarm_clock_2",     clk_alarm_clock_2_end, "inv_alarm_clock" );
      cmn.AddSubscriber( "clk_alarm_clock_2_beg", clk_alarm_clock_2_beg                    );
      cmn.AddSubscriber( "clk_alarm_clock_2_end", clk_alarm_clock_2_end, "inv_alarm_clock" );

    --------------------------------------------------------------------------------------------
    -- function clk_alarm_clock_3 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_alarm_clock_3" ] = {
        type = "click",
        use_place = "obj_deploy_inv_alarm_clock_clk_alarm_clock_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_alarm_clock",
        zz_gate = "inv_alarm_clock"
      };
      local clk_alarm_clock_3_beg = function ()

        ObjDelete( "obj_deploy_inv_alarm_clock_clk_alarm_clock_3" );
      
      end;
      local clk_alarm_clock_3_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_alarm_clock_gear_lvl4", {  input = true } },
          { "gfx_deploy_inv_alarm_clock_gear_lvl4", { active = true } },
        } );
        ObjDelete( "spr_deploy_inv_alarm_clock_protection" );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_alarm_clock_3",     clk_alarm_clock_3_beg                    );
      cmn.AddSubscriber( "clk_alarm_clock_3",     clk_alarm_clock_3_end, "inv_alarm_clock" );
      cmn.AddSubscriber( "clk_alarm_clock_3_beg", clk_alarm_clock_3_beg                    );
      cmn.AddSubscriber( "clk_alarm_clock_3_end", clk_alarm_clock_3_end, "inv_alarm_clock" );

    --------------------------------------------------------------------------------------------
    -- function get_gear_lvl4 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_gear_lvl4" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_alarm_clock_gear_lvl4",
        room = "int_deploy_inv",
        zz = "deploy_inv_alarm_clock",
        zz_gate = "inv_alarm_clock"
      };
      local get_gear_lvl4_inv = function ()

        interface.InventoryItemRemove( "inv_alarm_clock" );
        interface.InventoryItemAdd( "inv_gear_lvl4", "spr_deploy_inv_alarm_clock_gear_lvl4" );

      end;
      local get_gear_lvl4 = function ()

        ObjDelete( "gfx_deploy_inv_alarm_clock_gear_lvl4" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_gear_lvl4", get_gear_lvl4_inv );
      cmn.AddSubscriber( "get_gear_lvl4", get_gear_lvl4, "inv_alarm_clock" );
   
  end;

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_alarm_clock_1 ()
    
    cmn.CallEventHandler( "clk_alarm_clock_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_alarm_clock_1" );
      cmn.CallEventHandler( "clk_alarm_clock_1_end", "inv_alarm_clock" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_compas", 0, "", 0 );

    ObjAnimate( "obj_deploy_inv_alarm_clock_behind", "alp", 0, 0, func_end, {
      0.0, 0, ObjGet( "obj_deploy_inv_alarm_clock_behind" ).alp,
      0.3, 0, 1,
    } );
    ObjAnimate( "spr_deploy_inv_alarm_clock_in_front", "alp", 0, 0, "", {
      0.0, 0, ObjGet( "spr_deploy_inv_alarm_clock_in_front" ).alp,
      0.3, 0, 0,
    } );

  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_alarm_clock_2 ()
    
    cmn.CallEventHandler( "clk_alarm_clock_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_alarm_clock_2" );
      cmn.CallEventHandler( "clk_alarm_clock_2_end", "inv_alarm_clock" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_compas2", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_alarm_clock_cap", "pos_xy", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_alarm_clock_cap" ).pos_x, ObjGet( "spr_deploy_inv_alarm_clock_cap" ).pos_y,
      0.5, 0, -282, 119,
    } );
    ObjAnimate( "spr_deploy_inv_alarm_clock_cap", "alp", 0, 0, "", {
      0.0, 0, ObjGet( "spr_deploy_inv_alarm_clock_cap" ).alp,
      0.2, 0, ObjGet( "spr_deploy_inv_alarm_clock_cap" ).alp,
      0.5, 0, 0,
    } );

  end; 

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_alarm_clock_3 ()
    
    cmn.CallEventHandler( "clk_alarm_clock_3_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_alarm_clock_3" );
      cmn.CallEventHandler( "clk_alarm_clock_3_end", "inv_alarm_clock" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_compas2", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_alarm_clock_protection", "pos_xy", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_deploy_inv_alarm_clock_protection" ).pos_x, ObjGet( "spr_deploy_inv_alarm_clock_protection" ).pos_y,
      0.5, 0, 353, 226,
    } );
    ObjAnimate( "spr_deploy_inv_alarm_clock_protection", "alp", 0, 0, "", {
      0.0, 0, ObjGet( "spr_deploy_inv_alarm_clock_protection" ).alp,
      0.2, 0, ObjGet( "spr_deploy_inv_alarm_clock_protection" ).alp,
      0.5, 0, 0,
    } );

  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_gear_lvl4 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_gear_lvl4" );
    cmn.CallEventHandler( "get_gear_lvl4", "inv_alarm_clock" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** basket *** () end;
--*********************************************************************************************************************
  function private.init_basket()

    ObjMultiSet( { 
      { "spr_deploy_inv_basket_duster_lvl4",    { event_mdown = private.get_duster_lvl4     } },
      { "spr_deploy_inv_basket_scheme_piece_1", { event_mdown = private.get_scheme_piece_1  } },
      { "obj_deploy_inv_basket_clk_basket_1", { event_mdown = private.clk_basket_1  } },
      { "obj_deploy_inv_basket_clk_basket_2", { event_mdown = private.clk_basket_2  } }, 
    } );
    
    --------------------------------------------------------------------------------------------
    -- function clk_basket_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_basket_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_basket_clk_basket_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_basket",
        zz_gate = "inv_basket"
      };
      local clk_basket_1_beg = function ()

        ObjDelete( "obj_deploy_inv_basket_clk_basket_1" );
      
      end;
      local clk_basket_1_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_basket_clothes1", { pos_x = 33, pos_y = -27 } },
          { "obj_deploy_inv_basket_clk_basket_2", { input = true } },
        } );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_basket_1",     clk_basket_1_beg                 );
      cmn.AddSubscriber( "clk_basket_1",     clk_basket_1_end, "inv_basket" );
      cmn.AddSubscriber( "clk_basket_1_beg", clk_basket_1_beg                 );
      cmn.AddSubscriber( "clk_basket_1_end", clk_basket_1_end, "inv_basket" );    
      
    --------------------------------------------------------------------------------------------
    -- function clk_basket_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_basket_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_basket_clk_basket_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_basket",
        zz_gate = "inv_basket"
      };
      local clk_basket_2_beg = function ()

        ObjDelete( "obj_deploy_inv_basket_clk_basket_2" );
      
      end;
      local clk_basket_2_end = function ()

        ObjMultiSet( { 
          { "spr_deploy_inv_basket_clothes2", { pos_x = -112, pos_y = -50 } },
          { "spr_deploy_inv_basket_scheme_piece_1", { input = true } },
          { "gfx_deploy_inv_basket_scheme_piece_1", { active = true } },
        } );
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_basket_2",     clk_basket_2_beg                 );
      cmn.AddSubscriber( "clk_basket_2",     clk_basket_2_end, "inv_basket" );
      cmn.AddSubscriber( "clk_basket_2_beg", clk_basket_2_beg                 );
      cmn.AddSubscriber( "clk_basket_2_end", clk_basket_2_end, "inv_basket" ); 
      
    --------------------------------------------------------------------------------------------
    -- function get_gear_lvl4 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_duster_lvl4" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_basket_duster_lvl4",
        room = "int_deploy_inv",
        zz = "deploy_inv_basket",
        zz_gate = "inv_basket"
      };
      local get_duster_lvl4_inv = function ()

        if cmn.IsEventDone( "get_scheme_piece_1" ) then
          interface.InventoryItemRemove( "inv_basket" );
        end;

        interface.InventoryItemAdd( "inv_duster_lvl4", "spr_deploy_inv_basket_duster_lvl4" );

      end;
      local get_duster_lvl4 = function ()

        ObjDelete( "gfx_deploy_inv_basket_duster_lvl4" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_duster_lvl4", get_duster_lvl4_inv );
      cmn.AddSubscriber( "get_duster_lvl4", get_duster_lvl4, "inv_basket" );

    --------------------------------------------------------------------------------------------
    -- function get_scheme_piece_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_scheme_piece_1" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_basket_scheme_piece_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_basket",
        zz_gate = "inv_basket"
      };
      local get_scheme_piece_1_inv = function ()

        if cmn.IsEventDone( "get_duster_lvl4" ) then
          interface.InventoryItemRemove( "inv_basket" );
        end;

        local count = 1;
        
        for i = 2, 6, 1 do
          
          if ( cmn.IsEventDone( "get_scheme_piece_"..i ) ) then
            
            count = count + 1;
            ObjSet( "inv_scheme_piece_"..i, { alp = 1 } );
            
          end;
          
        end;
      
        ObjSet( "inv_scheme_piece_number", { frame = ObjGet( "inv_scheme_piece_number" ).frame + 1 } );
        interface.InventoryItemAdd( "inv_scheme_piece", "spr_deploy_inv_basket_scheme_piece_1", "assets/levels/levelext/inv_deploy/inv_basket/inv/inv_scheme_piece_1" );

        if count == 6 then
          ObjSet( "inv_scheme_piece", { drag = true } );
          
          cmn.SetInvPlusRGB( "paper_piece", true );
          
        else 
          ObjSet( "inv_scheme_piece", { drag = false } );

        end;

      end;
      local get_scheme_piece_1 = function ()

        ObjDelete( "gfx_deploy_inv_basket_scheme_piece_1" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_scheme_piece_1", get_scheme_piece_1_inv );
      cmn.AddSubscriber( "get_scheme_piece_1", get_scheme_piece_1, "inv_basket" );
   
  end;
    
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_basket_1 ()
    
    cmn.CallEventHandler( "clk_basket_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_basket_1" );
      cmn.CallEventHandler( "clk_basket_1_end", "inv_basket" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_cloth_4lvl", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_basket_clothes1", "pos_xy",0,0, func_end, { 0, 3, 79, -182,    0.6, 3, 33, -27 } );

  end;     

  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_basket_2 ()
    
    cmn.CallEventHandler( "clk_basket_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_basket_2" );
      cmn.CallEventHandler( "clk_basket_2_end", "inv_basket" ); 

    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_cloth_4lvl", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_basket_clothes2", "pos_xy",0,0, func_end, { 0, 3, -25, -126,    0.6, 3, -112, -50 } );

  end;
  
  -- GET ------------------------------------------------------------------------------------------
  function private.get_duster_lvl4 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_duster_lvl4" );
    cmn.CallEventHandler( "get_duster_lvl4", "inv_basket" );

    if cmn.IsEventDone( "get_scheme_piece_1" ) then
      common_impl.HideDeployInv();
    end;

  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_scheme_piece_1 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_scheme_piece_1" );
    cmn.CallEventHandler( "get_scheme_piece_1", "inv_basket" );

    if cmn.IsEventDone( "get_duster_lvl4" ) then
      common_impl.HideDeployInv();
    end;

  end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** tool_bag *** () end;
--*********************************************************************************************************************
  function private.init_tool_bag()

    ObjMultiSet( { 
      { "spr_deploy_inv_tool_bag_sand_paper", { event_mdown = private.get_wooden_handle  } },
      { "spr_deploy_inv_tool_bag_close",      { event_mdown = private.clk_tool_bag_1     } },
      { "spr_deploy_inv_tool_bag_trash2",     { event_mdown = private.clk_tool_bag_2     } },
      { "spr_deploy_inv_tool_bag_trash1",     { event_mdown = private.clk_tool_bag_3     } },
    } );
  
    --------------------------------------------------------------------------------------------
    -- function get_wooden_handle () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_wooden_handle" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_tool_bag_sand_paper",
        room = "int_deploy_inv",
        zz = "deploy_inv_tool_bag",
        zz_gate = "inv_tool_bag"
      };
      local get_wooden_handle_inv = function ()

        interface.InventoryItemRemove( "inv_tool_bag" );
        interface.InventoryItemAdd( "inv_wooden_handle", "spr_deploy_inv_tool_bag_sand_paper" );

      end;
      local get_wooden_handle = function ()

        ObjDelete( "gfx_deploy_inv_tool_bag_sand_paper" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_wooden_handle", get_wooden_handle_inv );
      cmn.AddSubscriber( "get_wooden_handle", get_wooden_handle, "inv_tool_bag" );
    --------------------------------------------------------------------------------------------
    -- function clk_tool_bag_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_tool_bag_1" ] = {
        type = "click",
        use_place = "spr_deploy_inv_tool_bag_close",
        room = "int_deploy_inv",
        zz = "deploy_inv_tool_bag",
        zz_gate = "inv_tool_bag"
      };
      local clk_tool_bag_1 = function ()

        ObjDelete( "spr_deploy_inv_tool_bag_close" );
        ObjSet( "spr_deploy_inv_tool_bag_open", { alp = 1 } );
        ObjSet( "spr_deploy_inv_tool_bag_trash2", { input = true } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_tool_bag_1", clk_tool_bag_1, "inv_tool_bag" );
    --------------------------------------------------------------------------------------------
    -- function clk_tool_bag_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_tool_bag_2" ] = {
        type = "click",
        use_place = "spr_deploy_inv_tool_bag_trash2",
        room = "int_deploy_inv",
        zz = "deploy_inv_tool_bag",
        zz_gate = "inv_tool_bag"
      };
      local clk_tool_bag_2 = function ()

        ObjSet( "spr_deploy_inv_tool_bag_trash2", { pos_x = 4, pos_y = 33, input = false } );
        ObjSet( "spr_deploy_inv_tool_bag_trash1", { input = true } );
        ObjDelete( "anm_deploy_inv_tool_bag_web" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_tool_bag_2", clk_tool_bag_2, "inv_tool_bag" );
    --------------------------------------------------------------------------------------------
    -- function clk_tool_bag_3 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_tool_bag_3" ] = {
        type = "click",
        use_place = "spr_deploy_inv_tool_bag_trash1",
        room = "int_deploy_inv",
        zz = "deploy_inv_tool_bag",
        zz_gate = "inv_tool_bag"
      };
      local clk_tool_bag_3 = function ()

        ObjSet( "spr_deploy_inv_tool_bag_trash1", { pos_x = 24, pos_y = -15, input = false } );
        ObjSet( "spr_deploy_inv_tool_bag_sand_paper", { input = true, active = true } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_tool_bag_3", clk_tool_bag_3, "inv_tool_bag" );
   
  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_wooden_handle ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_wooden_handle" );
    cmn.CallEventHandler( "get_wooden_handle", "inv_tool_bag" );
    common_impl.HideDeployInv();

  end;
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_tool_bag_1 ()

    local func_end = function()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_tool_bag_1" );
      cmn.CallEventHandler( "clk_tool_bag_1", "inv_tool_bag" );
      
    end;
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_mid2", 0, "", 0 );
    ObjAnimate( "spr_deploy_inv_tool_bag_close", "alp", 0, 0, func_end,
    {
      0.0, 0, 1,
      0.3, 0, 0
    } );
    ObjAnimate( "spr_deploy_inv_tool_bag_open", "alp", 0, 0, "",
    {
      0.0, 0, 0,
      0.3, 0, 1
    } );

  end;
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_tool_bag_2 ()

    local func_end = function()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_tool_bag_2" );
      cmn.CallEventHandler( "clk_tool_bag_2", "inv_tool_bag" );
      
    end;
    cmn.Lock( true );
    local params = ObjGet( "spr_deploy_inv_tool_bag_trash2" );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_trash_4lvl", 0, "", 0 );
    ObjAnimate( "spr_deploy_inv_tool_bag_trash2", "pos_xy", 0, 0, func_end,
    {
      0.0, 0, params.pos_x, params.pos_y,
      1.0, 0, params.pos_x, params.pos_y,
      1.3, 0, 4, 33
    } );
    AnimPlay( "anm_deploy_inv_tool_bag_web", "DoAnim", "" );

  end;
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_tool_bag_3 ()

    local func_end = function()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_tool_bag_3" );
      cmn.CallEventHandler( "clk_tool_bag_3", "inv_tool_bag" );
      
    end;
    cmn.Lock( true );
    local params = ObjGet( "spr_deploy_inv_tool_bag_trash1" );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_trash2_4lvl", 0, "", 0 );
    ObjAnimate( "spr_deploy_inv_tool_bag_trash1", "pos_xy", 0, 0, func_end,
    {
      0.0, 0, params.pos_x, params.pos_y,
      0.3, 0, 24, -15
    } );

  end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** paper_piece *** () end;
--*********************************************************************************************************************
  function private.init_paper_piece()
    
    private.PaperPieceLogicInit();
    private.paper_piece_define(); 
  
    --------------------------------------------------------------------------------------------
    -- function use_scheme_piece () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_scheme_piece" ] = {
        type = "use",
        inv_obj = "inv_scheme_piece",
        use_place = "obj_deploy_inv_paper_piece_use_scheme_piece",
        room = "int_deploy_inv",
        zz = "deploy_inv_paper_piece",
        zz_gate = "inv_paper_piece"
      };
      
      local use_scheme_piece_beg = function ()
      
        interface.InventoryItemRemove( "inv_scheme_piece" );
        ObjDelete( "obj_deploy_inv_paper_piece_use_scheme_piece" );
      
      end;
      local use_scheme_piece_end = function ()
      
        ObjMultiSet( { 
          { "spr_deploy_inv_paper_piece_dungeon",  { input = true } },
        } );
          
        for i = 1, private.PAPER_PIECE_PART_COUNT, 1 do
          
          local curPart = private.PAPER_PIECE_PART_NAME..i;
          ObjSet( curPart, { alp = 1, visible = true } );
        
        end;
      
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_scheme_piece",     use_scheme_piece_beg                    );
      cmn.AddSubscriber( "use_scheme_piece",     use_scheme_piece_end, "inv_paper_piece" );
      cmn.AddSubscriber( "use_scheme_piece_beg", use_scheme_piece_beg                    );
      cmn.AddSubscriber( "use_scheme_piece_end", use_scheme_piece_end, "inv_paper_piece" );

    --------------------------------------------------------------------------------------------
    -- function use_adhesive_bandage_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "use_adhesive_bandage_2" ] = {
        type = "use",
        inv_obj = "inv_adhesive_bandage",
        use_place = "obj_deploy_inv_paper_piece_use_adhesive_bandage_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_paper_piece",
        zz_gate = "inv_paper_piece"
      };
      
      local use_adhesive_bandage_2_beg = function ()
      
        if cmn.IsEventDone( "use_adhesive_bandage" ) then
          interface.InventoryItemRemove( "inv_adhesive_bandage" );
        end;

        ObjDelete( "obj_deploy_inv_paper_piece_use_adhesive_bandage_2" );
      
      end;
      local use_adhesive_bandage_2_end = function ()
      
        ObjMultiSet( { 
          { "spr_deploy_inv_paper_piece_patch",  { alp = 1, visible = true } },
          { "gfx_deploy_inv_paper_piece_dungeon",  { active = true } },
          { "spr_deploy_inv_paper_piece_dungeon",  { input = true, 
                                                     event_mdown = function () private.get_dungeon(); end,
                                                     event_menter = function () SetCursor( CURSOR_GET ); end,
                                                     event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
        } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "use_adhesive_bandage_2",     use_adhesive_bandage_2_beg                    );
      cmn.AddSubscriber( "use_adhesive_bandage_2",     use_adhesive_bandage_2_end, "inv_paper_piece" );
      cmn.AddSubscriber( "use_adhesive_bandage_2_beg", use_adhesive_bandage_2_beg                    );
      cmn.AddSubscriber( "use_adhesive_bandage_2_end", use_adhesive_bandage_2_end, "inv_paper_piece" );

    --------------------------------------------------------------------------------------------
    -- function get_dungeon () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_dungeon" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_paper_piece_dungeon",
        room = "int_deploy_inv",
        zz = "deploy_inv_paper_piece",
        zz_gate = "inv_paper_piece"
      };
      local get_dungeon_inv = function ()

        interface.InventoryItemRemove( "inv_paper_piece" );
        interface.InventoryItemAdd( "inv_dungeon", "spr_deploy_inv_paper_piece_dungeon" );

      end;
      local get_dungeon = function ()

        ObjDelete( "gfx_deploy_inv_paper_piece_dungeon" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_dungeon", get_dungeon_inv );
      cmn.AddSubscriber( "get_dungeon", get_dungeon, "inv_paper_piece" );
      
    --------------------------------------------------------------------------------------------
    -- function win_paper_piece () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "win_paper_piece" ] = {
        type = "win",
        room = "int_deploy_inv",
        zz = "deploy_inv_paper_piece",
        zz_gate = "inv_paper_piece"
      };
      
      local win_paper_piece_inv = function ()
        
        if cmn.IsEventDone( "win_paper_piece" ) then 
        end;

      end;
    
      local win_paper_piece = function ()

        if cmn.IsEventDone( "win_paper_piece" ) then
          
          ObjMultiSet( { 
            { "spr_deploy_inv_paper_piece_dungeon",  { input = false } },
            { "obj_deploy_inv_paper_piece_pieces",  { input = false } },
            { "obj_deploy_inv_paper_piece_use_adhesive_bandage_2",  { input = true } },
          } );
         
        end;

      end;
      cmn.AddSubscriber( "win_paper_piece", win_paper_piece_inv );
      cmn.AddSubscriber( "win_paper_piece", win_paper_piece, "inv_paper_piece" );  
      
  end;

  -- USE ------------------------------------------------------------------------------------------
  function public.use_scheme_piece()
  
    local item = "inv_scheme_piece";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_paper_piece_use_scheme_piece", "deploy_inv_paper_piece" ) ) then
  
      cmn.CallEventHandler( "use_scheme_piece_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_scheme_piece" );
        cmn.CallEventHandler( "use_scheme_piece_end", "inv_paper_piece" );
        
        cmn.MiniGameShow( "paper_piece" );
        common_impl.PassingMgStart( "paper_piece" );
        
      end;
  
      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","aud_clk_paper" );

      for i = 1, private.PAPER_PIECE_PART_COUNT, 1 do
        
        local curPart = private.PAPER_PIECE_PART_NAME..i;
        local trgAfter = "";
        
        if i == private.PAPER_PIECE_PART_COUNT - 1 then
          
          trgAfter = func_end;
        
        end;
          
        if ( i ~= 7 ) then
          
          ObjSet( curPart, { alp = 0, visible = true } );
          ObjAnimate( curPart, "alp",0,0, trgAfter, { 0, 0, 0,    0.6, 0, 1 } );
          
        end;
      
      end;

      return true;
  
    end;
  
    return false;
    
  end;

  -- USE ------------------------------------------------------------------------------------------
  function public.use_adhesive_bandage_2()

    local item = "inv_adhesive_bandage";
  
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_paper_piece_use_adhesive_bandage_2", "deploy_inv_paper_piece" ) and 
    cmn.IsEventDone( "win_paper_piece" ) ) then
  
      cmn.CallEventHandler( "use_adhesive_bandage_2_beg" );
  
      local func_end = function ()
  
        cmn.Lock( false );
        cmn.SetEventDone( "use_adhesive_bandage_2" );
        cmn.CallEventHandler( "use_adhesive_bandage_2_end", "inv_paper_piece" );
      
      end;
  
      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","levelext/sfx/aud_use_tape2_4lvl" );

      ObjSet( "spr_deploy_inv_paper_piece_patch", { alp = 0, visible = true } );
      ObjAnimate( "spr_deploy_inv_paper_piece_patch", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );

      return true;
  
    end;
  
    return false;
    
  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_dungeon ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_dungeon" );
    cmn.CallEventHandler( "get_dungeon", "inv_paper_piece" );
    common_impl.HideDeployInv();

  end;
  
  --********************************************************
  function private.paper_piece_define ()

    int_deploy_inv.Define( "paper_piece" ); 
    --------------------------------------------------------
    function paper_piece.PreOpen ()
      
      if ( cmn.IsEventStart( "win_paper_piece" ) and not cmn.IsEventDone( "win_paper_piece" ) ) then

        cmn.MiniGameShow( "paper_piece" );
        common_impl.PassingMgStart( "paper_piece" );

      end;
      
      private.PaperPieceLoad();
      private.PaperPieceUpdate(); 
      
    end;
    --------------------------------------------------------
    function paper_piece.Open ()

    end;
    --------------------------------------------------------
    function paper_piece.PreClose ()
      
      if ( cmn.IsEventStart( "win_paper_piece" ) and not cmn.IsEventDone( "win_paper_piece" ) ) then

        cmn.MiniGameHide( "paper_piece" );
        common_impl.PassingMgStop( "paper_piece" );

      end;
      
    end;
    --------------------------------------------------------
    function paper_piece.Close ()

    end;
    --------------------------------------------------------
    function paper_piece.Reset ()
      
      private.PaperPieceDefault();
      private.PaperPieceLoad();
      private.PaperPieceUpdate(); 
      
    end;
    --------------------------------------------------------
    function paper_piece.Skip ()
      
      for i = 1, private.PAPER_PIECE_PART_COUNT, 1 do
        
        local curPointObject = private.PAPER_PIECE_POINT_NAME..i;
        private.gamedata_paper_piece.position[ i ].pos_x = ObjGet( curPointObject ).pos_x;
        private.gamedata_paper_piece.position[ i ].pos_y = ObjGet( curPointObject ).pos_y;
        
      end;
    
      private.PaperPieceLoad();
      private.PaperPieceUpdate(); 
      
    end;

  end;
 
--*********************************************************************************************************************
-- function *** MMG PAPER_PIECE *** () end;
--*********************************************************************************************************************

  private.gamedata_paper_piece = {};
  
  private.PAPER_PIECE_PART_NAME = "spr_deploy_inv_paper_piece_piece_";
  private.PAPER_PIECE_POINT_NAME = "obj_deploy_inv_paper_piece_point_";
  
  private.PAPER_PIECE_PART_COUNT = 7;
  private.PAPER_PIECE_DELTA = 100;
  
  private.PAPER_PIECE_BORDER_LEFT = -665;
  private.PAPER_PIECE_BORDER_RIGHT = 659;
  private.PAPER_PIECE_BORDER_TOP = -303;
  private.PAPER_PIECE_BORDER_BOTTOM = 350;
  
  
--*******************************************************************************************************************
  function private.PaperPieceDefault ()

    ng_global.progress[ "ext" ][ "win_paper_piece" ].position = { 
                                                                  { pos_x = 291, pos_y = 227 },
                                                                  { pos_x = -49, pos_y = -166 },
                                                                  { pos_x = -374, pos_y = -164 },
                                                                  { pos_x = 208, pos_y = -245 },
                                                                  { pos_x = -366, pos_y = 230 },
                                                                  { pos_x = 6, pos_y = 240 },
                                                                  { pos_x = 187, pos_y = 121 }
                                                                }; 

  end; 
  

  --*******************************************************************************************************************
  function private.PaperPieceLoad ()

    if ( not ng_global.progress[ "ext" ][ "win_paper_piece" ].position ) then 

      private.PaperPieceDefault();

    end; 

    private.gamedata_paper_piece = ng_global.progress[ "ext" ][ "win_paper_piece" ];

  end;
 
  
  --*******************************************************************************************************************
  function private.PaperPieceLogicInit () 
    
    for i = 1, private.PAPER_PIECE_PART_COUNT, 1 do
      
      local curPart = private.PAPER_PIECE_PART_NAME..i;
      ObjSet( curPart, { 
                          input = true,
                          drag = true,
                          event_startdrag = function () private.PaperPieceStartDrag( i ); end,
                          event_dragdrop = function () private.PaperPieceEndDrag( i ); end,
                          event_menter = function () private.PaperPieceEnter( curPart ); end,
                          event_mleave = function () private.PaperPieceLeave( curPart ); end
                       } );       
      
    end;
    
  end;
  
    
  --*******************************************************************************************************************
  function private.PaperPieceEnter ( nameFocus )
   
    SetCursor( CURSOR_HAND );
    
    local current = nameFocus.."_focus";
    local alpha = ObjGet( current ).alp;
    ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );
    
  end;


  --*******************************************************************************************************************
  function private.PaperPieceLeave ( nameFocus )  

    SetCursor( CURSOR_DEFAULT );
    
    local current = nameFocus.."_focus";
    local alpha = ObjGet( current ).alp;
    ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );
    
  end;
    
    
  --*******************************************************************************************************************
  function private.PaperPieceStartDrag ( partID )  
    
    local curPart = private.PAPER_PIECE_PART_NAME..partID;
    ObjSet( curPart, { pos_z = 10 } );
    
  end;


  --*******************************************************************************************************************
  function private.PaperPieceEndDrag ( partID )  
    
    local curPart = private.PAPER_PIECE_PART_NAME..partID;
    ObjSet( curPart, { pos_z = 0 } );
    
    local cursor = GetZoomCursorPos();
    local cursorX = cursor[ 1 ] - 512;
    local cursorY = cursor[ 2 ] - 384;
    
    if ( cursorX > private.PAPER_PIECE_BORDER_LEFT and cursorX < private.PAPER_PIECE_BORDER_RIGHT and
    cursorY > private.PAPER_PIECE_BORDER_TOP and cursorY < private.PAPER_PIECE_BORDER_BOTTOM ) then
    
    common_impl.PlayAudio( "sfx","level1/sfx/aud_xx_clk_paper1" );

    local crossingPoint = private.IsCrossingExists( cursorX, cursorY );
      
      if ( crossingPoint ) then
        
        local curPointObject = private.PAPER_PIECE_POINT_NAME..crossingPoint;
        
        private.gamedata_paper_piece.position[ partID ].pos_x = ObjGet( curPointObject ).pos_x;
        private.gamedata_paper_piece.position[ partID ].pos_y = ObjGet( curPointObject ).pos_y;
        
      else 
        
        private.gamedata_paper_piece.position[ partID ].pos_x = cursorX;
        private.gamedata_paper_piece.position[ partID ].pos_y = cursorY;
        
      end;
    
    end;
    
    private.PaperPieceUpdate(); 
  
  end;

  --*******************************************************************************************************************
  function private.IsCrossingExists ( curPartX, curPartY )  
    
    local crossingPoint = nil;
    
    for i = 1, private.PAPER_PIECE_PART_COUNT, 1 do
      
      local curPointObject = private.PAPER_PIECE_POINT_NAME..i;
      local curPointX = ObjGet( curPointObject ).pos_x;
      local curPointY = ObjGet( curPointObject ).pos_y;
      
      if ( math.abs( curPointX - curPartX ) <= private.PAPER_PIECE_DELTA and 
      math.abs( curPointY - curPartY ) <= private.PAPER_PIECE_DELTA ) then
      
        crossingPoint = i;
        return crossingPoint;
        
      end;
      
    end;
    
    return crossingPoint;
    
  end;

  
  --*******************************************************************************************************************
  function private.PaperPieceUpdate () 
    
    for i = 1, private.PAPER_PIECE_PART_COUNT, 1 do
      
      local curPart = private.PAPER_PIECE_PART_NAME..i;
      local curPartX = private.gamedata_paper_piece.position[ i ].pos_x;
      local curPartY = private.gamedata_paper_piece.position[ i ].pos_y;
      
      ObjSet( curPart, { pos_x = curPartX, pos_y = curPartY } );
    
    end;
    
    if ( private.PaperPieceCheckWin() and
    not cmn.IsEventDone( "win_paper_piece" ) ) then
      
      private.PaperPieceWin(); 
      
    end;
    
  end;

  
  --*******************************************************************************************************************
  function private.PaperPieceCheckWin () 
    
    local result = false;
    local count = 0;
  
    for i = 1, private.PAPER_PIECE_PART_COUNT, 1 do

      local curPartX = private.gamedata_paper_piece.position[ i ].pos_x;
      local curPartY = private.gamedata_paper_piece.position[ i ].pos_y;
      
      local curPointObject = private.PAPER_PIECE_POINT_NAME..i;    
      local curPointObjectX = ObjGet( curPointObject ).pos_x;
      local curPointObjectY = ObjGet( curPointObject ).pos_y;
    
      if ( curPartX == curPointObjectX and curPartY == curPointObjectY ) then
        
        count = count + 1;
        
      end;
      
    end;
    
    if ( count == private.PAPER_PIECE_PART_COUNT ) then
      
      result = true;
      
    end;
    
    return result; 
    
  end;

  
  --*******************************************************************************************************************
  function private.PaperPieceWin () 
    
    local func_end = function()

      cmn.SetEventDone( "win_paper_piece" );
      cmn.CallEventHandler( "win_paper_piece", "inv_paper_piece" );

      cmn.Lock( false );
      common_impl.PassingMgWin( "paper_piece" );
      
    end; 
    
    ObjSet( "obj_deploy_inv_paper_piece_pieces", { input = false } );
    
    --common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_gate", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "aud_win_mg" );
    
    cmn.MiniGameHide( "paper_piece" );
    cmn.Lock( true );
    
    for i = 1, private.PAPER_PIECE_PART_COUNT, 1 do
      
      local trgAfter = "";
      
      if i == private.PAPER_PIECE_PART_COUNT then
        
        trgAfter = func_end;
        
      end;
      
    local curPartLight = private.PAPER_PIECE_PART_NAME..i.."_focus";
    ObjAnimate( curPartLight, "alp",0,0, trgAfter, { 0, 3, 0,    0.6, 3, 1,    1.0, 3, 0,    1.5, 3, 1,    2.6, 3, 0 } );
      
    end;
    
  end;

  
--*********************************************************************************************************************
-- function *** box_lvl4 *** () end;
--*********************************************************************************************************************
  function private.init_box_lvl4()

    ObjMultiSet( { 
      { "obj_deploy_inv_box_lvl4_clk_2", { event_mdown = private.get_lit_match  } },
      { "obj_deploy_inv_box_lvl4_clk",   { event_mdown = private.clk_match  } },
    } );
  
    --------------------------------------------------------------------------------------------
    -- function get_lit_match () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_lit_match" ] = {
        type = "get",
        get_obj = "obj_deploy_inv_box_lvl4_clk_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_box_lvl4",
        zz_gate = "inv_box_lvl4"
      };
      local get_lit_match_inv = function ()

        interface.InventoryItemRemove( "inv_box_lvl4" );
        interface.InventoryItemAdd( "inv_lit_match", "vid_deploy_inv_box_lvl4_match" );

      end;
      local get_lit_match = function ()

        ObjDelete( "gfx_deploy_inv_box_lvl4_lit_match" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_lit_match", get_lit_match_inv );
      cmn.AddSubscriber( "get_lit_match", get_lit_match, "inv_box_lvl4" );
    --------------------------------------------------------------------------------------------
    -- function clk_match () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_match" ] = {
        type = "click",
        use_place = "obj_deploy_inv_box_lvl4_clk",
        room = "int_deploy_inv",
        zz = "deploy_inv_box_lvl4",
        zz_gate = "inv_box_lvl4"
      };
      local clk_match = function ()

        ObjDelete( "vid_deploy_inv_box_lvl4_open_matchbox" );
        ObjSet( "vid_deploy_inv_box_lvl4_match", {   alp = 1    } );
        ObjSet( "obj_deploy_inv_box_lvl4_clk_2", { input = true } );     
        
      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_match", clk_match, "inv_box_lvl4" );      
   
  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_lit_match ()
    
    local func_end = function()
    
      cmn.Lock( false );    
      common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
      cmn.SetEventDone( "get_lit_match" );
      cmn.CallEventHandler( "get_lit_match", "inv_box_lvl4" );
      common_impl.HideDeployInv();
      
    end;
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_clk_matchbox_4lvl" );
    ObjDelete( "gfx_deploy_inv_box_lvl4_lit_match" );
    VidPlay( "vid_deploy_inv_box_lvl4_match", func_end );

  end;
  -- CLK ------------------------------------------------------------------------------------------

  function private.clk_match ()
    local func_end = function()
    
      cmn.Lock( false );
      cmn.SetEventDone( "clk_match" );
      cmn.CallEventHandler( "clk_match", "inv_box_lvl4" );
      
    end;
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_opn_matchbox_4lvl" );
    VidPlay( "vid_deploy_inv_box_lvl4_open_matchbox", func_end );

  end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** double_gun *** () end;
--*********************************************************************************************************************
  function private.init_double_gun()

    ObjMultiSet( { 
      { "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo",      { event_mdown = private.clk_double_gun_1  } },
      { "spr_deploy_inv_double_gun_butt",      { event_mdown = private.clk_double_gun_1  } },
      { "spr_deploy_inv_double_gun_patron1",      { event_mdown = private.clk_double_gun_2  } },
      { "spr_deploy_inv_double_gun_patron2",      { event_mdown = private.clk_double_gun_3  } },
    } );
  
    --------------------------------------------------------------------------------------------
    -- function get_twin_gun_with_blank_ammo () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_twin_gun_with_blank_ammo" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo",
        room = "int_deploy_inv",
        zz = "deploy_inv_double_gun",
        zz_gate = "inv_double_gun"
      };
      local get_twin_gun_with_blank_ammo_inv = function ()

        interface.InventoryItemRemove( "inv_double_gun" );
        interface.InventoryItemAdd( "inv_twin_gun_with_blank_ammo", "obj_deploy_inv_double_gun_twin_gun_with_blank_ammo" );

      end;
      local get_twin_gun_with_blank_ammo = function ()

        ObjDelete( "gfx_deploy_inv_double_gun_twin_gun_with_blank_ammo" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_twin_gun_with_blank_ammo", get_twin_gun_with_blank_ammo_inv );
      cmn.AddSubscriber( "get_twin_gun_with_blank_ammo", get_twin_gun_with_blank_ammo, "inv_double_gun" );
      --------------------------------------------------------------------------------------------
    -- function clk_double_gun_1 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_double_gun_1" ] = {
        type = "click",
        use_place = "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo",
        room = "int_deploy_inv",
        zz = "deploy_inv_double_gun",
        zz_gate = "inv_double_gun"
      };
      local clk_double_gun_1 = function ()
        
        ObjMultiSet( {
          { "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo", 
            { 
              ang = -0.71, 
              event_mdown = "", 
              event_menter = "", 
              event_mleave = "" 
            } },
          { "spr_deploy_inv_double_gun_butt", { pos_z = -1, input = false } },
          { "spr_deploy_inv_double_gun_patron1", { input = true } },
          { "spr_deploy_inv_double_gun_patron2", { input = true } },
          { "spr_deploy_inv_double_gun_patrons_over", { input = true } }
        } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_double_gun_1", clk_double_gun_1, "inv_double_gun" );
      --------------------------------------------------------------------------------------------
    -- function clk_double_gun_2 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_double_gun_2" ] = {
        type = "click",
        use_place = "spr_deploy_inv_double_gun_patron1",
        room = "int_deploy_inv",
        zz = "deploy_inv_double_gun",
        zz_gate = "inv_double_gun"
      };
      local clk_double_gun_2 = function ()

        ObjSet( "spr_deploy_inv_double_gun_patron1", 
        {
          pos_x = 26, pos_y = 203,
          ang = 0.86,
          scale_x = 1, scale_y = 1,
          event_mdown = private.clk_double_gun_4
        } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_double_gun_2", clk_double_gun_2, "inv_double_gun" );
      --------------------------------------------------------------------------------------------
    -- function clk_double_gun_3 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_double_gun_3" ] = {
        type = "click",
        use_place = "spr_deploy_inv_double_gun_patron2",
        room = "int_deploy_inv",
        zz = "deploy_inv_double_gun",
        zz_gate = "inv_double_gun"
      };
      local clk_double_gun_3 = function ()

        ObjSet( "spr_deploy_inv_double_gun_patron2", 
        {
          pos_x = 98, pos_y = 178,
          ang = 0.3,
          scale_x = 1, scale_y = 1,
          event_mdown = private.clk_double_gun_5
        } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_double_gun_3", clk_double_gun_3, "inv_double_gun" );
      --------------------------------------------------------------------------------------------
    -- function clk_double_gun_4 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_double_gun_4" ] = {
        type = "click",
        use_place = "spr_deploy_inv_double_gun_patron1",
        room = "int_deploy_inv",
        zz = "deploy_inv_double_gun",
        zz_gate = "inv_double_gun"
      };
      local clk_double_gun_4 = function ()

        ObjSet( "spr_deploy_inv_double_gun_patron1", 
        {
          ang = -2.12,
          event_mdown = private.clk_double_gun_6
        } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_double_gun_4", clk_double_gun_4, "inv_double_gun" );
      --------------------------------------------------------------------------------------------
    -- function clk_double_gun_5 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_double_gun_5" ] = {
        type = "click",
        use_place = "spr_deploy_inv_double_gun_patron2",
        room = "int_deploy_inv",
        zz = "deploy_inv_double_gun",
        zz_gate = "inv_double_gun"
      };
      local clk_double_gun_5 = function ()

        ObjSet( "spr_deploy_inv_double_gun_patron2", 
        {
          ang = -1.86,
          event_mdown = private.clk_double_gun_7
        } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_double_gun_5", clk_double_gun_5, "inv_double_gun" );
      --------------------------------------------------------------------------------------------
    -- function clk_double_gun_6 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_double_gun_6" ] = {
        type = "click",
        use_place = "spr_deploy_inv_double_gun_patron1",
        room = "int_deploy_inv",
        zz = "deploy_inv_double_gun",
        zz_gate = "inv_double_gun"
      };
      local clk_double_gun_6 = function ()

        ObjSet( "spr_deploy_inv_double_gun_patron1", 
        {
          pos_x = -31, pos_y = -16,
          ang = -1.16,
          scale_x = 0.7, scale_y = 0.7,
          input = false
        } );
        if ( cmn.IsEventDone( "clk_double_gun_7" ) ) then
          
          ObjSet( "spr_deploy_inv_double_gun_butt", 
          { 
            event_mdown = private.clk_double_gun_8, 
            input = true, 
            pos_z = 1
          } );
          ObjSet( "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo", 
          { 
            event_mdown = private.clk_double_gun_8, 
            event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
            event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
          } );
            ObjSet( "spr_deploy_inv_double_gun_patrons_over", { input = false } );
            
        end;

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_double_gun_6", clk_double_gun_6, "inv_double_gun" );
      --------------------------------------------------------------------------------------------
    -- function clk_double_gun_7 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_double_gun_7" ] = {
        type = "click",
        use_place = "spr_deploy_inv_double_gun_patron2",
        room = "int_deploy_inv",
        zz = "deploy_inv_double_gun",
        zz_gate = "inv_double_gun"
      };
      local clk_double_gun_7 = function ()

        ObjSet( "spr_deploy_inv_double_gun_patron2", 
        {
          pos_x = -23, pos_y = -17,
          ang = -1.16,
          scale_x = 0.7, scale_y = 0.7,
          input = false
        } );
        if ( cmn.IsEventDone( "clk_double_gun_6" ) ) then
          
          ObjSet( "spr_deploy_inv_double_gun_butt", 
          { 
            event_mdown = private.clk_double_gun_8, 
            input = true, 
            pos_z = 1
          } );
          ObjSet( "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo", 
          { 
            event_mdown = private.clk_double_gun_8, 
            event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
            event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
          } );
          ObjSet( "spr_deploy_inv_double_gun_patrons_over", { input = false } );
            
        end;

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_double_gun_7", clk_double_gun_7, "inv_double_gun" );
      --------------------------------------------------------------------------------------------
    -- function clk_double_gun_8 () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "clk_double_gun_8" ] = {
        type = "click",
        use_place = "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo",
        room = "int_deploy_inv",
        zz = "deploy_inv_double_gun",
        zz_gate = "inv_double_gun"
      };
      local clk_double_gun_8 = function ()

        ObjSet( "gfx_deploy_inv_double_gun_twin_gun_with_blank_ammo", { active = true } );
        ObjSet( "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo", 
        { 
          ang = 0, 
          event_mdown = private.get_twin_gun_with_blank_ammo,
          event_menter = function() common_impl.SetCursor( CURSOR_GET ) end, 
        } );
        ObjSet( "spr_deploy_inv_double_gun_butt", 
        { 
          event_mdown = private.get_twin_gun_with_blank_ammo,
          event_menter = function() common_impl.SetCursor( CURSOR_GET ) end, 
        } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_double_gun_8", clk_double_gun_8, "inv_double_gun" );
   
  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_twin_gun_with_blank_ammo ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_twin_gun_with_blank_ammo" );
    cmn.CallEventHandler( "get_twin_gun_with_blank_ammo", "inv_double_gun" );
    common_impl.HideDeployInv();

  end;
  -- Clk ------------------------------------------------------------------------------------------
  function private.clk_double_gun_1 ()

    local func_end = function()
    
      cmn.SetEventDone( "clk_double_gun_1" );
      cmn.CallEventHandler( "clk_double_gun_1", "inv_double_gun" );
      cmn.Lock( false );
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_weapon1_4lvl" );
    ObjAnimate( "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo", "ang", 0, 0, func_end, 
   {
     0.0, 0, 0,
     0.3, 0, -0.71
   } );

  end;
   -- Clk ------------------------------------------------------------------------------------------
   function private.clk_double_gun_2 ()

    local func_end = function()
    
      cmn.SetEventDone( "clk_double_gun_2" );
      cmn.CallEventHandler( "clk_double_gun_2", "inv_double_gun" );
      cmn.Lock( false );
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_weapon2_4lvl" );
    local params = ObjGet( "spr_deploy_inv_double_gun_patron1" );
    ObjAnimate( "spr_deploy_inv_double_gun_patron1", "ang", 0, 0, func_end, 
   {
     0.0, 0, params.ang,
     0.4, 0, params.ang,
     0.8, 0, 0.86,
   } );
   
    ObjAnimate( "spr_deploy_inv_double_gun_patron1", "pos_xy", 0, 0, "", 
   {
     0.0, 0, params.pos_x, params.pos_y,
     0.4, 0, -229, 31,
     0.8, 0, 26, 203,
   } );
   
    ObjAnimate( "spr_deploy_inv_double_gun_patron1", "scale_xy", 0, 0, "", 
   {
     0.0, 0, 0.7, 0.7,
     0.4, 0, 0.7, 0.7,
     0.8, 0, 1.0, 1.0,
   } );

  end;
   -- Clk ------------------------------------------------------------------------------------------
   function private.clk_double_gun_3 ()

    local func_end = function()
    
      cmn.SetEventDone( "clk_double_gun_3" );
      cmn.CallEventHandler( "clk_double_gun_3", "inv_double_gun" );
      cmn.Lock( false );
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_weapon2_4lvl" );
    local params = ObjGet( "spr_deploy_inv_double_gun_patron2" );
    ObjAnimate( "spr_deploy_inv_double_gun_patron2", "ang", 0, 0, func_end, 
   {
     0.0, 0, params.ang,
     0.4, 0, params.ang,
     0.8, 0, 0.3,
   } );
   
    ObjAnimate( "spr_deploy_inv_double_gun_patron2", "pos_xy", 0, 0, "", 
   {
     0.0, 0, params.pos_x, params.pos_y,
     0.4, 0, -206, 33,
     0.8, 0, 98, 178,
   } );
   
   ObjAnimate( "spr_deploy_inv_double_gun_patron2", "scale_xy", 0, 0, "", 
   {
     0.0, 0, 0.7, 0.7,
     0.4, 0, 0.7, 0.7,
     0.8, 0, 1.0, 1.0,
   } );

  end;
   -- Clk ------------------------------------------------------------------------------------------
   function private.clk_double_gun_4 ()

    local func_end = function()
    
      cmn.SetEventDone( "clk_double_gun_4" );
      cmn.CallEventHandler( "clk_double_gun_4", "inv_double_gun" );
      cmn.Lock( false );
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_weapon3_4lvl" );
    local params = ObjGet( "spr_deploy_inv_double_gun_patron1" );
    ObjAnimate( "obj_deploy_inv_double_gun_bullets1", "alp", 0, 0, func_end, 
   {
     0.0, 0, 0,
     0.6, 0, 0,
     0.8, 3, 1,
     1.0, 3, 0,
   } );
   
   ObjAnimate( "spr_deploy_inv_double_gun_patron1", "ang", 0, 0, func_end, 
   {
     0.0, 0, params.ang,
     0.4, 3, -2.12
   } );
   
   ObjAnimate( "spr_deploy_inv_double_gun_patron1", "pos_xy", 0, 0, "", 
   {
     0.0, 0, params.pos_x, params.pos_y,
     0.4, 0, params.pos_x, params.pos_y,
     0.6, 3, 10, 182,
     0.8, 3, params.pos_x, params.pos_y,
   } );

  end;
   -- Clk ------------------------------------------------------------------------------------------
   function private.clk_double_gun_5 ()

    local func_end = function()
    
      cmn.SetEventDone( "clk_double_gun_5" );
      cmn.CallEventHandler( "clk_double_gun_5", "inv_double_gun" );
      cmn.Lock( false );
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_weapon3_4lvl" );
    local params = ObjGet( "spr_deploy_inv_double_gun_patron2" );
    ObjAnimate( "obj_deploy_inv_double_gun_bullets2", "alp", 0, 0, func_end, 
   {
     0.0, 0, 0,
     0.6, 0, 0,
     0.8, 3, 1,
     1.0, 3, 0,
   } );
   
   ObjAnimate( "spr_deploy_inv_double_gun_patron2", "ang", 0, 0, func_end, 
   {
     0.0, 0, params.ang,
     0.4, 3, -1.86
   } );
   
   ObjAnimate( "spr_deploy_inv_double_gun_patron2", "pos_xy", 0, 0, "", 
   {
     0.0, 0, params.pos_x, params.pos_y,
     0.4, 0, params.pos_x, params.pos_y,
     0.6, 3, 84, 173,
     0.8, 3, params.pos_x, params.pos_y,
   } );

  end;
   -- Clk ------------------------------------------------------------------------------------------
   function private.clk_double_gun_6 ()

    local func_end = function()
    
      cmn.SetEventDone( "clk_double_gun_6" );
      cmn.CallEventHandler( "clk_double_gun_6", "inv_double_gun" );
      cmn.Lock( false );
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_weapon4_4lvl" );
    local params = ObjGet( "spr_deploy_inv_double_gun_patron1" );
    ObjAnimate( "spr_deploy_inv_double_gun_patron1", "ang", 0, 0, "", 
   {
     0.0, 0, params.ang,
     0.4, 0, -1.16
   } );
   
    ObjAnimate( "spr_deploy_inv_double_gun_patron1", "pos_xy", 0, 0, func_end, 
   {
     0.0, 0, params.pos_x, params.pos_y,
     0.4, 0, -229, 31,
     0.8, 0, -31, -16,
   } );
   
    ObjAnimate( "spr_deploy_inv_double_gun_patron1", "scale_xy", 0, 0, "", 
   {
     0.0, 0, 1.0, 1.0,
     0.4, 0, 0.7, 0.7
   } );

  end;
   -- Clk ------------------------------------------------------------------------------------------
   function private.clk_double_gun_7 ()

    local func_end = function()
    
      cmn.SetEventDone( "clk_double_gun_7" );
      cmn.CallEventHandler( "clk_double_gun_7", "inv_double_gun" );
      cmn.Lock( false );
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_weapon4_4lvl" );
    local params = ObjGet( "spr_deploy_inv_double_gun_patron2" );
    ObjAnimate( "spr_deploy_inv_double_gun_patron2", "ang", 0, 0, "", 
   {
     0.0, 0, params.ang,
     0.4, 0, -1.16
   } );
   
    ObjAnimate( "spr_deploy_inv_double_gun_patron2", "pos_xy", 0, 0, func_end, 
   {
     0.0, 0, params.pos_x, params.pos_y,
     0.4, 0, -206, 33,
     0.8, 0, -23, -17,
   } );
   
    ObjAnimate( "spr_deploy_inv_double_gun_patron2", "scale_xy", 0, 0, "", 
   {
     0.0, 0, 1.0, 1.0,
     0.4, 0, 0.7, 0.7
   } );

  end;
   -- Clk ------------------------------------------------------------------------------------------
   function private.clk_double_gun_8 ()

    local func_end = function()
    
      cmn.SetEventDone( "clk_double_gun_8" );
      cmn.CallEventHandler( "clk_double_gun_8", "inv_double_gun" );
      cmn.Lock( false );
      
    end;
    
    cmn.Lock( true );
    common_impl.PlayAudio( "sfx","levelext/sfx/aud_weapon5_4lvl" );
    ObjAnimate( "spr_deploy_inv_double_gun_twin_gun_with_blank_ammo", "ang", 0, 0, func_end, 
   {
     0.0, 0, -0.71,
     0.3, 0, 0
   } );

  end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** sara_locket *** () end;
--*********************************************************************************************************************
  function private.init_sara_locket()

    ObjMultiSet( { 
      { "spr_deploy_inv_sara_locket_sara_medallion",      { event_mdown = private.get_sara_medallion  } },
      { "spr_deploy_inv_sara_locket_close",      { event_mdown = private.clk_sara_locket  } },
      { "spr_deploy_inv_sara_locket_photo",      { event_mdown = private.clk_sara_photo  } },
    } );
  
    --------------------------------------------------------------------------------------------
    -- function get_sara_medallion () end;
    --------------------------------------------------------------------------------------------
      common_impl.hint[ "get_sara_medallion" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_sara_locket_sara_medallion",
        room = "int_deploy_inv",
        zz = "deploy_inv_sara_locket",
        zz_gate = "inv_sara_locket"
      };
      local get_sara_medallion_inv = function ()

        interface.InventoryItemRemove( "inv_sara_locket" );
        interface.InventoryItemAdd( "inv_sara_medallion", "spr_deploy_inv_sara_locket_sara_medallion" );

      end;
      local get_sara_medallion = function ()

        ObjDelete( "gfx_deploy_inv_sara_locket_sara_medallion" );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "get_sara_medallion", get_sara_medallion_inv );
      cmn.AddSubscriber( "get_sara_medallion", get_sara_medallion, "inv_sara_locket" );
    --------------------------------------------------------------------------------------------
    -- function clk_sara_locket () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_sara_locket" ] = {
        type = "click",
        use_place = "spr_deploy_inv_sara_locket_close",
        room = "int_deploy_inv",
        zz = "deploy_inv_sara_locket",
        zz_gate = "inv_sara_locket"
      };
      local clk_sara_locket = function ()

        ObjDelete( "spr_deploy_inv_sara_locket_close" );
        ObjSet( "spr_deploy_inv_sara_locket_open", { alp = 1 } );
        ObjSet( "spr_deploy_inv_sara_locket_photo", { input = true } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_sara_locket", clk_sara_locket, "inv_sara_locket" ); 
    --------------------------------------------------------------------------------------------
    -- function clk_sara_photo () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_sara_photo" ] = {
        type = "click",
        use_place = "spr_deploy_inv_sara_locket_photo",
        room = "int_deploy_inv",
        zz = "deploy_inv_sara_locket",
        zz_gate = "inv_sara_locket"
      };
      local clk_sara_photo = function ()

        ObjDelete( "spr_deploy_inv_sara_locket_photo" );
        ObjSet( "spr_deploy_inv_sara_locket_sara_medallion", { input = true } );

      end;
      --------------------------------------------------------------------------------------------
      cmn.AddSubscriber( "clk_sara_photo", clk_sara_photo, "inv_sara_locket" );       
   
  end;

  -- GET ------------------------------------------------------------------------------------------
  function private.get_sara_medallion ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_sara_medallion" );
    cmn.CallEventHandler( "get_sara_medallion", "inv_sara_locket" );
    common_impl.HideDeployInv();

  end;
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_sara_locket ()

    local func_end = function()  
    
      cmn.SetEventDone( "clk_sara_locket" );
      cmn.CallEventHandler( "clk_sara_locket", "inv_sara_locket" );
      cmn.Lock( false );
      
    end;
    cmn.Lock( true );

    common_impl.PlayAudio( "sfx","levelext/sfx/aud_opn_pendant_4lvl" );
    ObjAnimate( "spr_deploy_inv_sara_locket_close", "alp", 0, 0, func_end, 
    {
      0.0, 0, 1,
      0.3, 0, 0
    } );
    ObjAnimate( "spr_deploy_inv_sara_locket_open", "alp", 0, 0, "", 
    {
      0.0, 0, 0,
      0.3, 0, 1
    } );
  end;  
  -- CLK ------------------------------------------------------------------------------------------
  function private.clk_sara_photo ()

    local func_end = function()  
    
      cmn.SetEventDone( "clk_sara_photo" );
      cmn.CallEventHandler( "clk_sara_photo", "inv_sara_locket" );
      cmn.Lock( false );
      
    end;
    cmn.Lock( true );

    common_impl.PlayAudio( "sfx","level1/sfx/aud_xx_clk_paper1" );
    ObjAnimate( "spr_deploy_inv_sara_locket_photo", "alp", 0, 0, func_end, 
    {
      0.0, 0, 1,
      0.3, 0, 0
    } );
    
  end;   
--*********************************************************************************************************************