-- name=rm_backyard
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_backyard";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_driver_seat",   "room_hub" );
  ObjAttach( "zz_telephone_box", "room_hub" );
  ObjAttach( "zz_backdoor",      "room_hub" );
  ObjAttach( "zz_roof",          "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_driver_seat_honk",                      { event_mdown = private.get_honk                   }},
    { "spr_driver_seat_enema",                     { event_mdown = private.get_honk                   }},
    { "spr_driver_seat_patch_2",                   { event_mdown = private.get_honk                   }},
    { "spr_driver_seat_stone_lvl4",                { event_mdown = private.get_stone_lvl4             }},
    { "spr_driver_seat_box_wrench",                { event_mdown = private.get_box_wrench             }},
    { "spr_driver_seat_decor_part_3",              { event_mdown = private.get_decor_part_3           }},
    { "obj_driver_seat_use_screwdriver_lvl4",      { event_mdown = private.AnimUseScrewdriverLvl4     }},
    { "obj_driver_seat_use_sprinkler",             { event_mdown = private.AnimUseSprinkler           }},
    { "obj_driver_seat_use_glove_compartment_key", { event_mdown = private.AnimUseGloveCompartmentKey }},
    { "obj_driver_seat_use_armchair_lever",        { event_mdown = private.AnimUseArmchairLever       }},

    { "spr_telephone_box_recipe",                  { event_mdown = private.get_recipe                 }},
    { "spr_telephone_box_recipe1",                 { event_mdown = private.ScalePaper                 }},
    { "spr_telephone_box_recipe2",                 { event_mdown = private.TurnPaper                  }},
    { "spr_telephone_box_cross_1_lvl4",            { event_mdown = private.get_cross_1_lvl4           }},
    { "obj_telephone_box_clk_chain_lvl4_1",        { event_mdown = private.clk_chain_lvl4_1           }},
    { "obj_telephone_box_clk_chain_lvl4_2",        { event_mdown = private.clk_chain_lvl4_2           }},
    { "obj_telephone_box_clk_chain_lvl4_3",        { event_mdown = private.clk_chain_lvl4_3           }},
    { "obj_telephone_box_clk_alarm_double_key",    { event_mdown = private.clk_alarm_double_key       }},
    { "obj_telephone_box_use_chain_lvl4",          { event_mdown = private.AnimUseChainLvl4           }},

    { "spr_backdoor_sal_ammoniac",                 { event_mdown = private.get_sal_ammoniac           }},
    { "spr_backdoor_sprinkler",                    { event_mdown = private.get_sprinkler              }},
    { "spr_backdoor_screwdriver_lvl4",             { event_mdown = private.get_screwdriver_lvl4       }},
    { "spr_backdoor_screwdriver_2",                { event_mdown = private.get_screwdriver_lvl4       }},
    { "spr_backdoor_gargoyle_statuette",           { event_mdown = private.get_gargoyle_statuette     }},
    { "spr_backdoor_scalpel",                      { event_mdown = private.get_scalpel                }},
    { "obj_backdoor_use_plate",                    { event_mdown = private.AnimUsePlate               }},
    { "obj_backdoor_use_wooden_handle",            { event_mdown = private.AnimUseWoodenHandle        }},
    { "obj_backdoor_use_cross_1_lvl4",             { event_mdown = function() private.AnimUseCross(1) end; }},
    { "obj_backdoor_use_cross_2_lvl4",             { event_mdown = function() private.AnimUseCross(2) end; }},
    { "obj_backdoor_use_cross_3_lvl4",             { event_mdown = function() private.AnimUseCross(3) end; }},

    { "spr_roof_rake",                             { event_mdown = private.get_rake                   }},
    { "spr_roof_scheme_piece_6",                   { event_mdown = private.get_scheme_piece_6         }},
    { "spr_roof_plate",                            { event_mdown = private.get_plate                  }},
    { "obj_roof_use_planks",                       { event_mdown = private.AnimUsePlanks              }},
    { "obj_roof_use_round_key",                    { event_mdown = private.AnimUseRoundKey            }},
    { "obj_roof_use_letter_lvl4",                  { event_mdown = private.AnimUseLetterLvl4          }},
    { "obj_roof_use_handle_lvl4",                  { event_mdown = private.AnimUseHandleLvl4          }},

    { "spr_backyard_feathers_lvl4",                { event_mdown = private.get_feathers_lvl4          }},

    { "spr_backyard_collect_morph_item",  { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_18" ); end } },
      
    { "spr_telephone_box_collect2_item_28",        { event_mdown = private.get_collect2_item_28      }},
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_backyard = function ()
  
    table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gho_backyard_next_armchair",
      "gzz_backyard_driver_seat",
      "gzz_backyard_telephone_box",
      "gzz_backyard_backdoor",
      "gzz_backyard_roof",
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_driver_seat",
      "zz_telephone_box",
      "zz_backdoor",
      "zz_roof",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_backyard", update_game_mode_backyard, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_backyard = function ()

    local effects_table = 
    {
      "obj_backyard_anim",
      "anm_backyard_bushes",
      "anm_backyard_fireflies",
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_backyard", update_performance_mode_backyard, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_backyard () end;
  --------------------------------------------------------------------------------------------
  local opn_backyard_map = function ()

    common_impl.VisitMapRoom( "backyard" );

  end;
  cmn.AddSubscriber( "opn_backyard", opn_backyard_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_18 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_18 = function ()
  
    ObjDelete( "obj_backyard_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_18", get_collect_morph_item_18, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_honk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_honk" ] = {
    type = "get",
    get_obj = "spr_driver_seat_honk",
    room = private.room_objname,
    zz = "zz_driver_seat",
    zz_gate = "gzz_backyard_driver_seat"
  };
  
  local get_honk_inv = function ()
  
    interface.InventoryItemAdd( "inv_honk", "spr_driver_seat_honk" );
  
  end;
  
  local get_honk_closezz = function ()
  
    ObjDelete( "gfx_driver_seat_honk" );
    ObjDelete( "spr_backyard_toot"    );
  
  end;
  
  cmn.AddSubscriber( "get_honk", get_honk_inv );
  cmn.AddSubscriber( "get_honk", get_honk_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stone_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stone_lvl4" ] = {
    type = "get",
    get_obj = "spr_driver_seat_stone_lvl4",
    room = private.room_objname,
    zz = "zz_driver_seat",
    zz_gate = "gzz_backyard_driver_seat"
  };
  
  local get_stone_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_stone_lvl4", "spr_driver_seat_stone_lvl4" );
  
  end;
  
  local get_stone_lvl4_closezz = function ()
  
    ObjDelete( "gfx_driver_seat_stone_lvl4" );
    ObjDelete( "spr_backyard_stone"         );
  
  end;
  
  cmn.AddSubscriber( "get_stone_lvl4", get_stone_lvl4_inv );
  cmn.AddSubscriber( "get_stone_lvl4", get_stone_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_box_wrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_box_wrench" ] = {
    type = "get",
    get_obj = "spr_driver_seat_box_wrench",
    room = private.room_objname,
    zz = "zz_driver_seat",
    zz_gate = "gzz_backyard_driver_seat"
  };
  
  local get_box_wrench_inv = function ()
  
    interface.InventoryItemAdd( "inv_box_wrench", "spr_driver_seat_box_wrench" );
  
  end;
  
  local get_box_wrench_closezz = function ()
  
    ObjDelete( "gfx_driver_seat_box_wrench" );
  
  end;
  
  cmn.AddSubscriber( "get_box_wrench", get_box_wrench_inv );
  cmn.AddSubscriber( "get_box_wrench", get_box_wrench_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_decor_part_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_decor_part_3" ] = {
    type = "get",
    get_obj = "spr_driver_seat_decor_part_3",
    room = private.room_objname,
    zz = "zz_driver_seat",
    zz_gate = "gzz_backyard_driver_seat"
  };
  
  local get_decor_part_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_decor_part_3", "spr_driver_seat_decor_part_3" );
  
  end;
  
  local get_decor_part_3_closezz = function ()
  
    ObjDelete( "gfx_driver_seat_decor_part_3" );
  
  end;
  
  cmn.AddSubscriber( "get_decor_part_3", get_decor_part_3_inv );
  cmn.AddSubscriber( "get_decor_part_3", get_decor_part_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_recipe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_recipe" ] = {
    type = "get",
    get_obj = "spr_telephone_box_recipe1",
    room = private.room_objname,
    zz = "zz_telephone_box",
    zz_gate = "gzz_backyard_telephone_box"
  };
  
  local get_recipe_inv = function ()
  
    interface.InventoryItemAdd( "inv_recipe", "spr_telephone_box_recipe" );
  
  end;
  
  local get_recipe_closezz = function ()
  
    ObjDelete( "gfx_telephone_box_recipe"   );
    ObjDelete( "obj_telephone_box_recipe"   );
    ObjDelete( "spr_telephone_box_recipe1"   );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_28" ) ) then
      
      ObjDelete( "gzz_backyard_telephone_box" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_recipe", get_recipe_inv );
  cmn.AddSubscriber( "get_recipe", get_recipe_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cross_1_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cross_1_lvl4" ] = {
    type = "get",
    get_obj = "spr_telephone_box_cross_1_lvl4",
    room = private.room_objname,
    zz = "zz_telephone_box",
    zz_gate = "gzz_backyard_telephone_box"
  };
  
  local get_cross_1_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_cross_1_lvl4", "spr_telephone_box_cross_1_lvl4" );
  
  end;
  
  local get_cross_1_lvl4_closezz = function ()
  
    ObjDelete( "gfx_telephone_box_cross_1_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_cross_1_lvl4", get_cross_1_lvl4_inv );
  cmn.AddSubscriber( "get_cross_1_lvl4", get_cross_1_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sal_ammoniac () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sal_ammoniac" ] = {
    type = "get",
    get_obj = "spr_backdoor_sal_ammoniac",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  
  local get_sal_ammoniac_inv = function ()
  
    interface.InventoryItemAdd( "inv_sal_ammoniac", "spr_backdoor_sal_ammoniac" );
  
  end;
  
  local get_sal_ammoniac_closezz = function ()
  
    ObjDelete( "gfx_backdoor_sal_ammoniac" );
    ObjDelete( "gzz_backyard_backdoor"     );
  
  end;
  
  cmn.AddSubscriber( "get_sal_ammoniac", get_sal_ammoniac_inv );
  cmn.AddSubscriber( "get_sal_ammoniac", get_sal_ammoniac_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sprinkler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sprinkler" ] = {
    type = "get",
    get_obj = "spr_backdoor_sprinkler",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  
  local get_sprinkler_inv = function ()
  
    interface.InventoryItemAdd( "inv_sprinkler", "spr_backdoor_sprinkler" );
  
  end;
  
  local get_sprinkler_closezz = function ()
  
    ObjDelete( "gfx_backdoor_sprinkler" );
  
  end;
  
  cmn.AddSubscriber( "get_sprinkler", get_sprinkler_inv );
  cmn.AddSubscriber( "get_sprinkler", get_sprinkler_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriver_lvl4" ] = {
    type = "get",
    get_obj = "spr_backdoor_screwdriver_lvl4",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  
  local get_screwdriver_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_screwdriver_lvl4", "spr_backdoor_screwdriver_lvl4" );
  
  end;
  
  local get_screwdriver_lvl4_closezz = function ()
  
    ObjDelete( "gfx_backdoor_screwdriver_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_screwdriver_lvl4", get_screwdriver_lvl4_inv );
  cmn.AddSubscriber( "get_screwdriver_lvl4", get_screwdriver_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gargoyle_statuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gargoyle_statuette" ] = {
    type = "get",
    get_obj = "spr_backdoor_gargoyle_statuette",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  
  local get_gargoyle_statuette_inv = function ()
  
    interface.InventoryItemAdd( "inv_gargoyle_statuette", "spr_backdoor_gargoyle_statuette" );
  
  end;
  
  local get_gargoyle_statuette_closezz = function ()
  
    ObjDelete( "gfx_backdoor_gargoyle_statuette" );
  
  end;
  
  cmn.AddSubscriber( "get_gargoyle_statuette", get_gargoyle_statuette_inv );
  cmn.AddSubscriber( "get_gargoyle_statuette", get_gargoyle_statuette_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scalpel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scalpel" ] = {
    type = "get",
    get_obj = "spr_backdoor_scalpel",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  
  local get_scalpel_inv = function ()
  
    interface.InventoryItemAdd( "inv_scalpel", "spr_backdoor_scalpel" );
  
  end;
  
  local get_scalpel_closezz = function ()
  
    ObjDelete( "gfx_backdoor_scalpel"  );

  end;
  
  cmn.AddSubscriber( "get_scalpel", get_scalpel_inv );
  cmn.AddSubscriber( "get_scalpel", get_scalpel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rake () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rake" ] = {
    type = "get",
    get_obj = "spr_roof_rake",
    room = private.room_objname,
    zz = "zz_roof",
    zz_gate = "gzz_backyard_roof"
  };
  
  local get_rake_inv = function ()
  
    interface.InventoryItemAdd( "inv_rake", "spr_roof_rake" );
  
  end;
  
  local get_rake_closezz = function ()
  
    ObjDelete( "gfx_roof_rake"                      );
    ObjDelete( "spr_backyard_letter_hole_back_rake" );
  
  end;
  
  cmn.AddSubscriber( "get_rake", get_rake_inv );
  cmn.AddSubscriber( "get_rake", get_rake_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scheme_piece_6 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scheme_piece_6" ] = {
    type = "get",
    get_obj = "spr_roof_scheme_piece_6",
    room = private.room_objname,
    zz = "zz_roof",
    zz_gate = "gzz_backyard_roof"
  };
  
  local get_scheme_piece_6_inv = function ()
  
    local count = 1;
    
    for i = 2, 6, 1 do
      
      if ( cmn.IsEventDone( "get_scheme_piece_"..i ) ) then
        
        count = count + 1;
        ObjSet( "inv_scheme_piece_"..i, { alp = 1 } );
        
      end;
      
    end;
    
    ObjSet( "inv_scheme_piece_number", { frame = ObjGet( "inv_scheme_piece_number" ).frame + 1 } );
    interface.InventoryItemAdd( "inv_scheme_piece", "spr_roof_scheme_piece_6", "assets/levels/levelext/rm_backyard/zz_roof/inv/inv_scheme_piece_6" );

    if count == 6 then
      ObjSet( "inv_scheme_piece", { drag = true } );
      
      cmn.SetInvPlusRGB( "paper_piece", true );
      
    else 
      ObjSet( "inv_scheme_piece", { drag = false } );

    end;
    
  end;
  
  local get_scheme_piece_6_closezz = function ()
  
    ObjDelete( "gfx_roof_scheme_piece_6" );
    ObjMultiSet({ 
      { "obj_roof_use_round_key", { input = true, active = true, visible = true }},
    });
  
  end;
  
  cmn.AddSubscriber( "get_scheme_piece_6", get_scheme_piece_6_inv );
  cmn.AddSubscriber( "get_scheme_piece_6", get_scheme_piece_6_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plate () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plate" ] = {
    type = "get",
    get_obj = "spr_roof_plate",
    room = private.room_objname,
    zz = "zz_roof",
    zz_gate = "gzz_backyard_roof"
  };
  
  local get_plate_inv = function ()
  
    interface.InventoryItemAdd( "inv_plate", "spr_roof_plate" );
  
  end;
  
  local get_plate_closezz = function ()
  
    ObjDelete( "gfx_roof_plate" );
  
  end;
  
  cmn.AddSubscriber( "get_plate", get_plate_inv );
  cmn.AddSubscriber( "get_plate", get_plate_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_feathers_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_feathers_lvl4" ] = {
    type = "get",
    get_obj = "spr_backyard_feathers_lvl4",
    room = private.room_objname,
  };
  
  local get_feathers_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_feathers_lvl4", "spr_backyard_feathers_lvl4" );
  
  end;
  
  local get_feathers_lvl4_closezz = function ()
  
    ObjDelete( "gfx_backyard_feathers_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_feathers_lvl4", get_feathers_lvl4_inv );
  cmn.AddSubscriber( "get_feathers_lvl4", get_feathers_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_28 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_28 = function ()
  
    ObjDelete( "obj_telephone_box_collect2_item_28" ); 
  
    if ( cmn.IsEventDone( "get_recipe" ) ) then
      
      ObjDelete( "gzz_backyard_telephone_box" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_28", get_collect2_item_28, private.room_objname );      
  --------------------------------------------------------------------------------------------
  -- function use_armchair_lever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_armchair_lever" ] = {
    type = "use",
    inv_obj = "inv_armchair_lever",
    use_place = "obj_driver_seat_use_armchair_lever",
    room = private.room_objname,
    zz = "zz_driver_seat",
    zz_gate = "gzz_backyard_driver_seat"
  };
  local use_armchair_lever_inv = function ()
  
    interface.InventoryItemRemove( "inv_armchair_lever" );
  
  end;
  local use_armchair_lever_beg = function ()
  
    ObjDelete( "obj_driver_seat_use_armchair_lever" );
  
  end;
  local use_armchair_lever_end = function ()
  
    ObjMultiSet( { 
      { "anm_driver_seat_lever",      { frame = 500                                 }},
      { "gho_backyard_next_armchair", { input = true, visible = true, active = true }},
    } );
    ObjDelete( "gzz_backyard_driver_seat" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_armchair_lever", use_armchair_lever_beg, private.room_objname );
  cmn.AddSubscriber( "use_armchair_lever", use_armchair_lever_inv );
  cmn.AddSubscriber( "use_armchair_lever", use_armchair_lever_end, private.room_objname );
  cmn.AddSubscriber( "use_armchair_lever_inv", use_armchair_lever_inv, private.room_objname );
  cmn.AddSubscriber( "use_armchair_lever_beg", use_armchair_lever_beg, private.room_objname );
  cmn.AddSubscriber( "use_armchair_lever_end", use_armchair_lever_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sprinkler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sprinkler" ] = {
    type = "use",
    inv_obj = "inv_sprinkler",
    use_place = "obj_driver_seat_use_sprinkler",
    room = private.room_objname,
    zz = "zz_driver_seat",
    zz_gate = "gzz_backyard_driver_seat"
  };
  local use_sprinkler_inv = function ()
  
    interface.InventoryItemRemove( "inv_sprinkler" );
  
  end;
  local use_sprinkler_beg = function ()
  
    ObjDelete( "obj_driver_seat_use_sprinkler" );
  
  end;
  local use_sprinkler_end = function ()

    ObjMultiSet( { 
      { "spr_driver_seat_honk",  {  input = true } },
      { "gfx_driver_seat_honk",  { active = true } },
      { "spr_driver_seat_enema", {    alp = 1    } },
      { "spr_backyard_pear",     {    alp = 1    } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sprinkler", use_sprinkler_beg, private.room_objname );
  cmn.AddSubscriber( "use_sprinkler", use_sprinkler_inv );
  cmn.AddSubscriber( "use_sprinkler", use_sprinkler_end, private.room_objname );
  cmn.AddSubscriber( "use_sprinkler_inv", use_sprinkler_inv, private.room_objname );
  cmn.AddSubscriber( "use_sprinkler_beg", use_sprinkler_beg, private.room_objname );
  cmn.AddSubscriber( "use_sprinkler_end", use_sprinkler_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_lvl4" ] = {
    type = "use",
    inv_obj = "inv_screwdriver_lvl4",
    use_place = "obj_driver_seat_use_screwdriver_lvl4",
    room = private.room_objname,
    zz = "zz_driver_seat",
    zz_gate = "gzz_backyard_driver_seat"
  };
  local use_screwdriver_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_screwdriver_lvl4" );
  
  end;
  local use_screwdriver_lvl4_beg = function ()
  
    ObjDelete( "obj_driver_seat_use_screwdriver_lvl4" );
  
  end;
  local use_screwdriver_lvl4_end = function ()
  
    ObjMultiSet( { 
      { "spr_driver_seat_decor_part_3",              {  input = true                               } },
      { "gfx_driver_seat_decor_part_3",              {               active = true                 } },
      { "obj_driver_seat_use_glove_compartment_key", { input = true, active = true, visible = true } },
      { "obj_driver_seat_use_armchair_lever",        { input = true, active = true, visible = true } },
      { "spr_driver_seat_door",                      {   alp = 1                                   } },
      { "spr_backyard_opened_door_2",                {   alp = 1                                   } },
    } );
    ObjDelete( "spr_driver_seat_door_2"      );
    ObjDelete( "anm_driver_seat_screwdriver" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_lvl4", use_screwdriver_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_lvl4", use_screwdriver_lvl4_inv );
  cmn.AddSubscriber( "use_screwdriver_lvl4", use_screwdriver_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_lvl4_inv", use_screwdriver_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_lvl4_beg", use_screwdriver_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_lvl4_end", use_screwdriver_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glove_compartment_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glove_compartment_key" ] = {
    type = "use",
    inv_obj = "inv_glove_compartment_key",
    use_place = "obj_driver_seat_use_glove_compartment_key",
    room = private.room_objname,
    zz = "zz_driver_seat",
    zz_gate = "gzz_backyard_driver_seat"
  };
  local use_glove_compartment_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_glove_compartment_key" );
  
  end;
  local use_glove_compartment_key_beg = function ()
  
    ObjDelete( "obj_driver_seat_use_glove_compartment_key" );
  
  end;
  local use_glove_compartment_key_end = function ()

    ObjMultiSet( {
      { "spr_driver_seat_box_wrench",    {  input = true } },
      { "gfx_driver_seat_box_wrench",    { active = true } },
      { "spr_driver_seat_compartment_2", {    alp = 1    } },
    } );
    ObjDelete( "anm_driver_seat_key" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glove_compartment_key", use_glove_compartment_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_glove_compartment_key", use_glove_compartment_key_inv );
  cmn.AddSubscriber( "use_glove_compartment_key", use_glove_compartment_key_end, private.room_objname );
  cmn.AddSubscriber( "use_glove_compartment_key_inv", use_glove_compartment_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_glove_compartment_key_beg", use_glove_compartment_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_glove_compartment_key_end", use_glove_compartment_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chain_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chain_lvl4" ] = {
    type = "use",
    inv_obj = "inv_chain_lvl4",
    use_place = "obj_telephone_box_use_chain_lvl4",
    room = private.room_objname,
    zz = "zz_telephone_box",
    zz_gate = "gzz_backyard_telephone_box"
  };
  local use_chain_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_chain_lvl4" );
  
  end;
  local use_chain_lvl4_beg = function ()
  
    ObjDelete( "obj_telephone_box_use_chain_lvl4" );
  
  end;
  local use_chain_lvl4_end = function ()
  
    ObjMultiSet( { 
      { "obj_telephone_box_clk_chain_lvl4_3", { input = true, active = true, visible = true } },
      { "spr_telephone_chain",                {   alp = 1                                   } },
      { "spr_backyard_chain_2",               {   alp = 1                                   } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chain_lvl4", use_chain_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain_lvl4", use_chain_lvl4_inv );
  cmn.AddSubscriber( "use_chain_lvl4", use_chain_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_chain_lvl4_inv", use_chain_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_chain_lvl4_beg", use_chain_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain_lvl4_end", use_chain_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_alarm_double_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_alarm_double_key" ] = {
    type = "use",
    inv_obj = "inv_alarm_double_key",
    use_place = "obj_telephone_box_use_alarm_double_key",
    room = private.room_objname,
    zz = "zz_telephone_box",
    zz_gate = "gzz_backyard_telephone_box"
  };
  local use_alarm_double_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_alarm_double_key" );
  
  end;
  local use_alarm_double_key_beg = function ()
  
    ObjDelete( "obj_telephone_box_use_alarm_double_key" );
  
  end;
  local use_alarm_double_key_end = function ()
  
    ObjMultiSet({ 
      { "obj_telephone_box_clk_alarm_double_key", {   input = true, active = true, visible = true }},
      { "anm_telephone_key",                      {   frame = 500                                 }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_alarm_double_key", use_alarm_double_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_alarm_double_key", use_alarm_double_key_inv );
  cmn.AddSubscriber( "use_alarm_double_key", use_alarm_double_key_end, private.room_objname );
  cmn.AddSubscriber( "use_alarm_double_key_inv", use_alarm_double_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_alarm_double_key_beg", use_alarm_double_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_alarm_double_key_end", use_alarm_double_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cross_2_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cross_2_lvl4" ] = {
    type = "use",
    inv_obj = "inv_cross_2_lvl4",
    use_place = "obj_backdoor_use_cross_2_lvl4",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  local use_cross_2_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_cross_2_lvl4" );
  
  end;
  local use_cross_2_lvl4_beg = function ()
  
    ObjDelete( "obj_backdoor_use_cross_2_lvl4" );
  
  end;
  local use_cross_2_lvl4_end = function ()
  
    ObjMultiSet({ 
      { "spr_backdoor_scalpel", {  input = true }},
      { "gfx_backdoor_scalpel", { active = true }},
      { "spr_backdoor_open_2",  {    alp = 1    }},
      { "spr_backyard_opened_door_4", { alp = 1 }}
    });
    ObjDelete( "spr_backdoor_door_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cross_2_lvl4", use_cross_2_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_cross_2_lvl4", use_cross_2_lvl4_inv );
  cmn.AddSubscriber( "use_cross_2_lvl4", use_cross_2_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_cross_2_lvl4_inv", use_cross_2_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_cross_2_lvl4_beg", use_cross_2_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_cross_2_lvl4_end", use_cross_2_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wooden_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wooden_handle" ] = {
    type = "use",
    inv_obj = "inv_wooden_handle",
    use_place = "obj_backdoor_use_wooden_handle",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  local use_wooden_handle_inv = function ()
  
    interface.InventoryItemRemove( "inv_wooden_handle" );
  
  end;
  local use_wooden_handle_beg = function ()
  
    ObjDelete( "obj_backdoor_use_wooden_handle" );
  
  end;
  local use_wooden_handle_end = function ()
  
    ObjMultiSet({ 
      { "spr_backdoor_screwdriver_lvl4", {  input = true }},
      { "gfx_backdoor_screwdriver_lvl4", { active = true }},
      { "spr_backdoor_screwdriver_2",    {    alp = 1    }},
    });
    ObjDelete( "vid_backdoor_screwdriver_lvl4" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wooden_handle", use_wooden_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_wooden_handle", use_wooden_handle_inv );
  cmn.AddSubscriber( "use_wooden_handle", use_wooden_handle_end, private.room_objname );
  cmn.AddSubscriber( "use_wooden_handle_inv", use_wooden_handle_inv, private.room_objname );
  cmn.AddSubscriber( "use_wooden_handle_beg", use_wooden_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_wooden_handle_end", use_wooden_handle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cross_1_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cross_1_lvl4" ] = {
    type = "use",
    inv_obj = "inv_cross_1_lvl4",
    use_place = "obj_backdoor_use_cross_1_lvl4",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  local use_cross_1_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_cross_1_lvl4" );
  
  end;
  local use_cross_1_lvl4_beg = function ()
  
    ObjDelete( "obj_backdoor_use_cross_1_lvl4" );
  
  end;
  local use_cross_1_lvl4_end = function ()
  
    ObjMultiSet({ 
      { "spr_backdoor_sprinkler",     {  input = true }},
      { "gfx_backdoor_sprinkler",     { active = true }},
      { "spr_backdoor_open_3",        {    alp = 1    }},
      { "spr_backyard_opened_door_3", {    alp = 1    }},
    });
    ObjDelete( "spr_backdoor_door_3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cross_1_lvl4", use_cross_1_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_cross_1_lvl4", use_cross_1_lvl4_inv );
  cmn.AddSubscriber( "use_cross_1_lvl4", use_cross_1_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_cross_1_lvl4_inv", use_cross_1_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_cross_1_lvl4_beg", use_cross_1_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_cross_1_lvl4_end", use_cross_1_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_plate () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plate" ] = {
    type = "use",
    inv_obj = "inv_plate",
    use_place = "obj_backdoor_use_plate",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  local use_plate_inv = function ()
  
    interface.InventoryItemRemove( "inv_plate" );
  
  end;
  local use_plate_beg = function ()
  
    ObjDelete( "obj_backdoor_use_plate" );
  
  end;
  local use_plate_end = function ()
  
    ObjMultiSet({ 
      { "spr_backdoor_gargoyle_statuette", {  input = true }},
      { "gfx_backdoor_gargoyle_statuette", { active = true }},
    });
    ObjDelete( "spr_backdoor_cap" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_plate", use_plate_beg, private.room_objname );
  cmn.AddSubscriber( "use_plate", use_plate_inv );
  cmn.AddSubscriber( "use_plate", use_plate_end, private.room_objname );
  cmn.AddSubscriber( "use_plate_inv", use_plate_inv, private.room_objname );
  cmn.AddSubscriber( "use_plate_beg", use_plate_beg, private.room_objname );
  cmn.AddSubscriber( "use_plate_end", use_plate_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cross_3_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cross_3_lvl4" ] = {
    type = "use",
    inv_obj = "inv_cross_3_lvl4",
    use_place = "obj_backdoor_use_cross_3_lvl4",
    room = private.room_objname,
    zz = "zz_backdoor",
    zz_gate = "gzz_backyard_backdoor"
  };
  local use_cross_3_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_cross_3_lvl4" );
  
  end;
  local use_cross_3_lvl4_beg = function ()
  
    ObjDelete( "obj_backdoor_use_cross_3_lvl4" );
  
  end;
  local use_cross_3_lvl4_end = function ()
  
    ObjMultiSet({ 
      { "spr_backdoor_sal_ammoniac",  {  input = true }},
      { "gfx_backdoor_sal_ammoniac",  { active = true }},
      { "spr_backdoor_open_1",        {    alp = 1    }},
      { "spr_backyard_opened_door_1", {    alp = 1    }},
    });
    ObjDelete( "spr_backdoor_door_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cross_3_lvl4", use_cross_3_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_cross_3_lvl4", use_cross_3_lvl4_inv );
  cmn.AddSubscriber( "use_cross_3_lvl4", use_cross_3_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_cross_3_lvl4_inv", use_cross_3_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_cross_3_lvl4_beg", use_cross_3_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_cross_3_lvl4_end", use_cross_3_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_planks () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_planks" ] = {
    type = "use",
    inv_obj = "inv_planks",
    use_place = "obj_roof_use_planks",
    room = private.room_objname,
    zz = "zz_roof",
    zz_gate = "gzz_backyard_roof"
  };
  local use_planks_inv = function ()
  
    interface.InventoryItemRemove( "inv_planks" );
  
  end;
  local use_planks_beg = function ()
  
    ObjDelete( "obj_roof_use_planks" );
  
  end;
  local use_planks_end = function ()
  
    ObjDelete( "gzz_backyard_roof" );
    ObjMultiSet({ 
      { "grm_backyard_room_211_lvl4", { input = true, visible = true, active = true }},
      { "spr_roof_stick_1",           {    alp = 1,     pos_x = -154,  pos_y = 278  }},
      { "spr_roof_stick_2",           {    alp = 1,     pos_x = -131,  pos_y = 127  }},
      { "spr_roof_stick_3",           {    alp = 1,     pos_x = -112,  pos_y = -47  }},
      { "spr_backyard_stairs_2",      {    alp = 1                                  }},
      { "spr_backyard_opened_window", {    alp = 1                                  }},
    });
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_backyard_room_211_lvl4_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_planks", use_planks_beg, private.room_objname );
  cmn.AddSubscriber( "use_planks", use_planks_inv );
  cmn.AddSubscriber( "use_planks", use_planks_end, private.room_objname );
  cmn.AddSubscriber( "use_planks_inv", use_planks_inv, private.room_objname );
  cmn.AddSubscriber( "use_planks_beg", use_planks_beg, private.room_objname );
  cmn.AddSubscriber( "use_planks_end", use_planks_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handle_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handle_lvl4" ] = {
    type = "use",
    inv_obj = "inv_handle_lvl4",
    use_place = "obj_roof_use_handle_lvl4",
    room = private.room_objname,
    zz = "zz_roof",
    zz_gate = "gzz_backyard_roof"
  };
  local use_handle_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_handle_lvl4" );
  
  end;
  local use_handle_lvl4_beg = function ()
  
    ObjDelete( "obj_roof_use_handle_lvl4" );
  
  end;
  local use_handle_lvl4_end = function ()
  
    ObjMultiSet({ 
      { "spr_roof_rake", { alp = 1, input = true }},
      { "gfx_roof_rake", {         active = true }},
    });
    ObjDelete( "anm_roof_rake" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handle_lvl4", use_handle_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle_lvl4", use_handle_lvl4_inv );
  cmn.AddSubscriber( "use_handle_lvl4", use_handle_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_handle_lvl4_inv", use_handle_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_handle_lvl4_beg", use_handle_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle_lvl4_end", use_handle_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_letter_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_letter_lvl4" ] = {
    type = "use",
    inv_obj = "inv_letter_lvl4",
    use_place = "obj_roof_use_letter_lvl4",
    room = private.room_objname,
    zz = "zz_roof",
    zz_gate = "gzz_backyard_roof"
  };
  local use_letter_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_letter_lvl4" );
  
  end;
  local use_letter_lvl4_beg = function ()
  
    ObjDelete( "obj_roof_use_letter_lvl4" );
  
  end;
  local use_letter_lvl4_end = function ()

    ObjMultiSet({ 
      { "spr_roof_scheme_piece_6", {  input = true }},
      { "gfx_roof_scheme_piece_6", { active = true }},
    });
    ObjDelete( "anm_roof_letter"     );
    ObjDelete( "spr_backyard_letter" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_letter_lvl4", use_letter_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_lvl4", use_letter_lvl4_inv );
  cmn.AddSubscriber( "use_letter_lvl4", use_letter_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_letter_lvl4_inv", use_letter_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_letter_lvl4_beg", use_letter_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_lvl4_end", use_letter_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_round_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_round_key" ] = {
    type = "use",
    inv_obj = "inv_round_key",
    use_place = "obj_roof_use_round_key",
    room = private.room_objname,
    zz = "zz_roof",
    zz_gate = "gzz_backyard_roof"
  };
  local use_round_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_round_key" );
  
  end;
  local use_round_key_beg = function ()
  
    ObjDelete( "obj_roof_use_round_key" );
  
  end;
  local use_round_key_end = function ()
  
    ObjMultiSet({ 
      { "spr_roof_plate", {  input = true }},
      { "gfx_roof_plate", { active = true }},
    });
    ObjDelete( "spr_roof_hatch_2"   );
    ObjDelete( "anm_roof_key"       );
    ObjDelete( "spr_backyard_hatch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_round_key", use_round_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_round_key", use_round_key_inv );
  cmn.AddSubscriber( "use_round_key", use_round_key_end, private.room_objname );
  cmn.AddSubscriber( "use_round_key_inv", use_round_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_round_key_beg", use_round_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_round_key_end", use_round_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_honk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_honk" ] = {
    type = "use",
    inv_obj = "inv_honk",
    use_place = "obj_backyard_use_honk",
    room = private.room_objname,
  };
  local use_honk_inv = function ()
  
    interface.InventoryItemRemove( "inv_honk" );
  
  end;
  local use_honk_beg = function ()
  
    ObjDelete( "obj_backyard_use_honk" );
  
  end;
  local use_honk_end = function ()
  
    ObjMultiSet({ 
      { "spr_backyard_feathers_lvl4", { alp = 1, input = true }},
      { "gfx_backyard_feathers_lvl4", {         active = true }},
    });
    ObjDelete( "anm_backyard_crow"      );
    ObjDelete( "anm_backyard_crow_toot" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_honk", use_honk_beg, private.room_objname );
  cmn.AddSubscriber( "use_honk", use_honk_inv );
  cmn.AddSubscriber( "use_honk", use_honk_end, private.room_objname );
  cmn.AddSubscriber( "use_honk_inv", use_honk_inv, private.room_objname );
  cmn.AddSubscriber( "use_honk_beg", use_honk_beg, private.room_objname );
  cmn.AddSubscriber( "use_honk_end", use_honk_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_chain_lvl4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_chain_lvl4_1" ] = {
    type = "click",
    use_place = "obj_telephone_box_clk_chain_lvl4_1",
    room = private.room_objname,
    zz = "zz_telephone_box",
    zz_gate = "gzz_backyard_telephone_box"
  };
  
  local clk_chain_lvl4_1_beg = function ()

    ObjDelete( "obj_telephone_box_clk_chain_lvl4_1" );
  
  end;
  local clk_chain_lvl4_1_end = function ()
    
    ObjMultiSet( { 
      { "obj_telephone_box_clk_chain_lvl4_2", { input = true, active = true, visible = true } },
    } );
    ObjDelete( "spr_telephone_door_2" );
    ObjDelete( "spr_backyard_flap"    );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_chain_lvl4_1",     clk_chain_lvl4_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chain_lvl4_1",     clk_chain_lvl4_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_chain_lvl4_1_beg", clk_chain_lvl4_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chain_lvl4_1_end", clk_chain_lvl4_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_chain_lvl4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_chain_lvl4_2" ] = {
    type = "click",
    use_place = "obj_telephone_box_clk_chain_lvl4_2",
    room = private.room_objname,
    zz = "zz_telephone_box",
    zz_gate = "gzz_backyard_telephone_box"
  };
  
  local clk_chain_lvl4_2_beg = function ()

    ObjDelete( "obj_telephone_box_clk_chain_lvl4_2" );
  
  end;
  local clk_chain_lvl4_2_end = function ()
    
    ObjMultiSet( { 
      { "obj_telephone_box_use_chain_lvl4", { input = true, active = true, visible = true } },
    } );
    ObjDelete( "spr_telephone_rusty_chain" );
    ObjDelete( "spr_backyard_chain"        );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_chain_lvl4_2",     clk_chain_lvl4_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chain_lvl4_2",     clk_chain_lvl4_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_chain_lvl4_2_beg", clk_chain_lvl4_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chain_lvl4_2_end", clk_chain_lvl4_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_chain_lvl4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_chain_lvl4_3" ] = {
    type = "click",
    use_place = "obj_telephone_box_clk_chain_lvl4_3",
    room = private.room_objname,
    zz = "zz_telephone_box",
    zz_gate = "gzz_backyard_telephone_box"
  };
  
  local clk_chain_lvl4_3_beg = function ()

    ObjDelete( "obj_telephone_box_clk_chain_lvl4_3" );
  
  end;
  local clk_chain_lvl4_3_end = function ()
    
    ObjMultiSet( { 
      { "spr_telephone_box_cross_1_lvl4",         { input = true                                } },
      { "gfx_telephone_box_cross_1_lvl4",         {               active = true                 } },
      { "obj_telephone_box_use_alarm_double_key", { input = true, active = true, visible = true } },
      { "spr_backyard_open_booth",                {   alp = 1                                   } },
      { "obj_telephone_box_collect2_item_28",         { input = true } },
    } );
    ObjDelete( "spr_telephone_door" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_chain_lvl4_3",     clk_chain_lvl4_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chain_lvl4_3",     clk_chain_lvl4_3_end, private.room_objname );
  cmn.AddSubscriber( "clk_chain_lvl4_3_beg", clk_chain_lvl4_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chain_lvl4_3_end", clk_chain_lvl4_3_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_alarm_double_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_alarm_double_key" ] = {
    type = "click",
    use_place = "obj_telephone_box_clk_alarm_double_key",
    room = private.room_objname,
    zz = "zz_telephone_box",
    zz_gate = "gzz_backyard_telephone_box"
  };
  
  local clk_alarm_double_key_beg = function ()

    ObjDelete( "obj_telephone_box_clk_alarm_double_key" );
  
  end;
  local clk_alarm_double_key_end = function ()
    
    ObjMultiSet({ 
      { "spr_telephone_box_recipe1",{   input = true }},
      { "gfx_telephone_box_recipe", {  active = true }},
      { "spr_telephone_door_3",     {     alp = 1    }},
      { "anm_telephone_bell",       { playing = true }},
    });
    ObjDelete( "anm_telephone_key" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_alarm_double_key",     clk_alarm_double_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_alarm_double_key",     clk_alarm_double_key_end, private.room_objname );
  cmn.AddSubscriber( "clk_alarm_double_key_beg", clk_alarm_double_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_alarm_double_key_end", clk_alarm_double_key_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_backyard_gangsters () end;
  --------------------------------------------------------------------------------------------
  local see_backyard_gangsters = function ()

    ObjDelete( "anm_backyard_band" );
    ObjMultiSet({ 
      { "spr_backyard_opened_door",  { alp = 1 }},
      { "anm_backyard_bandits_away", { alp = 1 }},
    });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_backyard_gangsters", see_backyard_gangsters, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function see_backyard_anim_backyard_1 () end;
  --------------------------------------------------------------------------------------------
  local see_backyard_anim_backyard_1 = function ()
    
    ObjSet( "anm_backyard_anim", { frame = 500 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_backyard_anim_backyard_1", see_backyard_anim_backyard_1, private.room_objname ); 


  --------------------------------------------------------------------------------------------
  -- function see_backyard_bandits_away () end;
  --------------------------------------------------------------------------------------------
  local see_backyard_bandits_away = function ()

    ObjDelete( "anm_backyard_bandits_away" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_backyard_bandits_away", see_backyard_bandits_away, private.room_objname ); 


end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_telephone_box () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_telephone_box" );  
    ------------------------------------------------- 
    function zz_telephone_box.Close ()
      
      if cmn.IsEventDone( "clk_alarm_double_key" ) then
        
        ObjMultiSet( {
        
          { "spr_telephone_box_recipe2", { scale_x = 0.8, input = true  } };
          { "spr_telephone_box_recipe", { scale_x = 0, input = false  } };
        
        } );
        cmn.NoteScaleClose( { "spr_telephone_box_recipe1" }, { "obj_telephone_box_recipe" } );
        
      end;
      
    end; 
  
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_backyard();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_backyard_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();

  if cmn.IsEventDone( "opn_backyard" ) and not cmn.IsEventDone( "see_backyard_gangsters" ) then
    private.see_backyard_gangsters ();
  end;

  if cmn.IsEventDone( "see_backyard_gangsters" ) and not cmn.IsEventDone( "see_backyard_bandits_away" ) then
    private.see_backyard_bandits_away ();
  end;

  if cmn.IsEventDone( "win_in_chest" ) and not cmn.IsEventDone( "see_backyard_anim_backyard_1" ) then
    private.see_backyard_anim_backyard_1 ();
  end;

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()
  common_impl.StopAudio( "env", "levelext/env/aud_backyard_env", 0.5 );
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_armchair_lever ()

  local item = "inv_armchair_lever";

  if ( cmn.ApplyObj( item, "gzz_backyard_driver_seat" ) and cmn.IsEventDone( "use_screwdriver_lvl4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_driver_seat" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_driver_seat_use_armchair_lever" ) and cmn.IsEventDone( "use_screwdriver_lvl4" ) ) then

    cmn.CallEventHandler( "use_armchair_lever_inv" );
    cmn.CallEventHandler( "use_armchair_lever_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_armchair_lever" );
      cmn.CallEventHandler( "use_armchair_lever_end" );
      common.CloseSubRoom();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_handle_chair_4lvl", 0, "", 0 );

    ObjMultiSet({ 
      { "obj_driver_seat_armchair", { alp = 0 }},
      { "anm_driver_seat_lever",    { alp = 1 }},
    });
    AnimPlay( "anm_driver_seat_lever", "lever", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sprinkler ()

  local item = "inv_sprinkler";

  if ( cmn.ApplyObj( item, "gzz_backyard_driver_seat" ) and cmn.IsEventDone( "get_stone_lvl4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_driver_seat" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_driver_seat_use_sprinkler" ) and cmn.IsEventDone( "get_stone_lvl4" ) ) then

    cmn.CallEventHandler( "use_sprinkler_inv" );
    cmn.CallEventHandler( "use_sprinkler_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_sprinkler" );
      cmn.CallEventHandler( "use_sprinkler_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_sprinkler_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_driver_seat_enema", func_end, 2 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver_lvl4 ()

  local item = "inv_screwdriver_lvl4";

  if ( cmn.ApplyObj( item, "gzz_backyard_driver_seat" ) and cmn.IsEventDone( "get_stone_lvl4" ) and cmn.IsEventDone( "get_honk" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_driver_seat" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_driver_seat_use_screwdriver_lvl4" ) and cmn.IsEventDone( "get_stone_lvl4" ) and cmn.IsEventDone( "get_honk" ) ) then

    cmn.CallEventHandler( "use_screwdriver_lvl4_inv" );
    cmn.CallEventHandler( "use_screwdriver_lvl4_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_screwdriver_lvl4" );
        cmn.CallEventHandler( "use_screwdriver_lvl4_end" );

      end;
      
      ObjAnimate( "spr_driver_seat_door", "alp", 0, 0, func_end_2, {
        0.0, 0, ObjGet( "spr_driver_seat_door" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "anm_driver_seat_screwdriver", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "anm_driver_seat_screwdriver" ).alp,
        0.3, 0, 0,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_screwdriwer_4lvl", 0, "", 0 );

    ObjMultiSet( { 
      { "spr_driver_seat_door_2",      { alp = 0 } },
      { "anm_driver_seat_screwdriver", { alp = 1 } },
    } );
    AnimPlay( "anm_driver_seat_screwdriver", "screwdriver", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_glove_compartment_key ()

  local item = "inv_glove_compartment_key";

  if ( cmn.ApplyObj( item, "gzz_backyard_driver_seat" ) and cmn.IsEventDone( "use_screwdriver_lvl4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_driver_seat" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_driver_seat_use_glove_compartment_key" ) and cmn.IsEventDone( "use_screwdriver_lvl4" ) ) then

    cmn.CallEventHandler( "use_glove_compartment_key_inv" );
    cmn.CallEventHandler( "use_glove_compartment_key_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_glove_compartment_key" );
        cmn.CallEventHandler( "use_glove_compartment_key_end" );

      end;

      ObjAnimate( "anm_driver_seat_key", "alp",0,0, func_end_2, { 
        0.0, 0, ObjGet( "anm_driver_seat_key" ).alp, 
        0.3, 0, 0,
      } );
      ObjAnimate( "spr_driver_seat_compartment_2", "alp",0,0, "", { 
        0.0, 0, ObjGet( "spr_driver_seat_compartment_2" ).alp, 
        0.3, 0, 1,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_tranksmall_4lvl", 0, "", 0 );

    ObjSet( "anm_driver_seat_key", { alp = 1 } )
    AnimPlay( "anm_driver_seat_key", "key", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_chain_lvl4 ()

  local item = "inv_chain_lvl4";

  if ( cmn.ApplyObj( item, "gzz_backyard_telephone_box" ) and cmn.IsEventDone( "clk_chain_lvl4_1" ) and cmn.IsEventDone( "clk_chain_lvl4_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_telephone_box" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_telephone_box_use_chain_lvl4" )  and cmn.IsEventDone( "clk_chain_lvl4_1" ) and cmn.IsEventDone( "clk_chain_lvl4_2" )) then

    cmn.CallEventHandler( "use_chain_lvl4_inv" );
    cmn.CallEventHandler( "use_chain_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_chain_lvl4" );
      cmn.CallEventHandler( "use_chain_lvl4_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_chain_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_telephone_chain", func_end, -1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_alarm_double_key ()

  local item = "inv_alarm_double_key";

  if ( cmn.ApplyObj( item, "gzz_backyard_telephone_box" ) and cmn.IsEventDone( "clk_chain_lvl4_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_telephone_box" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_telephone_box_use_alarm_double_key" ) and cmn.IsEventDone( "clk_chain_lvl4_3" ) ) then

    cmn.CallEventHandler( "use_alarm_double_key_inv" );
    cmn.CallEventHandler( "use_alarm_double_key_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_alarm_double_key" );
      cmn.CallEventHandler( "use_alarm_double_key_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_key3_4lvl", 0, "", 0 );

    AnimPlay( "anm_telephone_key", "key", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cross_2_lvl4 ()

  local item = "inv_cross_2_lvl4";

  if ( cmn.ApplyObj( item, "gzz_backyard_backdoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_backdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_backdoor_use_cross_2_lvl4" ) ) then

    cmn.CallEventHandler( "use_cross_2_lvl4_inv" );
    cmn.CallEventHandler( "use_cross_2_lvl4_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_cross_2_lvl4" );
        cmn.CallEventHandler( "use_cross_2_lvl4_end" );

      end;

      ObjAnimate( "spr_backdoor_open_2", "alp", 0, 0, func_end_2, {
        0.0, 0, ObjGet( "spr_backdoor_open_2" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_backdoor_door_2", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_backdoor_door_2" ).alp,
        0.3, 0, 0,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_box_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_backdoor_cross_2", func_end, -1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wooden_handle ()

  local item = "inv_wooden_handle";

  if ( cmn.ApplyObj( item, "gzz_backyard_backdoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_backdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_backdoor_use_wooden_handle" ) ) then

    cmn.CallEventHandler( "use_wooden_handle_inv" );
    cmn.CallEventHandler( "use_wooden_handle_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_wooden_handle" );
      cmn.CallEventHandler( "use_wooden_handle_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_handle_screwdriwer_4lvl", 0, "", 0 );

    --cmn.ItemFly( "spr_backdoor_screwdriver_2", func_end, 0.5 );
    ObjSet( "vid_backdoor_screwdriver_lvl4", { alp = 1 } );
    VidPlay( "vid_backdoor_screwdriver_lvl4", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cross_1_lvl4 ()

  local item = "inv_cross_1_lvl4";

  if ( cmn.ApplyObj( item, "gzz_backyard_backdoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_backdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_backdoor_use_cross_1_lvl4" ) ) then

    cmn.CallEventHandler( "use_cross_1_lvl4_inv" );
    cmn.CallEventHandler( "use_cross_1_lvl4_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_cross_1_lvl4" );
        cmn.CallEventHandler( "use_cross_1_lvl4_end" );

      end;

      ObjAnimate( "spr_backdoor_open_3", "alp", 0, 0, func_end_2, {
        0.0, 0, ObjGet( "spr_backdoor_open_3" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_backdoor_door_3", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_backdoor_door_3" ).alp,
        0.3, 0, 0,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_box_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_backdoor_cross_3", func_end, -1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_plate ()

  local item = "inv_plate";

  if ( cmn.ApplyObj( item, "gzz_backyard_backdoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_backdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_backdoor_use_plate" ) ) then

    cmn.CallEventHandler( "use_plate_inv" );
    cmn.CallEventHandler( "use_plate_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_plate" );
        cmn.CallEventHandler( "use_plate_end" );

      end;

      ObjAnimate( "spr_backdoor_cap", "pos_xy", 0, 0, func_end_2, {
        0.0, 0, ObjGet( "spr_backdoor_cap" ).pos_x, ObjGet( "spr_backdoor_cap" ).pos_y,
        0.3, 0,  -95, 127,
        0.6, 0, -417, 177,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_small_box_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_backdoor_amulet", func_end, -0.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cross_3_lvl4 ()

  local item = "inv_cross_3_lvl4";

  if ( cmn.ApplyObj( item, "gzz_backyard_backdoor" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_backdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_backdoor_use_cross_3_lvl4" ) ) then

    cmn.CallEventHandler( "use_cross_3_lvl4_inv" );
    cmn.CallEventHandler( "use_cross_3_lvl4_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_cross_3_lvl4" );
        cmn.CallEventHandler( "use_cross_3_lvl4_end" );

      end;

      ObjAnimate( "spr_backdoor_open_1", "alp", 0, 0, func_end_2, {
        0.0, 0, ObjGet( "spr_backdoor_open_1" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_backdoor_door_1", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_backdoor_door_1" ).alp,
        0.3, 0, 0,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_box_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_backdoor_cross_1", func_end, -1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_planks ()

  local item = "inv_planks";

  if ( cmn.ApplyObj( item, "gzz_backyard_roof" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roof" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roof_use_planks" ) ) then

    cmn.CallEventHandler( "use_planks_inv" );
    cmn.CallEventHandler( "use_planks_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_planks" );
      cmn.CallEventHandler( "use_planks_end" );
      common.CloseSubRoom();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_steps_4lvl", 0, "", 0 );

    ObjAnimate( "spr_roof_stick_1", "alp", 0, 0, "", {
      0.0, 0, ObjGet( "spr_roof_stick_1" ).alp,  0.3, 0,  1,} );
    ObjAnimate( "spr_roof_stick_2", "alp", 0, 0, "", {
      0.0, 0, ObjGet( "spr_roof_stick_2" ).alp,  0.3, 0,  1,} );
    ObjAnimate( "spr_roof_stick_3", "alp", 0, 0, "", {
      0.0, 0, ObjGet( "spr_roof_stick_3" ).alp,  0.3, 0,  1, } );

    ObjAnimate( "spr_roof_stick_1", "pos_xy", 0, 0, func_end, {
      0.0, 0, ObjGet( "spr_roof_stick_1" ).pos_x, ObjGet( "spr_roof_stick_1" ).pos_y,
      0.3, 0, ObjGet( "spr_roof_stick_1" ).pos_x, ObjGet( "spr_roof_stick_1" ).pos_y,
      0.6, 0, -154, 278,
    } );
    ObjAnimate( "spr_roof_stick_2", "pos_xy", 0, 0, "", {
      0.0, 0, ObjGet( "spr_roof_stick_2" ).pos_x, ObjGet( "spr_roof_stick_2" ).pos_y,
      0.3, 0, ObjGet( "spr_roof_stick_2" ).pos_x, ObjGet( "spr_roof_stick_2" ).pos_y,
      0.6, 0, -131, 127,
    } );    
    ObjAnimate( "spr_roof_stick_3", "pos_xy", 0, 0, "", {
      0.0, 0, ObjGet( "spr_roof_stick_3" ).pos_x, ObjGet( "spr_roof_stick_3" ).pos_y,
      0.3, 0, ObjGet( "spr_roof_stick_3" ).pos_x, ObjGet( "spr_roof_stick_3" ).pos_y,
      0.6, 0, -112, -47,
    } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_handle_lvl4 ()

  local item = "inv_handle_lvl4";

  if ( cmn.ApplyObj( item, "gzz_backyard_roof" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roof" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roof_use_handle_lvl4" ) ) then

    cmn.CallEventHandler( "use_handle_lvl4_inv" );
    cmn.CallEventHandler( "use_handle_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_handle_lvl4" );
      cmn.CallEventHandler( "use_handle_lvl4_end" );

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_part", 0, "", 0 );

    end;

    cmn.Lock( true );
    AnimPlay( "anm_roof_rake", "rake", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_letter_lvl4 ()

  local item = "inv_letter_lvl4";

  if ( cmn.ApplyObj( item, "gzz_backyard_roof" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roof" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roof_use_letter_lvl4" ) ) then

    cmn.CallEventHandler( "use_letter_lvl4_inv" );
    cmn.CallEventHandler( "use_letter_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_letter_lvl4" );
      cmn.CallEventHandler( "use_letter_lvl4_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_w_letter_4lvl", 0, "", 0 );

    AnimPlay( "anm_roof_letter", "letter", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_round_key ()

  local item = "inv_round_key";

  if ( cmn.ApplyObj( item, "gzz_backyard_roof" ) and cmn.IsEventDone( "get_scheme_piece_6" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roof" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roof_use_round_key" ) and cmn.IsEventDone( "get_scheme_piece_6" ) ) then

    cmn.CallEventHandler( "use_round_key_inv" );
    cmn.CallEventHandler( "use_round_key_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_round_key" );
        cmn.CallEventHandler( "use_round_key_end" );

      end;

      ObjAnimate( "spr_roof_hatch_2", "pos_xy", 0, 0, func_end_2, {
        0.0, 0, ObjGet( "spr_roof_hatch_2" ).pos_x,ObjGet( "spr_roof_hatch_2" ).pos_y,
        0.3, 0, 336, 148,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_key2_4lvl", 0, "", 0 );

    AnimPlay( "anm_roof_key", "key", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_honk ()

  local item = "inv_honk";

  if ( cmn.ApplyObj( item, "obj_backyard_use_honk" ) ) then

    cmn.CallEventHandler( "use_honk_inv" );
    cmn.CallEventHandler( "use_honk_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_honk" );
      cmn.CallEventHandler( "use_honk_end" );

      private.get_feathers_lvl4 ();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_klaxon", 0, "", 0 );

    ObjMultiSet({ 
      { "anm_backyard_crow",      { alp = 0 }},
      { "anm_backyard_crow_toot", { alp = 1 }},
    });
    AnimPlay( "anm_backyard_crow_toot", "crow_toot", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_honk ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_honk" );
  cmn.CallEventHandler( "get_honk" );

end;
--------------------------------------------------------------------------------------------
function private.get_stone_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stone_lvl4" );
  cmn.CallEventHandler( "get_stone_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_box_wrench ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_box_wrench" );
  cmn.CallEventHandler( "get_box_wrench" );

end;
--------------------------------------------------------------------------------------------
function private.get_decor_part_3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_decor_part_3" );
  cmn.CallEventHandler( "get_decor_part_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_recipe ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_recipe" );
  cmn.CallEventHandler( "get_recipe" );

  if ( cmn.IsGetCollect2( "get_collect2_item_28" ) ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_cross_1_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cross_1_lvl4" );
  cmn.CallEventHandler( "get_cross_1_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_sal_ammoniac ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sal_ammoniac" );
  cmn.CallEventHandler( "get_sal_ammoniac" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_sprinkler ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sprinkler" );
  cmn.CallEventHandler( "get_sprinkler" );

end;
--------------------------------------------------------------------------------------------
function private.get_screwdriver_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_screwdriver_lvl4" );
  cmn.CallEventHandler( "get_screwdriver_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_gargoyle_statuette ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_gargoyle_statuette" );
  cmn.CallEventHandler( "get_gargoyle_statuette" );

end;
--------------------------------------------------------------------------------------------
function private.get_scalpel ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scalpel" );
  cmn.CallEventHandler( "get_scalpel" );

end;
--------------------------------------------------------------------------------------------
function private.get_rake ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rake" );
  cmn.CallEventHandler( "get_rake" );

end;
--------------------------------------------------------------------------------------------
function private.get_scheme_piece_6 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scheme_piece_6" );
  cmn.CallEventHandler( "get_scheme_piece_6" );

end;
--------------------------------------------------------------------------------------------
function private.get_plate ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_plate" );
  cmn.CallEventHandler( "get_plate" );

end;
--------------------------------------------------------------------------------------------
function private.get_feathers_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_feathers_lvl4" );
  cmn.CallEventHandler( "get_feathers_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_28 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_28" ); 

  end;

  common_impl.PlayEffectHO( "spr_telephone_box_collect2_item_28", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_28" );
  
  if ( cmn.IsEventDone( "get_recipe" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_chain_lvl4_1 ()
  
  cmn.CallEventHandler( "clk_chain_lvl4_1_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_chain_lvl4_1" );
    cmn.CallEventHandler( "clk_chain_lvl4_1_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_opn_wood_4lvl", 0, "", 0 );
  
  ObjAnimate( "spr_telephone_door_2", "pos_xy",0,0, func_end, { 
    0.0, 0, ObjGet( "spr_telephone_door_2" ).pos_x, ObjGet( "spr_telephone_door_2" ).pos_y, 
    0.3, 0, 113, 443,
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_chain_lvl4_2 ()
  
  cmn.CallEventHandler( "clk_chain_lvl4_2_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_chain_lvl4_2" );
    cmn.CallEventHandler( "clk_chain_lvl4_2_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_chain", 0, "", 0 );
  
  ObjAnimate( "spr_telephone_rusty_chain", "pos_xy",0,0, func_end, { 
    0.0, 0, ObjGet( "spr_telephone_rusty_chain" ).pos_x, ObjGet( "spr_telephone_rusty_chain" ).pos_y, 
    0.3, 0, -296, 189,
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_chain_lvl4_3 ()
  
  cmn.CallEventHandler( "clk_chain_lvl4_3_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_chain_lvl4_3" );
    cmn.CallEventHandler( "clk_chain_lvl4_3_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_wood_old_door", 0, "", 0 );
  
  ObjAnimate( "spr_telephone_door", "alp",0,0, func_end, { 
    0.0, 0, ObjGet( "spr_telephone_door" ).alp, 
    0.3, 0, 0,
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_alarm_double_key ()
  
  cmn.CallEventHandler( "clk_alarm_double_key_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_alarm_double_key" );
    cmn.CallEventHandler( "clk_alarm_double_key_end" ); 

    AnimPlay( "anm_telephone_bell", "bell", "" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_box_alarm_4lvl", 0, "", 0 );

  ObjAnimate( "anm_telephone_key", "alp",0,0, func_end, { 
    0.0, 0, ObjGet( "anm_telephone_key" ).alp, 
    0.3, 0, 0,
  } );
  ObjAnimate( "spr_telephone_door_3", "alp",0,0, "", { 
    0.0, 0, ObjGet( "spr_telephone_door_3" ).alp, 
    0.3, 0, 1,
  } );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )  
end;
--------------------------------------------------------------------------------------------
function private.see_backyard_gangsters ()

  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "levelext/voc/aud_backyard_gangsters_voc",  0.2 );
      common_impl.StopAudio( "sfx", "levelext/sfx/aud_backyard_gangsters",      0.2 );
      
    end;

    cmn.SetEventDone( "see_backyard_gangsters" );
    cmn.CallEventHandler( "see_backyard_gangsters" );

    common_impl.ShowBbt( 'bbt_backyard_see_gangsters' );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl4_get_to_holel" );

    private.see_backyard_bandits_away ();
    
  end;

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_backyard_gangsters",      0, "", 0 );
  common_impl.PlayAudio( "voc", "levelext/voc/aud_backyard_gangsters_voc",  0, "", 0 );
  
  cmn.PlayDialogVideo( "vid_backyard_gangsters", func_end );
  
end;
--*********************************************************************************************************************
function private.see_backyard_anim_backyard_1 ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_backyard_anim_backyard_1" );
    cmn.CallEventHandler( "see_backyard_anim_backyard_1" );

    common_impl.ShowBbt( 'bbt_backyard_anim_backyard_1' );
    
    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl4_rescue_girl" );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_zoom2_4lvl", 0, "", 0 );
  
  ObjAnimate( private.room_objname, "pos_xy", 0, 0, "", {
    0,   0,  0,    0,
    0.2, 1, -346, -18,
    2.0, 3, -347, -19,
    2.7, 3, -346, -18,
    3.0, 3,  0,    0,
  } );
  
  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "", {
    0,   0, 1,   1,
    0.2, 1, 1.3, 1.3,
    2.7,   3, 1.3, 1.3,
    3.0, 3, 1,   1,
  } );
  
  AnimPlay( "anm_backyard_anim", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
function private.see_backyard_bandits_away ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_backyard_bandits_away" );
    cmn.CallEventHandler( "see_backyard_bandits_away" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );

  AnimPlay( "anm_backyard_bandits_away", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_backyard ()

  if not ( cmn.IsEventDone( "opn_backyard" ) ) then

    cmn.SetEventDone( "opn_backyard" );
    common_impl.ShowBbt( 'bbt_backyard_opn_backyard' );

    private.see_backyard_gangsters ();

  end;
  cmn.CallEventHandler( "opn_backyard" ); 
  
end;

-----------------------------------------------------------------------------------------------------------------------

function private.ScalePaper ()

  cmn.NoteScale( "spr_telephone_box_recipe1", "obj_telephone_box_recipe" );
  
end;

-----------------------------------------------------------------------------------------------------------------------

function private.TurnPaper ()

  local func_end = function()
  
    cmn.Lock( false );
    
    ObjMultiSet( {
    
      { "spr_telephone_box_recipe", { input = true; } },
      { "spr_telephone_box_recipe2", { input = false; } },
    
    } );
    
    ObjSet( "spr_telephone_box_recipe", { input = true; } )
    
    common_impl.ShowBbt( 'bbt_telephone_box_recipe1_turn' );
  
  end;
  
  cmn.Lock( true );
  
  ObjAnimate( "spr_telephone_box_recipe2", "scale_x", 0, 0, "", { 0, 0, 0.8,   0.3, 3, 0 } );
  ObjAnimate( "spr_telephone_box_recipe", "scale_x", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 0,   0.6, 3, 0.8 } );
  
end;

--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseChainLvl4 ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_telephone_box_use_chain_lvl4' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_low_door", 0, "", 0 );
  
  ObjAnimate( "spr_telephone_door", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,-2,2,  0.4,3,0,0 });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUsePlate ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_backdoor_use_plate' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx", 0, "", 0 );

  if cmn.IsEventDone( "get_screwdriver_lvl4" ) then
  
    ObjAnimate( "spr_backdoor_cap", "pos_y", 0, 1, func_end, { 0.0,0,0,  0.2,3,2,  0.4,3,0 });

  else func_end();
  end;

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseWoodenHandle ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_backdoor_use_wooden_handle' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_clk_screwdriwer_4lvl", 0, "", 0 );
  
  ObjAnimate( "spr_backdoor_screwdriver_lvl4", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,2,-2,  0.4,3,0,0 });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseCross ( number )

  local temp_number;

      if number == 1 then temp_number = 3
  elseif number == 3 then temp_number = 1
  else                    temp_number = number
  end;

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_backdoor_use_cross_"..temp_number.."_lvl4" );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_door_small", 0, "", 0 );
  
  ObjAnimate( "spr_backdoor_door_"..temp_number, "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,-2,2,  0.4,3,0,0 });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUsePlanks ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_roof_use_planks' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_wood2", 0, "", 0 );
  
  ObjAnimate( "spr_roof_stairs", "pos_y", 0, 1, func_end, { 0.0,0,0,  0.2,3,2,  0.4,3,0 });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseRoundKey ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_roof_use_round_key' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_use_stone3", 0, "", 0 );
  
  ObjAnimate( "spr_roof_hatch_2", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,2,-2,  0.4,3,0,0 });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseLetterLvl4 ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_roof_use_letter_lvl4' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_stone_door", 0, "", 0 );
  
  ObjAnimate( "anm_roof_letter", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,2,-2,  0.4,3,0,0 });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseScrewdriverLvl4 ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_driver_seat_use_screwdriver_lvl4' );
  
  end;

  cmn.Lock( true );
  
  if( cmn.IsEventDone( "get_stone_lvl4" ) ) then  

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_clk_car", 0, "", 0 );
    ObjAnimate( "spr_driver_seat_door_2", "scale_x", 0, 0, func_end, { 0.0, 0, 1,  0.2, 0, 0.99,  0.4, 0, 1, });

  else func_end();
  end;

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseSprinkler ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_driver_seat_use_sprinkler' );
  
  end;

  cmn.Lock( true );

  if( cmn.IsEventDone( "get_stone_lvl4" ) ) then  

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_high2", 0, "", 0 );
    ObjAnimate( "spr_driver_seat_honk", "ang", 0, 0, func_end, { 0.0, 0, 0,  0.2, 0, -0.1,  0.4, 0, 0, });

  else func_end();
  end;

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseGloveCompartmentKey ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_driver_seat_use_glove_compartment_key' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_metal2_mid", 0, "", 0 );
 
  ObjAnimate( "anm_driver_seat_key", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,0,2,-2,  0.4,0,0,0, });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseArmchairLever ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_driver_seat_use_armchair_lever' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_clk_chair_4lvl", 0, "", 0 );
 
  ObjAnimate( "spr_driver_seat_armchair", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,0,2,2,  0.4,0,0,0, });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseHandleLvl4 ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_roof_use_handle_lvl4' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_wick", 0, "", 0 );
 
  ObjAnimate( "anm_roof_rake", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,0,-2,-2,  0.4,0,0,0, });

end;
-----------------------------------------------------------------------------------------------------------------------