-- name=rm_graveyard
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_graveyard";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_crypt_door", "room_hub" );
  ObjAttach( "zz_tombstone",  "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_crypt_door_stone_triangle",        { event_mdown = private.get_stone_triangle             }},
    { "spr_crypt_door_glove_compartment_key", { event_mdown = private.get_glove_compartment_key      }},
    { "obj_crypt_door_clk_open",              { event_mdown = private.clk_crypt_door                 }},

    { "spr_tombstone_letter_lvl4",            { event_mdown = private.get_letter_lvl4                }},
    { "spr_tombstone_flag_lvl4",              { event_mdown = private.get_flag_lvl4                  }},
    { "obj_tombstone_use_chisel_lvl4",        { event_mdown = private.TombstoneUseChiselLvl4         }},

    { "spr_graveyard_screcrow_outfit",        { event_mdown = private.get_screcrow_outfit            }},
    { "obj_graveyard_clk_anim_graveyard_1",   { event_mdown = private.see_graveyard_anim_graveyard_1 }},
    { "obj_graveyard_use_spade",              { event_mdown = private.AnimUseSpade                   }},
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_graveyard = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gmg_graveyard_catacombs_fear",
      "gzz_graveyard_crypt_door",
      "gzz_graveyard_tombstone"
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_crypt_door",
      "zz_tombstone",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_graveyard", update_game_mode_graveyard, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_graveyard = function ()

    local effects_table = 
    {
      "obj_graveyard_anim",
      "anm_graveyard_fireflies" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_graveyard", update_performance_mode_graveyard, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_graveyard () end;
  --------------------------------------------------------------------------------------------
  local opn_graveyard_map = function ()

    common_impl.VisitMapRoom( "graveyard" );

  end;
  cmn.AddSubscriber( "opn_graveyard", opn_graveyard_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_stone_triangle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stone_triangle" ] = {
    type = "get",
    get_obj = "spr_crypt_door_stone_triangle",
    room = private.room_objname,
    zz = "zz_crypt_door",
    zz_gate = "gzz_graveyard_crypt_door"
  };
  
  local get_stone_triangle_inv = function ()
  
    interface.InventoryItemAdd( "inv_stone_triangle", "spr_crypt_door_stone_triangle" );
  
  end;
  
  local get_stone_triangle_closezz = function ()
  
    ObjDelete( "gfx_crypt_door_stone_triangle" );
    ObjSet( "obj_crypt_door_clk_open", { input = true } );
    
  end;
  
  cmn.AddSubscriber( "get_stone_triangle", get_stone_triangle_inv );
  cmn.AddSubscriber( "get_stone_triangle", get_stone_triangle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glove_compartment_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glove_compartment_key" ] = {
    type = "get",
    get_obj = "obj_crypt_hint",
    room = private.room_objname,
    zz = "zz_crypt_door",
    zz_gate = "gzz_graveyard_crypt_door"
  };
  
  local get_glove_compartment_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_glove_compartment_key", "spr_crypt_door_glove_compartment_key" );
  
  end;
  
  local get_glove_compartment_key_closezz = function ()
  
    ObjDelete( "gfx_crypt_door_glove_compartment_key" );
    ObjDelete( "spr_crypt_patch_key" );
    
  end;
  
  cmn.AddSubscriber( "get_glove_compartment_key", get_glove_compartment_key_inv );
  cmn.AddSubscriber( "get_glove_compartment_key", get_glove_compartment_key_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_letter_lvl4" ] = {
    type = "get",
    get_obj = "spr_tombstone_letter_lvl4",
    room = private.room_objname,
    zz = "zz_tombstone",
    zz_gate = "gzz_graveyard_tombstone"
  };
  
  local get_letter_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter_lvl4", "spr_tombstone_letter_lvl4" );
  
  end;
  
  local get_letter_lvl4_closezz = function ()
  
    ObjDelete( "gfx_tombstone_letter_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_letter_lvl4", get_letter_lvl4_inv );
  cmn.AddSubscriber( "get_letter_lvl4", get_letter_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flag_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flag_lvl4" ] = {
    type = "get",
    get_obj = "spr_tombstone_flag_lvl4",
    room = private.room_objname,
    zz = "zz_tombstone",
    zz_gate = "gzz_graveyard_tombstone"
  };
  
  local get_flag_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_flag_lvl4", "spr_tombstone_flag_lvl4" );
  
  end;
  
  local get_flag_lvl4_closezz = function ()
  
    ObjDelete( "gfx_tombstone_flag_lvl4" );
    ObjDelete( "gzz_graveyard_tombstone" );
  
  end;
  
  cmn.AddSubscriber( "get_flag_lvl4", get_flag_lvl4_inv );
  cmn.AddSubscriber( "get_flag_lvl4", get_flag_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screcrow_outfit () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screcrow_outfit" ] = {
    type = "get",
    get_obj = "spr_graveyard_screcrow_outfit",
    room = private.room_objname,
  };
  
  local get_screcrow_outfit_inv = function ()
  
    interface.InventoryItemAdd( "inv_screcrow_outfit", "spr_graveyard_screcrow_outfit" );
  
  end;
  
  local get_screcrow_outfit_closezz = function ()
  
    ObjDelete( "gfx_graveyard_screcrow_outfit" );
  
  end;
  
  cmn.AddSubscriber( "get_screcrow_outfit", get_screcrow_outfit_inv );
  cmn.AddSubscriber( "get_screcrow_outfit", get_screcrow_outfit_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_crypt_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_crypt_door" ] = {
    type = "click",
    use_place = "obj_crypt_door_clk_open",
    room = private.room_objname,
    zz = "zz_crypt_door",
    zz_gate = "gzz_graveyard_crypt_door"
  };
  
  local clk_crypt_door_beg = function ()

    ObjDelete( "obj_crypt_door_clk_open" );
  
  end;
  local clk_crypt_door_end = function ()

    ObjMultiSet( { 
      { "obj_crypt_door_use_dungeon",     { input = true           } },
      { "anm_crypt_doors",                {   alp = 1, frame = 300 } },
      { "spr_graveyard_door_open_inside", {   alp = 1              } },
    } );
    ObjDelete( "spr_crypt_door_patch_triangle" );  
    ObjDelete( "spr_graveyard_door" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_crypt_door",     clk_crypt_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_crypt_door",     clk_crypt_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_crypt_door_beg", clk_crypt_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_crypt_door_end", clk_crypt_door_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function use_dungeon () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dungeon" ] = {
    type = "use",
    inv_obj = "inv_dungeon",
    use_place = "obj_crypt_door_use_dungeon",
    room = private.room_objname,
    zz = "zz_crypt_door",
    zz_gate = "gzz_graveyard_crypt_door"
  };
  local use_dungeon_inv = function ()
  
    interface.InventoryItemRemove( "inv_dungeon" );
  
  end;
  local use_dungeon_beg = function ()
  
    ObjDelete( "obj_crypt_door_use_dungeon" );
  
  end;
  local use_dungeon_end = function ()
  
    ObjDelete( "gzz_graveyard_crypt_door" );
    ObjSet( "gmg_graveyard_catacombs_fear", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dungeon", use_dungeon_beg, private.room_objname );
  cmn.AddSubscriber( "use_dungeon", use_dungeon_inv );
  cmn.AddSubscriber( "use_dungeon", use_dungeon_end, private.room_objname );
  cmn.AddSubscriber( "use_dungeon_inv", use_dungeon_inv, private.room_objname );
  cmn.AddSubscriber( "use_dungeon_beg", use_dungeon_beg, private.room_objname );
  cmn.AddSubscriber( "use_dungeon_end", use_dungeon_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tongs_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tongs_lvl4" ] = {
    type = "use",
    inv_obj = "inv_tongs_lvl4",
    use_place = "obj_crypt_door_use_tongs_lvl4",
    room = private.room_objname,
    zz = "zz_crypt_door",
    zz_gate = "gzz_graveyard_crypt_door"
  };
  local use_tongs_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_tongs_lvl4" );
  
  end;
  local use_tongs_lvl4_beg = function ()
  
    ObjDelete( "obj_crypt_door_use_tongs_lvl4" );
  
  end;
  local use_tongs_lvl4_end = function ()
    
    ObjDelete( "anm_crypt_nipper" );  
    ObjMultiSet( { 
      { "spr_crypt_door_glove_compartment_key", {  input = true, alp = 1 } },
      { "gfx_crypt_door_glove_compartment_key", { active = true          } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tongs_lvl4", use_tongs_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs_lvl4", use_tongs_lvl4_inv );
  cmn.AddSubscriber( "use_tongs_lvl4", use_tongs_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_tongs_lvl4_inv", use_tongs_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_tongs_lvl4_beg", use_tongs_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs_lvl4_end", use_tongs_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gargoyle_statuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gargoyle_statuette" ] = {
    type = "use",
    inv_obj = "inv_gargoyle_statuette",
    use_place = "obj_tombstone_use_gargoyle_statuette",
    room = private.room_objname,
    zz = "zz_tombstone",
    zz_gate = "gzz_graveyard_tombstone"
  };
  local use_gargoyle_statuette_inv = function ()
  
    interface.InventoryItemRemove( "inv_gargoyle_statuette" );
  
  end;
  local use_gargoyle_statuette_beg = function ()
  
    ObjDelete( "obj_tombstone_use_gargoyle_statuette" );
  
  end;
  local use_gargoyle_statuette_end = function ()
  
    ObjMultiSet( { 
      { "spr_tombstone_flag_lvl4",  { input = true } },
      { "spr_tombstone_tombstone",  { pos_x = 111, pos_y = 175 } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gargoyle_statuette", use_gargoyle_statuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoyle_statuette", use_gargoyle_statuette_inv );
  cmn.AddSubscriber( "use_gargoyle_statuette", use_gargoyle_statuette_end, private.room_objname );
  cmn.AddSubscriber( "use_gargoyle_statuette_inv", use_gargoyle_statuette_inv, private.room_objname );
  cmn.AddSubscriber( "use_gargoyle_statuette_beg", use_gargoyle_statuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoyle_statuette_end", use_gargoyle_statuette_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chisel_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel_lvl4" ] = {
    type = "use",
    inv_obj = "inv_chisel_lvl4",
    use_place = "obj_tombstone_use_chisel_lvl4",
    room = private.room_objname,
    zz = "zz_tombstone",
    zz_gate = "gzz_graveyard_tombstone"
  };
  local use_chisel_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_chisel_lvl4" );
  
  end;
  local use_chisel_lvl4_beg = function ()
  
    ObjDelete( "obj_tombstone_use_chisel_lvl4" );
  
  end;
  local use_chisel_lvl4_end = function ()
  
    ObjDelete( "anm_tombstone_use_chisel_lvl4" );
    ObjMultiSet( { 
      { "spr_tombstone_letter_lvl4",  { alp = 1, visible = true, input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel_lvl4", use_chisel_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_lvl4", use_chisel_lvl4_inv );
  cmn.AddSubscriber( "use_chisel_lvl4", use_chisel_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_lvl4_inv", use_chisel_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_lvl4_beg", use_chisel_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_lvl4_end", use_chisel_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spade" ] = {
    type = "use",
    inv_obj = "inv_spade",
    use_place = "obj_graveyard_use_spade",
    room = private.room_objname,
  };
  local use_spade_inv = function ()
  
    interface.InventoryItemRemove( "inv_spade" );
  
  end;
  local use_spade_beg = function ()
  
    ObjDelete( "obj_graveyard_use_spade" );
  
  end;
  local use_spade_end = function ()

    ObjDelete( "anm_graveyard_scarecrow" );    
    ObjDelete( "anm_graveyard_scarecrow_shovel" );    
    
    ObjMultiSet({ 
      { "spr_graveyard_screcrow_outfit",  {  input = true }},
      { "anm_graveyard_drop",             {    alp = 1    }},
      { "anm_graveyard_shovel",           {    alp = 1    }},
      { "gfx_graveyard_screcrow_outfit",  { active = true }},
    });  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spade", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade", use_spade_inv );
  cmn.AddSubscriber( "use_spade", use_spade_end, private.room_objname );
  cmn.AddSubscriber( "use_spade_inv", use_spade_inv, private.room_objname );
  cmn.AddSubscriber( "use_spade_beg", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade_end", use_spade_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_graveyard_anim_graveyard_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_graveyard_anim_graveyard_1" ] = {
    type = "click",
    use_place = "obj_graveyard_clk_anim_graveyard_1",
    room = private.room_objname
  };

  local see_graveyard_anim_graveyard_1 = function ()

    ObjDelete( "obj_graveyard_clk_anim_graveyard_1" );
    ObjDelete( "anm_graveyard_anim" );
    ObjSet( "spr_graveyard_door", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_graveyard_anim_graveyard_1", see_graveyard_anim_graveyard_1, private.room_objname ); 

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_graveyard();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_graveyard_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();
  if not cmn.IsEventDone( "see_graveyard_anim_graveyard_1" ) then
    private.see_graveyard_anim_graveyard_1();
  end;
  
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()
  common_impl.StopAudio( "env", "levelext/env/aud_graveyard_env", 0.5 );
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_dungeon ()

  local item = "inv_dungeon";

  if ( cmn.ApplyObj( item, "gzz_graveyard_crypt_door" ) and cmn.IsEventDone( "clk_crypt_door" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crypt_door" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_crypt_door_use_dungeon" ) and cmn.IsEventDone( "clk_crypt_door" ) ) then

    cmn.CallEventHandler( "use_dungeon_inv" );
    cmn.CallEventHandler( "use_dungeon_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_dungeon" );
      cmn.CallEventHandler( "use_dungeon_end" );

      common.CloseSubRoom();
      cmn.GotoRoom( "mg_catacombs_fear" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_dungeon", 0, "", 0 );

    func_end();
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tongs_lvl4 ()

  local item = "inv_tongs_lvl4";

  if ( cmn.ApplyObj( item, "gzz_graveyard_crypt_door" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crypt_door" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_crypt_door_use_tongs_lvl4" ) ) then

    cmn.CallEventHandler( "use_tongs_lvl4_inv" );
    cmn.CallEventHandler( "use_tongs_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_tongs_lvl4" );
      cmn.CallEventHandler( "use_tongs_lvl4_end" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_tweezers3_4lvl", 0, "", 0 );
    
    AnimPlay( "anm_crypt_nipper", "nipper", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_gargoyle_statuette ()

  local item = "inv_gargoyle_statuette";

  if ( cmn.ApplyObj( item, "gzz_graveyard_tombstone" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tombstone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tombstone_use_gargoyle_statuette" ) ) then

    cmn.CallEventHandler( "use_gargoyle_statuette_inv" );
    cmn.CallEventHandler( "use_gargoyle_statuette_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_gargoyle_statuette" );
      cmn.CallEventHandler( "use_gargoyle_statuette_end" );

    end;
    
    local func_end_2 = function ()
      
      ObjAnimate( "spr_tombstone_tombstone", "pos_xy",0,0, func_end, { 0, 3, 70, 84,    0.6, 3, 111, 175 } );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_gorgulie_head_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_tombstone_head", func_end_2, 1.22 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_chisel_lvl4 ()

  local item = "inv_chisel_lvl4";

  if ( cmn.ApplyObj( item, "gzz_graveyard_tombstone" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tombstone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tombstone_use_chisel_lvl4" ) ) then

    cmn.CallEventHandler( "use_chisel_lvl4_inv" );
    cmn.CallEventHandler( "use_chisel_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_chisel_lvl4" );
      cmn.CallEventHandler( "use_chisel_lvl4_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_chisel_4lvl", 0, "", 0 );

    AnimPlay( "anm_tombstone_use_chisel_lvl4", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_spade ()

  local item = "inv_spade";

  if ( cmn.ApplyObj( item, "obj_graveyard_use_spade" ) ) then

    cmn.CallEventHandler( "use_spade_inv" );
    cmn.CallEventHandler( "use_spade_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_spade" );
      cmn.CallEventHandler( "use_spade_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_shovel_4lvl", 0, "", 0 );
    
    ObjMultiSet({ 
      { "anm_graveyard_scarecrow",        { alp = 0 }},
      { "anm_graveyard_scarecrow_shovel", { alp = 1 }},
    });
  
    AnimPlay( "anm_graveyard_scarecrow_shovel", "things", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_stone_triangle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stone_triangle" );
  cmn.CallEventHandler( "get_stone_triangle" );

end;
--------------------------------------------------------------------------------------------
function private.get_glove_compartment_key ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_glove_compartment_key" );
  cmn.CallEventHandler( "get_glove_compartment_key" );

end;
--------------------------------------------------------------------------------------------
function private.get_letter_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_letter_lvl4" );
  cmn.CallEventHandler( "get_letter_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_flag_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_flag_lvl4" );
  cmn.CallEventHandler( "get_flag_lvl4" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_screcrow_outfit ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_screcrow_outfit" );
  cmn.CallEventHandler( "get_screcrow_outfit" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_crypt_door ()
  
  cmn.CallEventHandler( "clk_crypt_door_beg" );

  local func_end = function ()

    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_crypt_door" );
    cmn.CallEventHandler( "clk_crypt_door_end" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_door_crypt_4lvl", 0, "", 0 );
  ObjMultiSet({ 
    { "spr_crypt_door_patch_triangle", { alp = 0 }},
  });  
  AnimPlay( "anm_crypt_doors", "door", func_end )
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
end;
--*********************************************************************************************************************
function private.see_graveyard_anim_graveyard_1 ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_graveyard_anim_graveyard_1" );
    cmn.CallEventHandler( "see_graveyard_anim_graveyard_1" );

    common_impl.ShowBbt( 'bbt_graveyard_anim_graveyard_1' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_zoom_4lvl", 0, "", 0 );
  
  ObjAnimate( private.room_objname, "pos_xy", 0, 0, "", {
    0,   0,  0,    0,
    0.2, 1, 35, -106,
    2.0, 3, 34, -107,
    2.7, 3, 35, -106,
    3.0, 3,  0,    0,
  } );
  
  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "", {
    0,   0, 1,   1,
    0.2, 1, 1.3, 1.3,
    2.7,   3, 1.3, 1.3,
    3.0, 3, 1,   1,
  } );
  
  AnimPlay( "anm_graveyard_anim", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_graveyard ()

  if not ( cmn.IsEventDone( "opn_graveyard" ) ) then

    cmn.SetEventDone( "opn_graveyard" );
    common_impl.ShowBbt( 'bbt_graveyard_opn_graveyard' );

  end;
  cmn.CallEventHandler( "opn_graveyard" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TombstoneUseChiselLvl4 ()

  common_impl.ShowBbt( "bbt_tombstone_use_chisel_lvl4" );
  
  local obj = "spr_tombstone_tombstone";
  
  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_stone2", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  
end;

--------------------------------------------------------------------------------------------
function private.AnimUseSpade()
 
  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_graveyard_use_spade' );

    ObjMultiSet( { 
      { "anm_graveyard_scarecrow",    { alp = 1 } },
      { "anm_graveyard_scarecrow_hh", { alp = 0 } },
    } );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_clk_scarecrow_4lvl", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_graveyard_scarecrow",    { alp = 0 } },
    { "anm_graveyard_scarecrow_hh", { alp = 1 } },
  } );
  
  AnimPlay( "anm_graveyard_scarecrow_hh", "hh", func_end );

end;
--------------------------------------------------------------------------------------------