-- name=rm_hall_lvl4
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hall_lvl4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_stand_lvl4", "room_hub" );
  ObjAttach( "zz_power_box",  "room_hub" );
  ObjAttach( "zz_cart",       "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_stand_lvl4_key_lvl4",            { event_mdown = private.get_key_lvl4           }},
    { "spr_stand_lvl4_adhesive_bandage",    { event_mdown = private.get_adhesive_bandage   }},
    { "obj_stand_lvl4_use_hotel_symbol",    { event_mdown = private.AnimUseHotelSymbol     }},

    { "spr_power_box_scheme_piece_3",       { event_mdown = private.get_scheme_piece_3     }},
    { "spr_power_box_scheme_piece_5",       { event_mdown = private.get_scheme_piece_5     }},
    { "spr_power_box_bulb",                 { event_mdown = private.get_bulb               }},
    { "spr_power_box_chisel_lvl4",          { event_mdown = private.get_chisel_lvl4        }},
    { "obj_power_box_clk_adhesive_bandage", { event_mdown = private.clk_adhesive_bandage   }},
    { "obj_power_box_use_key_lvl4",         { event_mdown = private.AnimUseKeyLvl4         }},
    { "obj_power_box_use_adhesive_bandage", { event_mdown = private.AnimUseAdhesiveBandage }},

    { "spr_cart_scheme_piece_4",            { event_mdown = private.get_scheme_piece_4     }},
    { "spr_cart_tongs_lvl4",                { event_mdown = private.get_tongs_lvl4         }},
    { "obj_cart_clk_ring_lvl4",             { event_mdown = private.clk_ring_lvl4          }},
    { "obj_cart_use_ring_lvl4",             { event_mdown = private.AnimUseRingLvl4        }},

    { "spr_hall_lvl4_planks",               { event_mdown = private.get_planks             }},
    { "obj_hall_lvl4_clk_hall_picture",     { event_mdown = private.see_hall_picture       }},

    { "spr_hall_lvl4_collect_morph_item",   { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_19" ); end } },
      
    { "spr_stand_lvl4_collect2_item_26",    { event_mdown = private.get_collect2_item_26      }},
      
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_hall_lvl4 = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gzz_hall_lvl4_stand_lvl4",
      "gzz_hall_lvl4_power_box",
      "gzz_hall_lvl4_cart"
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_stand_lvl4",
      "zz_power_box",
      "zz_cart",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_hall_lvl4", update_game_mode_hall_lvl4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_hall_lvl4 = function ()

    local effects_table = 
    {
      "anm_hall_lvl4_all" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_hall_lvl4", update_performance_mode_hall_lvl4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_hall_lvl4 () end;
  --------------------------------------------------------------------------------------------
  local opn_hall_lvl4_map = function ()

    common_impl.VisitMapRoom( "hall_lvl4" );

  end;
  cmn.AddSubscriber( "opn_hall_lvl4", opn_hall_lvl4_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_19 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_19 = function ()
  
    ObjDelete( "obj_hall_lvl4_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_19", get_collect_morph_item_19, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_key_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_key_lvl4" ] = {
    type = "get",
    get_obj = "spr_stand_lvl4_key_lvl4",
    room = private.room_objname,
    zz = "zz_stand_lvl4",
    zz_gate = "gzz_hall_lvl4_stand_lvl4"
  };
  
  local get_key_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_key_lvl4", "spr_stand_lvl4_key_lvl4" );
  
  end;
  
  local get_key_lvl4_closezz = function ()
  
    ObjDelete( "gfx_stand_lvl4_key_lvl4"    );
    ObjDelete( "spr_hall_lvl4_zz_stand_key" );
  
  end;
  
  cmn.AddSubscriber( "get_key_lvl4", get_key_lvl4_inv );
  cmn.AddSubscriber( "get_key_lvl4", get_key_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_adhesive_bandage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_adhesive_bandage" ] = {
    type = "get",
    get_obj = "spr_stand_lvl4_adhesive_bandage",
    room = private.room_objname,
    zz = "zz_stand_lvl4",
    zz_gate = "gzz_hall_lvl4_stand_lvl4"
  };
  
  local get_adhesive_bandage_inv = function ()
  
    interface.InventoryItemAdd( "inv_adhesive_bandage", "spr_stand_lvl4_adhesive_bandage" );
  
  end;
  
  local get_adhesive_bandage_closezz = function ()
  
    ObjDelete( "gfx_stand_lvl4_adhesive_bandage" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_26" ) ) then
      
      ObjDelete( "gzz_hall_lvl4_stand_lvl4" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_adhesive_bandage", get_adhesive_bandage_inv );
  cmn.AddSubscriber( "get_adhesive_bandage", get_adhesive_bandage_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scheme_piece_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scheme_piece_3" ] = {
    type = "get",
    get_obj = "spr_power_box_scheme_piece_3",
    room = private.room_objname,
    zz = "zz_power_box",
    zz_gate = "gzz_hall_lvl4_power_box"
  };
  
  local get_scheme_piece_3_inv = function ()
  
    local count = 1;
    
    for i = 2, 6, 1 do
      
      if ( cmn.IsEventDone( "get_scheme_piece_"..i ) ) then
        
        count = count + 1;
        ObjSet( "inv_scheme_piece_"..i, { alp = 1 } );

      end;
      
    end;
  
    ObjSet( "inv_scheme_piece_number", { frame = ObjGet( "inv_scheme_piece_number" ).frame + 1 } );
    interface.InventoryItemAdd( "inv_scheme_piece", "spr_power_box_scheme_piece_3", "assets/levels/levelext/rm_hall_lvl4/zz_power_box/inv/inv_scheme_piece_3" );

    if count == 6 then
      ObjSet( "inv_scheme_piece", { drag = true } );
      
      cmn.SetInvPlusRGB( "paper_piece", true );
    else 
      ObjSet( "inv_scheme_piece", { drag = false } );
    end;  
    
  end;
  
  local get_scheme_piece_3_closezz = function ()
  
    ObjDelete( "gfx_power_box_scheme_piece_3"           );
    ObjDelete( "spr_hall_lvl4_zz_powerbox_papper_part3" );
    if cmn.IsEventDone( "get_scheme_piece_5" ) and cmn.IsEventDone( "get_chisel_lvl4" ) and cmn.IsEventDone( "get_scheme_piece_3" ) and
     ObjGet("gzz_hall_lvl4_power_box") then
      ObjDelete( "gzz_hall_lvl4_power_box" );
    end;
  end;
  
  cmn.AddSubscriber( "get_scheme_piece_3", get_scheme_piece_3_inv );
  cmn.AddSubscriber( "get_scheme_piece_3", get_scheme_piece_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scheme_piece_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scheme_piece_5" ] = {
    type = "get",
    get_obj = "spr_power_box_scheme_piece_5",
    room = private.room_objname,
    zz = "zz_power_box",
    zz_gate = "gzz_hall_lvl4_power_box"
  };
  
  local get_scheme_piece_5_inv = function ()
  
    local count = 1;
    
    for i = 2, 6, 1 do
      
      if ( cmn.IsEventDone( "get_scheme_piece_"..i ) ) then
        
        count = count + 1;
        ObjSet( "inv_scheme_piece_"..i, { alp = 1 } );
        
      end;
      
    end;
  
    ObjSet( "inv_scheme_piece_number", { frame = ObjGet( "inv_scheme_piece_number" ).frame + 1 } );
    interface.InventoryItemAdd( "inv_scheme_piece", "spr_power_box_scheme_piece_5", "assets/levels/levelext/rm_hall_lvl4/zz_power_box/inv/inv_scheme_piece_5" );

    if count == 6 then
      ObjSet( "inv_scheme_piece", { drag = true } );
      
      cmn.SetInvPlusRGB( "paper_piece", true );
    else 
      ObjSet( "inv_scheme_piece", { drag = false } );
    end;
    
  end;
  
  local get_scheme_piece_5_closezz = function ()
  
    ObjDelete( "gfx_power_box_scheme_piece_5"           );
    ObjDelete( "spr_hall_lvl4_zz_powerbox_papper_part5" );

    if cmn.IsEventDone( "get_scheme_piece_5" ) and cmn.IsEventDone( "get_chisel_lvl4" ) and cmn.IsEventDone( "get_scheme_piece_3" ) and
     ObjGet("gzz_hall_lvl4_power_box") then
      ObjDelete( "gzz_hall_lvl4_power_box" );
    end;
  end;
  
  cmn.AddSubscriber( "get_scheme_piece_5", get_scheme_piece_5_inv );
  cmn.AddSubscriber( "get_scheme_piece_5", get_scheme_piece_5_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bulb () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bulb" ] = {
    type = "get",
    get_obj = "spr_power_box_bulb",
    room = private.room_objname,
    zz = "zz_power_box",
    zz_gate = "gzz_hall_lvl4_power_box"
  };
  
  local get_bulb_inv = function ()
  
    interface.InventoryItemAdd( "inv_bulb", "spr_power_box_bulb" );
  
  end;
  
  local get_bulb_closezz = function ()
  
    ObjDelete( "gfx_power_box_bulb"              );
    ObjDelete( "spr_hall_lvl4_zz_powerbox_spray" );
  
  end;
  
  cmn.AddSubscriber( "get_bulb", get_bulb_inv );
  cmn.AddSubscriber( "get_bulb", get_bulb_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chisel_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chisel_lvl4" ] = {
    type = "get",
    get_obj = "spr_power_box_chisel_lvl4",
    room = private.room_objname,
    zz = "zz_power_box",
    zz_gate = "gzz_hall_lvl4_power_box"
  };
  
  local get_chisel_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_chisel_lvl4", "spr_power_box_chisel_lvl4" );
  
  end;
  
  local get_chisel_lvl4_closezz = function ()
  
    ObjDelete( "gfx_power_box_chisel_lvl4" );

    if cmn.IsEventDone( "get_scheme_piece_5" ) and cmn.IsEventDone( "get_chisel_lvl4" ) and cmn.IsEventDone( "get_scheme_piece_3" ) and
     ObjGet("gzz_hall_lvl4_power_box") then
      ObjDelete( "gzz_hall_lvl4_power_box" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_chisel_lvl4", get_chisel_lvl4_inv );
  cmn.AddSubscriber( "get_chisel_lvl4", get_chisel_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scheme_piece_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scheme_piece_4" ] = {
    type = "get",
    get_obj = "spr_cart_scheme_piece_4",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_hall_lvl4_cart"
  };
  
  local get_scheme_piece_4_inv = function ()
  
    local count = 1;
    
    for i = 2, 6, 1 do
      
      if ( cmn.IsEventDone( "get_scheme_piece_"..i ) ) then
        
        count = count + 1;
        ObjSet( "inv_scheme_piece_"..i, { alp = 1 } );

      end;
      
    end;
  
    ObjSet( "inv_scheme_piece_number", { frame = ObjGet( "inv_scheme_piece_number" ).frame + 1 } );
    interface.InventoryItemAdd( "inv_scheme_piece", "spr_cart_scheme_piece_4", "assets/levels/levelext/rm_hall_lvl4/zz_cart/inv/inv_scheme_piece_4" );

    if count == 6 then
      ObjSet( "inv_scheme_piece", { drag = true } );
      
      cmn.SetInvPlusRGB( "paper_piece", true );
    else 
      ObjSet( "inv_scheme_piece", { drag = false } );
    end;
    
  end;
  
  local get_scheme_piece_4_closezz = function ()
  
    ObjDelete( "gfx_cart_scheme_piece_4"           );
    ObjDelete( "spr_hall_lvl4_zz_cart_paper_piece" );

    if cmn.IsEventDone( "get_tongs_lvl4" ) then
      ObjDelete( "gzz_hall_lvl4_cart" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_scheme_piece_4", get_scheme_piece_4_inv );
  cmn.AddSubscriber( "get_scheme_piece_4", get_scheme_piece_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tongs_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tongs_lvl4" ] = {
    type = "get",
    get_obj = "spr_cart_tongs_lvl4",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_hall_lvl4_cart"
  };
  
  local get_tongs_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_tongs_lvl4", "spr_cart_tongs_lvl4" );
  
  end;
  
  local get_tongs_lvl4_closezz = function ()
  
    ObjDelete( "gfx_cart_tongs_lvl4"           );
    ObjDelete( "spr_hall_lvl4_zz_cart_forceps" );

    if cmn.IsEventDone( "get_scheme_piece_4" ) then
      ObjDelete( "gzz_hall_lvl4_cart" );
    end;

  end;
  
  cmn.AddSubscriber( "get_tongs_lvl4", get_tongs_lvl4_inv );
  cmn.AddSubscriber( "get_tongs_lvl4", get_tongs_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_planks () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_planks" ] = {
    type = "get",
    get_obj = "spr_hall_lvl4_planks",
    room = private.room_objname,
  };
  
  local get_planks_inv = function ()
  
    interface.InventoryItemAdd( "inv_planks", "spr_hall_lvl4_planks" );
  
  end;
  
  local get_planks_closezz = function ()
  
    ObjDelete( "gfx_hall_lvl4_planks" );
  
  end;
  
  cmn.AddSubscriber( "get_planks", get_planks_inv );
  cmn.AddSubscriber( "get_planks", get_planks_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_26 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_26 = function ()
  
    ObjDelete( "obj_stand_lvl4_collect2_item_26" ); 
  
    if ( cmn.IsEventDone( "get_adhesive_bandage" ) ) then
      
      ObjDelete( "gzz_hall_lvl4_stand_lvl4" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_26", get_collect2_item_26, private.room_objname );      
  --------------------------------------------------------------------------------------------
  -- function use_hotel_symbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hotel_symbol" ] = {
    type = "use",
    inv_obj = "inv_hotel_symbol",
    use_place = "obj_stand_lvl4_use_hotel_symbol",
    room = private.room_objname,
    zz = "zz_stand_lvl4",
    zz_gate = "gzz_hall_lvl4_stand_lvl4"
  };
  local use_hotel_symbol_inv = function ()
  
    interface.InventoryItemRemove( "inv_hotel_symbol" );
  
  end;
  local use_hotel_symbol_beg = function ()
  
    ObjDelete( "obj_stand_lvl4_use_hotel_symbol" );
  
  end;
  local use_hotel_symbol_end = function ()

    ObjMultiSet({ 
      { "spr_stand_lvl4_adhesive_bandage", {  input = true }},
      { "gfx_stand_lvl4_adhesive_bandage", { active = true }},
      { "spr_stand_lvl4_cup_opn",          {    alp = 1    }},
    });
    ObjDelete( "spr_stand_lvl4_cup_cls" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hotel_symbol",     use_hotel_symbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotel_symbol",     use_hotel_symbol_inv                       );
  cmn.AddSubscriber( "use_hotel_symbol",     use_hotel_symbol_end, private.room_objname );
  cmn.AddSubscriber( "use_hotel_symbol_inv", use_hotel_symbol_inv, private.room_objname );
  cmn.AddSubscriber( "use_hotel_symbol_beg", use_hotel_symbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotel_symbol_end", use_hotel_symbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_key_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_key_lvl4" ] = {
    type = "use",
    inv_obj = "inv_key_lvl4",
    use_place = "obj_power_box_use_key_lvl4",
    room = private.room_objname,
    zz = "zz_power_box",
    zz_gate = "gzz_hall_lvl4_power_box"
  };
  local use_key_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_key_lvl4" );
  
  end;
  local use_key_lvl4_beg = function ()
  
    ObjDelete( "obj_power_box_use_key_lvl4" );
  
  end;
  local use_key_lvl4_end = function ()
  
    ObjMultiSet({ 
      { "spr_power_box_scheme_piece_3",       { input = true                                }},
      { "gfx_power_box_scheme_piece_3",       {               active = true                 }},
      { "spr_power_box_bulb",                 { input = true                                }},
      { "gfx_power_box_bulb",                 {               active = true                 }},
      { "obj_power_box_use_adhesive_bandage", { input = true, active = true, visible = true }},
      { "spr_power_box_door_opn",             {   alp = 1                                   }},
      { "spr_hall_lvl4_zz_powerbox_open",     {   alp = 1                                   }},
    });
    ObjDelete( "anm_power_door_key" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_key_lvl4",     use_key_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_key_lvl4",     use_key_lvl4_inv                       );
  cmn.AddSubscriber( "use_key_lvl4",     use_key_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_key_lvl4_inv", use_key_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_key_lvl4_beg", use_key_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_key_lvl4_end", use_key_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_adhesive_bandage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_adhesive_bandage" ] = {
    type = "use",
    inv_obj = "inv_adhesive_bandage",
    use_place = "obj_power_box_use_adhesive_bandage",
    room = private.room_objname,
    zz = "zz_power_box",
    zz_gate = "gzz_hall_lvl4_power_box"
  };
  local use_adhesive_bandage_inv = function ()
  
    if cmn.IsEventDone( "use_adhesive_bandage_2" ) then
      interface.InventoryItemRemove( "inv_adhesive_bandage" );
    end;
  
  end;
  local use_adhesive_bandage_beg = function ()
  
    ObjDelete( "obj_power_box_use_adhesive_bandage" );
  
  end;
  local use_adhesive_bandage_end = function ()
  
    ObjMultiSet({ 
      { "obj_power_box_clk_adhesive_bandage", { input = true, active = true, visible = true }},
      { "anm_power_wire_bandage_click",       {   alp = 1                                   }},
    });
    ObjDelete( "anm_power_wire_bandage" );
    ObjDelete( "anm_power_wire_click"   );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_adhesive_bandage",     use_adhesive_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "use_adhesive_bandage",     use_adhesive_bandage_inv                       );
  cmn.AddSubscriber( "use_adhesive_bandage",     use_adhesive_bandage_end, private.room_objname );
  cmn.AddSubscriber( "use_adhesive_bandage_inv", use_adhesive_bandage_inv, private.room_objname );
  cmn.AddSubscriber( "use_adhesive_bandage_beg", use_adhesive_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "use_adhesive_bandage_end", use_adhesive_bandage_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ring_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ring_lvl4" ] = {
    type = "use",
    inv_obj = "inv_ring_lvl4",
    use_place = "obj_cart_use_ring_lvl4",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_hall_lvl4_cart"
  };
  local use_ring_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_ring_lvl4" );
  
  end;
  local use_ring_lvl4_beg = function ()
  
    ObjDelete( "obj_cart_use_ring_lvl4" );
  
  end;
  local use_ring_lvl4_end = function ()
  
    ObjMultiSet({ 
      { "obj_cart_clk_ring_lvl4",     { input = true, active = true, visible = true }},
      { "anm_cart_ring",              { frame = 500                                 }},
      { "spr_hall_lvl4_zz_cart_ring", {   alp = 1                                   }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ring_lvl4",     use_ring_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_lvl4",     use_ring_lvl4_inv                       );
  cmn.AddSubscriber( "use_ring_lvl4",     use_ring_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_ring_lvl4_inv", use_ring_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_ring_lvl4_beg", use_ring_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_lvl4_end", use_ring_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bomb () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bomb" ] = {
    type = "use",
    inv_obj = "inv_bomb",
    use_place = "obj_hall_lvl4_use_bomb",
    room = private.room_objname,
  };
  local use_bomb_inv = function ()
  
    interface.InventoryItemRemove( "inv_bomb" );
  
  end;
  local use_bomb_beg = function ()
  
    ObjDelete( "obj_hall_lvl4_use_bomb" );
  
  end;
  local use_bomb_end = function ()

    ObjMultiSet({ 
      { "spr_hall_lvl4_planks",      { alp = 1,   input = true }},
      { "gfx_hall_lvl4_planks",      {           active = true }},
      { "spr_hall_lvl4_column_2",    { alp = 1                 }},
      { "spr_hall_lvl4_wood_column", { alp = 1                 }},
      { "anm_hall_lvl4_curtain",     { alp = 1, playing = true }},
    });
    ObjDelete( "spr_hall_lvl4_column_1" );
    ObjDelete( "vid_hall_lvl4_explode"  );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bomb",     use_bomb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bomb",     use_bomb_inv                       );
  cmn.AddSubscriber( "use_bomb",     use_bomb_end, private.room_objname );
  cmn.AddSubscriber( "use_bomb_inv", use_bomb_inv, private.room_objname );
  cmn.AddSubscriber( "use_bomb_beg", use_bomb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bomb_end", use_bomb_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_ring_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_ring_lvl4" ] = {
    type = "click",
    use_place = "obj_cart_clk_ring_lvl4",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_hall_lvl4_cart"
  };
  
  local clk_ring_lvl4_beg = function ()

    ObjDelete( "obj_cart_clk_ring_lvl4" );
  
  end;
  local clk_ring_lvl4_end = function ()
    
    ObjMultiSet( { 
      { "spr_cart_tongs_lvl4",        {  input = true } },
      { "gfx_cart_tongs_lvl4",        { active = true } },
      { "spr_cart_scheme_piece_4",    {  input = true } },
      { "gfx_cart_scheme_piece_4",    { active = true } },
      { "spr_cart_door_opened",       {    alp = 1    } },
      { "spr_hall_lvl4_zz_cart_open", {    alp = 1    } },
    } );
    ObjDelete( "spr_cart_door_closed"              );
    ObjDelete( "spr_hall_lvl4_zz_cart_door_closed" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_ring_lvl4",     clk_ring_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ring_lvl4",     clk_ring_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "clk_ring_lvl4_beg", clk_ring_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ring_lvl4_end", clk_ring_lvl4_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_adhesive_bandage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_adhesive_bandage" ] = {
    type = "click",
    use_place = "obj_power_box_clk_adhesive_bandage",
    room = private.room_objname,
    zz = "zz_power_box",
    zz_gate = "gzz_hall_lvl4_power_box"
  };
  
  local clk_adhesive_bandage_beg = function ()

    ObjDelete( "obj_power_box_clk_adhesive_bandage" );
  
  end;
  local clk_adhesive_bandage_end = function ()
    
    ObjMultiSet({ 
      { "spr_power_box_scheme_piece_5", { input = true                }},
      { "gfx_power_box_scheme_piece_5", {               active = true }},
      { "spr_power_box_chisel_lvl4",    { input = true                }},
      { "gfx_power_box_chisel_lvl4",    {               active = true }},
      { "anm_power_wire_bandage_click", { frame = 500                 }},
    });
    ObjDelete( "spr_hall_lvl4_zz_powerbox_ware" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_adhesive_bandage",     clk_adhesive_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "clk_adhesive_bandage",     clk_adhesive_bandage_end, private.room_objname );
  cmn.AddSubscriber( "clk_adhesive_bandage_beg", clk_adhesive_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "clk_adhesive_bandage_end", clk_adhesive_bandage_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_hall_picture () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_hall_picture" ] = {
    type = "click",
    use_place = "obj_hall_lvl4_clk_hall_picture",
    room = private.room_objname,
  };

  local see_hall_picture = function ()
  
    ObjDelete( "obj_hall_lvl4_clk_hall_picture" );
    ObjSet( "anm_hall_lvl4_picture", { frame = 500 } );          

  end;
  cmn.AddSubscriber( "see_hall_picture", see_hall_picture, private.room_objname ); 

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_hall_lvl4();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_hall_lvl4_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()
  common_impl.StopAudio( "env", "levelext/env/aud_hall_lvl4_env", 0.5 );
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hotel_symbol ()

  local item = "inv_hotel_symbol";

  if ( cmn.ApplyObj( item, "gzz_hall_lvl4_stand_lvl4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand_lvl4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand_lvl4_use_hotel_symbol" ) ) then

    cmn.CallEventHandler( "use_hotel_symbol_inv" );
    cmn.CallEventHandler( "use_hotel_symbol_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_hotel_symbol" );
        cmn.CallEventHandler( "use_hotel_symbol_end" );

      end;
      
      ObjSet( "spr_stand_lvl4_slot_sign_hotel_patch", { alp = 1 } )

      ObjAnimate( "spr_stand_lvl4_cup_opn", "alp", 0, 0, func_end_2, {
        0.0, 0, ObjGet( "spr_stand_lvl4_cup_opn" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_stand_lvl4_cup_cls", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_stand_lvl4_cup_cls" ).alp,
        0.3, 0, 0,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_drawer_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_stand_lvl4_sign_hotel", func_end, -1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_key_lvl4 ()

  local item = "inv_key_lvl4";

  if ( cmn.ApplyObj( item, "gzz_hall_lvl4_power_box" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_power_box" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_power_box_use_key_lvl4" ) ) then

    cmn.CallEventHandler( "use_key_lvl4_inv" );
    cmn.CallEventHandler( "use_key_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_key_lvl4" );
      cmn.CallEventHandler( "use_key_lvl4_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_electry_4lvl", 0, "", 0 );

    AnimPlay( "anm_power_door_key", "door_key", func_end )
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_adhesive_bandage ()

  local item = "inv_adhesive_bandage";

  if ( cmn.ApplyObj( item, "gzz_hall_lvl4_power_box" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_power_box" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_power_box_use_adhesive_bandage" ) ) then

    cmn.CallEventHandler( "use_adhesive_bandage_inv" );
    cmn.CallEventHandler( "use_adhesive_bandage_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_adhesive_bandage" );
      cmn.CallEventHandler( "use_adhesive_bandage_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_tape_4lvl", 0, "", 0 );

    ObjMultiSet({ 
      { "anm_power_wire_bandage", { alp = 1 }},
      { "anm_power_wire_click",   { alp = 0 }},
    });
    AnimPlay( "anm_power_wire_bandage", "wire_bandage", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ring_lvl4 ()

  local item = "inv_ring_lvl4";

  if ( cmn.ApplyObj( item, "gzz_hall_lvl4_cart" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cart_use_ring_lvl4" ) ) then

    cmn.CallEventHandler( "use_ring_lvl4_inv" );
    cmn.CallEventHandler( "use_ring_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_ring_lvl4" );
      cmn.CallEventHandler( "use_ring_lvl4_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_ring_4lvl", 0, "", 0 );

    AnimPlay( "anm_cart_ring", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bomb ()

  local item = "inv_bomb";

  if ( cmn.ApplyObj( item, "obj_hall_lvl4_use_bomb" ) ) then

    cmn.CallEventHandler( "use_bomb_inv" );
    cmn.CallEventHandler( "use_bomb_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_bomb" );
      cmn.CallEventHandler( "use_bomb_end" );

      common_impl.ShowBbt( 'bbt_hall_lvl4_anim_hall_lvl4_1' );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_dynamite_4lvl", 0, "", 0 );

    ObjMultiSet({ 
      { "vid_hall_lvl4_explode",  { alp = 1 }},
      { "spr_hall_lvl4_column_1", { alp = 0 }},
      { "anm_hall_lvl4_curtain",  { alp = 0 }},
    });
    VidPlay( "vid_hall_lvl4_explode", func_end )
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_key_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_key_lvl4" );
  cmn.CallEventHandler( "get_key_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_adhesive_bandage ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_adhesive_bandage" );
  cmn.CallEventHandler( "get_adhesive_bandage" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_26" ) ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_scheme_piece_3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scheme_piece_3" );
  cmn.CallEventHandler( "get_scheme_piece_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_scheme_piece_5 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scheme_piece_5" );
  cmn.CallEventHandler( "get_scheme_piece_5" );

  if cmn.IsEventDone( "get_chisel_lvl4" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_bulb ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bulb" );
  cmn.CallEventHandler( "get_bulb" );

end;
--------------------------------------------------------------------------------------------
function private.get_chisel_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_chisel_lvl4" );
  cmn.CallEventHandler( "get_chisel_lvl4" );

  if cmn.IsEventDone( "get_scheme_piece_5" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_scheme_piece_4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scheme_piece_4" );
  cmn.CallEventHandler( "get_scheme_piece_4" );

  if cmn.IsEventDone( "get_tongs_lvl4" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_tongs_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tongs_lvl4" );
  cmn.CallEventHandler( "get_tongs_lvl4" );

  if cmn.IsEventDone( "get_scheme_piece_4" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_planks ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_planks" );
  cmn.CallEventHandler( "get_planks" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_26 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_26" ); 

  end;

  common_impl.PlayEffectHO( "spr_stand_lvl4_collect2_item_26", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_26" );
  
  if ( cmn.IsEventDone( "get_adhesive_bandage" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_ring_lvl4 ()
  
  cmn.CallEventHandler( "clk_ring_lvl4_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_ring_lvl4" );
    cmn.CallEventHandler( "clk_ring_lvl4_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_wood_small_door", 0, "", 0 );
  
  ObjAnimate( "spr_cart_door_opened", "alp",0,0, func_end, { 
    0.0, 0, ObjGet( "spr_cart_door_opened" ).alp, 
    0.3, 0, 1,
  } );
  ObjAnimate( "spr_cart_door_closed", "alp",0,0, "", { 
    0.0, 0, ObjGet( "spr_cart_door_closed" ).alp, 
    0.3, 0, 0,
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_adhesive_bandage ()
  
  cmn.CallEventHandler( "clk_adhesive_bandage_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_adhesive_bandage" );
    cmn.CallEventHandler( "clk_adhesive_bandage_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_wire_4lvl", 0, "", 0 );
  
  AnimPlay( "anm_power_wire_bandage_click", "wire_bandage_click", func_end );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt ) 
end;
----------------------------------------------------------------------------------------------
function private.see_hall_picture ()
  
  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "see_hall_picture" );
    cmn.CallEventHandler( "see_hall_picture" ); 
    
    common_impl.ShowBbt( 'bbt_hall_lvl4_see_hall_picture' );

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_drop_picture_4lvl", 0, "", 0 );
  
  AnimPlay( "anm_hall_lvl4_picture", "picture", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_hall_lvl4 ()

  if not ( cmn.IsEventDone( "opn_hall_lvl4" ) ) then
    cmn.SetEventDone( "opn_hall_lvl4" );
    common_impl.ShowBbt( 'bbt_hall_lvl4_opn_hall_lvl4' );
  end;
  cmn.CallEventHandler( "opn_hall_lvl4" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseRingLvl4 ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_cart_use_ring_lvl4' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood_mid", 0, "", 0 );
  
  ObjAnimate( "spr_cart_door_closed", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,2,-2,  0.4,3,0,0 });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseHotelSymbol ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_stand_lvl4_use_hotel_symbol' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_drawer", 0, "", 0 );
  
  ObjAnimate( "spr_stand_lvl4_cup_cls", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,-2,2,  0.4,3,0,0 });

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseKeyLvl4 ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_power_box_use_key_lvl4' );

    ObjMultiSet({ 
      { "anm_power_door_click", { alp = 0 }},
      { "anm_power_door_key",   { alp = 1 }},
    });
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_grill", 0, "", 0 );
  
  ObjMultiSet({ 
    { "anm_power_door_click", { alp = 1 }},
    { "anm_power_door_key",   { alp = 0 }},
  });

  AnimPlay( "anm_power_door_click", "door_click", func_end );

end;
-----------------------------------------------------------------------------------------------------------------------
function private.AnimUseAdhesiveBandage ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_power_box_use_adhesive_bandage' );
  
  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_electr", 0, "", 0 );
  
  AnimPlay( "anm_power_wire_click", "wire_click", func_end );

end;
-----------------------------------------------------------------------------------------------------------------------