-- name=rm_lucien_room_lvl4
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lucien_room_lvl4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_shelf", "room_hub" );
  ObjAttach( "zz_desk",  "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  private.InitMg();

  ObjMultiSet({ 
    { "spr_shelf_spade",               { event_mdown = private.get_spade           }},
    { "spr_shelf_box_lvl4",            { event_mdown = private.get_box_lvl4        }},
    { "spr_shelf_silver_key",          { event_mdown = private.get_silver_key      }},
    { "spr_shelf_box_closed",          { event_mdown = private.clk_box_rope        }},
    { "obj_shelf_use_boy_scout_badge", { event_mdown = private.ClkDoor             }},
    { "obj_shelf_use_scalpel",         { event_mdown = private.ClkRope             }},
    
    { "spr_desk_round_key",            { event_mdown = private.get_round_key       }},
    { "spr_desk_boy_scout_badge",      { event_mdown = private.get_boy_scout_badge }},
    { "spr_desk_double_gun",           { event_mdown = private.get_double_gun      }},

    { "spr_lucien_room_lvl4_collect_morph_item",   { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_20" ); end } },
    { "spr_shelf_collect2_item_25",  { event_mdown = private.get_collect2_item_25      }},
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_lucien_room_lvl4 = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gzz_lucien_room_lvl4_shelf",
      "gzz_lucien_room_lvl4_desk"
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_shelf",
      "zz_desk",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_lucien_room_lvl4", update_game_mode_lucien_room_lvl4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_lucien_room_lvl4 = function ()

    local effects_table = 
    {

    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_lucien_room_lvl4", update_performance_mode_lucien_room_lvl4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_lucien_room_lvl4 () end;
  --------------------------------------------------------------------------------------------
  local opn_lucien_room_lvl4_map = function ()

    common_impl.VisitMapRoom( "lucien_room_lvl4" );

  end;
  cmn.AddSubscriber( "opn_lucien_room_lvl4", opn_lucien_room_lvl4_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_20 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_20 = function ()
  
    ObjDelete( "obj_lucien_room_lvl4_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_20", get_collect_morph_item_20, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_spade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spade" ] = {
    type = "get",
    get_obj = "spr_shelf_spade",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_lucien_room_lvl4_shelf"
  };
  
  local get_spade_inv = function ()
  
    interface.InventoryItemAdd( "inv_spade", "spr_shelf_spade" );
  
  end;
  
  local get_spade_closezz = function ()
  
    ObjDelete( "gfx_shelf_spade" );
    ObjDelete( "spr_lucien_room_lvl4_zz_shelf_shovel" );
    
  end;
  
  cmn.AddSubscriber( "get_spade", get_spade_inv );
  cmn.AddSubscriber( "get_spade", get_spade_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_box_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_box_lvl4" ] = {
    type = "get",
    get_obj = "spr_shelf_box_lvl4",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_lucien_room_lvl4_shelf"
  };
  
  local get_box_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_box_lvl4", "spr_shelf_box_lvl4" );
    ObjSet( "inv_box_lvl4", { drag = false } );

  end;
  
  local get_box_lvl4_closezz = function ()
  
    ObjDelete( "gfx_shelf_box_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_box_lvl4", get_box_lvl4_inv );
  cmn.AddSubscriber( "get_box_lvl4", get_box_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_silver_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_silver_key" ] = {
    type = "get",
    get_obj = "spr_shelf_silver_key",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_lucien_room_lvl4_shelf"
  };
  
  local get_silver_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_silver_key", "spr_shelf_silver_key" );
  
  end;
  
  local get_silver_key_closezz = function ()
  
    ObjDelete( "gfx_shelf_silver_key"       );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_25" ) ) then
      
      ObjDelete( "gzz_lucien_room_lvl4_shelf" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_silver_key", get_silver_key_inv );
  cmn.AddSubscriber( "get_silver_key", get_silver_key_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_round_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_round_key" ] = {
    type = "get",
    get_obj = "spr_desk_round_key",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_lucien_room_lvl4_desk"
  };
  
  local get_round_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_round_key", "spr_desk_round_key" );
  
  end;
  
  local get_round_key_closezz = function ()
  
    ObjDelete( "gfx_desk_round_key" );
  
  end;
  
  cmn.AddSubscriber( "get_round_key", get_round_key_inv );
  cmn.AddSubscriber( "get_round_key", get_round_key_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boy_scout_badge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boy_scout_badge" ] = {
    type = "get",
    get_obj = "spr_desk_boy_scout_badge",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_lucien_room_lvl4_desk"
  };
  
  local get_boy_scout_badge_inv = function ()
  
    interface.InventoryItemAdd( "inv_boy_scout_badge", "spr_desk_boy_scout_badge" );
  
  end;
  
  local get_boy_scout_badge_closezz = function ()
  
    ObjDelete( "gfx_desk_boy_scout_badge"  );
    ObjDelete( "gzz_lucien_room_lvl4_desk" );  

  end;
  
  cmn.AddSubscriber( "get_boy_scout_badge", get_boy_scout_badge_inv );
  cmn.AddSubscriber( "get_boy_scout_badge", get_boy_scout_badge_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_double_gun () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_double_gun" ] = {
    type = "get",
    get_obj = "spr_desk_double_gun",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_lucien_room_lvl4_desk"
  };
  
  local get_double_gun_inv = function ()
  
    interface.InventoryItemAdd( "inv_double_gun", "spr_desk_double_gun" );
    ObjSet( "inv_double_gun", { drag = false } );

  end;
  
  local get_double_gun_closezz = function ()
  
    ObjDelete( "gfx_desk_double_gun" );
  
  end;
  
  cmn.AddSubscriber( "get_double_gun", get_double_gun_inv );
  cmn.AddSubscriber( "get_double_gun", get_double_gun_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_25 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_25 = function ()
  
    ObjDelete( "obj_shelf_collect2_item_25" ); 
  
    if ( cmn.IsEventDone( "get_silver_key" ) ) then
      
      ObjDelete( "gzz_lucien_room_lvl4_shelf" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_25", get_collect2_item_25, private.room_objname );        
  
  --------------------------------------------------------------------------------------------
  -- function use_scalpel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scalpel" ] = {
    type = "use",
    inv_obj = "inv_scalpel",
    use_place = "obj_shelf_use_scalpel",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_lucien_room_lvl4_shelf"
  };
  local use_scalpel_inv = function ()
  
    interface.InventoryItemRemove( "inv_scalpel" );
  
  end;
  local use_scalpel_beg = function ()
  
    ObjDelete( "obj_shelf_use_scalpel" );
  
  end;
  local use_scalpel_end = function ()
  
    ObjDelete( "spr_shelf_box_rope" );
    ObjDelete( "anm_shelf_scalpel" );
    
    ObjMultiSet({ 
      { "anm_shelf_rope_cut",   {   alp = 1    }},
      { "spr_shelf_box_closed", {   alp = 1    }},
      { "spr_shelf_box_closed", { input = true }},
    });  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scalpel", use_scalpel_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalpel", use_scalpel_inv );
  cmn.AddSubscriber( "use_scalpel", use_scalpel_end, private.room_objname );
  cmn.AddSubscriber( "use_scalpel_inv", use_scalpel_inv, private.room_objname );
  cmn.AddSubscriber( "use_scalpel_beg", use_scalpel_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalpel_end", use_scalpel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boy_scout_badge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boy_scout_badge" ] = {
    type = "use",
    inv_obj = "inv_boy_scout_badge",
    use_place = "obj_shelf_use_boy_scout_badge",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_lucien_room_lvl4_shelf"
  };
  local use_boy_scout_badge_inv = function ()
  
    interface.InventoryItemRemove( "inv_boy_scout_badge" );
  
  end;
  local use_boy_scout_badge_beg = function ()
  
    ObjDelete( "obj_shelf_use_boy_scout_badge" );
  
  end;
  local use_boy_scout_badge_end = function ()
  
    ObjMultiSet({ 
      { "spr_shelf_box_lvl4",                           { input = true }},
      { "obj_shelf_use_scalpel",                        { input = true }},
      { "spr_lucien_room_lvl4_zz_shelf_door_open",      {   alp = 1    }},
      { "spr_lucien_room_lvl4_zz_shelf_door_open_dark", {   alp = 1    }},
      { "anm_shelf_door",                               { frame = 300  }},
    });
    
    ObjDelete( "spr_lucien_room_lvl4_zz_shelf_door_closed" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boy_scout_badge", use_boy_scout_badge_beg, private.room_objname );
  cmn.AddSubscriber( "use_boy_scout_badge", use_boy_scout_badge_inv );
  cmn.AddSubscriber( "use_boy_scout_badge", use_boy_scout_badge_end, private.room_objname );
  cmn.AddSubscriber( "use_boy_scout_badge_inv", use_boy_scout_badge_inv, private.room_objname );
  cmn.AddSubscriber( "use_boy_scout_badge_beg", use_boy_scout_badge_beg, private.room_objname );
  cmn.AddSubscriber( "use_boy_scout_badge_end", use_boy_scout_badge_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flag_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flag_lvl4" ] = {
    type = "use",
    inv_obj = "inv_flag_lvl4",
    use_place = "obj_desk_use_flag_lvl4",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_lucien_room_lvl4_desk"
  };
  local use_flag_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_flag_lvl4" );
  
  end;
  local use_flag_lvl4_beg = function ()
  
    ObjDelete( "obj_desk_use_flag_lvl4" );
  
  end;
  local use_flag_lvl4_end = function ()

    ObjMultiSet({ 
      { "spr_desk_open",                     { input = true, alp = 1 }},
      { "spr_desk_flag",                     {   alp = 1             }},
      { "spr_lucien_room_lvl4_zz_desk_flag", {   alp = 1             }},
    });  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flag_lvl4", use_flag_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_flag_lvl4", use_flag_lvl4_inv );
  cmn.AddSubscriber( "use_flag_lvl4", use_flag_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_flag_lvl4_inv", use_flag_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_flag_lvl4_beg", use_flag_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_flag_lvl4_end", use_flag_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screcrow_outfit () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screcrow_outfit" ] = {
    type = "use",
    inv_obj = "inv_screcrow_outfit",
    use_place = "obj_lucien_room_lvl4_use_screcrow_outfit",
    room = private.room_objname,
  };
  local use_screcrow_outfit_inv = function ()
  
    interface.InventoryItemRemove( "inv_screcrow_outfit" );
  
  end;
  local use_screcrow_outfit_beg = function ()
  
    ObjDelete( "obj_lucien_room_lvl4_use_screcrow_outfit" );
  
  end;
  local use_screcrow_outfit_end = function ()
  
    ObjSet( "obj_lucien_room_lvl4_mg", { input = true, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screcrow_outfit", use_screcrow_outfit_beg, private.room_objname );
  cmn.AddSubscriber( "use_screcrow_outfit", use_screcrow_outfit_inv );
  cmn.AddSubscriber( "use_screcrow_outfit", use_screcrow_outfit_end, private.room_objname );
  cmn.AddSubscriber( "use_screcrow_outfit_inv", use_screcrow_outfit_inv, private.room_objname );
  cmn.AddSubscriber( "use_screcrow_outfit_beg", use_screcrow_outfit_beg, private.room_objname );
  cmn.AddSubscriber( "use_screcrow_outfit_end", use_screcrow_outfit_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lit_match () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lit_match" ] = {
    type = "use",
    inv_obj = "inv_lit_match",
    use_place = "obj_lucien_room_lvl4_use_lit_match",
    room = private.room_objname,
  };
  local use_lit_match_inv = function ()
  
    interface.InventoryItemRemove( "inv_lit_match" );
  
  end;
  local use_lit_match_beg = function ()
  
    ObjDelete( "obj_lucien_room_lvl4_use_lit_match" );
    ObjSet( "spr_lucien_room_lvl4_back",  { alp = 1 } );

  end;
  local use_lit_match_end = function ()
  
    ObjDelete( "spr_lucien_room_lvl4_back_dark" );
    ObjDelete( "obj_lucien_room_lvl4_zz_shelf_dark" );
    ObjDelete( "anm_shelf_door" );
    ObjDelete( "anm_lucien_room_lvl4_fail" );
    ObjDelete( "spr_lucien_room_lvl4_zz_desk_dark" );
    ObjMultiSet({ 
      { "grm_lucien_room_lvl4_weaponry",      { input = true, visible = true, active = true }},
      { "obj_lucien_room_lvl4_morph",         { input = true, alp = 1                       }},
      { "obj_lucien_room_lvl4_zz_shelf",      {   alp = 1                                   }},
      { "anm_lucien_room_lvl4_light",         {   alp = 1                                   }},
      { "anm_shelf_door_light",               {   alp = 1                                   }},
      { "spr_lucien_room_lvl4_table_light",   {   alp = 1                                   }},
      { "spr_lucien_room_lvl4_zz_desk_light", {   alp = 1                                   }},
    }); 
    
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_lucien_room_lvl4_weaponry_focus");
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lit_match", use_lit_match_beg, private.room_objname );
  cmn.AddSubscriber( "use_lit_match", use_lit_match_inv );
  cmn.AddSubscriber( "use_lit_match", use_lit_match_end, private.room_objname );
  cmn.AddSubscriber( "use_lit_match_inv", use_lit_match_inv, private.room_objname );
  cmn.AddSubscriber( "use_lit_match_beg", use_lit_match_beg, private.room_objname );
  cmn.AddSubscriber( "use_lit_match_end", use_lit_match_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_box_rope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_box_rope" ] = {
    type = "click",
    use_place = "spr_shelf_box_closed",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_lucien_room_lvl4_shelf"
  };
  
  local clk_box_rope = function ()
  
    ObjDelete( "spr_shelf_box_closed" );
    ObjMultiSet({ 
      { "spr_shelf_box_open",                     { alp = 1, input = true }},
      { "spr_lucien_room_lvl4_zz_shelf_box_open", { alp = 1               }},
      { "spr_lucien_room_lvl4_zz_shelf_open_box", { alp = 1               }},
    });  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_box_rope", clk_box_rope, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_lucien_room_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_lucien_room_lvl4" ] = {
    type = "win",
    room = private.room_objname,
  };
  
  local win_lucien_room_lvl4 = function ()
  
    if ( cmn.IsEventDone( "win_lucien_room_lvl4" ) ) then
      
      ObjDelete( "obj_lucien_room_lvl4_mg" );
      ObjDelete( "anm_lucien_room_lvl4_static_dark" );
      ObjSet( "gzz_lucien_room_lvl4_desk", { input = true, visible = true, active = true } );
      ObjSet( "anm_lucien_room_lvl4_fail", {   alp = 1, frame = 300                      } );
      
    else 
      private.LoadMg();
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_lucien_room_lvl4", win_lucien_room_lvl4, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_lucien_room_lvl4();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( not cmn.IsEventDone( "win_lucien_room_lvl4" ) ) and ( cmn.IsEventStart( "win_lucien_room_lvl4" ) ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
    private.AnimRound();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_lucien_room_lvl4_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

  if ( not cmn.IsEventDone( "win_lucien_room_lvl4" ) ) and ( cmn.IsEventStart( "win_lucien_room_lvl4" ) ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
function public.PreClose ()
  common_impl.StopAudio( "env", "levelext/env/aud_lucien_room_lvl4_env", 0.5 );
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_scalpel ()

  local item = "inv_scalpel";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_lvl4_shelf" ) ) and ( cmn.IsEventDone( "use_boy_scout_badge" ) )  then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shelf" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shelf_use_scalpel" ) ) and ( cmn.IsEventDone( "use_boy_scout_badge" ) ) then

    cmn.CallEventHandler( "use_scalpel_inv" );
    cmn.CallEventHandler( "use_scalpel_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_scalpel" );
      cmn.CallEventHandler( "use_scalpel_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_cut_rope_4lvl", 0, "", 0 );

    ObjMultiSet({ 
      { "anm_shelf_scalpel",    { alp = 1 }},
      { "spr_shelf_box_closed", { alp = 0 }},
    });  
    AnimPlay( "anm_shelf_scalpel", "scalpel", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_boy_scout_badge ()

  local item = "inv_boy_scout_badge";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_lvl4_shelf" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shelf" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shelf_use_boy_scout_badge" ) ) then

    cmn.CallEventHandler( "use_boy_scout_badge_inv" );
    cmn.CallEventHandler( "use_boy_scout_badge_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_boy_scout_badge" );
      cmn.CallEventHandler( "use_boy_scout_badge_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_self_4lvl", 0, "", 0 );

    AnimPlay( "anm_shelf_door", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_flag_lvl4 ()

  local item = "inv_flag_lvl4";

  if ( cmn.ApplyObj( item, "gzz_lucien_room_lvl4_desk" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_desk" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_desk_use_flag_lvl4" ) ) then

    cmn.CallEventHandler( "use_flag_lvl4_inv" );
    cmn.CallEventHandler( "use_flag_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_flag_lvl4" );
      cmn.CallEventHandler( "use_flag_lvl4_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_flag_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_desk_flag" );
    ObjAnimate( "spr_desk_open", "alp", 0, 0, func_end,
    {
      0.0, 0, 0,
      0.5, 0, 0,
      0.8, 0, 1
    } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_screcrow_outfit ()

  local item = "inv_screcrow_outfit";

  if ( cmn.ApplyObj( item, "obj_lucien_room_lvl4_use_screcrow_outfit" ) ) then

    cmn.CallEventHandler( "use_screcrow_outfit_inv" );
    cmn.CallEventHandler( "use_screcrow_outfit_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_screcrow_outfit" );
      cmn.CallEventHandler( "use_screcrow_outfit_end" );
      cmn.MiniGameShow();
      common_impl.PassingMgStart();
      ng_global.progress[ "ext" ][ "win_lucien_room_lvl4" ].level = 1;
      ng_global.progress[ "ext" ][ "win_lucien_room_lvl4" ].count = 0;
      private.AnimRound();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_clothes_4lvl", 0, "", 0 );

    ObjSet( "obj_lucien_room_lvl4_mg", { visible = true } );
    ObjAnimate( "obj_lucien_room_lvl4_mg", "alp", 0, 0, func_end,
    {
      0.0, 0, 0,
      0.3, 3, 1
    } );
    
    ObjAnimate( "anm_lucien_room_lvl4_static_dark", "alp", 0, 0, "",
    {
      0.0, 0, 1,
      0.3, 3, 0
    } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lit_match ()

  local item = "inv_lit_match";

  if ( cmn.ApplyObj( item, "obj_lucien_room_lvl4_use_lit_match" ) ) then

    cmn.CallEventHandler( "use_lit_match_inv" );
    cmn.CallEventHandler( "use_lit_match_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_lit_match" );
      cmn.CallEventHandler( "use_lit_match_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_match_4lvl", 0, "", 0 );

    ObjAnimate( "spr_lucien_room_lvl4_back_dark", "alp", 0, 0, "",
    {
      0.0, 0, 1,
      0.7, 0, 1,
      1.0, 0, 0
    } );
    
    ObjAnimate( "anm_lucien_room_lvl4_light", "alp", 0, 0, "",
    {
      0.0, 0, 0,
      0.7, 0, 0,
      1.0, 0, 1
    } );
    
    ObjAnimate( "obj_lucien_room_lvl4_anim", "alp", 0, 0, "",
    {
      0.0, 0, 1,
      0.7, 0, 1,
      1.0, 0, 0
    } );
    
    ObjAnimate( "spr_lucien_room_lvl4_table_light", "alp", 0, 0, "",
    {
      0.0, 0, 0,
      0.7, 0, 0,
      1.0, 0, 1
    } );
    
    ObjAnimate( "spr_lucien_room_lvl4_zz_desk_light", "alp", 0, 0, "",
    {
      0.0, 0, 0,
      0.7, 0, 0,
      1.0, 0, 1
    } );
    
    ObjAnimate( "spr_lucien_room_lvl4_zz_desk_dark", "alp", 0, 0, "",
    {
      0.0, 0, 1,
      0.7, 0, 1,
      1.0, 0, 0
    } );
    
    ObjAnimate( "obj_lucien_room_lvl4_morph", "alp", 0, 0, "",
    {
      0.0, 0, 0,
      0.7, 0, 0,
      1.0, 0, 1
    } );
    
    AnimPlay( "anm_lucien_room_lvl4_light_on", "DoAnim1", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_spade ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_spade" );
  cmn.CallEventHandler( "get_spade" );

end;
--------------------------------------------------------------------------------------------
function private.get_box_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_box_lvl4" );
  cmn.CallEventHandler( "get_box_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_silver_key ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_silver_key" );
  cmn.CallEventHandler( "get_silver_key" );

  if ( cmn.IsGetCollect2( "get_collect2_item_25" ) ) then
    
    common.CloseSubRoom();

  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_round_key ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_round_key" );
  cmn.CallEventHandler( "get_round_key" );

end;
--------------------------------------------------------------------------------------------
function private.get_boy_scout_badge ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_boy_scout_badge" );
  cmn.CallEventHandler( "get_boy_scout_badge" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_double_gun ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_double_gun" );
  cmn.CallEventHandler( "get_double_gun" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_25 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_25" ); 

  end;

  common_impl.PlayEffectHO( "spr_shelf_collect2_item_25", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_25" );
  
  if ( cmn.IsEventDone( "get_silver_key" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_box_rope ()

  local func_end = function()
    
    cmn.SetEventDone( "clk_box_rope" );
    cmn.CallEventHandler( "clk_box_rope" );
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_cardbox_4lvl", 0, "", 0 );

  ObjAnimate( "spr_shelf_box_closed", "alp", 0, 0, func_end, {
    0.0, 0, 1,
    0.3, 0, 0
  });
  ObjAnimate( "spr_shelf_box_open", "alp", 0, 0, "", {
    0.0, 0, 0,
    0.3, 0, 1
  });

end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
 
   
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lucien_room_lvl4 ()

  if not ( cmn.IsEventDone( "opn_lucien_room_lvl4" ) ) then

    cmn.SetEventDone( "opn_lucien_room_lvl4" );
    common_impl.ShowBbt( 'bbt_lucien_room_lvl4_opn_lucien_room_lvl4' );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_zoom3", 0, "", 0 );

  end;
  cmn.CallEventHandler( "opn_lucien_room_lvl4" ); 
  
end;
--*********************************************************************************************************************
function private.ClkDoor ()
  
  cmn.Lock( true );
  common_impl.ShowBbt( 'bbt_shelf_use_boy_scout_badge' );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_drawer", 0, "", 0 );
  ObjAnimate( "anm_shelf_door", "pos_x", 0, 1, function() cmn.Lock( false ) end,
  {
    0.0, 0, 0,
    0.2, 0, 2,
    0.4, 0, 0
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.ClkRope ()
  
  cmn.Lock( true );
  common_impl.ShowBbt( 'bbt_shelf_use_scalpel' );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_clk_box_4lvl", 0, "", 0 );
  ObjAnimate( "spr_shelf_box_closed", "pos_x", 0, 1, function() cmn.Lock( false ) end,
  {
    0.0, 0, 0,
    0.2, 0, 1,
    0.4, 0, 0
  } );
  ObjAnimate( "spr_shelf_box_rope", "pos_x", 0, 1, "",
  {
    0.0, 0, 0,
    0.2, 0, 1,
    0.4, 0, 0
  } );  
  
end;
--*********************************************************************************************************************
-- function *** mmg *** () end;
--*********************************************************************************************************************
  function public.Skip ()
    
    private.mg.count = private.mg.count_level[ private.mg.level ];
    private.AnimProgress();
    private.Win();
    
  end;
  --*********************************************************************************************************************
  function public.Reset ()
    
    private.mg.count = 0;
    ng_global.progress[ "ext" ][ "win_lucien_room_lvl4" ].count = 0;
    private.SetProgress();
    private.AnimRound();
    
  end;
  --*********************************************************************************************************************
  function private.WinEnd ()


    cmn.SetEventDone( "win_lucien_room_lvl4" );
    cmn.CallEventHandler( "win_lucien_room_lvl4" );
    
    common_impl.Lock( false );
  
  end;
  --*********************************************************************************************************************
  function private.Win ()
    
    cmn.MiniGameHide();
    
    cmn.SetEventDone( "win_lucien_room_lvl4" );

    common_impl.PassingMgWin();
    
    for i = 1, 7 do
      
      local name_symbol = "spr_lucien_room_lvl4_mg_symbol"..i;
      ObjStopAnimate( name_symbol, "pos_x" );
      ObjStopAnimate( name_symbol, "alp" );
      
    end; 
    
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_scream_fall_4lvl", 0, "", 0 );
    ObjAnimate( "anm_lucien_room_lvl4_static_light", "alp", 0, 0, "",
    {
      0.0, 0, 1,
      0.3, 0, 0
    } );
    ObjAnimate( "spr_lucien_room_lvl4_mg_panel", "alp", 0, 0, "",
    {
      0.0, 0, 1,
      0.3, 0, 0
    } );
    ObjAnimate( "anm_lucien_room_lvl4_fail", "alp", 0, 0, "",
    {
      0.0, 0, 0,
      0.3, 0, 1
    } );
    AnimPlay( "anm_lucien_room_lvl4_fail", "DoAnim_gangster_fail", private.WinEnd );
    
  end;
  --*********************************************************************************************************************
  function private.InitMg ()
    
    local table_multiset = {};
    for i = 1, 5 do
      table.insert( table_multiset, { "spr_lucien_room_lvl4_mg_button"..i, 
        {
          event_mdown = function() private.ClkButton( i ) end,
          event_menter = function() private.EnterButton( i ) end,
          event_mleave = function() private.LeaveButton( i ) end
        } } );
    end;
    ObjMultiSet( table_multiset );
    
    private.mg = {};
    
    private.mg.count = 0;
    
    private.mg.level = 1;
    private.mg.MAX_LEVEL = 3;
    
    private.mg.order = {
      { 1, 3, 4, 2, 5, 1, 2 },
      { 4, 3, 3, 2, 4, 1, 5 },
      { 3, 2, 4, 2, 5, 1, 2 },
    };
    
    private.mg.res = { "icon_foot_left", "icon_foot_right", "icon_hand_left", "icon_hand_right", "icon_sound" };
    
    private.mg.time = { 9, 7, 5 };
    private.mg.count_level = { 4, 5, 6 };
    
    private.last_symbol = 0;
    
  end;
  --*********************************************************************************************************************
  function private.LoadMg ()
    
    local progress = ng_global.progress[ "ext" ][ "win_lucien_room_lvl4" ];
    
    private.mg.level = progress.level;
    private.mg.count = progress.count;
    
    private.SetProgress();
    
  end;
  --*********************************************************************************************************************
  function private.ClkButton ( num )
    
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_button", 0, "", 0 );

    local index_symbol = private.GetSymbolApply();
    local progress = ng_global.progress[ "ext" ][ "win_lucien_room_lvl4" ];
    
    if ( ( index_symbol == 0 ) or 
      ( num ~= private.mg.order[ private.mg.level ][ index_symbol ] ) or
      ( private.last_symbol == index_symbol ) ) then
      
      private.mg.count = 0;
      progress.count = 0;
      
    else

      local func_end = function()
        
        common_impl.Lock( false );
        
        if ( private.mg.count == private.mg.count_level[ private.mg.level ] and private.mg.level == private.mg.MAX_LEVEL ) then
          private.Win();
        elseif ( private.mg.count == private.mg.count_level[ private.mg.level ] ) then
          private.NextRound();
        else
          progress.count = private.mg.count;
        end;
        
      end;
      
      if ( num == 1 or num == 2 ) then
        common_impl.PlayAudio( "sfx", "levelext/sfx/aud_ghost_legs_4lvl", 0, "", 0 );
      elseif ( num == 3 or num == 4 ) then
        common_impl.PlayAudio( "sfx", "levelext/sfx/aud_ghost_hand_4lvl", 0, "", 0 );
      else
        common_impl.PlayAudio( "sfx", "levelext/sfx/aud_ghost_voice_4lvl", 0, "", 0 );
      end;

      common_impl.Lock( true );
      
      local symbol = "spr_lucien_room_lvl4_mg_symbol"..index_symbol;
      local alp = ObjGet( "spr_lucien_room_lvl4_mg_symbol_light" ).alp;
      ObjAttach( "spr_lucien_room_lvl4_mg_symbol_light", symbol );
      ObjAnimate( "spr_lucien_room_lvl4_mg_symbol_light", "alp", 0, 0, func_end,
      {
        0.0, 0, alp,
        0.3, 0, 1,
        0.6, 0, 0
      } );
      
      if index_symbol == 2 or
         index_symbol == 3 then  
        
        ObjStopAnimate( "anm_lucien_room_lvl4_mg", "DoAnim" );
        AnimPlay( "anm_lucien_room_lvl4_mg", "DoAnim", "" );
        
      end; 
    
      private.mg.count = private.mg.count + 1;
      private.last_symbol = index_symbol;
      
    end;
    
    private.AnimProgress();
    
  end;
  --*********************************************************************************************************************
  function private.GetSymbolApply ()
    
    for i = 1, 7 do
      
      if ( cmn.ApplyObj( "spr_lucien_room_lvl4_mg_symbol"..i, "obj_lucien_room_lvl4_mg_apply" ) ) then
        return i;
      end;
      
    end;
    
    return 0;
    
  end;
  --*********************************************************************************************************************
  function private.NextRound ( )
    
    private.mg.level = private.mg.level + 1;
    private.mg.count = 0;
    
    local progress = ng_global.progress[ "ext" ][ "win_lucien_room_lvl4" ];
    progress.count = 0;
    progress.level = private.mg.level;
    
    private.SetProgress();
    private.AnimRound();
    
  end;
  --*********************************************************************************************************************
  function private.AnimRound ( )
    
    for i = 1, 7 do
      
      local name_symbol = "spr_lucien_room_lvl4_mg_symbol"..i;
      ObjStopAnimate( name_symbol, "pos_x" );
      ObjStopAnimate( name_symbol, "alp" );
      ObjSet( name_symbol, 
      { 
        alp = 0, pos_x = 400, 
        res = "assets/levels/levelext/rm_lucien_room_lvl4/layers/"..private.mg.res[ private.mg.order[ private.mg.level ][ i ] ] 
      } );
      
    end;
    private.AnimStartSymbols( 1 );
        
  end;
  --*********************************************************************************************************************
  function private.AnimStartSymbols ( num )
    
    if ( num > 7 ) then
      return;
    end;
    
    private.AnimSymbol( num );
    local tme = private.mg.time[ private.mg.level ] / 6;
    ObjSet( "tmr_lucien_room_lvl4_mg", 
    { 
      playing = true, 
      time = tme, 
      endtrig = function() private.AnimStartSymbols( num + 1 ) end 
    } );
    
  end;
  --*********************************************************************************************************************
  function private.AnimSymbol ( num )
    
    local name_symbol = "spr_lucien_room_lvl4_mg_symbol"..num;
    local params = ObjGet( name_symbol );
    local pos_x = 0;
    local tme = private.mg.time[ private.mg.level ];
    local tme3 = private.mg.time[ private.mg.level ] / 2;
    local tme2 = private.mg.time[ private.mg.level ] / 6;
    
    local func_end = function()
      
      ObjSet( name_symbol, { pos_x = 400 } );
      private.AnimSymbol( num );
      if ( private.last_symbol == num ) then
        private.last_symbol = 0;
      end;
      
    end;
    
    ObjAnimate( name_symbol, "pos_x", 0, 0, func_end,
    {
      0.0, 0, params.pos_x,
      tme + tme2, 0, pos_x,
      tme + tme2+0.2, 0, pos_x
    });
    
    local tme2 = private.mg.time[ private.mg.level ] / 6;
    ObjAnimate( name_symbol, "alp", 0, 0, "",
    {
      0.0, 0, 0,
      0.3, 0, 0,
      tme2+0.3, 0, 1,
      tme, 0, 1,
      tme + tme2, 0, 0
    });
    ObjAnimate( name_symbol, "scale_xy", 0, 0, "",
    {
      0.0, 0, 0.6, 0.6,
      0.3, 0, 0.6, 0.6,
      tme2+0.3, 0, 1, 1,
      tme3, 0, 1.1, 1.1,
      tme, 0, 1, 1,
      tme + tme2, 0, 0.6, 0.6
    });    
    
  end;
  --*********************************************************************************************************************
  function private.SetProgress ( )
    
    local percent = private.mg.count / private.mg.count_level[ private.mg.level ];
    local croprect_w = ObjGet( "obj_lucien_room_lvl4_mg_progress" ).croprect_w;
    local croprect_x = croprect_w * ( percent - 1.5 );
    ObjSet( "obj_lucien_room_lvl4_mg_progress", { croprect_x = croprect_x } );
    
  end;
  --*********************************************************************************************************************
  function private.AnimProgress ( )
    
    local croprect_x1 = ObjGet( "obj_lucien_room_lvl4_mg_progress" ).croprect_x;
    private.SetProgress();
    local croprect_x2 = ObjGet( "obj_lucien_room_lvl4_mg_progress" ).croprect_x;
    ObjAnimate( "obj_lucien_room_lvl4_mg_progress", "croprect_x", 0, 0, "",
    {
      0.0, 0, croprect_x1,
      0.3, 0, croprect_x2
    } );
    
  end;
  --*********************************************************************************************************************
  function private.EnterButton ( num )
    
    common_impl.SetCursor( CURSOR_HAND );
    local alp = ObjGet( "spr_lucien_room_lvl4_mg_button"..num.."_light" ).alp;
    ObjAnimate( "spr_lucien_room_lvl4_mg_button"..num.."_light", "alp", 0, 0, "",
    {
      0.0, 0, alp,
      0.3, 0, 1
    } );
    
  end;
  --*********************************************************************************************************************
  function private.LeaveButton ( num )
    
    common_impl.SetCursor( CURSOR_DEFAULT );
    local alp = ObjGet( "spr_lucien_room_lvl4_mg_button"..num.."_light" ).alp;
    ObjAnimate( "spr_lucien_room_lvl4_mg_button"..num.."_light", "alp", 0, 0, "",
    {
      0.0, 0, alp,
      0.3, 0, 0
    } );
    
  end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************