-- name=rm_park_lvl4
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_park_lvl4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_bench_lvl4",    "room_hub" );
  ObjAttach( "zz_birdhouse",     "room_hub" );
  ObjAttach( "zz_bridge",        "room_hub" );
  ObjAttach( "zz_fountain_lvl4", "room_hub" );
  ObjAttach( "zz_wicket",        "room_hub" );
  ObjAttach( "zz_bush",          "room_hub" );

  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_bench_lvl4_blunt_knife",     { event_mdown = private.get_blunt_knife           }},
    { "spr_bench_lvl4_chain_lvl4",      { event_mdown = private.get_chain_lvl4            }},
    { "spr_bench_lvl4_decor_part_2",    { event_mdown = private.get_decor_part_2          }},
    { "spr_bench_lvl4_scheme_piece_2",  { event_mdown = private.get_scheme_piece_2        }},
    { "spr_bench_lvl4_hotel_symbol",    { event_mdown = private.get_hotel_symbol          }},
    { "obj_bench_lvl4_use_box_wrench",  { event_mdown = private.UseBoxWrench              }},
    { "obj_bench_lvl4_use_feathers_lvl4",  { event_mdown = private.UseFeathers              }},
    { "obj_bench_lvl4_clk_lattice",     { event_mdown = private.clk_bench_lattice         }},
    
    { "spr_birdhouse_clock_amulet",     { event_mdown = private.get_clock_amulet          }},
    { "spr_birdhouse_gothic_cross",     { event_mdown = private.get_gothic_cross          }},
    { "obj_birdhouse_use_seeds",        { event_mdown = private.UseSeeds                  }},
    
    { "spr_fountain_lvl4_basket",       { event_mdown = private.get_basket                }},
    { "obj_fountain_lvl4_use_hook_lvl4",{ event_mdown = private.UseHook                   }},
    
    { "spr_wicket_crowbar",             { event_mdown = private.get_crowbar               }},
    { "spr_wicket_handle_lvl4",         { event_mdown = private.get_handle_lvl4           }},

    { "spr_bush_twig",                  { event_mdown = private.get_twig                  }},
    { "spr_bush_tool_bag",              { event_mdown = private.get_tool_bag              }},
    { "obj_bush_use_rake",              { event_mdown = private.UseRake                   }},
    
    { "spr_park_lvl4_torch_lvl4",       { event_mdown = private.get_torch_lvl4            }},
    { "obj_park_lvl4_clk_anim_park_1",  { event_mdown = private.see_park_lvl4_anim_park_1 }},
    
    { "spr_bridge_hook_lvl4",           { event_mdown = private.get_hook_lvl4             }},
    { "obj_bridge_clk_lever",           { event_mdown = private.clk_bridge_lever          }},    
    { "obj_bridge_clk_gear",            { event_mdown = private.clk_bridge_gear           }},    
    
    { "obj_wicket_clk_gothic_cross",    { event_mdown = private.clk_gothic_cross          }},
    { "obj_wicket_use_decor_part",      { event_mdown = function() private.WicketUseDecorPart( "" ); end }},
    { "obj_wicket_use_decor_part_2",    { event_mdown = function() private.WicketUseDecorPart( "_2" ); end }},
    { "obj_wicket_use_decor_part_3",    { event_mdown = function() private.WicketUseDecorPart( "_3" ); end }},
    
    { "spr_park_lvl4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_21" ); end } },
    { "spr_bush_collect2_item_27",      { event_mdown = private.get_collect2_item_27      }},
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_park_lvl4 = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gho_park_lvl4_stone_stash",
      "gzz_park_lvl4_bench_lvl4",
      "gzz_park_lvl4_birdhouse",
      "gzz_park_lvl4_bridge",
      "gzz_park_lvl4_fountain_lvl4",
      "gzz_park_lvl4_wicket",
      "gzz_park_lvl4_bush",
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_bench_lvl4",
      "zz_birdhouse",
      "zz_bridge",
      "zz_fountain_lvl4",
      "zz_wicket",
      "zz_bush",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_park_lvl4", update_game_mode_park_lvl4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_park_lvl4 = function ()

    local effects_table = 
    {
      "anm_park_lvl4_sky",
      "anm_park_lvl4_br_center",
      "anm_park_lvl4_br_in_blue_circle",
      "anm_park_lvl4_fog_front",
      "anm_park_lvl4_fog_middle",
      "anm_park_lvl4_light_ho",
      "anm_park_lvl4_fireflies",
      "anm_park_lvl4_br_right",
      "anm_park_lvl4_br_left"
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_park_lvl4", update_performance_mode_park_lvl4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_park_lvl4 () end;
  --------------------------------------------------------------------------------------------
  local opn_park_lvl4_map = function ()

    common_impl.VisitMapRoom( "park_lvl4" );

  end;
  cmn.AddSubscriber( "opn_park_lvl4", opn_park_lvl4_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_21 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_21 = function ()
  
    ObjDelete( "obj_park_lvl4_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_21", get_collect_morph_item_21, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_blunt_knife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blunt_knife" ] = {
    type = "get",
    get_obj = "spr_bench_lvl4_blunt_knife",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  
  local get_blunt_knife_inv = function ()
  
    interface.InventoryItemAdd( "inv_blunt_knife", "spr_bench_lvl4_blunt_knife" );
  
  end;
  
  local get_blunt_knife_closezz = function ()
  
    ObjDelete( "gfx_bench_lvl4_blunt_knife" );
    ObjDelete( "spr_bench_lvl4_knife_2" );
    ObjDelete( "spr_bench_lvl4_shadow_rust_knife" );
    
  end;
  
  cmn.AddSubscriber( "get_blunt_knife", get_blunt_knife_inv );
  cmn.AddSubscriber( "get_blunt_knife", get_blunt_knife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chain_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chain_lvl4" ] = {
    type = "get",
    get_obj = "spr_bench_lvl4_chain_lvl4",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  
  local get_chain_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_chain_lvl4", "spr_bench_lvl4_chain_lvl4" );
  
  end;
  
  local get_chain_lvl4_closezz = function ()
  
    ObjDelete( "gfx_bench_lvl4_chain_lvl4" );
    ObjDelete( "spr_bench_lvl4_lvl4_patch_chain" );
    ObjDelete( "spr_park_lvl4_zz_bench_lvl_4_chain" );
    
  end;
  
  cmn.AddSubscriber( "get_chain_lvl4", get_chain_lvl4_inv );
  cmn.AddSubscriber( "get_chain_lvl4", get_chain_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_decor_part_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_decor_part_2" ] = {
    type = "get",
    get_obj = "spr_bench_lvl4_decor_part_2",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  
  local get_decor_part_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_decor_part_2", "spr_bench_lvl4_decor_part_2" );
  
  end;
  
  local get_decor_part_2_closezz = function ()
  
    ObjDelete( "gfx_bench_lvl4_decor_part_2" );
    
    if cmn.IsEventDone( "get_scheme_piece_2" ) then
      
      ObjMultiSet( { 
        { "obj_bench_lvl4_use_box_wrench", {  input = true } },
      } ); 
      
    end;
    
  end;
  
  cmn.AddSubscriber( "get_decor_part_2", get_decor_part_2_inv );
  cmn.AddSubscriber( "get_decor_part_2", get_decor_part_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scheme_piece_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scheme_piece_2" ] = {
    type = "get",
    get_obj = "spr_bench_lvl4_scheme_piece_2",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  
  local get_scheme_piece_2_inv = function ()
  
    local count = 1;
    
    for i = 2, 6, 1 do
      
      if ( cmn.IsEventDone( "get_scheme_piece_"..i ) ) then
        
        count = count + 1;
        ObjSet( "inv_scheme_piece_"..i, { alp = 1 } );
        
      end;
      
    end;
  
    ObjSet( "inv_scheme_piece_number", { frame = ObjGet( "inv_scheme_piece_number" ).frame + 1 } );
    interface.InventoryItemAdd( "inv_scheme_piece", "spr_bench_lvl4_scheme_piece_2", "assets/levels/levelext/rm_park_lvl4/zz_bench_lvl4/inv/inv_scheme_piece_2" );

    if count == 6 then
      ObjSet( "inv_scheme_piece", { drag = true } );
      
      cmn.SetInvPlusRGB( "paper_piece", true );
      
    else 
      ObjSet( "inv_scheme_piece", { drag = false } );

    end;
    
  end;
  
  local get_scheme_piece_2_closezz = function ()
  
    ObjDelete( "gfx_bench_lvl4_scheme_piece_2" );
    if cmn.IsEventDone( "get_decor_part_2" ) then
      
      ObjMultiSet( { 
        { "obj_bench_lvl4_use_box_wrench", {  input = true } },
      } ); 
      
    end;
    
  end;
  
  cmn.AddSubscriber( "get_scheme_piece_2", get_scheme_piece_2_inv );
  cmn.AddSubscriber( "get_scheme_piece_2", get_scheme_piece_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hotel_symbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hotel_symbol" ] = {
    type = "get",
    get_obj = "spr_bench_lvl4_hotel_symbol",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  
  local get_hotel_symbol_inv = function ()
  
    interface.InventoryItemAdd( "inv_hotel_symbol", "spr_bench_lvl4_hotel_symbol" );
  
  end;
  
  local get_hotel_symbol_closezz = function ()
  
    ObjDelete( "gfx_bench_lvl4_hotel_symbol" );
    ObjDelete( "gzz_park_lvl4_bench_lvl4"    );
 
  end;
  
  cmn.AddSubscriber( "get_hotel_symbol", get_hotel_symbol_inv );
  cmn.AddSubscriber( "get_hotel_symbol", get_hotel_symbol_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clock_amulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clock_amulet" ] = {
    type = "get",
    get_obj = "spr_birdhouse_clock_amulet",
    room = private.room_objname,
    zz = "zz_birdhouse",
    zz_gate = "gzz_park_lvl4_birdhouse"
  };
  
  local get_clock_amulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_clock_amulet", "spr_birdhouse_clock_amulet" );
  
  end;
  
  local get_clock_amulet_closezz = function ()
  
    ObjDelete( "gfx_birdhouse_clock_amulet" );
    
  end;
  
  cmn.AddSubscriber( "get_clock_amulet", get_clock_amulet_inv );
  cmn.AddSubscriber( "get_clock_amulet", get_clock_amulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gothic_cross () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gothic_cross" ] = {
    type = "get",
    get_obj = "spr_birdhouse_gothic_cross",
    room = private.room_objname,
    zz = "zz_birdhouse",
    zz_gate = "gzz_park_lvl4_birdhouse"
  };
  
  local get_gothic_cross_inv = function ()
  
    interface.InventoryItemAdd( "inv_gothic_cross", "spr_birdhouse_gothic_cross" );
  
  end;
  
  local get_gothic_cross_closezz = function ()
  
    ObjDelete( "gfx_birdhouse_gothic_cross" );
    ObjDelete( "gzz_park_lvl4_birdhouse"    );
    ObjDelete( "spr_park_lvl4_zz_birdhouse_gothic_cross" );
    
  end;
  
  cmn.AddSubscriber( "get_gothic_cross", get_gothic_cross_inv );
  cmn.AddSubscriber( "get_gothic_cross", get_gothic_cross_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_basket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_basket" ] = {
    type = "get",
    get_obj = "spr_fountain_lvl4_basket",
    room = private.room_objname,
    zz = "zz_fountain_lvl4",
    zz_gate = "gzz_park_lvl4_fountain_lvl4"
  };
  
  local get_basket_inv = function ()
  
    interface.InventoryItemAdd( "inv_basket", "spr_fountain_lvl4_basket" );
    ObjSet( "inv_basket", { drag = false } );

  end;
  
  local get_basket_closezz = function ()
  
    ObjDelete( "gfx_fountain_lvl4_basket" );
  
  end;
  
  cmn.AddSubscriber( "get_basket", get_basket_inv );
  cmn.AddSubscriber( "get_basket", get_basket_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crowbar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crowbar" ] = {
    type = "get",
    get_obj = "spr_wicket_crowbar",
    room = private.room_objname,
    zz = "zz_wicket",
    zz_gate = "gzz_park_lvl4_wicket"
  };
  
  local get_crowbar_inv = function ()
  
    interface.InventoryItemAdd( "inv_crowbar", "spr_wicket_crowbar" );
  
  end;
  
  local get_crowbar_closezz = function ()
  
    ObjDelete( "gfx_wicket_crowbar" );
  
  end;
  
  cmn.AddSubscriber( "get_crowbar", get_crowbar_inv );
  cmn.AddSubscriber( "get_crowbar", get_crowbar_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handle_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle_lvl4" ] = {
    type = "get",
    get_obj = "spr_wicket_handle_lvl4",
    room = private.room_objname,
    zz = "zz_wicket",
    zz_gate = "gzz_park_lvl4_wicket"
  };
  
  local get_handle_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_handle_lvl4", "spr_wicket_handle_lvl4" );
  
  end;
  
  local get_handle_lvl4_closezz = function ()
  
    ObjDelete( "gfx_wicket_handle_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_handle_lvl4", get_handle_lvl4_inv );
  cmn.AddSubscriber( "get_handle_lvl4", get_handle_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_twig () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_twig" ] = {
    type = "get",
    get_obj = "spr_bush_twig",
    room = private.room_objname,
    zz = "zz_bush",
    zz_gate = "gzz_park_lvl4_bush"
  };
  
  local get_twig_inv = function ()
  
    interface.InventoryItemAdd( "inv_twig", "spr_bush_twig" );
  
  end;
  
  local get_twig_closezz = function ()
    
    ObjSet( "obj_bush_use_rake", { input = true } );  
    ObjDelete( "gfx_bush_lvl4_twig" );
  
  end;
  
  cmn.AddSubscriber( "get_twig", get_twig_inv );
  cmn.AddSubscriber( "get_twig", get_twig_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_torch_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_torch_lvl4" ] = {
    type = "get",
    get_obj = "spr_park_lvl4_torch_lvl4",
    room = private.room_objname,
  };
  
  local get_torch_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_torch_lvl4", "spr_park_lvl4_torch_lvl4" );
  
  end;
  
  local get_torch_lvl4_closezz = function ()
  
    ObjDelete( "gfx_park_lvl4_torch_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_torch_lvl4", get_torch_lvl4_inv );
  cmn.AddSubscriber( "get_torch_lvl4", get_torch_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tool_bag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tool_bag" ] = {
    type = "get",
    get_obj = "spr_bush_tool_bag",
    room = private.room_objname,
    zz = "zz_bush",
    zz_gate = "gzz_park_lvl4_bush"
  };
  
  local get_tool_bag_inv = function ()
  
    interface.InventoryItemAdd( "inv_tool_bag", "spr_bush_tool_bag" );
    ObjSet( "inv_tool_bag", { drag = false } );

  end;
  
  local get_tool_bag_closezz = function ()
  
    ObjDelete( "gfx_park_lvl4_tool_bag" );
    ObjDelete( "spr_park_lvl4_zz_bush_box" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_27" ) ) then
      
      ObjDelete( "gzz_park_lvl4_bush" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_tool_bag", get_tool_bag_inv );
  cmn.AddSubscriber( "get_tool_bag", get_tool_bag_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_hook_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hook_lvl4" ] = {
    type = "get",
    get_obj = "spr_bridge_hook_lvl4",
    room = private.room_objname,
    zz = "zz_bridge",
    zz_gate = "gzz_park_lvl4_bridge"
  };
  
  local get_hook_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_hook_lvl4", "spr_bridge_hook_lvl4" );
  
  end;
  
  local get_hook_lvl4_closezz = function ()
  
    ObjDelete( "gfx_bridge_hook_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_hook_lvl4", get_hook_lvl4_inv );
  cmn.AddSubscriber( "get_hook_lvl4", get_hook_lvl4_closezz, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_27 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_27 = function ()
  
    ObjDelete( "obj_bush_collect2_item_27" ); 
  
    if ( cmn.IsEventDone( "get_tool_bag" ) ) then
      
      ObjDelete( "gzz_park_lvl4_bush" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_27", get_collect2_item_27, private.room_objname );      
  --------------------------------------------------------------------------------------------
  -- function use_twig () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_twig" ] = {
    type = "use",
    inv_obj = "inv_twig",
    use_place = "obj_bench_lvl4_use_twig",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  local use_twig_inv = function ()
  
    interface.InventoryItemRemove( "inv_twig" );
  
  end;
  local use_twig_beg = function ()
  
    ObjDelete( "obj_bench_lvl4_use_twig" );
  
  end;
  local use_twig_end = function ()
    
    ObjDelete( "anm_bench_lvl4_rod" );
    ObjMultiSet( { 
      { "spr_bench_lvl4_blunt_knife", {   alp = 1, input = true   } },
    } );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_twig", use_twig_beg, private.room_objname );
  cmn.AddSubscriber( "use_twig", use_twig_inv );
  cmn.AddSubscriber( "use_twig", use_twig_end, private.room_objname );
  cmn.AddSubscriber( "use_twig_inv", use_twig_inv, private.room_objname );
  cmn.AddSubscriber( "use_twig_beg", use_twig_beg, private.room_objname );
  cmn.AddSubscriber( "use_twig_end", use_twig_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_feathers_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_feathers_lvl4" ] = {
    type = "use",
    inv_obj = "inv_feathers_lvl4",
    use_place = "obj_bench_lvl4_use_feathers_lvl4",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  local use_feathers_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_feathers_lvl4" );
  
  end;
  local use_feathers_lvl4_beg = function ()
  
    ObjDelete( "obj_bench_lvl4_use_feathers_lvl4" );
    ObjDelete( "anm_bench_lvl4_feathers_hh" );
  
  end;
  local use_feathers_lvl4_end = function ()
    
    ObjDelete( "spr_park_lvl4_zz_bench_lvl_4_spiderweb" );
    ObjDelete( "spr_park_lvl4_zz_bench_lvl_4_leafs" );
    
    ObjMultiSet( { 
      { "spr_bench_lvl4_decor_part_2",   {  input = true } },
      { "spr_bench_lvl4_scheme_piece_2", {  input = true } },
      { "gfx_bench_lvl4_decor_part_2",   { active = true } },
      { "gfx_bench_lvl4_scheme_piece_2", { active = true } },
      { "anm_bench_lvl4_feathers",       {  frame = 300  } },
    } ); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_feathers_lvl4", use_feathers_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_feathers_lvl4", use_feathers_lvl4_inv );
  cmn.AddSubscriber( "use_feathers_lvl4", use_feathers_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_feathers_lvl4_inv", use_feathers_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_feathers_lvl4_beg", use_feathers_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_feathers_lvl4_end", use_feathers_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stone_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stone_lvl4" ] = {
    type = "use",
    inv_obj = "inv_stone_lvl4",
    use_place = "obj_bench_lvl4_use_stone_lvl4",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  local use_stone_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_stone_lvl4" );
  
  end;
  local use_stone_lvl4_beg = function ()
  
    ObjDelete( "obj_bench_lvl4_use_stone_lvl4" );
  
  end;
  local use_stone_lvl4_end = function ()
    
    ObjDelete( "anm_bench_lvl4_stone" );
    ObjMultiSet( { 
      { "spr_bench_lvl4_chain_lvl4", { input = true, alp = 1 } },
      { "obj_bench_lvl4_part_chain", {   alp = 1             } },
    } );  
        
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stone_lvl4", use_stone_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_lvl4", use_stone_lvl4_inv );
  cmn.AddSubscriber( "use_stone_lvl4", use_stone_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_stone_lvl4_inv", use_stone_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_stone_lvl4_beg", use_stone_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_lvl4_end", use_stone_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_box_wrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_box_wrench" ] = {
    type = "use",
    inv_obj = "inv_box_wrench",
    use_place = "obj_bench_lvl4_use_box_wrench",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  local use_box_wrench_inv = function ()
  
    interface.InventoryItemRemove( "inv_box_wrench" );
  
  end;
  local use_box_wrench_beg = function ()
  
    ObjDelete( "obj_bench_lvl4_use_box_wrench" );
  
  end;
  local use_box_wrench_end = function ()
  
    --ObjSet( "spr_bench_lvl4_hotel_symbol", { input = true, visible = true } );
    ObjDelete( "vid_bench_lvl4_wrench" );
    ObjMultiSet( { 
      { "obj_bench_lvl4_clk_lattice", { input = true } },
    } );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_box_wrench", use_box_wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_box_wrench", use_box_wrench_inv );
  cmn.AddSubscriber( "use_box_wrench", use_box_wrench_end, private.room_objname );
  cmn.AddSubscriber( "use_box_wrench_inv", use_box_wrench_inv, private.room_objname );
  cmn.AddSubscriber( "use_box_wrench_beg", use_box_wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_box_wrench_end", use_box_wrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seeds () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_seeds" ] = {
    type = "use",
    inv_obj = "inv_seeds",
    use_place = "obj_birdhouse_use_seeds",
    room = private.room_objname,
    zz = "zz_birdhouse",
    zz_gate = "gzz_park_lvl4_birdhouse"
  };
  local use_seeds_inv = function ()
  
    interface.InventoryItemRemove( "inv_seeds" );
  
  end;
  local use_seeds_beg = function ()
  
    ObjDelete( "obj_birdhouse_use_seeds" );
  
  end;
  local use_seeds_end = function ()
  
    ObjDelete( "anm_birdhouse_bird" );
    ObjDelete( "anm_park_lvl4_bird" );
    ObjDelete( "obj_birdhouse_seed" );
    ObjMultiSet( { 
      { "anm_birdhouse_bird_eat",     {    alp = 1                    } },
      { "anm_park_lvl4_bird_eat",     {    alp = 1                    } },
      { "spr_birdhouse_clock_amulet", {  input = true, visible = true } },
      { "gfx_birdhouse_clock_amulet", { active = true                 } },
    } );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seeds", use_seeds_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeds", use_seeds_inv );
  cmn.AddSubscriber( "use_seeds", use_seeds_end, private.room_objname );
  cmn.AddSubscriber( "use_seeds_inv", use_seeds_inv, private.room_objname );
  cmn.AddSubscriber( "use_seeds_beg", use_seeds_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeds_end", use_seeds_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_bulb () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bulb" ] = {
    type = "use",
    inv_obj = "inv_bulb",
    use_place = "obj_birdhouse_use_bulb",
    room = private.room_objname,
    zz = "zz_birdhouse",
    zz_gate = "gzz_park_lvl4_birdhouse"
  };
  local use_bulb_inv = function ()
  
    interface.InventoryItemRemove( "inv_bulb" );
  
  end;
  local use_bulb_beg = function ()
  
    ObjDelete( "obj_birdhouse_use_bulb" );
  
  end;
  local use_bulb_end = function ()
  
    ObjSet( "spr_birdhouse_gothic_cross", {  input = true, visible = true } );
    ObjSet( "gfx_birdhouse_gothic_cross", { active = true                 } ); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bulb", use_bulb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulb", use_bulb_inv );
  cmn.AddSubscriber( "use_bulb", use_bulb_end, private.room_objname );
  cmn.AddSubscriber( "use_bulb_inv", use_bulb_inv, private.room_objname );
  cmn.AddSubscriber( "use_bulb_beg", use_bulb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulb_end", use_bulb_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lever_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lever_lvl4" ] = {
    type = "use",
    inv_obj = "inv_lever_lvl4",
    use_place = "obj_bridge_use_lever_lvl4",
    room = private.room_objname,
    zz = "zz_bridge",
    zz_gate = "gzz_park_lvl4_bridge"
  };
  local use_lever_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_lever_lvl4" );
  
  end;
  local use_lever_lvl4_beg = function ()
  
    ObjDelete( "obj_bridge_use_lever_lvl4" );
  
  end;
  local use_lever_lvl4_end = function ()
  
    ObjDelete( "gzz_park_lvl4_bridge" );
    ObjSet( "grm_park_lvl4_backyard", { input = true, visible = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_park_lvl4_backyard_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lever_lvl4", use_lever_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever_lvl4", use_lever_lvl4_inv );
  cmn.AddSubscriber( "use_lever_lvl4", use_lever_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_lever_lvl4_inv", use_lever_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_lever_lvl4_beg", use_lever_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever_lvl4_end", use_lever_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gear_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gear_lvl4" ] = {
    type = "use",
    inv_obj = "inv_gear_lvl4",
    use_place = "obj_bridge_use_gear_lvl4",
    room = private.room_objname,
    zz = "zz_bridge",
    zz_gate = "gzz_park_lvl4_bridge"
  };
  local use_gear_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_gear_lvl4" );
  
  end;
  local use_gear_lvl4_beg = function ()
  
    ObjDelete( "obj_bridge_use_gear_lvl4" );
  
  end;
  local use_gear_lvl4_end = function ()
    
    ObjDelete( "anm_bridge_gear" );  
    ObjDelete( "obj_bridge_over" );  
    ObjDelete( "anm_bridge_old_lever" );  
    ObjMultiSet( { 
      { "spr_bridge_hook_lvl4", {   alp = 1, input = true   } },
      { "anm_bridge_lever",     {   alp = 1                 } },
      { "anm_bridge_hook",      { frame = 300               } },
    } );  
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gear_lvl4", use_gear_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear_lvl4", use_gear_lvl4_inv );
  cmn.AddSubscriber( "use_gear_lvl4", use_gear_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_gear_lvl4_inv", use_gear_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_gear_lvl4_beg", use_gear_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear_lvl4_end", use_gear_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hook_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hook_lvl4" ] = {
    type = "use",
    inv_obj = "inv_hook_lvl4",
    use_place = "obj_fountain_lvl4_use_hook_lvl4",
    room = private.room_objname,
    zz = "zz_fountain_lvl4",
    zz_gate = "gzz_park_lvl4_fountain_lvl4"
  };
  local use_hook_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_hook_lvl4" );
  
  end;
  local use_hook_lvl4_beg = function ()
  
    ObjDelete( "obj_fountain_lvl4_use_hook_lvl4" );
  
  end;
  local use_hook_lvl4_end = function ()
    
    ObjDelete( "anm_fountain_lvl4_bascet_on_border" );
    ObjDelete( "anm_fountain_lvl4_hook" );
    ObjMultiSet( {   
      { "spr_fountain_lvl4_basket", {    alp = 1, input = true } },
      { "gfx_fountain_lvl4_basket", { active = true            } },
    } );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hook_lvl4", use_hook_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl4", use_hook_lvl4_inv );
  cmn.AddSubscriber( "use_hook_lvl4", use_hook_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl4_inv", use_hook_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl4_beg", use_hook_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl4_end", use_hook_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stone_triangle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stone_triangle" ] = {
    type = "use",
    inv_obj = "inv_stone_triangle",
    use_place = "obj_fountain_lvl4_use_stone_triangle",
    room = private.room_objname,
    zz = "zz_fountain_lvl4",
    zz_gate = "gzz_park_lvl4_fountain_lvl4"
  };
  local use_stone_triangle_inv = function ()
  
    interface.InventoryItemRemove( "inv_stone_triangle" );
  
  end;
  local use_stone_triangle_beg = function ()
  
    ObjDelete( "obj_fountain_lvl4_use_stone_triangle" );
  
  end;
  local use_stone_triangle_end = function ()
  
    ObjDelete( "gzz_park_lvl4_fountain_lvl4" )
    ObjMultiSet( {   
      { "gho_park_lvl4_stone_stash",         { input = true, visible = true, active = true } },
      { "spr_park_lvl4_zz_fontain_triangle", {   alp = 1                                   } },
    } );  
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stone_triangle", use_stone_triangle_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_triangle", use_stone_triangle_inv );
  cmn.AddSubscriber( "use_stone_triangle", use_stone_triangle_end, private.room_objname );
  cmn.AddSubscriber( "use_stone_triangle_inv", use_stone_triangle_inv, private.room_objname );
  cmn.AddSubscriber( "use_stone_triangle_beg", use_stone_triangle_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_triangle_end", use_stone_triangle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_decor_part () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_decor_part" ] = {
    type = "use",
    inv_obj = "inv_decor_part",
    use_place = "obj_wicket_use_decor_part",
    room = private.room_objname,
    zz = "zz_wicket",
    zz_gate = "gzz_park_lvl4_wicket"
  };
  local use_decor_part_inv = function ()
  
    interface.InventoryItemRemove( "inv_decor_part" );
  
  end;
  local use_decor_part_beg = function ()
  
    ObjDelete( "obj_wicket_use_decor_part" );
  
  end;
  local use_decor_part_end = function ()
    
    if cmn.IsEventDone( "use_decor_part_2" ) then
      
      ObjDelete( "spr_wicket_plate_big" );
      ObjMultiSet( { 
        { "spr_wicket_handle_lvl4",  { input = true } },
        { "anm_wicket_use_big_plate_open",  { alp = 1, visible = true, frame = 500 } },
      } );
      
    else 
      
      ObjMultiSet( { 
        { "anm_wicket_use_decor_part1",  { frame = 500 } },
      } );
    
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_decor_part", use_decor_part_beg, private.room_objname );
  cmn.AddSubscriber( "use_decor_part", use_decor_part_inv );
  cmn.AddSubscriber( "use_decor_part", use_decor_part_end, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_inv", use_decor_part_inv, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_beg", use_decor_part_beg, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_end", use_decor_part_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_decor_part_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_decor_part_2" ] = {
    type = "use",
    inv_obj = "inv_decor_part_2",
    use_place = "obj_wicket_use_decor_part_2",
    room = private.room_objname,
    zz = "zz_wicket",
    zz_gate = "gzz_park_lvl4_wicket"
  };
  local use_decor_part_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_decor_part_2" );
  
  end;
  local use_decor_part_2_beg = function ()
  
    ObjDelete( "obj_wicket_use_decor_part_2" );
  
  end;
  local use_decor_part_2_end = function ()
    
    if cmn.IsEventDone( "use_decor_part" ) then
      
      ObjDelete( "spr_wicket_plate_big" );
      ObjMultiSet( { 
        { "spr_wicket_handle_lvl4",  { input = true } },
        { "anm_wicket_use_big_plate_open",  { alp = 1, visible = true, frame = 500 } },
      } );
      
    else 
      
      ObjMultiSet( { 
        { "anm_wicket_use_decor_part2",  { frame = 500 } },
      } );
    
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_decor_part_2", use_decor_part_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_2", use_decor_part_2_inv );
  cmn.AddSubscriber( "use_decor_part_2", use_decor_part_2_end, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_2_inv", use_decor_part_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_2_beg", use_decor_part_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_2_end", use_decor_part_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gothic_cross () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gothic_cross" ] = {
    type = "use",
    inv_obj = "inv_gothic_cross",
    use_place = "obj_wicket_use_gothic_cross",
    room = private.room_objname,
    zz = "zz_wicket",
    zz_gate = "gzz_park_lvl4_wicket"
  };
  local use_gothic_cross_inv = function ()
  
    interface.InventoryItemRemove( "inv_gothic_cross" );
  
  end;
  local use_gothic_cross_beg = function ()
  
    ObjDelete( "obj_wicket_use_gothic_cross" );
  
  end;
  local use_gothic_cross_end = function ()

    ObjMultiSet( { 
      { "spr_wicket_cross",  { alp = 1, visible = true } },
      { "obj_wicket_clk_gothic_cross",  { input = true } },
    } );
    
    ObjDelete( "anm_wicket_use_cross" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gothic_cross", use_gothic_cross_beg, private.room_objname );
  cmn.AddSubscriber( "use_gothic_cross", use_gothic_cross_inv );
  cmn.AddSubscriber( "use_gothic_cross", use_gothic_cross_end, private.room_objname );
  cmn.AddSubscriber( "use_gothic_cross_inv", use_gothic_cross_inv, private.room_objname );
  cmn.AddSubscriber( "use_gothic_cross_beg", use_gothic_cross_beg, private.room_objname );
  cmn.AddSubscriber( "use_gothic_cross_end", use_gothic_cross_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_decor_part_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_decor_part_3" ] = {
    type = "use",
    inv_obj = "inv_decor_part_3",
    use_place = "obj_wicket_use_decor_part_3",
    room = private.room_objname,
    zz = "zz_wicket",
    zz_gate = "gzz_park_lvl4_wicket"
  };
  local use_decor_part_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_decor_part_3" );
  
  end;
  local use_decor_part_3_beg = function ()
  
    ObjDelete( "obj_wicket_use_decor_part_3" );
  
  end;
  local use_decor_part_3_end = function ()
  
    ObjDelete( "spr_wicket_plate_small" );
    ObjMultiSet( { 
      { "spr_wicket_crowbar",  { input = true } },
      { "anm_wicket_use_decor_part3",  { alp = 1, visible = true, frame = 500 } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_decor_part_3", use_decor_part_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_3", use_decor_part_3_inv );
  cmn.AddSubscriber( "use_decor_part_3", use_decor_part_3_end, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_3_inv", use_decor_part_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_3_beg", use_decor_part_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_decor_part_3_end", use_decor_part_3_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_duster_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_duster_lvl4" ] = {
    type = "use",
    inv_obj = "inv_duster_lvl4",
    use_place = "obj_park_lvl4_use_duster_lvl4",
    room = private.room_objname,
  };
  local use_duster_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_duster_lvl4" );
  
  end;
  local use_duster_lvl4_beg = function ()
  
    ObjDelete( "obj_park_lvl4_use_duster_lvl4" );
  
  end;
  local use_duster_lvl4_end = function ()
    
    ObjDelete( "anm_park_lvl4_lantern" );  
    ObjSet( "spr_park_lvl4_torch_lvl4", { input = true, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_duster_lvl4", use_duster_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster_lvl4", use_duster_lvl4_inv );
  cmn.AddSubscriber( "use_duster_lvl4", use_duster_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_duster_lvl4_inv", use_duster_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_duster_lvl4_beg", use_duster_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster_lvl4_end", use_duster_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rake () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_rake" ] = {
    type = "use",
    inv_obj = "inv_rake",
    use_place = "obj_bush_use_rake",
    room = private.room_objname,
    zz = "zz_bush",
    zz_gate = "gzz_park_lvl4_bush"
  };
  local use_rake_inv = function ()
  
    interface.InventoryItemRemove( "inv_rake" );
  
  end;
  local use_rake_beg = function ()
  
    ObjDelete( "obj_bush_use_rake" );
  
  end;
  local use_rake_end = function ()
    
    ObjDelete( "obj_bush_leaves" );
    ObjSet( "spr_bush_tool_bag",      {  input = true, visible = true } );
    ObjSet( "gfx_park_lvl4_tool_bag", { active = true                 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rake", use_rake_beg, private.room_objname );
  cmn.AddSubscriber( "use_rake", use_rake_inv );
  cmn.AddSubscriber( "use_rake", use_rake_end, private.room_objname );
  cmn.AddSubscriber( "use_rake_inv", use_rake_inv, private.room_objname );
  cmn.AddSubscriber( "use_rake_beg", use_rake_beg, private.room_objname );
  cmn.AddSubscriber( "use_rake_end", use_rake_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_gothic_cross () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_gothic_cross" ] = {
    type = "click",
    use_place = "obj_wicket_clk_gothic_cross",
    room = private.room_objname,
    zz = "zz_wicket",
    zz_gate = "gzz_park_lvl4_wicket"
  };
  local clk_gothic_cross_beg = function ()

    ObjDelete( "obj_wicket_clk_gothic_cross" );
  
  end;
  local clk_gothic_cross_end = function ()

    ObjDelete( "gzz_park_lvl4_wicket" ); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_gothic_cross",     clk_gothic_cross_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_gothic_cross",     clk_gothic_cross_end, private.room_objname  );
  cmn.AddSubscriber( "clk_gothic_cross_beg", clk_gothic_cross_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_gothic_cross_end", clk_gothic_cross_end, private.room_objname  );
  
  --------------------------------------------------------------------------------------------
  -- function clk_bridge_lever () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bridge_lever" ] = {
    type = "click",
    use_place = "obj_bridge_clk_lever",
    room = private.room_objname,
    zz = "zz_bridge",
    zz_gate = "gzz_park_lvl4_bridge"
  };
  local clk_bridge_lever_beg = function ()

    ObjDelete( "obj_bridge_clk_lever" );
  
  end;
  local clk_bridge_lever_end = function ()
    
    ObjDelete( "spr_bridge_truck" );
    ObjMultiSet( { 
      { "anm_bridge_old_lever",      { frame = 300  } },
      { "anm_bridge_gear",           {   alp = 1    } },
      { "obj_bridge_use_lever_lvl4", { input = true } },
    } ); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bridge_lever",     clk_bridge_lever_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bridge_lever",     clk_bridge_lever_end, private.room_objname  );
  cmn.AddSubscriber( "clk_bridge_lever_beg", clk_bridge_lever_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bridge_lever_end", clk_bridge_lever_end, private.room_objname  );
  
  --------------------------------------------------------------------------------------------
  -- function clk_bridge_gear () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bridge_gear" ] = {
    type = "click",
    use_place = "obj_bridge_clk_gear",
    room = private.room_objname,
    zz = "zz_bridge",
    zz_gate = "gzz_park_lvl4_bridge"
  };
  local clk_bridge_gear_beg = function ()

    ObjDelete( "obj_bridge_clk_gear" );
  
  end;
  local clk_bridge_gear_end = function ()

    ObjDelete( "anm_bridge_old_gear" ); 
    ObjDelete( "anm_bridge_flap" ); 
    ObjMultiSet( { 
      { "obj_bridge_use_gear_lvl4", { input = true } },
    } );   
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bridge_gear",     clk_bridge_gear_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bridge_gear",     clk_bridge_gear_end, private.room_objname  );
  cmn.AddSubscriber( "clk_bridge_gear_beg", clk_bridge_gear_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bridge_gear_end", clk_bridge_gear_end, private.room_objname  );
  
  --------------------------------------------------------------------------------------------
  -- function clk_bench_lattice () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bench_lattice" ] = {
    type = "click",
    use_place = "obj_bench_lvl4_clk_lattice",
    room = private.room_objname,
    zz = "zz_bench_lvl4",
    zz_gate = "gzz_park_lvl4_bench_lvl4"
  };
  local clk_bench_lattice_beg = function ()

    ObjDelete( "obj_bench_lvl4_clk_lattice" );
  
  end;
  local clk_bench_lattice_end = function ()

    ObjDelete( "spr_bench_lvl4_lattice" );
    ObjDelete( "spr_park_lvl4_zz_bench_lvl_4_lattice" );
    
    ObjMultiSet( { 
      { "spr_bench_lvl4_hotel_symbol", {  input = true            } },
      { "gfx_bench_lvl4_hotel_symbol", { active = true            } },
    } ); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bench_lattice",     clk_bench_lattice_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bench_lattice",     clk_bench_lattice_end, private.room_objname  );
  cmn.AddSubscriber( "clk_bench_lattice_beg", clk_bench_lattice_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bench_lattice_end", clk_bench_lattice_end, private.room_objname  );
  
  --------------------------------------------------------------------------------------------
  -- function see_park_lvl4_anim_park_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_park_lvl4_anim_park_1" ] = {
    type = "click",
    use_place = "obj_park_lvl4_clk_anim_park_1",
    room = private.room_objname
  };

  local see_park_lvl4_anim_park_1 = function ()
  
    ObjDelete( "obj_park_lvl4_clk_anim_park_1" );
    ObjDelete( "anm_park_lvl4_anim" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_park_lvl4_anim_park_1", see_park_lvl4_anim_park_1, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_park_lvl4_bridge () end;
  --------------------------------------------------------------------------------------------
  local see_park_lvl4_bridge = function ()
  
    ObjDelete( "anm_park_lvl4_bridge" );
    ObjMultiSet( { 
      { "anm_park_lvl4_bridge_after", { alp = 1, frame = 300 } },
    } );  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_park_lvl4_bridge", see_park_lvl4_bridge, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_park_lvl4_gates () end;
  --------------------------------------------------------------------------------------------
  local see_park_lvl4_gates = function ()
  
    ObjMultiSet( { 
      { "anm_park_lvl4_open_gate", { frame = 300                                 } },
      { "grm_park_lvl4_graveyard", { input = true, visible = true, active = true } },
    } );  
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_park_lvl4_graveyard_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_park_lvl4_gates", see_park_lvl4_gates, private.room_objname ); 
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_bridge () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_bridge" );  
    ------------------------------------------------- 
    function zz_bridge.Close ()
      
      if cmn.IsEventDone( "use_lever_lvl4" ) and not cmn.IsEventDone( "see_park_lvl4_bridge" ) then
        
        private.see_park_lvl4_bridge();
        
      end;
      
    end; 
    
  --*******************************************************************************************************************
  --*** function zz_wicket () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_wicket" );  
    ------------------------------------------------- 
    function zz_wicket.Close ()
      
      if cmn.IsEventDone( "clk_gothic_cross" ) and not cmn.IsEventDone( "see_park_lvl4_gates" ) then
        private.see_park_lvl4_gates();
      end; 
      
    end; 

  --*******************************************************************************************************************
  --*** function zz_birdhouse () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_birdhouse" );  
    ------------------------------------------------- 
    function zz_birdhouse.PreOpen ()
      
      if not cmn.IsEventDone( "use_bulb" ) then
        common_impl.PlayAudio( "env", "levelext/env/aud_bees_env", 1, "", 0 );
      end; 
      
    end; 
    ------------------------------------------------- 
    function zz_birdhouse.PreClose ()
      
      if not cmn.IsEventDone( "use_bulb" ) then
        common_impl.StopAudio( "env", "levelext/env/aud_bees_env", 0.5 );
      end; 
      
    end; 
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_park_lvl4();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_park_lvl4_env" }, "", 0.5 ); 
  common_impl.MorphItemMorphing();

  if not cmn.IsEventDone( "see_park_lvl4_anim_park_1" ) then
    private.see_park_lvl4_anim_park_1();
  end;
  if cmn.IsEventDone( "use_lever_lvl4" ) and not cmn.IsEventDone( "see_park_lvl4_bridge" ) then
    private.see_park_lvl4_bridge();
  end; 
  if cmn.IsEventDone( "clk_gothic_cross" ) and not cmn.IsEventDone( "see_park_lvl4_gates" ) then
    private.see_park_lvl4_gates();
  end; 
  
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()
  common_impl.StopAudio( "env", "levelext/env/aud_park_lvl4_env", 0.5 );
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_twig ()

  local item = "inv_twig";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_bench_lvl4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bench_lvl4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bench_lvl4_use_twig" ) ) then

    cmn.CallEventHandler( "use_twig_inv" );
    cmn.CallEventHandler( "use_twig_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_twig" );
      cmn.CallEventHandler( "use_twig_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_puller_4lvl", 0, "", 0 );
    
    AnimPlay( "anm_bench_lvl4_rod", "rod", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_feathers_lvl4 ()

  local item = "inv_feathers_lvl4";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_bench_lvl4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bench_lvl4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bench_lvl4_use_feathers_lvl4" ) ) then

    cmn.CallEventHandler( "use_feathers_lvl4_inv" );
    cmn.CallEventHandler( "use_feathers_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_feathers_lvl4" );
      cmn.CallEventHandler( "use_feathers_lvl4_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_brush", 0, "", 0 );

    ObjSet( "anm_bench_lvl4_feathers", { alp = 1 } );
    AnimPlay( "anm_bench_lvl4_feathers", "feathers", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stone_lvl4 ()

  local item = "inv_stone_lvl4";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_bench_lvl4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bench_lvl4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bench_lvl4_use_stone_lvl4" ) ) then

    cmn.CallEventHandler( "use_stone_lvl4_inv" );
    cmn.CallEventHandler( "use_stone_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_stone_lvl4" );
      cmn.CallEventHandler( "use_stone_lvl4_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_stone_4lvl", 0, "", 0 );

    AnimPlay( "anm_bench_lvl4_stone", "stone", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_box_wrench ()

  local item = "inv_box_wrench";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_bench_lvl4" ) and 
       cmn.IsEventDone( "get_scheme_piece_2" ) and
       cmn.IsEventDone( "get_decor_part_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bench_lvl4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bench_lvl4_use_box_wrench" ) and 
           cmn.IsEventDone( "get_scheme_piece_2" ) and
           cmn.IsEventDone( "get_decor_part_2" ) ) then

    cmn.CallEventHandler( "use_box_wrench_inv" );
    cmn.CallEventHandler( "use_box_wrench_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_box_wrench" );
      cmn.CallEventHandler( "use_box_wrench_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_wrench_4lvl", 0, "", 0 );
    ObjMultiSet( { 
      { "spr_bench_lvl4_lattice",      {  pos_z = 1 } },
    } );     
    VidPlay( "vid_bench_lvl4_wrench", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_seeds ()

  local item = "inv_seeds";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_birdhouse" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_birdhouse', 'under_frame' );
    
    return true;

  elseif ( cmn.ApplyObj( item, "obj_birdhouse_use_seeds" ) ) then

    cmn.CallEventHandler( "use_seeds_inv" );
    cmn.CallEventHandler( "use_seeds_beg" );

    local func_end = function ()
      
      local func_end2 = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_seeds" );
        cmn.CallEventHandler( "use_seeds_end" );
        
        ObjMultiSet( { 
          { "anm_birdhouse_bird_eat", { frame = 0 } },
        } );    
      
      end;
      
      ObjMultiSet( { 
        { "obj_birdhouse_seed", { alp = 0 } },
      } );    
      AnimPlay( "anm_birdhouse_bird", "bird_amulet", func_end2 );
    
    end;

    cmn.Lock( true );

    common_impl.StopAudio( "env", "levelext/env/aud_bees_env", 0.5 );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_magpie_4lvl", 0, "", 0 );
    
    ObjMultiSet( { 
      { "obj_birdhouse_seed", { alp = 1 } },
    } );    
      
    AnimPlay( "anm_birdhouse_seeds", "seeds", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bulb ()

  local item = "inv_bulb";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_birdhouse" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( 'zz_birdhouse', 'under_frame' );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_birdhouse_use_bulb" ) ) then

    cmn.CallEventHandler( "use_bulb_inv" );
    cmn.CallEventHandler( "use_bulb_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bulb" );
      cmn.CallEventHandler( "use_bulb_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_spray_4lvl", 0, "", 0 );

    AnimPlay( "anm_birdhouse_spray", "spray", func_end );
    ObjAnimate( "anm_birdhouse_bee", "alp", 0, 0, "", { 0, 0, 1,   3.0, 0, 1, 3.1, 0, 0 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lever_lvl4 ()

  local item = "inv_lever_lvl4";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_bridge" ) and
       cmn.IsEventDone( "clk_bridge_lever" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bridge" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bridge_use_lever_lvl4" ) and
           cmn.IsEventDone( "clk_bridge_lever" ) ) then

    cmn.CallEventHandler( "use_lever_lvl4_inv" );
    cmn.CallEventHandler( "use_lever_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_lever_lvl4" );
      cmn.CallEventHandler( "use_lever_lvl4_end" );

      common.CloseSubRoom();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_lever_4lvl", 0, "", 0 );

    AnimPlay( "anm_bridge_lever", "lever", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_gear_lvl4 ()

  local item = "inv_gear_lvl4";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_bridge" ) and
       cmn.IsEventDone( "clk_bridge_gear" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bridge" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bridge_use_gear_lvl4" )and
           cmn.IsEventDone( "clk_bridge_gear" ) ) then

    cmn.CallEventHandler( "use_gear_lvl4_inv" );
    cmn.CallEventHandler( "use_gear_lvl4_beg" );

    local func_end = function ()
      
      local func_end2 = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_gear_lvl4" );
        cmn.CallEventHandler( "use_gear_lvl4_end" );
      
      end;  
    
      AnimPlay( "anm_bridge_hook", "hook", func_end2 );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_gear_4lvl", 0, "", 0 );

    AnimPlay( "anm_bridge_gear", "gear", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hook_lvl4 ()

  local item = "inv_hook_lvl4";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_fountain_lvl4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fountain_lvl4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fountain_lvl4_use_hook_lvl4" ) ) then

    cmn.CallEventHandler( "use_hook_lvl4_inv" );
    cmn.CallEventHandler( "use_hook_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hook_lvl4" );
      cmn.CallEventHandler( "use_hook_lvl4_end" );
      ObjMultiSet( { 
        { "anm_fountain_lvl4_back", { frame = 0 } },
        { "obj_fountain_lvl4_water", { alp = 1 } },
      } );   
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_hook_4lvl", 0, "", 0 );
    ObjMultiSet( { 
      { "anm_fountain_lvl4_hook",  { alp = 1 } },
      { "obj_fountain_lvl4_water", { alp = 0 } },
    } );        
    --ObjAnimate( "anm_fountain_lvl4_hook", "alp",0,0, "", { 0, 0, 0,    0.1, 0, 1 } );
    --ObjAnimate( "obj_fountain_lvl4_water", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 0 } );
    AnimPlay( "anm_fountain_lvl4_hook", "hook", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stone_triangle ()

  local item = "inv_stone_triangle";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_fountain_lvl4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fountain_lvl4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fountain_lvl4_use_stone_triangle" ) ) then

    cmn.CallEventHandler( "use_stone_triangle_inv" );
    cmn.CallEventHandler( "use_stone_triangle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_stone_triangle" );
      cmn.CallEventHandler( "use_stone_triangle_end" );

      common.CloseSubRoom();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_triangle_amulet_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_fountain_lvl4_triangle", func_end, -0.22, 70 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_decor_part ()

  local item = "inv_decor_part";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_wicket" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wicket" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wicket_use_decor_part" ) ) then

    cmn.CallEventHandler( "use_decor_part_inv" );
    cmn.CallEventHandler( "use_decor_part_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_decor_part" );
      cmn.CallEventHandler( "use_decor_part_end" );
      
    end;
    
    local func_end_2 = function ()
      
      common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_compas", 0, "", 0 );

      if cmn.IsEventDone( "use_decor_part_2" ) then
        
        ObjMultiSet( { 
          { "spr_wicket_plate_big",  { alp = 0, visible = false } },
          { "anm_wicket_use_big_plate_open",  { alp = 1, visible = true } },
        } );
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_slide_stones4", 0, "", 0 );
        AnimPlay( "anm_wicket_use_big_plate_open", "use_big_plate_open", func_end );
        
      else 
        
        func_end();
        
      end;      
      
    end;

    cmn.Lock( true );

    AnimPlay( "anm_wicket_use_decor_part1", "use_decor_part1", func_end_2 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_decor_part_2 ()

  local item = "inv_decor_part_2";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_wicket" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wicket" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wicket_use_decor_part_2" ) ) then

    cmn.CallEventHandler( "use_decor_part_2_inv" );
    cmn.CallEventHandler( "use_decor_part_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_decor_part_2" );
      cmn.CallEventHandler( "use_decor_part_2_end" );

    end;
    
    local func_end_2 = function ()
      
      common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_clk_compas", 0, "", 0 );

      if cmn.IsEventDone( "use_decor_part" ) then
        
        ObjMultiSet( { 
          { "spr_wicket_plate_big",  { alp = 0, visible = false } },
          { "anm_wicket_use_big_plate_open",  { alp = 1, visible = true } },
        } );
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_slide_stones4", 0, "", 0 );
        AnimPlay( "anm_wicket_use_big_plate_open", "use_big_plate_open", func_end );
        
      else 
        
        func_end();
        
      end;  
  
    end;   
      
    cmn.Lock( true );

    AnimPlay( "anm_wicket_use_decor_part2", "use_decor_part2", func_end_2 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_gothic_cross ()

  local item = "inv_gothic_cross";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_wicket" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wicket" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wicket_use_gothic_cross" ) ) then

    cmn.CallEventHandler( "use_gothic_cross_inv" );
    cmn.CallEventHandler( "use_gothic_cross_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_gothic_cross" );
      cmn.CallEventHandler( "use_gothic_cross_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_amulet_in_gate_4lvl", 0, "", 0 );

    AnimPlay( "anm_wicket_use_cross", "use_cross", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_decor_part_3 ()

  local item = "inv_decor_part_3";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_wicket" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wicket" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wicket_use_decor_part_3" ) ) then

    cmn.CallEventHandler( "use_decor_part_3_inv" );
    cmn.CallEventHandler( "use_decor_part_3_beg" );

    local func_end = function ()

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_slide_stones4", 0, "", 0 );

      cmn.Lock( false );
      cmn.SetEventDone( "use_decor_part_3" );
      cmn.CallEventHandler( "use_decor_part_3_end" );

    end;
    
    cmn.Lock( true );

    ObjMultiSet( { 
      { "spr_wicket_plate_small",  { alp = 0, visible = false } },
      { "anm_wicket_use_decor_part3",  { alp = 1, visible = true } },
    } );
    AnimPlay( "anm_wicket_use_decor_part3", "use_decor_part3", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_duster_lvl4 ()

  local item = "inv_duster_lvl4";
  local item_wrong = "inv_hook_lvl4";

  if ( cmn.ApplyObj( item_wrong, "obj_park_lvl4_use_duster_lvl4" ) ) then

    common_impl.ShowBbt( 'bbt_park_lvl4_use_duster_lvl4_wrong' );
    return true;

  elseif ( cmn.ApplyObj( item, "obj_park_lvl4_use_duster_lvl4" ) ) then

    cmn.CallEventHandler( "use_duster_lvl4_inv" );
    cmn.CallEventHandler( "use_duster_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_duster_lvl4" );
      cmn.CallEventHandler( "use_duster_lvl4_end" );
      private.get_torch_lvl4();
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_cloth_4lvl", 0, "", 0 );

    ObjAnimate( "anm_park_lvl4_lantern", "alp", 0, 0, "", { 0, 0, 1,   0.4, 0, 0 } );
    ObjAnimate( "anm_park_lvl4_get_lantern", "alp", 0, 0, "", { 0, 0, 0,   0.4, 0, 1 } );  
    AnimPlay( "anm_park_lvl4_get_lantern", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_rake ()

  local item = "inv_rake";

  if ( cmn.ApplyObj( item, "gzz_park_lvl4_bush" ) and
       cmn.IsEventDone( "get_twig" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bush" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bush_use_rake" ) and
           cmn.IsEventDone( "get_twig" ) ) then

    cmn.CallEventHandler( "use_rake_inv" );
    cmn.CallEventHandler( "use_rake_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_rake" );
      cmn.CallEventHandler( "use_rake_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_rake", 0, "", 0 );

    AnimPlay( "anm_bush_leafs", "DoAnim_leafs", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_blunt_knife ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_blunt_knife" );
  cmn.CallEventHandler( "get_blunt_knife" );

end;
--------------------------------------------------------------------------------------------
function private.get_chain_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_chain_lvl4" );
  cmn.CallEventHandler( "get_chain_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_decor_part_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_decor_part_2" );
  cmn.CallEventHandler( "get_decor_part_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_scheme_piece_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scheme_piece_2" );
  cmn.CallEventHandler( "get_scheme_piece_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_hotel_symbol ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hotel_symbol" );
  cmn.CallEventHandler( "get_hotel_symbol" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_clock_amulet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_clock_amulet" );
  cmn.CallEventHandler( "get_clock_amulet" );

end;
--------------------------------------------------------------------------------------------
function private.get_gothic_cross ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_gothic_cross" );
  cmn.CallEventHandler( "get_gothic_cross" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_basket ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_basket" );
  cmn.CallEventHandler( "get_basket" );

end;
--------------------------------------------------------------------------------------------
function private.get_crowbar ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_crowbar" );
  cmn.CallEventHandler( "get_crowbar" );

end;
--------------------------------------------------------------------------------------------
function private.get_handle_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_handle_lvl4" );
  cmn.CallEventHandler( "get_handle_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_twig ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_twig" );
  cmn.CallEventHandler( "get_twig" );

end;
--------------------------------------------------------------------------------------------
function private.get_torch_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_torch_lvl4" );
  cmn.CallEventHandler( "get_torch_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_tool_bag ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tool_bag" );
  cmn.CallEventHandler( "get_tool_bag" );

  if ( cmn.IsGetCollect2( "get_collect2_item_27" ) ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_hook_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hook_lvl4" );
  cmn.CallEventHandler( "get_hook_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_27 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_27" ); 

  end;

  common_impl.PlayEffectHO( "spr_bush_collect2_item_27", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_27" );
  
  if ( cmn.IsEventDone( "get_tool_bag" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_gothic_cross ()
  
  cmn.CallEventHandler( "clk_gothic_cross_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_gothic_cross" );
    cmn.CallEventHandler( "clk_gothic_cross_end" ); 
    
    common.CloseSubRoom();
  
  end;
  
  cmn.Lock( true );
  --common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_old_door", 0, "", 0 );
  
  func_end()
  
end;
--------------------------------------------------------------------------------------------
function private.clk_bridge_lever ()
  
  cmn.CallEventHandler( "clk_bridge_lever_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_bridge_lever" );
    cmn.CallEventHandler( "clk_bridge_lever_end" ); 
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_break_bridge1_4lvl", 0, "", 0 );
  AnimPlay( "anm_bridge_old_lever", "old_lever", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_bridge_gear ()
  
  cmn.CallEventHandler( "clk_bridge_gear_beg" );
  
  local func_end2 = function ()
    
    local func_end = function ()
      
      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_bridge_gear" );
      cmn.CallEventHandler( "clk_bridge_gear_end" ); 
     
    end;   
    
    AnimPlay( "anm_bridge_old_gear", "old_gear", func_end );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_break_bridge_4lvl2", 0, "", 0 );
  AnimPlay( "anm_bridge_flap", "flap", func_end2 );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_bench_lattice ()
  
  cmn.CallEventHandler( "clk_bench_lattice_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_bench_lattice" );
    cmn.CallEventHandler( "clk_bench_lattice_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_grill_4lvl", 0, "", 0 );
  
  ObjSet( "spr_bench_lvl4_lattice", { pos_z = 1 } );  
  ObjAnimate( "spr_bench_lvl4_lattice", "pos_xy",0,1, func_end, { 0, 0, 0, 0,    0.5, 0, 60, 200 } );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
end;
--------------------------------------------------------------------------------------------
function private.see_park_lvl4_anim_park_1 ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_park_lvl4_anim_park_1" );
    cmn.CallEventHandler( "see_park_lvl4_anim_park_1" );

    common_impl.ShowBbt( 'bbt_park_lvl4_see_anim_park_1' );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl4_follow_bandits" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_zoom3_4lvl", 0, "", 0 );
  
  ObjAnimate( private.room_objname, "pos_xy", 0, 0, "", {
    0,   0,  0,    0,
    0.2, 1, 25, -143,
    2.0, 3, 24, -144,
    2.7, 3, 25, -143,
    3.0, 3,  0,    0,
  } );
  
  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "", {
    0,   0, 1,   1,
    0.2, 1, 1.4, 1.4,
    2.7,   3, 1.4, 1.4,
    3.0, 3, 1,   1,
  } );
  
  AnimPlay( "anm_park_lvl4_anim", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_park_lvl4_bridge ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_park_lvl4_bridge" );
    cmn.CallEventHandler( "see_park_lvl4_bridge" );

    common_impl.ShowBbt( 'bbt_park_lvl4_see_bridge' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );

  ObjMultiSet( { 
    { "anm_park_lvl4_bridge",       { alp = 0 } },
    { "anm_park_lvl4_bridge_after", { alp = 1 } },
  } );  
    
  AnimPlay( "anm_park_lvl4_bridge_after", "bridge", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_park_lvl4_gates ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_park_lvl4_gates" );
    cmn.CallEventHandler( "see_park_lvl4_gates" );

    common_impl.ShowBbt( 'bbt_park_lvl4_see_gates' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_gate_4lvl", 0, "", 0 );

  AnimPlay( "anm_park_lvl4_open_gate", "open_gate", func_end );  
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_park_lvl4 ()

  if not ( cmn.IsEventDone( "opn_park_lvl4" ) ) then

    cmn.SetEventDone( "opn_park_lvl4" );

  end;
  cmn.CallEventHandler( "opn_park_lvl4" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.UseSeeds ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_birdhouse_use_seeds' );
    AnimPlay( "anm_birdhouse_bird", "bird", "" );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_magpie_4lvl", 0, "", 0 );

  AnimPlay( "anm_birdhouse_bird", "bird_cleek", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UseRake ()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_park_lvl4_use_rake' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_foliage_4lvl", 0, "", 0 );

  ObjAnimate( "obj_bush_leaves", "scale_xy", 0, 0, func_end, { 0, 0, 1, 1,   0.2, 3, 1.005, 1.005,   0.4, 3, 1, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.UseHook ()
  
  common_impl.ShowBbt( 'bbt_fountain_lvl4_use_hook_lvl4' );
  
  local obj = "anm_fountain_lvl4_bascet_on_border";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_water_4lvl", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;

--------------------------------------------------------------------------------------------
function private.WicketUseDecorPart ( id )

  common_impl.ShowBbt( "bbt_wicket_use_decor_part"..id );
  
  local obj = "spr_wicket_plate_big";
  
  if ( id == "_3" ) then
    
    obj = "spr_wicket_plate_small";
    
  end;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_stone2", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;
--------------------------------------------------------------------------------------------
function private.UseBoxWrench ()

  common_impl.ShowBbt( 'bbt_bench_lvl4_use_box_wrench' );
  
  local obj = "spr_bench_lvl4_lattice";
  
  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_metal_door", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;

--------------------------------------------------------------------------------------------
function private.UseFeathers ()

  common_impl.ShowBbt( 'bbt_bench_lvl4_use_feathers_lvl4' );
  
  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_net_4lvl", 0, "", 0 );

  AnimPlay( "anm_bench_lvl4_feathers_hh", "hh", func_end );
  
end;


