-- name=rm_porch
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_porch";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_entrance_door", "room_hub" );
  ObjAttach( "zz_park_gates",    "room_hub" );
  ObjAttach( "zz_mailbox",       "room_hub" );
  ObjAttach( "zz_ivy",           "room_hub" );
  ObjAttach( "zz_signboard",     "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_entrance_door_cylinder",           { event_mdown = private.get_cylinder             }},
    { "spr_entrance_door_sharp_iron",         { event_mdown = private.get_sharp_iron           }},
    { "obj_entrance_door_use_crowbar",        { event_mdown = private.AnimUseCrowbar           }},
    { "obj_entrance_door_clk_door",           { event_mdown = private.clk_entrance_door        }},
    
    { "spr_park_gates_garden_glove",          { event_mdown = private.get_garden_glove         }},
    { "spr_park_gates_necklace",              { event_mdown = private.get_necklace             }},
    { "obj_park_gates_use_wrench_lvl4",       { event_mdown = private.UseWrench                }},
    { "obj_park_gates_use_gates_key",         { event_mdown = private.UseKey                   }},
    
    { "spr_mailbox_wrench_lvl4",              { event_mdown = private.get_wrench_lvl4          }},
    { "spr_mailbox_tweezers_lvl4",            { event_mdown = private.get_tweezers_lvl4        }},
    { "spr_mailbox_pulverizer",               { event_mdown = private.get_pulverizer           }},
    { "spr_mailbox_sharp_knife",              { event_mdown = private.get_sharp_knife          }},
    { "spr_mailbox_alarm_clock",              { event_mdown = private.get_alarm_clock          }},
    { "obj_mailbox_clk_mailbox_door3",        { event_mdown = private.clk_mailbox_door3        }},
    { "obj_mailbox_clk_diamond_lvl4_mailbox", { event_mdown = private.clk_diamond_lvl4_mailbox }},
    { "obj_mailbox_use_diamond_lvl4",         { event_mdown = private.AnimUseDiamondLvl4       }},
    { "obj_mailbox_use_can_opener_lvl4",      { event_mdown = private.AnimUseCanOpenerLvl4     }},
    { "obj_mailbox_use_clock_amulet",         { event_mdown = private.AnimUseClockAmulet       }},

    { "obj_ivy_hotel_sign",                   { event_mdown = private.get_hotel_sign           }},
    { "spr_ivy_gates_key",                    { event_mdown = private.get_gates_key            }},
    { "obj_ivy_decor_part",                   { event_mdown = private.get_decor_part           }},
    { "spr_ivy_seeds",                        { event_mdown = private.get_seeds                }},
    { "spr_ivy_paper_piece",                  { event_mdown = private.get_paper_piece          }},
    { "spr_ivy_lever_lvl4",                   { event_mdown = private.get_lever_lvl4           }},
    { "obj_ivy_use_garden_glove",             { event_mdown = private.AnimUseGardenGlove       }},
    { "obj_ivy_use_tweezers_lvl4",            { event_mdown = private.AnimUseTweezersLvl4      }},
    { "obj_ivy_use_sharp_knife",              { event_mdown = private.AnimUseSharpKnife        }},

    { "obj_porch_clk_anim_porch_1",           { event_mdown = private.see_anim_porch_1         }},
    { "obj_porch_clk_anim_porch_1_focus",     { event_mdown = private.see_anim_porch_1         }},
    
    { "spr_entrance_door_collect2_item_29",   { event_mdown = private.get_collect2_item_29      }},
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_porch = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gho_porch_storage",
      "gmg_porch_gates_lvl4",
      "gzz_porch_entrance_door",
      "gzz_porch_park_gates",
      "gzz_porch_mailbox",
      "gzz_porch_ivy",
      "gzz_porch_signboard",
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_entrance_door",
      "zz_park_gates", 
      "zz_mailbox",
      "zz_ivy",
      "zz_signboard",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_porch", update_game_mode_porch, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_porch = function ()

    local effects_table = 
    {
      "anm_porch_sky",
      "anm_porch_leaves",
      "anm_porch_light",
      "anm_porch_fireflies" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_porch", update_performance_mode_porch, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_porch () end;
  --------------------------------------------------------------------------------------------
  local opn_porch_map = function ()

    common_impl.VisitMapRoom( "porch" );

  end;
  cmn.AddSubscriber( "opn_porch", opn_porch_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_cylinder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cylinder" ] = {
    type = "get",
    get_obj = "spr_entrance_door_cylinder",
    room = private.room_objname,
    zz = "zz_entrance_door",
    zz_gate = "gzz_porch_entrance_door"
  };
  
  local get_cylinder_inv = function ()
  
    interface.InventoryItemAdd( "inv_cylinder", "spr_entrance_door_cylinder" );
    ObjSet( "inv_cylinder", { drag = false } );
    
    if not cmn.IsEventDone( "get_pulverizer" ) then
    
      cmn.SetInvPlusRGB( "cylinder", false );
      
    end;
  
  end;
  
  local get_cylinder_closezz = function ()
  
    ObjDelete( "gfx_entrance_door_cylinder" );
    ObjDelete( "spr_porch_zz_entr_door_ballon" ); 
    
  end;
  
  cmn.AddSubscriber( "get_cylinder", get_cylinder_inv );
  cmn.AddSubscriber( "get_cylinder", get_cylinder_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sharp_iron () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sharp_iron" ] = {
    type = "get",
    get_obj = "spr_entrance_door_sharp_iron",
    room = private.room_objname,
    zz = "zz_entrance_door",
    zz_gate = "gzz_porch_entrance_door"
  };
  
  local get_sharp_iron_inv = function ()
  
    interface.InventoryItemAdd( "inv_sharp_iron", "spr_entrance_door_sharp_iron" );
  
  end;
  
  local get_sharp_iron_closezz = function ()
  
    ObjDelete( "gfx_entrance_door_sharp_iron" );
    
  end;
  
  cmn.AddSubscriber( "get_sharp_iron", get_sharp_iron_inv );
  cmn.AddSubscriber( "get_sharp_iron", get_sharp_iron_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_garden_glove () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_garden_glove" ] = {
    type = "get",
    get_obj = "spr_park_gates_garden_glove",
    room = private.room_objname,
    zz = "zz_park_gates",
    zz_gate = "gzz_porch_park_gates"
  };
  
  local get_garden_glove_inv = function ()
  
    interface.InventoryItemAdd( "inv_garden_glove", "spr_park_gates_garden_glove" );
  
  end;
  
  local get_garden_glove_closezz = function ()
  
    ObjDelete( "gfx_park_gates_garden_glove" );
  
  end;
  
  cmn.AddSubscriber( "get_garden_glove", get_garden_glove_inv );
  cmn.AddSubscriber( "get_garden_glove", get_garden_glove_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_necklace () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_necklace" ] = {
    type = "get",
    get_obj = "spr_park_gates_necklace",
    room = private.room_objname,
    zz = "zz_park_gates",
    zz_gate = "gzz_porch_park_gates"
  };
  
  local get_necklace_inv = function ()
  
    interface.InventoryItemAdd( "inv_necklace", "spr_park_gates_necklace" );
    ObjSet( "inv_necklace", { drag = false } );

  end;
  
  local get_necklace_closezz = function ()
  
    ObjDelete( "gfx_park_gates_necklace" );
  
  end;
  
  cmn.AddSubscriber( "get_necklace", get_necklace_inv );
  cmn.AddSubscriber( "get_necklace", get_necklace_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wrench_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wrench_lvl4" ] = {
    type = "get",
    get_obj = "spr_mailbox_wrench_lvl4",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  
  local get_wrench_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_wrench_lvl4", "spr_mailbox_wrench_lvl4" );
  
  end;
  
  local get_wrench_lvl4_closezz = function ()
  
    ObjDelete( "gfx_mailbox_wrench_lvl4" );
    ObjMultiSet({ 
      { "obj_mailbox_use_blunt_knife",   { input = true, active = true, visible = true }},
    });
  
  end;
  
  cmn.AddSubscriber( "get_wrench_lvl4", get_wrench_lvl4_inv );
  cmn.AddSubscriber( "get_wrench_lvl4", get_wrench_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tweezers_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tweezers_lvl4" ] = {
    type = "get",
    get_obj = "spr_mailbox_tweezers_lvl4",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  
  local get_tweezers_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_tweezers_lvl4", "spr_mailbox_tweezers_lvl4" );
  
  end;
  
  local get_tweezers_lvl4_closezz = function ()
  
    ObjDelete( "gfx_mailbox_tweezers_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_tweezers_lvl4", get_tweezers_lvl4_inv );
  cmn.AddSubscriber( "get_tweezers_lvl4", get_tweezers_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pulverizer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pulverizer" ] = {
    type = "get",
    get_obj = "spr_mailbox_pulverizer",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  
  local get_pulverizer_inv = function ()
  
    interface.InventoryItemAdd( "inv_pulverizer", "spr_mailbox_pulverizer" );
    
    cmn.SetInvPlusRGB( "cylinder", true );
  
  end;
  
  local get_pulverizer_closezz = function ()
  
    ObjDelete( "gfx_mailbox_pulverizer" );
  
  end;
  
  cmn.AddSubscriber( "get_pulverizer", get_pulverizer_inv );
  cmn.AddSubscriber( "get_pulverizer", get_pulverizer_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sharp_knife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sharp_knife" ] = {
    type = "get",
    get_obj = "spr_mailbox_sharp_knife",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  
  local get_sharp_knife_inv = function ()
  
    interface.InventoryItemAdd( "inv_sharp_knife", "spr_mailbox_sharp_knife" );
  
  end;
  
  local get_sharp_knife_closezz = function ()
  
    ObjDelete( "gfx_mailbox_sharp_knife" );
  
  end;
  
  cmn.AddSubscriber( "get_sharp_knife", get_sharp_knife_inv );
  cmn.AddSubscriber( "get_sharp_knife", get_sharp_knife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_alarm_clock () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_alarm_clock" ] = {
    type = "get",
    get_obj = "spr_mailbox_alarm_clock",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  
  local get_alarm_clock_inv = function ()
  
    interface.InventoryItemAdd( "inv_alarm_clock", "spr_mailbox_alarm_clock" );
    ObjSet( "inv_alarm_clock", { drag = false } );

  end;
  
  local get_alarm_clock_closezz = function ()
  
    ObjDelete( "gfx_mailbox_alarm_clock" );
    ObjDelete( "gzz_porch_mailbox"       );
 
  end;
  
  cmn.AddSubscriber( "get_alarm_clock", get_alarm_clock_inv );
  cmn.AddSubscriber( "get_alarm_clock", get_alarm_clock_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hotel_sign () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hotel_sign" ] = {
    type = "get",
    get_obj = "obj_ivy_hotel_sign",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  
  local get_hotel_sign_inv = function ()
  
    interface.InventoryItemAdd( "inv_hotel_sign", "obj_ivy_hotel_sign" );
  
  end;
  
  local get_hotel_sign_closezz = function ()
  
    ObjDelete( "gfx_ivy_hotel_sign" );
  
  end;
  
  cmn.AddSubscriber( "get_hotel_sign", get_hotel_sign_inv );
  cmn.AddSubscriber( "get_hotel_sign", get_hotel_sign_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gates_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gates_key" ] = {
    type = "get",
    get_obj = "spr_ivy_gates_key",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  
  local get_gates_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_gates_key", "spr_ivy_gates_key" );
  
  end;
  
  local get_gates_key_closezz = function ()
  
    ObjDelete( "gfx_ivy_gates_key" );
  
  end;
  
  cmn.AddSubscriber( "get_gates_key", get_gates_key_inv );
  cmn.AddSubscriber( "get_gates_key", get_gates_key_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_decor_part () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_decor_part" ] = {
    type = "get",
    get_obj = "obj_ivy_decor_part",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  
  local get_decor_part_inv = function ()
  
    interface.InventoryItemAdd( "inv_decor_part", "obj_ivy_decor_part" );
  
  end;
  
  local get_decor_part_closezz = function ()
  
    ObjDelete( "gfx_ivy_decor_part" );
  
  end;
  
  cmn.AddSubscriber( "get_decor_part", get_decor_part_inv );
  cmn.AddSubscriber( "get_decor_part", get_decor_part_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_seeds () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_seeds" ] = {
    type = "get",
    get_obj = "spr_ivy_seeds",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  
  local get_seeds_inv = function ()
  
    interface.InventoryItemAdd( "inv_seeds", "spr_ivy_seeds" );
  
  end;
  
  local get_seeds_closezz = function ()
  
    ObjDelete( "gfx_ivy_seeds" );
  
  end;
  
  cmn.AddSubscriber( "get_seeds", get_seeds_inv );
  cmn.AddSubscriber( "get_seeds", get_seeds_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_paper_piece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_paper_piece" ] = {
    type = "get",
    get_obj = "spr_ivy_paper_piece",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  
  local get_paper_piece_inv = function ()
  
    interface.InventoryItemAdd( "inv_paper_piece", "spr_ivy_paper_piece" );
    ObjSet( "inv_paper_piece", { drag = false } );
    
    for i = 1, 6 do
      
      if ( not cmn.IsEventDone( "get_scheme_piece_"..i ) ) then
        
        cmn.SetInvPlusRGB( "paper_piece", false );
        
      end;
      
    end;

  end;
  
  local get_paper_piece_closezz = function ()
  
    ObjDelete( "gfx_ivy_paper_piece" );
  
  end;
  
  cmn.AddSubscriber( "get_paper_piece", get_paper_piece_inv );
  cmn.AddSubscriber( "get_paper_piece", get_paper_piece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lever_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lever_lvl4" ] = {
    type = "get",
    get_obj = "spr_ivy_lever_lvl4",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  
  local get_lever_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_lever_lvl4", "spr_ivy_lever_lvl4" );
  
  end;
  
  local get_lever_lvl4_closezz = function ()
  
    ObjDelete( "gfx_ivy_lever_lvl4" );
    ObjDelete( "gzz_porch_ivy"      );
  
  end;
  
  cmn.AddSubscriber( "get_lever_lvl4", get_lever_lvl4_inv );
  cmn.AddSubscriber( "get_lever_lvl4", get_lever_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_burner_2 () end;
  --------------------------------------------------------------------------------------------
  local get_burner_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_burner_2", "spr_entrance_door_burner" );
  
  end;
  
  local get_burner_2_closezz = function ()
  
  end;
  
  cmn.AddSubscriber( "get_burner_2", get_burner_2_inv );
  cmn.AddSubscriber( "get_burner_2", get_burner_2_closezz, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_29 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_29 = function ()
  
    ObjDelete( "obj_entrance_door_collect2_item_29" ); 
  
    if ( cmn.IsEventDone( "clk_entrance_door" ) ) then
      
      ObjDelete( "gzz_porch_entrance_door" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_29", get_collect2_item_29, private.room_objname );      
  --------------------------------------------------------------------------------------------
  -- function use_sharp_iron () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sharp_iron" ] = {
    type = "use",
    inv_obj = "inv_sharp_iron",
    use_place = "obj_park_gates_use_sharp_iron",
    room = private.room_objname,
    zz = "zz_park_gates",
    zz_gate = "gzz_porch_park_gates"
  };
  local use_sharp_iron_inv = function ()
  
    interface.InventoryItemRemove( "inv_sharp_iron" );
  
  end;
  local use_sharp_iron_beg = function ()
  
    ObjDelete( "obj_park_gates_use_sharp_iron" );
  
  end;
  local use_sharp_iron_end = function ()
    
    ObjDelete( "anm_park_necklace" );  
    ObjMultiSet({ 
      { "spr_park_gates_necklace",      {  input = true }},
      { "anm_park_necklace1",           {    alp = 1    }},
      { "spr_park_gates_gates_lattice", {    alp = 1    }},
      { "gfx_park_gates_necklace",      { active = true }},
    });  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sharp_iron", use_sharp_iron_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharp_iron", use_sharp_iron_inv );
  cmn.AddSubscriber( "use_sharp_iron", use_sharp_iron_end, private.room_objname );
  cmn.AddSubscriber( "use_sharp_iron_inv", use_sharp_iron_inv, private.room_objname );
  cmn.AddSubscriber( "use_sharp_iron_beg", use_sharp_iron_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharp_iron_end", use_sharp_iron_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crowbar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crowbar" ] = {
    type = "use",
    inv_obj = "inv_crowbar",
    use_place = "obj_entrance_door_use_crowbar",
    room = private.room_objname,
    zz = "zz_entrance_door",
    zz_gate = "gzz_porch_entrance_door"
  };
  local use_crowbar_inv = function ()
  
    interface.InventoryItemRemove( "inv_crowbar" );
  
  end;
  local use_crowbar_beg = function ()
  
    ObjDelete( "obj_entrance_door_use_crowbar" );
  
  end;
  local use_crowbar_end = function ()
    
    ObjDelete( "anm_entrance_dreamcatcher_crowbar" );  
    ObjDelete( "anm_entrance_dreamcatcher_static" ); 
    ObjDelete( "spr_porch_entr_door_dreamcatcher" ); 
    ObjMultiSet({ 
      { "obj_entrance_door_clk_door", { input = true }},
      { "anm_entrance_door_open",     {   alp = 1    }},
    }); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crowbar", use_crowbar_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar", use_crowbar_inv );
  cmn.AddSubscriber( "use_crowbar", use_crowbar_end, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_inv", use_crowbar_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_beg", use_crowbar_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_end", use_crowbar_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrench_lvl4" ] = {
    type = "use",
    inv_obj = "inv_wrench_lvl4",
    use_place = "obj_park_gates_use_wrench_lvl4",
    room = private.room_objname,
    zz = "zz_park_gates",
    zz_gate = "gzz_porch_park_gates"
  };
  local use_wrench_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_wrench_lvl4" );
  
  end;
  local use_wrench_lvl4_beg = function ()
  
    ObjDelete( "obj_park_gates_use_wrench_lvl4" );
  
  end;
  local use_wrench_lvl4_end = function ()
    
    ObjDelete( "spr_park_gates_top_gbox" );
    ObjDelete( "vid_park_gates_key" );
    ObjDelete( "spr_porch_zz_park_gates_top_box" );
    ObjMultiSet({ 
      { "spr_park_gates_garden_glove", {  input = true }},
      { "gfx_park_gates_garden_glove", { active = true }},
    });  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrench_lvl4", use_wrench_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_lvl4", use_wrench_lvl4_inv );
  cmn.AddSubscriber( "use_wrench_lvl4", use_wrench_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_wrench_lvl4_inv", use_wrench_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrench_lvl4_beg", use_wrench_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_lvl4_end", use_wrench_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gates_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gates_key" ] = {
    type = "use",
    inv_obj = "inv_gates_key",
    use_place = "obj_park_gates_use_gates_key",
    room = private.room_objname,
    zz = "zz_park_gates",
    zz_gate = "gzz_porch_park_gates"
  };
  local use_gates_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_gates_key" );
  
  end;
  local use_gates_key_beg = function ()
  
    ObjDelete( "obj_park_gates_use_gates_key" );
  
  end;
  local use_gates_key_end = function ()
  
    ObjDelete( "gzz_porch_park_gates" );
    ObjDelete( "anm_park_key" );
    ObjSet( "gmg_porch_gates_lvl4", { input = true, visible = true, active = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gates_key", use_gates_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_gates_key", use_gates_key_inv );
  cmn.AddSubscriber( "use_gates_key", use_gates_key_end, private.room_objname );
  cmn.AddSubscriber( "use_gates_key_inv", use_gates_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_gates_key_beg", use_gates_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_gates_key_end", use_gates_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_diamond_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_diamond_lvl4" ] = {
    type = "use",
    inv_obj = "inv_diamond_lvl4",
    use_place = "obj_mailbox_use_diamond_lvl4",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  local use_diamond_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_diamond_lvl4" );
  
  end;
  local use_diamond_lvl4_beg = function ()
  
    ObjDelete( "obj_mailbox_use_diamond_lvl4" );
  
  end;
  local use_diamond_lvl4_end = function ()
  
    ObjDelete( "anm_mailbox_diamond" );
    ObjMultiSet({ 
      { "anm_mailbox_door_after_diamond",       {   alp = 1                                   }},
      { "obj_mailbox_clk_diamond_lvl4_mailbox", { input = true, active = true, visible = true }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_diamond_lvl4", use_diamond_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_diamond_lvl4", use_diamond_lvl4_inv );
  cmn.AddSubscriber( "use_diamond_lvl4", use_diamond_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_diamond_lvl4_inv", use_diamond_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_diamond_lvl4_beg", use_diamond_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_diamond_lvl4_end", use_diamond_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_can_opener_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_can_opener_lvl4" ] = {
    type = "use",
    inv_obj = "inv_can_opener_lvl4",
    use_place = "obj_mailbox_use_can_opener_lvl4",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  local use_can_opener_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_can_opener_lvl4" );
  
  end;
  local use_can_opener_lvl4_beg = function ()
  
    ObjDelete( "obj_mailbox_use_can_opener_lvl4" );
  
  end;
  local use_can_opener_lvl4_end = function ()

    ObjDelete( "anm_mailbox_use_opener" );
    ObjMultiSet({ 
      { "spr_mailbox_pulverizer", {  input = true }},
      { "gfx_mailbox_pulverizer", { active = true }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_can_opener_lvl4", use_can_opener_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_can_opener_lvl4", use_can_opener_lvl4_inv );
  cmn.AddSubscriber( "use_can_opener_lvl4", use_can_opener_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_can_opener_lvl4_inv", use_can_opener_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_can_opener_lvl4_beg", use_can_opener_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_can_opener_lvl4_end", use_can_opener_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_burner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_burner" ] = {
    type = "use",
    inv_obj = "inv_burner",
    use_place = "obj_entrance_door_use_burner",
    room = private.room_objname,
    zz = "zz_entrance_door",
    zz_gate = "gzz_porch_entrance_door"
  };
  local use_burner_inv = function ()
  
    interface.InventoryItemRemove( "inv_burner" );
  
  end;
  local use_burner_beg = function ()
  
    ObjDelete( "obj_entrance_door_use_burner" );
  
  end;
  local use_burner_end = function ()
  
    ObjDelete( "vid_entrance_door_use_nonburning_burner" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_burner", use_burner_beg, private.room_objname );
  cmn.AddSubscriber( "use_burner", use_burner_inv );
  cmn.AddSubscriber( "use_burner", use_burner_end, private.room_objname );
  cmn.AddSubscriber( "use_burner_inv", use_burner_inv, private.room_objname );
  cmn.AddSubscriber( "use_burner_beg", use_burner_beg, private.room_objname );
  cmn.AddSubscriber( "use_burner_end", use_burner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_burner_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_burner_2" ] = {
    type = "use",
    inv_obj = "inv_burner_2",
    use_place = "obj_mailbox_use_burner_2",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  local use_burner_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_burner_2" );
  
  end;
  local use_burner_2_beg = function ()
  
    ObjDelete( "obj_mailbox_use_burner_2" );
  
  end;
  local use_burner_2_end = function ()
  
    ObjSet( "obj_mailbox_clk_mailbox_door3", { input = true, visible = true, active = true } );
    ObjDelete( "vid_mailbox_branch" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_burner_2", use_burner_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_burner_2", use_burner_2_inv );
  cmn.AddSubscriber( "use_burner_2", use_burner_2_end, private.room_objname );
  cmn.AddSubscriber( "use_burner_2_inv", use_burner_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_burner_2_beg", use_burner_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_burner_2_end", use_burner_2_end, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function use_blunt_knife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_blunt_knife" ] = {
    type = "use",
    inv_obj = "inv_blunt_knife",
    use_place = "obj_mailbox_use_blunt_knife",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  local use_blunt_knife_inv = function ()
  
    interface.InventoryItemRemove( "inv_blunt_knife" );
  
  end;
  local use_blunt_knife_beg = function ()
  
    ObjDelete( "obj_mailbox_use_blunt_knife" );
  
  end;
  local use_blunt_knife_end = function ()
  
    ObjDelete( "anm_mailbox_knife" );
    ObjMultiSet({ 
      { "spr_mailbox_sharp_knife", { alp = 1, input = true }},
      { "gfx_mailbox_sharp_knife", {         active = true }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_blunt_knife", use_blunt_knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_blunt_knife", use_blunt_knife_inv );
  cmn.AddSubscriber( "use_blunt_knife", use_blunt_knife_end, private.room_objname );
  cmn.AddSubscriber( "use_blunt_knife_inv", use_blunt_knife_inv, private.room_objname );
  cmn.AddSubscriber( "use_blunt_knife_beg", use_blunt_knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_blunt_knife_end", use_blunt_knife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clock_amulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clock_amulet" ] = {
    type = "use",
    inv_obj = "inv_clock_amulet",
    use_place = "obj_mailbox_use_clock_amulet",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  local use_clock_amulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_clock_amulet" );
  
  end;
  local use_clock_amulet_beg = function ()
  
    ObjDelete( "obj_mailbox_use_clock_amulet" );
  
  end;
  local use_clock_amulet_end = function ()
 
    ObjDelete( "spr_mailbox_1door_cls" );
    ObjMultiSet({ 
      { "spr_mailbox_alarm_clock",       {  input = true }},
      { "gfx_mailbox_alarm_clock",       { active = true }},
      { "spr_mailbox_1door_opn",         {    alp = 1    }},
      { "spr_porch_zz_mailbox_opn_1box", {    alp = 1    }},
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clock_amulet", use_clock_amulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_clock_amulet", use_clock_amulet_inv );
  cmn.AddSubscriber( "use_clock_amulet", use_clock_amulet_end, private.room_objname );
  cmn.AddSubscriber( "use_clock_amulet_inv", use_clock_amulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_clock_amulet_beg", use_clock_amulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_clock_amulet_end", use_clock_amulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_garden_glove () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_garden_glove" ] = {
    type = "use",
    inv_obj = "inv_garden_glove",
    use_place = "obj_ivy_use_garden_glove",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  local use_garden_glove_inv = function ()
  
    interface.InventoryItemRemove( "inv_garden_glove" );

  end;
  local use_garden_glove_beg = function ()
  
    ObjDelete( "obj_ivy_use_garden_glove" );
  
  end;
  local use_garden_glove_end = function ()
  
    ObjMultiSet({
      { "spr_ivy_gates_key",          { input = true                                }},
      { "spr_porch_zz_ivy_open_safe", {   alp = 1                                   }},
      { "gfx_ivy_gates_key",          {               active = true                 }},
      { "obj_ivy_use_sharp_knife",    { input = true, active = true, visible = true }},
      { "obj_ivy_use_torch_lvl4",     { input = true, active = true, visible = true }},
      
    });
    ObjDelete( "spr_ivy_lantern_plate" );
    ObjDelete( "spr_porch_zz_ivy_ivy_lians" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_garden_glove", use_garden_glove_beg, private.room_objname );
  cmn.AddSubscriber( "use_garden_glove", use_garden_glove_inv );
  cmn.AddSubscriber( "use_garden_glove", use_garden_glove_end, private.room_objname );
  cmn.AddSubscriber( "use_garden_glove_inv", use_garden_glove_inv, private.room_objname );
  cmn.AddSubscriber( "use_garden_glove_beg", use_garden_glove_beg, private.room_objname );
  cmn.AddSubscriber( "use_garden_glove_end", use_garden_glove_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_torch_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_torch_lvl4" ] = {
    type = "use",
    inv_obj = "inv_torch_lvl4",
    use_place = "obj_ivy_use_torch_lvl4",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  local use_torch_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_torch_lvl4" );
  
  end;
  local use_torch_lvl4_beg = function ()
  
    ObjDelete( "obj_ivy_use_torch_lvl4" );
  
  end;
  local use_torch_lvl4_end = function ()
    
    ObjDelete( "spr_porch_zz_ivy_open_safe" );
    ObjMultiSet({ 
      { "spr_ivy_lever_lvl4",                      {  input = true }},
      { "gfx_ivy_lever_lvl4",                      { active = true }},
      { "anm_ivy_lantern_light",                   {    alp = 1    }},
      { "spr_porch_zz_ivy_open_safe_with_lantern", {    alp = 1    }},
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_torch_lvl4", use_torch_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch_lvl4", use_torch_lvl4_inv );
  cmn.AddSubscriber( "use_torch_lvl4", use_torch_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_torch_lvl4_inv", use_torch_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_torch_lvl4_beg", use_torch_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch_lvl4_end", use_torch_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers_lvl4" ] = {
    type = "use",
    inv_obj = "inv_tweezers_lvl4",
    use_place = "obj_ivy_use_tweezers_lvl4",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  local use_tweezers_lvl4_inv = function ()
  
    interface.InventoryItemRemove( "inv_tweezers_lvl4" );
  
  end;
  local use_tweezers_lvl4_beg = function ()
  
    ObjDelete( "obj_ivy_use_tweezers_lvl4" );
  
  end;
  local use_tweezers_lvl4_end = function ()
        
    ObjMultiSet({ 
      { "obj_ivy_hotel_sign", { alp = 1, input = true }},
      { "gfx_ivy_hotel_sign", {         active = true }},
      { "obj_ivy_decor_part", { alp = 1, input = true }},
      { "gfx_ivy_decor_part", {         active = true }},
    });
    ObjDelete( "anm_ivy_tweezers_decor_part" );
    ObjDelete( "anm_ivy_tweezers_amulet"     );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers_lvl4", use_tweezers_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_lvl4", use_tweezers_lvl4_inv );
  cmn.AddSubscriber( "use_tweezers_lvl4", use_tweezers_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_lvl4_inv", use_tweezers_lvl4_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_lvl4_beg", use_tweezers_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_lvl4_end", use_tweezers_lvl4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sharp_knife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sharp_knife" ] = {
    type = "use",
    inv_obj = "inv_sharp_knife",
    use_place = "obj_ivy_use_sharp_knife",
    room = private.room_objname,
    zz = "zz_ivy",
    zz_gate = "gzz_porch_ivy"
  };
  local use_sharp_knife_inv = function ()
  
    interface.InventoryItemRemove( "inv_sharp_knife" );
  
  end;
  local use_sharp_knife_beg = function ()
  
    ObjDelete( "obj_ivy_use_sharp_knife" );
  
  end;
  local use_sharp_knife_end = function ()
  
    ObjMultiSet({ 
      { "spr_ivy_seeds",       { alp = 1, input = true }},
      { "gfx_ivy_seeds",       {         active = true }},
      { "spr_ivy_paper_piece", { alp = 1, input = true }},
      { "gfx_ivy_paper_piece", {         active = true }},
      { "spr_ivy_cut_open",    { alp = 1               }},
    });
    ObjDelete( "anm_ivy_knife" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sharp_knife", use_sharp_knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharp_knife", use_sharp_knife_inv );
  cmn.AddSubscriber( "use_sharp_knife", use_sharp_knife_end, private.room_objname );
  cmn.AddSubscriber( "use_sharp_knife_inv", use_sharp_knife_inv, private.room_objname );
  cmn.AddSubscriber( "use_sharp_knife_beg", use_sharp_knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharp_knife_end", use_sharp_knife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hotel_sign () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hotel_sign" ] = {
    type = "use",
    inv_obj = "inv_hotel_sign",
    use_place = "obj_signboard_use_hotel_sign",
    room = private.room_objname,
    zz = "zz_signboard",
    zz_gate = "gzz_porch_signboard"
  };
  local use_hotel_sign_inv = function ()
  
    interface.InventoryItemRemove( "inv_hotel_sign" );
  
  end;
  local use_hotel_sign_beg = function ()
  
    ObjDelete( "obj_porch_use_hotel_sign" );
  
  end;
  local use_hotel_sign_end = function ()
  
    ObjDelete( "gzz_porch_signboard" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hotel_sign", use_hotel_sign_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotel_sign", use_hotel_sign_inv );
  cmn.AddSubscriber( "use_hotel_sign", use_hotel_sign_end, private.room_objname );
  cmn.AddSubscriber( "use_hotel_sign_inv", use_hotel_sign_inv, private.room_objname );
  cmn.AddSubscriber( "use_hotel_sign_beg", use_hotel_sign_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotel_sign_end", use_hotel_sign_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_diamond_lvl4_mailbox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_diamond_lvl4_mailbox" ] = {
    type = "click",
    use_place = "obj_mailbox_clk_diamond_lvl4_mailbox",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  
  local clk_diamond_lvl4_mailbox_beg = function ()

    ObjDelete( "obj_mailbox_clk_diamond_lvl4_mailbox" );
  
  end;
  local clk_diamond_lvl4_mailbox_end = function ()
    
    ObjMultiSet({ 
      { "spr_mailbox_tweezers_lvl4",       { input = true                                }},
      { "gfx_mailbox_tweezers_lvl4",       {               active = true                 }},
      { "spr_mailbox_big_door_opn",        {   alp = 1                                   }},
      { "spr_porch_zz_mailbox_opn_door",   {   alp = 1                                   }},
      { "obj_mailbox_use_burner_2",        { input = true, active = true, visible = true }},
      { "obj_mailbox_use_clock_amulet",    { input = true, active = true, visible = true }},
      { "obj_mailbox_use_can_opener_lvl4", { input = true, active = true, visible = true }},
    });
    ObjDelete( "anm_mailbox_door_after_diamond" );
    ObjDelete( "spr_porch_zz_mailbox_cls_door" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_diamond_lvl4_mailbox",     clk_diamond_lvl4_mailbox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_diamond_lvl4_mailbox",     clk_diamond_lvl4_mailbox_end, private.room_objname );
  cmn.AddSubscriber( "clk_diamond_lvl4_mailbox_beg", clk_diamond_lvl4_mailbox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_diamond_lvl4_mailbox_end", clk_diamond_lvl4_mailbox_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_mailbox_door3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_mailbox_door3" ] = {
    type = "click",
    use_place = "obj_mailbox_clk_mailbox_door3",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_porch_mailbox"
  };
  
  local clk_mailbox_door3_beg = function ()

    ObjDelete( "obj_mailbox_clk_mailbox_door3" );
  
  end;
  local clk_mailbox_door3_end = function ()
    
    ObjMultiSet({ 
      { "spr_mailbox_wrench_lvl4",       { input = true                }},
      { "spr_mailbox_wrench_lvl4",       {               active = true }},
      { "spr_mailbox_3door_opn",         {   alp = 1                   }},
      { "spr_porch_zz_mailbox_opn_3box", {   alp = 1                   }},
    });
    ObjDelete( "spr_mailbox_3door_cls" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_mailbox_door3",     clk_mailbox_door3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_mailbox_door3",     clk_mailbox_door3_end, private.room_objname );
  cmn.AddSubscriber( "clk_mailbox_door3_beg", clk_mailbox_door3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_mailbox_door3_end", clk_mailbox_door3_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_entrance_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_entrance_door" ] = {
    type = "click",
    use_place = "obj_entrance_door_clk_door",
    room = private.room_objname,
    zz = "zz_entrance_door",
    zz_gate = "gzz_porch_entrance_door"
  };
  
  local clk_entrance_door_beg = function ()

    ObjDelete( "obj_entrance_door_clk_door" );
  
  end;
  local clk_entrance_door_end = function ()
  
    ObjMultiSet({ 
      { "grm_porch_hall_lvl4",             { input = true, visible = true, active = true }},
      { "spr_porch_zz_entr_door_opn_door", {   alp = 1                                   }},
    }); 
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_porch_hall_lvl4_focus");
    end;
    
    if ( cmn.IsGetCollect2( "get_collect2_item_29" ) ) then
      
      ObjDelete( "gzz_porch_entrance_door" );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_entrance_door",     clk_entrance_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_entrance_door",     clk_entrance_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_entrance_door_beg", clk_entrance_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_entrance_door_end", clk_entrance_door_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function see_intro_lvl4 () end;
  --------------------------------------------------------------------------------------------
  local see_intro_lvl4 = function ()
  
  end;
  cmn.AddSubscriber( "see_intro_lvl4", see_intro_lvl4, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function see_porch_death () end;
  --------------------------------------------------------------------------------------------
  local see_porch_death = function ()
    
  end;
  cmn.AddSubscriber( "see_porch_death", see_porch_death, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function see_porch_anim_porch_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_porch_anim_porch_1" ] = {
    type = "click",
    use_place = "obj_porch_clk_anim_porch_1_focus",
    room = private.room_objname
  };

  local see_porch_anim_porch_1 = function ()

    ObjDelete( "obj_porch_clk_anim_porch_1" );
    ObjDelete( "anm_porch_anim" );
    ObjMultiSet({ 
      { "gzz_porch_park_gates", { input = true, visible = true, active = true }},
      { "anm_porch_open_gates", { alp = 1                                     }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_porch_anim_porch_1", see_porch_anim_porch_1, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_porch_anim_porch_open () end;
  --------------------------------------------------------------------------------------------
  local see_porch_anim_porch_open = function ()

    ObjMultiSet({ 
      { "gho_porch_storage", { input = true, visible = true, active = true } },
      { "anm_porch_hoopen",  { frame = 300                                 } },
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_porch_anim_porch_open", see_porch_anim_porch_open, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function see_porch_anim_porch_open_2 () end;
  --------------------------------------------------------------------------------------------
  local see_porch_anim_porch_open_2 = function ()

    ObjMultiSet({ 
      { "anm_porch_open_gates",  { frame = 300 } },
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_porch_anim_porch_open_2", see_porch_anim_porch_open_2, private.room_objname );   
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  
  --*******************************************************************************************************************
  --*** function zz_signboard () end ****
  --*******************************************************************************************************************
    subroom.Define( "zz_signboard" );  
    ------------------------------------------------- 
    function zz_signboard.Close ()
      
      if cmn.IsEventDone( "use_hotel_sign" ) and not cmn.IsEventDone( "see_porch_anim_porch_open" ) then
        
       private.see_anim_porch_open();
        
      end;
      
    end; 
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_porch();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_porch_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();

  if ( not cmn.IsEventDone( "see_intro_lvl4" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( private.room_objname, { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_porch_intro_lvl4", private.room_objname );
    ObjSet( "tmr_porch_intro_lvl4",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntrolvl4(); end
    } );

  end; 

  if cmn.IsEventDone( "win_attack" ) and not cmn.IsEventDone( "see_porch_death" ) then
    private.see_porch_death ();
  end;
  if cmn.IsEventDone( "use_hotel_sign" ) and not cmn.IsEventDone( "see_porch_anim_porch_open" ) then
   private.see_anim_porch_open();
  end;
  if cmn.IsEventDone( "win_gates_lvl4" ) and not cmn.IsEventDone( "see_porch_anim_porch_open_2" ) then
    private.see_anim_porch_open_2();
  end; 
  
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "levelext/env/aud_porch_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_sharp_iron ()

  local item = "inv_sharp_iron";

  if ( cmn.ApplyObj( item, "gzz_porch_park_gates" ) and cmn.IsEventDone( "see_porch_anim_porch_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_park_gates" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_park_gates_use_sharp_iron" ) and cmn.IsEventDone( "see_porch_anim_porch_1" ) ) then

    cmn.CallEventHandler( "use_sharp_iron_inv" );
    cmn.CallEventHandler( "use_sharp_iron_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_sharp_iron" );
      cmn.CallEventHandler( "use_sharp_iron_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_iron_piece", 0, "", 0 );

    AnimPlay( "anm_park_necklace", "necklace", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_crowbar ()

  local item = "inv_crowbar";

  if ( cmn.ApplyObj( item, "gzz_porch_entrance_door" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_entrance_door" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_entrance_door_use_crowbar" ) ) then

    cmn.CallEventHandler( "use_crowbar_inv" );
    cmn.CallEventHandler( "use_crowbar_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_crowbar" );
      cmn.CallEventHandler( "use_crowbar_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_puller2_4lvl", 0, "", 0 );

    ObjMultiSet({ 
      { "anm_entrance_dreamcatcher_static",      { alp = 0 }},
      { "anm_entrance_dreamcatcher_crowbar",     { alp = 1 }},
    }); 
    AnimPlay( "anm_entrance_dreamcatcher_crowbar", "dreamcatcher_crowbar", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wrench_lvl4 ()

  local item = "inv_wrench_lvl4";

  if ( cmn.ApplyObj( item, "gzz_porch_park_gates" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_park_gates" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_park_gates_use_wrench_lvl4" ) ) then

    cmn.CallEventHandler( "use_wrench_lvl4_inv" );
    cmn.CallEventHandler( "use_wrench_lvl4_beg" );

    local func_end = function ()
      
      local func_end2 = function ()
      
        cmn.Lock( false );

        cmn.SetEventDone( "use_wrench_lvl4" );
        cmn.CallEventHandler( "use_wrench_lvl4_end" );
        
      end;       
      
      ObjAnimate( "spr_park_gates_top_gbox", "pos_xy", 0, 1, func_end2, { 0, 0, 0, 0,   0.5, 3, -200, -15 } );
    
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_hexagon_key", 0, "", 0 );

    VidPlay( "vid_park_gates_key", func_end );  
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_gates_key ()

  local item = "inv_gates_key";

  if ( cmn.ApplyObj( item, "gzz_porch_park_gates" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_park_gates" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_park_gates_use_gates_key" ) ) then

    cmn.CallEventHandler( "use_gates_key_inv" );
    cmn.CallEventHandler( "use_gates_key_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_gates_key" );
      cmn.CallEventHandler( "use_gates_key_end" );

      common.CloseSubRoom();
      cmn.GotoRoom( "mg_gates_lvl4" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_key_4lvl", 0, "", 0 );

    AnimPlay( "anm_park_key", "key", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_diamond_lvl4 ()

  local item = "inv_diamond_lvl4";

  if ( cmn.ApplyObj( item, "gzz_porch_mailbox" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailbox" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mailbox_use_diamond_lvl4" ) ) then

    cmn.CallEventHandler( "use_diamond_lvl4_inv" );
    cmn.CallEventHandler( "use_diamond_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_diamond_lvl4" );
      cmn.CallEventHandler( "use_diamond_lvl4_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_diamond", 0, "", 0 );

    AnimPlay( "anm_mailbox_diamond", "diamond", func_end )
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_can_opener_lvl4 ()

  local item = "inv_can_opener_lvl4";

  if ( cmn.ApplyObj( item, "gzz_porch_mailbox" ) and cmn.IsEventDone( "clk_diamond_lvl4_mailbox" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailbox" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mailbox_use_can_opener_lvl4" ) and cmn.IsEventDone( "clk_diamond_lvl4_mailbox" ) ) then

    cmn.CallEventHandler( "use_can_opener_lvl4_inv" );
    cmn.CallEventHandler( "use_can_opener_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_can_opener_lvl4" );
      cmn.CallEventHandler( "use_can_opener_lvl4_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_can_opener", 0, "", 0 );

    AnimPlay( "anm_mailbox_use_opener", "use_opener", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_burner ()

  local item = "inv_burner";

  if ( cmn.ApplyObj( item, "gzz_porch_entrance_door" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_entrance_door" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_entrance_door_use_burner" ) ) then

    cmn.CallEventHandler( "use_burner_inv" );
    cmn.CallEventHandler( "use_burner_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_burner" );
      cmn.CallEventHandler( "use_burner_end" );
      
      private.get_burner_2();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_gas_ballon", 0, "", 0 );

    VidPlay( "vid_entrance_door_use_nonburning_burner", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_blunt_knife ()

  local item = "inv_blunt_knife";

  if ( cmn.ApplyObj( item, "gzz_porch_mailbox" ) and cmn.IsEventDone( "clk_mailbox_door3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailbox" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mailbox_use_blunt_knife" ) and cmn.IsEventDone( "clk_mailbox_door3" ) ) then

    cmn.CallEventHandler( "use_blunt_knife_inv" );
    cmn.CallEventHandler( "use_blunt_knife_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_blunt_knife" );
      cmn.CallEventHandler( "use_blunt_knife_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_sharpen_knife_4lvl", 0, "", 0 );

    ObjSet( "anm_mailbox_knife", { alp = 1 } );
    AnimPlay( "anm_mailbox_knife", "knife", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_clock_amulet ()

  local item = "inv_clock_amulet";

  if ( cmn.ApplyObj( item, "gzz_porch_mailbox" ) and cmn.IsEventDone( "clk_diamond_lvl4_mailbox" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailbox" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mailbox_use_clock_amulet" ) and cmn.IsEventDone( "clk_diamond_lvl4_mailbox" ) ) then

    cmn.CallEventHandler( "use_clock_amulet_inv" );
    cmn.CallEventHandler( "use_clock_amulet_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_clock_amulet" );
        cmn.CallEventHandler( "use_clock_amulet_end" );

      end;

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_metal_door_small", 0, "", 0 );

      ObjAnimate( "spr_mailbox_1door_opn", "alp", 0, 0, func_end_2, {
        0.0, 0, ObjGet( "spr_mailbox_1door_opn" ).alp,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_mailbox_1door_cls", "alp", 0, 0, "", {
        0.0, 0, ObjGet( "spr_mailbox_1door_cls" ).alp,
        0.3, 0, 0,
      } );

    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_mailbox_clock_amulet_shadow",  func_end, 1.5 );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_garden_glove ()

  local item = "inv_garden_glove";

  if ( cmn.ApplyObj( item, "gzz_porch_ivy" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ivy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ivy_use_garden_glove" ) ) then

    cmn.CallEventHandler( "use_garden_glove_inv" );
    cmn.CallEventHandler( "use_garden_glove_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_garden_glove" );
        cmn.CallEventHandler( "use_garden_glove_end" );

      end;

      ObjSet( "spr_ivy_lantern_gardener_amulet_patch", { alp = 1 } );

      ObjAnimate( "spr_ivy_lantern_plate", "pos_xy", 0, 0, func_end_2, {
        0.0, 0, ObjGet( "spr_ivy_lantern_plate" ).pos_x, ObjGet( "spr_ivy_lantern_plate" ).pos_y,
        0.3, 0, -101, -46,
        0.7, 0, -536, -90,
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_brick", 0, "", 0 );

    cmn.ItemFly( "spr_ivy_lantern_plate_amulet", func_end, -1.5 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_torch_lvl4 ()

  local item = "inv_torch_lvl4";

  if ( cmn.ApplyObj( item, "gzz_porch_ivy" ) and cmn.IsEventDone( "get_seeds" ) and cmn.IsEventDone( "get_paper_piece" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ivy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ivy_use_torch_lvl4" ) and cmn.IsEventDone( "get_seeds" ) and cmn.IsEventDone( "get_paper_piece" ) ) then

    cmn.CallEventHandler( "use_torch_lvl4_inv" );
    cmn.CallEventHandler( "use_torch_lvl4_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_torch_lvl4" );
      cmn.CallEventHandler( "use_torch_lvl4_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_lamp_4lvl", 0, "", 0 );

    cmn.ItemFly( "anm_ivy_lantern_light", func_end, -1.5 );
    ObjAnimate( "obj_ivy_inside", "alp", 0, 0, "", {
      0.0, 0, ObjGet( "obj_ivy_inside" ).alp,
      0.3, 0, 1,
    } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tweezers_lvl4 ()

  local item = "inv_tweezers_lvl4";

  if ( cmn.ApplyObj( item, "gzz_porch_ivy" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ivy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ivy_use_tweezers_lvl4" ) ) then

    cmn.CallEventHandler( "use_tweezers_lvl4_inv" );
    cmn.CallEventHandler( "use_tweezers_lvl4_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_tweezers_lvl4" );
        cmn.CallEventHandler( "use_tweezers_lvl4_end" );

      end;

      AnimPlay( "anm_ivy_tweezers_decor_part", "tweezers_decor_part", func_end_2 );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_tweezers4", 0, "", 0 );

    AnimPlay( "anm_ivy_tweezers_amulet", "tweezers_amulet", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sharp_knife ()

  local item = "inv_sharp_knife";

  if ( cmn.ApplyObj( item, "gzz_porch_ivy" ) and cmn.IsEventDone( "get_gates_key" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ivy" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ivy_use_sharp_knife" ) and cmn.IsEventDone( "get_gates_key" ) ) then

    cmn.CallEventHandler( "use_sharp_knife_inv" );
    cmn.CallEventHandler( "use_sharp_knife_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_sharp_knife" );
      cmn.CallEventHandler( "use_sharp_knife_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_knife_4lvl", 0, "", 0 );

    AnimPlay( "anm_ivy_knife", "knife", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hotel_sign ()

  local item = "inv_hotel_sign";

  if ( cmn.ApplyObj( item, "gzz_porch_signboard" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_signboard" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_signboard_use_hotel_sign" ) ) then

    cmn.CallEventHandler( "use_hotel_sign_inv" );
    cmn.CallEventHandler( "use_hotel_sign_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hotel_sign" );
      cmn.CallEventHandler( "use_hotel_sign_end" );
      common.CloseSubRoom();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_hotel_sign", 0, "", 0 );

    cmn.ItemFly( "spr_signboard_hotel_sign", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_burner_2 ()

  local item = "inv_burner_2";

  if ( cmn.ApplyObj( item, "gzz_porch_mailbox" ) and cmn.IsEventDone( "clk_diamond_lvl4_mailbox" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailbox" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mailbox_use_burner_2" ) and cmn.IsEventDone( "clk_diamond_lvl4_mailbox" ) ) then

    cmn.CallEventHandler( "use_burner_2_inv" );
    cmn.CallEventHandler( "use_burner_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_burner_2" );
      cmn.CallEventHandler( "use_burner_2_end" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_gas_ballon2", 0, "", 0 );

    VidPlay( "vid_mailbox_branch", func_end );
  
    return true;

  end;
  
  return false;
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_cylinder ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cylinder" );
  cmn.CallEventHandler( "get_cylinder" );

end;
--------------------------------------------------------------------------------------------
function private.get_sharp_iron ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sharp_iron" );
  cmn.CallEventHandler( "get_sharp_iron" );

end;
--------------------------------------------------------------------------------------------
function private.get_garden_glove ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_garden_glove" );
  cmn.CallEventHandler( "get_garden_glove" );

end;

--------------------------------------------------------------------------------------------
function private.get_necklace ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_necklace" );
  cmn.CallEventHandler( "get_necklace" );

end;
--------------------------------------------------------------------------------------------
function private.get_wrench_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wrench_lvl4" );
  cmn.CallEventHandler( "get_wrench_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_tweezers_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tweezers_lvl4" );
  cmn.CallEventHandler( "get_tweezers_lvl4" );

end;
--------------------------------------------------------------------------------------------
function private.get_pulverizer ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pulverizer" );
  cmn.CallEventHandler( "get_pulverizer" );

end;
--------------------------------------------------------------------------------------------
function private.get_sharp_knife ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sharp_knife" );
  cmn.CallEventHandler( "get_sharp_knife" );

end;
--------------------------------------------------------------------------------------------
function private.get_alarm_clock ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_alarm_clock" );
  cmn.CallEventHandler( "get_alarm_clock" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_hotel_sign ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hotel_sign" );
  cmn.CallEventHandler( "get_hotel_sign" );

end;
--------------------------------------------------------------------------------------------
function private.get_gates_key ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_gates_key" );
  cmn.CallEventHandler( "get_gates_key" );

end;
--------------------------------------------------------------------------------------------
function private.get_decor_part ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_decor_part" );
  cmn.CallEventHandler( "get_decor_part" );

end;
--------------------------------------------------------------------------------------------
function private.get_seeds ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_seeds" );
  cmn.CallEventHandler( "get_seeds" );

end;
--------------------------------------------------------------------------------------------
function private.get_paper_piece ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_paper_piece" );
  cmn.CallEventHandler( "get_paper_piece" );

end;

--------------------------------------------------------------------------------------------
function private.get_lever_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lever_lvl4" );
  cmn.CallEventHandler( "get_lever_lvl4" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_burner_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_burner_2" );
  cmn.CallEventHandler( "get_burner_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_29 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_29" ); 

  end;

  common_impl.PlayEffectHO( "spr_entrance_door_collect2_item_29", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_29" );
  
  if ( cmn.IsEventDone( "clk_entrance_door" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_diamond_lvl4_mailbox ()
  
  cmn.CallEventHandler( "clk_diamond_lvl4_mailbox_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_diamond_lvl4_mailbox" );
    cmn.CallEventHandler( "clk_diamond_lvl4_mailbox_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_opn_smallbox", 0, "", 0 );

  AnimPlay( "anm_mailbox_door_after_diamond", "door_after_diamond", func_end ) 
  
end;
--------------------------------------------------------------------------------------------
function private.clk_mailbox_door3 ()

  cmn.CallEventHandler( "clk_mailbox_door3_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_mailbox_door3" );
    cmn.CallEventHandler( "clk_mailbox_door3_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_metal_door_small", 0, "", 0 );

  ObjAnimate( "spr_mailbox_3door_opn", "alp", 0, 0, func_end, {
    0.0, 0, ObjGet( "spr_mailbox_3door_opn" ).alp,
    0.3, 0, 1,
  } );
  ObjAnimate( "spr_mailbox_3door_cls", "alp", 0, 0, "", {
    0.0, 0, ObjGet( "spr_mailbox_3door_cls" ).alp,
    0.3, 0, 0,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_entrance_door ()

  cmn.CallEventHandler( "clk_entrance_door_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_entrance_door" );
    cmn.CallEventHandler( "clk_entrance_door_end" ); 
    
    if ( cmn.IsGetCollect2( "get_collect2_item_29" ) ) then
      
      common.CloseSubRoom();

    end;
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_door_4lvl", 0, "", 0 );

  AnimPlay( "anm_entrance_door_open", "door_open", func_end )   

end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
end;
--*********************************************************************************************************************
function private.SeeIntrolvl4 ()

  ObjDelete( "tmr_porch_intro_lvl4" );

  local func_end = function ( skip )
  
    if skip then
  
      common_impl.StopAudio( "voc", "levelext/voc/aud_intro_lvl4_voc",  0.2 );
      common_impl.StopAudio( "sfx", "levelext/sfx/aud_intro_lvl4",      0.2 );
      
    end;
    
    ObjSet( private.room_objname, { color_r = 1, color_g = 1, color_b = 1 } );

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

    cmn.SetEventDone( "see_intro_lvl4" );
    cmn.CallEventHandler( "see_intro_lvl4" );

    common_impl.ShowBbt( 'bbt_porch_see_intro_lvl4' );

    interface.KeyTaskAdd( "lvl4_fight_back" );

    cmn.GotoRoom( "mg_attack" );

  end;

  common_impl.PlayAudio( "voc", "levelext/voc/aud_intro_lvl4_voc",  0, "", 0 );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_intro_lvl4",      0, "", 0 );

  cmn.PlayDialogVideo( "vid_porch_intro_lvl4", func_end );

end;
--*********************************************************************************************************************
function private.see_porch_death ()
  
  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "levelext/voc/aud_porch_death_voc",  0.2 );
      common_impl.StopAudio( "sfx", "levelext/sfx/aud_porch_death",      0.2 );
      
    end;

    cmn.SetEventDone( "see_porch_death" );
    cmn.CallEventHandler( "see_porch_death" );

    common_impl.ShowBbt( 'bbt_porch_see_porch_death' );
    
  end;

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_porch_death",      0, "", 0 );
  common_impl.PlayAudio( "voc", "levelext/voc/aud_porch_death_voc",  0, "", 0 );
  
  cmn.PlayDialogVideo( "vid_porch_death", func_end );
  
end;
--*********************************************************************************************************************
function private.see_anim_porch_1 ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_porch_anim_porch_1" );
    cmn.CallEventHandler( "see_porch_anim_porch_1" );

    common_impl.ShowBbt( 'bbt_porch_anim_porch_1' );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl4_return_to_body" );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_close_gate", 0, "", 0 );

  ObjAnimate( private.room_objname, "pos_xy", 0, 0, "", {
    0,   0,  0,    0,
    0.2, 1, 26, -282,
    2.0, 3, 25, -283,
    2.7, 3, 26, -282,
    3.0, 3,  0,    0,
  } );
  
  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "", {
    0,   0, 1,   1,
    0.2, 1, 1.4, 1.4,
    2.7,   3, 1.4, 1.4,
    3.0, 3, 1,   1,
  } );
  
  AnimPlay( "anm_porch_anim", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_anim_porch_open ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_porch_anim_porch_open" );
    cmn.CallEventHandler( "see_porch_anim_porch_open" );

    --common_impl.ShowBbt( 'bbt_porch_anim_porch_1' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );

  AnimPlay( "anm_porch_hoopen", "ho_open", func_end );
  
end;
--------------------------------------------------------------------------------------------
function private.see_anim_porch_open_2 ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_porch_anim_porch_open_2" );
    cmn.CallEventHandler( "see_porch_anim_porch_open_2" );

    --common_impl.ShowBbt( 'bbt_porch_anim_porch_1' );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_main_gates_4lvl", 0, "", 0 );

  AnimPlay( "anm_porch_open_gates", "open_gates", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_porch ()

  if not ( cmn.IsEventDone( "opn_porch" ) ) then

    cmn.SetEventDone( "opn_porch" );
    common_impl.ShowBbt( 'bbt_porch_opn_porch' );

  end;
  cmn.CallEventHandler( "opn_porch" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.UseWrench()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_park_gates_use_wrench_lvl4' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_mid_door", 0, "", 0 );

  ObjAnimate( "obj_park_gates_box", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, -1, 0,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.UseKey()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_park_gates_use_gates_key' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_high2", 0, "", 0 );

  ObjAnimate( "anm_park_key", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, 0, 1,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseDiamondLvl4()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_mailbox_use_diamond_lvl4' );
  
    ObjMultiSet({ 
      { "anm_mailbox_door_after_diamond_click", { alp = 0 }},
      { "anm_mailbox_diamond",                  { alp = 1 }},
    });

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_wood2", 0, "", 0 );

  ObjMultiSet({ 
    { "anm_mailbox_door_after_diamond_click", { alp = 1 }},
    { "anm_mailbox_diamond",                  { alp = 0 }},
  });

  AnimPlay( "anm_mailbox_door_after_diamond_click", "door_after_diamond_click", func_end )

end;
--------------------------------------------------------------------------------------------
function private.AnimUseCanOpenerLvl4()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_mailbox_use_can_opener_lvl4' );
  
    ObjMultiSet({ 
      { "anm_mailbox_click_ballon_cap", { alp = 0 }},
      { "anm_mailbox_use_opener",       { alp = 1 }},
      { "spr_mailbox_pulverizer",       { alp = 1 }},
    });

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_clk_plastic_can", 0, "", 0 );

  ObjMultiSet({ 
    { "anm_mailbox_click_ballon_cap", { alp = 1 }},
    { "anm_mailbox_use_opener",       { alp = 0 }},
    { "spr_mailbox_pulverizer",       { alp = 0 }},
  });

  AnimPlay( "anm_mailbox_click_ballon_cap", "click_ballon_cap", func_end )

end;
--------------------------------------------------------------------------------------------
function private.AnimUseClockAmulet()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_mailbox_use_clock_amulet' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_metal_grill3", 0, "", 0 );

  ObjAnimate( "spr_mailbox_1door_cls", "pos_xy", 0, 1, func_end, { 0, 0, 0, 0,   0.2, 3, -1, 0,   0.4, 3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseGardenGlove()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_ivy_use_garden_glove' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_use_stone3", 0, "", 0 );

  ObjAnimate( "spr_ivy_lantern_plate", "pos_xy", 0, 1, func_end, { 0.0,0,0,0,  0.2,3,2,2,  0.4,3,0,0 } );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseTweezersLvl4()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_ivy_use_tweezers_lvl4' );
  
    ObjMultiSet({ 
      { "anm_ivy_tweezers_decor_part", { alp = 1 }},
      { "anm_ivy_tweezers_amulet",     { alp = 1 }},
      { "anm_ivy_hh_decor_part",       { alp = 0 }},
      { "anm_ivy_hh_amulet",           { alp = 0 }},
    });

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_cutters", 0, "", 0 );

  ObjMultiSet({ 
    { "anm_ivy_tweezers_decor_part", { alp = 0 }},
    { "anm_ivy_tweezers_amulet",     { alp = 0 }},
    { "anm_ivy_hh_decor_part",       { alp = 1 }},
    { "anm_ivy_hh_amulet",           { alp = 1 }},
  });

  AnimPlay( "anm_ivy_hh_decor_part", "hh_decor_part", func_end );
  AnimPlay( "anm_ivy_hh_amulet",     "hh_amulet",     ""       );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseSharpKnife()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_ivy_use_sharp_knife' );
  
    ObjMultiSet({ 
      { "anm_ivy_knife",  { alp = 1 }},
      { "anm_ivy_hh_bag", { alp = 0 }},
    });

  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_cloth", 0, "", 0 );

  ObjMultiSet({ 
    { "anm_ivy_knife",  { alp = 0 }},
    { "anm_ivy_hh_bag", { alp = 1 }},
  });

  AnimPlay( "anm_ivy_hh_bag", "hh_bag", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimUseCrowbar()
  
  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_entrance_door_use_crowbar' );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_xx_clk_magic", 0, "", 0 );

  AnimPlay( "anm_entrance_click", "click", func_end );

end;
--------------------------------------------------------------------------------------------
