-- name=rm_room_211_lvl4
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_room_211_lvl4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_sara_stuff", "room_hub" );
  ObjAttach( "zz_bed_lvl4",   "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  private.Room211Init();
  
  ObjMultiSet({ 
    { "spr_sara_stuff_cane_umbrella",         { event_mdown = private.get_cane_umbrella  }},
    { "spr_sara_stuff_sara_locket",           { event_mdown = private.get_sara_locket    }},

    { "spr_bed_lvl4_bag_lock_part",           { event_mdown = private.get_bag_lock_part  }},
 
    { "spr_room_211_lvl4_armchair_lever",     { event_mdown = private.get_armchair_lever }},
    { "obj_room_211_lvl4_clk_room_211_focus", { event_mdown = private.clk_room_211_lvl4  }},
    { "obj_room_211_lvl4_clk_room_211",       { event_mdown = private.clk_room_211_lvl4  }},
    
    { "obj_sara_stuff_clk_bag_lock_part_1",   { event_mdown = private.clk_bag_lock_part_1  }},
    { "obj_sara_stuff_clk_bag_lock_part_2",   { event_mdown = private.clk_bag_lock_part_2  }},
    
    { "obj_bed_lvl4_use_sara_medallion",      { event_mdown = private.BedLvl4UseSaraMedallion  }},
    { "obj_bed_lvl4_clk_sara_medallion",      { event_mdown = private.clk_sara_medallion  }},
    
    { "spr_room_211_lvl4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_22" ); end } },
      
    { "spr_bed_lvl4_collect2_item_24",        { event_mdown = private.get_collect2_item_24      }},
      
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_room_211_lvl4 = function ()
  
     table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;

    local gates = 
    {
      "gzz_room_211_lvl4_sara_stuff",
      "gzz_room_211_lvl4_bed_lvl4"
    };

    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_sara_stuff",
      "zz_bed_lvl4",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_room_211_lvl4", update_game_mode_room_211_lvl4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_room_211_lvl4 = function ()

    local effects_table = 
    {
      "obj_room_211_lvl4_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_room_211_lvl4", update_performance_mode_room_211_lvl4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_room_211_lvl4 () end;
  --------------------------------------------------------------------------------------------
  local opn_room_211_lvl4_map = function ()

    common_impl.VisitMapRoom( "room_211_lvl4" );

  end;
  cmn.AddSubscriber( "opn_room_211_lvl4", opn_room_211_lvl4_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_22 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_22 = function ()
  
    ObjDelete( "obj_room_211_lvl4_morph" );
  
  end;    
  cmn.AddSubscriber( "get_collect_morph_item_22", get_collect_morph_item_22, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function get_cane_umbrella () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cane_umbrella" ] = {
    type = "get",
    get_obj = "gfx_sara_stuff_cane_umbrella",
    room = private.room_objname,
    zz = "zz_sara_stuff",
    zz_gate = "gzz_room_211_lvl4_sara_stuff"
  };
  
  local get_cane_umbrella_inv = function ()
  
    interface.InventoryItemAdd( "inv_cane_umbrella", "spr_sara_stuff_cane_umbrella" );
  
  end;
  
  local get_cane_umbrella_closezz = function ()
  
    ObjDelete( "gfx_sara_stuff_cane_umbrella" );
    ObjDelete( "gzz_room_211_lvl4_sara_stuff" );

  end;
  
  cmn.AddSubscriber( "get_cane_umbrella", get_cane_umbrella_inv );
  cmn.AddSubscriber( "get_cane_umbrella", get_cane_umbrella_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sara_locket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sara_locket" ] = {
    type = "get",
    get_obj = "gfx_sara_stuff_sara_locket",
    room = private.room_objname,
    zz = "zz_sara_stuff",
    zz_gate = "gzz_room_211_lvl4_sara_stuff"
  };
  
  local get_sara_locket_inv = function ()
  
    interface.InventoryItemAdd( "inv_sara_locket", "spr_sara_stuff_sara_locket" );
    ObjSet( "inv_sara_locket", { drag = false } );

  end;
  
  local get_sara_locket_closezz = function ()
  
    ObjDelete( "gfx_sara_stuff_sara_locket" );
  
  end;
  
  cmn.AddSubscriber( "get_sara_locket", get_sara_locket_inv );
  cmn.AddSubscriber( "get_sara_locket", get_sara_locket_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bag_lock_part () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bag_lock_part" ] = {
    type = "get",
    get_obj = "spr_bed_lvl4_bag_lock_part",
    room = private.room_objname,
    zz = "zz_bed_lvl4",
    zz_gate = "gzz_room_211_lvl4_bed_lvl4"
  };
  
  local get_bag_lock_part_inv = function ()
  
    interface.InventoryItemAdd( "inv_bag_lock_part", "spr_bed_lvl4_bag_lock_part" );
  
  end;
  
  local get_bag_lock_part_closezz = function ()
  
    ObjDelete( "gfx_bed_lvl4_bag_lock_part" );
    
    if ( cmn.IsGetCollect2( "get_collect2_item_24" ) ) then
      
      ObjDelete( "gzz_room_211_lvl4_bed_lvl4" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_bag_lock_part", get_bag_lock_part_inv );
  cmn.AddSubscriber( "get_bag_lock_part", get_bag_lock_part_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_armchair_lever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_armchair_lever" ] = {
    type = "get",
    get_obj = "spr_room_211_lvl4_armchair_lever",
    room = private.room_objname,
  };
  
  local get_armchair_lever_inv = function ()
  
    interface.InventoryItemAdd( "inv_armchair_lever", "spr_room_211_lvl4_armchair_lever" );
  
  end;
  
  local get_armchair_lever_closezz = function ()
  
    ObjDelete( "gfx_room_211_lvl4_armchair_lever" );
    ObjDelete( "spr_room_211_lvl4_chandelier_lever" );
    
  end;
  
  cmn.AddSubscriber( "get_armchair_lever", get_armchair_lever_inv );
  cmn.AddSubscriber( "get_armchair_lever", get_armchair_lever_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_24 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_24 = function ()
  
    ObjDelete( "obj_bed_lvl4_collect2_item_24" ); 
  
    if ( cmn.IsEventDone( "get_bag_lock_part" ) ) then
      
      ObjDelete( "gzz_room_211_lvl4_bed_lvl4" );
      
    end;  
    
  end;    
  cmn.AddSubscriber( "get_collect2_item_24", get_collect2_item_24, private.room_objname );      
  --------------------------------------------------------------------------------------------
  -- function use_bag_lock_part () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bag_lock_part" ] = {
    type = "use",
    inv_obj = "inv_bag_lock_part",
    use_place = "obj_sara_stuff_use_bag_lock_part",
    room = private.room_objname,
    zz = "zz_sara_stuff",
    zz_gate = "gzz_room_211_lvl4_sara_stuff"
  };
  local use_bag_lock_part_inv = function ()
  
    interface.InventoryItemRemove( "inv_bag_lock_part" );
  
  end;
  local use_bag_lock_part_beg = function ()
  
    ObjDelete( "obj_sara_stuff_use_bag_lock_part" );
  
  end;
  local use_bag_lock_part_end = function ()
  
    ObjDelete( "spr_sara_stuff_amulet" );
    ObjMultiSet( { 
      { "obj_sara_stuff_open",  { alp = 1, visible = true } },
      { "obj_sara_stuff_clk_bag_lock_part_1",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bag_lock_part", use_bag_lock_part_beg, private.room_objname );
  cmn.AddSubscriber( "use_bag_lock_part", use_bag_lock_part_inv );
  cmn.AddSubscriber( "use_bag_lock_part", use_bag_lock_part_end, private.room_objname );
  cmn.AddSubscriber( "use_bag_lock_part_inv", use_bag_lock_part_inv, private.room_objname );
  cmn.AddSubscriber( "use_bag_lock_part_beg", use_bag_lock_part_beg, private.room_objname );
  cmn.AddSubscriber( "use_bag_lock_part_end", use_bag_lock_part_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sara_medallion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sara_medallion" ] = {
    type = "use",
    inv_obj = "inv_sara_medallion",
    use_place = "obj_bed_lvl4_use_sara_medallion",
    room = private.room_objname,
    zz = "zz_bed_lvl4",
    zz_gate = "gzz_room_211_lvl4_bed_lvl4"
  };
  local use_sara_medallion_inv = function ()
  
    interface.InventoryItemRemove( "inv_sara_medallion" );
  
  end;
  local use_sara_medallion_beg = function ()
  
    ObjDelete( "obj_bed_lvl4_use_sara_medallion" );
  
  end;
  local use_sara_medallion_end = function ()
  
    ObjDelete( "spr_bed_lvl4_hatch" );
    ObjMultiSet( { 
      { "spr_bed_lvl4_bag_lock_part",  { input = true } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sara_medallion", use_sara_medallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_sara_medallion", use_sara_medallion_inv );
  cmn.AddSubscriber( "use_sara_medallion", use_sara_medallion_end, private.room_objname );
  cmn.AddSubscriber( "use_sara_medallion_inv", use_sara_medallion_inv, private.room_objname );
  cmn.AddSubscriber( "use_sara_medallion_beg", use_sara_medallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_sara_medallion_end", use_sara_medallion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cane_umbrella () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cane_umbrella" ] = {
    type = "use",
    inv_obj = "inv_cane_umbrella",
    use_place = "obj_room_211_lvl4_use_cane_umbrella",
    room = private.room_objname,
  };
  local use_cane_umbrella_inv = function ()
  
    interface.InventoryItemRemove( "inv_cane_umbrella" );
  
  end;
  local use_cane_umbrella_beg = function ()
  
    ObjDelete( "obj_room_211_lvl4_use_cane_umbrella" );
  
  end;
  local use_cane_umbrella_end = function ()
  
    ObjMultiSet( { 
      { "spr_room_211_lvl4_armchair_lever", { input = true, visible = true } },
    } );
    ObjDelete( "anm_room_211_lvl4_room_umbrella" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cane_umbrella", use_cane_umbrella_beg, private.room_objname );
  cmn.AddSubscriber( "use_cane_umbrella", use_cane_umbrella_inv );
  cmn.AddSubscriber( "use_cane_umbrella", use_cane_umbrella_end, private.room_objname );
  cmn.AddSubscriber( "use_cane_umbrella_inv", use_cane_umbrella_inv, private.room_objname );
  cmn.AddSubscriber( "use_cane_umbrella_beg", use_cane_umbrella_beg, private.room_objname );
  cmn.AddSubscriber( "use_cane_umbrella_end", use_cane_umbrella_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sal_ammoniac () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sal_ammoniac" ] = {
    type = "use",
    inv_obj = "inv_sal_ammoniac",
    use_place = "obj_room_211_lvl4_use_sal_ammoniac",
    room = private.room_objname,
  };
  local use_sal_ammoniac_inv = function ()
  
    interface.InventoryItemRemove( "inv_sal_ammoniac" );
  
  end;
  local use_sal_ammoniac_beg = function ()
  
    ObjDelete( "obj_room_211_lvl4_use_sal_ammoniac" );
  
  end;
  local use_sal_ammoniac_end = function ()
  
    --ObjSet( "spr_room_211_lvl4_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sal_ammoniac", use_sal_ammoniac_beg, private.room_objname );
  cmn.AddSubscriber( "use_sal_ammoniac", use_sal_ammoniac_inv );
  cmn.AddSubscriber( "use_sal_ammoniac", use_sal_ammoniac_end, private.room_objname );
  cmn.AddSubscriber( "use_sal_ammoniac_inv", use_sal_ammoniac_inv, private.room_objname );
  cmn.AddSubscriber( "use_sal_ammoniac_beg", use_sal_ammoniac_beg, private.room_objname );
  cmn.AddSubscriber( "use_sal_ammoniac_end", use_sal_ammoniac_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_room_211_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_room_211_lvl4" ] = {
    type = "click",
    use_place = "obj_room_211_lvl4_clk_room_211",
    room = private.room_objname
  };
  
  local clk_room_211_lvl4_beg = function ()

    ObjDelete( "obj_room_211_lvl4_clk_room_211" );
  
  end;
  local clk_room_211_lvl4_end = function ()
    
    ObjDelete( "anm_room_211_lvl4_room_211_1_statics" );    
    ObjDelete( "anm_room_211_lvl4_room_211_1_amulet" );  
    ObjMultiSet( { 
      { "obj_room_211_lvl4_mmg",        {  alp = 1, input = true } },
      { "anm_room_211_lvl4_room_211_2", {  alp = 1               } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_room_211_lvl4",     clk_room_211_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_room_211_lvl4",     clk_room_211_lvl4_end, private.room_objname );
  cmn.AddSubscriber( "clk_room_211_lvl4_beg", clk_room_211_lvl4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_room_211_lvl4_end", clk_room_211_lvl4_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_bag_lock_part_1 () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bag_lock_part_1" ] = {
    type = "click",
    use_place = "obj_sara_stuff_clk_bag_lock_part_1",
    room = private.room_objname,
    zz = "zz_sara_stuff",
    zz_gate = "gzz_room_211_lvl4_sara_stuff"
  };
  local clk_bag_lock_part_1_beg = function ()

    ObjDelete( "obj_sara_stuff_clk_bag_lock_part_1" );
  
  end;
  local clk_bag_lock_part_1_end = function ()

    ObjDelete( "spr_sara_stuff_umbrella_1" );
    ObjMultiSet( { 
      { "spr_sara_stuff_cane_umbrella",  { alp = 1, visible = true, input = true } },
      { "obj_sara_stuff_clk_bag_lock_part_2",  { input = true } },
    } ); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bag_lock_part_1",     clk_bag_lock_part_1_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bag_lock_part_1",     clk_bag_lock_part_1_end, private.room_objname  );
  cmn.AddSubscriber( "clk_bag_lock_part_1_beg", clk_bag_lock_part_1_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bag_lock_part_1_end", clk_bag_lock_part_1_end, private.room_objname  );  
  --------------------------------------------------------------------------------------------
  -- function clk_bag_lock_part_2 () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bag_lock_part_2" ] = {
    type = "click",
    use_place = "obj_sara_stuff_clk_bag_lock_part_2",
    room = private.room_objname,
    zz = "zz_sara_stuff",
    zz_gate = "gzz_room_211_lvl4_sara_stuff"
  };
  local clk_bag_lock_part_2_beg = function ()

    ObjDelete( "obj_sara_stuff_clk_bag_lock_part_2" );
  
  end;
  local clk_bag_lock_part_2_end = function ()

    ObjMultiSet( { 
      { "spr_sara_stuff_cane_umbrella",  { pos_x = 167, pos_y = -125 } },
      { "spr_sara_stuff_umbrella_2",  { pos_x = -329, pos_y = 206 } },
      { "obj_sara_stuff_open",  { input = true } },
      { "gfx_sara_stuff_cane_umbrella",  { active = true } },
    } ); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bag_lock_part_2",     clk_bag_lock_part_2_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bag_lock_part_2",     clk_bag_lock_part_2_end, private.room_objname  );
  cmn.AddSubscriber( "clk_bag_lock_part_2_beg", clk_bag_lock_part_2_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_bag_lock_part_2_end", clk_bag_lock_part_2_end, private.room_objname  );  
  --------------------------------------------------------------------------------------------
  -- function clk_sara_medallion () end; 
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_sara_medallion" ] = {
    type = "click",
    use_place = "obj_bed_lvl4_clk_sara_medallion",
    room = private.room_objname,
    zz = "zz_bed_lvl4",
    zz_gate = "gzz_room_211_lvl4_bed_lvl4"
  };
  local clk_sara_medallion_beg = function ()

    ObjDelete( "obj_bed_lvl4_clk_sara_medallion" );
  
  end;
  local clk_sara_medallion_end = function ()

    ObjDelete( "spr_bed_lvl4_newspaper" );
    ObjMultiSet( { 
      { "obj_bed_lvl4_use_sara_medallion",  { input = true } },
    } ); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_sara_medallion",     clk_sara_medallion_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_sara_medallion",     clk_sara_medallion_end, private.room_objname  );
  cmn.AddSubscriber( "clk_sara_medallion_beg", clk_sara_medallion_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_sara_medallion_end", clk_sara_medallion_end, private.room_objname  ); 
  --------------------------------------------------------------------------------------------
  -- function see_room_211_lvl4_anim_room_211_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_room_211_lvl4_anim_room_211_1" ] = {
    type = "click",
    use_place = "obj_room_211_lvl4_anim_room_211_1",
    room = private.room_objname
  };

  local see_room_211_lvl4_anim_room_211_1 = function ()
  
    ObjDelete( "obj_room_211_lvl4_anim_room_211_1" );
    ObjDelete( "anm_room_211_lvl4_room_211_1" );
    
    ObjMultiSet({ 
      { "obj_room_211_lvl4_clk_room_211", { input = true }},
      { "anm_room_211_lvl4_room_211_1_statics", { alp = 1 }},
    });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_room_211_lvl4_anim_room_211_1", see_room_211_lvl4_anim_room_211_1, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function see_room_211_lvl4_anim_room_211_2 () end;
  --------------------------------------------------------------------------------------------
  local see_room_211_lvl4_anim_room_211_2 = function ()
    
    ObjDelete( "anm_room_211_lvl4_room_211_2" );  
    ObjMultiSet({ 
      { "gzz_room_211_lvl4_sara_stuff",    { input = true, active = true, visible = true  }},
      { "gzz_room_211_lvl4_bed_lvl4",      { input = true, active = true, visible = true  }},
      { "anm_room_211_lvl4_sarah",         {   alp = 1                                    }},
      { "anm_room_211_lvl4_room_umbrella", {   alp = 1                                    }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_room_211_lvl4_anim_room_211_2", see_room_211_lvl4_anim_room_211_2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_room_211_lvl4_outro_lvl4 () end;
  --------------------------------------------------------------------------------------------
  local see_room_211_lvl4_outro_lvl4 = function ()
    
  end;
  cmn.AddSubscriber( "see_room_211_lvl4_outro_lvl4", see_room_211_lvl4_outro_lvl4, private.room_objname );   
  
  --------------------------------------------------------------------------------------------
  -- function win_room_211_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_room_211_lvl4" ] =
  {
      type = "win",
      room = private.room_objname 
  };

  local win_room_211_lvl4 = function ()

    if ( cmn.IsEventDone( "win_room_211_lvl4" ) ) then
    
      ObjDelete( "obj_room_211_lvl4_mmg" );
      
    elseif ( cmn.IsEventStart( "win_room_211_lvl4" ) ) then

      private.Room211Load();
      
    end;

  end;

  cmn.AddSubscriber( "win_room_211_lvl4", win_room_211_lvl4, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_room_211_lvl4();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_room_211_lvl4_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();
  
  if not cmn.IsEventDone( "see_room_211_lvl4_anim_room_211_1" ) then
    private.see_room_211_lvl4_anim_room_211_1 ();
  end;
  
  if cmn.IsEventDone( "use_sal_ammoniac" ) and not cmn.IsEventDone( "see_room_211_lvl4_outro_lvl4" ) then
    private.see_room_211_lvl4_outro_lvl4 ();
  end;
  if ( cmn.IsEventStart( "win_room_211_lvl4" ) and not cmn.IsEventDone( "win_room_211_lvl4" ) ) then

    cmn.MiniGameShow( "room_211_lvl4" );
    common_impl.PassingMgStart( "room_211_lvl4" );
    private.Room211DrawScene();
    private.Room211StartGame();
    private.Room211Reset( false, true );

    ObjAnimate( "obj_room_211_lvl4_tracks", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    
    ObjAnimate( "anm_room_211_lvl4_light", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    ObjAnimate( "spr_room_211_lvl4_amulet", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
  
  end;  

  if cmn.IsEventDone( "see_room_211_lvl4_anim_room_211_1" ) and not cmn.IsEventDone( "see_room_211_lvl4_anim_room_211_2" ) then
    common_impl.PlayAudio( "env", "levelext/env/aud_anim1_env", 1, "", 0 );
  end;
  
end;
--*********************************************************************************************************************
function public.Close ()
  
  if ( cmn.IsEventDone( "clk_room_211_lvl4" ) and not cmn.IsEventDone( "win_room_211_lvl4" ) ) then 
    
    cmn.MiniGameHide( "room_211_lvl4" );
    common_impl.PassingMgStop( "room_211_lvl4" );
    
  end;
      
end;
--*********************************************************************************************************************
function public.PreClose ()
  common_impl.StopAudio( "env", "levelext/env/aud_room_211_lvl4_env", 0.5 );
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_bag_lock_part ()

  local item = "inv_bag_lock_part";

  if ( cmn.ApplyObj( item, "gzz_room_211_lvl4_sara_stuff" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sara_stuff" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sara_stuff_use_bag_lock_part" ) ) then

    cmn.CallEventHandler( "use_bag_lock_part_inv" );
    cmn.CallEventHandler( "use_bag_lock_part_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bag_lock_part" );
      cmn.CallEventHandler( "use_bag_lock_part_end" );

    end;
    
    local func_end_2 = function ()
      
      ObjSet( "obj_sara_stuff_open", { alp = 0, visible = true } );
      ObjAnimate( "obj_sara_stuff_open", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_amulet_bag_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_sara_stuff_amulet", func_end_2, 2.09 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sara_medallion ()

  local item = "inv_sara_medallion";

  if ( cmn.ApplyObj( item, "gzz_room_211_lvl4_bed_lvl4" ) and
  cmn.IsEventDone( "clk_sara_medallion" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bed_lvl4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bed_lvl4_use_sara_medallion" ) and
    cmn.IsEventDone( "clk_sara_medallion" ) ) then

    cmn.CallEventHandler( "use_sara_medallion_inv" );
    cmn.CallEventHandler( "use_sara_medallion_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_sara_medallion" );
      cmn.CallEventHandler( "use_sara_medallion_end" );

    end;
    
    local func_end_2 = function ()
      
      ObjAnimate( "spr_bed_lvl4_hatch", "pos_xy",0,0, func_end, { 0, 3, 96, 56,    0.6, 3, 369, 131 } );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_moon_amulet_4lvl", 0, "", 0 );

    cmn.ItemFly( "spr_bed_lvl4_moon", func_end_2, -1.22 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cane_umbrella ()

  local item = "inv_cane_umbrella";

  if ( cmn.ApplyObj( item, "obj_room_211_lvl4_use_cane_umbrella" ) ) then

    cmn.CallEventHandler( "use_cane_umbrella_inv" );
    cmn.CallEventHandler( "use_cane_umbrella_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_cane_umbrella" );
      cmn.CallEventHandler( "use_cane_umbrella_end" );
      private.get_armchair_lever();
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_umbrella_4lvl", 0, "", 0 );

    AnimPlay( "anm_room_211_lvl4_room_umbrella", "use_umbrella", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sal_ammoniac ()

  local item = "inv_sal_ammoniac";

  if ( cmn.ApplyObj( item, "obj_room_211_lvl4_use_sal_ammoniac" ) ) then

    cmn.CallEventHandler( "use_sal_ammoniac_inv" );
    cmn.CallEventHandler( "use_sal_ammoniac_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_sal_ammoniac" );
      cmn.CallEventHandler( "use_sal_ammoniac_end" );

      private.see_room_211_lvl4_outro_lvl4 ();

    end;

    cmn.Lock( true );

    --common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_ammonia_4lvl", 0, "", 0 );
    ObjMultiSet({ 
      { "anm_room_211_lvl4_room_ammon", { alp = 1 }},
      { "anm_room_211_lvl4_sarah",      { alp = 0 }},
    });
    AnimPlay( "anm_room_211_lvl4_room_ammon", "ammon", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_cane_umbrella ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cane_umbrella" );
  cmn.CallEventHandler( "get_cane_umbrella" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_sara_locket ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sara_locket" );
  cmn.CallEventHandler( "get_sara_locket" );

end;
--------------------------------------------------------------------------------------------
function private.get_bag_lock_part ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bag_lock_part" );
  cmn.CallEventHandler( "get_bag_lock_part" );

  if ( cmn.IsGetCollect2( "get_collect2_item_24" ) ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_armchair_lever ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_armchair_lever" );
  cmn.CallEventHandler( "get_armchair_lever" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_24 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_24" ); 

  end;

  common_impl.PlayEffectHO( "spr_bed_lvl4_collect2_item_24", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_24" );
  
  if ( cmn.IsEventDone( "get_bag_lock_part" ) ) then

    common.CloseSubRoom();

  end; 
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_room_211_lvl4 ()
  
  cmn.CallEventHandler( "clk_room_211_lvl4_beg" );

  local func_end = function ()
    
    local func_end2 = function ()  
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_room_211_lvl4" );
      cmn.CallEventHandler( "clk_room_211_lvl4_end" ); 

      cmn.MiniGameShow( "room_211_lvl4" );
      common_impl.PassingMgStart( "room_211_lvl4" );
      private.Room211DrawScene();
      private.Room211StartGame();
    
    end; 
  
    ObjAnimate( "obj_room_211_lvl4_mmg", "alp", 0, 0, func_end2, { 0, 0, 0,   0.3, 0, 1 } );
    
    private.Room211StartConditions();
    private.Room211Load();

    ObjAnimate( "obj_room_211_lvl4_tracks", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    
    ObjAnimate( "anm_room_211_lvl4_light", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    
    ObjAnimate( "spr_room_211_lvl4_amulet", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
  
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_room_211", 0, "", 0 );
  
  ObjMultiSet( { 
    { "anm_room_211_lvl4_room_211_1_statics", {  alp = 0 } },
    { "anm_room_211_lvl4_room_211_1_amulet",  {  alp = 1 } },
  } );    
  AnimPlay( "anm_room_211_lvl4_room_211_1_amulet", "211_amulet", func_end );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_bag_lock_part_1 ()
  
  cmn.CallEventHandler( "clk_bag_lock_part_1_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_bag_lock_part_1" );
    cmn.CallEventHandler( "clk_bag_lock_part_1_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_umbrella_4lvl", 0, "", 0 );
  
  ObjAnimate( "spr_sara_stuff_umbrella_1", "alp",0,0, func_end, { 0, 0, 1,    0.6, 0, 0 } );
  ObjSet( "spr_sara_stuff_cane_umbrella", { alp = 0, visible = true } );
  ObjAnimate( "spr_sara_stuff_cane_umbrella", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 1 } );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_bag_lock_part_2 ()
  
  cmn.CallEventHandler( "clk_bag_lock_part_2_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_bag_lock_part_2" );
    cmn.CallEventHandler( "clk_bag_lock_part_2_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_umbrella2_4lvl", 0, "", 0 );
  
  ObjAnimate( "spr_sara_stuff_cane_umbrella", "pos_xy",0,0, func_end, { 0, 3, -3, -16,    0.6, 3, 167, -125 } );
  ObjAnimate( "spr_sara_stuff_umbrella_2", "pos_xy",0,0, "", { 0, 3, -161, 92,    0.6, 3, -329, 206 } );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_sara_medallion ()
  
  cmn.CallEventHandler( "clk_sara_medallion_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    
    cmn.SetEventDone( "clk_sara_medallion" );
    cmn.CallEventHandler( "clk_sara_medallion_end" ); 
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper1", 0, "", 0 );
  
  ObjAnimate( "spr_bed_lvl4_newspaper", "pos_xy",0,0, func_end, { 0, 3, 181, 76,    0.6, 3, 393, 306 } );
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG ROOM211 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Skip ()
  
  private.Room211Skip();
  
end;
--*********************************************************************************************************************
function public.Reset ()
  
  private.Room211Reset();
  
end;
--------------------------------------------------------------------------------------------
function private.Room211Win ()
  
  local func_end = function()
  
    cmn.SetEventDone( "win_room_211_lvl4" );
    cmn.CallEventHandler( "win_room_211_lvl4" );
  
    cmn.Lock( false );
    
    common_impl.PassingMgWin( "room_211_lvl4" );
    private.see_room_211_lvl4_anim_room_211_2();
    --common_impl.ShowBbt( 'bbt_lucien_room_we_meet_again_win' );  
  
  end;
  
  cmn.MiniGameHide( "room_211_lvl4" );
  
  cmn.Lock( true );
  func_end();  
  
end;

function private.Room211Init ()

  private.stage_win_num = { 10 };           -- количество шариков нужно выбить в стадиях
  private.stage_win_end = { 10 };           -- количество шариков в стадии
  private.life_drawoff_y = 274;             -- смещение полоски жизней, когда ее полностью не видно
  private.fire_flag = false;                -- нахождение в процессе анимации выстрела
  private.fly_ball_flag = false;            -- нахождение в процессе полета выстреленного шара
  private.ball_waiting_flag = {};           -- нахождение в процессе ожидания предыдущих шаров (шары которые ждут)
  private.ball_insert_flag = 0;             -- нахождение в процессе вставки выстреленного шара (последний шар который убегает в перед)
  private.balls = {};                       -- динамически заполняемая таблица шаров ( номер, цвет, позиция, движение )
  private.balls_color = {};                 -- динамически заполняемая таблица цветов шаров на стадии ( цвет )
  private.room211_is_start = false;           -- для первого захода в локу
  private.insert_flag = false;              -- нахождение в процессе анимации вставки между шарами

  --точки которые проходят шарики, потом дополнительно разбиваються программно
  
    private.start_stage_points_1 =
  {
    { 443, 236 }, { 402, 208 }, { 358, 185 }, { 310, 168 }, { 259, 162 }, { 208, 167 },
    { 161, 185 }, { 113, 207 }, {  81, 248 }, {  70, 297 }, {  81, 348 }, { 120, 385 },
    { 166, 411 }, { 214, 426 }, { 266, 427 }, { 317, 418 }, { 366, 405 }, { 410, 378 },
    { 449, 347 }, { 489, 316 }, { 527, 282 }, { 565, 248 }, { 603, 214 }, { 645, 186 },
    { 645, 186 }, { 691, 164 }, { 742, 158 }, { 792, 160 }, { 841, 173 }, { 886, 196 },
    { 929, 224 }, { 949, 271 }, { 947, 322 }, { 924, 369 }, { 885, 401 }, { 837, 418 },
    { 786, 425 }, { 735, 424 }, { 686, 411 }, { 640, 390 }, { 598, 362 }
  };
  
  private.stage_points_1 = {};  --точки маршрута движения шаров
  --private.stage_points_2 = {};  --получаются программным разбитием начальных маршрутов start_stage_points_1 - 3
  --private.stage_points_3 = {};

  private.fire_points = {}; --точки пути летящего шара
  private.distance_between_points = 1.5;--2;  --растояние между точками через которые проходят шары
                                              --не менять денамически!!! участвует только в начальном разбитии маршрута шаров

  private.time_between_points = 0.0166666675;--0.0333333351; --время за которое шар добирается от точки до точки

  private.Room211SplitBallsPoints();

  private.balls_colors    = { "blue", "green", "purple", "red", "yellow" };
  private.fire_ball_color = 1;
  private.balls_diameter  = 50;

  --private.fire_ball_speed_coefficient = 0.0007;
  private.fire_ball_speed_coefficient = 0.000001;

  ObjSet( "obj_room_211_lvl4_back",
  {
    event_mdown    = function () private.Room211FireNewBall() end,
    event_menter   = function () common_impl.SetCursor( CURSOR_HAND ); private.Room211ArrowAnim(); end,
    event_mleave   = function () common_impl.SetCursor( CURSOR_DEFAULT ); private.Room211ArrowStopAnim(); end,
  } );

end;
--*********************************************************************************************************************
function private.Room211Load ()

  --private.Room211StartConditions(); 
  private.state = ng_global.progress[ "ext" ][ "win_room_211_lvl4" ].state;

end;
--*********************************************************************************************************************
function private.Room211Reset ( for_win, for_next_stage )

  if #private.balls == 0 then return; end;

  cmn.Lock( true );

  ObjSet( "tmr_room_211_lvl4_gametimer", { playing = false } );
  ObjSet( "spr_room_211_lvl4_patch",     {     alp = 1     } );
  
  for i = 1, #private.balls, 1 do

    local ball_name = "spr_room_211_lvl4_ball_"..private.balls[i].id;

    ObjAnimate( ball_name, "alp", 0, 0, function () ObjDelete( ball_name ); end, { 0, 0, 1,   0.3, 0, 0 } );
    private.Room211AnimDeleteBalls( ball_name );
    
  end;

  private.balls = {};

  private.state.last_ball_id = 0;
  private.state.stage_balls = 0;
  private.state.stage_del_ball_num = 0;

  private.ball_waiting_flag = {};
  private.ball_insert_flag = 0;

  if ( not for_win ) then
    ObjSet( "tmr_room_211_lvl4_resetskip", { time = 0.35, endtrig = function () cmn.Lock( false ); private.Room211StartGame(); end, playing = true } );
  else
    ObjSet( "tmr_room_211_lvl4_resetskip", { time = 0.35, endtrig = function () cmn.Lock( false ); private.Room211Win(); end, playing = true } );
  end;

end;
--*********************************************************************************************************************
function private.Room211Skip ()

  private.state.stage = #private.stage_win_num + 1;

  private.Room211Reset( true );

end;
--*********************************************************************************************************************
function private.Room211StartConditions ()

  ng_global.progress[ "ext" ][ "win_room_211_lvl4" ].state = {
    stage = 1,                       -- стадия игры (1-3)
    stage_del_ball_num = 0,          -- количество выбитых шариков на текущей стадии
    last_ball_id = 0,                -- номер последнего созданного шарика
    stage_balls = 0,                 -- количество выпущенных шариков на текущей стадии
    loaded_ball_color = 1            -- цвет шарика которым будем стрелять
  };

end;
--*********************************************************************************************************************
function private.Room211DrawScene ()

  ObjSet( "tmr_room_211_lvl4_gametimer", { playing = false } );

  for i = 1, #private.balls, 1 do
    ObjDelete( "spr_room_211_lvl4_ball_"..private.balls[i].id );
  end;

  private.balls = {};

  private.state.last_ball_id = 0;
  private.state.stage_del_ball_num = 0;

  private.ball_waiting_flag = {};
  private.ball_insert_flag = 0;

  ObjSet( "spr_room_211_lvl4_amulet_ball", { 
    res = "assets/levels/levelext/rm_room_211_lvl4/layers/mmg/balls_big/ball_"..private.balls_colors[ private.state.loaded_ball_color ],
  } );

  ObjAnimate( "spr_room_211_lvl4_amulet_ball", "scale_xy", 0, 0, "",
  {
    0.0, 3, 0.0, 0.0,
    0.3, 3, 1.0, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.Room211CheckWin ()

  --if ( private.state.stage_del_ball_num >= private.stage_win_num[ private.state.stage ] ) then
  if ( #private.balls == 1 and private.state.stage_balls == private.stage_win_end[ private.state.stage ]+1 ) then
    --common_impl.PlayAudio( "snd", "assets/levels/level3/mg_fight/audio/aud_hpless" );

    ObjAnimate( "obj_room_211_lvl4_track_"..private.state.stage, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

    private.state.stage = private.state.stage + 1;

    if ( private.state.stage > #private.stage_win_num ) then

      private.state.stage = private.state.stage - 1;

      private.Room211Reset( true );

    else

      private.Room211Reset( false, true );

    end;

  end;

end;
--*********************************************************************************************************************
function private.Room211WinEnd ()

  common_impl.PassingMgWin( "room_211_lvl4" );
  cmn.MiniGameHide( "room_211_lvl4" );
  cmn.SetEventDone( "win_room_211_lvl4" );
  cmn.CallEventHandler( "win_room_211_lvl4" );
  private.see_room_211_lvl4_anim_room_211_2();

end;
--*********************************************************************************************************************
function private.Room211Win ()

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_ball_win_4lvl" );

  local func_end = function ()
     
    local func_end2 = function ()
      
      cmn.Lock( false );
      private.Room211WinEnd();
      
    end;
    
    ObjAnimate( "obj_room_211_lvl4_mmg", "alp", 0, 0, func_end2,
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );
    
  end;

  cmn.Lock( true );

  ObjAnimate( "spr_room_211_lvl4_amulet", "alp", 0, 0, "",
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );
  
  ObjAnimate( "anm_room_211_lvl4_light", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );
    
  ObjAnimate( "obj_room_211_lvl4_tracks", "alp", 0, 0, func_end,
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

end;
--*********************************************************************************************************************
function private.Room211FireNewBall ()

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_ball1_4lvl" );

  if private.fire_flag or private.fly_ball_flag or private.insert_flag then

    return;

  end;

  private.fire_flag = true;

  local cursor_pos = GetZoomCursorPos();

  local ball_start_pos_x = 509;
  local ball_start_pos_y = 629;
  local ball_start_pos = { ball_start_pos_x, ball_start_pos_y };

  local ball_fly_border = { --границы полета шара (левая, верхняя, правая)
    {{ -172 - private.balls_diameter*2, 0 - private.balls_diameter*2 }, { -171 - private.balls_diameter*2, 768 + private.balls_diameter*2 }},
    {{ -171 - private.balls_diameter*2, 0 - private.balls_diameter*2 }, { 1195 + private.balls_diameter*2,  -1 - private.balls_diameter*2 }},
    {{ 1195 + private.balls_diameter*2, 0 - private.balls_diameter*2 }, { 1196 + private.balls_diameter*2, 768 + private.balls_diameter*2 }}
  };

  local ball_end_pos;
  local len;
  local new_len;

  local cycle_step_start = 1;
  local cycle_step_num   = 2;
  if ( cursor_pos[1] > ball_start_pos_x ) then  --стрельнули влево  сравниваем с левой  и верхней границе
    cycle_step_start = 2;                       --стрельнули вправо сравниваем с правой и верхней границе
    cycle_step_num   = 3;
  end;

  for i = cycle_step_start, cycle_step_num, 1 do

    ball_end_pos = private.Room211FindLineIntersection( cursor_pos, ball_start_pos, ball_fly_border[i][1], ball_fly_border[i][2] );
    new_len = private.Room211FindSegmentLength( ball_start_pos, ball_end_pos );

    if ( not len ) or ( new_len < len ) then

      len = new_len;
      private.fire_points.ball_start_pos = ball_start_pos;
      private.fire_points.ball_end_pos = ball_end_pos;
      private.fire_points.len = len;

    end;

  end;

  ObjSet( "spr_room_211_lvl4_amulet_ball", { scale_x = 0.0, scale_y = 0.0 } );

  private.Room211FireNewBallBeg();

  --common_impl.PlayAudio( "snd", "assets/levels/level3/mg_fight/audio/aud_shot" );

end;
--*********************************************************************************************************************
function private.Room211CheckNewBall ()
    
  for i = 1,#private.balls do
 
    private.color_flag = true;  
    
    for j = 1,#private.balls do
       
      if private.balls[ i ][ "color" ] == private.balls_color[ j ] then 
        
         private.color_flag = false;  
         
      end;

    end;
    
    if private.color_flag then 
      
      table.insert( private.balls_color, private.balls[ i ][ "color" ] );     
      
    end;   
    
  end;

  local idx = math.random( 1, #private.balls_color );
  
  return private.balls_color[ idx ];
  
end;
--*********************************************************************************************************************
function private.Room211FireNewBallBeg ()

  private.fire_flag = false;
  private.fly_ball_flag = true;

  private.fire_ball_color = private.state.loaded_ball_color;
  private.balls_color = {};
  private.state.loaded_ball_color = private.Room211CheckNewBall();
  
  local ball_color = private.fire_ball_color;
  local ball_name = "spr_room_211_lvl4_flying_ball";

  ObjCreate( ball_name, "spr" );
  ObjSet( ball_name, {
    res = "assets/levels/levelext/rm_room_211_lvl4/layers/mmg/balls_big/ball_"..private.balls_colors[ ball_color ],
    pos_x = private.fire_points.ball_start_pos[1],
    pos_y = private.fire_points.ball_start_pos[2]
  } );
  ObjAttach( ball_name, "obj_room_211_lvl4_fireballshub" );

  local tme = private.fire_ball_speed_coefficient * private.fire_points.len + 1.5;
  ObjAnimate( ball_name, "pos_xy", 0, 0, private.Room211FireNewBallEnd, { 
    0,   0, private.fire_points.ball_start_pos[1], private.fire_points.ball_start_pos[2],
    tme, 0, private.fire_points.ball_end_pos[1],   private.fire_points.ball_end_pos[2] 
  } );

  ObjSet( "spr_room_211_lvl4_amulet_ball", { 
    res = "assets/levels/levelext/rm_room_211_lvl4/layers/mmg/balls_big/ball_"..private.balls_colors[ private.state.loaded_ball_color ],
  } );

  ObjAnimate( "spr_room_211_lvl4_amulet_ball", "scale_xy", 0, 0, "",
  {
    0.0, 3, 0.0, 0.0,
    0.3, 3, 1.0, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.Room211FireNewBallEnd ()

  private.fly_ball_flag = false;
  ObjStopAnimate( "spr_room_211_lvl4_flying_ball", "pos_xy" );
  ObjDelete( "spr_room_211_lvl4_flying_ball" );

end;
--*********************************************************************************************************************
function private.Room211StartGame ()
  
  private.Room211CreateBall();

  ObjSet( "tmr_room_211_lvl4_gametimer", { time = private.time_between_points, endtrig = private.Room211MoveBalls, playing = true } );

  ObjAnimate( "obj_room_211_lvl4_track_"..private.state.stage, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

end;
--*********************************************************************************************************************
function private.Room211CreateBall ( ball_color, pos_x, pos_y, pos, point )

    private.state.last_ball_id = private.state.last_ball_id + 1;
    
    if not ( ball_color ) then
      
      private.state.stage_balls = private.state.stage_balls + 1;
      
    end;
    
    ball_color = ball_color or math.random( 1, #private.balls_colors );
  
    local ball_num = private.state.last_ball_id;
    local ball_name = "spr_room_211_lvl4_ball_"..ball_num;
    local ball_pos_x = pos_x or private[ "stage_points_"..private.state.stage ][1][1];
    local ball_pos_y = pos_y or private[ "stage_points_"..private.state.stage ][1][2];
    local ball_alp_scale = 0;

    if ( pos ) then
      ball_alp_scale = 1;
      table.insert( private.balls, pos, { id = ball_num, color = ball_color, pos = point, move = true } );
    else
      ball_alp_scale = 0;
      table.insert( private.balls,      { id = ball_num, color = ball_color, pos = 1, move = true } );
    end;

    ObjCreate( ball_name, "spr" );
    ObjSet( ball_name, {
      res = "assets/levels/levelext/rm_room_211_lvl4/layers/mmg/balls/ball_"..private.balls_colors[ ball_color ],
      pos_x = ball_pos_x,
      pos_y = ball_pos_y,
      scale_x = ball_alp_scale,
      scale_y = ball_alp_scale,
      alp = ball_alp_scale
    } );

    ObjAttach( ball_name, "obj_room_211_lvl4_ballshub" );

    if ( not pos ) then
      ObjAnimate( ball_name, "alp",      0, 0, "", { 0, 0, 0,       0.3, 0, 1 } );
      ObjAnimate( ball_name, "scale_xy", 0, 0, "", { 0, 0, 0, 0,    0.3, 0, 1, 1 } );
    end;
    
end;
--*********************************************************************************************************************
function private.Room211InsertBalls ( num, fire_ball_pos_x, fire_ball_pos_y )

  private.insert_flag = true;

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_ball4_4lvl" );

  local stage_points = private[ "stage_points_"..private.state.stage ];

  private.ball_insert_flag = num;

  private.Room211FireNewBallEnd();

  private.Room211CreateBall( 
    private.fire_ball_color, 
    fire_ball_pos_x, 
    fire_ball_pos_y, 
    num + 1,
    private.balls[ num ].pos
  );

  local last_stoping_ball = #private.balls;  --номер последнего останавливаемого шара
  local first_moving_ball = 1;  --номер первого смещаемого шара

  for i = #private.ball_waiting_flag, 1, -1  do
    if ( private.ball_waiting_flag[i] >= num ) then
      private.ball_waiting_flag[i] = private.ball_waiting_flag[i] + 1;
      last_stoping_ball = private.ball_waiting_flag[i];
    end;
  end;

  for i = 1, #private.ball_waiting_flag, 1  do
    if ( private.ball_waiting_flag[i] <= num ) then
      first_moving_ball = private.ball_waiting_flag[i] + 1;
    end;
  end;

  for i = num + 1, last_stoping_ball, 1 do
    private.balls[i].move = false;
  end;
 
  for i = first_moving_ball, num, 1 do
    private.balls[i].move = true;
  end;

  local fire_ball_end_pos_x = stage_points[ private.balls[num].pos ][1];
  local fire_ball_end_pos_y = stage_points[ private.balls[num].pos ][2];

  ObjAnimate( "spr_room_211_lvl4_ball_"..private.state.last_ball_id, "pos_xy", 0, 0,
  function ()

    private.insert_flag = false;

  end, 
  { 0,   0, fire_ball_pos_x,     fire_ball_pos_y,    
    0.2, 0, fire_ball_end_pos_x, fire_ball_end_pos_y
  } );

end;
--*********************************************************************************************************************
function private.Room211InsertBallsEnd ()

  local ball_waiting_before_ball_insert = false;

  for i = 1, #private.ball_waiting_flag, 1 do
    if ( private.ball_waiting_flag[i] >= private.ball_insert_flag + 1 ) then
      ball_waiting_before_ball_insert = true;
      break;
    end;
  end;

  if ( not ball_waiting_before_ball_insert ) then

    for i = private.ball_insert_flag + 1, #private.balls, 1 do
      private.balls[i].move = true;
    end;

  else

    for i = 1, private.ball_insert_flag, 1 do
      private.balls[i].move = false;
    end;

  end;

  local check_ball_num = private.ball_insert_flag + 1;

  private.ball_insert_flag = 0;

  private.Room211CheckSameBalls( check_ball_num, private.balls[ check_ball_num ].color );

end;
--*********************************************************************************************************************
function private.Room211CheckSameBalls ( check_ball_num, check_color, need_launch_befor_delete_flag )

  check_color = check_color or private.fire_ball_color;

  local same_color_balls = {};  --сщитаем количество одинаковых шариков

  local left_search_border  = #private.balls; --границы поиска
  local right_search_border = 1;

  ----------------------определяем границы поиска

  if ( check_ball_num ~= #private.balls ) then

    for i = 1, #private.ball_waiting_flag, 1 do
      if ( private.ball_waiting_flag[i] >= check_ball_num ) then
        left_search_border = private.ball_waiting_flag[i];
        break;
      end;
    end;

  end;

  if ( check_ball_num ~= 1 ) then

    for i = #private.ball_waiting_flag, 1, -1 do
      if ( private.ball_waiting_flag[i] < check_ball_num ) then
        right_search_border = private.ball_waiting_flag[i] + 1;
        break;
      end;
    end;

  end;

  -------------------------сщитаем количество одинаковых шаров

  for k = check_ball_num, right_search_border, -1 do
    if ( check_color == private.balls[k].color ) then
      table.insert( same_color_balls, k );
    else
      break;
    end;
  end;

  for k = check_ball_num+1, left_search_border, 1 do
    if ( check_color == private.balls[k].color ) then
      table.insert( same_color_balls, k );
    else
      break;
    end;
  end;

  if ( #same_color_balls >= 3 ) then

    if ( private.ball_insert_flag ~= 0 ) then
      for i = 1, #same_color_balls, 1 do
        if ( same_color_balls[i] == private.ball_insert_flag + 1 ) then
          need_launch_befor_delete_flag = true;
          break;
        end;
      end;
    end;

    if ( need_launch_befor_delete_flag ) then

      for i = check_ball_num, #private.balls, 1 do
        private.balls[i].move = true;
      end;

    end;

    private.Room211DeleteBalls( same_color_balls );

  end;

end;
--*******************************************************************************************************************
function private.Room211AnimDeleteBalls( curBall )
  
  local spr  = curBall;
  local ghost = spr.."_ghost";
  local curRes = ObjGet( spr );
  
  if ObjGet( spr ) then  

    ObjCreate( ghost, "spr" );    
    ObjAttach( ghost, curBall );   
    ObjSet( ghost,
    {
      alp = 0.7,
      input = false,
      res = curRes.res,
      pos_z = 1,
      scale_x = 1.0, 
      scale_y = 1.0,
    } );
    
    ObjAnimate( ghost, "scale_xy",0,0, "",
    { 0, 0, 1, 1, 
      0.3, 0, 1.7, 1.7, 
    } );  
    
  end;

end;
--*********************************************************************************************************************
function private.Room211DeleteBalls ( same_color_balls )

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_mg_fight_sfx" );

  private.state.stage_del_ball_num = private.state.stage_del_ball_num + #same_color_balls;

  -----------------

  local stage_points = private[ "stage_points_"..private.state.stage ];

  local first_stoping_ball = 1; --первый останавливаемый шар, после образования дырки

  table.sort( same_color_balls );

  local anm_pos;
  local anm_pos_x;
  local anm_pos_y;
  local anm_color;

  for d = 1, #same_color_balls, 1 do

    local delete_ball_name = "spr_room_211_lvl4_ball_"..private.balls[ same_color_balls[d] ].id;
    ObjAnimate( delete_ball_name, "alp", 0, 0, function () ObjDelete( delete_ball_name ); end, { 0, 0, 1,   0.3, 0, 0 } );
    private.Room211AnimDeleteBalls( delete_ball_name );
    
  end;

  for d = #same_color_balls, 1, -1 do
    table.remove( private.balls, same_color_balls[d] );
  end;

  local need_to_insert_end_ball = false; --флаг надобности завершить вставку шара после удаления

  -----------------проверка на процесс вставки
  if ( private.ball_insert_flag ~= 0 ) then

    local ball_insert_num = private.ball_insert_flag + 1;

    if  ( ball_insert_num >= same_color_balls[1] ) 
    and ( ball_insert_num <= same_color_balls[#same_color_balls] ) then

      first_stoping_ball = 1;
      private.ball_insert_flag = 0;

    elseif ( ball_insert_num < same_color_balls[1] ) then

      first_stoping_ball = ball_insert_num;

    elseif ( ball_insert_num > same_color_balls[ #same_color_balls ] ) then

      private.ball_insert_flag = private.ball_insert_flag - #same_color_balls;

      if ( private.ball_insert_flag > 0 ) then
      else
        need_to_insert_end_ball = true;
      end;

    end;

  end;

  local new_ball_waiting = same_color_balls[1] - 1;

  ------------------------ изменение флагов ожидания

  for i = #private.ball_waiting_flag, 1, -1  do

    if ( private.ball_waiting_flag[i] > same_color_balls[ #same_color_balls ] ) then

      private.ball_waiting_flag[i] = private.ball_waiting_flag[i] - #same_color_balls;

    elseif ( private.ball_waiting_flag[i] >= same_color_balls[1] ) 
    and ( private.ball_waiting_flag[i] <= same_color_balls[#same_color_balls] ) then

      table.remove( private.ball_waiting_flag, i );

    else

      if ( new_ball_waiting == private.ball_waiting_flag[i] ) then
        new_ball_waiting = 0;
      end;

      break;

    end;
  end;

  --------------------- добавление новых флагов ожидания
  
  if new_ball_waiting > 0 and ( new_ball_waiting ~= #private.balls ) then

    table.insert( private.ball_waiting_flag, new_ball_waiting );
    table.sort( private.ball_waiting_flag );

    for i = first_stoping_ball, new_ball_waiting, 1 do --останавливаем шары, идущие перед оброзовавшейся дыркой
      private.balls[i].move = false;
    end;

  end;

  if ( need_to_insert_end_ball ) then

    private.Room211InsertBallsEnd();

  end;
  
end;
--*********************************************************************************************************************
function private.Room211MoveBalls ()

  local stage_points = private[ "stage_points_"..private.state.stage ];

  if ( private.balls[1].pos == #stage_points ) then

    local func_end = function ()

      ObjSet( "anm_room_211_lvl4_guardian_lose",   { pos_z = -5 } );
      private.Room211Reset();
      
    end;

    ObjSet( "anm_room_211_lvl4_guardian_lose",   { pos_z = 14 } );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_ball2_4lvl" );
    AnimPlay( "anm_room_211_lvl4_guardian_lose", "mmg_loss", func_end );
    for i = 1, #private.balls, 1 do

      local ball_name = "spr_room_211_lvl4_ball_"..private.balls[i].id;
      private.Room211AnimDeleteBalls( ball_name );
      ObjAnimate( ball_name, "alp", 0, 0, function () ObjDelete( ball_name ); end, { 0, 0, 1,   0.3, 0, 0 } );
        
    end;
    return;
    
  end;

  local ball_num;
  local ball_pos;
  local ball_new_pos_x;
  local ball_new_pos_y;

  local ball_old_pos_x;
  local ball_old_pos_y;

  -------------------------

  if ( #private.ball_waiting_flag > 0 ) then  --есть ожидающие шары

    for check_waiting_ball_num = #private.ball_waiting_flag, 1, -1 do

      local num_waiting_balls = private.ball_waiting_flag[ check_waiting_ball_num ]; --номер шара который стоит
      local num_move_balls = num_waiting_balls + 1; --номер шара после ждущего

      if ( num_move_balls <= #private.balls ) then  --проверка на существование шара

        local movebal_pos = private.balls[ num_move_balls ].pos;
        local waiting_ball_pos = private.balls[ num_waiting_balls ].pos;
        local distance_moveball_waiting_ball = private.Room211FindSegmentLength( stage_points[ movebal_pos ], stage_points[ waiting_ball_pos ] );

        if ( distance_moveball_waiting_ball <= private.balls_diameter + private.distance_between_points ) then

          table.remove( private.ball_waiting_flag, check_waiting_ball_num );

          local num_first_launch_ball = 1; --первый запускаемый шар

          for i = #private.ball_waiting_flag, 1, -1 do    --ищем дыры спереди
            if ( private.ball_waiting_flag[i] < num_waiting_balls ) then
              num_first_launch_ball = private.ball_waiting_flag[i] + 1;
              break;
            end;
          end;


          local need_launch_befor_delete_flag = false;  --флаг надобности запустить остановленные шары перед удалением

          if ( private.ball_insert_flag ~= 0 )
          and ( private.ball_insert_flag + 1 >= num_first_launch_ball )
          and ( private.ball_insert_flag + 1 <= num_waiting_balls ) then

            for i = num_move_balls, #private.balls, 1 do
              private.balls[i].move = false;
            end;

            need_launch_befor_delete_flag = true;

          else

            for i = num_first_launch_ball, num_waiting_balls, 1 do
              private.balls[i].move = true;

            end;

          end;

          if ( private.balls[ num_move_balls ].color == private.balls[ num_waiting_balls ].color ) then
            private.Room211CheckSameBalls( num_move_balls, private.balls[ num_move_balls ].color, need_launch_befor_delete_flag );
          end;

        end;

      end;

    end;

  end;

  -------------------------

  if ( private.ball_insert_flag ~= 0 ) then

    local insert_bal_pos = private.balls[ private.ball_insert_flag + 1 ].pos;
    local move_ball_pos  = private.balls[ private.ball_insert_flag ].pos;
    local distance_insert_ball_move_ball = private.Room211FindSegmentLength( stage_points[ insert_bal_pos ], stage_points[ move_ball_pos ] );

    if ( distance_insert_ball_move_ball >= private.balls_diameter ) then --+ private.distance_between_points

      private.Room211InsertBallsEnd();

    end;

  end;

  -------------------------
  
  for i = 1, #private.balls, 1 do  --двигаем эти шары
    
    if ( private.balls[i].move ) then

      ball_pos = private.balls[i].pos;
      ball_old_pos_x = stage_points[ ball_pos ][1];
      ball_old_pos_y = stage_points[ ball_pos ][2];

      private.balls[i].pos = private.balls[i].pos + 1;

      ball_num = private.balls[i].id;
      ball_pos = private.balls[i].pos;
      ball_new_pos_x = stage_points[ ball_pos ][1];
      ball_new_pos_y = stage_points[ ball_pos ][2];

      ObjAnimate( "spr_room_211_lvl4_ball_"..ball_num, "pos_xy", 0, 0, "", 
      { 0,                           0, ball_old_pos_x, ball_old_pos_y,
        private.time_between_points, 0, ball_new_pos_x, ball_new_pos_y
      } );

    end;

  end;

  -------------------------

  if ( private.fly_ball_flag ) then   --проверки на поподание выстреленного шара

    local fire_ball_name = "spr_room_211_lvl4_flying_ball";
    local fire_ball_pos_x = ObjGet( fire_ball_name ).pos_x;
    local fire_ball_pos_y = ObjGet( fire_ball_name ).pos_y;
    local fire_ball_pos = { fire_ball_pos_x, fire_ball_pos_y };
    local len;

    for i = 1, #private.balls, 1 do

      len = private.Room211FindSegmentLength( fire_ball_pos, stage_points[ private.balls[i].pos ] );

      if ( len < private.balls_diameter ) then

          private.Room211InsertBalls( i, fire_ball_pos_x, fire_ball_pos_y );
          
        break;

      end;

    end;

  end;

  ----------------------------

  if ( #private.balls == 0) then  --создание новых шаров

    private.Room211CreateBall();
    
  else

    local last_ball_pos = private.balls[ #private.balls ].pos;
    local distance_from_start_to_last_ball = private.Room211FindSegmentLength( stage_points[1], stage_points[ last_ball_pos ] );

    if ( distance_from_start_to_last_ball >= private.balls_diameter ) then
      
      if private.state.stage_balls < private.stage_win_end[ private.state.stage ] then
      
        private.Room211CreateBall();
        
      else
        
        ObjSet( "spr_room_211_lvl4_patch", { alp = 0 } );
        
      end;
      
    end;

  end;

  ----------------------------
  ObjSet( "tmr_room_211_lvl4_gametimer", { time = private.time_between_points, endtrig = private.Room211MoveBalls, playing = true } );

  private.Room211CheckWin();

end;
--*********************************************************************************************************************
function private.Room211FindSegmentPoint ( point_a, point_b, delta )
  --нахождения координат точки на отрезке по заданному отношению
  --( {x1,y1}, {x2,y2}, num )

  local pos_x = ( point_a[1] + ( delta * point_b[1] ) ) / ( 1 + delta );
  local pos_y = ( point_a[2] + ( delta * point_b[2] ) ) / ( 1 + delta );

  return { pos_x, pos_y };

end;
--*********************************************************************************************************************
function private.Room211FindSegmentLength ( point_a, point_b )
  --нахождение растояния от координаты А до Б ( {x1,y1}, {x2,y2} )

  local len = ( ( point_b[1] - point_a[1] )^2 + ( point_b[2] - point_a[2] )^2 )^0.5;

  return len;

end;
--*********************************************************************************************************************
function private.Room211FindLineIntersection ( point_a1, point_b1, point_a2, point_b2 )
  --нахождения точки пересечения прямых
  --входные параметры - 2 точки каждой прямой {x,y}
  --ОСТОРОЖНО!!! упращенная формула, может быть деление на нуль, при чисто горизонтальных/вертикальных линиях

  local x1 = point_a1[1]; local y1 = point_a1[2];
  local x2 = point_b1[1]; local y2 = point_b1[2];

  local x3 = point_a2[1]; local y3 = point_a2[2];
  local x4 = point_b2[1]; local y4 = point_b2[2];

  local x = ( ((x1*y2-x2*y1)*(x4-x3)-(x3*y4-x4*y3)*(x2-x1))/((y1-y2)*(x4-x3)-(y3-y4)*(x2-x1)) );
  local y = ( ((y3-y4)*x-(x3*y4-x4*y3))/(x4-x3) );

  x = -x;

  return { x, y };

end;
--*********************************************************************************************************************
function private.Room211SplitBallsPoints ()

  local start_points;
  local seg_len;
  local point_a;
  local point_b;
  local points_in_seg;
  local delta;
  local new_point;

  local seg_a_to_new;
  local seg_new_to_b;

  for stage = 1, #private.stage_win_num, 1 do

    start_points = private[ "start_stage_points_"..stage ];
    point_a = start_points[1];

    table.insert( private[ "stage_points_"..stage ], point_a );

    for i = 1, #start_points - 1, 1 do

      point_b = start_points[i+1];
      seg_len = private.Room211FindSegmentLength( point_a, point_b );
      points_in_seg = math.floor( seg_len / private.distance_between_points );

      for j = 1, points_in_seg, 1 do

        seg_a_to_new = private.distance_between_points * j;
        seg_new_to_b = seg_len - ( private.distance_between_points * j );

        if     ( seg_a_to_new == 0 ) then --попали на начальную точку
          new_point = point_a;
        elseif ( seg_new_to_b == 0 ) then --попали на канечную точку
          new_point = point_b;
        else
          delta = seg_a_to_new / seg_new_to_b;
          new_point = private.Room211FindSegmentPoint( point_a, point_b, delta );
        end;

        table.insert( private[ "stage_points_"..stage ], new_point );

      end;

      point_a = new_point;

    end;

  end;

end;
--*********************************************************************************************************************
function private.Room211ArrowAnim ()

  local params = ObjGet( "spr_room_211_lvl4_amulet" );
  local x1 = params.pos_x;
  local y1 = params.pos_y;

  local cursor_pos = GetZoomCursorPos();
  local x2 = cursor_pos[ 1 ];
  local y2 = cursor_pos[ 2 ];

  local ang = private.Room211ArrowAng( x1,y1,x2,y2 ) - 1.57;

  ObjSet( "spr_room_211_lvl4_amulet_arrow", { ang = ang } );
  ObjSet( "tmr_room_211_lvl4_arrow",
  {
    playing = 1,
    time = 0.01,
    endtrig = function ()

      private.Room211ArrowAnim();

    end
  } );
  
  for i = 1,#private.balls_colors do
    ObjSet( "spr_room_211_lvl4_amulet_light_symbol_"..private.balls_colors[ i ], { alp = 0 } );
  end;
  
  ObjSet( "spr_room_211_lvl4_amulet_light_symbol_"..private.balls_colors[ private.state.loaded_ball_color ], { alp = 1 } );
  
end;
--*********************************************************************************************************************
function private.Room211ArrowStopAnim ()

  ObjSet( "tmr_room_211_lvl4_arrow", { playing = 0 } );

end;
--*********************************************************************************************************************
function private.Room211ArrowAng( x1,y1,x2,y2 )

  local len = ( (x1-x2)^2 +(y1-y2)^2 )^0.5
  y1 = -y1; --переворот для игровой системы координат
  y2 = -y2; --переворот для игровой системы координат

  if ( len == 0 ) then return 0,0 end; --исключение

  local k = ( y1 - y2 ) / len;
  local a = math.abs( math.asin( k ) );

  if ( x2 >= x1 and y2 <= y1 ) then

    a = math.pi*2 - a;
    return a,len;

  elseif ( x2 >= x1 and y2 >= y1 ) then

    return a,len;

  elseif ( x2 <= x1 and y2 <= y1 ) then

    a = math.pi + a;
    return a,len;

  elseif ( x2 <= x1 and y2 >= y1 ) then

    a = math.pi - a;
    return a,len;

  end;

end
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
end;
--------------------------------------------------------------------------------------------
function private.see_room_211_lvl4_anim_room_211_1 ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_room_211_lvl4_anim_room_211_1" );
    cmn.CallEventHandler( "see_room_211_lvl4_anim_room_211_1" );

    common_impl.ShowBbt( 'bbt_room_211_lvl4_anim_room_211_1' );
    
    ObjMultiSet({ 
      { "anm_room_211_lvl4_room_211_1_statics", { frame = 0 }},
    });

    common_impl.PlayAudio( "env", "levelext/env/aud_anim1_env", 1, "", 0 );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_anim1_4lvl",     0, "", 0 );
  common_impl.PlayAudio( "voc", "levelext/voc/aud_anim1_4lvl_voc", 0, "", 0 );
  common_impl.ShowBbt( 'sub_room_211_lvl4_anim_room_211_1' );

  AnimPlay( "anm_room_211_lvl4_room_211_1", "211_1", func_end );
  ObjAnimate( private.room_objname, "pos_xy", 0, 0, "", {
    0,   0,  0,    0,
    0.2, 1, -140, -64,
    1.0, 3, -141, -63,
    1.1, 3, -140, -64,
    1.4, 3,  0,    0,
  } );
  
  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "", {
    0,   0, 1,   1,
    0.2, 1, 1.3, 1.3,
    1,   3, 1.3, 1.3,
    1.4, 3, 1,   1,
  } );
    
end;
--------------------------------------------------------------------------------------------
function private.see_room_211_lvl4_anim_room_211_2 ()

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "see_room_211_lvl4_anim_room_211_2" );
    cmn.CallEventHandler( "see_room_211_lvl4_anim_room_211_2" );

    common_impl.ShowBbt( 'bbt_room_211_lvl4_anim_room_211_2' );
    ObjMultiSet({ 
      { "obj_room_211_lvl4_az",               {   alp = 1 }},
      { "spr_room_211_lvl4_chandelier_lever", {   alp = 1 }},
      { "anm_room_211_lvl4_sarah",            { frame = 0 }},
    });
  
    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "lvl4_bring_girl_life" );

  end;
  
  cmn.Lock( true );
  common_impl.StopAudio( "env", "levelext/env/aud_anim1_env", 0.2 );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_", 0, "", 0 );
  
  ObjMultiSet({ 
    { "obj_room_211_lvl4_az", { alp = 0 }},
  });
    
  AnimPlay( "anm_room_211_lvl4_room_211_2", "211_2", func_end );
  
end;
--*********************************************************************************************************************
function private.see_room_211_lvl4_outro_lvl4 ()
  
  local func_end = function( skip )
    
    if skip then
  
      common_impl.StopAudio( "voc", "levelext/voc/aud_outro_lvl4_voc",  0.2 );
      common_impl.StopAudio( "sfx", "levelext/sfx/aud_outro_lvl4",      0.2 );
      
    end;

    cmn.SetEventDone( "see_room_211_lvl4_outro_lvl4" );
    cmn.CallEventHandler( "see_room_211_lvl4_outro_lvl4" );
    
    cmn.GotoRoom( "rm_credits" );
    
  end;

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_outro_lvl4", 0, "", 0 );
  common_impl.PlayAudio( "voc", "levelext/voc/aud_outro_lvl4_voc",  0, "", 0 );

  common_impl.PlayAudio( "mus_env", "mus_env/aud_lovestory_theme_mus",  0, "", 0 );
  ObjSet( "tmr_room_211_lvl4_time", { playing = true, time = 150, endtrig = function() cmn.PlayMusEnv() end } );


  cmn.PlayDialogVideo( "vid_room_211_lvl4_outro_lvl4", func_end );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_room_211_lvl4 ()

  if not ( cmn.IsEventDone( "opn_room_211_lvl4" ) ) then

    cmn.SetEventDone( "opn_room_211_lvl4" );
    common_impl.ShowBbt( 'bbt_room_211_lvl4_opn_room_211_lvl4' );
  end;
  cmn.CallEventHandler( "opn_room_211_lvl4" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.BedLvl4UseSaraMedallion ()

  common_impl.ShowBbt( "bbt_bed_lvl4_use_sara_medallion" );
  
  local obj = "spr_bed_lvl4_hatch";

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  local func_end = function ()
    
    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_metal_door", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,1, func_end, { 0,0,0, time/4,0,dx, 3/4*time,0,-dx, time,0,0 });  
  ObjAnimate( obj, "pos_y",0,1, "", { 0,0,0, time/4,0,dy, 3/4*time,0,-dy, time,0,0 });  
  
end;

