-- name=rm_weaponry
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_weaponry";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_chest", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "obj_chest_clk_silver_key",  { event_mdown = private.clk_silver_key }},

    { "spr_weaponry_cross_2_lvl4", { event_mdown = private.get_cross_2_lvl4 }},
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_weaponry = function ()
  
    table_multiset = {};
    local res_sparkle_area = "assets/levels/common/fx/sparkle_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      res_sparkle_area = "";
    end;
    local visible_sparkle_ho = "assets/levels/common/fx/ho_effect";  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = "";
    end;
    local gates = 
    {
      "gho_weaponry_in_chest",
      "gmg_weaponry_minigame_3",
      "gzz_weaponry_chest"
    };
    for i = 1, #gates do
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then
      table.insert( table_multiset, { name, { res = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { res = res_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_chest",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, res_sparkle_area );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_weaponry", update_game_mode_weaponry, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_weaponry = function ()

  local effects_table = 
  {
    "anm_weaponry_all" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_weaponry", update_performance_mode_weaponry, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_weaponry () end;
  --------------------------------------------------------------------------------------------
  local opn_weaponry_map = function ()

    common_impl.VisitMapRoom( "weaponry" );

  end;
  cmn.AddSubscriber( "opn_weaponry", opn_weaponry_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_cross_2_lvl4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cross_2_lvl4" ] = {
    type = "get",
    get_obj = "spr_weaponry_cross_2_lvl4",
    room = private.room_objname,
  };
  
  local get_cross_2_lvl4_inv = function ()
  
    interface.InventoryItemAdd( "inv_cross_2_lvl4", "spr_weaponry_cross_2_lvl4" );
  
  end;
  
  local get_cross_2_lvl4_closezz = function ()
  
    ObjDelete( "gfx_weaponry_cross_2_lvl4" );
  
  end;
  
  cmn.AddSubscriber( "get_cross_2_lvl4", get_cross_2_lvl4_inv );
  cmn.AddSubscriber( "get_cross_2_lvl4", get_cross_2_lvl4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_silver_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_silver_key" ] = {
    type = "use",
    inv_obj = "inv_silver_key",
    use_place = "obj_chest_use_silver_key",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_weaponry_chest"
  };
  local use_silver_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_silver_key" );
  
  end;
  local use_silver_key_beg = function ()
  
    ObjDelete( "obj_chest_use_silver_key" );
  
  end;
  local use_silver_key_end = function ()
  
    ObjDelete( "anm_chest_key" );  
    ObjMultiSet( { 
      { "obj_chest_clk_silver_key", { input = true, visible = true, active = true } },
      { "spr_chest_key_2",          {   alp = 1                                   } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_silver_key", use_silver_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_silver_key", use_silver_key_inv );
  cmn.AddSubscriber( "use_silver_key", use_silver_key_end, private.room_objname );
  cmn.AddSubscriber( "use_silver_key_inv", use_silver_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_silver_key_beg", use_silver_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_silver_key_end", use_silver_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_twin_gun_with_blank_ammo () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_twin_gun_with_blank_ammo" ] = {
    type = "use",
    inv_obj = "inv_twin_gun_with_blank_ammo",
    use_place = "obj_weaponry_use_twin_gun_with_blank_ammo",
    room = private.room_objname,
  };
  local use_twin_gun_with_blank_ammo_inv = function ()
  
    interface.InventoryItemRemove( "inv_twin_gun_with_blank_ammo" );
  
  end;
  local use_twin_gun_with_blank_ammo_beg = function ()
  
    ObjDelete( "obj_weaponry_use_twin_gun_with_blank_ammo" );
    ObjDelete( "anm_weaponry_bandit_static" );
  
  end;
  local use_twin_gun_with_blank_ammo_end = function ()
  
    ObjDelete( "anm_weaponry_bandit_shot" );
    ObjSet( "spr_weaponry_cross_2_lvl4", { input = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_twin_gun_with_blank_ammo", use_twin_gun_with_blank_ammo_beg, private.room_objname );
  cmn.AddSubscriber( "use_twin_gun_with_blank_ammo", use_twin_gun_with_blank_ammo_inv );
  cmn.AddSubscriber( "use_twin_gun_with_blank_ammo", use_twin_gun_with_blank_ammo_end, private.room_objname );
  cmn.AddSubscriber( "use_twin_gun_with_blank_ammo_inv", use_twin_gun_with_blank_ammo_inv, private.room_objname );
  cmn.AddSubscriber( "use_twin_gun_with_blank_ammo_beg", use_twin_gun_with_blank_ammo_beg, private.room_objname );
  cmn.AddSubscriber( "use_twin_gun_with_blank_ammo_end", use_twin_gun_with_blank_ammo_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_recipe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_recipe" ] = {
    type = "use",
    inv_obj = "inv_recipe",
    use_place = "obj_weaponry_use_recipe",
    room = private.room_objname,
  };
  local use_recipe_inv = function ()
  
    interface.InventoryItemRemove( "inv_recipe" );
  
  end;
  local use_recipe_beg = function ()
  
    ObjDelete( "obj_weaponry_use_recipe" );
  
  end;
  local use_recipe_end = function ()
  
    ObjSet( "gmg_weaponry_minigame_3", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_recipe", use_recipe_beg, private.room_objname );
  cmn.AddSubscriber( "use_recipe", use_recipe_inv );
  cmn.AddSubscriber( "use_recipe", use_recipe_end, private.room_objname );
  cmn.AddSubscriber( "use_recipe_inv", use_recipe_inv, private.room_objname );
  cmn.AddSubscriber( "use_recipe_beg", use_recipe_beg, private.room_objname );
  cmn.AddSubscriber( "use_recipe_end", use_recipe_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_silver_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_silver_key" ] = {
    type = "click",
    use_place = "obj_chest_clk_silver_key",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_weaponry_chest"
  };
  
  local clk_silver_key_beg = function ()

    ObjDelete( "obj_chest_clk_silver_key" );
  
  end;
  local clk_silver_key_end = function ()
    
    ObjMultiSet( { 
      { "gho_weaponry_in_chest", { input = true, visible = true, active = true } },
      { "spr_chest_key_1",       {   alp = 1                                   } },
      { "spr_weaponry_zz_chest_ho", {    alp = 1                               } },
      { "anm_weaponry_zz_chest_ho", { active = 1                               } },
      
    } );
    ObjDelete( "spr_chest_key_2"    );
    ObjDelete( "anm_chest_key"      );
    ObjDelete( "gzz_weaponry_chest" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_silver_key",     clk_silver_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_silver_key",     clk_silver_key_end, private.room_objname );
  cmn.AddSubscriber( "clk_silver_key_beg", clk_silver_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_silver_key_end", clk_silver_key_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_weaponry();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "levelext/env/aud_weaponry_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()
  common_impl.StopAudio( "env", "levelext/env/aud_weaponry_env", 0.5 );
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
function public.use_silver_key ()

  local item = "inv_silver_key";

  if ( cmn.ApplyObj( item, "gzz_weaponry_chest" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chest" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_chest_use_silver_key" ) ) then

    cmn.CallEventHandler( "use_silver_key_inv" );
    cmn.CallEventHandler( "use_silver_key_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_silver_key" );
      cmn.CallEventHandler( "use_silver_key_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_key_chest_4lvl", 0, "", 0 );

    AnimPlay( "anm_chest_key", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_twin_gun_with_blank_ammo ()

  local item = "inv_twin_gun_with_blank_ammo";

  if ( cmn.ApplyObj( item, "obj_weaponry_use_twin_gun_with_blank_ammo" ) ) then

    cmn.CallEventHandler( "use_twin_gun_with_blank_ammo_inv" );
    cmn.CallEventHandler( "use_twin_gun_with_blank_ammo_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_twin_gun_with_blank_ammo" );
      cmn.CallEventHandler( "use_twin_gun_with_blank_ammo_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_weapon_4lvl", 0, "", 0 );

    ObjSet( "anm_weaponry_bandit_shot", { alp = 1 } );
    AnimPlay( "anm_weaponry_bandit_shot", "bandit_shot", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_recipe ()

  local item = "inv_recipe";

  if ( cmn.ApplyObj( item, "obj_weaponry_use_recipe" ) ) then

    cmn.CallEventHandler( "use_recipe_inv" );
    cmn.CallEventHandler( "use_recipe_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_recipe" );
      cmn.CallEventHandler( "use_recipe_end" );
      cmn.GotoRoom( "mg_minigame_3" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "aud_clk_paper", 0, "", 0 );

    func_end();
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_cross_2_lvl4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cross_2_lvl4" );
  cmn.CallEventHandler( "get_cross_2_lvl4" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_silver_key ()
  
  cmn.CallEventHandler( "clk_silver_key_beg" );

  local func_end = function ()
    
    cmn.Lock( false );
    cmn.SetEventDone( "clk_silver_key" );
    cmn.CallEventHandler( "clk_silver_key_end" ); 
    common.CloseSubRoom();
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_chest_4lvl", 0, "", 0 );
  
  ObjAnimate( "spr_chest_key_1", "alp",0,0, func_end, { 
    0.0, 0, ObjGet( "spr_chest_key_1" ).alp, 
    0.3, 0, 1,
    0.5, 0, 1,
  } );
  ObjAnimate( "spr_chest_key_2", "alp",0,0, "", { 
    0.0, 0, ObjGet( "spr_chest_key_2" ).alp, 
    0.3, 0, 0,
    0.5, 0, 0,
  } );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_weaponry ()

  if not ( cmn.IsEventDone( "opn_weaponry" ) ) then
    cmn.SetEventDone( "opn_weaponry" );
    common_impl.ShowBbt( 'bbt_weaponry_opn_weaponry' );
  end;
  cmn.CallEventHandler( "opn_weaponry" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()
end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************