-- name=ho_baths_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "baths_scr" );
  game.relations[ "ho_baths_scr" ].exitroom = "rm_toilets";
  private.room_objname = "ho_baths_scr";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  
    { "spr_baths_scr_mirror", { event_mdown = function() private.TaskComplete( 'mirror' ) end } },
    { "spr_baths_scr_gargoyle", { event_mdown = function() private.TaskComplete( 'gargoyle' ) end } },
    { "spr_baths_scr_hairbrush", { event_mdown = function() private.TaskComplete( 'hairbrush' ) end } },
    { "spr_baths_scr_hanger", { event_mdown = function() private.TaskComplete( 'hanger' ) end } },
    { "spr_baths_scr_ladder", { event_mdown = function() private.TaskComplete( 'ladder' ) end } },
    { "spr_baths_scr_laddle_1", { event_mdown = function() private.TaskComplete( 'laddle', 1 ) end } },
    { "spr_baths_scr_laddle_2", { event_mdown = function() private.TaskComplete( 'laddle', 2 ) end } },
    { "spr_baths_scr_laddle_3", { event_mdown = function() private.TaskComplete( 'laddle', 3 ) end } },
    { "spr_baths_scr_lion", { event_mdown = function() private.TaskComplete( 'lion' ) end } },
    { "spr_baths_scr_mop", { event_mdown = function() private.TaskComplete( 'mop' ) end } },
    { "spr_baths_scr_ovenfork", { event_mdown = function() private.TaskComplete( 'ovenfork' ) end } },
    { "spr_baths_scr_candle", { event_mdown = function() private.TaskComplete( 'candle' ) end } },
    { "spr_baths_scr_towel_1", { event_mdown = function() private.TaskComplete( 'towel', 1 ) end } },
    { "spr_baths_scr_towel_2", { event_mdown = function() private.TaskComplete( 'towel', 2 ) end } },
    { "spr_baths_scr_towel_3", { event_mdown = function() private.TaskComplete( 'towel', 3 ) end } },
    { "spr_baths_scr_bucket", { event_dragdrop = function() private.DropBucket() end } },
    { "spr_baths_scr_loupe", { event_dragdrop = function() private.DropLoupe() end } },
  
  } );
  --------------------------------------------------------------------------------------------
  -- function win_baths_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_baths_scr" ] = {
    type = "win",
    room = "rm_toilets",
    zz = "ho_baths_scr",
    zz_gate = "gho_toilets_baths_scr"
  };
  local win_baths_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_baths_scr" ) ) then
    
      --interface.InventoryItemAdd( "inv_ovenfork", "spr_baths_scr_win" );    
    
    end;
    
  end;
  local win_baths_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_baths_scr" ) ) then
    
      --ObjDelete( "gho_toilets_baths_scr" );   
    
    end;
    
  end;

  cmn.AddSubscriber( "win_baths_scr", win_baths_scr_inv );
  cmn.AddSubscriber( "win_baths_scr", win_baths_scr_loc, "rm_toilets" );
  --------------------------------------------------------------------------------------------------
  local start_baths_scr_func = function ()

  if ( cmn.IsEventStart( "win_baths_scr" ) ) then

    --common_impl.ProcessHoStart( "baths_scr" );

    --if ( cmn.IsUnmarkedTask( "baths_scr", "bucket" ) ) then
    --  cmn.CallEventHandler( "unmark_baths_scr_bucket" );
    --elseif ( cmn.IsUnmarkedTask( "baths_scr", "candle" ) ) then
    --  cmn.CallEventHandler( "unmark_baths_scr_candle" );
    --end;

  end;

  end;
  cmn.AddSubscriber( "win_baths_scr", start_baths_scr_func, private.room_objname ); 
  --------------------------------------------------------------------------------------------------
  local unmark_bucket_func = function ()    

    ObjDelete( "obj_baths_scr_use_bucket" );
    ObjSet( "spr_baths_scr_bucket",
    {
      event_mdown = function() private.TaskComplete( 'bucket' ) end,
      drag = false
    } );
    
  end;
  cmn.AddSubscriber( "unmark_baths_scr_bucket", unmark_bucket_func, "ho_baths_scr" );  
   --------------------------------------------------------------------------------------------------
  local unmark_candle_func = function ()    

      ObjDelete( "spr_baths_scr_loupe" );
      ObjDelete( "obj_baths_scr_use_loupe" );
      ObjSet( "spr_baths_scr_candle", { input = true } );
      ObjSet( "anm_baths_scr_candle", { visible = true } );    

  end;
  cmn.AddSubscriber( "unmark_baths_scr_candle", unmark_candle_func, "ho_baths_scr" );   

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayMusEnvHO();

  if ( not cmn.IsEventDone( "opn_baths_scr" ) ) then
  
    --cmn.InitHo( "baths_scr" );
    cmn.SetEventDone( "opn_baths_scr" );
    --cmn.SetMarkedTask( "baths_scr", "bucket" );
    --cmn.SetMarkedTask( "baths_scr", "candle" );
  
  end;
  cmn.InitHo( "baths_scr" );
  cmn.SetMarkedTask( "baths_scr", "bucket" );
  cmn.SetMarkedTask( "baths_scr", "candle" );
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "mirror",        1, 0, { { "spr_baths_scr_mirror" } } );
  interface.TaskPanelTaskAdd( ho_items, "gargoyle",      1, 0, { { "spr_baths_scr_gargoyle" } } );
  interface.TaskPanelTaskAdd( ho_items, "hairbrush",     1, 0, { { "spr_baths_scr_hairbrush" } } );
  interface.TaskPanelTaskAdd( ho_items, "hanger",        1, 0, { { "spr_baths_scr_hanger" } } );
  interface.TaskPanelTaskAdd( ho_items, "ladder",        1, 0, { { "spr_baths_scr_ladder" } } );
  interface.TaskPanelTaskAdd( ho_items, "laddle",        3, 0, { { "spr_baths_scr_laddle_1" }, { "spr_baths_scr_laddle_2" }, { "spr_baths_scr_laddle_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "lion",          1, 0, { { "spr_baths_scr_lion" } } );
  interface.TaskPanelTaskAdd( ho_items, "mop",           1, 0, { { "spr_baths_scr_mop" } } );
  interface.TaskPanelTaskAdd( ho_items, "ovenfork",      1, 0, { { "spr_baths_scr_ovenfork" } } );
  interface.TaskPanelTaskAdd( ho_items, "towel",         3, 0, { { "spr_baths_scr_towel_1" }, { "spr_baths_scr_towel_2" }, { "spr_baths_scr_towel_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "candle",        1, 0, { { "spr_baths_scr_loupe", "obj_baths_scr_use_loupe" }, { "spr_baths_scr_candle" } } );
  interface.TaskPanelTaskAdd( ho_items, "bucket",        1, 0, { { "spr_baths_scr_bucket", "obj_baths_scr_use_bucket" }, { "spr_baths_scr_bucket" } } );
  
  interface.TaskPanelShow( ho_items );  

end;
--*********************************************************************************************************************
function public.PreClose ()
  
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()
  
  --common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close ()
  
  cmn.PlayMusEnv();
  --common_impl.PassingHoStop();
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  --common_impl.PassingHoWin(); 
  
end;
--*********************************************************************************************************************
function private.TaskComplete ( task_name, part )
  
  local object = "spr_baths_scr_"..task_name;
  if ( part ) then
    object = object.."_"..part;
  end;
  cmn.HoTaskFind( object, task_name );
  if ( task_name == "bucket" ) then
    ObjDelete( "spr_baths_scr_bucket_shadow" );
  end;
  
end;
--*********************************************************************************************************************
function private.DropLoupe (  )
  
  if ( cmn.ApplyObj( "obj_baths_scr_loupe_apply", "obj_baths_scr_use_loupe" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "baths_scr", "candle" );
      cmn.CallEventHandler( "unmark_baths_scr_candle" );
      ObjDelete( "anm_baths_scr_use_loupe" );
      
    end;
    
    cmn.Lock( true );
    ObjDelete( "spr_baths_scr_loupe" );
    ObjSet( "anm_baths_scr_use_loupe", { visible = true } );
    AnimPlay( "anm_baths_scr_use_loupe", "loupe", func_end );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_candle", 0, "", 0 );
    
  else
    ObjSet( "spr_baths_scr_loupe", { pos_z = 2 } );
    common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );
  end;
  
end;
--*********************************************************************************************************************
function private.DropBucket (  )
  
  if ( cmn.ApplyObj( "spr_baths_scr_bucket", "obj_baths_scr_use_bucket" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "baths_scr", "bucket" );
      cmn.CallEventHandler( "unmark_baths_scr_bucket" );
      ObjSet( "spr_baths_scr_bucket", { alp = 1 } );
      ObjSet( "spr_baths_scr_bucket_shadow", { alp = 1 } );
      ObjDelete( "anm_baths_scr_use_bucket" );
      
      private.see_baths_scr_ghost();

    end;
    
    cmn.Lock( true );
    ObjSet( "spr_baths_scr_bucket", { alp = 0 } );
    ObjSet( "anm_baths_scr_use_bucket", { visible = true } );
    AnimPlay( "anm_baths_scr_use_bucket", "bucket", func_end );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_bucket", 0, "", 0 );
    
  else
    ObjSet( "spr_baths_scr_bucket", { pos_z = 1 } );
    ObjSet( "spr_baths_scr_bucket_shadow", { alp = 1 } );
    common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );
  end;
  
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.see_baths_scr_ghost ()

  local func_end = function ()
  
    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_baths_scr_see_ghost' );
    
    ObjDelete( "anm_baths_scr_ghost" );

  end;
    
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_water_ghost_sc", 0, "", 0 );

  ObjSet( "anm_baths_scr_ghost", { alp = 1 } );
  AnimPlay( "anm_baths_scr_ghost", "DoAnim", func_end );
  
end;
