-- name=ho_darkcorner_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "darkcorner_scr" );
  game.relations[ "ho_darkcorner_scr" ].exitroom = "rm_closedroom";
  private.room_objname = "ho_darkcorner_scr";
  --------------------------------------------------------------------------------------------------

  private.TASKPANEL_LEFT = -250;
  private.TASKPANEL_DIFF = 120;
  private.TASKPANEL_COUNT = 5;
  
  private.tasks = { 
                    "balloon", "bell", "brush", "coin", "glove", "paper_airplane", 
                    "pin", "purse", "shoe", "skull", "star", "voodoo_doll"
                  };

  ObjMultiSet( { 
    { "spr_darkcorner_scr_balloon",        { event_mdown = function() private.TaskComplete( "balloon" );        end } },
    { "spr_darkcorner_scr_bell",           { event_mdown = function() private.TaskComplete( "bell" );           end } },
    { "spr_darkcorner_scr_brush",          { event_mdown = function() private.TaskComplete( "brush" );          end } },
    { "spr_darkcorner_scr_coin",           { event_mdown = function() private.TaskComplete( "coin" );           end } },
    { "spr_darkcorner_scr_glove",          { event_mdown = function() private.TaskComplete( "glove" );          end } },
    { "spr_darkcorner_scr_paper_airplane", { event_mdown = function() private.TaskComplete( "paper_airplane" ); end } },
    { "spr_darkcorner_scr_pin",            { event_mdown = function() private.TaskComplete( "pin" );            end } },
    { "spr_darkcorner_scr_purse",          { event_mdown = function() private.TaskComplete( "purse" );          end } },
    { "spr_darkcorner_scr_shoe",           { event_mdown = function() private.TaskComplete( "shoe" );           end } },
    { "spr_darkcorner_scr_skull",          { event_mdown = function() private.TaskComplete( "skull" );          end } },
    { "spr_darkcorner_scr_star",           { event_mdown = function() private.TaskComplete( "star" );           end } },
    { "spr_darkcorner_scr_voodoo_doll",    { event_mdown = function() private.TaskComplete( "voodoo_doll" );    end } },
    
    { "obj_darkcorner_scr_coin",  { event_mdown = private.AnimCoin } },
    
  } );
  
  for i = 1, #private.tasks do

    local itemInput = false;
    
    if ( i <= private.TASKPANEL_COUNT ) then 
      
      itemInput = true;
      
    end;
    
    local curItem = "spr_darkcorner_scr_"..private.tasks[ i ];
    local curPanelItem = "spr_darkcorner_scr_taskpanel_"..private.tasks[ i ];
    
    ObjMultiSet( { 
      { curItem,  { input = itemInput } },
      { curPanelItem,  { pos_x = private.TASKPANEL_LEFT + ( i - 1 ) * private.TASKPANEL_DIFF } },
    } );
    
  end;
  
  --------------------------------------------------------------------------------------------
  -- function win_darkcorner_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_darkcorner_scr" ] = {
    type = "win",
    room = "rm_closedroom",
    zz = "ho_darkcorner_scr",
    zz_gate = "gho_closedroom_darkcorner_scr"
  };
  local win_darkcorner_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_darkcorner_scr" ) ) then
    
      --interface.InventoryItemAdd( "inv_rubbertoy", "spr_darkcorner_scr_win" );   
    
    end;
    
  end;
  local win_darkcorner_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_darkcorner_scr" ) ) then
    
      --ObjDelete( "gho_closedroom_darkcorner_scr" );   
    
    end;
    
  end;

  cmn.AddSubscriber( "win_darkcorner_scr", win_darkcorner_scr_inv );
  cmn.AddSubscriber( "win_darkcorner_scr", win_darkcorner_scr_loc, "rm_closedroom" );
  --------------------------------------------------------------------------------------------------
  local start_darkcorner_scr_func = function ()

    if ( cmn.IsEventStart( "win_darkcorner_scr" ) ) then
    
--      common_impl.ProcessHoStart( "darkcorner_scr" );
--      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_darkcorner_scr" ].found;
--
--      for i = 1, #ho_found, 1 do
--        
--        ObjDelete( ho_found[ i ][ "object" ] );
--        
--        for k = 1, 12 do
--          
--          if ( ho_found[ i ].task == private.tasks[ k ] ) then
--            
--            ObjDelete( "spr_darkcorner_scr_taskpanel_"..private.tasks[ k ] );
--            
--            for j = k, 12 do
--              
--              if ( ObjGet( "spr_darkcorner_scr_taskpanel_"..private.tasks[ j ] ) ) then
--         
--                ObjSet( "spr_darkcorner_scr_taskpanel_"..private.tasks[ j ], { pos_x = ObjGet( "spr_darkcorner_scr_taskpanel_"..private.tasks[ j ] ).pos_x - private.TASKPANEL_DIFF } ); 
--                
--                if ( ObjGet( "spr_darkcorner_scr_taskpanel_"..private.tasks[ j ] ).pos_x < private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF ) then
--                  
--                  ObjSet( "spr_darkcorner_scr_"..private.tasks[ j ], { input = true } );
--                  
--                end;
--              
--              end;
--              
--            end;
--          
--          end;
--          
--        end;
--      
--      end;
      
    end;

  end;
  cmn.AddSubscriber( "win_darkcorner_scr", start_darkcorner_scr_func, private.room_objname );  

  ObjSet("obj_darkcorner_scr_light_transparent",{
    event_mdown = function() private.light_down(); end,
    event_mup = function() private.light_up() end
  });
end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  private.CursorFlashlight();

  cmn.StopMusEnv();
  common_impl.StopAllMus();

  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.EnvPlay( { "level1/env/aud_closedroom_env" }, "", 0.5 );

  common_impl.PlayMusEnvHO();

  if ( not cmn.IsEventDone( "opn_darkcorner_scr" ) ) then
  
    --cmn.InitHo( "darkcorner_scr" );
    cmn.SetEventDone( "opn_darkcorner_scr" );
  
  end;
  
  cmn.InitHo( "darkcorner_scr" );
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "balloon",        1, 0, { { "spr_darkcorner_scr_balloon" } } );
  interface.TaskPanelTaskAdd( ho_items, "bell",           1, 0, { { "spr_darkcorner_scr_bell" } } );
  interface.TaskPanelTaskAdd( ho_items, "brush",          1, 0, { { "spr_darkcorner_scr_brush" } } );
  interface.TaskPanelTaskAdd( ho_items, "coin",           1, 0, { { "spr_darkcorner_scr_coin" } } );
  interface.TaskPanelTaskAdd( ho_items, "glove",          1, 0, { { "spr_darkcorner_scr_glove" } } );
  interface.TaskPanelTaskAdd( ho_items, "paper_airplane", 1, 0, { { "spr_darkcorner_scr_paper_airplane" } } );
  interface.TaskPanelTaskAdd( ho_items, "pin",            1, 0, { { "spr_darkcorner_scr_pin" } } );
  interface.TaskPanelTaskAdd( ho_items, "purse",          1, 0, { { "spr_darkcorner_scr_purse" } } );
  interface.TaskPanelTaskAdd( ho_items, "shoe",           1, 0, { { "spr_darkcorner_scr_shoe" } } );
  interface.TaskPanelTaskAdd( ho_items, "skull",          1, 0, { { "spr_darkcorner_scr_skull" } } );
  interface.TaskPanelTaskAdd( ho_items, "star",           1, 0, { { "spr_darkcorner_scr_star" } } );
  interface.TaskPanelTaskAdd( ho_items, "voodoo_doll",    1, 0, { { "spr_darkcorner_scr_voodoo_doll" } } );
  
  interface.TaskPanelShow( ho_items );
  
  ObjAttach( "obj_darkcorner_scr_taskpanel", "spr_int_taskpanel" );
  ObjSet( "obj_int_taskpanel", { visible = false } );
  ObjSet( "txt_int_taskpanel", { visible = false } );

end;
--*********************************************************************************************************************
function public.Open ()

  --common_impl.PassingHoStart();

  common_impl.TutorialShow( "tutorial_page_17" );
  
end;
--*********************************************************************************************************************
function public.PreClose ()
  
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  --common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { visible = true } );
  ObjSet( "txt_int_taskpanel", { visible = true } );

  ObjAttach( "obj_darkcorner_scr_taskpanel", "ho_darkcorner_scr" );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  --common_impl.PassingHoWin();
  ObjDelete( "obj_darkcorner_scr_gates" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, part )
  
  cmn.HoTaskFind( "spr_darkcorner_scr_"..task_name, task_name );

  local func_move = function () 
    
    private.TaskPanelUpdate( task_name ); 
    
  end;

  ObjAnimate( "spr_darkcorner_scr_taskpanel_"..task_name, "alp", 0, 0, func_move,
  { 
    0.0, 0, 1.0,
    0.4, 0, 1.0,
    0.6, 0, 0.0
  } );
  
end;
--*********************************************************************************************************************
function private.TaskPanelUpdate ( task_name )

  ObjDelete( "spr_darkcorner_scr_taskpanel_"..task_name );
  
  local index = private.FindIndex( private.tasks, task_name ); 
  
  for j = index, #private.tasks do

    local params = ObjGet( "spr_darkcorner_scr_taskpanel_"..private.tasks[ j ] );
    
    if ( params ) then

      local func_end = "";

      if ( not ObjGet( "spr_darkcorner_scr_"..private.tasks[ j ] ).input ) then

        func_end = function()
          
          local limitX = private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF;
          
          if ( ObjGet( "spr_darkcorner_scr_taskpanel_"..private.tasks[ j ] ) and 
          ( ObjGet( "spr_darkcorner_scr_taskpanel_"..private.tasks[ j ] ).pos_x < limitX ) and 
          ( ObjGet( "spr_darkcorner_scr_"..private.tasks[ j ] ).alp == 1 ) ) then
            
            ObjSet( "spr_darkcorner_scr_"..private.tasks[ j ], { input = true } );
            
          end;

        end;

      end;          

      if ( not private.IsFound( private.tasks[ j ] ) ) then
        
        ObjAnimate( "spr_darkcorner_scr_taskpanel_"..private.tasks[ j ], "pos_x", 0, 0, func_end, 
        { 
          0.0, 3, params.pos_x, 
          0.4, 3, params.pos_x - private.TASKPANEL_DIFF
        } );
        
      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.FindIndex( arr, elem ) -- поиск по таблице 

  for i = 1, #arr do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
function private.IsFound( task ) -- поиск по таблице 

  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_darkcorner_scr" ].found;
  
  for i = 1, #progress do
    
    if ( progress[ i ].task == task ) then

      return true;

    end;
    
  end;
  
  return false;  

end;
--*********************************************************************************************************************
function private.CursorFlashlight ()

  local cursorPosition = GetZoomCursorPos();
  local cursorPositionX = cursorPosition[ 1 ];
  local cursorPositionY = cursorPosition[ 2 ]-100;

  --if ( not cmn.IsEventDone( "win_darkcorner_scr" ) ) then
    ObjMultiSet( { 
      { "spr_darkcorner_scr_shadow",  { pos_x = cursorPositionX, pos_y = cursorPositionY } },
      { "spr_darkcorner_scr_light",  { pos_x = cursorPositionX, pos_y = cursorPositionY } },
      { "obj_darkcorner_light_transparent",  { pos_x = cursorPositionX, pos_y = cursorPositionY } },
      { "tmr_darkcorner_scr_flashlight",  { playing = true, time = 0.001, endtrig = function() private.CursorFlashlight(); end } },
    } );
    
  --end;

end;
--*********************************************************************************************************************
function private.light_down()
 MsgSend( Command_Level_SetMove, { move = false } );
end;
--*********************************************************************************************************************
function private.light_up()
 MsgSend( Command_Level_SetMove, { move = true } );
end;  
--*********************************************************************************************************************
function private.AnimCoin ()

  ObjDelete( "obj_darkcorner_scr_coin" );
  AnimPlay( "anm_darkcorner_scr_hand", "hand", "" );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_hand_ho", 0, "", 0 );

end;
  