-- name=ho_in_chest_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "in_chest_scr" );
  game.relations[ "ho_in_chest_scr" ].exitroom = "rm_weaponry";
  --------------------------------------------------------------------------------------------------
  
  private.room_objname = "ho_in_chest_scr";
  private.task_name = "win_in_chest_scr";
  private.win = 6;
  
  private.coordinates_cover_object = { 
                                        spr_in_chest_scr_cross_1_cover = { old = { pos_x = 481, pos_y = 424 }, new = { pos_x = 451, pos_y = 579 } },
                                        spr_in_chest_scr_cross_2_cover = { old = { pos_x = 125, pos_y = 266 }, new = { pos_x = 73, pos_y = 42 } },
                                        spr_in_chest_scr_knife_1_cover = { old = { pos_x = 964, pos_y = 404 }, new = { pos_x = 829, pos_y = 510 } },
                                        spr_in_chest_scr_knife_2_cover = { old = { pos_x = 303, pos_y = 65 }, new = { pos_x = 262, pos_y = -47 } },
                                        spr_in_chest_scr_purse_1_cover = { old = { pos_x = 938, pos_y = 117 }, new = { pos_x = 1010, pos_y = 142 } },
                                        spr_in_chest_scr_purse_2_cover = { old = { pos_x = 268, pos_y = 498 }, new = { pos_x = 218, pos_y = 645 } },
                                        spr_in_chest_scr_pyramid_1_cover = { old = { pos_x = 667, pos_y = 436 }, new = { pos_x = 562, pos_y = 516 } },
                                        spr_in_chest_scr_pyramid_2_cover = { old = { pos_x = 395, pos_y = 275 }, new = { pos_x = 284, pos_y = 367 } },
                                        spr_in_chest_scr_ring_1_cover = { old = { pos_x = 102, pos_y = 517 }, new = { pos_x = 45, pos_y = 548 } },
                                        spr_in_chest_scr_ring_2_cover = { old = { pos_x = 600, pos_y = 75 }, new = { pos_x = 601, pos_y = -56 } },
                                        spr_in_chest_scr_symbol_1_cover = { old = { pos_x = 246, pos_y = 231 }, new = { pos_x = 450, pos_y = 140 } },
                                        spr_in_chest_scr_symbol_2_cover = { old = { pos_x = 765, pos_y = 229 }, new = { pos_x = 913, pos_y = 285 } } 
                                     };
                         
  --------------------------------------------------------------------------------------------------

  private.moving_type = { 
                            spr_in_chest_scr_cross_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_cross_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_knife_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_knife_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_purse_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_purse_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_pyramid_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_pyramid_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_ring_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_ring_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_symbol_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_in_chest_scr_symbol_2_cover = "MOVE_XY_COVER_OBJECT" 
                        };
                        
  --------------------------------------------------------------------------------------------------

  ObjMultiSet( {  
    { "spr_in_chest_scr_cross_1_cover",             { input = true, 
                                                  event_mdown = function() private.TaskComplete( "spr_in_chest_scr_cross_1_cover", "cross" ) end,
                                                  event_menter = function () SetCursor( CURSOR_HAND ); end,
                                                  event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_cross_2_cover",             { input = true, 
                                                  event_mdown = function() private.TaskComplete( "spr_in_chest_scr_cross_2_cover", "cross" ) end,
                                                  event_menter = function () SetCursor( CURSOR_HAND ); end,
                                                  event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_knife_1_cover",             { input = true, 
                                                  event_mdown = function() private.TaskComplete( "spr_in_chest_scr_knife_1_cover", "knife" ) end,
                                                  event_menter = function () SetCursor( CURSOR_HAND ); end,
                                                  event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_knife_2_cover",             { input = true, 
                                                  event_mdown = function() private.TaskComplete( "spr_in_chest_scr_knife_2_cover", "knife" ) end,
                                                  event_menter = function () SetCursor( CURSOR_HAND ); end,
                                                  event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_purse_1_cover",          { input = true, 
                                               event_mdown = function() private.TaskComplete( "spr_in_chest_scr_purse_1_cover", "purse" ) end,
                                               event_menter = function () SetCursor( CURSOR_HAND ); end,
                                               event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_purse_2_cover",          { input = true, 
                                               event_mdown = function() private.TaskComplete( "spr_in_chest_scr_purse_2_cover", "purse" ) end,
                                               event_menter = function () SetCursor( CURSOR_HAND ); end,
                                               event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_pyramid_1_cover",            { input = true, 
                                                   event_mdown = function() private.TaskComplete( "spr_in_chest_scr_pyramid_1_cover", "pyramid" ) end,
                                                   event_menter = function () SetCursor( CURSOR_HAND ); end,
                                                   event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_pyramid_2_cover",            { input = true, 
                                                   event_mdown = function() private.TaskComplete( "spr_in_chest_scr_pyramid_2_cover", "pyramid" ) end,
                                                   event_menter = function () SetCursor( CURSOR_HAND ); end,
                                                   event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_ring_1_cover",       { input = true, 
                                           event_mdown = function() private.TaskComplete( "spr_in_chest_scr_ring_1_cover", "ring" ) end,
                                           event_menter = function () SetCursor( CURSOR_HAND ); end,
                                           event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_ring_2_cover",       { input = true, 
                                           event_mdown = function() private.TaskComplete( "spr_in_chest_scr_ring_2_cover", "ring" ) end,
                                           event_menter = function () SetCursor( CURSOR_HAND ); end,
                                           event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_symbol_1_cover",         { input = true, 
                                               event_mdown = function() private.TaskComplete( "spr_in_chest_scr_symbol_1_cover", "symbol" ) end,
                                               event_menter = function () SetCursor( CURSOR_HAND ); end,
                                               event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_symbol_2_cover",         { input = true, 
                                               event_mdown = function() private.TaskComplete( "spr_in_chest_scr_symbol_2_cover", "symbol" ); end,
                                               event_menter = function () SetCursor( CURSOR_HAND ); end,
                                               event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_in_chest_scr_key",                    { input = false, 
                                               event_mdown = function() private.TaskComplete( "spr_in_chest_scr_key", "key" ) end,
                                               event_menter = function () SetCursor( CURSOR_HAND ); end,
                                               event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    
  } );    
                                       
  --------------------------------------------------------------------------------------------
  -- function win_in_chest_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_in_chest_scr" ] = {
    type = "win",
    room = "rm_weaponry",
    zz = "ho_in_chest_scr",
    zz_gate = "gho_weaponry_in_chest_scr"
  };
  local win_in_chest_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_in_chest_scr" ) ) then
    end;
    
  end;
  local win_in_chest_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_in_chest_scr" ) ) then
    end;
    
  end;

  cmn.AddSubscriber( "win_in_chest_scr", win_in_chest_scr_inv );
  cmn.AddSubscriber( "win_in_chest_scr", win_in_chest_scr_loc, "rm_weaponry" );
  --------------------------------------------------------------------------------------------------
  local start_in_chest_scr_func = function ()

    if ( cmn.IsEventStart( "win_in_chest_scr" ) ) then
    end;
    --local foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
    --local nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;   
    
  end;
  cmn.AddSubscriber( "win_in_chest_scr", start_in_chest_scr_func, private.room_objname ); 

end;


--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  --common_impl.PlayAudio( "env", "level2/env/aud_room_313_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_in_chest_scr" ) ) then
  
    cmn.SetEventDone( "opn_in_chest_scr" );

  end;
  
  cmn.InitHo( "in_chest_scr" );
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = {};
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = {};
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "cross_1",       1, 0, { { "spr_in_chest_scr_cross_1_cover", "spr_in_chest_scr_cross_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "cross_2",       1, 0, { { "spr_in_chest_scr_cross_2_cover", "spr_in_chest_scr_cross_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "knife_1",       1, 0, { { "spr_in_chest_scr_knife_1_cover",  "spr_in_chest_scr_knife_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "knife_2",       1, 0, { { "spr_in_chest_scr_knife_2_cover",  "spr_in_chest_scr_knife_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "purse_1",       1, 0, { { "spr_in_chest_scr_purse_1_cover",  "spr_in_chest_scr_purse_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "purse_2",       1, 0, { { "spr_in_chest_scr_purse_2_cover",  "spr_in_chest_scr_purse_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "pyramid_1",     1, 0, { { "spr_in_chest_scr_pyramid_1_cover",   "spr_in_chest_scr_pyramid_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "pyramid_2",     1, 0, { { "spr_in_chest_scr_pyramid_2_cover",   "spr_in_chest_scr_pyramid_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring_1",        1, 0, { { "spr_in_chest_scr_ring_1_cover",   "spr_in_chest_scr_ring_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring_2",        1, 0, { { "spr_in_chest_scr_ring_2_cover",   "spr_in_chest_scr_ring_1_cover"  } } );
  interface.TaskPanelTaskAdd( ho_items, "symbol_1",      1, 0, { { "spr_in_chest_scr_symbol_1_cover", "spr_in_chest_scr_symbol_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "symbol_2",      1, 0, { { "spr_in_chest_scr_symbol_2_cover", "spr_in_chest_scr_symbol_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "key",           1, 0, { { "spr_in_chest_scr_key" } } );

  ObjAttach( "obj_int_taskpanel_in_chest_scr", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 
  interface.TaskPanelShow( ho_items );

end;


--*********************************************************************************************************************
function public.Open ()

  --common_impl.PassingHoStart();
  
end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  --common_impl.PassingHoStop();
  
  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_in_chest_scr" );

end;


--*********************************************************************************************************************
function public.HoComplete ()

  --common_impl.PassingHoWin();
  
end;


--*********************************************************************************************************************
function private.TaskComplete( sender, task ) 
 
  local EMPTY_PROGRESS = 0;
  local ACTIVATE_WIN_OBJECT = 6;
  local NOT_COMPLETED_COUPLE = 1;
  local COMPLETED_COUPLE = 2;

  local foundCouples = {};
  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local countFoundCouples = #foundCouples;

  local nameTaskObjects = {};
  nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

  if countFoundCouples == EMPTY_PROGRESS then
 
    local foundTask = { task };
    table.insert( foundCouples, foundTask );

    local foundObjectTask = { sender };
    table.insert( nameTaskObjects, foundObjectTask );

    private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
    private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
    ObjSet( sender, { input = false } );

    cmn.Lock( true );

  else 

    local lastCouple = foundCouples[ countFoundCouples ];
    local sizeLastCouple = #lastCouple;

    if sizeLastCouple == COMPLETED_COUPLE then   

      if countFoundCouples == ACTIVATE_WIN_OBJECT then 

        local taskObjectNameWin = "spr_in_chest_scr_"..task;
        cmn.HoTaskFind( taskObjectNameWin, task );
        private.TaskPanel( "WINNING", "key" );

      else 

        local foundTask = { task };
        table.insert( foundCouples, foundTask );

        local foundObjectTask = { sender };
        table.insert( nameTaskObjects, foundObjectTask );

        private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
        private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );

      end;

    elseif sizeLastCouple == NOT_COMPLETED_COUPLE then  

      local firstObject = lastCouple[ 1 ];
      local lastObjectTask = nameTaskObjects[ #nameTaskObjects ];
      local prevSender = lastObjectTask[ 1 ];

      if firstObject == task then 

        table.insert( lastCouple, task );
        table.insert( lastObjectTask, sender );

        local taskObjectName_1 = "spr_in_chest_scr_"..task.."_1";
        local task_1 = task.."_1";
        cmn.HoTaskFind( taskObjectName_1, task_1 );
        
        --common_impl.StopAudio( "sfx", "aud_hide_sfx", 0 );
        common_impl.StopAudio( "sfx", "aud_clk_ho_sfx2", 0 );
        
        local taskObjectName_2 = "spr_in_chest_scr_"..task.."_2";
        local task_2 = task.."_2";
        cmn.HoTaskFind( taskObjectName_2, task_2 );
        
        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_RIGHT_COUPLE", task );
        private.TaskPanel( "RIGHT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );

        if countFoundCouples == ACTIVATE_WIN_OBJECT then 

          ObjSet( "spr_in_chest_scr_key", { input = true } );

          local func_end_win = function () 
            private.TaskPanel( "ACTIVATE_WIN_OBJECT", "key" );
          end;

          ObjAnimate( "obj_in_chest_scr_items", "alp",0,0, func_end_win, { 0, 0, 1,    0.7, 0, 1 } );

        end;

      else 

        table.remove( foundCouples );
        table.remove( nameTaskObjects );

        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_WRONG_COUPLE", task, prevSender );
        private.TaskPanel( "WRONG_COMPLETED_COUPLE", firstObject );
        ObjSet( prevSender, { input = true } );

        cmn.Lock( true );

      end;

    end;

  end;
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = foundCouples;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = nameTaskObjects;
  
  if ( #ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples > 0 ) then

    local sizeS = #ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;

    if ( #ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples[ sizeS ] == 1 ) then
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples[ sizeS ][ 1 ];
    else
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = "";
    end;

  else 

    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = "";

  end;
  
end;


--*********************************************************************************************************************
function private.MoveCoveringObjects( taskObject, moveType, direction ) 

  if moveType == "MOVE_XY_COVER_OBJECT" then 

    local oldX = private.coordinates_cover_object[ taskObject ].old.pos_x;
    local oldY = private.coordinates_cover_object[ taskObject ].old.pos_y;

    local newX = private.coordinates_cover_object[ taskObject ].new.pos_x;
    local newY = private.coordinates_cover_object[ taskObject ].new.pos_y;

    local beginX = 0;
    local beginY = 0;

    local endX = 0;
    local endY = 0;

    if direction == "OLD_TO_NEW" then 

      beginX = oldX;
      beginY = oldY;

      endX = newX;
      endY = newY;
      
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_ho_parts", 0, "", 0 );

    elseif direction == "NEW_TO_OLD" then 

      beginX = newX;
      beginY = newY;

      endX = oldX;
      endY = oldY;

      common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );

    end;

    ObjAnimate( taskObject, "pos_xy",0,0, "", { 0, 3, beginX, beginY,    0.4, 3, endX, endY } );
    
  end;

end;


--*********************************************************************************************************************
function private.AnimCoveringObjects( sender, animType, task, prevSender ) 

  local func_end_block = function () 

    cmn.Lock( false );

  end;

  if animType == "FIRST_OBJECT_OF_COUPLE" then 

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( private.room_objname, "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_RIGHT_COUPLE" then 

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( private.room_objname, "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_WRONG_COUPLE" then 

    local func_end = function () 

      if prevSender then 
        private.MoveCoveringObjects( prevSender, private.moving_type[ prevSender ], "NEW_TO_OLD" );
        private.MoveCoveringObjects( sender, private.moving_type[ sender ], "NEW_TO_OLD" ); 
      end;

    end;

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( private.room_objname, "alp",0,0, func_end, { 0, 0, 1,    0.4, 0, 1 } );
    ObjAnimate( private.room_objname, "scale_x",0,0, func_end_block, { 0, 0, 1,    1.0, 0, 1 } );

  end; 

end;


--*********************************************************************************************************************
function private.TaskPanelUpdate() 

  ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );

  ObjSet( "txt_in_chest_scr_taskpanel", { pos_x = 0, pos_y = 15 } );
  ObjAttach( "txt_in_chest_scr_taskpanel", "obj_int_taskpanel_in_chest_scr" );

  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local count = 6 - #foundCouples;

  local COLOR_R = 1;
  local COLOR_G = 1;
  local COLOR_B = 1;

  ObjSet( "txt_in_chest_scr_taskpanel",
  {
     text   = "str_int_taskpanel_pattern_couples",
     param0 = COLOR_R,
     param1 = COLOR_G,
     param2 = COLOR_B,
     param3 = StringGet( "str_taskpanel_couple_ho" ),
     param4 = count
   } );

  if count == 0 then 
  
    ObjSet( "txt_in_chest_scr_taskpanel", { alp = 0 } );

  end;

end;


--*********************************************************************************************************************
function private.TaskPanel( animType, curTask ) 

  local OBJECT_Y = 15;
  local OBJECT_LEFT_X = -170;
  local OBJECT_MIDDLE_X = 0;
  local OBJECT_RIGHT_X = 170;

  if animType == "NOT_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_in_chest_scr_"..curTask.."_shadow_1";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_in_chest_scr" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_LEFT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( "txt_in_chest_scr_taskpanel", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 0, 0 } );

  elseif animType == "RIGHT_COMPLETED_COUPLE" then 

    local taskPanelObject_1 = "spr_in_chest_scr_"..curTask.."_shadow_1";
    local taskPanelObject_2 = "spr_in_chest_scr_"..curTask.."_shadow_2";
    ObjAttach( taskPanelObject_2, "obj_int_taskpanel_in_chest_scr" ); 

    local func_end = function () 

      ObjAnimate( taskPanelObject_1, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
      ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
------------------------------
------------------------------
      local fxTaskPanelObject = "fx_in_chest_scr_"..curTask;
      local pos = GetObjPosByObj( taskPanelObject_1, "obj_int_taskpanel_in_chest_scr" );
      ObjCreate( fxTaskPanelObject, "partsys" );
      ObjSet( fxTaskPanelObject,
      {
        res = "assets/interface/resources/ho_collect_effect",
        blendmode = 2, color_r = 0.8, color_g = 0.4, color_b = 1, 
        alp = 1, visible = true, pos_x = pos[1], pos_y = pos[2], pos_z = 1, input = false
      } );

      local func_end_fx = function () 
        ObjDelete( fxTaskPanelObject );
      end;

      ObjAttach( fxTaskPanelObject, "obj_int_taskpanel_in_chest_scr" );
      ObjAnimate( fxTaskPanelObject, "alp", 0, 0, func_end_fx, { 0, 0, 1,    0.4, 0, 1,    0.7, 0, 0 } );
------------------------------
------------------------------
      private.TaskPanelUpdate();
      ObjAnimate( "txt_in_chest_scr_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

    end;

    ObjSet( taskPanelObject_2, { pos_x = OBJECT_RIGHT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( taskPanelObject_1, "pos_x",0,0, "", { 0, 3, OBJECT_LEFT_X,    0.3, 3, OBJECT_LEFT_X,    0.7, 3, OBJECT_MIDDLE_X } );
    ObjAnimate( taskPanelObject_2, "pos_x",0,0, func_end, { 0, 3, OBJECT_RIGHT_X,    0.3, 3, OBJECT_RIGHT_X,    0.7, 3, OBJECT_MIDDLE_X } );   

  elseif animType == "WRONG_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_in_chest_scr_"..curTask.."_shadow_1";

    local func_end = function () 

      ObjDetach( taskPanelObject );

    end;

    ObjAnimate( taskPanelObject, "alp",0,0, func_end, { 0, 3, 1,    0.3, 3, 0 } );

    private.TaskPanelUpdate();
    ObjAnimate( "txt_in_chest_scr_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

  elseif animType == "ACTIVATE_WIN_OBJECT" then 

    local taskPanelObject = "spr_in_chest_scr_"..curTask.."_shadow";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_in_chest_scr" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_MIDDLE_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

  elseif animType == "WINNING" then 

    local taskPanelObject = "spr_in_chest_scr_"..curTask.."_shadow";
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );

  end;

end;


