-- name=ho_next_armchair_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "next_armchair_scr" );
  game.relations[ "ho_next_armchair_scr" ].exitroom = "rm_backyard";
  private.room_objname = "ho_next_armchair_scr";
  --------------------------------------------------------------------------------------------------
  
  ObjSet( "obj_next_armchair_scr_clk_wheel", {  
                                           event_mdown = function() private.WheelClick(); end, 
                                           event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
                                           event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                                         } );  
  
  private.task_name = "win_next_armchair_scr";
  private.cover_count = 12;
  private.item_count = 5;
  
  for i = 1, private.cover_count, 1 do 

    local curCover = "spr_next_armchair_scr_piece_"..i.."_cover";  
    ObjSet( curCover, { input = true, event_mdown = function() private.CoverClick( i ); end } );
 
  end; 
                   
  for i = 1, private.item_count, 1 do 

    local curItem = "spr_next_armchair_scr_piece_"..i.."_item";
    ObjSet( curItem, { input = false, 
                       event_mdown = function() private.ItemClick( i ); end, 
                       event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
                       event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                     } );

  end;   
                     
  ObjSet( "spr_next_armchair_scr_cross", { input = false, 
                                       event_mdown = function() cmn.HoTaskFind( "spr_next_armchair_scr_cross", "cross" ); end, 
                                       event_menter = function () common_impl.SetCursor( CURSOR_GET ); end,
                                       event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                                     } );    
                                       
  --------------------------------------------------------------------------------------------
  -- function win_next_armchair_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_next_armchair_scr" ] = {
    type = "win",
    room = "rm_backyard",
    zz = "ho_next_armchair_scr",
    zz_gate = "gho_backyard_next_armchair_scr"
  };
  local win_next_armchair_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_next_armchair_scr" ) ) then
  
    end;
    
  end;
  local win_next_armchair_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_next_armchair_scr" ) ) then
    
    end;
    
  end;

  cmn.AddSubscriber( "win_next_armchair_scr", win_next_armchair_scr_inv );
  cmn.AddSubscriber( "win_next_armchair_scr", win_next_armchair_scr_loc, "rm_backyard" );
  --------------------------------------------------------------------------------------------------
  local start_next_armchair_scr_func = function ()

    if ( cmn.IsEventStart( "win_next_armchair_scr" ) ) then
    end;

  end;
  cmn.AddSubscriber( "win_next_armchair_scr", start_next_armchair_scr_func, private.room_objname ); 

end;


--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopMusEnv();
  common_impl.StopAllMus();

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level2/env/aud_hall_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_next_armchair_scr" ) ) then
  
    cmn.SetEventDone( "opn_next_armchair_scr" );
  
  end;
  
  cmn.InitHo( "next_armchair_scr" );
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items = {};
  
  local ho_items = {};

  for i = 1, private.cover_count, 1 do 
    
    local curCover = "spr_next_armchair_scr_piece_"..i.."_cover";
    local curCoverTask = "piece_"..i.."_cover";
     
    interface.TaskPanelTaskAdd( ho_items, curCoverTask,             1, 0, { { curCover } } );

  end; 

  for i = 1, private.item_count, 1 do 

    local curItem = "spr_next_armchair_scr_piece_"..i.."_item";
    local curItemTask = "piece_"..i.."_item";
    interface.TaskPanelTaskAdd( ho_items, curItemTask,              1, 0, { { curItem } } );

  end; 
  
  interface.TaskPanelTaskAdd( ho_items, "cross",                    1, 0, { { "spr_next_armchair_scr_cross" } } );
  interface.TaskPanelShow( ho_items );  

  ObjAttach( "obj_int_taskpanel_next_armchair_scr", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 

end;


--*********************************************************************************************************************
function public.Open ()

  --common_impl.PassingHoStart();
  
end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();
  
end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  --common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_next_armchair_scr" );

end;


--*********************************************************************************************************************
function public.HoComplete ()
  
  --common_impl.PassingHoWin(); 
  
end;


--*********************************************************************************************************************
function private.CoverClick ( id )

  local curCover = "spr_next_armchair_scr_piece_"..id.."_cover";
  local curCoverTask = "piece_"..id.."_cover";

  cmn.HoTaskFind( curCover, curCoverTask );
  
  if ( id <= private.item_count ) then 

    local curItem = "spr_next_armchair_scr_piece_"..id.."_item";
    ObjSet( curItem, { input = true } );

  end; 

  local element = { id_part = id, is_piece_found = false }; 
  table.insert( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items, element ); 
  
  if ( private.CheckingOnAllItemsFound() and
  private.CheckingOnAllCoversFound() ) then 

    ObjMultiSet( { 
      { "spr_next_armchair_scr_cross",  { alp = 1, visible = true, input = true } },
      { "obj_next_armchair_scr_pieces",  { alp = 0, visible = false, input = false } },
    } );
    
  end; 
  
  private.TaskPanelUpdate(); 

end;


--*********************************************************************************************************************
function private.ItemClick ( id )

  local func_end = function () 

    cmn.Lock( false );

  end;

  local curItem = "spr_next_armchair_scr_piece_"..id.."_item";
  local curItemTask = "piece_"..id.."_item";
  
  cmn.HoTaskFind( curItem, curItemTask );

  local curPiece = "spr_next_armchair_scr_piece_"..id;

  cmn.Lock( true );
  ObjAnimate( curPiece, "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1 } );

  private.MarkingFoundItem( id );
  
  if ( private.CheckingOnAllItemsFound() and
  private.CheckingOnAllCoversFound() ) then 

    ObjMultiSet( { 
      { "spr_next_armchair_scr_cross",  { alp = 1, visible = true, input = true } },
      { "obj_next_armchair_scr_pieces",  { alp = 0, visible = false, input = false } },
    } );
    
  end;
  
  private.TaskPanelUpdate();

end;


--*********************************************************************************************************************
function private.TaskPanelUpdate () 

  if private.CheckingOnAllCoversFound() then 

    ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );
    ObjSet( "txt_next_armchair_scr_taskpanel", { alp = 1, visible = true } );

    local count = private.item_count - private.GettingFoundItemsCount();

    ObjSet( "txt_next_armchair_scr_taskpanel",
    {
       text   = "str_next_armchair_scr_task",
       param0 = count
    } );

    if count == 0 then 
    
      ObjSet( "txt_next_armchair_scr_taskpanel", { text = "str_next_armchair_scr_final" } );

    end;

  end;

end;


--*********************************************************************************************************************
function private.MarkingFoundItem ( id )

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].id_part == id ) and ( not foundItems[ i ].is_piece_found ) then 

      foundItems[ i ].is_piece_found = true; 
      break; 

    end; 

  end; 

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items = foundItems; 

end; 


--*********************************************************************************************************************
function private.CheckingOnAllItemsFound ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local result = false; 
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].is_piece_found ) then 

      count = count + 1; 

    end; 

  end; 

  if private.item_count == count then 

    result = true;

  end;

  return result;

end; 


--*********************************************************************************************************************
function private.CheckingOnAllCoversFound ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local result = false; 
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ] ) then 

      count = count + 1; 

    end; 

  end; 

  if private.cover_count == count then 

    result = true;

  end;

  return result;

end; 


--*********************************************************************************************************************
function private.GettingFoundItemsCount ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].is_piece_found ) then 

      count = count + 1; 

    end; 

  end; 

  return count;

end; 


--*********************************************************************************************************************
function private.IsCoverFound ( coverID )
  
  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local result = false; 

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].id_part == coverID ) then 

      result = true;
      break; 

    end; 

  end; 

  return result;
  
end;


--*********************************************************************************************************************
function private.WheelClick ()
  
  local func_end = function()

    cmn.Lock( false );
    
    if ( not private.IsCoverFound( 9 ) ) then   
      
      ObjMultiSet( { 
        { "spr_next_armchair_scr_piece_9_cover_visible",  { alp = 0, visible = false } },
        { "spr_next_armchair_scr_piece_9_cover",  { alp = 1, visible = true } },
      } );
      
    end;
  
  end; 
  
  if ( not private.IsCoverFound( 9 ) ) then
    
    ObjMultiSet( { 
      { "spr_next_armchair_scr_piece_9_cover",  { alp = 0, visible = false } },
      { "spr_next_armchair_scr_piece_9_cover_visible",  { alp = 1, visible = true } },
    } );    
    
  end;
  
  cmn.Lock( true );
  AnimPlay( "anm_next_armchair_scr_wheel", "wheel", func_end );
  
end;








