-- name=ho_portraithall_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "portraithall_scr" );
  game.relations[ "ho_portraithall_scr" ].exitroom = "rm_hall";
  private.room_objname = "ho_portraithall_scr";
  --------------------------------------------------------------------------------------------------
  private.task_name = "win_portraithall_scr";
  private.cover_count = 12;
  private.item_count = 6;
  
  for i = 1, private.cover_count, 1 do 

    local curCover = "spr_portraithall_scr_piece_"..i.."_cover";  
    ObjSet( curCover, { input = true, event_mdown = function() private.CoverClick( i ); end } );
 
  end; 
                   
  for i = 1, private.item_count, 1 do 

    local curItem = "spr_portraithall_scr_piece_"..i.."_item";
    ObjSet( curItem, { input = false, 
                       event_mdown = function() private.ItemClick( i ); end, 
                       event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
                       event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                     } );

  end;   
                     
  ObjSet( "spr_portraithall_scr_amulet", { input = false, 
                                       event_mdown = function() cmn.HoTaskFind( "spr_portraithall_scr_amulet", "amulet" ); end, 
                                       event_menter = function () common_impl.SetCursor( CURSOR_GET ); end,
                                       event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                                     } );                                          
                            
  --------------------------------------------------------------------------------------------
  -- function win_portraithall_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_portraithall_scr" ] = {
    type = "win",
    room = "rm_hall",
    zz = "ho_portraithall_scr",
    zz_gate = "gho_hall_portraithall_scr"
  };
  local win_portraithall_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_portraithall_scr" ) ) then
    
    end;
    
  end;
  local win_portraithall_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_portraithall_scr" ) ) then
    
    end;
    
  end;

  cmn.AddSubscriber( "win_portraithall_scr", win_portraithall_scr_inv );
  cmn.AddSubscriber( "win_portraithall_scr", win_portraithall_scr_loc, "rm_hall" );
  
  --------------------------------------------------------------------------------------------------
  local start_portraithall_scr_func = function ()

  if ( cmn.IsEventStart( "win_portraithall_scr" ) ) then

  end;

  end;
  cmn.AddSubscriber( "win_portraithall_scr", start_portraithall_scr_func, private.room_objname );   

end;

--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopMusEnv();
  common_impl.StopAllMus();

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level2/env/aud_hall_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_portraithall_scr" ) ) then
  
    cmn.SetEventDone( "opn_portraithall_scr" );
  
  end;
  
  cmn.InitHo( "portraithall_scr" );
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items = {};
  
  local ho_items = {};

  for i = 1, private.cover_count, 1 do 
    
    local curCover = "spr_portraithall_scr_piece_"..i.."_cover";
    local curCoverTask = "piece_"..i.."_cover";
     
    interface.TaskPanelTaskAdd( ho_items, curCoverTask,             1, 0, { { curCover } } );

  end; 

  for i = 1, private.item_count, 1 do 

    local curItem = "spr_portraithall_scr_piece_"..i.."_item";
    local curItemTask = "piece_"..i.."_item";
    interface.TaskPanelTaskAdd( ho_items, curItemTask,              1, 0, { { curItem } } );

  end; 
  
  interface.TaskPanelTaskAdd( ho_items, "amulet",                   1, 0, { { "spr_portraithall_scr_amulet" } } );
  interface.TaskPanelShow( ho_items );  

  ObjAttach( "obj_int_taskpanel_portraithall_scr", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 

end;


--*********************************************************************************************************************
function public.Open ()

  --common_impl.PassingHoStart();
  
  common_impl.TutorialShow( "tutorial_page_15" );
  
end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  --common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_portraithall_scr" );

end;


--*********************************************************************************************************************
function public.HoComplete ()
  
  --common_impl.PassingHoWin(); 
  
end;


--*********************************************************************************************************************
function private.CoverClick ( id )

  local curCover = "spr_portraithall_scr_piece_"..id.."_cover";
  local curCoverTask = "piece_"..id.."_cover";

  cmn.HoTaskFind( curCover, curCoverTask );
  
  if ( id <= private.item_count ) then 

    local curItem = "spr_portraithall_scr_piece_"..id.."_item";
    ObjSet( curItem, { input = true } );

  end; 

  local element = { id_part = id, is_piece_found = false }; 
  table.insert( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items, element ); 
  
  if id == 10 then
    
    ObjSet( "anm_portraithall_scr_crow", { alp = 1 } );
    AnimPlay( "anm_portraithall_scr_crow", "crow", "" );
    
  end;
  
  if ( private.CheckingOnAllItemsFound() and
  private.CheckingOnAllCoversFound() ) then 

    ObjMultiSet( { 
      { "spr_portraithall_scr_amulet",  { alp = 1, visible = true, input = true } },
      { "obj_portraithall_scr_pieces",  { alp = 0, visible = false, input = false } },
    } );
    
    private.AnimScare();

  end; 
  
  private.TaskPanelUpdate(); 

end;


--*********************************************************************************************************************
function private.ItemClick ( id )

  local func_end = function () 

    cmn.Lock( false );

  end;

  local curItem = "spr_portraithall_scr_piece_"..id.."_item";
  local curItemTask = "piece_"..id.."_item";
  
  cmn.HoTaskFind( curItem, curItemTask );

  local curPiece = "spr_portraithall_scr_piece_"..id;

  cmn.Lock( true );
  ObjAnimate( curPiece, "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1 } );

  private.MarkingFoundItem( id );
  
  if ( private.CheckingOnAllItemsFound() and
  private.CheckingOnAllCoversFound() ) then 

    ObjMultiSet( { 
      { "spr_portraithall_scr_amulet",  { alp = 1, visible = true, input = true } },
      { "obj_portraithall_scr_pieces",  { alp = 0, visible = false, input = false } },
    } );
    
    private.AnimScare();

  end;
  
  private.TaskPanelUpdate();

end;


--*********************************************************************************************************************
function private.TaskPanelUpdate () 

  if private.CheckingOnAllCoversFound() then 

    ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );
    ObjSet( "txt_portraithall_scr_taskpanel", { alp = 1, visible = true } );

    local count = private.item_count - private.GettingFoundItemsCount();

    ObjSet( "txt_portraithall_scr_taskpanel",
    {
       text   = "str_portraithall_scr_task",
       param0 = count
    } );

    if count == 0 then 
    
      ObjSet( "txt_portraithall_scr_taskpanel", { text = "str_portraithall_scr_final" } );

    end;

  end;

end;


--*********************************************************************************************************************
function private.MarkingFoundItem ( id )

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].id_part == id ) and ( not foundItems[ i ].is_piece_found ) then 

      foundItems[ i ].is_piece_found = true; 
      break; 

    end; 

  end; 

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items = foundItems; 

end; 


--*********************************************************************************************************************
function private.CheckingOnAllItemsFound ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local result = false; 
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].is_piece_found ) then 

      count = count + 1; 

    end; 

  end; 

  if private.item_count == count then 

    result = true;

  end;

  return result;

end; 


--*********************************************************************************************************************
function private.CheckingOnAllCoversFound ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local result = false; 
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ] ) then 

      count = count + 1; 

    end; 

  end; 

  if private.cover_count == count then 

    result = true;

  end;

  return result;

end; 


--*********************************************************************************************************************
function private.GettingFoundItemsCount ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].is_piece_found ) then 

      count = count + 1; 

    end; 

  end; 

  return count;

end; 
--*********************************************************************************************************************
function private.AnimScare ()

  local func_end = function ()
  
    cmn.Lock( false );
  
  end;
  
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_artist", 0, "", 0 );

  ObjSet( "anm_portraithall_scr_scary", { alp = 1 } );
  AnimPlay( "anm_portraithall_scr_scary", "scary", func_end );

end; 




