-- name=ho_stone_stash_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "stone_stash_scr" );
  game.relations[ "ho_stone_stash_scr" ].exitroom = "rm_park_lvl4";
  private.room_objname = "ho_stone_stash_scr";
  --------------------------------------------------------------------------------------------------
   ObjMultiSet( {
    { "spr_stone_stash_scr_seven",            { event_mdown = function() private.TaskComplete( 'seven'      ) end } },
    { "spr_stone_stash_scr_bell",             { event_mdown = function() private.TaskComplete( 'bell'       ) end } },
    { "spr_stone_stash_scr_boat",             { event_mdown = function() private.TaskComplete( 'boat'       ) end } },
    { "spr_stone_stash_scr_butterfly",        { event_mdown = function() private.TaskComplete( 'butterfly'  ) end } },
    { "spr_stone_stash_scr_chamomille",       { event_mdown = function() private.TaskComplete( 'chamomille' ) end } },
    { "spr_stone_stash_scr_flute",            { event_mdown = function() private.TaskComplete( 'flute'      ) end } },
    { "spr_stone_stash_scr_frog",             { event_mdown = function() private.TaskComplete( 'frog'       ) end } },
    { "spr_stone_stash_scr_ring",             { event_mdown = function() private.TaskComplete( 'ring'       ) end } },
    { "spr_stone_stash_scr_snail",            { event_mdown = function() private.TaskComplete( 'snail'      ) end } },
    { "spr_stone_stash_scr_waterlilly",       { event_mdown = function() private.TaskComplete( 'waterlilly' ) end } },

    { "spr_stone_stash_scr_coin_1",           { event_mdown = function() private.TaskComplete( 'coin',  1   ) end } },
    { "spr_stone_stash_scr_coin_2",           { event_mdown = function() private.TaskComplete( 'coin',  2   ) end } },
    { "spr_stone_stash_scr_coin_3",           { event_mdown = function() private.TaskComplete( 'coin',  3   ) end } },

    { "spr_stone_stash_scr_leaf_1",           { event_mdown = function() private.TaskComplete( 'leaf',  1   ) end } },
    { "spr_stone_stash_scr_leaf_2",           { event_mdown = function() private.TaskComplete( 'leaf',  2   ) end } },
    { "spr_stone_stash_scr_leaf_3",           { event_mdown = function() private.TaskComplete( 'leaf',  3   ) end } },

    { "spr_stone_stash_scr_pick",             { event_dragdrop = function() private.DropPick()                end } },
    { "spr_stone_stash_scr_pruner",           { event_dragdrop = function() private.DropPruner()              end } },
  } );
  --------------------------------------------------------------------------------------------
  -- function win_stone_stash_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_stone_stash_scr" ] = {
    type = "win",
    room = "rm_park_lvl4",
    zz = "ho_stone_stash_scr",
    zz_gate = "gho_park_lvl4_stone_stash_scr"
  };
  local win_stone_stash_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_stone_stash_scr" ) ) then
    end;
    
  end;
  local win_stone_stash_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_stone_stash_scr" ) ) then
    end;
    
  end;
  cmn.AddSubscriber( "win_stone_stash_scr", win_stone_stash_scr_inv );
  cmn.AddSubscriber( "win_stone_stash_scr", win_stone_stash_scr_loc, "rm_park_lvl4" );
  --------------------------------------------------------------------------------------------------
  local start_stone_stash_scr_func = function ()

    if ( cmn.IsEventStart( "win_stone_stash_scr" ) ) then
      
    end;

  end;
  cmn.AddSubscriber( "win_stone_stash_scr", start_stone_stash_scr_func, private.room_objname );  
  --------------------------------------------------------------------------------------------------
  local unmark_ring_func = function ()    

    ObjMultiSet( {
      { "spr_stone_stash_scr_ring",         { alp = 1, input = true                                   } },
      { "spr_stone_stash_scr_pick",         { alp = 0, input = false                                  } },
      { "spr_stone_stash_scr_shadow_pick",  { alp = 0                                                 } },
      { "spr_stone_stash_scr_stone_1",      { alp = 0                                                 } },
      { "spr_stone_stash_scr_shadow_stone", { alp = 0                                                 } },
      { "anm_stone_stash_scr_stone",        { alp = 1, frame = 300                                    } },
      { "obj_stone_stash_scr_use_pick",     {          input = false, active = false, visible = false } },
    });

  end;
  cmn.AddSubscriber( "unmark_ring_func", unmark_ring_func, private.room_objname );  
  --------------------------------------------------------------------------------------------------
  local unmark_chamomille_func = function ()    

    ObjMultiSet( {
      { "spr_stone_stash_scr_chamomille",       { alp = 1, input = true                                   } },
      { "spr_stone_stash_scr_pruner",           { alp = 0, input = false                                  } },
      { "spr_stone_stash_scr_patch_pruner",     {          input = false                                  } },
      { "spr_stone_stash_scr_shadow_pruner",    { alp = 0                                                 } },
      { "spr_stone_stash_scr_chamomile",        { alp = 0                                                 } },
      { "anm_stone_stash_scr_cut",              { alp = 0                                                 } },
      { "spr_stone_stash_scr_chamomille_2",     { alp = 1                                                 } },
      { "spr_stone_stash_scr_patch_chamomille", { alp = 1                                                 } },
      { "obj_stone_stash_scr_use_pruner",       {          input = false, active = false, visible = false } },
    });

  end;
  cmn.AddSubscriber( "unmark_chamomille_func", unmark_chamomille_func, private.room_objname );  
  --------------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );

  if ( not cmn.IsEventDone( "opn_stone_stash_scr" ) ) then

    cmn.SetEventDone( "opn_stone_stash_scr" );
	
  end;
  
    cmn.InitHo( "stone_stash_scr" );
    cmn.SetMarkedTask( "stone_stash_scr", "ring"       );
    cmn.SetMarkedTask( "stone_stash_scr", "chamomille" );
	
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "seven",      1, 0, { { "spr_stone_stash_scr_seven"      } } );
  interface.TaskPanelTaskAdd( ho_items, "bell",       1, 0, { { "spr_stone_stash_scr_bell"       } } );
  interface.TaskPanelTaskAdd( ho_items, "boat",       1, 0, { { "spr_stone_stash_scr_boat"       } } );
  interface.TaskPanelTaskAdd( ho_items, "butterfly",  1, 0, { { "spr_stone_stash_scr_butterfly"  } } );
  interface.TaskPanelTaskAdd( ho_items, "flute",      1, 0, { { "spr_stone_stash_scr_flute"      } } );
  interface.TaskPanelTaskAdd( ho_items, "frog",       1, 0, { { "spr_stone_stash_scr_frog"       } } );
  interface.TaskPanelTaskAdd( ho_items, "snail",      1, 0, { { "spr_stone_stash_scr_snail"      } } );
  interface.TaskPanelTaskAdd( ho_items, "waterlilly", 1, 0, { { "spr_stone_stash_scr_waterlilly" } } );

  interface.TaskPanelTaskAdd( ho_items, "chamomille", 1, 1, { { "spr_stone_stash_scr_pruner", "obj_stone_stash_scr_use_pruner" }, 
                                                              { "spr_stone_stash_scr_chamomille" } 
                                                            } );
  interface.TaskPanelTaskAdd( ho_items, "ring",       1, 1, { { "spr_stone_stash_scr_pick",   "obj_stone_stash_scr_use_pick"   }, 
                                                              { "spr_stone_stash_scr_ring"} 
                                                            } );

  interface.TaskPanelTaskAdd( ho_items, "coin",       3, 0, { { "spr_stone_stash_scr_coin_1" }, 
                                                              { "spr_stone_stash_scr_coin_2" }, 
                                                              { "spr_stone_stash_scr_coin_3" } 
                                                            } );
  interface.TaskPanelTaskAdd( ho_items, "leaf",       3, 0, { { "spr_stone_stash_scr_leaf_1" }, 
                                                              { "spr_stone_stash_scr_leaf_2" }, 
                                                              { "spr_stone_stash_scr_leaf_3" } 
                                                            } );
  interface.TaskPanelShow( ho_items );

end;
--*********************************************************************************************************************
function public.Open () 
end;
--*********************************************************************************************************************
function public.PreClose ()
  interface.TaskPanelHide();
end;
--*********************************************************************************************************************
function public.Close ()
  cmn.PlayMusEnv();
end;
--*********************************************************************************************************************
function public.HoComplete ()
end;
--*********************************************************************************************************************
function private.TaskComplete ( task_name, part )
  
  local object = "spr_stone_stash_scr_"..task_name;
  if ( part ) then
    object = object.."_"..part;
  end;
  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function private.DropPick ()
  
  if ( ObjIntersect( "spr_stone_stash_scr_pick", "obj_stone_stash_scr_use_pick" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "stone_stash_scr", "ring" );
      cmn.CallEventHandler( "unmark_ring_func" );

    end;
    
    ObjMultiSet( {
      { "spr_stone_stash_scr_stone_1",      { alp = 0 } },
      { "spr_stone_stash_scr_shadow_stone", { alp = 0 } },
      { "anm_stone_stash_scr_stone",        { alp = 1 } },
      { "spr_stone_stash_scr_pick",         { alp = 0 } },
      { "spr_stone_stash_scr_shadow_pick",  { alp = 0 } },
    });   
    
    cmn.Lock( true );
    AnimPlay( "anm_stone_stash_scr_stone", "stone", func_end );
    
  else
    
    ObjAttach( "spr_stone_stash_scr_pick", "obj_stone_stash_scr_anim" );
    ObjSet( "spr_stone_stash_scr_pick",        { pos_z = 0 } );
    ObjSet( "spr_stone_stash_scr_shadow_pick", {   alp = 1 } );
    
  end;
  
end;
--*********************************************************************************************************************
function private.DropPruner ()
  
  if ( ObjIntersect( "spr_stone_stash_scr_pruner", "obj_stone_stash_scr_use_pruner" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "stone_stash_scr", "chamomille" );
      cmn.CallEventHandler( "unmark_chamomille_func" );
      
    end;
    
    ObjMultiSet( {
      { "spr_stone_stash_scr_chamomille_2",  { alp = 0 } },
      { "spr_stone_stash_scr_chamomile",     { alp = 0 } },
      { "anm_stone_stash_scr_cut",           { alp = 1 } },
      { "spr_stone_stash_scr_pruner",        { alp = 0 } },
      { "spr_stone_stash_scr_shadow_pruner", { alp = 0 } },
    });
    
    cmn.Lock( true );
    AnimPlay( "anm_stone_stash_scr_cut", "cut", func_end );
    
  else  
    
    ObjSet( "spr_stone_stash_scr_pruner",        { pos_z = 0 } );
    ObjSet( "spr_stone_stash_scr_shadow_pruner", {   alp = 1 } );
    
  end;
  
end;
--*********************************************************************************************************************