-- name=ho_storage_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "storage_scr" );
  game.relations[ "ho_storage_scr" ].exitroom = "rm_porch";
  private.room_objname = "ho_storage_scr";
  --------------------------------------------------------------------------------------------------
  
  private.TASKPANEL_LEFT = -250;
  private.TASKPANEL_DIFF = 120;
  private.TASKPANEL_COUNT = 5;
  
  private.tasks = { 
                    "basket", "bike", "broom", "candle", "doll", "elephant", 
                    "figure", "hat", "iron", "ladder", "skates", "opener"
                  };

  ObjMultiSet( { 
                  { "spr_storage_scr_basket",  { event_mdown = function() private.TaskComplete( "basket" ); end } },
                  { "spr_storage_scr_bike",  { event_mdown = function() private.TaskComplete( "bike" ); end } },
                  { "spr_storage_scr_broom",  { event_mdown = function() private.TaskComplete( "broom" ); end } },
                  { "spr_storage_scr_candle",  { event_mdown = function() private.TaskComplete( "candle" ); end } },
                  { "spr_storage_scr_doll",  { event_mdown = function() private.TaskComplete( "doll" ); end } },
                  { "spr_storage_scr_elephant",  { event_mdown = function() private.TaskComplete( "elephant" ); end } },
                  { "spr_storage_scr_figure",  { event_mdown = function() private.TaskComplete( "figure" ); end } },
                  { "spr_storage_scr_hat",  { event_mdown = function() private.TaskComplete( "hat" ); end } },
                  { "spr_storage_scr_iron",  { event_mdown = function() private.TaskComplete( "iron" ); end } },
                  { "spr_storage_scr_ladder",  { event_mdown = function() private.TaskComplete( "ladder" ); end } },
                  { "spr_storage_scr_skates",  { event_mdown = function() private.TaskComplete( "skates" ); end } },
                  { "spr_storage_scr_opener",  { event_mdown = function() private.TaskComplete( "opener" ); end } },
  } );
  
  for i = 1, #private.tasks do

    local itemInput = false;
    
    if ( i <= private.TASKPANEL_COUNT ) then 
      
      itemInput = true;
      
    end;
    
    local curItem = "spr_storage_scr_"..private.tasks[ i ];
    local curPanelItem = "spr_storage_scr_taskpanel_"..private.tasks[ i ];
    
    ObjMultiSet( { 
      { curItem,  { input = itemInput } },
      { curPanelItem,  { pos_x = private.TASKPANEL_LEFT + ( i - 1 ) * private.TASKPANEL_DIFF } },
    } );
    
  end;
  
  --------------------------------------------------------------------------------------------
  -- function win_storage_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_storage_scr" ] = {
    type = "win",
    room = "rm_porch",
    zz = "ho_storage_scr",
    zz_gate = "gho_porch_storage_scr"
  };
  local win_storage_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_storage_scr" ) ) then
 
    end;
    
  end;
  local win_storage_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_storage_scr" ) ) then
    
    end;
    
  end;

  cmn.AddSubscriber( "win_storage_scr", win_storage_scr_inv );
  cmn.AddSubscriber( "win_storage_scr", win_storage_scr_loc, "rm_porch" );
  --------------------------------------------------------------------------------------------------
  local start_storage_scr_func = function ()

    if ( cmn.IsEventStart( "win_storage_scr" ) ) then
    end;

  end;
  cmn.AddSubscriber( "win_storage_scr", start_storage_scr_func, private.room_objname );  

end;


--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopMusEnv();
  common_impl.StopAllMus();

  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.EnvPlay( { "level1/env/aud_closedroom_env" }, "", 0.5 );

  common_impl.PlayMusEnvHO();

  if ( not cmn.IsEventDone( "opn_storage_scr" ) ) then
  
    cmn.SetEventDone( "opn_storage_scr" );
  
  end;
  
  cmn.InitHo( "storage_scr" );
	
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "basket",          1, 0, { { "spr_storage_scr_basket" } } );
  interface.TaskPanelTaskAdd( ho_items, "bike",        1, 0, { { "spr_storage_scr_bike" } } );
  interface.TaskPanelTaskAdd( ho_items, "broom",   1, 0, { { "spr_storage_scr_broom" } } );
  interface.TaskPanelTaskAdd( ho_items, "candle",         1, 0, { { "spr_storage_scr_candle" } } );
  interface.TaskPanelTaskAdd( ho_items, "doll",           1, 0, { { "spr_storage_scr_doll" } } );
  interface.TaskPanelTaskAdd( ho_items, "elephant",   1, 0, { { "spr_storage_scr_elephant" } } );
  interface.TaskPanelTaskAdd( ho_items, "figure",          1, 0, { { "spr_storage_scr_figure" } } );
  interface.TaskPanelTaskAdd( ho_items, "hat",    1, 0, { { "spr_storage_scr_hat" } } );
  interface.TaskPanelTaskAdd( ho_items, "iron",         1, 0, { { "spr_storage_scr_iron" } } );
  interface.TaskPanelTaskAdd( ho_items, "ladder",      1, 0, { { "spr_storage_scr_ladder" } } );
  interface.TaskPanelTaskAdd( ho_items, "skates",          1, 0, { { "spr_storage_scr_skates" } } );
  interface.TaskPanelTaskAdd( ho_items, "opener",         1, 0, { { "spr_storage_scr_opener" } } );
  
  interface.TaskPanelShow( ho_items );
  
  ObjAttach( "obj_storage_scr_taskpanel", "spr_int_taskpanel" );
  ObjSet( "obj_int_taskpanel", { visible = false } );
  ObjSet( "txt_int_taskpanel", { visible = false } );

end;


--*********************************************************************************************************************
function public.Open ()
 
end;
--*********************************************************************************************************************
function public.PreClose ()
  
  cmn.PlayMusEnv();
  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  ObjSet( "obj_int_taskpanel", { visible = true } );
  ObjSet( "txt_int_taskpanel", { visible = true } );

  ObjAttach( "obj_storage_scr_taskpanel", "ho_storage_scr" );

end;


--*********************************************************************************************************************
function public.HoComplete ()
  
end;


--*********************************************************************************************************************
function private.TaskComplete( task_name, part )
  
  cmn.HoTaskFind( "spr_storage_scr_"..task_name, task_name );

  local func_move = function () 
    
    private.TaskPanelUpdate( task_name ); 
    
  end;

  ObjAnimate( "spr_storage_scr_taskpanel_"..task_name, "alp", 0, 0, func_move,
  { 
    0.0, 0, 1.0,
    0.4, 0, 1.0,
    0.6, 0, 0.0
  } );
  
end;
--*********************************************************************************************************************
function private.TaskPanelUpdate ( task_name )

  ObjDelete( "spr_storage_scr_taskpanel_"..task_name );
  
  local index = private.FindIndex( private.tasks, task_name ); 
  
  for j = index, #private.tasks do

    local params = ObjGet( "spr_storage_scr_taskpanel_"..private.tasks[ j ] );
    
    if ( params ) then

      local func_end = "";

      if ( not ObjGet( "spr_storage_scr_"..private.tasks[ j ] ).input ) then

        func_end = function()
          
          local limitX = private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF;
          
          if ( ObjGet( "spr_storage_scr_taskpanel_"..private.tasks[ j ] ) and 
          ( ObjGet( "spr_storage_scr_taskpanel_"..private.tasks[ j ] ).pos_x < limitX ) and 
          ( ObjGet( "spr_storage_scr_"..private.tasks[ j ] ).alp == 1 ) ) then
            
            ObjSet( "spr_storage_scr_"..private.tasks[ j ], { input = true } );
            
          end;

        end;

      end;          

      if ( not private.IsFound( private.tasks[ j ] ) ) then
        
        ObjAnimate( "spr_storage_scr_taskpanel_"..private.tasks[ j ], "pos_x", 0, 0, func_end, 
        { 
          0.0, 3, params.pos_x, 
          0.4, 3, params.pos_x - private.TASKPANEL_DIFF
        } );
        
      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.FindIndex( arr, elem ) -- поиск по таблице 

  for i = 1, #arr do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
function private.IsFound( task ) -- поиск по таблице 

  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_storage_scr" ].found;
  
  for i = 1, #progress do
    
    if ( progress[ i ].task == task ) then

      return true;

    end;
    
  end;
  
  return false;  

end;



