-- name=ho_underbookcase_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "underbookcase_scr" );
  game.relations[ "ho_underbookcase_scr" ].exitroom = "rm_library";
  private.room_objname = "ho_underbookcase_scr";
  --------------------------------------------------------------------------------------------------
  private.TASKPANEL_LEFT = -250;
  private.TASKPANEL_DIFF = 120;
  private.TASKPANEL_COUNT = 5;
  
  private.tasks = { 
                    "bottle", "bug", "crest", "fang", "glasses", "moon", 
                    "napkin", "pen", "ring", "picture", "star", "spiral", "tongs"
                  };

  ObjMultiSet( { 
    { "spr_underbookcase_scr_bottle",        { event_mdown = function() private.TaskComplete( "bottle" ); end } },
    { "spr_underbookcase_scr_bug",           { event_mdown = function() private.TaskComplete( "bug" );    end } },
    { "spr_underbookcase_scr_crest",         { event_mdown = function() private.TaskComplete( "crest" );  end } },
    { "spr_underbookcase_scr_fang",          { event_mdown = function() private.TaskComplete( "fang" );   end } },
    { "spr_underbookcase_scr_glasses",       { event_mdown = function() private.TaskComplete( "glasses" );end } },
    { "spr_underbookcase_scr_moon",          { event_mdown = function() private.TaskComplete( "moon" );   end } },
    { "spr_underbookcase_scr_napkin",        { event_mdown = function() private.TaskComplete( "napkin" ); end } },
    { "spr_underbookcase_scr_pen",           { event_mdown = function() private.TaskComplete( "pen" );    end } },
    { "spr_underbookcase_scr_picture",       { event_mdown = function() private.TaskComplete( "picture" );end } },
    { "spr_underbookcase_scr_ring",          { event_mdown = function() private.TaskComplete( "ring" );   end } },
    { "spr_underbookcase_scr_star",          { event_mdown = function() private.TaskComplete( "star" );   end } },
    { "spr_underbookcase_scr_spiral",        { event_mdown = function() private.TaskComplete( "spiral" ); end } },
    { "spr_underbookcase_scr_tongs",         { event_mdown = function() private.TaskComplete( "tongs" );  end } },    
    
  } );
  
  for i = 1, #private.tasks do

    local itemInput = false;
    
    if ( i <= private.TASKPANEL_COUNT ) then 
      
      itemInput = true;
      
    end;
    
    local curItem = "spr_underbookcase_scr_"..private.tasks[ i ];
    local curPanelItem = "spr_underbookcase_scr_taskpanel_"..private.tasks[ i ];
    
    ObjMultiSet( { 
      { curItem,  { input = itemInput } },
      { curPanelItem,  { pos_x = private.TASKPANEL_LEFT + ( i - 1 ) * private.TASKPANEL_DIFF } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  -- function win_underbookcase_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_underbookcase_scr" ] = {
    type = "win",
    room = "rm_library",
    zz = "ho_underbookcase_scr",
    zz_gate = "gho_library_underbookcase_scr"
  };
  local win_underbookcase_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_underbookcase_scr" ) ) then
        
    end;
    
  end;
  local win_underbookcase_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_underbookcase_scr" ) ) then
    
    end;
    
  end;

  cmn.AddSubscriber( "win_underbookcase_scr", win_underbookcase_scr_inv );
  cmn.AddSubscriber( "win_underbookcase_scr", win_underbookcase_scr_loc, "rm_library" );
  --------------------------------------------------------------------------------------------------
  local start_underbookcase_scr_func = function ()

  if ( cmn.IsEventStart( "win_underbookcase_scr" ) ) then
  end;

  end;
  cmn.AddSubscriber( "win_underbookcase_scr", start_underbookcase_scr_func, private.room_objname );  

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayMusEnvHO();

  if ( not cmn.IsEventDone( "opn_underbookcase_scr" ) ) then
  
    cmn.SetEventDone( "opn_underbookcase_scr" );
  
  end;
  
  cmn.InitHo( "underbookcase_scr" );
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bottle",     1, 0, { { "spr_underbookcase_scr_bottle" } } );
  interface.TaskPanelTaskAdd( ho_items, "bug",        1, 0, { { "spr_underbookcase_scr_bug" } } );
  interface.TaskPanelTaskAdd( ho_items, "crest",      1, 0, { { "spr_underbookcase_scr_crest" } } );
  interface.TaskPanelTaskAdd( ho_items, "fang",       1, 0, { { "spr_underbookcase_scr_fang" } } );
  interface.TaskPanelTaskAdd( ho_items, "glasses",    1, 0, { { "spr_underbookcase_scr_glasses" } } );
  interface.TaskPanelTaskAdd( ho_items, "moon",       1, 0, { { "spr_underbookcase_scr_moon" } } );
  interface.TaskPanelTaskAdd( ho_items, "napkin",     1, 0, { { "spr_underbookcase_scr_napkin" } } );
  interface.TaskPanelTaskAdd( ho_items, "pen",        1, 0, { { "spr_underbookcase_scr_pen" } } );
  interface.TaskPanelTaskAdd( ho_items, "picture",    1, 0, { { "spr_underbookcase_scr_picture" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring",       1, 0, { { "spr_underbookcase_scr_ring" } } );
  interface.TaskPanelTaskAdd( ho_items, "star",       1, 0, { { "spr_underbookcase_scr_star" } } );
  interface.TaskPanelTaskAdd( ho_items, "spiral",     1, 0, { { "spr_underbookcase_scr_spiral" } } );
  interface.TaskPanelTaskAdd( ho_items, "tongs",     1, 0, { { "spr_underbookcase_scr_tongs" } } );

  interface.TaskPanelShow( ho_items );
  
  ObjAttach( "obj_underbookcase_scr_taskpanel", "spr_int_taskpanel" );
  ObjSet( "obj_int_taskpanel", { visible = false } );
  ObjSet( "txt_int_taskpanel", { visible = false } );
        
end;
--*********************************************************************************************************************
function public.Open ()

  --if ( not private.opn_underbookcase_scr ) then
    private.AnmHorror();
    private.opn_underbookcase_scr = true;
  --end;
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();

  ObjSet( "obj_int_taskpanel", { visible = true } );
  ObjSet( "txt_int_taskpanel", { visible = true } );

  ObjAttach( "obj_underbookcase_scr_taskpanel", "ho_underbookcase_scr" );

end;
--*********************************************************************************************************************
function public.HoComplete ()
 
end;
--*********************************************************************************************************************
function private.TaskComplete ( task_name, part )
  
  cmn.HoTaskFind( "spr_underbookcase_scr_"..task_name, task_name );

  local func_move = function () 
    
    private.TaskPanelUpdate( task_name ); 
    
  end;

  ObjAnimate( "spr_underbookcase_scr_taskpanel_"..task_name, "alp", 0, 0, func_move,
  { 
    0.0, 0, 1.0,
    0.4, 0, 1.0,
    0.6, 0, 0.0
  } );
  
end;
--*********************************************************************************************************************
function private.TaskPanelUpdate ( task_name )

  ObjDelete( "spr_underbookcase_scr_taskpanel_"..task_name );
  
  local index = private.FindIndex( private.tasks, task_name ); 
  
  for j = index, #private.tasks do

    local params = ObjGet( "spr_underbookcase_scr_taskpanel_"..private.tasks[ j ] );
    
    if ( params ) then
      
      local func_end = "";

      if ( not ObjGet( "spr_underbookcase_scr_"..private.tasks[ j ] ).input ) then

        func_end = function()
          
          local limitX = private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF;
          
          if ( ObjGet( "spr_underbookcase_scr_taskpanel_"..private.tasks[ j ] ) and 
          ( ObjGet( "spr_underbookcase_scr_taskpanel_"..private.tasks[ j ] ).pos_x < limitX ) and 
          ( ObjGet( "spr_underbookcase_scr_"..private.tasks[ j ] ).alp == 1 ) ) then
            
            ObjSet( "spr_underbookcase_scr_"..private.tasks[ j ], { input = true } );
            
          end;

        end;
    
      end;  

      if ( not private.IsFound( private.tasks[ j ] ) ) then
        
        ObjAnimate( "spr_underbookcase_scr_taskpanel_"..private.tasks[ j ], "pos_x", 0, 0, func_end, 
        { 
          0.0, 3, params.pos_x, 
          0.4, 3, params.pos_x - private.TASKPANEL_DIFF
        } );
        
      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.FindIndex ( arr, elem ) 

  for i = 1, #arr do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
function private.IsFound ( task ) 

  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_underbookcase_scr" ].found;
  
  for i = 1, #progress do
    
    if ( progress[ i ].task == task ) then

      return true;

    end;
    
  end;
  
  return false;  

end;
--*********************************************************************************************************************
function private.AnmHorror (  ) 
  
  local anim_morph_1 = {
                          { anim = "glasses", func = "small_objects" },
                          { anim = "sun", func = "small_objects" },
                          { anim = "napkin", func = "large_objects" },
                          { anim = "leaf", func = "small_objects" },
                          { anim = "picture", func = "big_objects" },
                          { anim = "triangle", func = "big_objects" },
                          { anim = "bottle", func = "large_objects" },
                          { anim = "spiral", func = "big_objects" },
                          { anim = "coin", func = "small_objects" },
                          { anim = "crest", func = "big_objects" },
                          { anim = "keys", func = "small_objects" },
                          { anim = "pen", func = "pen" } 
                        }; 
  
  ObjSet( "anm_underbookcase_scr_horror", { frame = 0 } );
  ObjSet( "anm_underbookcase_scr_eyes_burns", { frame = 0 } );
  AnimPlay( "anm_underbookcase_scr_horror", "behind_all", private.AnmHorrorEnd );
  AnimPlay( "anm_underbookcase_scr_eyes_burns", "eyes_burns", "" );
  ObjAnimate( "obj_underbookcase_scr_morph1", "alp", 0, 0, "",
  {
    0.0, 0, 1,
    0.4, 0, 0
  } );
  ObjAnimate( "obj_underbookcase_scr_morph2", "alp", 0, 0, "",
  {
    0.0, 0, 0,
    0.4, 0, 1
  } );
  ObjSet( "obj_underbookcase_scr_morph1", { input = false } );
  ObjSet( "obj_underbookcase_scr_morph2", { input = true } );
  
  for i = 1, #anim_morph_1, 1 do 
  
    if not private.IsFound( anim_morph_1[ i ].anim )  then
    
      local curAnim = "anm_underbookcase_scr_"..anim_morph_1[ i ].anim;  
      local curFunc = anim_morph_1[ i ].func;
      
      local curSpr = "spr_underbookcase_scr_"..anim_morph_1[ i ].anim; 
      local curX = ObjGet( curSpr ).pos_x;
      local curY = ObjGet( curSpr ).pos_y;
      
      ObjSet( curAnim, { pos_x = curX, pos_y = curY } );
      AnimPlay( curAnim, curFunc, "" );
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.AnmHorrorEnd (  ) 
  
  local anim_morph_2 = {
                          { anim = "moon", func = "small_objects" },
                          { anim = "eye", func = "small_objects" },
                          { anim = "star", func = "big_objects" },
                          { anim = "picture2", func = "big_objects" },
                          { anim = "fang", func = "small_objects" },
                          { anim = "blood", func = "large_objects" },
                          { anim = "smithers", func = "large_objects" },
                          { anim = "mousetrap", func = "big_objects" },
                          { anim = "bug", func = "small_objects" },
                          { anim = "can", func = "big_objects" },
                          { anim = "ring", func = "small_objects" },
                          { anim = "knife", func = "knife" }
                        };                             
                           
  ObjAnimate( "obj_underbookcase_scr_morph2", "alp", 0, 0, private.AnmHorror,
  {
    0.0, 0, 1,
    0.4, 0, 0,
    5.0, 0, 0
  } );
  ObjAnimate( "obj_underbookcase_scr_morph1", "alp", 0, 0, "",
  {
    0.0, 0, 0,
    0.4, 0, 1
  } );
  ObjSet( "obj_underbookcase_scr_morph2", { input = false } );
  ObjSet( "obj_underbookcase_scr_morph1", { input = true } ); 
  
  for i = 1, #anim_morph_2, 1 do 
  
    if not private.IsFound( anim_morph_2[ i ].anim )  then
      
      local curAnim = "anm_underbookcase_scr_"..anim_morph_2[ i ].anim;  
      local curFunc = anim_morph_2[ i ].func;
      
      local curSpr = "spr_underbookcase_scr_"..anim_morph_2[ i ].anim; 
      local curX = ObjGet( curSpr ).pos_x;
      local curY = ObjGet( curSpr ).pos_y;
      
      ObjSet( curAnim, { pos_x = curX, pos_y = curY } );
      AnimPlay( curAnim, curFunc, "" );
      
    end;
    
  end;
  
end;

