-- name=ho_weapon_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "weapon_scr" );
  game.relations[ "ho_weapon_scr" ].exitroom = "rm_weapon_scr_room";
  
  --------------------------------------------------------------------------------------------------
  private.room_objname = "ho_weapon_scr";
  private.task_name = "win_weapon_scr";
  private.win = 6;
  
  private.AnimBat = false;
  
  
  private.coordinates_cover_object = { 
                                        spr_weapon_scr_cup_1_cover = { old = { pos_x = 61, pos_y = 495 }, new = { pos_x = -52, pos_y = 555 } }, 
                                        spr_weapon_scr_cup_2_cover = { old = { pos_x = 809, pos_y = 509 }, new = { pos_x = 727, pos_y = 476 } }, 
                                        spr_weapon_scr_gun_1_cover = { old = { pos_x = 356, pos_y = 139 }, new = { pos_x = 313, pos_y = -16 } }, 
                                        spr_weapon_scr_gun_2_cover = { old = { pos_x = 363, pos_y = 572 }, new = { pos_x = 527, pos_y = 586 } }, 
                                        spr_weapon_scr_hammer_1_cover = { old = { pos_x = 109, pos_y = 241 }, new = { pos_x = 44, pos_y = 386 } },
                                        spr_weapon_scr_hammer_2_cover = { old = { pos_x = 949, pos_y = 487 }, new = { pos_x = 1072, pos_y = 487 } },
                                        spr_weapon_scr_horn_1_cover = { old = { pos_x = 613, pos_y = 458 }, new = { pos_x = 668, pos_y = 505 } }, 
                                        spr_weapon_scr_horn_2_cover = { old = { pos_x = 911, pos_y = 114 }, new = { pos_x = 1081, pos_y = 95 } }, 
                                        spr_weapon_scr_horseshoe_1_cover = { old = { pos_x = 231, pos_y = 369 }, new = { pos_x = 190, pos_y = 505 } }, 
                                        spr_weapon_scr_horseshoe_2_cover = { old = { pos_x = 784, pos_y = 242 }, new = { pos_x = 772, pos_y = 158 } },
                                        spr_weapon_scr_scratch_1_cover = { old = { pos_x = 474, pos_y = 512 }, new = { pos_x = 546, pos_y = 506 } }, 
                                        spr_weapon_scr_scratch_2_cover = { old = { pos_x = 602, pos_y = 86 }, new = { pos_x = 539, pos_y = 40 } }, 
                                     };
                         
  --------------------------------------------------------------------------------------------------

  private.moving_type = { 
                            spr_weapon_scr_cup_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_cup_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_gun_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_gun_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_hammer_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_hammer_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_horn_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_horn_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_horseshoe_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_horseshoe_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_scratch_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_weapon_scr_scratch_2_cover = "MOVE_XY_COVER_OBJECT" 
                        };
                          
  --------------------------------------------------------------------------------------------------

  ObjMultiSet( {  
    { "spr_weapon_scr_cup_1_cover",             { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_cup_1_cover", "cup" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_cup_2_cover",             { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_cup_2_cover", "cup" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_gun_1_cover",             { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_gun_1_cover", "gun" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_gun_2_cover",             { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_gun_2_cover", "gun" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_hammer_1_cover",          { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_hammer_1_cover", "hammer" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_hammer_2_cover",          { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_hammer_2_cover", "hammer" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_horn_1_cover",            { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_horn_1_cover", "horn" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_horn_2_cover",            { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_horn_2_cover", "horn" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_horseshoe_1_cover",       { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_horseshoe_1_cover", "horseshoe" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_horseshoe_2_cover",       { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_horseshoe_2_cover", "horseshoe" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_scratch_1_cover",         { input = true, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_scratch_1_cover", "scratch" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_scratch_2_cover",         { input = true, 
                                              event_mdown = function()
                                                              private.TaskComplete( "spr_weapon_scr_scratch_2_cover", "scratch" );
                                                              if not private.AnimBat then
                                                                common_impl.PlayAudio( "sfx", "level1/sfx/aud_sc_shadow", 0, "", 0 );
                                                                AnimPlay( "anm_weapon_scr_bat", "bat", "" );
                                                                private.AnimBat = true;
                                                              end;
                                                            end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    { "spr_weapon_scr_core",                    { input = false, 
                                              event_mdown = function() private.TaskComplete( "spr_weapon_scr_core", "core" ) end,
                                              event_menter = function () SetCursor( CURSOR_HAND ); end,
                                              event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } },
    
  } );    
                                            
                                              
  --------------------------------------------------------------------------------------------
  -- function win_weapon_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_weapon_scr" ] = {
    type = "win",
    room = "rm_weapon_scr_room",
    zz = "ho_weapon_scr",
    zz_gate = "gho_weapon_scr_room_weapon_scr"
  };
  local win_weapon_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_weapon_scr" ) ) then
    end;
    
  end;
  local win_weapon_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_weapon_scr" ) ) then
    end;
    
  end;

  cmn.AddSubscriber( "win_weapon_scr", win_weapon_scr_inv );
  cmn.AddSubscriber( "win_weapon_scr", win_weapon_scr_loc, "rm_weapon_scr_room" );
  
  --------------------------------------------------------------------------------------------------
  local start_weapon_scr_func = function ()

    if ( cmn.IsEventStart( "win_weapon_scr" ) ) then
    end;

  end;
  cmn.AddSubscriber( "win_weapon_scr", start_weapon_scr_func, private.room_objname );  

end;


--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level3/env/aud_weapon_scr_room_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_weapon_scr" ) ) then
  
    cmn.SetEventDone( "opn_weapon_scr" );

  end;
  
  cmn.InitHo( "weapon_scr" );
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = {};
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = {};
	
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "cup_1",       1, 0, { { "spr_weapon_scr_cup_1_cover", "spr_weapon_scr_cup_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "cup_2",       1, 0, { { "spr_weapon_scr_cup_2_cover", "spr_weapon_scr_cup_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "gun_1",       1, 0, { { "spr_weapon_scr_gun_1_cover",  "spr_weapon_scr_gun_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "gun_2",       1, 0, { { "spr_weapon_scr_gun_2_cover",  "spr_weapon_scr_gun_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "hammer_1",    1, 0, { { "spr_weapon_scr_hammer_1_cover",  "spr_weapon_scr_hammer_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "hammer_2",    1, 0, { { "spr_weapon_scr_hammer_2_cover",  "spr_weapon_scr_hammer_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "horn_1",      1, 0, { { "spr_weapon_scr_horn_1_cover",   "spr_weapon_scr_horn_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "horn_2",      1, 0, { { "spr_weapon_scr_horn_2_cover",   "spr_weapon_scr_horn_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "horseshoe_1", 1, 0, { { "spr_weapon_scr_horseshoe_1_cover",   "spr_weapon_scr_horseshoe_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "horseshoe_2", 1, 0, { { "spr_weapon_scr_horseshoe_2_cover",   "spr_weapon_scr_horseshoe_1_cover"  } } );
  interface.TaskPanelTaskAdd( ho_items, "scratch_1",   1, 0, { { "spr_weapon_scr_scratch_1_cover", "spr_weapon_scr_scratch_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "scratch_2",   1, 0, { { "spr_weapon_scr_scratch_2_cover", "spr_weapon_scr_scratch_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "core",        1, 0, { { "spr_weapon_scr_core" } } );

  ObjAttach( "obj_int_taskpanel_weapon_scr", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 
  interface.TaskPanelShow( ho_items );

end;


--*********************************************************************************************************************
function public.Open ()
end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  
  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_weapon_scr" );

end;


--*********************************************************************************************************************
function public.HoComplete ()
 
end;


--*********************************************************************************************************************
function private.TaskComplete( sender, task ) 
 
  local EMPTY_PROGRESS = 0;
  local ACTIVATE_WIN_OBJECT = 6;
  local NOT_COMPLETED_COUPLE = 1;
  local COMPLETED_COUPLE = 2;

  local foundCouples = {};
  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local countFoundCouples = #foundCouples;

  local nameTaskObjects = {};
  nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

  if countFoundCouples == EMPTY_PROGRESS then
 
    local foundTask = { task };
    table.insert( foundCouples, foundTask );

    local foundObjectTask = { sender };
    table.insert( nameTaskObjects, foundObjectTask );

    private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
    private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
    ObjSet( sender, { input = false } );

    cmn.Lock( true );

  else 

    local lastCouple = foundCouples[ countFoundCouples ];
    local sizeLastCouple = #lastCouple;

    if sizeLastCouple == COMPLETED_COUPLE then   

      if countFoundCouples == ACTIVATE_WIN_OBJECT then 

        local taskObjectNameWin = "spr_weapon_scr_"..task;
        cmn.HoTaskFind( taskObjectNameWin, task );
        private.TaskPanel( "WINNING", "core" );

      else 

        local foundTask = { task };
        table.insert( foundCouples, foundTask );

        local foundObjectTask = { sender };
        table.insert( nameTaskObjects, foundObjectTask );

        private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
        private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );

      end;

    elseif sizeLastCouple == NOT_COMPLETED_COUPLE then  

      local firstObject = lastCouple[ 1 ];
      local lastObjectTask = nameTaskObjects[ #nameTaskObjects ];
      local prevSender = lastObjectTask[ 1 ];

      if firstObject == task then 

        table.insert( lastCouple, task );
        table.insert( lastObjectTask, sender );

        local taskObjectName_1 = "spr_weapon_scr_"..task.."_1";
        local task_1 = task.."_1";
        cmn.HoTaskFind( taskObjectName_1, task_1 );
        
        --common_impl.StopAudio( "sfx", "aud_hide_sfx", 0 );
        common_impl.StopAudio( "sfx", "aud_clk_ho_sfx2", 0 );
        
        local taskObjectName_2 = "spr_weapon_scr_"..task.."_2";
        local task_2 = task.."_2";
        cmn.HoTaskFind( taskObjectName_2, task_2 );
        
        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_RIGHT_COUPLE", task );
        private.TaskPanel( "RIGHT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );

        if countFoundCouples == ACTIVATE_WIN_OBJECT then 

          ObjSet( "spr_weapon_scr_core", { input = true } );

          local func_end_win = function () 
            private.TaskPanel( "ACTIVATE_WIN_OBJECT", "core" );
          end;

          ObjAnimate( "obj_weapon_scr_items", "alp",0,0, func_end_win, { 0, 0, 1,    0.7, 0, 1 } );

        end;

      else 

        table.remove( foundCouples );
        table.remove( nameTaskObjects );

        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_WRONG_COUPLE", task, prevSender );
        private.TaskPanel( "WRONG_COMPLETED_COUPLE", firstObject );
        ObjSet( prevSender, { input = true } );

        cmn.Lock( true );

      end;

    end;

  end;
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = foundCouples;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = nameTaskObjects;
  
  if ( #ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples > 0 ) then

    local sizeS = #ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;

    if ( #ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples[ sizeS ] == 1 ) then
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples[ sizeS ][ 1 ];
    else
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = "";
    end;

  else 

    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = "";

  end;
  
end;


--*********************************************************************************************************************
function private.MoveCoveringObjects( taskObject, moveType, direction ) 

  if moveType == "MOVE_XY_COVER_OBJECT" then 

    local oldX = private.coordinates_cover_object[ taskObject ].old.pos_x;
    local oldY = private.coordinates_cover_object[ taskObject ].old.pos_y;

    local newX = private.coordinates_cover_object[ taskObject ].new.pos_x;
    local newY = private.coordinates_cover_object[ taskObject ].new.pos_y;

    local beginX = 0;
    local beginY = 0;

    local endX = 0;
    local endY = 0;

    if direction == "OLD_TO_NEW" then 

      beginX = oldX;
      beginY = oldY;

      endX = newX;
      endY = newY;
      
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_move_ho_parts", 0, "", 0 );

    elseif direction == "NEW_TO_OLD" then 

      beginX = newX;
      beginY = newY;

      endX = oldX;
      endY = oldY;

      common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );

    end;

    ObjAnimate( taskObject, "pos_xy",0,0, "", { 0, 3, beginX, beginY,    0.4, 3, endX, endY } );
    
  end;

end;


--*********************************************************************************************************************
function private.AnimCoveringObjects( sender, animType, task, prevSender ) 

  local func_end_block = function () 

    cmn.Lock( false );

  end;

  if animType == "FIRST_OBJECT_OF_COUPLE" then 

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( private.room_objname, "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_RIGHT_COUPLE" then 

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( private.room_objname, "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_WRONG_COUPLE" then 

    local func_end = function () 

      if prevSender then 
        private.MoveCoveringObjects( prevSender, private.moving_type[ prevSender ], "NEW_TO_OLD" );
        private.MoveCoveringObjects( sender, private.moving_type[ sender ], "NEW_TO_OLD" ); 
      end;

    end;

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( private.room_objname, "alp",0,0, func_end, { 0, 0, 1,    0.4, 0, 1 } );
    ObjAnimate( private.room_objname, "scale_x",0,0, func_end_block, { 0, 0, 1,    1.0, 0, 1 } );

  end; 

end;


--*********************************************************************************************************************
function private.TaskPanelUpdate() 

  ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );

  ObjSet( "txt_weapon_scr_taskpanel", { pos_x = 0, pos_y = 15 } );
  ObjAttach( "txt_weapon_scr_taskpanel", "obj_int_taskpanel_weapon_scr" );

  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local count = 6 - #foundCouples;

  local COLOR_R = 1;
  local COLOR_G = 1;
  local COLOR_B = 1;

  ObjSet( "txt_weapon_scr_taskpanel",
  {
     text   = "str_int_taskpanel_pattern_couples",
     param0 = COLOR_R,
     param1 = COLOR_G,
     param2 = COLOR_B,
     param3 = StringGet( "str_taskpanel_couple_ho" ),
     param4 = count
   } );

  if count == 0 then 
  
    ObjSet( "txt_weapon_scr_taskpanel", { alp = 0 } );

  end;

end;


--*********************************************************************************************************************
function private.TaskPanel( animType, curTask ) 

  local OBJECT_Y = 15;
  local OBJECT_LEFT_X = -170;
  local OBJECT_MIDDLE_X = 0;
  local OBJECT_RIGHT_X = 170;

  if animType == "NOT_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_weapon_scr_"..curTask.."_shadow_1";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_weapon_scr" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_LEFT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( "txt_weapon_scr_taskpanel", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 0, 0 } );

  elseif animType == "RIGHT_COMPLETED_COUPLE" then 

    local taskPanelObject_1 = "spr_weapon_scr_"..curTask.."_shadow_1";
    local taskPanelObject_2 = "spr_weapon_scr_"..curTask.."_shadow_2";
    ObjAttach( taskPanelObject_2, "obj_int_taskpanel_weapon_scr" ); 

    local func_end = function () 

      ObjAnimate( taskPanelObject_1, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
      ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
------------------------------
------------------------------
      local fxTaskPanelObject = "fx_weapon_scr_"..curTask;
      local pos = GetObjPosByObj( taskPanelObject_1, "obj_int_taskpanel_weapon_scr" );
      ObjCreate( fxTaskPanelObject, "partsys" );
      ObjSet( fxTaskPanelObject,
      {
        res = "assets/interface/resources/ho_collect_effect",
        blendmode = 2, color_r = 0.8, color_g = 0.4, color_b = 1, 
        alp = 1, visible = true, pos_x = pos[1], pos_y = pos[2], pos_z = 1, input = false
      } );

      local func_end_fx = function () 
        ObjDelete( fxTaskPanelObject );
      end;

      ObjAttach( fxTaskPanelObject, "obj_int_taskpanel_weapon_scr" );
      ObjAnimate( fxTaskPanelObject, "alp", 0, 0, func_end_fx, { 0, 0, 1,    0.4, 0, 1,    0.7, 0, 0 } );
------------------------------
------------------------------
      private.TaskPanelUpdate();
      ObjAnimate( "txt_weapon_scr_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

    end;

    ObjSet( taskPanelObject_2, { pos_x = OBJECT_RIGHT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( taskPanelObject_1, "pos_x",0,0, "", { 0, 3, OBJECT_LEFT_X,    0.3, 3, OBJECT_LEFT_X,    0.7, 3, OBJECT_MIDDLE_X } );
    ObjAnimate( taskPanelObject_2, "pos_x",0,0, func_end, { 0, 3, OBJECT_RIGHT_X,    0.3, 3, OBJECT_RIGHT_X,    0.7, 3, OBJECT_MIDDLE_X } );   

  elseif animType == "WRONG_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_weapon_scr_"..curTask.."_shadow_1";

    local func_end = function () 

      ObjDetach( taskPanelObject );

    end;

    ObjAnimate( taskPanelObject, "alp",0,0, func_end, { 0, 3, 1,    0.3, 3, 0 } );

    private.TaskPanelUpdate();
    ObjAnimate( "txt_weapon_scr_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

  elseif animType == "ACTIVATE_WIN_OBJECT" then 

    local taskPanelObject = "spr_weapon_scr_"..curTask.."_shadow";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_weapon_scr" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_MIDDLE_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

  elseif animType == "WINNING" then 

    local taskPanelObject = "spr_weapon_scr_"..curTask.."_shadow";
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );

  end;

end;



