-- name=ho_winecollection_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "winecollection_scr" );
  game.relations[ "ho_winecollection_scr" ].exitroom = "rm_winecellar";
  private.room_objname = "ho_winecollection_scr";
  --------------------------------------------------------------------------------------------------
  
  private.TASKPANEL_LEFT = -250;
  private.TASKPANEL_DIFF = 120;
  private.TASKPANEL_COUNT = 5;

  private.tasks = { 
                    "chain", "bat", "wineglass", "corkscrew", "leaf", "hat", "knife", 
                    "mushroom", "symbol_1", "symbol_2", "medallion", "crane"
                  };

  local table_set = {};
  for i = 1, #private.tasks do
    table.insert( table_set,  { "spr_winecollection_scr_"..private.tasks[ i ], { event_mdown = function() private.TaskComplete( private.tasks[ i ] ); end } } )
  end;

  table.insert( table_set,  { "spr_winecollection_scr_letter", { event_mdown = function() cmn.NoteScale( "spr_winecollection_scr_letter" ) end } } )
  table.insert( table_set,  { "spr_winecollection_scr_letter_big", { event_mdown = function() cmn.NoteScale( "spr_winecollection_scr_letter" ) end } } )

  ObjMultiSet( table_set );

  for i = 1, #private.tasks do

    local itemInput = false;
    
    if ( i <= private.TASKPANEL_COUNT ) then 
      
      itemInput = true;
      
    end;
    
    local curItem = "spr_winecollection_scr_"..private.tasks[ i ];
    local curPanelItem = "spr_winecollection_scr_taskpanel_"..private.tasks[ i ];
    
    ObjMultiSet( { 
      { curItem,  { input = itemInput } },
      { curPanelItem,  { pos_x = private.TASKPANEL_LEFT + ( i - 1 ) * private.TASKPANEL_DIFF } },
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  -- function win_winecollection_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_winecollection_scr" ] = {
    type = "win",
    room = "rm_winecellar",
    zz = "ho_winecollection_scr",
    zz_gate = "gho_winecellar_winecollection_scr"
  };
  local win_winecollection_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_winecollection_scr" ) ) then
   
    end;
    
  end;
  local win_winecollection_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_winecollection_scr" ) ) then
    
    end;
    
  end;

  cmn.AddSubscriber( "win_winecollection_scr", win_winecollection_scr_inv );
  cmn.AddSubscriber( "win_winecollection_scr", win_winecollection_scr_loc, "rm_winecellar" );
  --------------------------------------------------------------------------------------------------
  local start_winecollection_scr_func = function ()

  if ( cmn.IsEventStart( "win_winecollection_scr" ) ) then
  end;

  end;
  cmn.AddSubscriber( "win_winecollection_scr", start_winecollection_scr_func, private.room_objname );  

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();

  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level2/env/aud_winecellar_env", 0, "", 0 );
  common_impl.PlayMusEnvHO();

  if ( not cmn.IsEventDone( "opn_winecollection_scr" ) ) then
  
    cmn.SetEventDone( "opn_winecollection_scr" );
  
  end;
  
  cmn.InitHo( "winecollection_scr" );
  local ho_items = {};

  for i = 1, 12 do
    interface.TaskPanelTaskAdd( ho_items, private.tasks[ i ],          1, 0, { { "spr_winecollection_scr_"..private.tasks[ i ] } } );
  end;
  
  interface.TaskPanelShow( ho_items );

  ObjAttach( "obj_winecollection_scr_taskpanel", "spr_int_taskpanel" );
  ObjSet( "obj_int_taskpanel", { visible = false } );
  ObjSet( "txt_int_taskpanel", { visible = false } );

  private.InitAnimations();

end;
--*********************************************************************************************************************
function public.Open ()
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();

  ObjSet( "obj_int_taskpanel", { visible = true } );
  ObjSet( "txt_int_taskpanel", { visible = true } );

  ObjAttach( "obj_winecollection_scr_taskpanel", "ho_winecollection_scr" );

  cmn.NoteScaleClose( { "spr_winecollection_scr_letter" } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  --common_impl.PlayAudio( "sfx", "aud_ho_win" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete ( task_name )

  cmn.HoTaskFind( "spr_winecollection_scr_"..task_name, task_name );

  if ( task_name == "bat" ) then
    ObjDelete( "anm_winecollection_scr_bat" );

  elseif ( task_name == "mushroom" ) then

    ObjDelete( "anm_winecollection_scr_mushroom" );

  elseif ( task_name == "hat" ) then

    cmn.Lock( true );

  end;

  local func_move = function () 
    
    private.TaskPanelUpdate( task_name ); 

    if ( task_name == "hat" ) then
      common_impl.PlayAudio( "sfx", "level2/sfx/aud_scull_ghost_sc", 0, "", 0 );
      AnimPlay( "anm_winecollection_scr_skull", "skull", function () cmn.Lock( false ); end )
    end;
    
  end;

  ObjAnimate( "spr_winecollection_scr_taskpanel_"..task_name, "alp", 0, 0, func_move,
  { 
    0.0, 0, 1.0,
    0.4, 0, 1.0,
    0.6, 0, 0.0
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TaskPanelUpdate ( task_name )

  ObjDelete( "spr_winecollection_scr_taskpanel_"..task_name );
  
  local index = private.FindIndex( private.tasks, task_name ); 
  
  for j = index, #private.tasks do

    local params = ObjGet( "spr_winecollection_scr_taskpanel_"..private.tasks[ j ] );
    
    if ( params ) then

      local func_end = "";

      if ( not ObjGet( "spr_winecollection_scr_"..private.tasks[ j ] ).input ) then

        func_end = function()
          
          local limitX = private.TASKPANEL_LEFT + private.TASKPANEL_COUNT * private.TASKPANEL_DIFF;
          
          if ( ObjGet( "spr_winecollection_scr_taskpanel_"..private.tasks[ j ] ) and 
          ( ObjGet( "spr_winecollection_scr_taskpanel_"..private.tasks[ j ] ).pos_x < limitX ) and 
          ( ObjGet( "spr_winecollection_scr_"..private.tasks[ j ] ).alp == 1 ) ) then
            
            ObjSet( "spr_winecollection_scr_"..private.tasks[ j ], { input = true } );
            
          end;

        end;

      end;          

      if ( not private.IsFound( private.tasks[ j ] ) ) then
        
        ObjAnimate( "spr_winecollection_scr_taskpanel_"..private.tasks[ j ], "pos_x", 0, 0, func_end, 
        { 
          0.0, 3, params.pos_x, 
          0.4, 3, params.pos_x - private.TASKPANEL_DIFF
        } );
        
      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.FindIndex( arr, elem ) -- поиск по таблице 

  for i = 1, #arr do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
function private.IsFound( task ) -- поиск по таблице 

  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_winecollection_scr" ].found;
  
  for i = 1, #progress do
    
    if ( progress[ i ].task == task ) then

      return true;

    end;
    
  end;
  
  return false;  

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_winecollection_scr_chain_hook", "ang", 1, 0, "", { 0, 3, 0, 3, 3, -0.03, 6, 3, 0 } )

end;