-- name=ho_withflashlight_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "withflashlight_scr" );
  game.relations[ "ho_withflashlight_scr" ].exitroom = "rm_stairflight";
  private.room_objname = "ho_withflashlight_scr";
  --------------------------------------------------------------------------------------------------
  

  private.task_name = "win_withflashlight_scr";
  private.cover_count = 12;
  private.item_count = 6;
  
  for i = 1, private.cover_count, 1 do 

    local curCover = "spr_withflashlight_scr_piece_"..i.."_cover";  
    ObjSet( curCover, { input = true, event_mdown = function() private.CoverClick( i ); end } );
 
  end; 
                   
  for i = 1, private.item_count, 1 do 

    local curItem = "spr_withflashlight_scr_piece_"..i.."_item";
    ObjSet( curItem, { input = false, 
                       event_mdown = function() private.ItemClick( i ); end, 
                       event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
                       event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                     } );

  end;   
                     
  ObjSet( "spr_withflashlight_scr_amulet", { input = false, 
                                       event_mdown = function() cmn.HoTaskFind( "spr_withflashlight_scr_amulet", "amulet" ); end, 
                                       event_menter = function () common_impl.SetCursor( CURSOR_GET ); end,
                                       event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                                     } );         
                   
  --------------------------------------------------------------------------------------------
  -- function win_withflashlight_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_withflashlight_scr" ] = {
    type = "win",
    room = "rm_stairflight",
    zz = "ho_withflashlight_scr",
    zz_gate = "gho_stairflight_withflashlight_scr"
  };
  local win_withflashlight_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_withflashlight_scr" ) ) then
    
    end;
    
  end;
  local win_withflashlight_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_withflashlight_scr" ) ) then
    
    end;
    
  end;

  cmn.AddSubscriber( "win_withflashlight_scr", win_withflashlight_scr_inv );
  cmn.AddSubscriber( "win_withflashlight_scr", win_withflashlight_scr_loc, "rm_stairflight" );
  --------------------------------------------------------------------------------------------------
  local start_withflashlight_scr_func = function ()

  if ( cmn.IsEventStart( "win_withflashlight_scr" ) ) then

  end;

  end;
  cmn.AddSubscriber( "win_withflashlight_scr", start_withflashlight_scr_func, private.room_objname );  

  ObjSet("obj_withflashlight_scr_light_transparent",{
    event_mdown = function() private.light_down(); end,
    event_mup = function() private.light_up(); end
  });
    
end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayMusEnvHO();

  if ( not cmn.IsEventDone( "opn_withflashlight_scr" ) ) then

    cmn.SetEventDone( "opn_withflashlight_scr" );
  
  end;
  
  cmn.InitHo( "withflashlight_scr" );
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items = {};
  
  local ho_items = {};

  for i = 1, private.cover_count, 1 do 
    
    local curCover = "spr_withflashlight_scr_piece_"..i.."_cover";
    local curCoverTask = "piece_"..i.."_cover";
     
    interface.TaskPanelTaskAdd( ho_items, curCoverTask,             1, 0, { { curCover } } );

  end; 

  for i = 1, private.item_count, 1 do 

    local curItem = "spr_withflashlight_scr_piece_"..i.."_item";
    local curItemTask = "piece_"..i.."_item";
    interface.TaskPanelTaskAdd( ho_items, curItemTask,              1, 0, { { curItem } } );

  end; 
  
  interface.TaskPanelTaskAdd( ho_items, "amulet",                   1, 0, { { "spr_withflashlight_scr_amulet" } } );
  interface.TaskPanelShow( ho_items );  

  ObjAttach( "obj_int_taskpanel_withflashlight_scr", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 
  
  private.CursorFlashlight();

end;


--*********************************************************************************************************************
function public.Open ()
  
end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;

--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();

  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_withflashlight_scr" );

end;

--*********************************************************************************************************************
function public.HoComplete ()
  
end;

--*********************************************************************************************************************
function private.CoverClick ( id )

  local curCover = "spr_withflashlight_scr_piece_"..id.."_cover";
  local curCoverTask = "piece_"..id.."_cover";

  cmn.HoTaskFind( curCover, curCoverTask );
  
  if ( id <= private.item_count ) then 

    local curItem = "spr_withflashlight_scr_piece_"..id.."_item";
    ObjSet( curItem, { input = true } );

  end; 

  local element = { id_part = id, is_piece_found = false }; 
  table.insert( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items, element ); 
  
  if ( private.CheckingOnAllItemsFound() and
  private.CheckingOnAllCoversFound() ) then 

    ObjMultiSet( { 
      { "spr_withflashlight_scr_amulet",  { alp = 1, visible = true, input = true } },
      { "obj_withflashlight_scr_pieces",  { alp = 0, visible = false, input = false } },
    } );
    
  end; 
  
  private.TaskPanelUpdate(); 

end;

--*********************************************************************************************************************
function private.ItemClick ( id )

  local func_end = function () 

    cmn.Lock( false );

  end;

  local curItem = "spr_withflashlight_scr_piece_"..id.."_item";
  local curItemTask = "piece_"..id.."_item";
  
  cmn.HoTaskFind( curItem, curItemTask );

  local curPiece = "spr_withflashlight_scr_piece_"..id;

  cmn.Lock( true );
  ObjAnimate( curPiece, "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1 } );

  private.MarkingFoundItem( id );
  
  if ( private.CheckingOnAllItemsFound() and
  private.CheckingOnAllCoversFound() ) then 

    ObjMultiSet( { 
      { "spr_withflashlight_scr_amulet",  { alp = 1, visible = true, input = true } },
      { "obj_withflashlight_scr_pieces",  { alp = 0, visible = false, input = false } },
    } );

  end;
  
  private.TaskPanelUpdate();

end;

--*********************************************************************************************************************
function private.TaskPanelUpdate () 

  if private.CheckingOnAllCoversFound() then 

    ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );
    ObjSet( "txt_withflashlight_scr_taskpanel", { alp = 1, visible = true } );

    local count = private.item_count - private.GettingFoundItemsCount();

    ObjSet( "txt_withflashlight_scr_taskpanel",
    {
       text   = "str_withflashlight_scr_task",
       param0 = count
    } );

    if count == 0 then 
    
      ObjSet( "txt_withflashlight_scr_taskpanel", { text = "str_withflashlight_scr_final" } );

    end;

  end;

end;

--*********************************************************************************************************************
function private.MarkingFoundItem ( id )

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].id_part == id ) and ( not foundItems[ i ].is_piece_found ) then 

      foundItems[ i ].is_piece_found = true; 
      break; 

    end; 

  end; 

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items = foundItems; 

end; 

--*********************************************************************************************************************
function private.CheckingOnAllItemsFound ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local result = false; 
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].is_piece_found ) then 

      count = count + 1; 

    end; 

  end; 

  if private.item_count == count then 

    result = true;

  end;

  return result;

end; 

--*********************************************************************************************************************
function private.CheckingOnAllCoversFound ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local result = false; 
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ] ) then 

      count = count + 1; 

    end; 

  end; 

  if private.cover_count == count then 

    result = true;

  end;

  return result;

end; 

--*********************************************************************************************************************
function private.GettingFoundItemsCount ()

  local foundItems = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found_items;
  local count = 0;

  for i = 1, #foundItems, 1 do 

    if ( foundItems[ i ].is_piece_found ) then 

      count = count + 1; 

    end; 

  end; 

  return count;

end; 
--*********************************************************************************************************************
function private.CursorFlashlight ()

  local cursorPosition = GetZoomCursorPos();
  local cursorPositionX = cursorPosition[ 1 ];
  local cursorPositionY = cursorPosition[ 2 ]-100;

 -- if ( not cmn.IsEventDone( "win_withflashlight_scr" ) ) then

    ObjMultiSet( { 
      { "spr_withflashlight_scr_light",  { pos_x = cursorPositionX, pos_y = cursorPositionY } },
      { "obj_withflashlight_scr_light_transparent",  { pos_x = cursorPositionX, pos_y = cursorPositionY } },
      { "tmr_withflashlight_scr_flashlight",  { playing = true, time = 0.001, endtrig = function() private.CursorFlashlight(); end } },
    } );
    
 -- end;

end;
  --*********************************************************************************************************************
function private.light_down()
 MsgSend( Command_Level_SetMove, { move = false } );
end;
--*********************************************************************************************************************
function private.light_up()
 MsgSend( Command_Level_SetMove, { move = true } );
end;  
