-- name=mg_catacomb_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_catacomb_scr";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_lucien_room" } );

  ObjMultiSet({ 
    { "spr_catacomb_scr_maggie", { event_mdown = private.get_maggie }},
    { "spr_catacomb_scr_dungeon_map", { event_mdown = private.get_dungeon_map }},
  });
  
  cmn.AnimateAmbientLight( "spr_catacomb_scr_light" ); 
  cmn.AnimateFlashLight( "spr_catacomb_scr_cursor_focus" ); 
  
  private.LogicInit(); 

  --------------------------------------------------------------------------------------------
  -- function win_catacomb_scr () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_catacomb_scr" ] = {
    type = "win",
    use_place = "gmg_lucien_room_catacomb_scr",
    room = "rm_lucien_room",
    zz_gate = "gmg_lucien_room_catacomb_scr"
  };   

  local win_catacomb_scr = function ()

    if ( cmn.IsEventDone( "win_catacomb_scr" ) ) then  
      
    end;

  end;
  local win_catacomb_scr_loc = function ()

    if ( cmn.IsEventDone( "win_catacomb_scr" ) ) then  

      ObjDelete( "gmg_lucien_room_catacomb_scr" );
      ObjMultiSet( { 
        { "grm_catacomb_scr_lucien_room",  { visible = true, input = true } },
      } );

    end;

  end;
 -- cmn.AddSubscriber( "win_catacomb_scr", win_catacomb_scr, private.room_objname );
--  cmn.AddSubscriber( "win_catacomb_scr", win_catacomb_scr_loc, "rm_lucien_room" );  
  --------------------------------------------------------------------------------------------
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open () 

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  cmn.PlayMusEnv( "mus_env/aud_danger_mus_env" );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level3/env/aud_catacombs_env" }, "", 0.5 );

  --interface.KeyTaskAdd( "lvl3_get_safe_place" );
  --
  --int_slider.InitSlider( private.room_objname );
    
 -- if ( not cmn.IsEventDone( "win_catacomb_scr" ) and 
 -- cmn.IsEventDone( "use_dungeon_map" ) ) then

    cmn.MiniGameShow();

--  end;

  private.Load();
  private.Update();

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  --common_impl.StopAudio( "env", "level1/env/aud_porch_env", 0.5 );
    
 -- if ( not cmn.IsEventDone( "win_catacomb_scr" ) and 
--  cmn.IsEventDone( "use_dungeon_map" ) ) then

    cmn.MiniGameHide();

  --end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

private.gamedata = {};

private.win = 35;

-- information about sprites for room gates 
private.gates_info = {
                       left = { 
                         big = { pos_x = -243, pos_y = -114,  scale_x = 1, path = "assets/levels/level3/mg_catacomb/layers/door_big" },
                         small = { pos_x = -168, pos_y = -126, scale_x = -1, path = "assets/levels/level3/mg_catacomb/layers/door_small" }
                              },
                              
                       right = { 
                         big = { pos_x = 198, pos_y = -106, scale_x = -1, path = "assets/levels/level3/mg_catacomb/layers/door_big" },
                         small = { pos_x = 122, pos_y = -126, scale_x = 1, path = "assets/levels/level3/mg_catacomb/layers/door_small" }
                               },
                              
                       front = { 
                         small = { pos_x = -33, pos_y = -157, scale_x = 1, path = "assets/levels/level3/mg_catacomb/layers/exit" }
                               },
                       
                       deadend = { 
                         pos_x = -34, pos_y = -141, scale_x = 1, path = "assets/levels/level3/mg_catacomb/layers/dead_end_" 
                                 }
                     };
 
-- information about sprites for room focus gates                  
private.gates_focus_info = {
                             left = { 
                               big = { pos_x = 114, pos_y = 10, path = "assets/levels/level3/mg_catacomb/layers/door_big_light" },
                               small = { pos_x = -52, pos_y = -3, path = "assets/levels/level3/mg_catacomb/layers/door_small_light" }
                                    },
                                    
                             right = { 
                               big = { pos_x = 114, pos_y = 10, path = "assets/levels/level3/mg_catacomb/layers/door_big_light" },
                               small = { pos_x = -52, pos_y = -3, path = "assets/levels/level3/mg_catacomb/layers/door_small_light" }
                                     },
                             
                             front = { 
                               small = { pos_x = 35, pos_y = 74, path = "assets/levels/level3/mg_catacomb/layers/exit_light" }
                                     }
 
                           };   
             
-- full information about rooms, cursor position on map 
-- in current room and linked room with current room
private.rooms_info = {
  { id = 0, kind = "room", cursor_angle = 0, cursor_x = -227, cursor_y = -49, gates = { { id = 2, dir = "left", kind = "small" }, -- 1
                                                                                        { id = 3, dir = "right", kind = "small" },
                                                                                        { id = 4, dir = "right", kind = "big" } } },
  { id = 1, kind = "room", cursor_angle = 1, cursor_x = -145, cursor_y = -66, gates = { { id = 13, dir = "left", kind = "big" }, -- 2
                                                                                        { id = 14, dir = "front", kind = "small" },
                                                                                        { id = 15, dir = "right", kind = "small" } } },
  { id = 2, kind = "room", cursor_angle = -1, cursor_x = -145, cursor_y = -35, gates = nil }, -- 3 
  { id = 3, kind = "room", cursor_angle = 0, cursor_x = -211, cursor_y = 146, gates = { { id = 5, dir = "left", kind = "big" }, -- 4
                                                                                        { id = 6, dir = "left", kind = "small" } } },   
  { id = 1, kind = "room", cursor_angle = 1, cursor_x = -177, cursor_y = 146, gates = nil }, -- 5     
  { id = 2, kind = "room", cursor_angle = 1, cursor_x = -144, cursor_y = 146, gates = { { id = 7, dir = "left", kind = "small" }, -- 6 
                                                                                        { id = 8, dir = "front", kind = "small" },
                                                                                        { id = 9, dir = "right", kind = "big" } } }, 
  { id = 3, kind = "room", cursor_angle = 2, cursor_x = -157, cursor_y = 47, gates = nil }, -- 7     
  { id = 1, kind = "room", cursor_angle = 0, cursor_x = -133, cursor_y = 16, gates = { { id = 10, dir = "left", kind = "small" }, -- 8 
                                                                                       { id = 11, dir = "right", kind = "small" } } },
  { id = 2, kind = "room", cursor_angle = 0, cursor_x = -114, cursor_y = 145, gates = { { id = 12, dir = "left", kind = "big" } } }, -- 9 
  { id = 3, kind = "death", cursor_angle = 0, cursor_x = -73, cursor_y = -17, gates = nil }, -- 10 
  { id = 1, kind = "death", cursor_angle = -1, cursor_x = -72, cursor_y = 40, gates = nil }, -- 11 
  { id = 2, kind = "death", cursor_angle = 0, cursor_x = -73, cursor_y = 122, gates = nil }, -- 12  
  { id = 3, kind = "room", cursor_angle = 1, cursor_x = -176, cursor_y = -97, gates = nil }, -- 13 
  { id = 1, kind = "room", cursor_angle = 0, cursor_x = -128, cursor_y = -149, gates = nil }, -- 14 
  { id = 2, kind = "room", cursor_angle = 0, cursor_x = -88, cursor_y = -50, gates = { { id = 16, dir = "left", kind = "small" }, -- 15 
                                                                                       { id = 17, dir = "right", kind = "small" } } },
  { id = 3, kind = "room", cursor_angle = 0, cursor_x = 12, cursor_y = -149, gates = { { id = 19, dir = "right", kind = "small" }, -- 16  
                                                                                       { id = 18, dir = "right", kind = "big" } } }, 
  { id = 1, kind = "room", cursor_angle = -1, cursor_x = 50, cursor_y = -109, gates = { { id = 23, dir = "left", kind = "big" }, -- 17  
                                                                                        { id = 24, dir = "front", kind = "small" } } }, 
  { id = 2, kind = "room", cursor_angle = 0, cursor_x = 156, cursor_y = -86, gates = { { id = 21, dir = "left", kind = "big" }, -- 18  
                                                                                       { id = 22, dir = "right", kind = "big" } } }, 
  { id = 3, kind = "room", cursor_angle = 0, cursor_x = 144, cursor_y = -147, gates = { { id = 20, dir = "right", kind = "big" } } }, -- 19  
  { id = 1, kind = "death", cursor_angle = 0, cursor_x = 193, cursor_y = -129, gates = nil }, -- 20 
  { id = 2, kind = "death", cursor_angle = 0, cursor_x = 195, cursor_y = -122, gates = nil }, -- 21 
  { id = 3, kind = "death", cursor_angle = 0, cursor_x = 195, cursor_y = -46, gates = nil }, -- 22  
  { id = 1, kind = "room", cursor_angle = 0, cursor_x = 73, cursor_y = -20, gates = { { id = 27, dir = "left", kind = "big" }, -- 23  
                                                                                      { id = 29, dir = "front", kind = "small" }, 
                                                                                      { id = 28, dir = "right", kind = "big" } } },
  { id = 2, kind = "room", cursor_angle = 1, cursor_x = -71, cursor_y = 74, gates = { { id = 25, dir = "left", kind = "big" }, -- 24   
                                                                                      { id = 26, dir = "right", kind = "small" } } },
  { id = 3, kind = "death", cursor_angle = 0, cursor_x = -100, cursor_y = 17, gates = nil }, -- 25 
  { id = 1, kind = "death", cursor_angle = 0, cursor_x = -41, cursor_y = -14, gates = nil }, -- 26 
  { id = 2, kind = "room", cursor_angle = 0, cursor_x = 138, cursor_y = -52, gates = { { id = 30, dir = "left", kind = "big" }, -- 27    
                                                                                       { id = 31, dir = "right", kind = "big" } } },
  { id = 3, kind = "room", cursor_angle = -1, cursor_x = 89, cursor_y = 33, gates = { { id = 38, dir = "left", kind = "big" }, -- 28     
                                                                                      { id = 39, dir = "right", kind = "big" } } },
  { id = 1, kind = "room", cursor_angle = -1, cursor_x = 157, cursor_y = 31, gates = nil }, -- 29 
  { id = 2, kind = "room", cursor_angle = 1, cursor_x = 194, cursor_y = -47, gates = { { id = 32, dir = "left", kind = "big" }, -- 30      
                                                                                       { id = 33, dir = "front", kind = "small" } } },
  { id = 3, kind = "room", cursor_angle = -1, cursor_x = 186, cursor_y = 38, gates = { { id = 35, dir = "left", kind = "small" }, -- 31      
                                                                                       { id = 34, dir = "front", kind = "small" } } },
  { id = 1, kind = "death", cursor_angle = 0, cursor_x = 164, cursor_y = -91, gates = nil }, -- 32  
  { id = 2, kind = "death", cursor_angle = 0, cursor_x = 193, cursor_y = -127, gates = nil }, -- 33 
  { id = 3, kind = "room", cursor_angle = 0, cursor_x = 60, cursor_y = 84, gates = { { id = 36, dir = "left", kind = "big" }, -- 34       
                                                                                     { id = 37, dir = "front", kind = "small" } } },
  { id = 1, kind = "room", cursor_angle = 0, cursor_x = 216, cursor_y = 111, gates = nil }, -- 35 
  { id = 2, kind = "death", cursor_angle = 0, cursor_x = 92, cursor_y = 44, gates = nil }, -- 36 
  { id = 3, kind = "death", cursor_angle = 0, cursor_x = 129, cursor_y = 108, gates = nil }, -- 37  
  { id = 1, kind = "death", cursor_angle = 0, cursor_x = 62, cursor_y = 82, gates = nil }, -- 38 
  { id = 2, kind = "death", cursor_angle = 0, cursor_x = 128, cursor_y = 82, gates = nil }, -- 39  
                     };

private.death_anim_func = { "hummer", "stouns", "saw", "sticks" };

private.last_anim = 0;
private.is_map_open = false;
private.is_moving_map = false;

private.ROOMS_NAME = "spr_catacomb_src_room_";
private.TRAPS_NAME = "spr_catacomb_scr_trap_";
private.DEATH_ANIM_NAME = "anm_catacomb_scr_death_";
private.CURSOR_NAME = "spr_catacomb_scr_cursor";
private.MAP_NAME = "spr_catacomb_scr_map_paper";

private.ROOMS_PATH = "assets/levels/level3/mg_catacomb/back_";
private.ROOMS_COUNT = 39;
private.TRAPS_COUNT = 14;
private.ANGLE_DELTA = 1.57;


--*******************************************************************************************************************
function private.Default ()

  ng_global.progress[ "scr" ][ "win_catacomb_scr" ].cur_room = 1;
  ng_global.progress[ "scr" ][ "win_catacomb_scr" ].traps = { 
                                                          { id = 10, exist = false },
                                                          { id = 25, exist = false },
                                                          { id = 26, exist = false },
                                                          { id = 12, exist = false },
                                                          { id = 11, exist = false },
                                                          { id = 20, exist = false },
                                                          { id = 21, exist = false },
                                                          { id = 22, exist = false },
                                                          { id = 32, exist = false },
                                                          { id = 33, exist = false },
                                                          { id = 36, exist = false },
                                                          { id = 37, exist = false },
                                                          { id = 38, exist = false },
                                                          { id = 39, exist = false }
                                                        };

end; 


--*******************************************************************************************************************
function private.Load ()

 -- if ( not ng_global.progress[ "scr" ][ "win_catacomb_scr" ].cur_room or 
 -- not ng_global.progress[ "scr" ][ "win_catacomb_scr" ].traps ) then 

    private.Default();

  --end; 

  private.gamedata = ng_global.progress[ "scr" ][ "win_catacomb_scr" ];

end;


--*******************************************************************************************************************
function private.LogicInit ()

  ObjSet( private.MAP_NAME, { 
    input = true,
                              event_mdown = function () private.MapClick(); end,
                              event_menter = function () private.MapEnter(); end,
                              event_mleave = function () private.MapLeave(); end
                            } );
  
  for i = 1, private.ROOMS_COUNT, 1 do 
    
    local curRoom = private.ROOMS_NAME..i;
    local curRoomPath = private.ROOMS_PATH..private.rooms_info[ i ].id;
    
    ObjCreate( curRoom, "spr" );
    ObjAttach( curRoom, "obj_catacomb_scr_rooms" );
    ObjSet( curRoom, { 
                        alp = 0, 
                        visible = false, 
                        input = false,
                        res = curRoomPath 
                      } );
    
    local roomGates = private.rooms_info[ i ].gates;
    local isExistFrontGates = false; 
    
    if ( roomGates ) then
      
      for j = 1, #roomGates, 1 do
       
         if ( roomGates[ j ].dir == "front" ) then
           
           isExistFrontGates = true; 
           
         end; 
        
        local curGates = curRoom.."_door_"..roomGates[ j ].dir.."_"..roomGates[ j ].kind.."_"..roomGates[ j ].id;
        
        ObjCreate( curGates, "spr" );
        ObjAttach( curGates, curRoom );
        
        local curGatesX = private.gates_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].pos_x;
        local curGatesY = private.gates_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].pos_y;
        local curGatesScaleX = private.gates_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].scale_x;
        local curGatesPath = private.gates_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].path;

        ObjSet( curGates, { 
                            input = true,
                            pos_x = curGatesX,
                            pos_y = curGatesY,
                            scale_x = curGatesScaleX,
                            res = curGatesPath, 
                            event_mdown = function () private.GoToRoom( roomGates[ j ].id ); end,
                            event_menter = function () private.Enter( curGates ); end,
                            event_mleave = function () private.Leave( curGates ); end
                        } );
                            
        local curGatesFocus = curGates.."_focus"; 
        
        ObjCreate( curGatesFocus, "spr" );
        ObjAttach( curGatesFocus, curGates );
        
        local curGatesFocusX = private.gates_focus_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].pos_x;
        local curGatesFocusY = private.gates_focus_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].pos_y;
        local curGatesFocusPath = private.gates_focus_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].path;
        
        ObjSet( curGatesFocus, { 
                                  alp = 0,
                                  visible = true,
                                  input = false, 
                                  blendmode = "2", 
                                  pos_x = curGatesFocusX, 
                                  pos_y = curGatesFocusY, 
                                  res = curGatesFocusPath 
                               } );
        
      end;
      
    end;
                      
    if ( not isExistFrontGates ) then
      
      local curDeadend = curRoom.."_door_deadend";
      
      ObjCreate( curDeadend, "spr" );
      ObjAttach( curDeadend, curRoom );
      
      local curDeadendX = private.gates_info.deadend.pos_x;
      local curDeadendY = private.gates_info.deadend.pos_y;
      local curDeadendScaleX = private.gates_info.deadend.scale_x;
      
      local pictureID = i % 2 + 1;      
      local curDeadendPath = private.gates_info.deadend.path..pictureID;
      
      ObjSet( curDeadend, { 
                            input = false,
                            pos_x = curDeadendX,
                            pos_y = curDeadendY,
                            scale_x = curDeadendScaleX,
                            res = curDeadendPath 
                        } );  
                          
    end;
    
  end;  

end;


--*******************************************************************************************************************
function private.MapEnter ()

  SetCursor( CURSOR_HAND );

  local oldMapY = ObjGet( private.MAP_NAME ).pos_y;
  local newMapY = 820;
  
  if ( oldMapY == 863 and not private.is_moving_map ) then 

    ObjAnimate( private.MAP_NAME, "pos_y",0,0, "", { 0, 3, oldMapY,    0.2, 3, newMapY } );

  end;
 
end;


--*******************************************************************************************************************
function private.MapLeave ()
 
  SetCursor( CURSOR_DEFAULT );

  local oldMapY = ObjGet( private.MAP_NAME ).pos_y;
  local newMapY = 863;
  
  if ( oldMapY == 820 and not private.is_moving_map ) then 

    ObjAnimate( private.MAP_NAME, "pos_y",0,0, "", { 0, 3, oldMapY,    0.2, 3, newMapY } );

  end;
    
end;


--*******************************************************************************************************************
function private.MapClick ()

  local func_end = function()

    cmn.Lock( false );
    private.is_moving_map = false;
    
    if ( private.gamedata.cur_room > 1 ) then
      
      if ( private.is_map_open ) then
        ObjSet( "grm_catacomb_scr_exit", { input = false } );
        
      else
        ObjSet( "grm_catacomb_scr_exit", { input = true } );
        
      end;
      
    end;
    
  end;
 
  local oldMapY = ObjGet( private.MAP_NAME ).pos_y;
  local newMapY = 333;

  if ( private.is_map_open ) then 

    newMapY = 863;

  end;

  private.is_map_open = not private.is_map_open;
  private.is_moving_map = true;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "aud_clk_paper", 0, "", 0 );

  ObjAnimate( private.MAP_NAME, "pos_y",0,0, func_end, { 0, 2, oldMapY,    0.4, 2, newMapY } );
  
end;


--*******************************************************************************************************************
function private.Enter ( nameFocus )
 
  if ( nameFocus == "grm_catacomb_scr_exit" ) then
    SetCursor( CURSOR_DOWN );
    
  else
    SetCursor( CURSOR_HAND );
    
  end;
  
  local current = nameFocus.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );
  
end;


--*******************************************************************************************************************
function private.Leave ( nameFocus )  

  SetCursor( CURSOR_DEFAULT );
  
  local current = nameFocus.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );
  
end;


--*******************************************************************************************************************
function private.GoToRoom ( roomID ) 
  
  local func_end = function()

    cmn.Lock( false );
    private.Update();
  
  end;

  local func_end_2 = function()

    if ( private.rooms_info[ roomID ].kind == "death" ) then

      local deathAnimID = private.GetAnimID();
      local deathAnim = private.DEATH_ANIM_NAME..deathAnimID;
      local deathAnimFunc = private.death_anim_func[ deathAnimID ];

      local func_end_3 = function()

        ObjSet( deathAnim, { frame = 0 } );
        ObjAnimate( "obj_catacomb_scr_gates", "alp",0,0, func_end, { 0, 0, 1,    0.3, 0, 1 } );
        ObjAnimate( "mg_catacomb_scr", "alp",0,0, "", { 0, 0, 1,    0.2, 0, 0,    0.3, 0, 0,    0.5, 0, 1 } );

      end;

      private.gamedata.cur_room = 1;
      private.ChangeTrapState( roomID ); 

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_trap"..deathAnimID, 0, "", 0 );
      AnimPlay( deathAnim, deathAnimFunc, func_end_3 );

    else

      private.gamedata.cur_room = roomID;
      func_end();

    end;

  end;
  
  cmn.Lock( true );

  local rnd = math.random( 1, 4 );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_footstep"..rnd, 0, "", 0 );

  ObjAnimate( "mg_catacomb_scr", "pos_y",0,0, func_end_2, { 0, 3, 0,    0.3, 3, -70,    0.5, 3, -80,    0.7, 3, -60,    0.9, 3, -80,    1.1, 3, -60,    1.4, 3, 0 } );
  ObjAnimate( "mg_catacomb_scr", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 1.3, 1.3,    1.1, 3, 1.3, 1.3,    1.4, 3, 1, 1 } );
  ObjAnimate( "mg_catacomb_scr", "pos_x",0,0, "", { 0, 3, 0,    0.3, 3, -120,    1.1, 3, -120,    1.4, 3, 0 } );
  ObjAnimate( "mg_catacomb_scr", "alp",0,0, "", { 0, 0, 1,    0.8, 0, 1,    1.0, 0, 0.2,    1.2, 0, 0.2,    1.4, 0, 1 } );
  
  local curRoom = private.ROOMS_NAME..private.gamedata.cur_room;
  local nextRoom = private.ROOMS_NAME..roomID;

  ObjAnimate( curRoom, "alp",0,0, "", { 0, 0, 1,    1.0, 0, 1,    1.1, 0, 0 } );
  ObjSet( nextRoom, { alp = 0, visible = true } );
  ObjAnimate( nextRoom, "alp",0,0, "", { 0, 0, 0,    1.0, 0, 0,    1.1, 0, 1 } );

end;


--*******************************************************************************************************************
function private.Randomseed ()
  
  math.randomseed( os.time() );

  for i = 1, os.time() % 100, 1 do

    math.random();

  end;
  
end;


--*******************************************************************************************************************
-- random getting of death animation ID

function private.GetAnimID ()

  private.Randomseed();
  local newID = math.random( 1, 4 );

  while newID == private.last_anim do 

    newID = math.random( 1, 4 );

  end;

  private.last_anim = newID;

  return newID;

end;


--*******************************************************************************************************************
-- changing progress state of trap: visible/invisible 

function private.ChangeTrapState ( roomID ) 

  for i = 1, private.TRAPS_COUNT, 1 do  

    if ( roomID == private.gamedata.traps[ i ].id ) then 

      private.gamedata.traps[ i ].exist = true;
      break; 

    end;

  end;

end;


--*******************************************************************************************************************
function private.GettingLastRoomID ()
  
  for i = 1, private.ROOMS_COUNT, 1 do 
    
    local roomGates = private.rooms_info[ i ].gates;
    
    if ( roomGates ) then
      
      for j = 1, #roomGates, 1 do
        
        if ( roomGates[ j ].id == private.gamedata.cur_room ) then
          
          return i;
          
        end;
        
      end;
      
    end;
    
  end;
  
end;


--*******************************************************************************************************************
function private.Update ()

  local cursorX = private.rooms_info[ private.gamedata.cur_room ].cursor_x;
  local cursorY = private.rooms_info[ private.gamedata.cur_room ].cursor_y;
  local cursorAngle = private.ANGLE_DELTA * private.rooms_info[ private.gamedata.cur_room ].cursor_angle;

  ObjSet( private.CURSOR_NAME, { pos_x = cursorX, pos_y = cursorY, ang = cursorAngle } );
  
  if ( private.gamedata.cur_room > 1 ) then
    
    local lastRoom = private.GettingLastRoomID();
    ObjSet( "grm_catacomb_scr_exit", { input = true, 
                                    event_mdown = function () private.GoToRoom( lastRoom ); end,
                                    event_menter = function () private.Enter( "grm_catacomb_scr_exit" ); end,
                                    event_mleave = function () private.Leave( "grm_catacomb_scr_exit" ); end } );
    
  else
    ObjSet( "grm_catacomb_scr_exit", { input = false } );
    
  end;    
  
  
---------------------------------------------------
---------------------------------------------------
  for i = 1, private.ROOMS_COUNT, 1 do 
    
    local curRoom = private.ROOMS_NAME..i;

    if ( i == private.gamedata.cur_room ) then

      ObjSet( curRoom, { alp = 1, visible = true, input = true } );

    else 

      ObjSet( curRoom, { alp = 0, visible = false, input = false } );

    end;

  end;
---------------------------------------------------
---------------------------------------------------
  for i = 1, private.TRAPS_COUNT, 1 do 

    local curTrap = private.TRAPS_NAME..private.gamedata.traps[ i ].id;

    if ( private.gamedata.traps[ i ].exist ) then

      ObjSet( curTrap, { alp = 1, visible = true } );

    else 

      ObjSet( curTrap, { alp = 0, visible = false } );

    end;

  end;
---------------------------------------------------
---------------------------------------------------
  if ( private.gamedata.cur_room == private.win ) then
    
    private.Win();
    
  end;
  
end;


--*******************************************************************************************************************
function private.Win () 
  
 -- local func_end = function()

    cmn.SetEventDone( "win_catacomb_scr" );
    cmn.CallEventHandler( "win_catacomb_scr" );

    --cmn.Lock( false );
    levelscr.ExitMG();

 -- end; 
  
  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_gate", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
  cmn.MiniGameHide();
  --cmn.Lock( true );
  
  ObjStopAnimate( "mg_catacomb_scr", 8 );
  ObjSet( "mg_catacomb_scr", { alp = 0 } );

 -- ObjAnimate( "obj_catacomb_scr_gates", "scale_x",0,0, func_end, { 0, 0, 1,    0.1, 0, 1 } );
  
end;


--*********************************************************************************************************************
function public.Reset ()

  private.Default(); 
  private.Load();
  private.Update(); 

end; 


--*********************************************************************************************************************
function public.Skip ()

  local func_end = function()

    cmn.Lock( false );

    private.Load();
    private.Update(); 

  end;

  private.gamedata.cur_room = private.win;

  cmn.Lock( true );
  ObjAnimate( "mg_catacomb_scr", "alp",0,0, func_end, { 0, 0, 1,    0.3, 0, 0 } );
  
end;








