-- name=mg_catacombs_fear_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_catacombs_fear_scr";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_graveyard" } );

  cmn.AnimateAmbientLight( "spr_catacombs_fear_scr_light" ); 
  cmn.AnimateFlashLight( "spr_catacombs_fear_scr_cursor_focus" ); 
  
  private.LogicInit(); 

  --------------------------------------------------------------------------------------------
  -- function win_catacombs_fear_scr () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_catacombs_fear_scr" ] = {
    type = "win",
    use_place = "gmg_graveyard_catacombs_fear_scr",
    room = "rm_graveyard",
    zz_gate = "gmg_graveyard_catacombs_fear_scr"
  };   

  local win_catacombs_fear_scr = function ()

    if ( cmn.IsEventDone( "win_catacombs_fear_scr" ) ) then  

      ObjSet( "grm_catacombs_fear_scr_graveyard", { input = true } ); 
      
    end;

  end;
  local win_catacombs_fear_scr_loc = function ()

    if ( cmn.IsEventDone( "win_catacombs_fear_scr" ) ) then  

      ObjSet( "grm_graveyard_lucien_room_lvl4", { input = true, active = true, visible = true } ); 
      ObjDelete( "gmg_graveyard_catacombs_fear_scr" );
      if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_graveyard_lucien_room_lvl4_focus");
    end;
    end;

  end;
  --cmn.AddSubscriber( "win_catacombs_fear_scr", win_catacombs_fear_scr, private.room_objname );
 -- cmn.AddSubscriber( "win_catacombs_fear_scr", win_catacombs_fear_scr_loc, "rm_graveyard" );  
  --------------------------------------------------------------------------------------------
end;


--*********************************************************************************************************************
function public.Open () 
  
  cmn.StopMusEnv();
  common_impl.StopAllMus();
  cmn.PlayMusEnv( "mus_env/aud_danger_mus_env" );

end;


--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level3/env/aud_catacombs_env" }, "", 0.5 );
  cmn.MiniGameShow();
  private.Load();
  private.Update();

end;


--*********************************************************************************************************************
function public.Close ()

end;


--*********************************************************************************************************************
function public.PreClose ()

  --common_impl.StopAudio( "env", "level1/env/aud_porch_env", 0.5 );
  cmn.MiniGameHide();

end;


--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

private.gamedata = {};

private.win = 21;

-- information about sprites for room gates 
private.gates_info = {
                       left = { 
                         big = { pos_x = -243, pos_y = -114,  scale_x = 1, path = "assets/levels/levelext/mg_catacombs_fear/layers/door_big" },
                         small = { pos_x = -168, pos_y = -126, scale_x = -1, path = "assets/levels/levelext/mg_catacombs_fear/layers/door_small" }
                              },
                              
                       right = { 
                         big = { pos_x = 198, pos_y = -106, scale_x = -1, path = "assets/levels/levelext/mg_catacombs_fear/layers/door_big" },
                         small = { pos_x = 122, pos_y = -126, scale_x = 1, path = "assets/levels/levelext/mg_catacombs_fear/layers/door_small" }
                               },
                              
                       front = { 
                         small = { pos_x = -33, pos_y = -157, scale_x = 1, path = "assets/levels/levelext/mg_catacombs_fear/layers/exit" }
                               },
                       
                       deadend = { 
                         pos_x = -34, pos_y = -141, scale_x = 1, path = "assets/levels/levelext/mg_catacombs_fear/layers/dead_end_" 
                                 }
                     };
 
-- information about sprites for room focus gates                  
private.gates_focus_info = {
                             left = { 
                               big = { pos_x = 114, pos_y = 10, path = "assets/levels/levelext/mg_catacombs_fear/layers/door_big_light" },
                               small = { pos_x = -52, pos_y = -3, path = "assets/levels/levelext/mg_catacombs_fear/layers/door_small_light" }
                                    },
                                    
                             right = { 
                               big = { pos_x = 114, pos_y = 10, path = "assets/levels/levelext/mg_catacombs_fear/layers/door_big_light" },
                               small = { pos_x = -52, pos_y = -3, path = "assets/levels/levelext/mg_catacombs_fear/layers/door_small_light" }
                                     },
                             
                             front = { 
                               small = { pos_x = 35, pos_y = 74, path = "assets/levels/levelext/mg_catacombs_fear/layers/exit_light" }
                                     }
 
                           };   
             
-- full information about rooms, cursor position on map 
-- in current room and linked rooms with current room
private.rooms_info = {
  { id = 2, kind = "room", cursor_angle = 0, cursor_x = -242, cursor_y = 11, gates = { { id = 32, dir = "left", kind = "big" }, -- 1
                                                                                       --{ id = 3, dir = "left", kind = "big" },
                                                                                       --{ id = 4, dir = "right", kind = "big" },
                                                                                       { id = 33, dir = "right", kind = "big" } } },
  { id = 3, kind = "room", cursor_angle = 0, cursor_x = -192, cursor_y = -146, gates = { { id = 26, dir = "right", kind = "small" } } }, -- 2                                                                                   
  { id = 4, kind = "room", cursor_angle = 0, cursor_x = -157, cursor_y = -41, gates = nil }, -- 3 
  { id = 2, kind = "room", cursor_angle = 0, cursor_x = -154, cursor_y = 120, gates = nil }, -- 4  
  { id = 3, kind = "room", cursor_angle = 0, cursor_x = -192, cursor_y = 154, gates = { { id = 6, dir = "left", kind = "small" } } }, -- 5 
  { id = 4, kind = "room", cursor_angle = 1, cursor_x = -5, cursor_y = 145, gates = { { id = 7, dir = "right", kind = "small" } } }, -- 6 
  { id = 2, kind = "room", cursor_angle = 0, cursor_x = 11, cursor_y = 51, gates = { { id = 8, dir = "left", kind = "big" }, -- 7
                                                                                     { id = 9, dir = "left", kind = "small" },
                                                                                     { id = 10, dir = "right", kind = "small" } } },
  { id = 3, kind = "room", cursor_angle = 1, cursor_x = 30, cursor_y = -10, gates = nil }, -- 8
  { id = 4, kind = "gangster", cursor_angle = 1, cursor_x = 65, cursor_y = -16, gates = { { id = 11, dir = "front", kind = "small" }, -- 9
                                                                                      { id = 12, dir = "right", kind = "big" } } },
  { id = 2, kind = "room", cursor_angle = -1, cursor_x = 93, cursor_y = 68, gates = { { id = 22, dir = "right", kind = "big" } } }, -- 10 
  { id = 3, kind = "room", cursor_angle = -1, cursor_x = -75, cursor_y = 80, gates = { { id = 13, dir = "left", kind = "big" } } }, -- 11 
  { id = 4, kind = "room", cursor_angle = 1, cursor_x = 128, cursor_y = -40, gates = { { id = 14, dir = "left", kind = "small" }, -- 12
                                                                                       { id = 15, dir = "front", kind = "small" },
                                                                                       { id = 16, dir = "right", kind = "big" } } },
  { id = 2, kind = "room", cursor_angle = 1, cursor_x = -38, cursor_y = 42, gates = nil }, -- 13
  { id = 3, kind = "room", cursor_angle = 1, cursor_x = 97, cursor_y = -125, gates = { { id = 17, dir = "left", kind = "big" } } }, -- 14  
  { id = 4, kind = "room", cursor_angle = 0, cursor_x = 138, cursor_y = -145, gates = { { id = 19, dir = "right", kind = "big" }, -- 15 
                                                                                        { id = 20, dir = "right", kind = "small" } } },  
  { id = 2, kind = "room", cursor_angle = 0, cursor_x = 157, cursor_y = -45, gates = nil }, -- 16
  { id = 3, kind = "gangster", cursor_angle = 2, cursor_x = 8, cursor_y = -150, gates = { { id = 18, dir = "left", kind = "big" } } }, -- 17  
  { id = 4, kind = "room", cursor_angle = -1, cursor_x = -43, cursor_y = -114, gates = nil }, -- 18 
  { id = 2, kind = "room", cursor_angle = -1, cursor_x = 158, cursor_y = -101, gates = nil }, -- 19  
  { id = 3, kind = "room", cursor_angle = -1, cursor_x = 194, cursor_y = -135, gates = { { id = 21, dir = "left", kind = "small" } } }, -- 20 
  { id = 4, kind = "room", cursor_angle = 0, cursor_x = 230, cursor_y = -36, gates = nil }, -- 21  
  { id = 2, kind = "room", cursor_angle = 1, cursor_x = 128, cursor_y = 120, gates = { { id = 24, dir = "front", kind = "small" }, -- 22 
                                                                                       { id = 25, dir = "right", kind = "small" },
                                                                                       { id = 23, dir = "right", kind = "big" } } },
  { id = 3, kind = "room", cursor_angle = 0, cursor_x = 181, cursor_y = 149, gates = nil }, -- 23  
  { id = 4, kind = "room", cursor_angle = 2, cursor_x = 134, cursor_y = 15, gates = nil }, -- 24 
  { id = 2, kind = "room", cursor_angle = 0, cursor_x = 177, cursor_y = 50, gates = nil }, -- 25  
  { id = 3, kind = "room", cursor_angle = 0, cursor_x = -90, cursor_y = -118, gates = { { id = 27, dir = "right", kind = "big" } } }, -- 26 
  { id = 4, kind = "gangster", cursor_angle = 2, cursor_x = -74, cursor_y = -85, gates = { { id = 28, dir = "front", kind = "small" }, -- 27
                                                                                       { id = 29, dir = "left", kind = "big" } } },
  { id = 2, kind = "room", cursor_angle = 1, cursor_x = -137, cursor_y = -98, gates = nil }, -- 28                                                                                   
  { id = 3, kind = "room", cursor_angle = -1, cursor_x = -110, cursor_y = -47, gates = { { id = 30, dir = "right", kind = "small" }, -- 29 
                                                                                        { id = 31, dir = "front", kind = "small" } } },
  { id = 4, kind = "room", cursor_angle = 2, cursor_x = -155, cursor_y = 15, gates = nil }, -- 30
  { id = 2, kind = "room", cursor_angle = 2, cursor_x = -124, cursor_y = 77, gates = nil }, -- 31 
  { id = 2, kind = "room", cursor_angle = 1, cursor_x = -200, cursor_y = -50, gates = { { id = 3, dir = "right", kind = "big" },  -- 32
                                                                                     { id = 2, dir = "front", kind = "small" } } },  
  { id = 2, kind = "room", cursor_angle = -1, cursor_x = -210, cursor_y = 50, gates = { { id = 4, dir = "left", kind = "big" },  -- 33
                                                                                     { id = 5, dir = "front", kind = "small" } } },    
                     };

private.is_map_open = false;
private.is_moving_map = false;

private.ROOMS_NAME = "spr_catacombs_fear_scr_room_";
private.GANGSTER_NAME = "spr_catacombs_fear_scr_gangster_";
private.CURSOR_NAME = "spr_catacombs_fear_scr_cursor";
private.MAP_NAME = "spr_catacombs_fear_scr_map_paper";

private.ROOMS_PATH = "assets/levels/levelext/mg_catacombs_fear/back_";
private.ROOMS_COUNT = 33;
private.GANGSTERS_COUNT = 3;
private.ANGLE_DELTA = 1.57;


--*******************************************************************************************************************
function private.Default ()

  ng_global.progress[ "scr" ][ "win_catacombs_fear_scr" ].cur_room = 1;
  ng_global.progress[ "scr" ][ "win_catacombs_fear_scr" ].gangster = { 
                                                                    { id = 9, exist = false },
                                                                    { id = 17, exist = false },
                                                                    { id = 27, exist = false }
                                                                 };

end; 


--*******************************************************************************************************************
function private.Load ()

  private.Default();
  private.gamedata = ng_global.progress[ "scr" ][ "win_catacombs_fear_scr" ];

end;


--*******************************************************************************************************************
function private.LogicInit ()

  ObjSet( private.MAP_NAME, { 
                              input = true,
                              event_mdown = function () private.MapClick(); end
                                --event_menter = function () private.MapEnter(); end,
                                  --event_mleave = function () private.MapLeave(); end
                            } );
  
  for i = 1, private.ROOMS_COUNT, 1 do 
    
    local curRoom = private.ROOMS_NAME..i;
    local curRoomPath = private.ROOMS_PATH..private.rooms_info[ i ].id;

    ObjCreate( curRoom, "spr" );
    ObjAttach( curRoom, "obj_catacombs_fear_scr_rooms" );
    ObjSet( curRoom, { 
                        alp = 0, 
                        visible = false, 
                        input = false,
                        res = curRoomPath 
                      } );
    
    local roomGates = private.rooms_info[ i ].gates;
    local isExistFrontGates = false; 
    
    if ( roomGates ) then
      
      for j = 1, #roomGates, 1 do
       
         if ( roomGates[ j ].dir == "front" ) then
           
           isExistFrontGates = true; 
           
         end; 
        
        local curGates = curRoom.."_door_"..roomGates[ j ].dir.."_"..roomGates[ j ].kind.."_"..roomGates[ j ].id;
        
        ObjCreate( curGates, "spr" );
        ObjAttach( curGates, curRoom );
        
        local curGatesX = private.gates_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].pos_x;
        local curGatesY = private.gates_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].pos_y;
        local curGatesScaleX = private.gates_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].scale_x;
        local curGatesPath = private.gates_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].path;

        ObjSet( curGates, { 
                            input = true,
                            pos_x = curGatesX,
                            pos_y = curGatesY,
                            scale_x = curGatesScaleX,
                            res = curGatesPath, 
                            event_mdown = function () private.GoToRoom( roomGates[ j ].id ); end,
                            event_menter = function () private.Enter( curGates ); end,
                            event_mleave = function () private.Leave( curGates ); end
                        } );
                            
        local curGatesFocus = curGates.."_focus"; 
        
        ObjCreate( curGatesFocus, "spr" );
        ObjAttach( curGatesFocus, curGates );
        
        local curGatesFocusX = private.gates_focus_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].pos_x;
        local curGatesFocusY = private.gates_focus_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].pos_y;
        local curGatesFocusPath = private.gates_focus_info[ roomGates[ j ].dir ][ roomGates[ j ].kind ].path;
        
        ObjSet( curGatesFocus, { 
                                  alp = 0,
                                  visible = true,
                                  input = false, 
                                  blendmode = "2", 
                                  pos_x = curGatesFocusX, 
                                  pos_y = curGatesFocusY, 
                                  res = curGatesFocusPath 
                               } );
        
      end;
      
    end;
                      
    if ( not isExistFrontGates ) then
      
      local curDeadend = curRoom.."_door_deadend";
      
      ObjCreate( curDeadend, "spr" );
      ObjAttach( curDeadend, curRoom );
      
      local curDeadendX = private.gates_info.deadend.pos_x;
      local curDeadendY = private.gates_info.deadend.pos_y;
      local curDeadendScaleX = private.gates_info.deadend.scale_x;
      
      local pictureID = i % 2 + 1;      
      local curDeadendPath = private.gates_info.deadend.path..pictureID;
      
      ObjSet( curDeadend, { 
                            input = false,
                            pos_x = curDeadendX,
                            pos_y = curDeadendY,
                            scale_x = curDeadendScaleX,
                            res = curDeadendPath 
                        } );  
                          
    end;
    
  end;  

end;


--*******************************************************************************************************************
function private.MapEnter ()

  SetCursor( CURSOR_HAND );

  local oldMapY = ObjGet( private.MAP_NAME ).pos_y;
  local newMapY = 820;
  
  if ( oldMapY == 863 and not private.is_moving_map ) then 

    ObjAnimate( private.MAP_NAME, "pos_y",0,0, "", { 0, 3, oldMapY,    0.2, 3, newMapY } );

  end;
 
end;


--*******************************************************************************************************************
function private.MapLeave ()
 
  SetCursor( CURSOR_DEFAULT );

  local oldMapY = ObjGet( private.MAP_NAME ).pos_y;
  local newMapY = 863;
  
  if ( oldMapY == 820 and not private.is_moving_map ) then 

    ObjAnimate( private.MAP_NAME, "pos_y",0,0, "", { 0, 3, oldMapY,    0.2, 3, newMapY } );

  end;
    
end;


--*******************************************************************************************************************
function private.MapClick ()
  
  local func_end = function()

    cmn.Lock( false );
    private.is_moving_map = false;
    
    if ( private.gamedata.cur_room > 1 ) then
      
      if ( private.is_map_open ) then
        
        ObjSet( "grm_catacombs_fear_scr_exit_tupic", { input = false, alp = 0 });
        --ObjSet( "grm_catacombs_fear_scr_exit", { input = false } );
        
      else
        
        ObjSet( "grm_catacombs_fear_scr_exit_tupic", { input = true, alp = 1 });
        --ObjSet( "grm_catacombs_fear_scr_exit", { input = true } );
        
      end;
      
    end;
    
  end;
 
  local oldMapY = ObjGet( private.MAP_NAME ).pos_y;
  local newMapY = 333;

  if ( private.is_map_open ) then 

    newMapY = 863;
    
  end;

  private.is_map_open = not private.is_map_open;
  private.is_moving_map = true;
  
  cmn.Lock( true );
  ObjAnimate( private.MAP_NAME, "pos_y",0,0, func_end, { 0, 2, oldMapY,    0.4, 2, newMapY } );
  
end;


--*******************************************************************************************************************
function private.Enter ( nameFocus )
 
  if ( nameFocus == "grm_catacombs_fear_scr_exit" ) then
    SetCursor( CURSOR_DOWN );
    
  else
    SetCursor( CURSOR_HAND );
    
  end;
  
  local current = nameFocus.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );
  
end;


--*******************************************************************************************************************
function private.Leave ( nameFocus )  

  SetCursor( CURSOR_DEFAULT );
  
  local current = nameFocus.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );
  
end;


--*******************************************************************************************************************
function private.GoToRoom ( roomID ) 
  
  local func_end = function()
    
    if ( private.rooms_info[ roomID ].kind == "gangster" ) then
      
      private.ChangeGangsterState( roomID ); 
      
    end;
    
    private.gamedata.cur_room = roomID;
    
    cmn.Lock( false );
    private.Update();
    
  end;
  
  cmn.Lock( true );
  
  local rnd = math.random( 1, 4 );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_footstep"..rnd, 0, "", 0 );

  ObjAnimate( "mg_catacombs_fear_scr", "pos_y",0,0, "", { 0, 3, 0,    0.3, 3, -70,    0.5, 3, -80,    0.7, 3, -60,    0.9, 3, -80,    1.1, 3, -60,    1.4, 3, 0 } );
  ObjAnimate( "mg_catacombs_fear_scr", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 1.3, 1.3,    1.1, 3, 1.3, 1.3,    1.4, 3, 1, 1 } );
  ObjAnimate( "mg_catacombs_fear_scr", "pos_x",0,0, "", { 0, 3, 0,    0.3, 3, -120,    1.1, 3, -120,    1.4, 3, 0 } );
  ObjAnimate( "mg_catacombs_fear_scr", "alp",0,0, "", { 0, 0, 1,    0.8, 0, 1,    1.0, 0, 0.2,    1.2, 0, 0.2,    1.4, 0, 1 } );
  
  local curRoom = private.ROOMS_NAME..private.gamedata.cur_room;
  local nextRoom = private.ROOMS_NAME..roomID;

  ObjAnimate( curRoom, "alp",0,0, func_end, { 0, 0, 1,    1.0, 0, 1,    1.1, 0, 0 } );
  ObjSet( nextRoom, { alp = 0, visible = true } );
  ObjAnimate( nextRoom, "alp",0,0, "", { 0, 0, 0,    1.0, 0, 0,    1.1, 0, 1 } );

end;


--*******************************************************************************************************************
-- changing progress state of gangster: visible/invisible 

function private.ChangeGangsterState ( roomID ) 

  for i = 1, private.GANGSTERS_COUNT, 1 do  

    if ( roomID == private.gamedata.gangster[ i ].id ) then 

      private.gamedata.gangster[ i ].exist = true;
      break; 

    end;

  end;

end;


--*******************************************************************************************************************
function private.GettingLastRoomID ()
  
  for i = 1, private.ROOMS_COUNT, 1 do 
    
    local roomGates = private.rooms_info[ i ].gates;
    
    if ( roomGates ) then
      
      for j = 1, #roomGates, 1 do
        
        if ( roomGates[ j ].id == private.gamedata.cur_room ) then
          
          return i;
          
        end;
        
      end;
      
    end;
    
  end;
  
end;


--*******************************************************************************************************************
function private.Update ()

  local cursorX = private.rooms_info[ private.gamedata.cur_room ].cursor_x;
  local cursorY = private.rooms_info[ private.gamedata.cur_room ].cursor_y;
  local cursorAngle = private.ANGLE_DELTA * private.rooms_info[ private.gamedata.cur_room ].cursor_angle;

  ObjSet( private.CURSOR_NAME, { pos_x = cursorX, pos_y = cursorY, ang = cursorAngle } );
  
  if ( private.gamedata.cur_room > 1 ) then
    
    local lastRoom = private.GettingLastRoomID();
    ObjSet( "grm_catacombs_fear_scr_exit", { --input = true, 
                                         event_mdown = function () private.GoToRoom( lastRoom ); end,
                                         event_menter = function () private.Enter( "grm_catacombs_fear_scr_exit" ); end,
                                         event_mleave = function () private.Leave( "grm_catacombs_fear_scr_exit" ); end } );
    ObjSet( "grm_catacombs_fear_scr_exit_tupic", { input = true, alp = 1, event_mdown = function () private.GoToRoom( lastRoom ); end });
  else
    ObjSet( "grm_catacombs_fear_scr_exit", { input = false } );
    ObjSet( "grm_catacombs_fear_scr_exit_tupic", { input = false, alp = 0 });
  end;  
  
---------------------------------------------------
---------------------------------------------------
  for i = 1, private.ROOMS_COUNT, 1 do 
    
    local curRoom = private.ROOMS_NAME..i;

    if ( i == private.gamedata.cur_room ) then

      ObjSet( curRoom, { alp = 1, visible = true, input = true } );

    else 

      ObjSet( curRoom, { alp = 0, visible = false, input = false } );

    end;

  end;
---------------------------------------------------
---------------------------------------------------
  for i = 1, private.GANGSTERS_COUNT, 1 do 

    local curGangster = private.GANGSTER_NAME..private.gamedata.gangster[ i ].id;

    if ( private.gamedata.gangster[ i ].exist ) then

      ObjSet( curGangster, { alp = 1, visible = true } );

    else 

      ObjSet( curGangster, { alp = 0, visible = false } );

    end;

  end;
---------------------------------------------------
---------------------------------------------------
  if ( private.gamedata.cur_room == private.win ) then
    
    private.Win();
    
  end;
  
end;


--*******************************************************************************************************************
function private.Win () 
  
  --local func_end = function()

    cmn.SetEventDone( "win_catacombs_fear_scr" );
    cmn.CallEventHandler( "win_catacombs_fear_scr" );
    levelscr.ExitMG();
    --cmn.Lock( false );
    
  --end; 
  
  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_gate", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
  cmn.MiniGameHide();
  --cmn.Lock( true );
  
  ObjStopAnimate( "mg_catacombs_fear_scr", 8 );
  ObjSet( "mg_catacombs_fear_scr", { alp = 0 } );

  --ObjAnimate( "obj_catacombs_fear_scr_gates", "alp",0,0, func_end, { 0, 0, 1,    0.1, 0, 1 } );
  
end;


--*********************************************************************************************************************
function public.Reset ()

  private.Default(); 
  private.Load();
  private.Update(); 

end; 


--*********************************************************************************************************************
function public.Skip ()

  local func_end = function()

    cmn.Lock( false );

    private.Load();
    private.Update(); 

  end;

  private.gamedata.cur_room = private.win;

  cmn.Lock( true );
  ObjAnimate( "mg_catacombs_fear_scr", "alp",0,0, func_end, { 0, 0, 1,    0.3, 0, 0 } );
  
end;


