-- name=mg_chain_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_chain_scr";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_winecellar" } );
  private.LogicInit();

  --------------------------------------------------------------------------------------------
  -- function win_chain_scr () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_chain_scr" ] = {
    type = "win",
    use_place = "gmg_winecellar_chain_scr",
    room = "rm_winecellar",
    zz_gate = "gmg_winecellar_chain_scr"
  };   
  
  local win_chain_scr = function ()

    if ( cmn.IsEventDone( "win_chain_scr" ) ) then  


    end;
    
  end;
  
  local win_chain_scr_loc = function ()

    if ( cmn.IsEventDone( "win_chain_scr" ) ) then  

      ObjDelete( "gmg_winecellar_chain_scr" );
      ObjMultiSet( { 
        { "grm_winecellar_eventshall",  { visible = true, input = true } },
      } );

    end;

  end;
 -- cmn.AddSubscriber( "win_chain_scr", win_chain_scr, private.room_objname );
 -- cmn.AddSubscriber( "win_chain_scr", win_chain_scr_loc, "rm_winecellar" ); 
  --------------------------------------------------------------------------------------------
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************


--*********************************************************************************************************************
function public.Open () 

end;

--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level2/env/aud_winecellar_env" }, "", 0.5 );
    
  cmn.MiniGameShow();

  private.Load();
  private.SetState();

  iOS_NeedDrag(0);
  
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  iOS_NeedDrag(1);
  
  common_impl.StopAudio( "env", "level2/env/aud_winecellar_env", 0.5 );
  cmn.MiniGameHide();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

private.gamedata = {};

private.win = {};


--*******************************************************************************************************************
function private.Default ()

  private.FieldArray = {};
  ng_global.progress[ "scr" ][ "win_chain_scr" ].field = {};

  for i = 1, private.FIELD_HIGH do

    ng_global.progress[ "scr" ][ "win_chain_scr" ].field[ i ] = {};
    private.FieldArray[ i ] = {};

    for j = 1, private.FIELD_WIDTH do

      private.FieldArray[ i ][ j ] = 0;
      ng_global.progress[ "scr" ][ "win_chain_scr" ].field[ i ][ j ] = private.FieldArray[ i ][ j ];

    end;
  end;

  private.FieldArray[ 1 ][ 3 ] = -1;
  private.FieldArray[ 4 ][ 3 ] = -1;
  ng_global.progress[ "scr" ][ "win_chain_scr" ].field[ 1 ][ 3 ] = -1;
  ng_global.progress[ "scr" ][ "win_chain_scr" ].field[ 4 ][ 3 ] = -1;

  ng_global.progress[ "scr" ][ "win_chain_scr" ].parts = {};
  private.StartOnField = {};
  for i = 1, private.PARTS_COUNT do
    private.StartOnField[ i ] = { -1, -1 };
    ng_global.progress[ "scr" ][ "win_chain_scr" ].parts[ i ] = { -1, -1 };
  end;

end; 
--*******************************************************************************************************************
function private.Load ()

  private.Default();
  private.FieldArray = {};
  
  for i = 1, private.FIELD_HIGH do

    private.FieldArray[ i ] = {};
    for j = 1, private.FIELD_WIDTH do

      private.FieldArray[ i ][ j ] = ng_global.progress[ "scr" ][ "win_chain_scr" ].field[ i ][ j ];

    end;
  end;

  private.StartOnField = {};
  for i = 1, private.PARTS_COUNT do
    private.StartOnField[ i ] = { ng_global.progress[ "scr" ][ "win_chain_scr" ].parts[ i ][ 1 ], ng_global.progress[ "scr" ][ "win_chain_scr" ].parts[ i ][ 2 ] }; 
  end;

end;
--*******************************************************************************************************************
function private.LogicInit ()  

  private.PartsArray = {};
  private.PartsArray[ 1 ] = { { 1, 1 } };
  private.PartsArray[ 2 ] = { { 0, 1, 1 }, { 1, 1, 0 } };
  private.PartsArray[ 3 ] = { { 0, 1 }, { 1, 1 } };
  private.PartsArray[ 4 ] = { { 1, 1 }, { 1, 0 }, { 1, 0 } };
  private.PartsArray[ 5 ] = { { 1, 1, 1 }, { 0, 0, 1 } };
  private.PartsArray[ 6 ] = { { 0, 1, 0 }, { 1, 1, 1 } };
  private.PartsArray[ 7 ] = { { 1, 1, 1 } };
  private.PartsArray[ 8 ] = { { 1 }, { 1 } };
  private.PartsArray[ 9 ] = { { 1 }, { 1 } };

  private.START_POINT = { 346, 196 };
  private.DIFF        = 68;
  private.PARTS_COUNT = 9;
  private.FIELD_HIGH  = 5;
  private.FIELD_WIDTH = 6;

  private.ResetCoords = {};
  for i = 1, private.PARTS_COUNT do

    ObjSet( "spr_chain_scr_part_"..i.."_drag",
      {
        --realdrag = true,
        --event_menter =    function () private.Enter() end,
        --event_mleave =    function () private.Leave() end,
        event_startdrag = function () private.PartStartDrag( i ) end,
        event_drag = function () private.PartDrag( i ) end, 
        event_dragdrop =  function () private.PartDragDrop( i ) end
      } );
    private.ResetCoords[ i ] = 
    {
      ObjGet( "spr_chain_scr_part_"..i ).pos_x,
      ObjGet( "spr_chain_scr_part_"..i ).pos_y
    };

  end;

  private.CreateField();

end;
--*******************************************************************************************************************
function private.CreateField ()

  for i = 1, 5 do

    for j = 1, 6 do

      ObjClone( "obj_chain_scr_point", "_"..i.."_"..j, 0, "obj_chain_scr_field" );
      ObjSet( "obj_chain_scr_point_"..i.."_"..j,
      {
        pos_x = private.START_POINT[ 1 ] + ( j - 1 ) * private.DIFF+50,
        pos_y = private.START_POINT[ 2 ] + ( i - 1 ) * private.DIFF+125,
        event_menter_drag = function () private.PartDragEnter( i, j ) end
      } );

    end;

  end;

end;
--*******************************************************************************************************************
function private.Enter ()
 
  SetCursor( CURSOR_HAND );
  
end;
--*******************************************************************************************************************
function private.Leave ()  

  SetCursor( CURSOR_DEFAULT );
  
end;
--*******************************************************************************************************************
function private.PartDragEnter ( id_x, id_y ) 

  private.LastPoint = { id_x, id_y };

end;
--*******************************************************************************************************************
function private.PartStartDrag ( partNum ) 

  common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  --common_impl.SetCursor( CURSOR_NULL );

  ObjSet( "spr_chain_scr_part_"..partNum, { pos_z = 10 } );

end;
--*******************************************************************************************************************
function private.PartDrag( partNum ) 
  local cur_pos = GetZoomCursorPos();
  cur_pos[1] = cur_pos[1] - 50;
  cur_pos[2] = cur_pos[2] - 125;
  ObjSet("spr_chain_scr_part_"..partNum, { pos_x = cur_pos[1], pos_y = cur_pos[2] });
end;
--*******************************************************************************************************************
function private.PartDragDrop ( partNum ) 

  common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );

  ObjSet("tmr_common_forbidscale",{ time = 0.25, playing = true, endtrig = function() private.SetState(); end });
    
  common_impl.SetCursor( CURSOR_DEFAULT );
  ObjSet( "spr_chain_scr_part_"..partNum, { pos_z = 0 } );

  local cur_pos = GetZoomCursorPos();
  cur_pos[1] = cur_pos[1] - 50;
  cur_pos[2] = cur_pos[2] - 125;
  local on_field = false;
  if ( cur_pos[ 1 ] > 300 and cur_pos[ 1 ] < 720 ) and ( cur_pos[ 2 ] > 160 and cur_pos[ 2 ] < 490 ) then
    on_field = true;
  end;

  for i = 1, 5 do
    for j = 1, 6 do
      local obj =  ObjGet("obj_chain_scr_point_"..i.."_"..j);
      if obj.pos_x-50 <= cur_pos[ 1 ] + 20 and obj.pos_x-50 >= cur_pos[ 1 ] - 20
        and obj.pos_y-125 <= cur_pos[ 2 ] + 20 and obj.pos_y-125 >= cur_pos[ 2 ] - 20 then
        private.LastPoint[ 1 ] = i;
        private.LastPoint[ 2 ] = j;
      end;
    end;
  end;
  
  if ( on_field ) then

    if ( private.LastPoint ) then

      if ( private.LastPoint[ 1 ] == private.StartOnField[ partNum ][ 1 ] ) and 
         ( private.LastPoint[ 2 ] == private.StartOnField[ partNum ][ 2 ] ) then
        return;
      end;

      --AK> Check on field borders
      if ( -1 + private.LastPoint[ 2 ] + #private.PartsArray[ partNum ][ 1 ] > private.FIELD_WIDTH ) or
         ( -1 + private.LastPoint[ 1 ] + #private.PartsArray[ partNum ] > private.FIELD_HIGH ) then

        if ( private.StartOnField[ partNum ][ 1 ] ~= -1 ) then

          private.SetPartOnField( partNum, 0 );
          private.StartOnField[ partNum ] = { -1, -1 };

        end;

        private.LastPoint = nil;
        return;

      end;

      --AK> Check on field state
      local setPart = true;
      for i = 1, #private.PartsArray[ partNum ] do

        for j = 1, #private.PartsArray[ partNum ][ i ] do
          
          if ( private.PartsArray[ partNum ][ i ][ j ] == 1 ) then 

            if ( private.FieldArray[ private.LastPoint[ 1 ] - 1 + i ][ private.LastPoint[ 2 ] - 1 + j ] ~= 0 ) then
              setPart = false;
              break;
            end;

          end;

        end;

      end;

      if ( setPart ) then

        if ( private.StartOnField[ partNum ][ 1 ] ~= -1 ) then

          private.SetPartOnField( partNum, 0 );

        end;
        private.StartOnField[ partNum ] = { private.LastPoint[ 1 ], private.LastPoint[ 2 ] };
        private.SetPartOnField( partNum, 1 );

      else

        if ( private.StartOnField[ partNum ][ 1 ] ~= -1 ) then

          private.SetPartOnField( partNum, 0 );
          private.StartOnField[ partNum ] = { -1, -1 };

        end;

      end;

    end;

    private.LastPoint = nil;

  else

    if ( private.StartOnField[ partNum ][ 1 ] ~= -1 ) then

      private.SetPartOnField( partNum, 0 );
      private.StartOnField[ partNum ] = { -1, -1 };

    end;

  end;

  private.SetState();
  if ( private.CheckWin() ) then

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_uxx_opn_lock", 0, "", 0 );
    ObjAnimate( "spr_chain_scr_lock_part", "pos_x", 0, 1, private.Win, { 0, 0, 0, 1.5, 3, 150 } )

  else

    private.SaveValues();

  end;

end;
--*******************************************************************************************************************
function private.SetPartOnField ( partNum, stateField )

  for i = 1, #private.PartsArray[ partNum ] do

    for j = 1, #private.PartsArray[ partNum ][ i ] do
      
      if ( private.PartsArray[ partNum ][ i ][ j ] == 1 ) then 

        private.FieldArray[ private.StartOnField[ partNum ][ 1 ] - 1 + i ][ private.StartOnField[ partNum ][ 2 ] - 1 + j ] = stateField;

      end;

    end;

  end;

end;
--*******************************************************************************************************************
function private.SaveValues ()

  ng_global.progress[ "scr" ][ "win_chain_scr" ].field = {};
  for i = 1, private.FIELD_HIGH do

    ng_global.progress[ "scr" ][ "win_chain_scr" ].field[ i ] = {};
    for j = 1, private.FIELD_WIDTH do

      ng_global.progress[ "scr" ][ "win_chain_scr" ].field[ i ][ j ] = private.FieldArray[ i ][ j ];

    end;
  end;

  ng_global.progress[ "scr" ][ "win_chain_scr" ].parts = {};
  for i = 1, private.PARTS_COUNT do
    ng_global.progress[ "scr" ][ "win_chain_scr" ].parts[ i ] = { private.StartOnField[ i ][ 1 ], private.StartOnField[ i ][ 2 ] };
  end;

end;

--*******************************************************************************************************************
function private.SetState ()

  for i = 1, private.PARTS_COUNT do
    if ( private.StartOnField[ i ][ 1 ] ~= -1 ) then

      ObjSet( "spr_chain_scr_part_"..i,
      { 
        pos_x = ObjGet( "obj_chain_scr_point_"..private.StartOnField[ i ][ 1 ].."_"..private.StartOnField[ i ][ 2 ] ).pos_x-50,
        pos_y = ObjGet( "obj_chain_scr_point_"..private.StartOnField[ i ][ 1 ].."_"..private.StartOnField[ i ][ 2 ] ).pos_y-125,
      } ); 
      ObjSet( "spr_chain_scr_part_"..i.."_drag",
      { 
        pos_x = ObjGet( "obj_chain_scr_point_"..private.StartOnField[ i ][ 1 ].."_"..private.StartOnField[ i ][ 2 ] ).pos_x-50,
        pos_y = ObjGet( "obj_chain_scr_point_"..private.StartOnField[ i ][ 1 ].."_"..private.StartOnField[ i ][ 2 ] ).pos_y-125,
      } );

    else

      ObjSet( "spr_chain_scr_part_"..i,
      { 
        pos_x = private.ResetCoords[ i ][ 1 ],
        pos_y = private.ResetCoords[ i ][ 2 ]
      } ); 

       ObjSet( "spr_chain_scr_part_"..i.."_drag",
      { 
        pos_x = private.ResetCoords[ i ][ 1 ],
        pos_y = private.ResetCoords[ i ][ 2 ]
      } );
    end;
  end;

end;
--*******************************************************************************************************************
function private.CheckWin () 

  for i = 1, private.FIELD_HIGH do

    for j = 1, private.FIELD_WIDTH do

      if ( private.FieldArray[ i ][ j ] == 0 ) then
        return false;
      end;

    end;

  end;
  return true;

end;
--*******************************************************************************************************************
function private.Win () 

  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  cmn.MiniGameHide();

  cmn.SetEventDone( "win_chain_scr" );
  cmn.CallEventHandler( "win_chain_scr" );

  cmn.Lock( false );
  levelscr.ExitMG();
    
end;


--*********************************************************************************************************************
function public.Reset ()

  private.Default();
  private.SetState(); 

end; 
--*********************************************************************************************************************
function public.Skip ()

  cmn.Lock( true );

  local func_end = function()
  
    ObjAnimate( "spr_chain_scr_lock_part", "pos_x", 0, 1, private.Win, { 0, 0, 0, 1.5, 3, 150 } )
  
  end;
  
  local params = {};
  for i = 1, 9 do
    
    params[ i ] = ObjGet( "spr_chain_scr_part_"..i );
    
  end;
  
  ObjAnimate( "spr_chain_scr_part_1", "pos_xy", 0, 0, func_end, { 0, 0, params[1].pos_x, params[1].pos_y,   0.8, 3, 346, 196 } );
  ObjAnimate( "spr_chain_scr_part_2", "pos_xy", 0, 0, "", { 0, 0, params[2].pos_x, params[2].pos_y,   0.8, 3, 414, 264 } );
  ObjAnimate( "spr_chain_scr_part_3", "pos_xy", 0, 0, "", { 0, 0, params[3].pos_x, params[3].pos_y,   0.8, 3, 618, 332 } );
  ObjAnimate( "spr_chain_scr_part_4", "pos_xy", 0, 0, "", { 0, 0, params[4].pos_x, params[4].pos_y,   0.8, 3, 346, 264 } );
  ObjAnimate( "spr_chain_scr_part_5", "pos_xy", 0, 0, "", { 0, 0, params[5].pos_x, params[5].pos_y,   0.8, 3, 550, 196 } );
  ObjAnimate( "spr_chain_scr_part_6", "pos_xy", 0, 0, "", { 0, 0, params[6].pos_x, params[6].pos_y,   0.8, 3, 346, 400 } );
  ObjAnimate( "spr_chain_scr_part_7", "pos_xy", 0, 0, "", { 0, 0, params[7].pos_x, params[7].pos_y,   0.8, 3, 550, 468 } );
  ObjAnimate( "spr_chain_scr_part_8", "pos_xy", 0, 0, "", { 0, 0, params[8].pos_x, params[8].pos_y,   0.8, 3, 618, 264 } );
  ObjAnimate( "spr_chain_scr_part_9", "pos_xy", 0, 0, "", { 0, 0, params[9].pos_x, params[9].pos_y,   0.8, 3, 550, 332 } );
  
end;
