-- name=mg_incabinet_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_incabinet_scr";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_toilets" } );
  
  private.win = 
  {
    { { pos_x = 266, pos_y = -11 },  { pos_x = 127, pos_y = 17 },    { pos_x = -112, pos_y = 57 } },
    { { pos_x = -122, pos_y = 157 }, { pos_x = 111, pos_y = 109 },   { pos_x = -147, pos_y = 17 } },
    { { pos_x = -162, pos_y = 17 },  { pos_x = -328, pos_y = -164 }, { pos_x = -20, pos_y = -173 } }
  };
  
  local table_set = 
  { 
    { "spr_incabinet_scr_squarekey", { event_mdown = private.get_squarekey } },
    { "spr_incabinet_scr_book_close", { event_mdown = private.OpenBook } }
  };

  for i = 1, #private.win do
    for j = 1, #private.win[ i ] do
      table.insert( table_set, { "spr_incabinet_scr_page"..i.."_obj"..j, 
        { 
          event_mdown = function() private.Click( i, j ) end, 
          event_dragdrop = function() private.DragDrop( i, j ) end,
        } } );
    end;
  end; 
  
  ObjMultiSet( table_set );
  
  --------------------------------------------------------------------------------------------
  -- function get_squarekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_squarekey" ] = {
    type = "click",                     --special
    use_place = "spr_incabinet_scr_squarekey", --special
    room = "rm_toilets",
    zz = private.room_objname,
    zz_gate = "gmg_toilets_incabinet_scr"
  };
  
  local get_squarekey_inv = function ()
  
    interface.InventoryItemAdd( "inv_squarekey", "spr_incabinet_scr_squarekey" );
  
  end;
  
  local get_squarekey_closezz = function ()
  
    ObjDelete( "gfx_incabinet_scr_squarekey" );
  
  end;
  
  local get_squarekey_loc = function ()
    
    ObjDelete( "gmg_toilets_incabinet_scr" );

  end;
  
  --cmn.AddSubscriber( "get_squarekey", get_squarekey_inv );
  --cmn.AddSubscriber( "get_squarekey", get_squarekey_closezz, private.room_objname );
  --cmn.AddSubscriber( "get_squarekey", get_squarekey_loc, "rm_toilets" ); 
  --------------------------------------------------------------------------------------------
  -- function win_incabinet_scr () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_incabinet_scr" ] = {
    type = "win",
    use_place = "gmg_toilets_incabinet_scr",
    room = "rm_toilets",
    zz_gate = "gmg_toilets_incabinet_scr"
  };  
  
  local win_incabinet_scr = function ()

    if ( cmn.IsEventDone( "win_incabinet_scr" ) ) then  
      ObjMultiSet( { 
        { "spr_incabinet_scr_shelf",  { visible = true, input = true, pos_x = 612 } },
      } );
    end;

  end;
  local win_incabinet_scr_loc = function ()

    if ( cmn.IsEventDone( "win_incabinet_scr" ) ) then  
    end;

  end;
  --cmn.AddSubscriber( "win_incabinet_scr", win_incabinet_scr, private.room_objname );
  --cmn.AddSubscriber( "win_incabinet_scr", win_incabinet_scr_loc, "rm_toilets" );  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_squarekey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_squarekey" );
  cmn.CallEventHandler( "get_squarekey" );
  
  cmn.GotoRoom( "rm_toilets" );

end;
--*********************************************************************************************************************
function public.Open () 
  
end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level2/env/aud_toilets_env" }, "", 0.5 );
  
  cmn.MiniGameShow();
  private.Load();
  private.Update();

end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level2/env/aud_toilets_env", 0.5 );
  cmn.MiniGameHide();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*******************************************************************************************************************
function private.Default ()

  ng_global.progress[ "scr" ][ "win_incabinet_scr" ].current_page = 0;
  ng_global.progress[ "scr" ][ "win_incabinet_scr" ].set_objects = {};

end; 
--*******************************************************************************************************************
function private.Load ()

  private.Default();
  private.gamedata = ng_global.progress[ "scr" ][ "win_incabinet_scr" ];

end;
--*******************************************************************************************************************
function private.OpenBook ( ) 
  
  local func_end = function()
    
    cmn.Lock( false );
    private.gamedata.current_page = 1;
    ObjSet( "spr_incabinet_scr_book_close", { visible = false, input = false } );
    
  end;
  
  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_book", 0, "", 0 );
  
  ObjAnimate( "spr_incabinet_scr_book_close", "alp", 0, 0, func_end,{
    0.0, 0, 1,
    0.3, 0, 0
  } );
  
  ObjSet( "spr_incabinet_scr_book_open", { visible = true, input = true } );
  ObjAnimate( "spr_incabinet_scr_book_open", "alp", 0, 0, "",{
    0.0, 0, 0,
    0.3, 0, 1
  } );
  
end;
--*******************************************************************************************************************
function private.Click ( page_num, obj_num ) 

  ObjSet( "spr_incabinet_scr_page"..page_num.."_obj"..obj_num, { pos_z = 10 } );
  common_impl.PlayAudio( "sfx", "aud_take_inventory", 0, "", 0 );
  
end;
--*******************************************************************************************************************
function private.DragDrop ( page_num, obj_num ) 

  if ( cmn.ApplyObj( "obj_incabinet_scr_page"..page_num.."_obj"..obj_num, "obj_incabinet_scr_page"..page_num.."_obj"..obj_num.."_apply" ) ) then
    
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_xx_clk_paper2", 0, "", 0 );

    local pos_x = private.win[ page_num ][ obj_num ].pos_x;
    local pos_y = private.win[ page_num ][ obj_num ].pos_y;
    ObjSet( "spr_incabinet_scr_page"..page_num.."_obj"..obj_num, { 
      pos_x = pos_x, 
      pos_y = pos_y, 
      input = false
    } );
    
    table.insert( private.gamedata.set_objects, obj_num );
    
    if ( #private.win[ private.gamedata.current_page ] == #private.gamedata.set_objects ) then
      
      if ( private.gamedata.current_page == #private.win ) then --CheckWin
        
        private.Win();
        
      else
        
        private.gamedata.current_page = private.gamedata.current_page + 1;
        private.gamedata.set_objects = {};
        private.OpenNewPage();
        
      end;
      
    end;
    
  end;
  ObjSet( "spr_incabinet_scr_page"..page_num.."_obj"..obj_num, { pos_z = 1 } );
  
end;
--*******************************************************************************************************************
function private.OpenNewPage ( ) 
  
  local old_page = "obj_incabinet_scr_page"..(private.gamedata.current_page - 1);
  local current_page = "obj_incabinet_scr_page"..private.gamedata.current_page;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page", 0, "", 0 );

  local func_end = function()
    
    ObjAnimate( old_page, "alp", 0, 0, private.OpenNewPageEnd,{
     0.0, 0, 1,
     0.3, 0, 0
    } );

    ObjSet( current_page, { visible = true, input = true } );
    ObjAnimate( current_page, "alp", 0, 0, "",{
     0.0, 0, 0,
     0.3, 0, 1
    } );
    
  end;

  ObjAnimate( old_page, "alp", 0, 0, func_end,{
   0.0, 0, 1,
   1.0, 0, 1,
  } );
  ObjAnimate( current_page, "alp", 0, 0, "",{
   0.0, 0, 0,
   1.0, 0, 0,
  } );
  
end;
--*******************************************************************************************************************
function private.OpenNewPageEnd ( ) 
  
  cmn.Lock( false );
  local old_page = "obj_incabinet_scr_page"..(private.gamedata.current_page - 1);
  ObjSet( old_page, { visible = false, input = false } );
  
  --[[local progress = ng_global.progress[ "scr" ][ "win_incabinet_scr" ];
  progress.current_page = private.gamedata.current_page;
  progress.set_objects = {};]]
  
end;
--*******************************************************************************************************************
function private.Update ()
  
  local table_set = {};
  local current_page = private.gamedata.current_page;
  
  local start_positions = 
  {
    { { pos_x = 264, pos_y = -240 },  { pos_x = -296, pos_y = -196 },  { pos_x = 175, pos_y = -66 } },
    { { pos_x = 326, pos_y = -96 },   { pos_x = -58, pos_y = -18 },    { pos_x = 264, pos_y = 145 } },
    { { pos_x = 115, pos_y = -135 },  { pos_x = 104, pos_y = 85 },     { pos_x = 280, pos_y = -155 } }
  };
  
  for i = 1, #start_positions do
    table.insert( table_set, { "obj_incabinet_scr_page"..i, { input = false, visible = false } } );
  end;
  
  for i = 1, #start_positions do
    for j = 1, #start_positions[ i ] do
      table.insert( table_set, { "spr_incabinet_scr_page"..i.."_obj"..j, 
        {
          pos_x = start_positions[ i ][ j ].pos_x,
          pos_y = start_positions[ i ][ j ].pos_y,
          input = true
        } 
      } );
    end;
  end; 
  
  for i = 1, #private.gamedata.set_objects do
    
    local obj_num = private.gamedata.set_objects[ i ];
    local data = private.win[ current_page ][ obj_num ];
    table.insert( table_set, { "spr_incabinet_scr_page"..current_page.."_obj"..obj_num, 
      {
        pos_x = data.pos_x,
        pos_y = data.pos_y,
        input = false
      } 
    } );
    
  end;
  
  local flag = false;
  if ( current_page == 0 ) then
    flag = true;
    current_page = 1;
  end;
  
  table.insert( table_set, { "spr_incabinet_scr_book_open", { input = not flag, visible = not flag, alp = 1 } } );
  table.insert( table_set, { "spr_incabinet_scr_book_close", { input = flag, visible = flag, alp = 1 } } );
  
  table.insert( table_set, { "obj_incabinet_scr_page"..current_page, 
  { 
    input = true, 
    visible = true, 
    alp = 1 
  } } );
  
  ObjMultiSet( table_set );
  
end;
--*******************************************************************************************************************
function private.Win () 

    cmn.SetEventDone( "win_incabinet_scr" );
    cmn.CallEventHandler( "win_incabinet_scr" );

    cmn.Lock( false );
    levelscr.ExitMG();

  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
  cmn.MiniGameHide();

  --common_impl.PlayAudio( "sfx", "level2/sfx/aud_slide_wood", 0, "", 0 );
  
end;
--*********************************************************************************************************************
function public.Reset ()
  
  private.Default(); 
  private.Load();
  private.Update();

end; 
--*********************************************************************************************************************
function public.Skip ()

  private.Win(); 
  
  private.gamedata.current_page = 3;
  private.gamedata.set_objects = { 1, 2, 3 };
  
  private.Update(); 

end;
--*********************************************************************************************************************