-- name=mg_inthreewaymirror_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_inthreewaymirror_scr";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_room_211" } );

  ObjMultiSet({ 
    { "spr_inthreewaymirror_scr_hook", { event_mdown = private.get_hook }},
  });
  private.LogicInit();

  --------------------------------------------------------------------------------------------
  -- function get_hook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hook" ] = {
    type = "click",                          --special
    use_place = "spr_inthreewaymirror_scr_hook", --special
    room = "rm_room_211",
    zz = private.room_objname,
    zz_gate = "gmg_room_211_inthreewaymirror_scr"
  };  
    
  local get_hook_inv = function ()
  
    interface.InventoryItemAdd( "inv_hook", "spr_inthreewaymirror_scr_hook" );
    cmn.SetInvPlusRGB( "stick", true );
  
  end;
  local get_hook_closezz = function ()
  
    ObjDelete( "gfx_inthreewaymirror_scr_hook" );
    
  end;
  local get_hook_loc = function ()

    ObjDelete( "gmg_room_211_inthreewaymirror_scr" );
    
  end;
  
  --cmn.AddSubscriber( "get_hook", get_hook_inv );
  --cmn.AddSubscriber( "get_hook", get_hook_closezz, private.room_objname );
  --cmn.AddSubscriber( "get_hook", get_hook_loc, "rm_room_211" );
  --------------------------------------------------------------------------------------------
  -- function win_inthreewaymirror_scr () end;
  --------------------------------------------------------------------------------------------
  local win_inthreewaymirror_scr = function ()

    if ( cmn.IsEventDone( "win_inthreewaymirror_scr" ) ) then  
      
      ObjMultiSet( { 
        { "spr_inthreewaymirror_scr_hook",  {  input = true  } },
        { "gfx_inthreewaymirror_scr_hook",  { active = true  } },
        { "obj_inthreewaymirror_scr_stars", {  input = false } },
      } );
      ObjDelete( "spr_inthreewaymirror_scr_door" );

    end;

  end;
  local win_inthreewaymirror_scr_loc = function ()

    if ( cmn.IsEventDone( "win_inthreewaymirror_scr" ) ) then  
    end;

  end;
  --cmn.AddSubscriber( "win_inthreewaymirror_scr", win_inthreewaymirror_scr, private.room_objname );
  --cmn.AddSubscriber( "win_inthreewaymirror_scr", win_inthreewaymirror_scr_loc, "rm_room_211" ); 
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_hook ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hook" );
  cmn.CallEventHandler( "get_hook" );
  
  cmn.GotoRoom( "rm_room_211" );

end;
--*********************************************************************************************************************
function public.Open () 
end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level1/env/aud_room_313_env" }, "", 0.5 );

  cmn.MiniGameShow();

  private.Load();
  private.Update();

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level1/env/aud_room_313_env", 0.5 );
    
  cmn.MiniGameHide();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.gamedata = {};

private.angle_of_rotation = { 0, -1.23, -2.51, -3.81, -5.06, -6.26 };

                           -----{     left,    right }
private.color_of_rotation = { { {   "blue",  "green" }, 
                                {  "green",    "red" }, 
                                {    "red", "yellow" }, 
                                { "yellow",  "green" }, 
                                {  "green",   "blue" }, 
                                {   "blue",  "green" } 
                              }, 
                              { {    "red",  "green" }, 
                                {   "blue",    "red" }, 
                                {  "green",   "blue" }, 
                                { "yellow",  "green" }, 
                                {  "green", "yellow" },
                                {    "red",  "green" },  
                              }, 
                              { {   "blue",    "red" }, 
                                { "yellow",   "blue" }, 
                                {  "green", "yellow" }, 
                                {   "blue",  "green" }, 
                                {    "red",   "blue" }, 
                                {   "blue",    "red" },
                              }
                            };

private.numberOfElements = 3; 
private.nameElement = "spr_inthreewaymirror_scr_star_";
private.nameElement2 = "spr_inthreewaymirror_scr_cogwheel_";

--*******************************************************************************************************************
function private.Default ()

  ng_global.progress[ "scr" ][ "win_inthreewaymirror_scr" ].temp_color = { { "green",  "red" },
                                                                       { "green", "blue" },
                                                                       { "blue",   "red" }
                                                                     };
  ng_global.progress[ "scr" ][ "win_inthreewaymirror_scr" ].angle_now = { 2, 3, 1 };

end; 
--*******************************************************************************************************************
function private.Load ()

  private.Default();

  private.gamedata = ng_global.progress[ "scr" ][ "win_inthreewaymirror_scr" ];

end;
--*******************************************************************************************************************
function private.LogicInit ()  

  for element = 1, private.numberOfElements do

    ObjSet( private.nameElement..element, { event_mdown  = function () private.Click( element ); end,
                                            event_menter = function () private.Enter( element ); end,
                                            event_mleave = function () private.Leave( element ); end
    } );

  end;

end;
--*******************************************************************************************************************
function private.Enter ( itemID )
 
  SetCursor( CURSOR_HAND );
  
end;
--*******************************************************************************************************************
function private.Leave ( itemID )  

  SetCursor( CURSOR_DEFAULT );
  
end;
--*******************************************************************************************************************
function private.Click ( itemID ) 

  local centerElement = private.nameElement..itemID;
  local centerElement2 = private.nameElement2..itemID;

  local func_end = function()

    cmn.Lock( false );

    private.gamedata.angle_now[itemID] = private.gamedata.angle_now[itemID] + 1;
    private.gamedata.temp_color[itemID][1] = private.color_of_rotation[ itemID ][ private.gamedata.angle_now[itemID] ][1];
    private.gamedata.temp_color[itemID][2] = private.color_of_rotation[ itemID ][ private.gamedata.angle_now[itemID] ][2];

    if private.CheckWin() then
      private.Win();
    end;

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_move_star", 0, "", 0 );
 
  if private.gamedata.angle_now[itemID] == 6 then private.gamedata.angle_now[itemID] = 1; end;
 
  local tempAng = private.gamedata.angle_now[itemID];
  local tempAngle = private.angle_of_rotation[tempAng]; 
  local tempAngleNext = private.angle_of_rotation[tempAng + 1]; 

  local elementLeft = "spr_inthreewaymirror_scr_star_"..itemID.."_left_"..private.color_of_rotation[itemID][tempAng][1];
  local elementLeftNew = "spr_inthreewaymirror_scr_star_"..itemID.."_left_"..private.color_of_rotation[itemID][tempAng + 1][1];

  local elementRight = "spr_inthreewaymirror_scr_star_"..itemID.."_right_"..private.color_of_rotation[itemID][tempAng][2];
  local elementRightNew = "spr_inthreewaymirror_scr_star_"..itemID.."_right_"..private.color_of_rotation[itemID][tempAng + 1][2];

  ObjAnimate( centerElement, "ang", 0, 0, func_end, { 
    0.0, 0, tempAngle, 
    0.6, 0, tempAngleNext,
  } );
  ObjAnimate( centerElement2, "ang", 0, 0, "", { 
    0.0, 0, tempAngle, 
    0.6, 0, tempAngleNext,
  } );

  --color left
  ObjAnimate( elementLeft, "alp", 0, 0, "", { 
    0.0, 0, 1, 
    0.3, 0, 0,
  } );
  ObjAnimate( elementLeftNew, "alp", 0, 0, "", { 
    0.0, 0, 0, 
    0.3, 0, 0, 
    0.6, 0, 1,
  } );

  --color right
  ObjAnimate( elementRight, "alp", 0, 0, "", { 
    0.0, 0, 1, 
    0.3, 0, 0,
  } );
  ObjAnimate( elementRightNew, "alp", 0, 0, "", { 
    0.0, 0, 0, 
    0.3, 0, 0, 
    0.6, 0, 1,
  } );

end;
--*******************************************************************************************************************
function private.Update ()

  for i = 1, private.numberOfElements do
    ObjSet( "spr_inthreewaymirror_scr_star_"..i.."_left_blue",    { alp = 0 } );
    ObjSet( "spr_inthreewaymirror_scr_star_"..i.."_left_red",     { alp = 0 } );
    ObjSet( "spr_inthreewaymirror_scr_star_"..i.."_left_green",   { alp = 0 } );
    ObjSet( "spr_inthreewaymirror_scr_star_"..i.."_left_yellow",  { alp = 0 } );

    ObjSet( "spr_inthreewaymirror_scr_star_"..i.."_right_blue",   { alp = 0 } );
    ObjSet( "spr_inthreewaymirror_scr_star_"..i.."_right_red",    { alp = 0 } );
    ObjSet( "spr_inthreewaymirror_scr_star_"..i.."_right_green",  { alp = 0 } );
    ObjSet( "spr_inthreewaymirror_scr_star_"..i.."_right_yellow", { alp = 0 } );
  end; 
 
  for element = 1, private.numberOfElements do

    ObjSet( private.nameElement..element, { ang =private.angle_of_rotation[ private.gamedata.angle_now[element] ] } );

    ObjSet( "spr_inthreewaymirror_scr_star_"..element.."_right_"..private.gamedata.temp_color[element][2], { alp = 1 } );
    ObjSet( "spr_inthreewaymirror_scr_star_"..element.."_left_"..private.gamedata.temp_color[element][1],  { alp = 1 } );
  end; 

  if private.CheckWin() then
    
    private.Win();
    
  end;
  
end;
--*******************************************************************************************************************
function private.CheckWin ()  

  local result = false;

  --private.win = { { "blue", "green" }, { "red", "green" }, { "blue", "red" } };
  if ( private.gamedata.temp_color[1][1] == private.gamedata.temp_color[3][1] and
       private.gamedata.temp_color[1][2] == private.gamedata.temp_color[2][2] and
       private.gamedata.temp_color[2][1] == private.gamedata.temp_color[3][2] and

       private.gamedata.temp_color[1][1] == "blue" and
       private.gamedata.temp_color[2][1] == "red" and
       private.gamedata.temp_color[2][2] == "green"
     ) then 
     result = true;
  end;

  return result;

end;
--*******************************************************************************************************************
function private.Win () 
  
    cmn.SetEventDone( "win_inthreewaymirror_scr" );
    cmn.CallEventHandler( "win_inthreewaymirror_scr" );

    cmn.Lock( false );
    levelscr.ExitMG();
  
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_clk_slide1", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
  cmn.MiniGameHide();

end;
--*********************************************************************************************************************
function public.Reset ()

  private.Default(); 
  private.Load();
  private.Update(); 

end; 
--*********************************************************************************************************************
function public.Skip ()

  private.gamedata.temp_color = { { "blue", "green" },{ "red", "green" },{ "blue", "red" }};
  private.gamedata.angle_now = { 1, 1, 1 };

  private.Load();
  private.Update(); 
  
  private.Win();

end;
--*********************************************************************************************************************