-- name=mg_librarysecret_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_librarysecret_scr";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_library" } );

  ObjMultiSet({ 
    { "spr_librarysecret_scr_skull6", { event_mdown = private.get_skull6 }},
  });
  
  private.LogicInit(); 
  cmn.AnimateAmbientLight( "spr_librarysecret_scr_light" ); 

  --------------------------------------------------------------------------------------------
  -- function get_skull6 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_skull6" ] = {
    type = "click",                     --special
    use_place = "spr_librarysecret_scr_skull6", --special
    room = "rm_library",
    zz = private.room_objname,
    zz_gate = "gmg_library_librarysecret_scr"
  };
  
  local get_skull6_inv = function ()
  
    local count = 0;
    
    for i = 1, 6 do
      
      if ( cmn.IsEventDone( "get_skull"..i ) ) then
        
        count = count + 1;
        
      end;
      
    end;

    interface.InventoryItemAdd( "inv_skull", "spr_librarysecret_scr_skull6", "assets/levels/level2/inv_deploy/inv_scoop_2/inv/inv_skull" );

    if count == 6 then
      
      ObjSet( "inv_skull", { drag = true } );
      
    else 
      
      ObjSet( "inv_skull", { drag = false } );

    end;  
    
    ObjSet( "inv_skull", { res = "assets/levels/level2/inv_deploy/inv_scoop_2/inv/inv_skull"..count } );
    
  end;
  
  local get_skull6_closezz = function ()
  
    ObjDelete( "gfx_librarysecret_scr_skull6" );
  
  end;
  
  local get_skull6_loc = function ()

    ObjDelete( "gmg_library_librarysecret_scr" );

  end;
  cmn.AddSubscriber( "get_skull6", get_skull6_inv );
  cmn.AddSubscriber( "get_skull6", get_skull6_closezz, private.room_objname );
  cmn.AddSubscriber( "get_skull6", get_skull6_loc, "rm_library" );  
  --------------------------------------------------------------------------------------------
  -- function win_librarysecret_scr () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_librarysecret_scr" ] = {
    type = "win",
    use_place = "gmg_library_librarysecret_scr",
    room = "rm_library",
    zz_gate = "gmg_library_librarysecret_scr"
  };   
  
  local win_librarysecret_scr = function ()

    if ( cmn.IsEventDone( "win_librarysecret_scr" ) ) then  

      ObjMultiSet( { 
        { "spr_librarysecret_scr_shelf",  { input = true, pos_y = 282 } },
        { "obj_librarysecret_scr_plate_vertical",  { input = false, pos_x = 278 } },
        { "obj_librarysecret_scr_plate_gorizontal",  { input = false, pos_y = 282 } },
        { "spr_librarysecret_scr_button_off",  { input = false } },
      } );

    end;

  end;
  local win_librarysecret_scr_loc = function ()

    if ( cmn.IsEventDone( "win_librarysecret_scr" ) ) then  

    end;

  end;
  --cmn.AddSubscriber( "win_librarysecret_scr", win_librarysecret_scr, private.room_objname );
  --cmn.AddSubscriber( "win_librarysecret_scr", win_librarysecret_scr_loc, "rm_library" );  
  --------------------------------------------------------------------------------------------
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_skull6 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_skull6" );
  cmn.CallEventHandler( "get_skull6" );
  
  cmn.GotoRoom( "rm_library" );

end;
--*********************************************************************************************************************
function public.Open () 
end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level2/env/aud_library_env" }, "", 0.5 );
  cmn.MiniGameShow();

  private.Load();
  private.Update();

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level2/env/aud_library_env", 0.5 );
    
  cmn.MiniGameHide();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

private.gamedata = {};

private.win_vertical = { 2, 1, 4, 3 };
private.win_gorizontal = { 4, 3, 2, 1 };

private.win_field_vertical = { 
                                { 1, 1, 0, 0 },
                                { 0, 1, 0, 1 },
                                { 0, 1, 1, 0 },
                                { 1, 0, 0, 1 } 
                             };
                              
private.win_field_gorizontal = { 
                                  { 0, 0, 1, 1 },
                                  { 1, 0, 1, 0 },
                                  { 1, 0, 0, 1 },
                                  { 0, 1, 1, 0 } 
                               };
                            
private.coordinates_vertical = { 
                                  { pos_x = 270, pos_y = 491 },
                                  { pos_x = 341, pos_y = 491 },
                                  { pos_x = 411, pos_y = 491 },
                                  { pos_x = 480, pos_y = 491 } 
                               };
 
private.coordinates_gorizontal = { 
                                    { pos_x = 654, pos_y = 103 },
                                    { pos_x = 654, pos_y = 173 },
                                    { pos_x = 654, pos_y = 244 },
                                    { pos_x = 654, pos_y = 313 } 
                                 };  
                            
private.lastPlateID = 0;
private.lastPlateType = "";


private.PLATE_NAME = "spr_librarysecret_scr_plate_";

private.PLATE_COUNT = 4;
private.FIELD_SIZE = 4;
private.FIRST_PLATE = 0;


--*******************************************************************************************************************
function private.Default ()

  ng_global.progress[ "scr" ][ "win_librarysecret_scr" ].states_vertical = { 1, 2, 3, 4 };
  ng_global.progress[ "scr" ][ "win_librarysecret_scr" ].states_gorizontal = { 1, 2, 3, 4 };
  
  -- 1 - ball, 0 - empty 
  ng_global.progress[ "scr" ][ "win_librarysecret_scr" ].field_vertical = {
                                                                        { 1, 1, 0, 0 },
                                                                        { 1, 0, 1, 0 },
                                                                        { 1, 0, 0, 1 },
                                                                        { 0, 1, 1, 0 } 
                                                                     };
                                                                      
  ng_global.progress[ "scr" ][ "win_librarysecret_scr" ].field_gorizontal = {
                                                                          { 0, 1, 1, 0 },
                                                                          { 1, 0, 0, 1 },
                                                                          { 1, 0, 1, 0 },
                                                                          { 0, 0, 1, 1 } 
                                                                       };
                                                                        
end; 
--*******************************************************************************************************************
function private.Load ()

  private.Default();

  private.gamedata = ng_global.progress[ "scr" ][ "win_librarysecret_scr" ];

end;
--*******************************************************************************************************************
function private.LogicInit ()  
  
  local plateType = { "vertical", "gorizontal" };
   
  for i = 1, #plateType, 1 do  
    
    for j = 1, private.PLATE_COUNT, 1 do 
      
      local curPlate = private.PLATE_NAME..plateType[ i ].."_"..j;
      ObjSet( curPlate, { 
                            input = true,
                            event_mdown = function () private.PlateClick( plateType[ i ], j ); end,
                            event_menter = function () private.Enter( curPlate ); end,
                            event_mleave = function () private.Leave( curPlate ); end
                        } );
                      
    end;
    
  end;  
                        
  ObjSet( "spr_librarysecret_scr_button_off", { 
                            input = true,
                            event_mdown = function () private.ButtonClick(); end,
                            event_menter = function () private.Enter( "spr_librarysecret_scr_button_off" ); end,
                            event_mleave = function () private.Leave( "spr_librarysecret_scr_button_off" ); end
                        } );

end;
--*******************************************************************************************************************
function private.Enter ( nameFocus )
 
  SetCursor( CURSOR_HAND );
  
  local current = nameFocus.."_light";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );
  
end;
--*******************************************************************************************************************
function private.Leave ( nameFocus )  

  SetCursor( CURSOR_DEFAULT );
  
  local current = nameFocus.."_light";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );
  
end;
--*******************************************************************************************************************
function private.PlateClick ( plateType, plateID ) 
  
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

  local func_end = function ()

    cmn.Lock( false );
    private.Update(); 
    
  end;
    
  cmn.Lock( true );
  
  if ( private.lastPlateID == private.FIRST_PLATE ) then
    
    local curPlateFocus = private.PLATE_NAME..plateType.."_"..plateID.."_focus";
    ObjAnimate( curPlateFocus, "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1 } );
    
    private.lastPlateID = plateID;
    private.lastPlateType = plateType;
    
  elseif ( private.lastPlateID ~= plateID and
  private.lastPlateType == plateType ) then
  
    local lastSlotID = private.GettingSlotID( private.lastPlateType, private.lastPlateID );
    local curSlotID = private.GettingSlotID( plateType, plateID );
    
    private.ChangeField( plateType, lastSlotID, curSlotID ); 
    
    local temp = private.gamedata[ "states_"..private.lastPlateType ][ lastSlotID ];
    private.gamedata[ "states_"..private.lastPlateType ][ lastSlotID ] = private.gamedata[ "states_"..plateType ][ curSlotID ];
    private.gamedata[ "states_"..plateType ][ curSlotID ] = temp;
    
    local lastPlateFocus = private.PLATE_NAME..private.lastPlateType.."_"..private.lastPlateID.."_focus";
    ObjAnimate( lastPlateFocus, "alp",0,0, "", { 0, 0, 1,    0.3, 0, 0 } );
    
    local lastPlate = private.PLATE_NAME..private.lastPlateType.."_"..private.lastPlateID;
    local curPlate = private.PLATE_NAME..plateType.."_"..plateID;
    
    local lastPlateX = private[ "coordinates_"..private.lastPlateType ][ lastSlotID ].pos_x;
    local lastPlateY = private[ "coordinates_"..private.lastPlateType ][ lastSlotID ].pos_y;
    local curPlateX = private[ "coordinates_"..plateType ][ curSlotID ].pos_x;
    local curPlateY = private[ "coordinates_"..plateType ][ curSlotID ].pos_y;
    
    private.lastPlateID = 0;
    private.lastPlateType = "";
    
    ObjMultiSet( { 
      { lastPlate,  { pos_z = 10 } },
      { curPlate,  { pos_z = 10 } },
    } );
    
    ObjAnimate( lastPlate, "pos_xy",0,0, func_end, { 0, 3, lastPlateX, lastPlateY,    0.4, 3, curPlateX, curPlateY } );
    ObjAnimate( curPlate, "pos_xy",0,0, "", { 0, 3, curPlateX, curPlateY,    0.4, 3, lastPlateX, lastPlateY } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter2", 0, "", 0 );
    
  else 
    
    --DbgTrace( "WRONG" );
    
    local curPlateFocus = private.PLATE_NAME..private.lastPlateType.."_"..private.lastPlateID.."_focus";
    ObjAnimate( curPlateFocus, "alp",0,0, func_end, { 0, 0, 1,    0.3, 0, 0 } );   
   
    private.lastPlateID = 0;
    private.lastPlateType = ""; 
    
  end;

end;
--*******************************************************************************************************************
function private.GettingSlotID ( plateType, plateID )
  
  local slotID = 1;
  
  for i = 1, #private.gamedata[ "states_"..plateType ], 1 do 
    
    if plateID == private.gamedata[ "states_"..plateType ][ i ] then
      
      slotID = i;
      
    end;
    
  end;
  
  return slotID;
  
end;
--*******************************************************************************************************************
function private.ChangeField ( plateType, slotID_1, slotID_2 )
  
  local temp = { 0, 0, 0, 0 };
  
  for i = 1, private.FIELD_SIZE, 1 do 
    
    if plateType == "vertical" then
      
      temp[ i ] = private.gamedata.field_vertical[ i ][ slotID_1 ];
      private.gamedata.field_vertical[ i ][ slotID_1 ] = private.gamedata.field_vertical[ i ][ slotID_2 ];
      private.gamedata.field_vertical[ i ][ slotID_2 ] = temp[ i ];
      
    elseif plateType == "gorizontal" then
      
      temp[ i ] = private.gamedata.field_gorizontal[ slotID_1 ][ i ];
      private.gamedata.field_gorizontal[ slotID_1 ][ i ] = private.gamedata.field_gorizontal[ slotID_2 ][ i ];
      private.gamedata.field_gorizontal[ slotID_2 ][ i ] = temp[ i ];
      
    end;
    
  end;
  
end;
--*******************************************************************************************************************
function private.ButtonClick () 
  
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_round", 0, "", 0 );

  local func_end = function ()

    cmn.Lock( false );
    
    if private.CheckWin() then
      
      private.Win();
      
    else
      
      local func_end_2 = function ()
        
        cmn.Lock( false );
              
      end;
      
      cmn.Lock( true );
      common_impl.PlayAudio( "sfx", "aud_clk_wrong", 0, "", 0 );      

      ObjAnimate( "obj_librarysecret_scr_plate_vertical", "pos_x",0,0, func_end_2, { 0, 3, 278,    0.6, 3, 0 } );
      ObjAnimate( "obj_librarysecret_scr_plate_gorizontal", "pos_y",0,0, "", { 0, 3, 282,    0.6, 3, 0 } );   
        
    end;
  
  end;
  
  cmn.Lock( true );
  
  ObjAnimate( "obj_librarysecret_scr_plate_vertical", "pos_x",0,0, func_end, { 0, 3, 0,    0.6, 3, 278,    1.6, 3, 278 } );
  ObjAnimate( "obj_librarysecret_scr_plate_gorizontal", "pos_y",0,0, "", { 0, 3, 0,    0.6, 3, 282 } );
  
  ObjAnimate( "spr_librarysecret_scr_button_on", "alp",0,0, "", { 0, 0, 0,    0.1, 0, 1,    0.2, 0, 0 } );
  
end;
--*******************************************************************************************************************
function private.Update ()
  
  local plateType = { "vertical", "gorizontal" };
   
  for i = 1, #plateType, 1 do  
    
    for j = 1, private.PLATE_COUNT, 1 do 
      
      local curPlate = private.PLATE_NAME..plateType[ i ].."_"..private.gamedata[ "states_"..plateType[ i ] ][ j ];
      
      local curPlateX = private[ "coordinates_"..plateType[ i ] ][ j ].pos_x;
      local curPlateY = private[ "coordinates_"..plateType[ i ] ][ j ].pos_y;
      
      ObjSet( curPlate, { pos_x = curPlateX, pos_y = curPlateY, pos_z = 0 } );
    
    end;
    
  end;
  
end;
--*******************************************************************************************************************
function private.CheckWin () 
  
  local result = true;
  
  for i = 1, private.FIELD_SIZE, 1 do 
    
    for j = 1, private.FIELD_SIZE, 1 do 
      
      if ( private.gamedata.field_vertical[ i ][ j ] == private.gamedata.field_gorizontal[ i ][ j ] ) then
        
        result = false;
        break;
        
      end;
      
    end;    
      
  end;
  
  return result;

end;
--*******************************************************************************************************************
function private.Win () 
  
  cmn.SetEventDone( "win_librarysecret_scr" );
  cmn.CallEventHandler( "win_librarysecret_scr" );

  levelscr.ExitMG();

  cmn.MiniGameHide();
  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
end;
--*********************************************************************************************************************
function public.Reset ()
  
  ObjMultiSet( { 
    { "obj_librarysecret_scr_plate_vertical",  { pos_x = 0, pos_y = 0 } },
    { "obj_librarysecret_scr_plate_gorizontal",  { pos_x = 0, pos_y = 0 } },
  } );

  private.lastPlateID = 0;
  private.lastPlateType = "";

  private.Default(); 
  private.Load();
  private.Update(); 

end; 
--*********************************************************************************************************************
function public.Skip ()
  
  private.gamedata.states_vertical = private.win_vertical;
  private.gamedata.states_gorizontal = private.win_gorizontal;
  
  private.gamedata.field_vertical = private.win_field_vertical;
  private.gamedata.field_gorizontal = private.win_field_gorizontal;
  
  private.Load();
  private.Update(); 
  
  private.ButtonClick();

end;

