-- name=levelscr

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );
  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, 0 );
  interface.WidgetSetInput( InterfaceWidget_BtnHint, false );  

  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetSetVisible( InterfaceWidget_BtnSkip, 0 );
  interface.WidgetSetInput( InterfaceWidget_BtnSkip, false );    

  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  interface.WidgetAdd( InterfaceWidget_Inventory, 9 ); 
  interface.WidgetSetVisible( InterfaceWidget_Inventory, 0 );
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );   

  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_Tutorial );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.PanelNotificationAdd();

  --interface.DialogHintAdd();
  --interface.EvidenceAdd( 18 );
  --interface.DialogEvidenceAdd( 20 );
  --interface.InvestigationButtonAdd( 17 ); 
  --interface.SliderAdd( -1 );
  --interface.ProvideAdd( 8 );
  --interface.ButtonTimerAdd( 10 );
  --interface.DialogTaskAdd( 20 );  
  interface.DeployInvAdd( 9 );

  --if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    --interface.BtnMorphAdd( 25 );

  --end;

  private.Init();
  ModLoad( "assets/levels/levelscr/mod_levelscr_inv" );
  levelscr_inv.Init();

  common.LevelLoad( "levelscr", "scr", "rm_porch_lvl4", param );
  --if IsCollectorsEdition() then

    --common_impl.Collectibles2CoinsLoad();

  --end;

  private.TutorialSetParams();
  --interface.KeyUpdate();

  --event_show_investigation = "beg_levelscr";

  --interface.InvestigationButtonCheck();
  
  --interface.PanelProvideShow();
  
  cmn.PlayMusEnv();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
  
     "ho_darkcorner_scr"
    ,"ho_minibar_scr"
    ,"ho_portraithall_scr"
    ,"ho_signs_scr"  
    ,"ho_baths_scr"
    ,"ho_underbookcase_scr" 
    ,"ho_winecollection_scr"
    ,"ho_withflashlight_scr"  
    ,"ho_in_safe_scr"
    ,"ho_knight_arrmor_scr"
    ,"ho_lucien_table_scr"
    ,"ho_weapon_scr"
    ,"ho_in_chest_scr"
    ,"ho_next_armchair_scr"
    ,"ho_stone_stash_scr"
    ,"ho_storage_scr"
  
    ,"mg_inthreewaymirror_scr"
    ,"mg_onworkbench_scr"
    ,"mg_scaryhead_scr"
  
    ,"mg_chain_scr"
    ,"mg_incabinet_scr"
    ,"mg_librarysecret_scr"
  
    ,"mg_boss_fight_scr"
    ,"mg_catacomb_scr"
    ,"mg_clock_scr"    
  
    ,"mg_attack_scr"
    ,"mg_catacombs_fear_scr"
    ,"mg_gates_lvl4_scr"
    ,"mg_minigame_3_scr" 

  };

  game.progress_names =
  {
    "opn_darkcorner_scr"
    ,"opn_minibar_scr"
    ,"opn_portraithall_scr"
    ,"opn_signs_scr" 
    ,"opn_baths_scr"
    ,"opn_underbookcase_scr"  
    ,"opn_winecollection_scr"
    ,"opn_withflashlight_scr" 
    ,"opn_in_safe_scr"
    ,"opn_knight_arrmor_scr"
    ,"opn_lucien_table_scr"
    ,"opn_weapon_scr"
    ,"opn_in_chest_scr"
    ,"opn_next_armchair_scr"
    ,"opn_stone_stash_scr"
    ,"opn_storage_scr"
  
    ,"win_darkcorner_scr"
    ,"win_minibar_scr"
    ,"win_portraithall_scr"
    ,"win_signs_scr" 
    ,"win_baths_scr"
    ,"win_underbookcase_scr"  
    ,"win_winecollection_scr"
    ,"win_withflashlight_scr" 
    ,"win_in_safe_scr"
    ,"win_knight_arrmor_scr"
    ,"win_lucien_table_scr"
    ,"win_weapon_scr"
    ,"win_in_chest_scr"
    ,"win_next_armchair_scr"
    ,"win_stone_stash_scr" 
    ,"win_storage_scr"
    
    ,"win_inthreewaymirror_scr"
    ,"win_onworkbench_scr"
    ,"win_scaryhead_scr"
    ,"win_chain_scr"
    ,"win_incabinet_scr"
    ,"win_librarysecret_scr"
    ,"win_boss_fight_scr"
    ,"win_catacomb_scr"
    ,"win_clock_scr"   
    ,"win_attack_scr"
    ,"win_catacombs_fear_scr"
    ,"win_gates_lvl4_scr"
    ,"win_minigame_3_scr"  

 --   ,"clk_portraithall_scr_door"                                    
 --   ,"clk_portraithall_scr_eagle"   

 --   ,"clk_horse_scr"                        
 --   ,"clk_duck_scr"                         
  };
  
  --game.progress_names = {};
  --for i = 1, #game.progress_names_room do
    --game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  --end;
  
  game.relations = {};
  
  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

end;
--************************************************************************************************************************

function private.TutorialSetParams()

  if not ng_global.progress[ "scr" ][ "see_tutorial_scr" ] then

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ] = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].done  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].start = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.no  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.currentpage = "tutorial_page_1_scr";
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].func = function() end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );
      
    end;

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages = {

      [ "tutorial_page_1_scr" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = {} } , -- Показать туториал? 

      [ "tutorial_page_2_scr" ] = { shown = 0, noskip = false, posx = 350, posy = 280, arrows = { 
                                                                              { pos_x = 650, pos_y = 200, ang =  -1.2 }
                                                                            } },   -- туториал на кнопку сообщений

      [ "tutorial_page_3_scr" ] = { shown = 0, noskip = false, posx = 400, posy = 500, arrows = { 
                                                                              { pos_x = 350, pos_y = 350, ang =  0 }
                                                                            } },   -- туториал на две папки

      [ "tutorial_page_4_scr" ] = { shown = 0, noskip = false, posx = 700, posy = 500, arrows = { 
                                                                              { pos_x = 400, pos_y = 490, ang =  1.3 }
                                                                            } },   -- туториал на задания в папках

      [ "tutorial_page_5_scr" ] = { shown = 0, noskip = false, posx = 200, posy = 400, arrows = { 
                                                                              { pos_x = 500, pos_y = 300, ang =  -1.1 }
                                                                            } },   -- туториал о получении звезд

      [ "tutorial_page_6_scr" ] = { shown = 0, noskip = false, posx = 350, posy = 350, arrows = { 
                                                                              { pos_x = 100, pos_y = -30, ang =  2, target = "spr_int_button_timer" }
                                                                            } },   -- туториал на таймер

      [ "tutorial_page_7_scr" ] = { shown = 0, noskip = false, posx = 210, posy = 300, arrows = { 
                                                                              { pos_x = 500, pos_y = 230, ang =  -1.3 }
                                                                            } },   -- туториал на папку с видеороликами
    };

  end;

end;
--************************************************************************************************************************
function public.InventoryDisable ()

  interface.WidgetSetVisible( InterfaceWidget_Inventory, false );
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );    
  ObjStopAnimate( "int_inventory", "alp" );
  ObjSet( "int_inventory", { alp = 0 } );  

end;
--************************************************************************************************************************
function public.ExitMG ()

  common.LevelSwitch( "menu", "extra" ); 

end;