-- name=rm_collectibles2

--******************************************************************************************
function public.Init ()
-------------------------------------------------------------------------------------------- 
  private.ANIM_TIME = 0.2;
--------------------------------------------------------------------------------------------
  local table_multiset = {};

  table.insert( table_multiset, { "obj_collectibles2_btn_exit", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "spr_collectibles2_btn_exit_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "spr_collectibles2_btn_exit_focus" ) end; } } );
        
  table.insert( table_multiset, { "obj_collectibles2_btn_close", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "anm_collectibles2_btn_close_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "anm_collectibles2_btn_close_focus" ) end; } } );
        
  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

end;


--******************************************************************************************
function public.PreOpen ()

  local table_multiset = {};

  for i = 1, common_impl.collectibles2.count do
  
    local event = "get_collect2_item_"..i;
    
    if ( ng_global.collectibles2[ event ] and not ng_global.collectibles2[ event ].done ) then
 
      table.insert( table_multiset, { "spr_collectibles2_crest_part_"..i, { alp = 0 } } );   

    else 
      
      if ( ng_global.collectibles2[ event ].show ) then  
 
        table.insert( table_multiset, { "spr_collectibles2_crest_part_"..i, { alp = 1 } } );

      else 
  
        table.insert( table_multiset, { "spr_collectibles2_crest_part_"..i, { alp = 0 } } );  
        
        ng_global.collectibles2[ event ].show = true;
        private.ShowAnimCrestPart( i );

      end;

    end;

  end;

  if( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset ); 

  end;

end;


--******************************************************************************************
function public.Open ()

end;


--******************************************************************************************
function public.Close ()

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    cmn.ExitRmWithoutInterface();
    
  end;

end;


--******************************************************************************************
function private.BtnMouseEnter( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

end;


--******************************************************************************************
function private.BtnMouseLeave( obj )
    
  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;


--******************************************************************************************
function private.BtnCloseMouseDown( )

  local current_room = common.GetCurrentRoom();
  if ( not current_room ) then

    current_room = "rm_extra";

  end;  

  common.GotoRoom( current_room );

end;


--******************************************************************************************
function private.ShowAnimCrestPart ( id )

  local func_end = function ()
    
    cmn.Lock( false );

    ObjSet( "spr_collectibles2_crest_part_"..id, { alp = 1 } );
    ObjDelete( "pfx_collectibles2_crest_part_"..id );

  end;

  cmn.Lock( true );
  
  local partsys_name  = "pfx_collectibles2_crest_part_"..id; 
  ObjCreate( partsys_name, "partsys" );

  local drawoff_x = ObjGet( "spr_collectibles2_crest_part_"..id ).drawoff_x;
  local drawoff_y = ObjGet( "spr_collectibles2_crest_part_"..id ).drawoff_y;

  ObjSet( partsys_name, {
    res = "assets/interface/resources/effects_ho",
    pos_x = drawoff_x, pos_y = drawoff_y,   
    input = false, pos_z = 10, blendmode = 2,
  } );

  PartSysSetMaskObj( partsys_name, "spr_collectibles2_crest_part_"..id ); 
  ObjAttach( partsys_name, "obj_collectibles2_crest_part" );

  ObjAnimate( partsys_name, "alp", 0, 0, func_end,{
    0.0, 0, 1,
    0.2, 0, 1,  
    1.0, 0, 0,
  } ); 

  ObjAnimate( "spr_collectibles2_crest_part_"..id, "alp", 0, 0, "", { 
    0.0, 0, 0,
    0.2, 0, 0,  
    1.0, 0, 1,
  });

end;




