-- name=rm_menu
--******************************************************************************************
function public.Init()
  
  local tb = {};

  table.insert( tb, { "menu_but_play", 
  {
    event_mdown = private.PlayDown--,
    --event_menter = function () private.ButMouseEnter( "play" ); end,
    --event_mleave = function () private.ButMouseLeave( "play" ); end
  }});

  table.insert( tb, { "obj_menu_bat", 
  {
    event_mdown = private.AnimBat
  }});

  ObjMultiSet( tb );

  ObjSet("menu_but_options", 
  {
    event_mdown = private.OptionsDown
  });
  
  ObjSet( "menu_but_credits", 
  {
    event_mdown = private.CreditsDown
  } );

  ObjSet( "menu_but_profile", 
  {
    event_mdown = private.ProfileDown
  } );
  ObjSet( "menu_but_moregames", 
  {
    event_mdown = private.MoreGamesDown
  } );
  ObjSet( "menu_but_forum", 
  {
    event_mdown = private.ForumDown
  } );
 
  ObjSet("menu_but_sequel", { event_mdown = private.SneakPeakDown });
  ObjSet("menu_but_save50", { event_mdown = private.Save50Down });
  ObjSet("menu_but_support", { event_mdown = function() common.dialog.options.SupportDown(); end });
  ObjSet("menu_but_terms", { event_mdown = function() common.dialog.options.TermsDown(); end });
  ObjSet("menu_but_privacy", { event_mdown = function() common.dialog.options.PolicyDown() end});
  ObjSet("menu_but_credits", { event_mdown = function() common.MenuCredits("credits"); end});
  
  ObjSet("menu_but_unlock", { event_mdown = private.UnlockDown,
    --event_menter = function() private.ButMouseEnter( "unlock" ); end,
    --event_mleave = function() private.ButMouseLeave( "unlock" ); end
    });
    ObjSet("spr_menu_but_back_button", { event_mdown = function() public.closeGearSubMenu(); end--,
    --event_menter = function() private.ButMouseEnter( "close_gear" ); end,
    --event_mleave = function() private.ButMouseLeave( "close_gear" ); end
    });
  ObjSet("menu_but_gear", { event_mdown = function() public.openGearSubMenu(); end,
    --event_menter = function() private.ButMouseEnter( "gear" ); end,
    --event_mleave = function() private.ButMouseLeave( "gear" ); end 
    });
  
  ObjSet( "menu_but_extra", 
  {
    event_mdown = private.ExtraDown,
    --event_menter = function() private.ButMouseEnter( "extra" ); end,
    --event_mleave = function() private.ButMouseLeave( "extra" ); end 
  } );
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  
  if GetPlatform() == "android" then
    ObjSet("menu_but_forum",{ alp = 0, input = false, visible = false });  
    ObjSet("menu_but_credits",{ pos_x = 512 });  
  end;
  
  
end;
--******************************************************************************************
function private.ButMouseEnter(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1.1, scale_y = 1.1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1.1, scale_y = 1.1 }); 
  end;
end;
--******************************************************************************************
function private.ButMouseLeave(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1, scale_y = 1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1, scale_y = 1 }); 
  end;
end;
--******************************************************************************************
local wait_gear;
public.sub_menu_active = false;
--******************************************************************************************
function public.closeGearSubMenu()
  private.ButMouseEnter( "close_gear" );
  port.TapDownTimer(0.5,
    function() 
      private.ButMouseLeave("close_gear");
      public.sub_menu_active = false;
      ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
    end
  );
  
end;
--******************************************************************************************
function public.openGearSubMenu()
  private.ButMouseEnter( "gear" );
  port.TapDownTimer(0.5,
    function() 
      public.sub_menu_active = true;
      ObjSet("menu_port_hub_sub_menu", { active = true, visible = true, input = true, alp = true });
      private.ButMouseLeave("gear");
    end
  );
  
end;
--******************************************************************************************
function public.gearOverAngle()
  
  local current_ang = ObjGet("spr_menu_but_gear").ang;
  
  if (wait_gear) then
    
    ObjSet( "tmr_gear", { time = 0.5, playing = 1, endtrig = function() wait_gear = false; public.gearOverAngle(); end  } );
  else
    wait_gear = true;
    local end_ang = current_ang + ((360/8)*3.14)/180;
    ObjAnimate( "spr_menu_but_gear", "ang", 0, 0, function() public.gearOverAngle(); end , {0,0,current_ang, 1,0,end_ang} ); 
  end;
  
  
end;
--******************************************************************************************
function public.PreOpen()
  
  ObjSet( "obj_menu_ce_buttons_left",  { input = false } );
  ObjSet( "spr_menu_but_extra_active",  { alp = 0, visible = false } );
  ObjSet( "spr_menu_but_extra_notactive",  { alp = 1, visible = true } );
  
  ObjSet( "obj_menu_ce_buttons_right", { active = false, visible = false, input = false } );

  if ( IsCollectorsEdition() ) then

    ObjSet( "obj_menu_ce_buttons_left",  { input = true } );
    ObjSet( "spr_menu_but_extra_active",  { alp = 1, visible = true } );
    ObjSet( "spr_menu_but_extra_notactive",  { alp = 0, visible = false } );
  
    ObjSet( "obj_menu_ce_buttons_right", { active = true, visible = true, input = true } );
    ObjSet( "spr_menu_logo_ce",      { visible = true } );

  else

    ObjSet( "obj_menu_ce_buttons_left", { input = false, visible = false } );
    --ObjSet( "spr_menu_but_extra_active",  { alp = 0, visible = false } );
    --ObjSet( "spr_menu_but_extra_notactive",  { alp = 1, visible = true } );
    
    ObjSet( "obj_menu_but_strguide", { input = false, visible = false } );
    --ObjSet( "spr_menu_but_strguide", { alp = 0, visible = false } );
    --ObjSet( "spr_menu_but_strguide_noactive", { alp = 1, visible = true } );

  end;

  public.SetProfileText( GetCurrentProfile() );
  public.ButtonSetPos();

  common_impl.PlayAudio( "mus", "aud_main_theme_mus", 1 );
  common_impl.PlayAudio( "env", "aud_mainmenu_env", 1, "", 0 );

  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  wait_gear = false;
  public.gearOverAngle();  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      iOS_LogEvents(2);
        
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
      ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
      ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
      ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
      ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;

    if port.isTablet() == 0 then
        ObjSet("tmr_menu_performance", {endtrig = function() private.PerformanceWarning(); end, time = 2, playing = 1 });
    end;
      
    

    if iOS_IsiSplashPressed() == 1 then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsRated() == 1 then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsBought() == 1 then
        ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });
    end;
  end;
      
end;
--******************************************************************************************
function public.Open()

  if ( IsCollectorsEdition() ) then

    if ( ng_global.progress[ "std" ].common.gamewin == true ) and
       ( ng_global.progress[ "std" ].common.gamestart == false ) and
         ( not ng_global.bonusunlock ) then

      common.DialogWindowShow( "common", "bonusunlock", false );
      ng_global.bonusunlock = true;

      SaveProfiles();

    elseif ( ng_global.progress[ "ext" ].common.gamewin == true ) and
       ( ng_global.progress[ "ext" ].common.gamestart == false ) and
         ( not ng_global.secretunlock ) then

      common.DialogWindowShow( "common", "secretunlock", false );
      ng_global.secretunlock = true;

      SaveProfiles();

    end;

  end;

end;

--***ios fix***************************************************************************************
function public.PreClose()
  ObjStopAnimate( "spr_menu_but_gear", "ang");
  ObjSet( "tmr_gear", { playing = 0 }); 
end;
--******************************************************************************************
function private.PerformanceWarning()
   if tostring(GetPlatform()) == "ios" then
    iOS_PerformanceWarning();
  else
    DbgTrace("SetPerformanceMode(1)");
    SetPerformanceMode(1);
  end;
end;
--******************************************************************************************
function private.Save50Timer()
  if iOS_IsiSplashPressed() == 1 then
    ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
  end;
end;
--******************************************************************************************
function private.SneakpeakTimer()
  if iOS_IsRated() == 1 then
    ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
  end;
end;
-------------------------ios----------------------------------------
function private.UnlockTimer()
  if iOS_IsBought() == 1 then
    ObjSet("menu_but_unlock", { input = 0, visible = 0, active = 0, alp = 0 });
  else
    ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });  
  end;
end;
--******************************************************************************************
function public.SetProfileText ( name )
  
  local obj = "txt_menu_but_profile";
  local profile_name = "";

  if  ( name ~= "ng_noprofiles" ) and ( name ~= "ng_error" ) then

    profile_name = name;

  end;

  ObjSet( obj, { text = profile_name } );

end;
--******************************************************************************************
function private.PlayDown()

  private.ButMouseEnter( "play" );
  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );
  port.TapDownTimer(0.5,
    function()
      private.ButMouseLeave( "play" );
      common.MenuPlay();
    end
    ); 
  

end;
--******************************************************************************************
function private.OptionsDown()

  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );
  common.MenuOptions();

end;
--******************************************************************************************
function private.QuitDown()

  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );
  common.MenuQuit();

end;
--******************************************************************************************
function private.ExtraDown()

  private.ButMouseEnter( "extra" );
  
  port.TapDownTimer(0.5,
    function()
      private.ButMouseLeave( "extra" );
      if port.isPortable() == 1 then
        if iOS_IsBought() == 1 then
          common.MenuExtra();
        else
          common.MenuUnlock();
        end;
      else
        common.MenuExtra();
      end;
    end
    ); 
  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );

end;
--******************************************************************************************
function private.StrguideDown()

  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );

  if IsCollectorsEdition() then

    common_impl.ButtonGuide_Click();
    interface.StrategyGuideShow();

  else

    local guide_url = GetGuideUrl();
    OpenBrowser( guide_url );

  end;

end;
--******************************************************************************************
function private.ProfileDown()

  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );
  common.MenuProfile();

end;
--*****************************************************************************************
function private.MoreGamesDown()

  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );
  iOS_MoreGamesPressed();

end;
--*************************************ios*****************************************************
function private.Save50Down()
  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );
  common.MenuSave50();
end;
--*************************************ios*****************************************************
function private.UnlockDown()
  private.ButMouseEnter( "unlock" );
  port.TapDownTimer(0.5,
    function()
      common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );
      private.ButMouseLeave( "unlock" );
      common.MenuUnlock();
    end
   );
end;
--*************************************ios*****************************************************
function private.SneakPeakDown()
  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );
  common.MenuSneakPeak();
end;
--*************************************ios*****************************************************
function private.ForumDown()
  common_impl.PlayAudio( "sfx", "aud_menu_click", 0, "", 0 );
  iOS_LaunchForum();
end;
--******************************************************************************************
function private.ButtonMouseEnter( but_name, type )

  common_impl.PlayAudio( "sfx", "aud_menter_menu", 0, "", 0 );
  SetCursor( CURSOR_HAND );

  local type = type or "spr";
  local obj_focus = type.."_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function private.ButtonMouseLeave( but_name, type )

  SetCursor( CURSOR_DEFAULT );

  local type = type or "spr";
  local obj_focus = type.."_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function public.ButtonSetPos()

  local offwidth = 0.5 * ( GetAppWidth() - 1024 );

end;
--******************************************************************************************
function private.AnimBat()

  local func_end = function ()
  
    ObjSet( "obj_menu_bat", { input = true } );
  
  end;
  
  ObjSet( "obj_menu_bat", { input = false } );

  AnimPlay( "anm_menu_bat", "bat", func_end );
  
end;






