-- name=levelext

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 20 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 20 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 19 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup, 27 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog, 26 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 26 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 19 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide, 23 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 18 );
    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
    interface.BtnMorphAdd( 18 );

  end;

  private.Init();
  --ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  --levelext_inv.Init();

  common.LevelLoad( "secretroom", "secretroom", "rm_firstfloor_ext", param, private.menu_moduls );

  common_impl.CollectiblesBirdsLoadOnLocation();
  common_impl.Collectibles2Load();
  common_impl.MorphLoad();

  private.TutorialSetParams();
  interface.KeyUpdate();

  cmn.PlayMusEnv();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
  "rm_firstfloor_ext"
  ,"rm_dukesoffice_ext"
  ,"rm_outsideuniversity"
  ,"rm_sportsground_ext"
  ,"rm_reservationentrance"
  ,"rm_reservation"
  ,"rm_oceanarium"
  ,"rm_aviaries"
  ,"rm_poultryhouse"
  ,"ho_officeduke"
  ,"mg_forest"
  ,"mg_spreader"
  ,"ho_bleachers"
  ,"mg_mgpump"
  ,"ho_policecase"
  ,"ho_inhollow"
  ,"mg_prisoncell"
  };

  game.progress_names_room =
  {
  { "opn_firstfloor_ext" }
  ,{ "see_intro_ext" }
  ,{ "dlg_firstfloor_ext_police_1" }
  ,{ "opn_dukesoffice_ext" }
  ,{ "dlg_dukesoffice_ext_police_2" }
  ,{ "opn_officeduke" }
  ,{ "win_officeduke" }
  ,{ "clk_fobosfolder_1" }
  ,{ "clk_fobosfolder_2" }
  ,{ "clk_fobosfolder_3" }
  ,{ "clk_fobosfolder_4" }
  ,{ "get_amuletbeast1" }
  ,{ "get_code_ext" }
  ,{ "get_passingphoto" } 
  ,{ "see_outsideuniversity_door",  "rm_firstfloor_ext" }
  ,{ "use_code_ext",                "rm_dukesoffice_ext" }
  ,{ "win_officewindow",            "rm_dukesoffice_ext" }
  ,{ "get_signet",                  "rm_dukesoffice_ext" }
  ,{ "get_gunpowder",               "rm_dukesoffice_ext" }
  ,{ "use_signet",                  "rm_dukesoffice_ext" }
  ,{ "clk_signet",                  "rm_dukesoffice_ext" }
  ,{ "get_wrench_ext",              "rm_dukesoffice_ext" }
  ,{ "use_wrench_ext_1",            "rm_firstfloor_ext" }
  ,{ "get_valve_ext",               "rm_firstfloor_ext" }
  ,{ "use_valve_ext",               "rm_firstfloor_ext" }
  ,{ "clk_valve_ext",               "rm_firstfloor_ext" }
  ,{ "get_amuletbeast2",            "rm_firstfloor_ext" }
  ,{ "opn_outsideuniversity" }
  ,{ "see_secret_path",             "rm_outsideuniversity" }
  ,{ "clk_grass_1",                 "rm_outsideuniversity" }
  ,{ "clk_grass_2",                 "rm_outsideuniversity" }
  ,{ "get_stone_ext",               "rm_outsideuniversity" }
  ,{ "use_stone_ext",               "rm_firstfloor_ext" }
  ,{ "get_wireroll",                "rm_firstfloor_ext" }
  ,{ "clk_hook_ext_1" }
  ,{ "clk_hook_ext_2" }
  ,{ "clk_hook_ext_3" }
  ,{ "clk_hook_ext_4" }
  ,{ "get_hook_ext" }
  ,{ "use_hook_ext_1",              "rm_outsideuniversity" }
  ,{ "get_amulettriangle1",         "rm_outsideuniversity" }
  ,{ "use_amulettriangle1",         "rm_firstfloor_ext" }
  ,{ "get_shovel_ext",              "rm_firstfloor_ext" }
  ,{ "use_shovel_ext",              "rm_outsideuniversity" }
  ,{ "get_clay",                    "rm_outsideuniversity" }
  ,{ "clk_gate_ext",                "rm_outsideuniversity" }
  ,{ "opn_sportsground_ext" }
  ,{ "get_burner",                  "rm_sportsground_ext" }
  ,{ "use_wrench_ext_2",            "rm_sportsground_ext" }
  ,{ "clk_wrench_ext_2",            "rm_sportsground_ext" }
  ,{ "get_gascylinder",             "rm_sportsground_ext" }
  ,{ "use_gascylinder" }
  ,{ "get_chargedburner" }
  ,{ "use_clay",                    "rm_sportsground_ext" }
  ,{ "use_chargedburner",           "rm_sportsground_ext" }
  ,{ "get_amuletbeast3",            "rm_sportsground_ext" }
  ,{ "use_amuletbeast1",            "rm_outsideuniversity" }
  ,{ "use_amuletbeast2",            "rm_outsideuniversity" }
  ,{ "use_amuletbeast3",            "rm_outsideuniversity" }
  ,{ "win_forest",                  "rm_outsideuniversity" }
  ,{ "opn_reservationentrance" }
  ,{ "get_prunerpart",              "rm_reservationentrance" }
  ,{ "clk_pruner",                  "rm_reservationentrance" }
  ,{ "get_lever_ext",               "rm_reservationentrance" }
  ,{ "use_lever_ext",               "rm_reservationentrance" }    
  ,{ "get_librarycard",             "rm_reservationentrance" }
  ,{ "get_coal",                    "rm_outsideuniversity" }
  ,{ "use_librarycard",             "rm_outsideuniversity" }
  ,{ "get_book_ext",                "rm_outsideuniversity" }
  ,{ "clk_book_ext" }
  ,{ "get_hint_ext" }
  ,{ "use_hint_ext",                "rm_reservationentrance" }
  ,{ "win_hint_ext",                    "rm_reservationentrance" }
  ,{ "see_reservationgates",        "rm_reservationentrance" }
  ,{ "win_spreader",                "rm_reservationentrance" }
  ,{ "get_insectspray",             "rm_reservationentrance" }
  ,{ "use_insectspray",             "rm_sportsground_ext" }
  ,{ "get_amulettriangle2",         "rm_sportsground_ext" }
  ,{ "use_amulettriangle2",         "rm_firstfloor_ext" }
  ,{ "get_screwdriver_ext",         "rm_firstfloor_ext" }
  ,{ "use_screwdriver_ext_1",       "rm_firstfloor_ext" }
  ,{ "get_button_ext",              "rm_firstfloor_ext" }
  ,{ "use_button_ext",              "rm_sportsground_ext" }
  ,{ "clk_button_ext_1",            "rm_sportsground_ext" }
  ,{ "clk_button_ext_2",            "rm_sportsground_ext" }
  ,{ "opn_bleachers" }
  ,{ "win_bleachers",               "rm_sportsground_ext" }
  ,{ "clk_soccerboot" }
  ,{ "get_lace" }
  ,{ "use_lace",                    "rm_sportsground_ext" }
  ,{ "clk_lace",                    "rm_sportsground_ext" }
  ,{ "get_racket",                  "rm_sportsground_ext" }
  ,{ "use_racket",                  "rm_sportsground_ext" }
  ,{ "get_prunerpart2",             "rm_sportsground_ext" }
  ,{ "use_prunerpart2" }
  ,{ "clk_prunerpart" }
  ,{ "get_pruner" }
  ,{ "use_pruner",                  "rm_reservationentrance" }
  ,{ "get_reservationkey",          "rm_reservationentrance" }
  ,{ "use_reservationkey",          "rm_reservationentrance" }
  ,{ "clk_reservationgates_1",      "rm_reservationentrance" }
  ,{ "see_reservationgates_open_door","rm_reservationentrance" }
  ,{ "opn_reservation" }
  ,{ "see_appearance_terence",      "rm_reservation" }
  ,{ "opn_zz_terencescell",         "rm_reservation" }
  ,{ "dlg_reservation_terence_1",   "rm_reservation" }
  ,{ "get_lockpick",                "rm_reservation" }
  ,{ "get_mosaicpiece1",            "rm_reservation" }
  ,{ "use_lockpick",                "rm_reservation" }
  ,{ "win_lockpick",                "rm_reservation" }
  ,{ "opn_oceanarium" }
  ,{ "get_stepladder",              "rm_oceanarium" }
  ,{ "use_stepladder",              "rm_oceanarium" }
  ,{ "get_matches",                 "rm_reservation" }
  ,{ "get_burningmatch" }
  ,{ "opn_zz_pump",                 "rm_oceanarium" }
  ,{ "use_burningmatch",            "rm_oceanarium" }
  ,{ "get_watersign",               "rm_oceanarium" }
  ,{ "get_fishingrod",              "rm_oceanarium" }
  ,{ "use_watersign",               "rm_oceanarium" }
  ,{ "clk_watersign",               "rm_oceanarium" }
  ,{ "get_spoonhook",               "rm_oceanarium" }
  ,{ "use_spoonhook",               "rm_oceanarium" }
  ,{ "get_codepart",                "rm_oceanarium" }
  ,{ "use_codepart",                "rm_oceanarium" }
  ,{ "win_seatackles",              "rm_oceanarium" }
  ,{ "get_fishingline",             "rm_oceanarium" }
  ,{ "use_fishingline" }
  ,{ "get_fixfishingrod" }
  ,{ "opn_zz_aquarium",             "rm_oceanarium" }
  ,{ "use_fixfishingrod",           "rm_oceanarium" }
  ,{ "get_fishermansshirt",         "rm_oceanarium" }
  ,{ "use_fishermansshirt" }
  ,{ "clk_fishermansshirt" }
  ,{ "get_amulettriangle3" }
  ,{ "use_amulettriangle3",         "rm_firstfloor_ext" }
  ,{ "get_hacksaw",                 "rm_firstfloor_ext" }
  ,{ "use_hacksaw",                 "rm_oceanarium" }
  ,{ "get_emergencykey",            "rm_oceanarium" }
  ,{ "get_terencelockpart1",        "rm_oceanarium" }
  ,{ "get_pass",                    "rm_oceanarium" }
  ,{ "use_emergencykey",            "rm_oceanarium" }
  ,{ "clk_emergencykey" ,           "rm_oceanarium" }
  ,{ "win_mgpump",                  "rm_oceanarium" }
  ,{ "see_pump",                    "rm_oceanarium" }
  ,{ "use_pass",                    "rm_reservation" }
  ,{ "opn_aviaries" }
  ,{ "opn_zz_cellaviary",           "rm_aviaries" }
  ,{ "get_boyscoutbadge",           "rm_aviaries" }
  ,{ "see_puma" }
  ,{ "clk_boyscoutbadge",           "rm_aviaries" }
  ,{ "use_boyscoutbadge",           "rm_aviaries" }
  ,{ "get_paperpiece",              "rm_aviaries" }
  ,{ "clk_doublegun",               "rm_aviaries" }
  ,{ "get_doublegun",               "rm_aviaries" }
  ,{ "use_paperpiece",              "rm_aviaries" }
  ,{ "use_coal",                    "rm_aviaries" }
  ,{ "clk_paperpiece",              "rm_aviaries" }
  ,{ "get_digitcode",               "rm_aviaries" }
  ,{ "use_digitcode",               "rm_aviaries" }
  ,{ "win_digitcode",               "rm_aviaries" }
  ,{ "get_jar",                     "rm_aviaries" }
  ,{ "use_jar",                     "rm_firstfloor_ext" }
  ,{ "get_jarwithwater",            "rm_firstfloor_ext" }
  ,{ "use_jarwithwater",            "rm_aviaries" }
  ,{ "get_tongs_ext",               "rm_aviaries" }
  ,{ "use_tongs_ext",               "rm_aviaries" }
  ,{ "get_bluntblade",              "rm_aviaries" }
  ,{ "use_bluntblade",              "rm_aviaries" }
  ,{ "get_blade_ext",               "rm_aviaries" }
  ,{ "use_blade_ext",               "rm_reservation" }
  ,{ "get_caretakerssign",          "rm_reservation" }
  ,{ "use_caretakerssign",          "rm_aviaries"  }
  ,{ "get_ammo",                    "rm_aviaries"  }
  ,{ "clk_gun_ext_1"    }
  ,{ "use_ammo"         }
  ,{ "clk_ammo_ext_1"   }
  ,{ "use_gunpowder"    }
  ,{ "clk_ammo_ext_2"   }
  ,{ "clk_ammo_ext_3"   }
  ,{ "clk_gun_ext_2"    }
  ,{ "get_gunblankcartridge" }
  ,{ "use_gunblankcartridge",       "rm_aviaries" }
  ,{ "get_terencelockpart2",        "rm_aviaries" }
  ,{ "get_protectiontube",          "rm_aviaries" }
  ,{ "get_amulettriangle4",         "rm_aviaries" }
  ,{ "use_amulettriangle4",         "rm_firstfloor_ext" }
  ,{ "get_spreadingtool",           "rm_firstfloor_ext" }
  ,{ "use_spreadingtool",           "rm_outsideuniversity" }  
  ,{ "get_wheel_ext",               "rm_outsideuniversity" }
  ,{ "use_wheel_ext",               "rm_aviaries" }
  ,{ "clk_wheel_ext",               "rm_aviaries" }
  ,{ "get_policebadge",             "rm_aviaries" }
  ,{ "use_policebadge",             "rm_dukesoffice_ext" }
  ,{ "opn_policecase" }
  ,{ "win_policecase",              "rm_dukesoffice_ext" }
  ,{ "use_detectivesselection",     "rm_aviaries" }
  ,{ "get_fingerprint",             "rm_aviaries" }
  ,{ "get_mosaicpiece2",            "rm_reservation" }
  ,{ "use_fingerprint",             "rm_reservation" }
  ,{ "opn_poultryhouse" }
  ,{ "use_mosaicpiece1",            "rm_poultryhouse" }
  ,{ "use_mosaicpiece2",            "rm_poultryhouse" }
  ,{ "get_saw_ext",                 "rm_poultryhouse" }
  ,{ "use_saw_ext",                 "rm_aviaries" }
  ,{ "get_pole",                    "rm_aviaries" }
  ,{ "use_pole",                    "rm_poultryhouse" }
  ,{ "use_protectiontube",          "rm_poultryhouse" }
  ,{ "get_bulb",                    "rm_poultryhouse" }
  ,{ "use_bulb",                    "rm_poultryhouse" }
  ,{ "get_amuletbird",              "rm_poultryhouse" }
  ,{ "use_amuletbird",              "rm_poultryhouse" }
  ,{ "get_feed",                    "rm_poultryhouse" }
  ,{ "use_feed",                    "rm_poultryhouse" }
  ,{ "opn_inhollow" }
  ,{ "win_inhollow" }
  ,{ "clk_shinybox_ext_1" }
  ,{ "clk_shinybox_ext_2" }
  ,{ "get_drywallscrews" }
  ,{ "use_drywallscrews",           "rm_poultryhouse" }
  ,{ "use_screwdriver_ext_2",       "rm_poultryhouse" }
  ,{ "clk_screwdriver_ext_2",       "rm_poultryhouse" }
  ,{ "get_call",                    "rm_poultryhouse" }
  ,{ "use_call_1",                  "rm_poultryhouse" }
  ,{ "get_nestling1_6",             "rm_poultryhouse" }
  ,{ "use_call_2",                  "rm_reservation" }
  ,{ "get_nestling2_6",             "rm_reservation" }
  ,{ "use_call_3",                  "rm_aviaries" }
  ,{ "get_nestling3_6",             "rm_aviaries" }
  ,{ "use_call_4",                  "rm_reservationentrance" }
  ,{ "get_nestling4_6",             "rm_reservationentrance" }
  ,{ "use_call_5",                  "rm_outsideuniversity" }
  ,{ "get_nestling5_6",             "rm_outsideuniversity" }
  ,{ "use_call_6",                  "rm_sportsground_ext" }
  ,{ "get_nestling6_6",             "rm_sportsground_ext" }
  ,{ "use_nestling",                "rm_poultryhouse" }
  ,{ "get_terencelockpart3",        "rm_poultryhouse" }
  ,{ "use_terencelockpart1",        "rm_reservation" }
  ,{ "use_terencelockpart2",        "rm_reservation" }
  ,{ "use_terencelockpart3",        "rm_reservation" }
  ,{ "win_prisoncell",              "rm_reservation" }
  ,{ "see_outro_ext" }

  ,{ "get_collect_morph_item_17" }
  ,{ "get_collect_morph_item_18" }
  ,{ "get_collect_morph_item_19" }
  ,{ "get_collect_morph_item_20" }
  ,{ "get_collect_morph_item_21" }

  ,{ "get_collect2_item_16" }
  ,{ "get_collect2_item_17" }
  ,{ "get_collect2_item_18" }
  ,{ "get_collect2_item_19" }
  ,{ "get_collect2_item_20" }

  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements"
    }

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;

end;

function private.TutorialSetParams ()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;

  end;

end;