-- name=secretroom

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 20 );

--  if IsCollectorsEdition() then
--
--    interface.WidgetAdd( InterfaceWidget_BtnGuide, 20 );
--
--  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  --interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  --interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  --interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

--  interface.WidgetAdd( InterfaceWidget_Effects, 11 );
--
--  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  --interface.WidgetAdd( InterfaceWidget_DialogHo, 19 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  --interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  --interface.WidgetAdd( InterfaceWidget_ItemPanel );
  --interface.WidgetAdd( InterfaceWidget_Popup, 27 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog, 26 );

  --interface.WidgetAdd( InterfaceWidget_DialogVideo, 26 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 19 );

  --interface.WidgetAdd( InterfaceWidget_StrategyGuide, 23 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 30 );

  --interface.WidgetAdd( InterfaceWidget_Map, 26  );

  --interface.PanelNotificationAdd();
  --interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  --interface.ButtonTaskAdd( 1 );
  --interface.DialogTaskAdd( 20 );  
  --interface.DiaryAdd( 28 );

  interface.IntTaskpanelSecretAdd( 5 );
  interface.IntMorphSecretAdd( 5 );
  interface.IntTimerSecretAdd( 5 );
  interface.IntDialogSecretAdd( 19 );

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then
--
--    interface.BtnCollectibles2Add( 18 );
--    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
--    interface.BtnMorphAdd( 18 );
--
  end;

  private.Init(); 

  common.LevelLoad( "secretroom", "secret", "rm_winecellar_secret", param, private.menu_moduls );

  cmn.MorphingSecretLoad();
  private.TutorialSetParams();
  --interface.KeyUpdate();

  cmn.PlayMusEnv();

  int_timer_secret.SetTimer();
  int_taskpanel_secret.UpdateAchievpanel();

  ng_global.secret.game = false;

--  end;
--
end;
    
function private.Init ()

  game = {};
  game.room_names =  {
    "rm_winecellar_secret"
    ,"rm_toilets_secret"
    ,"rm_stairflight_secret"
    ,"rm_cemetery_secret"
  };

   game.progress_names_room =
  {
    { "opn_winecellar_secret" }
    ,{ "opn_toilets_secret" }
    ,{ "opn_stairflight_secret" }
    ,{ "opn_cemetery_secret" }

    ,{ "get_amulets_secret" }
    ,{ "get_chimeras_secret" }
    ,{ "get_jacketl_secret" }
    ,{ "get_blood_secret" }
    ,{ "get_knives_secret" }
    ,{ "get_ghost_secret" }
    
  };

  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2"
      ,"rm_collectibles"
      ,"rm_achievements"
    }

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;



end;
-------------------------------------------------
function private.TutorialSetParams ()

  if not ng_global.progress[ "secret" ][ "see_tutorial_secret" ] then

    ng_global.progress[ "secret" ][ "see_tutorial_secret" ] = {};
    ng_global.progress[ "secret" ][ "see_tutorial_secret" ].done  = 0;
    ng_global.progress[ "secret" ][ "see_tutorial_secret" ].start = 0;
    ng_global.progress[ "secret" ][ "see_tutorial_secret" ].state = {};
    ng_global.progress[ "secret" ][ "see_tutorial_secret" ].state.no  = 0;
    ng_global.progress[ "secret" ][ "see_tutorial_secret" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "secret" ][ "see_tutorial_secret" ].func = function()
      --
    end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );      

    end;

    ng_global.progress[ "secret" ][ "see_tutorial_secret" ].state.pages = {

      [ "tutorial_page_1_secret" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = { } }, -- о начале сикретрума

      [ "tutorial_page_2_secret" ] = { shown = 0, noskip = false, posx = 650, posy = 325, arrows = {
                                                                                    { pos_x = 350, pos_y = 300, ang =  1.3 }
                                                                                  } } , -- что искать и сколько искать
      [ "tutorial_page_3_secret" ] = { shown = 0, noskip = false, posx = 350, posy = 400, arrows = {
                                                                                    { pos_x = 200, pos_y = 570, ang =  2.1 }
                                                                                  } } , -- показать на таймер
      [ "tutorial_page_4_secret" ] = { shown = 0, noskip = false, posx = 512, posy = 384, arrows = {
                                                                                    { pos_x = 350, pos_y = 550, ang =  2.9 },
                                                                                    { pos_x = 650, pos_y = 550, ang =  -2.9 }
                                                                                  } } , -- показать на панель ачивок и прогресса
      [ "tutorial_page_5_secret" ] = { shown = 0, noskip = false, posx = 650, posy = 325, arrows = {
                                                                                    { pos_x = 350, pos_y = 300, ang =  1.3 }
                                                                                  } } , -- показать, что становится серым когда взяли все предметы в этой локи
      [ "tutorial_page_6_secret" ] = { shown = 0, noskip = false, posx = 512, posy = 384, arrows = {
                                                                                    { pos_x = 512, pos_y = 550, ang =  3.14 }
                                                                                  } } , -- показать на прогресс бар после первого этапа сикретрума

    };

  end;

end;