-- name=rm_winecellar_secret
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_winecellar_secret";
  --------------------------------------------------------------------------------------------
  private.window_light = { false, false, false };
  private.InitAnimations();
  
  ObjMultiSet( { 
    { "obj_timer_start", { event_mdown = private.StartTimer } },
  } );  
  cmn.SecretroomhAddObj( private.room_objname, "amulets",  1 );
  cmn.SecretroomhAddObj( private.room_objname, "chimeras", 2 );
  cmn.SecretroomhAddObj( private.room_objname, "jacketl",  3 );
  cmn.SecretroomhAddObj( private.room_objname, "blood",    4 );
  cmn.SecretroomhAddObj( private.room_objname, "knives",   5 );
  cmn.SecretroomhAddObj( private.room_objname, "ghost",    2 );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_winecellar_secret = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "grm_winecellar_stairflight_secret",
    "grm_winecellar_toilets_secret",
    "grm_winecellar_cemetery_secret",
  };
  for i = 1, #gates do
    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;
  end;

    local mas_parent_gfx = 
    {
      private.room_objname,
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_winecellar_secret", update_game_mode_winecellar_secret, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_winecellar_secret = function ()

  local effects_table = 
  {
    "obj_winecellar_secret_anim", 
    "obj_winecellar_secret_anim_over", 
    "anm_winecellar_wind2", 
    "anm_winecellar_snow_swirl", 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_winecellar_secret", update_performance_mode_winecellar_secret, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_winecellar_secret () end;
  --------------------------------------------------------------------------------------------
  local opn_winecellar_secret_map = function ()

    --common_impl.VisitMapRoom( "winecellar_secret" );

  end;
  cmn.AddSubscriber( "opn_winecellar_secret", opn_winecellar_secret_map );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************

--*********************************************************************************************************************
function public.Open ()

  private.opn_winecellar_secret();

  local pages = ng_global.progress[ "secret" ][ "see_tutorial_secret" ].state.pages;
  
  local cond_1 = pages[ "tutorial_page_1_secret" ][ "shown" ] == 0;
  local cond_2 = ng_global.gamemode == 0;
  local cond_3 = ng_global.gamemode == 3 and ng_global.gamemode_custom[ "tutorial" ];
  local cond_4 = cond_2 or cond_3;
  
  if ( cond_1 and cond_4 ) then
    
    common_impl.TutorialShow( "tutorial_page_1_secret" );
    
  else 

    cmn.StartMorhpTask(); 
   
  end;

  --cmn.CallEventHandler( "get_glass_secret" );
  --cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  --cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.DefaultMorphItemSecret();
  common_impl.EnvPlay( {"level2/env/aud_winecellar_env"} , "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  common_impl.StopAudio( "env", "level2/env/aud_winecellar_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_winecellar_secret ()

--  if not ( cmn.IsEventDone( "opn_winecellar_secret" ) ) then
--
--    cmn.SetEventDone( "opn_winecellar_secret" );
--    common_impl.ShowBbt( "bbt_winecellar_secret_opn_winecellar_secret" );
--
--  end;
--  cmn.CallEventHandler( "opn_winecellar_secret" ); 
  
end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------
function private.InitAnimations ()
end;
--------------------------------------------------------------------------------------------
function private.StartTimer ()

  int_timer_secret.StartTimer();

end;















