-- name=int_frame_subroom
--******************************************************************************************
function public.Init( pos_z )

  interface.LoadImplementation( "frame_subroom" );
  ObjAttach( "int_frame_subroom", interface.originhub );
  ObjSet( "int_frame_subroom", { pos_z = pos_z } );
  private.event_anim_end = {};
  private.block = false;

end;
--******************************************************************************************
function public.Destroy()

end;
--******************************************************************************************
function public.BlockClose( flag )

  private.block = flag;

end;
--********************************************************************************************************************
function public.Show( subroom_name, frame )

  private.subroom_name = subroom_name;
  local name = "int_frame_subroom_"..private.subroom_name;
  private.name = name;  

  ObjDelete( name );
  ObjClone( "int_frame_subroom", "_"..subroom_name, 1, subroom_name );  

  local pos_z = 100;
  local params = true;
  if ( frame == "under_frame" ) then
    pos_z = -5;
  elseif ( frame == "not_frame" ) then
    params = false;
  end;

  ObjSet( name, { input = true, visible = true, active = true, pos_x = 0, pos_y = 0, pos_z = pos_z } );--input = false
  --private.Anim( params_anim, private.ShowAnimEnd );

  ObjSet( "grd_"..name, { input = params, visible = params } );

end;
--********************************************************************************************************************
function public.Hide()
  
  ObjSet( private.name, { input = false } );
  private.HideAnimEnd()
  --private.Anim( params_anim, private.HideAnimEnd );

end;
--******************************************************************************************
function private.HideAnimEnd()

  ObjSet( private.name, { visible = false, active = false } );
  ObjDelete( private.name );

end;
--******************************************************************************************
function private.ShowAnimEnd( )

  ObjSet( private.name, { input = true } );

end;
--******************************************************************************************
function private.Anim( params_anim, func )

  local func_end = func;
  for param, anm_table in pairs( params_anim ) do

    ObjAnimate( private.name, param, 0, 0, func_end, anm_table );
    func_end = "";

  end;

end;
--******************************************************************************************
function public.Construct( frame_w, frame_h, position_button, extended )  

  --DbgTrace( "Frame Subroom Show: w = "..frame_w..", h = "..frame_h );

  local border_w = int_frame_subroom_impl.GRID_BORDER_W;
  local border_h = int_frame_subroom_impl.GRID_BORDER_H;

  frame_w = frame_w + border_w;
  frame_h = frame_h + border_h;

  local frame_corner_w = int_frame_subroom_impl.GRID_CORNER_W;
  local frame_corner_h = int_frame_subroom_impl.GRID_CORNER_H;

  local frame_mid_w = int_frame_subroom_impl.GRID_MID_W;
  local frame_mid_h = int_frame_subroom_impl.GRID_MID_H;

  interface.FrameGridSet( private.name,
  {
    grid_w   = frame_w,
    grid_h   = frame_h,
    corner_w = frame_corner_w,
    corner_h = frame_corner_h,
    mid_w    = frame_mid_w,
    mid_h    = frame_mid_h
  } );

  local pos_x = 0.5 * frame_w;
  local pos_y = - 0.5 * frame_h;

  if ( position_button ) then
    pos_x = position_button.x;
    pos_y = position_button.y;
  end;

  ObjSet( "pnt_int_frame_subroom_rgt_top_"..private.subroom_name, { pos_x = pos_x, pos_y = pos_y } );

  if ( int_frame_subroom_impl.ShowExtended ) then

    int_frame_subroom_impl.ShowExtended( frame_w, frame_h, extended );

  end;

end;
--******************************************************************************************
function public.ButtonCloseClick()

  if not private.block then

    MsgSend( Event_FrameSubroom_Click, {} );

  end;

end;
--******************************************************************************************
function public.FieldCloseMouseEnter()

  SetCursor( CURSOR_DOWN );

end;
--******************************************************************************************
function public.FieldCloseMouseLeave()

  SetCursor( CURSOR_DEFAULT );

end;
--******************************************************************************************