-- name=subroom
--********************************************************************************************************************
function public.Init()

  private.current = nil;
  private.subroom_list = {};
  private.pos_list = {};
  private.event_anim_end = {};
  private.SUBROOM = "subroom";
  ObjAttach( private.SUBROOM, "ng_level_internal" );

  ModLoad( "assets/levels/common/mod_subroom_impl" );
  subroom_impl.Init();

end;

--********************************************************************************************************************
function public.Destroy()

end;
--********************************************************************************************************************
function public.Define( subroom )
  _G[ subroom ] = {};
end;
--********************************************************************************************************************
function public.EventAnimEnd( event_id )

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
    
    if not ( private.current == "zz_clockface_2" ) then
      
      common_impl.Lock( false )
      
    end;
    
    ObjSet( private.current, { bake = 0 } );
    ObjSet( private.current, { input = true } );
    private.Execute( private.current, "Open" );
    
------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

    ObjSet( private.current, { bake = 0 } );
    private.Execute( private.current, "Close" );
    ObjDetach( private.current );    

    --port. fix 
    if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
    
      ne.obj.UnloadGraphic(private.current);
      ne.reshub.ClearUsedRes();
    
    end;
    
    table.remove( private.subroom_list );
    private.current = private.subroom_list[ #private.subroom_list ];
    ObjSet( "obj_subroom_subroom", { pos_z = #private.subroom_list - 1 } );

    if ( not private.current ) then

      ObjSet( private.SUBROOM, { input = false, visible = false, active = false } );
      room.SetCurrentRoomActive( true );
      room.SetCurrentRoomInput( true );
      ObjDetach( subroom_impl.BLACK );

    end;

  end;

end;
--********************************************************************************************************************
function public.Open( subroom_name, position_zz, frame, position_button )
  
  --if not private.current then

    private.current = subroom_name;
    table.insert( private.subroom_list, subroom_name );
    local pos_z = #private.subroom_list;

    room.SetCurrentRoomActive( false );
    room.SetCurrentRoomInput( false );
    ObjSet( private.SUBROOM, { input = true, visible = true, active = true } );

    private.pos_list[ subroom_name ] = position_zz;    

    ObjAttach( subroom_impl.BLACK, private.SUBROOM );

    ObjSet( "obj_subroom_subroom", { pos_z = pos_z } );

    ObjSet( subroom_name, { pos_z = pos_z, input = false } );
    ObjAttach( subroom_name, private.SUBROOM );    

    subroom_impl.Show( "show", subroom_name, position_zz, frame );     
    
    private.Execute( private.current, "PreOpen" );

    local back_params = ObjGet( subroom_name );
    interface.ConstructFrameSubroom( back_params.draw_width, back_params.draw_height, position_button );

    ObjSet( private.current, { clear_bake = 1, bake = 1 } );
    
  --end;

end;
--********************************************************************************************************************
function public.Close()

  if private.current then

    ObjSet( private.current, { input = false } );
    private.Execute( private.current, "PreClose" );
    ObjSet( private.current, { clear_bake = 1, bake = 1 } );

    local is_subroom = false;
    if ( #private.subroom_list > 1 ) then
      is_subroom = true;
    end;

    subroom_impl.Hide( "hide", private.current, private.pos_list[ private.current ], is_subroom );    

  end;

end;
--********************************************************************************************************************
function public.CloseAll()

  if ( private.current ) then

    local is_subroom = false;

    DbgTrace( "CloseAll" );

    for i = #private.subroom_list, 1, -1 do

      local subroom = private.subroom_list[ i ];
      DbgTrace( "closeall "..subroom);

      ObjSet( subroom, { input = false } );
      private.Execute( subroom, "PreClose" );
      ObjSet( subroom, { clear_bake = 1, bake = 1 } );

      subroom_impl.Hide( "hide", subroom, private.pos_list[ subroom ], is_subroom );    
      is_subroom = true;

    end;

  end;  

end;
--********************************************************************************************************************
function private.Execute( room, func )

  if room and func and _G[ room ] and _G[ room ][ func ] then
    _G[ room ][ func ]();
  end;

end;
--********************************************************************************************************************
